/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/base/common/types","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/extensions/common/extensions","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ae=function(Z){for(var e=[],k=0,i=Z.length;k<i;k++)e[k]=oe[Z[k]];return e};define(oe[52],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(O,R)=>` ${R} `).trim():""}e.getCodiconAriaLabel=k;class i{constructor(O,R,P){this.id=O,this.definition=R,this.description=P,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}e.Codicon=i,i.a=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.commentDraft=new i("comment-draft",{fontCharacter:"\\ec0e"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var D;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function R(E){if(E instanceof i)return["codicon","codicon-"+E.id];const b=O.exec(E.id);if(!b)return R(i.error);const[,g,m]=b,h=["codicon","codicon-"+g];return m&&h.push("codicon-modifier-"+m.substring(1)),h}A.asClassNameArray=R;function P(E){return R(E).join(" ")}A.asClassName=P;function S(E){return"."+R(E).join(".")}A.asCSSSelector=S})(D=e.CSSIcon||(e.CSSIcon={}))}),define(oe[63],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(O){return(R,P,S)=>{let E=null,b=null;if(typeof S.value=="function"?(E="value",b=S.value):typeof S.get=="function"&&(E="get",b=S.get),!b)throw new Error("not supported");S[E]=O(b,P)}}function i(O,R,P){let S=null,E=null;if(typeof P.value=="function"?(S="value",E=P.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(S="get",E=P.get),!E)throw new Error("not supported");const b=`$memoize$${R}`;P[S]=function(...g){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,g)}),this[b]}}e.memoize=i;function D(O,R,P){return k((S,E)=>{const b=`$debounce$${E}`,g=`$debounce$result$${E}`;return function(...m){this[g]||(this[g]=P?P():void 0),clearTimeout(this[b]),R&&(this[g]=R(this[g],...m),m=[this[g]]),this[b]=setTimeout(()=>{S.apply(this,m),this[g]=P?P():void 0},O)}})}e.debounce=D;function A(O,R,P){return k((S,E)=>{const b=`$throttle$timer$${E}`,g=`$throttle$result$${E}`,m=`$throttle$lastRun$${E}`,h=`$throttle$pending$${E}`;return function(...y){if(this[g]||(this[g]=P?P():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),R&&(this[g]=R(this[g],...y)),this[h])return;const f=this[m]+O;f<=Date.now()?(this[m]=Date.now(),S.apply(this,[this[g]]),this[g]=P?P():void 0):(this[h]=!0,this[b]=setTimeout(()=>{this[h]=!1,this[m]=Date.now(),S.apply(this,[this[g]]),this[g]=P?P():void 0},f-Date.now()))}})}e.throttle=A}),define(oe[7],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?p.isErrorNoTelemetry(n)?new p(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(c=>{c(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=k,e.errorHandler=new k;function i(I){e.errorHandler.setUnexpectedErrorHandler(I)}e.setUnexpectedErrorHandler=i;function D(I){P(I)||e.errorHandler.onUnexpectedError(I)}e.onUnexpectedError=D;function A(I){P(I)||e.errorHandler.onUnexpectedExternalError(I)}e.onUnexpectedExternalError=A;function O(I){if(I instanceof Error){const{name:n,message:c}=I,t=I.stacktrace||I.stack;return{$isError:!0,name:n,message:c,stack:t,noTelemetry:p.isErrorNoTelemetry(I)}}return I}e.transformErrorForSerialization=O;const R="Canceled";function P(I){return I instanceof S?!0:I instanceof Error&&I.name===R&&I.message===R}e.isCancellationError=P;class S extends Error{constructor(){super(R),this.name=this.message}}e.CancellationError=S;function E(){const I=new Error(R);return I.name=I.message,I}e.canceled=E;function b(I){return I?new Error(`Illegal argument: ${I}`):new Error("Illegal argument")}e.illegalArgument=b;function g(I){return I?new Error(`Illegal state: ${I}`):new Error("Illegal state")}e.illegalState=g;function m(I){return I?new Error(`readonly property '${I} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function h(I){const n=new Error(`${I} has been disposed`);return n.name="DISPOSED",n}e.disposed=h;function y(I){return I?I.message?I.message:I.stack?I.stack.split(`
`)[0]:String(I):"Error"}e.getErrorMessage=y;class f extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=f;class l extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=l;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class p extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof p)return n;const c=new p;return c.message=n.message,c.stack=n.stack,c}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=p;class w extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype);debugger}}e.BugIndicatingError=w}),define(oe[21],ae([0,1,7]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function i(Y,Q=0){return Y[Y.length-(1+Q)]}e.tail=i;function D(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}e.tail2=D;function A(Y,Q,se=(le,ue)=>le===ue){if(Y===Q)return!0;if(!Y||!Q||Y.length!==Q.length)return!1;for(let le=0,ue=Y.length;le<ue;le++)if(!se(Y[le],Q[le]))return!1;return!0}e.equals=A;function O(Y,Q){const se=Y.length-1;Q<se&&(Y[Q]=Y[se]),Y.pop()}e.removeFastWithoutKeepingOrder=O;function R(Y,Q,se){return P(Y.length,le=>se(Y[le],Q))}e.binarySearch=R;function P(Y,Q){let se=0,le=Y-1;for(;se<=le;){const ue=(se+le)/2|0,pe=Q(ue);if(pe<0)se=ue+1;else if(pe>0)le=ue-1;else return ue}return-(se+1)}e.binarySearch2=P;function S(Y,Q){let se=0,le=Y.length;if(le===0)return 0;for(;se<le;){const ue=Math.floor((se+le)/2);Q(Y[ue])?le=ue:se=ue+1}return se}e.findFirstInSorted=S;function E(Y,Q,se){if(Y=Y|0,Y>=Q.length)throw new TypeError("invalid index");const le=Q[Math.floor(Q.length*Math.random())],ue=[],pe=[],we=[];for(const be of Q){const Ee=se(be,le);Ee<0?ue.push(be):Ee>0?pe.push(be):we.push(be)}return Y<ue.length?E(Y,ue,se):Y<ue.length+we.length?we[0]:E(Y-(ue.length+we.length),pe,se)}e.quickSelect=E;function b(Y,Q){const se=[];let le;for(const ue of Y.slice(0).sort(Q))!le||Q(le[0],ue)!==0?(le=[ue],se.push(le)):le.push(ue);return se}e.groupBy=b;function g(Y,Q,se){const le=[];function ue(be,Ee,Te){if(Ee===0&&Te.length===0)return;const Ue=le[le.length-1];Ue&&Ue.start+Ue.deleteCount===be?(Ue.deleteCount+=Ee,Ue.toInsert.push(...Te)):le.push({start:be,deleteCount:Ee,toInsert:Te})}let pe=0,we=0;for(;;){if(pe===Y.length){ue(pe,0,Q.slice(we));break}if(we===Q.length){ue(pe,Y.length-pe,[]);break}const be=Y[pe],Ee=Q[we],Te=se(be,Ee);Te===0?(pe+=1,we+=1):Te<0?(ue(pe,1,[]),pe+=1):Te>0&&(ue(pe,0,[Ee]),we+=1)}return le}e.sortedDiff=g;function m(Y,Q,se){const le=g(Y,Q,se),ue=[],pe=[];for(const we of le)ue.push(...Y.slice(we.start,we.start+we.deleteCount)),pe.push(...we.toInsert);return{removed:ue,added:pe}}e.delta=m;function h(Y,Q,se){if(se===0)return[];const le=Y.slice(0,se).sort(Q);return f(Y,Q,le,se,Y.length),le}e.top=h;function y(Y,Q,se,le,ue){return se===0?Promise.resolve([]):new Promise((pe,we)=>{(async()=>{const be=Y.length,Ee=Y.slice(0,se).sort(Q);for(let Te=se,Ue=Math.min(se+le,be);Te<be;Te=Ue,Ue=Math.min(Ue+le,be)){if(Te>se&&await new Promise(Ye=>setTimeout(Ye)),ue&&ue.isCancellationRequested)throw new k.CancellationError;f(Y,Q,Ee,Te,Ue)}return Ee})().then(pe,we)})}e.topAsync=y;function f(Y,Q,se,le,ue){for(const pe=se.length;le<ue;le++){const we=Y[le];if(Q(we,se[pe-1])<0){se.pop();const be=S(se,Ee=>Q(we,Ee)<0);se.splice(be,0,we)}}}function l(Y){return Y.filter(Q=>!!Q)}e.coalesce=l;function d(Y){let Q=0;for(let se=0;se<Y.length;se++)Y[se]&&(Y[Q]=Y[se],Q+=1);Y.length=Q}e.coalesceInPlace=d;function p(Y,Q,se){Y.splice(se,0,Y.splice(Q,1)[0])}e.move=p;function w(Y){return!Array.isArray(Y)||Y.length===0}e.isFalsyOrEmpty=w;function I(Y){return Array.isArray(Y)&&Y.length>0}e.isNonEmptyArray=I;function n(Y,Q=se=>se){const se=new Set;return Y.filter(le=>{const ue=Q(le);return se.has(ue)?!1:(se.add(ue),!0)})}e.distinct=n;function c(Y){const Q=new Set;return se=>{const le=Y(se);return Q.has(le)?!1:(Q.add(le),!0)}}e.uniqueFilter=c;function t(Y,Q){const se=s(Y,Q);if(se!==-1)return Y[se]}e.findLast=t;function s(Y,Q){for(let se=Y.length-1;se>=0;se--){const le=Y[se];if(Q(le))return se}return-1}e.lastIndex=s;function o(Y,Q){return Y.length>0?Y[0]:Q}e.firstOrDefault=o;function a(Y,Q){return Y.length>0?Y[Y.length-1]:Q}e.lastOrDefault=a;function r(Y,Q,se=(le,ue)=>le===ue){let le=0;for(let ue=0,pe=Math.min(Y.length,Q.length);ue<pe&&se(Y[ue],Q[ue]);ue++)le++;return le}e.commonPrefixLength=r;function u(Y){return[].concat(...Y)}e.flatten=u;function v(Y,Q){let se=typeof Q=="number"?Y:0;typeof Q=="number"?se=Y:(se=0,Q=Y);const le=[];if(se<=Q)for(let ue=se;ue<Q;ue++)le.push(ue);else for(let ue=se;ue>Q;ue--)le.push(ue);return le}e.range=v;function C(Y,Q,se){return Y.reduce((le,ue)=>(le[Q(ue)]=se?se(ue):ue,le),Object.create(null))}e.index=C;function T(Y,Q){return Y.push(Q),()=>N(Y,Q)}e.insert=T;function N(Y,Q){const se=Y.indexOf(Q);if(se>-1)return Y.splice(se,1),Q}e.remove=N;function F(Y,Q,se){const le=Y.slice(0,Q),ue=Y.slice(Q);return le.concat(se,ue)}e.arrayInsert=F;function j(Y,Q){let se;if(typeof Q=="number"){let le=Q;se=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else se=Math.random;for(let le=Y.length-1;le>0;le-=1){const ue=Math.floor(se()*(le+1)),pe=Y[le];Y[le]=Y[ue],Y[ue]=pe}}e.shuffle=j;function L(Y,Q){const se=Y.indexOf(Q);se>-1&&(Y.splice(se,1),Y.unshift(Q))}e.pushToStart=L;function $(Y,Q){const se=Y.indexOf(Q);se>-1&&(Y.splice(se,1),Y.push(Q))}e.pushToEnd=$;function z(Y,Q){for(const se of Q)Y.push(se)}e.pushMany=z;function H(Y,Q){return Array.isArray(Y)?Y.map(Q):Q(Y)}e.mapArrayOrNot=H;function X(Y){return Array.isArray(Y)?Y:[Y]}e.asArray=X;function ie(Y){return Y[Math.floor(Math.random()*Y.length)]}e.getRandomElement=ie;function G(Y,Q){for(const se of Y){const le=Q(se);if(le!==void 0)return le}}e.mapFind=G;function M(Y,Q,se){const le=x(Y,Q),ue=Y.length,pe=se.length;Y.length=ue+pe;for(let we=ue-1;we>=le;we--)Y[we+pe]=Y[we];for(let we=0;we<pe;we++)Y[we+le]=se[we]}e.insertInto=M;function V(Y,Q,se,le){const ue=x(Y,Q),pe=Y.splice(ue,se);return M(Y,ue,le),pe}e.splice=V;function x(Y,Q){return Q<0?Math.max(Q+Y.length,0):Math.min(Q,Y.length)}var ee;(function(Y){function Q(ue){return ue<0}Y.isLessThan=Q;function se(ue){return ue>0}Y.isGreaterThan=se;function le(ue){return ue===0}Y.isNeitherLessOrGreaterThan=le,Y.greaterThan=1,Y.lessThan=-1,Y.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function re(Y,Q){return(se,le)=>Q(Y(se),Y(le))}e.compareBy=re;function te(...Y){return(Q,se)=>{for(const le of Y){const ue=le(Q,se);if(!ee.isNeitherLessOrGreaterThan(ue))return ue}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=te;const U=(Y,Q)=>Y-Q;e.numberComparator=U;function B(Y,Q){if(Y.length===0)return;let se=Y[0];for(let le=1;le<Y.length;le++){const ue=Y[le];Q(ue,se)>0&&(se=ue)}return se}e.findMaxBy=B;function W(Y,Q){if(Y.length===0)return;let se=Y[0];for(let le=1;le<Y.length;le++){const ue=Y[le];Q(ue,se)>=0&&(se=ue)}return se}e.findLastMaxBy=W;function q(Y,Q){return B(Y,(se,le)=>-Q(se,le))}e.findMinBy=q;class J{constructor(Q){this.f=Q,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let se=this.c;for(;se<this.f.length&&Q(this.f[se]);)se++;const le=se===this.c?null:this.f.slice(this.c,se);return this.c=se,le}takeFromEndWhile(Q){let se=this.d;for(;se>=0&&Q(this.f[se]);)se--;const le=se===this.d?null:this.f.slice(se+1,this.d+1);return this.d=se,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Q=this.f[this.c];return this.c++,Q}removeLast(){const Q=this.f[this.d];return this.d--,Q}takeCount(Q){const se=this.f.slice(this.c,this.c+Q);return this.c+=Q,se}}e.ArrayQueue=J;class _{constructor(Q){this.iterate=Q}forEach(Q){this.iterate(se=>(Q(se),!0))}toArray(){const Q=[];return this.iterate(se=>(Q.push(se),!0)),Q}filter(Q){return new _(se=>this.iterate(le=>Q(le)?se(le):!0))}map(Q){return new _(se=>this.iterate(le=>se(Q(le))))}some(Q){let se=!1;return this.iterate(le=>(se=Q(le),!se)),se}findFirst(Q){let se;return this.iterate(le=>Q(le)?(se=le,!1):!0),se}findLast(Q){let se;return this.iterate(le=>(Q(le)&&(se=le),!0)),se}findLastMaxBy(Q){let se,le=!0;return this.iterate(ue=>((le||ee.isGreaterThan(Q(ue,se)))&&(le=!1,se=ue),!0)),se}}e.CallbackIterable=_,_.empty=new _(Y=>{})}),define(oe[128],ae([0,1,7]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function i(P,S){if(!P)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=i;function D(P,S="Unreachable"){throw new Error(S)}e.assertNever=D;function A(P){if(!P)throw new k.BugIndicatingError("Assertion Failed")}e.assert=A;function O(P){if(!P()){debugger;P(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=O;function R(P,S){let E=0;for(;E<P.length-1;){const b=P[E],g=P[E+1];if(!S(b,g))return!1;E++}return!0}e.checkAdjacentItems=R}),define(oe[82],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(i){const D=this;let A=!1,O;return function(){return A||(A=!0,O=i.apply(D,arguments)),O}}e.once=k}),define(oe[64],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(i){function D(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}i.is=D;const A=Object.freeze([]);function O(){return A}i.empty=O;function*R(w){yield w}i.single=R;function P(w){return D(w)?w:R(w)}i.wrap=P;function S(w){return w||A}i.from=S;function E(w){return!w||w[Symbol.iterator]().next().done===!0}i.isEmpty=E;function b(w){return w[Symbol.iterator]().next().value}i.first=b;function g(w,I){for(const n of w)if(I(n))return!0;return!1}i.some=g;function m(w,I){for(const n of w)if(I(n))return n}i.find=m;function*h(w,I){for(const n of w)I(n)&&(yield n)}i.filter=h;function*y(w,I){let n=0;for(const c of w)yield I(c,n++)}i.map=y;function*f(...w){for(const I of w)for(const n of I)yield n}i.concat=f;function l(w,I,n){let c=n;for(const t of w)c=I(c,t);return c}i.reduce=l;function*d(w,I,n=w.length){for(I<0&&(I+=w.length),n<0?n+=w.length:n>w.length&&(n=w.length);I<n;I++)yield w[I]}i.slice=d;function p(w,I=Number.POSITIVE_INFINITY){const n=[];if(I===0)return[n,w];const c=w[Symbol.iterator]();for(let t=0;t<I;t++){const s=c.next();if(s.done)return[n,i.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return c}}]}i.consume=p})(k=e.Iterable||(e.Iterable={}))}),define(oe[35],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var i;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(n){n.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function O(n,c=!1){let t=0;const s=n.length;let o="",a=0,r=16,u=0;function v($){let z=0,H=0;for(;z<$;){const X=n.charCodeAt(t);if(X>=48&&X<=57)H=H*16+X-48;else if(X>=65&&X<=70)H=H*16+X-65+10;else if(X>=97&&X<=102)H=H*16+X-97+10;else break;t++,z++}return z<$&&(H=-1),H}function C($){t=$,o="",a=0,r=16,u=0}function T(){const $=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&S(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&S(n.charCodeAt(t)))for(t++;t<n.length&&S(n.charCodeAt(t));)t++;else return u=3,n.substring($,t);let z=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&S(n.charCodeAt(t))){for(t++;t<n.length&&S(n.charCodeAt(t));)t++;z=t}else u=3;return n.substring($,z)}function N(){let $="",z=t;for(;;){if(t>=s){$+=n.substring(z,t),u=2;break}const H=n.charCodeAt(t);if(H===34){$+=n.substring(z,t),t++;break}if(H===92){if($+=n.substring(z,t),t++,t>=s){u=2;break}switch(n.charCodeAt(t++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const ie=v(4);ie>=0?$+=String.fromCharCode(ie):u=4;break}default:u=5}z=t;continue}if(H>=0&&H<=31)if(P(H)){$+=n.substring(z,t),u=2;break}else u=6;t++}return $}function F(){if(o="",u=0,a=t,t>=s)return a=s,r=17;let $=n.charCodeAt(t);if(R($)){do t++,o+=String.fromCharCode($),$=n.charCodeAt(t);while(R($));return r=15}if(P($))return t++,o+=String.fromCharCode($),$===13&&n.charCodeAt(t)===10&&(t++,o+=`
`),r=14;switch($){case 123:return t++,r=1;case 125:return t++,r=2;case 91:return t++,r=3;case 93:return t++,r=4;case 58:return t++,r=6;case 44:return t++,r=5;case 34:return t++,o=N(),r=10;case 47:{const z=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<s&&!P(n.charCodeAt(t));)t++;return o=n.substring(z,t),r=12}if(n.charCodeAt(t+1)===42){t+=2;const H=s-1;let X=!1;for(;t<H;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,X=!0;break}t++}return X||(t++,u=1),o=n.substring(z,t),r=13}return o+=String.fromCharCode($),t++,r=16}case 45:if(o+=String.fromCharCode($),t++,t===s||!S(n.charCodeAt(t)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),r=11;default:for(;t<s&&j($);)t++,$=n.charCodeAt(t);if(a!==t){switch(o=n.substring(a,t),o){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return o+=String.fromCharCode($),t++,r=16}}function j($){if(R($)||P($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let $;do $=F();while($>=12&&$<=15);return $}return{setPosition:C,getPosition:()=>t,scan:c?L:F,getToken:()=>r,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>t-a,getTokenError:()=>u}}e.createScanner=O;function R(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function P(n){return n===10||n===13||n===8232||n===8233}function S(n){return n>=48&&n<=57}var E;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(E||(E={}));function b(n,c){const t=[],s=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function u(v,C,T,N){a.value=v,a.offset=C,a.length=T,a.type=N,a.colonOffset=void 0,o=a}try{p(n,{onObjectBegin:(v,C)=>{if(c<=v)throw s;o=void 0,r=c>v,t.push("")},onObjectProperty:(v,C,T)=>{if(c<C||(u(v,C,T,"property"),t[t.length-1]=v,c<=C+T))throw s},onObjectEnd:(v,C)=>{if(c<=v)throw s;o=void 0,t.pop()},onArrayBegin:(v,C)=>{if(c<=v)throw s;o=void 0,t.push(0)},onArrayEnd:(v,C)=>{if(c<=v)throw s;o=void 0,t.pop()},onLiteralValue:(v,C,T)=>{if(c<C||(u(v,C,T,I(v)),c<=C+T))throw s},onSeparator:(v,C,T)=>{if(c<=C)throw s;if(v===":"&&o&&o.type==="property")o.colonOffset=C,r=!1,o=void 0;else if(v===","){const N=t[t.length-1];typeof N=="number"?t[t.length-1]=N+1:(r=!0,t[t.length-1]=""),o=void 0}}})}catch(v){if(v!==s)throw v}return{path:t,previousNode:o,isAtPropertyKey:r,matches:v=>{let C=0;for(let T=0;C<v.length&&T<t.length;T++)if(v[C]===t[T]||v[C]==="*")C++;else if(v[C]!=="**")return!1;return C===v.length}}}e.getLocation=b;function g(n,c=[],t=A.DEFAULT){let s=null,o=[];const a=[];function r(v){Array.isArray(o)?o.push(v):s!==null&&(o[s]=v)}return p(n,{onObjectBegin:()=>{const v={};r(v),a.push(o),o=v,s=null},onObjectProperty:v=>{s=v},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const v=[];r(v),a.push(o),o=v,s=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:r,onError:(v,C,T)=>{c.push({error:v,offset:C,length:T})}},t),o[0]}e.parse=g;function m(n,c=[],t=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(v){s.type==="property"&&(s.length=v-s.offset,s=s.parent)}function a(v){return s.children.push(v),v}p(n,{onObjectBegin:v=>{s=a({type:"object",offset:v,length:-1,parent:s,children:[]})},onObjectProperty:(v,C,T)=>{s=a({type:"property",offset:C,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:v,offset:C,length:T,parent:s})},onObjectEnd:(v,C)=>{s.length=v+C-s.offset,s=s.parent,o(v+C)},onArrayBegin:(v,C)=>{s=a({type:"array",offset:v,length:-1,parent:s,children:[]})},onArrayEnd:(v,C)=>{s.length=v+C-s.offset,s=s.parent,o(v+C)},onLiteralValue:(v,C,T)=>{a({type:I(v),offset:C,length:T,parent:s,value:v}),o(C+T)},onSeparator:(v,C,T)=>{s.type==="property"&&(v===":"?s.colonOffset=C:v===","&&o(C))},onError:(v,C,T)=>{c.push({error:v,offset:C,length:T})}},t);const u=s.children[0];return u&&delete u.parent,u}e.parseTree=m;function h(n,c){if(!n)return;let t=n;for(const s of c)if(typeof s=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const a of t.children)if(Array.isArray(a.children)&&a.children[0].value===s){t=a.children[1],o=!0;break}if(!o)return}else{const o=s;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=h;function y(n){if(!n.parent||!n.parent.children)return[];const c=y(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;c.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&c.push(t)}return c}e.getNodePath=y;function f(n){switch(n.type){case"array":return n.children.map(f);case"object":{const c=Object.create(null);for(const t of n.children){const s=t.children[1];s&&(c[t.children[0].value]=f(s))}return c}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=f;function l(n,c,t=!1){return c>=n.offset&&c<n.offset+n.length||t&&c===n.offset+n.length}e.contains=l;function d(n,c,t=!1){if(l(n,c,t)){const s=n.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=c;o++){const a=d(s[o],c,t);if(a)return a}return n}}e.findNodeAtOffset=d;function p(n,c,t=A.DEFAULT){const s=O(n,!1);function o(re){return re?()=>re(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(re){return re?te=>re(te,s.getTokenOffset(),s.getTokenLength()):()=>!0}const r=o(c.onObjectBegin),u=a(c.onObjectProperty),v=o(c.onObjectEnd),C=o(c.onArrayBegin),T=o(c.onArrayEnd),N=a(c.onLiteralValue),F=a(c.onSeparator),j=o(c.onComment),L=a(c.onError),$=t&&t.disallowComments,z=t&&t.allowTrailingComma;function H(){for(;;){const re=s.scan();switch(s.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:$||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(re){case 12:case 13:$?X(10):j();break;case 16:X(1);break;case 15:case 14:break;default:return re}}}function X(re,te=[],U=[]){if(L(re),te.length+U.length>0){let B=s.getToken();for(;B!==17;){if(te.indexOf(B)!==-1){H();break}else if(U.indexOf(B)!==-1)break;B=H()}}}function ie(re){const te=s.getTokenValue();return re?N(te):u(te),H(),!0}function G(){switch(s.getToken()){case 11:{let re=0;try{re=JSON.parse(s.getTokenValue()),typeof re!="number"&&(X(2),re=0)}catch{X(2)}N(re);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return H(),!0}function M(){return s.getToken()!==10?(X(3,[],[2,5]),!1):(ie(!1),s.getToken()===6?(F(":"),H(),ee()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function V(){r(),H();let re=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(re||X(4,[],[]),F(","),H(),s.getToken()===2&&z)break}else re&&X(6,[],[]);M()||X(4,[],[2,5]),re=!0}return v(),s.getToken()!==2?X(7,[2],[]):H(),!0}function x(){C(),H();let re=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(re||X(4,[],[]),F(","),H(),s.getToken()===4&&z)break}else re&&X(6,[],[]);ee()||X(4,[],[4,5]),re=!0}return T(),s.getToken()!==4?X(8,[4],[]):H(),!0}function ee(){switch(s.getToken()){case 3:return x();case 1:return V();case 10:return ie(!0);default:return G()}}return H(),s.getToken()===17?t.allowEmptyContent?!0:(X(4,[],[]),!1):ee()?(s.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.visit=p;function w(n,c){const t=O(n),s=[];let o,a=0,r;do switch(r=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:a!==r&&s.push(n.substring(a,r)),c!==void 0&&s.push(t.getTokenValue().replace(/[^\r\n]/g,c)),a=t.getPosition();break}while(o!==17);return s.join("")}e.stripComments=w;function I(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=I}),define(oe[43],ae([0,1,35]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(S,E,b){let g,m,h,y,f;if(E){for(y=E.offset,f=y+E.length,h=y;h>0&&!P(S,h-1);)h--;let r=f;for(;r<S.length&&!P(S,r);)r++;m=S.substring(h,r),g=O(m,b)}else m=S,g=0,h=0,y=0,f=S.length;const l=R(b,S);let d=!1,p=0,w;b.insertSpaces?w=A(" ",b.tabSize||4):w="	";const I=(0,k.createScanner)(m,!1);let n=!1;function c(){return l+A(w,g+p)}function t(){let r=I.scan();for(d=!1;r===15||r===14;)d=d||r===14,r=I.scan();return n=r===16||I.getTokenError()!==0,r}const s=[];function o(r,u,v){!n&&u<f&&v>y&&S.substring(u,v)!==r&&s.push({offset:u,length:v-u,content:r})}let a=t();if(a!==17){const r=I.getTokenOffset()+h,u=A(w,g);o(u,h,r)}for(;a!==17;){let r=I.getTokenOffset()+I.getTokenLength()+h,u=t(),v="";for(;!d&&(u===12||u===13);){const T=I.getTokenOffset()+h;o(" ",r,T),r=I.getTokenOffset()+I.getTokenLength()+h,v=u===12?c():"",u=t()}if(u===2)a!==1&&(p--,v=c());else if(u===4)a!==3&&(p--,v=c());else{switch(a){case 3:case 1:p++,v=c();break;case 5:case 12:v=c();break;case 13:d?v=c():v=" ";break;case 6:v=" ";break;case 10:if(u===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?v=" ":u!==5&&u!==17&&(n=!0);break;case 16:n=!0;break}d&&(u===12||u===13)&&(v=c())}const C=I.getTokenOffset()+h;o(v,r,C),a=u}return s}e.format=i;function D(S,E){const b=JSON.stringify(S,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?b.replace(/\r\n|\r|\n/g,E.eol):b}e.toFormattedString=D;function A(S,E){let b="";for(let g=0;g<E;g++)b+=S;return b}function O(S,E){let b=0,g=0;const m=E.tabSize||4;for(;b<S.length;){const h=S.charAt(b);if(h===" ")g++;else if(h==="	")g+=m;else break;b++}return Math.floor(g/m)}function R(S,E){for(let b=0;b<E.length;b++){const g=E.charAt(b);if(g==="\r")return b+1<E.length&&E.charAt(b+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=R;function P(S,E){return`\r
`.indexOf(S.charAt(E))!==-1}e.isEOL=P}),define(oe[83],ae([0,1,35,43]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(S,E,b){return A(S,E,void 0,b)}e.removeProperty=D;function A(S,E,b,g,m){const h=E.slice(),y=[],f=(0,k.parseTree)(S,y);let l,d;for(;h.length>0&&(d=h.pop(),l=(0,k.findNodeAtLocation)(f,h),l===void 0&&b!==void 0);)typeof d=="string"?b={[d]:b}:b=[b];if(l)if(l.type==="object"&&typeof d=="string"&&Array.isArray(l.children)){const p=(0,k.findNodeAtLocation)(l,[d]);if(p!==void 0)if(b===void 0){if(!p.parent)throw new Error("Malformed AST");const w=l.children.indexOf(p.parent);let I,n=p.parent.offset+p.parent.length;if(w>0){const c=l.children[w-1];I=c.offset+c.length}else I=l.offset+1,l.children.length>1&&(n=l.children[1].offset);return O(S,{offset:I,length:n-I,content:""},g)}else return O(S,{offset:p.offset,length:p.length,content:JSON.stringify(b)},g);else{if(b===void 0)return[];const w=`${JSON.stringify(d)}: ${JSON.stringify(b)}`,I=m?m(l.children.map(c=>c.children[0].value)):l.children.length;let n;if(I>0){const c=l.children[I-1];n={offset:c.offset+c.length,length:0,content:","+w}}else l.children.length===0?n={offset:l.offset+1,length:0,content:w}:n={offset:l.offset+1,length:0,content:w+","};return O(S,n,g)}}else if(l.type==="array"&&typeof d=="number"&&Array.isArray(l.children))if(b!==void 0){const p=`${JSON.stringify(b)}`;let w;if(l.children.length===0||d===0)w={offset:l.offset+1,length:0,content:l.children.length===0?p:p+","};else{const I=d===-1||d>l.children.length?l.children.length:d,n=l.children[I-1];w={offset:n.offset+n.length,length:0,content:","+p}}return O(S,w,g)}else{const p=d,w=l.children[p];let I;if(l.children.length===1)I={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===p){const n=l.children[p-1],c=n.offset+n.length,t=l.offset+l.length;I={offset:c,length:t-2-c,content:""}}else I={offset:w.offset,length:l.children[p+1].offset-w.offset,content:""};return O(S,I,g)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${l.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return O(S,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(b)},g)}}e.setProperty=A;function O(S,E,b){let g=R(S,E),m=E.offset,h=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;m>0&&!(0,i.isEOL)(g,m-1);)m--;for(;h<g.length&&!(0,i.isEOL)(g,h);)h++}const y=(0,i.format)(g,{offset:m,length:h-m},b);for(let l=y.length-1;l>=0;l--){const d=y[l];g=R(g,d),m=Math.min(m,d.offset),h=Math.max(h,d.offset+d.length),h+=d.content.length-d.length}const f=S.length-(g.length-h)-m;return[{offset:m,length:f,content:g.substring(m,h)}]}e.withFormatting=O;function R(S,E){return S.substring(0,E.offset)+E.content+S.substring(E.offset+E.length)}e.applyEdit=R;function P(S,E){const b=E.slice(0).sort((m,h)=>{const y=m.offset-h.offset;return y===0?m.length-h.length:y});let g=S.length;for(let m=b.length-1;m>=0;m--){const h=b[m];if(h.offset+h.length<=g)S=R(S,h);else throw new Error("Overlapping edit");g=h.offset}return S}e.applyEdits=P}),define(oe[129],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(D){this.d=D,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(D){return new k(()=>D(this.getValue()))}}e.Lazy=k}),define(oe[2],ae([0,1,82,64]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let A=null;function O(a){A=a}if(e.setDisposableTracker=O,D){const a="__is_disposable_tracked__";O(new class{trackDisposable(r){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[a]||console.log(u)},3e3)}setParent(r,u){if(r&&r!==d.None)try{r[a]=!0}catch{}}markAsDisposed(r){if(r&&r!==d.None)try{r[a]=!0}catch{}}markAsSingleton(r){}})}function R(a){return A?.trackDisposable(a),a}function P(a){A?.markAsDisposed(a)}function S(a,r){A?.setParent(a,r)}function E(a,r){if(!!A)for(const u of a)A.setParent(u,r)}function b(a){return A?.markAsSingleton(a),a}e.markAsSingleton=b;function g(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=g;function m(a){if(i.Iterable.is(a)){const r=[];for(const u of a)if(u)try{u.dispose()}catch(v){r.push(v)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=m;function h(a){for(const r of a)g(r)&&r.dispose();return[]}e.disposeIfDisposable=h;function y(...a){const r=f(()=>m(a));return E(a,r),r}e.combinedDisposable=y;function f(a){const r=R({dispose:(0,k.once)(()=>{P(r),a()})});return r}e.toDisposable=f;class l{constructor(){this.c=new Set,this.f=!1,R(this)}dispose(){this.f||(P(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{m(this.c)}finally{this.c.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return S(r,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(r),r}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this.q=new l,R(this),S(this.q,this)}dispose(){P(this),this.q.dispose()}B(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(r)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class p{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(r){this.b||r===this.a||(this.a?.dispose(),r&&S(r,this),this.a=r)}clear(){this.value=void 0}dispose(){this.b=!0,P(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&S(r,null),r}}e.MutableDisposable=p;class w{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=w;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(r){let u=r;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,P(this))},this}}e.SafeDisposable=I;class n{constructor(){this.a=new Map}acquire(r,...u){let v=this.a.get(r);v||(v={counter:0,object:this.b(r,...u)},this.a.set(r,v));const{object:C}=v,T=(0,k.once)(()=>{--v.counter===0&&(this.c(r,v.object),this.a.delete(r))});return v.counter++,{object:C,dispose:T}}}e.ReferenceCollection=n;class c{constructor(r){this.a=r}async acquire(r,...u){const v=this.a.acquire(r,...u);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(C){throw v.dispose(),C}}}e.AsyncReferenceCollection=c;class t{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=t;function s(a){const r=new l;try{a(r)}finally{r.dispose()}}e.disposeOnReturn=s;class o{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){P(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(r){return this.a.has(r)}get(r){return this.a.get(r)}set(r,u,v=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),v||this.a.get(r)?.dispose(),this.a.set(r,u)}deleteAndDispose(r){this.a.get(r)?.dispose(),this.a.delete(r)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(oe[84],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(A){this.element=A,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class i{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let A=this.a;for(;A!==k.Undefined;){const O=A.next;A.prev=k.Undefined,A.next=k.Undefined,A=O}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const R=new k(A);if(this.a===k.Undefined)this.a=R,this.b=R;else if(O){const S=this.b;this.b=R,R.prev=S,S.next=R}else{const S=this.a;this.a=R,R.next=S,S.prev=R}this.c+=1;let P=!1;return()=>{P||(P=!0,this.e(R))}}shift(){if(this.a!==k.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==k.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==k.Undefined&&A.next!==k.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===k.Undefined&&A.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):A.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):A.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==k.Undefined;)yield A.element,A=A.next}}e.LinkedList=i}),define(oe[37],ae([0,1]),function(Z,e){"use strict";var k,i,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(h,y,f){let l=h.get(y);return l===void 0&&(l=f,h.set(y,l)),l}e.getOrSet=A;function O(h){const y=[];return h.forEach((f,l)=>{y.push(`${l} => ${f}`)}),`Map(${h.size}) {${y.join(", ")}}`}e.mapToString=O;function R(h){const y=[];return h.forEach(f=>{y.push(f)}),`Set(${h.size}) {${y.join(", ")}}`}e.setToString=R;class P{constructor(y,f){this.uri=y,this.value=f}}class S{constructor(y,f){this[k]="ResourceMap",y instanceof S?(this.b=new Map(y.b),this.c=f??S.a):(this.b=new Map,this.c=y??S.a)}set(y,f){return this.b.set(this.c(y),new P(y,f)),this}get(y){return this.b.get(this.c(y))?.value}has(y){return this.b.has(this.c(y))}get size(){return this.b.size}clear(){this.b.clear()}delete(y){return this.b.delete(this.c(y))}forEach(y,f){typeof f<"u"&&(y=y.bind(f));for(const[l,d]of this.b)y(d.value,d.uri,this)}*values(){for(const y of this.b.values())yield y.value}*keys(){for(const y of this.b.values())yield y.uri}*entries(){for(const y of this.b.values())yield[y.uri,y.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,y]of this.b)yield[y.uri,y.value]}}e.ResourceMap=S,S.a=h=>h.toString();class E{constructor(y,f){this[i]="ResourceSet",!y||typeof y=="function"?this.a=new S(y):(this.a=new S(f),y.forEach(this.add,this))}get size(){return this.a.size}add(y){return this.a.set(y,y),this}clear(){this.a.clear()}delete(y){return this.a.delete(y)}forEach(y,f){this.a.forEach((l,d)=>y.call(f,d,d,this))}has(y){return this.a.has(y)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=E;var b;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class g{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(y){return this.a.has(y)}get(y,f=0){const l=this.a.get(y);if(!!l)return f!==0&&this.j(l,f),l.value}set(y,f,l=0){let d=this.a.get(y);if(d)d.value=f,l!==0&&this.j(d,l);else{switch(d={key:y,value:f,next:void 0,previous:void 0},l){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(y,d),this.d++}return this}delete(y){return!!this.remove(y)}remove(y){const f=this.a.get(y);if(!!f)return this.a.delete(y),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const y=this.b;return this.a.delete(y.key),this.i(y),this.d--,y.value}forEach(y,f){const l=this.e;let d=this.b;for(;d;){if(f?y.bind(f)(d.value,d.key,this):y(d.value,d.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const y=this,f=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(y.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:l.key,done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return d}values(){const y=this,f=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(y.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:l.value,done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return d}entries(){const y=this,f=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(y.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const p={value:[l.key,l.value],done:!1};return l=l.next,p}else return{value:void 0,done:!0}}};return d}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(y){if(y>=this.size)return;if(y===0){this.clear();return}let f=this.b,l=this.size;for(;f&&l>y;)this.a.delete(f.key),f=f.next,l--;this.b=f,this.d=l,f&&(f.previous=void 0),this.e++}g(y){if(!this.b&&!this.c)this.c=y;else if(this.b)y.next=this.b,this.b.previous=y;else throw new Error("Invalid list");this.b=y,this.e++}h(y){if(!this.b&&!this.c)this.b=y;else if(this.c)y.previous=this.c,this.c.next=y;else throw new Error("Invalid list");this.c=y,this.e++}i(y){if(y===this.b&&y===this.c)this.b=void 0,this.c=void 0;else if(y===this.b){if(!y.next)throw new Error("Invalid list");y.next.previous=void 0,this.b=y.next}else if(y===this.c){if(!y.previous)throw new Error("Invalid list");y.previous.next=void 0,this.c=y.previous}else{const f=y.next,l=y.previous;if(!f||!l)throw new Error("Invalid list");f.previous=l,l.next=f}y.next=void 0,y.previous=void 0,this.e++}j(y,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(y===this.b)return;const l=y.next,d=y.previous;y===this.c?(d.next=void 0,this.c=d):(l.previous=d,d.next=l),y.previous=void 0,y.next=this.b,this.b.previous=y,this.b=y,this.e++}else if(f===2){if(y===this.c)return;const l=y.next,d=y.previous;y===this.b?(l.previous=void 0,this.b=l):(l.previous=d,d.next=l),y.next=void 0,y.previous=this.c,this.c.next=y,this.c=y,this.e++}}}toJSON(){const y=[];return this.forEach((f,l)=>{y.push([l,f])}),y}fromJSON(y){this.clear();for(const[f,l]of y)this.set(f,l)}}e.LinkedMap=g;class m extends g{constructor(y,f=1){super(),this.k=y,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(y){this.k=y,this.m()}get ratio(){return this.l}set ratio(y){this.l=Math.min(Math.max(0,y),1),this.m()}get(y,f=2){return super.get(y,f)}peek(y){return super.get(y,0)}set(y,f){return super.set(y,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=m}),define(oe[85],ae([0,1,37]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new k.LRUCache(1e4);function D(S){return P(S,"NFC",i)}e.normalizeNFC=D;const A=new k.LRUCache(1e4);function O(S){return P(S,"NFD",A)}e.normalizeNFD=O;const R=/[^\u0000-\u0080]/;function P(S,E,b){if(!S)return S;const g=b.get(S);if(g)return g;let m;return R.test(S)?m=S.normalize(E):m=S,b.set(S,m),m}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(E){return O(E).replace(S,"")}}()}),define(oe[130],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function k(R,P,S){return Math.min(Math.max(R,P),S)}e.clamp=k;function i(R,P){return(P+R%P)%P}e.rot=i;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class A{constructor(){this.a=1,this.b=0}update(P){return this.b=this.b+(P-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class O{constructor(P){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(P),this.c.fill(0,0,P)}update(P){const S=this.c[this.d];return this.c[this.d]=P,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=P,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=O}),function(){function Z(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function O(P){A.push(P,Date.now())}function R(){const P=[];for(let S=0;S<A.length;S+=2)P.push({name:A[S],startTime:A[S+1]});return P}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(D+O.startTime)});return A}};if(typeof process=="object"){const D=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function k(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=k(i))}(),function(Z,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var i in k)(typeof exports=="object"?exports:Z)[i]=k[i]}}(typeof self<"u"?self:this,function(){return function(Z){var e={};function k(i){if(e[i])return e[i].exports;var D=e[i]={i,l:!1,exports:{}};return Z[i].call(D.exports,D,D.exports,k),D.l=!0,D.exports}return k.m=Z,k.c=e,k.d=function(i,D,A){k.o(i,D)||Object.defineProperty(i,D,{enumerable:!0,get:A})},k.r=function(i){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},k.t=function(i,D){if(1&D&&(i=k(i)),8&D||4&D&&typeof i=="object"&&i&&i.__esModule)return i;var A=Object.create(null);if(k.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:i}),2&D&&typeof i!="string")for(var O in i)k.d(A,O,function(R){return i[R]}.bind(null,O));return A},k.n=function(i){var D=i&&i.__esModule?function(){return i.default}:function(){return i};return k.d(D,"a",D),D},k.o=function(i,D){return Object.prototype.hasOwnProperty.call(i,D)},k.p="",k(k.s=0)}([function(Z,e,k){(function(i){var D;e=Z.exports=U,D=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],P=e.src=[],S=0,E=S++;P[E]="0|[1-9]\\d*";var b=S++;P[b]="[0-9]+";var g=S++;P[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=S++;P[m]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var h=S++;P[h]="("+P[b]+")\\.("+P[b]+")\\.("+P[b]+")";var y=S++;P[y]="(?:"+P[E]+"|"+P[g]+")";var f=S++;P[f]="(?:"+P[b]+"|"+P[g]+")";var l=S++;P[l]="(?:-("+P[y]+"(?:\\."+P[y]+")*))";var d=S++;P[d]="(?:-?("+P[f]+"(?:\\."+P[f]+")*))";var p=S++;P[p]="[0-9A-Za-z-]+";var w=S++;P[w]="(?:\\+("+P[p]+"(?:\\."+P[p]+")*))";var I=S++,n="v?"+P[m]+P[l]+"?"+P[w]+"?";P[I]="^"+n+"$";var c="[v=\\s]*"+P[h]+P[d]+"?"+P[w]+"?",t=S++;P[t]="^"+c+"$";var s=S++;P[s]="((?:<|>)?=?)";var o=S++;P[o]=P[b]+"|x|X|\\*";var a=S++;P[a]=P[E]+"|x|X|\\*";var r=S++;P[r]="[v=\\s]*("+P[a]+")(?:\\.("+P[a]+")(?:\\.("+P[a]+")(?:"+P[l]+")?"+P[w]+"?)?)?";var u=S++;P[u]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[d]+")?"+P[w]+"?)?)?";var v=S++;P[v]="^"+P[s]+"\\s*"+P[r]+"$";var C=S++;P[C]="^"+P[s]+"\\s*"+P[u]+"$";var T=S++;P[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=S++;P[N]="(?:~>?)";var F=S++;P[F]="(\\s*)"+P[N]+"\\s+",R[F]=new RegExp(P[F],"g");var j=S++;P[j]="^"+P[N]+P[r]+"$";var L=S++;P[L]="^"+P[N]+P[u]+"$";var $=S++;P[$]="(?:\\^)";var z=S++;P[z]="(\\s*)"+P[$]+"\\s+",R[z]=new RegExp(P[z],"g");var H=S++;P[H]="^"+P[$]+P[r]+"$";var X=S++;P[X]="^"+P[$]+P[u]+"$";var ie=S++;P[ie]="^"+P[s]+"\\s*("+c+")$|^$";var G=S++;P[G]="^"+P[s]+"\\s*("+n+")$|^$";var M=S++;P[M]="(\\s*)"+P[s]+"\\s*("+c+"|"+P[r]+")",R[M]=new RegExp(P[M],"g");var V=S++;P[V]="^\\s*("+P[r]+")\\s+-\\s+("+P[r]+")\\s*$";var x=S++;P[x]="^\\s*("+P[u]+")\\s+-\\s+("+P[u]+")\\s*$";var ee=S++;P[ee]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)D(re,P[re]),R[re]||(R[re]=new RegExp(P[re]));function te(ce,de){if(ce instanceof U)return ce;if(typeof ce!="string"||ce.length>A||!(de?R[t]:R[I]).test(ce))return null;try{return new U(ce,de)}catch{return null}}function U(ce,de){if(ce instanceof U){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof U))return new U(ce,de);D("SemVer",ce,de),this.loose=de;var ge=ce.trim().match(de?R[t]:R[I]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<O)return Pe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=te,e.valid=function(ce,de){var ge=te(ce,de);return ge?ge.version:null},e.clean=function(ce,de){var ge=te(ce.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof U||(ce=new U(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},U.prototype.compareMain=function(ce){return ce instanceof U||(ce=new U(ce,this.loose)),W(this.major,ce.major)||W(this.minor,ce.minor)||W(this.patch,ce.patch)},U.prototype.comparePre=function(ce){if(ce instanceof U||(ce=new U(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ce=ce.prerelease[de];if(D("prerelease compare",de,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return W(ge,Ce)}while(++de)},U.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new U(ce,ge).inc(de,Ce).version}catch{return null}},e.diff=function(ce,de){if(Y(ce,de))return null;var ge=te(ce),Ce=te(de);if(ge.prerelease.length||Ce.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=W;var B=/^[0-9]+$/;function W(ce,de){var ge=B.test(ce),Ce=B.test(de);return ge&&Ce&&(ce=+ce,de=+de),ge&&!Ce?-1:Ce&&!ge?1:ce<de?-1:ce>de?1:0}function q(ce,de,ge){return new U(ce,ge).compare(new U(de,ge))}function J(ce,de,ge){return q(ce,de,ge)>0}function _(ce,de,ge){return q(ce,de,ge)<0}function Y(ce,de,ge){return q(ce,de,ge)===0}function Q(ce,de,ge){return q(ce,de,ge)!==0}function se(ce,de,ge){return q(ce,de,ge)>=0}function le(ce,de,ge){return q(ce,de,ge)<=0}function ue(ce,de,ge,Ce){var Pe;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=Y(ce,ge,Ce);break;case"!=":Pe=Q(ce,ge,Ce);break;case">":Pe=J(ce,ge,Ce);break;case">=":Pe=se(ce,ge,Ce);break;case"<":Pe=_(ce,ge,Ce);break;case"<=":Pe=le(ce,ge,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function pe(ce,de){if(ce instanceof pe){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof pe))return new pe(ce,de);D("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===we?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,de){return W(de,ce)},e.major=function(ce,de){return new U(ce,de).major},e.minor=function(ce,de){return new U(ce,de).minor},e.patch=function(ce,de){return new U(ce,de).patch},e.compare=q,e.compareLoose=function(ce,de){return q(ce,de,!0)},e.rcompare=function(ce,de,ge){return q(de,ce,ge)},e.sort=function(ce,de){return ce.sort(function(ge,Ce){return e.compare(ge,Ce,de)})},e.rsort=function(ce,de){return ce.sort(function(ge,Ce){return e.rcompare(ge,Ce,de)})},e.gt=J,e.lt=_,e.eq=Y,e.neq=Q,e.gte=se,e.lte=le,e.cmp=ue,e.Comparator=pe;var we={};function be(ce,de){if(ce instanceof be)return ce.loose===de?ce:new be(ce.raw,de);if(ce instanceof pe)return new be(ce.value,de);if(!(this instanceof be))return new be(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ee(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Te(ce,de,ge,Ce,Pe,Ae,De,je,Oe,Fe,ze,ke,Ne){return((de=Ee(ge)?"":Ee(Ce)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ce+".0":">="+de)+" "+(je=Ee(Oe)?"":Ee(Fe)?"<"+(+Oe+1)+".0.0":Ee(ze)?"<"+Oe+"."+(+Fe+1)+".0":ke?"<="+Oe+"."+Fe+"."+ze+"-"+ke:"<="+je)).trim()}function Ue(ce,de){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<ce.length;ge++)if(D(ce[ge].semver),ce[ge].semver!==we&&ce[ge].semver.prerelease.length>0){var Ce=ce[ge].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ye(ce,de,ge){try{de=new be(de,ge)}catch{return!1}return de.test(ce)}function Be(ce,de,ge,Ce){var Pe,Ae,De,je,Oe;switch(ce=new U(ce,Ce),de=new be(de,Ce),ge){case">":Pe=J,Ae=le,De=_,je=">",Oe=">=";break;case"<":Pe=_,Ae=se,De=J,je="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ce,de,Ce))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var ze=de.set[Fe],ke=null,Ne=null;if(ze.forEach(function(ne){ne.semver===we&&(ne=new pe(">=0.0.0")),ke=ke||ne,Ne=Ne||ne,Pe(ne.semver,ke.semver,Ce)?ke=ne:De(ne.semver,Ne.semver,Ce)&&(Ne=ne)}),ke.operator===je||ke.operator===Oe||(!Ne.operator||Ne.operator===je)&&Ae(ce,Ne.semver)||Ne.operator===Oe&&De(ce,Ne.semver))return!1}return!0}pe.prototype.parse=function(ce){var de=this.loose?R[ie]:R[G],ge=ce.match(de);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new U(ge[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===we||(typeof ce=="string"&&(ce=new U(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ce,de){if(!(ce instanceof pe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,de),Ye(this.value,ge,de);if(ce.operator==="")return ge=new be(this.value,de),Ye(ce.semver,ge,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ae=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=ue(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Oe=ue(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ce||Pe||Ae&&De||je||Oe},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),D("range",ce,de);var ge=de?R[x]:R[V];ce=ce.replace(ge,Te),D("hyphen replace",ce),ce=ce.replace(R[M],"$1$2$3"),D("comparator trim",ce,R[M]),ce=(ce=(ce=ce.replace(R[F],"$1~")).replace(R[z],"$1^")).split(/\s+/).join(" ");var Ce=de?R[ie]:R[G],Pe=ce.split(" ").map(function(Ae){return function(De,je){return D("comp",De),De=function(Oe,Fe){return Oe.trim().split(/\s+/).map(function(ze){return function(ke,Ne){D("caret",ke,Ne);var ne=Ne?R[X]:R[H];return ke.replace(ne,function(he,fe,me,ve,Ie){var Re;return D("caret",ke,he,fe,me,ve,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(ve)?Re=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+ve+Ie+" <"+fe+"."+me+"."+(+ve+1):">="+fe+"."+me+"."+ve+Ie+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+ve+Ie+" <"+(+fe+1)+".0.0"):(D("no pr"),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+ve+" <"+fe+"."+me+"."+(+ve+1):">="+fe+"."+me+"."+ve+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+ve+" <"+(+fe+1)+".0.0"),D("caret return",Re),Re})}(ze,Fe)}).join(" ")}(De,je),D("caret",De),De=function(Oe,Fe){return Oe.trim().split(/\s+/).map(function(ze){return function(ke,Ne){var ne=Ne?R[L]:R[j];return ke.replace(ne,function(he,fe,me,ve,Ie){var Re;return D("tilde",ke,he,fe,me,ve,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(ve)?Re=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=">="+fe+"."+me+"."+ve+Ie+" <"+fe+"."+(+me+1)+".0"):Re=">="+fe+"."+me+"."+ve+" <"+fe+"."+(+me+1)+".0",D("tilde return",Re),Re})}(ze,Fe)}).join(" ")}(De,je),D("tildes",De),De=function(Oe,Fe){return D("replaceXRanges",Oe,Fe),Oe.split(/\s+/).map(function(ze){return function(ke,Ne){ke=ke.trim();var ne=Ne?R[C]:R[v];return ke.replace(ne,function(he,fe,me,ve,Ie,Re){D("xRange",ke,he,fe,me,ve,Ie,Re);var He=Ee(me),$e=He||Ee(ve),Le=$e||Ee(Ie);return fe==="="&&Le&&(fe=""),He?he=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Le?($e&&(ve=0),Le&&(Ie=0),fe===">"?(fe=">=",$e?(me=+me+1,ve=0,Ie=0):Le&&(ve=+ve+1,Ie=0)):fe==="<="&&(fe="<",$e?me=+me+1:ve=+ve+1),he=fe+me+"."+ve+"."+Ie):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Le&&(he=">="+me+"."+ve+".0 <"+me+"."+(+ve+1)+".0"),D("xRange return",he),he})}(ze,Fe)}).join(" ")}(De,je),D("xrange",De),De=function(Oe,Fe){return D("replaceStars",Oe,Fe),Oe.trim().replace(R[ee],"")}(De,je),D("stars",De),De}(Ae,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ae){return!!Ae.match(Ce)})),Pe=Pe.map(function(Ae){return new pe(Ae,de)})},be.prototype.intersects=function(ce,de){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ce.set.some(function(Pe){return Pe.every(function(Ae){return Ce.intersects(Ae,de)})})})})},e.toComparators=function(ce,de){return new be(ce,de).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new U(ce,this.loose));for(var de=0;de<this.set.length;de++)if(Ue(this.set[de],ce))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==-1||(Pe=new U(Ce=De,ge)))}),Ce},e.minSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==1||(Pe=new U(Ce=De,ge)))}),Ce},e.validRange=function(ce,de){try{return new be(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,ge){return Be(ce,de,"<",ge)},e.gtr=function(ce,de,ge){return Be(ce,de,">",ge)},e.outside=Be,e.prerelease=function(ce,de){var ge=te(ce,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,de,ge){return ce=new be(ce,ge),de=new be(de,ge),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof U)return ce;if(typeof ce!="string")return null;var de=ce.match(R[T]);return de==null?null:te((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,k(1))},function(Z,e){var k,i,D=Z.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(f){if(k===setTimeout)return setTimeout(f,0);if((k===A||!k)&&setTimeout)return k=setTimeout,setTimeout(f,0);try{return k(f,0)}catch{try{return k.call(null,f,0)}catch{return k.call(this,f,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:A}catch{k=A}try{i=typeof clearTimeout=="function"?clearTimeout:O}catch{i=O}})();var P,S=[],E=!1,b=-1;function g(){E&&P&&(E=!1,P.length?S=P.concat(S):b=-1,S.length&&m())}function m(){if(!E){var f=R(g);E=!0;for(var l=S.length;l;){for(P=S,S=[];++b<l;)P&&P[b].run();b=-1,l=S.length}P=null,E=!1,function(d){if(i===clearTimeout)return clearTimeout(d);if((i===O||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(d);try{i(d)}catch{try{return i.call(null,d)}catch{return i.call(this,d)}}}(f)}}function h(f,l){this.fun=f,this.array=l}function y(){}D.nextTick=function(f){var l=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)l[d-1]=arguments[d];S.push(new h(f,l)),S.length!==1||E||R(m)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(f){return[]},D.binding=function(f){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(f){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(oe[131],ae([0,1]),function(Z,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(R,P,S){this.level=R,this.key=P,this.value=S,this.forward=[]}}const D=void 0;class A{constructor(R,P=2**16){this.comparator=R,this[k]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(P)|0),this.e=new i(this.c,D,D)}get size(){return this.f}clear(){this.e=new i(this.c,D,D)}has(R){return Boolean(A.g(this,R,this.comparator))}get(R){return A.g(this,R,this.comparator)?.value}set(R,P){return A.h(this,R,P,this.comparator)&&(this.f+=1),this}delete(R){const P=A.k(this,R,this.comparator);return P&&(this.f-=1),P}forEach(R,P){let S=this.e.forward[0];for(;S;)R.call(P,S.value,S.key,this),S=S.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",P=this.e.forward[0];for(;P;)R+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return R}static g(R,P,S){let E=R.e;for(let b=R.d-1;b>=0;b--)for(;E.forward[b]&&S(E.forward[b].key,P)<0;)E=E.forward[b];if(E=E.forward[0],E&&S(E.key,P)===0)return E}static h(R,P,S,E){const b=[];let g=R.e;for(let m=R.d-1;m>=0;m--){for(;g.forward[m]&&E(g.forward[m].key,P)<0;)g=g.forward[m];b[m]=g}if(g=g.forward[0],g&&E(g.key,P)===0)return g.value=S,!1;{const m=A.j(R);if(m>R.d){for(let h=R.d;h<m;h++)b[h]=R.e;R.d=m}g=new i(m,P,S);for(let h=0;h<m;h++)g.forward[h]=b[h].forward[h],b[h].forward[h]=g;return!0}}static j(R,P=.5){let S=1;for(;Math.random()<P&&S<R.c;)S+=1;return S}static k(R,P,S){const E=[];let b=R.e;for(let g=R.d-1;g>=0;g--){for(;b.forward[g]&&S(b.forward[g].key,P)<0;)b=b.forward[g];E[g]=b}if(b=b.forward[0],!b||S(b.key,P)!==0)return!1;for(let g=0;g<R.d&&E[g].forward[g]===b;g++)E[g].forward[g]=b.forward[g];for(;R.d>0&&R.e.forward[R.d-1]===D;)R.d-=1;return!0}}e.SkipList=A}),define(oe[44],ae([0,1,7,2]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(w){const I=w;return I?typeof I.read=="function":!1}e.isReadable=D;function A(w){const I=w;return I?[I.on,I.pause,I.resume,I.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=A;function O(w){const I=w;return I?A(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.isReadableBufferedStream=O;function R(w,I){return new P(w,I)}e.newWriteableStream=R;class P{constructor(I,n){this.e=I,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(I){if(!this.a.destroyed){if(this.a.flowing)this.g(I);else if(this.b.data.push(I),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(I){this.a.destroyed||(this.a.flowing?this.h(I):this.b.error.push(I))}end(I){this.a.destroyed||(typeof I<"u"&&this.write(I),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(I){this.c.data.slice(0).forEach(n=>n(I))}h(I){this.c.error.length===0?(0,k.onUnexpectedError)(I):this.c.error.slice(0).forEach(n=>n(I))}i(){this.c.end.slice(0).forEach(I=>I())}on(I,n){if(!this.a.destroyed)switch(I){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(I,n){if(this.a.destroyed)return;let c;switch(I){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const t=c.indexOf(n);t>=0&&c.splice(t,1)}}j(){if(this.b.data.length>0){const I=this.e(this.b.data);this.g(I),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const I of this.b.error)this.h(I);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(w,I){const n=[];let c;for(;(c=w.read())!==null;)n.push(c);return I(n)}e.consumeReadable=S;function E(w,I,n){const c=[];let t;for(;(t=w.read())!==null&&c.length<n;)c.push(t);return t===null&&c.length>0?I(c):{read:()=>{if(c.length>0)return c.shift();if(typeof t<"u"){const s=t;return t=void 0,s}return w.read()}}}e.peekReadable=E;function b(w,I){return new Promise((n,c)=>{const t=[];g(w,{onData:s=>{I&&t.push(s)},onError:s=>{I?c(s):n(void 0)},onEnd:()=>{n(I?I(t):void 0)}})})}e.consumeStream=b;function g(w,I){let n=!1;return w.on("error",c=>{n||I.onError(c)}),w.on("end",()=>{n||I.onEnd()}),w.on("data",c=>{n||I.onData(c)}),(0,i.toDisposable)(()=>n=!0)}e.listenStream=g;function m(w,I){return new Promise((n,c)=>{const t=new i.DisposableStore,s=[],o=u=>{if(s.push(u),s.length>I)return t.dispose(),w.pause(),n({stream:w,buffer:s,ended:!1})},a=u=>c(u),r=()=>n({stream:w,buffer:s,ended:!0});t.add((0,i.toDisposable)(()=>w.removeListener("error",a))),w.on("error",a),t.add((0,i.toDisposable)(()=>w.removeListener("end",r))),w.on("end",r),t.add((0,i.toDisposable)(()=>w.removeListener("data",o))),w.on("data",o)})}e.peekStream=m;function h(w,I){const n=R(I);return n.end(w),n}e.toStream=h;function y(){const w=R(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=y;function f(w){let I=!1;return{read:()=>I?null:(I=!0,w)}}e.toReadable=f;function l(w,I,n){const c=R(n);return g(w,{onData:t=>c.write(I.data(t)),onError:t=>c.error(I.error?I.error(t):t),onEnd:()=>c.end()}),c}e.transform=l;function d(w,I,n){let c=!1;return{read:()=>{const t=I.read();return c?t:(c=!0,t!==null?n([w,t]):w)}}}e.prefixedReadable=d;function p(w,I,n){let c=!1;const t=R(n);return g(I,{onData:s=>c?t.write(s):(c=!0,t.write(n([w,s]))),onError:s=>t.error(s),onEnd:()=>{c||(c=!0,t.write(w)),t.end()}}),t}e.prefixedStream=p}),define(oe[17],ae([0,1,44]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer<"u";let D,A;class O{static alloc(u){return i?new O(Buffer.allocUnsafe(u)):new O(new Uint8Array(u))}static wrap(u){return i&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new O(u)}static fromString(u,v){return!(v?.dontUseNodeBuffer||!1)&&i?new O(Buffer.from(u)):(D||(D=new TextEncoder),new O(D.encode(u)))}static fromByteArray(u){const v=O.alloc(u.length);for(let C=0,T=u.length;C<T;C++)v.buffer[C]=u[C];return v}static concat(u,v){if(typeof v>"u"){v=0;for(let N=0,F=u.length;N<F;N++)v+=u[N].byteLength}const C=O.alloc(v);let T=0;for(let N=0,F=u.length;N<F;N++){const j=u[N];C.set(j,T),T+=j.byteLength}return C}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=O.alloc(this.byteLength);return u.set(this),u}toString(){return i?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(u,v){return new O(this.buffer.subarray(u,v))}set(u,v){if(u instanceof O)this.buffer.set(u.buffer,v);else if(u instanceof Uint8Array)this.buffer.set(u,v);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),v);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return S(this.buffer,u)}writeUInt32BE(u,v){E(this.buffer,u,v)}readUInt32LE(u){return b(this.buffer,u)}writeUInt32LE(u,v){g(this.buffer,u,v)}readUInt8(u){return m(this.buffer,u)}writeUInt8(u,v){h(this.buffer,u,v)}}e.VSBuffer=O;function R(r,u){return r[u+0]<<0>>>0|r[u+1]<<8>>>0}e.readUInt16LE=R;function P(r,u,v){r[v+0]=u&255,u=u>>>8,r[v+1]=u&255}e.writeUInt16LE=P;function S(r,u){return r[u]*2**24+r[u+1]*2**16+r[u+2]*2**8+r[u+3]}e.readUInt32BE=S;function E(r,u,v){r[v+3]=u,u=u>>>8,r[v+2]=u,u=u>>>8,r[v+1]=u,u=u>>>8,r[v]=u}e.writeUInt32BE=E;function b(r,u){return r[u+0]<<0>>>0|r[u+1]<<8>>>0|r[u+2]<<16>>>0|r[u+3]<<24>>>0}e.readUInt32LE=b;function g(r,u,v){r[v+0]=u&255,u=u>>>8,r[v+1]=u&255,u=u>>>8,r[v+2]=u&255,u=u>>>8,r[v+3]=u&255}e.writeUInt32LE=g;function m(r,u){return r[u]}e.readUInt8=m;function h(r,u,v){r[v]=u}e.writeUInt8=h;function y(r){return k.consumeReadable(r,u=>O.concat(u))}e.readableToBuffer=y;function f(r){return k.toReadable(r)}e.bufferToReadable=f;function l(r){return k.consumeStream(r,u=>O.concat(u))}e.streamToBuffer=l;async function d(r){return r.ended?O.concat(r.buffer):O.concat([...r.buffer,await l(r.stream)])}e.bufferedStreamToBuffer=d;function p(r){return k.toStream(r,u=>O.concat(u))}e.bufferToStream=p;function w(r){return k.transform(r,{data:u=>typeof u=="string"?O.fromString(u):O.wrap(u)},u=>O.concat(u))}e.streamToBufferReadableStream=w;function I(r){return k.newWriteableStream(u=>O.concat(u),r)}e.newWriteableBufferStream=I;function n(r,u){return k.prefixedReadable(r,u,v=>O.concat(v))}e.prefixedBufferReadable=n;function c(r,u){return k.prefixedStream(r,u,v=>O.concat(v))}e.prefixedBufferStream=c;function t(r){let u=0,v=0,C=0;const T=new Uint8Array(Math.floor(r.length/4*3)),N=j=>{switch(v){case 3:T[C++]=u|j,v=0;break;case 2:T[C++]=u|j>>>2,u=j<<6,v=3;break;case 1:T[C++]=u|j>>>4,u=j<<4,v=2;break;default:u=j<<2,v=1}};for(let j=0;j<r.length;j++){const L=r.charCodeAt(j);if(L>=65&&L<=90)N(L-65);else if(L>=97&&L<=122)N(L-97+26);else if(L>=48&&L<=57)N(L-48+52);else if(L===43||L===45)N(62);else if(L===47||L===95)N(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${r[j]}`)}}const F=C;for(;v>0;)N(0);return O.wrap(T).slice(0,F)}e.decodeBase64=t;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:r},u=!0,v=!1){const C=v?o:s;let T="";const N=r.byteLength%3;let F=0;for(;F<r.byteLength-N;F+=3){const j=r[F+0],L=r[F+1],$=r[F+2];T+=C[j>>>2],T+=C[(j<<4|L>>>4)&63],T+=C[(L<<2|$>>>6)&63],T+=C[$&63]}if(N===1){const j=r[F+0];T+=C[j>>>2],T+=C[j<<4&63],u&&(T+="==")}else if(N===2){const j=r[F+0],L=r[F+1];T+=C[j>>>2],T+=C[(j<<4|L>>>4)&63],T+=C[L<<2&63],u&&(T+="=")}return T}e.encodeBase64=a}),define(oe[13],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(c){return typeof c=="string"}e.isString=k;function i(c){return Array.isArray(c)&&c.every(t=>k(t))}e.isStringArray=i;function D(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=D;function A(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.isTypedArray=A;function O(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=O;function R(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=R;function P(c){return c===!0||c===!1}e.isBoolean=P;function S(c){return typeof c>"u"}e.isUndefined=S;function E(c){return!b(c)}e.isDefined=E;function b(c){return S(c)||c===null}e.isUndefinedOrNull=b;function g(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=g;function m(c){if(b(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=m;function h(...c){const t=[];for(let s=0;s<c.length;s++){const o=c[s];if(b(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(o)}return t}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function f(c){if(!D(c))return!1;for(const t in c)if(y.call(c,t))return!1;return!0}e.isEmptyObject=f;function l(c){return typeof c=="function"}e.isFunction=l;function d(...c){return c.length>0&&c.every(l)}e.areFunctions=d;function p(c,t){const s=Math.min(c.length,t.length);for(let o=0;o<s;o++)w(c[o],t[o])}e.validateConstraints=p;function w(c,t){if(k(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if(c instanceof t)return}catch{}if(!b(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=w;function I(c){return c===null?void 0:c}e.withNullAsUndefined=I;function n(c){return typeof c>"u"?null:c}e.withUndefinedAsNull=n}),define(oe[32],ae([0,1,13]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([p,w])=>{d[p]=w&&typeof w=="object"?i(w):w}),d}e.deepClone=i;function D(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const p=d.shift();Object.freeze(p);for(const w in p)if(A.call(p,w)){const I=p[w];typeof I=="object"&&!Object.isFrozen(I)&&!(0,k.isTypedArray)(I)&&d.push(I)}}return l}e.deepFreeze=D;const A=Object.prototype.hasOwnProperty;function O(l,d){return R(l,d,new Set)}e.cloneAndChange=O;function R(l,d,p){if((0,k.isUndefinedOrNull)(l))return l;const w=d(l);if(typeof w<"u")return w;if(Array.isArray(l)){const I=[];for(const n of l)I.push(R(n,d,p));return I}if((0,k.isObject)(l)){if(p.has(l))throw new Error("Cannot clone recursive data-structure");p.add(l);const I={};for(const n in l)A.call(l,n)&&(I[n]=R(l[n],d,p));return p.delete(l),I}return l}function P(l,d,p=!0){return(0,k.isObject)(l)?((0,k.isObject)(d)&&Object.keys(d).forEach(w=>{w in l?p&&((0,k.isObject)(l[w])&&(0,k.isObject)(d[w])?P(l[w],d[w],p):l[w]=d[w]):l[w]=d[w]}),l):d}e.mixin=P;function S(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let p,w;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(p=0;p<l.length;p++)if(!S(l[p],d[p]))return!1}else{const I=[];for(w in l)I.push(w);I.sort();const n=[];for(w in d)n.push(w);if(n.sort(),!S(I,n))return!1;for(p=0;p<I.length;p++)if(!S(l[I[p]],d[I[p]]))return!1}return!0}e.equals=S;function E(l){const d=new Set;return JSON.stringify(l,(p,w)=>{if((0,k.isObject)(w)||Array.isArray(w)){if(d.has(w))return"[Circular]";d.add(w)}return w})}e.safeStringify=E;function b(l,d){const p=Object.create(null);return!l||!d||Object.keys(d).forEach(I=>{const n=l[I],c=d[I];S(n,c)||(p[I]=c)}),p}e.distinct=b;function g(l,d){const p=d.toLowerCase(),w=Object.keys(l).find(I=>I.toLowerCase()===p);return w?l[w]:l[d]}e.getCaseInsensitive=g;function m(l,d){const p=Object.create(null);for(const[w,I]of Object.entries(l))d(w,I)&&(p[w]=I);return p}e.filter=m;function h(l){let d=[],p=Object.getPrototypeOf(l);for(;Object.prototype!==p;)d=d.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return d}e.getAllPropertyNames=h;function y(l){const d=[];for(const p of h(l))typeof l[p]=="function"&&d.push(p);return d}e.getAllMethodNames=y;function f(l,d){const p=I=>function(){const n=Array.prototype.slice.call(arguments,0);return d(I,n)},w={};for(const I of l)w[I]=p(I);return w}e.createProxyObject=f}),define(oe[31],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(D){return k.test(D)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let P=0;P<R.length;P++)R[P]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let P=0,S="";return S+=O[A[P++]],S+=O[A[P++]],S+=O[A[P++]],S+=O[A[P++]],S+="-",S+=O[A[P++]],S+=O[A[P++]],S+="-",S+=O[A[P++]],S+=O[A[P++]],S+="-",S+=O[A[P++]],S+=O[A[P++]],S+="-",S+=O[A[P++]],S+=O[A[P++]],S+=O[A[P++]],S+=O[A[P++]],S+=O[A[P++]],S+=O[A[P++]],S}}()}),define(oe[132],ae([0,1,34]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(O){const R=O.replace(/\-/g,":").toLowerCase();return!i.has(R)}function A(){const O=(0,k.networkInterfaces)();for(const R in O){const P=O[R];if(P){for(const{mac:S}of P)if(D(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(oe[133],ae([0,1,86]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(R,P,S,E=1){let b=!1;return new Promise(g=>{const m=setTimeout(()=>{if(!b)return b=!0,g(0)},S);D(R,P,E,h=>{if(!b)return b=!0,clearTimeout(m),g(h)})})}e.findFreePort=i;function D(R,P,S,E){if(P===0)return E(0);const b=new k.Socket;b.once("connect",()=>(O(b),D(R+S,P-1,S,E))),b.once("data",()=>{}),b.once("error",g=>(O(b),g.code!=="ECONNREFUSED"?D(R+S,P-1,S,E):E(R))),b.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,P,S,E="127.0.0.1"){let b=!1,g,m=1;const h=k.createServer({pauseOnConnect:!0});function y(f,l){b||(b=!0,h.removeAllListeners(),h.close(),g&&clearTimeout(g),l(f))}return new Promise(f=>{g=setTimeout(()=>{y(0,f)},S),h.on("listening",()=>{y(R,f)}),h.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&m<P?(R++,m++,h.listen(R,E)):y(0,f)}),h.on("close",()=>{y(0,f)}),h.listen(R,E)})}e.findFreePortFaster=A;function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(P){console.error(P)}}}),define(oe[134],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function i(A){return A instanceof D?!0:A instanceof Error&&A.name===k&&A.message===k}e.isOfflineError=i;class D extends Error{constructor(){super(k),this.name=this.message}}e.OfflineError=D}),define(oe[135],ae([0,1,17,7,134]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(P,S){if(!navigator.onLine)throw new D.OfflineError;P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((b,g)=>{E.open(P.type||"GET",P.url||"",!0,P.user,P.password),O(E,P),E.responseType="arraybuffer",E.onerror=m=>g(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=m=>{b({res:{statusCode:E.status,headers:R(E)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=m=>g(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(E.timeout=P.timeout),E.send(P.data),S.onCancellationRequested(()=>{E.abort(),g((0,i.canceled)())})})}e.request=A;function O(P,S){if(S.headers){e:for(const E in S.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(E,S.headers[E])}}}function R(P){const S=Object.create(null);for(const E of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const b=E.indexOf(":");S[E.substr(0,b).trim().toLowerCase()]=E.substr(b+1).trim()}return S}}),define(oe[136],ae([10,11]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(oe[65],ae([0,1,136]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,D=i*60,A=D*24,O=A*7,R=A*30,P=A*365;function S(b,g,m,h){typeof b!="number"&&(b=b.getTime());const y=Math.round((new Date().getTime()-b)/1e3);if(y<-30)return(0,k.localize)(0,null,S(new Date().getTime()+y*1e3,!1));if(!h&&y<30)return(0,k.localize)(1,null);let f;return y<i?(f=y,g?f===1?m?(0,k.localize)(2,null,f):(0,k.localize)(3,null,f):m?(0,k.localize)(4,null,f):(0,k.localize)(5,null,f):f===1?m?(0,k.localize)(6,null,f):(0,k.localize)(7,null,f):m?(0,k.localize)(8,null,f):(0,k.localize)(9,null,f)):y<D?(f=Math.floor(y/i),g?f===1?m?(0,k.localize)(10,null,f):(0,k.localize)(11,null,f):m?(0,k.localize)(12,null,f):(0,k.localize)(13,null,f):f===1?m?(0,k.localize)(14,null,f):(0,k.localize)(15,null,f):m?(0,k.localize)(16,null,f):(0,k.localize)(17,null,f)):y<A?(f=Math.floor(y/D),g?f===1?m?(0,k.localize)(18,null,f):(0,k.localize)(19,null,f):m?(0,k.localize)(20,null,f):(0,k.localize)(21,null,f):f===1?m?(0,k.localize)(22,null,f):(0,k.localize)(23,null,f):m?(0,k.localize)(24,null,f):(0,k.localize)(25,null,f)):y<O?(f=Math.floor(y/A),g?f===1?(0,k.localize)(26,null,f):(0,k.localize)(27,null,f):f===1?(0,k.localize)(28,null,f):(0,k.localize)(29,null,f)):y<R?(f=Math.floor(y/O),g?f===1?m?(0,k.localize)(30,null,f):(0,k.localize)(31,null,f):m?(0,k.localize)(32,null,f):(0,k.localize)(33,null,f):f===1?m?(0,k.localize)(34,null,f):(0,k.localize)(35,null,f):m?(0,k.localize)(36,null,f):(0,k.localize)(37,null,f)):y<P?(f=Math.floor(y/R),g?f===1?m?(0,k.localize)(38,null,f):(0,k.localize)(39,null,f):m?(0,k.localize)(40,null,f):(0,k.localize)(41,null,f):f===1?m?(0,k.localize)(42,null,f):(0,k.localize)(43,null,f):m?(0,k.localize)(44,null,f):(0,k.localize)(45,null,f)):(f=Math.floor(y/P),g?f===1?m?(0,k.localize)(46,null,f):(0,k.localize)(47,null,f):m?(0,k.localize)(48,null,f):(0,k.localize)(49,null,f):f===1?m?(0,k.localize)(50,null,f):(0,k.localize)(51,null,f):m?(0,k.localize)(52,null,f):(0,k.localize)(53,null,f))}e.fromNow=S;function E(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(oe[137],ae([10,11]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,13,137]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(b,g){return g&&(b.stack||b.stacktrace)?D.localize(0,null,R(b),O(b.stack)||O(b.stacktrace)):R(b)}function O(b){return Array.isArray(b)?b.join(`
`):b}function R(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?D.localize(1,null,b.message):b.message||D.localize(2,null)}function P(b=null,g=!1){if(!b)return D.localize(3,null);if(Array.isArray(b)){const m=k.coalesce(b),h=P(m[0],g);return m.length>1?D.localize(4,null,h,m.length):h}if(i.isString(b))return b;if(b.detail){const m=b.detail;if(m.error)return A(m.error,g);if(m.exception)return A(m.exception,g)}return b.stack?A(b,g):b.message?b.message:D.localize(5,null)}e.toErrorMessage=P;function S(b){const g=b;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=S;function E(b,g){let m;return typeof b=="string"?m=new Error(b):m=b,m.actions=g,m}e.createErrorWithActions=E}),define(oe[138],ae([10,11]),function(Z,e){return Z.create("vs/base/common/jsonErrorMessages",e)}),define(oe[139],ae([0,1,138]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(D){switch(D){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(oe[140],ae([10,11]),function(Z,e){return Z.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,140]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let i=!1,D=!1,A=!1,O=!1,R=!1,P=!1,S=!1,E=!1,b=!1,g=!1,m,h=e.LANGUAGE_DEFAULT,y,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const d=typeof l?.versions?.electron=="string",p=d&&l?.type==="renderer";if(typeof navigator=="object"&&!p)f=navigator.userAgent,i=f.indexOf("Windows")>=0,D=f.indexOf("Macintosh")>=0,E=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=f.indexOf("Linux")>=0,g=f?.indexOf("Mobi")>=0,P=!0,m=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,h=m;else if(typeof l=="object"){i=l.platform==="win32",D=l.platform==="darwin",A=l.platform==="linux",O=A&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,S=d,b=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT;const r=l.env.VSCODE_NLS_CONFIG;if(r)try{const u=JSON.parse(r),v=u.availableLanguages["*"];m=u.locale,h=v||e.LANGUAGE_DEFAULT,y=u._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function I(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let n=0;D?n=1:i?n=3:A&&(n=2),e.isWindows=i,e.isMacintosh=D,e.isLinux=A,e.isLinuxSnap=O,e.isNative=R,e.isElectron=S,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=E,e.isMobile=g,e.isCI=b,e.platform=n,e.userAgent=f,e.language=h;var c;(function(r){function u(){return e.language}r.value=u;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=v;function C(){return e.language==="en"}r.isDefault=C})(c=e.Language||(e.Language={})),e.locale=m,e.translationsConfigFile=y,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const r=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let C=0,T=r.length;C<T;C++){const N=r[C];if(N.id===v.data.vscodeScheduleAsyncWork){r.splice(C,1),N.callback();return}}});let u=0;return v=>{const C=++u;r.push({id:C,callback:v}),e.globals.postMessage({vscodeScheduleAsyncWork:C},"*")}}return r=>setTimeout(r)})();var t;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||E?2:i?1:3;let s=!0,o=!1;function a(){if(!o){o=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,s=new Uint16Array(r.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[36],ae([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.process<"u"){const D=k.globals.vscode.process;i={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(oe[12],ae([0,1,36]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,D=97,A=90,O=122,R=46,P=47,S=92,E=58,b=63;class g extends Error{constructor(c,t,s){let o;typeof t=="string"&&t.indexOf("not ")===0?(o="must not be",t=t.replace(/^not /,"")):o="must be";const a=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${a} ${o} of type ${t}`;r+=`. Received type ${typeof s}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function m(n,c){if(n===null||typeof n!="object")throw new g(c,"Object",n)}function h(n,c){if(typeof n!="string")throw new g(c,"string",n)}const y=k.platform==="win32";function f(n){return n===P||n===S}function l(n){return n===P}function d(n){return n>=i&&n<=A||n>=D&&n<=O}function p(n,c,t,s){let o="",a=0,r=-1,u=0,v=0;for(let C=0;C<=n.length;++C){if(C<n.length)v=n.charCodeAt(C);else{if(s(v))break;v=P}if(s(v)){if(!(r===C-1||u===1))if(u===2){if(o.length<2||a!==2||o.charCodeAt(o.length-1)!==R||o.charCodeAt(o.length-2)!==R){if(o.length>2){const T=o.lastIndexOf(t);T===-1?(o="",a=0):(o=o.slice(0,T),a=o.length-1-o.lastIndexOf(t)),r=C,u=0;continue}else if(o.length!==0){o="",a=0,r=C,u=0;continue}}c&&(o+=o.length>0?`${t}..`:"..",a=2)}else o.length>0?o+=`${t}${n.slice(r+1,C)}`:o=n.slice(r+1,C),a=C-r-1;r=C,u=0}else v===R&&u!==-1?++u:u=-1}return o}function w(n,c){m(c,"pathObject");const t=c.dir||c.root,s=c.base||`${c.name||""}${c.ext||""}`;return t?t===c.root?`${t}${s}`:`${t}${n}${s}`:s}e.win32={resolve(...n){let c="",t="",s=!1;for(let o=n.length-1;o>=-1;o--){let a;if(o>=0){if(a=n[o],h(a,"path"),a.length===0)continue}else c.length===0?a=k.cwd():(a=k.env[`=${c}`]||k.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==c.toLowerCase()&&a.charCodeAt(2)===S)&&(a=`${c}\\`));const r=a.length;let u=0,v="",C=!1;const T=a.charCodeAt(0);if(r===1)f(T)&&(u=1,C=!0);else if(f(T))if(C=!0,f(a.charCodeAt(1))){let N=2,F=N;for(;N<r&&!f(a.charCodeAt(N));)N++;if(N<r&&N!==F){const j=a.slice(F,N);for(F=N;N<r&&f(a.charCodeAt(N));)N++;if(N<r&&N!==F){for(F=N;N<r&&!f(a.charCodeAt(N));)N++;(N===r||N!==F)&&(v=`\\\\${j}\\${a.slice(F,N)}`,u=N)}}}else u=1;else d(T)&&a.charCodeAt(1)===E&&(v=a.slice(0,2),u=2,r>2&&f(a.charCodeAt(2))&&(C=!0,u=3));if(v.length>0)if(c.length>0){if(v.toLowerCase()!==c.toLowerCase())continue}else c=v;if(s){if(c.length>0)break}else if(t=`${a.slice(u)}\\${t}`,s=C,C&&c.length>0)break}return t=p(t,!s,"\\",f),s?`${c}\\${t}`:`${c}${t}`||"."},normalize(n){h(n,"path");const c=n.length;if(c===0)return".";let t=0,s,o=!1;const a=n.charCodeAt(0);if(c===1)return l(a)?"\\":n;if(f(a))if(o=!0,f(n.charCodeAt(1))){let u=2,v=u;for(;u<c&&!f(n.charCodeAt(u));)u++;if(u<c&&u!==v){const C=n.slice(v,u);for(v=u;u<c&&f(n.charCodeAt(u));)u++;if(u<c&&u!==v){for(v=u;u<c&&!f(n.charCodeAt(u));)u++;if(u===c)return`\\\\${C}\\${n.slice(v)}\\`;u!==v&&(s=`\\\\${C}\\${n.slice(v,u)}`,t=u)}}}else t=1;else d(a)&&n.charCodeAt(1)===E&&(s=n.slice(0,2),t=2,c>2&&f(n.charCodeAt(2))&&(o=!0,t=3));let r=t<c?p(n.slice(t),!o,"\\",f):"";return r.length===0&&!o&&(r="."),r.length>0&&f(n.charCodeAt(c-1))&&(r+="\\"),s===void 0?o?`\\${r}`:r:o?`${s}\\${r}`:`${s}${r}`},isAbsolute(n){h(n,"path");const c=n.length;if(c===0)return!1;const t=n.charCodeAt(0);return f(t)||c>2&&d(t)&&n.charCodeAt(1)===E&&f(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let c,t;for(let a=0;a<n.length;++a){const r=n[a];h(r,"path"),r.length>0&&(c===void 0?c=t=r:c+=`\\${r}`)}if(c===void 0)return".";let s=!0,o=0;if(typeof t=="string"&&f(t.charCodeAt(0))){++o;const a=t.length;a>1&&f(t.charCodeAt(1))&&(++o,a>2&&(f(t.charCodeAt(2))?++o:s=!1))}if(s){for(;o<c.length&&f(c.charCodeAt(o));)o++;o>=2&&(c=`\\${c.slice(o)}`)}return e.win32.normalize(c)},relative(n,c){if(h(n,"from"),h(c,"to"),n===c)return"";const t=e.win32.resolve(n),s=e.win32.resolve(c);if(t===s||(n=t.toLowerCase(),c=s.toLowerCase(),n===c))return"";let o=0;for(;o<n.length&&n.charCodeAt(o)===S;)o++;let a=n.length;for(;a-1>o&&n.charCodeAt(a-1)===S;)a--;const r=a-o;let u=0;for(;u<c.length&&c.charCodeAt(u)===S;)u++;let v=c.length;for(;v-1>u&&c.charCodeAt(v-1)===S;)v--;const C=v-u,T=r<C?r:C;let N=-1,F=0;for(;F<T;F++){const L=n.charCodeAt(o+F);if(L!==c.charCodeAt(u+F))break;L===S&&(N=F)}if(F!==T){if(N===-1)return s}else{if(C>T){if(c.charCodeAt(u+F)===S)return s.slice(u+F+1);if(F===2)return s.slice(u+F)}r>T&&(n.charCodeAt(o+F)===S?N=F:F===2&&(N=3)),N===-1&&(N=0)}let j="";for(F=o+N+1;F<=a;++F)(F===a||n.charCodeAt(F)===S)&&(j+=j.length===0?"..":"\\..");return u+=N,j.length>0?`${j}${s.slice(u,v)}`:(s.charCodeAt(u)===S&&++u,s.slice(u,v))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const c=e.win32.resolve(n);if(c.length<=2)return n;if(c.charCodeAt(0)===S){if(c.charCodeAt(1)===S){const t=c.charCodeAt(2);if(t!==b&&t!==R)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(d(c.charCodeAt(0))&&c.charCodeAt(1)===E&&c.charCodeAt(2)===S)return`\\\\?\\${c}`;return n},dirname(n){h(n,"path");const c=n.length;if(c===0)return".";let t=-1,s=0;const o=n.charCodeAt(0);if(c===1)return f(o)?n:".";if(f(o)){if(t=s=1,f(n.charCodeAt(1))){let u=2,v=u;for(;u<c&&!f(n.charCodeAt(u));)u++;if(u<c&&u!==v){for(v=u;u<c&&f(n.charCodeAt(u));)u++;if(u<c&&u!==v){for(v=u;u<c&&!f(n.charCodeAt(u));)u++;if(u===c)return n;u!==v&&(t=s=u+1)}}}}else d(o)&&n.charCodeAt(1)===E&&(t=c>2&&f(n.charCodeAt(2))?3:2,s=t);let a=-1,r=!0;for(let u=c-1;u>=s;--u)if(f(n.charCodeAt(u))){if(!r){a=u;break}}else r=!1;if(a===-1){if(t===-1)return".";a=t}return n.slice(0,a)},basename(n,c){c!==void 0&&h(c,"ext"),h(n,"path");let t=0,s=-1,o=!0,a;if(n.length>=2&&d(n.charCodeAt(0))&&n.charCodeAt(1)===E&&(t=2),c!==void 0&&c.length>0&&c.length<=n.length){if(c===n)return"";let r=c.length-1,u=-1;for(a=n.length-1;a>=t;--a){const v=n.charCodeAt(a);if(f(v)){if(!o){t=a+1;break}}else u===-1&&(o=!1,u=a+1),r>=0&&(v===c.charCodeAt(r)?--r===-1&&(s=a):(r=-1,s=u))}return t===s?s=u:s===-1&&(s=n.length),n.slice(t,s)}for(a=n.length-1;a>=t;--a)if(f(n.charCodeAt(a))){if(!o){t=a+1;break}}else s===-1&&(o=!1,s=a+1);return s===-1?"":n.slice(t,s)},extname(n){h(n,"path");let c=0,t=-1,s=0,o=-1,a=!0,r=0;n.length>=2&&n.charCodeAt(1)===E&&d(n.charCodeAt(0))&&(c=s=2);for(let u=n.length-1;u>=c;--u){const v=n.charCodeAt(u);if(f(v)){if(!a){s=u+1;break}continue}o===-1&&(a=!1,o=u+1),v===R?t===-1?t=u:r!==1&&(r=1):t!==-1&&(r=-1)}return t===-1||o===-1||r===0||r===1&&t===o-1&&t===s+1?"":n.slice(t,o)},format:w.bind(null,"\\"),parse(n){h(n,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return c;const t=n.length;let s=0,o=n.charCodeAt(0);if(t===1)return f(o)?(c.root=c.dir=n,c):(c.base=c.name=n,c);if(f(o)){if(s=1,f(n.charCodeAt(1))){let N=2,F=N;for(;N<t&&!f(n.charCodeAt(N));)N++;if(N<t&&N!==F){for(F=N;N<t&&f(n.charCodeAt(N));)N++;if(N<t&&N!==F){for(F=N;N<t&&!f(n.charCodeAt(N));)N++;N===t?s=N:N!==F&&(s=N+1)}}}}else if(d(o)&&n.charCodeAt(1)===E){if(t<=2)return c.root=c.dir=n,c;if(s=2,f(n.charCodeAt(2))){if(t===3)return c.root=c.dir=n,c;s=3}}s>0&&(c.root=n.slice(0,s));let a=-1,r=s,u=-1,v=!0,C=n.length-1,T=0;for(;C>=s;--C){if(o=n.charCodeAt(C),f(o)){if(!v){r=C+1;break}continue}u===-1&&(v=!1,u=C+1),o===R?a===-1?a=C:T!==1&&(T=1):a!==-1&&(T=-1)}return u!==-1&&(a===-1||T===0||T===1&&a===u-1&&a===r+1?c.base=c.name=n.slice(r,u):(c.name=n.slice(r,a),c.base=n.slice(r,u),c.ext=n.slice(a,u))),r>0&&r!==s?c.dir=n.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const I=(()=>{if(y){const n=/\\/g;return()=>{const c=k.cwd().replace(n,"/");return c.slice(c.indexOf("/"))}}return()=>k.cwd()})();e.posix={resolve(...n){let c="",t=!1;for(let s=n.length-1;s>=-1&&!t;s--){const o=s>=0?n[s]:I();h(o,"path"),o.length!==0&&(c=`${o}/${c}`,t=o.charCodeAt(0)===P)}return c=p(c,!t,"/",l),t?`/${c}`:c.length>0?c:"."},normalize(n){if(h(n,"path"),n.length===0)return".";const c=n.charCodeAt(0)===P,t=n.charCodeAt(n.length-1)===P;return n=p(n,!c,"/",l),n.length===0?c?"/":t?"./":".":(t&&(n+="/"),c?`/${n}`:n)},isAbsolute(n){return h(n,"path"),n.length>0&&n.charCodeAt(0)===P},join(...n){if(n.length===0)return".";let c;for(let t=0;t<n.length;++t){const s=n[t];h(s,"path"),s.length>0&&(c===void 0?c=s:c+=`/${s}`)}return c===void 0?".":e.posix.normalize(c)},relative(n,c){if(h(n,"from"),h(c,"to"),n===c||(n=e.posix.resolve(n),c=e.posix.resolve(c),n===c))return"";const t=1,s=n.length,o=s-t,a=1,r=c.length-a,u=o<r?o:r;let v=-1,C=0;for(;C<u;C++){const N=n.charCodeAt(t+C);if(N!==c.charCodeAt(a+C))break;N===P&&(v=C)}if(C===u)if(r>u){if(c.charCodeAt(a+C)===P)return c.slice(a+C+1);if(C===0)return c.slice(a+C)}else o>u&&(n.charCodeAt(t+C)===P?v=C:C===0&&(v=0));let T="";for(C=t+v+1;C<=s;++C)(C===s||n.charCodeAt(C)===P)&&(T+=T.length===0?"..":"/..");return`${T}${c.slice(a+v)}`},toNamespacedPath(n){return n},dirname(n){if(h(n,"path"),n.length===0)return".";const c=n.charCodeAt(0)===P;let t=-1,s=!0;for(let o=n.length-1;o>=1;--o)if(n.charCodeAt(o)===P){if(!s){t=o;break}}else s=!1;return t===-1?c?"/":".":c&&t===1?"//":n.slice(0,t)},basename(n,c){c!==void 0&&h(c,"ext"),h(n,"path");let t=0,s=-1,o=!0,a;if(c!==void 0&&c.length>0&&c.length<=n.length){if(c===n)return"";let r=c.length-1,u=-1;for(a=n.length-1;a>=0;--a){const v=n.charCodeAt(a);if(v===P){if(!o){t=a+1;break}}else u===-1&&(o=!1,u=a+1),r>=0&&(v===c.charCodeAt(r)?--r===-1&&(s=a):(r=-1,s=u))}return t===s?s=u:s===-1&&(s=n.length),n.slice(t,s)}for(a=n.length-1;a>=0;--a)if(n.charCodeAt(a)===P){if(!o){t=a+1;break}}else s===-1&&(o=!1,s=a+1);return s===-1?"":n.slice(t,s)},extname(n){h(n,"path");let c=-1,t=0,s=-1,o=!0,a=0;for(let r=n.length-1;r>=0;--r){const u=n.charCodeAt(r);if(u===P){if(!o){t=r+1;break}continue}s===-1&&(o=!1,s=r+1),u===R?c===-1?c=r:a!==1&&(a=1):c!==-1&&(a=-1)}return c===-1||s===-1||a===0||a===1&&c===s-1&&c===t+1?"":n.slice(c,s)},format:w.bind(null,"/"),parse(n){h(n,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return c;const t=n.charCodeAt(0)===P;let s;t?(c.root="/",s=1):s=0;let o=-1,a=0,r=-1,u=!0,v=n.length-1,C=0;for(;v>=s;--v){const T=n.charCodeAt(v);if(T===P){if(!u){a=v+1;break}continue}r===-1&&(u=!1,r=v+1),T===R?o===-1?o=v:C!==1&&(C=1):o!==-1&&(C=-1)}if(r!==-1){const T=a===0&&t?1:a;o===-1||C===0||C===1&&o===r-1&&o===a+1?c.base=c.name=n.slice(T,r):(c.name=n.slice(T,o),c.base=n.slice(T,r),c.ext=n.slice(o,r))}return a>0?c.dir=n.slice(0,a-1):t&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(oe[141],ae([0,1,12]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(E){const b=(0,k.extname)(E),g=i[b.toLowerCase()];return g!==void 0?g:O(E)}e.getMediaOrTextMime=A;function O(E){const b=(0,k.extname)(E);return D[b.toLowerCase()]}e.getMediaMime=O;function R(E){for(const b in D)if(D[b]===E)return b}e.getExtensionForMimeType=R;const P=/^(.+)\/(.+?)(;.+)?$/;function S(E,b){const g=P.exec(E);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:b?void 0:E}e.normalizeMimeType=S}),define(oe[87],ae([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(R,...P){const S=P.reduce((g,m)=>(g[m]=!0,g),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(g=>!S[g]).forEach(g=>{for(let m=0;m<E.length;m++)if(g.search(E[m])!==-1){delete R[g];break}})}e.sanitizeProcessEnvironment=A;function O(R){!R||(delete R.DEBUG,k.isMacintosh&&delete R.DYLD_LIBRARY_PATH,k.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=O}),define(oe[88],ae([0,1,5]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=k.globals.performance&&typeof k.globals.performance.now=="function";class D{static create(O=!0){return new D(O)}constructor(O){this.a=i&&O,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?k.globals.performance.now():Date.now()}}e.StopWatch=D}),define(oe[3],ae([0,1,7,82,2,84,88]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,P=!1;var S;(function(a){a.None=()=>D.Disposable.None;function r(q){if(P){const{onDidAddListener:J}=q,_=h.create();let Y=0;q.onDidAddListener=()=>{++Y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),_.print()),J?.()}}}function u(q,J){return z(q,()=>{},0,void 0,void 0,J)}a.defer=u;function v(q){return(J,_=null,Y)=>{let Q=!1,se;return se=q(le=>{if(!Q)return se?se.dispose():Q=!0,J.call(_,le)},null,Y),Q&&se.dispose(),se}}a.once=v;function C(q,J,_){return $((Y,Q=null,se)=>q(le=>Y.call(Q,J(le)),null,se),_)}a.map=C;function T(q,J,_){return $((Y,Q=null,se)=>q(le=>{J(le),Y.call(Q,le)},null,se),_)}a.forEach=T;function N(q,J,_){return $((Y,Q=null,se)=>q(le=>J(le)&&Y.call(Q,le),null,se),_)}a.filter=N;function F(q){return q}a.signal=F;function j(...q){return(J,_=null,Y)=>(0,D.combinedDisposable)(...q.map(Q=>Q(se=>J.call(_,se),null,Y)))}a.any=j;function L(q,J,_,Y){let Q=_;return C(q,se=>(Q=J(Q,se),Q),Y)}a.reduce=L;function $(q,J){let _;const Y={onWillAddFirstListener(){_=q(Q.fire,Q)},onDidRemoveLastListener(){_?.dispose()}};J||r(Y);const Q=new f(Y);return J?.add(Q),Q.event}function z(q,J,_=100,Y=!1,Q,se){let le,ue,pe,we=0;const be={leakWarningThreshold:Q,onWillAddFirstListener(){le=q(Te=>{we++,ue=J(ue,Te),Y&&!pe&&(Ee.fire(ue),ue=void 0),clearTimeout(pe),pe=setTimeout(()=>{const Ue=ue;ue=void 0,pe=void 0,(!Y||we>1)&&Ee.fire(Ue),we=0},_)})},onDidRemoveLastListener(){le.dispose()}};se||r(be);const Ee=new f(be);return se?.add(Ee),Ee.event}a.debounce=z;function H(q,J=0,_){return a.debounce(q,(Y,Q)=>Y?(Y.push(Q),Y):[Q],J,void 0,void 0,_)}a.accumulate=H;function X(q,J=(Y,Q)=>Y===Q,_){let Y=!0,Q;return N(q,se=>{const le=Y||!J(se,Q);return Y=!1,Q=se,le},_)}a.latch=X;function ie(q,J,_){return[a.filter(q,J,_),a.filter(q,Y=>!J(Y),_)]}a.split=ie;function G(q,J=!1,_=[]){let Y=_.slice(),Q=q(ue=>{Y?Y.push(ue):le.fire(ue)});const se=()=>{Y?.forEach(ue=>le.fire(ue)),Y=null},le=new f({onWillAddFirstListener(){Q||(Q=q(ue=>le.fire(ue)))},onDidAddFirstListener(){Y&&(J?setTimeout(se):se())},onDidRemoveLastListener(){Q&&Q.dispose(),Q=null}});return le.event}a.buffer=G;class M{constructor(J){this.event=J,this.c=new D.DisposableStore}map(J){return new M(C(this.event,J,this.c))}forEach(J){return new M(T(this.event,J,this.c))}filter(J){return new M(N(this.event,J,this.c))}reduce(J,_){return new M(L(this.event,J,_,this.c))}latch(){return new M(X(this.event,void 0,this.c))}debounce(J,_=100,Y=!1,Q){return new M(z(this.event,J,_,Y,Q,this.c))}on(J,_,Y){return this.event(J,_,Y)}once(J,_,Y){return v(this.event)(J,_,Y)}dispose(){this.c.dispose()}}function V(q){return new M(q)}a.chain=V;function x(q,J,_=Y=>Y){const Y=(...ue)=>le.fire(_(...ue)),Q=()=>q.on(J,Y),se=()=>q.removeListener(J,Y),le=new f({onWillAddFirstListener:Q,onDidRemoveLastListener:se});return le.event}a.fromNodeEventEmitter=x;function ee(q,J,_=Y=>Y){const Y=(...ue)=>le.fire(_(...ue)),Q=()=>q.addEventListener(J,Y),se=()=>q.removeEventListener(J,Y),le=new f({onWillAddFirstListener:Q,onDidRemoveLastListener:se});return le.event}a.fromDOMEventEmitter=ee;function re(q){return new Promise(J=>v(q)(J))}a.toPromise=re;function te(q,J){return J(void 0),q(_=>J(_))}a.runAndSubscribe=te;function U(q,J){let _=null;function Y(se){_?.dispose(),_=new D.DisposableStore,J(se,_)}Y(void 0);const Q=q(se=>Y(se));return(0,D.toDisposable)(()=>{Q.dispose(),_?.dispose()})}a.runAndSubscribeWithStore=U;class B{constructor(J,_){this.obs=J,this.c=0,this.d=!1;const Y={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};_||r(Y),this.emitter=new f(Y),_&&_.add(this.emitter)}beginUpdate(J){this.c++}handleChange(J,_){this.d=!0}endUpdate(J){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(q,J){return new B(q,J).emitter.event}a.fromObservable=W})(S=e.Event||(e.Event={}));class E{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${E.c++}`,E.all.add(this)}start(r){this.d=new O.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=E,E.all=new Set,E.c=0;let b=-1;function g(a){const r=b;return b=a,{dispose(){b=r}}}e.setGlobalLeakWarningThreshold=g;class m{constructor(r,u=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=u,this.d=0}dispose(){this.c?.clear()}check(r,u){const v=this.threshold;if(v<=0||u<v)return;this.c||(this.c=new Map);const C=this.c.get(r.value)||0;if(this.c.set(r.value,C+1),this.d-=1,this.d<=0){this.d=v*.5;let T,N=0;for(const[F,j]of this.c)(!T||N<j)&&(T=F,N=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${N}):`),console.warn(T)}return()=>{const T=this.c.get(r.value)||0;this.c.set(r.value,T-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y{constructor(r,u,v){this.callback=r,this.callbackThis=u,this.stack=v,this.subscription=new D.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class f{constructor(r){this.j=!1,this.d=r,this.f=b>0||this.d?.leakWarningThreshold?new m(this.d?.leakWarningThreshold??b):void 0,this.g=this.d?._profName?new E(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(R){const r=Array.from(this.q);queueMicrotask(()=>{for(const u of r)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(r,u,v)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.Disposable.None;const C=this.q.isEmpty();C&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=h.create(),T=this.f.check(N,this.q.size+1)),R&&(N=N??h.create());const F=new y(r,u,N),j=this.q.push(F);C&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,r,u);const L=F.subscription.set(()=>{T?.(),this.j||(j(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return v instanceof D.DisposableStore?v.add(L):Array.isArray(v)&&v.push(L),L}),this.l}fire(r){if(this.q){this.m||(this.m=new d);for(const u of this.q)this.m.push(this,u,r);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=f;class l{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(r,u,v){this.c.push(new p(r,u,v))}clear(r){const u=new A.LinkedList;for(const v of this.c)v.emitter!==r&&u.push(v);this.c=u}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(u){(0,k.onUnexpectedError)(u)}}}}e.EventDeliveryQueue=l;class d extends l{clear(r){this.c.clear()}}class p{constructor(r,u,v){this.emitter=r,this.listener=u,this.event=v}}class w extends f{async fireAsync(r,u,v){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const C of this.q)this.c.push([C,r]);for(;this.c.size>0&&!u.isCancellationRequested;){const[C,T]=this.c.shift(),N=[],F={...T,token:u,waitUntil:j=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");v&&(j=v(j,C.callback)),N.push(j)}};try{C.invoke(F)}catch(j){(0,k.onUnexpectedError)(j);continue}Object.freeze(N),await Promise.allSettled(N).then(j=>{for(const L of j)L.status==="rejected"&&(0,k.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=w;class I extends f{constructor(r){super(r),this.h=0,this.s=new A.LinkedList,this.t=r?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const r=Array.from(this.s);this.s.clear(),super.fire(this.t(r))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(r){this.q&&(this.h!==0?this.s.push(r):super.fire(r))}}e.PauseableEmitter=I;class n extends I{constructor(r){super(r),this.c=r.delay??100}fire(r){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(r)}}e.DebounceEmitter=n;class c extends f{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}e.MicrotaskEmitter=c;class t{constructor(){this.d=!1,this.f=[],this.c=new f({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(r){const u={event:r,listener:null};this.f.push(u),this.d&&this.j(u);const v=()=>{this.d&&this.k(u);const C=this.f.indexOf(u);this.f.splice(C,1)};return(0,D.toDisposable)((0,i.once)(v))}g(){this.d=!0,this.f.forEach(r=>this.j(r))}h(){this.d=!1,this.f.forEach(r=>this.k(r))}j(r){r.listener=r.event(u=>this.c.fire(u))}k(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class s{constructor(){this.c=[]}wrapEvent(r){return(u,v,C)=>r(T=>{const N=this.c[this.c.length-1];N?N.push(()=>u.call(v,T)):u.call(v,T)},void 0,C)}bufferEvents(r){const u=[];this.c.push(u);const v=r();return this.c.pop(),u.forEach(C=>C()),v}}e.EventBufferer=s;class o{constructor(){this.c=!1,this.d=S.None,this.f=D.Disposable.None,this.g=new f({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(oe[23],ae([0,1,3]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(R,P){const S=setTimeout(R.bind(P),0);return{dispose(){clearTimeout(S)}}});var D;(function(R){function P(S){return S===R.None||S===R.Cancelled||S instanceof A?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}R.isCancellationToken=P,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(D=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new k.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(P){this.a=void 0,this.b=void 0,this.b=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=D.Cancelled}dispose(P=!1){P&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=D.None}}e.CancellationTokenSource=O}),define(oe[142],ae([0,1,23]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new k.CancellationTokenSource,P=this.b(R.token);return this.a={promise:P,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.Cache=i;class D{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const P=JSON.stringify(R);return this.b!==P&&(this.b=P,this.a=this.c(R)),this.a}}e.LRUCachedFunction=D;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const P=this.b(R);return this.a.set(R,P),P}}e.CachedFunction=A}),define(oe[27],ae([0,1,142,129]),function(Z,e,k,i){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=A;const O=/{(\d+)}/g;function R(ne,...he){return he.length===0?ne:ne.replace(O,function(fe,me){const ve=parseInt(me,10);return isNaN(ve)||ve<0||ve>=he.length?fe:he[ve]})}e.format=R;const P=/{([^}]+)}/g;function S(ne,he){return ne.replace(P,(fe,me)=>he[me]??fe)}e.format2=S;function E(ne){return ne.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=E;function b(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function g(ne,he){let fe=0;const me=he.charCodeAt(0);for(let ve=ne.length-1;ve>=0;ve--)ne.charCodeAt(ve)===me&&fe++;return fe}e.count=g;function m(ne,he,fe="\u2026"){return ne.length<=he?ne:`${ne.substr(0,he)}${fe}`}e.truncate=m;function h(ne,he=" "){const fe=y(ne,he);return f(fe,he)}e.trim=h;function y(ne,he){if(!ne||!he)return ne;const fe=he.length;if(fe===0||ne.length===0)return ne;let me=0;for(;ne.indexOf(he,me)===me;)me=me+fe;return ne.substring(me)}e.ltrim=y;function f(ne,he){if(!ne||!he)return ne;const fe=he.length,me=ne.length;if(fe===0||me===0)return ne;let ve=me,Ie=-1;for(;Ie=ne.lastIndexOf(he,ve-1),!(Ie===-1||Ie+fe!==ve);){if(Ie===0)return"";ve=Ie}return ne.substring(0,ve)}e.rtrim=f;function l(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function d(ne){return ne.replace(/\*/g,"")}e.stripWildcards=d;function p(ne,he,fe={}){if(!ne)throw new Error("Cannot create regex from empty string");he||(ne=b(ne)),fe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(ne,me)}e.createRegExp=p;function w(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function I(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function n(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=n;function c(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=c;function t(ne){for(let he=0,fe=ne.length;he<fe;he++){const me=ne.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function s(ne,he=0,fe=ne.length){for(let me=he;me<fe;me++){const ve=ne.charCodeAt(me);if(ve!==32&&ve!==9)return ne.substring(he,me)}return ne.substring(he,fe)}e.getLeadingWhitespace=s;function o(ne,he=ne.length-1){for(let fe=he;fe>=0;fe--){const me=ne.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=o;function a(ne,he,fe){const me=[];let ve=0;for(const Ie of ne.matchAll(he)){if(me.push(ne.slice(ve,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");ve=Ie.index+Ie[0].length,me.push(fe(Ie[0],...Ie.slice(1),Ie.index,ne,Ie.groups))}return me.push(ne.slice(ve)),Promise.all(me).then(Ie=>Ie.join(""))}e.replaceAsync=a;function r(ne,he){return ne<he?-1:ne>he?1:0}e.compare=r;function u(ne,he,fe=0,me=ne.length,ve=0,Ie=he.length){for(;fe<me&&ve<Ie;fe++,ve++){const $e=ne.charCodeAt(fe),Le=he.charCodeAt(ve);if($e<Le)return-1;if($e>Le)return 1}const Re=me-fe,He=Ie-ve;return Re<He?-1:Re>He?1:0}e.compareSubstring=u;function v(ne,he){return C(ne,he,0,ne.length,0,he.length)}e.compareIgnoreCase=v;function C(ne,he,fe=0,me=ne.length,ve=0,Ie=he.length){for(;fe<me&&ve<Ie;fe++,ve++){let $e=ne.charCodeAt(fe),Le=he.charCodeAt(ve);if($e===Le)continue;if($e>=128||Le>=128)return u(ne.toLowerCase(),he.toLowerCase(),fe,me,ve,Ie);N($e)&&($e-=32),N(Le)&&(Le-=32);const qe=$e-Le;if(qe!==0)return qe}const Re=me-fe,He=Ie-ve;return Re<He?-1:Re>He?1:0}e.compareSubstringIgnoreCase=C;function T(ne){return ne>=48&&ne<=57}e.isAsciiDigit=T;function N(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=N;function F(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=F;function j(ne,he){return ne.length===he.length&&C(ne,he)===0}e.equalsIgnoreCase=j;function L(ne,he){const fe=he.length;return he.length>ne.length?!1:C(ne,he,0,fe)===0}e.startsWithIgnoreCase=L;function $(ne,he){const fe=Math.min(ne.length,he.length);let me;for(me=0;me<fe;me++)if(ne.charCodeAt(me)!==he.charCodeAt(me))return me;return fe}e.commonPrefixLength=$;function z(ne,he){const fe=Math.min(ne.length,he.length);let me;const ve=ne.length-1,Ie=he.length-1;for(me=0;me<fe;me++)if(ne.charCodeAt(ve-me)!==he.charCodeAt(Ie-me))return me;return fe}e.commonSuffixLength=z;function H(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=H;function X(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=X;function ie(ne,he){return(ne-55296<<10)+(he-56320)+65536}e.computeCodePoint=ie;function G(ne,he,fe){const me=ne.charCodeAt(fe);if(H(me)&&fe+1<he){const ve=ne.charCodeAt(fe+1);if(X(ve))return ie(me,ve)}return me}e.getNextCodePoint=G;function M(ne,he){const fe=ne.charCodeAt(he-1);if(X(fe)&&he>1){const me=ne.charCodeAt(he-2);if(H(me))return ie(me,fe)}return fe}class V{get offset(){return this.e}constructor(he,fe=0){this.c=he,this.d=he.length,this.e=fe}setOffset(he){this.e=he}prevCodePoint(){const he=M(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=G(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=V;class x{get offset(){return this.c.offset}constructor(he,fe=0){this.c=new V(he,fe)}nextGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let ve=he.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.nextCodePoint());if(Ce(ve,Re)){fe.setOffset(Ie);break}ve=Re}return fe.offset-me}prevGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let ve=he.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.prevCodePoint());if(Ce(Re,ve)){fe.setOffset(Ie);break}ve=Re}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=x;function ee(ne,he){return new x(ne,he).nextGraphemeLength()}e.nextCharLength=ee;function re(ne,he){return new x(ne,he).prevGraphemeLength()}e.prevCharLength=re;function te(ne,he){he>0&&X(ne.charCodeAt(he))&&he--;const fe=he+ee(ne,he);return[fe-re(ne,fe),fe]}e.getCharContainingOffset=te;function U(ne){const he=new x(ne);let fe=0;for(;!he.eol();)fe++,he.nextGraphemeLength();return fe}e.charCount=U;let B;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(ne){return B||(B=W()),B.test(ne)}e.containsRTL=q;const J=/^[\t\n\r\x20-\x7E]*$/;function _(ne){return J.test(ne)}e.isBasicASCII=_,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Y(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=Y;function Q(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=Q;function se(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=se;function le(ne,he){if(ne.length<he)return ne;const fe=/\b/g;let me=0;for(;fe.test(ne)&&!(ne.length-fe.lastIndex<he);)me=fe.lastIndex,fe.lastIndex+=1;return ne.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function be(ne){return ne&&(ne=ne.replace(ue,""),ne=ne.replace(pe,""),ne=ne.replace(we,"")),ne}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Te(ne){return Ee(ne)?ne.substr(1):ne}e.stripUTF8BOM=Te;function Ue(ne,he){if(!ne||!he||ne.length<he.length)return!1;const fe=he.length,me=ne.toLowerCase();let ve=0,Ie=-1;for(;ve<fe;){const Re=me.indexOf(he[ve],Ie+1);if(Re<0)return!1;Ie=Re,ve++}return!0}e.fuzzyContains=Ue;function Ye(ne,he=!1){return ne?(he&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=Ye;function Be(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=Be;function ce(ne,he=1){if(he===0)return"";let fe=-1;do fe=ne.indexOf(`
`,fe+1),he--;while(he>0&&fe>=0);return fe===-1?ne:(ne[fe-1]==="\r"&&fe--,ne.substr(0,fe))}e.getNLines=ce;function de(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=de;function ge(ne){return Ae.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=ge;function Ce(ne,he){return ne===0?he!==5&&he!==7:ne===2&&he===3?!1:ne===4||ne===2||ne===3||he===4||he===2||he===3?!0:!(ne===8&&(he===8||he===9||he===11||he===12)||(ne===11||ne===9)&&(he===9||he===10)||(ne===12||ne===10)&&he===10||he===5||he===13||he===7||ne===1||ne===13&&he===14||ne===6&&he===6)}var Pe;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const fe=this.d,me=fe.length/3;let ve=1;for(;ve<=me;)if(he<fe[3*ve])ve=2*ve;else if(he>fe[3*ve+1])ve=2*ve+1;else return fe[3*ve+2];return 0}}Ae.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(ne,he){if(ne===0)return 0;const fe=Oe(ne,he);if(fe!==void 0)return fe;const me=new V(he,ne);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=je;function Oe(ne,he){const fe=new V(he,ne);let me=fe.prevCodePoint();for(;Fe(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!se(me))return;let ve=fe.offset;return ve>0&&fe.prevCodePoint()===8205&&(ve=fe.offset),ve}function Fe(ne){return 127995<=ne&&ne<=127999}var ze;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.d.get(Array.from(he))}static getLocales(){return ke.e.getValue()}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=ke,D=ke,ke.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.d=new k.LRUCachedFunction(ne=>{function he(Le){const qe=new Map;for(let Ge=0;Ge<Le.length;Ge+=2)qe.set(Le[Ge],Le[Ge+1]);return qe}function fe(Le,qe){const Ge=new Map(Le);for(const[et,ot]of qe)Ge.set(et,ot);return Ge}function me(Le,qe){if(!Le)return qe;const Ge=new Map;for(const[et,ot]of Le)qe.has(et)&&Ge.set(et,ot);return Ge}const ve=D.c.getValue();let Ie=ne.filter(Le=>!Le.startsWith("_")&&Le in ve);Ie.length===0&&(Ie=["_default"]);let Re;for(const Le of Ie){const qe=he(ve[Le]);Re=me(Re,qe)}const He=he(ve._common),$e=fe(He,Re);return new ke($e)}),ke.e=new i.Lazy(()=>Object.keys(ke.c.getValue()).filter(ne=>!ne.startsWith("_")));class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(he){return Ne.e().has(he)}static get codePoints(){return Ne.e()}}e.InvisibleCharacters=Ne,Ne.d=void 0}),define(oe[48],ae([0,1,12,5,27,13]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function O(o){return o===47||o===92}e.isPathSeparator=O;function R(o){return o.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=R;function P(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=P;function S(o,a=k.posix.sep){if(!o)return"";const r=o.length,u=o.charCodeAt(0);if(O(u)){if(O(o.charCodeAt(1))&&!O(o.charCodeAt(2))){let C=3;const T=C;for(;C<r&&!O(o.charCodeAt(C));C++);if(T!==C&&!O(o.charCodeAt(C+1))){for(C+=1;C<r;C++)if(O(o.charCodeAt(C)))return o.slice(0,C+1).replace(/[\\/]/g,a)}}return a}else if(l(u)&&o.charCodeAt(1)===58)return O(o.charCodeAt(2))?o.slice(0,2)+a:o.slice(0,2);let v=o.indexOf("://");if(v!==-1){for(v+=3;v<r;v++)if(O(o.charCodeAt(v)))return o.slice(0,v+1)}return""}e.getRoot=S;function E(o){if(!i.isWindows||!o||o.length<5)return!1;let a=o.charCodeAt(0);if(a!==92||(a=o.charCodeAt(1),a!==92))return!1;let r=2;const u=r;for(;r<o.length&&(a=o.charCodeAt(r),a!==92);r++);return!(u===r||(a=o.charCodeAt(r+1),isNaN(a)||a===92))}e.isUNC=E;const b=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(o,a=i.isWindows){const r=a?b:g;return!(!o||o.length===0||/^\s+$/.test(o)||(r.lastIndex=0,r.test(o))||a&&m.test(o)||o==="."||o===".."||a&&o[o.length-1]==="."||a&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=h;function y(o,a,r){const u=o===a;return!r||u?u:!o||!a?!1:(0,D.equalsIgnoreCase)(o,a)}e.isEqual=y;function f(o,a,r,u=k.sep){if(o===a)return!0;if(!o||!a||a.length>o.length)return!1;if(r){if(!(0,D.startsWithIgnoreCase)(o,a))return!1;if(a.length===o.length)return!0;let C=a.length;return a.charAt(a.length-1)===u&&C--,o.charAt(C)===u}return a.charAt(a.length-1)!==u&&(a+=u),o.indexOf(a)===0}e.isEqualOrParent=f;function l(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=l;function d(o,a){return i.isWindows&&o.endsWith(":")&&(o+=k.sep),(0,k.isAbsolute)(o)||(o=(0,k.join)(a,o)),o=(0,k.normalize)(o),i.isWindows?(o=(0,D.rtrim)(o,k.sep),o.endsWith(":")&&(o+=k.sep)):(o=(0,D.rtrim)(o,k.sep),o||(o=k.sep)),o}e.sanitizeFilePath=d;function p(o){const a=(0,k.normalize)(o);return i.isWindows?o.length>3?!1:w(a)&&(o.length===2||a.charCodeAt(2)===92):a===k.posix.sep}e.isRootOrDriveLetter=p;function w(o,a=i.isWindows){return a?l(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=w;function I(o){return w(o)?o[0]:void 0}e.getDriveLetter=I;function n(o,a,r){return a.length>o.length?-1:o===a?0:(r&&(o=o.toLowerCase(),a=a.toLowerCase()),o.indexOf(a))}e.indexOfPath=n;function c(o){const a=o.split(":");let r,u,v;for(const C of a){const T=Number(C);(0,A.isNumber)(T)?u===void 0?u=T:v===void 0&&(v=T):r=r?[r,C].join(":"):C}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:u!==void 0?u:void 0,column:v!==void 0?v:u!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(o,a,r=8){let u="";for(let C=0;C<r;C++)u+=t.charAt(Math.floor(Math.random()*t.length));let v;return a?v=`${a}-${u}`:v=u,o?(0,k.join)(o,v):v}e.randomPath=s}),define(oe[66],ae([0,1,27]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(l){return D(l,0)}e.hash=i;function D(l,d){switch(typeof l){case"object":return l===null?A(349,d):Array.isArray(l)?P(l,d):S(l,d);case"string":return R(l,d);case"boolean":return O(l,d);case"number":return A(l,d);case"undefined":return A(937,d);default:return A(617,d)}}e.doHash=D;function A(l,d){return(d<<5)-d+l|0}e.numberHash=A;function O(l,d){return A(l?433:863,d)}function R(l,d){d=A(149417,d);for(let p=0,w=l.length;p<w;p++)d=A(l.charCodeAt(p),d);return d}e.stringHash=R;function P(l,d){return d=A(104579,d),l.reduce((p,w)=>D(w,p),d)}function S(l,d){return d=A(181387,d),Object.keys(l).sort().reduce((p,w)=>(p=R(w,p),D(l[w],p)),d)}class E{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=D(d,this.g),this.g}}e.Hasher=E;var b;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function g(l,d,p=32){const w=p-d,I=~((1<<w)-1);return(l<<d|(I&l)>>>w)>>>0}function m(l,d=0,p=l.byteLength,w=0){for(let I=0;I<p;I++)l[d+I]=w}function h(l,d,p="0"){for(;l.length<d;)l=p+l;return l}function y(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(p=>p.toString(16).padStart(2,"0")).join(""):h((l>>>0).toString(16),d/4)}e.toHexString=y;class f{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const p=d.length;if(p===0)return;const w=this.p;let I=this.r,n=this.u,c,t;for(n!==0?(c=n,t=-1,n=0):(c=d.charCodeAt(0),t=0);;){let s=c;if(k.isHighSurrogate(c))if(t+1<p){const o=d.charCodeAt(t+1);k.isLowSurrogate(o)?(t++,s=k.computeCodePoint(c,o)):s=65533}else{n=c;break}else k.isLowSurrogate(c)&&(s=65533);if(I=this.w(w,I,s),t++,t<p)c=d.charCodeAt(t);else break}this.r=I,this.u=n}w(d,p,w){return w<128?d[p++]=w:w<2048?(d[p++]=192|(w&1984)>>>6,d[p++]=128|(w&63)>>>0):w<65536?(d[p++]=224|(w&61440)>>>12,d[p++]=128|(w&4032)>>>6,d[p++]=128|(w&63)>>>0):(d[p++]=240|(w&1835008)>>>18,d[p++]=128|(w&258048)>>>12,d[p++]=128|(w&4032)>>>6,d[p++]=128|(w&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=f.g,p=this.q;for(let r=0;r<64;r+=4)d.setUint32(r,p.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)d.setUint32(r,g(d.getUint32(r-12,!1)^d.getUint32(r-32,!1)^d.getUint32(r-56,!1)^d.getUint32(r-64,!1),1),!1);let w=this.h,I=this.l,n=this.m,c=this.n,t=this.o,s,o,a;for(let r=0;r<80;r++)r<20?(s=I&n|~I&c,o=1518500249):r<40?(s=I^n^c,o=1859775393):r<60?(s=I&n|I&c|n&c,o=2400959708):(s=I^n^c,o=3395469782),a=g(w,5)+s+t+o+d.getUint32(r*4,!1)&4294967295,t=c,c=n,n=g(I,30),I=w,w=a;this.h=this.h+w&4294967295,this.l=this.l+I&4294967295,this.m=this.m+n&4294967295,this.n=this.n+c&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=f,f.g=new DataView(new ArrayBuffer(320))}),define(oe[89],ae([0,1,27]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(i||(i={})),function(D){const A="error",O="warning",R="warn",P="info",S="ignore";function E(g){return g?k.equalsIgnoreCase(A,g)?D.Error:k.equalsIgnoreCase(O,g)||k.equalsIgnoreCase(R,g)?D.Warning:k.equalsIgnoreCase(P,g)?D.Info:D.Ignore:D.Ignore}D.fromValue=E;function b(g){switch(g){case D.Error:return A;case D.Warning:return O;case D.Info:return P;default:return S}}D.toString=b}(i||(i={})),e.default=i}),define(oe[49],ae([0,1,21,27]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const h=m.charCodeAt(0),y=this.b.charCodeAt(this.c);return h-y}value(){return this.b[this.c]}}e.StringIterator=D;class A{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,i.compareSubstring)(m,this.b,0,m.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class O{constructor(m=!0,h=!0){this.f=m,this.g=h}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let h=m.length-1;h>=0;h--,this.c--){const y=this.b.charCodeAt(h);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===47||this.f&&h===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,i.compareSubstring)(m,this.b,0,m.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=O;var R;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(R||(R={}));class P{constructor(m,h){this.f=m,this.g=h,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(m,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,i.compare)(m,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=P;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(E||(E={}));class b{static forUris(m=()=>!1,h=()=>!1){return new b(new P(m,h))}static forPaths(m=!1){return new b(new O(void 0,!m))}static forStrings(){return new b(new D)}static forConfigKeys(){return new b(new A)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,h){if(h){const y=h.slice(0);(0,k.shuffle)(y);for(const f of y)this.set(f,m)}else{const y=m.slice(0);(0,k.shuffle)(y);for(const f of y)this.set(f[0],f[1])}}set(m,h){const y=this.b.reset(m);let f;this.c||(this.c=new S,this.c.segment=y.value());const l=[];for(f=this.c;;){const p=y.cmp(f.segment);if(p>0)f.left||(f.left=new S,f.left.segment=y.value()),l.push([-1,f]),f=f.left;else if(p<0)f.right||(f.right=new S,f.right.segment=y.value()),l.push([1,f]),f=f.right;else if(y.hasNext())y.next(),f.mid||(f.mid=new S,f.mid.segment=y.value()),l.push([0,f]),f=f.mid;else break}const d=f.value;f.value=h,f.key=m;for(let p=l.length-1;p>=0;p--){const w=l[p][1];w.updateHeight();const I=w.balanceFactor();if(I<-1||I>1){const n=l[p][0],c=l[p+1][0];if(n===1&&c===1)l[p][1]=w.rotateLeft();else if(n===-1&&c===-1)l[p][1]=w.rotateRight();else if(n===1&&c===-1)w.right=l[p+1][1]=l[p+1][1].rotateRight(),l[p][1]=w.rotateLeft();else if(n===-1&&c===1)w.left=l[p+1][1]=l[p+1][1].rotateLeft(),l[p][1]=w.rotateRight();else throw new Error;if(p>0)switch(l[p-1][0]){case-1:l[p-1][1].left=l[p][1];break;case 1:l[p-1][1].right=l[p][1];break;case 0:l[p-1][1].mid=l[p][1];break}else this.c=l[0][1]}}return d}get(m){return this.d(m)?.value}d(m){const h=this.b.reset(m);let y=this.c;for(;y;){const f=h.cmp(y.segment);if(f>0)y=y.left;else if(f<0)y=y.right;else if(h.hasNext())h.next(),y=y.mid;else break}return y}has(m){const h=this.d(m);return!(h?.value===void 0&&h?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,h){const y=this.b.reset(m),f=[];let l=this.c;for(;l;){const d=y.cmp(l.segment);if(d>0)f.push([-1,l]),l=l.left;else if(d<0)f.push([1,l]),l=l.right;else if(y.hasNext())y.next(),f.push([0,l]),l=l.mid;else break}if(!!l){if(h?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const d=this.f(l.right);if(d.key){const{key:p,value:w,segment:I}=d;this.e(d.key,!1),l.key=p,l.value=w,l.segment=I}}else{const d=l.left??l.right;if(f.length>0){const[p,w]=f[f.length-1];switch(p){case-1:w.left=d;break;case 0:w.mid=d;break;case 1:w.right=d;break}}else this.c=d}for(let d=f.length-1;d>=0;d--){const p=f[d][1];p.updateHeight();const w=p.balanceFactor();if(w>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),f[d][1]=p.rotateLeft()):w<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),f[d][1]=p.rotateRight()),d>0)switch(f[d-1][0]){case-1:f[d-1][1].left=f[d][1];break;case 1:f[d-1][1].right=f[d][1];break;case 0:f[d-1][1].mid=f[d][1];break}else this.c=f[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const h=this.b.reset(m);let y=this.c,f;for(;y;){const l=h.cmp(y.segment);if(l>0)y=y.left;else if(l<0)y=y.right;else if(h.hasNext())h.next(),f=y.value||f,y=y.mid;else break}return y&&y.value||f}findSuperstr(m){return this.g(m,!1)}g(m,h){const y=this.b.reset(m);let f=this.c;for(;f;){const l=y.cmp(f.segment);if(l>0)f=f.left;else if(l<0)f=f.right;else if(y.hasNext())y.next(),f=f.mid;else return f.mid?this.h(f.mid):h?f.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[h,y]of this)m(y,h)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const h=[];return this.j(m,h),h[Symbol.iterator]()}j(m,h){!m||(m.left&&this.j(m.left,h),m.value&&h.push([m.key,m.value]),m.mid&&this.j(m.mid,h),m.right&&this.j(m.right,h))}_isBalanced(){const m=h=>{if(!h)return!0;const y=h.balanceFactor();return y<-1||y>1?!1:m(h.left)&&m(h.right)};return m(this.c)}}e.TernarySearchTree=b}),define(oe[8],ae([0,1,12,5]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function R(t,s){if(!t.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!D.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!A.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(t,s){return!t&&!s?"file":t}function S(t,s){switch(t){case"https":case"http":case"file":s?s[0]!==b&&(s=b+s):s=b;break}return s}const E="",b="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(s){return s instanceof m?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,o,a,r,u,v=!1){typeof s=="object"?(this.scheme=s.scheme||E,this.authority=s.authority||E,this.path=s.path||E,this.query=s.query||E,this.fragment=s.fragment||E):(this.scheme=P(s,v),this.authority=o||E,this.path=S(this.scheme,a||E),this.query=r||E,this.fragment=u||E,R(this,v))}get fsPath(){return p(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:a,path:r,query:u,fragment:v}=s;return o===void 0?o=this.scheme:o===null&&(o=E),a===void 0?a=this.authority:a===null&&(a=E),r===void 0?r=this.path:r===null&&(r=E),u===void 0?u=this.query:u===null&&(u=E),v===void 0?v=this.fragment:v===null&&(v=E),o===this.scheme&&a===this.authority&&r===this.path&&u===this.query&&v===this.fragment?this:new y(o,a,r,u,v)}static parse(s,o=!1){const a=g.exec(s);return a?new y(a[2]||E,c(a[4]||E),c(a[5]||E),c(a[7]||E),c(a[9]||E),o):new y(E,E,E,E,E)}static file(s){let o=E;if(i.isWindows&&(s=s.replace(/\\/g,b)),s[0]===b&&s[1]===b){const a=s.indexOf(b,2);a===-1?(o=s.substring(2),s=b):(o=s.substring(2,a),s=s.substring(a)||b)}return new y("file",o,s,E,E)}static from(s){const o=new y(s.scheme,s.authority,s.path,s.query,s.fragment);return R(o,!0),o}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return i.isWindows&&s.scheme==="file"?a=m.file(k.win32.join(p(s,!0),...o)).path:a=k.posix.join(s.path,...o),s.with({path:a})}toString(s=!1){return w(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof m)return s;{const o=new y(s);return o._formatted=s.external,o._fsPath=s._sep===h?s.fsPath:null,o}}else return s}}e.URI=m;const h=i.isWindows?1:void 0;class y extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(s=!1){return s?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=h),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(t,s,o){let a,r=-1;for(let u=0;u<t.length;u++){const v=t.charCodeAt(u);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||s&&v===47||o&&v===91||o&&v===93||o&&v===58)r!==-1&&(a+=encodeURIComponent(t.substring(r,u)),r=-1),a!==void 0&&(a+=t.charAt(u));else{a===void 0&&(a=t.substr(0,u));const C=f[v];C!==void 0?(r!==-1&&(a+=encodeURIComponent(t.substring(r,u)),r=-1),a+=C):r===-1&&(r=u)}}return r!==-1&&(a+=encodeURIComponent(t.substring(r))),a!==void 0?a:t}function d(t){let s;for(let o=0;o<t.length;o++){const a=t.charCodeAt(o);a===35||a===63?(s===void 0&&(s=t.substr(0,o)),s+=f[a]):s!==void 0&&(s+=t[o])}return s!==void 0?s:t}function p(t,s){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?s?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,i.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=p;function w(t,s){const o=s?d:l;let a="",{scheme:r,authority:u,path:v,query:C,fragment:T}=t;if(r&&(a+=r,a+=":"),(u||r==="file")&&(a+=b,a+=b),u){let N=u.indexOf("@");if(N!==-1){const F=u.substr(0,N);u=u.substr(N+1),N=F.lastIndexOf(":"),N===-1?a+=o(F,!1,!1):(a+=o(F.substr(0,N),!1,!1),a+=":",a+=o(F.substr(N+1),!1,!0)),a+="@"}u=u.toLowerCase(),N=u.lastIndexOf(":"),N===-1?a+=o(u,!1,!0):(a+=o(u.substr(0,N),!1,!0),a+=u.substr(N))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const N=v.charCodeAt(1);N>=65&&N<=90&&(v=`/${String.fromCharCode(N+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const N=v.charCodeAt(0);N>=65&&N<=90&&(v=`${String.fromCharCode(N+32)}:${v.substr(2)}`)}a+=o(v,!0,!1)}return C&&(a+="?",a+=o(C,!1,!1)),T&&(a+="#",a+=s?T:l(T,!1,!1)),a}function I(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+I(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(t){return t.match(n)?t.replace(n,s=>I(s)):t}}),define(oe[143],ae([0,1,8]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(S){const E=S;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=i;function D(S){const E=[];let b;try{const g=JSON.parse(S.arguments),m=g[g.length-1];m&&m.__$stack&&(g.pop(),b=m.__$stack),E.push(...g)}catch{E.push("Unable to log remote console arguments",S.arguments)}return{args:E,stack:b}}e.parse=D;function A(S){if(typeof S!="string")return A(D(S).stack);const E=S;if(E){const b=O(E),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(g&&g.length===4)return{uri:k.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=A;function O(S){if(!S)return S;const E=S.indexOf(`
`);return E===-1?S:S.substring(0,E)}function R(S,E){const{args:b,stack:g}=D(S),m=typeof b[0]=="string"&&b.length===1;let h=O(g);h&&(h=`(${h.trim()})`);let y=[];if(typeof b[0]=="string"?h&&m?y=[`%c[${E}] %c${b[0]} %c${h}`,P("blue"),P(""),P("grey")]:y=[`%c[${E}] %c${b[0]}`,P("blue"),P(""),...b.slice(1)]:y=[`%c[${E}]%`,P("blue"),...b],h&&!m&&y.push(h),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,y)}e.log=R;function P(S){return`color: ${S}`}}),define(oe[67],ae([0,1,17,27,8]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(S){return JSON.stringify(S,R)}e.stringify=A;function O(S){let E=JSON.parse(S);return E=P(E),E}e.parse=O;function R(S,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,i.regExpFlags)(E)}:E}function P(S,E=0){if(!S||E>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return D.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof k.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let b=0;b<S.length;++b)S[b]=P(S[b],E+1);else for(const b in S)Object.hasOwnProperty.call(S,b)&&(S[b]=P(S[b],E+1))}return S}e.revive=P}),define(oe[24],ae([0,1,7,5,8]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var A;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(A=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(E){this.d=E}setDelegate(E){this.e=E}setServerRootPath(E){this.f=`${E}/${A.vscodeRemoteResource}`}set(E,b,g){this.a[E]=b,this.b[E]=g}setConnectionToken(E,b){this.c[E]=b}getPreferredWebSchema(){return this.d}rewrite(E){if(this.e)try{return this.e(E)}catch(f){return k.onUnexpectedError(f),E}const b=E.authority;let g=this.a[b];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const m=this.b[b],h=this.c[b];let y=`path=${encodeURIComponent(E.path)}`;return typeof h=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),D.URI.from({scheme:i.isWeb?this.d:A.vscodeRemoteResource,authority:`${g}:${m}`,path:this.f,query:y})}}e.RemoteAuthorities=new O,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(E){const b=this.b(E,Z);return this.uriToBrowserUri(b)}uriToBrowserUri(E){return E.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===A.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${A.vscodeFileResource}://${R.a}`)?E.with({scheme:A.vscodeFileResource,authority:E.authority||R.a,query:null,fragment:null}):E}asFileUri(E){const b=this.b(E,Z);return this.uriToFileUri(b)}uriToFileUri(E){return E.scheme===A.vscodeFileResource?E.with({scheme:A.file,authority:E.authority!==R.a?E.authority:null,query:null,fragment:null}):E}b(E,b){return D.URI.isUri(E)?E:D.URI.parse(b.toUrl(E))}}R.a="vscode-app",e.FileAccess=new R;var P;(function(S){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(E.get("3"));const b="vscode-coi";function g(h){let y;typeof h=="string"?y=new URL(h).searchParams:h instanceof URL?y=h.searchParams:D.URI.isUri(h)&&(y=new URL(h.toString(!0)).searchParams);const f=y?.get(b);if(!!f)return E.get(f)}S.getHeadersFromQuery=g;function m(h,y,f){if(!globalThis.crossOriginIsolated)return;const l=y&&f?"3":f?"2":"1";h instanceof URLSearchParams?h.set(b,l):h[b]=l}S.addSearchParam=m})(P=e.COI||(e.COI={}))}),define(oe[22],ae([0,1,48,24,12,5,27,8]),function(Z,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(m){return(0,R.uriToFsPath)(m,!0)}e.originalFSPath=P;class S{constructor(h){this.a=h}compare(h,y,f=!1){return h===y?0:(0,O.compare)(this.getComparisonKey(h,f),this.getComparisonKey(y,f))}isEqual(h,y,f=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,f)===this.getComparisonKey(y,f)}getComparisonKey(h,y=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,y,f=!1){if(h.scheme===y.scheme){if(h.scheme===i.Schemas.file)return k.isEqualOrParent(P(h),P(y),this.a(h))&&h.query===y.query&&(f||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return k.isEqualOrParent(h.path,y.path,this.a(h),"/")&&h.query===y.query&&(f||h.fragment===y.fragment)}return!1}joinPath(h,...y){return R.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===i.Schemas.file?y=R.URI.file(D.dirname(P(h))).path:(y=D.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===i.Schemas.file?y=R.URI.file(D.normalize(P(h))).path:y=D.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===i.Schemas.file){const d=D.relative(P(h),P(y));return A.isWindows?k.toSlashes(d):d}let f=h.path||"/";const l=y.path||"/";if(this.a(h)){let d=0;for(const p=Math.min(f.length,l.length);d<p&&!(f.charCodeAt(d)!==l.charCodeAt(d)&&f.charAt(d).toLowerCase()!==l.charAt(d).toLowerCase());d++);f=l.substr(0,d)+f.substr(d)}return D.posix.relative(f,l)}resolvePath(h,y){if(h.scheme===i.Schemas.file){const f=R.URI.file(D.resolve(P(h),y));return h.with({authority:f.authority,path:f.path})}return y=k.toPosixPath(y),h.with({path:D.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||h!==void 0&&y!==void 0&&(0,O.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=D.sep){if(h.scheme===i.Schemas.file){const f=P(h);return f.length>k.getRoot(f).length&&f[f.length-1]===y}else{const f=h.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=D.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=D.sep){let f=!1;if(h.scheme===i.Schemas.file){const l=P(h);f=l!==void 0&&l.length===k.getRoot(l).length&&l[l.length-1]===y}else{y="/";const l=h.path;f=l.length===1&&l.charCodeAt(l.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(m=>m.scheme===i.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new S(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(m,h){const y=[];for(let f=0;f<m.length;f++){const l=h(m[f]);m.some((d,p)=>p===f?!1:(0,e.isEqualOrParent)(l,h(d)))||y.push(m[f])}return y}e.distinctParents=E;var b;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function h(y){const f=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(p=>{const[w,I]=p.split(":");w&&I&&f.set(w,I)});const d=y.path.substring(0,y.path.indexOf(";"));return d&&f.set(m.META_DATA_MIME,d),f}m.parseMetaData=h})(b=e.DataUri||(e.DataUri={}));function g(m,h,y){if(h){let f=m.path;return f&&f[0]!==D.posix.sep&&(f=D.posix.sep+f),m.with({scheme:y,authority:h,path:f})}return m.with({scheme:y})}e.toLocalResource=g}),define(oe[6],ae([0,1,23,7,3,2,22,5]),function(Z,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(te){return!!te&&typeof te.then=="function"}e.isThenable=P;function S(te){const U=new k.CancellationTokenSource,B=te(U.token),W=new Promise((q,J)=>{const _=U.token.onCancellationRequested(()=>{_.dispose(),U.dispose(),J(new i.CancellationError)});Promise.resolve(B).then(Y=>{_.dispose(),U.dispose(),q(Y)},Y=>{_.dispose(),U.dispose(),J(Y)})});return new class{cancel(){U.cancel()}then(q,J){return W.then(q,J)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.createCancelablePromise=S;function E(te,U,B){return new Promise((W,q)=>{const J=U.onCancellationRequested(()=>{J.dispose(),W(B)});te.then(W,q).finally(()=>J.dispose())})}e.raceCancellation=E;function b(te,U){return new Promise((B,W)=>{const q=U.onCancellationRequested(()=>{q.dispose(),W(new i.CancellationError)});te.then(B,W).finally(()=>q.dispose())})}e.raceCancellationError=b;async function g(te){let U=-1;const B=te.map((q,J)=>q.then(_=>(U=J,_))),W=await Promise.race(B);return te.forEach((q,J)=>{J!==U&&q.cancel()}),W}e.raceCancellablePromises=g;function m(te,U,B){let W;const q=setTimeout(()=>{W?.(void 0),B?.()},U);return Promise.race([te.finally(()=>clearTimeout(q)),new Promise(J=>W=J)])}e.raceTimeout=m;function h(te){return new Promise((U,B)=>{const W=te();P(W)?W.then(U,B):U(W)})}e.asPromise=h;class y{constructor(){this.a=null,this.b=null,this.d=null}queue(U){if(this.a){if(this.d=U,!this.b){const B=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(B,B).then(W)})}return new Promise((B,W)=>{this.b.then(B,W)})}return this.a=U(),new Promise((B,W)=>{this.a.then(q=>{this.a=null,B(q)},q=>{this.a=null,W(q)})})}}e.Throttler=y;class f{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.Sequencer=f;class l{constructor(){this.a=new Map}queue(U,B){const q=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(U)===q&&this.a.delete(U)});return this.a.set(U,q),q}}e.SequencerByKey=l;const d=(te,U)=>{let B=!0;const W=setTimeout(()=>{B=!1,U()},te);return{isTriggered:()=>B,dispose:()=>{clearTimeout(W),B=!1}}},p=te=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,te())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class w{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,B=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((q,J)=>{this.d=q,this.f=J}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=B===e.MicrotaskDelay?p(W):d(B,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=w;class I{constructor(U){this.a=new w(U),this.b=new y}trigger(U,B){return this.a.trigger(()=>this.b.queue(U),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=I;class n{constructor(){this.a=!1,this.b=new Promise((U,B)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class c extends n{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=c;function t(te,U){return U?new Promise((B,W)=>{const q=setTimeout(()=>{J.dispose(),B()},te),J=U.onCancellationRequested(()=>{clearTimeout(q),J.dispose(),W(new i.CancellationError)})}):S(B=>t(te,B))}e.timeout=t;function s(te,U=0){const B=setTimeout(te,U);return(0,A.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=s;function o(te){const U=[];let B=0;const W=te.length;function q(){return B<W?te[B++]():null}function J(_){_!=null&&U.push(_);const Y=q();return Y?Y.then(J):Promise.resolve(U)}return Promise.resolve(null).then(J)}e.sequence=o;function a(te,U=W=>!!W,B=null){let W=0;const q=te.length,J=()=>{if(W>=q)return Promise.resolve(B);const _=te[W++];return Promise.resolve(_()).then(Q=>U(Q)?Promise.resolve(Q):J())};return J()}e.first=a;function r(te,U=W=>!!W,B=null){if(te.length===0)return Promise.resolve(B);let W=te.length;const q=()=>{W=-1;for(const J of te)J.cancel?.()};return new Promise((J,_)=>{for(const Y of te)Y.then(Q=>{--W>=0&&U(Q)?(q(),J(Q)):W===0&&J(B)}).catch(Q=>{--W>=0&&(q(),_(Q))})})}e.firstParallel=r;class u{constructor(U){this.a=0,this.d=U,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(U){return this.a++,new Promise((B,W)=>{this.f.push({factory:U,c:B,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const U=this.f.shift();this.b++;const B=U.factory();B.then(U.c,U.e),B.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=u;class v extends u{constructor(){super(1)}}e.Queue=v;class C{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const U=new G;return this.b.add(U),U.p}d(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueFor(U,B=O.extUri){const W=B.getComparisonKey(U);let q=this.a.get(W);return q||(q=new v,D.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,q)),q}f(){!this.d()||this.g()}g(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.g()}}e.ResourceQueue=C;class T{constructor(U,B){this.a=-1,typeof U=="function"&&typeof B=="number"&&this.setIfNotSet(U,B)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,B){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},B)}setIfNotSet(U,B){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},B))}}e.TimeoutTimer=T;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(U,B){this.cancel(),this.a=setInterval(()=>{U()},B)}}e.IntervalTimer=N;class F{constructor(U,B){this.b=-1,this.a=U,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=F;class j{constructor(U,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=U,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=j;class L extends F{constructor(U,B){super(U,B),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=L;class $ extends A.Disposable{constructor(U,B){super(),this.g=U,this.h=B,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of U)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=te=>{(0,R.setTimeout0)(()=>{if(U)return;const B=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(te,U)=>{const B=requestIdleCallback(te,typeof U=="number"?{timeout:U}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(B))}}}}();class z{constructor(U){this.d=!1,this.a=()=>{try{this.f=U()}catch(B){this.g=B}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=z;async function H(te,U,B){let W;for(let q=0;q<B;q++)try{return await te()}catch(J){W=J,await t(U)}throw W}e.retry=H;class X{hasPending(U){return this.a?typeof U=="number"?this.a.taskId===U:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(U,B,W){return this.a={taskId:U,cancel:()=>W?.(),promise:B},B.then(()=>this.d(U),()=>this.d(U)),B}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this.b)this.b.run=U;else{let B,W;const q=new Promise((J,_)=>{B=J,W=_});this.b={run:U,promise:q,promiseResolve:B,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class ie{constructor(U,B=()=>Date.now()){this.d=U,this.f=B,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.IntervalCounter=ie;class G{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((U,B)=>{this.a=U,this.b=B})}complete(U){return new Promise(B=>{this.a(U),this.f=!0,B()})}error(U){return new Promise(B=>{this.b(U),this.d=!0,B()})}cancel(){new Promise(U=>{this.b(new i.CancellationError),this.d=!0,U()})}}e.DeferredPromise=G;var M;(function(te){async function U(W){let q;const J=await Promise.all(W.map(_=>_.then(Y=>Y,Y=>{q||(q=Y)})));if(typeof q<"u")throw q;return J}te.settled=U;function B(W){return new Promise(async(q,J)=>{try{await W(q,J)}catch(_){J(_)}})}te.withAsyncBody=B})(M=e.Promises||(e.Promises={}));var V;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(V||(V={}));class x{static fromArray(U){return new x(B=>{B.emitMany(U)})}static fromPromise(U){return new x(async B=>{B.emitMany(await U)})}static fromPromises(U){return new x(async B=>{await Promise.all(U.map(async W=>B.emitOne(await W)))})}static merge(U){return new x(async B=>{await Promise.all(U.map(async W=>{for await(const q of W)B.emitOne(q)}))})}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const B={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(U(B)),this.j()}catch(W){this.k(W)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(U,B){return new x(async W=>{for await(const q of U)W.emitOne(B(q))})}map(U){return x.map(this,U)}static filter(U,B){return new x(async W=>{for await(const q of U)B(q)&&W.emitOne(q)})}filter(U){return x.filter(this,U)}static coalesce(U){return x.filter(U,B=>!!B)}coalesce(){return x.coalesce(this)}static async toPromise(U){const B=[];for await(const W of U)B.push(W);return B}toPromise(){return x.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}e.AsyncIterableObject=x,x.EMPTY=x.fromArray([]);class ee extends x{constructor(U,B){super(B),this.l=U}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ee;function re(te){const U=new k.CancellationTokenSource,B=te(U.token);return new ee(U,async W=>{const q=U.token.onCancellationRequested(()=>{q.dispose(),U.dispose(),W.reject(new i.CancellationError)});try{for await(const J of B){if(U.token.isCancellationRequested)return;W.emitOne(J)}q.dispose(),U.dispose()}catch(J){q.dispose(),U.dispose(),W.reject(J)}})}e.createCancelableAsyncIterable=re}),define(oe[90],ae([0,1,21,6,48,37,12,5,27]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",b="[^/\\\\]",g=/\//g;function m(G,M){switch(G){case 0:return"";case 1:return`${b}*?`;default:return`(?:${E}|${b}+${E}${M?`|${E}${b}+`:""})*?`}}function h(G,M){if(!G)return[];const V=[];let x=!1,ee=!1,re="";for(const te of G){switch(te){case M:if(!x&&!ee){V.push(re),re="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}re+=te}return re&&V.push(re),V}e.splitGlobAware=h;function y(G){if(!G)return"";let M="";const V=h(G,e.GLOB_SPLIT);if(V.every(x=>x===e.GLOBSTAR))M=".*";else{let x=!1;V.forEach((ee,re)=>{if(ee===e.GLOBSTAR){if(x)return;M+=m(2,re===V.length-1)}else{let te=!1,U="",B=!1,W="";for(const q of ee){if(q!=="}"&&te){U+=q;continue}if(B&&(q!=="]"||!W)){let J;q==="-"?J=q:(q==="^"||q==="!")&&!W?J="^":q===e.GLOB_SPLIT?J="":J=(0,P.escapeRegExpCharacters)(q),W+=J;continue}switch(q){case"{":te=!0;continue;case"[":B=!0;continue;case"}":{M+=`(?:${h(U,",").map(Y=>y(Y)).join("|")})`,te=!1,U="";break}case"]":{M+="["+W+"]",B=!1,W="";break}case"?":M+=b;continue;case"*":M+=m(1);continue;default:M+=(0,P.escapeRegExpCharacters)(q)}}re<V.length-1&&(V[re+1]!==e.GLOBSTAR||re+2<V.length)&&(M+=E)}x=ee===e.GLOBSTAR})}return M}const f=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new A.LRUCache(1e4),c=function(){return!1},t=function(){return null};function s(G,M){if(!G)return t;let V;typeof G!="string"?V=G.pattern:V=G,V=V.trim();const x=`${V}_${!!M.trimForExclusions}`;let ee=n.get(x);if(ee)return o(ee,G);let re;return f.test(V)?ee=r(V.substr(4),V):(re=l.exec(a(V,M)))?ee=u(re[1],V):(M.trimForExclusions?p:d).test(V)?ee=v(V,M):(re=w.exec(a(V,M)))?ee=C(re[1].substr(1),V,!0):(re=I.exec(a(V,M)))?ee=C(re[1],V,!1):ee=T(V),n.set(x,ee),o(ee,G)}function o(G,M){if(typeof M=="string")return G;const V=function(x,ee){return(0,D.isEqualOrParent)(x,M.base,!R.isLinux)?G((0,P.ltrim)(x.substr(M.base.length),O.sep),ee):null};return V.allBasenames=G.allBasenames,V.allPaths=G.allPaths,V.basenames=G.basenames,V.patterns=G.patterns,V}function a(G,M){return M.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function r(G,M){return function(V,x){return typeof V=="string"&&V.endsWith(G)?M:null}}function u(G,M){const V=`/${G}`,x=`\\${G}`,ee=function(te,U){return typeof te!="string"?null:U?U===G?M:null:te===G||te.endsWith(V)||te.endsWith(x)?M:null},re=[G];return ee.basenames=re,ee.patterns=[M],ee.allBasenames=re,ee}function v(G,M){const V=X(G.slice(1,-1).split(",").map(U=>s(U,M)).filter(U=>U!==t),G),x=V.length;if(!x)return t;if(x===1)return V[0];const ee=function(U,B){for(let W=0,q=V.length;W<q;W++)if(V[W](U,B))return G;return null},re=V.find(U=>!!U.allBasenames);re&&(ee.allBasenames=re.allBasenames);const te=V.reduce((U,B)=>B.allPaths?U.concat(B.allPaths):U,[]);return te.length&&(ee.allPaths=te),ee}function C(G,M,V){const x=O.sep===O.posix.sep,ee=x?G:G.replace(g,O.sep),re=O.sep+ee,te=O.posix.sep+G;let U;return V?U=function(B,W){return typeof B=="string"&&(B===ee||B.endsWith(re)||!x&&(B===G||B.endsWith(te)))?M:null}:U=function(B,W){return typeof B=="string"&&(B===ee||!x&&B===G)?M:null},U.allPaths=[(V?"*/":"./")+G],U}function T(G){try{const M=new RegExp(`^${y(G)}$`);return function(V){return M.lastIndex=0,typeof V=="string"&&M.test(V)?G:null}}catch{return t}}function N(G,M,V){return!G||typeof M!="string"?!1:F(G)(M,void 0,V)}e.match=N;function F(G,M={}){if(!G)return c;if(typeof G=="string"||j(G)){const V=s(G,M);if(V===t)return c;const x=function(ee,re){return!!V(ee,re)};return V.allBasenames&&(x.allBasenames=V.allBasenames),V.allPaths&&(x.allPaths=V.allPaths),x}return z(G,M)}e.parse=F;function j(G){const M=G;return M?typeof M.base=="string"&&typeof M.pattern=="string":!1}e.isRelativePattern=j;function L(G){return G.allBasenames||[]}e.getBasenameTerms=L;function $(G){return G.allPaths||[]}e.getPathTerms=$;function z(G,M){const V=X(Object.getOwnPropertyNames(G).map(U=>H(U,G[U],M)).filter(U=>U!==t)),x=V.length;if(!x)return t;if(!V.some(U=>!!U.requiresSiblings)){if(x===1)return V[0];const U=function(q,J){let _;for(let Y=0,Q=V.length;Y<Q;Y++){const se=V[Y](q,J);if(typeof se=="string")return se;(0,i.isThenable)(se)&&(_||(_=[]),_.push(se))}return _?(async()=>{for(const Y of _){const Q=await Y;if(typeof Q=="string")return Q}return null})():null},B=V.find(q=>!!q.allBasenames);B&&(U.allBasenames=B.allBasenames);const W=V.reduce((q,J)=>J.allPaths?q.concat(J.allPaths):q,[]);return W.length&&(U.allPaths=W),U}const ee=function(U,B,W){let q,J;for(let _=0,Y=V.length;_<Y;_++){const Q=V[_];Q.requiresSiblings&&W&&(B||(B=(0,O.basename)(U)),q||(q=B.substr(0,B.length-(0,O.extname)(U).length)));const se=Q(U,B,q,W);if(typeof se=="string")return se;(0,i.isThenable)(se)&&(J||(J=[]),J.push(se))}return J?(async()=>{for(const _ of J){const Y=await _;if(typeof Y=="string")return Y}return null})():null},re=V.find(U=>!!U.allBasenames);re&&(ee.allBasenames=re.allBasenames);const te=V.reduce((U,B)=>B.allPaths?U.concat(B.allPaths):U,[]);return te.length&&(ee.allPaths=te),ee}function H(G,M,V){if(M===!1)return t;const x=s(G,V);if(x===t)return t;if(typeof M=="boolean")return x;if(M){const ee=M.when;if(typeof ee=="string"){const re=(te,U,B,W)=>{if(!W||!x(te,U))return null;const q=ee.replace("$(basename)",()=>B),J=W(q);return(0,i.isThenable)(J)?J.then(_=>_?G:null):J?G:null};return re.requiresSiblings=!0,re}}return x}function X(G,M){const V=G.filter(U=>!!U.basenames);if(V.length<2)return G;const x=V.reduce((U,B)=>{const W=B.basenames;return W?U.concat(W):U},[]);let ee;if(M){ee=[];for(let U=0,B=x.length;U<B;U++)ee.push(M)}else ee=V.reduce((U,B)=>{const W=B.patterns;return W?U.concat(W):U},[]);const re=function(U,B){if(typeof U!="string")return null;if(!B){let q;for(q=U.length;q>0;q--){const J=U.charCodeAt(q-1);if(J===47||J===92)break}B=U.substr(q)}const W=x.indexOf(B);return W!==-1?ee[W]:null};re.basenames=x,re.patterns=ee,re.allBasenames=x;const te=G.filter(U=>!U.basenames);return te.push(re),te}function ie(G,M){return(0,k.equals)(G,M,(V,x)=>typeof V=="string"&&typeof x=="string"?V===x:typeof V!="string"&&typeof x!="string"?V.base===x.base&&V.pattern===x.pattern:!1)}e.patternsEquals=ie}),define(oe[144],ae([0,1,8]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(E){return E.toJSON()}class D{constructor(b){this.a=b}transformIncoming(b){const g=this.a.transformIncoming(b);return g===b?b:i(k.URI.from(g))}transformOutgoing(b){const g=this.a.transformOutgoing(b);return g===b?b:i(k.URI.from(g))}transformOutgoingURI(b){const g=this.a.transformOutgoing(b);return g===b?b:k.URI.from(g)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function A(E,b,g){if(!E||g>200)return null;if(typeof E=="object"){if(E instanceof k.URI)return b.transformOutgoing(E);for(const m in E)if(Object.hasOwnProperty.call(E,m)){const h=A(E[m],b,g+1);h!==null&&(E[m]=h)}}return null}function O(E,b){const g=A(E,b,0);return g===null?E:g}e.transformOutgoingURIs=O;function R(E,b,g,m){if(!E||m>200)return null;if(typeof E=="object"){if(E.$mid===1)return g?k.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);for(const h in E)if(Object.hasOwnProperty.call(E,h)){const y=R(E[h],b,g,m+1);y!==null&&(E[h]=y)}}return null}function P(E,b){const g=R(E,b,!1,0);return g===null?E:g}e.transformIncomingURIs=P;function S(E,b){const g=R(E,b,!0,0);return g===null?E:g}e.transformAndReviveIncomingURIs=S}),define(oe[145],ae([0,1,34,7,49,31,132]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(E){return this.a||(this.a=D.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(E)}value(){if(this.b===void 0){let E=0,b=0;const g=(0,k.networkInterfaces)();for(const m in g){const h=g[m];if(h)for(const{mac:y,internal:f}of h)f||(b+=1,this.c(y.toUpperCase())&&(E+=1))}this.b=b>0?E/b:0}return this.b}};let R;async function P(){return R||(R=(async()=>await S()||A.generateUuid())()),R}e.getMachineId=P;async function S(){try{const E=await new Promise((g,m)=>{Z(["crypto"],g,m)}),b=(0,O.getMac)();return E.createHash("sha256").update(b,"utf8").digest("hex")}catch(E){i.onUnexpectedError(E);return}}}),define(oe[28],ae([0,1,53,34,284,6,48,85,12,5,22,8]),function(Z,e,k,i,D,A,O,R,P,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function m(z,H=g.UNLINK){if((0,O.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return H===g.UNLINK?y(z):h(z)}async function h(z){try{const H=(0,O.randomPath)((0,i.tmpdir)());try{await k.promises.rename(z,H)}catch(X){return X.code==="ENOENT"?void 0:y(z)}y(H).catch(X=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function y(z){return(0,D.promisify)(k.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function f(z){if((0,O.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function l(z,H){return w(await(H?d(z):(0,D.promisify)(k.readdir)(z)))}async function d(z){try{return await(0,D.promisify)(k.readdir)(z,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const H=[],X=await l(z);for(const ie of X){let G=!1,M=!1,V=!1;try{const x=await e.Promises.lstat((0,P.join)(z,ie));G=x.isFile(),M=x.isDirectory(),V=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}H.push({name:ie,isFile:()=>G,isDirectory:()=>M,isSymbolicLink:()=>V})}return H}function p(z){return w(k.readdirSync(z))}e.readdirSync=p;function w(z){return z.map(H=>typeof H=="string"?S.isMacintosh?(0,R.normalizeNFC)(H):H:(H.name=S.isMacintosh?(0,R.normalizeNFC)(H.name):H.name,H))}async function I(z){const H=await l(z),X=[];for(const ie of H)await c.existsDirectory((0,P.join)(z,ie))&&X.push(ie);return X}function n(z,H=1e3){return new Promise(X=>{let ie=!1;const G=setInterval(()=>{ie||(ie=!0,k.access(z,M=>{ie=!1,M&&(clearInterval(G),X(void 0))}))},H)})}e.whenDeleted=n;var c;(function(z){async function H(G){let M;try{if(M=await e.Promises.lstat(G),!M.isSymbolicLink())return{stat:M}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:M?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(S.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw x}throw V}}z.stat=H;async function X(G){try{const{stat:M,symbolicLink:V}=await z.stat(G);return M.isFile()&&V?.dangling!==!0}catch{}return!1}z.existsFile=X;async function ie(G){try{const{stat:M,symbolicLink:V}=await z.stat(G);return M.isDirectory()&&V?.dangling!==!0}catch{}return!1}z.existsDirectory=ie})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new A.ResourceQueue;function s(z,H,X){return t.queueFor(b.URI.file(z),E.extUriBiasedIgnorePathCase).queue(()=>{const ie=v(X);return new Promise((G,M)=>r(z,H,ie,V=>V?M(V):G()))})}let o=!0;function a(z){o=z}e.configureFlushOnWrite=a;function r(z,H,X,ie){if(!o)return k.writeFile(z,H,{mode:X.mode,flag:X.flag},ie);k.open(z,X.flag,X.mode,(G,M)=>{if(G)return ie(G);k.writeFile(M,H,V=>{if(V)return k.close(M,()=>ie(V));k.fdatasync(M,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),a(!1)),k.close(M,ee=>ie(ee))))})})}function u(z,H,X){const ie=v(X);if(!o)return k.writeFileSync(z,H,{mode:ie.mode,flag:ie.flag});const G=k.openSync(z,ie.flag,ie.mode);try{k.writeFileSync(G,H);try{k.fdatasyncSync(G)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),a(!1)}}finally{k.closeSync(G)}}e.writeFileSync=u;function v(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function C(z,H){if(z!==H)try{await e.Promises.rename(z,H)}catch(X){if(z.toLowerCase()!==H.toLowerCase()&&X.code==="EXDEV"||z.endsWith("."))await T(z,H,{preserveSymlinks:!1}),await m(z,g.MOVE);else throw X}}async function T(z,H,X){return F(z,H,{root:{source:z,target:H},options:X,handledSourcePaths:new Set})}const N=511;async function F(z,H,X){if(X.handledSourcePaths.has(z))return;X.handledSourcePaths.add(z);const{stat:ie,symbolicLink:G}=await c.stat(z);if(G){if(X.options.preserveSymlinks)try{return await $(z,H,X)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(G.dangling)return}return ie.isDirectory()?j(z,H,ie.mode&N,X):L(z,H,ie.mode&N)}async function j(z,H,X,ie){await e.Promises.mkdir(H,{recursive:!0,mode:X});const G=await l(z);for(const M of G)await F((0,P.join)(z,M),(0,P.join)(H,M),ie)}async function L(z,H,X){await e.Promises.copyFile(z,H),await e.Promises.chmod(H,X)}async function $(z,H,X){let ie=await e.Promises.readlink(z);(0,O.isEqualOrParent)(ie,X.root.source,!S.isLinux)&&(ie=(0,P.join)(X.root.target,ie.substr(X.root.source.length+1))),await e.Promises.symlink(ie,H)}e.Promises=new class{get access(){return(0,D.promisify)(k.access)}get stat(){return(0,D.promisify)(k.stat)}get lstat(){return(0,D.promisify)(k.lstat)}get utimes(){return(0,D.promisify)(k.utimes)}get read(){return(z,H,X,ie,G)=>new Promise((M,V)=>{k.read(z,H,X,ie,G,(x,ee,re)=>x?V(x):M({bytesRead:ee,buffer:re}))})}get readFile(){return(0,D.promisify)(k.readFile)}get write(){return(z,H,X,ie,G)=>new Promise((M,V)=>{k.write(z,H,X,ie,G,(x,ee,re)=>x?V(x):M({bytesWritten:ee,buffer:re}))})}get appendFile(){return(0,D.promisify)(k.appendFile)}get fdatasync(){return(0,D.promisify)(k.fdatasync)}get truncate(){return(0,D.promisify)(k.truncate)}get rename(){return(0,D.promisify)(k.rename)}get copyFile(){return(0,D.promisify)(k.copyFile)}get open(){return(0,D.promisify)(k.open)}get close(){return(0,D.promisify)(k.close)}get symlink(){return(0,D.promisify)(k.symlink)}get readlink(){return(0,D.promisify)(k.readlink)}get chmod(){return(0,D.promisify)(k.chmod)}get mkdir(){return(0,D.promisify)(k.mkdir)}get unlink(){return(0,D.promisify)(k.unlink)}get rmdir(){return(0,D.promisify)(k.rmdir)}get realpath(){return(0,D.promisify)(k.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return I}get writeFile(){return s}get rm(){return m}get move(){return C}get copy(){return T}}}),define(oe[146],ae([0,1,53,12,5,27,28]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(g){if(D.isLinux)return g;const m=(0,i.dirname)(g);if(g===m)return g;const h=((0,i.basename)(g)||g).toLowerCase();try{const f=(0,O.readdirSync)(m).filter(l=>l.toLowerCase()===h);if(f.length===1){const l=R(m);if(l)return(0,i.join)(l,f[0])}else if(f.length>1){const l=f.indexOf(h);if(l>=0){const d=R(m);if(d)return(0,i.join)(d,f[l])}}}catch{}return null}e.realcaseSync=R;async function P(g){if(D.isLinux)return g;const m=(0,i.dirname)(g);if(g===m)return g;const h=((0,i.basename)(g)||g).toLowerCase();try{const f=(await O.Promises.readdir(m)).filter(l=>l.toLowerCase()===h);if(f.length===1){const l=await P(m);if(l)return(0,i.join)(l,f[0])}else if(f.length>1){const l=f.indexOf(h);if(l>=0){const d=await P(m);if(d)return(0,i.join)(d,f[l])}}}catch{}return null}e.realcase=P;async function S(g){try{return await O.Promises.realpath(g)}catch{const h=b(g);return await O.Promises.access(h,k.constants.R_OK),h}}e.realpath=S;function E(g){try{return k.realpathSync(g)}catch{const h=b(g);return k.accessSync(h,k.constants.R_OK),h}}e.realpathSync=E;function b(g){return(0,A.rtrim)((0,i.normalize)(g),i.sep)}}),define(oe[91],ae([0,1,34,12,28]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,O=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var P;(function(w){w[w.x64=0]="x64",w[w.x86=1]="x86",w[w.ARM=2]="ARM"})(P||(P={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class b{constructor(I,n,c){this.exePath=I,this.displayName=n,this.a=c}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:w=!1}={}){return w?S===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:w=!1,findPreview:I=!1}={}){const n=g({useAlternateBitness:w});if(!n)return null;const c=i.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(c))return null;let t=-1,s=null;for(const r of await D.Promises.readdir(c)){let u=-1;if(I){const C=r.indexOf("-");if(C<0)continue;const T=r.substring(0,C);if(!A.test(T)||r.substring(C+1)!=="preview")continue;u=parseInt(T,10)}else{if(!A.test(r))continue;u=parseInt(r,10)}if(u<=t)continue;const v=i.join(c,r,"pwsh.exe");!await D.SymlinkSupport.existsFile(v)||(s=v,t=u)}if(!s)return null;const o=n.includes("x86")?" (x86)":"",a=I?" Preview":"";return new b(s,`PowerShell${a}${o}`,!0)}async function h({findPreview:w}={}){if(!process.env.LOCALAPPDATA)return null;const I=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(I))return null;const{pwshMsixDirRegex:n,pwshMsixName:c}=w?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(I))if(n.test(t)){const s=i.join(I,t,"pwsh.exe");return new b(s,c)}return null}function y(){const w=i.join(k.homedir(),".dotnet","tools","pwsh.exe");return new b(w,".NET Core PowerShell Global Tool")}function f(){const w=i.join(process.env.windir,S===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(w,"Windows PowerShell",!0)}async function*l(){let w=await m();w&&(yield w),w=await m({useAlternateBitness:!0}),w&&(yield w),w=await h(),w&&(yield w),w=y(),w&&(yield w),w=await m({findPreview:!0}),w&&(yield w),w=await h({findPreview:!0}),w&&(yield w),w=await m({useAlternateBitness:!0,findPreview:!0}),w&&(yield w),w=f(),w&&(yield w)}async function*d(){for await(const w of l())await w.exists()&&(yield w)}e.enumeratePowerShellInstallations=d;async function p(){for await(const w of d())return w;return null}e.getFirstAvailablePowerShellInstallation=p}),define(oe[92],ae([0,1,12,5,36,87,13,28]),function(Z,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function P(b=D.env){return b.comspec||"cmd.exe"}e.getWindowsShell=P;function S(b){let g=[],m=!1;const h=function(y){if(m){g.push(y);return}(!b.send(y,l=>{if(l&&console.error(l),m=!1,g.length>0){const d=g.slice(0);g=[],d.forEach(p=>h(p))}})||i.isWindows)&&(m=!0)};return{send:h}}e.createQueuedSender=S;var E;(function(b){async function g(m,h,y){if(k.isAbsolute(m))return m;if(h===void 0&&(h=D.cwd()),k.dirname(m)!=="."||(y===void 0&&O.isString(D.env.PATH)&&(y=D.env.PATH.split(k.delimiter)),y===void 0||y.length===0))return k.join(h,m);async function l(d){if(await R.Promises.exists(d)){let p;try{p=await R.Promises.stat(d)}catch(w){w.message.startsWith("EACCES")&&(p=await R.Promises.lstat(d))}return p?!p.isDirectory():!1}return!1}for(const d of y){let p;if(k.isAbsolute(d)?p=k.join(d,m):p=k.join(h,d,m),await l(p))return p;let w=p+".com";if(await l(w)||(w=p+".exe",await l(w)))return w}return k.join(h,m)}b.findExecutable=g})(E=e.win32||(e.win32={}))}),define(oe[147],ae([0,1,50,24]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(O){return new Promise((R,P)=>{let S;const E=new Map;function b(m,h,y,f,l){const d=E.get(h);if(m===O||d){const p={name:g(y),cmd:y,pid:m,ppid:h,load:f,mem:l};E.set(m,p),m===O&&(S=p),d&&(d.children||(d.children=[]),d.children.push(p),d.children.length>1&&(d.children=d.children.sort((w,I)=>w.pid-I.pid)))}}function g(m){const h=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,d=/--utility-sub-type=node.mojom.NodeService/,p=/--crashes-directory/,w=/\\pipe\\winpty-control/,I=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(p.exec(m))return"electron-crash-reporter";if(w.exec(m))return"winpty-process";if(I.exec(m))return"console-window-host (Windows internal process)";let c=n.exec(m);if(c&&c.length===2){if(c[1]==="renderer")return h.exec(m)?"shared-process":y.exec(m)?"issue-reporter":f.exec(m)?"process-explorer":"window";if(c[1]==="utility"){if(l.exec(m))return"utility-network-service";if(d.exec(m))return"extension-host"}else if(c[1]==="extensionHost")return"extension-host";return c[1]}const t=/[a-zA-Z-]+\.js/g;let s="";do c=t.exec(m),c&&(s+=c+" ");while(c);return s&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${s}`:m}if(process.platform==="win32"){const m=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{Z(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(O,y=>{if(!y){P(new Error(`Root process ${O} not found`));return}h.getProcessCpuUsage(y,f=>{const l=new Map;f.forEach(d=>{const p=m(d.commandLine||"");l.set(d.pid,{name:g(p),cmd:p,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),S=l.get(O),S?(l.forEach(d=>{const p=l.get(d.ppid);p&&(p.children||(p.children=[]),p.children.push(d))}),l.forEach(d=>{d.children&&(d.children=d.children.sort((p,w)=>p.pid-w.pid))}),R(S)):P(new Error(`Root process ${O} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let m=function(){let h=[S];const y=[];for(;h.length;){const l=h.shift();l&&(y.push(l.pid),l.children&&(h=h.concat(l.children)))}let f=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+y.join(" "),(0,k.exec)(f,{},(l,d,p)=>{if(l||p)P(l||new Error(p.toString()));else{const w=d.toString().split(`
`);for(let I=0;I<y.length;I++){const n=E.get(y[I]);n.load=parseFloat(w[I])}if(!S){P(new Error(`Root process ${O} not found`));return}R(S)}})};(0,k.exec)("which ps",{},(h,y,f)=>{if(h||f)if(process.platform!=="linux")P(h||new Error(f.toString()));else{const l=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(l,{},(d,p,w)=>{d||w?P(d||new Error(w.toString())):(A(p,b),m())})}else{const l=y.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${l} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,w,I)=>{p||I&&!I.includes("screen size is bogus")?P(p||new Error(I.toString())):(A(w,b),process.platform==="linux"?m():S?R(S):P(new Error(`Root process ${O} not found`)))})}})}})}e.listProcesses=D;function A(O,R){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=O.toString().split(`
`);for(const E of S){const b=P.exec(E.trim());b&&b.length===6&&R(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(oe[148],ae([0,1,34,5,91,92]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function O(b,g){return b===1?i.isWindows?E():A.getWindowsShell(g):P(b,g)}e.getSystemShell=O;let R=null;function P(b,g){if(i.isLinux&&b===2||i.isMacintosh&&b===3)return"/bin/bash";if(!R){let m;if(i.isWindows)m="/bin/bash";else{if(m=g.SHELL,!m)try{m=(0,k.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}R=m}return R}let S=null;async function E(){return S||(S=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),S}});var ye=this&&this.__decorate||function(Z,e,k,i){var D=arguments.length,A=D<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,k):i,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Z,e,k,i);else for(var R=Z.length-1;R>=0;R--)(O=Z[R])&&(A=(D<3?O(A):D>3?O(e,k,A):O(e,k))||A);return D>3&&A&&Object.defineProperty(e,k,A),A};define(oe[39],ae([0,1,21,6,17,23,63,7,3,2,67,27,13]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m||(m={}));function h(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(y||(y={}));function f(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(l||(l={}));function d(M){let V=0;for(let x=0;;x+=7){const ee=M.read(1);if(V|=(ee.buffer[0]&127)<<x,!(ee.buffer[0]&128))return V}}const p=t(0);function w(M,V){if(V===0){M.write(p);return}let x=0;for(let re=V;re!==0;re=re>>>7)x++;const ee=D.VSBuffer.alloc(x);for(let re=0;V!==0;re++)ee.buffer[re]=V&127,V=V>>>7,V>0&&(ee.buffer[re]|=128);M.write(ee)}class I{constructor(V){this.b=V,this.a=0}read(V){const x=this.b.slice(this.a,this.a+V);return this.a+=x.byteLength,x}}e.BufferReader=I;class n{constructor(){this.a=[]}get buffer(){return D.VSBuffer.concat(this.a)}write(V){this.a.push(V)}}e.BufferWriter=n;var c;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(c||(c={}));function t(M){const V=D.VSBuffer.alloc(1);return V.writeUInt8(M,0),V}const s={Undefined:t(c.Undefined),String:t(c.String),Buffer:t(c.Buffer),VSBuffer:t(c.VSBuffer),Array:t(c.Array),Object:t(c.Object),Uint:t(c.Int)},o=typeof Buffer<"u";function a(M,V){if(typeof V>"u")M.write(s.Undefined);else if(typeof V=="string"){const x=D.VSBuffer.fromString(V);M.write(s.String),w(M,x.byteLength),M.write(x)}else if(o&&Buffer.isBuffer(V)){const x=D.VSBuffer.wrap(V);M.write(s.Buffer),w(M,x.byteLength),M.write(x)}else if(V instanceof D.VSBuffer)M.write(s.VSBuffer),w(M,V.byteLength),M.write(V);else if(Array.isArray(V)){M.write(s.Array),w(M,V.length);for(const x of V)a(M,x)}else if(typeof V=="number"&&(V|0)===V)M.write(s.Uint),w(M,V);else{const x=D.VSBuffer.fromString(JSON.stringify(V));M.write(s.Object),w(M,x.byteLength),M.write(x)}}e.serialize=a;function r(M){switch(M.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return M.read(d(M)).toString();case c.Buffer:return M.read(d(M)).buffer;case c.VSBuffer:return M.read(d(M));case c.Array:{const x=d(M),ee=[];for(let re=0;re<x;re++)ee.push(r(M));return ee}case c.Object:return JSON.parse(M.read(d(M)).toString());case c.Int:return d(M)}}e.deserialize=r;class u{constructor(V,x,ee=null,re=1e3){this.h=V,this.j=x,this.k=ee,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(V,x){this.b.set(V,x),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const x=this.o([V.type]);this.k?.logOutgoing(x,0,1,f(V.type));return}case 201:case 202:case 204:case 203:{const x=this.o([V.type,V.id],V.data);this.k?.logOutgoing(x,V.id,1,f(V.type),V.data);return}}}o(V,x=void 0){const ee=new n;return a(ee,V),a(ee,x),this.p(ee.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const x=new I(V),ee=r(x),re=r(x),te=ee[0];switch(te){case 100:return this.k?.logIncoming(V.byteLength,ee[1],1,`${h(te)}: ${ee[2]}.${ee[3]}`,re),this.s({type:te,id:ee[1],channelName:ee[2],name:ee[3],arg:re});case 102:return this.k?.logIncoming(V.byteLength,ee[1],1,`${h(te)}: ${ee[2]}.${ee[3]}`,re),this.t({type:te,id:ee[1],channelName:ee[2],name:ee[3],arg:re});case 101:return this.k?.logIncoming(V.byteLength,ee[1],1,`${h(te)}`),this.u({type:te,id:ee[1]});case 103:return this.k?.logIncoming(V.byteLength,ee[1],1,`${h(te)}`),this.u({type:te,id:ee[1]})}}s(V){const x=this.b.get(V.channelName);if(!x){this.v(V);return}const ee=new A.CancellationTokenSource;let re;try{re=x.call(this.j,V.name,V.arg,ee.token)}catch(B){re=Promise.reject(B)}const te=V.id;re.then(B=>{this.m({id:te,data:B,type:201}),this.d.delete(V.id)},B=>{B instanceof Error?this.m({id:te,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:te,data:B,type:203}),this.d.delete(V.id)});const U=(0,S.toDisposable)(()=>ee.cancel());this.d.set(V.id,U)}t(V){const x=this.b.get(V.channelName);if(!x){this.v(V);return}const ee=V.id,te=x.listen(this.j,V.name,V.arg)(U=>this.m({id:ee,data:U,type:204}));this.d.set(V.id,te)}u(V){const x=this.d.get(V.id);x&&(x.dispose(),this.d.delete(V.id))}v(V){let x=this.g.get(V.channelName);x||(x=[],this.g.set(V.channelName,x));const ee=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:V,timeoutTimer:ee})}w(V){const x=this.g.get(V);if(x){for(const ee of x)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=u;var v;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));class C{constructor(V,x=null){this.l=V,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new P.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=x}getChannel(V){const x=this;return{call(ee,re,te){return x.a?Promise.reject(new R.CancellationError):x.m(V,ee,re,te)},listen(ee,re){return x.a?P.Event.None:x.o(V,ee,re)}}}m(V,x,ee,re=A.CancellationToken.None){const te=this.g++,B={id:te,type:100,channelName:V,name:x,arg:ee};if(re.isCancellationRequested)return Promise.reject(new R.CancellationError);let W;return new Promise((J,_)=>{if(re.isCancellationRequested)return _(new R.CancellationError);const Y=()=>{const ue=pe=>{switch(pe.type){case 201:this.f.delete(te),J(pe.data);break;case 202:{this.f.delete(te);const we=new Error(pe.data.message);we.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,we.name=pe.data.name,_(we);break}case 203:this.f.delete(te),_(pe.data);break}};this.f.set(te,ue),this.p(B)};let Q=null;this.b===l.Idle?Y():(Q=(0,i.createCancelablePromise)(ue=>this.u()),Q.then(()=>{Q=null,Y()}));const se=()=>{Q?(Q.cancel(),Q=null):this.p({id:te,type:101}),_(new R.CancellationError)},le=re.onCancellationRequested(se);W=(0,S.combinedDisposable)((0,S.toDisposable)(se),le),this.d.add(W)}).finally(()=>{this.d.delete(W)})}o(V,x,ee){const re=this.g++,U={id:re,type:102,channelName:V,name:x,arg:ee};let B=null;const W=new P.Emitter({onWillAddFirstListener:()=>{B=(0,i.createCancelablePromise)(J=>this.u()),B.then(()=>{B=null,this.d.add(W),this.p(U)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(W),this.p({id:re,type:103}))}}),q=J=>W.fire(J.data);return this.f.set(re,q),W.event}p(V){switch(V.type){case 100:case 102:{const x=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(x,V.id,0,`${h(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const x=this.q([V.type,V.id]);this.j?.logOutgoing(x,V.id,0,h(V.type));return}}}q(V,x=void 0){const ee=new n;return a(ee,V),a(ee,x),this.r(ee.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const x=new I(V),ee=r(x),re=r(x),te=ee[0];switch(te){case 200:return this.j?.logIncoming(V.byteLength,0,0,f(te)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ee[1],0,f(te),re),this.t({type:ee[0],id:ee[1],data:re})}}t(V){if(V.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.dispose)(this.d.values()),this.d.clear()}}ye([O.memoize],C.prototype,"onDidInitializePromise",null),e.ChannelClient=C;class T{get connections(){const V=[];return this.f.forEach(x=>V.push(x)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new P.Emitter,this.onDidAddConnection=this.g.event,this.h=new P.Emitter,this.onDidRemoveConnection=this.h.event,V(({protocol:x,onDidClientDisconnect:ee})=>{P.Event.once(x.onMessage)(te=>{const U=new I(te),B=r(U),W=new u(x,B),q=new C(x);this.a.forEach((_,Y)=>W.registerChannel(Y,_));const J={channelServer:W,channelClient:q,ctx:B};this.f.add(J),this.g.fire(J),ee(()=>{W.dispose(),q.dispose(),this.f.delete(J),this.h.fire(J)})})})}getChannel(V,x){const ee=this;return{call(re,te,U){let B;if((0,g.isFunction)(x)){const q=(0,k.getRandomElement)(ee.connections.filter(x));B=q?Promise.resolve(q):P.Event.toPromise(P.Event.filter(ee.onDidAddConnection,x))}else B=x.routeCall(ee,re,te);const W=B.then(q=>q.channelClient.getChannel(V));return F(W).call(re,te,U)},listen(re,te){if((0,g.isFunction)(x))return ee.j(V,x,re,te);const U=x.routeEvent(ee,re,te).then(B=>B.channelClient.getChannel(V));return F(U).listen(re,te)}}}j(V,x,ee,re){const te=this;let U=new S.DisposableStore;const B=new P.Emitter({onWillAddFirstListener:()=>{U=new S.DisposableStore;const W=new P.EventMultiplexer,q=new Map,J=Y=>{const se=Y.channelClient.getChannel(V).listen(ee,re),le=W.add(se);q.set(Y,le)},_=Y=>{const Q=q.get(Y);!Q||(Q.dispose(),q.delete(Y))};te.connections.filter(x).forEach(J),P.Event.filter(te.onDidAddConnection,x)(J,void 0,U),te.onDidRemoveConnection(_,void 0,U),W.event(B.fire,B,U),U.add(W)},onDidRemoveLastListener:()=>{U.dispose()}});return B.event}registerChannel(V,x){this.a.set(V,x),this.f.forEach(ee=>{ee.channelServer.registerChannel(V,x)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class N{constructor(V,x,ee=null){const re=new n;a(re,x),V.send(re.buffer),this.a=new C(V,ee),this.d=new u(V,x,ee)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,x){this.d.registerChannel(V,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function F(M){return{call(V,x,ee){return M.then(re=>re.call(V,x,ee))},listen(V,x){const ee=new P.Relay;return M.then(re=>ee.input=re.listen(V,x)),ee.event}}}e.getDelayedChannel=F;function j(M){let V=!1;return{call(x,ee,re){return V?M.call(x,ee,re):(0,i.timeout)(0).then(()=>V=!0).then(()=>M.call(x,ee,re))},listen(x,ee){if(V)return M.listen(x,ee);const re=new P.Relay;return(0,i.timeout)(0).then(()=>V=!0).then(()=>re.input=M.listen(x,ee)),re.event}}}e.getNextTickChannel=j;class L{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const x of V.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await P.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.StaticRouter=L;var $;(function(M){function V(te,U){const B=te,W=U&&U.disableMarshalling,q=new Map;for(const J in B)ee(J)&&q.set(J,P.Event.buffer(B[J],!0));return new class{listen(J,_,Y){const Q=q.get(_);if(Q)return Q;if(re(_)){const se=B[_];if(typeof se=="function")return se.call(B,Y)}throw new Error(`Event not found: ${_}`)}call(J,_,Y){const Q=B[_];if(typeof Q=="function"){if(!W&&Array.isArray(Y))for(let se=0;se<Y.length;se++)Y[se]=(0,E.revive)(Y[se]);return Q.apply(B,Y)}throw new Error(`Method not found: ${_}`)}}}M.fromService=V;function x(te,U){const B=U&&U.disableMarshalling;return new Proxy({},{get(W,q){if(typeof q=="string")return U?.properties?.has(q)?U.properties.get(q):re(q)?function(J){return te.listen(q,J)}:ee(q)?te.listen(q):async function(...J){let _;U&&!(0,g.isUndefinedOrNull)(U.context)?_=[U.context,...J]:_=J;const Y=await te.call(q,_);return B?Y:(0,E.revive)(Y)};throw new Error(`Property not found: ${String(q)}`)}})}M.toService=x;function ee(te){return te[0]==="o"&&te[1]==="n"&&b.isUpperAsciiLetter(te.charCodeAt(2))}function re(te){return/^onDynamic/.test(te)&&b.isUpperAsciiLetter(te.charCodeAt(9))}})($=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const V=M.toString();if(V!=="[object Object]")return V}return M}function X(M){return Array.isArray(M)?M.map(H):H(M)}function ie(M,V,x,ee,re,te,U){U=X(U);const B=z[re],W=B[ee%B.length];let q=[`%c[${M}]%c[${String(V).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(te)?(q=q.concat(U),q.push(")")):q.push(U),console.log.apply(console,q)}class G{constructor(V,x){this.d=V,this.f=x,this.a=0,this.b=0}logOutgoing(V,x,ee,re,te){this.b+=V,ie(this.d,this.b,V,x,ee,re,te)}logIncoming(V,x,ee,re,te){this.a+=V,ie(this.f,this.a,V,x,ee,re,te)}}e.IPCLogger=G}),define(oe[149],ae([0,1,17,3,39]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(P){this.a=P,this.onMessage=i.Event.fromDOMEventEmitter(this.a,"message",S=>k.VSBuffer.wrap(S.data)),P.start()}send(P){this.a.postMessage(P.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class O extends D.IPCClient{constructor(P,S){const E=new A(P);super(E,S),this.b=E}dispose(){this.b.disconnect()}}e.Client=O}),define(oe[93],ae([0,1,6,17,3,2,39]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(C){C.Created="created",C.Read="read",C.Write="write",C.Open="open",C.Error="error",C.Close="close",C.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",C.NodeEndReceived="nodeEndReceived",C.NodeEndSent="nodeEndSent",C.NodeDrainBegin="nodeDrainBegin",C.NodeDrainEnd="nodeDrainEnd",C.zlibInflateError="zlibInflateError",C.zlibInflateData="zlibInflateData",C.zlibInflateInitialWrite="zlibInflateInitialWrite",C.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",C.zlibInflateWrite="zlibInflateWrite",C.zlibInflateFlushFired="zlibInflateFlushFired",C.zlibDeflateError="zlibDeflateError",C.zlibDeflateData="zlibDeflateData",C.zlibDeflateWrite="zlibDeflateWrite",C.zlibDeflateFlushFired="zlibDeflateFlushFired",C.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",C.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",C.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",C.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",C.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",C.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",C.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",C.ProtocolHeaderRead="protocolHeaderRead",C.ProtocolMessageRead="protocolMessageRead",C.ProtocolHeaderWrite="protocolHeaderWrite",C.ProtocolMessageWrite="protocolMessageWrite",C.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(C){C.enableDiagnostics=!1,C.records=[];const T=new WeakMap;let N=0;function F(L,$){if(!T.has(L)){const z=String(++N);T.set(L,z)}return T.get(L)}function j(L,$,z,H){if(!C.enableDiagnostics)return;const X=F(L,$);if(H instanceof i.VSBuffer||H instanceof Uint8Array||H instanceof ArrayBuffer||ArrayBuffer.isView(H)){const ie=i.VSBuffer.alloc(H.byteLength);ie.set(H),C.records.push({timestamp:Date.now(),id:X,label:$,type:z,buff:ie})}else C.records.push({timestamp:Date.now(),id:X,label:$,type:z,data:H})}C.traceSocketEvent=j})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(C){C[C.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",C[C.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function b(){return E||(E=i.VSBuffer.alloc(0)),E}class g{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,N){if(T===0)return b();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const $=this.a[0];return N&&(this.a.shift(),this.b-=T),$}if(this.a[0].byteLength>T){const $=this.a[0].slice(0,T);return N&&(this.a[0]=this.a[0].slice(T),this.b-=T),$}const F=i.VSBuffer.alloc(T);let j=0,L=0;for(;T>0;){const $=this.a[L];if($.byteLength>T){const z=$.slice(0,T);F.set(z,j),j+=T,N&&(this.a[L]=$.slice(T),this.b-=T),T-=T}else F.set($,j),j+=$.byteLength,N?(this.a.shift(),this.b-=$.byteLength):L++,T-=$.byteLength}return F}}e.ChunkStream=g;var m;(function(C){C[C.None=0]="None",C[C.Regular=1]="Regular",C[C.Control=2]="Control",C[C.Ack=3]="Ack",C[C.Disconnect=5]="Disconnect",C[C.ReplayRequest=6]="ReplayRequest",C[C.Pause=7]="Pause",C[C.Resume=8]="Resume",C[C.KeepAlive=9]="KeepAlive",C[C.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",C[C.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(m||(m={}));function h(C){switch(C){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var y;(function(C){C[C.HeaderLength=13]="HeaderLength",C[C.AcknowledgeTime=2e3]="AcknowledgeTime",C[C.TimeoutTime=2e4]="TimeoutTime",C[C.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",C[C.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",C[C.KeepAliveSendTime=5e3]="KeepAliveSendTime",C[C.LatencySampleTime=6e4]="LatencySampleTime",C[C.LatencySampleCount=5]="LatencySampleCount",C[C.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",C[C.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(T,N,F,j){this.type=T,this.id=N,this.ack=F,this.data=j,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends A.Disposable{constructor(T){super(),this.f=this.B(new D.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new g,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const F=this.g.messageType,j=this.g.id,L=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new f(F,j,L,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=i.VSBuffer.alloc(13);N.writeUInt8(T.type,0),N.writeUInt32BE(T.id,1),N.writeUInt32BE(T.ack,5),N.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(N,T.data)}g(T,N){const F=this.f===0;return this.d.push(T,N),this.f+=T.byteLength+N.byteLength,F}h(){const T=i.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,N){this.g(T,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class p extends A.Disposable{constructor(T){super(),this.f=new D.Emitter,this.onMessage=this.f.event,this.g=new D.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.B(new d(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new f(1,0,0,T))}}e.Protocol=p;class w extends O.IPCClient{static fromSocket(T,N){return new w(new p(T),N)}get onDidDispose(){return this.b.onDidDispose}constructor(T,N,F=null){super(T,N,F),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=w;class I{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=I;class n{constructor(T){this.data=T,this.next=null}}class c{constructor(){this.a=null,this.b=null}length(){let T=0,N=this.a;for(;N;)N=N.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let N=0,F=this.a;for(;F;)T[N++]=F.data,F=F.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const N=new n(T);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const T=Date.now();for(let N=0;N<t.a;N++)this.c[N]=T-1e3*N;setInterval(()=>{for(let N=t.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),N=(1+t.a)*1e3;let F=0;for(let j=0;j<t.a;j++)T-this.c[j]<=N&&F++;return 1-F/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var s;(function(C){C[C.Good=0]="Good",C[C.Poor=1]="Poor"})(s=e.ConnectionHealth||(e.ConnectionHealth={}));function o(C){switch(C){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class a{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=a;class r{constructor(T,N){this.roundTripTime=T,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=r;class u{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new I,this.onControlMessage=this.x.event,this.y=new I,this.onMessage=this.y.event,this.z=new I,this.onDidDispose=this.z.event,this.A=new I,this.onSocketClose=this.A.event,this.B=new I,this.onSocketTimeout=this.B.event,this.C=new I,this.onHighRoundTripTime=this.C.event,this.D=new I,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??t.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new c,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new A.DisposableStore,this.o=T.socket,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new v),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new f(5,0,0,b());this.p.write(T),this.p.flush()}sendPause(){const T=new f(7,0,0,b());this.p.write(T)}sendResume(){const T=new f(8,0,0,b());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,N){this.a=!0,this.t.dispose(),this.t=new A.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new v),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new f(3,0,this.h,b());this.p.write(T);const N=this.b.toArray();for(let F=0,j=N.length;F<j;F++)this.p.write(N[F]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const N=this.b.peek();if(N&&N.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new f(6,0,0,b())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let F=0,j=N.length;F<j;F++)this.p.write(N[F]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const N=++this.c;this.h=this.g;const F=new f(1,N,this.h,T);this.b.push(F),this.a||(this.p.write(F),this.G())}sendControl(T){const N=new f(2,0,0,T);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),N=Date.now()-T.writtenTime,F=Date.now()-this.q.lastReadTime,j=Date.now()-this.n;if(N>=2e4&&F>=2e4&&j>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:F});return}const L=Math.max(2e4-N,2e4-F,2e4-j,500);this.f=setTimeout(()=>{this.f=null,this.G()},L)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new f(3,0,this.h,b());this.p.write(T)}I(){this.h=this.g;const T=new f(9,0,this.h,b());this.p.write(T)}J(T){this.h=this.g;const N=new f(10,0,this.h,T);this.p.write(N)}K(T){this.h=this.g;const N=new f(11,0,this.h,T);this.p.write(N)}}e.PersistentProtocol=u;class v extends A.Disposable{constructor(){super(),this.a=this.B(new D.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new D.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new D.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new k.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,N=i.VSBuffer.alloc(4);N.writeUInt32BE(T,0),this.a.fire(N)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const N=T.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const F=Date.now()-this.g,j=this.k++;this.j[j%this.j.length]=F;const L=this.l,$=this.j.filter(z=>z>=1e3).length;this.l=$>=3?1:0,F>1e3&&this.b.fire(new r(F,$)),L!==this.l&&this.c.fire(this.l)}}}),define(oe[150],ae([0,1,94,3,39,149]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class O extends D.IPCServer{static b(){const P=i.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(S,E)=>E);return i.Event.map(P,S=>{const{port1:E,port2:b}=new MessageChannel,m={protocol:new A.Protocol(E),onDidClientDisconnect:i.Event.fromDOMEventEmitter(E,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[b]),m})}constructor(){super(O.b())}}e.Server=O}),define(oe[68],ae([0,1,50,6,17,23,143,7,3,2,32,92,87,39]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends m.ChannelServer{constructor(l){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",d=>D.VSBuffer.wrap(Buffer.from(d,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=h;class y{constructor(l,d){this.i=l,this.j=d,this.c=new Set,this.g=new Map,this.h=new P.Emitter,this.onDidProcessExit=this.h.event;const p=d&&d.timeout?d.timeout:6e4;this.b=new i.Delayer(p),this.d=null,this.f=null}getChannel(l){const d=this;return{call(p,w,I){return d.k(l,p,w,I)},listen(p,w){return d.l(l,p,w)}}}k(l,d,p,w=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(R.canceled());this.b.cancel();const I=this.n(l),n=(0,i.createCancelablePromise)(s=>I.call(d,p,s)),c=w.onCancellationRequested(()=>n.cancel()),t=(0,S.toDisposable)(()=>n.cancel());return this.c.add(t),n.finally(()=>{c.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(l,d,p){if(!this.b)return P.Event.None;this.b.cancel();let w;const I=new P.Emitter({onWillAddFirstListener:()=>{w=this.n(l).listen(d,p)(I.fire,I),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return I.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,g.removeDangerousEnvVariables)(d.env),this.d=(0,k.fork)(this.i,l,d);const p=new P.Emitter;P.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,O.isRemoteConsoleLog)(o)){(0,O.log)(o,`IPC Library: ${this.j.serverName}`);return}p.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const I=this.j.useQueue?(0,b.createQueuedSender)(this.d):this.d,n=o=>this.d&&this.d.connected&&I.send(o.buffer.toString("base64")),c=p.event,t={send:n,onMessage:c};this.f=new m.ChannelClient(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,a)=>{process.removeListener("exit",s),this.c.forEach(r=>(0,S.dispose)(r)),this.c.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:a})})}return this.f}n(l){let d=this.g.get(l);return d||(d=this.m.getChannel(l),this.g.set(l,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=y}),define(oe[151],ae([0,1,17,7,3,2,12,5,31,39,93]),function(Z,e,k,i,D,A,O,R,P,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class g{traceSocketEvent(r,u){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,r,u)}constructor(r,u=""){this.f=!0,this.debugLabel=u,this.socket=r,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=v=>{if(this.traceSocketEvent("error",{code:v?.code,message:v?.message}),v){if(v.code==="EPIPE")return;(0,i.onUnexpectedError)(v)}},this.socket.on("error",this.a),this.b=v=>{this.traceSocketEvent("close",{hadError:v}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(r){const u=v=>{this.traceSocketEvent("read",v),r(k.VSBuffer.wrap(v))};return this.socket.on("data",u),{dispose:()=>this.socket.off("data",u)}}onClose(r){const u=v=>{r({type:0,hadError:v,error:void 0})};return this.socket.on("close",u),{dispose:()=>this.socket.off("close",u)}}onEnd(r){const u=()=>{r()};return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(r){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",r),this.socket.write(r.buffer,u=>{if(u){if(u.code==="EPIPE")return;(0,i.onUnexpectedError)(u)}})}catch(u){if(u.code==="EPIPE")return;(0,i.onUnexpectedError)(u)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((r,u)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),r();return}const v=()=>{this.socket.off("close",v),this.socket.off("end",v),this.socket.off("error",v),this.socket.off("timeout",v),this.socket.off("drain",v),this.traceSocketEvent("nodeDrainEnd"),r()};this.socket.on("close",v),this.socket.on("end",v),this.socket.on("error",v),this.socket.on("timeout",v),this.socket.on("drain",v)})}}e.NodeSocket=g;var m;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var h;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(h||(h={}));class y extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(r,u){this.socket.traceSocketEvent(r,u)}constructor(r,u,v,C){super(),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=r,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:u,inflateBytesLength:v?.byteLength||0,recordInflateBytes:C}),this.a=this.B(new f(this,u,v,C,this.f,(T,N)=>this.k(T,N))),this.B(this.a.onError(T=>{console.error(T),(0,i.onUnexpectedError)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new E.ChunkStream,this.B(this.socket.onData(T=>this.l(T))),this.B(this.socket.onClose(T=>this.g.fire(T)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(r){return this.f.event(r)}onClose(r){return this.g.event(r)}onEnd(r){return this.socket.onEnd(r)}write(r){this.a.writeMessage(r)}k(r,u){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",r);let v=2;r.byteLength<126?v+=0:r.byteLength<2**16?v+=2:v+=8;const C=k.VSBuffer.alloc(v);if(u?C.writeUInt8(194,0):C.writeUInt8(130,0),r.byteLength<126)C.writeUInt8(r.byteLength,1);else if(r.byteLength<2**16){C.writeUInt8(126,1);let T=1;C.writeUInt8(r.byteLength>>>8&255,++T),C.writeUInt8(r.byteLength>>>0&255,++T)}else{C.writeUInt8(127,1);let T=1;C.writeUInt8(0,++T),C.writeUInt8(0,++T),C.writeUInt8(0,++T),C.writeUInt8(0,++T),C.writeUInt8(r.byteLength>>>24&255,++T),C.writeUInt8(r.byteLength>>>16&255,++T),C.writeUInt8(r.byteLength>>>8&255,++T),C.writeUInt8(r.byteLength>>>0&255,++T)}this.socket.write(k.VSBuffer.concat([C,r]))}end(){this.h=!0,this.socket.end()}l(r){if(r.byteLength!==0){for(this.b.acceptChunk(r);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const u=this.b.peek(this.j.readLen),v=u.readUInt8(0),C=(v&128)>>>7,T=(v&64)>>>6,N=u.readUInt8(1),F=(N&128)>>>7,j=N&127;this.j.state=2,this.j.readLen=2+(F?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=C,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(T)),this.j.firstFrameOfMessage=Boolean(C),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const u=this.b.read(this.j.readLen),v=u.readUInt8(1),C=(v&128)>>>7;let T=v&127,N=1;T===126?T=u.readUInt8(++N)*2**8+u.readUInt8(++N):T===127&&(T=u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*0+u.readUInt8(++N)*2**24+u.readUInt8(++N)*2**16+u.readUInt8(++N)*2**8+u.readUInt8(++N));let F=0;C&&(F=u.readUInt8(++N)*2**24+u.readUInt8(++N)*2**16+u.readUInt8(++N)*2**8+u.readUInt8(++N)),this.j.state=3,this.j.readLen=T,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const u=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",u),p(u,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",u),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(u,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await D.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class f extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(r,u,v,C,T,N){super(),this.k=r,this.l=T,this.m=N,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new D.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,u?(this.b=this.B(new l(this.k,C,v,{windowBits:15})),this.f=this.B(new d(this.k,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(r){this.g.push(r),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const r=this.g.shift();if(this.f){const u=await this.r(this.f,r);this.m(u,!0)}else this.m(r,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(r,u){return new Promise((v,C)=>{r.write(u),r.flush(T=>v(T))})}acceptFrame(r,u,v){this.h.push({data:r,isCompressed:u,isLastFrameOfMessage:v}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const r=this.h.shift();if(this.b&&r.isCompressed){const u=await this.u(this.b,r.data,r.isLastFrameOfMessage);this.l.fire(u)}else this.l.fire(r.data)}this.s=!1}}u(r,u,v){return new Promise((C,T)=>{r.write(u),v&&r.write(k.VSBuffer.fromByteArray([0,0,255,255])),r.flush(N=>C(N))})}}class l extends A.Disposable{get recordedInflateBytes(){return this.j?k.VSBuffer.concat(this.f):k.VSBuffer.alloc(0)}constructor(r,u,v,C){super(),this.h=r,this.j=u,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=b().zlib.createInflateRaw(C),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(k.VSBuffer.wrap(T))}),v&&(this.h.traceSocketEvent("zlibInflateInitialWrite",v.buffer),this.b.write(v.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(r){this.j&&this.f.push(r.clone()),this.h.traceSocketEvent("zlibInflateWrite",r),this.b.write(r.buffer)}flush(r){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const u=k.VSBuffer.concat(this.g);this.g.length=0,r(u)})}}class d extends A.Disposable{constructor(r,u){super(),this.g=r,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.b=b().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",v=>{this.g.traceSocketEvent("zlibDeflateError",{message:v?.message,code:v?.code}),this.a.fire(v)}),this.b.on("data",v=>{this.g.traceSocketEvent("zlibDeflateData",v),this.f.push(k.VSBuffer.wrap(v))})}write(r){this.g.traceSocketEvent("zlibDeflateWrite",r.buffer),this.b.write(r.buffer)}flush(r){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let u=k.VSBuffer.concat(this.f);this.f.length=0,u=u.slice(0,u.byteLength-4),r(u)})}}function p(a,r){if(r===0)return;const u=a.byteLength>>>2;for(let j=0;j<u;j++){const L=a.readUInt32BE(j*4);a.writeUInt32BE(L^r,j*4)}const v=u*4,C=a.byteLength-v,T=r>>>24&255,N=r>>>16&255,F=r>>>8&255;C>=1&&a.writeUInt8(a.readUInt8(v)^T,v),C>=2&&a.writeUInt8(a.readUInt8(v+1)^N,v+1),C>=3&&a.writeUInt8(a.readUInt8(v+2)^F,v+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const w={[2]:107,[1]:103};function I(){const a=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let r;return e.XDG_RUNTIME_DIR?r=(0,O.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):r=(0,O.join)(b().os.tmpdir(),`vscode-ipc-${a}.sock`),c(r),r}e.createRandomIPCHandle=I;function n(a,r,u){const v=b().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${v}-${u}-${r}-sock`;let C;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?C=(0,O.join)(e.XDG_RUNTIME_DIR,`vscode-${v.substr(0,8)}-${u}-${r}.sock`):C=(0,O.join)(a,`${u}-${r}.sock`),c(C),C}e.createStaticIPCHandle=n;function c(a){const r=w[R.platform];typeof r=="number"&&a.length>=r&&console.warn(`WARNING: IPC handle "${a}" is longer than ${r} chars, try a shorter --user-data-dir`)}class t extends S.IPCServer{static b(r){const u=D.Event.fromNodeEventEmitter(r,"connection");return D.Event.map(u,v=>({protocol:new E.Protocol(new g(v,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(v,"close"))}))}constructor(r){super(t.b(r)),this.d=r}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function s(a){return new Promise((r,u)=>{const v=b().net.createServer();v.on("error",u),v.listen(a,()=>{v.removeListener("error",u),r(new t(v))})})}e.serve=s;function o(a,r){return new Promise((u,v)=>{const C=b().net.createConnection(a,()=>{C.removeListener("error",v),u(E.Client.fromSocket(new g(C,`ipc-client${r}`),r))});C.once("error",v)})}e.connect=o}),define(oe[69],ae([0,1,6,3,2,13]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var O;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O=e.StorageHint||(e.StorageHint={}));function R(b){const g=b;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var P;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(P=e.StorageState||(e.StorageState={}));class S extends D.Disposable{constructor(g,m=Object.create(null)){super(),this.m=g,this.n=m,this.b=this.B(new i.Emitter),this.onDidChangeStorage=this.b.event,this.c=P.None,this.f=new Map,this.g=new k.ThrottledDelayer(S.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(g=>this.r(g)))}r(g){g.changed?.forEach((m,h)=>this.s(h,m)),g.deleted?.forEach(m=>this.s(m,void 0))}s(g,m){if(this.c===P.Closed)return;let h=!1;(0,A.isUndefinedOrNull)(m)?h=this.f.delete(g):this.f.get(g)!==m&&(this.f.set(g,m),h=!0),h&&this.b.fire(g)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===P.None&&(this.c=P.Initialized,this.n.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(g,m){const h=this.f.get(g);return(0,A.isUndefinedOrNull)(h)?m:h}getBoolean(g,m){const h=this.get(g);return(0,A.isUndefinedOrNull)(h)?m:h==="true"}getNumber(g,m){const h=this.get(g);return(0,A.isUndefinedOrNull)(h)?m:parseInt(h,10)}async set(g,m){if(this.c===P.Closed)return;if((0,A.isUndefinedOrNull)(m))return this.delete(g);const h=String(m);if(this.f.get(g)!==h)return this.f.set(g,h),this.j.set(g,h),this.h.delete(g),this.b.fire(g),this.w()}async delete(g){if(!(this.c===P.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire(g),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=P.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(g).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(g){if(!!this.u)return this.w(g)}async w(g){return this.g.trigger(()=>this.v(),g)}async whenFlushed(){if(!!this.u)return new Promise(g=>this.l.push(g))}isInMemory(){return this.n.hint===O.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=S,S.a=100;class E{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((m,h)=>this.a.set(h,m)),g.delete?.forEach(m=>this.a.delete(m))}async close(){}}e.InMemoryStorageDatabase=E}),define(oe[152],ae([10,11]),function(Z,e){return Z.create("vs/base/node/zip",e)}),define(oe[153],ae([10,11]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[154],ae([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argv",e)}),define(oe[155],ae([10,11]),function(Z,e){return Z.create("vs/platform/environment/node/argvHelper",e)}),define(oe[156],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[157],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[158],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[159],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[160],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(oe[161],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[162],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[163],ae([10,11]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[164],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/common/fileService",e)}),define(oe[165],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(oe[166],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/common/io",e)}),define(oe[167],ae([10,11]),function(Z,e){return Z.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[168],ae([10,11]),function(Z,e){return Z.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[169],ae([10,11]),function(Z,e){return Z.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(oe[170],ae([10,11]),function(Z,e){return Z.create("vs/platform/request/common/request",e)}),define(oe[171],ae([10,11]),function(Z,e){return Z.create("vs/platform/shell/node/shellEnv",e)}),define(oe[172],ae([10,11]),function(Z,e){return Z.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[173],ae([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[174],ae([10,11]),function(Z,e){return Z.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[175],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[176],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[177],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[178],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[179],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[180],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[181],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[182],ae([10,11]),function(Z,e){return Z.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[183],ae([10,11]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(oe[95],ae([0,1,65,63,24,12,36,22,8]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,A.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return P.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.b.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return P.URI.file((0,A.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(P.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=O.env.VSCODE_PORTABLE;return h?P.URI.file((0,A.join)(h,"argv.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,A.resolve)(h):(0,A.normalize)((0,A.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?P.URI.file((0,A.resolve)(h)):P.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,A.resolve)(h);const y=O.env.VSCODE_EXTENSIONS;if(y)return y;const f=O.env.VSCODE_PORTABLE;return f?(0,A.join)(f,"extensions"):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(y=>/^[^:/?#]+?:\/\//.test(y)?P.URI.parse(y):P.URI.file((0,A.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file((0,A.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const y of this.args.log||[]){const f=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);f&&f[1]&&f[2]&&h.push([f[1],f[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return P.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=O.env.VSCODE_PORTABLE;return h?P.URI.file((0,A.join)(h,"policy.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,y,f){this.a=h,this.b=y,this.c=f,this.editSessionId=this.args.editSessionId}}ye([i.memoize],S.prototype,"appRoot",null),ye([i.memoize],S.prototype,"userHome",null),ye([i.memoize],S.prototype,"userDataPath",null),ye([i.memoize],S.prototype,"appSettingsHome",null),ye([i.memoize],S.prototype,"tmpDir",null),ye([i.memoize],S.prototype,"cacheHome",null),ye([i.memoize],S.prototype,"stateResource",null),ye([i.memoize],S.prototype,"userRoamingDataHome",null),ye([i.memoize],S.prototype,"userDataSyncHome",null),ye([i.memoize],S.prototype,"userDataSyncLogResource",null),ye([i.memoize],S.prototype,"editSessionsLogResource",null),ye([i.memoize],S.prototype,"sync",null),ye([i.memoize],S.prototype,"machineSettingsResource",null),ye([i.memoize],S.prototype,"workspaceStorageHome",null),ye([i.memoize],S.prototype,"localHistoryHome",null),ye([i.memoize],S.prototype,"keyboardLayoutResource",null),ye([i.memoize],S.prototype,"argvResource",null),ye([i.memoize],S.prototype,"isExtensionDevelopment",null),ye([i.memoize],S.prototype,"untitledWorkspacesHome",null),ye([i.memoize],S.prototype,"installSourcePath",null),ye([i.memoize],S.prototype,"builtinExtensionsPath",null),ye([i.memoize],S.prototype,"extensionsPath",null),ye([i.memoize],S.prototype,"extensionDevelopmentLocationURI",null),ye([i.memoize],S.prototype,"extensionDevelopmentKind",null),ye([i.memoize],S.prototype,"extensionTestsLocationURI",null),ye([i.memoize],S.prototype,"debugExtensionHost",null),ye([i.memoize],S.prototype,"logLevel",null),ye([i.memoize],S.prototype,"extensionLogLevel",null),ye([i.memoize],S.prototype,"serviceMachineIdResource",null),ye([i.memoize],S.prototype,"telemetryLogResource",null),ye([i.memoize],S.prototype,"disableWorkspaceTrust",null),ye([i.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function E(m,h){return g(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId,m.extensionEnvironment)}e.parseExtensionHostPort=E;function b(m,h){return g(m["inspect-ptyhost"],m["inspect-brk-ptyhost"],5877,h,m.extensionEnvironment)}e.parsePtyHostPort=b;function g(m,h,y,f,l,d){const w=Number(h||m)||(f?null:y),I=w?Boolean(!!h):!1;let n;if(d)try{n=JSON.parse(d)}catch{}return{port:w,break:I,debugId:l,env:n}}}),define(oe[184],ae([0,1,285,5,154]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,D.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},category:{type:"string",cat:"e",description:(0,D.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,D.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,D.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(y,f,l=O){const d=y.find(a=>a.length>0&&a[0]!=="-"),p={},w=["_"],I=[],n={};let c;for(const a in f){const r=f[a];r.type==="subcommand"?a===d&&(c=r):(r.alias&&(p[a]=r.alias),r.type==="string"||r.type==="string[]"?(w.push(a),r.deprecates&&w.push(...r.deprecates)):r.type==="boolean"&&(I.push(a),r.deprecates&&I.push(...r.deprecates)),r.global&&(n[a]=r))}if(c&&d){const a=n;for(const C in c.options)a[C]=c.options[C];const r=y.filter(C=>C!==d),u=l.getSubcommandReporter?l.getSubcommandReporter(d):void 0,v=R(r,a,u);return{[d]:v,_:[]}}const t=k(y,{string:w,boolean:I,alias:p}),s={},o=t;s._=t._.map(a=>String(a)).filter(a=>a.length>0),delete o._;for(const a in f){const r=f[a];if(r.type==="subcommand")continue;r.alias&&delete o[r.alias];let u=o[a];if(r.deprecates)for(const v of r.deprecates)o.hasOwnProperty(v)&&(u||(u=o[v],u&&l.onDeprecatedOption(v,r.deprecationMessage||(0,D.localize)(36,null,a))),delete o[v]);if(typeof u<"u"){if(r.type==="string[]"){if(Array.isArray(u)||(u=[u]),!r.allowEmptyValue){const v=u.filter(C=>C.length>0);v.length!==u.length&&(l.onEmptyValue(a),u=v.length>0?v:void 0)}}else r.type==="string"&&(Array.isArray(u)?(u=u.pop(),l.onMultipleValues(a,u)):!u&&!r.allowEmptyValue&&(l.onEmptyValue(a),u=void 0));s[a]=u,r.deprecationMessage&&l.onDeprecatedOption(a,r.deprecationMessage)}delete o[a]}for(const a in o)l.onUnknownOption(a);return s}e.parseArgs=R;function P(y,f){let l="";return f.args&&(Array.isArray(f.args)?l=` <${f.args.join("> <")}>`:l=` <${f.args}>`),f.alias?`-${f.alias} --${y}${l}`:`--${y}${l}`}function S(y,f){const l=[];for(const d in y){const p=y[d],w=P(d,p);l.push([w,p.description])}return E(l,f)}e.formatOptions=S;function E(y,f){const d=y.reduce((I,n)=>Math.max(I,n[0].length),12)+2+1;if(f-d<25)return y.reduce((I,n)=>I.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const p=f-d-1,w=[];for(const I of y){const n=I[0],c=g(I[1],p),t=b(d-n.length-2);w.push("  "+n+t+c[0]);for(let s=1;s<c.length;s++)w.push(b(d)+c[s])}return w}function b(y){return" ".repeat(y)}function g(y,f){const l=[];for(;y.length;){const d=y.length<f?y.length:y.lastIndexOf(" ",f),p=y.slice(0,d).trim();y=y.slice(d),l.push(p)}return l}function m(y,f,l,d,p){const w=process.stdout.isTTY&&process.stdout.columns||80,I=p?.noInputFiles!==!0?`[${(0,D.localize)(37,null)}...]`:"",n=[`${y} ${l}`];n.push(""),n.push(`${(0,D.localize)(38,null)}: ${f} [${(0,D.localize)(39,null)}]${I}`),n.push(""),p?.noPipe!==!0&&(i.isWindows?n.push((0,D.localize)(40,null,f)):n.push((0,D.localize)(41,null,f)),n.push(""));const c={},t=[];for(const s in d){const o=d[s];if(o.type==="subcommand")o.description&&t.push({command:s,description:o.description});else if(o.description&&o.cat){let a=c[o.cat];a||(c[o.cat]=a={}),a[s]=o}}for(const s in c){const o=s,a=c[o];a&&(n.push(A[o]),n.push(...S(a,w)),n.push(""))}return t.length&&(n.push((0,D.localize)(42,null)),n.push(...E(t.map(s=>[s.command,s.description]),w)),n.push("")),n.join(`
`)}e.buildHelpMessage=m;function h(y,f){return`${y||(0,D.localize)(43,null)}
${f||(0,D.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=h}),define(oe[185],ae([0,1,286,155,184]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function O(g,m){const h=(w,I)=>{console.warn((0,i.localize)(0,null,w,I))},y=w=>{console.warn((0,i.localize)(1,null,w))},f=(w,I)=>{console.warn((0,i.localize)(2,null,w,I))},l=w=>({onUnknownOption:I=>{w!=="tunnel"&&console.warn((0,i.localize)(3,null,I,w))},onMultipleValues:h,onEmptyValue:y,onDeprecatedOption:f,getSubcommandReporter:w!=="tunnel"?l:void 0}),d={onUnknownOption:w=>{console.warn((0,i.localize)(4,null,w))},onMultipleValues:h,onEmptyValue:y,onDeprecatedOption:f,getSubcommandReporter:l},p=(0,D.parseArgs)(g,D.OPTIONS,m?d:void 0);return p.goto&&p._.forEach(w=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,i.localize)(5,null))),p["max-memory"]&&k(parseInt(p["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),p}function R(g){const m=g.findIndex(h=>!/^-/.test(h));if(m>-1)return[...g.slice(0,m),...g.slice(m+1)]}function P(g){let[,...m]=g;process.env.VSCODE_DEV&&(m=R(m)||[]);const h=!b(process.env);return O(m,h)}e.parseMainProcessArgv=P;function S(g){let[,,...m]=g;return process.env.VSCODE_DEV&&(m=R(m)||[]),O(m,!0)}e.parseCLIProcessArgv=S;function E(g,...m){const h=g.indexOf("--");return h===-1?g.push(...m):g.splice(h,0,...m),g}e.addArg=E;function b(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function Z(e,k,i){function D(O,R){const P=A(O,R),S=[P];return e.isAbsolute(P)||S.unshift(i),e.resolve(...S)}function A(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,R);const E=O["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(b,"AppData","Roaming")}break;case"darwin":S=e.join(k.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,R)}return{getUserDataPath:D}}if(typeof define=="function")define(oe[186],ae([287,34,36]),function(e,k,i){return Z(e,k,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=Z(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[187],ae([0,1,34,95,186]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends i.AbstractNativeEnvironmentService{constructor(R,P){super(R,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,D.getUserDataPath)(R,P.nameShort)},P)}}e.NativeEnvironmentService=A}),define(oe[188],ae([0,1,8]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,O=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,P=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(f){const l=f.match(O);return l?l[1]:null}function E(f){if(f.indexOf("://")===-1){const l=f.match(i);return l?S(l[2]):null}try{const l=k.URI.parse(f);if(l.authority)return S(l.authority)}catch{}return null}function b(f,l){const d=new Set;let p;for(;p=R.exec(f);){const I=E(p[1]);I&&d.add(I)}const w=new Set(l);return Array.from(d).map(I=>w.has(I)?I:I.replace(P,"a"))}e.getDomainsOfRemotes=b;function g(f){const l=f.match(A);return l?l[2]:null}function m(f,l,d){return f&&l?(d&&l.endsWith(".git")&&(l=l.substr(0,l.length-4)),l.indexOf("/")===0?`${f}${l}`:`${f}/${l}`):null}function h(f,l){if(f.indexOf("://")===-1){const d=f.match(D);if(d)return m(d[2],d[3],l)}try{const d=k.URI.parse(f);if(d.authority)return m(g(d.authority),d.path,l)}catch{}return null}function y(f,l=!1){const d=[];let p;for(;p=R.exec(f);){const w=h(p[1],l);w&&d.push(w)}return d}e.getRemotes=y}),define(oe[189],ae([0,1,13,158]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(O,R,P){try{A(O,R,P)}catch(S){console.error(S?.message??S)}return O}e.localizeManifest=D;function A(O,R,P){const S=(E,b,g)=>{const m=E[b];if((0,k.isString)(m)){const h=m,y=h.length;if(y>1&&h[0]==="%"&&h[y-1]==="%"){const f=h.substr(1,y-2);let l=R[f];l===void 0&&P&&(l=P[f]);const d=typeof l=="string"?l:l?.message,p=P?.[f],w=typeof p=="string"?p:p?.message;if(!d){w||console.warn(`[${O.name}]: ${(0,i.localize)(0,null,f)}`);return}if(g&&(b==="title"||b==="category")&&w&&w!==d){const I={value:d,original:w};E[b]=I}else E[b]=d}}else if((0,k.isObject)(m))for(const h in m)m.hasOwnProperty(h)&&(h==="commands"?S(m,h,!0):S(m,h,g));else if(Array.isArray(m))for(let h=0;h<m.length;h++)S(m,h,g)};for(const E in O)O.hasOwnProperty(E)&&S(O,E)}}),define(oe[190],ae([0,1,7]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class i{constructor(){this.a=new Map}register(A,O){this.a.set(A,O)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const O in A.contributes){const R=this.a.get(O);if(!R)continue;const P=A.contributes[O],S=Array.isArray(P)?P:[P];try{R(S,A.activationEvents)}catch(E){(0,k.onUnexpectedError)(E)}}}}e.ImplicitActivationEventsImpl=i,e.ImplicitActivationEvents=new i}),define(oe[191],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,O,R,P){return this.a.call("promptImportantExtensionsInstallNotification",[A,O,R,P])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class i{constructor(A){this.a=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${O}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(oe[70],ae([0,1,22,89,163,54]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function P(l){return l=l.trim(),l==="*"||O.test(l)}e.isValidVersionStr=P;function S(l){if(!P(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=l.match(O);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=S;function E(l){if(!l)return null;const d=l.majorBase,p=l.majorMustEqual,w=l.minorBase;let I=l.minorMustEqual;const n=l.patchBase;let c=l.patchMustEqual;l.hasCaret&&(d===0||(I=!1),c=!1);let t=0;if(l.preRelease){const s=R.exec(l.preRelease);if(s){const[,o,a,r]=s;t=Date.UTC(Number(o),Number(a)-1,Number(r))}}return{majorBase:d,majorMustEqual:p,minorBase:w,minorMustEqual:I,patchBase:n,patchMustEqual:c,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=E;function b(l,d,p){let w;typeof l=="string"?w=E(S(l)):w=l;let I;d instanceof Date?I=d.getTime():typeof d=="string"&&(I=new Date(d).getTime());let n;if(typeof p=="string"?n=E(S(p)):n=p,!w||!n)return!1;const c=w.majorBase,t=w.minorBase,s=w.patchBase;let o=n.majorBase,a=n.minorBase,r=n.patchBase;const u=n.notBefore;let v=n.majorMustEqual,C=n.minorMustEqual,T=n.patchMustEqual;return n.isMinimum?c>o?!0:c<o?!1:t>a?!0:t<a||I&&I<u?!1:s>=r:(c===1&&o===0&&(!v||!C||!T)&&(o=1,a=0,r=0,v=!0,C=!1,T=!1),c<o?!1:c>o?!v:t<a?!1:t>a?!C:s<r?!1:s>r?!T:!(I&&I<u))}e.isValidVersion=b;function g(l,d,p,w,I){const n=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return n.push([i.default.Error,D.localize(0,null)]),n;if(typeof w.name!="string")return n.push([i.default.Error,D.localize(1,null,"name")]),n;if(typeof w.version!="string")return n.push([i.default.Error,D.localize(2,null,"version")]),n;if(!w.engines)return n.push([i.default.Error,D.localize(3,null,"engines")]),n;if(typeof w.engines.vscode!="string")return n.push([i.default.Error,D.localize(4,null,"engines.vscode")]),n;if(typeof w.extensionDependencies<"u"&&!f(w.extensionDependencies))return n.push([i.default.Error,D.localize(5,null,"extensionDependencies")]),n;if(typeof w.activationEvents<"u"){if(!f(w.activationEvents))return n.push([i.default.Error,D.localize(6,null,"activationEvents")]),n;if(typeof w.main>"u"&&typeof w.browser>"u")return n.push([i.default.Error,D.localize(7,null,"activationEvents","main")]),n}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&n.push([i.default.Warning,D.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return n.push([i.default.Error,D.localize(9,null,"main")]),n;{const s=(0,k.joinPath)(p,w.main);(0,k.isEqualOrParent)(s,p)||n.push([i.default.Warning,D.localize(10,null,s.path,p.path)])}if(typeof w.activationEvents>"u")return n.push([i.default.Error,D.localize(11,null,"activationEvents","main")]),n}if(typeof w.browser<"u"){if(typeof w.browser!="string")return n.push([i.default.Error,D.localize(12,null,"browser")]),n;{const s=(0,k.joinPath)(p,w.browser);(0,k.isEqualOrParent)(s,p)||n.push([i.default.Warning,D.localize(13,null,s.path,p.path)])}if(typeof w.activationEvents>"u")return n.push([i.default.Error,D.localize(14,null,"activationEvents","browser")]),n}if(!A.valid(w.version))return n.push([i.default.Error,D.localize(15,null)]),n;const c=[];if(!m(l,d,w,I,c))for(const s of c)n.push([i.default.Error,s]);return n}e.validateExtensionManifest=g;function m(l,d,p,w,I){return w||typeof p.main>"u"&&typeof p.browser>"u"?!0:y(l,d,p.engines.vscode,I)}e.isValidExtensionVersion=m;function h(l,d,p){return l==="*"||y(d,p,l)}e.isEngineValid=h;function y(l,d,p,w=[]){const I=E(S(p));if(!I)return w.push(D.localize(16,null,p)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return w.push(D.localize(17,null,p)),!1}else if(!I.majorMustEqual)return w.push(D.localize(18,null,p)),!1;return b(l,d,I)?!0:(w.push(D.localize(19,null,l,p)),!1)}function f(l){if(!Array.isArray(l))return!1;for(let d=0,p=l.length;d<p;d++)if(typeof l[d]!="string")return!1;return!0}}),define(oe[45],ae([0,1,17,31]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(A,O,R){let P=R&&R.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const E=(await O.readFile(A.serviceMachineIdResource)).value.toString();P=(0,i.isUUID)(E)?E:null}catch{P=null}if(!P){P=(0,i.generateUuid)();try{await O.writeFile(A.serviceMachineIdResource,k.VSBuffer.fromString(P))}catch{}}return R?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=D}),define(oe[55],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(D,A=[],O=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=k}),define(oe[71],ae([0,1,55]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const i=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function A(R,P,S){P instanceof k.SyncDescriptor||(P=new k.SyncDescriptor(P,[],Boolean(S))),i.push([R,P])}e.registerSingleton=A;function O(){return i}e.getSingletonServiceDescriptors=O}),define(oe[192],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class i{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const R=this.lookupOrInsertNode(A),P=this.lookupOrInsertNode(O);R.outgoing.set(P.key,P),P.incoming.set(R.key,R)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let R=this.a.get(O);return R||(R=new k(O,A),this.a.set(O,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,R]of this.a)A.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const R=new Set([A]),P=this.c(O,R);if(P)return P}}c(A,O){for(const[R,P]of A.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const S=this.c(P,O);if(S)return S;O.delete(R)}}}e.Graph=i}),define(oe[4],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(P){return P[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(k=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function i(O,R,P){R[k.DI_TARGET]===R?R[k.DI_DEPENDENCIES].push({id:O,index:P}):(R[k.DI_DEPENDENCIES]=[{id:O,index:P}],R[k.DI_TARGET]=R)}function D(O){if(k.serviceIds.has(O))return k.serviceIds.get(O);const R=function(P,S,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(R,P,E)};return R.toString=()=>O,k.serviceIds.set(O,R),R}e.createDecorator=D;function A(O){return O}e.refineServiceDecorator=A}),define(oe[193],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(oe[16],ae([0,1,13,8,4]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof i.URI)}e.isConfigurationOverrides=A;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=O;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function S(l,d){const p=Object.create(null);for(const w in l)E(p,w,l[w],d);return p}e.toValuesTree=S;function E(l,d,p,w){const I=d.split("."),n=I.pop();let c=l;for(let t=0;t<I.length;t++){const s=I[t];let o=c[s];switch(typeof o){case"undefined":o=c[s]=Object.create(null);break;case"object":break;default:w(`Ignoring ${d} as ${I.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}c=o}if(typeof c=="object"&&c!==null)try{c[n]=p}catch{w(`Ignoring ${d} as ${I.join(".")} is ${JSON.stringify(c)}`)}else w(`Ignoring ${d} as ${I.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=E;function b(l,d){const p=d.split(".");g(l,p)}e.removeFromValueTree=b;function g(l,d){const p=d.shift();if(d.length===0){delete l[p];return}if(Object.keys(l).indexOf(p)!==-1){const w=l[p];typeof w=="object"&&!Array.isArray(w)&&(g(w,d),Object.keys(w).length===0&&delete l[p])}}function m(l,d,p){function w(c,t){let s=c;for(const o of t){if(typeof s!="object"||s===null)return;s=s[o]}return s}const I=d.split("."),n=w(l,I);return typeof n>"u"?p:n}e.getConfigurationValue=m;function h(l,d,p){Object.keys(d).forEach(w=>{w!=="__proto__"&&(w in l?k.isObject(l[w])&&k.isObject(d[w])?h(l[w],d[w],p):p&&(l[w]=d[w]):l[w]=d[w])})}e.merge=h;function y(l,d,p){const w=l.inspect(d),I=l.inspect(p);return typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:typeof I.userValue<"u"||typeof I.workspaceValue<"u"||typeof I.workspaceFolderValue<"u"?I.value:w.defaultValue}e.getMigratedSettingValue=y;function f(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(oe[194],ae([0,1,5,27,4]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",k.isMacintosh),A.set("isLinux",k.isLinux),A.set("isWindows",k.isWindows),A.set("isWeb",k.isWeb),A.set("isMacNative",k.isMacintosh&&!k.isWeb),A.set("isEdge",k.isEdge),A.set("isFirefox",k.isFirefox),A.set("isChrome",k.isChrome),A.set("isSafari",k.isSafari);const O=Object.prototype.hasOwnProperty;var R;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return b.INSTANCE}static true(){return g.INSTANCE}static has(L){return m.create(L)}static equals(L,$){return h.create(L,$)}static notEquals(L,$){return l.create(L,$)}static regex(L,$){return t.create(L,$)}static in(L,$){return y.create(L,$)}static notIn(L,$){return f.create(L,$)}static not(L){return d.create(L)}static and(...L){return a.create(L,null,!0)}static or(...L){return r.create(L,null,!0)}static greater(L,$){return w.create(L,$)}static greaterEquals(L,$){return I.create(L,$)}static smaller(L,$){return n.create(L,$)}static smallerEquals(L,$){return c.create(L,$)}static deserialize(L,$=!1){if(!!L)return this.c(L,$)}static c(L,$){const z=L.split("||");return r.create(z.map(H=>this.d(H,$)),null,!0)}static d(L,$){const z=L.split("&&");return a.create(z.map(H=>this.f(H,$)),null,!0)}static f(L,$){if(L=L.trim(),L.indexOf("!=")>=0){const z=L.split("!=");return l.create(z[0].trim(),this.g(z[1],$))}if(L.indexOf("==")>=0){const z=L.split("==");return h.create(z[0].trim(),this.g(z[1],$))}if(L.indexOf("=~")>=0){const z=L.split("=~");return t.create(z[0].trim(),this.h(z[1],$))}if(L.indexOf(" not in ")>=0){const z=L.split(" not in ");return f.create(z[0].trim(),this.g(z[1],$))}if(L.indexOf(" in ")>=0){const z=L.split(" in ");return y.create(z[0].trim(),this.g(z[1],$))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const z=L.split(">=");return I.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const z=L.split(">");return w.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const z=L.split("<=");return c.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const z=L.split("<");return n.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(L)?d.create(L.substr(1).trim()):m.create(L)}static g(L,$){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const z=/^'([^']*)'$/.exec(L);return z?z[1].trim():L}static h(L,$){if((0,i.isFalsyOrWhitespace)(L)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const z=L.indexOf("/"),H=L.lastIndexOf("/");if(z===H||z<0){if($)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const X=L.slice(z+1,H),ie=L[H+1]==="i"?"i":"";try{return new RegExp(X,ie)}catch(G){if($)throw new Error(`bad regexp-value '${L}', parse error: ${G}`);return console.warn(`bad regexp-value '${L}', parse error: ${G}`),null}}}e.ContextKeyExpr=P;function S(j,L){const $=j?j.substituteConstants():void 0,z=L?L.substituteConstants():void 0;return!$&&!z?!0:!$||!z?!1:$.equals(z)}e.expressionsAreEqualWithConstantSubstitution=S;function E(j,L){return j.cmp(L)}class b{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class g{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class m{static create(L,$=null){const z=A.get(L);return typeof z=="boolean"?z?g.INSTANCE:b.INSTANCE:new m(L,$)}constructor(L,$){this.key=L,this.c=$,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:v(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=A.get(this.key);return typeof L=="boolean"?L?g.INSTANCE:b.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=d.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=m;class h{static create(L,$,z=null){if(typeof $=="boolean")return $?m.create(L,z):d.create(L,z);const H=A.get(L);return typeof H=="boolean"?$===(H?"true":"false")?g.INSTANCE:b.INSTANCE:new h(L,$,z)}constructor(L,$,z){this.c=L,this.d=$,this.f=z,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const $=L?"true":"false";return this.d===$?g.INSTANCE:b.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class y{static create(L,$){return new y(L,$)}constructor(L,$){this.d=L,this.f=$,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:C(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const $=L.getValue(this.f),z=L.getValue(this.d);return Array.isArray($)?$.includes(z):typeof z=="string"&&typeof $=="object"&&$!==null?O.call($,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=y;class f{static create(L,$){return new f(L,$)}constructor(L,$){this.d=L,this.f=$,this.type=11,this.c=y.create(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=f;class l{static create(L,$,z=null){if(typeof $=="boolean")return $?d.create(L,z):m.create(L,z);const H=A.get(L);return typeof H=="boolean"?$===(H?"true":"false")?b.INSTANCE:g.INSTANCE:new l(L,$,z)}constructor(L,$,z){this.c=L,this.d=$,this.f=z,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const $=L?"true":"false";return this.d===$?b.INSTANCE:g.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class d{static create(L,$=null){const z=A.get(L);return typeof z=="boolean"?z?b.INSTANCE:g.INSTANCE:new d(L,$)}constructor(L,$){this.c=L,this.d=$,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:v(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=A.get(this.c);return typeof L=="boolean"?L?b.INSTANCE:g.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.ContextKeyNotExpr=d;function p(j,L){if(typeof j=="string"){const $=parseFloat(j);isNaN($)||(j=$)}return typeof j=="string"||typeof j=="number"?L(j):b.INSTANCE}class w{static create(L,$,z=null){return p($,H=>new w(L,H,z))}constructor(L,$,z){this.c=L,this.d=$,this.f=z,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=c.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=w;class I{static create(L,$,z=null){return p($,H=>new I(L,H,z))}constructor(L,$,z){this.c=L,this.d=$,this.f=z,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=I;class n{static create(L,$,z=null){return p($,H=>new n(L,H,z))}constructor(L,$,z){this.c=L,this.d=$,this.f=z,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class c{static create(L,$,z=null){return p($,H=>new c(L,H,z))}constructor(L,$,z){this.c=L,this.d=$,this.f=z,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:C(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=c;class t{static create(L,$){return new t(L,$)}constructor(L,$){this.d=L,this.f=$,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const $=this.f?this.f.source:"",z=L.f?L.f.source:"";return $<z?-1:$>z?1:0}equals(L){if(L.type===this.type){const $=this.f?this.f.source:"",z=L.f?L.f.source:"";return this.d===L.d&&$===z}return!1}substituteConstants(){return this}evaluate(L){const $=L.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=s.create(this)),this.c}}e.ContextKeyRegexExpr=t;class s{static create(L){return new s(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(L){return new s(this.c.map(L))}negate(){return this.c}}e.ContextKeyNotRegexExpr=s;function o(j){let L=null;for(let $=0,z=j.length;$<z;$++){const H=j[$].substituteConstants();if(j[$]!==H&&L===null){L=[];for(let X=0;X<$;X++)L[X]=j[X]}L!==null&&(L[$]=H)}return L===null?j:L}class a{static create(L,$,z){return a.d(L,$,z)}constructor(L,$){this.expr=L,this.c=$,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,z=this.expr.length;$<z;$++){const H=E(this.expr[$],L.expr[$]);if(H!==0)return H}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:a.create(L,this.c,!1)}evaluate(L){for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].evaluate(L))return!1;return!0}static d(L,$,z){const H=[];let X=!1;for(const ie of L)if(!!ie){if(ie.type===1){X=!0;continue}if(ie.type===0)return b.INSTANCE;if(ie.type===6){H.push(...ie.expr);continue}H.push(ie)}if(H.length===0&&X)return g.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(E);for(let ie=1;ie<H.length;ie++)H[ie-1].equals(H[ie])&&(H.splice(ie,1),ie--);if(H.length===1)return H[0];for(;H.length>1;){const ie=H[H.length-1];if(ie.type!==9)break;H.pop();const G=H.pop(),M=H.length===0,V=r.create(ie.expr.map(x=>a.create([x,G],null,z)),null,M);V&&(H.push(V),H.sort(E))}if(H.length===1)return H[0];if(z){for(let ie=0;ie<H.length;ie++)for(let G=ie+1;G<H.length;G++)if(H[ie].negate().equals(H[G]))return b.INSTANCE;if(H.length===1)return H[0]}return new a(H,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const $ of this.expr)L.push(...$.keys());return L}map(L){return new a(this.expr.map($=>$.map(L)),null)}negate(){if(!this.c){const L=[];for(const $ of this.expr)L.push($.negate());this.c=r.create(L,this,!0)}return this.c}}class r{static create(L,$,z){return r.d(L,$,z)}constructor(L,$){this.expr=L,this.c=$,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,z=this.expr.length;$<z;$++){const H=E(this.expr[$],L.expr[$]);if(H!==0)return H}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,z=this.expr.length;$<z;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:r.create(L,this.c,!1)}evaluate(L){for(let $=0,z=this.expr.length;$<z;$++)if(this.expr[$].evaluate(L))return!0;return!1}static d(L,$,z){let H=[],X=!1;if(L){for(let ie=0,G=L.length;ie<G;ie++){const M=L[ie];if(!!M){if(M.type===0){X=!0;continue}if(M.type===1)return g.INSTANCE;if(M.type===9){H=H.concat(M.expr);continue}H.push(M)}}if(H.length===0&&X)return b.INSTANCE;H.sort(E)}if(H.length!==0){if(H.length===1)return H[0];for(let ie=1;ie<H.length;ie++)H[ie-1].equals(H[ie])&&(H.splice(ie,1),ie--);if(H.length===1)return H[0];if(z){for(let ie=0;ie<H.length;ie++)for(let G=ie+1;G<H.length;G++)if(H[ie].negate().equals(H[G]))return g.INSTANCE;if(H.length===1)return H[0]}return new r(H,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const $ of this.expr)L.push(...$.keys());return L}map(L){return new r(this.expr.map($=>$.map(L)),null)}negate(){if(!this.c){const L=[];for(const $ of this.expr)L.push($.negate());for(;L.length>1;){const $=L.shift(),z=L.shift(),H=[];for(const X of F($))for(const ie of F(z))H.push(a.create([X,ie],null,!1));L.unshift(r.create(H,null,!1))}this.c=r.create(L,this,!0)}return this.c}}class u extends m{static all(){return u.d.values()}constructor(L,$,z){super(L,null),this.f=$,typeof z=="object"?u.d.push({...z,key:L}):z!==!0&&u.d.push({key:L,description:z,type:$!=null?typeof $:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return h.create(this.key,L)}notEqualsTo(L){return l.create(this.key,L)}}e.RawContextKey=u,u.d=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function v(j,L){return j<L?-1:j>L?1:0}function C(j,L,$,z){return j<$?-1:j>$?1:L<z?-1:L>z?1:0}function T(j,L){if(j.type===0||L.type===1)return!0;if(j.type===9)return L.type===9?N(j.expr,L.expr):!1;if(L.type===9){for(const $ of L.expr)if(T(j,$))return!0;return!1}if(j.type===6){if(L.type===6)return N(L.expr,j.expr);for(const $ of j.expr)if(T($,L))return!0;return!1}return j.equals(L)}e.implies=T;function N(j,L){let $=0,z=0;for(;$<j.length&&z<L.length;){const H=j[$].cmp(L[z]);if(H<0)return!1;H===0&&$++,z++}return $===j.length}function F(j){return j.type===9?j.expr:[j]}}),define(oe[96],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function i(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=i;class D{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.NullDiagnosticsService=D}),define(oe[97],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(oe[15],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[30],ae([0,1,157,4]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function O(l,d){switch(l){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function R(l,d){return d==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function P(l,d,p){return R(d,p)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===p?!0:S(p).includes(l)}e.isTargetPlatformCompatible=P;function S(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function E(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=E;var b;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var g;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var m;(function(l){l.Install="install",l.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var h;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var y;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(d,p){super(d),this.code=p,this.name=p}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(oe[195],ae([0,1,3,2,67,32,8,144,30]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(f,l){return O.URI.revive(l?l.transformIncoming(f):f)}function E(f,l){return l?l.transformOutgoingURI(f):f}function b(f,l){l=l||R.DefaultURITransformer;const d=f.manifest;return{...(0,R.transformAndReviveIncomingURIs)({...f,manifest:void 0},l),manifest:d}}function g(f,l){return l?(0,A.cloneAndChange)(f,d=>d instanceof O.URI?l.transformOutgoingURI(d):void 0):f}class m{constructor(l,d){this.a=l,this.b=d,this.onInstallExtension=k.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(l.onDidUninstallExtension,!0)}listen(l,d){const p=this.b(l);switch(d){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,w=>w.map(I=>({...I,local:I.local?g(I.local,p):I.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(l,d,p){const w=this.b(l);switch(d){case"zip":return this.a.zip(b(p[0],w)).then(I=>E(I,w));case"unzip":return this.a.unzip(S(p[0],w));case"install":return this.a.install(S(p[0],w),(0,D.revive)(p[1]));case"installFromLocation":return this.a.installFromLocation(S(p[0],w),O.URI.revive(p[1]));case"getManifest":return this.a.getManifest(S(p[0],w));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(p[0]);case"installFromGallery":return this.a.installFromGallery(p[0],(0,D.revive)(p[1]));case"uninstall":return this.a.uninstall(b(p[0],w),(0,D.revive)(p[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(b(p[0],w));case"getInstalled":return this.a.getInstalled(p[0],O.URI.revive(p[1])).then(I=>I.map(n=>g(n,w)));case"getMetadata":return this.a.getMetadata(b(p[0],w));case"updateMetadata":return this.a.updateMetadata(b(p[0],w),p[1]).then(I=>g(I,w));case"updateExtensionScope":return this.a.updateExtensionScope(b(p[0],w),p[1]).then(I=>g(I,w));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(p[0],p[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class h extends i.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}constructor(l){super(),this.j=l,this.c=this.B(new k.Emitter),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=this.B(new k.Emitter),this.B(this.j.listen("onInstallExtension")(d=>this.c.fire({identifier:d.identifier,source:this.k(d.source)?O.URI.revive(d.source):d.source,profileLocation:O.URI.revive(d.profileLocation)}))),this.B(this.j.listen("onDidInstallExtensions")(d=>this.f.fire(d.map(p=>({...p,local:p.local?b(p.local,null):p.local,source:this.k(p.source)?O.URI.revive(p.source):p.source,profileLocation:O.URI.revive(p.profileLocation)}))))),this.B(this.j.listen("onUninstallExtension")(d=>this.g.fire({identifier:d.identifier,profileLocation:O.URI.revive(d.profileLocation)}))),this.B(this.j.listen("onDidUninstallExtension")(d=>this.h.fire({...d,profileLocation:O.URI.revive(d.profileLocation)})))}k(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.l||(this.l=this.j.call("getTargetPlatform")),this.l}async canInstall(l){const d=await this.getTargetPlatform();return l.allTargetPlatforms.some(p=>(0,P.isTargetPlatformCompatible)(p,l.allTargetPlatforms,d))}zip(l){return Promise.resolve(this.j.call("zip",[l]).then(d=>O.URI.revive(d)))}unzip(l){return Promise.resolve(this.j.call("unzip",[l]))}install(l,d){return Promise.resolve(this.j.call("install",[l,d])).then(p=>b(p,null))}installFromLocation(l,d){return Promise.resolve(this.j.call("installFromLocation",[l,d])).then(p=>b(p,null))}getManifest(l){return Promise.resolve(this.j.call("getManifest",[l]))}installFromGallery(l,d){return Promise.resolve(this.j.call("installFromGallery",[l,d])).then(p=>b(p,null))}uninstall(l,d){return Promise.resolve(this.j.call("uninstall",[l,d]))}reinstallFromGallery(l){return Promise.resolve(this.j.call("reinstallFromGallery",[l])).then(d=>b(d,null))}getInstalled(l=null,d){return Promise.resolve(this.j.call("getInstalled",[l,d])).then(p=>p.map(w=>b(w,null)))}getMetadata(l){return Promise.resolve(this.j.call("getMetadata",[l]))}updateMetadata(l,d){return Promise.resolve(this.j.call("updateMetadata",[l,d])).then(p=>b(p,null))}updateExtensionScope(l,d){return Promise.resolve(this.j.call("updateExtensionScope",[l,d])).then(p=>b(p,null))}getExtensionsControlManifest(){return Promise.resolve(this.j.call("getExtensionsControlManifest"))}async download(l,d){const p=await this.j.call("download",[l,d]);return O.URI.revive(p)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class y{constructor(l){this.a=l}listen(l,d){throw new Error("Invalid listen")}call(l,d,p){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(O.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(oe[98],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class i{b(){return this.a||(this.a=new Promise((A,O)=>Z(["node-vsce-sign"],async R=>A(R),O))),this.a}async verify(A,O){let R;try{R=await this.b()}catch{return!1}return R.verify(A,O)}}e.ExtensionSignatureVerificationService=i}),define(oe[99],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function D(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[14],ae([0,1,49,12,27,13,8,165,4,5]),function(Z,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function E(M){return M.create===!0}e.isFileOpenForWriteOptions=E;var b;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var g;(function(M){M[M.Readonly=1]="Readonly"})(g=e.FilePermission||(e.FilePermission={}));var m;(function(M){M[M.None=0]="None",M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead",M[M.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=h;function y(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=y;function f(M){return!!(M.capabilities&32768)}e.hasFileCloneCapability=f;function l(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function d(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=d;function p(M){return h(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var w;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(V,x){super(V),this.code=x}}e.FileSystemProviderError=I;function n(M,V){const x=new I(M.toString(),V);return t(x,V),x}e.createFileSystemProviderError=n;function c(M){return M||n((0,R.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=c;function t(M,V){return M.name=V?`${V} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=t;function s(M){if(!M)return w.Unknown;if(M instanceof I)return M.code;const V=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!V)return w.Unknown;switch(V[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=s;function o(M){if(M instanceof T)return M.fileOperationResult;switch(s(M)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var a;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY",M[M.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class r{constructor(V,x,ee){this.resource=V,this.operation=x,this.target=ee}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var u;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class v{constructor(V,x){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ee=new Map;for(const re of V){const te=ee.get(re.type);switch(te?te.push([re.resource,re]):ee.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,te]of ee)switch(re){case 1:this.a=k.TernarySearchTree.forUris(()=>x),this.a.fill(te);break;case 0:this.b=k.TernarySearchTree.forUris(()=>x),this.b.fill(te);break;case 2:this.c=k.TernarySearchTree.forUris(()=>x),this.c.fill(te);break}}contains(V,...x){return this.d(V,{includeChildren:!1},...x)}affects(V,...x){return this.d(V,{includeChildren:!0},...x)}d(V,x,...ee){if(!V)return!1;const re=ee.length>0;return!!((!re||ee.includes(1))&&(this.a?.get(V)||x.includeChildren&&this.a?.findSuperstr(V))||(!re||ee.includes(0))&&(this.b?.get(V)||x.includeChildren&&this.b?.findSuperstr(V))||(!re||ee.includes(2))&&(this.c?.findSubstr(V)||x.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=v;function C(M,V,x){return!M||!V||M===V||V.length>M.length?!1:(V.charAt(V.length-1)!==i.sep&&(V+=i.sep),x?(0,D.startsWithIgnoreCase)(M,V):M.indexOf(V)===0)}e.isParent=C;class T extends Error{constructor(V,x,ee){super(V),this.fileOperationResult=x,this.options=ee}}e.FileOperationError=T;class N extends T{constructor(V,x,ee,re){super(V,x,re),this.fileOperationResult=x,this.size=ee}}e.TooLargeFileOperationError=N;class F extends T{constructor(V,x,ee){super(V,2,ee),this.stat=x}}e.NotModifiedSinceFileOperationError=F;var j;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(j=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=$;async function z(M,V){if(!V.hasProvider(O.URI.from({scheme:M.scheme})))return new Promise(x=>{const ee=V.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===M.scheme&&re.added&&(ee.dispose(),x())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(V){return(0,A.isNumber)(V)||(V=0),V<H.KB?(0,R.localize)(1,null,V.toFixed(0)):V<H.MB?(0,R.localize)(2,null,(V/H.KB).toFixed(2)):V<H.GB?(0,R.localize)(3,null,(V/H.MB).toFixed(2)):V<H.TB?(0,R.localize)(4,null,(V/H.GB).toFixed(2)):(0,R.localize)(5,null,(V/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var X;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(X=e.Arch||(e.Arch={}));function ie(M){return{maxFileSize:M===0?300*H.MB:16*H.GB,maxHeapSize:M===0?700*H.MB:2*700*H.MB}}e.getPlatformFileLimits=ie;function G(M){return S.isWeb?M?10*H.MB:50*H.MB:M?100*H.MB:1024*H.MB}e.getLargeFileConfirmationLimit=G});var K=this&&this.__param||function(Z,e){return function(k,i){e(k,i,Z)}};define(oe[196],ae([0,1,100,44,14]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const P=(await this.a.readFileStream(R)).value;return new Promise((S,E)=>{const b=(0,k.createHash)("md5");(0,i.listenStream)(P,{onData:g=>b.update(g.buffer),onError:g=>E(g),onEnd:()=>S(b.digest("base64").replace(/=+$/,""))})})}};A=ye([K(0,D.IFileService)],A),e.ChecksumService=A}),define(oe[197],ae([0,1,17,38,7,3,2,44,8,31,14]),function(Z,e,k,i,D,A,O,R,P,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends O.Disposable{constructor(m,h){super(),this.a=m,this.b=h,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,S.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,h){const{buffer:y}=await this.a.call("readFile",[m,h]);return y}readFileStream(m,h,y){const f=(0,R.newWriteableStream)(d=>k.VSBuffer.concat(d.map(p=>k.VSBuffer.wrap(p))).buffer),l=this.a.listen("readFileStream",[m,h])(d=>{if(d instanceof k.VSBuffer)f.write(d.buffer);else{if(d==="end")f.end();else{let p;if(d instanceof Error)p=d;else{const w=d;p=(0,E.createFileSystemProviderError)(w.message??(0,i.toErrorMessage)(w),w.code??E.FileSystemProviderErrorCode.Unknown)}f.error(p),f.end()}l.dispose()}});return y.onCancellationRequested(()=>{f.error((0,D.canceled)()),f.end(),l.dispose()}),f}writeFile(m,h,y){return this.a.call("writeFile",[m,k.VSBuffer.wrap(h),y])}open(m,h){return this.a.call("open",[m,h])}close(m){return this.a.call("close",[m])}async read(m,h,y,f,l){const[d,p]=await this.a.call("read",[m,h,l]);return y.set(d.buffer.slice(0,p),f),p}write(m,h,y,f,l){return this.a.call("write",[m,h,k.VSBuffer.wrap(y),f,l])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,h){return this.a.call("delete",[m,h])}rename(m,h,y){return this.a.call("rename",[m,h,y])}copy(m,h,y){return this.a.call("copy",[m,h,y])}cloneFile(m,h){return this.a.call("cloneFile",[m,h])}i(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const h=m;this.f.fire(h.map(y=>({resource:P.URI.revive(y.resource),type:y.type})))}else{const h=m;this.g.fire(h)}}))}watch(m,h){const y=(0,S.generateUuid)();return this.a.call("watch",[this.h,y,m,h]),(0,O.toDisposable)(()=>this.a.call("unwatch",[this.h,y]))}}e.DiskFileSystemProviderClient=b}),define(oe[101],ae([0,1,17,7,166,14]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(E,b,g,m,h,y){let f;try{await R(E,b,g,m,h,y)}catch(l){f=l}finally{f&&h.errorTransformer&&(f=h.errorTransformer(f)),typeof f<"u"&&g.error(f),g.end()}}e.readFileIntoStream=O;async function R(E,b,g,m,h,y){P(y);const f=await E.open(b,{create:!1});try{P(y);let l=0,d=0,p=h&&typeof h.length=="number"?h.length:void 0,w=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof p=="number"?p:h.bufferSize)),I=h&&typeof h.position=="number"?h.position:0,n=0;do d=await E.read(f,I,w.buffer,n,w.byteLength-n),I+=d,n+=d,l+=d,typeof p=="number"&&(p-=d),n===w.byteLength&&(await g.write(m(w)),w=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof p=="number"?p:h.bufferSize)),n=0);while(d>0&&(typeof p!="number"||p>0)&&P(y)&&S(l,h));if(n>0){let c=n;typeof p=="number"&&(c=Math.min(n,p)),g.write(m(w.slice(0,c)))}}catch(l){throw(0,A.ensureFileSystemProviderError)(l)}finally{await E.close(f)}}function P(E){if(E.isCancellationRequested)throw(0,i.canceled)();return!0}function S(E,b){if(b?.limits){if(typeof b.limits.memory=="number"&&E>b.limits.memory)throw(0,A.createFileSystemProviderError)((0,D.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&E>b.limits.size)throw(0,A.createFileSystemProviderError)((0,D.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(oe[56],ae([0,1,90,2,12,5,8,14]),function(Z,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(l){return l.recursive===!0}e.isRecursiveWatchRequest=P;class S extends i.Disposable{constructor(d,p,w,I){super(),this.h=d,this.i=p,this.j=w,this.k=I,this.c=this.B(new i.MutableDisposable),this.f=void 0,this.g=0}m(){const d=new i.DisposableStore;this.c.value=d,this.b=this.l(d),this.b.setVerboseLogging(this.j),d.add(this.b.onDidChangeFile(p=>this.h(p))),d.add(this.b.onDidLogMessage(p=>this.i(p))),d.add(this.b.onDidError(p=>this.n(p)))}n(d){this.k.restartOnError?this.g<S.a&&this.f?(this.r(`restarting watcher after error: ${d}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${d}`):this.r(d)}p(d){this.g++,this.m(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.j=d,await this.b?.setVerboseLogging(d)}r(d){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.a=5;class E extends S{constructor(d,p,w){super(d,p,w,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class b extends S{constructor(d,p,w){super(d,p,w,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function g(l){return l.map(d=>({type:d.type,resource:O.URI.file(d.path)}))}e.toFileChanges=g;function m(l){const d=new f;for(const p of l)d.processEvent(p);return d.coalesce()}e.coalesceEvents=m;function h(l,d){return typeof d=="string"&&!d.startsWith(k.GLOBSTAR)&&!(0,D.isAbsolute)(d)?{base:l,pattern:d}:d}e.normalizeWatcherPattern=h;function y(l,d){const p=[];for(const w of d)p.push((0,k.parse)(h(l,w)));return p}e.parseWatcherPatterns=y;class f{constructor(){this.a=new Set,this.b=new Map}c(d){return A.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const p=this.b.get(this.c(d));let w=!1;if(p){const I=p.type,n=d.type;p.path!==d.path&&(d.type===2||d.type===1)?w=!0:I===1&&n===2?(this.b.delete(this.c(d)),this.a.delete(p)):I===2&&n===1?p.type=0:I===1&&n===0||(p.type=n)}else w=!0;w&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],p=[];return Array.from(this.a).filter(w=>w.type!==2?(d.push(w),!1):!0).sort((w,I)=>w.path.length-I.path.length).filter(w=>p.some(I=>(0,R.isParent)(w.path,I,!A.isLinux))?!1:(p.push(w.path),!0)).concat(d)}}}),define(oe[198],ae([0,1,53,6,23,48,2,85,12,5,146,28,56]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class m extends O.Disposable{constructor(f,l,d,p){super(),this.j=f,this.k=l,this.l=d,this.m=p,this.c=this.B(new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},w=>this.k(w))),this.f=this.B(new i.RunOnceWorker(w=>this.u(w),m.b)),this.g=(0,g.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,g.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new D.CancellationTokenSource,this.ready=this.n()}async n(){try{const f=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const l=await b.Promises.stat(f);this.B(await this.s(f,l.isDirectory()))}catch(f){f.code!=="ENOENT"?this.w(f):this.z(f)}}async r(f){let l=f.path;try{l=await b.Promises.realpath(f.path),f.path===l&&(l=await(0,E.realcase)(f.path)??f.path),f.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${l})`)}catch{}return l}async s(f,l){if(S.isMacintosh&&(0,A.isEqualOrParent)(f,"/Volumes/",!0))return this.w(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.Disposable.None;const d=new D.CancellationTokenSource(this.i.token),p=new O.DisposableStore;try{const w=(0,P.basename)(f),I=(0,k.watch)(f);p.add((0,O.toDisposable)(()=>{I.removeAllListeners(),I.close()})),this.z(`Started watching: '${f}'`);const n=new Set;if(l)try{for(const t of await b.Promises.readdir(f))n.add(t)}catch(t){this.w(t)}const c=new Map;p.add((0,O.toDisposable)(()=>{for(const[,t]of c)t.dispose();c.clear()})),I.on("error",(t,s)=>{this.w(`Failed to watch ${f} for changes using fs.watch() (${t}, ${s})`),this.dispose()}),I.on("change",(t,s)=>{if(d.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${s}`);let o="";if(s&&(o=s.toString(),S.isMacintosh&&(o=(0,R.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(l)if(t==="rename"){c.get(o)?.dispose();const a=setTimeout(async()=>{if(c.delete(o),o===w&&!await b.Promises.exists(f)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const r=await this.v((0,P.join)(f,o));if(d.token.isCancellationRequested)return;let u;r?n.has(o)?u=0:(u=1,n.add(o)):(n.delete(o),u=2),this.t({path:(0,P.join)(this.j.path,o),type:u})},m.a);c.set(o,(0,O.toDisposable)(()=>clearTimeout(a)))}else{let a;n.has(o)?a=0:(a=1,n.add(o)),this.t({path:(0,P.join)(this.j.path,o),type:a})}else if(t==="rename"||o!==w){const a=setTimeout(async()=>{const r=await b.Promises.exists(f);d.token.isCancellationRequested||(r?(this.t({path:this.j.path,type:0},!0),p.add(await this.s(f,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},m.a);p.clear(),p.add((0,O.toDisposable)(()=>clearTimeout(a)))}else this.t({path:this.j.path,type:0},!0)})}catch(w){await b.Promises.exists(f)&&!d.token.isCancellationRequested&&this.w(`Failed to watch ${f} for changes using fs.watch() (${w.toString()})`)}return(0,O.toDisposable)(()=>{d.dispose(!0),p.dispose()})}t(f,l=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!l&&this.g.some(d=>d(f.path))?this.m&&this.z(` >> ignored (excluded) ${f.path}`):!l&&this.h&&this.h.length>0&&!this.h.some(d=>d(f.path))?this.m&&this.z(` >> ignored (not included) ${f.path}`):this.f.work(f))}u(f){const l=(0,g.coalesceEvents)(f);if(l.length>0){if(this.m)for(const p of l)this.z(`>> normalized ${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`);this.c.work(l)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(f){if(S.isLinux)return b.Promises.exists(f);try{const l=(0,P.basename)(f);return(await b.Promises.readdir((0,P.dirname)(f))).some(p=>p===l)}catch(l){return this.z(l),!1}}setVerboseLogging(f){this.m=f}w(f){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}y(f){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}z(f){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=m,m.a=100,m.b=75;async function h(y,f,l,d,p=512){const w=await b.Promises.open(y,"r"),I=Buffer.allocUnsafe(p),n=new D.CancellationTokenSource(d);let c,t=!1;const s={path:y,excludes:[],recursive:!1},o=new m(s,a=>{(async()=>{for(const{type:r}of a)if(r===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:u}=await b.Promises.read(w,I,0,p,null);if(!u||n.token.isCancellationRequested)break;f(I.slice(0,u))}}catch(u){c=new Error(u),n.dispose(!0)}finally{t=!1}}})()});return await o.ready,l(),new Promise((a,r)=>{n.token.onCancellationRequested(async()=>{o.dispose();try{await b.Promises.close(w)}catch(u){c=new Error(u)}c?r(c):a()})})}e.watchFileContents=h}),define(oe[199],ae([0,1,3,90,2,5,198]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new k.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=k.Event.None,this.c=new Map,this.f=!1}async watch(S){const E=this.i(S),b=E.filter(m=>{const h=this.c.get(m.path);return h?!(0,i.patternsEquals)(h.request.excludes,m.excludes)||!(0,i.patternsEquals)(h.request.includes,m.includes):!0}),g=Array.from(this.c.values()).filter(({request:m})=>!E.find(h=>h.path===m.path&&(0,i.patternsEquals)(h.excludes,m.excludes)&&(0,i.patternsEquals)(h.includes,m.includes))).map(({request:m})=>m.path);b.length&&this.j(`Request to start watching: ${b.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"})`).join(",")}`),g.length&&this.j(`Request to stop watching: ${g.join(",")}`);for(const m of g)this.h(m);for(const m of b)this.g(m)}g(S){const E=new O.NodeJSFileWatcherLibrary(S,g=>this.a.fire(g),g=>this.b.fire(g),this.f),b={request:S,instance:E};this.c.set(S.path,b)}async stop(){for(const[S]of this.c)this.h(S);this.c.clear()}h(S){const E=this.c.get(S);E&&(this.c.delete(S),E.instance.dispose())}i(S){const E=new Map;for(const b of S){const g=A.isLinux?b.path:b.path.toLowerCase();E.set(g,b)}return Array.from(E.values())}async setVerboseLogging(S){this.f=S;for(const[,E]of this.c)E.instance.setVerboseLogging(S)}j(S){this.f&&this.b.fire({type:"trace",message:this.k(S)})}k(S,E){return E?`[File Watcher (node.js)] ${S} (path: ${E.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=R}),define(oe[200],ae([0,1,56,199]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends k.AbstractNonRecursiveWatcherClient{constructor(O,R,P){super(O,R,P),this.m()}l(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(oe[201],ae([0,1,24,39,68,56]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends A.AbstractUniversalWatcherClient{constructor(P,S,E){super(P,S,E),this.m()}l(P){const S=P.add(new D.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(S.onDidProcessExit(({code:E,signal:b})=>this.n(`terminated by itself with code ${E}, signal: ${b}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(oe[72],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...D){this.a=new Map;for(const[A,O]of D)this.set(A,O)}set(D,A){const O=this.a.get(D);return this.a.set(D,A),O}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=k}),define(oe[202],ae([0,1,6,7,2,55,192,4,72,84]),function(Z,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class b extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class g{constructor(f=new P.ServiceCollection,l=!1,d,p=E){this.f=f,this.g=l,this.h=d,this.i=p,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=p?d?._globalGraph??new O.Graph(w=>w):void 0}createChild(f){return new g(f,this.g,this,this.i)}invokeFunction(f,...l){const d=h.traceInvocation(this.i,f);let p=!1;try{return f({get:I=>{if(p)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(I,d);if(!n)throw new Error(`[invokeFunction] unknown service '${I}'`);return n}},...l)}finally{p=!0,d.stop()}}createInstance(f,...l){let d,p;return f instanceof A.SyncDescriptor?(d=h.traceCreation(this.i,f.ctor),p=this.j(f.ctor,f.staticArguments.concat(l),d)):(d=h.traceCreation(this.i,f),p=this.j(f,l,d)),d.stop(),p}j(f,l=[],d){const p=R._util.getServiceDependencies(f).sort((n,c)=>n.index-c.index),w=[];for(const n of p){const c=this.m(n.id,d);c||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${n.id}.`,!1),w.push(c)}const I=p.length>0?p[0].index:l.length;if(l.length!==I){console.trace(`[createInstance] First service dependency of ${f.name} at position ${I+1} conflicts with ${l.length} static arguments`);const n=I-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,I)}return Reflect.construct(f,l.concat(w))}k(f,l){if(this.f.get(f)instanceof A.SyncDescriptor)this.f.set(f,l);else if(this.h)this.h.k(f,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const l=this.f.get(f);return!l&&this.h?this.h.l(f):l}m(f,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const d=this.l(f);return d instanceof A.SyncDescriptor?this.q(f,d,l.branch(f,!0)):(l.branch(f,!1),d)}q(f,l,d){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,l,d)}finally{this.o.delete(f)}}r(f,l,d){const p=new O.Graph(n=>n.id.toString());let w=0;const I=[{id:f,desc:l,_trace:d}];for(;I.length;){const n=I.pop();if(p.lookupOrInsertNode(n),w++>1e3)throw new b(p);for(const c of R._util.getServiceDependencies(n.desc.ctor)){const t=this.l(c.id);if(t||this.u(`[createInstance] ${f} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(c.id)),t instanceof A.SyncDescriptor){const s={id:c.id,desc:t,_trace:n._trace.branch(c.id,!0)};p.insertEdge(n,s),I.push(s)}}}for(;;){const n=p.roots();if(n.length===0){if(!p.isEmpty())throw new b(p);break}for(const{data:c}of n){if(this.l(c.id)instanceof A.SyncDescriptor){const s=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,s)}p.removeNode(c)}}return this.l(f)}s(f,l,d=[],p,w){if(this.f.get(f)instanceof A.SyncDescriptor)return this.t(f,l,d,p,w);if(this.h)return this.h.s(f,l,d,p,w);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(f,l,d=[],p,w){if(p){const I=new g(void 0,this.g,this,this.i);I.c=String(f);const n=new Map,c=new k.IdleValue(()=>{const t=I.j(l,d,w);for(const[s,o]of n){const a=t[s];if(typeof a=="function")for(const r of o)a.apply(t,r)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,s){if(!c.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let r=n.get(s);return r||(r=new S.LinkedList,n.set(s,r)),(v,C,T)=>{const N=r.push([v,C,T]);return(0,D.toDisposable)(N)}}if(s in t)return t[s];const o=c.value;let a=o[s];return typeof a!="function"||(a=a.bind(o),t[s]=a),a},set(t,s,o){return c.value[s]=o,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,d,w)}u(f,l){if(l&&console.warn(f),this.g)throw new Error(f)}}e.InstantiationService=g;var m;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(m||(m={}));class h{static traceInvocation(f,l){return f?new h(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(f,l){return f?new h(1,l.name):h.c}constructor(f,l){this.type=f,this.name=l,this.g=Date.now(),this.h=[]}branch(f,l){const d=new h(3,f.toString());return this.h.push([f,l,d]),d}stop(){const f=Date.now()-this.g;h.f+=f;let l=!1;function d(w,I){const n=[],c=new Array(w+1).join("	");for(const[t,s,o]of I.h)if(s&&o){l=!0,n.push(`${c}CREATES -> ${t}`);const a=d(w+1,o);a&&n.push(a)}else n.push(`${c}uses -> ${t}`);return n.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(f>2||l)&&h.all.add(p.join(`
`))}}e.Trace=h,h.all=new Set,h.c=new class extends h{constructor(){super(0,null)}stop(){}branch(){return this}},h.f=0}),define(oe[203],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(D,A){this.a=D,this.b=A}getChannel(D){return this.a.getChannel(D,this.b)}registerChannel(D,A){this.a.registerChannel(D,A)}}e.MessagePortMainProcessService=k}),define(oe[57],ae([0,1,39,55,71,4]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class O{constructor(m,h,y,f){const l=y.getChannel(m);return R(h)?f.createInstance(new i.SyncDescriptor(h.channelClientCtor,[l])):k.ProxyChannel.toService(l,h?.proxyOptions)}}function R(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let P=class extends O{constructor(m,h,y,f){super(m,h,y,f)}};P=ye([K(2,e.IMainProcessService),K(3,A.IInstantiationService)],P);function S(g,m,h){(0,D.registerSingleton)(g,new i.SyncDescriptor(P,[m,h],!0))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let E=class extends O{constructor(m,h,y,f){super(m,h,y,f)}};E=ye([K(2,e.ISharedProcessService),K(3,A.IInstantiationService)],E);function b(g,m,h){(0,D.registerSingleton)(g,new i.SyncDescriptor(E,[m,h],!0))}e.registerSharedProcessRemoteService=b}),define(oe[73],ae([0,1,23,2,5,168,30,4]),function(Z,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function P(E){return E.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=P,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let S=class extends i.Disposable{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new k.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const h=g.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(f=>f.startsWith("lp-"))).map(y=>{const f=y.properties.localizedLanguages?.[0],l=P(y);return{...this.f(l,f,y),extensionId:y.identifier.id,galleryExtension:y}});return h.push({...this.f("en","English"),extensionId:"default"}),h}f(b,g,m){const h=g??b;let y;if(h!==b&&(y=`(${b})`),b.toLowerCase()===D.language.toLowerCase()&&(y??="",y+=(0,A.localize)(0,null)),m?.installCount){y??="";const f=m.installCount;let l;f>1e6?l=`${Math.floor(f/1e5)/10}M`:f>1e3?l=`${Math.floor(f/1e3)}K`:l=String(f),y+=` $(cloud-download) ${l}`}return{id:b,label:h,description:y}}};S=ye([K(0,O.IExtensionGalleryService)],S),e.LanguagePackBaseService=S}),define(oe[204],ae([0,1,2,73]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends k.Disposable{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};D=ye([K(0,i.ILanguagePackService)],D),e.LocalizationsUpdater=D}),define(oe[9],ae([0,1,38,3,2,37,5,8,4]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function S(){return new Date().toISOString()}var E;(function(a){a[a.Off=0]="Off",a[a.Trace=1]="Trace",a[a.Debug=2]="Debug",a[a.Info=3]="Info",a[a.Warning=4]="Warning",a[a.Error=5]="Error"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function b(a,r,u){switch(r){case E.Trace:a.trace(u);break;case E.Debug:a.debug(u);break;case E.Info:a.info(u);break;case E.Warning:a.warn(u);break;case E.Error:a.error(u);break;case E.Off:break;default:throw new Error(`Invalid log level ${r}`)}}e.log=b;function g(a){let r="";for(let u=0;u<a.length;u++){let v=a[u];if(typeof v=="object")try{v=JSON.stringify(v)}catch{}r+=(u>0?" ":"")+v}return r}e.format=g;class m extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new i.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(r){this.b!==r&&(this.b=r,this.c.fire(this.b))}getLevel(){return this.b}f(r){return this.b!==E.Off&&this.b<=r}}e.AbstractLogger=m;class h extends m{constructor(r){super(),this.h=r}f(r){return this.h||super.f(r)}trace(r,...u){this.f(E.Trace)&&this.g(E.Trace,g([r,...u]))}debug(r,...u){this.f(E.Debug)&&this.g(E.Debug,g([r,...u]))}info(r,...u){this.f(E.Info)&&this.g(E.Info,g([r,...u]))}warn(r,...u){this.f(E.Warning)&&this.g(E.Warning,g([r,...u]))}error(r,...u){if(this.f(E.Error))if(r instanceof Error){const v=Array.prototype.slice.call(arguments);v[0]=r.stack,this.g(E.Error,g(v))}else this.g(E.Error,g([r,...u]))}flush(){}}e.AbstractMessageLogger=h;class y extends m{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r),this.g=!O.isWindows}trace(r,...u){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,r,...u):console.log(`[main ${S()}]`,r,...u))}debug(r,...u){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,r,...u):console.log(`[main ${S()}]`,r,...u))}info(r,...u){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,r,...u):console.log(`[main ${S()}]`,r,...u))}warn(r,...u){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,r,...u):console.warn(`[main ${S()}]`,r,...u))}error(r,...u){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,r,...u):console.error(`[main ${S()}]`,r,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class f extends m{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r)}trace(r,...u){this.f(E.Trace)&&console.log("%cTRACE","color: #888",r,...u)}debug(r,...u){this.f(E.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",r,...u)}info(r,...u){this.f(E.Info)&&console.log("%c INFO","color: #33f",r,...u)}warn(r,...u){this.f(E.Warning)&&console.log("%c WARN","color: #993",r,...u)}error(r,...u){this.f(E.Error)&&console.log("%c  ERR","color: #f33",r,...u)}dispose(){}flush(){}}e.ConsoleLogger=f;class l extends m{constructor(r,u=e.DEFAULT_LOG_LEVEL){super(),this.g=r,this.setLevel(u)}trace(r,...u){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(r),...u])}debug(r,...u){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(r),...u])}info(r,...u){this.f(E.Info)&&this.g.log(E.Info,[this.h(r),...u])}warn(r,...u){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(r),...u])}error(r,...u){this.f(E.Error)&&this.g.log(E.Error,[this.h(r),...u])}h(r){return typeof r=="string"?r:(0,k.toErrorMessage)(r,this.f(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class d extends m{constructor(r){super(),this.g=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const u of this.g)u.setLevel(r);super.setLevel(r)}trace(r,...u){for(const v of this.g)v.trace(r,...u)}debug(r,...u){for(const v of this.g)v.debug(r,...u)}info(r,...u){for(const v of this.g)v.info(r,...u)}warn(r,...u){for(const v of this.g)v.warn(r,...u)}error(r,...u){for(const v of this.g)v.error(r,...u)}flush(){for(const r of this.g)r.flush()}dispose(){for(const r of this.g)r.dispose()}}e.MultiplexLogService=d;class p extends D.Disposable{constructor(r){super(),this.b=r,this.B(r)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(r){this.b.setLevel(r)}getLevel(){return this.b.getLevel()}trace(r,...u){this.b.trace(r,...u)}debug(r,...u){this.b.debug(r,...u)}info(r,...u){this.b.info(r,...u)}warn(r,...u){this.b.warn(r,...u)}error(r,...u){this.b.error(r,...u)}flush(){this.b.flush()}}e.LogService=p;class w extends D.Disposable{constructor(r,u){super(),this.c=r,this.b=new A.ResourceMap,this.B(u(v=>this.setLevel(v)))}getLoggers(){return[...this.b.values()].map(({logger:r})=>r)}getLogger(r){return this.b.get(r)?.logger}createLogger(r,u,v){let C=this.b.get(r)?.logger;return C||(v=u?.always?E.Trace:v,C=this.f(r,v??this.c,u),this.b.set(r,{logger:C,logLevel:v})),C}setLevel(r,u){const v=R.URI.isUri(r)?r:void 0,C=v?u:r;if(v){const T=this.b.get(v);T&&T.logLevel!==C&&(T.logLevel=C,T.logger.setLevel(C))}else this.c=C,this.b.forEach(({logLevel:T,logger:N})=>{T===void 0&&N.setLevel(this.c)})}getLogLevel(r){return this.b.get(r)?.logLevel}dispose(){this.b.forEach(({logger:r})=>r.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=w;class I{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(r){}getLevel(){return E.Info}trace(r,...u){}debug(r,...u){}info(r,...u){}warn(r,...u){}error(r,...u){}critical(r,...u){}dispose(){}flush(){}}e.NullLogger=I;class n extends I{}e.NullLogService=n;class c extends w{constructor(){super(E.Info,i.Event.None)}f(r,u,v){return new I}}e.NullLoggerService=c;function t(a){if(a.verbose)return E.Trace;if(typeof a.logLevel=="string"){const r=o(a.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function s(a){switch(a){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=s;function o(a){switch(a){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=o}),define(oe[205],ae([0,1,6,7,2,12,28,15,9]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends D.Disposable{constructor(b,g){super(),this.a=b,this.b=g,this.B(new k.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,A.basename)(this.a.logsPath),g=(0,A.dirname)(this.a.logsPath),y=(await O.Promises.readdir(g)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==b),f=y.slice(0,Math.max(0,y.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(l=>O.Promises.rm((0,A.join)(g,l)))))}catch(b){(0,i.onUnexpectedError)(b)}}};S=ye([K(0,R.IEnvironmentService),K(1,P.ILogService)],S),e.LogsDataCleaner=S}),define(oe[206],ae([0,1,21,6,7,3,2,12,56,9]),function(Z,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends O.Disposable{constructor(g,m){super(),this.a=g,this.b=m,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new i.ThrottledDelayer(0)),this.s=[],this.t=this.B(new i.ThrottledDelayer(0))}watch(g,m){return m.recursive||this.b?.watcher?.forceUniversal?this.l(g,m):this.u(g,m)}l(g,m){const h={path:this.C(g),excludes:m.excludes,includes:m.includes,recursive:m.recursive},y=(0,k.insert)(this.j,h);return this.m(),(0,O.toDisposable)(()=>{y(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(g=>(0,D.onUnexpectedError)(g))}n(){this.h||(this.h=this.B(this.p(m=>this.c.fire((0,P.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const m of this.j)(0,P.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const m of this.j)(0,P.isRecursiveWatchRequest)(m)&&g.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(g,m){const h={path:this.C(g),excludes:m.excludes,includes:m.includes,recursive:!1},y=(0,k.insert)(this.s,h);return this.v(),(0,O.toDisposable)(()=>{y(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(g=>(0,D.onUnexpectedError)(g))}w(){return this.r||(this.r=this.B(this.y(g=>this.c.fire((0,P.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.r.watch(this.s)}z(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}C(g){return(0,R.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(oe[207],ae([0,1,21,6,17,23,3,66,64,2,49,24,102,22,44,164,14,101,9,7]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends S.Disposable{constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new O.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new O.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new O.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new i.ResourceQueue)}registerProvider(n,c){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${n}`);const t=new S.DisposableStore;return this.h.set(n,c),this.c.fire({added:!0,scheme:n,provider:c}),t.add(c.onDidChangeFile(s=>this.R.fire(new f.FileChangesEvent(s,!this.O(c))))),typeof c.onDidWatchError=="function"&&t.add(c.onDidWatchError(s=>this.S.fire(new Error(s)))),t.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:n}))),(0,S.toDisposable)(()=>{this.c.fire({added:!1,scheme:n,provider:c}),this.h.delete(n),(0,S.dispose)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const c=[];this.f.fire({scheme:n,join(t){c.push(t)}}),!this.h.has(n)&&await i.Promises.settled(c)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,c){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return P.Iterable.map(this.h,([n,c])=>({scheme:n,capabilities:c.capabilities}))}async j(n){if(!(0,m.isAbsolutePath)(n))throw new f.FileOperationError((0,y.localize)(0,null,this.nb(n)),8);await this.activateProvider(n.scheme);const c=this.h.get(n.scheme);if(!c){const t=new p.ErrorNoTelemetry;throw t.message=(0,y.localize)(1,null,n.toString()),t}return c}async k(n){const c=await this.j(n);if((0,f.hasOpenReadWriteCloseCapability)(c)||(0,f.hasReadWriteCapability)(c)||(0,f.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(n){const c=await this.j(n);if((0,f.hasOpenReadWriteCloseCapability)(c)||(0,f.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,c){try{return await this.n(n,c)}catch(t){throw(0,f.toFileSystemProviderErrorCode)(t)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,y.localize)(2,null,this.nb(n)),1):(0,f.ensureFileSystemProviderError)(t)}}async n(n,c){const t=await this.j(n),s=this.O(t),o=c?.resolveTo,a=c?.resolveSingleChildDescendants,r=c?.resolveMetadata,u=await t.stat(n);let v;return this.p(t,n,u,void 0,!!r,(C,T)=>(v||(v=E.TernarySearchTree.forUris(()=>!s),v.set(n,!0),o&&v.fill(!0,o)),v.get(C.resource)||v.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&a?T===1:!1))}async p(n,c,t,s,o,a){const{providerExtUri:r}=this.N(n),u={resource:c,name:r.basename(c),isFile:(t.type&f.FileType.File)!==0,isDirectory:(t.type&f.FileType.Directory)!==0,isSymbolicLink:(t.type&f.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&f.FilePermission.Readonly)||Boolean(n.capabilities&2048),etag:(0,f.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(u.isDirectory&&a(u,s)){try{const v=await n.readdir(c),C=await i.Promises.settled(v.map(async([T,N])=>{try{const F=r.joinPath(c,T),j=o?await n.stat(F):{type:N};return await this.p(n,F,j,v.length,o,a)}catch(F){return this.b.trace(F),null}}));u.children=(0,k.coalesce)(C)}catch(v){this.b.trace(v),u.children=[]}return u}return u}async resolveAll(n){return i.Promises.settled(n.map(async c=>{try{return{stat:await this.n(c.resource,c.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const c=await this.j(n),t=await c.stat(n);return this.p(c,n,t,void 0,!0,()=>!1)}async exists(n){const c=await this.j(n);try{return!!await c.stat(n)}catch{return!1}}async canCreateFile(n,c){try{await this.r(n,c)}catch(t){return t}return!0}async r(n,c){if(!c?.overwrite&&await this.exists(n))throw new f.FileOperationError((0,y.localize)(3,null,this.nb(n)),3,c)}async createFile(n,c=D.VSBuffer.fromString(""),t){await this.r(n,t);const s=await this.writeFile(n,c);return this.m.fire(new f.FileOperationEvent(n,0,s)),s}async writeFile(n,c,t){const s=this.lb(await this.l(n),n),{providerExtUri:o}=this.N(s);try{await this.s(s,n,t)||await this.P(s,o.dirname(n));let r;if((0,f.hasReadWriteCapability)(s)&&!(c instanceof D.VSBuffer))if((0,h.isReadableStream)(c)){const u=await(0,h.peekStream)(c,3);u.ended?r=D.VSBuffer.concat(u.buffer):r=u}else r=(0,h.peekReadable)(c,u=>D.VSBuffer.concat(u),3);else r=c;!(0,f.hasOpenReadWriteCloseCapability)(s)||(0,f.hasReadWriteCapability)(s)&&r instanceof D.VSBuffer?await this.cb(s,n,t,r):await this.Y(s,n,t,r instanceof D.VSBuffer?(0,D.bufferToReadable)(r):r),this.m.fire(new f.FileOperationEvent(n,4))}catch(a){throw new f.FileOperationError((0,y.localize)(4,null,this.nb(n),(0,f.ensureFileSystemProviderError)(a).toString()),(0,f.toFileOperationResult)(a),t)}return this.resolve(n,{resolveMetadata:!0})}async s(n,c,t){if(!!t?.unlock&&!(n.capabilities&8192))throw new Error((0,y.localize)(5,null,this.nb(c)));let o;try{o=await n.stat(c)}catch{return}if((o.type&f.FileType.Directory)!==0)throw new f.FileOperationError((0,y.localize)(6,null,this.nb(c)),0,t);if(this.mb(c,o),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==f.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,f.etag)({mtime:t.mtime,size:o.size}))throw new f.FileOperationError((0,y.localize)(7,null),3,t);return o}async readFile(n,c,t){const s=await this.k(n);return c?.atomic?this.t(s,n,c,t):this.u(s,n,c,t)}async t(n,c,t,s){return new Promise((o,a)=>{this.X.queueFor(c,this.N(n).providerExtUri).queue(async()=>{try{const r=await this.u(n,c,t,s);o(r)}catch(r){a(r)}})})}async u(n,c,t,s){const o=await this.v(n,c,{...t,preferUnbuffered:!0},s);return{...o,value:await(0,D.streamToBuffer)(o.value)}}async readFileStream(n,c,t){const s=await this.k(n);return this.v(s,n,c,t)}async v(n,c,t,s){const o=new A.CancellationTokenSource(s),a=this.F(c,t).then(u=>u,u=>{throw o.cancel(),u});let r;try{return typeof t?.etag=="string"&&t.etag!==f.ETAG_DISABLED&&await a,t?.atomic&&(0,f.hasFileAtomicReadCapability)(n)||!((0,f.hasOpenReadWriteCloseCapability)(n)||(0,f.hasFileReadStreamCapability)(n))||(0,f.hasReadWriteCapability)(n)&&t?.preferUnbuffered?r=this.D(n,c,t):(0,f.hasFileReadStreamCapability)(n)?r=this.z(n,c,o.token,t):r=this.C(n,c,o.token,t),{...await a,value:r}}catch(u){throw r&&await(0,h.consumeStream)(r),this.w(u,c,t)}}w(n,c,t){const s=(0,y.localize)(8,null,this.nb(c),(0,f.ensureFileSystemProviderError)(n).toString());return n instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(s,n.stat,t):n instanceof f.TooLargeFileOperationError?new f.TooLargeFileOperationError(s,n.fileOperationResult,n.size,n.options):new f.FileOperationError(s,(0,f.toFileOperationResult)(n),t)}z(n,c,t,s=Object.create(null)){const o=n.readFileStream(c,s,t);return(0,h.transform)(o,{data:a=>a instanceof D.VSBuffer?a:D.VSBuffer.wrap(a),error:a=>this.w(a,c,s)},a=>D.VSBuffer.concat(a))}C(n,c,t,s=Object.create(null)){const o=(0,D.newWriteableBufferStream)();return(0,l.readFileIntoStream)(n,c,o,a=>a,{...s,bufferSize:this.a,errorTransformer:a=>this.w(a,c,s)},t),o}D(n,c,t){const s=(0,h.newWriteableStream)(o=>D.VSBuffer.concat(o));return(async()=>{try{let o;t?.atomic&&(0,f.hasFileAtomicReadCapability)(n)?o=await n.readFile(c,{atomic:!0}):o=await n.readFile(c),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.G(c,o.byteLength,t),s.end(D.VSBuffer.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async F(n,c){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new f.FileOperationError((0,y.localize)(9,null,this.nb(n)),0,c);if(typeof c?.etag=="string"&&c.etag!==f.ETAG_DISABLED&&c.etag===t.etag)throw new f.NotModifiedSinceFileOperationError((0,y.localize)(10,null),t,c);return this.G(n,t.size,c),t}G(n,c,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&c>t.limits.size&&(s=7),typeof s=="number")throw new f.TooLargeFileOperationError((0,y.localize)(11,null,this.nb(n)),s,c,t)}}async canMove(n,c,t){return this.H(n,c,"move",t)}async canCopy(n,c,t){return this.H(n,c,"copy",t)}async H(n,c,t,s){if(n.toString()!==c.toString())try{const o=t==="move"?this.lb(await this.l(n),n):await this.k(n),a=this.lb(await this.l(c),c);await this.M(o,n,a,c,t,s)}catch(o){return o}return!0}async move(n,c,t){const s=this.lb(await this.l(n),n),o=this.lb(await this.l(c),c),a=await this.I(s,n,o,c,"move",!!t),r=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(n,a==="move"?2:3,r)),r}async copy(n,c,t){const s=await this.k(n),o=this.lb(await this.l(c),c),a=await this.I(s,n,o,c,"copy",!!t),r=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(n,a==="copy"?3:2,r)),r}async I(n,c,t,s,o,a){if(c.toString()===s.toString())return o;const{exists:r,isSameResourceWithDifferentPathCase:u}=await this.M(n,c,t,s,o,a);if(r&&!u&&a&&await this.del(s,{recursive:!0}),await this.P(t,this.N(t).providerExtUri.dirname(s)),o==="copy"){if(n===t&&(0,f.hasFileFolderCopyCapability)(n))await n.copy(c,s,{overwrite:a});else{const v=await this.resolve(c);v.isDirectory?await this.L(n,v,t,s):await this.J(n,c,t,s)}return o}else return n===t?(await n.rename(c,s,{overwrite:a}),o):(await this.I(n,c,t,s,"copy",a),await this.del(c,{recursive:!0}),"copy")}async J(n,c,t,s){if((0,f.hasOpenReadWriteCloseCapability)(n)&&(0,f.hasOpenReadWriteCloseCapability)(t))return this.eb(n,c,t,s);if((0,f.hasOpenReadWriteCloseCapability)(n)&&(0,f.hasReadWriteCapability)(t))return this.kb(n,c,t,s);if((0,f.hasReadWriteCapability)(n)&&(0,f.hasOpenReadWriteCloseCapability)(t))return this.ib(n,c,t,s);if((0,f.hasReadWriteCapability)(n)&&(0,f.hasReadWriteCapability)(t))return this.gb(n,c,t,s)}async L(n,c,t,s){await t.mkdir(s),Array.isArray(c.children)&&await i.Promises.settled(c.children.map(async o=>{const a=this.N(t).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.L(n,await this.resolve(o.resource),t,a):this.J(n,o.resource,t,a)}))}async M(n,c,t,s,o,a){let r=!1;if(n===t){const{providerExtUri:v,isPathCaseSensitive:C}=this.N(n);if(C||(r=v.isEqual(c,s)),r&&o==="copy")throw new Error((0,y.localize)(12,null,this.nb(c),this.nb(s)));if(!r&&v.isEqualOrParent(s,c))throw new Error((0,y.localize)(13,null,this.nb(c),this.nb(s)))}const u=await this.exists(s);if(u&&!r){if(!a)throw new f.FileOperationError((0,y.localize)(14,null,this.nb(c),this.nb(s)),4);if(n===t){const{providerExtUri:v}=this.N(n);if(v.isEqualOrParent(c,s))throw new Error((0,y.localize)(15,null,this.nb(c),this.nb(s)))}}return{exists:u,isSameResourceWithDifferentPathCase:r}}N(n){const c=this.O(n);return{providerExtUri:c?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:c}}O(n){return!!(n.capabilities&1024)}async createFolder(n){const c=this.lb(await this.j(n),n);await this.P(c,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(n,0,t)),t}async P(n,c){const t=[],{providerExtUri:s}=this.N(n);for(;!s.isEqual(c,s.dirname(c));)try{if(((await n.stat(c)).type&f.FileType.Directory)===0)throw new Error((0,y.localize)(16,null,this.nb(c)));break}catch(o){if((0,f.toFileSystemProviderErrorCode)(o)!==f.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(s.basename(c)),c=s.dirname(c)}for(let o=t.length-1;o>=0;o--){c=s.joinPath(c,t[o]);try{await n.mkdir(c)}catch(a){if((0,f.toFileSystemProviderErrorCode)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(n,c){try{await this.Q(n,c)}catch(t){return t}return!0}async Q(n,c){const t=this.lb(await this.j(n),n);if(!!c?.useTrash&&!(t.capabilities&4096))throw new Error((0,y.localize)(17,null,this.nb(n)));let o;try{o=await t.stat(n)}catch{}if(o)this.mb(n,o);else throw new f.FileOperationError((0,y.localize)(18,null,this.nb(n)),1);if(!!!c?.recursive){const r=await this.resolve(n);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,y.localize)(19,null,this.nb(n)))}return t}async del(n,c){const t=await this.Q(n,c),s=!!c?.useTrash,o=!!c?.recursive;await t.delete(n,{recursive:o,useTrash:s}),this.m.fire(new f.FileOperationEvent(n,1))}async cloneFile(n,c){const t=await this.j(n),s=this.lb(await this.l(c),c);if(t===s&&this.N(t).providerExtUri.isEqual(n,c))return;if(t===s&&(0,f.hasFileCloneCapability)(t))return t.cloneFile(n,c);await this.P(s,this.N(s).providerExtUri.dirname(c));const o=this.X.queueFor(n,this.N(t).providerExtUri);return t===s&&(0,f.hasFileFolderCopyCapability)(t)?o.queue(()=>t.copy(n,c,{overwrite:!0})):o.queue(()=>this.J(t,n,s,c))}watch(n,c={recursive:!1,excludes:[]}){const t=new S.DisposableStore;let s=!1,o=()=>{s=!0};return t.add((0,S.toDisposable)(()=>o())),(async()=>{try{const a=await this.W(n,c);s?(0,S.dispose)(a):o=()=>(0,S.dispose)(a)}catch(a){this.b.error(a)}})(),t}async W(n,c){const t=await this.j(n),s=(0,R.hash)([this.N(t).providerExtUri.getComparisonKey(n),c]);let o=this.U.get(s);return o||(o={count:0,disposable:t.watch(n,c)},this.U.set(s,o)),o.count+=1,(0,S.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,S.dispose)(o.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,n]of this.U)(0,S.dispose)(n.disposable);this.U.clear()}async Y(n,c,t,s){return this.X.queueFor(c,this.N(n).providerExtUri).queue(async()=>{const o=await n.open(c,{create:!0,unlock:t?.unlock??!1});try{(0,h.isReadableStream)(s)||(0,h.isReadableBufferedStream)(s)?await this.Z(n,o,s):await this.ab(n,o,s)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await n.close(o)}})}async Z(n,c,t){let s=0,o;if((0,h.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=D.VSBuffer.concat(t.buffer);await this.bb(n,c,a,a.byteLength,s,0),s+=a.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((a,r)=>{(0,h.listenStream)(o,{onData:async u=>{o.pause();try{await this.bb(n,c,u,u.byteLength,s,0)}catch(v){return r(v)}s+=u.byteLength,setTimeout(()=>o.resume())},onError:u=>r(u),onEnd:()=>a()})})}async ab(n,c,t){let s=0,o;for(;(o=t.read())!==null;)await this.bb(n,c,o,o.byteLength,s,0),s+=o.byteLength}async bb(n,c,t,s,o,a){let r=0;for(;r<s;)r+=await n.write(c,o+r,t.buffer,a+r,s-r)}async cb(n,c,t,s){return this.X.queueFor(c,this.N(n).providerExtUri).queue(()=>this.db(n,c,t,s))}async db(n,c,t,s){let o;s instanceof D.VSBuffer?o=s:(0,h.isReadableStream)(s)?o=await(0,D.streamToBuffer)(s):(0,h.isReadableBufferedStream)(s)?o=await(0,D.bufferedStreamToBuffer)(s):o=(0,D.readableToBuffer)(s),await n.writeFile(c,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async eb(n,c,t,s){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.fb(n,c,t,s))}async fb(n,c,t,s){let o,a;try{o=await n.open(c,{create:!1}),a=await t.open(s,{create:!0,unlock:!1});const r=D.VSBuffer.alloc(this.a);let u=0,v=0,C=0;do C=await n.read(o,u,r.buffer,v,r.byteLength-v),await this.bb(t,a,r,C,u,v),u+=C,v+=C,v===r.byteLength&&(v=0);while(C>0)}catch(r){throw(0,f.ensureFileSystemProviderError)(r)}finally{await i.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async gb(n,c,t,s){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.hb(n,c,t,s))}async hb(n,c,t,s){return t.writeFile(s,await n.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async ib(n,c,t,s){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.jb(n,c,t,s))}async jb(n,c,t,s){const o=await t.open(s,{create:!0,unlock:!1});try{const a=await n.readFile(c);await this.bb(t,o,D.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await t.close(o)}}async kb(n,c,t,s){const o=await(0,D.streamToBuffer)(this.C(n,c,A.CancellationToken.None));await this.cb(t,s,void 0,o)}lb(n,c){if(n.capabilities&2048)throw new f.FileOperationError((0,y.localize)(20,null,this.nb(c)),6);return n}mb(n,c){if((c.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,y.localize)(21,null,this.nb(n)),6)}nb(n){return n.scheme===b.Schemas.file?n.fsPath:n.toString(!0)}};w=ye([K(0,d.ILogService)],w),e.FileService=w}),define(oe[208],ae([0,1,53,288,6,37,17,3,48,2,12,5,22,44,28,167,14,101,206,38,201,200]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(k)}catch(c){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(c)}`)}})();class n extends d.AbstractDiskFileSystemProvider{constructor(t,s){super(t,s),this.onDidChangeCapabilities=R.Event.None,this.H=new A.ResourceMap(o=>g.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,b.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:s,symbolicLink:o}=await h.SymlinkSupport.stat(this.C(t));return{type:this.G(s,o),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.Y(s)}}async readdir(t){try{const s=await h.Promises.readdir(this.C(t),{withFileTypes:!0}),o=[];return await Promise.all(s.map(async a=>{try{let r;a.isSymbolicLink()?r=(await this.stat((0,g.joinPath)(t,a.name))).type:r=this.G(a),o.push([a.name,r])}catch(r){this.a.trace(r)}})),o}catch(s){throw this.Y(s)}}G(t,s){let o;return s?.dangling?o=f.FileType.Unknown:t.isFile()?o=f.FileType.File:t.isDirectory()?o=f.FileType.Directory:o=f.FileType.Unknown,s&&(o|=f.FileType.SymbolicLink),o}async I(t){const s=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let o;for(;o=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await o.wait();const a=new D.Barrier;return this.H.set(t,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,S.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.H.get(t)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),a.open()})}async readFile(t,s){let o;try{s?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),o=await this.I(t));const a=this.C(t);return await h.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{o?.dispose()}}J(t){n.D&&this.a.trace(t)}readFileStream(t,s,o){const a=(0,m.newWriteableStream)(r=>O.VSBuffer.concat(r.map(u=>O.VSBuffer.wrap(u))).buffer);return(0,l.readFileIntoStream)(this,t,a,r=>r.buffer,{...s,bufferSize:256*1024},o),a}async writeFile(t,s,o){let a;try{const r=this.C(t);if(!o.create||!o.overwrite){if(await h.Promises.exists(r)){if(!o.overwrite)throw(0,f.createFileSystemProviderError)((0,y.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,f.createFileSystemProviderError)((0,y.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(a,0,s,0,s.byteLength)}catch(r){throw await this.Z(t,r)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(t){n.O=t}async open(t,s){const o=this.C(t);let a;(0,f.isFileOpenForWriteOptions)(s)&&(a=await this.I(t));let r;try{if((0,f.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:v}=await h.SymlinkSupport.stat(o);v.mode&128||await h.Promises.chmod(o,v.mode|128)}catch(v){this.a.trace(v)}let u;if((0,f.isFileOpenForWriteOptions)(s)){if(b.isWindows)try{await h.Promises.truncate(o,0),u="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}u||(u="w")}else u="r";r=await h.Promises.open(o,u)}catch(u){throw a?.dispose(),(0,f.isFileOpenForWriteOptions)(s)?await this.Z(t,u):this.Y(u)}if(this.L.set(r,0),(0,f.isFileOpenForWriteOptions)(s)&&this.N.set(r,t),a){const u=this.M.get(r);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${o})`),this.M.set(r,a),u&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${o})`),u.dispose())}return r}async close(t){const s=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&n.O)try{await h.Promises.fdatasync(t)}catch(o){n.configureFlushOnWrite(!1),this.a.error(o)}return await h.Promises.close(t)}catch(o){throw this.Y(o)}finally{s&&(this.M.get(t)===s&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),s.dispose())}}async read(t,s,o,a,r){const u=this.P(t,s);let v=null;try{v=(await h.Promises.read(t,o,a,r,u)).bytesRead}catch(C){throw this.Y(C)}finally{this.Q(t,u,v)}return v}P(t,s){return s===this.L.get(t)?null:s}Q(t,s,o){const a=this.L.get(t);typeof a=="number"&&(typeof s=="number"||(typeof o=="number"?this.L.set(t,a+o):this.L.delete(t)))}async write(t,s,o,a,r){return(0,D.retry)(()=>this.R(t,s,o,a,r),100,3)}async R(t,s,o,a,r){const u=this.P(t,s);let v=null;try{v=(await h.Promises.write(t,o,a,r,u)).bytesWritten}catch(C){throw await this.Z(this.N.get(t),C)}finally{this.Q(t,u,v)}return v}async mkdir(t){try{await h.Promises.mkdir(this.C(t))}catch(s){throw this.Y(s)}}async delete(t,s){try{const o=this.C(t);s.recursive?await h.Promises.rm(o,h.RimRafMode.MOVE):await h.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(t,s,o){const a=this.C(t),r=this.C(s);if(a!==r)try{await this.S(t,s,"move",o.overwrite),await h.Promises.move(a,r)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,y.localize)(2,null,(0,E.basename)(a),(0,E.basename)((0,E.dirname)(r)),u.toString()))),this.Y(u)}}async copy(t,s,o){const a=this.C(t),r=this.C(s);if(a!==r)try{await this.S(t,s,"copy",o.overwrite),await h.Promises.copy(a,r,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,y.localize)(3,null,(0,E.basename)(a),(0,E.basename)((0,E.dirname)(r)),u.toString()))),this.Y(u)}}async S(t,s,o,a){const r=this.C(t),u=this.C(s);let v=!1;if(!!(this.capabilities&1024)||(v=(0,P.isEqual)(r,u,!0)),v&&o==="copy")throw(0,f.createFileSystemProviderError)((0,y.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!v&&await h.Promises.exists(u)){if(!a)throw(0,f.createFileSystemProviderError)((0,y.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(t,s){return this.U(t,s,!1)}async U(t,s,o){const a=this.C(t),r=this.C(s),u=!!(this.capabilities&1024);if((0,P.isEqual)(a,r,!u))return;const v=new S.DisposableStore;try{const[C,T]=await Promise.all([this.I(t),this.I(s)]);v.add(C),v.add(T),o&&await h.Promises.mkdir((0,E.dirname)(r),{recursive:!0}),await h.Promises.copyFile(a,r)}catch(C){if(C.code==="ENOENT"&&!o)return this.U(t,s,!0);throw this.Y(C)}finally{v.dispose()}}p(t,s,o){return new w.UniversalWatcherClient(a=>t(a),a=>s(a),o)}y(t,s,o){return new I.NodeJSWatcherClient(a=>t(a),a=>s(a),o)}Y(t){if(t instanceof f.FileSystemProviderError)return t;let s;switch(t.code){case"ENOENT":s=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=f.FileSystemProviderErrorCode.NoPermissions;break;default:s=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(t,s)}async Z(t,s){let o=this.Y(s);if(t&&o.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await h.SymlinkSupport.stat(this.C(t));a.mode&128||(o=(0,f.createFileSystemProviderError)(s,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return o}}e.DiskFileSystemProvider=n,n.D=!1,n.O=!0}),define(oe[103],ae([0,1,6,3,2,4,9]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("lifecycleSharedProcessService");let R=class extends D.Disposable{constructor(S){super(),this.c=S,this.a=void 0,this.b=this.B(new i.Emitter),this.onWillShutdown=this.b.event}fireOnWillShutdown(){if(this.a)return this.a;this.c.trace("Lifecycle#onWillShutdown.fire()");const S=[];return this.b.fire({join(E){S.push(E)}}),this.a=(async()=>{try{await k.Promises.settled(S)}catch(E){this.c.error(E)}})(),this.a}};R=ye([K(0,O.ILogService)],R),e.SharedProcessLifecycleService=R}),define(oe[104],ae([0,1,3,8,9]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(g,m){this.a=g,this.b=m,this.onDidChangeLogLevel=k.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(g,m,h){switch(m){case"setLevel":return h[1]?this.b.setLevel(i.URI.revive(h[1]),h[0]):this.a.setLevel(h[0])}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=A;class O{constructor(g){this.a=g}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(g,m){O.setLevel(this.a,g,m)}static setLevel(g,m,h){return g.call("setLevel",[m,h])}}e.LogLevelChannelClient=O;class R{constructor(g){this.b=g,this.a=new Map}listen(g,m){throw new Error(`Event not found: ${m}`)}async call(g,m,h){switch(m){case"createLogger":this.c(i.URI.revive(h[0]),h[1]);return;case"log":return this.e(i.URI.revive(h[0]),h[1]);case"consoleLog":return this.d(h[0],h[1])}throw new Error(`Call not found: ${m}`)}c(g,m){this.a.set(g.toString(),this.b.createLogger(g,m))}d(g,m){let h=console.log;switch(g){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...m)}e(g,m){const h=this.a.get(g.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,f]of m)(0,D.log)(h,y,f)}}e.LoggerChannel=R;class P extends D.AbstractLoggerService{constructor(g,m,h){super(g,m),this.g=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(g,m)=>{this.g.call("consoleLog",[g,m])}})}f(g,m,h){return new S(this.g,g,m,h)}}e.LoggerChannelClient=P;class S extends D.AbstractMessageLogger{constructor(g,m,h,y){super(y?.always),this.m=g,this.n=m,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[m,y]).then(()=>{this.r(this.l),this.k=!0})}g(g,m){const h=[[g,m]];this.k?this.r(h):this.l.push(...h)}r(g){this.m.call("log",[this.n,g])}}class E extends D.LogService{constructor(g,m){super(m),this.c=g,this.B(g.onDidChangeLogLevel(h=>m.setLevel(h)))}setLevel(g){super.setLevel(g),this.c.setLevel(g)}}e.FollowerLogService=E}),define(oe[58],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(oe[59],ae([0,1,3,64,2,4]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class O extends D.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new k.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(S){const E=Object.keys(this.f).length;return this.f={...S,...this.f},E!==Object.keys(this.f).length&&await this.i(S),i.Iterable.reduce(this.g.entries(),(b,[g,m])=>({...b,[g]:m}),{})}getPolicyValue(S){return this.g.get(S)}serialize(){return i.Iterable.reduce(Object.entries(this.f),(S,[E,b])=>({...S,[E]:{definition:b,value:this.g.get(E)}}),{})}}e.AbstractPolicyService=O;class R{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(oe[209],ae([0,1,3,2,59]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(P){this.b=P,this.a=new i.DisposableStore}listen(P,S){switch(S){case"onDidChange":return k.Event.map(this.b.onDidChange,E=>E.reduce((b,g)=>({...b,[g]:this.b.getPolicyValue(g)??null}),{}),this.a)}throw new Error(`Event not found: ${S}`)}call(P,S,E){switch(S){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(E)}throw new Error(`Call not found: ${S}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class O extends D.AbstractPolicyService{constructor(P,S){super(),this.a=S;for(const E in P){const{definition:b,value:g}=P[E];this.f[E]=b,g!==void 0&&this.g.set(E,g)}this.a.listen("onDidChange")(E=>{for(const b in E){const g=E[b];g===null?this.g.delete(b):this.g.set(b,g)}this.h.fire(Object.keys(E))})}async i(P){const S=await this.a.call("updatePolicyDefinitions",P);for(const E in S)this.g.set(E,S[E])}}e.PolicyChannelClient=O}),define(oe[105],ae([0,1,5,36]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.context<"u"){const A=k.globals.vscode.context.configuration();if(A)D=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:A.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(oe[25],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[210],ae([0,1,6,7,2,12,28,9,25]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends D.Disposable{constructor(b,g,m){super(),this.b=g,this.c=m,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this.B(new k.RunOnceScheduler(()=>{this.f(b)},3e4)).schedule()}async f(b){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),m=(0,A.dirname)(b),h=(0,A.basename)(b),y=await O.Promises.readdir(m);await Promise.all(y.map(async f=>{if(f===h)return;const l=(0,A.join)(m,f),d=await O.Promises.stat(l);if(d.isDirectory()&&g-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),O.Promises.rm(l)}))}catch(g){(0,i.onUnexpectedError)(g)}}};S=ye([K(1,P.IProductService),K(2,R.ILogService)],S),e.CodeCacheCleaner=S}),define(oe[211],ae([0,1,6,7,2,12,28,15,9,25]),function(Z,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let E=class extends D.Disposable{constructor(g,m,h){super(),this.b=g,this.c=m,this.f=h,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new k.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),m=JSON.parse(await O.Promises.readFile((0,A.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(m)){const p=m[d];g[`${p.hash}.${d}`]=!0}const h=(0,A.join)(this.b.userDataPath,"clp");if(!await O.Promises.exists(h))return;const f=await O.Promises.readdir(h);for(const d of f){if(g[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await O.Promises.rm((0,A.join)(h,d))}const l=Date.now();for(const d of Object.keys(g)){const p=(0,A.join)(h,d),w=await O.Promises.readdir(p);for(const I of w){if(I==="tcf.json")continue;const n=(0,A.join)(p,I),c=await O.Promises.stat(n);c.isDirectory()&&l-c.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(d,I)}`),await O.Promises.rm(n))}}}catch(g){(0,i.onUnexpectedError)(g)}}};E=ye([K(0,R.INativeEnvironmentService),K(1,P.ILogService),K(2,S.IProductService)],E),e.LanguagePackCachedDataCleaner=E}),define(oe[212],ae([0,1,21,2,22,188,14,25]),function(Z,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let P=class extends i.Disposable{constructor(E,b){super(),this.b=E,this.c=b,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,g])=>this.a.set(g.configPath,g))}getConfigBasedTips(E){return this.f(E)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(E){const b=[];for(const[g,m]of this.a)if(!(m.configScheme&&m.configScheme!==E.scheme))try{const h=await this.b.readFile((0,D.joinPath)(E,g)),y=new Map;Object.entries(m.recommendations).forEach(([l,d])=>{if((0,k.isNonEmptyArray)(d.remotes))for(const p of d.remotes)y.set(p,{extensionId:l,extensionName:d.name,configName:m.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled});else b.push({extensionId:l,extensionName:d.name,configName:m.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled})});const f=(0,A.getDomainsOfRemotes)(h.value.toString(),[...y.keys()]);for(const l of f){const d=y.get(l);d&&b.push(d)}}catch{}return b}};P=ye([K(0,O.IFileService),K(1,R.IProductService)],P),e.ExtensionTipsService=P}),define(oe[213],ae([0,1,12,4]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var D;(function(A){function O(P){return Boolean(P.samples&&P.timeDeltas)}A.isValidProfile=O;function R(P,S="noAbsolutePaths"){for(const E of P.nodes)E.callFrame&&E.callFrame.url&&((0,k.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,k.join)(S,(0,k.basename)(E.callFrame.url)));return P}A.rewriteAbsolutePaths=R})(D=e.Utils||(e.Utils={}))}),define(oe[214],ae([0,1,31]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise((S,E)=>{Z(["v8-inspect-profiler"],S,E)})).startProfiling({port:A.port,checkForPaused:!0}),P=(0,k.generateUuid)();return this.a.set(P,R),P}async stopProfiling(A){const O=this.a.get(A);if(!O)throw new Error(`UNKNOWN session '${A}'`);const R=await O.stop();return this.a.delete(A),R.profile}}e.InspectProfilingService=i}),define(oe[40],ae([0,1,128,13]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(O,R){k.ok(i.isString(O)),k.ok(i.isObject(R)),k.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.Registry=new D}),define(oe[106],ae([0,1,3,40]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new k.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(P,S){this.a[D(P)]=S,this.b.fire(P)}notifySchemaChanged(P){this.b.fire(P)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;i.Registry.add(e.Extensions.JSONContribution,O)}),define(oe[46],ae([0,1,21,3,13,153,16,106,40]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=P.Registry.as(R.Extensions.JSONContribution);class g{constructor(){this.h=new Set,this.i=new i.Emitter,this.onDidSchemaChange=this.i.event,this.j=new i.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(n,c=!0){this.registerConfigurations([n],c)}registerConfigurations(n,c=!0){const t=new Set;this.n(n,c,t),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const c=new Set;this.o(n,c),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:n,remove:c}){const t=new Set;this.o(c,t),this.n(n,!1,t),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const c=new Set;this.k(n,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(n,c){const t=[];for(const{overrides:s,source:o}of n)for(const a in s)if(c.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const r=this.a.get(a),u=r?.valuesSources??new Map;if(o)for(const N of Object.keys(s[a]))u.set(N,o);const v={...r?.value||{},...s[a]};this.a.set(a,{source:o,value:v,valuesSources:u});const C=(0,O.getLanguageTagSettingPlainKey)(a),T={type:"object",default:v,description:A.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:D.isString(o)?void 0:o,defaultValueSource:o};t.push(...y(a)),this.d[a]=T,this.b.properties[a]=T}else{this.a.set(a,{value:s[a],source:o});const r=this.d[a];r&&(this.w(a,r),this.r(a,r))}this.m(t)}deregisterDefaultConfigurations(n){const c=new Set;this.l(n,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(n,c){for(const{overrides:t,source:s}of n)for(const o in t){const a=this.a.get(o),r=D.isString(s)?s:s?.id,u=D.isString(a?.source)?a?.source:a?.source?.id;if(r===u)if(c.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const v=this.d[o];v&&(this.w(o,v),this.r(o,v))}}this.u()}deltaConfiguration(n){let c=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),c=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),c=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const c of n)this.h.add(c);this.u()}n(n,c,t){n.forEach(s=>{this.p(s,c,s.extensionInfo,s.restrictedProperties,void 0,t),this.c.push(s),this.q(s)})}o(n,c){const t=s=>{if(s.properties)for(const o in s.properties){c.add(o);const a=this.d[o];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[o],this.s(o,s.properties[o])}s.allOf?.forEach(o=>t(o))};for(const s of n){t(s);const o=this.c.indexOf(s);o!==-1&&this.c.splice(o,1)}}p(n,c=!0,t,s,o=3,a){o=D.isUndefinedOrNull(n.scope)?o:n.scope;const r=n.properties;if(r)for(const v in r){const C=r[v];if(c&&p(v,C)){delete r[v];continue}if(C.source=t,C.defaultDefaultValue=r[v].default,this.w(v,C),e.OVERRIDE_PROPERTY_REGEX.test(v)?C.scope=void 0:(C.scope=D.isUndefinedOrNull(C.scope)?o:C.scope,C.restricted=D.isUndefinedOrNull(C.restricted)?!!s?.includes(v):C.restricted),r[v].hasOwnProperty("included")&&!r[v].included){this.f[v]=r[v],delete r[v];continue}else this.d[v]=r[v],r[v].policy?.name&&this.e.set(r[v].policy.name,v);!r[v].deprecationMessage&&r[v].markdownDeprecationMessage&&(r[v].deprecationMessage=r[v].markdownDeprecationMessage),a.add(v)}const u=n.allOf;if(u)for(const v of u)this.p(v,c,t,s,o,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const c=t=>{const s=t.properties;if(s)for(const a in s)this.r(a,s[a]);t.allOf?.forEach(c)};c(n)}r(n,c){switch(e.allSettings.properties[n]=c,c.scope){case 1:e.applicationSettings.properties[n]=c;break;case 2:e.machineSettings.properties[n]=c;break;case 6:e.machineOverridableSettings.properties[n]=c;break;case 3:e.windowSettings.properties[n]=c;break;case 4:e.resourceSettings.properties[n]=c;break;case 5:e.resourceSettings.properties[n]=c,this.g.properties[n]=c;break}}s(n,c){switch(delete e.allSettings.properties[n],c.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const c=`[${n}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(c,t),e.allSettings.properties[c]=t,e.applicationSettings.properties[c]=t,e.machineSettings.properties[c]=t,e.machineOverridableSettings.properties[c]=t,e.windowSettings.properties[c]=t,e.resourceSettings.properties[c]=t}}v(){const n={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}w(n,c){const t=this.a.get(n);let s=t?.value,o=t?.source;D.isUndefined(s)&&(s=c.defaultDefaultValue,o=void 0),D.isUndefined(s)&&(s=l(c.type)),c.default=s,c.defaultValueSource=o}}const m="\\[([^\\]]+)\\]",h=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(I){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(I)){let c=h.exec(I);for(;c?.length;){const t=c[1].trim();t&&n.push(t),c=h.exec(I)}}return(0,k.distinct)(n)}e.overrideIdentifiersFromKey=y;function f(I){return I.reduce((n,c)=>`${n}[${c}]`,"")}e.keyFromOverrideIdentifiers=f;function l(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const d=new g;P.Registry.add(e.Extensions.Configuration,d);function p(I,n){return I.trim()?e.OVERRIDE_PROPERTY_REGEX.test(I)?A.localize(7,null,I):d.getConfigurationProperties()[I]!==void 0?A.localize(8,null,I):n.policy?.name&&d.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(9,null,I,n.policy?.name,d.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(6,null)}e.validateProperty=p;function w(){const I=[],n=d.getConfigurationProperties();for(const c of Object.keys(n))I.push([c,n[c].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=w}),define(oe[74],ae([0,1,21,3,35,2,37,32,13,8,16,46,40]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function m(c){return Object.isFrozen(c)?c:R.deepFreeze(c)}class h{constructor(t={},s=[],o=[],a){this.b=t,this.c=s,this.d=o,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(s=>{if(s instanceof h)return s;const o=new y("");return o.parseRaw(s),o.configurationModel});this.f=t.reduce((s,o)=>o===s?o:s.merge(o),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,E.getConfigurationValue)(this.contents,t):this.contents}inspect(t,s){const o=this.rawConfiguration.getValue(t),a=s?this.rawConfiguration.getOverrideValue(t,s):void 0,r=s?this.rawConfiguration.override(s).getValue(t):o;return{value:o,override:a,merged:r}}getOverrideValue(t,s){const o=this.i(s);return o?t?(0,E.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const s=[];for(const o of this.overrides)o.identifiers.includes(t)&&s.push(...o.keys);return k.distinct(s)}getAllOverrideIdentifiers(){const t=[];for(const s of this.overrides)t.push(...s.identifiers);return k.distinct(t)}override(t){let s=this.a.get(t);return s||(s=this.g(t),this.a.set(t,s)),s}merge(...t){const s=R.deepClone(this.contents),o=R.deepClone(this.overrides),a=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const u of t)if(r.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(s,u.contents);for(const v of u.overrides){const[C]=o.filter(T=>k.equals(T.identifiers,v.identifiers));C?(this.h(C.contents,v.contents),C.keys.push(...v.keys),C.keys=k.distinct(C.keys)):o.push(R.deepClone(v))}for(const v of u.keys)a.indexOf(v)===-1&&a.push(v)}return new h(s,a,o,r.every(u=>u instanceof h)?void 0:r)}g(t){const s=this.i(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const a of k.distinct([...Object.keys(this.contents),...Object.keys(s)])){let r=this.contents[a];const u=s[a];u&&(typeof r=="object"&&typeof u=="object"?(r=R.deepClone(r),this.h(r,u)):r=u),o[a]=r}return new h(o,this.keys,this.overrides)}h(t,s){for(const o of Object.keys(s)){if(o in t&&P.isObject(t[o])&&P.isObject(s[o])){this.h(t[o],s[o]);continue}t[o]=R.deepClone(s[o])}}i(t){let s=null,o=null;const a=r=>{r&&(o?this.h(o,r):o=R.deepClone(r))};for(const r of this.overrides)k.equals(r.identifiers,[t])?s=r.contents:r.identifiers.includes(t)&&a(r.contents);return a(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,s){this.j(t,s,!0)}setValue(t,s){this.j(t,s,!1)}removeValue(t){const s=this.keys.indexOf(t);s!==-1&&(this.keys.splice(s,1),(0,E.removeFromValueTree)(this.contents,t),b.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>k.equals(o.identifiers,(0,b.overrideIdentifiersFromKey)(t))),1))}j(t,s,o){(0,E.addToValueTree)(this.contents,t,s,a=>console.error(a)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),b.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,E.toValuesTree)(this.contents[t],a=>console.error(a))})}}e.ConfigurationModel=h;class y{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new h}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,s){if(!P.isUndefinedOrNull(t)){const o=this.g(t);this.parseRaw(o,s)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,s){this.a=t;const{contents:o,keys:a,overrides:r,restricted:u,hasExcludedProperties:v}=this.h(t,s);this.b=new h(o,a,r,v?[t]:void 0),this.c=u||[]}g(t){let s={},o=null,a=[];const r=[],u=[];function v(T){Array.isArray(a)?a.push(T):o!==null&&(a[o]=T)}const C={onObjectBegin:()=>{const T={};v(T),r.push(a),a=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{a=r.pop()},onArrayBegin:()=>{const T=[];v(T),r.push(a),a=T,o=null},onArrayEnd:()=>{a=r.pop()},onLiteralValue:v,onError:(T,N,F)=>{u.push({error:T,offset:N,length:F})}};if(t)try{D.visit(t,C),s=a[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return s}h(t,s){const o=g.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),a=this.i(t,o,!0,s);t=a.raw;const r=(0,E.toValuesTree)(t,C=>console.error(`Conflict in settings file ${this.f}: ${C}`)),u=Object.keys(t),v=this.j(t,C=>console.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:r,keys:u,overrides:v,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(t,s,o,a){let r=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:r};const u={},v=[];for(const C in t)if(b.OVERRIDE_PROPERTY_REGEX.test(C)&&o){const T=this.i(t[C],s,!1,a);u[C]=T.raw,r=r||T.hasExcludedProperties,v.push(...T.restricted)}else{const T=s[C],N=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&v.push(C),(N===void 0||a.scopes===void 0||a.scopes.includes(N))&&!(a.skipRestricted&&T?.restricted)?u[C]=t[C]:r=!0}return{raw:u,restricted:v,hasExcludedProperties:r}}j(t,s){const o=[];for(const a of Object.keys(t))if(b.OVERRIDE_PROPERTY_REGEX.test(a)){const r={};for(const u in t[a])r[u]=t[a][u];o.push({identifiers:(0,b.overrideIdentifiersFromKey)(a),keys:Object.keys(r),contents:(0,E.toValuesTree)(r,s)})}return o}}e.ConfigurationModelParser=y;class f extends A.Disposable{constructor(t,s,o,a){super(),this.f=t,this.g=s,this.h=a,this.c=this.B(new i.Emitter),this.onDidChange=this.c.event,this.a=new y(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(i.Event.any(i.Event.filter(this.h.onDidFilesChange,r=>r.contains(this.f)),i.Event.filter(this.h.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&o.isEqual(r.resource,t)))(()=>this.c.fire()))}async loadConfiguration(){try{const t=await this.h.readFile(this.f);return this.a.parse(t.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new h}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=f;class l{constructor(t,s,o,a,r,u,v,C,T,N,F,j,L){this.a=t,this.b=s,this.c=o,this.overrideIdentifiers=a,this.d=r,this.f=u,this.g=v,this.h=C,this.i=T,this.j=N,this.k=F,this.l=j,this.m=L}get value(){return m(this.c)}n(t,s,o){const a=t.inspect(s,o);return{get value(){return m(a.value)},get override(){return m(a.override)},get merged(){return m(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(t,s,o,a,r=new h,u=new h,v=new O.ResourceMap,C=new h,T=new O.ResourceMap){this.c=t,this.d=s,this.f=o,this.g=a,this.h=r,this.i=u,this.j=v,this.l=C,this.m=T,this.a=null,this.b=new O.ResourceMap,this.n=null}getValue(t,s,o){return this.q(t,s,o).getValue(t)}updateValue(t,s,o={}){let a;o.resource?(a=this.m.get(o.resource),a||(a=new h,this.m.set(o.resource,a))):a=this.l,s===void 0?a.removeValue(t):a.setValue(t,s),o.resource||(this.a=null)}inspect(t,s,o){const a=this.q(t,s,o),r=this.u(s.resource,o),u=s.resource?this.m.get(s.resource)||this.l:this.l,v=new Set;for(const C of a.overrides)for(const T of C.identifiers)a.getOverrideValue(t,T)!==void 0&&v.add(T);return new l(t,s,a.getValue(t),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,r||void 0,u)}keys(t){const s=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,s){this.j.set(t,s),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const o=[];if(!s){const{added:a,updated:r,removed:u}=I(this.c,t);s=[...a,...r,...u]}for(const a of s)for(const r of(0,b.overrideIdentifiersFromKey)(a)){const u=this.c.getKeysForOverrideIdentifier(r),v=t.getKeysForOverrideIdentifier(r),C=[...v.filter(T=>u.indexOf(T)===-1),...u.filter(T=>v.indexOf(T)===-1),...u.filter(T=>!R.equals(this.c.override(r).getValue(T),t.override(r).getValue(T)))];o.push([r,C])}return this.updateDefaultConfiguration(t),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:s,updated:o,removed:a}=I(this.d,t),r=[...s,...o,...a];return r.length&&this.updatePolicyConfiguration(t),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:s,updated:o,removed:a,overrides:r}=I(this.applicationConfiguration,t),u=[...s,...o,...a];return u.length&&this.updateApplicationConfiguration(t),{keys:u,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:o,removed:a,overrides:r}=I(this.localUserConfiguration,t),u=[...s,...o,...a];return u.length&&this.updateLocalUserConfiguration(t),{keys:u,overrides:r}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:o,removed:a,overrides:r}=I(this.remoteUserConfiguration,t),u=[...s,...o,...a];return u.length&&this.updateRemoteUserConfiguration(t),{keys:u,overrides:r}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:o,removed:a,overrides:r}=I(this.workspaceConfiguration,t),u=[...s,...o,...a];return u.length&&this.updateWorkspaceConfiguration(t),{keys:u,overrides:r}}compareAndUpdateFolderConfiguration(t,s){const o=this.p.get(t),{added:a,updated:r,removed:u,overrides:v}=I(o,s),C=[...a,...r,...u];return(C.length||!o)&&this.updateFolderConfiguration(t,s),{keys:C,overrides:v}}compareAndDeleteFolderConfiguration(t){const s=this.p.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:a,removed:r,overrides:u}=I(s,void 0);return{keys:[...o,...a,...r],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,s,o){let a=this.r(s,o);return s.overrideIdentifier&&(a=a.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(a=a.merge(this.d)),a}r({resource:t},s){let o=this.s();if(s&&t){const a=s.getFolder(t);a&&(o=this.t(a.uri)||o);const r=this.m.get(t);r&&(o=o.merge(r))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let s=this.b.get(t);if(!s){const o=this.s(),a=this.j.get(t);a?(s=o.merge(a),this.b.set(t,s)):s=o}return s}u(t,s){if(s&&t){const o=s.getFolder(t);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,s)=>{const{contents:o,overrides:a,keys:r}=this.j.get(s);return t.push([s,{contents:o,overrides:a,keys:r}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(s=>t.add(s)),this.userConfiguration.keys.forEach(s=>t.add(s)),this.i.keys.forEach(s=>t.add(s)),this.j.forEach(s=>s.keys.forEach(o=>t.add(o))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>t.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}w(t){const s=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.i.getKeysForOverrideIdentifier(t).forEach(o=>s.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(a=>s.add(a))),[...s.values()]}static parse(t){const s=this.x(t.defaults),o=this.x(t.policy),a=this.x(t.application),r=this.x(t.user),u=this.x(t.workspace),v=t.folders.reduce((C,T)=>(C.set(S.URI.revive(T[0]),this.x(T[1])),C),new O.ResourceMap);return new d(s,o,a,r,new h,u,v,new h,new O.ResourceMap)}static x(t){return new h(t.contents,t.keys,t.overrides)}}e.Configuration=d;function p(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,s=new Map;for(const a of c)a.keys.forEach(r=>t.add(r)),a.overrides.forEach(([r,u])=>{const v=(0,O.getOrSet)(s,r,new Set);u.forEach(C=>v.add(C))});const o=[];return s.forEach((a,r)=>o.push([r,[...a.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=p;class w{constructor(t,s,o,a){this.change=t,this.f=s,this.g=o,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const r of t.keys)this.affectedKeys.add(r);for(const[,r]of t.overrides)for(const u of r)this.affectedKeys.add(u);this.d=this.a;for(const r of this.affectedKeys)this.d+=r+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(t,s){const o=this.a+t,a=this.d.indexOf(o);if(a<0)return!1;const r=a+o.length;if(r>=this.d.length)return!1;const u=this.d.charCodeAt(r);if(u!==this.b&&u!==this.c)return!1;if(s){const v=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.f?.workspace):void 0,C=this.g.getValue(t,s,this.h);return!R.equals(v,C)}return!0}}e.ConfigurationChangeEvent=w;function I(c,t){const{added:s,removed:o,updated:a}=n(t?.rawConfiguration,c?.rawConfiguration),r=[],u=c?.getAllOverrideIdentifiers()||[],v=t?.getAllOverrideIdentifiers()||[];if(t){const C=v.filter(T=>!u.includes(T));for(const T of C)r.push([T,t.getKeysForOverrideIdentifier(T)])}if(c){const C=u.filter(T=>!v.includes(T));for(const T of C)r.push([T,c.getKeysForOverrideIdentifier(T)])}if(t&&c){for(const C of u)if(v.includes(C)){const T=n({contents:c.getOverrideValue(void 0,C)||{},keys:c.getKeysForOverrideIdentifier(C)},{contents:t.getOverrideValue(void 0,C)||{},keys:t.getKeysForOverrideIdentifier(C)});r.push([C,[...T.added,...T.removed,...T.updated]])}}return{added:s,removed:o,updated:a,overrides:r}}function n(c,t){const s=c?t?c.keys.filter(r=>t.keys.indexOf(r)===-1):[...c.keys]:[],o=t?c?t.keys.filter(r=>c.keys.indexOf(r)===-1):[...t.keys]:[],a=[];if(c&&t){for(const r of t.keys)if(c.keys.indexOf(r)!==-1){const u=(0,E.getConfigurationValue)(t.contents,r),v=(0,E.getConfigurationValue)(c.contents,r);R.equals(u,v)||a.push(r)}}return{added:s,removed:o,updated:a}}}),define(oe[215],ae([0,1,21,3,2,32,13,74,46,9,59,40]),function(Z,e,k,i,D,A,O,R,P,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class g extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:l})=>this.c(Array.from(f),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(f,l){this.h(f,b.Registry.as(P.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:f})}f(){return{}}g(){this.b=new R.ConfigurationModel;const f=b.Registry.as(P.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(f),f)}h(f,l){const d=this.f();for(const p of f){const w=d[p],I=l[p];w!==void 0?this.b.addValue(p,w):I?this.b.addValue(p,I.default):this.b.removeValue(p)}}}e.DefaultConfiguration=g;class m{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new R.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=m;let h=class extends D.Disposable{get configurationModel(){return this.b}constructor(f,l,d){super(),this.c=f,this.f=l,this.g=d,this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new R.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(f=>this.i(f))),this.B(this.c.onDidChangeConfiguration(async({properties:f})=>this.j(await this.h(f),!0))),this.b}async h(f){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",f);const l={},d=[],p=b.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(const w of f){const I=p[w];if(!I){d.push(w);continue}if(I.policy){if(I.type!=="string"&&I.type!=="number"){this.g.warn(`Policy ${I.policy.name} has unsupported type ${I.type}`);continue}d.push(w),l[I.policy.name]={type:I.type}}}return(0,O.isEmptyObject)(l)||await this.f.updatePolicyDefinitions(l),d}i(f){this.g.trace("PolicyConfiguration#onDidChangePolicies",f);const l=b.Registry.as(P.Extensions.Configuration).getPolicyConfigurations(),d=(0,k.coalesce)(f.map(p=>l.get(p)));this.j(d,!0)}j(f,l){this.g.trace("PolicyConfiguration#update",f);const d=b.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),p=[],w=this.b.isEmpty();for(const I of f){const n=d[I]?.policy?.name;if(n){const c=this.f.getPolicyValue(n);(w?c!==void 0:!(0,A.equals)(this.b.getValue(I),c))&&p.push([I,c])}else this.b.getValue(I)!==void 0&&p.push([I,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const I=this.b;this.b=new R.ConfigurationModel;for(const n of I.keys)this.b.setValue(n,I.getValue(n));for(const[n,c]of p)c===void 0?this.b.removeValue(n):this.b.setValue(n,c);l&&this.a.fire(this.b)}}};h=ye([K(1,E.IPolicyService),K(2,S.ILogService)],h),e.PolicyConfiguration=h}),define(oe[216],ae([0,1,6,3,2,22,16,74,215,59]),function(Z,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends D.Disposable{constructor(g,m,h,y){super(),this.i=g,this.h=this.B(new i.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new P.DefaultConfiguration),this.c=h instanceof S.NullPolicyService?new P.NullPolicyConfiguration:this.B(new P.PolicyConfiguration(this.b,h,y)),this.f=this.B(new R.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,m)),this.a=new R.Configuration(this.b.configurationModel,this.c.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.g=this.B(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:l})=>this.k(f,l))),this.B(this.c.onDidChangeConfiguration(f=>this.l(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,m,h]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.Configuration(g,m,new R.ConfigurationModel,h)}getConfigurationData(){return this.a.toData()}getValue(g,m){const h=typeof g=="string"?g:void 0,y=(0,O.isConfigurationOverrides)(g)?g:(0,O.isConfigurationOverrides)(m)?m:{};return this.a.getValue(h,y,void 0)}updateValue(g,m,h,y){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.j(g)}j(g){const m=this.a.toData(),h=this.a.compareAndUpdateLocalUserConfiguration(g);this.m(h,m,2)}k(g,m){const h=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(g,m);this.m(y,h,7)}l(g){const m=this.a.toData(),h=this.a.compareAndUpdatePolicyConfiguration(g);this.m(h,m,7)}m(g,m,h){const y=new R.ConfigurationChangeEvent(g,{data:m},this.a);y.source=h,y.sourceConfig=this.n(h),this.h.fire(y)}n(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(oe[217],ae([0,1,7,4]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var D;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends k.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof A&&P._code===D.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof A&&P._code===D.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof A&&P._code===D.NoResolverFound}static isHandled(P){return P instanceof A&&P.isHandled}constructor(P,S=D.Unknown,E){super(P),this._message=P,this._code=S,this._detail=E,this.isHandled=S===D.NotAvailable&&E===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A;function O(R){const P=R.indexOf("+");return P===-1?R:R.substring(0,P)}e.getRemoteAuthorityPrefix=O}),define(oe[75],ae([0,1,24]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(S){return S.scheme===k.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=i;function D(S){if(!S)return;const E=S.indexOf("+");return E<0?S:S.substr(0,E)}e.getRemoteName=D;function A(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=A;function O(S){const{host:E,port:b}=P(S);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:b}}e.parseAuthorityWithPort=O;function R(S,E){let{host:b,port:g}=P(S);return typeof g>"u"&&(g=E),{host:b,port:g}}e.parseAuthorityWithOptionalPort=R;function P(S){const E=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const b=S.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const g=S.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:S,port:void 0}}}),define(oe[42],ae([0,1,27,4,75]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=A;function O(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var P;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(y){this.value=y,this.c=y.toLowerCase()}static equals(y,f){if(typeof y>"u"||y===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof y=="string"||typeof f=="string"){const l=typeof y=="string"?y:y.value,d=typeof f=="string"?f:f.value;return k.equalsIgnoreCase(l,d)}return y.c===f.c}static toKey(y){return typeof y=="string"?y.toLowerCase():y.c}}e.ExtensionIdentifier=S;function E(h){return b(h)}e.isApplicationScopedExtension=E;function b(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function g(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function m(h,y){if(y){const f=`onResolveRemoteAuthority:${(0,D.getRemoteName)(y)}`;return h.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[218],ae([0,1,2,12,28,42]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends k.Disposable{constructor(P,S){super(),this.b=P,this.a=(0,i.join)(this.b.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this.B(S.onDidInstallExtensions(E=>this.c(E))),this.B(S.onDidUninstallExtension(E=>this.f(E)))}c(P){P.some(S=>!!S.local)&&this.invalidate()}f(P){P.error||this.invalidate()}invalidate(){D.Promises.rm(this.a,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(oe[219],ae([0,1,6,17,23,7,3,2,102,88,31,93,217,75]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const h=30*1e3;var y;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function f(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(W){const q=new D.CancellationTokenSource;return setTimeout(()=>q.cancel(),W),q.token}function d(W,q){if(W.isCancellationRequested||q.isCancellationRequested)return D.CancellationToken.Cancelled;const J=new D.CancellationTokenSource;return W.onCancellationRequested(()=>J.cancel()),q.onCancellationRequested(()=>J.cancel()),J.token}class p{get didTimeout(){return this.c==="timedout"}constructor(q){this.c="pending",this.d=new R.DisposableStore,this.promise=new Promise((J,_)=>{this.f=J,this.g=_}),q.isCancellationRequested?this.h():this.d.add(q.onCancellationRequested(()=>this.h()))}registerDisposable(q){this.c==="pending"?this.d.add(q):q.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const q=new Error("Time limit reached");return q.code="ETIMEDOUT",q.syscall="connect",q}resolve(q){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(q))}reject(q){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(q))}}function w(W,q){const J=new p(q);return J.registerDisposable(W.onControlMessage(_=>{const Y=JSON.parse(_.toString()),Q=x(Y);Q?J.reject(Q):J.resolve(Y)})),J.promise}function I(W,q,J,_,Y,Q,se,le,ue){const pe=new p(ue),we=S.StopWatch.create(!1);return W.info(`Creating a socket (${le})...`),P.mark(`code/willCreateSocket/${se}`),q.connect(J,_,Y,Q,le,(be,Ee)=>{pe.didTimeout?(P.mark(`code/didCreateSocketError/${se}`),W.info(`Creating a socket (${le}) finished after ${we.elapsed()} ms, but this is too late and has timed out already.`),be&&W.error(be),Ee?.dispose()):be||!Ee?(P.mark(`code/didCreateSocketError/${se}`),W.info(`Creating a socket (${le}) returned an error after ${we.elapsed()} ms.`),pe.reject(be)):(P.mark(`code/didCreateSocketOK/${se}`),W.info(`Creating a socket (${le}) was successful after ${we.elapsed()} ms.`),pe.resolve(Ee))}),pe.promise}function n(W,q){const J=new p(q);return W.then(_=>{J.didTimeout||J.resolve(_)},_=>{J.didTimeout||J.reject(_)}),J.promise}async function c(W,q,J,_){const Y=U(W,q);W.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await I(W.logService,W.socketFactory,W.host,W.port,(0,m.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,f(q),`renderer-${f(q)}-${W.reconnectionToken}`,_)}catch(we){throw W.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),W.logService.error(we),we}W.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let se,le;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(Q,null),se=W.reconnectionProtocol,le=!1):(se=new b.PersistentProtocol({socket:Q,measureRoundTripTime:!0}),le=!0),W.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const ue=await n(W.signService.createNewMessage((0,E.generateUuid)()),_),pe={type:"auth",auth:W.connectionToken||"00000000000000000000",data:ue.data};se.sendControl(i.VSBuffer.fromString(JSON.stringify(pe)));try{const we=await w(se,d(_,l(1e4)));if(we.type!=="sign"||typeof we.data!="string"){const Ue=new Error("Unexpected handshake message");throw Ue.code="VSCODE_CONNECTION_ERROR",Ue}if(W.logService.trace(`${Y} 4/6. received SignRequest control message.`),!await n(W.signService.validate(ue,we.signedData),_)){const Ue=new Error("Refused to connect to unsupported server");throw Ue.code="VSCODE_CONNECTION_ERROR",Ue}const Ee=await n(W.signService.sign(we.data),_),Te={type:"connectionType",commit:W.commit,signedData:Ee,desiredConnectionType:q};return J&&(Te.args=J),W.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),se.sendControl(i.VSBuffer.fromString(JSON.stringify(Te))),{protocol:se,ownsProtocol:le}}catch(we){throw we&&we.code==="ETIMEDOUT"&&(W.logService.error(`${Y} the handshake timed out. Error:`),W.logService.error(we)),we&&we.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${Y} received error control message when negotiating connection. Error:`),W.logService.error(we)),le&&V(se),we}}async function t(W,q,J,_){const Y=Date.now(),Q=U(W,q),{protocol:se,ownsProtocol:le}=await c(W,q,J,_),ue=new p(_);return ue.registerDisposable(se.onControlMessage(pe=>{const we=JSON.parse(pe.toString()),be=x(we);be?(W.logService.error(`${Q} received error control message when negotiating connection. Error:`),W.logService.error(be),le&&V(se),ue.reject(be)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${B(Y)}!`),ue.resolve({protocol:se,firstMessage:we}))})),ue.promise}async function s(W,q){const{protocol:J}=await t(W,1,void 0,q);return{protocol:J}}async function o(W,q,J){const{protocol:_,firstMessage:Y}=await t(W,2,q,J),Q=Y&&Y.debugPort;return{protocol:_,debugPort:Q}}async function a(W,q,J){const _=Date.now(),Y=U(W,3),{protocol:Q}=await c(W,3,q,J);return W.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${B(_)}!`),Q}async function r(W,q,J){const{host:_,port:Y,connectionToken:Q}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,host:_,port:Y,connectionToken:Q,reconnectionToken:q,reconnectionProtocol:J,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function u(W,q,J){return C(W,async _=>{const{protocol:Y}=await s(_,D.CancellationToken.None);return new G(W,q,J,_.reconnectionToken,Y)})}e.connectRemoteAgentManagement=u;async function v(W,q){return C(W,async J=>{const{protocol:_,debugPort:Y}=await o(J,q,D.CancellationToken.None);return new M(W,q,J.reconnectionToken,_,Y)})}e.connectRemoteAgentExtensionHost=v;async function C(W,q){for(let _=1;;_++)try{const Y=(0,E.generateUuid)(),Q=await r(W,Y,null);return await q(Q)}catch(Y){if(_<5)W.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(Y);else throw W.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(Y),ie.triggerPermanentFailure(0,0,g.RemoteAuthorityResolverError.isHandled(Y)),Y}}async function T(W,q,J){const _=await r(W,(0,E.generateUuid)(),null);return await a(_,{host:q,port:J},D.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function N(W){return(0,k.createCancelablePromise)(q=>new Promise((J,_)=>{const Y=setTimeout(J,W*1e3);q.onCancellationRequested(()=>{clearTimeout(Y),J()})}))}var F;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain",W[W.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class j{constructor(q,J){this.reconnectionToken=q,this.millisSinceLastIncomingData=J,this.type=0}}e.ConnectionLostEvent=j;class L{constructor(q,J,_,Y){this.reconnectionToken=q,this.millisSinceLastIncomingData=J,this.durationSeconds=_,this.c=Y,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=L;class ${constructor(q,J,_){this.reconnectionToken=q,this.millisSinceLastIncomingData=J,this.attempt=_,this.type=2}}e.ReconnectionRunningEvent=$;class z{constructor(q,J,_){this.reconnectionToken=q,this.millisSinceLastIncomingData=J,this.attempt=_,this.type=4}}e.ConnectionGainEvent=z;class H{constructor(q,J){this.reconnectionToken=q,this.connectionHealth=J,this.type=5}}e.ConnectionHealthChangedEvent=H;class X{constructor(q,J,_,Y){this.reconnectionToken=q,this.millisSinceLastIncomingData=J,this.attempt=_,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=X;class ie extends R.Disposable{static triggerPermanentFailure(q,J,_){this._permanentFailure=!0,this.f=q,this.g=J,this.h=_,this.i.forEach(Y=>Y.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(q=>q.r())}static debugPauseSocketWriting(){this.i.forEach(q=>q.v())}get k(){return this.c||ie._permanentFailure}constructor(q,J,_,Y,Q){super(),this.m=q,this.n=J,this.reconnectionToken=_,this.protocol=Y,this.p=Q,this.j=this.B(new O.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new z(this.reconnectionToken,0,0)),this.B(Y.onSocketClose(se=>{const le=te(this.m,this.reconnectionToken,!0);se?se.type===0?(this.n.logService.info(`${le} received socket close event (hadError: ${se.hadError}).`),se.error&&this.n.logService.error(se.error)):(this.n.logService.info(`${le} received socket close event (wasClean: ${se.wasClean}, code: ${se.code}, reason: ${se.reason}).`),se.event&&this.n.logService.error(se.event)):this.n.logService.info(`${le} received socket close event.`),this.r()})),this.B(Y.onSocketTimeout(se=>{const le=te(this.m,this.reconnectionToken,!0);this.n.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${se.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${se.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${se.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(Y.onHighRoundTripTime(se=>{const le=re(this.m,this.reconnectionToken);this.n.logService.info(`${le} high roundtrip time: ${se.roundTripTime}ms (${se.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(Y.onDidChangeConnectionHealth(se=>{this.j.fire(new H(this.reconnectionToken,se))})),ie.i.push(this),this.B((0,R.toDisposable)(()=>{const se=ie.i.indexOf(this);se>=0&&ie.i.splice(se,1)})),this.k&&this.u(ie.f,ie.g,ie.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const q=te(this.m,this.reconnectionToken,!0);this.n.logService.info(`${q} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const J=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const Y=_<J.length?J[_]:J[J.length-1];try{if(Y>0){const se=N(Y);this.j.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,se)),this.n.logService.info(`${q} waiting for ${Y} seconds before reconnecting...`);try{await se}catch{}}if(this.k){this.n.logService.error(`${q} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new $(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.n.logService.info(`${q} resolving connection...`);const Q=await r(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${q} connecting to ${Q.host}:${Q.port}...`),await this.w(Q,l(h)),this.n.logService.info(`${q} reconnected!`),this.j.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.n.logService.error(`${q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(g.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Q)){this.n.logService.info(`${q} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.n.logService.info(`${q} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Q);continue}if((0,A.isCancellationError)(Q)){this.n.logService.info(`${q} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Q);continue}if(Q instanceof g.RemoteAuthorityResolverError){this.n.logService.error(`${q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,g.RemoteAuthorityResolverError.isHandled(Q));break}this.n.logService.error(`${q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(Q),this.t(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.k)}t(q,J,_){this.p?ie.triggerPermanentFailure(q,J,_):this.u(q,J,_)}u(q,J,_){this.j.fire(new X(this.reconnectionToken,q,J,_)),V(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ie,ie._permanentFailure=!1,ie.f=0,ie.g=0,ie.h=!1,ie.i=[];class G extends ie{constructor(q,J,_,Y,Q){super(1,q,Y,Q,!0),this.client=this.B(new b.Client(Q,{remoteAuthority:J,clientId:_},q.ipcLogger))}async w(q,J){await s(q,J)}}e.ManagementPersistentConnection=G;class M extends ie{constructor(q,J,_,Y,Q){super(2,q,_,Y,!1),this.y=J,this.debugPort=Q}async w(q,J){await o(q,this.y,J)}}e.ExtensionHostPersistentConnection=M;function V(W){try{W.acceptDisconnect();const q=W.getSocket();W.dispose(),q.dispose()}catch(q){(0,A.onUnexpectedError)(q)}}function x(W){if(W&&W.type==="error"){const q=new Error(`Connection error: ${W.reason}`);return q.code="VSCODE_CONNECTION_ERROR",q}return null}function ee(W,q){for(;W.length<q;)W+=" ";return W}function re(W,q){return`[remote-connection][${ee(f(W),13)}][${q.substr(0,5)}\u2026]`}function te(W,q,J){return`${re(W,q)}[${J?"reconnect":"initial"}]`}function U(W,q){return`${te(q,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function B(W){return`${Date.now()-W} ms`}}),define(oe[220],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[221],ae([0,1,86,151]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,A,O,R,P,S){const E=g=>S(g,void 0),b=k.createConnection({host:D,port:A},()=>{b.removeListener("error",E);const g=Buffer.alloc(16);for(let f=0;f<16;f++)g[f]=Math.round(Math.random()*256);const m=g.toString("base64"),h=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${A}${O}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`];b.write(h.join(`\r
`)+`\r
\r
`);const y=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",y),S(void 0,new i.NodeSocket(b,P)))};b.on("data",y)});b.setNoDelay(!0),b.once("error",E)}}}),define(oe[107],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService");var i;(function(D){D.disconnected={type:"disconnected"},D.uninitialized={type:"uninitialized"},D.connected=A=>({type:"connected",info:A}),D.connecting=A=>({type:"connecting",progress:A})})(i=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME="remoteTunnelService",e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(oe[222],ae([0,1,135,16,9]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(R,P){this.a=R,this.b=P}async request(R,P){this.b.trace("RequestService#request (browser) - begin",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const S=await(0,k.request)(R,P);return this.b.trace("RequestService#request (browser) - success",R.url),S}catch(S){throw this.b.error("RequestService#request (browser) - error",R.url,S),S}}async resolveProxy(R){}};A=ye([K(0,i.IConfigurationService),K(1,D.ILogService)],A),e.RequestService=A}),define(oe[60],ae([0,1,17,170,46,4,40]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function R(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=R;function P(y){return y.res.statusCode===204}async function S(y){return P(y)?null:(await(0,k.streamToBuffer)(y.stream)).toString()}e.asText=S;async function E(y){if(!R(y))throw new Error("Server returned "+y.res.statusCode);return S(y)}e.asTextOrError=E;async function b(y){if(!R(y))throw new Error("Server returned "+y.res.statusCode);if(P(y))return null;const l=(await(0,k.streamToBuffer)(y.stream)).toString();try{return JSON.parse(l)}catch(d){throw d.message+=`:
`+l,d}}e.asJson=b;function g(y){h(y)}e.updateProxyConfigurationsScope=g;let m;function h(y){const f=O.Registry.as(D.Extensions.Configuration),l=m;m={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[m],remove:l?[l]:[]})}h(2)}),define(oe[223],ae([0,1,23,24,14,60]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(P,S){this.a=P,this.b=S}async download(P,S,E=k.CancellationToken.None){if(P.scheme===i.Schemas.file||P.scheme===i.Schemas.vscodeRemote){await this.b.copy(P,S);return}const b={type:"GET",url:P.toString(!0)},g=await this.a.request(b,E);if(g.res.statusCode===200)await this.b.writeFile(S,g.stream);else{const m=await(0,A.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${m}`)}}};O=ye([K(0,A.IRequestService),K(1,D.IFileService)],O),e.DownloadService=O}),define(oe[224],ae([0,1,17,23]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(R){this.a=R}listen(R,P){throw new Error("Invalid listen")}call(R,P,S,E=i.CancellationToken.None){switch(P){case"request":return this.a.request(S[0],E).then(async({res:b,stream:g})=>{const m=await(0,k.streamToBuffer)(g);return[{statusCode:b.statusCode,headers:b.headers},m]});case"resolveProxy":return this.a.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class A{constructor(R){this.a=R}async request(R,P){const[S,E]=await this.a.call("request",[R],P);return{res:S,stream:(0,k.bufferToStream)(E)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.RequestChannelClient=A}),define(oe[225],ae([0,1,13,222,224]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class A{constructor(R,P,S,E){this.c=P,this.d=S,this.e=E,this.a=new i.RequestService(P,E),this.b=new D.RequestChannelClient(R.getChannel("request"))}request(R,P){return this.f().request(R,P)}async resolveProxy(R){return this.f().resolveProxy(R)}f(){return this.g()?(this.e.trace("Using main request service"),this.b):(this.e.trace("Using browser request service"),this.a)}g(){const R=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,k.isBoolean)(R)?R:this.d.quality!=="stable"}}e.SharedProcessRequestService=A}),define(oe[108],ae([0,1,66,4]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(A){return(0,k.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(oe[226],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(oe[227],ae([0,1,94,6,23,3,2,24,31,9,108,226]),function(Z,e,k,i,D,A,O,R,P,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let g=class{constructor(y){this.d=y,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(y){const f=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${f})`);const l=(0,E.hash)(y);this.b.has(l)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${f})`),this.f(y));const d=new D.CancellationTokenSource;let p,w,I;this.b.set(l,s=>{d.dispose(!0),p?.terminate(y,D.CancellationToken.None),w?.close(),I?.close(),this.b.delete(l);const o=this.c.get(l);o&&(this.c.delete(l),o({reason:s}))}),p=await this.e(y);const n=new Promise(s=>{this.c.set(l,s)});if(d.token.isCancellationRequested)return n;const{port1:c,port2:t}=new MessageChannel;return w=c,I=t,await p.spawn(y,I,d.token),d.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${f})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[w])),n}e(y){let f=this.a.get(y.process.moduleId);if(!f){this.d.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const l=new m(y.process.type,this.d);f=l.init(),l.onDidProcessSelfTerminate(({configuration:d,reason:p})=>{this.f(d,p)}),this.a.set(y.process.moduleId,f)}return f}async disposeWorker(y){return this.f(y)}f(y,f){const l=this.b.get((0,E.hash)(y));l&&(this.d.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),l(f))}};g=ye([K(0,S.ILogService)],g),e.SharedProcessWorkerService=g;class m extends O.Disposable{constructor(y,f){super(),this.f=y,this.g=f,this.a=this.B(new A.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const y=new i.DeferredPromise,f=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return f.onerror=l=>{this.g.error(`SharedProcess: worker error (${this.f})`,l.message)},f.onmessageerror=l=>{this.g.error(`SharedProcess: worker message error (${this.f})`,l)},f.onmessage=l=>{const{id:d,message:p,configuration:w,nonce:I}=l.data;switch(d){case b.SharedProcessWorkerMessages.Ready:y.complete(f);break;case b.SharedProcessWorkerMessages.Ack:if(I){const n=this.c.get(I);n&&(this.c.delete(I),n())}break;case b.SharedProcessWorkerMessages.SelfTerminated:w&&p&&this.a.fire({configuration:w,reason:JSON.parse(p)});break;case b.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,p);break;case b.SharedProcessWorkerMessages.Info:p&&this.g.info(p);break;case b.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,p);break;case b.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,p);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,l)}},f.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async i(y,f,l){const d=await this.b;if(!f.isCancellationRequested)return new Promise(p=>{const w=(0,P.generateUuid)();this.c.set(w,p);const I={...y,nonce:w};l?d.postMessage(I,[l]):d.postMessage(I),f.onCancellationRequested(()=>{this.c.delete(w)&&p()})})}spawn(y,f,l){const d={id:b.SharedProcessWorkerMessages.Spawn,configuration:y,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(d,l,f)}terminate(y,f){const l={id:b.SharedProcessWorkerMessages.Terminate,configuration:y};return this.i(l,f)}}}),define(oe[228],ae([0,1,63,24,187]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}ye([k.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(oe[229],ae([0,1,50,12,171,23,38,7,5,31,148,185,6,130]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let h;async function y(l,d,p,w){return p["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(w)&&!p["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(w)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=g.Promises.withAsyncBody(async(I,n)=>{const c=new A.CancellationTokenSource;let t=1e4;const s=l.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(t=(0,m.clamp)(s,1,120)*1e3);const o=setTimeout(()=>{c.dispose(!0),n(new Error((0,D.localize)(0,null)))},t);try{I(await f(d,c.token))}catch(a){!(0,R.isCancellationError)(a)&&!c.token.isCancellationRequested?n(new Error((0,D.localize)(1,null,(0,O.toErrorMessage)(a)))):I({})}finally{clearTimeout(o),c.dispose()}})),h)}e.getResolvedShellEnv=y;async function f(l,d){const p=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",p);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",w);const I=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(I+"({.*})"+I),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",c);const t=await(0,E.getSystemShell)(P.OS,c);return l.trace("getUnixShellEnvironment#shell",t),new Promise((s,o)=>{if(d.isCancellationRequested)return o(new R.CancellationError);const a=(0,i.basename)(t);let r,u;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(r=`& '${process.execPath}' ${v} -p '''${I}'' + JSON.stringify(process.env) + ''${I}'''`,u=["-Login","-Command"]):(r=`'${process.execPath}' ${v} -p '"${I}" + JSON.stringify(process.env) + "${I}"'`,a==="tcsh"||a==="csh"?u=["-ic"]:u=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),r);const C=(0,k.spawn)(t,[...u,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});d.onCancellationRequested(()=>(C.kill(),o(new R.CancellationError))),C.on("error",F=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(F)),o(F)});const T=[];C.stdout.on("data",F=>T.push(F));const N=[];C.stderr.on("data",F=>N.push(F)),C.on("close",(F,j)=>{const L=Buffer.concat(T).toString("utf8");l.trace("getUnixShellEnvironment#raw",L);const $=Buffer.concat(N).toString("utf8");if($.trim()&&l.trace("getUnixShellEnvironment#stderr",$),F||j)return o(new Error((0,D.localize)(2,null,F,j)));const z=n.exec(L),H=z?z[1]:"{}";try{const X=JSON.parse(H);p?X.ELECTRON_RUN_AS_NODE=p:delete X.ELECTRON_RUN_AS_NODE,w?X.ELECTRON_NO_ATTACH_CONSOLE=w:delete X.ELECTRON_NO_ATTACH_CONSOLE,delete X.VSCODE_RESOLVING_ENVIRONMENT,delete X.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",X),s(X)}catch(X){l.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(X)),o(X)}})})}}),define(oe[109],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[230],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.b=new Map}c(){return new Promise((D,A)=>Z(["vsda"],D,A))}async createNewMessage(D){try{const A=await this.c(),O=new A.validator;if(O){const R=String(k.a++);return this.b.set(R,O),{id:R,data:O.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,A){if(!D.id)return!0;const O=this.b.get(D.id);if(!O)return!1;this.b.delete(D.id);try{return O.validate(A)==="ok"}catch{return!1}}async sign(D){try{const A=await this.c(),O=new A.signer;if(O)return O.sign(D)}catch{}return D}}e.SignService=k,k.a=1}),define(oe[76],ae([0,1,3,2]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class D extends i.Disposable{constructor(b,g,m){super(),this.a=b,this.b=g,this.c=m}async getItems(){const b={profile:this.b,workspace:this.c},g=await this.a.call("getItems",b);return new Map(g)}updateItems(b){const g={profile:this.b,workspace:this.c};return b.insert&&(g.insert=Array.from(b.insert.entries())),b.delete&&(g.delete=Array.from(b.delete.values())),this.a.call("updateItems",g)}}class A extends D{constructor(b,g){super(b,g,void 0),this.f=this.B(new k.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(b=>this.h(b)))}h(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this.f.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class O extends A{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=O;class R extends A{constructor(b,g){super(b,g)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class P extends D{constructor(b,g){super(b,void 0,g),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P;class S{constructor(b){this.a=b}isUsed(b){const g={payload:b,profile:void 0,workspace:void 0};return this.a.call("isUsed",g)}}e.StorageClient=S}),define(oe[110],ae([0,1,5,36,8,31]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(S){if(k.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function R(S,E,b,g,m,h,y,f,l,d){const p=Object.create(null);p["common.machineId"]=y,p.sessionID=(0,A.generateUuid)()+Date.now(),p.commitHash=m,p.version=h,p["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,k.PlatformToString)(k.platform),p["common.nodePlatform"]=i.platform,p["common.nodeArch"]=g,p["common.product"]=d||"desktop",f&&(p["common.msftInternal"]=f);let w=0;const I=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-I,enumerable:!0},"common.sequence":{get:()=>w++,enumerable:!0}}),k.isLinuxSnap&&(p["common.snap"]="true");const n=O(b);n&&(p["common.platformDetail"]=n);try{const c=await S.readFile(D.URI.file(l));p["common.source"]=c.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=R;function P(S){const E=i.env.USERDNSDOMAIN;if(!E)return!1;const b=E.toLowerCase();return S.some(g=>b===g)}e.verifyMicrosoftInternalDomain=P}),define(oe[19],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(oe[231],ae([0,1,34,6,35,24,12,5,8,145,28,147,96,14,25,19]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const f=new Map;async function l(n,c){const t=`${n}::${c.join(":")}`,s=f.get(t);if(s)return s;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,r=new Map,u=2e4;function v(T,N,F,j){const L=N.substring(T.length+1);return i.Promises.withAsyncBody(async $=>{let z;try{z=await E.Promises.readdir(N,{withFileTypes:!0})}catch{$();return}if(j.count>=u){j.count+=z.length,j.maxReached=!0,$();return}let H=z.length;if(H===0){$();return}let X=z;j.count+z.length>u&&(j.maxReached=!0,H=u-j.count,X=z.slice(0,H)),j.count+=z.length;for(const ie of X)if(ie.isDirectory()){if(F.includes(ie.name)||await v(T,(0,O.join)(N,ie.name),F,j),--H===0){$();return}}else{const G=ie.name.lastIndexOf(".");if(G>=0){const M=ie.name.substring(G+1);M&&a.set(M,(a.get(M)??0)+1)}for(const M of o)M.relativePathPattern?.test(L)!==!1&&M.filePattern.test(ie.name)&&r.set(M.tag,(r.get(M.tag)??0)+1);if(--H===0){$();return}}})}const C=i.Promises.withAsyncBody(async T=>{const N={count:0,maxReached:!1};await v(n,n,c,N);const F=await w(n);T({configFiles:d(r),fileTypes:d(a),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:F})});return f.set(t,C),C}e.collectWorkspaceStats=l;function d(n){return Array.from(n.entries(),([c,t])=>({name:c,count:t})).sort((c,t)=>t.count-c.count)}function p(){const n={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},c=k.cpus();return c&&c.length>0&&(n.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),n}e.getMachineInfo=p;async function w(n){try{const c=new Map,t=(0,O.join)(n,".vscode","launch.json"),s=await E.Promises.readFile(t),o=[],a=(0,D.parse)(s.toString(),o);if(o.length)return console.log(`Unable to parse ${t}`),[];if((0,D.getNodeType)(a)==="object"&&a.configurations)for(const r of a.configurations){const u=r.type;u&&(c.has(u)?c.set(u,c.get(u)+1):c.set(u,1))}return d(c)}catch{return[]}}e.collectLaunchConfigs=w;let I=class{constructor(c,t){this.c=c,this.d=t}f(c){const t=[];return t.push(`OS Version:       ${c.os}`),t.push(`CPUs:             ${c.cpus}`),t.push(`Memory (System):  ${c.memory}`),t.push(`VM:               ${c.vmHint}`),t.join(`
`)}g(c){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const s=k.cpus();return s&&s.length>0&&t.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),t.push(`Memory (System):  ${(k.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||t.push(`Load (avg):       ${k.loadavg().map(o=>Math.round(o)).join(", ")}`),t.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${c.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(c,t){return Promise.all([(0,b.listProcesses)(c.mainPID),this.k(c)]).then(async s=>{let[o,a]=s,r=this.m(c,o);return t.forEach(u=>{if((0,g.isRemoteDiagnosticError)(u))r+=`
${u.errorMessage}`,a+=`
${u.errorMessage}`;else if(r+=`

Remote: ${u.hostName}`,u.processes&&(r+=`
${this.m(c,u.processes)}`),u.workspaceMetadata){a+=`
|  Remote: ${u.hostName}`;for(const v of Object.keys(u.workspaceMetadata)){const C=u.workspaceMetadata[v];let T=`${C.fileCount} files`;C.maxFilesReached&&(T=`more than ${T}`),a+=`|    Folder (${v}): ${T}`,a+=this.h(C)}}}),{processInfo:r,workspaceInfo:a}})}async getSystemInfo(c,t){const{memory:s,vmHint:o,os:a,cpus:r}=p(),u={os:a,memory:s,cpus:r,vmHint:o,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:t};return R.isWindows||(u.load=`${k.loadavg().map(v=>Math.round(v)).join(", ")}`),R.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(c,t){const s=[];return(0,b.listProcesses)(c.mainPID).then(async o=>(s.push(""),s.push(this.g(c)),s.push(""),s.push(this.m(c,o)),c.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(c))),t.forEach(a=>{if((0,g.isRemoteDiagnosticError)(a))s.push(`
${a.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${a.hostName}`),s.push(this.f(a.machineInfo)),a.processes&&s.push(this.m(c,a.processes)),a.workspaceMetadata)for(const r of Object.keys(a.workspaceMetadata)){const u=a.workspaceMetadata[r];let v=`${u.fileCount} files`;u.maxFilesReached&&(v=`more than ${v}`),s.push(`Folder (${r}): ${v}`),s.push(this.h(u))}}),s.push(""),s.push(""),s.join(`
`)))}h(c){const t=[];let o=0;const a=(C,T)=>{const N=` ${C}(${T})`;o+N.length>60?(t.push(r),r="|                 ",o=r.length):o+=N.length,r+=N};let r="|      File types:";const u=10,v=c.fileTypes.length>u?u:c.fileTypes.length;for(let C=0;C<v;C++){const T=c.fileTypes[C];a(T.name,T.count)}if(t.push(r),c.configFiles.length>=0&&(r="|      Conf files:",o=0,c.configFiles.forEach(C=>{a(C.name,C.count)}),t.push(r)),c.launchConfigFiles.length>0){let C="|      Launch Configs:";c.launchConfigFiles.forEach(T=>{C+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),t.push(C)}return t.join(`
`)}j(c){const t=Math.max(...Object.keys(c).map(s=>s.length));return Object.keys(c).map(s=>`${s}:  ${" ".repeat(t-s.length)}  ${c[s]}`).join(`
                  `)}k(c){const t=[],s=[];return c.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(t.push(`|  Window (${o.title})`),o.folderURIs.forEach(a=>{const r=P.URI.revive(a);if(r.scheme===A.Schemas.file){const u=r.fsPath;s.push(l(u,["node_modules",".git"]).then(v=>{let C=`${v.fileCount} files`;v.maxFilesReached&&(C=`more than ${C}`),t.push(`|    Folder (${(0,O.basename)(u)}): ${C}`),t.push(this.h(v))}).catch(v=>{t.push(`|      Error: Unable to collect workspace stats for folder ${u} (${v.toString()})`)}))}else t.push(`|    Folder (${r.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(o=>t.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(c,t){const s=new Map;c.windows.forEach(a=>s.set(a.pid,a.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),t&&this.n(c.mainPID,s,o,t,0),o.join(`
`)}n(c,t,s,o,a){const r=a===0;let u;r?u=o.pid===c?`${this.d.applicationName} main`:"remote agent":(u=`${"  ".repeat(a)} ${o.name}`,o.name==="window"&&(u=`${u} (${t.get(o.pid)})`));const v=process.platform==="win32"?o.mem:k.totalmem()*(o.mem/100);s.push(`${o.load.toFixed(0).padStart(5," ")}	${(v/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(o.children)&&o.children.forEach(C=>this.n(c,t,s,C,a+1))}async getWorkspaceFileExtensions(c){const t=new Set;for(const{uri:s}of c.folders){const o=P.URI.revive(s);if(o.scheme!==A.Schemas.file)continue;const a=o.fsPath;try{(await l(a,["node_modules",".git"])).fileTypes.forEach(u=>t.add(u.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(c){for(const{uri:t}of c.folders){const s=P.URI.revive(t);if(s.scheme!==A.Schemas.file)continue;const o=s.fsPath;try{const a=await l(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),a.fileTypes.forEach(r=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:r.name,count:r.count})}),a.launchConfigFiles.forEach(r=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:r.name,count:r.count})}),a.configFiles.forEach(r=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:r.name,count:r.count})})}catch{}}}};I=ye([K(0,y.ITelemetryService),K(1,h.IProductService)],I),e.DiagnosticsService=I}),define(oe[232],ae([0,1,107,3,19,15,2,9,12,50,25,5,6,103,16,169,34,8]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let d=class extends O.Disposable{constructor(w,I,n,c,t,s){super(),this.p=w,this.r=I,this.s=n,this.t=s,this.b=new i.Emitter,this.onDidTokenFailed=this.b.event,this.c=new i.Emitter,this.onDidChangeTunnelStatus=this.c.event,this.f=new i.Emitter,this.onDidChangeAccount=this.f.event,this.j=k.TunnelStates.disconnected;const o=l.URI.file((0,P.join)(n.logsPath,k.LOG_FILE_NAME));this.g=this.B(c.createLogger(o,{name:k.LOGGER_NAME})),this.k=new g.Delayer(100),this.B(this.g.onDidChangeLogLevel(a=>this.g.info("Log level changed to "+(0,R.LogLevelToString)(a)))),this.B(t.onWillShutdown(a=>{this.i&&(this.i.cancel(),this.i=void 0),this.dispose()})),this.B(s.onDidChangeConfiguration(a=>{a.affectsConfiguration(k.CONFIGURATION_KEY_HOST_NAME)&&this.k.trigger(()=>this.v())}))}async getAccount(){return this.h}async updateAccount(w){if(w&&this.h?w.token!==this.h.token||w.providerId!==this.h.providerId:w!==this.h){this.h=w,this.f.fire(w),w?this.g.info(`Account updated: ${w.accountLabel} (${w.providerId})`):this.g.info("Account reset"),this.p.publicLog2("remoteTunnel.enablement",{enabled:!!w});try{await this.k.trigger(()=>this.v())}catch(I){this.g.error(I)}}return this.j}u(){if(!this.n){let w;b.isMacintosh?w=this.s.appRoot:w=(0,P.dirname)((0,P.dirname)(this.s.appRoot)),this.n=(0,P.join)(w,"bin",`${this.r.tunnelApplicationName}${b.isWindows?".exe":""}`)}return this.n}async v(){if(this.i&&(this.i.cancel(),this.i=void 0),!this.h){this.w(k.TunnelStates.disconnected);return}const{token:w,providerId:I,accountLabel:n}=this.h;this.w(k.TunnelStates.connecting((0,y.localize)(0,null,n,I)));const c=(r,u)=>{r=r.replaceAll(w,"*".repeat(4)),u?this.g.error(r):this.g.info(r),!this.s.isBuilt&&r.startsWith("   Compiling")&&this.w(k.TunnelStates.connecting((0,y.localize)(1,null)))},t=this.y("login",["user","login","--provider",I,"--access-token",w,"--log",(0,R.LogLevelToString)(this.g.getLevel())],c);this.i=t;try{if(await t,this.i!==t)return}catch(r){this.g.error(r),this.i=void 0,this.b.fire(!0),this.w(k.TunnelStates.disconnected);return}const s=this.z();s?this.w(k.TunnelStates.connecting((0,y.localize)(2,null,s))):this.w(k.TunnelStates.connecting((0,y.localize)(3,null)));const o=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this.g.getLevel())];s?o.push("--name",s):o.push("--random-name");const a=this.y("tunnel",o,(r,u)=>{u?this.g.error(r):this.g.info(r);const v=r.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(v){const C={link:v[1],domain:v[2],hostName:v[4]};this.w(k.TunnelStates.connected(C))}else r.match(/error refreshing token/)&&(a.cancel(),this.b.fire(!0),this.w(k.TunnelStates.disconnected))});this.i=a,a.finally(()=>{a===this.i&&(this.g.info("tunnel process terminated"),this.i=void 0,this.h=void 0,this.w(k.TunnelStates.disconnected))})}async getTunnelStatus(){return this.j}w(w){this.j=w,this.c.fire(w)}y(w,I,n=()=>{}){return(0,g.createCancelablePromise)(c=>new Promise((t,s)=>{c.isCancellationRequested&&t();let o;if(c.onCancellationRequested(()=>{o&&(this.g.info(`${w} terminating(${o.pid})`),o.kill())}),!this.s.isBuilt)n("Building tunnel CLI from sources and run",!1),n(`${w} Spawning: cargo run -- tunnel ${I.join(" ")}`,!1),o=(0,S.spawn)("cargo",["run","--","tunnel",...I],{cwd:(0,P.join)(this.s.appRoot,"cli")});else{n("Running tunnel CLI",!1);const a=this.u();n(`${w} Spawning: ${a} tunnel ${I.join(" ")}`,!1),o=(0,S.spawn)(a,["tunnel",...I],{cwd:(0,f.homedir)()})}o.stdout.on("data",a=>{if(o){const r=a.toString();n(r,!1)}}),o.stderr.on("data",a=>{if(o){const r=a.toString();n(r,!0)}}),o.on("exit",a=>{o&&(n(`${w} exit(${o.pid}): + ${a} `,!1),o=void 0,a===0?t():s())}),o.on("error",a=>{o&&(n(`${w} error(${o.pid}): + ${a} `,!0),o=void 0,s())})}))}async getHostName(){return this.z()}z(){let w=this.t.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,f.hostname)();return w=w.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),w||void 0}};d=ye([K(0,D.ITelemetryService),K(1,E.IProductService),K(2,A.INativeEnvironmentService),K(3,R.ILoggerService),K(4,m.ISharedProcessLifecycleService),K(5,h.IConfigurationService)],d),e.RemoteTunnelService=d}),define(oe[111],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:R,data:P}){return this.b.forEach(S=>S.log(R,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class i{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(oe[47],ae([0,1,32,13,3,16,75,110,19]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class S{constructor(r){this.value=r}}e.TelemetryTrustedValue=S;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,u){return Promise.resolve(void 0)}publicLog2(r,u){return this.publicLog(r,u)}publicLogError(r,u){return Promise.resolve(void 0)}publicLogError2(r,u){return this.publicLogError(r,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class b{async publicLog(r,u,v){}async publicLogError(r,u,v){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(a,r){return D.Event.debounce(r.onDidChangeConfiguration,(v,C)=>{const T=v?new Set([...v.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:T}},1e3,!0)(v=>{v.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(v.source),configurationKeys:w(v.affectedKeys)})})}e.configurationTelemetry=g;function m(a,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!a.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=m;function h(a,r){return!(r.isBuilt||r.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=h;function y(a){const r=a.getValue(P.TELEMETRY_SETTING_ID),u=a.getValue(P.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function f(a){const r={},u={},v={};p(a,v);for(let C in v){C=C.length>150?C.substr(C.length-149):C;const T=v[C];typeof T=="number"?u[C]=T:typeof T=="boolean"?u[C]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${T.length}`),r[C]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(r[C]=T)}return{properties:r,measurements:u}}e.validateTelemetryData=f;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function d(a){if(!a)return"none";const r=(0,O.getRemoteName)(a);return l.has(r)?r:"other"}e.cleanRemoteAuthority=d;function p(a,r,u=0,v){if(!!a)for(const C of Object.getOwnPropertyNames(a)){const T=a[C],N=v?v+C:C;Array.isArray(T)?r[N]=(0,k.safeStringify)(T):T instanceof Date?r[N]=T.toISOString():(0,i.isObject)(T)?u<2?p(T,r,u+1,N+"."):r[N]=(0,k.safeStringify)(T):r[N]=T}}function w(a){if(!a)return[];const r=[];return I(r,"",a),r}function I(a,r,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(v=>I(a,r?`${r}.${v}`:v,u[v])):a.push(r)}function n(a,r){const u=a.msftInternalDomains||[],v=r.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(u)||v}e.isInternalTelemetry=n;function c(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=c;function t(a,r){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let u=a;const v=[];for(const F of r)for(;;){const j=F.exec(a);if(!j)break;v.push([j.index,F.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(u="";;){const F=T.exec(a);if(!F)break;const j=v.some(([L,$])=>F.index<$&&L<T.lastIndex);!C.test(F[0])&&!j&&(u+=a.substring(N,F.index)+"<REDACTED: user-file-path>",N=T.lastIndex)}return N<a.length&&(u+=a.substr(N)),u}function s(a){if(!a)return a;const r=a.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const v of u)if(v.regex.test(r))return`<REDACTED: ${v.label}>`;return a}function o(a,r){return(0,k.cloneAndChange)(a,u=>{if(u instanceof S)return u.value;if(typeof u=="string"){let v=u.replaceAll("%20"," ");v=t(v,r);for(const C of r)v=v.replace(C,"");return v=s(v),v}})}e.cleanData=o}),define(oe[33],ae([0,1,27,30,42,5,8,7,36,47]),function(Z,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function E(t,s){return t.uuid&&s.uuid?t.uuid===s.uuid:t.id===s.id?!0:(0,k.compareIgnoreCase)(t.id,s.id)===0}e.areSameExtensions=E;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(s){const o=s.manifest?s.manifest.version:s.version,a=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new g(s.identifier,o,a)}static parse(s){const o=b.exec(s);return o&&o[1]&&o[2]?new g({id:o[1]},o[2],o[4]||void 0):null}constructor(s,o,a="undefined"){this.version=o,this.targetPlatform=a,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof g?E(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=g;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(t){const s=m.exec(t);return s&&s[1]?[f(s[1]),s[2]]:[f(t),void 0]}e.getIdAndVersion=h;function y(t,s){return`${t}.${s}`}e.getExtensionId=y;function f(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=f;function l(t,s){return f(y(t,s))}e.getGalleryExtensionId=l;function d(t,s){const o=[],a=r=>{for(const u of o)if(u.some(v=>E(s(v),s(r))))return u;return null};for(const r of t){const u=a(r);u?u.push(r):o.push([r])}return o}e.groupByExtension=d;function p(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function w(t){return{id:new S.TelemetryTrustedValue(t.identifier.id),name:new S.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function I(t,s){const o=[],a=s.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const r=a.shift();if(r&&o.every(u=>!E(u.identifier,{id:r}))){const u=t.filter(v=>E(v.identifier,{id:r}));u.length===1&&(o.push(u[0]),a.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=I;async function n(t,s){if(!A.isLinux)return!1;let o;try{o=(await t.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await t.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){s.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(r))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=n;async function c(t,s){const o=await n(t,s),a=(0,i.getTargetPlatform)(o?"alpine":A.platform,P.arch);return s.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=c}),define(oe[233],ae([0,1,23,33]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function D(A,O,R,P,S){try{const E=await A.getExtensionsControlManifest();if(!E.deprecated)return;const b=await A.getInstalled(1);for(const[g,m]of Object.entries(E.deprecated)){if(!m?.extension)continue;const{id:h,autoMigrate:y,preRelease:f}=m.extension;if(!y)continue;const l=b.find(p=>(0,i.areSameExtensions)(p.identifier,{id:g}));if(!l)continue;const d=(await O.getExtensions([{id:h,preRelease:f}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!d){S.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{S.info(`Migrating '${l.identifier.id}' extension to '${h}' extension...`);const p=!P.getDisabledExtensions().some(I=>(0,i.areSameExtensions)(I,l.identifier));await A.uninstall(l),S.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let w=b.find(I=>(0,i.areSameExtensions)(I.identifier,{id:h}));(!w||!w.isPreReleaseVersion&&p)&&(w=await A.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${w.identifier.id}'`),p||(await P.disableExtension(w.identifier),S.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,i.getExtensionId)(l.manifest.publisher,l.manifest.name),(0,i.getExtensionId)(w.manifest.publisher,w.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${l.identifier.id}' extension to '${h}' extension.`)}catch(p){S.error(p)}}}catch(E){S.error(E)}}e.migrateUnsupportedExtensions=D}),define(oe[234],ae([0,1,6,7,2,24,5,22,54,13,31,28,16,15,30,33,98,14,9,25]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let w=class yt extends D.Disposable{constructor(n,c,t,s,o,a,r){super(),this.h=c,this.i=t,this.j=s,this.k=o,this.l=a,this.m=r,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.v()}async download(n,c){await this.g;const t=(0,R.joinPath)(this.extensionsDownloadDir,this.w(n));try{await this.t(n,t,o=>this.i.download(n,o,c))}catch(o){throw new h.ExtensionManagementError(o.message,h.ExtensionManagementErrorCode.Download)}let s="Unverified";if(await this.n(n)){const o=await this.r(n);try{await this.l.verify(t.fsPath,o.fsPath)&&(s="Verified"),this.m.info(`Extension signature verification: ${n.identifier.id}. Verification status: ${s}.`)}catch(a){const r=a.code;if(r==="UnknownError")s="UnknownError",this.m.warn(`Extension signature verification: ${n.identifier.id}. Verification status: ${s}.`);else throw await this.delete(o),await this.delete(t),new h.ExtensionManagementError(r,h.ExtensionManagementErrorCode.Signature)}}return{location:t,verificationStatus:s}}async n(n){if(!n.isSigned)return!1;const c=this.j.getValue("extensions.verifySignature");return(0,S.isBoolean)(c)?c:this.k.quality!=="stable"}async r(n){await this.g;const c=(0,R.joinPath)(this.extensionsDownloadDir,`${this.w(n)}${yt.c}`);return await this.t(n,c,t=>this.i.downloadSignatureArchive(n,t)),c}async t(n,c,t){if(await this.h.exists(c))return;if(c.scheme!==A.Schemas.file){await t(c);return}const s=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.h.exists(s)||await t(s);try{await this.u(s,c,Date.now()+2*60*1e3)}catch(o){try{await this.h.del(s)}catch{}if(o.code==="ENOTEMPTY")this.m.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,c.path);else throw this.m.info(`Rename failed because of ${(0,i.getErrorMessage)(o)}. Deleted the file from downloaded location`,s.path),o}}async delete(n){await this.g,await this.h.del(n)}async u(n,c,t){try{await b.Promises.rename(n.fsPath,c.fsPath)}catch(s){if(O.isWindows&&s&&s.code==="EPERM"&&Date.now()<t)return this.m.info(`Failed renaming ${n} to ${c} with 'EPERM' error. Trying again...`),this.u(n,c,t);throw s}}async v(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.m.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const c=[],t=[],s=[];for(const r of n.children)if(r.name.endsWith(yt.c))s.push(r.resource);else{const u=y.ExtensionKey.parse(r.name);u&&t.push([u,r])}const o=(0,y.groupByExtension)(t,([r])=>r),a=[];for(const r of o)r.sort((u,v)=>P.rcompare(u[0].version,v[0].version)),c.push(...r.slice(1).map(u=>u[1].resource)),a.push(r[0][1]);a.sort((r,u)=>r.mtime-u.mtime),c.push(...a.slice(0,Math.max(0,a.length-this.f)).map(r=>r.resource)),c.push(...s),await k.Promises.settled(c.map(r=>(this.m.trace("Deleting from cache",r.path),this.h.del(r))))}}catch(n){this.m.error(n)}}w(n){return this.f?y.ExtensionKey.create(n).toString().toLowerCase():(0,E.generateUuid)()}};w.c=".sigzip",w=ye([K(0,m.INativeEnvironmentService),K(1,l.IFileService),K(2,h.IExtensionGalleryService),K(3,g.IConfigurationService),K(4,p.IProductService),K(5,f.IExtensionSignatureVerificationService),K(6,d.ILogService)],w),e.ExtensionsDownloader=w}),define(oe[235],ae([0,1,3,2,37,33,42]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends i.Disposable{constructor(S,E,b,g,m,h,y){super(),this.f=S,this.g=E,this.h=b,this.i=g,this.j=m,this.k=h,this.l=y,this.a=this.B(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new i.DisposableMap),this.m().then(null,f=>y.error(f))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(S=>this.p(S.added,S.removed))),this.B(this.i.onAddExtensions(S=>this.r(S))),this.B(this.i.onDidAddExtensions(S=>this.s(S))),this.B(this.i.onRemoveExtensions(S=>this.t(S))),this.B(this.i.onDidRemoveExtensions(S=>this.u(S))),this.B(this.k.onDidFilesChange(S=>this.v(S)))}async p(S,E){try{await Promise.all(E.map(b=>(this.c.deleteAndDispose(b.id),this.z(b.extensionsResource)))),S.length&&await Promise.all(S.map(b=>(this.c.set(b.id,(0,i.combinedDisposable)(this.k.watch(this.j.extUri.dirname(b.extensionsResource)),this.k.watch(b.extensionsResource))),this.y(b.extensionsResource))))}catch(b){throw this.l.error(b),b}}async r(S){for(const E of S.extensions)this.D(this.G(E.identifier,E.version),S.profileLocation)}async s(S){for(const E of S.extensions){const b=this.G(E.identifier,E.version);S.error?this.F(b,S.profileLocation):this.D(b,S.profileLocation)}}async t(S){for(const E of S.extensions)this.F(this.G(E.identifier,E.version),S.profileLocation)}async u(S){let E=!1;for(const b of S.extensions){const g=this.G(b.identifier,b.version);S.error?this.D(g,S.profileLocation):(this.F(g,S.profileLocation),E=E||!this.b.has(g))}E&&await this.C()}v(S){for(const E of this.h.profiles)S.contains(E.extensionsResource,0,1)&&this.w(E.extensionsResource)}async w(S){const E=[],b=[],g=await this.i.scanProfileExtensions(S),m=new Set,h=new Set;for(const[y,f]of this.b)f.has(S)&&h.add(y);for(const y of g){const f=this.G(y.identifier,y.version);m.add(f),h.has(f)||(E.push(y.identifier),this.D(f,S))}for(const y of h)if(!m.has(y)){const f=this.H(y);f&&(b.push(f.identifier),this.F(y,S))}(E.length||b.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:S}:void 0,removed:b.length?{extensions:b,profileLocation:S}:void 0})}async y(S){const E=await this.i.scanProfileExtensions(S);for(const b of E)this.D(this.G(b.identifier,b.version),S)}async z(S){for(const E of[...this.b.keys()])this.F(E,S);await this.C()}async C(){const E=(await this.f.getAllUserInstalled()).filter(b=>b.installedTimestamp&&!this.b.has(this.G(b.identifier,b.manifest.version)));E.length&&await this.f.markAsUninstalled(...E)}D(S,E){let b=this.b.get(S);b||this.b.set(S,b=new D.ResourceSet(g=>this.j.extUri.getComparisonKey(g))),b.add(E)}F(S,E){const b=this.b.get(S);b&&b.delete(E),b?.size||this.b.delete(S)}G(S,E){return`${O.ExtensionIdentifier.toKey(S.id)}@${E}`}H(S){const[E,b]=(0,A.getIdAndVersion)(S);return b?{identifier:{id:E},version:b}:void 0}}e.ExtensionsWatcher=R}),define(oe[236],ae([0,1,45,47]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(A,O,R,P,S,E,b){const g={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,i.supportsTelemetry)(O,R)&&(0,i.getTelemetryLevel)(P)===3){const m=await(0,k.getServiceMachineId)(R,S,E),{machineId:h}=await b.getTelemetryInfo();g["X-Market-User-Id"]=m,g["VSCode-SessionId"]=h||m}return g}e.resolveMarketplaceHeaders=D}),define(oe[237],ae([0,1,100,21,6,2,24,12,28,15,30,33,9,73,5,8]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let f=class extends m.LanguagePackBaseService{constructor(w,I,n,c){super(n),this.h=w,this.i=c,this.g=this.B(new l(I,c)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(w){const n=(await this.g.getLanguagePacks())[h.Language.value()];if(!n){this.i.warn(`No language pack found for ${h.Language.value()}`);return}const c=n.translations[w];return c?y.URI.file(c):void 0}async getInstalledLanguages(){const w=await this.g.getLanguagePacks(),I=Object.keys(w).map(n=>{const c=w[n];return{...this.f(n,c.label),extensionId:c.extensions[0].extensionIdentifier.id}});return I.push({...this.f("en","English"),extensionId:"default"}),I.sort((n,c)=>n.label.localeCompare(c.label)),I}async j(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",w.identifier.id),await this.update())}async k(w){const I=await this.g.getLanguagePacks();Object.keys(I).some(n=>I[n]&&I[n].extensions.some(c=>(0,b.areSameExtensions)(c.extensionIdentifier,w.identifier)))&&(this.i.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,I]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),n=await this.g.update(I);return!(0,i.equals)(Object.keys(w),Object.keys(n))}};f=ye([K(0,E.IExtensionManagementService),K(1,S.INativeEnvironmentService),K(2,E.IExtensionGalleryService),K(3,g.ILogService)],f),e.NativeLanguagePackService=f;let l=class extends A.Disposable{constructor(w,I){super(),this.i=I,this.c={},this.f=(0,R.join)(w.userDataPath,"languagepacks.json"),this.g=new D.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(w){return this.m(I=>{Object.keys(I).forEach(n=>delete I[n]),this.j(I,...w)}).then(()=>this.c)}j(w,...I){for(const n of I)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.k(w,n);Object.keys(w).forEach(n=>this.l(w[n]))}k(w,I){const n=I.identifier,c=I.manifest.contributes&&I.manifest.contributes.localizations?I.manifest.contributes.localizations:[];for(const t of c)if(I.location.scheme===O.Schemas.file&&d(t)){let s=w[t.languageId];s||(s={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},w[t.languageId]=s);const o=s.extensions.filter(a=>(0,b.areSameExtensions)(a.extensionIdentifier,n))[0];o?o.version=I.manifest.version:s.extensions.push({extensionIdentifier:n,version:I.manifest.version});for(const a of t.translations)s.translations[a.id]=(0,R.join)(I.location.fsPath,a.path)}}l(w){if(w){const I=(0,k.createHash)("md5");for(const n of w.extensions)I.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);w.hash=I.digest("hex")}}m(w=()=>null){return this.g.queue(()=>{let I=null;return P.Promises.readFile(this.f,"utf8").then(void 0,n=>n.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(n)).then(n=>{try{return JSON.parse(n)}catch{return{}}}).then(n=>(I=w(n),n)).then(n=>{for(const t of Object.keys(n))n[t]||delete n[t];this.c=n,this.h=!0;const c=JSON.stringify(this.c);return this.i.debug("Writing language packs",c),P.Promises.writeFile(this.f,c)}).then(()=>I,n=>this.i.error(n))})}};l=ye([K(0,S.INativeEnvironmentService),K(1,g.ILogService)],l);function d(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const w of p.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(oe[238],ae([0,1,7,32,47]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function R(S,E,b){const g=await new Promise((l,d)=>{Z(["@microsoft/1ds-core-js"],l,d)}),m=await new Promise((l,d)=>{Z(["@microsoft/1ds-post-js"],l,d)}),h=new g.AppInsightsCore,y=new m.PostChannel,f={instrumentationKey:S,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(b){f.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:b};f.extensionConfig[y.identifier]=l}return h.initialize(f,[]),h.addTelemetryInitializer(l=>{E&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),h}class P{constructor(E,b,g,m,h){this.e=E,this.f=b,this.g=g,this.h=h,this.c=A,this.d=O,this.g||(this.g={}),typeof m=="function"?this.a=m():this.a=m,this.b=null}i(E){if(!!this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(b=>{E(b)},b=>{(0,k.onUnexpectedError)(b),console.error(b)})}}log(E,b){if(!this.a)return;b=(0,i.mixin)(b,this.g),b=(0,D.validateTelemetryData)(b);const g=this.f+"/"+E;try{this.i(m=>{m.pluginVersionString=b?.properties.version??"Unknown",m.track({name:g,baseData:{name:g,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(oe[112],ae([0,1,2,15,9,47]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let O=class extends k.Disposable{constructor(P,S,E=""){super(),this.b=E;const b=P.getLogger(S.telemetryLogResource);b?this.a=this.B(b):(this.a=this.B(P.createLogger(S.telemetryLogResource)),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(P,S){this.a.trace(`${this.b}telemetry/${P}`,(0,A.validateTelemetryData)(S))}};O=ye([K(0,D.ILoggerService),K(1,i.IEnvironmentService)],O),e.TelemetryLogAppender=O}),define(oe[113],ae([0,1,2,32,5,27,172,16,46,105,25,40,19,47]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{constructor(l,d,p){this.k=d,this.l=p,this.d={},this.i=new k.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration(g.TELEMETRY_SETTING_ID)||w.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||w.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(l,d){this.d[l]=d}m(){let l=(0,m.getTelemetryLevel)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const p=d.usage?3:d.error?2:0;l=Math.min(l,p)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,d=l.sessionID,p=l["common.machineId"],w=l["common.firstSessionDate"],I=l["common.msftInternal"];return{sessionId:d,machineId:p,firstSessionDate:w,msftInternal:I}}dispose(){this.i.dispose()}n(l,d,p){return this.g<d?Promise.resolve(void 0):this.c.then(w=>{p=(0,i.mixin)(p,this.d),p=(0,m.cleanData)(p,this.j),p=(0,i.mixin)(p,w),this.b.forEach(I=>I.log(l,p))},w=>{console.error(w)})}publicLog(l,d){return this.n(l,3,d)}publicLog2(l,d){return this.publicLog(l,d)}publicLogError(l,d){return this.h?this.n(l,2,d):Promise.resolve(void 0)}publicLogError2(l,d){return this.publicLogError(l,d)}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=ye([K(1,R.IConfigurationService),K(2,E.IProductService)],h),e.TelemetryService=h;function y(){const f=(0,O.localize)(0,null,S.default.nameLong),l=S.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=D.isWeb?"":(0,O.localize)(3,null),p=(0,O.localize)(4,null),w=(0,O.localize)(5,null),I=(0,O.localize)(6,null),n=(0,O.localize)(7,null),c=`
|       | ${p} | ${w} | ${I} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,O.localize)(8,null);return`
${f} ${l} ${d}

&nbsp;

${n}
${c}

&nbsp;

${t}
`}b.Registry.as(P.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(P.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,O.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,O.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[239],ae([0,1,289,238]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends i.AbstractOneDataSystemAppender{constructor(O,R,P,S){const E={sendPOST:(b,g)=>{const m={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const h=k.request(b.urlString,m,y=>{y.on("data",function(f){g(y.statusCode??200,y.headers,f.toString())}),y.on("error",function(f){g(0,{})})});h.write(b.data),h.end()}catch{g(0,{})}}};super(O,R,P,S,E)}}e.OneDataSystemAppender=D}),define(oe[240],ae([0,1,24,68,16,15,9,25,19,111,112,113]),function(Z,e,k,i,D,A,O,R,P,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let g=class{constructor(h,y,f,l,d){this.b=h,this.c=y,this.d=f,this.e=l,this.f=d,this.a=new Map}async g(h){if(!this.a.has(h.id)){const{machineId:y,sessionId:f}=await this.c.getTelemetryInfo(),l=Object.create(null);l["common.vscodemachineid"]=y,l["common.vscodesessionid"]=f;const d=[h.id,JSON.stringify(l),h.aiKey],w=new i.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),I=[new S.TelemetryAppenderClient(w),new E.TelemetryLogAppender(this.d,this.e,`[${h.id}] `)];this.a.set(h.id,new b.TelemetryService({appenders:I,sendErrorTelemetry:h.sendErrorTelemetry},this.b,this.f))}return this.a.get(h.id)}async publicLog(h,y,f){await(await this.g(h)).publicLog(y,f)}async publicLogError(h,y,f){await(await this.g(h)).publicLogError(y,f)}};g=ye([K(0,D.IConfigurationService),K(1,P.ITelemetryService),K(2,O.ILoggerService),K(3,A.IEnvironmentService),K(4,R.IProductService)],g),e.CustomEndpointTelemetryService=g}),define(oe[241],ae([0,1,6,23,3,2,9]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends A.Disposable{constructor(S,E){super(),this.h=E,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new D.Emitter),this.onCreateRequest=this.g.event,this.b=S===void 0?15e3:S}createRequest(S){return new Promise((E,b)=>{const g=++this.a;this.c.set(g,E),this.g.fire({requestId:g,...S});const m=new i.CancellationTokenSource;(0,k.timeout)(this.b,m.token).then(()=>b(`Request ${g} timed out (${this.b}ms)`)),this.f.set(g,[(0,A.toDisposable)(()=>m.cancel())])})}acceptReply(S,E){const b=this.c.get(S);b?(this.c.delete(S),(0,A.dispose)(this.f.get(S)||[]),this.f.delete(S),b(E)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};R=ye([K(1,O.ILogService)],R),e.RequestStore=R}),define(oe[114],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(p){p.Shell="terminal.integrated.shell.",p.ShellArgs="terminal.integrated.shellArgs.",p.DefaultProfile="terminal.integrated.defaultProfile.",p.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(p){p.ShellLinux="terminal.integrated.shell.linux",p.ShellMacOs="terminal.integrated.shell.osx",p.ShellWindows="terminal.integrated.shell.windows",p.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",p.AutomationShellLinux="terminal.integrated.automationShell.linux",p.AutomationShellMacOs="terminal.integrated.automationShell.osx",p.AutomationShellWindows="terminal.integrated.automationShell.windows",p.AutomationProfileLinux="terminal.integrated.automationProfile.linux",p.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",p.AutomationProfileWindows="terminal.integrated.automationProfile.windows",p.ShellArgsLinux="terminal.integrated.shellArgs.linux",p.ShellArgsMacOs="terminal.integrated.shellArgs.osx",p.ShellArgsWindows="terminal.integrated.shellArgs.windows",p.ProfilesWindows="terminal.integrated.profiles.windows",p.ProfilesMacOs="terminal.integrated.profiles.osx",p.ProfilesLinux="terminal.integrated.profiles.linux",p.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",p.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",p.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",p.UseWslProfiles="terminal.integrated.useWslProfiles",p.TabsDefaultColor="terminal.integrated.tabs.defaultColor",p.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",p.TabsEnabled="terminal.integrated.tabs.enabled",p.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",p.TabsHideCondition="terminal.integrated.tabs.hideCondition",p.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",p.TabsShowActions="terminal.integrated.tabs.showActions",p.TabsLocation="terminal.integrated.tabs.location",p.TabsFocusMode="terminal.integrated.tabs.focusMode",p.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",p.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",p.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",p.CopyOnSelection="terminal.integrated.copyOnSelection",p.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",p.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",p.FontFamily="terminal.integrated.fontFamily",p.FontSize="terminal.integrated.fontSize",p.LetterSpacing="terminal.integrated.letterSpacing",p.LineHeight="terminal.integrated.lineHeight",p.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",p.TabStopWidth="terminal.integrated.tabStopWidth",p.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",p.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",p.BellDuration="terminal.integrated.bellDuration",p.FontWeight="terminal.integrated.fontWeight",p.FontWeightBold="terminal.integrated.fontWeightBold",p.CursorBlinking="terminal.integrated.cursorBlinking",p.CursorStyle="terminal.integrated.cursorStyle",p.CursorWidth="terminal.integrated.cursorWidth",p.Scrollback="terminal.integrated.scrollback",p.DetectLocale="terminal.integrated.detectLocale",p.DefaultLocation="terminal.integrated.defaultLocation",p.GpuAcceleration="terminal.integrated.gpuAcceleration",p.TerminalTitleSeparator="terminal.integrated.tabs.separator",p.TerminalTitle="terminal.integrated.tabs.title",p.TerminalDescription="terminal.integrated.tabs.description",p.RightClickBehavior="terminal.integrated.rightClickBehavior",p.Cwd="terminal.integrated.cwd",p.ConfirmOnExit="terminal.integrated.confirmOnExit",p.ConfirmOnKill="terminal.integrated.confirmOnKill",p.EnableBell="terminal.integrated.enableBell",p.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",p.AllowChords="terminal.integrated.allowChords",p.AllowMnemonics="terminal.integrated.allowMnemonics",p.EnvMacOs="terminal.integrated.env.osx",p.EnvLinux="terminal.integrated.env.linux",p.EnvWindows="terminal.integrated.env.windows",p.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",p.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",p.ShowExitAlert="terminal.integrated.showExitAlert",p.SplitCwd="terminal.integrated.splitCwd",p.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",p.WordSeparators="terminal.integrated.wordSeparators",p.EnableFileLinks="terminal.integrated.enableFileLinks",p.UnicodeVersion="terminal.integrated.unicodeVersion",p.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",p.LocalEchoEnabled="terminal.integrated.localEchoEnabled",p.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",p.LocalEchoStyle="terminal.integrated.localEchoStyle",p.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",p.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",p.CustomGlyphs="terminal.integrated.customGlyphs",p.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",p.InheritEnv="terminal.integrated.inheritEnv",p.ShowLinkHover="terminal.integrated.showLinkHover",p.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",p.AutoReplies="terminal.integrated.autoReplies",p.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",p.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",p.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",p.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",p.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(p){p.FileName="ptyhost"})(A=e.TerminalLogConstants||(e.TerminalLogConstants={}));var O;(function(p){p.PowerShell="pwsh",p.Bash="bash",p.Fish="fish",p.Sh="sh",p.Csh="csh",p.Ksh="ksh",p.Zsh="zsh"})(O=e.PosixShellType||(e.PosixShellType={}));var R;(function(p){p.CommandPrompt="cmd",p.PowerShell="pwsh",p.Wsl="wsl",p.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(p){p[p.Api=0]="Api",p[p.Process=1]="Process",p[p.Sequence=2]="Sequence",p[p.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(p){p.LocalPty="localPty",p.PtyHost="ptyHost",p.Log="log",p.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var E;(function(p){p.Cwd="cwd",p.InitialCwd="initialCwd",p.FixedDimensions="fixedDimensions",p.Title="title",p.ShellType="shellType",p.HasChildProcesses="hasChildProcesses",p.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",p.OverrideDimensions="overrideDimensions",p.FailedShellIntegrationActivation="failedShellIntegrationActivation",p.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(p){p[p.BeatInterval=5e3]="BeatInterval",p[p.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",p[p.SecondWaitMultiplier=1]="SecondWaitMultiplier",p[p.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var g;(function(p){p[p.Panel=1]="Panel",p[p.Editor=2]="Editor"})(g=e.TerminalLocation||(e.TerminalLocation={}));var m;(function(p){p.TerminalView="view",p.Editor="editor"})(m=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(p){p[p.GraceTime=6e4]="GraceTime",p[p.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(p){p[p.HighWatermarkChars=1e5]="HighWatermarkChars",p[p.LowWatermarkChars=5e3]="LowWatermarkChars",p[p.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var f;(function(p){p.GitBash="Git Bash",p.Pwsh="PowerShell"})(f=e.ProfileSource||(e.ProfileSource={}));var l;(function(p){p[p.Off=0]="Off",p[p.FinalTerm=1]="FinalTerm",p[p.VSCode=2]="VSCode"})(l=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var d;(function(p){p[p.Unknown=0]="Unknown",p[p.Shutdown=1]="Shutdown",p[p.Process=2]="Process",p[p.User=3]="User",p[p.Extension=4]="Extension"})(d=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(oe[242],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(oe[243],ae([0,1,34,24,32,12,5,36,27,13,28]),function(Z,e,k,i,D,A,O,R,P,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let n=0;return I&&I.length===4&&(n=parseInt(I[3])),n}e.getWindowsBuildNumber=b;async function g(I,n,c,t=R.env,s=E.Promises.exists){if(A.isAbsolute(I))return await s(I)?I:void 0;if(n===void 0&&(n=R.cwd()),A.dirname(I)!=="."){const u=A.join(n,I);return await s(u)?u:void 0}const a=(0,D.getCaseInsensitive)(t,"PATH");if(c===void 0&&(0,S.isString)(a)&&(c=a.split(A.delimiter)),c===void 0||c.length===0){const u=A.join(n,I);return await s(u)?u:void 0}for(const u of c){let v;if(A.isAbsolute(u)?v=A.join(u,I):v=A.join(n,u,I),await s(v))return v;if(O.isWindows){let C=v+".com";if(await s(C)||(C=v+".exe",await s(C)))return C}}const r=A.join(n,I);return await s(r)?r:void 0}e.findExecutable=g;function m(I,n,c,t,s){if(!n.shellIntegration.enabled||!I.executable||I.isFeatureTerminal||I.hideFromUser||I.ignoreShellIntegration||O.isWindows&&!n.windowsEnableConpty)return;const o=I.args,a=R.platform==="win32"?A.basename(I.executable).toLowerCase():A.basename(I.executable),r=A.dirname(i.FileAccess.asFileUri("").fsPath);let u;const v={VSCODE_INJECTION:"1"};if(O.isWindows){if(a==="pwsh.exe"||a==="powershell.exe")return!o||p(o)?u=y.get(h.WindowsPwsh):d(o)&&(u=y.get(h.WindowsPwshLogin)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],r,""),{newArgs:u,envMixin:v}):void 0;t.warn(`Shell integration cannot be enabled for executable "${I.executable}" and args`,I.args);return}switch(a){case"bash":return!o||o.length===0?u=y.get(h.Bash):w(o)&&(v.VSCODE_SHELL_LOGIN="1",u=y.get(h.Bash)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],r),{newArgs:u,envMixin:v}):void 0;case"fish":{const C=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",T=A.join(r,"out/vs/workbench/contrib/xdg_data");return v.XDG_DATA_DIRS=`${C}:${T}`,{newArgs:void 0,envMixin:v}}case"pwsh":return!o||p(o)?u=y.get(h.Pwsh):d(o)&&(u=y.get(h.PwshLogin)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],r,""),{newArgs:u,envMixin:v}):void 0;case"zsh":{if(!o||o.length===0?u=y.get(h.Zsh):w(o)?u=y.get(h.ZshLogin):(o===y.get(h.Zsh)||o===y.get(h.ZshLogin))&&(u=o),!u)return;u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],r);let C;try{C=k.userInfo().username}catch{C="unknown"}const T=A.join(k.tmpdir(),`${C}-${s.applicationName}-zsh`);v.ZDOTDIR=T;const N=c?.ZDOTDIR??k.homedir()??"~";v.USER_ZDOTDIR=N;const F=[];return F.push({source:A.join(r,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(T,".zshrc")}),F.push({source:A.join(r,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(T,".zprofile")}),F.push({source:A.join(r,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(T,".zshenv")}),F.push({source:A.join(r,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(T,".zlogin")}),{newArgs:u,envMixin:v,filesToCopy:F}}}t.warn(`Shell integration cannot be enabled for executable "${I.executable}" and args`,I.args)}e.getShellIntegrationInjection=m;var h;(function(I){I.WindowsPwsh="windows-pwsh",I.WindowsPwshLogin="windows-pwsh-login",I.Pwsh="pwsh",I.PwshLogin="pwsh-login",I.Zsh="zsh",I.ZshLogin="zsh-login",I.Bash="bash"})(h||(h={}));const y=new Map;y.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),y.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),y.set(h.Zsh,["-i"]),y.set(h.ZshLogin,["-il"]),y.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const f=["-login","-l"],l=["-nol","-nologo"];function d(I){return typeof I=="string"?f.includes(I.toLowerCase()):I.length===1&&f.includes(I[0].toLowerCase())||I.length===2&&(f.includes(I[0].toLowerCase())||f.includes(I[1].toLowerCase()))&&(l.includes(I[0].toLowerCase())||l.includes(I[1].toLowerCase()))}function p(I){return typeof I=="string"?l.includes(I.toLowerCase()):I.length===0||I?.length===1&&l.includes(I[0].toLowerCase())}function w(I){return I==="string"&&f.includes(I.toLowerCase())||typeof I!="string"&&I.length===1&&f.includes(I[0].toLowerCase())}}),define(oe[244],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var k;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(k=e.ColorScheme||(e.ColorScheme={}));function i(A){return A===k.HIGH_CONTRAST_DARK||A===k.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function D(A){return A===k.DARK||A===k.HIGH_CONTRAST_DARK}e.isDark=D}),define(oe[115],ae([0,1,52,3,2,4,40,244]),function(Z,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var P;(function(f){function l(d){return d&&typeof d=="object"&&typeof d.id=="string"}f.isThemeColor=l})(P=e.ThemeColor||(e.ThemeColor={}));function S(f){return{id:f}}e.themeColorFromId=S;var E;(function(f){function l(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||P.isThemeColor(s.color))}f.isThemeIcon=l;const d=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function p(s){const o=d.exec(s);if(!o)return;const[,a]=o;return{id:a}}f.fromString=p;function w(s){return{id:s}}f.fromId=w;function I(s,o){let a=s.id;const r=a.lastIndexOf("~");return r!==-1&&(a=a.substring(0,r)),o&&(a=`${a}~${o}`),{id:a}}f.modify=I;function n(s){const o=s.id.lastIndexOf("~");if(o!==-1)return s.id.substring(o+1)}f.getModifier=n;function c(s,o){return s.id===o.id&&s.color?.id===o.color?.id}f.isEqual=c;function t(s,o){return{id:s.id,color:o?S(o):void 0}}f.asThemeIcon=t,f.asClassNameArray=k.CSSIcon.asClassNameArray,f.asClassName=k.CSSIcon.asClassName,f.asCSSSelector=k.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function b(f){switch(f){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case R.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,D.toDisposable)(()=>{const d=this.a.indexOf(l);this.a.splice(d,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const m=new g;O.Registry.add(e.Extensions.ThemingContribution,m);function h(f){return m.onColorThemeChange(f)}e.registerThemingParticipant=h;class y extends D.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(d=>this.n(d)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,d){let p=this.h.getColor(l);return p&&d&&(p=d(p,this.h)),p?p.toString():null}}e.Themable=y}),define(oe[245],ae([0,1,52,8,174,115]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function O(g,m){const h=[{name:null,description:(0,D.localize)(0,null)}];return h.push(...g.map(y=>({name:y.profileName,description:R(y)}))),m&&h.push(...m.map(y=>({name:y.title,description:P(y)}))),{values:h.map(y=>y.name),markdownDescriptions:h.map(y=>y.description)}}e.createProfileSchemaEnums=O;function R(g){let m=`$(${A.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:k.Codicon.terminal.id}) ${g.profileName}
- path: ${g.path}`;return g.args&&(typeof g.args=="string"?m+=`
- args: "${g.args}"`:m+=`
- args: [${g.args.length===0?"":`'${g.args.join("','")}'`}]`),g.overrideName!==void 0&&(m+=`
- overrideName: ${g.overrideName}`),g.color&&(m+=`
- color: ${g.color}`),g.env&&(m+=`
- env: ${JSON.stringify(g.env)}`),m}function P(g){return`$(${A.ThemeIcon.isThemeIcon(g.icon)?g.icon.id:g.icon?g.icon:k.Codicon.terminal.id}) ${g.title}
- extensionIdentifier: ${g.extensionIdentifier}`}function S(g,m){if(!g&&!m)return!0;if(typeof g=="string"&&typeof m=="string")return g===m;if(Array.isArray(g)&&Array.isArray(m)){if(g.length!==m.length)return!1;for(let h=0;h<g.length;h++)if(g[h]!==m[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function E(g,m){if(!g&&!m)return!0;if(!g||!m)return!1;if(A.ThemeIcon.isThemeIcon(g)&&A.ThemeIcon.isThemeIcon(m))return g.id===m.id&&g.color===m.color;if(typeof g=="object"&&"light"in g&&"dark"in g&&typeof m=="object"&&"light"in m&&"dark"in m){const h=g,y=m;if((i.URI.isUri(h.light)||b(h.light))&&(i.URI.isUri(h.dark)||b(h.dark))&&(i.URI.isUri(y.light)||b(y.light))&&(i.URI.isUri(y.dark)||b(y.dark)))return h.light.path===y.light.path&&h.dark.path===y.dark.path}if(i.URI.isUri(g)&&i.URI.isUri(m)||b(g)||b(m)){const h=g,y=m;return h.path===y.path&&h.scheme===y.scheme}return!1}e.terminalIconsEqual=E;function b(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}e.isUriComponents=b}),define(oe[246],ae([0,1,52,173,46,40,245]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(k.Codicon.getAll(),w=>w.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),w=>`$(${w.id})`)};const R={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),...e.terminalIconSchema},color:{description:(0,i.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},P={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},S={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...R}},E=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),g=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),f={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:g},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){A.Registry.as(D.Extensions.Configuration).registerConfiguration(f),p()}e.registerTerminalPlatformConfiguration=l;let d;function p(w,I){const n=A.Registry.as(D.Extensions.Configuration);let c;w&&(c=(0,O.createProfileSchemaEnums)(w?.profiles,I));const t=d;d={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:w?.os===3?c?.values:void 0,markdownEnumDescriptions:w?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:w?.os===2?c?.values:void 0,markdownEnumDescriptions:w?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:w?.os===1?c?.values:void 0,markdownEnumDescriptions:w?.os===1?c?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[d],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(oe[247],ae([0,1,50,52,12,5,13,28,91,243,115]),function(Z,e,k,i,D,A,O,R,P,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let b,g=!0;function m(t,s,o,a,r=process.env,u,v,C,T){return u=u||{existsFile:R.SymlinkSupport.existsFile,readFile:R.Promises.readFile},A.isWindows?h(o,u,r,v,a.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:a.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:a.getValue("terminal.integrated.defaultProfile.windows"),T,C):I(u,v,o,t&&typeof t=="object"?{...t}:a.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:a.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,C,r)}e.detectAvailableProfiles=m;async function h(t,s,o,a,r,u,v,C,T){const N=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),F=`${process.env.windir}\\${N?"Sysnative":"System32"}`;let j=!1;(0,S.getWindowsBuildNumber)()>=16299&&(j=!0),await l(C);const L=new Map;if(t){L.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),L.set("Windows PowerShell",{path:`${F}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),L.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),L.set("Command Prompt",{path:`${F}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0}),L.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),L.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:i.Codicon.terminalBash,isAutoDetected:!0});const z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;L.set("Cmder",{path:`${F}\\cmd.exe`,args:["/K",z],requiresPath:process.env.CMDER_ROOT?z:{path:z,isUnsafe:!0},isAutoDetected:!0})}n(u,L);const $=await y(L.entries(),v,s,o,a,T);if(t||r)try{const z=await p(`${F}\\${j?"wsl":"bash"}.exe`,v);for(const H of z)(!u||!(H.profileName in u))&&$.push(H)}catch{g&&(a?.info("WSL is not installed, so could not detect WSL profiles"),g=!1)}return $}async function y(t,s,o,a=process.env,r,u){const v=[];for(const[C,T]of t){if(T===null)continue;let N,F,j;if("source"in T){const H=b?.get(T.source);if(!H)continue;N=H.paths,F=T.args||H.args,T.icon?j=f(T.icon):H.icon&&(j=H.icon)}else N=Array.isArray(T.path)?T.path:[T.path],F=A.isWindows||Array.isArray(T.args)?T.args:void 0,j=f(T.icon);let L;if(u){const H=N.map(ie=>typeof ie=="string"?ie:ie.path),X=await u(H);L=new Array(N.length);for(let ie=0;ie<N.length;ie++)typeof N[ie]=="string"?L[ie]=X[ie]:L[ie]={path:X[ie],isUnsafe:!0}}else L=N.slice();let $;if(T.requiresPath){let H;if((0,O.isString)(T.requiresPath)?H=T.requiresPath:(H=T.requiresPath.path,T.requiresPath.isUnsafe&&($=H)),!await o.existsFile(H))continue}const z=await c(C,s,L,o,a,F,T.env,T.overrideName,T.isAutoDetected,$);z?(z.isAutoDetected=T.isAutoDetected,z.icon=j,z.color=T.color,v.push(z)):r?.debug("Terminal profile not validated",C,N)}return r?.debug("Validated terminal profiles",v),v}function f(t){return typeof t=="string"?{id:t}:t}async function l(t){b&&!t||(b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:t||await d(),icon:E.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function d(){const t=[];for await(const s of(0,P.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function p(t,s){const o=[],a=await new Promise((v,C)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,N)=>{if(T)return C("Problem occurred when getting wsl distros");v(N)})});if(!a)return[];const r=new RegExp(/[\r?\n]/),u=a.split(r).filter(v=>v.trim().length>0&&v!=="");for(const v of u){if(v===""||v.startsWith("docker-desktop"))continue;const C=`${v} (WSL)`,T={profileName:C,path:t,args:["-d",`${v}`],isDefault:C===s,icon:w(v),isAutoDetected:!1};o.push(T)}return o}function w(t){return t.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):t.includes("Debian")?E.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function I(t,s,o,a,r,u,v,C){const T=new Map;if(o){const N=(await t.readFile("/etc/shells")).toString(),F=u||N.split(`
`).filter(L=>L.trim().includes("#")&&L.trim().length>0),j=new Map;for(const L of F){let $=(0,D.basename)(L),z=j.get($)||0;z++,z>1&&($=`${$} (${z})`),j.set($,z),T.set($,{path:L,isAutoDetected:!0})}}return n(a,T),await y(T.entries(),r,t,C,s,v)}function n(t,s){if(!!t)for(const[o,a]of Object.entries(t))a===null||!("path"in a)&&!("source"in a)?s.delete(o):(a.icon=a.icon||s.get(o)?.icon,s.set(o,a))}async function c(t,s,o,a,r,u,v,C,T,N){if(o.length===0)return Promise.resolve(void 0);const F=o.shift();if(F==="")return c(t,s,o,a,r,u,v,C,T);const j=typeof F!="string"&&F.isUnsafe,L=typeof F=="string"?F:F.path,$={profileName:t,path:L,args:u,env:v,overrideName:C,isAutoDetected:T,isDefault:t===s,isUnsafePath:j,requiresUnsafePath:N};if((0,D.basename)(L)===L){const H=r.PATH?r.PATH.split(D.delimiter):void 0,X=await(0,S.findExecutable)(L,void 0,H,void 0,a.existsFile);return X?($.path=X,$.isFromPath=!0,$):c(t,s,o,a,r,u)}return await a.existsFile((0,D.normalize)(L))?$:c(t,s,o,a,r,u,v,C,T)}}),define(oe[248],ae([0,1,3,2,24,5,39,68,16,15,95,229,9,104,241,114,246,247]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let p=0,w=class extends i.Disposable{constructor(n,c,t,s){super(),this.C=n,this.D=c,this.F=t,this.G=s,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new k.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new k.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new k.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new k.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new k.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new k.Emitter),this.onProcessData=this.s.event,this.t=this.B(new k.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new k.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new k.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new k.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new k.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new k.Emitter),this.onProcessExit=this.z.event,(0,f.registerTerminalPlatformConfiguration)(),this.c=this.J(),this.B((0,i.toDisposable)(()=>this.M())),this.f=this.B(new h.RequestStore(void 0,this.G)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.L(),this.B(this.D.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.I()}))}initialize(){this.I()}get H(){return this.D.getValue("terminal.integrated.ignoreProcessNames")}async I(){return this.b.refreshIgnoreProcessNames?.(this.H)}async J(){if(A.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this.D,this.G,{_:[]},process.env)}catch(n){return this.G.error("ptyHost was unable to resolve shell environment",n),{}}}L(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.F.logsPath],env:{VSCODE_LAST_PTY_ID:p,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},c=(0,E.parsePtyHostPort)(this.F.args,this.F.isBuilt);c&&(c.break&&c.port?n.debugBrk=c.port:!c.break&&c.port&&(n.debug=c.port));const t=new R.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this.m.fire(),O.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.N()),this.N(),this.B(t.onDidProcessExit(r=>{this.l.fire(r.code),this.i||(this.g<=d.MaxRestarts?(this.G.error(`ptyHost terminated unexpectedly with code ${r.code}`),this.g++,this.restartPtyHost()):this.G.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const o=t.getChannel(y.TerminalIpcChannels.Log);m.LogLevelChannelClient.setLevel(o,this.G.getLevel()),this.B(this.G.onDidChangeLogLevel(()=>{m.LogLevelChannelClient.setLevel(o,this.G.getLevel())}));const a=O.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(a.onProcessData(r=>this.s.fire(r))),this.B(a.onProcessReady(r=>this.t.fire(r))),this.B(a.onProcessExit(r=>this.z.fire(r))),this.B(a.onDidChangeProperty(r=>this.y.fire(r))),this.B(a.onProcessReplay(r=>this.u.fire(r))),this.B(a.onProcessOrphanQuestion(r=>this.v.fire(r))),this.B(a.onDidRequestDetach(r=>this.w.fire(r))),[t,a]}dispose(){this.i=!0,super.dispose()}async createProcess(n,c,t,s,o,a,r,u,v,C,T){const N=setTimeout(()=>this.Q(),y.HeartbeatConstants.CreateProcessTimeout),F=await this.b.createProcess(n,c,t,s,o,a,r,u,v,C,T);return clearTimeout(N),p=Math.max(p,F),F}updateTitle(n,c,t){return this.b.updateTitle(n,c,t)}updateIcon(n,c,t,s){return this.b.updateIcon(n,c,t,s)}attachToProcess(n){return this.b.attachToProcess(n)}detachFromProcess(n,c){return this.b.detachFromProcess(n,c)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(n){return this.b.start(n)}shutdown(n,c){return this.b.shutdown(n,c)}input(n,c){return this.b.input(n,c)}processBinary(n,c){return this.b.processBinary(n,c)}resize(n,c,t){return this.b.resize(n,c,t)}acknowledgeDataEvent(n,c){return this.b.acknowledgeDataEvent(n,c)}setUnicodeVersion(n,c){return this.b.setUnicodeVersion(n,c)}getInitialCwd(n){return this.b.getInitialCwd(n)}getCwd(n){return this.b.getCwd(n)}getLatency(n){return this.b.getLatency(n)}orphanQuestionReply(n){return this.b.orphanQuestionReply(n)}installAutoReply(n,c){return this.b.installAutoReply(n,c)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(n){return this.b.uninstallAutoReply(n)}getDefaultSystemShell(n){return this.b.getDefaultSystemShell(n)}async getProfiles(n,c,t,s=!1){const o=await this.c;return(0,l.detectAvailableProfiles)(c,t,s,this.D,o,void 0,this.G,this.S.bind(this,n))}getEnvironment(){return this.b.getEnvironment()}getWslPath(n,c){return this.b.getWslPath(n,c)}getRevivedPtyNewId(n){return this.b.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this.b.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this.b.getTerminalLayoutInfo(n)}async requestDetachInstance(n,c){return this.b.requestDetachInstance(n,c)}async acceptDetachInstanceReply(n,c){return this.b.acceptDetachInstanceReply(n,c)}async freePortKillProcess(n){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(n)}async serializeTerminalState(n){return this.b.serializeTerminalState(n)}async reviveTerminalProcesses(n,c){return this.b.reviveTerminalProcesses(n,c)}async refreshProperty(n,c){return this.b.refreshProperty(n,c)}async updateProperty(n,c,t){return this.b.updateProperty(n,c,t)}async restartPtyHost(){this.h=!0,this.M(),[this.a,this.b]=this.L()}M(){this.b.shutdownAll?.(),this.a.dispose()}N(){this.R(),this.j=setTimeout(()=>this.O(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}O(){this.G.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.P(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}P(){this.G.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}Q(){this.R(),this.G.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}R(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}S(n,c){return this.f.createRequest({workspaceId:n,originalText:c})}async acceptPtyHostResolvedVariables(n,c){this.f.acceptReply(n,c)}};w=ye([K(1,P.IConfigurationService),K(2,S.IEnvironmentService),K(3,g.ILogService)],w),e.PtyHostService=w}),define(oe[77],ae([0,1,3,16,4,9]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var O;(function(y){y.Http="http",y.Https="https"})(O=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var P;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=b;function g(y,f,l,d){if(l===1)return!1;if(l===2&&b(f)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(p?.length===4&&parseInt(p[1])>=18)return!1}return y<1024}e.isPortPrivileged=g;class m{constructor(f,l,d){this.remoteAddress=f,this.localAddress=l,this.b=d,this.a=new k.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=m;let h=class{constructor(f,l){this.i=f,this.j=l,this.a=new k.Emitter,this.onTunnelOpened=this.a.event,this.b=new k.Emitter,this.onTunnelClosed=this.b.event,this.c=new k.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const f=this.j.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(f){return this.e=f,f?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(f){this.f=f.elevation,this.g=f.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const f=[],l=Array.from(this.d.values());for(const d of l){const p=Array.from(d.values());for(const w of p){const I=await w.value;I&&f.push(I)}}return f}async dispose(){for(const f of this.d.values()){for(const{value:l}of f.values())await l.then(d=>d?.dispose());f.clear()}this.d.clear()}setEnvironmentTunnel(f,l,d,p,w){this.o(f,l,Promise.resolve({tunnelRemoteHost:f,tunnelRemotePort:l,localAddress:d,privacy:p,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(f,l){(b(f)||E(f))&&(f=e.LOCALHOST_ADDRESSES[0]);const d=this.q(f,l);if(d)return++d.refcount,d.value}openTunnel(f,l,d,p,w=!1,I,n){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${d} on local port ${p}.`),!f)return;if(l||(l="localhost"),this.e&&this.h.has(d)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.r(f,l,d,p,w,I,n);return c?c.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,d);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(t);return(t.tunnelRemoteHost!==l||t.tunnelRemotePort!==d)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}m(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const l=this.d.get(f.tunnelRemoteHost);if(l){const d=l.get(f.tunnelRemotePort);d&&(d.refcount--,await this.n(f.tunnelRemoteHost,f.tunnelRemotePort,d))}}}}async n(f,l,d){if(d.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${l}.`);const p=d.value.then(async w=>{w&&(await w.dispose(!0),this.b.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this.d.has(f)&&this.d.get(f).delete(l),p}}async closeTunnel(f,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${l} `);const d=this.d.get(f);if(d&&d.has(l)){const p=d.get(l);p.refcount=0,await this.n(f,l,p)}}o(f,l,d){this.d.has(f)||this.d.set(f,new Map),this.d.get(f).set(l,{refcount:1,value:d})}async p(f,l){const d=this.d.get(f);d&&(await d.get(l)||d.delete(l),d.size===0&&this.d.delete(f))}q(f,l){const d=[f];E(f)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):b(f)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const p=d.map(w=>this.d.get(w));for(const w of p){const I=w?.get(l);if(I)return I}}canTunnel(f){return!!S(f)}s(f,l,d,p,w,I,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${d} on local port ${p}.`);const c=d;this.h.add(c);const t=p===void 0?d:p,s={elevationRequired:w?this.isPortPrivileged(t):!1},o={remoteAddress:{host:l,port:d},localAddressPort:p,privacy:I,public:I?I!==R.Private:void 0,protocol:n},a=f.forwardPort(o,s);return a?(this.o(l,d,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(c)})):this.h.delete(c),a}};h=ye([K(0,A.ILogService),K(1,i.IConfigurationService)],h),e.AbstractTunnelService=h}),define(oe[249],ae([0,1,9,77,2,7,6]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends D.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.DeferredPromise),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let P=class Dt extends D.Disposable{constructor(E,b){super(),this.f=E,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++Dt.a)}}async startTunnel(E,b,g,m,h,y){const f=new R,l=await Promise.resolve(this.f.openTunnel(E,f,g,m,h,y));if(!l)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${g}:${m} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),f.dispose(),await l.dispose(),(0,A.canceled)();return f.setTunnel(l),this.b.set(b,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${l.localAddress} (local) to ${g}:${m} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(E,b){const g=this.b.get(E);!g||g.setAddress(b)}async destroyTunnel(E){const b=this.b.get(E);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await b.dispose();return}this.c.add(E)}};P.a=0,P=ye([K(0,i.ISharedTunnelsService),K(1,k.ILogService)],P),e.SharedProcessTunnelService=P}),define(oe[250],ae([0,1,86,34,133,221,6,2,16,9,25,219,77,109,5]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(w,I,n,c,t){let s;for(let o=3;o&&(s?.dispose(),s=await new f(w,I,n,c,t).waitForReady(),!(t&&D.BROWSER_RESTRICTED_PORTS[t]||!D.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));o--);return s}class f extends R.Disposable{constructor(I,n,c,t,s){super(),this.j=n,this.k=s,this.privacy=g.TunnelPrivacyId.Private,this.i=new Map,this.a=I,this.b=k.createServer(),this.c=new O.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const I=this.k??this.tunnelRemotePort,n=(0,g.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let c=await(0,D.findFreePortFaster)(I,2,1e3,n),t=null;return this.b.listen(c,this.j),await this.c.wait(),t=this.b.address(),t||(c=0,this.b.listen(c,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(I){I.pause();const n=(0,g.isLocalhost)(this.tunnelRemoteHost)||(0,g.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,b.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),t=c.getSocket().socket,s=c.readEntireBuffer();c.dispose(),s.byteLength>0&&I.write(s.buffer),I.on("end",()=>{I.localAddress&&this.i.delete(I.localAddress),t.end()}),I.on("close",()=>t.end()),I.on("error",()=>{I.localAddress&&this.i.delete(I.localAddress),t.destroy()}),t.on("end",()=>I.end()),t.on("close",()=>I.end()),t.on("error",()=>{I.destroy()}),I.pipe(t),t.pipe(I),I.localAddress&&this.i.set(I.localAddress,()=>{I.end(),t.end()})}}let l=class extends g.AbstractTunnelService{constructor(I,n,c,t,s){super(n,s),this.t=I,this.u=c,this.v=t}isPortPrivileged(I){return(0,g.isPortPrivileged)(I,this.k,h.OS,i.release())}r(I,n,c,t,s,o,a){const r=this.q(n,c);if(r)return++r.refcount,r.value;if(this.e)return this.s(this.e,n,c,t,s,o,a);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${c} on local port ${t}.`);const u={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:I,signService:this.u,logService:this.i,ipcLogger:null},v=y(u,this.k,n,c,t);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,c,v),v}}};l=ye([K(1,S.ILogService),K(2,m.ISignService),K(3,E.IProductService),K(4,P.IConfigurationService)],l),e.BaseTunnelService=l;let d=class extends l{constructor(I,n,c,t){super(A.nodeSocketFactory,I,n,c,t)}};d=ye([K(0,S.ILogService),K(1,m.ISignService),K(2,E.IProductService),K(3,P.IConfigurationService)],d),e.TunnelService=d;let p=class extends R.Disposable{constructor(I,n,c,t){super(),this.b=I,this.c=n,this.f=c,this.g=t,this.a=new Map}async openTunnel(I,n,c,t,s,o,a,r){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${t} on local port ${s}.`),!this.a.has(I)){const u=new d(this.b,this.f,this.c,this.g);this.B(u),this.a.set(I,u),u.onTunnelClosed(async()=>{(await u.tunnels).length===0&&(u.dispose(),this.a.delete(I))})}return this.a.get(I).openTunnel(n,c,t,s,o,a,r)}};p=ye([K(0,S.ILogService),K(1,E.IProductService),K(2,m.ISignService),K(3,P.IConfigurationService)],p),e.SharedTunnelsService=p}),define(oe[29],ae([0,1,4]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(oe[251],ae([0,1,29,71,14,22,131,3,2]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(g){this.uri=g,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let E=class{constructor(g){this.g=g,this.c=new P.DisposableStore,this.f=2**16;const m=new Map,h=y=>{let f=m.get(y.scheme);return f===void 0&&(f=g.hasProvider(y)&&!this.g.hasCapability(y,1024),m.set(y.scheme,f)),f};this.c.add(R.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(y=>{m.delete(y.scheme)})),this.extUri=new A.ExtUri(h),this.d=new O.SkipList((y,f)=>this.extUri.compare(y,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,A.normalizePath)(g));const m=this.d.get(g);return m?m.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new S(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((h,y)=>h[1].touch<y[1].touch?1:h[1].touch>y[1].touch?-1:0);S._clock=0,this.d.clear();const m=this.f*.5;for(let h=0;h<m;h++)this.d.set(g[h][0],g[h][1].touch())}};E=ye([K(0,D.IFileService)],E),e.UriIdentityService=E,(0,i.registerSingleton)(k.IUriIdentityService,E,1)}),define(oe[252],ae([0,1,3,2,14,44,49,17]),function(Z,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends i.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(E,b,g,m){super(),this.c=E,this.f=b,this.g=g,this.h=m,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=O.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(h=>this.i(h)))}watch(E,b){this.b.set(E,E);const g=this.f.watch(this.j(E),b);return(0,i.toDisposable)(()=>{this.b.delete(E),g.dispose()})}stat(E){return this.f.stat(this.j(E))}mkdir(E){return this.f.mkdir(this.j(E))}rename(E,b,g){return this.f.rename(this.j(E),this.j(b),g)}readFile(E){return this.f.readFile(this.j(E),{atomic:!0})}readFileStream(E,b,g){const m=(0,A.newWriteableStream)(h=>R.VSBuffer.concat(h.map(y=>R.VSBuffer.wrap(y))).buffer);return(async()=>{try{const h=await this.readFile(E);m.end(h)}catch(h){m.error(h),m.end()}})(),m}readdir(E){return this.f.readdir(this.j(E))}writeFile(E,b,g){return this.f.writeFile(this.j(E),b,g)}delete(E,b){return this.f.delete(this.j(E),b)}copy(E,b,g){if((0,D.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(E),this.j(b),g);throw new Error("copy not supported")}i(E){const b=[];for(const g of E){if(g.resource.scheme!==this.c)continue;const m=this.k(g.resource);this.b.findSubstr(m)&&b.push({resource:m,type:g.type})}b.length&&(this.h.debug("User data changed"),this.a.fire(b))}j(E){return E.with({scheme:this.c})}k(E){return E.with({scheme:this.g})}}e.FileUserDataProvider=P}),define(oe[61],ae([0,1,83]),function(Z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(O,R,P,S){const E=(0,k.setProperty)(O,R,P,S)[0];return E&&(O=O.substring(0,E.offset)+E.content+O.substring(E.offset+E.length)),O}e.edit=i;function D(O,R,P){let S=P;for(;S>=0;){if(O.charAt(S)===R.charAt(R.length-1)&&R.length===1)return S+1;if(S--,R.length===2&&S>=0&&O.charAt(S)===R.charAt(0))return S+2}return 0}e.getLineStartOffset=D;function A(O,R,P){let S=P;for(;S>=0;)if(O.charAt(S)===R.charAt(R.length-1)&&R.length===1||(S++,R.length===2&&S>=0&&O.charAt(S)===R.charAt(1)))return S;return O.length-1}e.getLineEndOffset=A}),define(oe[253],ae([0,1,32,54,13]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(m,h,y,f,l,d){const p=[],w=[],I=[];if(!h){const $=m.filter(({identifier:z})=>l.every(H=>H.toLowerCase()!==z.id.toLowerCase()));return{local:{added:p,removed:w,updated:I},remote:$.length>0?{added:$,updated:[],removed:[],all:$}:null}}m=m.map(b),h=h.map(b),y=y?y.map(b):null;const n=new Map,c=$=>{$.uuid&&n.set($.id.toLowerCase(),$.uuid)};m.forEach(({identifier:$})=>c($)),h.forEach(({identifier:$})=>c($)),y?.forEach(({identifier:$})=>c($));const t=$=>{const z=$.identifier.uuid||n.get($.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${$.identifier.id.toLowerCase()}`},s=($,z)=>($.set(t(z),z),$),o=m.reduce(s,new Map),a=h.reduce(s,new Map),r=h.reduce(($,z)=>s($,(0,k.deepClone)(z)),new Map),u=y?y.reduce(s,new Map):null,v=f.reduce(s,new Map),C=l.reduce(($,z)=>{const H=n.get(z.toLowerCase());return $.add(H?`uuid:${H}`:`id:${z.toLowerCase()}`)},new Set),T=d.reduce(($,{id:z,uuid:H})=>(H=H??n.get(z.toLowerCase()),$.add(H?`uuid:${H}`:`id:${z.toLowerCase()}`)),new Set),N=O(o,a,C,!1);if(N.added.size>0||N.removed.size>0||N.updated.size>0){const $=O(u,o,C,!1),z=O(u,a,C,!0),H=(X,ie,G,M)=>({...M,installed:ie.installed||G.installed,version:G.version&&(!ie.installed||i.gt(G.version,ie.version))?G.version:ie.version,state:P(ie,G,u?.get(X)),preRelease:(ie.installed?M.preRelease:G.preRelease)??ie.preRelease});for(const X of z.removed.values()){const ie=o.get(X);if(!ie)continue;const G=(0,D.assertIsDefined)(u?.get(X)),M=!T.has(X)&&G.installed;ie.installed&&M?w.push(ie.identifier):r.set(X,ie)}for(const X of z.added.values()){const ie=(0,D.assertIsDefined)(a.get(X)),G=o.get(X);if(G){if(N.updated.has(X)){const M=H(X,G,ie,ie);R(G,ie,!1,!1)||I.push(g(M,X)),r.set(X,M)}}else ie.installed&&p.push(g(ie,X))}for(const X of z.updated.values()){const ie=(0,D.assertIsDefined)(a.get(X)),G=(0,D.assertIsDefined)(u?.get(X)),M=o.get(X);if(M)if(!T.has(X)&&G.installed&&M.installed&&!ie.installed)w.push(M.identifier);else{const x=H(X,M,ie,ie);I.push(g(x,X)),r.set(X,x)}else ie.installed&&p.push(g(ie,X))}for(const X of $.added.values())z.added.has(X)||r.set(X,(0,D.assertIsDefined)(o.get(X)));for(const X of $.updated.values()){if(z.removed.has(X)||z.updated.has(X))continue;const ie=(0,D.assertIsDefined)(o.get(X)),G=(0,D.assertIsDefined)(a.get(X));r.set(X,H(X,ie,G,ie))}for(const X of $.removed.values())z.updated.has(X)||z.removed.has(X)||v.has(X)||!(0,D.assertIsDefined)(a.get(X)).installed||T.has(X)||!(0,D.assertIsDefined)(u?.get(X)).installed||r.delete(X)}const F=[],j=O(a,r,new Set,!0),L=j.added.size>0||j.updated.size>0||j.removed.size>0;return L&&r.forEach(($,z)=>F.push(g($,z))),{local:{added:p,removed:w,updated:I},remote:L?{added:[...j.added].map($=>r.get($)),updated:[...j.updated].map($=>r.get($)),removed:[...j.removed].map($=>a.get($)),all:F}:null}}e.merge=A;function O(m,h,y,f){const l=m?[...m.keys()].filter(n=>!y.has(n)):[],d=[...h.keys()].filter(n=>!y.has(n)),p=d.filter(n=>l.indexOf(n)===-1).reduce((n,c)=>(n.add(c),n),new Set),w=l.filter(n=>d.indexOf(n)===-1).reduce((n,c)=>(n.add(c),n),new Set),I=new Set;for(const n of l){if(w.has(n))continue;const c=m.get(n),t=h.get(n);(!t||!R(c,t,f,!0))&&I.add(n)}return{added:p,removed:w,updated:I}}function R(m,h,y,f){return!(m.disabled!==h.disabled||f&&m.installed!==h.installed||m.installed&&h.installed&&m.preRelease!==h.preRelease||!E(m.state,h.state)||y&&m.version!==h.version)}function P(m,h,y){const f=m.state,l=h.state,d=y?.state;if(!h.version||f&&i.gt(m.version,h.version))return f;if(l&&i.gt(h.version,m.version)||!f)return l;if(!l)return f;const p=(0,k.deepClone)(f),w=d?S(d,l):{added:Object.keys(l).reduce((n,c)=>(n.add(c),n),new Set),removed:new Set,updated:new Set},I=d?S(d,f):{added:Object.keys(f).reduce((n,c)=>(n.add(c),n),new Set),removed:new Set,updated:new Set};for(const n of[...w.added.values(),...w.updated.values()])p[n]=l[n];for(const n of w.removed.values())I.updated.has(n)||delete p[n];return p}function S(m,h){const y=Object.keys(m),f=Object.keys(h),l=f.filter(w=>y.indexOf(w)===-1).reduce((w,I)=>(w.add(I),w),new Set),d=y.filter(w=>f.indexOf(w)===-1).reduce((w,I)=>(w.add(I),w),new Set),p=new Set;for(const w of y){if(d.has(w))continue;const I=m[w],n=h[w];(0,k.equals)(I,n)||p.add(w)}return{added:l,removed:d,updated:p}}function E(m={},h={}){const{added:y,removed:f,updated:l}=S(m,h);return y.size===0&&f.size===0&&l.size===0}function b(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function g(m,h){const y={identifier:{id:m.identifier.id,uuid:h.startsWith("uuid:")?h.substring(5):void 0},preRelease:!!m.preRelease};return m.version&&(y.version=m.version),m.disabled&&(y.disabled=!0),m.installed&&(y.installed=!0),m.state&&(y.state=m.state),y}}),define(oe[116],ae([0,1,21,16,4]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,P){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return S=S.filter(E=>E!==R&&E!==`-${R}`),P&&S.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(R,P){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return S=S.filter(E=>E!==R&&E!==`-${R}`),P&&S.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(R){const P=R.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),S=this.b().map(g=>g.toLowerCase()),E=[],b=[];if(Array.isArray(S))for(const g of S)g.startsWith("-")?b.push(g.substring(1)):E.push(g);return(0,k.distinct)([...P,...E].filter(g=>b.indexOf(g)===-1))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};A=ye([K(0,i.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(oe[254],ae([0,1,21,35,32,194,61]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(w){return(0,i.parse)(w)||[]}e.parseKeybindings=R;async function P(w,I,n,c,t){const s=R(w),o=R(I),a=n?R(n):null,r=[...s,...o,...a||[]].map(H=>H.key),u=await t.resolveUserBindings(r),v=E(s,o,a,u);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:w,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:I,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:w,hasChanges:!0,hasConflicts:!1};const C=g(s),T=g(o),N=a?g(a):null,F=h(C,T,u),j=N?h(N,C,u):{added:[...C.keys()].reduce((H,X)=>(H.add(X),H),new Set),removed:new Set,updated:new Set},L=N?h(N,T,u):{added:[...T.keys()].reduce((H,X)=>(H.add(X),H),new Set),removed:new Set,updated:new Set},$=S(F,j,L);let z=w;for(const H of $.removed.values())$.conflicts.has(H)||(z=d(z,H,c));for(const H of $.added.values()){if($.conflicts.has(H))continue;const X=T.get(H);if(X.some(ie=>ie.command!==`-${H}`&&v.conflicts.has(u[ie.key]))){$.conflicts.add(H);continue}z=l(z,X,c)}for(const H of $.updated.values()){if($.conflicts.has(H))continue;const X=T.get(H);if(X.some(ie=>ie.command!==`-${H}`&&v.conflicts.has(u[ie.key]))){$.conflicts.add(H);continue}z=p(z,H,X,c)}return{mergeContent:z,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=P;function S(w,I,n){const c=new Set,t=new Set,s=new Set,o=new Set;for(const a of I.removed.values())n.updated.has(a)&&o.add(a);for(const a of n.removed.values())o.has(a)||(I.updated.has(a)?o.add(a):t.add(a));for(const a of I.added.values())o.has(a)||n.added.has(a)&&w.updated.has(a)&&o.add(a);for(const a of n.added.values())o.has(a)||(I.added.has(a)?w.updated.has(a)&&o.add(a):c.add(a));for(const a of I.updated.values())o.has(a)||n.updated.has(a)&&w.updated.has(a)&&o.add(a);for(const a of n.updated.values())o.has(a)||(I.updated.has(a)?w.updated.has(a)&&o.add(a):s.add(a));return{added:c,removed:t,updated:s,conflicts:o}}function E(w,I,n,c){const t=new Set,s=b(w,c),o=b(I,c),a=n?b(n,c):null,r=m(s,o);if(r.added.size===0&&r.removed.size===0&&r.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const u=a?m(a,s):{added:[...s.keys()].reduce((j,L)=>(j.add(L),j),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const v=a?m(a,o):{added:[...o.keys()].reduce((j,L)=>(j.add(L),j),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:C,removed:T,updated:N,conflicts:F}=S(r,u,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:C,removed:T,updated:N,conflicts:F}}function b(w,I){const n=new Map;for(const c of w){const t=I[c.key];let s=n.get(t);s||(s=[],n.set(t,s)),s.push(c)}return n}function g(w){const I=new Map;for(const n of w){const c=n.command[0]==="-"?n.command.substring(1):n.command;let t=I.get(c);t||(t=[],I.set(c,t)),t.push(n)}return I}function m(w,I){const n=[...w.keys()],c=[...I.keys()],t=c.filter(a=>n.indexOf(a)===-1).reduce((a,r)=>(a.add(r),a),new Set),s=n.filter(a=>c.indexOf(a)===-1).reduce((a,r)=>(a.add(r),a),new Set),o=new Set;for(const a of n){if(s.has(a))continue;const r=w.get(a).map(v=>({...v,key:a})),u=I.get(a).map(v=>({...v,key:a}));(0,k.equals)(r,u,(v,C)=>f(v,C))||o.add(a)}return{added:t,removed:s,updated:o}}function h(w,I,n){const c=[...w.keys()],t=[...I.keys()],s=t.filter(r=>c.indexOf(r)===-1).reduce((r,u)=>(r.add(u),r),new Set),o=c.filter(r=>t.indexOf(r)===-1).reduce((r,u)=>(r.add(u),r),new Set),a=new Set;for(const r of c){if(o.has(r))continue;const u=w.get(r).map(C=>({...C,key:n[C.key]})),v=I.get(r).map(C=>({...C,key:n[C.key]}));y(u,v)||a.add(r)}return{added:s,removed:o,updated:a}}function y(w,I){return!(!(0,k.equals)(w.filter(({command:n})=>n[0]!=="-"),I.filter(({command:n})=>n[0]!=="-"),(n,c)=>f(n,c))||!(0,k.equals)(w.filter(({command:n})=>n[0]==="-"),I.filter(({command:n})=>n[0]==="-"),(n,c)=>f(n,c)))}function f(w,I){if(w.command!==I.command||w.key!==I.key)return!1;const n=A.ContextKeyExpr.deserialize(w.when),c=A.ContextKeyExpr.deserialize(I.when);return!(n&&!c||!n&&c||n&&c&&!n.equals(c)||!D.equals(w.args,I.args))}function l(w,I,n){for(const c of I)w=O.edit(w,[-1],c,n);return w}function d(w,I,n){const c=R(w);for(let t=c.length-1;t>=0;t--)(c[t].command===I||c[t].command===`-${I}`)&&(w=O.edit(w,[t],void 0,n));return w}function p(w,I,n,c){const t=R(w),s=t.findIndex(o=>o.command===I||o.command===`-${I}`);for(let o=t.length-1;o>=0;o--)(t[o].command===I||t[o].command===`-${I}`)&&(w=O.edit(w,[o],void 0,c));for(let o=n.length-1;o>=0;o--)w=O.edit(w,[s],n[o],c);return w}}),define(oe[255],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(A,O,R){const P={},S={},E=new Set;if(!O)return{local:{added:P,updated:S,removed:[...E.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const b=i(A,O);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:P,updated:S,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=i(R,A),m=i(R,O),h={},y={},f=new Set,l=new Set;for(const d of g.removed.values())m.updated.has(d)?P[d]=O[d]:f.add(d);for(const d of m.removed.values())l.has(d)||(g.updated.has(d)?l.add(d):E.add(d));for(const d of g.updated.values())l.has(d)||(m.updated.has(d)?b.updated.has(d)&&l.add(d):y[d]=A[d]);for(const d of m.updated.values())l.has(d)||(g.updated.has(d)?b.updated.has(d)&&l.add(d):A[d]!==void 0&&(S[d]=O[d]));for(const d of g.added.values())l.has(d)||(m.added.has(d)?b.updated.has(d)&&l.add(d):h[d]=A[d]);for(const d of m.added.values())l.has(d)||(g.added.has(d)?b.updated.has(d)&&l.add(d):P[d]=O[d]);return{local:{added:P,removed:[...E.values()],updated:S},remote:{added:h,removed:[...f.values()],updated:y},conflicts:[...l.values()]}}e.merge=k;function i(A,O){const R=A?Object.keys(A):[],P=O?Object.keys(O):[],S=P.filter(g=>R.indexOf(g)===-1).reduce((g,m)=>(g.add(m),g),new Set),E=R.filter(g=>P.indexOf(g)===-1).reduce((g,m)=>(g.add(m),g),new Set),b=new Set;for(const g of R){if(E.has(g))continue;const m=A[g],h=O[g];m!==h&&b.add(g)}return{added:S,removed:E,updated:b}}function D(A,O){const{added:R,removed:P,updated:S}=i(A,O);return R.size===0&&P.size===0&&S.size===0}e.areSame=D}),define(oe[256],ae([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(D,A,O,R){const P={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!A){const b=D.filter(({id:g})=>!R.includes(g));return b.length?S.added=b:S=null,{local:P,remote:S}}const E=i(D,A,R);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const b=i(O,D,R),g=i(O,A,R);for(const m of g.removed){const h=D.find(y=>y.id===m);h&&P.removed.push(h)}for(const m of g.added){const h=A.find(y=>y.id===m);b.added.includes(m)?E.updated.includes(m)&&P.updated.push(h):P.added.push(h)}for(const m of g.updated)P.updated.push(A.find(h=>h.id===m));for(const m of b.added)g.added.includes(m)||S.added.push(D.find(h=>h.id===m));for(const m of b.updated)g.removed.includes(m)||g.updated.includes(m)||S.updated.push(D.find(h=>h.id===m));for(const m of b.removed){const h=A.find(y=>y.id===m);h&&S.removed.push(h)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:P,remote:S}}e.merge=k;function i(D,A,O){D=D?D.filter(({id:g})=>!O.includes(g)):[],A=A.filter(({id:g})=>!O.includes(g));const R=D.map(({id:g})=>g),P=A.map(({id:g})=>g),S=P.filter(g=>R.indexOf(g)===-1),E=R.filter(g=>P.indexOf(g)===-1),b=[];for(const{id:g,name:m,shortName:h}of D){if(E.includes(g))continue;const y=A.find(f=>f.id===g);(!y||y.name!==m||y.shortName!==h)&&b.push(g)}return{added:S,removed:E,updated:b}}}),define(oe[26],ae([0,1,21,13,180,46,30,4,106,40]),function(Z,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EXTENSIONS_SYNC_CONTEXT_KEY=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const o=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(a=>!!o[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function b(){const o=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(o).filter(v=>!!o[v].ignoreSync),r=Object.keys(o).filter(v=>o[v].scope===2||o[v].scope===6),u=E();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...r,...u])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function g(){const o="vscode://schemas/ignoredSettings",a=S.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const r=S.Registry.as(P.Extensions.JSONContribution),u=()=>{const v=E(),C=b().filter(j=>j!==e.CONFIGURATION_SYNC_STORE_KEY),T=Object.keys(A.allSettings.properties).filter(j=>C.indexOf(j)===-1),N=C.filter(j=>v.indexOf(j)===-1),F={items:{type:"string",enum:[...T,...N.map(j=>`-${j}`)]}};r.registerSchema(o,F)};return a.onDidUpdateConfiguration(()=>u())}e.registerConfiguration=g;function m(o){return o&&(0,i.isObject)(o)&&(0,i.isString)(o.id)&&Array.isArray(o.scopes)}e.isAuthenticationProvider=m;var h;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState",o.Profiles="profiles"})(h=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(o,...a){return o?[o,...a]:a}e.getPathSegments=y;function f(o,a,r,u){return u.joinPath(r.userDataSyncHome,...y(o,a,`lastSync${a}.json`))}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function l(o){const a={};return a[e.HEADER_EXECUTION_ID]=o,a}e.createSyncHeaders=l;var d;(function(o){o.Unauthorized="Unauthorized",o.NotFound="NotFound",o.MethodNotFound="MethodNotFound",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoCollection="NoCollection",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyProfiles="LocalTooManyProfiles",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.Unknown="Unknown"})(d=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(a,r,u,v){super(a),this.code=r,this.resource=u,this.operationId=v,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class w extends p{constructor(a,r,u,v,C){super(a,u,void 0,C),this.url=r,this.serverCode=v}}e.UserDataSyncStoreError=w;class I extends p{constructor(a,r){super(a,r)}}e.UserDataAutoSyncError=I,function(o){function a(r){if(r instanceof o)return r;const u=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(r.name);if(u&&u[1]){const v=u[2]==="unknown"?void 0:u[2],C=u[3]==="unknown"?void 0:u[3];return new o(r.message,u[1],v,C)}return new o(r.message,"Unknown")}o.toUserDataSyncError=a}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var c;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(c=e.Change||(e.Change={}));var t;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(o){return`sync.enable.${o}`}e.getEnablementKey=s,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview",e.EXTENSIONS_SYNC_CONTEXT_KEY="extensionsSync"}),define(oe[257],ae([0,1,32,26]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(O,R,P,S,E){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const b=A(O,R);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const g=P?A(P,R):{added:Object.keys(R).reduce((d,p)=>(d.add(p),d),new Set),removed:new Set,updated:new Set},m=P?A(P,O):{added:Object.keys(O).reduce((d,p)=>(d.add(p),d),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},y=k.deepClone(R),f=!P;for(const d of m.added.values())d!==i.SYNC_SERVICE_URL_TYPE&&f&&g.added.has(d)||(y[d]=O[d]);for(const d of m.updated.values())y[d]=O[d];for(const d of m.removed.values())S.unregistered.includes(d)||delete y[d];for(const d of g.added.values()){const p=R[d];if(S.machine.includes(d)){E.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(P&&m.added.has(d))continue;const w=O[d];w&&w.value===p.value||d===i.SYNC_SERVICE_URL_TYPE&&f&&m.added.has(d)||(w?h.updated[d]=p:h.added[d]=p)}for(const d of g.updated.values()){const p=R[d];if(S.machine.includes(d)){E.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(m.updated.has(d)||m.removed.has(d))continue;const w=O[d];w&&w.value===p.value||(h.updated[d]=p)}for(const d of g.removed.values()){if(S.machine.includes(d)){E.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}m.updated.has(d)||m.removed.has(d)||h.removed.push(d)}const l=A(R,y);return{local:h,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:y}}}e.merge=D;function A(O,R){const P=Object.keys(O),S=Object.keys(R),E=S.filter(m=>P.indexOf(m)===-1).reduce((m,h)=>(m.add(h),m),new Set),b=P.filter(m=>S.indexOf(m)===-1).reduce((m,h)=>(m.add(h),m),new Set),g=new Set;for(const m of P){if(b.has(m))continue;const h=O[m],y=R[m];k.equals(h,y)||g.add(m)}return{added:E,removed:b,updated:g}}}),define(oe[258],ae([0,1,21,35,83,43,32,61,26]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(r,u,v){let C=[];v?C=b(v):C=E(u);const T=[],N=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(C))for(const F of C)F.startsWith("-")?N.push(F.substring(1)):T.push(F);return(0,k.distinct)([...r,...T].filter(F=>N.indexOf(F)===-1))}e.getIgnoredSettings=S;function E(r){let u=r.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=r.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:r.getValue("settingsSync.ignoredSettings")||[]}function b(r){const u=(0,i.parse)(r);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function g(r,u){const v=(0,i.parse)(r)||{};let C="{}";for(const T of Object.keys(v)){const N=(0,D.setProperty)(C,[T],v[T],u);C=(0,D.applyEdits)(C,N)}return C}e.removeComments=g;function m(r,u,v,C){if(v.length){const T=a(u),N=(0,i.parse)(u)||{},F=(0,i.parse)(r);if(!F)return r;const j=[];for(const L of v){const $=N[L],z=F[L];$===void 0?r=R.edit(r,[L],void 0,C):z!==void 0?r=R.edit(r,[L],$,C):j.push(n(L,T))}j.sort((L,$)=>L.startOffset-$.startOffset),j.forEach(L=>r=d(L.setting.key,u,r,C))}return r}e.updateIgnoredSettings=m;function h(r,u,v,C,T,N){const F=m(r,u,C,N),j=v!==F,L=v!==u;if(!j&&!L)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!L)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(L&&!j)return{conflictsSettings:[],localContent:m(u,r,C,N),remoteContent:null,hasConflicts:!1};if(v===null&&f(r)){const q=y(r,u,C)?null:m(u,r,C,N);return{conflictsSettings:[],localContent:q,remoteContent:null,hasConflicts:!1}}let $=r,z=u;const H=(0,i.parse)(r),X=(0,i.parse)(u),ie=v?(0,i.parse)(v):null,G=C.reduce((q,J)=>(q.add(J),q),new Set),M=l(H,X,G),V=l(ie,H,G),x=l(ie,X,G),ee=new Map,re=new Set,te=q=>{re.add(q);const J=T.filter(({key:_})=>_===q)[0];J?($=R.edit($,[q],J.value,N),z=R.edit(z,[q],J.value,N)):ee.set(q,{key:q,localValue:H[q],remoteValue:X[q]})};for(const q of V.removed.values())x.updated.has(q)?te(q):z=R.edit(z,[q],void 0,N);for(const q of x.removed.values())re.has(q)||(V.updated.has(q)?te(q):$=R.edit($,[q],void 0,N));for(const q of V.updated.values())re.has(q)||(x.updated.has(q)?M.updated.has(q)&&te(q):z=R.edit(z,[q],H[q],N));for(const q of x.updated.values())re.has(q)||(V.updated.has(q)?M.updated.has(q)&&te(q):$=R.edit($,[q],X[q],N));for(const q of V.added.values())re.has(q)||(x.added.has(q)?M.updated.has(q)&&te(q):z=d(q,$,z,N));for(const q of x.added.values())re.has(q)||(V.added.has(q)?M.updated.has(q)&&te(q):$=d(q,z,$,N));const U=ee.size>0||!y($,z,C),B=U||!y($,r,[]),W=U||!y(z,u,[]);return{localContent:B?$:null,remoteContent:W?z:null,conflictsSettings:[...ee.values()],hasConflicts:U}}e.merge=h;function y(r,u,v){if(r===u)return!0;const C=(0,i.parse)(r),T=(0,i.parse)(u),N=v.reduce((L,$)=>(L.add($),L),new Set),F=a(r).filter(L=>!(L.setting&&N.has(L.setting.key))),j=a(u).filter(L=>!(L.setting&&N.has(L.setting.key)));if(F.length!==j.length)return!1;for(let L=0;L<F.length;L++){const $=F[L],z=j[L];if($.setting&&z.setting){if($.setting.key!==z.setting.key||!O.equals(C[$.setting.key],T[$.setting.key]))return!1}else if(!$.setting&&!z.setting){if($.value!==z.value)return!1}else return!1}return!0}e.areSame=y;function f(r){return r?a(r).length===0:!0}e.isEmpty=f;function l(r,u,v){const C=r?Object.keys(r).filter(L=>!v.has(L)):[],T=Object.keys(u).filter(L=>!v.has(L)),N=T.filter(L=>C.indexOf(L)===-1).reduce((L,$)=>(L.add($),L),new Set),F=C.filter(L=>T.indexOf(L)===-1).reduce((L,$)=>(L.add($),L),new Set),j=new Set;if(r)for(const L of C){if(F.has(L))continue;const $=r[L],z=u[L];O.equals($,z)||j.add(L)}return{added:N,removed:F,updated:j}}function d(r,u,v,C){const T=(0,i.parse)(u),N=a(u),F=a(v),j=p(r,N,F);return w(v,r,T[r],j,F,C)}e.addSetting=d;function p(r,u,v){const C=u.findIndex(N=>N.setting?.key===r),T=u[C-1];if(T){if(T.setting){const F=n(T.setting.key,v);if(F)return{index:v.indexOf(F),insertAfter:!0}}else{const F=c(C,u);if(F){const j=n(F.setting.key,v);if(j){const L=t(v.indexOf(j),v),$=s(u,F,u[C]);if(L){const z=s(v,j,L),H=o($,z);return H?{index:v.indexOf(H),insertAfter:!0}:{index:v.indexOf(L),insertAfter:!1}}else{const z=s(v,j,v[v.length-1]),H=o($,z);return H?{index:v.indexOf(H),insertAfter:!0}:{index:v.length-1,insertAfter:!0}}}}}const N=u[C+1];if(N)if(N.setting){const F=n(N.setting.key,v);if(F)return{index:v.indexOf(F),insertAfter:!1}}else{const F=t(C,u);if(F){const j=n(F.setting.key,v);if(j){const L=c(v.indexOf(j),v),$=s(u,u[C],F);if(L){const z=s(v,L,j),H=o($.reverse(),z.reverse());return H?{index:v.indexOf(H),insertAfter:!1}:{index:v.indexOf(L),insertAfter:!0}}else{const z=s(v,v[0],j),H=o($.reverse(),z.reverse());return H?{index:v.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:v.length-1,insertAfter:!0}}function w(r,u,v,C,T,N){let F;return C.index===-1?F=(0,D.setProperty)(r,[u],v,N):F=I(r,u,v,C,T,N).map(j=>(0,D.withFormatting)(r,j,N)[0]),(0,D.applyEdits)(r,F)}function I(r,u,v,C,T,N){const F=`${JSON.stringify(u)}: ${JSON.stringify(v)}`,j=(0,A.getEOL)(N,r),L=T[C.index];if(C.insertAfter){const $=[];if(L.setting)$.push({offset:L.endOffset,length:0,content:","+F});else{const z=t(C.index,T),H=c(C.index,T),X=H?.setting?.commaOffset;H&&X===void 0&&$.push({offset:H.endOffset,length:0,content:","});const ie=X!==void 0&&X>L.endOffset;$.push({offset:ie?X+1:L.endOffset,length:0,content:z?j+F+",":j+F})}return $}else{if(L.setting)return[{offset:L.startOffset,length:0,content:F+","}];const $=(T[C.index-1]&&!T[C.index-1].setting?j:"")+F+(t(C.index,T)?",":"")+j;return[{offset:L.startOffset,length:0,content:$}]}}function n(r,u){return u.filter(v=>v.setting?.key===r)[0]}function c(r,u){for(let v=r-1;v>=0;v--)if(u[v].setting)return u[v]}function t(r,u){for(let v=r+1;v<u.length;v++)if(u[v].setting)return u[v]}function s(r,u,v){const C=r.indexOf(u),T=r.indexOf(v);return r.filter((N,F)=>C<F&&F<T)}function o(r,u){if(r.length&&u.length){let v=0;for(;v<u.length&&v<r.length;v++)if(r[v].value!==u[v].value)return u[v-1];return u[v-1]}}function a(r){const u=[];let v=-1,C,T;const N={onObjectBegin:F=>{v++},onObjectProperty:(F,j,L)=>{v===0&&(C=j,T=F)},onObjectEnd:(F,j)=>{v--,v===0&&u.push({startOffset:C,endOffset:F+j,value:r.substring(C,F+j),setting:{key:T,commaOffset:void 0}})},onArrayBegin:(F,j)=>{v++},onArrayEnd:(F,j)=>{v--,v===0&&u.push({startOffset:C,endOffset:F+j,value:r.substring(C,F+j),setting:{key:T,commaOffset:void 0}})},onLiteralValue:(F,j,L)=>{v===0&&u.push({startOffset:C,endOffset:j+L,value:r.substring(C,j+L),setting:{key:T,commaOffset:void 0}})},onSeparator:(F,j,L)=>{if(v===0&&F===","){let $=u.length-1;for(;$>=0&&!u[$].setting;$--);const z=u[$];z&&u.splice($,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:j}})}},onComment:(F,j)=>{v===0&&u.push({startOffset:F,endOffset:F+j,value:r.substring(F,F+j)})}};return(0,i.visit)(r,N),u}}),define(oe[78],ae([0,1,3,2,4,26]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let O=class extends i.Disposable{get account(){return this.a}constructor(P,S){super(),this.g=P,this.h=S,this.b=this.B(new k.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new k.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(P.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(P.onTokenSucceed(()=>this.f=!1))}async updateAccount(P){(P&&this.a?P.token!==this.a.token||P.authenticationProviderId!==this.a.authenticationProviderId:P!==this.a)&&(this.a=P,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(P))}};O=ye([K(0,A.IUserDataSyncStoreService),K(1,A.IUserDataSyncLogService)],O),e.UserDataSyncAccountService=O}),define(oe[259],ae([0,1,2,8]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(g){this.a=g}listen(g,m){switch(m){case"onError":return this.a.onError}throw new Error(`Event not found: ${m}`)}call(g,m,h){switch(m){case"triggerSync":return this.a.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class A{constructor(g){this.a=g}listen(g,m){throw new Error(`Event not found: ${m}`)}call(g,m,h){switch(m){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(i.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class O{constructor(g){this.a=g}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.a.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.a.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=O;class R{constructor(g){this.a=g}listen(g,m){switch(m){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${m}`)}async call(g,m,h){switch(m){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(h[0],h[1]);case"setEnablements":return this.a.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class P{constructor(g){this.a=g}listen(g,m){switch(m){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${m}`)}call(g,m,h){switch(m){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class S{constructor(g){this.a=g}listen(g,m){switch(m){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${m}`)}call(g,m,h){switch(m){case"switch":return this.a.switch(h[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class E extends k.Disposable{constructor(g){super(),this.a=g,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.a.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.a.call("getPreviousUserDataSyncStore");return this.b(g)}b(g){return{url:i.URI.revive(g.url),type:g.type,defaultUrl:i.URI.revive(g.defaultUrl),insidersUrl:i.URI.revive(g.insidersUrl),stableUrl:i.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=E}),define(oe[260],ae([0,1,15,9]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends i.AbstractLogger{constructor(O,R){super(),this.g=this.B(O.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(O,...R){this.g.trace(O,...R)}debug(O,...R){this.g.debug(O,...R)}info(O,...R){this.g.info(O,...R)}warn(O,...R){this.g.warn(O,...R)}error(O,...R){this.g.error(O,...R)}flush(){this.g.flush()}};D=ye([K(0,i.ILoggerService),K(1,k.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(oe[261],ae([0,1,6,3,2]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends D.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:P,getActiveWindowId:S}){super(),this.a=this.B(new D.DisposableStore),i.Event.latch(i.Event.any(R,P))(this.f,this,this.a),this.b=(0,k.createCancelablePromise)(()=>S()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(oe[117],ae([0,1,183,12,49,22,8,4,24]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function S(t){const s=t;return typeof s?.id=="string"&&O.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=S;function E(t){return typeof t?.id=="string"&&!S(t)&&!g(t)}e.isEmptyWorkspaceIdentifier=E,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,i.basename)(t)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=b;function g(t){const s=t;return typeof s?.id=="string"&&O.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=g;function m(t){const s=t;if(s?.uri)return{id:s.id,uri:O.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:O.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=m;var h;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(h=e.WorkbenchState||(e.WorkbenchState={}));function y(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=y;function f(t){const s=t;return!!(s&&typeof s=="object"&&O.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=f;class l{constructor(s,o,a,r,u){this.h=s,this.j=a,this.k=r,this.l=u,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class d{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function p(t){return new d({uri:t,index:0,name:(0,A.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(t,s){return A.extUriBiasedIgnorePathCase.isEqualOrParent(t,s.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function I(t){let s;return O.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=I;function n(t,s){return!w(t,s)&&!I(t)}e.isSavedWorkspace=n;function c(t){return(typeof t=="string"?(0,i.extname)(t):(0,A.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=c}),define(oe[18],ae([0,1,66,3,2,22,8,175,15,14,4,9,117,37,29,6,31,27,13]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function p(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&O.URI.isUri(s.location)&&O.URI.isUri(s.globalStorageHome)&&O.URI.isUri(s.settingsResource)&&O.URI.isUri(s.keybindingsResource)&&O.URI.isUri(s.tasksResource)&&O.URI.isUri(s.snippetsHome)&&O.URI.isUri(s.extensionsResource))}e.isUserDataProfile=p,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,E.createDecorator)("IUserDataProfilesService");function w(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:O.URI.revive(t.location).with({scheme:s}),globalStorageHome:O.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:O.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:O.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:O.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:O.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:O.URI.revive(t.extensionsResource)?.with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=w;function I(t,s,o,a){return{id:t,name:s,location:o,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,A.joinPath)(o,"globalStorage"),settingsResource:(0,A.joinPath)(o,"settings.json"),keybindingsResource:(0,A.joinPath)(o,"keybindings.json"),tasksResource:(0,A.joinPath)(o,"tasks.json"),snippetsHome:(0,A.joinPath)(o,"snippets"),extensionsResource:(0,A.joinPath)(o,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=I;let n=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(s,o,a,r){super(),this.m=s,this.n=o,this.r=a,this.s=r,this.f=!1,this.g=this.B(new i.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new i.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new i.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new i.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new m.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,A.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(s){this.f!==s&&(this.t=void 0,this.f=s)}isEnabled(){return this.f}get u(){if(!this.t){const s=[];if(this.f)for(const u of this.G()){if(!u.name||!(0,d.isString)(u.name)||!u.location){this.s.warn("Skipping the invalid stored profile",u.location||u.name);continue}s.push(I((0,A.basename)(u.location),u.name,u.location,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}))}const o=new m.ResourceMap,a=new Map,r=I((0,k.hash)(this.m.userRoamingDataHome.path).toString(16),(0,R.localize)(0,null),this.m.userRoamingDataHome);if(s.unshift({...r,extensionsResource:this.L()??r.extensionsResource,isDefault:!0}),s.length){const u=this.I();if(u.workspaces)for(const[v,C]of Object.entries(u.workspaces)){const T=O.URI.parse(v),N=O.URI.parse(C),F=s.find(j=>this.r.extUri.isEqual(j.location,N));F&&o.set(T,F)}if(u.emptyWindows)for(const[v,C]of Object.entries(u.emptyWindows)){const T=O.URI.parse(C),N=s.find(F=>this.r.extUri.isEqual(F.location,T));N&&a.set(v,N)}}this.t={profiles:s,workspaces:o,emptyWindows:a}}return this.t}async createTransientProfile(s){const o="Temp",a=new RegExp(`${(0,l.escapeRegExpCharacters)(o)}\\s(\\d+)`);let r=0;for(const v of this.profiles){const C=a.exec(v.name),T=C?parseInt(C[1]):0;r=T>r?T:r}const u=`${o} ${r+1}`;return this.createProfile((0,k.hash)((0,f.generateUuid)()).toString(16),u,{transient:!0},s)}async createNamedProfile(s,o,a){return this.createProfile((0,k.hash)((0,f.generateUuid)()).toString(16),s,o,a)}async createProfile(s,o,a,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.v(s,o,a);return r&&await this.setProfileForWorkspace(r,u),u}async v(s,o,a){if(!(0,d.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let r=this.k.get(o);return r||(r=(async()=>{try{const u=this.profiles.find(T=>T.name===o||T.id===s);if(u)return u;const v=I(s,o,(0,A.joinPath)(this.profilesHome,s),a);await this.n.createFolder(v.location);const C=[];return this.h.fire({profile:v,join(T){C.push(T)}}),await y.Promises.settled(C),this.z([v],[],[]),v}finally{this.k.delete(o)}})(),this.k.set(o,r)),r}async updateProfile(s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(r=>r.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);return a=I(a.id,o.name??a.name,a.location,{shortName:o.shortName??a.shortName,transient:o.transient??a.isTransient,useDefaultFlags:o.useDefaultFlags??a.useDefaultFlags}),this.z([],[],[a]),a}async removeProfile(s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(r=>r.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const a=[];this.i.fire({profile:o,join(r){a.push(r)}});try{await Promise.allSettled(a)}catch(r){this.s.error(r)}for(const r of[...this.u.emptyWindows.keys()])o.id===this.u.emptyWindows.get(r)?.id&&this.u.emptyWindows.delete(r);for(const r of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(r)?.id&&this.u.workspaces.delete(r);this.F(),this.z([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(r){this.s.error(r)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=this.profiles.find(r=>r.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);this.D(s,a)}unsetWorkspace(s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(s,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const s=await this.n.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(a=>!this.r.extUri.isEqual(a.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.l.profiles.filter(o=>!this.y(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.w(s);return O.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindows.get(o)??this.u.emptyWindows.get(o)}w(s){return(0,g.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,g.isWorkspaceIdentifier)(s)?s.configPath:s.id}y(s){return!!([...this.l.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.u.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,s.location)))}z(s,o,a){const r=[...this.profiles,...s],u=[];this.l.profiles=[];for(let v of r)v.isDefault||o.some(C=>v.id===C.id)||(v=a.find(C=>v.id===C.id)??v,v.isTransient?this.l.profiles.push(v):u.push({location:v.location,name:v.name,shortName:v.shortName,useDefaultFlags:v.useDefaultFlags}));this.H(u),this.t=void 0,this.C(s,o,a)}C(s,o,a){this.g.fire({added:s,removed:o,updated:a,all:this.profiles})}D(s,o,a){a=o?.isTransient?!0:a,a||this.D(s,void 0,!0);const r=this.w(s),u=a?this.l:this.u;O.URI.isUri(r)?(u.workspaces.delete(r),o&&u.workspaces.set(r,o)):(u.emptyWindows.delete(r),o&&u.emptyWindows.set(r,o)),a||this.F()}F(){const s={};for(const[a,r]of this.u.workspaces.entries())s[a.toString()]=r.location.toString();const o={};for(const[a,r]of this.u.emptyWindows.entries())o[a.toString()]=r.location.toString();this.J({workspaces:s,emptyWindows:o}),this.t=void 0}G(){return[]}H(s){throw new Error("not implemented")}I(){return{}}J(s){throw new Error("not implemented")}L(){}};n.b="userDataProfiles",n.c="profileAssociations",n=ye([K(0,P.IEnvironmentService),K(1,S.IFileService),K(2,h.IUriIdentityService),K(3,b.ILogService)],n),e.UserDataProfilesService=n;class c extends n{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(s){this.a=s}I(){return this.O}J(s){this.O=s}}e.InMemoryUserDataProfilesService=c}),define(oe[262],ae([0,1,6,2,18]),function(Z,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends i.Disposable{constructor(R){super(),this.B(new k.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};A=ye([K(0,D.IUserDataProfilesService)],A),e.UserDataProfilesCleaner=A}),define(oe[263],ae([0,1,21,6,23,7,3,2,5,8,156,30,33,42,9,25,19,18]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var d;(function(t){t.Verified="Verified",t.Unverified="Unverified",t.UnknownError="UnknownError"})(d=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let p=class extends R.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(s,o,a,r,u){super(),this.t=s,this.u=o,this.v=a,this.w=r,this.y=u,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new O.Emitter),this.m=this.B(new O.Emitter),this.n=this.B(new O.Emitter),this.p=this.B(new O.Emitter),this.s=[],this.B((0,R.toDisposable)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.k.forEach(v=>v.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(a=>(0,b.isTargetPlatformCompatible)(a,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{if(!this.t.isEnabled())throw new b.ExtensionManagementError(E.localize(0,null),b.ExtensionManagementErrorCode.Internal);const a=await this.G(s,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.z(a.manifest,a.extension,o)}catch(a){throw n(this.u,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(s),error:a}),this.v.error("Failed to install extension.",s.identifier.id),this.v.error(a),I(a)}}async uninstall(s,o={}){return this.v.trace("ExtensionManagementService#uninstall",s.identifier.id),this.I(s,o)}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.O(),this.h=s),this.g}registerParticipant(s){this.s.push(s)}async z(s,o,a){const r={...a,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(o)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,m.isApplicationScopedExtension)(s)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},u=j=>`${g.ExtensionKey.create(j).toString()}${r.profileLocation?`-${r.profileLocation.toString()}`:""}`;if(!S.URI.isUri(o)){const j=this.j.get(u(o));if(j){this.v.info("Extensions is already requested to install",o.identifier.id);const{local:L}=await j.task.waitUntilTaskIsFinished();return L}}const v=[],C=[],T=[],N=this.Q(s,o,r);S.URI.isUri(o)||this.j.set(u(o),{task:N,waitingTasks:[]}),this.l.fire({identifier:N.identifier,source:o,profileLocation:r.profileLocation}),this.v.info("Installing extension:",N.identifier.id),v.push({task:N,manifest:s});let F=!1;try{if(r.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const L=await this.F(N.identifier,s,!!r.installOnlyNewlyAddedFromExtensionPack,!!r.installPreReleaseVersion,r.profileLocation),$=await this.getInstalled(void 0,r.profileLocation);for(const{gallery:z,manifest:H}of(0,k.distinct)(L,({gallery:X})=>X.identifier.id)){F=F||!!H.extensionDependencies?.some(G=>(0,g.areSameExtensions)({id:G},N.identifier));const X=u(z),ie=this.j.get(X);if(ie){if(this.C(N,ie.task)){const G=ie.task.identifier;this.v.info("Waiting for already requested installing extension",G.id,N.identifier.id),ie.waitingTasks.push(N),C.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,M=>M.some(V=>(0,g.areSameExtensions)(V.identifier,G)))).then(M=>{if(this.v.info("Finished waiting for already requested installing extension",G.id,N.identifier.id),!M.find(x=>(0,g.areSameExtensions)(x.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else if(!$.some(({identifier:G})=>(0,g.areSameExtensions)(G,z.identifier))){const G=this.Q(H,z,{...r,donotIncludePackAndDependencies:!0});this.j.set(X,{task:G,waitingTasks:[N]}),this.l.fire({identifier:G.identifier,source:z,profileLocation:r.profileLocation}),this.v.info("Installing extension:",G.identifier.id,N.identifier.id),v.push({task:G,manifest:H})}}}catch(L){if(S.URI.isUri(N.source))(0,k.isNonEmptyArray)(s.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",N.identifier.id,L.message),(0,k.isNonEmptyArray)(s.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",N.identifier.id,L.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),L}const j=v.reduce((L,{task:$,manifest:z})=>(L.set($.identifier.id.toLowerCase(),{task:$,manifest:z}),L),new Map);for(;j.size;){let L;const $=[...j.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(H=>j.has(H.toLowerCase())));$.length?L=j.size===1?$:$.filter(({task:z})=>!(z===N&&!F)):(this.v.info("Found extensions with circular dependencies",$.map(({task:z})=>z.identifier.id)),L=[...j.values()]),await this.D(L.map(async({task:z})=>{const H=new Date().getTime();try{const{local:X}=await z.run();if(await this.D(this.s.map(ie=>ie.postInstall(X,z.source,r,D.CancellationToken.None))),!S.URI.isUri(z.source)){const ie=z.operation===3,G=ie?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(n(this.u,ie?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-H,durationSinceUpdate:G}),P.isWeb&&z.operation!==3)try{await this.t.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}T.push({local:X,identifier:z.identifier,operation:z.operation,source:z.source,context:r.context,profileLocation:r.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw S.URI.isUri(z.source)||n(this.u,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-H,error:X}),this.v.error("Error while installing the extension:",z.identifier.id),X}finally{j.delete(z.identifier.id.toLowerCase())}}))}return C.length&&await this.D(C),T.forEach(({identifier:L})=>this.v.info("Extension installed successfully:",L.id)),this.m.fire(T),T.filter(({identifier:L})=>(0,g.areSameExtensions)(L,N.identifier))[0].local}catch(j){if(v.forEach(({task:L})=>L.cancel()),T.length)try{const L=await Promise.allSettled(T.map(({local:$})=>this.R($,{versionOnly:!0,profileLocation:r.profileLocation}).run()));for(let $=0;$<L.length;$++){const z=L[$],{identifier:H}=T[$];z.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",H.id):this.v.warn("Rollback: Error while uninstalling extension",H.id,(0,A.getErrorMessage)(z.reason))}}catch(L){this.v.warn("Error while rolling back extensions",(0,A.getErrorMessage)(L),T.map(({identifier:$})=>$.id))}throw this.m.fire(v.map(({task:L})=>({identifier:L.identifier,operation:2,source:L.source,context:r.context,profileLocation:r.profileLocation}))),j}finally{for(const{task:j}of v)j.source&&!S.URI.isUri(j.source)&&this.j.delete(u(j.source))}}C(s,o){for(const[,{task:a,waitingTasks:r}]of this.j.entries())if(a===s&&(r.includes(o)||r.some(u=>this.C(u,o)))||a===o&&r[0]&&!this.C(s,r[0]))return!1;return!0}async D(s){const o=[],a=[],r=await Promise.allSettled(s);for(const u of r)u.status==="fulfilled"?o.push(u.value):a.push(u.reason);if(a.length)throw w(a);return o}async F(s,o,a,r,u){if(!this.t.isEnabled())return[];const v=await this.getInstalled(void 0,u),C=[],T=[],N=async(F,j)=>{C.push(F);const L=j.extensionDependencies||[],$=[...L];if(j.extensionPack){const z=a?v.find(H=>(0,g.areSameExtensions)(H.identifier,F)):void 0;for(const H of j.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(X=>(0,g.areSameExtensions)({id:X},{id:H}))||$.every(X=>!(0,g.areSameExtensions)({id:X},{id:H}))&&$.push(H)}if($.length){const z=$.filter(H=>C.every(X=>!(0,g.areSameExtensions)(X,{id:H})));if(z.length){const H=await this.t.getExtensions(z.map(X=>({id:X,preRelease:r})),D.CancellationToken.None);for(const X of H){if(C.find(M=>(0,g.areSameExtensions)(M,X.identifier)))continue;const ie=L.some(M=>(0,g.areSameExtensions)({id:M},X.identifier));let G;try{G=await this.G(X,!1,r)}catch(M){if(M instanceof b.ExtensionManagementError&&M.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ie){this.v.info("Skipping the packed extension as it cannot be installed",X.identifier.id);continue}else throw M}T.push({gallery:G.extension,manifest:G.manifest}),await N(G.extension.identifier,G.manifest)}}}};return await N(s,o),T}async G(s,o,a){if((await this.getExtensionsControlManifest()).malicious.some(C=>(0,g.areSameExtensions)(s.identifier,C)))throw new b.ExtensionManagementError(E.localize(1,null,s.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(s)){const C=await this.getTargetPlatform();throw new b.ExtensionManagementError(E.localize(2,null,s.identifier.id,this.w.nameLong,(0,b.TargetPlatformToString)(C)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.H(s,o,a);if(u){if(a&&!o&&s.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(E.localize(3,null,s.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&s.properties.isPreReleaseVersion&&(await this.t.getExtensions([s.identifier],D.CancellationToken.None))[0]?new b.ExtensionManagementError(E.localize(4,null,s.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(E.localize(5,null,s.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",u.identifier.id);const v=await this.t.getManifest(u,D.CancellationToken.None);if(v===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(v.version!==u.version)throw new b.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:v}}async H(s,o,a){const r=await this.getTargetPlatform();let u=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==a&&(u=(await this.t.getExtensions([{...s.identifier,preRelease:a}],{targetPlatform:r,compatible:!0},D.CancellationToken.None))[0]||null),!u&&await this.t.isExtensionCompatible(s,a,r)&&(u=s),u||(o?u=(await this.t.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:r,compatible:!0},D.CancellationToken.None))[0]||null:u=await this.t.getCompatibleExtension(s,a,r)),u}async I(s,o){const a={...o,profileLocation:s.isApplicationScoped?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},r=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${s.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,u=this.k.get(r(s.identifier));if(u)return this.v.info("Extensions is already requested to uninstall",s.identifier.id),u.waitUntilTaskIsFinished();const v=F=>{const j=this.R(F,a);return this.k.set(r(j.extension.identifier),j),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.n.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),j},C=(F,j)=>{j?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),j.message):this.v.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,j.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),n(this.u,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(F),error:j}),this.p.fire({identifier:F.identifier,error:j?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},T=[],N=[];try{T.push(v(s));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const j=this.M(s,F);for(const L of j)this.k.has(r(L.identifier))?this.v.info("Extensions is already requested to uninstall",L.identifier.id):T.push(v(L))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.J(T.map(j=>j.extension),F,s),await this.D(T.map(async j=>{try{if(await j.run(),await this.D(this.s.map(L=>L.postUninstall(j.extension,a,D.CancellationToken.None))),j.extension.identifier.uuid)try{await this.t.reportStatistic(j.extension.manifest.publisher,j.extension.manifest.name,j.extension.manifest.version,"uninstall")}catch{}C(j.extension)}catch(L){const $=L instanceof b.ExtensionManagementError?L:new b.ExtensionManagementError((0,A.getErrorMessage)(L),b.ExtensionManagementErrorCode.Internal);throw C(j.extension,$),$}finally{N.push(j)}}))}catch(F){const j=F instanceof b.ExtensionManagementError?F:new b.ExtensionManagementError((0,A.getErrorMessage)(F),b.ExtensionManagementErrorCode.Internal);for(const L of T){try{L.cancel()}catch{}N.includes(L)||C(L.extension,j)}throw j}finally{for(const F of T)this.k.delete(r(F.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}J(s,o,a){for(const r of s){const u=this.N(r,o);if(u.length){const v=u.filter(C=>!s.some(T=>(0,g.areSameExtensions)(T.identifier,C.identifier)));if(v.length)throw new Error(this.L(r,v,a))}}}L(s,o,a){return a===s?o.length===1?E.localize(6,null,a.manifest.displayName||a.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(7,null,a.manifest.displayName||a.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(8,null,a.manifest.displayName||a.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?E.localize(9,null,a.manifest.displayName||a.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(10,null,a.manifest.displayName||a.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(11,null,a.manifest.displayName||a.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}M(s,o,a=[]){if(a.indexOf(s)!==-1)return[];a.push(s);const r=s.manifest.extensionPack?s.manifest.extensionPack:[];if(r.length){const u=o.filter(C=>!C.isBuiltin&&r.some(T=>(0,g.areSameExtensions)({id:T},C.identifier))),v=[];for(const C of u)v.push(...this.M(C,o,a));return[...u,...v]}return[]}N(s,o){return o.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(r=>(0,g.areSameExtensions)({id:r},s.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const s=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};p=ye([K(0,b.IExtensionGalleryService),K(1,f.ITelemetryService),K(2,h.ILogService),K(3,y.IProductService),K(4,l.IUserDataProfilesService)],p),e.AbstractExtensionManagementService=p;function w(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,a)=>new Error(`${o.message}${o.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=w;function I(t){if(t instanceof b.ExtensionManagementError)return t;const s=new b.ExtensionManagementError(t.message,b.ExtensionManagementErrorCode.Internal);return s.stack=t.stack,s}function n(t,s,{extensionData:o,verificationStatus:a,duration:r,error:u,durationSinceUpdate:v}){let C,T;u&&(u instanceof b.ExtensionManagementError?(C=u.code,u.code===b.ExtensionManagementErrorCode.Signature&&(T=u.message)):C=b.ExtensionManagementErrorCode.Internal),t.publicLog(s,{...o,verificationStatus:a,success:!u,duration:r,errorcode:C,errorcodeDetail:T,durationSinceUpdate:v})}e.reportTelemetry=n;class c{constructor(){this.d=new i.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,i.createCancelablePromise)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,i.createCancelablePromise)(s=>new Promise((o,a)=>{const r=s.onCancellationRequested(()=>{r.dispose(),a(new A.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=c}),define(oe[51],ae([0,1,6,17,2,3,37,8,33,42,14,4,9,18,29,13,7,19]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class p extends Error{constructor(t,s){super(t),this.code=s}}e.ExtensionsProfileScanningError=p,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let w=class extends D.Disposable{constructor(t,s,o,a,r,u){super(),this.h=t,this.i=s,this.j=o,this.k=a,this.l=r,this.m=u,this.a=this.B(new A.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new A.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new O.ResourceMap}scanProfileExtensions(t,s){return this.n(t,void 0,s)}async addExtensionsToProfile(t,s){const o=[],a=[];try{return await this.n(s,r=>{const u=[];for(const v of r)t.some(([C])=>(0,P.areSameExtensions)(C.identifier,v.identifier)&&C.manifest.version!==v.version)?o.push(v):u.push(v);for(const[v,C]of t)if(!u.some(T=>(0,P.areSameExtensions)(T.identifier,v.identifier)&&T.version===v.manifest.version)){const T={identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:C};a.push(T),u.push(T)}return a.length&&this.a.fire({extensions:a,profileLocation:s}),o.length&&this.c.fire({extensions:o,profileLocation:s}),u}),a.length&&this.b.fire({extensions:a,profileLocation:s}),o.length&&this.f.fire({extensions:o,profileLocation:s}),a}catch(r){throw a.length&&this.b.fire({extensions:a,error:r,profileLocation:s}),o.length&&this.f.fire({extensions:o,error:r,profileLocation:s}),r}}async removeExtensionFromProfile(t,s){const o=[];this.c.fire({extensions:o,profileLocation:s});try{await this.n(s,a=>{const r=[];for(const u of a)(0,P.areSameExtensions)(u.identifier,t.identifier)?o.push(u):r.push(u);return o.length&&this.c.fire({extensions:o,profileLocation:s}),r}),o.length&&this.f.fire({extensions:o,profileLocation:s})}catch(a){throw o.length&&this.f.fire({extensions:o,error:a,profileLocation:s}),a}}async n(t,s,o){return this.v(t).queue(async()=>{let a=[],r;try{const u=await this.i.readFile(t);r=JSON.parse(u.value.toString())}catch(u){if((0,E.toFileOperationResult)(u)!==1)throw u;if(this.k.extUri.isEqual(t,this.j.defaultProfile.extensionsResource)&&(r=await this.u()),!r&&o?.bailOutWhenFileNotFound)throw new p((0,f.getErrorMessage)(u),"ERROR_PROFILE_NOT_FOUND")}if(r){Array.isArray(r)||this.p(t);let u=!1;for(const v of r){I(v)||this.p(t);let C;if((0,y.isString)(v.location))C=this.s(v.location);else{C=R.URI.revive(v.location);const T=this.r(C);T&&(u=!0,v.location=T)}a.push({identifier:v.identifier,location:C,version:v.version,metadata:v.metadata})}u&&await this.i.writeFile(t,i.VSBuffer.fromString(JSON.stringify(r)))}if(s){a=s(a);const u=a.map(v=>({identifier:v.identifier,version:v.version,location:this.r(v.location)??v.location.toJSON(),metadata:v.metadata}));await this.i.writeFile(t,i.VSBuffer.fromString(JSON.stringify(u)))}return a})}p(t){const s=new p(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}r(t){return this.k.extUri.isEqualOrParent(t,this.h)?this.k.extUri.relativePath(this.h,t):void 0}s(t){return this.k.extUri.joinPath(this.h,t)}async u(){return this.t||(this.t=(async()=>{const t=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let s;try{s=(await this.i.readFile(t)).value.toString()}catch(a){if((0,E.toFileOperationResult)(a)===1)return;throw a}this.m.info("Migrating extensions from old default profile location",t.toString());let o;try{const a=JSON.parse(s);Array.isArray(a)&&a.every(r=>I(r))?o=a:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.m.error(a)}if(o)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,i.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",t.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(a){if((0,E.toFileOperationResult)(a)===3)this.m.info("Migration from old default profile location to new location is done by another window",t.toString(),this.j.defaultProfile.extensionsResource.toString());else throw a}try{await this.i.del(t)}catch(a){(0,E.toFileOperationResult)(a)!==1&&this.m.error(a)}return o})()),this.t}v(t){let s=this.g.get(t);return s||(s=new k.Queue,this.g.set(t,s)),s}};w=ye([K(1,E.IFileService),K(2,m.IUserDataProfilesService),K(3,h.IUriIdentityService),K(4,l.ITelemetryService),K(5,g.ILogService)],w),e.AbstractExtensionsProfileScannerService=w;function I(c){return(0,y.isObject)(c)&&(0,S.isIExtensionIdentifier)(c.identifier)&&(n(c.location)||(0,y.isString)(c.location))&&c.version&&(0,y.isString)(c.version)}function n(c){return c?(0,y.isString)(c.path)&&(0,y.isString)(c.scheme):!1}}),define(oe[79],ae([0,1,21,6,32,17,7,35,139,2,24,12,5,22,54,89,13,8,159,15,33,42,70,14,4,9,25,3,67,51,18,29,189,190]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p,w,I,n,c,t,s,o,a,r,u,v,C,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var F;(function(ie){function G(M,V){if(M===V)return!0;const x=Object.keys(M),ee=new Set;for(const re of Object.keys(V))ee.add(re);if(x.length!==ee.size)return!1;for(const re of x){if(M[re]!==V[re])return!1;ee.delete(re)}return ee.size===0}ie.equals=G})(F=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let j=class extends S.Disposable{constructor(G,M,V,x,ee,re,te,U,B,W,q,J){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=M,this.l=V,this.m=x,this.n=ee,this.p=re,this.r=te,this.s=U,this.t=B,this.u=W,this.v=q,this.w=J,this.g=this.B(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(z,(0,m.joinPath)(this.m,I.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(z,(0,m.joinPath)(this.m,I.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance($,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,w.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(G,M,V){const[x,ee]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(M)]),re=V?await this.scanExtensionsUnderDevelopment(G,[...x,...ee]):[];return this.F(x,ee,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const M=[];M.push(this.G(!!G.useCache,G.language)),M.push(this.H(G.language,!!G.checkControlFile));const[V,x]=await Promise.all(M);return this.D([...V,...x],0,G,!1)}async scanUserExtensions(G){const M=G.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",M);const V=this.v.extUri.isEqual(G.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,x=await this.J(M,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,V),ee=G.useCache&&!x.devMode&&x.excludeObsolete?this.j:this.k;let re;try{re=await ee.scanExtensions(x)}catch(te){if(te instanceof u.ExtensionsProfileScanningError&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),re=await ee.scanExtensions(x);else throw te}return re=await this.D(re,1,G,!0),this.s.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(G,M){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const V=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(x=>x.scheme===E.Schemas.file).map(async x=>{const ee=await this.J(x,!1,1,!0,G.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ee)).map(te=>(te.type=M.find(U=>(0,w.areSameExtensions)(U.identifier,te.identifier))?.type??te.type,this.k.validate(te,ee)))}))).flat();return this.D(V,"development",G,!0)}return[]}async scanExistingExtension(G,M,V){const x=await this.J(G,!1,M,!0,V.language,!0,void 0),ee=await this.k.scanExtension(x);return!ee||!V.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(G,M,V){const x=await this.J(G,!1,M,!0,V.language,!0,void 0),ee=await this.k.scanOneOrMultipleExtensions(x);return this.D(ee,M,V,!0)}async scanMetadata(G){const M=(0,m.joinPath)(G,"package.json"),V=(await this.r.readFile(M)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(G,M){const V=(0,m.joinPath)(G,"package.json"),x=(await this.r.readFile(V)).value.toString(),ee=JSON.parse(x);M.isMachineScoped=M.isMachineScoped||void 0,M.isBuiltin=M.isBuiltin||void 0,M.installedTimestamp=M.installedTimestamp||void 0,ee.__metadata={...ee.__metadata,...M},await this.r.writeFile((0,m.joinPath)(G,"package.json"),A.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof u.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw G}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.p.addExtensionsToProfile(G.map(M=>[M,M.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify([])))}catch(M){(0,c.toFileOperationResult)(M)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.getErrorMessage)(M))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.s.error(G)}finally{this.z=void 0}})()),this.z}async D(G,M,V,x){return V.includeAllVersions||(G=this.F(M===0?G:void 0,M===1?G:void 0,M==="development"?G:void 0,await this.getTargetPlatform(),x)),V.includeInvalid||(G=G.filter(ee=>ee.isValid)),G.sort((ee,re)=>{const te=b.basename(ee.location.fsPath),U=b.basename(re.location.fsPath);return te<U?-1:te>U?1:0})}F(G,M,V,x,ee){const re=(U,B,W)=>{if(U.isValid&&!B.isValid)return!1;if(U.isValid===B.isValid){if(ee&&h.gt(U.manifest.version,B.manifest.version))return this.s.debug(`Skipping extension ${B.location.path} with lower version ${B.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(h.eq(U.manifest.version,B.manifest.version)){if(U.type===0)return this.s.debug(`Skipping extension ${B.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===x)return this.s.debug(`Skipping extension ${B.location.path} from different target platform ${B.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${U.location.path} with ${B.location.path}.`):this.s.debug(`Overwriting user extension ${U.location.path} with ${B.location.path}.`),!0},te=new Map;return G?.forEach(U=>{const B=I.ExtensionIdentifier.toKey(U.identifier.id),W=te.get(B);(!W||re(W,U,!1))&&te.set(B,U)}),M?.forEach(U=>{const B=I.ExtensionIdentifier.toKey(U.identifier.id),W=te.get(B);if(!W&&G&&U.type===0){this.s.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!W||re(W,U,!1))&&te.set(B,U)}),V?.forEach(U=>{const B=I.ExtensionIdentifier.toKey(U.identifier.id),W=te.get(B);(!W||re(W,U,!0))&&te.set(B,U),te.set(B,U)}),[...te.values()]}async G(G,M){this.s.trace("Started scanning system extensions");const V=await this.J(this.systemExtensionsLocation,!1,0,!0,M,!0,void 0),ee=await(G&&!V.devMode?this.i:this.k).scanExtensions(V);return this.s.trace("Scanned system extensions:",ee.length),ee}async H(G,M){const V=this.t.isBuilt?[]:this.u.builtInExtensions;if(!V?.length)return[];this.s.trace("Started scanning dev system extensions");const x=M?await this.I():{},ee=[],re=l.URI.file(b.normalize(b.join(E.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const U of V){const B=x[U.name]||"marketplace";switch(B){case"disabled":break;case"marketplace":ee.push((0,m.joinPath)(re,U.name));break;default:ee.push(l.URI.file(B));break}}const te=await Promise.all(ee.map(async U=>this.k.scanExtension(await this.J(U,!1,0,!0,G,!0,void 0))));return this.s.trace("Scanned dev system extensions:",te.length),(0,k.coalesce)(te)}async I(){try{const G=await this.r.readFile(this.l);return JSON.parse(G.value.toString())}catch{return{}}}async J(G,M,V,x,ee,re,te){const U=await this.f(ee??g.language),B=await this.L(G),W=M&&!this.v.extUri.isEqual(G,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,q=W?await this.L(W):void 0;return new L(G,B,W,q,M,te,V,x,re,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,ee,U)}async L(G){try{const M=await this.r.stat(G);if(typeof M.mtime=="number")return M.mtime}catch{}}};j=ye([K(4,v.IUserDataProfilesService),K(5,u.IExtensionsProfileScannerService),K(6,c.IFileService),K(7,s.ILogService),K(8,p.IEnvironmentService),K(9,o.IProductService),K(10,C.IUriIdentityService),K(11,t.IInstantiationService)],j),e.AbstractExtensionsScannerService=j;class L{constructor(G,M,V,x,ee,re,te,U,B,W,q,J,_,Y,Q){this.location=G,this.mtime=M,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=x,this.profile=ee,this.profileScanOptions=re,this.type=te,this.excludeObsolete=U,this.validate=B,this.productVersion=W,this.productDate=q,this.productCommit=J,this.devMode=_,this.language=Y,this.translations=Q}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,M){return(0,m.isEqual)(G.location,M.location)&&G.mtime===M.mtime&&(0,m.isEqual)(G.applicationExtensionslocation,M.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===M.applicationExtensionslocationMtime&&G.profile===M.profile&&D.equals(G.profileScanOptions,M.profileScanOptions)&&G.type===M.type&&G.excludeObsolete===M.excludeObsolete&&G.validate===M.validate&&G.productVersion===M.productVersion&&G.productDate===M.productDate&&G.productCommit===M.productCommit&&G.devMode===M.devMode&&G.language===M.language&&F.equals(G.translations,M.translations)}}e.ExtensionScannerInput=L;let $=class extends S.Disposable{constructor(G,M,V,x,ee){super(),this.f=G,this.g=M,this.h=V,this.i=x,this.j=ee}async scanExtensions(G){const M=G.profile?await this.l(G):await this.k(G);let V={};if(G.excludeObsolete&&G.type===1)try{const x=(await this.i.readFile(this.f)).value.toString();V=JSON.parse(x)}catch{}return(0,f.isEmptyObject)(V)?M:M.filter(x=>!V[w.ExtensionKey.create(x).toString()])}async k(G){const M=await this.i.resolve(G.location);if(!M.children?.length)return[];const V=await Promise.all(M.children.map(async x=>{if(!x.isDirectory||G.type===1&&(0,m.basename)(x.resource).indexOf(".")===0)return null;const ee=new L(x.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(ee)}));return(0,k.coalesce)(V).sort((x,ee)=>x.location.path<ee.location.path?-1:1)}async l(G){let M=await this.m(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){M=M.filter(x=>!x.metadata?.isApplicationScoped);const V=await this.m(G.applicationExtensionslocation,x=>!!x.metadata?.isApplicationScoped,G);M.push(...V)}return M}async m(G,M,V){const x=await this.g.scanProfileExtensions(G,V.profileScanOptions);if(!x.length)return[];const ee=await Promise.all(x.map(async re=>{if(M(re)){const te=new L(re.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(te,re.metadata)}return null}));return(0,k.coalesce)(ee)}async scanOneOrMultipleExtensions(G){try{if(await this.i.exists((0,m.joinPath)(G.location,"package.json"))){const M=await this.scanExtension(G);return M?[M]:[]}else return await this.scanExtensions(G)}catch(M){return this.j.error(`Error scanning extensions at ${G.location.path}:`,(0,O.getErrorMessage)(M)),[]}}async scanExtension(G,M){try{let V=await this.scanExtensionManifest(G.location);if(V){V.publisher||(V.publisher=I.UNDEFINED_PUBLISHER),M=M??V.__metadata,delete V.__metadata;const x=(0,w.getGalleryExtensionId)(V.publisher,V.name),ee=M?.id?{id:x,uuid:M.id}:{id:x},re=M?.isSystem?0:G.type,te=re===0||!!M?.isBuiltin;N.ImplicitActivationEvents.updateManifest(V),V=await this.n(G.location,V,L.createNlsConfiguration(G));const U={type:re,identifier:ee,manifest:V,location:G.location,isBuiltin:te,targetPlatform:M?.targetPlatform??"undefined",metadata:M,isValid:!0,validations:[]};return G.validate?this.validate(U,G):U}}catch(V){G.type!==0&&this.j.error(V)}return null}validate(G,M){let V=!0;const x=(0,n.validateExtensionManifest)(M.productVersion,M.productDate,M.location,G.manifest,G.isBuiltin);for(const[ee,re]of x)ee===y.default.Error&&(V=!1,this.j.error(this.t(M.location,re)));return G.isValid=V,G.validations=x,G}async scanExtensionManifest(G){const M=(0,m.joinPath)(G,"package.json");let V;try{V=(await this.i.readFile(M)).value.toString()}catch(ee){return(0,c.toFileOperationResult)(ee)!==1&&this.j.error(this.t(G,(0,d.localize)(0,null,M.path,ee.message))),null}let x;try{x=JSON.parse(V)}catch{const re=[];(0,R.parse)(V,re);for(const te of re)this.j.error(this.t(G,(0,d.localize)(1,null,M.path,te.offset,te.length,(0,P.getParseErrorMessage)(te.error))));return null}return(0,R.getNodeType)(x)!=="object"?(this.j.error(this.t(G,(0,d.localize)(2,null,M.path))),null):x}async n(G,M,V){const x=await this.p(G,M,V);if(x)try{const ee=[],re=await this.r(x.default,ee);if(ee.length>0)return ee.forEach(U=>{this.j.error(this.t(G,(0,d.localize)(3,null,x.default?.path,(0,P.getParseErrorMessage)(U.error))))}),M;if((0,R.getNodeType)(x)!=="object")return this.j.error(this.t(G,(0,d.localize)(4,null,x.default?.path))),M;const te=x.values||Object.create(null);return(0,T.localizeManifest)(M,te,re)}catch{}return M}async p(G,M,V){const x=(0,m.joinPath)(G,"package.nls.json"),ee=(B,W)=>{W.forEach(q=>{this.j.error(this.t(G,(0,d.localize)(5,null,B?.path,(0,P.getParseErrorMessage)(q.error))))})},re=B=>{this.j.error(this.t(G,(0,d.localize)(6,null,B?.path)))},te=`${M.publisher}.${M.name}`,U=V.translations[te];if(U)try{const B=l.URI.file(U),W=(await this.i.readFile(B)).value.toString(),q=[],J=(0,R.parse)(W,q);return q.length>0?(ee(B,q),{values:void 0,default:x}):(0,R.getNodeType)(J)!=="object"?(re(B),{values:void 0,default:x}):{values:J.contents?J.contents.package:void 0,default:x}}catch{return{values:void 0,default:x}}else{if(!await this.i.exists(x))return;let W;try{W=await this.s(G,V)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const q=(await this.i.readFile(W.localized)).value.toString(),J=[],_=(0,R.parse)(q,J);return J.length>0?(ee(W.localized,J),{values:void 0,default:W.original}):(0,R.getNodeType)(_)!=="object"?(re(W.localized),{values:void 0,default:W.original}):{values:_,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(G,M){if(G)try{const V=(await this.i.readFile(G)).value.toString();return(0,R.parse)(V,M)}catch{}}s(G,M){return new Promise((V,x)=>{const ee=re=>{const te=(0,m.joinPath)(G,`package.nls.${re}.json`);this.i.exists(te).then(U=>{U&&V({localized:te,original:(0,m.joinPath)(G,"package.nls.json")});const B=re.lastIndexOf("-");B===-1?V({localized:(0,m.joinPath)(G,"package.nls.json"),original:null}):(re=re.substring(0,B),ee(re))})};if(M.devMode||M.pseudo||!M.language)return V({localized:(0,m.joinPath)(G,"package.nls.json"),original:null});ee(M.language)})}t(G,M){return`[${G.path}]: ${M}`}};$=ye([K(1,u.IExtensionsProfileScannerService),K(2,C.IUriIdentityService),K(3,c.IFileService),K(4,s.ILogService)],$);let z=class extends ${constructor(G,M,V,x,ee,re){super(M,V,x,ee,re),this.y=G,this.v=this.B(new i.ThrottledDelayer(3e3)),this.w=this.B(new a.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(G){const M=await this.z();if(this.u=G,M&&M.input&&L.equals(M.input,this.u))return this.j.debug("Using cached extensions scan result",G.location.toString()),this.v.trigger(()=>this.D()),M.result.map(x=>(x.location=l.URI.revive(x.location),x));const V=await super.scanExtensions(G);return await this.C({input:G,result:V}),V}async z(){try{const G=await this.i.readFile(this.y),M=JSON.parse(G.value.toString());return{result:M.result,input:(0,r.revive)(M.input)}}catch(G){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,O.getErrorMessage)(G))}return null}async C(G){try{await this.i.writeFile(this.y,A.VSBuffer.fromString(JSON.stringify(G)))}catch(M){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,O.getErrorMessage)(M))}}async D(){if(!this.u)return;const G=await this.z();if(!G)return;const M=G.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!D.equals(V,M))try{await this.i.del(this.y),this.w.fire()}catch(x){this.j.error(x)}}};z=ye([K(2,u.IExtensionsProfileScannerService),K(3,C.IUriIdentityService),K(4,c.IFileService),K(5,s.ILogService)],z);function H(ie,G){const M=(0,w.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:M,identifier:new I.ExtensionIdentifier(M),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:G,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.toExtensionDescription=H;class X extends j{constructor(G,M,V,x,ee,re,te,U,B,W,q,J){super(G,M,(0,m.joinPath)(V,".vscode-oss-dev","extensions","control.json"),(0,m.joinPath)(x,I.MANIFEST_CACHE_FOLDER),ee,re,te,U,B,W,q,J),this.M=(async()=>{if(g.translationsConfigFile)try{const _=await this.r.readFile(l.URI.file(g.translationsConfigFile));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(G){return this.M}}e.NativeExtensionsScannerService=X}),define(oe[264],ae([0,1,9,18,29,19,51,14,15,8]),function(Z,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let E=class extends O.AbstractExtensionsProfileScannerService{constructor(g,m,h,y,f,l){super(S.URI.file(g.extensionsPath),m,h,y,f,l)}};E=ye([K(0,P.INativeEnvironmentService),K(1,R.IFileService),K(2,i.IUserDataProfilesService),K(3,D.IUriIdentityService),K(4,A.ITelemetryService),K(5,k.ILogService)],E),e.ExtensionsProfileScannerService=E}),define(oe[265],ae([0,1,50,6,38,3,2,24,12,28,9,18]),function(Z,e,k,i,D,A,O,R,P,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends O.Disposable{constructor(h,y){super(),this.b=h,this.f=y,this.a=new i.Limiter(5)}async postUninstall(h){const y=this.g(h,"uninstall");return y&&(this.f.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(y.script,"uninstall",y.args,!0,h).then(()=>this.f.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),f=>this.f.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${f}`)))),S.Promises.rm(this.j(h)).then(void 0,f=>this.f.error("Error while removing extension storage path",f))}g(h,y){const f=`vscode:${y}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[f]=="string"){const l=h.manifest.scripts[f].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(h.identifier.id,h.manifest.version,`${f} should be a node script`),null):{script:(0,P.join)(h.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(h,y,f,l,d){return new Promise((p,w)=>{const I=this.i(h,y,f,d);let n;const c=t=>{n&&(clearTimeout(n),n=null),t?w(t):p(void 0)};I.on("error",t=>{c((0,D.toErrorMessage)(t)||"Unknown")}),I.on("exit",(t,s)=>{c(t?`post-${y} process exited with code ${t}`:void 0)}),l&&(n=setTimeout(()=>{n=null,I.kill(),w("timed out")},5e3))})}i(h,y,f,l){const d={silent:!0,execArgv:void 0},p=(0,k.fork)(h,[`--type=extension-post-${y}`,...f],d);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const w=A.Event.fromNodeEventEmitter(p.stdout,"data"),I=A.Event.fromNodeEventEmitter(p.stderr,"data");w(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${y}`,t)),I(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${y}`,t));const n=A.Event.any(A.Event.map(w,t=>({data:`%c${t}`,format:[""]})),A.Event.map(I,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(n,(t,s)=>t?{data:t.data+s.data,format:[...t.format,...s.format]}:{data:s.data,format:s.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),p}j(h){return(0,P.join)(this.b.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};g=ye([K(0,b.IUserDataProfilesService),K(1,E.ILogService)],g),e.ExtensionsLifecycle=g}),define(oe[266],ae([0,1,8,15,51,79,14,4,9,25,29,18]),function(Z,e,k,i,D,A,O,R,P,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends A.NativeExtensionsScannerService{constructor(h,y,f,l,d,p,w,I){super(k.URI.file(d.builtinExtensionsPath),k.URI.file(d.extensionsPath),d.userHome,k.URI.file(d.userDataPath),h,y,f,l,d,p,w,I)}};g=ye([K(0,b.IUserDataProfilesService),K(1,D.IExtensionsProfileScannerService),K(2,O.IFileService),K(3,P.ILogService),K(4,i.INativeEnvironmentService),K(5,S.IProductService),K(6,E.IUriIdentityService),K(7,R.IInstantiationService)],g),e.ExtensionsScannerService=g}),define(oe[20],ae([0,1,6,3,2,102,13,69,4,18]),function(Z,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,P.createDecorator)("storageService");var E;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var g;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));function m(d){const p=d.get(e.TARGET_KEY);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.loadKeyTargets=m;class h extends D.Disposable{constructor(p={flushInterval:h.a}){super(),this.j=p,this.b=this.B(new i.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new i.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new i.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new k.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,k.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(p,w){if(w===e.TARGET_KEY){switch(p){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:w,target:this.F(p)[w]})}r(p){this.f.fire({reason:p})}get(p,w,I){return this.L(w)?.get(p,I)}getBoolean(p,w,I){return this.L(w)?.getBoolean(p,I)}getNumber(p,w,I){return this.L(w)?.getNumber(p,I)}store(p,w,I,n){if((0,O.isUndefinedOrNull)(w)){this.remove(p,I);return}this.t(()=>{this.u(p,I,n),this.L(I)?.set(p,w)})}remove(p,w){this.t(()=>{this.u(p,w,void 0),this.L(w)?.delete(p)})}t(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,w){const I=[],n=this.F(p);for(const c of Object.keys(n))n[c]===w&&I.push(c);return I}u(p,w,I){const n=this.F(w);typeof I=="number"?n[p]!==I&&(n[p]=I,this.L(w)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[p]=="number"&&(delete n[p],this.L(w)?.set(e.TARGET_KEY,JSON.stringify(n)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(p){switch(p){case-1:return this.D;case 0:return this.z;default:return this.w}}G(p){const w=this.L(p);return w?m(w):Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=E.NONE){this.f.fire({reason:p});const w=this.L(-1),I=this.L(0),n=this.L(1);switch(p){case E.NONE:await k.Promises.settled([w?.whenFlushed()??Promise.resolve(),I?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await k.Promises.settled([w?.flush(0)??Promise.resolve(),I?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.L(-1)?.items??new Map,w=this.L(0)?.items??new Map,I=this.L(1)?.items??new Map;return l(p,w,I,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(p,w){return this.r(E.NONE),(0,S.isUserDataProfile)(p)?this.N(p,w):this.O(p,w)}H(p,w){return!(p.id===w.id||y(w)&&y(p))}I(p,w,I,n){this.t(()=>{if(n)for(const[c,t]of p)w.set(c,t);else{const c=new Set;for(const[t,s]of p)c.add(t),w.get(t)!==s&&this.n(I,t);for(const[t]of w.items)c.has(t)||this.n(I,t)}})}}e.AbstractStorageService=h,h.a=60*1e3;function y(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=y;class f extends h{constructor(){super(),this.p=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(p=>this.n(1,p))),this.B(this.P.onDidChangeStorage(p=>this.n(0,p))),this.B(this.p.onDidChangeStorage(p=>this.n(-1,p)))}L(p){switch(p){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(p){return!1}}e.InMemoryStorageService=f;async function l(d,p,w,I,n,c){const t=N=>{try{return JSON.parse(N)}catch{return N}},s=new Map,o=new Map;d.forEach((N,F)=>{s.set(F,N),o.set(F,t(N))});const a=new Map,r=new Map;p.forEach((N,F)=>{a.set(F,N),r.set(F,t(N))});const u=new Map,v=new Map;w.forEach((N,F)=>{u.set(F,N),v.set(F,t(N))}),console.group(I!==n?`Storage: Application (path: ${I})`:`Storage: Application & Profile (path: ${I}, default profile)`);const C=[];if(s.forEach((N,F)=>{C.push({key:F,value:N})}),console.table(C),console.groupEnd(),console.log(o),I!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const N=[];a.forEach((F,j)=>{N.push({key:j,value:F})}),console.table(N),console.groupEnd(),console.log(r)}console.group(`Storage: Workspace (path: ${c})`);const T=[];u.forEach((N,F)=>{T.push({key:F,value:N})}),console.table(T),console.groupEnd(),console.log(v)}e.logStorage=l}),define(oe[118],ae([0,1,3,2,13,30,33,20]),function(Z,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends i.Disposable{constructor(b,g){super(),this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new S(b)),this.B(this.b.onDidChange(m=>this.a.fire({extensions:m,source:"storage"}))),this.B(g.onDidInstallExtensions(m=>m.forEach(({local:h,operation:y})=>{h&&y===4&&this.f(h.identifier)})))}async enableExtension(b,g){return this.f(b)?(this.a.fire({extensions:[b],source:g}),!0):!1}async disableExtension(b,g){return this.c(b)?(this.a.fire({extensions:[b],source:g}),!0):!1}getDisabledExtensions(){return this.h(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(b){const g=this.getDisabledExtensions();return g.every(m=>!(0,O.areSameExtensions)(m,b))?(g.push(b),this.g(g),!0):!1}f(b){const g=this.getDisabledExtensions();for(let m=0;m<g.length;m++){const h=g[m];if((0,O.areSameExtensions)(h,b))return g.splice(m,1),this.g(g),!0}return!1}g(b){this.i(A.DISABLED_EXTENSIONS_STORAGE_PATH,b)}h(b){return this.b.get(b,0)}i(b,g){this.b.set(b,g,0)}};P=ye([K(0,R.IStorageService),K(1,A.IExtensionManagementService)],P),e.GlobalExtensionEnablementService=P;class S extends i.Disposable{constructor(b){super(),this.c=b,this.a=Object.create(null),this.b=this.B(new k.Emitter),this.onDidChange=this.b.event,this.B(b.onDidChangeValue(g=>this.f(g)))}get(b,g){let m;return g===0?((0,D.isUndefinedOrNull)(this.a[b])&&(this.a[b]=this.g(b,g)),m=this.a[b]):m=this.g(b,g),JSON.parse(m)}set(b,g,m){const h=JSON.stringify(g.map(({id:f,uuid:l})=>({id:f,uuid:l})));this.g(b,m)!==h&&(m===0&&(g.length?this.a[b]=h:delete this.a[b]),this.h(b,g.length?h:void 0,m))}f(b){if(b.scope===0&&!(0,D.isUndefinedOrNull)(this.a[b.key])&&this.g(b.key,b.scope)!==this.a[b.key]){const m=this.get(b.key,b.scope);delete this.a[b.key];const h=this.get(b.key,b.scope),y=m.filter(l=>!h.some(d=>(0,O.areSameExtensions)(l,d))),f=h.filter(l=>!m.some(d=>(0,O.areSameExtensions)(d,l)));(y.length||f.length)&&this.b.fire([...y,...f])}}g(b,g){return this.c.get(b,g,"[]")}h(b,g,m){g?this.c.store(b,g,m,1):this.c.remove(b,m)}}e.StorageManager=S}),define(oe[267],ae([0,1,21,23,7,5,36,13,8,16,15,30,33,70,14,9,25,60,236,20,19]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const I=A.isWeb?"web":(0,b.getTargetPlatform)(A.platform,O.arch);var n;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function c(...U){return String(U.reduce((B,W)=>B|W,0))}var t;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},r={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class u{constructor(B=r){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,W=this.d.pageSize){return new u({...this.d,pageNumber:B,pageSize:W})}withFilter(B,...W){const q=[...this.d.criteria,...W.length?W.map(J=>({filterType:B,value:J})):[{filterType:B}]];return new u({...this.d,criteria:q})}withSortBy(B){return new u({...this.d,sortBy:B})}withSortOrder(B){return new u({...this.d,sortOrder:B})}withFlags(...B){return new u({...this.d,flags:B.reduce((W,q)=>W|q,0)})}withAssetTypes(...B){return new u({...this.d,assetTypes:B})}withSource(B){return new u({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:W,pageSize:q,sortBy:J,sortOrder:_,flags:Y,assetTypes:Q}=this.d;return{filters:[{criteria:B,pageNumber:W,pageSize:q,sortBy:J,sortOrder:_}],assetTypes:Q,flags:Y}}get searchText(){const B=this.d.criteria.filter(W=>W.filterType===t.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function v(U,B){const W=(U||[]).filter(q=>q.statisticName===B)[0];return W?W.value:0}function C(U){const B="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(q=>q.assetType.indexOf(B)===0).reduce((q,J)=>{const _=F(U,J.assetType);return _&&q.push([J.assetType.substring(B.length),_]),q},[])}function T(U){if(U.properties){const B=U.properties.filter(J=>J.key===s.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),q=B.filter(J=>W.test(J.value))[0];return q?{uri:q.value,fallbackUri:q.value}:null}return F(U,s.Repository)}function N(U){return{uri:`${U.fallbackAssetUri}/${s.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${s.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function F(U,B){return U.files.filter(q=>q.assetType===B)[0]?{uri:`${U.assetUri}/${B}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${B}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function j(U,B){const W=U.properties?U.properties.filter(J=>J.key===B):[],q=W.length>0&&W[0].value;return q?q.split(",").map(J=>(0,g.adoptToGalleryExtensionId)(J)):[]}function L(U){const B=U.properties?U.properties.filter(W=>W.key===o.Engine):[];return B.length>0&&B[0].value||""}function $(U){const B=U.properties?U.properties.filter(W=>W.key===o.PreRelease):[];return B.length>0&&B[0].value==="true"}function z(U){const B=U.properties?U.properties.filter(q=>q.key===o.LocalizedLanguages):[],W=B.length>0&&B[0].value||"";return W?W.split(","):[]}function H(U){return U.properties?.find(B=>B.key===o.SponsorLink)?.value}function X(U){return U.indexOf("preview")!==-1}function ie(U){return U.targetPlatform?(0,b.toTargetPlatform)(U.targetPlatform):"undefined"}function G(U){const B=(0,k.distinct)(U.versions.map(ie)),W=!!U.tags?.includes(b.WEB_EXTENSION_TAG),q=B.indexOf("web");return W?q===-1&&B.push("web"):q!==-1&&B.splice(q,1),B}function M(U,B){const W=(0,b.getFallbackTargetPlarforms)(B);for(let q=0;q<U.length;q++){const J=U[q];if(J.version===U[q-1]?.version){let _=q;const Y=ie(J);if(Y===B)for(;_>0&&U[_-1].version===J.version;)_--;else if(W.includes(Y))for(;_>0&&U[_-1].version===J.version&&ie(U[_-1])!==B;)_--;_!==q&&(U.splice(q,1),U.splice(_,0,J))}}return U}e.sortExtensionVersions=M;function V(U,B,W){U.telemetryData={index:B,querySource:W}}function x(U,B,W){const q=U.versions[0],J={manifest:F(B,s.Manifest),readme:F(B,s.Details),changelog:F(B,s.Changelog),license:F(B,s.License),repository:T(B),download:N(B),icon:F(B,s.Icon),signature:F(B,s.Signature),coreTranslations:C(B)};return{identifier:{id:(0,g.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:B.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(q),description:U.shortDescription||"",installCount:v(U.statistics,"install"),rating:v(U.statistics,"averagerating"),ratingCount:v(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:W,assets:J,properties:{dependencies:j(B,o.Dependency),extensionPack:j(B,o.ExtensionPack),engine:L(B),localizedLanguages:z(B),targetPlatform:ie(B),isPreReleaseVersion:$(B)},hasPreReleaseVersion:$(q),hasReleaseVersion:!0,preview:X(U.flags),isSigned:!!J.signature}}let ee=class{constructor(B,W,q,J,_,Y,Q,se){this.k=W,this.l=q,this.n=J,this.o=_,this.q=Y,this.u=Q,this.w=se;const le=Q.extensionsGallery,ue=le?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.d=ue?le.servicePPEUrl:le?.serviceUrl,this.g=ue?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,d.resolveMarketplaceHeaders)(Q.version,Q,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,W,q){const J=i.CancellationToken.isCancellationToken(W)?{}:W,_=i.CancellationToken.isCancellationToken(W)?W:q,Y=[],Q=[],se=[],le=[];let ue=!0;for(const be of B){be.uuid?Q.push(be.uuid):Y.push(be.id);const Ee=!!(be.version||be.preRelease);se.push({id:be.id,uuid:be.uuid,includePreRelease:Ee}),be.version&&le.push({id:be.id,uuid:be.uuid,version:be.version}),ue=ue&&!!be.hasPreRelease&&!Ee}if(!Q.length&&!Y.length)return[];let pe=new u().withPage(1,B.length);Q.length&&(pe=pe.withFilter(t.ExtensionId,...Q)),Y.length&&(pe=pe.withFilter(t.ExtensionName,...Y)),(J.queryAllVersions||ue)&&(pe=pe.withFlags(pe.flags,n.IncludeVersions)),J.source&&(pe=pe.withSource(J.source));const{extensions:we}=await this.z(pe,{targetPlatform:J.targetPlatform??I,includePreRelease:se,versions:le,compatible:!!J.compatible},_);return J.source&&we.forEach((be,Ee)=>V(be,Ee,J.source)),we}async getCompatibleExtension(B,W,q){if((0,b.isNotWebExtensionInWebTargetPlatform)(B.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(B,W,q))return B;const J=new u().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,B.identifier.uuid),{extensions:_}=await this.z(J,{targetPlatform:q,compatible:!0,includePreRelease:W},i.CancellationToken.None);return _[0]||null}async isExtensionCompatible(B,W,q){if(!(0,b.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,q)||!W&&B.properties.isPreReleaseVersion)return!1;let J=B.properties.engine;if(!J){const _=await this.getManifest(B,i.CancellationToken.None);if(!_)throw new Error("Manifest was not found");J=_.engines.vscode}return(0,m.isEngineValid)(J,this.u.version,this.u.date)}async y(B,W,q,J,_){if(!(0,b.isTargetPlatformCompatible)(ie(B),J,_)||W!=="any"&&$(B)!==(W==="prerelease"))return!1;if(q)try{const Y=await this.E(B);if(!(0,m.isEngineValid)(Y,this.u.version,this.u.date))return!1}catch(Y){return this.l.error(`Error while getting the engine for the version ${B.version}.`,(0,D.getErrorMessage)(Y)),!1}return!0}async query(B,W){let q=B.text||"";const J=B.pageSize??50;let _=new u().withPage(1,J);q?(q=q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,we)=>(_=_.withFilter(t.Category,we||pe),"")),q=q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,we)=>(_=_.withFilter(t.Tag,we||pe),"")),q=q.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(t.Featured),"")),q=q.trim(),q&&(q=q.length<200?q:q.substring(0,200),_=_.withFilter(t.SearchText,q)),_=_.withSortBy(0)):B.ids?_=_.withFilter(t.ExtensionId,...B.ids):B.names?_=_.withFilter(t.ExtensionName,...B.names):_=_.withSortBy(4),typeof B.sortBy=="number"&&(_=_.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(_=_.withSortOrder(B.sortOrder)),B.source&&(_=_.withSource(B.source));const Y=async(ue,pe)=>{const{extensions:we,total:be}=await this.z(ue,{targetPlatform:I,compatible:!1,includePreRelease:!!B.includePreRelease},pe);return we.forEach((Ee,Te)=>V(Ee,(ue.pageNumber-1)*ue.pageSize+Te,B.source)),{extensions:we,total:be}},{extensions:Q,total:se}=await Y(_,W),le=async(ue,pe)=>{if(pe.isCancellationRequested)throw new D.CancellationError;const{extensions:we}=await Y(_.withPage(ue+1),pe);return we};return{firstPage:Q,total:se,pageSize:_.pageSize,getPage:le}}async z(B,W,q){const J=B.flags;!!(B.flags&n.IncludeLatestVersionOnly)&&!!(B.flags&n.IncludeVersions)&&(B=B.withFlags(B.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(B.flags&n.IncludeLatestVersionOnly)&&!(B.flags&n.IncludeVersions)&&(B=B.withFlags(B.flags,n.IncludeLatestVersionOnly)),W.versions?.length&&(B=B.withFlags(B.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),B=B.withFlags(B.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:_,total:Y}=await this.B(B,q);if(!(B.flags&n.IncludeLatestVersionOnly)){const ue=[];for(const pe of _){const we=await this.A(pe,W);we&&ue.push(we)}return{extensions:ue,total:Y}}const se=[],le=new Map;for(let ue=0;ue<_.length;ue++){const pe=_[ue],we={id:(0,g.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},be=(0,R.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(Te=>(0,g.areSameExtensions)(Te,we))?.includePreRelease;if(W.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(G(pe),W.targetPlatform))continue;const Ee=await this.A(pe,W);!Ee||Ee.properties.isPreReleaseVersion&&(!be||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==W.targetPlatform&&Ee.hasPreReleaseVersion?le.set(pe.extensionId,ue):se.push([ue,Ee])}if(le.size){const ue=new Date().getTime(),pe=new u().withFlags(J&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:we}=await this.z(pe,W,q);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const be of we){const Ee=le.get(be.identifier.uuid);se.push([Ee,be])}}return{extensions:se.sort((ue,pe)=>ue[0]-pe[0]).map(([,ue])=>ue),total:Y}}async A(B,W){const q={id:(0,g.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},J=W.versions?.find(se=>(0,g.areSameExtensions)(se,q))?.version,_=(0,R.isBoolean)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(se=>(0,g.areSameExtensions)(se,q))?.includePreRelease,Y=G(B),Q=M(B.versions,W.targetPlatform);if(W.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(Y,W.targetPlatform))return null;for(let se=0;se<Q.length;se++){const le=Q[se];if(!(J&&le.version!==J)){if(await this.y(le,_?"any":"release",W.compatible,Y,W.targetPlatform))return x(B,le,Y);if(J&&le.version===J)return null}}return J||W.compatible?null:x(B,B.versions[0],Y)}async B(B,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,c(n.Unpublished));const q=await this.j,J=JSON.stringify(B.raw),_={...q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},Y=new Date().getTime();let Q,se,le=0;try{if(Q=await this.k.request({type:"POST",url:this.g&&B.criteria.some(pe=>pe.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:J,headers:_},W),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,l.asJson)(Q);if(ue){const pe=ue.results[0],we=pe.extensions,be=pe.resultMetadata&&pe.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return le=be&&be.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw se=ue,ue}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(J.length),duration:new Date().getTime()-Y,success:!!Q&&(0,l.isSuccess)(Q),responseBodySize:Q?.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:se?(0,D.isCancellationError)(se)?"canceled":(0,D.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(B,W,q,J){if(!this.isEnabled())return;const _=A.isWeb?this.x(`/itemName/${B}.${W}/version/${q}/statType/${J==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${W}/${q}/stats?statType=${J}`),Y=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.j,Accept:Y};try{await this.k.request({type:"POST",url:_,headers:se},i.CancellationToken.None)}catch{}}async download(B,W,q){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const J=(0,g.getGalleryExtensionTelemetryData)(B),_=new Date().getTime(),Y=ue=>this.o.publicLog("galleryService:downloadVSIX",{...J,duration:ue}),Q=q===2?"install":q===3?"update":"",se=Q?{uri:`${B.assets.download.uri}${P.URI.parse(B.assets.download.uri).query?"&":"?"}${Q}=true`,fallbackUri:`${B.assets.download.fallbackUri}${P.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${Q}=true`}:B.assets.download,le=await this.D(se);await this.q.writeFile(W,le.stream),Y(new Date().getTime()-_)}async downloadSignatureArchive(B,W){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const q=await this.D(B.assets.signature);await this.q.writeFile(W,q.stream)}async getReadme(B,W){if(B.assets.readme){const q=await this.D(B.assets.readme,{},W);return await(0,l.asTextOrError)(q)||""}return""}async getManifest(B,W){if(B.assets.manifest){const q=await this.D(B.assets.manifest,{},W),J=await(0,l.asTextOrError)(q);return J?JSON.parse(J):null}return null}async C(B,W){const q=F(B,s.Manifest);if(!q)throw new Error("Manifest was not found");const J={"Accept-Encoding":"gzip"},_=await this.D(q,{headers:J});return await(0,l.asJson)(_)}async getCoreTranslation(B,W){const q=B.assets.coreTranslations.filter(J=>J[0]===W.toUpperCase())[0];if(q){const J=await this.D(q[1]),_=await(0,l.asTextOrError)(J);return _?JSON.parse(_):null}return null}async getChangelog(B,W){if(B.assets.changelog){const q=await this.D(B.assets.changelog,{},W);return await(0,l.asTextOrError)(q)||""}return""}async getAllCompatibleVersions(B,W,q){let J=new u().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?J=J.withFilter(t.ExtensionId,B.identifier.uuid):J=J.withFilter(t.ExtensionName,B.identifier.id);const{galleryExtensions:_}=await this.B(J,i.CancellationToken.None);if(!_.length)return[];const Y=G(_[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(Y,q))return[];const Q=[];await Promise.all(_[0].versions.map(async ue=>{try{await this.y(ue,W?"any":"release",!0,Y,q)&&Q.push(ue)}catch{}}));const se=[],le=new Set;for(const ue of M(Q,q))le.has(ue.version)||(le.add(ue.version),se.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:$(ue)}));return se}async D(B,W={},q=i.CancellationToken.None){const J=await this.j,_={type:"GET"},Y={...J,...W.headers||{}};W={...W,..._,headers:Y};const Q=B.uri,se=B.fallbackUri,le={...W,url:Q};try{const ue=await this.k.request(le,q);if(ue.res.statusCode===200)return ue;const pe=await(0,l.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${pe}`)}catch(ue){if((0,D.isCancellationError)(ue))throw ue;const pe=(0,D.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:Q,message:pe});const we={...W,url:se};return this.k.request(we,q)}}async E(B){let W=L(B);if(!W){const q=await this.C(B,i.CancellationToken.None);if(!q)throw new Error("Manifest was not found");W=q.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const B=await this.k.request({type:"GET",url:this.h},i.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,l.asJson)(B),q=[],J={};if(W){for(const _ of W.malicious)q.push({id:_});if(W.migrateToPreRelease)for(const[_,Y]of Object.entries(W.migrateToPreRelease))(!Y.engine||(0,m.isEngineValid)(Y.engine,this.u.version,this.u.date))&&(J[_.toLowerCase()]={disallowInstall:!0,extension:{id:Y.id,displayName:Y.displayName,autoMigrate:{storage:!!Y.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[_,Y]of Object.entries(W.deprecated))Y&&(J[_.toLowerCase()]=(0,R.isBoolean)(Y)?{}:Y)}return{malicious:q,deprecated:J}}};ee=ye([K(1,l.IRequestService),K(2,y.ILogService),K(3,E.IEnvironmentService),K(4,w.ITelemetryService),K(5,h.IFileService),K(6,f.IProductService),K(7,S.IConfigurationService)],ee);let re=class extends ee{constructor(B,W,q,J,_,Y,Q,se){super(B,W,q,J,_,Y,Q,se)}};re=ye([K(0,p.IStorageService),K(1,l.IRequestService),K(2,y.ILogService),K(3,E.IEnvironmentService),K(4,w.ITelemetryService),K(5,h.IFileService),K(6,f.IProductService),K(7,S.IConfigurationService)],re),e.ExtensionGalleryService=re;let te=class extends ee{constructor(B,W,q,J,_,Y,Q){super(void 0,B,W,q,J,_,Y,Q)}};te=ye([K(0,l.IRequestService),K(1,y.ILogService),K(2,E.IEnvironmentService),K(3,w.ITelemetryService),K(4,h.IFileService),K(5,f.IProductService),K(6,S.IConfigurationService)],te),e.ExtensionGalleryServiceWithNoStorageService=te}),define(oe[80],ae([0,1,4,3,2,20,33,25,21,9,13]),function(Z,e,k,i,D,A,O,R,P,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let g=class Ze extends D.Disposable{static b(h){return`extensionKeys/${(0,O.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static c(h){const y=b.exec(h);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(h,y){const f=await h.getInstalled(),l=[];for(const[d,p]of Ze.f(y)){const w=f.find(I=>(0,O.areSameExtensions)(I.identifier,{id:d}))?.manifest.version;for(const I of p)w!==I&&l.push(Ze.b({id:d,version:I}))}for(const d of l)y.remove(d,0)}static f(h){const y=new Map,f=h.keys(0,1);for(const l of f){const d=Ze.c(l);if(d){let p=y.get(d.id.toLowerCase());p||y.set(d.id.toLowerCase(),p=[]),p.push(d.version)}}return y}constructor(h,y,f){super(),this.i=h,this.j=y,this.k=f,this.g=this.B(new i.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Ze.f(h),this.B(this.i.onDidChangeValue(l=>this.l(l)))}l(h){if(h.scope!==0)return;if(this.h.has(h.key.toLowerCase())){this.g.fire();return}const y=Ze.c(h.key);if(y){if(this.i.get(h.key,0)===void 0)this.h.delete(y.id.toLowerCase());else{let f=this.h.get(y.id.toLowerCase());f||this.h.set(y.id.toLowerCase(),f=[]),f.push(y.version),this.g.fire()}return}}m(h){if((0,E.isString)(h))return h;const y=h.manifest?h.manifest.publisher:h.publisher,f=h.manifest?h.manifest.name:h.name;return(0,O.getExtensionId)(y,f)}getExtensionState(h,y){const f=this.m(h),l=this.getExtensionStateRaw(h,y);if(l)try{return JSON.parse(l)}catch(d){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${y}): ${d}`)}}getExtensionStateRaw(h,y){const f=this.m(h),l=this.i.get(f,y?0:1);return l&&l?.length>Ze.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${y}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(h,y,f){const l=this.m(h);y===void 0?this.i.remove(l,f?0:1):this.i.store(l,JSON.stringify(y),f?0:1,1)}setKeysForSync(h,y){this.i.store(Ze.b(h),JSON.stringify(y),0,1)}getKeysForSync(h){const y=this.j.extensionSyncedKeys?.[h.id.toLowerCase()],f=this.i.get(Ze.b(h),0),l=f?JSON.parse(f):void 0;return l&&y?(0,P.distinct)([...l,...y]):l||y}addToMigrationList(h,y){if(h!==y){const f=this.n.filter(l=>!l.includes(h)&&!l.includes(y));f.push([h,y]),this.n=f}}getSourceExtensionToMigrate(h){const y=this.n.find(([,f])=>h===f);return y?y[0]:void 0}get n(){const h=this.i.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(h);if(Array.isArray(y))return y}catch{}return[]}set n(h){h.length?this.i.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};g.a=512*1024,g=ye([K(0,A.IStorageService),K(1,R.IProductService),K(2,S.ILogService)],g),e.ExtensionStorageService=g}),define(oe[268],ae([0,1,21,6,3,12,5,36,8,160,15,30,33,212,99,14,58,25,20,19]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const w="extensionTips/promptedExecutableTips",I="extensionTips/lastPromptedMediumImpExeTime";let n=class extends m.ExtensionTipsService{constructor(t,s,o,a,r,u,v,C){super(v,C),this.m=t,this.n=s,this.p=o,this.r=a,this.s=r,this.t=u,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,C.exeBasedExtensionTips&&Object.entries(C.exeBasedExtensionTips).forEach(([T,N])=>{const F=[],j=[],L=[];Object.entries(N.recommendations).forEach(([$,z])=>{z.important?N.important?F.push({extensionId:$,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):j.push({extensionId:$,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):L.push({extensionId:$,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),F.length&&this.g.set(T,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:F}),j.length&&this.h.set(T,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:j}),L.length&&this.j.set(T,{exeFriendlyName:N.friendlyName,windowsPath:N.windowsPath,recommendations:L})}),(0,i.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const t=await this.I(this.g),s=await this.I(this.h);return[...t,...s]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const t=await this.I(this.g),s=await this.I(this.h),o=await this.p.getInstalled();this.k=this.v(t,o),this.l=this.v(s,o)}v(t,s){const o=new Map;t.forEach(C=>o.set(C.extensionId.toLowerCase(),C));const{installed:a,uninstalled:r}=this.H([...o.keys()],s);for(const C of a){const T=o.get(C);T&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:C,exeName:T.exeName})}for(const C of r){const T=o.get(C);T&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:C,exeName:T.exeName})}const u=this.F(),v=new Map;for(const C of r){const T=o.get(C);if(T&&(!u[T.exeName]||!u[T.exeName].includes(T.extensionId))){let N=v.get(T.exeName);N||(N=[],v.set(T.exeName,N)),N.push(T)}}return v}w(){if(this.k.size===0)return;const[t,s]=[...this.k.entries()][0];this.z(s).then(o=>{switch(o){case"reacted":this.G(s[0].exeName,s);break;case"ignored":this.k.delete(t);break;case"incompatibleWindow":{const a=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(a(()=>this.w()));break}case"toomany":{const a=this.B((0,i.disposableTimeout)(()=>{a.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const t=this.C(),s=Date.now()-t,o=7*24*60*60*1e3;if(s<o){const u=this.B((0,i.disposableTimeout)(()=>{u.dispose(),this.y()},o-s));return}const[a,r]=[...this.l.entries()][0];this.z(r).then(u=>{switch(u){case"reacted":{this.D(Date.now()),this.l.delete(a),this.G(r[0].exeName,r);const v=this.B((0,i.disposableTimeout)(()=>{v.dispose(),this.y()},o));break}case"ignored":this.l.delete(a),this.y();break;case"incompatibleWindow":{const v=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(v(()=>this.y()));break}case"toomany":{const v=this.B((0,i.disposableTimeout)(()=>{v.dispose(),this.y()},36e5));break}}})}async z(t){const s=await this.p.getInstalled(1),o=t.filter(r=>!r.whenNotInstalled||r.whenNotInstalled.every(u=>s.every(v=>!(0,g.areSameExtensions)(v.identifier,{id:u})))).map(({extensionId:r})=>r.toLowerCase()),a=(0,S.localize)(0,null,t[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(o,a,`@exe:"${t[0].exeName}"`,3)}C(){let t=this.r.getNumber(I,-1);return t||(t=Date.now(),this.D(t)),t}D(t){this.r.store(I,t,-1,1)}F(){return JSON.parse(this.r.get(w,-1,"{}"))}G(t,s){const o=this.F();o[t]=s.map(({extensionId:a})=>a.toLowerCase()),this.r.store(w,JSON.stringify(o),-1,0)}H(t,s){const o=[],a=[],r=s.reduce((u,v)=>(u.add(v.identifier.id.toLowerCase()),u),new Set);return t.forEach(u=>{r.has(u.toLowerCase())?o.push(u):a.push(u)}),{installed:o,uninstalled:a}}async I(t){const s=[],o=new Map;for(const a of t.keys()){const r=t.get(a);if(!r||!(0,k.isNonEmptyArray)(r.recommendations))continue;const u=[];O.isWindows?r.windowsPath&&u.push(r.windowsPath.replace("%USERPROFILE%",()=>R.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>R.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>R.env.ProgramFiles).replace("%APPDATA%",()=>R.env.APPDATA).replace("%WINDIR%",()=>R.env.WINDIR)):(u.push((0,A.join)("/usr/local/bin",a)),u.push((0,A.join)("/usr/bin",a)),u.push((0,A.join)(this.m.userHome.fsPath,a)));for(const v of u){let C=o.get(v);if(C===void 0&&(C=await this.b.exists(P.URI.file(v)),o.set(v,C)),C)for(const{extensionId:T,extensionName:N,isExtensionPack:F,whenNotInstalled:j}of r.recommendations)s.push({extensionId:T,extensionName:N,isExtensionPack:F,exeName:a,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:j})}}return s}};n=ye([K(0,E.INativeEnvironmentService),K(1,p.ITelemetryService),K(2,b.IExtensionManagementService),K(3,d.IStorageService),K(4,f.INativeHostService),K(5,h.IExtensionRecommendationNotificationService),K(6,y.IFileService),K(7,l.IProductService)],n),e.ExtensionTipsService=n}),define(oe[269],ae([0,1,6,2,22,69,20,76,18]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends O.AbstractStorageService{constructor(b,g,m,h){super(),this.X=b,this.Y=g,this.Z=m,this.ab=h,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new i.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new i.DisposableStore),this.W=this.db(this.X)}bb(){const b=this.B(new R.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),g=this.B(new A.Storage(b));return this.B(g.onDidChangeStorage(m=>this.n(-1,m))),g}cb(b){this.Q.clear(),this.P=b;let g;if((0,O.isProfileUsingDefaultStorage)(b))g=this.s;else{const m=this.Q.add(new R.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),b));g=this.Q.add(new A.Storage(m))}return this.Q.add(g.onDidChangeStorage(m=>this.n(0,m))),g}db(b){this.U.clear(),this.S=b?.id;let g;if(b){const m=this.U.add(new R.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),b));g=this.U.add(new A.Storage(m)),this.U.add(g.onDidChangeStorage(h=>this.n(1,h)))}return g}async J(){await k.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(b){switch(b){case-1:return this.s;case 0:return this.R;default:return this.W}}M(b){switch(b){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,D.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(O.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(b,g){if(!this.H(this.P,b))return;const m=this.R,h=m.items;m!==this.s&&await m.close(),this.R=this.cb(b),await this.R.init(),this.I(h,this.R,0,g)}async O(b,g){const m=this.W,h=m?.items??new Map;await m?.close(),this.W=this.db(b),await this.W.init(),this.I(h,this.W,1,g)}hasScope(b){return(0,P.isUserDataProfile)(b)?this.P.id===b.id:this.S===b.id}}e.NativeStorageService=S}),define(oe[62],ae([0,1,2,69,4,20]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,D.createDecorator)("IUserDataProfileStorageService");let O=class extends k.Disposable{constructor(S){super(),this.a=S}async readStorageData(S){return this.withProfileScopedStorageService(S,async E=>this.b(E))}async updateStorageData(S,E,b){return this.withProfileScopedStorageService(S,async g=>this.c(g,E,b))}async withProfileScopedStorageService(S,E){if(this.a.hasScope(S))return E(this.a);const b=await this.createStorageDatabase(S),g=new R(b);try{await g.initialize();const m=await E(g);return await g.flush(),m}finally{g.dispose(),await this.f(b)}}b(S){const E=new Map,b=g=>{for(const m of S.keys(0,g))E.set(m,{value:S.get(m,0),target:g})};return b(0),b(1),E}c(S,E,b){for(const[g,m]of E)S.store(g,m,0,b)}async f(S){try{await S.close()}finally{(0,k.isDisposable)(S)&&S.dispose()}}};O=ye([K(0,A.IStorageService)],O),e.AbstractUserDataProfileStorageService=O;class R extends A.AbstractStorageService{constructor(S){super({flushInterval:100}),this.p=this.B(new i.Storage(S))}J(){return this.p.init()}L(S){return S===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[270],ae([0,1,3,2,22,15,57,18]),function(Z,e,k,i,D,A,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let P=class extends i.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(E,b,g){super(),this.b=[],this.c=this.B(new k.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=b.getChannel("userDataProfiles"),this.profilesHome=(0,D.joinPath)(g.userRoamingDataHome,"profiles"),this.b=E.map(m=>(0,R.reviveProfile)(m,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(m=>{const h=m.added.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),y=m.removed.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),f=m.updated.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme));this.b=m.all.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),this.c.fire({added:h,removed:y,updated:f,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(E){this.f=E}isEnabled(){return this.f}async createNamedProfile(E,b,g){const m=await this.a.call("createNamedProfile",[E,b,g]);return(0,R.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(E,b,g,m){const h=await this.a.call("createProfile",[E,b,g,m]);return(0,R.reviveProfile)(h,this.profilesHome.scheme)}async createTransientProfile(E){const b=await this.a.call("createTransientProfile",[E]);return(0,R.reviveProfile)(b,this.profilesHome.scheme)}async setProfileForWorkspace(E,b){await this.a.call("setProfileForWorkspace",[E,b])}removeProfile(E){return this.a.call("removeProfile",[E])}async updateProfile(E,b){const g=await this.a.call("updateProfile",[E,b]);return(0,R.reviveProfile)(g,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};P=ye([K(1,O.IMainProcessService),K(2,A.IEnvironmentService)],P),e.UserDataProfilesNativeService=P}),define(oe[271],ae([0,1,3,2,57,9,62,20,76,18,71]),function(Z,e,k,i,D,A,O,R,P,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let b=class extends O.AbstractUserDataProfileStorageService{constructor(m,h,y,f){super(y),this.h=m;const l=m.getChannel("profileStorageListener"),d=this.B(new i.MutableDisposable);this.g=this.B(new k.Emitter({onWillAddFirstListener:()=>{d.value=l.listen("onDidChange")(p=>{f.trace("profile storage changes",p),this.g.fire({targetChanges:p.targetChanges.map(w=>(0,S.reviveProfile)(w,h.profilesHome.scheme)),valueChanges:p.valueChanges.map(w=>({...w,profile:(0,S.reviveProfile)(w.profile,h.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.g.event}async createStorageDatabase(m){const h=this.h.getChannel("storage");return(0,R.isProfileUsingDefaultStorage)(m)?new P.ApplicationStorageDatabaseClient(h):new P.ProfileStorageDatabaseClient(h,m)}};b=ye([K(0,D.IMainProcessService),K(1,S.IUserDataProfilesService),K(2,R.IStorageService),K(3,A.ILogService)],b),e.UserDataProfileStorageService=b,(0,E.registerSingleton)(O.IUserDataProfileStorageService,b,1)}),define(oe[41],ae([0,1,21,6,17,23,3,35,2,27,13,176,16,15,14,9,45,20,19,29,26,18]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(u){return!!(u&&u.ref!==void 0&&typeof u.ref=="string"&&u.ref!==""&&u.syncData!==void 0&&(u.syncData===null||c(u.syncData)))}e.isRemoteUserData=n;function c(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=c;function t(u,v){return`${(0,S.uppercaseFirstLetter)(u)}${v.isDefault?"":` (${v.name})`}`}e.getSyncResourceLogLabel=t;let s=class extends P.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(v,C,T,N,F,j,L,$,z,H,X,ie){super(),this.syncResource=v,this.collection=C,this.C=T,this.D=N,this.F=F,this.G=j,this.H=L,this.I=$,this.J=z,this.L=H,this.M=X,this.c=null,this.k="idle",this.l=this.B(new O.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new O.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new i.ThrottledDelayer(50),this.t=this.B(new O.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(v.syncResource,v.profile),this.h=ie.extUri,this.f=this.h.joinPath(N.userDataSyncHome,...(0,w.getPathSegments)(v.profile.isDefault?void 0:v.profile.id,v.syncResource)),this.g=this.h.joinPath(this.f,w.PREVIEW_DIR_NAME),this.u=(0,w.getLastSyncResourceUri)(v.profile.isDefault?void 0:v.profile.id,v.syncResource,N,this.h),this.j=(0,f.getServiceMachineId)(N,T,F)}triggerLocalChange(){this.s.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const v=await this.c;this.c=null;const C=await this.S(v.remoteUserData,v.lastSyncUserData,!0,this.lb());this.O(C)}else{this.L.trace(`${this.y}: Checking for local changes...`);const v=await this.getLastSyncUserData();(v?await this.rb(v):!0)&&this.t.fire()}}O(v){this.k!==v&&(this.k=v,this.l.fire(v))}async sync(v,C={}){await this.P(v,!0,this.lb(),C)}async preview(v,C,T={}){return this.P(v,!1,C,T)}async apply(v,C={}){try{this.z={...C};const T=await this.X(v);return this.O(T),this.c}finally{this.z={}}}async P(v,C,T,N){try{if(this.z={...N},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let F="idle";try{const j=await this.getLastSyncUserData(),L=await this.R(v,j);return F=await this.S(L,j,C,T),F==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O(F)}}finally{this.z={}}}async replace(v){const C=this.hb(v);if(!C)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const T=await this.getLastSyncUserData(),N=await this.R(null,T),F=await this.Q(N),j=await this.nb({ref:N.ref,syncData:C},T,F,this.lb(),A.CancellationToken.None),L=[];for(const $ of j){const z=await this.pb($,$.remoteResource,void 0,A.CancellationToken.None),{remoteChange:H}=await this.pb($,$.previewResource,$.remoteContent,A.CancellationToken.None);L.push([$,{...z,remoteChange:H!==0?H:2}])}await this.qb(N,T,L,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(v){const C=await this.j;return!!v.syncData?.machineId&&v.syncData.machineId===C}async R(v,C){if(C){const T=v?v[this.resource]:void 0;if(C.ref===T||T===void 0&&C.syncData===null)return C}return this.getRemoteUserData(C)}async S(v,C,T,N){if(v.syncData&&v.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new w.UserDataSyncError((0,b.localize)(0,null,this.resource,this.mb,v.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(v,C,T,N)}catch(F){if(F instanceof w.UserDataSyncError)switch(F.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.S(v,C,T,N);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),v=await this.getRemoteUserData(null),C=await this.getLastSyncUserData(),this.S(v,C,T,N)}throw F}}async U(v,C,T,N){try{const F=await this.Q(v),j=!F&&C===null&&this.db()!==void 0,L=T&&!j;this.c||(this.c=(0,i.createCancelablePromise)(z=>this.bb(v,C,F,L,N,z)));let $=await this.c;if(T&&j){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const z of $.resourcePreviews)$=await this.accept(z.remoteResource)||$}return this.Z($.resourcePreviews),$.resourcePreviews.some(({mergeState:z})=>z==="conflict")?"hasConflicts":T?await this.X(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(v){return await this.W(v,async C=>{const T=await this.ob(C,A.CancellationToken.None);await this.C.writeFile(C.previewResource,D.VSBuffer.fromString(T?.content||""));const N=T&&!T.hasConflicts?await this.pb(C,C.previewResource,void 0,A.CancellationToken.None):void 0;return C.acceptResult=N,C.mergeState=T.hasConflicts?"conflict":N?"accepted":"preview",C.localChange=N?N.localChange:T.localChange,C.remoteChange=N?N.remoteChange:T.remoteChange,C}),this.c}async accept(v,C){return await this.W(v,async T=>{const N=await this.pb(T,v,C,A.CancellationToken.None);return T.acceptResult=N,T.mergeState="accepted",T.localChange=N.localChange,T.remoteChange=N.remoteChange,T}),this.c}async discard(v){return await this.W(v,async C=>{const T=await this.ob(C,A.CancellationToken.None);return await this.C.writeFile(C.previewResource,D.VSBuffer.fromString(T.content||"")),C.acceptResult=void 0,C.mergeState="preview",C.localChange=T.localChange,C.remoteChange=T.remoteChange,C}),this.c}async W(v,C){if(!this.c)return;let T=await this.c;const N=T.resourcePreviews.findIndex(({localResource:F,remoteResource:j,previewResource:L})=>this.h.isEqual(F,v)||this.h.isEqual(j,v)||this.h.isEqual(L,v));N!==-1&&(this.c=(0,i.createCancelablePromise)(async F=>{const j=[...T.resourcePreviews];return j[N]=await C(j[N]),{...T,resourcePreviews:j}}),T=await this.c,this.Z(T.resourcePreviews),T.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(v){if(!this.c)return"idle";const C=await this.c;return C.resourcePreviews.some(({mergeState:T})=>T==="conflict")?"hasConflicts":C.resourcePreviews.some(({mergeState:T})=>T!=="accepted")?"syncing":(await this.qb(C.remoteUserData,C.lastSyncUserData,C.resourcePreviews.map(T=>[T,T.acceptResult]),v),this.c=null,await this.Y(),"idle")}async Y(){try{await this.C.del(this.g,{recursive:!0})}catch{}}Z(v){const C=v.filter(({mergeState:T})=>T==="conflict");(0,k.equals)(this.m,C,(T,N)=>this.h.isEqual(T.previewResource,N.previewResource))||(this.m=C,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const v=await this.getLastSyncUserData();return!!v&&v.syncData!==null}async ab(v){const C=this.c?await this.c:null;if(C)for(const T of C.resourcePreviews){if(this.h.isEqual(T.acceptedResource,v))return T.acceptResult?T.acceptResult.content:null;if(this.h.isEqual(T.remoteResource,v))return T.remoteContent;if(this.h.isEqual(T.localResource,v))return T.localContent;if(this.h.isEqual(T.baseResource,v))return T.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(v){(0,h.toFileOperationResult)(v)!==1&&this.L.error(v)}}async bb(v,C,T,N,F,j){const L=await this.nb(v,C,T,F,j),$=[];for(const z of L){const H=z.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)$.push({...z,acceptedResource:H,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const X=N?await this.ob(z,j):void 0;if(j.isCancellationRequested)break;await this.C.writeFile(z.previewResource,D.VSBuffer.fromString(X?.content||""));const ie=X&&!X.hasConflicts?await this.pb(z,z.previewResource,void 0,j):void 0;$.push({...z,acceptResult:ie,mergeState:X?.hasConflicts?"conflict":ie?"accepted":"preview",localChange:ie?ie.localChange:X?X.localChange:z.localChange,remoteChange:ie?ie.remoteChange:X?X.remoteChange:z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:v,lastSyncUserData:C,resourcePreviews:$,isLastSyncFromCurrentMachine:T}}async getLastSyncUserData(){let v=this.db();if(v||(v=await this.gb()),!v)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const C=JSON.parse(v),T=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!C.version&&!!T&&C.version!==T,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${C.version} is not compatible with current sync state version ${T}.`),await this.resetLocal(),null;let N,F=1;for(;N===void 0&&F++<6;)try{const j=await this.eb();j&&(j.ref===C.ref?N=j.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(j){if(j instanceof h.FileOperationError&&j.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(j instanceof w.UserDataSyncError)throw j;this.L.error(j,F)}}if(N===void 0)try{const j=await this.G.resolveResourceContent(this.resource,C.ref,this.collection,this.z);N=j===null?null:this.hb(j),await this.fb({ref:C.ref,syncData:N})}catch(j){if(j instanceof w.UserDataSyncError&&j.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw j}return N===void 0?null:{...C,syncData:N}}async cb(v,C={}){if(C.ref||C.version)throw new Error("Cannot have core properties as additional");const T=this.I.getResourceSyncStateVersion(this.resource),N={ref:v.ref,version:T,...C};this.F.store(this.v,JSON.stringify(N),-1,1),await this.fb(v)}db(){return this.F.get(this.v,-1)}async eb(){const v=(await this.C.readFile(this.u)).value.toString();try{const C=v?JSON.parse(v):void 0;if(n(C))return C}catch(C){this.L.error(C)}}async fb(v){await this.C.writeFile(this.u,D.VSBuffer.fromString(JSON.stringify(v)))}async gb(){try{const v=await this.C.readFile(this.u),C=JSON.parse(v.value.toString());await this.C.del(this.u),C.ref&&C.content!==void 0&&(this.F.store(this.v,JSON.stringify({...C,content:void 0}),-1,1),await this.fb({ref:C.ref,syncData:C.content===null?null:JSON.parse(C.content)}))}catch(v){v instanceof h.FileOperationError&&v.fileOperationResult===1?this.L.debug(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(v)}return this.F.get(this.v,-1)}async getRemoteUserData(v){const{ref:C,content:T}=await this.ib(v);let N=null;return T!==null&&(N=this.hb(T)),{ref:C,syncData:N}}hb(v){try{const C=JSON.parse(v);if(c(C))return C}catch(C){this.L.error(C)}throw new w.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(v){const C=v?{ref:v.ref,content:v.syncData?JSON.stringify(v.syncData):null}:null;return this.G.readResource(this.resource,C,this.collection,this.z)}async jb(v,C){const T=await this.j,N={version:this.mb,machineId:T,content:v};try{return C=await this.G.writeResource(this.resource,JSON.stringify(N),C,this.collection,this.z),{ref:C,syncData:N}}catch(F){throw F instanceof w.UserDataSyncError&&F.code==="TooLarge"&&(F=new w.UserDataSyncError(F.message,F.code,this.resource)),F}}async kb(v){const C={version:this.mb,content:v};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(C))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(w.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};s=ye([K(2,h.IFileService),K(3,m.IEnvironmentService),K(4,l.IStorageService),K(5,w.IUserDataSyncStoreService),K(6,w.IUserDataSyncBackupStoreService),K(7,w.IUserDataSyncEnablementService),K(8,d.ITelemetryService),K(9,w.IUserDataSyncLogService),K(10,g.IConfigurationService),K(11,p.IUriIdentityService)],s),e.AbstractSynchroniser=s;let o=class extends s{constructor(v,C,T,N,F,j,L,$,z,H,X,ie,G){super(C,T,N,F,j,L,$,z,H,X,ie,G),this.i=v,this.B(this.C.watch(this.h.dirname(v))),this.B(this.C.onDidFilesChange(M=>this.tb(M)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(v,C,T){try{C?await this.C.writeFile(this.i,D.VSBuffer.fromString(v),T?void 0:C):await this.C.createFile(this.i,D.VSBuffer.fromString(v),{overwrite:T})}catch(N){throw N instanceof h.FileOperationError&&N.fileOperationResult===1||N instanceof h.FileOperationError&&N.fileOperationResult===3?new w.UserDataSyncError(N.message,"LocalPreconditionFailed"):N}}async sb(){try{await this.C.del(this.i)}catch(v){if(!(v instanceof h.FileOperationError&&v.fileOperationResult===1))throw v}}tb(v){!v.contains(this.i)||this.triggerLocalChange()}};o=ye([K(3,h.IFileService),K(4,m.IEnvironmentService),K(5,l.IStorageService),K(6,w.IUserDataSyncStoreService),K(7,w.IUserDataSyncBackupStoreService),K(8,w.IUserDataSyncEnablementService),K(9,d.ITelemetryService),K(10,w.IUserDataSyncLogService),K(11,g.IConfigurationService),K(12,p.IUriIdentityService)],o),e.AbstractFileSynchroniser=o;let a=class extends o{constructor(v,C,T,N,F,j,L,$,z,H,X,ie,G,M){super(v,C,T,N,F,j,L,$,z,H,X,G,M),this.ub=ie,this.wb=void 0}vb(v,C){const T=[],N=(0,R.parse)(v,T,{allowEmptyContent:!0,allowTrailingComma:!0});return T.length>0||!(0,E.isUndefined)(N)&&C!==Array.isArray(N)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};a=ye([K(3,h.IFileService),K(4,m.IEnvironmentService),K(5,l.IStorageService),K(6,w.IUserDataSyncStoreService),K(7,w.IUserDataSyncBackupStoreService),K(8,w.IUserDataSyncEnablementService),K(9,d.ITelemetryService),K(10,w.IUserDataSyncLogService),K(11,w.IUserDataSyncUtilService),K(12,g.IConfigurationService),K(13,p.IUriIdentityService)],a),e.AbstractJsonFileSynchroniser=a;let r=class{constructor(v,C,T,N,F,j,L){this.resource=v,this.g=C,this.h=T,this.j=N,this.k=F,this.l=j,this.d=L.extUri,this.f=(0,w.getLastSyncResourceUri)(void 0,this.resource,T,this.d)}async initialize({ref:v,content:C}){if(!C){this.j.info("Remote content does not exist.",this.resource);return}const T=this.m(C);if(!!T)try{await this.doInitialize({ref:v,syncData:T})}catch(N){this.j.error(N)}}m(v){try{const C=JSON.parse(v);if(c(C))return C}catch(C){this.j.error(C)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(v,C={}){if(C.ref||C.version)throw new Error("Cannot have core properties as additional");const T={ref:v.ref,version:void 0,...C};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(T),-1,1),await this.k.writeFile(this.f,D.VSBuffer.fromString(JSON.stringify(v)))}};r=ye([K(1,I.IUserDataProfilesService),K(2,m.IEnvironmentService),K(3,y.ILogService),K(4,h.IFileService),K(5,l.IStorageService),K(6,p.IUriIdentityService)],r),e.AbstractInitializer=r}),define(oe[119],ae([0,1,6,23,7,3,43,2,27,16,15,118,30,33,80,14,4,72,9,20,19,29,18,41,253,116,26,62]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p,w,I,n,c,t,s,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function r(F,j){const L=JSON.parse(F.content);if(F.version===1||F.version===2){const $=(await j.getInstalled(0)).filter(z=>z.isBuiltin);for(const z of L)F.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),F.version===2&&$.every(H=>!(0,m.areSameExtensions)(H.identifier,z.identifier))&&(z.installed=!0)}return L}function u(F){return JSON.parse(F.content)}e.parseExtensions=u;function v(F,j){return F.sort((L,$)=>!L.identifier.uuid&&$.identifier.uuid?-1:L.identifier.uuid&&!$.identifier.uuid?1:(0,P.compare)(L.identifier.id,$.identifier.id)),j?(0,O.toFormattedString)(F,{}):JSON.stringify(F)}e.stringify=v;let C=class extends c.AbstractSynchroniser{constructor(j,L,$,z,H,X,ie,G,M,V,x,ee,re,te,U,B,W){super({syncResource:"extensions",profile:j},L,z,$,H,X,ie,ee,re,V,x,U),this.yb=G,this.zb=M,this.Ab=W,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(T),this.B(A.Event.any(A.Event.filter(this.yb.onDidInstallExtensions,q=>q.some(({local:J})=>!!J)),A.Event.filter(this.yb.onDidUninstallExtension,q=>!q.error),A.Event.filter(B.onDidChange,q=>q.valueChanges.some(({profile:J,changes:_})=>this.syncResource.profile.id===J.id&&_.some(Y=>Y.key===g.DISABLED_EXTENSIONS_STORAGE_PATH))),te.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async nb(j,L){const $=j.syncData?await r(j.syncData,this.yb):null,z=L?.skippedExtensions||[],H=L?.builtinExtensions||[],X=L?.syncData?await r(L.syncData,this.yb):null,{localExtensions:ie,ignoredExtensions:G}=await this.xb.getLocalExtensions(this.syncResource.profile);$?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:V}=(0,t.merge)(ie,$,X,z,G,H),x={local:M,remote:V,content:this.Db(ie,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:V!==null?2:0},ee=this.Jb(ie,!1);return[{skippedExtensions:z,builtinExtensions:H,baseResource:this.tb,baseContent:X?this.Jb(X,!1):ee,localResource:this.ub,localContent:ee,localExtensions:ie,remoteResource:this.vb,remoteExtensions:$,remoteContent:$?this.Jb($,!1):null,previewResource:this.sb,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.wb}]}async rb(j){const L=j.syncData?await r(j.syncData,this.yb):null,{localExtensions:$,ignoredExtensions:z}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:H}=(0,t.merge)($,L,L,j.skippedExtensions||[],z,j.builtinExtensions||[]);return H!==null}Db(j,L,$,z){const H=[...L,...$],X=new Set,ie=G=>{X.add(G.id.toLowerCase()),G.uuid&&X.add(G.uuid)};H.forEach(({identifier:G})=>ie(G)),z.forEach(ie);for(const G of j)X.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&X.has(G.identifier.uuid)||H.push(G);return this.Jb(H,!1)}async ob(j,L){return{...j.previewResult,hasConflicts:!1}}async pb(j,L,$,z){if(this.h.isEqual(L,this.ub))return this.Gb(j);if(this.h.isEqual(L,this.vb))return this.Hb(j);if(this.h.isEqual(L,this.sb))return j.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async Gb(j){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),$=this.zb.getIgnoredExtensions(L),z=(0,t.merge)(j.localExtensions,null,null,j.skippedExtensions,$,j.builtinExtensions),{local:H,remote:X}=z;return{content:j.localContent,local:H,remote:X,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:X!==null?2:0}}async Hb(j){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),$=this.zb.getIgnoredExtensions(L),z=j.remoteContent?JSON.parse(j.remoteContent):null;if(z!==null){const H=(0,t.merge)(j.localExtensions,z,j.localExtensions,[],$,j.builtinExtensions),{local:X,remote:ie}=H;return{content:j.remoteContent,local:X,remote:ie,localChange:X.added.length>0||X.removed.length>0||X.updated.length>0?2:0,remoteChange:ie!==null?2:0}}else return{content:j.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(j,L,$,z){let{skippedExtensions:H,localExtensions:X}=$[0][0];const{local:ie,remote:G,localChange:M,remoteChange:V}=$[0][1];if(M===0&&V===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),M!==0&&(await this.kb(JSON.stringify(X)),H=await this.xb.updateLocalExtensions(ie.added,ie.removed,ie.updated,H,this.syncResource.profile)),G){this.L.trace(`${this.y}: Updating remote extensions...`);const x=JSON.stringify(G.all);j=await this.jb(x,z?null:j.ref),this.L.info(`${this.y}: Updated remote extensions.${G.added.length?` Added: ${JSON.stringify(G.added.map(ee=>ee.identifier.id))}.`:""}${G.updated.length?` Updated: ${JSON.stringify(G.updated.map(ee=>ee.identifier.id))}.`:""}${G.removed.length?` Removed: ${JSON.stringify(G.removed.map(ee=>ee.identifier.id))}.`:""}`)}if(L?.ref!==j.ref){this.L.trace(`${this.y}: Updating last synchronized extensions...`);const x=X.filter(ee=>!ee.installed).map(ee=>ee.identifier);await this.cb(j,{skippedExtensions:H,builtinExtensions:x}),this.L.info(`${this.y}: Updated last synchronized extensions.${H.length?` Skipped: ${JSON.stringify(H.map(ee=>ee.identifier.id))}.`:""}`)}}async resolveContent(j){if(this.h.isEqual(this.vb,j)||this.h.isEqual(this.tb,j)||this.h.isEqual(this.ub,j)||this.h.isEqual(this.wb,j)){const L=await this.ab(j);return L&&this.Jb(JSON.parse(L),!0)}return null}Jb(j,L){return v(j,L)}async hasLocalData(){try{const{localExtensions:j}=await this.xb.getLocalExtensions(this.syncResource.profile);if(j.some(L=>L.installed||L.disabled))return!0}catch{}return!1}};C=ye([K(2,E.IEnvironmentService),K(3,y.IFileService),K(4,p.IStorageService),K(5,o.IUserDataSyncStoreService),K(6,o.IUserDataSyncBackupStoreService),K(7,g.IExtensionManagementService),K(8,s.IIgnoredExtensionsManagementService),K(9,o.IUserDataSyncLogService),K(10,S.IConfigurationService),K(11,o.IUserDataSyncEnablementService),K(12,w.ITelemetryService),K(13,h.IExtensionStorageService),K(14,I.IUriIdentityService),K(15,a.IUserDataProfileStorageService),K(16,f.IInstantiationService)],C),e.ExtensionsSynchroniser=C;let T=class{constructor(j,L,$,z,H,X){this.a=j,this.b=L,this.c=$,this.d=z,this.f=H,this.g=X}async getLocalExtensions(j){const L=await this.a.getInstalled(void 0,j.extensionsResource),$=this.d.getIgnoredExtensions(L);return{localExtensions:await this.j(j,async(H,X)=>{const ie=H.getDisabledExtensions();return L.map(G=>{const{identifier:M,isBuiltin:V,manifest:x,preRelease:ee}=G,re={identifier:M,preRelease:ee,version:x.version};ie.some(te=>(0,m.areSameExtensions)(te,M))&&(re.disabled=!0),V||(re.installed=!0);try{const te=X.getKeysForSync({id:M.id,version:x.version});if(te){const U=X.getExtensionState(G,!0)||{};re.state=Object.keys(U).reduce((B,W)=>(te.includes(W)&&(B[W]=U[W]),B),{})}}catch(te){this.g.info(`${(0,c.getSyncResourceLogLabel)("extensions",j)}: Error while parsing extension state`,(0,D.getErrorMessage)(te))}return re})}),ignoredExtensions:$}}async updateLocalExtensions(j,L,$,z,H){const X=(0,c.getSyncResourceLogLabel)("extensions",H),ie=[],G=[],M=[],V=await this.a.getInstalled(void 0,H.extensionsResource);if((j.length||$.length)&&await this.j(H,async(ee,re)=>{await k.Promises.settled([...j,...$].map(async te=>{const U=V.find(W=>(0,m.areSameExtensions)(W.identifier,te.identifier));if(U&&U.isBuiltin){te.state&&U.manifest.version===te.version&&this.h(te.state,U,U.manifest.version,re),ee.getDisabledExtensions().some(q=>(0,m.areSameExtensions)(q,te.identifier))!==!!te.disabled&&(te.disabled?(this.g.trace(`${X}: Disabling extension...`,te.identifier.id),await ee.disableExtension(te.identifier),this.g.info(`${X}: Disabled extension`,te.identifier.id)):(this.g.trace(`${X}: Enabling extension...`,te.identifier.id),await ee.enableExtension(te.identifier),this.g.info(`${X}: Enabled extension`,te.identifier.id))),G.push(te.identifier);return}const B=(await this.c.getExtensions([{...te.identifier,preRelease:te.preRelease}],i.CancellationToken.None))[0];if(te.state&&(U?U.manifest.version===te.version:!!B)&&this.h(te.state,U||B,U?.manifest.version,re),B)try{ee.getDisabledExtensions().some(q=>(0,m.areSameExtensions)(q,te.identifier))!==!!te.disabled&&(te.disabled?(this.g.trace(`${X}: Disabling extension...`,te.identifier.id,B.version),await ee.disableExtension(B.identifier),this.g.info(`${X}: Disabled extension`,te.identifier.id,B.version)):(this.g.trace(`${X}: Enabling extension...`,te.identifier.id,B.version),await ee.enableExtension(B.identifier),this.g.info(`${X}: Enabled extension`,te.identifier.id,B.version))),(!U||U.preRelease!==te.preRelease)&&(await this.a.canInstall(B)?ie.push([te,B]):(this.g.info(`${X}: Skipped synchronizing extension because it cannot be installed.`,B.displayName||B.identifier.id),M.push(te)))}catch(W){M.push(te),this.g.error(W),this.g.info(`${X}: Skipped synchronizing extension`,B.displayName||B.identifier.id)}else M.push(te),this.g.info(`${X}: Skipped synchronizing extension because the extension is not found.`,te.identifier.id)}))}),L.length){const ee=V.filter(({identifier:re,isBuiltin:te})=>!te&&L.some(U=>(0,m.areSameExtensions)(re,U)));await k.Promises.settled(ee.map(async re=>{this.g.trace(`${X}: Uninstalling local extension...`,re.identifier.id),await this.a.uninstall(re,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:H.extensionsResource}),this.g.info(`${X}: Uninstalled local extension.`,re.identifier.id),G.push(re.identifier)}))}for(const[ee,re]of ie)try{this.g.trace(`${X}: Installing extension...`,re.identifier.id,re.version),await this.a.installFromGallery(re,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:ee.preRelease,profileLocation:H.extensionsResource,context:{[o.EXTENSIONS_SYNC_CONTEXT_KEY]:!0}}),this.g.info(`${X}: Installed extension.`,re.identifier.id,re.version),G.push(re.identifier)}catch(te){M.push(ee),te instanceof g.ExtensionManagementError&&[g.ExtensionManagementErrorCode.Incompatible,g.ExtensionManagementErrorCode.IncompatiblePreRelease,g.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(te.code)?this.g.info(`${X}: Skipped synchronizing extension because the compatible extension is not found.`,re.displayName||re.identifier.id):(this.g.error(te),this.g.info(`${X}: Skipped synchronizing extension`,re.displayName||re.identifier.id))}const x=[];for(const ee of z)G.some(re=>(0,m.areSameExtensions)(re,ee.identifier))||x.push(ee);for(const ee of M)x.some(re=>(0,m.areSameExtensions)(re.identifier,ee.identifier))||x.push(ee);return x}h(j,L,$,z){const H=z.getExtensionState(L,!0)||{},X=$?z.getKeysForSync({id:L.identifier.id,version:$}):void 0;X?X.forEach(ie=>{H[ie]=j[ie]}):Object.keys(j).forEach(ie=>H[ie]=j[ie]),z.setExtensionState(L,H,!0)}async j(j,L){return this.b.withProfileScopedStorageService(j,async $=>{const z=new R.DisposableStore,H=this.f.createChild(new l.ServiceCollection([p.IStorageService,$])),X=z.add(H.createInstance(b.GlobalExtensionEnablementService)),ie=z.add(H.createInstance(h.ExtensionStorageService));try{return await L(X,ie)}finally{z.dispose()}})}};T=ye([K(0,g.IExtensionManagementService),K(1,a.IUserDataProfileStorageService),K(2,g.IExtensionGalleryService),K(3,s.IIgnoredExtensionsManagementService),K(4,f.IInstantiationService),K(5,o.IUserDataSyncLogService)],T),e.LocalExtensionsProvider=T;let N=class extends c.AbstractInitializer{constructor(j,L,$,z,H,X,ie,G){super("extensions",z,H,X,$,ie,G),this.o=j,this.p=L}async q(j){return j.syncData?await r(j.syncData,this.o):null}t(j,L){const $=[],z=[],H=[];for(const X of j){if(this.p.hasToNeverSyncExtension(X.identifier.id))continue;const ie=L.find(G=>(0,m.areSameExtensions)(G.identifier,X.identifier));ie?($.push(ie),X.disabled&&H.push(X.identifier)):X.installed&&(z.push({...X.identifier,preRelease:!!X.preRelease}),X.disabled&&H.push(X.identifier))}return{installedExtensions:$,newExtensions:z,disabledExtensions:H,remoteExtensions:j}}};N=ye([K(0,g.IExtensionManagementService),K(1,s.IIgnoredExtensionsManagementService),K(2,y.IFileService),K(3,n.IUserDataProfilesService),K(4,E.IEnvironmentService),K(5,d.ILogService),K(6,p.IStorageService),K(7,I.IUriIdentityService)],N),e.AbstractExtensionsInitializer=N}),define(oe[120],ae([0,1,17,7,3,35,43,5,31,16,15,14,9,45,20,19,29,41,61,257,26,18,62,4]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p,w,I,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",s=["locale"];function o(T,N){const F=T.storage?Object.keys(T.storage).sort():[],j={};return F.forEach(L=>j[L]=T.storage[L]),T.storage=j,N?(0,O.toFormattedString)(T,{}):JSON.stringify(T)}e.stringify=o;const a=1;let r=class extends l.AbstractSynchroniser{constructor(N,F,j,L,$,z,H,X,ie,G,M,V,x,ee){super({syncResource:"globalState",profile:N},F,L,X,V,$,z,ie,G,H,M,x),this.wb=j,this.mb=a,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.sb=this.p.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.tb=this.p.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.ub=this.p.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.vb=ee.createInstance(u),this.B(L.watch(this.h.dirname(this.D.argvResource))),this.B(D.Event.any(D.Event.filter(L.onDidFilesChange,re=>re.contains(this.D.argvResource)),D.Event.filter(j.onDidChange,re=>!!(re.targetChanges.some(te=>this.syncResource.profile.id===te.id)||re.valueChanges.some(({profile:te,changes:U})=>this.syncResource.profile.id===te.id&&U.some(B=>B.target===0)))))(()=>this.triggerLocalChange()))}async nb(N,F,j){const L=N.syncData?JSON.parse(N.syncData.content):null;F=F===null&&j?N:F;const $=F&&F.syncData?JSON.parse(F.syncData.content):null,z=await this.vb.getLocalGlobalState(this.syncResource.profile);L?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=await this.Eb($),{local:X,remote:ie}=(0,p.merge)(z.storage,L?L.storage:null,$?$.storage:null,H,this.L),G={content:null,local:X,remote:ie,localChange:Object.keys(X.added).length>0||Object.keys(X.updated).length>0||X.removed.length>0?2:0,remoteChange:ie.all!==null?2:0},M=o(z,!1);return[{baseResource:this.r,baseContent:$?o($,!1):M,localResource:this.sb,localContent:M,localUserData:z,remoteResource:this.tb,remoteContent:L?o(L,!1):null,previewResource:this.p,previewResult:G,localChange:G.localChange,remoteChange:G.remoteChange,acceptedResource:this.ub,storageKeys:H}]}async rb(N){const F=N.syncData?JSON.parse(N.syncData.content):null;if(F===null)return!0;const j=await this.vb.getLocalGlobalState(this.syncResource.profile),L=await this.Eb(F),{remote:$}=(0,p.merge)(j.storage,F.storage,F.storage,L,this.L);return $.all!==null}async ob(N,F){return{...N.previewResult,hasConflicts:!1}}async pb(N,F,j,L){if(this.h.isEqual(F,this.sb))return this.Bb(N);if(this.h.isEqual(F,this.tb))return this.Cb(N);if(this.h.isEqual(F,this.p))return N.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Bb(N){return{content:N.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(N.localUserData.storage),removed:[],updated:[],all:N.localUserData.storage},localChange:0,remoteChange:2}}async Cb(N){if(N.remoteContent!==null){const F=JSON.parse(N.remoteContent),{local:j,remote:L}=(0,p.merge)(N.localUserData.storage,F.storage,null,N.storageKeys,this.L);return{content:N.remoteContent,local:j,remote:L,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:L!==null?2:0}}else return{content:N.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(N,F,j,L){const{localUserData:$}=j[0][0],{local:z,remote:H,localChange:X,remoteChange:ie}=j[0][1];if(X===0&&ie===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),X!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify($)),await this.vb.writeLocalGlobalState(z,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),ie!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const G=JSON.stringify({storage:H.all});N=await this.jb(G,L?null:N.ref),this.L.info(`${this.y}: Updated remote ui state.${H.added.length?` Added: ${H.added}.`:""}${H.updated.length?` Updated: ${H.updated}.`:""}${H.removed.length?` Removed: ${H.removed}.`:""}`)}F?.ref!==N.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(N),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(N){if(this.h.isEqual(this.tb,N)||this.h.isEqual(this.r,N)||this.h.isEqual(this.sb,N)||this.h.isEqual(this.ub,N)){const F=await this.ab(N);return F&&o(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:N}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(N).length>1||N[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(N){const F=await this.wb.readStorageData(this.syncResource.profile),j=[],L=[];for(const[H,X]of F)X.target===0?j.push(H):X.target===1&&L.push(H);const $=[...j,...L],z=N?.storage?Object.keys(N.storage).filter(H=>!H.startsWith(t)&&!$.includes(H)&&F.get(H)!==void 0):[];if(!R.isWeb){const H=[...w.ALL_SYNC_RESOURCES.map(X=>(0,w.getEnablementKey)(X)),w.SYNC_SERVICE_URL_TYPE];z.push(...H),L.push(...H)}return{user:j,machine:L,unregistered:z}}};r=ye([K(2,n.IUserDataProfileStorageService),K(3,b.IFileService),K(4,w.IUserDataSyncStoreService),K(5,w.IUserDataSyncBackupStoreService),K(6,w.IUserDataSyncLogService),K(7,E.IEnvironmentService),K(8,w.IUserDataSyncEnablementService),K(9,y.ITelemetryService),K(10,S.IConfigurationService),K(11,h.IStorageService),K(12,f.IUriIdentityService),K(13,c.IInstantiationService)],r),e.GlobalStateSynchroniser=r;let u=class{constructor(N,F,j,L){this.a=N,this.b=F,this.c=j,this.d=L}async getLocalGlobalState(N){const F={};if(N.isDefault){const L=await this.f(),$=(0,A.parse)(L);for(const z of s)$[z]!==void 0&&(F[`${t}${z}`]={version:1,value:$[z]})}const j=await this.c.readStorageData(N);for(const[L,$]of j)$.value&&$.target===0&&(F[L]={version:1,value:$.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const N=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),N.value.toString()}catch(N){this.d.debug((0,i.getErrorMessage)(N))}return"{}"}async writeLocalGlobalState({added:N,removed:F,updated:j},L){const $=(0,l.getSyncResourceLogLabel)("globalState",L),z={},H=new Map,X=await this.c.readStorageData(L),ie=(G,M)=>{for(const V of G){if(V.startsWith(t)){z[V.substring(t.length)]=M?M[V].value:void 0;continue}if(M){const x=M[V];x.value!==X.get(V)?.value&&H.set(V,x.value)}else X.get(V)!==void 0&&H.set(V,void 0)}};if(ie(Object.keys(N),N),ie(Object.keys(j),j),ie(F),Object.keys(z).length){this.d.trace(`${$}: Updating locale...`);const G=await this.f();let M=G;for(const V of Object.keys(z))M=(0,d.edit)(M,[V],z[V],{});G!==M&&(this.d.trace(`${$}: Updating locale...`),await this.a.writeFile(this.b.argvResource,k.VSBuffer.fromString(M)),this.d.info(`${$}: Updated locale.`)),this.d.info(`${$}: Updated locale`)}H.size&&(this.d.trace(`${$}: Updating global state...`),await this.c.updateStorageData(L,H,0),this.d.info(`${$}: Updated global state`,[...H.keys()]))}};u=ye([K(0,b.IFileService),K(1,E.IEnvironmentService),K(2,n.IUserDataProfileStorageService),K(3,w.IUserDataSyncLogService)],u),e.LocalGlobalStateProvider=u;let v=class extends l.AbstractInitializer{constructor(N,F,j,L,$,z){super("globalState",j,L,$,F,N,z)}async doInitialize(N){const F=N.syncData?JSON.parse(N.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const j={},L={};for(const $ of Object.keys(F.storage))$.startsWith(t)?j[$.substring(t.length)]=F.storage[$].value:this.l.get($,0)===void 0&&(L[$]=F.storage[$].value);if(Object.keys(j).length){let $="{}";try{$=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const z of Object.keys(j))$=(0,d.edit)($,[z],j[z],{});await this.k.writeFile(this.h.argvResource,k.VSBuffer.fromString($))}if(Object.keys(L).length)for(const $ of Object.keys(L))this.l.store($,L[$],0,0)}};v=ye([K(0,h.IStorageService),K(1,b.IFileService),K(2,I.IUserDataProfilesService),K(3,E.IEnvironmentService),K(4,w.IUserDataSyncLogService),K(5,f.IUriIdentityService)],v),e.GlobalStateInitializer=v;let C=class{constructor(N,F,j,L,$){this.a=N,this.b=F,this.c=j,this.d=L,this.f=$}getSyncStoreType(N){return this.h(N)?.storage[w.SYNC_SERVICE_URL_TYPE]?.value}async sync(N){const F=(0,w.createSyncHeaders)((0,P.generateUuid)());try{return await this.g(N,F)}catch(j){if(j instanceof w.UserDataSyncError)switch(j.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(N,F)}throw j}}async g(N,F){const j=await this.a.readResource("globalState",null,void 0,F),L=this.h(j)||{storage:{}};L.storage[w.SYNC_SERVICE_URL_TYPE]={value:N,version:a};const $=await(0,m.getServiceMachineId)(this.c,this.d,this.b),z={version:a,machineId:$,content:o(L,!1)};await this.a.writeResource("globalState",JSON.stringify(z),j.ref,void 0,F)}h({content:N}){if(!N)return null;const F=JSON.parse(N);if((0,l.isSyncData)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};C=ye([K(1,h.IStorageService),K(2,E.IEnvironmentService),K(3,b.IFileService),K(4,g.ILogService)],C),e.UserDataSyncStoreTypeSynchronizer=C}),define(oe[121],ae([0,1,21,17,3,35,5,13,177,16,15,14,20,19,29,18,41,254,26]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function p(n,c,t){try{const s=JSON.parse(n);if(!c)return(0,R.isUndefined)(s.all)?null:s.all;switch(O.OS){case 2:return(0,R.isUndefined)(s.mac)?null:s.mac;case 3:return(0,R.isUndefined)(s.linux)?null:s.linux;case 1:return(0,R.isUndefined)(s.windows)?null:s.windows}}catch(s){return t.error(s),null}}e.getKeybindingsContentFromSyncContent=p;let w=class extends f.AbstractJsonFileSynchroniser{constructor(c,t,s,o,a,r,u,v,C,T,N,F,j){super(c.keybindingsResource,{syncResource:"keybindings",profile:c},t,v,C,T,s,o,u,F,a,N,r,j),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Bb=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Cb=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Db=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(D.Event.filter(r.onDidChangeConfiguration,L=>L.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async nb(c,t,s,o){const a=c.syncData?p(c.syncData.content,o.keybindingsPerPlatform??this.Lb(),this.L):null;t=t===null&&s?c:t;const r=t?this.Jb(t):null,u=await this.p(),v=await this.xb();let C=null,T=!1,N=!1,F=!1;if(a){let $=u?u.value.toString():"[]";if($=$||"[]",this.vb($,!0))throw new d.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!r||r!==$||r!==a){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const z=await(0,l.merge)($,a,r,v,this.ub);z.hasChanges&&(C=z.mergeContent,F=z.hasConflicts,T=F||z.mergeContent!==$,N=F||z.mergeContent!==a)}}else u&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),C=u.value.toString(),N=!0);const j={content:F?r:C,localChange:T?u?2:1:0,remoteChange:N?2:0,hasConflicts:F},L=u?u.value.toString():null;return[{fileContent:u,baseResource:this.Ab,baseContent:r,localResource:this.Bb,localContent:L,localChange:j.localChange,remoteResource:this.Cb,remoteContent:a,remoteChange:j.remoteChange,previewResource:this.zb,previewResult:j,acceptedResource:this.Db}]}async rb(c){const t=this.Jb(c);if(t===null)return!0;const s=await this.p(),o=s?s.value.toString():"",a=await this.xb(),r=await(0,l.merge)(o||"[]",t,t,a,this.ub);return r.hasConflicts||r.mergeContent!==t}async ob(c,t){return c.previewResult}async pb(c,t,s,o){if(this.h.isEqual(t,this.Bb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Cb))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.zb))return s===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(c,t,s,o){const{fileContent:a}=s[0][0];let{content:r,localChange:u,remoteChange:v}=s[0][1];if(u===0&&v===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),r!==null&&(r=r.trim(),r=r||"[]",this.vb(r,!0)))throw new d.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),a&&await this.kb(this.Kb(a.value.toString())),await this.r(r||"[]",a,o),this.L.info(`${this.y}: Updated local keybindings`)),v!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const C=this.Kb(r||"[]",c.syncData?.content);c=await this.jb(C,o?null:c.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}t?.ref!==c.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(c,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.p();if(c){const t=(0,A.parse)(c.value.toString());if((0,k.isNonEmptyArray)(t))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async resolveContent(c){return this.h.isEqual(this.Cb,c)||this.h.isEqual(this.Ab,c)||this.h.isEqual(this.Bb,c)||this.h.isEqual(this.Db,c)?this.ab(c):null}Jb(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.Lb()?null:p(c.syncData.content,this.Lb(),this.L)}Kb(c,t){let s={};try{s=JSON.parse(t||"{}")}catch(o){this.L.error(o)}switch(this.Lb()?delete s.all:s.all=c,O.OS){case 2:s.mac=c;break;case 3:s.linux=c;break;case 1:s.windows=c;break}return JSON.stringify(s)}Lb(){return!!this.M.getValue(d.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};w=ye([K(2,d.IUserDataSyncStoreService),K(3,d.IUserDataSyncBackupStoreService),K(4,d.IUserDataSyncLogService),K(5,S.IConfigurationService),K(6,d.IUserDataSyncEnablementService),K(7,b.IFileService),K(8,E.IEnvironmentService),K(9,g.IStorageService),K(10,d.IUserDataSyncUtilService),K(11,m.ITelemetryService),K(12,h.IUriIdentityService)],w),e.KeybindingsSynchroniser=w;let I=class extends f.AbstractInitializer{constructor(c,t,s,o,a,r){super("keybindings",t,s,o,c,a,r)}async doInitialize(c){const t=c.syncData?this.i(c.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,i.VSBuffer.fromString(t)),await this.n(c)}async c(){try{const c=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,A.parse)(c.value.toString());return!(0,k.isNonEmptyArray)(t)}catch(c){return c.fileOperationResult===1}}i(c){try{return p(c,!0,this.j)}catch(t){return this.j.error(t),null}}};I=ye([K(0,b.IFileService),K(1,y.IUserDataProfilesService),K(2,E.IEnvironmentService),K(3,d.IUserDataSyncLogService),K(4,g.IStorageService),K(5,h.IUriIdentityService)],I),e.KeybindingsInitializer=I}),define(oe[122],ae([0,1,17,3,178,16,74,15,30,14,20,19,29,18,41,61,258,26]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function d(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function p(n){const c=JSON.parse(n);return d(c)?c:{settings:n}}e.parseSettingsSyncContent=p;let w=class extends h.AbstractJsonFileSynchroniser{constructor(c,t,s,o,a,r,u,v,C,T,N,F,j,L){super(c.settingsResource,{syncResource:"settings",profile:c},t,s,o,a,r,u,N,F,v,C,T,L),this.zb=j,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(c){const t=await this.getLastSyncUserData(),s=await this.R(c,t),o=this.Gb(s),a=new O.ConfigurationModelParser(l.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&a.parse(o.settings),a.configurationModel.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(c,t,s){const o=await this.p(),a=await this.xb(),r=this.Gb(c);t=t===null&&s?c:t;const u=t?this.Gb(t):null,v=await this.Kb();let C=null,T=!1,N=!1,F=!1;if(r){let z=o?o.value.toString().trim():"{}";z=z||"{}",this.Lb(z),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const H=(0,f.merge)(z,r.settings,u?u.settings:null,v,[],a);C=H.localContent||H.remoteContent,T=H.localContent!==null,N=H.remoteContent!==null,F=H.hasConflicts}else o&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),C=o.value.toString().trim()||"{}",this.Lb(C),N=!0);const j=o?o.value.toString():null,L=u?.settings??null,$={content:F?L:C,localChange:T?2:0,remoteChange:N?2:0,hasConflicts:F};return[{fileContent:o,baseResource:this.baseResource,baseContent:L,localResource:this.localResource,localContent:j,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async rb(c){const t=this.Gb(c);if(t===null)return!0;const s=await this.p(),o=s?s.value.toString().trim():"",a=await this.Kb(),r=await this.xb();return(0,f.merge)(o||"{}",t.settings,t.settings,a,[],r).remoteContent!==null}async ob(c,t){const s=await this.xb(),o=await this.Kb();return{...c.previewResult,content:c.previewResult.content?(0,f.updateIgnoredSettings)(c.previewResult.content,"{}",o,s):null}}async pb(c,t,s,o){const a=await this.xb(),r=await this.Kb();if(this.h.isEqual(t,this.localResource))return{content:c.fileContent?(0,f.updateIgnoredSettings)(c.fileContent.value.toString(),"{}",r,a):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:c.remoteContent!==null?(0,f.updateIgnoredSettings)(c.remoteContent,c.fileContent?c.fileContent.value.toString():"{}",r,a):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return s===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:s!==null?(0,f.updateIgnoredSettings)(s,c.fileContent?c.fileContent.value.toString():"{}",r,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(c,t,s,o){const{fileContent:a}=s[0][0];let{content:r,localChange:u,remoteChange:v}=s[0][1];if(u===0&&v===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Lb(r),u!==0&&(this.L.trace(`${this.y}: Updating local settings...`),a&&await this.kb(JSON.stringify(this.Ib(a.value.toString()))),await this.r(r,a,o),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),v!==0){const C=await this.xb(),T=this.Gb(c),N=await this.Kb(r);r=(0,f.updateIgnoredSettings)(r,T?T.settings:"{}",N,C),this.L.trace(`${this.y}: Updating remote settings...`),c=await this.jb(JSON.stringify(this.Ib(r)),o?null:c.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==c.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(c),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const c=await this.p();if(c){const t=await this.xb(),s=(0,y.edit)(c.value.toString(),[l.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,f.isEmpty)(s)}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async resolveContent(c){return this.h.isEqual(this.remoteResource,c)||this.h.isEqual(this.localResource,c)||this.h.isEqual(this.acceptedResource,c)||this.h.isEqual(this.baseResource,c)?this.ab(c):null}async ab(c){let t=await super.ab(c);if(t){const s=await this.xb(),o=await this.Kb();t=(0,f.updateIgnoredSettings)(t,"{}",o,s)}return t}Gb(c){return c.syncData?this.Hb(c.syncData.content):null}Hb(c){try{return p(c)}catch(t){this.L.error(t)}return null}Ib(c){return{settings:c}}async Kb(c){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const s=i.Event.any(i.Event.filter(this.zb.onDidInstallExtensions,o=>o.some(({local:a})=>!!a)),i.Event.filter(this.zb.onDidUninstallExtension,o=>!o.error))(()=>{s.dispose(),this.Jb=void 0})}const t=await this.Jb;return(0,f.getIgnoredSettings)(t,this.M,c)}Lb(c){if(this.vb(c,!1))throw new l.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};w=ye([K(2,S.IFileService),K(3,R.IEnvironmentService),K(4,E.IStorageService),K(5,l.IUserDataSyncStoreService),K(6,l.IUserDataSyncBackupStoreService),K(7,l.IUserDataSyncLogService),K(8,l.IUserDataSyncUtilService),K(9,A.IConfigurationService),K(10,l.IUserDataSyncEnablementService),K(11,b.ITelemetryService),K(12,P.IExtensionManagementService),K(13,g.IUriIdentityService)],w),e.SettingsSynchroniser=w;let I=class extends h.AbstractInitializer{constructor(c,t,s,o,a,r){super("settings",t,s,o,c,a,r)}async doInitialize(c){const t=c.syncData?this.i(c.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,k.VSBuffer.fromString(t.settings)),await this.n(c)}async c(){try{const c=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,f.isEmpty)(c.value.toString().trim())}catch(c){return c.fileOperationResult===1}}i(c){try{return p(c)}catch(t){this.j.error(t)}return null}};I=ye([K(0,S.IFileService),K(1,m.IUserDataProfilesService),K(2,R.IEnvironmentService),K(3,l.IUserDataSyncLogService),K(4,E.IStorageService),K(5,g.IUriIdentityService)],I),e.SettingsInitializer=I}),define(oe[123],ae([0,1,17,3,32,16,15,14,20,19,29,18,41,255,26]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function y(d){return JSON.parse(d.content)}e.parseSnippets=y;let f=class extends g.AbstractSynchroniser{constructor(p,w,I,n,c,t,s,o,a,r,u,v){super({syncResource:"snippets",profile:p},w,n,I,c,t,s,r,u,o,a,v),this.mb=1,this.p=p.snippetsHome,this.B(this.C.watch(I.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(i.Event.filter(this.C.onDidFilesChange,C=>C.affects(this.p))(()=>this.triggerLocalChange()))}async nb(p,w,I){const n=await this.Cb(),c=this.Bb(n),t=p.syncData?this.Ab(p.syncData):null;w=w===null&&I?p:w;const s=w&&w.syncData?this.Ab(w.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const o=(0,m.merge)(c,t,s);return this.wb(o,n,t||{},s||{})}async rb(p){const w=p.syncData?this.Ab(p.syncData):null;if(w===null)return!0;const I=await this.Cb(),n=this.Bb(I),c=(0,m.merge)(n,w,w);return Object.keys(c.remote.added).length>0||Object.keys(c.remote.updated).length>0||c.remote.removed.length>0||c.conflicts.length>0}async ob(p,w){return p.previewResult}async pb(p,w,I,n){if(this.h.isEqualOrParent(w,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:p.fileContent?p.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(w,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:p.remoteContent,localChange:p.remoteContent!==null?p.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(w,this.g))return I===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:I,localChange:I===null?p.fileContent!==null?3:0:2,remoteChange:I===null?p.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async qb(p,w,I,n){const c=I.map(([t,s])=>({...t,acceptResult:s}));c.every(({localChange:t,remoteChange:s})=>t===0&&s===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),c.some(({localChange:t})=>t!==0)&&(await this.xb(c),await this.yb(c,n)),c.some(({remoteChange:t})=>t!==0)&&(p=await this.zb(c,p,n)),w?.ref!==p.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(p),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of c)try{await this.C.del(t)}catch{}}wb(p,w,I,n){const c=new Map;for(const t of Object.keys(p.local.added)){const s={content:p.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.local.updated)){const s={content:p.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},o=w[t]?w[t].value.toString():null;c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},o=w[t]?w[t].value.toString():null;c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.remote.added)){const s={content:p.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},o=w[t]?w[t].value.toString():null;c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(p.remote.updated)){const s={content:p.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},o=w[t]?w[t].value.toString():null;c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of p.conflicts){const s={content:n[t]??null,hasConflicts:!0,localChange:w[t]?2:1,remoteChange:I[t]?2:1},o=w[t]?w[t].value.toString():null;c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[t]||null,localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(w))if(!c.has(t)){const s={content:w[t]?w[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},o=w[t]?w[t].value.toString():null;c.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[t]||null,localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...c.values()]}async resolveContent(p){return this.h.isEqualOrParent(p,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(p,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(p,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(p,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(p):null}async hasLocalData(){try{const p=await this.Cb();if(Object.keys(p).length)return!0}catch{}return!1}async xb(p){const w={};for(const I of p)I.fileContent&&(w[this.h.basename(I.localResource)]=I.fileContent);await this.kb(JSON.stringify(this.Bb(w)))}async yb(p,w){for(const{fileContent:I,acceptResult:n,localResource:c,remoteResource:t,localChange:s}of p)if(s!==0){const o=t?this.h.basename(t):this.h.basename(c),a=this.h.joinPath(this.p,o);s===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(a)),await this.C.del(a),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(a))):s===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(a)),await this.C.createFile(a,k.VSBuffer.fromString(n.content),{overwrite:w}),this.L.info(`${this.y}: Created snippet`,this.h.basename(a))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(a)),await this.C.writeFile(a,k.VSBuffer.fromString(n.content),w?void 0:I),this.L.info(`${this.y}: Updated snippet`,this.h.basename(a)))}}async zb(p,w,I){const n=w.syncData?this.Ab(w.syncData):{},c=(0,D.deepClone)(n);for(const{acceptResult:t,localResource:s,remoteResource:o,remoteChange:a}of p)if(a!==0){const r=s?this.h.basename(s):this.h.basename(o);a===3?delete c[r]:c[r]=t.content}return(0,m.areSame)(n,c)||(this.L.trace(`${this.y}: Updating remote snippets...`),w=await this.jb(JSON.stringify(c),I?null:w.ref),this.L.info(`${this.y}: Updated remote snippets`)),w}Ab(p){return y(p)}Bb(p){const w={};for(const I of Object.keys(p))w[I]=p[I].value.toString();return w}async Cb(){const p={};let w;try{w=await this.C.resolve(this.p)}catch(I){if(I instanceof R.FileOperationError&&I.fileOperationResult===1)return p;throw I}for(const I of w.children||[]){const n=I.resource,c=this.h.extname(n);if(c===".json"||c===".code-snippets"){const t=this.h.relativePath(this.p,n),s=await this.C.readFile(n);p[t]=s}}return p}};f=ye([K(2,O.IEnvironmentService),K(3,R.IFileService),K(4,P.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncLogService),K(8,A.IConfigurationService),K(9,h.IUserDataSyncEnablementService),K(10,S.ITelemetryService),K(11,E.IUriIdentityService)],f),e.SnippetsSynchroniser=f;let l=class extends g.AbstractInitializer{constructor(p,w,I,n,c,t){super("snippets",w,I,n,p,c,t)}async doInitialize(p){const w=p.syncData?JSON.parse(p.syncData.content):null;if(!w){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(w)){const c=w[n];if(c){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(t,k.VSBuffer.fromString(c)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(p)}async c(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(p){return p.fileOperationResult===1}}};l=ye([K(0,R.IFileService),K(1,b.IUserDataProfilesService),K(2,O.IEnvironmentService),K(3,h.IUserDataSyncLogService),K(4,P.IStorageService),K(5,E.IUriIdentityService)],l),e.SnippetsInitializer=l}),define(oe[124],ae([0,1,17,16,15,14,20,19,29,18,41,26]),function(Z,e,k,i,D,A,O,R,P,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function g(f,l){try{return JSON.parse(f).tasks??null}catch(d){return l.error(d),null}}e.getTasksContentFromSyncContent=g;let m=class extends E.AbstractFileSynchroniser{constructor(l,d,p,w,I,n,c,t,s,o,a,r){super(l.tasksResource,{syncResource:"tasks",profile:l},d,t,s,o,p,w,c,a,I,n,r),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.xb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.yb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.zb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(l,d,p,w){const I=l.syncData?g(l.syncData.content,this.L):null;d=d===null&&p?l:d;const n=d?.syncData?g(d.syncData.content,this.L):null,c=await this.p();let t=null,s=!1,o=!1,a=!1;if(l.syncData){const v=c?c.value.toString():null;if(!n||n!==v||n!==I){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const C=y(v,I,n);t=C.content,a=C.hasConflicts,s=C.hasLocalChanged,o=C.hasRemoteChanged}}else c&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=c.value.toString(),o=!0);const r={content:a?n:t,localChange:s?c?2:1:0,remoteChange:o?2:0,hasConflicts:a},u=c?c.value.toString():null;return[{fileContent:c,baseResource:this.wb,baseContent:n,localResource:this.xb,localContent:u,localChange:r.localChange,remoteResource:this.yb,remoteContent:I,remoteChange:r.remoteChange,previewResource:this.vb,previewResult:r,acceptedResource:this.zb}]}async rb(l){const d=l?.syncData?g(l.syncData.content,this.L):null;if(d===null)return!0;const p=await this.p(),w=p?p.value.toString():null,I=y(w,d,d);return I.hasLocalChanged||I.hasRemoteChanged}async ob(l,d){return l.previewResult}async pb(l,d,p,w){if(this.h.isEqual(d,this.xb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(d,this.yb))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(d,this.vb))return p===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:p,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async qb(l,d,p,w){const{fileContent:I}=p[0][0],{content:n,localChange:c,remoteChange:t}=p[0][1];if(c===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),c!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),I&&await this.kb(JSON.stringify(this.Fb(I.value.toString()))),n?await this.r(n,I,w):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const s=JSON.stringify(this.Fb(n));l=await this.jb(s,w?null:l.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}d?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(l){return this.h.isEqual(this.yb,l)||this.h.isEqual(this.wb,l)||this.h.isEqual(this.xb,l)||this.h.isEqual(this.zb,l)?this.ab(l):null}Fb(l){return l?{tasks:l}:{}}};m=ye([K(2,b.IUserDataSyncStoreService),K(3,b.IUserDataSyncBackupStoreService),K(4,b.IUserDataSyncLogService),K(5,i.IConfigurationService),K(6,b.IUserDataSyncEnablementService),K(7,A.IFileService),K(8,D.IEnvironmentService),K(9,O.IStorageService),K(10,R.ITelemetryService),K(11,P.IUriIdentityService)],m),e.TasksSynchroniser=m;let h=class extends E.AbstractInitializer{constructor(l,d,p,w,I,n){super("tasks",d,p,w,l,I,n),this.c=this.g.defaultProfile.tasksResource}async doInitialize(l){const d=l.syncData?g(l.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,k.VSBuffer.fromString(d)),await this.n(l)}async i(){return this.k.exists(this.c)}};h=ye([K(0,A.IFileService),K(1,S.IUserDataProfilesService),K(2,D.IEnvironmentService),K(3,b.IUserDataSyncLogService),K(4,O.IStorageService),K(5,P.IUriIdentityService)],h),e.TasksInitializer=h;function y(f,l,d){if(f===null&&l===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(f===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const p=d!==f,w=d!==l;return!p&&!w?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:p&&!w?{content:f,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:w&&!p?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:f,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[125],ae([0,1,43,16,15,14,20,19,29,18,41,256,26]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let m=class extends E.AbstractSynchroniser{constructor(l,d,p,w,I,n,c,t,s,o,a,r,u){super({syncResource:"profiles",profile:l},d,w,I,n,c,t,a,r,s,o,u),this.r=p,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?y(l.syncData):null}async getRemoteSyncedProfiles(l){const d=await this.getLastSyncUserData(),p=await this.R(l,d);return p?.syncData?y(p.syncData):null}async nb(l,d,p){if(!this.r.isEnabled())throw new g.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const w=l.syncData?y(l.syncData):null,I=d?.syncData?y(d.syncData):null,n=this.zb(),{local:c,remote:t}=(0,b.merge)(n,w,I,[]),s={local:c,remote:t,content:I?this.Ab(I):null,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:t!==null?2:0},o=h(n,!1);return[{baseResource:this.baseResource,baseContent:I?this.Ab(I):null,localResource:this.localResource,localContent:o,remoteResource:this.remoteResource,remoteContent:w?this.Ab(w):null,remoteProfiles:w,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async rb(l){const d=l?.syncData?y(l.syncData):null,p=this.zb(),{remote:w}=(0,b.merge)(p,d,d,[]);return!!w?.added.length||!!w?.removed.length||!!w?.updated.length}async ob(l,d){return{...l.previewResult,hasConflicts:!1}}async pb(l,d,p,w){if(this.h.isEqual(d,this.localResource))return this.wb(l);if(this.h.isEqual(d,this.remoteResource))return this.xb(l);if(this.h.isEqual(d,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async wb(l){const d=this.zb(),p=(0,b.merge)(d,null,null,[]),{local:w,remote:I}=p;return{content:l.localContent,local:w,remote:I,localChange:w.added.length>0||w.removed.length>0||w.updated.length>0?2:0,remoteChange:I!==null?2:0}}async xb(l){const d=l.remoteContent?JSON.parse(l.remoteContent):null,p=[],w=[];for(const I of this.zb()){const n=d?.find(c=>c.id===I.id);n&&(p.push({id:I.id,name:I.name,collection:n.collection}),w.push(I))}if(d!==null){const I=(0,b.merge)(w,d,p,[]),{local:n,remote:c}=I;return{content:l.remoteContent,local:n,remote:c,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:c!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(l,d,p,w){const{local:I,remote:n,localChange:c,remoteChange:t}=p[0][1];c===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const s=p[0][0].remoteProfiles||[];if(s.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new g.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(c!==0){await this.kb(h(this.zb(),!1));const o=[];for(const a of I.added)o.push((async()=>{this.L.trace(`${this.y}: Creating '${a.name}' profile...`),await this.r.createProfile(a.id,a.name,{shortName:a.shortName}),this.L.info(`${this.y}: Created profile '${a.name}'.`)})());for(const a of I.removed)o.push((async()=>{this.L.trace(`${this.y}: Removing '${a.name}' profile...`),await this.r.removeProfile(a),this.L.info(`${this.y}: Removed profile '${a.name}'.`)})());for(const a of I.updated){const r=this.r.profiles.find(u=>u.id===a.id);r?o.push((async()=>{this.L.trace(`${this.y}: Updating '${a.name}' profile...`),await this.r.updateProfile(r,{name:a.name,shortName:a.shortName}),this.L.info(`${this.y}: Updated profile '${a.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${a.id}' to update.`)}await Promise.all(o)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const o=[],a=s.length+(n?.added.length??0)<=20;if(a)for(const r of n?.added||[]){const u=await this.G.createCollection(this.z);o.push(u),s.push({id:r.id,name:r.name,collection:u,shortName:r.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const r of n?.removed||[])s.splice(s.findIndex(({id:u})=>r.id===u),1);for(const r of n?.updated||[]){const u=s.find(({id:v})=>r.id===v);u&&s.splice(s.indexOf(u),1,{id:r.id,name:r.name,collection:u.collection,shortName:r.shortName})}try{l=await this.updateRemoteProfiles(s,w?null:l.ref),this.L.info(`${this.y}: Updated remote profiles.${a&&n?.added.length?` Added: ${JSON.stringify(n.added.map(r=>r.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(r=>r.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(r=>r.name))}.`:""}`)}catch(r){if(o.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const u of o)await this.G.deleteCollection(u,this.z)}throw r}for(const r of n?.removed||[])await this.G.deleteCollection(r.collection,this.z)}d?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,d){return this.jb(this.Ab(l),d)}async hasLocalData(){return this.zb().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const d=await this.ab(l);return d&&(0,k.toFormattedString)(JSON.parse(d),{})}return null}zb(){return this.r.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Ab(l){return JSON.stringify([...l].sort((d,p)=>d.name.localeCompare(p.name)))}};m=ye([K(2,S.IUserDataProfilesService),K(3,A.IFileService),K(4,D.IEnvironmentService),K(5,O.IStorageService),K(6,g.IUserDataSyncStoreService),K(7,g.IUserDataSyncBackupStoreService),K(8,g.IUserDataSyncLogService),K(9,i.IConfigurationService),K(10,g.IUserDataSyncEnablementService),K(11,R.ITelemetryService),K(12,P.IUriIdentityService)],m),e.UserDataProfilesManifestSynchroniser=m;function h(f,l){const d=[...f].sort((p,w)=>p.name.localeCompare(w.name)).map(p=>({id:p.id,name:p.name}));return l?(0,k.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=h;function y(f){return JSON.parse(f.content)}e.parseUserDataProfilesManifest=y}),define(oe[272],ae([0,1,6,17,65,2,22,16,15,14,18,26]),function(Z,e,k,i,D,A,O,R,P,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let g=class extends A.Disposable{constructor(h,y,f,l,d){super(),this.a=h,this.b=y,this.c=f,this.f=l,this.g=d,this.h()}async h(){for(const y of this.g.profiles)for(const f of b.ALL_SYNC_RESOURCES)try{await this.j(this.i(y,f))}catch(l){this.f.error(l)}let h;try{h=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,S.toFileOperationResult)(y)!==1&&this.f.error(y);return}if(h.children){for(const y of h.children)if(y.isDirectory&&!this.g.profiles.some(f=>f.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(f){this.f.error(f)}}}async getAllRefs(h,y){const f=this.i(h,y),l=await this.b.resolve(f);return l.children?l.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.k(p)})):[]}async resolveContent(h,y,f){const l=this.i(h,y),d=(0,O.joinPath)(l,f);try{return(await this.b.readFile(d)).value.toString()}catch(p){return this.f.error(p),null}}async backup(h,y,f){const l=this.i(h,y),d=(0,O.joinPath)(l,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,i.VSBuffer.fromString(f))}catch(p){this.f.error(p)}try{this.j(l)}catch{}}i(h,y){return(0,O.joinPath)(this.a.userDataSyncHome,...h.isDefault?[y]:[h.id,y])}async j(h){try{try{if(!await this.b.exists(h))return}catch{return}const y=await this.b.resolve(h);if(y.children){const f=y.children.filter(w=>w.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(w.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=f.filter(w=>Date.now()-this.k(w)>l);const p=f.length-d.length;p<10&&(d=d.slice(10-p)),await k.Promises.settled(d.map(async w=>{this.f.info("Deleting from backup",w.resource.path),await this.b.del(w.resource)}))}}catch(y){this.f.error(y)}}k(h){return h.ctime||new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};g=ye([K(0,P.IEnvironmentService),K(1,S.IFileService),K(2,R.IConfigurationService),K(3,b.IUserDataSyncLogService),K(4,E.IUserDataProfilesService)],g),e.UserDataSyncBackupStoreService=g}),define(oe[273],ae([0,1,3,2,5,15,20,19,26]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let E=class extends i.Disposable{constructor(g,m,h,y){super(),this.c=g,this.f=m,this.g=h,this.h=y,this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new k.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(g.onDidChangeValue(f=>this.j(f)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(S,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.f.publicLog2(S,{enabled:g}),this.c.store(S,g,-1,1))}isResourceEnabled(g){return this.c.getBoolean((0,P.getEnablementKey)(g),-1,!0)}setResourceEnablement(g,m){if(this.isResourceEnabled(g)!==m){const h=(0,P.getEnablementKey)(g);this.i(h,m)}}getResourceSyncStateVersion(g){}i(g,m){this.c.store(g,m,-1,D.isWeb?0:1)}j(g){if(g.scope!==-1)return;if(S===g.key){this.a.fire(this.isEnabled());return}const m=P.ALL_SYNC_RESOURCES.filter(h=>(0,P.getEnablementKey)(h)===g.key)[0];if(m){this.b.fire([m,this.isResourceEnabled(m)]);return}}};E=ye([K(0,O.IStorageService),K(1,R.ITelemetryService),K(2,A.IEnvironmentService),K(3,P.IUserDataSyncStoreManagementService)],E),e.UserDataSyncEnablementService=E}),define(oe[81],ae([0,1,3,2,5,27,181,15,14,4,25,45,20,26]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",y="Safari",f="Chrome",l="Edge",d="Firefox",p="Android";function w(c){switch(c){case y:case f:case l:case d:case p:case(0,D.PlatformToString)(0):return!0}return!1}e.isWebPlatform=w;function I(){return D.isSafari?y:D.isChrome?f:D.isEdge?l:D.isFirefox?d:D.isAndroid?p:(0,D.PlatformToString)(D.isWeb?0:D.platform)}let n=class rt extends i.Disposable{constructor(t,s,o,a,r,u){super(),this.h=o,this.i=a,this.j=r,this.k=u,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,b.getServiceMachineId)(t,s,o)}async getMachines(t){const s=await this.f;return(await this.m(t)).machines.map(a=>({...a,isCurrent:a.id===s}))}async addCurrentMachine(t){const s=await this.f,o=await this.m(t);o.machines.some(({id:a})=>a===s)||(o.machines.push({id:s,name:this.l(o.machines),platform:I()}),await this.n(o))}async removeCurrentMachine(t){const s=await this.f,o=await this.m(t),a=o.machines.filter(({id:r})=>r!==s);a.length!==o.machines.length&&(o.machines=a,await this.n(o))}async renameMachine(t,s,o){const a=await this.m(o),r=a.machines.find(({id:u})=>u===t);if(r){r.name=s,await this.n(a);const u=await this.f;t===u&&this.h.store(h,s,-1,1)}}async setEnablements(t){const s=await this.m();for(const[o,a]of t){const r=s.machines.find(u=>u.id===o);r&&(r.disabled=a?void 0:!0)}await this.n(s)}l(t){const s=this.h.get(h,-1);if(s)return s;const o=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${I()} (${this.k.nameShort})`,a=new RegExp(`${(0,A.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let r=0;for(const u of t){const v=a.exec(u.name),C=v?parseInt(v[1]):0;r=C>r?C:r}return`${o} #${r+1}`}async m(t){this.g=await this.p(t);const s=this.r(this.g);if(s.version!==rt.a)throw new Error((0,O.localize)(0,null,this.k.nameLong));return s}async n(t){const s=JSON.stringify(t),o=await this.i.writeResource(rt.b,s,this.g?.ref||null);this.g={ref:o,content:s},this.c.fire()}async p(t){if(this.g){const s=t&&t.latest?t.latest[rt.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.i.readResource(rt.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.j.error(s)}return{version:rt.a,machines:[]}}};n.a=1,n.b="machines",n=ye([K(0,R.IEnvironmentService),K(1,P.IFileService),K(2,g.IStorageService),K(3,m.IUserDataSyncStoreService),K(4,m.IUserDataSyncLogService),K(5,E.IProductService)],n),e.UserDataSyncMachinesService=n}),define(oe[274],ae([0,1,6,65,38,7,3,2,5,22,8,179,25,20,19,26,78,81]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",p="sync.sessionId",w="sync.storeUrl",I="sync.productQuality";let n=class extends R.Disposable{get j(){const s=this.z.get(w,-1);return s?E.URI.parse(s):void 0}set j(s){s?this.z.store(w,s.toString(),-1,1):this.z.remove(w,-1)}get l(){return this.z.get(I,-1)}set l(s){s?this.z.store(I,s,-1,1):this.z.remove(I,-1)}constructor(s,o,a,r,u,v,C,T,N,F){super(),this.n=o,this.p=a,this.r=r,this.s=u,this.u=v,this.v=C,this.w=T,this.y=N,this.z=F,this.a=this.B(new R.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new k.ThrottledDelayer(this.O())),this.i=this.j,this.j=o.userDataSyncStore?.url,this.k=this.l,this.l=s.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(o.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.j,o.userDataSyncStore?.url)||(this.i=this.j,this.j=o.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(C.onDidChangeAccount(()=>this.C())),this.B(a.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(u.onDidChangeLocal(j=>this.triggerSync([j],!1,!1))),this.B(O.Event.filter(this.r.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:s,message:o}=this.F();s?this.a.value===void 0&&(this.a.value=new c(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(a=>this.I(a))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(o&&this.u.info(o),this.a.clear()):o&&this.r.isEnabled()&&this.u.info(o))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(s,o,a){try{this.v.account&&!a&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(p,-1),s?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(r){if(this.u.error(r),o)this.G(!1);else throw r}}G(s){this.r.isEnabled()!==s&&(this.r.setEnablement(s),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(s){if(!s){this.b=0;return}const o=y.UserDataSyncError.toUserDataSyncError(s);o instanceof y.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:o.code,service:this.n.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?P.isWeb&&o.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(o),this.b++),this.h.fire(o)}async J(){this.z.store(d,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(d,-1,!1)}M(){this.z.remove(d,-1)}async triggerSync(s,o,a){if(this.a.value===void 0)return this.f.cancel();if(o&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...s),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const r=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:r}),this.N=[],this.a.value&&await this.a.value.sync("Activity",a)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};n=ye([K(0,g.IProductService),K(1,y.IUserDataSyncStoreManagementService),K(2,y.IUserDataSyncStoreService),K(3,y.IUserDataSyncEnablementService),K(4,y.IUserDataSyncService),K(5,y.IUserDataSyncLogService),K(6,f.IUserDataSyncAccountService),K(7,h.ITelemetryService),K(8,l.IUserDataSyncMachinesService),K(9,m.IStorageService)],n),e.UserDataAutoSyncService=n;class c extends R.Disposable{constructor(s,o,a,r,u,v,C,T){super(),this.j=s,this.k=o,this.l=a,this.m=r,this.n=u,this.p=v,this.r=C,this.s=T,this.b=this.B(new R.MutableDisposable),this.c=this.B(new O.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new O.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,R.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(c.a,!1)}u(){this.b.value=(0,k.disposableTimeout)(()=>this.sync(c.a,!1),this.k)}sync(s,o){const a=(0,k.createCancelablePromise)(async r=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(u){if((0,A.isCancellationError)(u))return}return this.y(s,o,r)});return this.i=a,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,S.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const s=await this.l.getPreviousUserDataSyncStore(),o=this.l.userDataSyncStore;return!!o&&!!s&&(!(0,S.isEqual)(o.defaultUrl,s.defaultUrl)||!(0,S.isEqual)(o.insidersUrl,s.insidersUrl)||!(0,S.isEqual)(o.stableUrl,s.stableUrl))}async y(s,o,a){this.r.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let r;try{await this.z(o,a)}catch(u){if(this.r.error(u),r=u,y.UserDataSyncError.toUserDataSyncError(u).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(o,a),r=void 0}catch(v){this.r.error(v),r=v}}this.f.fire(r)}async z(s,o){if(this.h=await this.n.createSyncTask(this.g,s),o.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new y.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const a=this.s.get(p,-1);if(a&&this.g&&a!==this.g.session)throw this.v()?await this.w()?new y.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const r=await this.p.getMachines(this.g||void 0);if(o.isCancellationRequested)return;const u=r.find(v=>v.isCurrent);if(u?.disabled)throw new y.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(v){throw new y.UserDataAutoSyncError((0,D.toErrorMessage)(v),v instanceof y.UserDataSyncError?v.code:"Unknown")}this.g&&this.g.session!==a&&this.s.store(p,this.g.session,-1,1),!o.isCancellationRequested&&(u||await this.p.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}c.a="Interval"}),define(oe[275],ae([0,1,8,182,15,14,45,20,29,26,18,41,123,122,121,16,124,119,120,4,125,43]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class Ve{constructor(t,s,o,a,r,u,v,C,T,N){this.e=t,this.f=s,this.g=o,this.h=r,this.i=u,this.j=v,this.k=C,this.l=T,this.m=N,this.d=a.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const s=this.K(t.content,"profiles");return(0,w.parseUserDataProfilesManifest)(s)}return[]}async getRemoteSyncResourceHandles(t,s){return(await this.e.getAllResourceRefs(t,s?.collection)).map(({created:a,ref:r})=>({created:a,uri:this.I({remote:!0,syncResource:t,profile:s?.id??this.k.defaultProfile.id,collection:s?.collection,ref:r,node:void 0})}))}async getLocalSyncResourceHandles(t,s){return(await this.f.getAllRefs(s,t)).map(({created:a,ref:r})=>({created:a,uri:this.I({remote:!1,syncResource:t,profile:s.id,collection:void 0,ref:r,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const s=this.J(t),o=s?this.k.profiles.find(a=>a.id===s.profile):void 0;return s&&o?{profile:o,syncResource:s?.syncResource}:void 0}async getAssociatedResources({uri:t}){const s=this.J(t);if(!s)return[];const o=this.k.profiles.find(a=>a.id===s.profile);switch(s.syncResource){case"settings":return this.r(t,o);case"keybindings":return this.t(t,o);case"tasks":return this.v(t,o);case"snippets":return this.x(t,o);case"globalState":return this.C(t,o);case"extensions":return this.z(t,o);case"profiles":return this.F(t,o)}}async getMachineId({uri:t}){const s=this.J(t);if(!!s){if(s.remote){if(s.ref){const{content:o}=await this.L(s.syncResource,s.ref,s.collection);if(o)return this.K(o,s.syncResource)?.machineId}return}return(0,O.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const s=this.J(t);if(!s||s.node===Ve.a)return null;if(s.ref){const o=await this.n(s.remote,s.syncResource,s.profile,s.collection,s.ref);return s.node&&o?this.o(s.syncResource,o,s.node):o}return!s.remote&&!s.node?this.q(s.syncResource,s.profile):null}async n(t,s,o,a,r){if(t){const{content:v}=await this.L(s,r,a);return v}const u=this.k.profiles.find(v=>v.id===o);return u?this.f.resolveContent(u,s,r):null}o(t,s,o){const a=this.K(s,t);switch(t){case"settings":return this.s(a,o);case"keybindings":return this.u(a,o);case"tasks":return this.w(a,o);case"snippets":return this.y(a,o);case"globalState":return this.D(a,o);case"extensions":return this.A(a,o);case"profiles":return this.G(a,o)}}async q(t,s){const o=this.k.profiles.find(a=>a.id===s);if(!o)return null;switch(t){case"globalState":return this.E(o);case"extensions":return this.B(o);case"profiles":return this.H(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,s){const o=this.d.joinPath(t,"settings.json"),a=s?s.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:a}]}s(t,s){switch(s){case"settings.json":return(0,m.parseSettingsSyncContent)(t.content).settings}return null}t(t,s){const o=this.d.joinPath(t,"keybindings.json"),a=s?s.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:a}]}u(t,s){switch(s){case"keybindings.json":return(0,h.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,s){const o=this.d.joinPath(t,"tasks.json"),a=s?s.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:a}]}w(t,s){switch(s){case"tasks.json":return(0,f.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,s){const o=await this.resolveContent(t);if(o){const a=this.K(o,"snippets");if(a){const r=(0,g.parseSnippets)(a),u=[];for(const v of Object.keys(r)){const C=this.d.joinPath(t,v),T=s?this.d.joinPath(s.snippetsHome,v):this.d.joinPath(t,Ve.a);u.push({resource:C,comparableResource:T})}return u}}return[]}y(t,s){return(0,g.parseSnippets)(t)[s]||null}z(t,s){const o=this.d.joinPath(t,"extensions.json"),a=s?this.I({remote:!1,syncResource:"extensions",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:a}]}A(t,s){switch(s){case"extensions.json":return(0,l.stringify)((0,l.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:s}=await this.m.createInstance(l.LocalExtensionsProvider).getLocalExtensions(t);return(0,l.stringify)(s,!0)}C(t,s){const o=this.d.joinPath(t,"globalState.json"),a=s?this.I({remote:!1,syncResource:"globalState",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:a}]}D(t,s){switch(s){case"globalState.json":return(0,d.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const s=await this.m.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,d.stringify)(s,!0)}F(t,s){const o=this.d.joinPath(t,"profiles.json"),a=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:a}]}G(t,s){switch(s){case"profiles.json":return(0,I.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,w.stringifyLocalProfiles)(this.k.profiles.filter(s=>!s.isDefault&&!s.isTransient),!0)}I(t){const s=t.remote?Ve.b:Ve.c,o=[t.syncResource,t.profile];return t.collection&&o.push(`collection:${t.collection}`),t.ref&&o.push(`ref:${t.ref}`),t.node&&o.push(t.node),this.d.joinPath(k.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:s,path:"/"}),...o)}J(t){if(t.scheme!==S.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const s=[];for(;t.path!=="/";)s.unshift(this.d.basename(t)),t=this.d.dirname(t);if(s.length<2)return;const o=t.authority===Ve.b,a=s.shift(),r=s.shift();let u,v,C;for(;s.length;){const T=s.shift();T.startsWith("collection:")?u=T.substring(11):T.startsWith("ref:")?v=T.substring(4):C=T}return{remote:o,syncResource:a,profile:r,collection:u,ref:v,node:C}}K(t,s){try{const o=JSON.parse(t);if((0,b.isSyncData)(o))return o}catch(o){this.g.error(o)}throw new S.UserDataSyncError((0,i.localize)(0,null),"IncompatibleRemoteContent",s)}async L(t,s,o){const a=await this.e.resolveResourceContent(t,s,o);return{ref:s,content:a}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",n=ye([K(0,S.IUserDataSyncStoreService),K(1,S.IUserDataSyncBackupStoreService),K(2,S.IUserDataSyncLogService),K(3,P.IUriIdentityService),K(4,D.IEnvironmentService),K(5,R.IStorageService),K(6,A.IFileService),K(7,E.IUserDataProfilesService),K(8,y.IConfigurationService),K(9,p.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(oe[276],ae([0,1,21,6,23,38,3,2,22,13,31,16,30,4,20,19,18,119,120,121,122,123,124,125,26]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p,w,I,n,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let o=class extends R.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(C,T,N,F,j,L,$,z,H){super(),this.v=C,this.w=T,this.y=N,this.z=F,this.C=j,this.D=L,this.F=$,this.G=z,this.H=H,this.f="uninitialized",this.g=this.B(new O.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new O.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new O.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new O.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new O.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new O.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=T.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(s,-1,void 0),this.B((0,R.toDisposable)(()=>this.W()))}async createSyncTask(C,T){this.X(),this.z.info("Sync started.");const N=new Date().getTime(),F=(0,E.generateUuid)();try{const z=(0,t.createSyncHeaders)(F);T&&(z["Cache-Control"]="no-cache"),C=await this.v.manifest(C,z)}catch(z){const H=t.UserDataSyncError.toUserDataSyncError(z);throw u(H,F,this.w,this.C),H}const j=!1,L=this;let $;return{manifest:C,async run(){if(j)throw new Error("Can run a task only once");$=(0,i.createCancelablePromise)(z=>L.I(C,!1,F,z)),await $.finally(()=>$=void 0),L.z.info(`Sync done. Took ${new Date().getTime()-N}ms`),L.S()},stop(){return $?.cancel(),L.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const C=new Date().getTime(),T=(0,E.generateUuid)(),N=(0,t.createSyncHeaders)(T);let F;try{F=await this.v.manifest(null,N)}catch($){const z=t.UserDataSyncError.toUserDataSyncError($);throw u(z,T,this.w,this.C),z}await this.resetLocal();const j=this,L=new D.CancellationTokenSource;return{id:T,async merge(){return j.I(F,!0,T,L.token)},async apply(){try{try{await j.L(F,T,L.token)}catch($){if(t.UserDataSyncError.toUserDataSyncError($).code==="MethodNotFound")j.z.info("Client is making invalid requests. Cleaning up data..."),await j.cleanUpRemoteData(),j.z.info("Applying manual sync again..."),await j.L(F,T,L.token);else throw $}}catch($){throw j.z.error($),$}j.z.info(`Sync done. Took ${new Date().getTime()-C}ms`),j.S()},async stop(){L.cancel(),await j.N(),await j.resetLocal()}}}async I(C,T,N,F){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const j=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(j,C,T,N,F));const L=j.enabled.find($=>$.resource==="profiles");if(L){const $=await L.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.J($,C,T,N,F)}}finally{this.l.fire(this.k)}}async J(C,T,N,F,j){for(const L of C){if(j.isCancellationRequested)return;const $=this.G.profiles.find(H=>H.id===L.id);if(!$){this.z.error(`Profile with id:${L.id} and name: ${L.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",L.name);const z=this.getOrCreateActiveProfileSynchronizer($,L);this.k.push(...await this.M(z,T,N,F,j))}for(const[L,$]of this.u.entries())this.G.profiles.some(z=>z.id===$[0].profile.id)||($[1].dispose(),this.u.delete(L))}async L(C,T,N){const F=this.U();for(const H of F){if(N.isCancellationRequested)return;await H.apply(T,N)}const j=F.find(H=>H.profile.isDefault);if(!j)return;const L=j.enabled.find(H=>H.resource==="profiles");if(!L)return;const z=(await L.getRemoteSyncedProfiles(C?.latest??null)||[]).filter(H=>F.every(X=>X.profile.id!==H.id));z.length&&await this.J(z,C,!1,T,N)}async M(C,T,N,F,j){return(await C.sync(T,N,F,j)).map(([$,z])=>({profile:C.profile,syncResource:$,error:z}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(C=>C.stop()))}async resolveContent(C){const T=await this.H.resolveContent(C);if(T)return T;for(const N of this.U())for(const F of N.enabled){const j=await F.resolveContent(C);if(j)return j}return null}async replace(C){this.X();const T=this.H.resolveUserDataSyncResource(C);if(!T)return;const N=await this.resolveContent(C.uri);!N||await this.O(T.profile,async F=>{if(T.syncResource===F.resource)return await F.replace(N),!0})}async accept(C,T,N,F){this.X(),await this.O(C.profile,async j=>{if(C.syncResource===j.resource)return await j.accept(T,N),F&&await j.apply((0,S.isBoolean)(F)?!1:F.force,(0,t.createSyncHeaders)((0,E.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(C,T){return this.H.getRemoteSyncResourceHandles(C,T)}async getLocalSyncResourceHandles(C,T){return this.H.getLocalSyncResourceHandles(C,T??this.G.defaultProfile)}async getAssociatedResources(C){return this.H.getAssociatedResources(C)}async getMachineId(C){return this.H.getMachineId(C)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async T=>{if(T.resource!=="globalState"&&await T.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async T=>{if(await T.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(C){this.z.error(C)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(s,-1);for(const[C]of this.u.values())try{await C.resetLocal()}catch(T){this.z.error(T)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const C=await this.H.getRemoteSyncedProfiles(),T=C.map(L=>L.collection),N=await this.v.getAllCollections(),F=N.filter(L=>!T.includes(L));F.length&&(this.z.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(L=>this.v.deleteCollection(L))),this.z.info("Deleted redundant collections on server"));const j=C.filter(L=>N.includes(L.collection));if(j.length!==C.length){this.z.info("Updating remote profiles with invalid collections on server");const L=this.y.createInstance(c.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await L.updateRemoteProfiles(j,null),this.z.info("Updated remote profiles on server")}finally{L.dispose()}}}async O(C,T){const N=new R.DisposableStore;try{const F=this.u.get(C.id);if(F){const H=await this.P(F[0],T,N);return(0,S.isUndefined)(H)?null:H}if(C.isDefault){const H=N.add(this.y.createInstance(a,C,void 0)),X=await this.P(H,T,N);return(0,S.isUndefined)(X)?null:X}if(this.G.isEnabled())return null;const j=N.add(this.y.createInstance(c.UserDataProfilesManifestSynchroniser,C,void 0)),L=await this.v.manifest(null),z=(await j.getRemoteSyncedProfiles(L?.latest??null)||[]).find(H=>H.id===C.id);if(z){const H=N.add(this.y.createInstance(a,C,z.collection)),X=await this.P(H,T,N);return(0,S.isUndefined)(X)?null:X}return null}finally{N.dispose()}}async P(C,T,N){const F=[...C.enabled,...C.disabled.map(j=>N.add(C.createSynchronizer(j)))];for(const j of F){const L=await T(j);if(!(0,S.isUndefined)(L))return L}}Q(C){const T=this.f;this.f!==C&&(this.f=C,this.g.fire(C),T==="hasConflicts"&&this.S())}R(){const C=this.U().map(T=>T.conflicts).flat();(0,k.equals)(this.i,C,(T,N)=>T.profile.id===N.profile.id&&T.syncResource===N.syncResource&&(0,k.equals)(T.conflicts,N.conflicts,(F,j)=>(0,P.isEqual)(F.previewResource,j.previewResource)))||(this.i=C,this.j.fire(C))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(s,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(C,T){let N=this.u.get(C.id);if(N&&N[0].collection!==T?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.u.delete(C.id)),!N){const F=new R.DisposableStore,j=F.add(this.y.createInstance(a,C,T?.collection));F.add(j.onDidChangeStatus(L=>this.Q(L))),F.add(j.onDidChangeConflicts(L=>this.R())),F.add(j.onDidChangeLocal(L=>this.h.fire(L))),this.u.set(C.id,N=[j,F])}return N[0]}U(){const C=[];for(const[T]of this.u.values())C.push(T);return C}W(){this.u.forEach(([,C])=>C.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};o=ye([K(0,t.IUserDataSyncStoreService),K(1,t.IUserDataSyncStoreManagementService),K(2,m.IInstantiationService),K(3,t.IUserDataSyncLogService),K(4,y.ITelemetryService),K(5,h.IStorageService),K(6,t.IUserDataSyncEnablementService),K(7,f.IUserDataProfilesService),K(8,t.IUserDataSyncResourceProviderService)],o),e.UserDataSyncService=o;let a=class extends R.Disposable{get enabled(){return this.f.sort((C,T)=>C[1]-T[1]).map(([C])=>C)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(C=>!this.l.isResourceEnabled(C))}get status(){return this.g}get conflicts(){return this.j}constructor(C,T,N,F,j,L,$,z,H,X){super(),this.profile=C,this.collection=T,this.l=N,this.m=F,this.n=j,this.r=L,this.t=$,this.u=z,this.v=H,this.w=X,this.f=[],this.g="idle",this.h=this.B(new O.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new O.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new O.Emitter),this.onDidChangeConflicts=this.k.event,this.B(N.onDidChangeResourceEnablement(([ie,G])=>this.y(ie,G))),this.B((0,R.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of t.ALL_SYNC_RESOURCES)N.isResourceEnabled(ie)&&this.z(ie)}y(C,T){T?this.z(C):this.C(C)}z(C){if(this.f.some(([j])=>j.resource===C))return;if(C==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(C==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const T=new R.DisposableStore,N=T.add(this.createSynchronizer(C));T.add(N.onDidChangeStatus(()=>this.G())),T.add(N.onDidChangeConflicts(()=>this.H())),T.add(N.onDidChangeLocal(()=>this.i.fire(C)));const F=this.I(C);this.f.push([N,F,T])}C(C){const T=this.f.findIndex(([N])=>N.resource===C);if(T!==-1){const[[N,,F]]=this.f.splice(T,1);F.dispose(),this.G(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,j=>this.u.error(j))}}createSynchronizer(C){switch(C){case"settings":return this.m.createInstance(w.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(p.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(I.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(d.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(l.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(c.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(C,T,N,F){if(F.isCancellationRequested)return[];const j=this.enabled;if(!j.length)return[];try{const L=[],$=(0,t.createSyncHeaders)(N),z=(this.collection?C?.collections?.[this.collection]?.latest:C?.latest)??null,H=T?await this.D(z):{};for(const X of j){if(F.isCancellationRequested)return[];if(!this.l.isResourceEnabled(X.resource))return[];try{if(T){const ie=await X.preview(z,H,$);if(ie)for(const G of ie.resourcePreviews)(G.localChange!==0||G.remoteChange!==0)&&G.mergeState==="preview"&&await X.merge(G.previewResource)}else await X.sync(z,$)}catch(ie){const G=t.UserDataSyncError.toUserDataSyncError(ie);if(u(G,N,this.r,this.t),r(ie))throw G;this.u.error(ie),this.u.error(`${X.resource}: ${(0,A.toErrorMessage)(ie)}`),L.push([X.resource,G])}}return L}finally{this.G()}}async apply(C,T){const N=(0,t.createSyncHeaders)(C);for(const F of this.enabled){if(T.isCancellationRequested)return;try{await F.apply(!1,N)}catch(j){const L=t.UserDataSyncError.toUserDataSyncError(j);if(u(L,C,this.r,this.t),r(j))throw L;this.u.error(j),this.u.error(`${F.resource}: ${(0,A.toErrorMessage)(j)}`)}}}async stop(){for(const C of this.enabled)try{C.status!=="idle"&&await C.stop()}catch(T){this.u.error(T)}}async resetLocal(){for(const C of this.enabled)try{await C.resetLocal()}catch(T){this.u.error(`${C.resource}: ${(0,A.toErrorMessage)(T)}`),this.u.error(T)}}async D(C){if(!this.profile.isDefault)return{};const T=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),N=this.enabled.find(F=>F instanceof w.SettingsSynchroniser);if(N){const F=await N.getRemoteUserDataSyncConfiguration(C);return{...T,...F}}return T}F(C){this.g!==C&&(this.g=C,this.h.fire(C))}G(){return this.H(),this.enabled.some(C=>C.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(C=>C.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const C=this.enabled.filter(T=>T.status==="hasConflicts").filter(T=>T.conflicts.conflicts.length>0).map(T=>T.conflicts);(0,k.equals)(this.j,C,(T,N)=>T.syncResource===N.syncResource&&(0,k.equals)(T.conflicts,N.conflicts,(F,j)=>(0,P.isEqual)(F.previewResource,j.previewResource)))||(this.j=C,this.k.fire(C))}I(C){switch(C){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};a=ye([K(2,t.IUserDataSyncEnablementService),K(3,m.IInstantiationService),K(4,g.IExtensionGalleryService),K(5,t.IUserDataSyncStoreManagementService),K(6,y.ITelemetryService),K(7,t.IUserDataSyncLogService),K(8,f.IUserDataProfilesService),K(9,b.IConfigurationService)],a);function r(v){if(v instanceof t.UserDataSyncError)switch(v.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function u(v,C,T,N){N.publicLog2("sync/error",{code:v.code,serverCode:v instanceof t.UserDataSyncStoreError?String(v.serverCode):void 0,url:v instanceof t.UserDataSyncStoreError?v.url:void 0,resource:v.resource,executionId:C,service:T.userDataSyncStore.url.toString()})}}),define(oe[277],ae([0,1,3,2,8,18,26]),function(Z,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(g,m){return{...g,profile:(0,A.reviveProfile)(g.profile,m.profilesHome.scheme)}}function P(g){return{created:g.created,uri:D.URI.revive(g.uri)}}class S{constructor(m,h,y){this.c=m,this.d=h,this.f=y,this.a=new Map,this.b=new k.Emitter}listen(m,h){switch(h){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${h}`)}async call(m,h,y){try{return await this.g(m,h,y)}catch(f){throw this.f.error(f),f}}async g(m,h,y){switch(h){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(y[0]));case"accept":return this.c.accept(R(y[0],this.d),D.URI.revive(y[1]),y[2],y[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(y[0],(0,A.reviveProfile)(y[1],this.d.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(y[0],y[1]);case"replace":return this.c.replace(P(y[0]));case"getAssociatedResources":return this.c.getAssociatedResources(P(y[0]));case"getMachineId":return this.c.getMachineId(P(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(h.startsWith("manualSync/")){const f=h.substring(11),l=y[0],d=this.h(l);switch(y=y.slice(1),f){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(m){const h=this.a.get(this.j(m));if(!h)throw new Error(`Manual sync taks not found: ${m}`);return h}async i(){const m=await this.c.createManualSyncTask();return this.a.set(this.j(m.id),m),m.id}j(m){return`manualSyncTask-${m}`}}e.UserDataSyncChannel=S;let E=class extends i.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(m,h){super(),this.k=h,this.b="uninitialized",this.c=this.B(new k.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new k.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new k.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new k.Emitter),this.onSyncErrors=this.j.event,this.a={call(y,f,l){return m.call(y,f,l).then(null,d=>{throw O.UserDataSyncError.toUserDataSyncError(d)})},listen(y,f){return m.listen(y,f)}},this.a.call("_getInitialData").then(([y,f,l])=>{this.l(y),this.m(f),l&&this.n(l),this.B(this.a.listen("onDidChangeStatus")(d=>this.l(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.n(d)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.m(y))),this.B(this.a.listen("onSyncErrors")(y=>this.j.fire(y.map(f=>({...f,error:O.UserDataSyncError.toUserDataSyncError(f.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const m=await this.a.call("createManualSyncTask"),h=this;return new b(m,{async call(f,l,d){return h.a.call(`manualSync/${f}`,[m,...Array.isArray(l)?l:[l]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(m,h,y,f){return this.a.call("accept",[m,h,y,f])}resolveContent(m){return this.a.call("resolveContent",[m])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(m,h){return(await this.a.call("getLocalSyncResourceHandles",[m,h])).map(({created:f,uri:l})=>({created:f,uri:D.URI.revive(l)}))}async getRemoteSyncResourceHandles(m,h){return(await this.a.call("getRemoteSyncResourceHandles",[m,h])).map(({created:f,uri:l})=>({created:f,uri:D.URI.revive(l)}))}async getAssociatedResources(m){return(await this.a.call("getAssociatedResources",[m])).map(({resource:y,comparableResource:f})=>({resource:D.URI.revive(y),comparableResource:D.URI.revive(f)}))}getMachineId(m){return this.a.call("getMachineId",[m])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(m){return this.a.call("replace",[m])}async l(m){this.b=m,this.c.fire(m)}async m(m){this.f=m.map(h=>({syncResource:h.syncResource,profile:(0,A.reviveProfile)(h.profile,this.k.profilesHome.scheme),conflicts:h.conflicts.map(y=>({...y,baseResource:D.URI.revive(y.baseResource),localResource:D.URI.revive(y.localResource),remoteResource:D.URI.revive(y.remoteResource),previewResource:D.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}n(m){this.h!==m&&(this.h=m,this.i.fire(m))}};E=ye([K(1,A.IUserDataProfilesService)],E),e.UserDataSyncChannelClient=E;class b extends i.Disposable{constructor(m,h){super(),this.id=m,this.a=h}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[278],ae([0,1,6,23,7,3,2,141,5,22,13,8,31,16,15,14,25,60,45,20,26]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const I="sync.previous.store",n="sync.donot-make-requests-until",c="sync.user-session-id",t="sync.machine-session-id",s=100,o=1e3*60*5;let a=class extends O.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(w.SYNC_SERVICE_URL_TYPE,-1)}set c(N){this.h.store(w.SYNC_SERVICE_URL_TYPE,N,-1,P.isWeb?0:1)}constructor(N,F,j){super(),this.f=N,this.g=F,this.h=j,this.a=this.B(new A.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(A.Event.filter(j.onDidChangeValue,L=>L.key===w.SYNC_SERVICE_URL_TYPE&&L.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[w.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(w.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(N,F){N=P.isWeb&&N?.web?{...N,...N.web}:N;const j={...N||{},...F||{}};if(j&&(0,E.isString)(j.url)&&(0,E.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(L=>Array.isArray(j.authenticationProviders[L].scopes))){const L=j,$=!!L.canSwitch&&!F?.url,z=L.url===L.insidersUrl?"insiders":"stable",H=($?this.c:void 0)||z,X=F?.url||(H==="insiders"?L.insidersUrl:H==="stable"?L.stableUrl:L.url);return{url:b.URI.parse(X),type:H,defaultType:z,defaultUrl:b.URI.parse(L.url),stableUrl:b.URI.parse(L.stableUrl),insidersUrl:b.URI.parse(L.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(L.authenticationProviders).reduce((ie,G)=>(ie.push({id:G,scopes:L.authenticationProviders[G].scopes}),ie),[])}}}};a=ye([K(0,f.IProductService),K(1,m.IConfigurationService),K(2,p.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let r=class extends a{constructor(N,F,j){super(N,F,j);const L=this.h.get(I,-1);L&&(this.k=JSON.parse(L));const $=this.f[w.CONFIGURATION_SYNC_STORE_KEY];$?this.h.store(I,JSON.stringify($),-1,1):this.h.remove(I,-1)}async switch(N){N!==this.c&&(this.c=N,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};r=ye([K(0,f.IProductService),K(1,m.IConfigurationService),K(2,p.IStorageService)],r),e.UserDataSyncStoreManagementService=r;let u=class extends O.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(N,F,j,L,$,z,H){super(),this.k=j,this.l=L,this.n=H,this.g=this.B(new A.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new A.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(N),this.c=(0,d.getServiceMachineId)($,z,H).then(X=>{const ie={"X-Client-Name":`${F.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(ie["X-Client-Commit"]=F.commit),ie}),this.f=new C(s,o,this.k,this.l),this.r(),this.B((0,O.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(N,F){this.b={token:N,type:F}}p(N){this.a=N?(0,S.joinPath)(N,"v1"):void 0}r(){const N=this.n.getNumber(n,-1);N&&Date.now()<N&&this.t(new Date(N))}t(N){this.i?.getTime()!==N?.getTime()&&(this.i=N,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(n,this.i.getTime(),-1,1),this.s=(0,k.createCancelablePromise)(F=>(0,k.timeout)(this.i.getTime()-Date.now(),F).then(()=>this.t(void 0))),this.s.then(null,F=>null)):this.n.remove(n,-1),this.j.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const j=await this.w(F,{type:"GET",headers:N},[],i.CancellationToken.None);return(await(0,l.asJson)(j))?.map(({id:L})=>L)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.a,"collection").toString();N={...N},N["Content-Type"]=R.Mimes.text;const j=await this.w(F,{type:"POST",headers:N},[],i.CancellationToken.None),L=await(0,l.asTextOrError)(j);if(!L)throw new w.UserDataSyncStoreError("Server did not return the collection id",F,"NoCollection",j.res.statusCode,j.res.headers[w.HEADER_OPERATION_ID]);return L}async deleteCollection(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=N?(0,S.joinPath)(this.a,"collection",N).toString():(0,S.joinPath)(this.a,"collection").toString();F={...F},await this.w(j,{type:"DELETE",headers:F},[],i.CancellationToken.None)}async getAllResourceRefs(N,F){if(!this.a)throw new Error("No settings sync store url configured.");const j=this.u(this.a,F,N),L={},$=await this.w(j.toString(),{type:"GET",headers:L},[],i.CancellationToken.None);return(await(0,l.asJson)($)||[]).map(({url:H,created:X})=>({ref:(0,S.relativePath)(j,j.with({path:H})),created:X*1e3}))}async resolveResourceContent(N,F,j,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,S.joinPath)(this.u(this.a,j,N),F).toString();L={...L},L["Cache-Control"]="no-cache";const z=await this.w($,{type:"GET",headers:L},[],i.CancellationToken.None);return await(0,l.asTextOrError)(z)}async deleteResource(N,F,j){if(!this.a)throw new Error("No settings sync store url configured.");const L=F!==null?(0,S.joinPath)(this.u(this.a,j,N),F).toString():this.u(this.a,j,N).toString(),$={};await this.w(L,{type:"DELETE",headers:$},[],i.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,S.joinPath)(this.a,"resource").toString(),F={"Content-Type":R.Mimes.text};await this.w(N,{type:"DELETE",headers:F},[],i.CancellationToken.None)}async readResource(N,F,j,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=(0,S.joinPath)(this.u(this.a,j,N),"latest").toString();L={...L},L["Cache-Control"]="no-cache",F&&(L["If-None-Match"]=F.ref);const z=await this.w($,{type:"GET",headers:L},[304],i.CancellationToken.None);let H=null;if(z.res.statusCode===304&&(H=F),H===null){const X=z.res.headers.etag;if(!X)throw new w.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",z.res.statusCode,z.res.headers[w.HEADER_OPERATION_ID]);const ie=await(0,l.asTextOrError)(z);if(!ie&&z.res.statusCode===304)throw new w.UserDataSyncStoreError("Empty response",$,"EmptyResponse",z.res.statusCode,z.res.headers[w.HEADER_OPERATION_ID]);H={ref:X,content:ie}}return H}async writeResource(N,F,j,L,$={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.u(this.a,L,N).toString();$={...$},$["Content-Type"]=R.Mimes.text,j&&($["If-Match"]=j);const H=await this.w(z,{type:"POST",data:F,headers:$},[],i.CancellationToken.None),X=H.res.headers.etag;if(!X)throw new w.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",H.res.statusCode,H.res.headers[w.HEADER_OPERATION_ID]);return X}async manifest(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,S.joinPath)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",N&&(F["If-None-Match"]=N.ref);const L=await this.w(j,{type:"GET",headers:F},[304],i.CancellationToken.None);let $=null;if(L.res.statusCode===304&&($=N),!$){const H=L.res.headers.etag;if(!H)throw new w.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",L.res.statusCode,L.res.headers[w.HEADER_OPERATION_ID]);const X=await(0,l.asTextOrError)(L);if(!X&&L.res.statusCode===304)throw new w.UserDataSyncStoreError("Empty response",j,"EmptyResponse",L.res.statusCode,L.res.headers[w.HEADER_OPERATION_ID]);X&&($={...JSON.parse(X),ref:H})}const z=this.n.get(c,-1);return z&&$&&z!==$.session&&this.v(),$===null&&z&&this.v(),$&&this.n.store(c,$.session,-1,1),$}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(N,F,j){return F?(0,S.joinPath)(N,"collection",F,"resource",j):(0,S.joinPath)(N,"resource",j)}v(){this.n.remove(c,-1),this.n.remove(t,-1)}async w(N,F,j,L){if(!this.b)throw new w.UserDataSyncStoreError("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const $=await this.c;F.headers={...F.headers||{},...$,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(F.headers),this.l.trace("Sending request to server",{url:N,type:F.type,headers:{...F.headers,authorization:void 0}});let z;try{z=await this.f.request(N,F,L)}catch(M){if(!(M instanceof w.UserDataSyncStoreError)){let V="RequestFailed";const x=(0,D.getErrorMessage)(M).toLowerCase();x.includes("xhr timeout")?V="RequestTimeout":x.includes("protocol")&&x.includes("not supported")?V="RequestProtocolNotSupported":x.includes("request path contains unescaped characters")?V="RequestPathNotEscaped":x.includes("headers must be an object")?V="RequestHeadersNotObject":(0,D.isCancellationError)(M)&&(V="RequestCanceled"),M=new w.UserDataSyncStoreError(`Connection refused for the request '${N}'.`,N,V,void 0,void 0)}throw this.l.info("Request failed",N),M}const H=z.res.headers[w.HEADER_OPERATION_ID],X={url:N,status:z.res.statusCode,"execution-id":F.headers[w.HEADER_EXECUTION_ID],"operation-id":H},ie=(0,l.isSuccess)(z)||z.res.statusCode&&j.indexOf(z.res.statusCode)!==-1;let G="";if(ie?this.l.trace("Request succeeded",X):(this.l.info("Request failed",X),G=await(0,l.asText)(z)||""),z.res.statusCode===401)throw this.b=void 0,this.g.fire(),new w.UserDataSyncStoreError(`Request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",z.res.statusCode,H);if(this.h.fire(),z.res.statusCode===404)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",z.res.statusCode,H);if(z.res.statusCode===405)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested endpoint is not found (405). ${G}`,N,"MethodNotFound",z.res.statusCode,H);if(z.res.statusCode===409)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",z.res.statusCode,H);if(z.res.statusCode===410)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",z.res.statusCode,H);if(z.res.statusCode===412)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",z.res.statusCode,H);if(z.res.statusCode===413)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",z.res.statusCode,H);if(z.res.statusCode===426)throw new w.UserDataSyncStoreError(`${F.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",z.res.statusCode,H);if(z.res.statusCode===429){const M=z.res.headers["retry-after"];throw M?(this.t(new Date(Date.now()+parseInt(M)*1e3)),new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",z.res.statusCode,H)):new w.UserDataSyncStoreError(`${F.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",z.res.statusCode,H)}if(!ie)throw new w.UserDataSyncStoreError("Server returned "+z.res.statusCode,N,"Unknown",z.res.statusCode,H);return z}y(N){let F=this.n.get(t,-1);F===void 0&&(F=(0,g.generateUuid)(),this.n.store(t,F,-1,1)),N["X-Machine-Session-Id"]=F;const j=this.n.get(c,-1);j!==void 0&&(N["X-User-Session-Id"]=j)}};u=ye([K(1,f.IProductService),K(2,l.IRequestService),K(3,w.IUserDataSyncLogService),K(4,h.IEnvironmentService),K(5,y.IFileService),K(6,p.IStorageService)],u),e.UserDataSyncStoreClient=u;let v=class extends u{constructor(N,F,j,L,$,z,H){super(N.userDataSyncStore?.url,F,j,L,$,z,H),this.B(N.onDidChangeUserDataSyncStore(()=>this.p(N.userDataSyncStore?.url)))}};v=ye([K(0,w.IUserDataSyncStoreManagementService),K(1,f.IProductService),K(2,l.IRequestService),K(3,w.IUserDataSyncLogService),K(4,h.IEnvironmentService),K(5,y.IFileService),K(6,p.IStorageService)],v),e.UserDataSyncStoreService=v;class C{constructor(N,F,j,L){this.c=N,this.d=F,this.f=j,this.g=L,this.a=[],this.b=void 0}request(N,F,j){if(this.h()&&this.i(),F.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new w.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(F,j)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=C}),define(oe[279],ae([0,1,3,58,25,20,19,274,26,78,81]),function(Z,e,k,i,D,A,O,R,P,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends R.UserDataAutoSyncService{constructor(m,h,y,f,l,d,p,w,I,n,c){super(m,h,y,f,l,p,w,I,n,c),this.B(k.Event.debounce(k.Event.any(k.Event.map(d.onDidFocusWindow,()=>"windowFocus"),k.Event.map(d.onDidOpenWindow,()=>"windowOpen")),(t,s)=>t?[...t,s]:[s],1e3)(t=>this.triggerSync(t,!0,!1)))}};b=ye([K(0,D.IProductService),K(1,P.IUserDataSyncStoreManagementService),K(2,P.IUserDataSyncStoreService),K(3,P.IUserDataSyncEnablementService),K(4,P.IUserDataSyncService),K(5,i.INativeHostService),K(6,P.IUserDataSyncLogService),K(7,S.IUserDataSyncAccountService),K(8,O.ITelemetryService),K(9,E.IUserDataSyncMachinesService),K(10,A.IStorageService)],b),e.UserDataAutoSyncService=b}),define(oe[280],ae([0,1,100,24,5,22]),function(Z,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function O(S){function E(){let b=S.scheme===i.Schemas.file?(0,A.originalFSPath)(S):S.toString();return D.isLinux||(b=b.toLowerCase()),(0,k.createHash)("md5").update(b).digest("hex")}return{id:E(),configPath:S}}e.getWorkspaceIdentifier=O;function R(S,E){function b(){if(S.scheme!==i.Schemas.file)return(0,k.createHash)("md5").update(S.toString()).digest("hex");if(!E)return;let m;return D.isLinux?m=E.ino:D.isMacintosh?m=E.birthtime.getTime():D.isWindows&&(typeof E.birthtimeMs=="number"?m=Math.floor(E.birthtimeMs):m=E.birthtime.getTime()),(0,k.createHash)("md5").update(S.fsPath).update(m?String(m):"").digest("hex")}const g=b();if(typeof g=="string")return{id:g,uri:S}}e.getSingleFolderWorkspaceIdentifier=R;function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=P}),define(oe[281],ae([0,1,6,7,2,12,28,15,57,9,58,76,117,280]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends D.Disposable{constructor(f,l,d,p){super(),this.a=f,this.b=l,this.c=d,this.f=p,this.B(new k.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=await O.Promises.readdir(this.a.workspaceStorageHome.fsPath),l=new b.StorageClient(this.f.getChannel("storage"));await Promise.all(f.map(async d=>{const p=(0,A.join)(this.a.workspaceStorageHome.fsPath,d);d.length===m.NON_EMPTY_WORKSPACE_ID_LENGTH||d===g.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(n=>n.workspace?.id===d)||await l.isUsed(p)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await O.Promises.rm(p))}))}catch(f){(0,i.onUnexpectedError)(f)}}};h=ye([K(0,R.INativeEnvironmentService),K(1,S.ILogService),K(2,E.INativeHostService),K(3,P.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(oe[126],ae([0,1,53,6,12,13,28,152,290,291]),function(Z,e,k,i,D,A,O,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class E extends Error{constructor(n,c){let t=c.message;switch(n){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=n,this.cause=c}}e.ExtractError=E;function b(I){const n=I.externalFileAttributes>>16||33188;return[448,56,7].map(c=>n&c).reduce((c,t)=>c+t,n&61440)}function g(I){if(I instanceof E)return I;let n;return/end of central directory record signature not found/.test(I.message)&&(n="CorruptZip"),new E(n,I)}function m(I,n,c,t,s,o){const a=D.dirname(n),r=D.join(t,a);if(!r.startsWith(t))return Promise.reject(new Error(R.localize(0,null,n)));const u=D.join(t,n);let v;return o.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(O.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((C,T)=>{if(!o.isCancellationRequested)try{v=(0,k.createWriteStream)(u,{mode:c}),v.once("close",()=>C()),v.once("error",T),I.once("error",T),I.pipe(v)}catch(N){T(N)}}))}function h(I,n,c,t){let s=(0,i.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{s.cancel(),I.close()}),new Promise((a,r)=>{const u=new i.Sequencer,v=C=>{C.isCancellationRequested||(o++,I.readEntry())};I.once("error",r),I.once("close",()=>s.then(()=>{t.isCancellationRequested||I.entryCount===o?a():r(new E("Incomplete",new Error(R.localize(1,null,o,I.entryCount))))},r)),I.readEntry(),I.on("entry",C=>{if(t.isCancellationRequested)return;if(!c.sourcePathRegex.test(C.fileName)){v(t);return}const T=C.fileName.replace(c.sourcePathRegex,"");if(/\/$/.test(T)){const j=D.join(n,T);s=(0,i.createCancelablePromise)(L=>O.Promises.mkdir(j,{recursive:!0}).then(()=>v(L)).then(void 0,r));return}const N=f(I,C),F=b(C);s=(0,i.createCancelablePromise)(j=>u.queue(()=>N.then(L=>m(L,T,F,n,c,j).then(()=>v(j)))).then(null,r))})})}function y(I,n=!1){return new Promise((c,t)=>{(0,P.open)(I,n?{lazyEntries:!0}:void 0,(s,o)=>{s?t(g(s)):c((0,A.assertIsDefined)(o))})})}function f(I,n){return new Promise((c,t)=>{I.openReadStream(n,(s,o)=>{s?t(g(s)):c((0,A.assertIsDefined)(o))})})}function l(I,n){return new Promise((c,t)=>{const s=new S.ZipFile;n.forEach(a=>{a.contents?s.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&s.addFile(a.localPath,a.path)}),s.end();const o=(0,k.createWriteStream)(I);s.outputStream.pipe(o),s.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>c(I))})}e.zip=l;function d(I,n,c={},t){const s=new RegExp(c.sourcePath?`^${c.sourcePath}`:"");let o=y(I,!0);return c.overwrite&&(o=o.then(a=>O.Promises.rm(n).then(()=>a))),o.then(a=>h(a,n,{sourcePathRegex:s},t))}e.extract=d;function p(I,n){return y(I).then(c=>new Promise((t,s)=>{c.on("entry",o=>{o.fileName===n&&f(c,o).then(a=>t(a),a=>s(a))}),c.once("close",()=>s(new Error(R.localize(2,null,n))))}))}function w(I,n){return p(I,n).then(c=>new Promise((t,s)=>{const o=[];c.once("error",s),c.on("data",a=>o.push(a)),c.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=w}),define(oe[282],ae([0,1,126,162]),function(Z,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(A){return(0,k.buffer)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=D}),define(oe[127],ae([0,1,6,23,38,7,3,2,37,24,12,5,22,54,13,8,31,28,126,161,97,15,263,30,33,51,79,234,265,282,218,235,42,70,14,4,9,25,19,29,18]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p,w,I,n,c,t,s,o,a,r,u,v,C,T,N,F,j,L,$,z,H,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,j.refineServiceDecorator)(c.IExtensionManagementService);let ie=class extends n.AbstractExtensionManagementService{constructor(U,B,W,q,J,_,Y,Q,se,le,ue,pe){super(U,B,W,le,pe),this.Y=J,this.Z=_,this.ab=Y,this.bb=se,this.cb=ue,this.X=new Map,this.kb=new P.ResourceSet;const we=this.B(Q.createInstance(r.ExtensionsLifecycle));this.S=this.B(Q.createInstance(G,Ee=>we.postUninstall(Ee))),this.U=this.B(new v.ExtensionsManifestCache(q,this)),this.W=this.B(Q.createInstance(a.ExtensionsDownloader));const be=this.B(new C.ExtensionsWatcher(this,this.Y,pe,_,ue,se,W));this.B(be.onDidChangeExtensionsByAnotherSource(Ee=>this.jb(Ee))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,t.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(U){this.v.trace("ExtensionManagementService#zip",U.identifier.id);const B=await this.ib(U),W=await(0,d.zip)((0,g.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,B);return y.URI.file(W)}async unzip(U){return this.v.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:B,cleanup:W}=await this.eb(U),q=E.resolve(B.fsPath);try{return await(0,u.getManifest)(q)}finally{await W()}}getInstalled(U,B){return this.S.scanExtensions(U??null,B)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(U,B={}){this.v.trace("ExtensionManagementService#install",U.toString());const{location:W,cleanup:q}=await this.eb(U);try{const J=await(0,u.getManifest)(E.resolve(W.fsPath));if(J.engines&&J.engines.vscode&&!(0,N.isEngineValid)(J.engines.vscode,this.w.version,this.w.date))throw new Error(p.localize(0,null,(0,t.getGalleryExtensionId)(J.publisher,J.name),this.w.version));return await this.z(J,W,B)}finally{await q()}}async installFromLocation(U,B){this.v.trace("ExtensionManagementService#installFromLocation",U.toString());const W=await this.S.scanUserExtensionAtLocation(U);if(!W)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.nb([W],B),this.v.info("Successfully installed extension",W.identifier.id,B.toString()),W}getMetadata(U){return this.Y.scanMetadata(U.location)}async updateMetadata(U,B){this.v.trace("ExtensionManagementService#updateMetadata",U.identifier.id);const W={...B};return B.isPreReleaseVersion&&(W.preRelease=!0),U=await this.S.updateMetadata(U,W),this.U.invalidate(),U}async updateExtensionScope(U,B){return this.v.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.S.updateMetadata(U,{isMachineScoped:B}),this.U.invalidate(),U}async reinstallFromGallery(U){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.t.isEnabled())throw new Error(p.localize(1,null));const B=await this.getTargetPlatform(),[W]=await this.t.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:B,compatible:!0},i.CancellationToken.None);if(!W)throw new Error(p.localize(2,null));await this.S.setUninstalled(U);try{await this.S.removeUninstalledExtension(U)}catch(q){throw new Error(p.localize(3,null,(0,D.toErrorMessage)(q)))}return this.installFromGallery(W)}markAsUninstalled(...U){return this.S.setUninstalled(...U)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(U,B){const{location:W}=await this.W.download(U,B);return W}async eb(U){if(U.scheme===S.Schemas.file)return{location:U,async cleanup(){}};this.v.trace("Downloading extension from",U.toString());const B=(0,g.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.ab.download(U,B),this.v.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.bb.del(B)}catch(q){this.v.error(q)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(U,B,W){let q;if(y.URI.isUri(B))q=new x(U,B,W,this.t,this.S,this.v);else{const J=t.ExtensionKey.create(B).toString();q=this.X.get(J),q||(this.X.set(J,q=new V(U,B,W,this.W,this.S,this.v)),q.waitUntilTaskIsFinished().then(()=>this.X.delete(J)))}return new ee(q,W.profileLocation,this.cb,this.y,this.Y,this.Z)}R(U,B){return new re(U,B.profileLocation,this.Z)}async ib(U){const B=async q=>{let J=await l.Promises.readdir(q);J=J.map(Q=>E.join(q,Q));const _=await Promise.all(J.map(Q=>l.Promises.stat(Q)));let Y=Promise.resolve([]);return _.forEach((Q,se)=>{const le=J[se];Q.isFile()&&(Y=Y.then(ue=>[...ue,le])),Q.isDirectory()&&(Y=Y.then(ue=>B(le).then(pe=>[...ue,...pe])))}),Y};return(await B(U.location.fsPath)).map(q=>({path:`extension/${E.relative(U.location.fsPath,q)}`,localPath:q}))}async jb({added:U,removed:B}){if(B)for(const W of B.extensions)this.v.info("Extensions removed from another source",W.id,B.profileLocation.toString()),this.p.fire({identifier:W,profileLocation:B.profileLocation});if(U){const q=(await this.S.scanExtensions(1,U.profileLocation)).filter(J=>U.extensions.some(_=>(0,t.areSameExtensions)(_,J.identifier)));this.m.fire(q.map(J=>(this.v.info("Extensions added from another source",J.identifier.id,U.profileLocation.toString()),{identifier:J.identifier,local:J,profileLocation:U.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(B=>this.kb.add(B)));const U=await this.bb.resolve(this.Y.userExtensionsLocation);for(const B of U.children??[])B.isDirectory&&this.kb.add(B.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(B=>this.mb(B)))}async mb(U){if(!U.affects(this.Y.userExtensionsLocation,1))return;const B=[];for(const W of U.rawAdded){if(this.kb.has(W)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(W),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(W,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(W).startsWith(".")||!(await this.bb.stat(W)).isDirectory)continue;const q=await this.S.scanUserExtensionAtLocation(W);q&&q.installedTimestamp===void 0&&(this.kb.add(W),B.push(q))}B.length&&(await this.nb(B,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",B.map(W=>W.identifier.id)))}async nb(U,B){await this.Z.addExtensionsToProfile(U.map(W=>[W,void 0]),B),this.m.fire(U.map(W=>({local:W,identifier:W.identifier,operation:1,profileLocation:B})))}};ie=ye([K(0,c.IExtensionGalleryService),K(1,z.ITelemetryService),K(2,L.ILogService),K(3,I.INativeEnvironmentService),K(4,o.IExtensionsScannerService),K(5,s.IExtensionsProfileScannerService),K(6,w.IDownloadService),K(7,j.IInstantiationService),K(8,F.IFileService),K(9,$.IProductService),K(10,H.IUriIdentityService),K(11,X.IUserDataProfilesService)],ie),e.ExtensionManagementService=ie;let G=class extends R.Disposable{constructor(U,B,W,q){super(),this.j=U,this.k=B,this.l=W,this.m=q,this.h=this.B(new O.Emitter),this.onExtract=this.h.event,this.c=(0,g.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new k.Queue}async cleanUp(){await this.v()}async scanExtensions(U,B){const W={includeInvalid:!0,profileLocation:B};let q=[];return U===null||U===0?q.push(...await this.l.scanAllExtensions({includeInvalid:!0},W,!1)):U===1&&q.push(...await this.l.scanUserExtensions(W)),q=U!==null?q.filter(J=>J.type===U):q,Promise.all(q.map(J=>this.u(J)))}async scanAllUserExtensions(U){const B=await this.l.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(B.map(W=>this.u(W)))}async scanUserExtensionAtLocation(U){try{const B=await this.l.scanExistingExtension(U,1,{includeInvalid:!0});if(B)return await this.u(B)}catch(B){this.m.error(B)}return null}async extractUserExtension(U,B,W,q){const J=U.toString(),_=E.join(this.l.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),Y=E.join(this.l.userExtensionsLocation.fsPath,J);try{await l.Promises.rm(Y)}catch{throw new c.ExtensionManagementError(p.localize(4,null,Y,U.id),c.ExtensionManagementErrorCode.Delete)}await this.p(U,B,_,q),await this.l.updateMetadata(y.URI.file(_),W);try{this.h.fire(y.URI.file(Y)),await this.s(U,_,Y,Date.now()+2*60*1e3),this.m.info("Renamed to",Y)}catch(Q){try{await l.Promises.rm(_)}catch{}if(Q.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.m.info(`Rename failed because of ${(0,A.getErrorMessage)(Q)}. Deleted from extracted location`,_),Q}return this.t(y.URI.file(Y),1)}async updateMetadata(U,B){return await this.l.updateMetadata(U.location,B),this.t(U.location,U.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...U){const B=U.map(W=>t.ExtensionKey.create(W));await this.n(W=>B.forEach(q=>{W[q.toString()]=!0,this.m.info("Marked extension as uninstalled",q.toString())}))}async setInstalled(U){await this.n(q=>delete q[U.toString()]);const W=(await this.scanAllUserExtensions(!0)).find(q=>t.ExtensionKey.create(q).equals(U))||null;return W?this.updateMetadata(W,{installedTimestamp:Date.now()}):null}async removeExtension(U,B){this.m.trace(`Deleting ${B} extension from disk`,U.identifier.id,U.location.fsPath),await l.Promises.rm(U.location.fsPath),this.m.info("Deleted from disk",U.identifier.id,U.location.fsPath)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.n(B=>delete B[t.ExtensionKey.create(U).toString()])}async n(U){return this.g.queue(async()=>{let B;try{B=await l.Promises.readFile(this.c,"utf8")}catch(q){if(q.code!=="ENOENT")throw q}let W={};if(B)try{W=JSON.parse(B)}catch{}return U&&(U(W),Object.keys(W).length?await l.Promises.writeFile(this.c,JSON.stringify(W)):await l.Promises.rm(this.c)),W})}async p(U,B,W,q){this.m.trace(`Started extracting the extension from ${B} to ${W}`);try{await l.Promises.rm(W)}catch(J){throw new c.ExtensionManagementError(this.w(J).message,c.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(B,W,{sourcePath:"extension",overwrite:!0},q),this.m.info(`Extracted extension to ${W}:`,U.id)}catch(J){try{await l.Promises.rm(W)}catch{}let _=c.ExtensionManagementErrorCode.Extract;throw J instanceof d.ExtractError&&(J.type==="CorruptZip"?_=c.ExtensionManagementErrorCode.CorruptZip:J.type==="Incomplete"&&(_=c.ExtensionManagementErrorCode.IncompleteZip)),new c.ExtensionManagementError(J.message,_)}}async s(U,B,W,q){try{await l.Promises.rename(B,W)}catch(J){if(b.isWindows&&J&&J.code==="EPERM"&&Date.now()<q)return this.m.info(`Failed renaming ${B} to ${W} with 'EPERM' error. Trying again...`,U.id),this.s(U,B,W,q);throw new c.ExtensionManagementError(J.message||p.localize(5,null,B,W),J.code||c.ExtensionManagementErrorCode.Rename)}}async t(U,B){const W=await this.l.scanExistingExtension(U,B,{includeInvalid:!0});if(W)return this.u(W);throw new Error(p.localize(6,null,U.path))}async u(U){const B=await this.k.resolve(U.location);let W,q;return B.children&&(W=B.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,q=B.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:W,changelogUrl:q,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated}}async v(){const U=await this.getUninstalledExtensions(),B=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),W=new Set;for(const _ of B)U[t.ExtensionKey.create(_).toString()]||W.add(_.identifier.id.toLowerCase());const q=(0,t.groupByExtension)(B,_=>_.identifier);await k.Promises.settled(q.map(async _=>{const Y=_.sort((Q,se)=>m.rcompare(Q.manifest.version,se.manifest.version))[0];W.has(Y.identifier.id.toLowerCase())||await this.j(await this.u(Y))}));const J=B.filter(_=>_.metadata&&U[t.ExtensionKey.create(_).toString()]);await k.Promises.settled(J.map(_=>this.removeUninstalledExtension(_)))}w(U){const B=Array.isArray(U)?U:[U];return B.length===1?B[0]instanceof Error?B[0]:new Error(B[0]):B.reduce((W,q)=>new Error(`${W.message}${W.message?",":""}${q instanceof Error?q.message:q}`),new Error(""))}};G=ye([K(1,F.IFileService),K(2,o.IExtensionsScannerService),K(3,L.ILogService)],G),e.ExtensionsScanner=G;class M extends n.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,h.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(U,B,W,q,J){super(),this.identifier=U,this.source=B,this.l=W,this.m=q,this.n=J,this.j="Unverified",this.k=2}async o(U,B){try{const W=await this.p(U.key);if(W)return this.m.updateMetadata(W,U.metadata)}catch{throw b.isMacintosh?new c.ExtensionManagementError(p.localize(7,null),c.ExtensionManagementErrorCode.Internal):new c.ExtensionManagementError(p.localize(8,null),c.ExtensionManagementErrorCode.Internal)}return this.s(U,B)}async p(U){if(!await this.q(U))return null;this.n.trace("Removing the extension from uninstalled list:",U.id);const W=await this.m.setInstalled(U);return this.n.info("Removed the extension from uninstalled list:",U.id),W}async q(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}async s({zipPath:U,key:B,metadata:W},q){const J=await this.m.extractUserExtension(B,U,W,q);return this.n.info("Extracting completed.",B.id),J}}class V extends M{constructor(U,B,W,q,J,_){super(B.identifier,B,W,J,_),this.t=U,this.u=B,this.v=q}async h(U){const W=(await this.m.scanExtensions(null,void 0)).find(Y=>(0,t.areSameExtensions)(Y.identifier,this.u.identifier));W&&(this.k=3);const q={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,T.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||W?.isMachineScoped,isBuiltin:this.l.isBuiltin||W?.isBuiltin,isSystem:W?.type===0?!0:void 0,updated:!!W,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.u.properties.isPreReleaseVersion||((0,h.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:W?.preRelease)};if(W?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(W,q),metadata:q};const{location:J,verificationStatus:_}=await this.v.download(this.u,this.k);try{return this.j=_,this.x(J.fsPath),{local:await this.o({zipPath:J.fsPath,key:t.ExtensionKey.create(this.u),metadata:q},U),metadata:q}}catch(Y){try{await this.v.delete(J)}catch(Q){this.n.warn("Error while deleting the downloaded file",J.toString(),(0,A.getErrorMessage)(Q))}throw Y}}async x(U){try{await(0,u.getManifest)(U)}catch(B){throw new c.ExtensionManagementError((0,n.joinErrors)(B).message,c.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=V;class x extends M{constructor(U,B,W,q,J,_){super({id:(0,t.getGalleryExtensionId)(U.publisher,U.name)},B,W,J,_),this.t=U,this.u=B,this.v=q}async h(U){const B=new t.ExtensionKey(this.identifier,this.t.version),q=(await this.m.scanExtensions(1,void 0)).find(Y=>(0,t.areSameExtensions)(this.identifier,Y.identifier)),J=await this.x(this.identifier.id,this.t.version,U);if(J.isApplicationScoped=(0,T.isApplicationScopedExtension)(this.t),J.isMachineScoped=this.l.isMachineScoped||q?.isMachineScoped,J.isBuiltin=this.l.isBuiltin||q?.isBuiltin,J.installedTimestamp=Date.now(),q)if(this.k=3,B.equals(new t.ExtensionKey(q.identifier,q.manifest.version)))try{await this.m.removeExtension(q,"existing")}catch{throw new Error(p.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&m.gt(q.manifest.version,this.t.version)&&await this.m.setUninstalled(q);else{const Y=await this.p(B);if(Y)try{await this.m.removeExtension(Y,"existing")}catch{throw new Error(p.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:E.resolve(this.u.fsPath),key:B,metadata:J},U),metadata:J}}async x(U,B,W){try{let[q]=await this.v.getExtensions([{id:U,version:B}],W);if(q||([q]=await this.v.getExtensions([{id:U}],W)),q)return{id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class ee{get verificationStatus(){return this.d.verificationStatus}constructor(U,B,W,q,J,_){this.d=U,this.g=B,this.h=W,this.j=q,this.k=J,this.l=_,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.m()}async m(){const U=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[U.local,U.metadata]],this.g),U}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class re extends n.AbstractExtensionTask{constructor(U,B,W){super(),this.extension=U,this.j=B,this.k=W}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[283],ae([0,1,2,30,80,233,127,9,20]),function(Z,e,k,i,D,A,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends k.Disposable{constructor(b,g,m,h,y,f){super(),b.removeUninstalledExtensions(),(0,A.migrateUnsupportedExtensions)(b,g,m,h,f),D.ExtensionStorageService.removeOutdatedExtensionVersions(b,y)}};S=ye([K(0,O.INativeServerExtensionManagementService),K(1,i.IExtensionGalleryService),K(2,D.IExtensionStorageService),K(3,i.IGlobalExtensionEnablementService),K(4,P.IStorageService),K(5,R.ILogService)],S),e.ExtensionsContributions=S}),define(oe[292],ae([0,1,94,34,38,7,2,24,22,8,39,150,210,211,204,205,281,193,196,16,216,96,231,97,223,15,228,118,267,30,98,195,268,127,99,191,14,207,208,55,4,202,72,203,57,73,237,9,104,58,105,25,60,20,269,110,19,111,112,113,47,240,114,242,248,80,116,26,78,272,259,260,81,273,276,277,278,279,271,62,261,109,230,77,250,220,249,108,227,29,251,5,252,197,214,213,79,266,18,51,209,59,270,225,239,262,232,107,103,275,283,264]),function(Z,e,k,i,D,A,O,R,P,S,E,b,g,m,h,y,f,l,d,p,w,I,n,c,t,s,o,a,r,u,v,C,T,N,F,j,L,$,z,H,X,ie,G,M,V,x,ee,re,te,U,B,W,q,J,_,Y,Q,se,le,ue,pe,we,be,Ee,Te,Ue,Ye,Be,ce,de,ge,Ce,Pe,Ae,De,je,Oe,Fe,ze,ke,Ne,ne,he,fe,me,ve,Ie,Re,He,$e,Le,qe,Ge,et,ot,wt,kt,At,vt,Lt,Tt,St,Ot,Nt,Ut,Mt,Ft,bt,Et,jt,$t,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class zt extends O.Disposable{constructor(Se){super(),this.f=Se,this.a=this.B(new b.Server),this.b=void 0,this.c=void 0,this.g()}g(){const Se=async()=>{this.c&&(await this.c.fireOnWillShutdown(),this.c.dispose(),this.c=void 0),this.dispose()};process.once("exit",Se),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",Se);const Me="vscode:electron-main->shared-process=disposeWorker",We=(Je,tt)=>{this.h(tt)};k.ipcRenderer.on(Me,We),this.B((0,O.toDisposable)(()=>k.ipcRenderer.removeListener(Me,We)))}h(Se){this.b?.disposeWorker(Se)}async open(){const Se=await this.i();(0,Be.registerConfiguration)(),Se.invokeFunction(Me=>{const We=Me.get(re.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Me),this.k(We)}),this.B((0,O.combinedDisposable)(Se.createInstance(g.CodeCacheCleaner,this.f.codeCachePath),Se.createInstance(m.LanguagePackCachedDataCleaner),Se.createInstance(f.UnusedWorkspaceStorageDataCleaner),Se.createInstance(y.LogsDataCleaner),Se.createInstance(h.LocalizationsUpdater),Se.createInstance($t.ExtensionsContributions),Se.createInstance(Mt.UserDataProfilesCleaner)))}async i(){const Se=new G.ServiceCollection,Me={_serviceBrand:void 0,...B.default};Se.set(W.IProductService,Me);const We=new E.StaticRouter(Qe=>Qe==="main"),Je=new M.MessagePortMainProcessService(this.a,We);Se.set(V.IMainProcessService,Je);const tt=this.f.policiesData?new Tt.PolicyChannelClient(this.f.policiesData,Je.getChannel("policy")):new St.NullPolicyService;Se.set(St.IPolicyService,tt);const Ke=new o.SharedProcessEnvironmentService(this.f.args,Me);Se.set(s.INativeEnvironmentService,Ke);const lt=new te.LogLevelChannelClient(this.a.getChannel("logLevel",We)),it=new te.LoggerChannelClient(this.f.logLevel,lt.onDidChangeLogLevel,Je.getChannel("logger"));Se.set(re.ILoggerService,it);const ht=this.B(new re.MultiplexLogService([this.B(new re.ConsoleLogger(this.f.logLevel)),this.B(it.createLogger((0,P.joinPath)(S.URI.file(Ke.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),xe=this.B(new te.FollowerLogService(lt,ht));Se.set(re.ILogService,xe),this.c=new Et.SharedProcessLifecycleService(xe),Se.set(Et.ISharedProcessLifecycleService,this.c),this.b=new He.SharedProcessWorkerService(xe),Se.set(Re.ISharedProcessWorkerService,this.b);const _e=this.B(new $.FileService(xe));Se.set(L.IFileService,_e);const ft=this.B(new z.DiskFileSystemProvider(xe));_e.registerProvider(R.Schemas.file,ft);const dt=this.B(new Ge.FileUserDataProvider(R.Schemas.file,this.B(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),R.Schemas.vscodeUserData,xe));_e.registerProvider(R.Schemas.vscodeUserData,dt);const nt=this.B(new Ot.UserDataProfilesNativeService(this.f.profiles,Je,Ke));Se.set(vt.IUserDataProfilesService,nt);const Xe=this.B(new w.ConfigurationService(nt.defaultProfile.settingsResource,_e,tt,xe));Se.set(p.IConfigurationService,Xe);const at=new _.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);Se.set(J.IStorageService,at),this.B((0,O.toDisposable)(()=>at.flush())),await Promise.all([Xe.initialize(),at.initialize()]),Se.set($e.IUriIdentityService,new Le.UriIdentityService(_e)),Se.set(q.IRequestService,new Nt.SharedProcessRequestService(Je,Xe,Me,xe)),Se.set(l.IChecksumService,new H.SyncDescriptor(d.ChecksumService,void 0,!1)),Se.set(wt.IV8InspectProfilingService,new H.SyncDescriptor(ot.InspectProfilingService,void 0,!1));const ut=E.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.f.windowId});Se.set(U.INativeHostService,ut),Se.set(c.IDownloadService,new H.SyncDescriptor(t.DownloadService,void 0,!0));const gt=this.B(new Ne.ActiveWindowManager(ut)),mt=new E.StaticRouter(Qe=>gt.getActiveClientId().then(pt=>Qe===pt));Se.set(F.IExtensionRecommendationNotificationService,new j.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",mt)));let st;const ct=[],It=(0,pe.isInternalTelemetry)(Me,Xe);if((0,pe.supportsTelemetry)(Me,Ke)){const Qe=new le.TelemetryLogAppender(it,Ke);ct.push(Qe);const{installSourcePath:pt}=Ke;if(Me.aiConfig?.ariaKey){const Rt=new Ut.OneDataSystemAppender(It,"monacoworkbench",null,Me.aiConfig.ariaKey);this.B((0,O.toDisposable)(()=>Rt.flush())),ct.push(Rt)}st=new ue.TelemetryService({appenders:ct,commonProperties:(0,Y.resolveCommonProperties)(_e,(0,i.release)(),(0,i.hostname)(),process.arch,Me.commit,Me.version,this.f.machineId,It,pt),sendErrorTelemetry:!0,piiPaths:(0,pe.getPiiPathsFromEnvironment)(Ke)},Xe,Me)}else{st=pe.NullTelemetryService;const Qe=pe.NullAppender;ct.push(Qe)}this.a.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(ct)),Se.set(Q.ITelemetryService,st);const Wt=new we.CustomEndpointTelemetryService(Xe,st,it,Ke,Me);Se.set(Q.ICustomEndpointTelemetryService,Wt),Se.set(Lt.IExtensionsProfileScannerService,new H.SyncDescriptor(Bt.ExtensionsProfileScannerService,void 0,!0)),Se.set(kt.IExtensionsScannerService,new H.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),Se.set(v.IExtensionSignatureVerificationService,new H.SyncDescriptor(v.ExtensionSignatureVerificationService,void 0,!0)),Se.set(N.INativeServerExtensionManagementService,new H.SyncDescriptor(N.ExtensionManagementService,void 0,!0)),Se.set(u.IExtensionGalleryService,new H.SyncDescriptor(r.ExtensionGalleryService,void 0,!0)),Se.set(u.IExtensionTipsService,new H.SyncDescriptor(T.ExtensionTipsService,void 0,!1)),Se.set(x.ILanguagePackService,new H.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1)),Se.set(I.IDiagnosticsService,new H.SyncDescriptor(n.DiagnosticsService,void 0,!1)),Se.set(ce.IUserDataSyncAccountService,new H.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),Se.set(Be.IUserDataSyncLogService,new H.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),Se.set(Be.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),Se.set(u.IGlobalExtensionEnablementService,new H.SyncDescriptor(a.GlobalExtensionEnablementService,void 0,!1)),Se.set(Ye.IIgnoredExtensionsManagementService,new H.SyncDescriptor(Ye.IgnoredExtensionsManagementService,void 0,!0)),Se.set(Ue.IExtensionStorageService,new H.SyncDescriptor(Ue.ExtensionStorageService)),Se.set(Be.IUserDataSyncStoreManagementService,new H.SyncDescriptor(Oe.UserDataSyncStoreManagementService,void 0,!0)),Se.set(Be.IUserDataSyncStoreService,new H.SyncDescriptor(Oe.UserDataSyncStoreService,void 0,!0)),Se.set(Pe.IUserDataSyncMachinesService,new H.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),Se.set(Be.IUserDataSyncBackupStoreService,new H.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),Se.set(Be.IUserDataSyncEnablementService,new H.SyncDescriptor(Ae.UserDataSyncEnablementService,void 0,!0)),Se.set(Be.IUserDataSyncService,new H.SyncDescriptor(De.UserDataSyncService,void 0,!1)),Se.set(ke.IUserDataProfileStorageService,new H.SyncDescriptor(ze.UserDataProfileStorageService,void 0,!0)),Se.set(Be.IUserDataSyncResourceProviderService,new H.SyncDescriptor(jt.UserDataSyncResourceProviderService,void 0,!0));const Pt=new Te.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Xe.getValue("terminal.integrated.persistentSessionScrollback")??100},Xe,Ke,xe);return Pt.initialize(),Se.set(Ee.ILocalPtyService,this.B(Pt)),Se.set(ne.ISignService,new H.SyncDescriptor(he.SignService,void 0,!1)),Se.set(fe.ISharedTunnelsService,new H.SyncDescriptor(me.SharedTunnelsService)),Se.set(ve.ISharedProcessTunnelService,new H.SyncDescriptor(Ie.SharedProcessTunnelService)),Se.set(bt.IRemoteTunnelService,new H.SyncDescriptor(Ft.RemoteTunnelService)),new ie.InstantiationService(Se)}j(Se){const Me=new te.LogLevelChannel(Se.get(re.ILogService),Se.get(re.ILoggerService));this.a.registerChannel("logLevel",Me);const We=new C.ExtensionManagementChannel(Se.get(u.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",We);const Je=E.ProxyChannel.fromService(Se.get(x.ILanguagePackService));this.a.registerChannel("languagePacks",Je);const tt=E.ProxyChannel.fromService(Se.get(I.IDiagnosticsService));this.a.registerChannel("diagnostics",tt);const Ke=new C.ExtensionTipsChannel(Se.get(u.IExtensionTipsService));this.a.registerChannel("extensionTipsService",Ke);const lt=E.ProxyChannel.fromService(Se.get(l.IChecksumService));this.a.registerChannel("checksum",lt);const it=E.ProxyChannel.fromService(Se.get(wt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",it);const ht=new ge.UserDataSyncMachinesServiceChannel(Se.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ht);const xe=E.ProxyChannel.fromService(Se.get(Q.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",xe);const _e=new ge.UserDataSyncAccountServiceChannel(Se.get(ce.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",_e);const ft=new ge.UserDataSyncStoreManagementServiceChannel(Se.get(Be.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",ft);const dt=new je.UserDataSyncChannel(Se.get(Be.IUserDataSyncService),Se.get(vt.IUserDataProfilesService),Se.get(re.ILogService));this.a.registerChannel("userDataSync",dt);const nt=this.B(Se.get(X.IInstantiationService).createInstance(Fe.UserDataAutoSyncService)),Xe=new ge.UserDataAutoSyncChannel(nt);this.a.registerChannel("userDataAutoSync",Xe);const at=Se.get(Ee.ILocalPtyService),ut=E.ProxyChannel.fromService(at);this.a.registerChannel(be.TerminalIpcChannels.LocalPty,ut);const gt=E.ProxyChannel.fromService(Se.get(ve.ISharedProcessTunnelService));this.a.registerChannel(ve.ipcSharedProcessTunnelChannelName,gt);const mt=E.ProxyChannel.fromService(Se.get(Re.ISharedProcessWorkerService));this.a.registerChannel(Re.ipcSharedProcessWorkerChannelName,mt);const st=E.ProxyChannel.fromService(Se.get(bt.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",st)}k(Se){window.addEventListener("unhandledrejection",Me=>{(0,A.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,A.setUnexpectedErrorHandler)(Me=>{const We=(0,D.toErrorMessage)(Me,!0);!We||Se.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function qt(Ct){const Se=new zt(Ct);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await Se.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=qt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e7b5449579249db344d473370d56a5df9446c826/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
