/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/base/common/process","vs/base/common/labels","vs/platform/userDataProfile/common/userDataProfile","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/objects","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/severity","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/parts/sandbox/electron-main/electronTypes","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/utilityProcess/electron-main/utilityProcess","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","vscode-policy-watcher","zlib","vs/code/electron-main/main"],te=function(H){for(var e=[],S=0,t=H.length;S<t;S++)e[S]=ee[H[S]];return e};define(ee[121],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function S(R){return R?R.replace(/\$\((.*?)\)/g,(M,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=S;class t{constructor(M,I,m){this.id=M,this.definition=I,this.description=m,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var P;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const M=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function I(p){if(p instanceof t)return["codicon","codicon-"+p.id];const b=M.exec(p.id);if(!b)return I(t.error);const[,y,f]=b,d=["codicon","codicon-"+y];return f&&d.push("codicon-modifier-"+f.substring(1)),d}R.asClassNameArray=I;function m(p){return I(p).join(" ")}R.asClassName=m;function w(p){return"."+I(p).join(".")}R.asCSSSelector=w})(P=e.CSSIcon||(e.CSSIcon={}))}),define(ee[122],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function S(I,m){const w=Math.pow(10,m);return Math.round(I*w)/w}class t{constructor(m,w,p,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=S(Math.max(Math.min(1,b),0),3)}static equals(m,w){return m.r===w.r&&m.g===w.g&&m.b===w.b&&m.a===w.a}}e.RGBA=t;class P{constructor(m,w,p,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=S(Math.max(Math.min(1,w),0),3),this.l=S(Math.max(Math.min(1,p),0),3),this.a=S(Math.max(Math.min(1,b),0),3)}static equals(m,w){return m.h===w.h&&m.s===w.s&&m.l===w.l&&m.a===w.a}static fromRGBA(m){const w=m.r/255,p=m.g/255,b=m.b/255,y=m.a,f=Math.max(w,p,b),d=Math.min(w,p,b);let v=0,a=0;const u=(d+f)/2,g=f-d;if(g>0){switch(a=Math.min(u<=.5?g/(2*u):g/(2-2*u),1),f){case w:v=(p-b)/g+(p<b?6:0);break;case p:v=(b-w)/g+2;break;case b:v=(w-p)/g+4;break}v*=60,v=Math.round(v)}return new P(v,a,u,y)}static i(m,w,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?m+(w-m)*6*p:p<1/2?w:p<2/3?m+(w-m)*(2/3-p)*6:m}static toRGBA(m){const w=m.h/360,{s:p,l:b,a:y}=m;let f,d,v;if(p===0)f=d=v=b;else{const a=b<.5?b*(1+p):b+p-b*p,u=2*b-a;f=P.i(u,a,w+1/3),d=P.i(u,a,w),v=P.i(u,a,w-1/3)}return new t(Math.round(f*255),Math.round(d*255),Math.round(v*255),y)}}e.HSLA=P;class R{constructor(m,w,p,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=S(Math.max(Math.min(1,w),0),3),this.v=S(Math.max(Math.min(1,p),0),3),this.a=S(Math.max(Math.min(1,b),0),3)}static equals(m,w){return m.h===w.h&&m.s===w.s&&m.v===w.v&&m.a===w.a}static fromRGBA(m){const w=m.r/255,p=m.g/255,b=m.b/255,y=Math.max(w,p,b),f=Math.min(w,p,b),d=y-f,v=y===0?0:d/y;let a;return d===0?a=0:y===w?a=((p-b)/d%6+6)%6:y===p?a=(b-w)/d+2:a=(w-p)/d+4,new R(Math.round(a*60),v,y,m.a)}static toRGBA(m){const{h:w,s:p,v:b,a:y}=m,f=b*p,d=f*(1-Math.abs(w/60%2-1)),v=b-f;let[a,u,g]=[0,0,0];return w<60?(a=f,u=d):w<120?(a=d,u=f):w<180?(u=f,g=d):w<240?(u=d,g=f):w<300?(a=d,g=f):w<=360&&(a=f,g=d),a=Math.round((a+v)*255),u=Math.round((u+v)*255),g=Math.round((g+v)*255),new t(a,u,g,y)}}e.HSVA=R;class M{static fromHex(m){return M.Format.CSS.parseHex(m)||M.red}static equals(m,w){return!m&&!w?!0:!m||!w?!1:m.equals(w)}get hsla(){return this.i?this.i:P.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(m){if(m)if(m instanceof t)this.rgba=m;else if(m instanceof P)this.i=m,this.rgba=P.toRGBA(m);else if(m instanceof R)this.j=m,this.rgba=R.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(m){return!!m&&t.equals(this.rgba,m.rgba)&&P.equals(this.hsla,m.hsla)&&R.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=M.k(this.rgba.r),w=M.k(this.rgba.g),p=M.k(this.rgba.b),b=.2126*m+.7152*w+.0722*p;return S(b,4)}static k(m){const w=m/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(m){const w=this.getRelativeLuminance(),p=m.getRelativeLuminance();return w>p?(w+.05)/(p+.05):(p+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const w=this.getRelativeLuminance(),p=m.getRelativeLuminance();return w>p}isDarkerThan(m){const w=this.getRelativeLuminance(),p=m.getRelativeLuminance();return w<p}lighten(m){return new M(new P(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new M(new P(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:w,g:p,b,a:y}=this.rgba;return new M(new t(w,p,b,y*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const w=m.rgba,p=this.rgba.a,b=w.a,y=p+b*(1-p);if(y<1e-6)return M.transparent;const f=this.rgba.r*p/y+w.r*b*(1-p)/y,d=this.rgba.g*p/y+w.g*b*(1-p)/y,v=this.rgba.b*p/y+w.b*b*(1-p)/y;return new M(new t(f,d,v,y))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:w,g:p,b,a:y}=this.rgba;return new M(new t(m.rgba.r-y*(m.rgba.r-w),m.rgba.g-y*(m.rgba.g-p),m.rgba.b-y*(m.rgba.b-b),1))}flatten(...m){const w=m.reduceRight((p,b)=>M.o(b,p));return M.o(this,w)}static o(m,w){const p=1-m.rgba.a;return new M(new t(p*w.rgba.r+m.rgba.a*m.rgba.r,p*w.rgba.g+m.rgba.a*m.rgba.g,p*w.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this.u||(this.u=M.Format.CSS.format(this)),this.u}static getLighterColor(m,w,p){if(m.isLighterThan(w))return m;p=p||.5;const b=m.getRelativeLuminance(),y=w.getRelativeLuminance();return p=p*(y-b)/y,m.lighten(p)}static getDarkerColor(m,w,p){if(m.isDarkerThan(w))return m;p=p||.5;const b=m.getRelativeLuminance(),y=w.getRelativeLuminance();return p=p*(b-y)/b,m.darken(p)}}e.Color=M,M.white=new M(new t(255,255,255,1)),M.black=new M(new t(0,0,0,1)),M.red=new M(new t(255,0,0,1)),M.blue=new M(new t(0,0,255,1)),M.green=new M(new t(0,255,0,1)),M.cyan=new M(new t(0,255,255,1)),M.lightgrey=new M(new t(211,211,211,1)),M.transparent=new M(new t(0,0,0,0)),function(I){let m;(function(w){let p;(function(b){function y(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:I.Format.CSS.formatRGBA(i)}b.formatRGB=y;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}b.formatRGBA=f;function d(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:I.Format.CSS.formatHSLA(i)}b.formatHSL=d;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}b.formatHSLA=v;function a(i){const l=i.toString(16);return l.length!==2?"0"+l:l}function u(i){return`#${a(i.rgba.r)}${a(i.rgba.g)}${a(i.rgba.b)}`}b.formatHex=u;function g(i,l=!1){return l&&i.rgba.a===1?I.Format.CSS.formatHex(i):`#${a(i.rgba.r)}${a(i.rgba.g)}${a(i.rgba.b)}${a(Math.round(i.rgba.a*255))}`}b.formatHexA=g;function k(i){return i.isOpaque()?I.Format.CSS.formatHex(i):I.Format.CSS.formatRGBA(i)}b.format=k;function E(i){const l=i.length;if(l===0||i.charCodeAt(0)!==35)return null;if(l===7){const n=16*D(i.charCodeAt(1))+D(i.charCodeAt(2)),s=16*D(i.charCodeAt(3))+D(i.charCodeAt(4)),o=16*D(i.charCodeAt(5))+D(i.charCodeAt(6));return new I(new t(n,s,o,1))}if(l===9){const n=16*D(i.charCodeAt(1))+D(i.charCodeAt(2)),s=16*D(i.charCodeAt(3))+D(i.charCodeAt(4)),o=16*D(i.charCodeAt(5))+D(i.charCodeAt(6)),c=16*D(i.charCodeAt(7))+D(i.charCodeAt(8));return new I(new t(n,s,o,c/255))}if(l===4){const n=D(i.charCodeAt(1)),s=D(i.charCodeAt(2)),o=D(i.charCodeAt(3));return new I(new t(16*n+n,16*s+s,16*o+o))}if(l===5){const n=D(i.charCodeAt(1)),s=D(i.charCodeAt(2)),o=D(i.charCodeAt(3)),c=D(i.charCodeAt(4));return new I(new t(16*n+n,16*s+s,16*o+o,(16*c+c)/255))}return null}b.parseHex=E;function D(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=w.CSS||(w.CSS={}))})(m=I.Format||(I.Format={}))}(M=e.Color||(e.Color={}))}),define(ee[54],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function S(M){return(I,m,w)=>{let p=null,b=null;if(typeof w.value=="function"?(p="value",b=w.value):typeof w.get=="function"&&(p="get",b=w.get),!b)throw new Error("not supported");w[p]=M(b,m)}}function t(M,I,m){let w=null,p=null;if(typeof m.value=="function"?(w="value",p=m.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(w="get",p=m.get),!p)throw new Error("not supported");const b=`$memoize$${I}`;m[w]=function(...y){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,y)}),this[b]}}e.memoize=t;function P(M,I,m){return S((w,p)=>{const b=`$debounce$${p}`,y=`$debounce$result$${p}`;return function(...f){this[y]||(this[y]=m?m():void 0),clearTimeout(this[b]),I&&(this[y]=I(this[y],...f),f=[this[y]]),this[b]=setTimeout(()=>{w.apply(this,f),this[y]=m?m():void 0},M)}})}e.debounce=P;function R(M,I,m){return S((w,p)=>{const b=`$throttle$timer$${p}`,y=`$throttle$result$${p}`,f=`$throttle$lastRun$${p}`,d=`$throttle$pending$${p}`;return function(...v){if(this[y]||(this[y]=m?m():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),I&&(this[y]=I(this[y],...v)),this[d])return;const a=this[f]+M;a<=Date.now()?(this[f]=Date.now(),w.apply(this,[this[y]]),this[y]=m?m():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[f]=Date.now(),w.apply(this,[this[y]]),this[y]=m?m():void 0},a-Date.now()))}})}e.throttle=R}),define(ee[13],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class S{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?k.isErrorNoTelemetry(i)?new k(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(l=>{l(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=S,e.errorHandler=new S;function t(D){e.errorHandler.setUnexpectedErrorHandler(D)}e.setUnexpectedErrorHandler=t;function P(D){m(D)||e.errorHandler.onUnexpectedError(D)}e.onUnexpectedError=P;function R(D){m(D)||e.errorHandler.onUnexpectedExternalError(D)}e.onUnexpectedExternalError=R;function M(D){if(D instanceof Error){const{name:i,message:l}=D,n=D.stacktrace||D.stack;return{$isError:!0,name:i,message:l,stack:n,noTelemetry:k.isErrorNoTelemetry(D)}}return D}e.transformErrorForSerialization=M;const I="Canceled";function m(D){return D instanceof w?!0:D instanceof Error&&D.name===I&&D.message===I}e.isCancellationError=m;class w extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=w;function p(){const D=new Error(I);return D.name=D.message,D}e.canceled=p;function b(D){return D?new Error(`Illegal argument: ${D}`):new Error("Illegal argument")}e.illegalArgument=b;function y(D){return D?new Error(`Illegal state: ${D}`):new Error("Illegal state")}e.illegalState=y;function f(D){return D?new Error(`readonly property '${D} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function d(D){const i=new Error(`${D} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function v(D){return D?D.message?D.message:D.stack?D.stack.split(`
`)[0]:String(D):"Error"}e.getErrorMessage=v;class a extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=a;class u extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=u;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class k extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof k)return i;const l=new k;return l.message=i.message,l.stack=i.stack,l}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=k;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype);debugger}}e.BugIndicatingError=E}),define(ee[25],te([0,1,13]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(j,X=0){return j[j.length-(1+X)]}e.tail=t;function P(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=P;function R(j,X,Z=(oe,de)=>oe===de){if(j===X)return!0;if(!j||!X||j.length!==X.length)return!1;for(let oe=0,de=j.length;oe<de;oe++)if(!Z(j[oe],X[oe]))return!1;return!0}e.equals=R;function M(j,X){const Z=j.length-1;X<Z&&(j[X]=j[Z]),j.pop()}e.removeFastWithoutKeepingOrder=M;function I(j,X,Z){return m(j.length,oe=>Z(j[oe],X))}e.binarySearch=I;function m(j,X){let Z=0,oe=j-1;for(;Z<=oe;){const de=(Z+oe)/2|0,ke=X(de);if(ke<0)Z=de+1;else if(ke>0)oe=de-1;else return de}return-(Z+1)}e.binarySearch2=m;function w(j,X){let Z=0,oe=j.length;if(oe===0)return 0;for(;Z<oe;){const de=Math.floor((Z+oe)/2);X(j[de])?oe=de:Z=de+1}return Z}e.findFirstInSorted=w;function p(j,X,Z){if(j=j|0,j>=X.length)throw new TypeError("invalid index");const oe=X[Math.floor(X.length*Math.random())],de=[],ke=[],De=[];for(const Pe of X){const Ae=Z(Pe,oe);Ae<0?de.push(Pe):Ae>0?ke.push(Pe):De.push(Pe)}return j<de.length?p(j,de,Z):j<de.length+De.length?De[0]:p(j-(de.length+De.length),ke,Z)}e.quickSelect=p;function b(j,X){const Z=[];let oe;for(const de of j.slice(0).sort(X))!oe||X(oe[0],de)!==0?(oe=[de],Z.push(oe)):oe.push(de);return Z}e.groupBy=b;function y(j,X,Z){const oe=[];function de(Pe,Ae,ve){if(Ae===0&&ve.length===0)return;const me=oe[oe.length-1];me&&me.start+me.deleteCount===Pe?(me.deleteCount+=Ae,me.toInsert.push(...ve)):oe.push({start:Pe,deleteCount:Ae,toInsert:ve})}let ke=0,De=0;for(;;){if(ke===j.length){de(ke,0,X.slice(De));break}if(De===X.length){de(ke,j.length-ke,[]);break}const Pe=j[ke],Ae=X[De],ve=Z(Pe,Ae);ve===0?(ke+=1,De+=1):ve<0?(de(ke,1,[]),ke+=1):ve>0&&(de(ke,0,[Ae]),De+=1)}return oe}e.sortedDiff=y;function f(j,X,Z){const oe=y(j,X,Z),de=[],ke=[];for(const De of oe)de.push(...j.slice(De.start,De.start+De.deleteCount)),ke.push(...De.toInsert);return{removed:de,added:ke}}e.delta=f;function d(j,X,Z){if(Z===0)return[];const oe=j.slice(0,Z).sort(X);return a(j,X,oe,Z,j.length),oe}e.top=d;function v(j,X,Z,oe,de){return Z===0?Promise.resolve([]):new Promise((ke,De)=>{(async()=>{const Pe=j.length,Ae=j.slice(0,Z).sort(X);for(let ve=Z,me=Math.min(Z+oe,Pe);ve<Pe;ve=me,me=Math.min(me+oe,Pe)){if(ve>Z&&await new Promise(ye=>setTimeout(ye)),de&&de.isCancellationRequested)throw new S.CancellationError;a(j,X,Ae,ve,me)}return Ae})().then(ke,De)})}e.topAsync=v;function a(j,X,Z,oe,de){for(const ke=Z.length;oe<de;oe++){const De=j[oe];if(X(De,Z[ke-1])<0){Z.pop();const Pe=w(Z,Ae=>X(De,Ae)<0);Z.splice(Pe,0,De)}}}function u(j){return j.filter(X=>!!X)}e.coalesce=u;function g(j){let X=0;for(let Z=0;Z<j.length;Z++)j[Z]&&(j[X]=j[Z],X+=1);j.length=X}e.coalesceInPlace=g;function k(j,X,Z){j.splice(Z,0,j.splice(X,1)[0])}e.move=k;function E(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=E;function D(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=D;function i(j,X=Z=>Z){const Z=new Set;return j.filter(oe=>{const de=X(oe);return Z.has(de)?!1:(Z.add(de),!0)})}e.distinct=i;function l(j){const X=new Set;return Z=>{const oe=j(Z);return X.has(oe)?!1:(X.add(oe),!0)}}e.uniqueFilter=l;function n(j,X){const Z=s(j,X);if(Z!==-1)return j[Z]}e.findLast=n;function s(j,X){for(let Z=j.length-1;Z>=0;Z--){const oe=j[Z];if(X(oe))return Z}return-1}e.lastIndex=s;function o(j,X){return j.length>0?j[0]:X}e.firstOrDefault=o;function c(j,X){return j.length>0?j[j.length-1]:X}e.lastOrDefault=c;function r(j,X,Z=(oe,de)=>oe===de){let oe=0;for(let de=0,ke=Math.min(j.length,X.length);de<ke&&Z(j[de],X[de]);de++)oe++;return oe}e.commonPrefixLength=r;function h(j){return[].concat(...j)}e.flatten=h;function C(j,X){let Z=typeof X=="number"?j:0;typeof X=="number"?Z=j:(Z=0,X=j);const oe=[];if(Z<=X)for(let de=Z;de<X;de++)oe.push(de);else for(let de=Z;de>X;de--)oe.push(de);return oe}e.range=C;function L(j,X,Z){return j.reduce((oe,de)=>(oe[X(de)]=Z?Z(de):de,oe),Object.create(null))}e.index=L;function O(j,X){return j.push(X),()=>B(j,X)}e.insert=O;function B(j,X){const Z=j.indexOf(X);if(Z>-1)return j.splice(Z,1),X}e.remove=B;function K(j,X,Z){const oe=j.slice(0,X),de=j.slice(X);return oe.concat(Z,de)}e.arrayInsert=K;function V(j,X){let Z;if(typeof X=="number"){let oe=X;Z=()=>{const de=Math.sin(oe++)*179426549;return de-Math.floor(de)}}else Z=Math.random;for(let oe=j.length-1;oe>0;oe-=1){const de=Math.floor(Z()*(oe+1)),ke=j[oe];j[oe]=j[de],j[de]=ke}}e.shuffle=V;function J(j,X){const Z=j.indexOf(X);Z>-1&&(j.splice(Z,1),j.unshift(X))}e.pushToStart=J;function re(j,X){const Z=j.indexOf(X);Z>-1&&(j.splice(Z,1),j.push(X))}e.pushToEnd=re;function se(j,X){for(const Z of X)j.push(Z)}e.pushMany=se;function ae(j,X){return Array.isArray(j)?j.map(X):X(j)}e.mapArrayOrNot=ae;function fe(j){return Array.isArray(j)?j:[j]}e.asArray=fe;function ge(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=ge;function q(j,X){for(const Z of j){const oe=X(Z);if(oe!==void 0)return oe}}e.mapFind=q;function T(j,X,Z){const oe=z(j,X),de=j.length,ke=Z.length;j.length=de+ke;for(let De=de-1;De>=oe;De--)j[De+ke]=j[De];for(let De=0;De<ke;De++)j[De+oe]=Z[De]}e.insertInto=T;function U(j,X,Z,oe){const de=z(j,X),ke=j.splice(de,Z);return T(j,de,oe),ke}e.splice=U;function z(j,X){return X<0?Math.max(X+j.length,0):Math.min(X,j.length)}var Q;(function(j){function X(de){return de<0}j.isLessThan=X;function Z(de){return de>0}j.isGreaterThan=Z;function oe(de){return de===0}j.isNeitherLessOrGreaterThan=oe,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function ne(j,X){return(Z,oe)=>X(j(Z),j(oe))}e.compareBy=ne;function x(...j){return(X,Z)=>{for(const oe of j){const de=oe(X,Z);if(!Q.isNeitherLessOrGreaterThan(de))return de}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const A=(j,X)=>j-X;e.numberComparator=A;function F(j,X){if(j.length===0)return;let Z=j[0];for(let oe=1;oe<j.length;oe++){const de=j[oe];X(de,Z)>0&&(Z=de)}return Z}e.findMaxBy=F;function W(j,X){if(j.length===0)return;let Z=j[0];for(let oe=1;oe<j.length;oe++){const de=j[oe];X(de,Z)>=0&&(Z=de)}return Z}e.findLastMaxBy=W;function N(j,X){return F(j,(Z,oe)=>-X(Z,oe))}e.findMinBy=N;class ${constructor(X){this.f=X,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(X){let Z=this.c;for(;Z<this.f.length&&X(this.f[Z]);)Z++;const oe=Z===this.c?null:this.f.slice(this.c,Z);return this.c=Z,oe}takeFromEndWhile(X){let Z=this.d;for(;Z>=0&&X(this.f[Z]);)Z--;const oe=Z===this.d?null:this.f.slice(Z+1,this.d+1);return this.d=Z,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const X=this.f[this.c];return this.c++,X}removeLast(){const X=this.f[this.d];return this.d--,X}takeCount(X){const Z=this.f.slice(this.c,this.c+X);return this.c+=X,Z}}e.ArrayQueue=$;class G{constructor(X){this.iterate=X}forEach(X){this.iterate(Z=>(X(Z),!0))}toArray(){const X=[];return this.iterate(Z=>(X.push(Z),!0)),X}filter(X){return new G(Z=>this.iterate(oe=>X(oe)?Z(oe):!0))}map(X){return new G(Z=>this.iterate(oe=>Z(X(oe))))}some(X){let Z=!1;return this.iterate(oe=>(Z=X(oe),!Z)),Z}findFirst(X){let Z;return this.iterate(oe=>X(oe)?(Z=oe,!1):!0),Z}findLast(X){let Z;return this.iterate(oe=>(X(oe)&&(Z=oe),!0)),Z}findLastMaxBy(X){let Z,oe=!0;return this.iterate(de=>((oe||Q.isGreaterThan(X(de,Z)))&&(oe=!1,Z=de),!0)),Z}}e.CallbackIterable=G,G.empty=new G(j=>{})}),define(ee[123],te([0,1,13]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(m,w){if(!m)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=t;function P(m,w="Unreachable"){throw new Error(w)}e.assertNever=P;function R(m){if(!m)throw new S.BugIndicatingError("Assertion Failed")}e.assert=R;function M(m){if(!m()){debugger;m(),(0,S.onUnexpectedError)(new S.BugIndicatingError("Assertion Failed"))}}e.assertFn=M;function I(m,w){let p=0;for(;p<m.length-1;){const b=m[p],y=m[p+1];if(!w(b,y))return!1;p++}return!0}e.checkAdjacentItems=I}),define(ee[50],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function S(t){const P=this;let R=!1,M;return function(){return R||(R=!0,M=t.apply(P,arguments)),M}}e.once=S}),define(ee[68],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(t){function P(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}t.is=P;const R=Object.freeze([]);function M(){return R}t.empty=M;function*I(E){yield E}t.single=I;function m(E){return P(E)?E:I(E)}t.wrap=m;function w(E){return E||R}t.from=w;function p(E){return!E||E[Symbol.iterator]().next().done===!0}t.isEmpty=p;function b(E){return E[Symbol.iterator]().next().value}t.first=b;function y(E,D){for(const i of E)if(D(i))return!0;return!1}t.some=y;function f(E,D){for(const i of E)if(D(i))return i}t.find=f;function*d(E,D){for(const i of E)D(i)&&(yield i)}t.filter=d;function*v(E,D){let i=0;for(const l of E)yield D(l,i++)}t.map=v;function*a(...E){for(const D of E)for(const i of D)yield i}t.concat=a;function u(E,D,i){let l=i;for(const n of E)l=D(l,n);return l}t.reduce=u;function*g(E,D,i=E.length){for(D<0&&(D+=E.length),i<0?i+=E.length:i>E.length&&(i=E.length);D<i;D++)yield E[D]}t.slice=g;function k(E,D=Number.POSITIVE_INFINITY){const i=[];if(D===0)return[i,E];const l=E[Symbol.iterator]();for(let n=0;n<D;n++){const s=l.next();if(s.done)return[i,t.empty()];i.push(s.value)}return[i,{[Symbol.iterator](){return l}}]}t.consume=k})(S=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function M(i,l=!1){let n=0;const s=i.length;let o="",c=0,r=16,h=0;function C(re){let se=0,ae=0;for(;se<re;){const fe=i.charCodeAt(n);if(fe>=48&&fe<=57)ae=ae*16+fe-48;else if(fe>=65&&fe<=70)ae=ae*16+fe-65+10;else if(fe>=97&&fe<=102)ae=ae*16+fe-97+10;else break;n++,se++}return se<re&&(ae=-1),ae}function L(re){n=re,o="",c=0,r=16,h=0}function O(){const re=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&w(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&w(i.charCodeAt(n)))for(n++;n<i.length&&w(i.charCodeAt(n));)n++;else return h=3,i.substring(re,n);let se=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&w(i.charCodeAt(n))){for(n++;n<i.length&&w(i.charCodeAt(n));)n++;se=n}else h=3;return i.substring(re,se)}function B(){let re="",se=n;for(;;){if(n>=s){re+=i.substring(se,n),h=2;break}const ae=i.charCodeAt(n);if(ae===34){re+=i.substring(se,n),n++;break}if(ae===92){if(re+=i.substring(se,n),n++,n>=s){h=2;break}switch(i.charCodeAt(n++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const ge=C(4);ge>=0?re+=String.fromCharCode(ge):h=4;break}default:h=5}se=n;continue}if(ae>=0&&ae<=31)if(m(ae)){re+=i.substring(se,n),h=2;break}else h=6;n++}return re}function K(){if(o="",h=0,c=n,n>=s)return c=s,r=17;let re=i.charCodeAt(n);if(I(re)){do n++,o+=String.fromCharCode(re),re=i.charCodeAt(n);while(I(re));return r=15}if(m(re))return n++,o+=String.fromCharCode(re),re===13&&i.charCodeAt(n)===10&&(n++,o+=`
`),r=14;switch(re){case 123:return n++,r=1;case 125:return n++,r=2;case 91:return n++,r=3;case 93:return n++,r=4;case 58:return n++,r=6;case 44:return n++,r=5;case 34:return n++,o=B(),r=10;case 47:{const se=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!m(i.charCodeAt(n));)n++;return o=i.substring(se,n),r=12}if(i.charCodeAt(n+1)===42){n+=2;const ae=s-1;let fe=!1;for(;n<ae;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,fe=!0;break}n++}return fe||(n++,h=1),o=i.substring(se,n),r=13}return o+=String.fromCharCode(re),n++,r=16}case 45:if(o+=String.fromCharCode(re),n++,n===s||!w(i.charCodeAt(n)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),r=11;default:for(;n<s&&V(re);)n++,re=i.charCodeAt(n);if(c!==n){switch(o=i.substring(c,n),o){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return o+=String.fromCharCode(re),n++,r=16}}function V(re){if(I(re)||m(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let re;do re=K();while(re>=12&&re<=15);return re}return{setPosition:L,getPosition:()=>n,scan:l?J:K,getToken:()=>r,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>h}}e.createScanner=M;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function m(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var p;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(p||(p={}));function b(i,l){const n=[],s=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function h(C,L,O,B){c.value=C,c.offset=L,c.length=O,c.type=B,c.colonOffset=void 0,o=c}try{k(i,{onObjectBegin:(C,L)=>{if(l<=C)throw s;o=void 0,r=l>C,n.push("")},onObjectProperty:(C,L,O)=>{if(l<L||(h(C,L,O,"property"),n[n.length-1]=C,l<=L+O))throw s},onObjectEnd:(C,L)=>{if(l<=C)throw s;o=void 0,n.pop()},onArrayBegin:(C,L)=>{if(l<=C)throw s;o=void 0,n.push(0)},onArrayEnd:(C,L)=>{if(l<=C)throw s;o=void 0,n.pop()},onLiteralValue:(C,L,O)=>{if(l<L||(h(C,L,O,D(C)),l<=L+O))throw s},onSeparator:(C,L,O)=>{if(l<=L)throw s;if(C===":"&&o&&o.type==="property")o.colonOffset=L,r=!1,o=void 0;else if(C===","){const B=n[n.length-1];typeof B=="number"?n[n.length-1]=B+1:(r=!0,n[n.length-1]=""),o=void 0}}})}catch(C){if(C!==s)throw C}return{path:n,previousNode:o,isAtPropertyKey:r,matches:C=>{let L=0;for(let O=0;L<C.length&&O<n.length;O++)if(C[L]===n[O]||C[L]==="*")L++;else if(C[L]!=="**")return!1;return L===C.length}}}e.getLocation=b;function y(i,l=[],n=R.DEFAULT){let s=null,o=[];const c=[];function r(C){Array.isArray(o)?o.push(C):s!==null&&(o[s]=C)}return k(i,{onObjectBegin:()=>{const C={};r(C),c.push(o),o=C,s=null},onObjectProperty:C=>{s=C},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const C=[];r(C),c.push(o),o=C,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:r,onError:(C,L,O)=>{l.push({error:C,offset:L,length:O})}},n),o[0]}e.parse=y;function f(i,l=[],n=R.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(C){s.type==="property"&&(s.length=C-s.offset,s=s.parent)}function c(C){return s.children.push(C),C}k(i,{onObjectBegin:C=>{s=c({type:"object",offset:C,length:-1,parent:s,children:[]})},onObjectProperty:(C,L,O)=>{s=c({type:"property",offset:L,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:C,offset:L,length:O,parent:s})},onObjectEnd:(C,L)=>{s.length=C+L-s.offset,s=s.parent,o(C+L)},onArrayBegin:(C,L)=>{s=c({type:"array",offset:C,length:-1,parent:s,children:[]})},onArrayEnd:(C,L)=>{s.length=C+L-s.offset,s=s.parent,o(C+L)},onLiteralValue:(C,L,O)=>{c({type:D(C),offset:L,length:O,parent:s,value:C}),o(L+O)},onSeparator:(C,L,O)=>{s.type==="property"&&(C===":"?s.colonOffset=L:C===","&&o(L))},onError:(C,L,O)=>{l.push({error:C,offset:L,length:O})}},n);const h=s.children[0];return h&&delete h.parent,h}e.parseTree=f;function d(i,l){if(!i)return;let n=i;for(const s of l)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===s){n=c.children[1],o=!0;break}if(!o)return}else{const o=s;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=d;function v(i){if(!i.parent||!i.parent.children)return[];const l=v(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;l.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&l.push(n)}return l}e.getNodePath=v;function a(i){switch(i.type){case"array":return i.children.map(a);case"object":{const l=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(l[n.children[0].value]=a(s))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=a;function u(i,l,n=!1){return l>=i.offset&&l<i.offset+i.length||n&&l===i.offset+i.length}e.contains=u;function g(i,l,n=!1){if(u(i,l,n)){const s=i.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=l;o++){const c=g(s[o],l,n);if(c)return c}return i}}e.findNodeAtOffset=g;function k(i,l,n=R.DEFAULT){const s=M(i,!1);function o(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function c(ne){return ne?x=>ne(x,s.getTokenOffset(),s.getTokenLength()):()=>!0}const r=o(l.onObjectBegin),h=c(l.onObjectProperty),C=o(l.onObjectEnd),L=o(l.onArrayBegin),O=o(l.onArrayEnd),B=c(l.onLiteralValue),K=c(l.onSeparator),V=o(l.onComment),J=c(l.onError),re=n&&n.disallowComments,se=n&&n.allowTrailingComma;function ae(){for(;;){const ne=s.scan();switch(s.getTokenError()){case 4:fe(14);break;case 5:fe(15);break;case 3:fe(13);break;case 1:re||fe(11);break;case 2:fe(12);break;case 6:fe(16);break}switch(ne){case 12:case 13:re?fe(10):V();break;case 16:fe(1);break;case 15:case 14:break;default:return ne}}}function fe(ne,x=[],A=[]){if(J(ne),x.length+A.length>0){let F=s.getToken();for(;F!==17;){if(x.indexOf(F)!==-1){ae();break}else if(A.indexOf(F)!==-1)break;F=ae()}}}function ge(ne){const x=s.getTokenValue();return ne?B(x):h(x),ae(),!0}function q(){switch(s.getToken()){case 11:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&(fe(2),ne=0)}catch{fe(2)}B(ne);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return ae(),!0}function T(){return s.getToken()!==10?(fe(3,[],[2,5]),!1):(ge(!1),s.getToken()===6?(K(":"),ae(),Q()||fe(4,[],[2,5])):fe(5,[],[2,5]),!0)}function U(){r(),ae();let ne=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ne||fe(4,[],[]),K(","),ae(),s.getToken()===2&&se)break}else ne&&fe(6,[],[]);T()||fe(4,[],[2,5]),ne=!0}return C(),s.getToken()!==2?fe(7,[2],[]):ae(),!0}function z(){L(),ae();let ne=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ne||fe(4,[],[]),K(","),ae(),s.getToken()===4&&se)break}else ne&&fe(6,[],[]);Q()||fe(4,[],[4,5]),ne=!0}return O(),s.getToken()!==4?fe(8,[4],[]):ae(),!0}function Q(){switch(s.getToken()){case 3:return z();case 1:return U();case 10:return ge(!0);default:return q()}}return ae(),s.getToken()===17?n.allowEmptyContent?!0:(fe(4,[],[]),!1):Q()?(s.getToken()!==17&&fe(9,[],[]),!0):(fe(4,[],[]),!1)}e.visit=k;function E(i,l){const n=M(i),s=[];let o,c=0,r;do switch(r=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:c!==r&&s.push(i.substring(c,r)),l!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,l)),c=n.getPosition();break}while(o!==17);return s.join("")}e.stripComments=E;function D(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(ee[124],te([0,1,43]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(w,p,b){let y,f,d,v,a;if(p){for(v=p.offset,a=v+p.length,d=v;d>0&&!m(w,d-1);)d--;let r=a;for(;r<w.length&&!m(w,r);)r++;f=w.substring(d,r),y=M(f,b)}else f=w,y=0,d=0,v=0,a=w.length;const u=I(b,w);let g=!1,k=0,E;b.insertSpaces?E=R(" ",b.tabSize||4):E="	";const D=(0,S.createScanner)(f,!1);let i=!1;function l(){return u+R(E,y+k)}function n(){let r=D.scan();for(g=!1;r===15||r===14;)g=g||r===14,r=D.scan();return i=r===16||D.getTokenError()!==0,r}const s=[];function o(r,h,C){!i&&h<a&&C>v&&w.substring(h,C)!==r&&s.push({offset:h,length:C-h,content:r})}let c=n();if(c!==17){const r=D.getTokenOffset()+d,h=R(E,y);o(h,d,r)}for(;c!==17;){let r=D.getTokenOffset()+D.getTokenLength()+d,h=n(),C="";for(;!g&&(h===12||h===13);){const O=D.getTokenOffset()+d;o(" ",r,O),r=D.getTokenOffset()+D.getTokenLength()+d,C=h===12?l():"",h=n()}if(h===2)c!==1&&(k--,C=l());else if(h===4)c!==3&&(k--,C=l());else{switch(c){case 3:case 1:k++,C=l();break;case 5:case 12:C=l();break;case 13:g?C=l():C=" ";break;case 6:C=" ";break;case 10:if(h===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?C=" ":h!==5&&h!==17&&(i=!0);break;case 16:i=!0;break}g&&(h===12||h===13)&&(C=l())}const L=D.getTokenOffset()+d;o(C,r,L),c=h}return s}e.format=t;function P(w,p){const b=JSON.stringify(w,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?b.replace(/\r\n|\r|\n/g,p.eol):b}e.toFormattedString=P;function R(w,p){let b="";for(let y=0;y<p;y++)b+=w;return b}function M(w,p){let b=0,y=0;const f=p.tabSize||4;for(;b<w.length;){const d=w.charAt(b);if(d===" ")y++;else if(d==="	")y+=f;else break;b++}return Math.floor(y/f)}function I(w,p){for(let b=0;b<p.length;b++){const y=p.charAt(b);if(y==="\r")return b+1<p.length&&p.charAt(b+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=I;function m(w,p){return`\r
`.indexOf(w.charAt(p))!==-1}e.isEOL=m}),define(ee[125],te([0,1,43,124]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(w,p,b){return R(w,p,void 0,b)}e.removeProperty=P;function R(w,p,b,y,f){const d=p.slice(),v=[],a=(0,S.parseTree)(w,v);let u,g;for(;d.length>0&&(g=d.pop(),u=(0,S.findNodeAtLocation)(a,d),u===void 0&&b!==void 0);)typeof g=="string"?b={[g]:b}:b=[b];if(u)if(u.type==="object"&&typeof g=="string"&&Array.isArray(u.children)){const k=(0,S.findNodeAtLocation)(u,[g]);if(k!==void 0)if(b===void 0){if(!k.parent)throw new Error("Malformed AST");const E=u.children.indexOf(k.parent);let D,i=k.parent.offset+k.parent.length;if(E>0){const l=u.children[E-1];D=l.offset+l.length}else D=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return M(w,{offset:D,length:i-D,content:""},y)}else return M(w,{offset:k.offset,length:k.length,content:JSON.stringify(b)},y);else{if(b===void 0)return[];const E=`${JSON.stringify(g)}: ${JSON.stringify(b)}`,D=f?f(u.children.map(l=>l.children[0].value)):u.children.length;let i;if(D>0){const l=u.children[D-1];i={offset:l.offset+l.length,length:0,content:","+E}}else u.children.length===0?i={offset:u.offset+1,length:0,content:E}:i={offset:u.offset+1,length:0,content:E+","};return M(w,i,y)}}else if(u.type==="array"&&typeof g=="number"&&Array.isArray(u.children))if(b!==void 0){const k=`${JSON.stringify(b)}`;let E;if(u.children.length===0||g===0)E={offset:u.offset+1,length:0,content:u.children.length===0?k:k+","};else{const D=g===-1||g>u.children.length?u.children.length:g,i=u.children[D-1];E={offset:i.offset+i.length,length:0,content:","+k}}return M(w,E,y)}else{const k=g,E=u.children[k];let D;if(u.children.length===1)D={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===k){const i=u.children[k-1],l=i.offset+i.length,n=u.offset+u.length;D={offset:l,length:n-2-l,content:""}}else D={offset:E.offset,length:u.children[k+1].offset-E.offset,content:""};return M(w,D,y)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${u.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return M(w,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(b)},y)}}e.setProperty=R;function M(w,p,b){let y=I(w,p),f=p.offset,d=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;f>0&&!(0,t.isEOL)(y,f-1);)f--;for(;d<y.length&&!(0,t.isEOL)(y,d);)d++}const v=(0,t.format)(y,{offset:f,length:d-f},b);for(let u=v.length-1;u>=0;u--){const g=v[u];y=I(y,g),f=Math.min(f,g.offset),d=Math.max(d,g.offset+g.length),d+=g.content.length-g.length}const a=w.length-(y.length-d)-f;return[{offset:f,length:a,content:y.substring(f,d)}]}e.withFormatting=M;function I(w,p){return w.substring(0,p.offset)+p.content+w.substring(p.offset+p.length)}e.applyEdit=I;function m(w,p){const b=p.slice(0).sort((f,d)=>{const v=f.offset-d.offset;return v===0?f.length-d.length:v});let y=w.length;for(let f=b.length-1;f>=0;f--){const d=b[f];if(d.offset+d.length<=y)w=I(w,d);else throw new Error("Overlapping edit");y=d.offset}return w}e.applyEdits=m}),define(ee[126],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class S{constructor(P){this.d=P,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(P){return new S(()=>P(this.getValue()))}}e.Lazy=S}),define(ee[2],te([0,1,50,68]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const P=!1;let R=null;function M(c){R=c}if(e.setDisposableTracker=M,P){const c="__is_disposable_tracked__";M(new class{trackDisposable(r){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[c]||console.log(h)},3e3)}setParent(r,h){if(r&&r!==g.None)try{r[c]=!0}catch{}}markAsDisposed(r){if(r&&r!==g.None)try{r[c]=!0}catch{}}markAsSingleton(r){}})}function I(c){return R?.trackDisposable(c),c}function m(c){R?.markAsDisposed(c)}function w(c,r){R?.setParent(c,r)}function p(c,r){if(!!R)for(const h of c)R.setParent(h,r)}function b(c){return R?.markAsSingleton(c),c}e.markAsSingleton=b;function y(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=y;function f(c){if(t.Iterable.is(c)){const r=[];for(const h of c)if(h)try{h.dispose()}catch(C){r.push(C)}if(r.length===1)throw r[0];if(r.length>1)throw new AggregateError(r,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=f;function d(c){for(const r of c)y(r)&&r.dispose();return[]}e.disposeIfDisposable=d;function v(...c){const r=a(()=>f(c));return p(c,r),r}e.combinedDisposable=v;function a(c){const r=I({dispose:(0,S.once)(()=>{m(r),c()})});return r}e.toDisposable=a;class u{constructor(){this.c=new Set,this.f=!1,I(this)}dispose(){this.f||(m(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{f(this.c)}finally{this.c.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return w(r,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(r),r}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this.q=new u,I(this),w(this.q,this)}dispose(){m(this),this.q.dispose()}B(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(r)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class k{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(r){this.b||r===this.a||(this.a?.dispose(),r&&w(r,this),this.a=r)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const r=this.a;return this.a=void 0,r&&w(r,null),r}}e.MutableDisposable=k;class E{constructor(r){this.b=r,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=E;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(r){let h=r;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,m(this))},this}}e.SafeDisposable=D;class i{constructor(){this.a=new Map}acquire(r,...h){let C=this.a.get(r);C||(C={counter:0,object:this.b(r,...h)},this.a.set(r,C));const{object:L}=C,O=(0,S.once)(()=>{--C.counter===0&&(this.c(r,C.object),this.a.delete(r))});return C.counter++,{object:L,dispose:O}}}e.ReferenceCollection=i;class l{constructor(r){this.a=r}async acquire(r,...h){const C=this.a.acquire(r,...h);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(L){throw C.dispose(),L}}}e.AsyncReferenceCollection=l;class n{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=n;function s(c){const r=new u;try{c(r)}finally{r.dispose()}}e.disposeOnReturn=s;class o{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(r){return this.a.has(r)}get(r){return this.a.get(r)}set(r,h,C=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),C||this.a.get(r)?.dispose(),this.a.set(r,h)}deleteAndDispose(r){this.a.get(r)?.dispose(),this.a.delete(r)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(ee[97],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class S{constructor(R){this.element=R,this.next=S.Undefined,this.prev=S.Undefined}}S.Undefined=new S(void 0);class t{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let R=this.a;for(;R!==S.Undefined;){const M=R.next;R.prev=S.Undefined,R.next=S.Undefined,R=M}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,M){const I=new S(R);if(this.a===S.Undefined)this.a=I,this.b=I;else if(M){const w=this.b;this.b=I,I.prev=w,w.next=I}else{const w=this.a;this.a=I,I.next=w,w.prev=I}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(I))}}shift(){if(this.a!==S.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==S.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==S.Undefined&&R.next!==S.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===S.Undefined&&R.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):R.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):R.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==S.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ee[40],te([0,1]),function(H,e){"use strict";var S,t,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(d,v,a){let u=d.get(v);return u===void 0&&(u=a,d.set(v,u)),u}e.getOrSet=R;function M(d){const v=[];return d.forEach((a,u)=>{v.push(`${u} => ${a}`)}),`Map(${d.size}) {${v.join(", ")}}`}e.mapToString=M;function I(d){const v=[];return d.forEach(a=>{v.push(a)}),`Set(${d.size}) {${v.join(", ")}}`}e.setToString=I;class m{constructor(v,a){this.uri=v,this.value=a}}class w{constructor(v,a){this[S]="ResourceMap",v instanceof w?(this.b=new Map(v.b),this.c=a??w.a):(this.b=new Map,this.c=v??w.a)}set(v,a){return this.b.set(this.c(v),new m(v,a)),this}get(v){return this.b.get(this.c(v))?.value}has(v){return this.b.has(this.c(v))}get size(){return this.b.size}clear(){this.b.clear()}delete(v){return this.b.delete(this.c(v))}forEach(v,a){typeof a<"u"&&(v=v.bind(a));for(const[u,g]of this.b)v(g.value,g.uri,this)}*values(){for(const v of this.b.values())yield v.value}*keys(){for(const v of this.b.values())yield v.uri}*entries(){for(const v of this.b.values())yield[v.uri,v.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,v]of this.b)yield[v.uri,v.value]}}e.ResourceMap=w,w.a=d=>d.toString();class p{constructor(v,a){this[t]="ResourceSet",!v||typeof v=="function"?this.a=new w(v):(this.a=new w(a),v.forEach(this.add,this))}get size(){return this.a.size}add(v){return this.a.set(v,v),this}clear(){this.a.clear()}delete(v){return this.a.delete(v)}forEach(v,a){this.a.forEach((u,g)=>v.call(a,g,g,this))}has(v){return this.a.has(v)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var b;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class y{constructor(){this[P]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(v){return this.a.has(v)}get(v,a=0){const u=this.a.get(v);if(!!u)return a!==0&&this.j(u,a),u.value}set(v,a,u=0){let g=this.a.get(v);if(g)g.value=a,u!==0&&this.j(g,u);else{switch(g={key:v,value:a,next:void 0,previous:void 0},u){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(v,g),this.d++}return this}delete(v){return!!this.remove(v)}remove(v){const a=this.a.get(v);if(!!a)return this.a.delete(v),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const v=this.b;return this.a.delete(v.key),this.i(v),this.d--,v.value}forEach(v,a){const u=this.e;let g=this.b;for(;g;){if(a?v.bind(a)(g.value,g.key,this):v(g.value,g.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const v=this,a=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(v.e!==a)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:u.key,done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return g}values(){const v=this,a=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(v.e!==a)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:u.value,done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return g}entries(){const v=this,a=this.e;let u=this.b;const g={[Symbol.iterator](){return g},next(){if(v.e!==a)throw new Error("LinkedMap got modified during iteration.");if(u){const k={value:[u.key,u.value],done:!1};return u=u.next,k}else return{value:void 0,done:!0}}};return g}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(v){if(v>=this.size)return;if(v===0){this.clear();return}let a=this.b,u=this.size;for(;a&&u>v;)this.a.delete(a.key),a=a.next,u--;this.b=a,this.d=u,a&&(a.previous=void 0),this.e++}g(v){if(!this.b&&!this.c)this.c=v;else if(this.b)v.next=this.b,this.b.previous=v;else throw new Error("Invalid list");this.b=v,this.e++}h(v){if(!this.b&&!this.c)this.b=v;else if(this.c)v.previous=this.c,this.c.next=v;else throw new Error("Invalid list");this.c=v,this.e++}i(v){if(v===this.b&&v===this.c)this.b=void 0,this.c=void 0;else if(v===this.b){if(!v.next)throw new Error("Invalid list");v.next.previous=void 0,this.b=v.next}else if(v===this.c){if(!v.previous)throw new Error("Invalid list");v.previous.next=void 0,this.c=v.previous}else{const a=v.next,u=v.previous;if(!a||!u)throw new Error("Invalid list");a.previous=u,u.next=a}v.next=void 0,v.previous=void 0,this.e++}j(v,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(v===this.b)return;const u=v.next,g=v.previous;v===this.c?(g.next=void 0,this.c=g):(u.previous=g,g.next=u),v.previous=void 0,v.next=this.b,this.b.previous=v,this.b=v,this.e++}else if(a===2){if(v===this.c)return;const u=v.next,g=v.previous;v===this.b?(u.previous=void 0,this.b=u):(u.previous=g,g.next=u),v.next=void 0,v.previous=this.c,this.c.next=v,this.c=v,this.e++}}}toJSON(){const v=[];return this.forEach((a,u)=>{v.push([u,a])}),v}fromJSON(v){this.clear();for(const[a,u]of v)this.set(a,u)}}e.LinkedMap=y;class f extends y{constructor(v,a=1){super(),this.k=v,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(v){this.k=v,this.m()}get ratio(){return this.l}set ratio(v){this.l=Math.min(Math.max(0,v),1),this.m()}get(v,a=2){return super.get(v,a)}peek(v){return super.get(v,0)}set(v,a){return super.set(v,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=f}),define(ee[78],te([0,1,40]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new S.LRUCache(1e4);function P(w){return m(w,"NFC",t)}e.normalizeNFC=P;const R=new S.LRUCache(1e4);function M(w){return m(w,"NFD",R)}e.normalizeNFD=M;const I=/[^\u0000-\u0080]/;function m(w,p,b){if(!w)return w;const y=b.get(w);if(y)return y;let f;return I.test(w)?f=w.normalize(p):f=w,b.set(w,f),f}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(p){return M(p).replace(w,"")}}()}),define(ee[127],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function S(I,m,w){return Math.min(Math.max(I,m),w)}e.clamp=S;function t(I,m){return(m+I%m)%m}e.rot=t;class P{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=P;class R{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class M{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const w=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=M}),function(){function H(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function M(m){R.push(m,Date.now())}function I(){const m=[];for(let w=0;w<R.length;w+=2)m.push({name:R[w],startTime:R[w+1]});return m}return{mark:M,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(P+M.startTime)});return R}};if(typeof process=="object"){const P=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function S(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=S(t))}(),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var t in S)(typeof exports=="object"?exports:H)[t]=S[t]}}(typeof self<"u"?self:this,function(){return function(H){var e={};function S(t){if(e[t])return e[t].exports;var P=e[t]={i:t,l:!1,exports:{}};return H[t].call(P.exports,P,P.exports,S),P.l=!0,P.exports}return S.m=H,S.c=e,S.d=function(t,P,R){S.o(t,P)||Object.defineProperty(t,P,{enumerable:!0,get:R})},S.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},S.t=function(t,P){if(1&P&&(t=S(t)),8&P||4&P&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(S.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&P&&typeof t!="string")for(var M in t)S.d(R,M,function(I){return t[I]}.bind(null,M));return R},S.n=function(t){var P=t&&t.__esModule?function(){return t.default}:function(){return t};return S.d(P,"a",P),P},S.o=function(t,P){return Object.prototype.hasOwnProperty.call(t,P)},S.p="",S(S.s=0)}([function(H,e,S){(function(t){var P;e=H.exports=A,P=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],m=e.src=[],w=0,p=w++;m[p]="0|[1-9]\\d*";var b=w++;m[b]="[0-9]+";var y=w++;m[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=w++;m[f]="("+m[p]+")\\.("+m[p]+")\\.("+m[p]+")";var d=w++;m[d]="("+m[b]+")\\.("+m[b]+")\\.("+m[b]+")";var v=w++;m[v]="(?:"+m[p]+"|"+m[y]+")";var a=w++;m[a]="(?:"+m[b]+"|"+m[y]+")";var u=w++;m[u]="(?:-("+m[v]+"(?:\\."+m[v]+")*))";var g=w++;m[g]="(?:-?("+m[a]+"(?:\\."+m[a]+")*))";var k=w++;m[k]="[0-9A-Za-z-]+";var E=w++;m[E]="(?:\\+("+m[k]+"(?:\\."+m[k]+")*))";var D=w++,i="v?"+m[f]+m[u]+"?"+m[E]+"?";m[D]="^"+i+"$";var l="[v=\\s]*"+m[d]+m[g]+"?"+m[E]+"?",n=w++;m[n]="^"+l+"$";var s=w++;m[s]="((?:<|>)?=?)";var o=w++;m[o]=m[b]+"|x|X|\\*";var c=w++;m[c]=m[p]+"|x|X|\\*";var r=w++;m[r]="[v=\\s]*("+m[c]+")(?:\\.("+m[c]+")(?:\\.("+m[c]+")(?:"+m[u]+")?"+m[E]+"?)?)?";var h=w++;m[h]="[v=\\s]*("+m[o]+")(?:\\.("+m[o]+")(?:\\.("+m[o]+")(?:"+m[g]+")?"+m[E]+"?)?)?";var C=w++;m[C]="^"+m[s]+"\\s*"+m[r]+"$";var L=w++;m[L]="^"+m[s]+"\\s*"+m[h]+"$";var O=w++;m[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=w++;m[B]="(?:~>?)";var K=w++;m[K]="(\\s*)"+m[B]+"\\s+",I[K]=new RegExp(m[K],"g");var V=w++;m[V]="^"+m[B]+m[r]+"$";var J=w++;m[J]="^"+m[B]+m[h]+"$";var re=w++;m[re]="(?:\\^)";var se=w++;m[se]="(\\s*)"+m[re]+"\\s+",I[se]=new RegExp(m[se],"g");var ae=w++;m[ae]="^"+m[re]+m[r]+"$";var fe=w++;m[fe]="^"+m[re]+m[h]+"$";var ge=w++;m[ge]="^"+m[s]+"\\s*("+l+")$|^$";var q=w++;m[q]="^"+m[s]+"\\s*("+i+")$|^$";var T=w++;m[T]="(\\s*)"+m[s]+"\\s*("+l+"|"+m[r]+")",I[T]=new RegExp(m[T],"g");var U=w++;m[U]="^\\s*("+m[r]+")\\s+-\\s+("+m[r]+")\\s*$";var z=w++;m[z]="^\\s*("+m[h]+")\\s+-\\s+("+m[h]+")\\s*$";var Q=w++;m[Q]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)P(ne,m[ne]),I[ne]||(I[ne]=new RegExp(m[ne]));function x(ie,ue){if(ie instanceof A)return ie;if(typeof ie!="string"||ie.length>R||!(ue?I[n]:I[D]).test(ie))return null;try{return new A(ie,ue)}catch{return null}}function A(ie,ue){if(ie instanceof A){if(ie.loose===ue)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof A))return new A(ie,ue);P("SemVer",ie,ue),this.loose=ue;var he=ie.trim().match(ue?I[n]:I[D]);if(!he)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ce=+be;if(Ce>=0&&Ce<M)return Ce}return be}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=x,e.valid=function(ie,ue){var he=x(ie,ue);return he?he.version:null},e.clean=function(ie,ue){var he=x(ie.trim().replace(/^[=v]+/,""),ue);return he?he.version:null},e.SemVer=A,A.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},A.prototype.toString=function(){return this.version},A.prototype.compare=function(ie){return P("SemVer.compare",this.version,this.loose,ie),ie instanceof A||(ie=new A(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},A.prototype.compareMain=function(ie){return ie instanceof A||(ie=new A(ie,this.loose)),W(this.major,ie.major)||W(this.minor,ie.minor)||W(this.patch,ie.patch)},A.prototype.comparePre=function(ie){if(ie instanceof A||(ie=new A(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ue=0;do{var he=this.prerelease[ue],be=ie.prerelease[ue];if(P("prerelease compare",ue,he,be),he===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(he===void 0)return-1;if(he!==be)return W(he,be)}while(++ue)},A.prototype.inc=function(ie,ue){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ue,he,be){typeof he=="string"&&(be=he,he=void 0);try{return new A(ie,he).inc(ue,be).version}catch{return null}},e.diff=function(ie,ue){if(j(ie,ue))return null;var he=x(ie),be=x(ue);if(he.prerelease.length||be.prerelease.length){for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==be[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in he)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&he[Ce]!==be[Ce])return Ce},e.compareIdentifiers=W;var F=/^[0-9]+$/;function W(ie,ue){var he=F.test(ie),be=F.test(ue);return he&&be&&(ie=+ie,ue=+ue),he&&!be?-1:be&&!he?1:ie<ue?-1:ie>ue?1:0}function N(ie,ue,he){return new A(ie,he).compare(new A(ue,he))}function $(ie,ue,he){return N(ie,ue,he)>0}function G(ie,ue,he){return N(ie,ue,he)<0}function j(ie,ue,he){return N(ie,ue,he)===0}function X(ie,ue,he){return N(ie,ue,he)!==0}function Z(ie,ue,he){return N(ie,ue,he)>=0}function oe(ie,ue,he){return N(ie,ue,he)<=0}function de(ie,ue,he,be){var Ce;switch(ue){case"===":typeof ie=="object"&&(ie=ie.version),typeof he=="object"&&(he=he.version),Ce=ie===he;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof he=="object"&&(he=he.version),Ce=ie!==he;break;case"":case"=":case"==":Ce=j(ie,he,be);break;case"!=":Ce=X(ie,he,be);break;case">":Ce=$(ie,he,be);break;case">=":Ce=Z(ie,he,be);break;case"<":Ce=G(ie,he,be);break;case"<=":Ce=oe(ie,he,be);break;default:throw new TypeError("Invalid operator: "+ue)}return Ce}function ke(ie,ue){if(ie instanceof ke){if(ie.loose===ue)return ie;ie=ie.value}if(!(this instanceof ke))return new ke(ie,ue);P("comparator",ie,ue),this.loose=ue,this.parse(ie),this.semver===De?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(ie,ue){return W(ue,ie)},e.major=function(ie,ue){return new A(ie,ue).major},e.minor=function(ie,ue){return new A(ie,ue).minor},e.patch=function(ie,ue){return new A(ie,ue).patch},e.compare=N,e.compareLoose=function(ie,ue){return N(ie,ue,!0)},e.rcompare=function(ie,ue,he){return N(ue,ie,he)},e.sort=function(ie,ue){return ie.sort(function(he,be){return e.compare(he,be,ue)})},e.rsort=function(ie,ue){return ie.sort(function(he,be){return e.rcompare(he,be,ue)})},e.gt=$,e.lt=G,e.eq=j,e.neq=X,e.gte=Z,e.lte=oe,e.cmp=de,e.Comparator=ke;var De={};function Pe(ie,ue){if(ie instanceof Pe)return ie.loose===ue?ie:new Pe(ie.raw,ue);if(ie instanceof ke)return new Pe(ie.value,ue);if(!(this instanceof Pe))return new Pe(ie,ue);if(this.loose=ue,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function Ae(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function ve(ie,ue,he,be,Ce,We,Te,qe,Ue,Be,Xe,$e,Ke){return((ue=Ae(he)?"":Ae(be)?">="+he+".0.0":Ae(Ce)?">="+he+"."+be+".0":">="+ue)+" "+(qe=Ae(Ue)?"":Ae(Be)?"<"+(+Ue+1)+".0.0":Ae(Xe)?"<"+Ue+"."+(+Be+1)+".0":$e?"<="+Ue+"."+Be+"."+Xe+"-"+$e:"<="+qe)).trim()}function me(ie,ue){for(var he=0;he<ie.length;he++)if(!ie[he].test(ue))return!1;if(ue.prerelease.length){for(he=0;he<ie.length;he++)if(P(ie[he].semver),ie[he].semver!==De&&ie[he].semver.prerelease.length>0){var be=ie[he].semver;if(be.major===ue.major&&be.minor===ue.minor&&be.patch===ue.patch)return!0}return!1}return!0}function ye(ie,ue,he){try{ue=new Pe(ue,he)}catch{return!1}return ue.test(ie)}function Me(ie,ue,he,be){var Ce,We,Te,qe,Ue;switch(ie=new A(ie,be),ue=new Pe(ue,be),he){case">":Ce=$,We=oe,Te=G,qe=">",Ue=">=";break;case"<":Ce=G,We=Z,Te=$,qe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(ie,ue,be))return!1;for(var Be=0;Be<ue.set.length;++Be){var Xe=ue.set[Be],$e=null,Ke=null;if(Xe.forEach(function(Y){Y.semver===De&&(Y=new ke(">=0.0.0")),$e=$e||Y,Ke=Ke||Y,Ce(Y.semver,$e.semver,be)?$e=Y:Te(Y.semver,Ke.semver,be)&&(Ke=Y)}),$e.operator===qe||$e.operator===Ue||(!Ke.operator||Ke.operator===qe)&&We(ie,Ke.semver)||Ke.operator===Ue&&Te(ie,Ke.semver))return!1}return!0}ke.prototype.parse=function(ie){var ue=this.loose?I[ge]:I[q],he=ie.match(ue);if(!he)throw new TypeError("Invalid comparator: "+ie);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new A(he[2],this.loose):this.semver=De},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(ie){return P("Comparator.test",ie,this.loose),this.semver===De||(typeof ie=="string"&&(ie=new A(ie,this.loose)),de(ie,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(ie,ue){if(!(ie instanceof ke))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Pe(ie.value,ue),ye(this.value,he,ue);if(ie.operator==="")return he=new Pe(this.value,ue),ye(ie.semver,he,ue);var be=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),We=this.semver.version===ie.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),qe=de(this.semver,"<",ie.semver,ue)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),Ue=de(this.semver,">",ie.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return be||Ce||We&&Te||qe||Ue},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(ie){var ue=this.loose;ie=ie.trim(),P("range",ie,ue);var he=ue?I[z]:I[U];ie=ie.replace(he,ve),P("hyphen replace",ie),ie=ie.replace(I[T],"$1$2$3"),P("comparator trim",ie,I[T]),ie=(ie=(ie=ie.replace(I[K],"$1~")).replace(I[se],"$1^")).split(/\s+/).join(" ");var be=ue?I[ge]:I[q],Ce=ie.split(" ").map(function(We){return function(Te,qe){return P("comp",Te),Te=function(Ue,Be){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){P("caret",$e,Ke);var Y=Ke?I[fe]:I[ae];return $e.replace(Y,function(ce,le,we,Se,Oe){var je;return P("caret",$e,ce,le,we,Se,Oe),Ae(le)?je="":Ae(we)?je=">="+le+".0.0 <"+(+le+1)+".0.0":Ae(Se)?je=le==="0"?">="+le+"."+we+".0 <"+le+"."+(+we+1)+".0":">="+le+"."+we+".0 <"+(+le+1)+".0.0":Oe?(P("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),je=le==="0"?we==="0"?">="+le+"."+we+"."+Se+Oe+" <"+le+"."+we+"."+(+Se+1):">="+le+"."+we+"."+Se+Oe+" <"+le+"."+(+we+1)+".0":">="+le+"."+we+"."+Se+Oe+" <"+(+le+1)+".0.0"):(P("no pr"),je=le==="0"?we==="0"?">="+le+"."+we+"."+Se+" <"+le+"."+we+"."+(+Se+1):">="+le+"."+we+"."+Se+" <"+le+"."+(+we+1)+".0":">="+le+"."+we+"."+Se+" <"+(+le+1)+".0.0"),P("caret return",je),je})}(Xe,Be)}).join(" ")}(Te,qe),P("caret",Te),Te=function(Ue,Be){return Ue.trim().split(/\s+/).map(function(Xe){return function($e,Ke){var Y=Ke?I[J]:I[V];return $e.replace(Y,function(ce,le,we,Se,Oe){var je;return P("tilde",$e,ce,le,we,Se,Oe),Ae(le)?je="":Ae(we)?je=">="+le+".0.0 <"+(+le+1)+".0.0":Ae(Se)?je=">="+le+"."+we+".0 <"+le+"."+(+we+1)+".0":Oe?(P("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),je=">="+le+"."+we+"."+Se+Oe+" <"+le+"."+(+we+1)+".0"):je=">="+le+"."+we+"."+Se+" <"+le+"."+(+we+1)+".0",P("tilde return",je),je})}(Xe,Be)}).join(" ")}(Te,qe),P("tildes",Te),Te=function(Ue,Be){return P("replaceXRanges",Ue,Be),Ue.split(/\s+/).map(function(Xe){return function($e,Ke){$e=$e.trim();var Y=Ke?I[L]:I[C];return $e.replace(Y,function(ce,le,we,Se,Oe,je){P("xRange",$e,ce,le,we,Se,Oe,je);var it=Ae(we),xe=it||Ae(Se),He=xe||Ae(Oe);return le==="="&&He&&(le=""),it?ce=le===">"||le==="<"?"<0.0.0":"*":le&&He?(xe&&(Se=0),He&&(Oe=0),le===">"?(le=">=",xe?(we=+we+1,Se=0,Oe=0):He&&(Se=+Se+1,Oe=0)):le==="<="&&(le="<",xe?we=+we+1:Se=+Se+1),ce=le+we+"."+Se+"."+Oe):xe?ce=">="+we+".0.0 <"+(+we+1)+".0.0":He&&(ce=">="+we+"."+Se+".0 <"+we+"."+(+Se+1)+".0"),P("xRange return",ce),ce})}(Xe,Be)}).join(" ")}(Te,qe),P("xrange",Te),Te=function(Ue,Be){return P("replaceStars",Ue,Be),Ue.trim().replace(I[Q],"")}(Te,qe),P("stars",Te),Te}(We,ue)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(We){return!!We.match(be)})),Ce=Ce.map(function(We){return new ke(We,ue)})},Pe.prototype.intersects=function(ie,ue){if(!(ie instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(be){return ie.set.some(function(Ce){return Ce.every(function(We){return be.intersects(We,ue)})})})})},e.toComparators=function(ie,ue){return new Pe(ie,ue).set.map(function(he){return he.map(function(be){return be.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new A(ie,this.loose));for(var ue=0;ue<this.set.length;ue++)if(me(this.set[ue],ie))return!0;return!1},e.satisfies=ye,e.maxSatisfying=function(ie,ue,he){var be=null,Ce=null;try{var We=new Pe(ue,he)}catch{return null}return ie.forEach(function(Te){We.test(Te)&&(be&&Ce.compare(Te)!==-1||(Ce=new A(be=Te,he)))}),be},e.minSatisfying=function(ie,ue,he){var be=null,Ce=null;try{var We=new Pe(ue,he)}catch{return null}return ie.forEach(function(Te){We.test(Te)&&(be&&Ce.compare(Te)!==1||(Ce=new A(be=Te,he)))}),be},e.validRange=function(ie,ue){try{return new Pe(ie,ue).range||"*"}catch{return null}},e.ltr=function(ie,ue,he){return Me(ie,ue,"<",he)},e.gtr=function(ie,ue,he){return Me(ie,ue,">",he)},e.outside=Me,e.prerelease=function(ie,ue){var he=x(ie,ue);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(ie,ue,he){return ie=new Pe(ie,he),ue=new Pe(ue,he),ie.intersects(ue)},e.coerce=function(ie){if(ie instanceof A)return ie;if(typeof ie!="string")return null;var ue=ie.match(I[O]);return ue==null?null:x((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,S(1))},function(H,e){var S,t,P=H.exports={};function R(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function I(a){if(S===setTimeout)return setTimeout(a,0);if((S===R||!S)&&setTimeout)return S=setTimeout,setTimeout(a,0);try{return S(a,0)}catch{try{return S.call(null,a,0)}catch{return S.call(this,a,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:R}catch{S=R}try{t=typeof clearTimeout=="function"?clearTimeout:M}catch{t=M}})();var m,w=[],p=!1,b=-1;function y(){p&&m&&(p=!1,m.length?w=m.concat(w):b=-1,w.length&&f())}function f(){if(!p){var a=I(y);p=!0;for(var u=w.length;u;){for(m=w,w=[];++b<u;)m&&m[b].run();b=-1,u=w.length}m=null,p=!1,function(g){if(t===clearTimeout)return clearTimeout(g);if((t===M||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(g);try{t(g)}catch{try{return t.call(null,g)}catch{return t.call(this,g)}}}(a)}}function d(a,u){this.fun=a,this.array=u}function v(){}P.nextTick=function(a){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];w.push(new d(a,u)),w.length!==1||p||I(f)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=v,P.addListener=v,P.once=v,P.off=v,P.removeListener=v,P.removeAllListeners=v,P.emit=v,P.prependListener=v,P.prependOnceListener=v,P.listeners=function(a){return[]},P.binding=function(a){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(a){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(ee[128],te([0,1]),function(H,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(I,m,w){this.level=I,this.key=m,this.value=w,this.forward=[]}}const P=void 0;class R{constructor(I,m=2**16){this.comparator=I,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(m)|0),this.e=new t(this.c,P,P)}get size(){return this.f}clear(){this.e=new t(this.c,P,P)}has(I){return Boolean(R.g(this,I,this.comparator))}get(I){return R.g(this,I,this.comparator)?.value}set(I,m){return R.h(this,I,m,this.comparator)&&(this.f+=1),this}delete(I){const m=R.k(this,I,this.comparator);return m&&(this.f-=1),m}forEach(I,m){let w=this.e.forward[0];for(;w;)I.call(m,w.value,w.key,this),w=w.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",m=this.e.forward[0];for(;m;)I+=`node(${m.key}, ${m.value}, lvl:${m.level})`,m=m.forward[0];return I}static g(I,m,w){let p=I.e;for(let b=I.d-1;b>=0;b--)for(;p.forward[b]&&w(p.forward[b].key,m)<0;)p=p.forward[b];if(p=p.forward[0],p&&w(p.key,m)===0)return p}static h(I,m,w,p){const b=[];let y=I.e;for(let f=I.d-1;f>=0;f--){for(;y.forward[f]&&p(y.forward[f].key,m)<0;)y=y.forward[f];b[f]=y}if(y=y.forward[0],y&&p(y.key,m)===0)return y.value=w,!1;{const f=R.j(I);if(f>I.d){for(let d=I.d;d<f;d++)b[d]=I.e;I.d=f}y=new t(f,m,w);for(let d=0;d<f;d++)y.forward[d]=b[d].forward[d],b[d].forward[d]=y;return!0}}static j(I,m=.5){let w=1;for(;Math.random()<m&&w<I.c;)w+=1;return w}static k(I,m,w){const p=[];let b=I.e;for(let y=I.d-1;y>=0;y--){for(;b.forward[y]&&w(b.forward[y].key,m)<0;)b=b.forward[y];p[y]=b}if(b=b.forward[0],!b||w(b.key,m)!==0)return!1;for(let y=0;y<I.d&&p[y].forward[y]===b;y++)p[y].forward[y]=b.forward[y];for(;I.d>0&&I.e.forward[I.d-1]===P;)I.d-=1;return!0}}e.SkipList=R}),define(ee[59],te([0,1,13,2]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function P(E){const D=E;return D?typeof D.read=="function":!1}e.isReadable=P;function R(E){const D=E;return D?[D.on,D.pause,D.resume,D.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function M(E){const D=E;return D?R(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=M;function I(E,D){return new m(E,D)}e.newWriteableStream=I;class m{constructor(D,i){this.e=D,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(D){if(!this.a.destroyed){if(this.a.flowing)this.g(D);else if(this.b.data.push(D),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(D){this.a.destroyed||(this.a.flowing?this.h(D):this.b.error.push(D))}end(D){this.a.destroyed||(typeof D<"u"&&this.write(D),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(D){this.c.data.slice(0).forEach(i=>i(D))}h(D){this.c.error.length===0?(0,S.onUnexpectedError)(D):this.c.error.slice(0).forEach(i=>i(D))}i(){this.c.end.slice(0).forEach(D=>D())}on(D,i){if(!this.a.destroyed)switch(D){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(D,i){if(this.a.destroyed)return;let l;switch(D){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const n=l.indexOf(i);n>=0&&l.splice(n,1)}}j(){if(this.b.data.length>0){const D=this.e(this.b.data);this.g(D),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const D of this.b.error)this.h(D);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(E,D){const i=[];let l;for(;(l=E.read())!==null;)i.push(l);return D(i)}e.consumeReadable=w;function p(E,D,i){const l=[];let n;for(;(n=E.read())!==null&&l.length<i;)l.push(n);return n===null&&l.length>0?D(l):{read:()=>{if(l.length>0)return l.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return E.read()}}}e.peekReadable=p;function b(E,D){return new Promise((i,l)=>{const n=[];y(E,{onData:s=>{D&&n.push(s)},onError:s=>{D?l(s):i(void 0)},onEnd:()=>{i(D?D(n):void 0)}})})}e.consumeStream=b;function y(E,D){let i=!1;return E.on("error",l=>{i||D.onError(l)}),E.on("end",()=>{i||D.onEnd()}),E.on("data",l=>{i||D.onData(l)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=y;function f(E,D){return new Promise((i,l)=>{const n=new t.DisposableStore,s=[],o=h=>{if(s.push(h),s.length>D)return n.dispose(),E.pause(),i({stream:E,buffer:s,ended:!1})},c=h=>l(h),r=()=>i({stream:E,buffer:s,ended:!0});n.add((0,t.toDisposable)(()=>E.removeListener("error",c))),E.on("error",c),n.add((0,t.toDisposable)(()=>E.removeListener("end",r))),E.on("end",r),n.add((0,t.toDisposable)(()=>E.removeListener("data",o))),E.on("data",o)})}e.peekStream=f;function d(E,D){const i=I(D);return i.end(E),i}e.toStream=d;function v(){const E=I(()=>{throw new Error("not supported")});return E.end(),E}e.emptyStream=v;function a(E){let D=!1;return{read:()=>D?null:(D=!0,E)}}e.toReadable=a;function u(E,D,i){const l=I(i);return y(E,{onData:n=>l.write(D.data(n)),onError:n=>l.error(D.error?D.error(n):n),onEnd:()=>l.end()}),l}e.transform=u;function g(E,D,i){let l=!1;return{read:()=>{const n=D.read();return l?n:(l=!0,n!==null?i([E,n]):E)}}}e.prefixedReadable=g;function k(E,D,i){let l=!1;const n=I(i);return y(D,{onData:s=>l?n.write(s):(l=!0,n.write(i([E,s]))),onError:s=>n.error(s),onEnd:()=>{l||(l=!0,n.write(E)),n.end()}}),n}e.prefixedStream=k}),define(ee[17],te([0,1,59]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let P,R;class M{static alloc(h){return t?new M(Buffer.allocUnsafe(h)):new M(new Uint8Array(h))}static wrap(h){return t&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new M(h)}static fromString(h,C){return!(C?.dontUseNodeBuffer||!1)&&t?new M(Buffer.from(h)):(P||(P=new TextEncoder),new M(P.encode(h)))}static fromByteArray(h){const C=M.alloc(h.length);for(let L=0,O=h.length;L<O;L++)C.buffer[L]=h[L];return C}static concat(h,C){if(typeof C>"u"){C=0;for(let B=0,K=h.length;B<K;B++)C+=h[B].byteLength}const L=M.alloc(C);let O=0;for(let B=0,K=h.length;B<K;B++){const V=h[B];L.set(V,O),O+=V.byteLength}return L}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=M.alloc(this.byteLength);return h.set(this),h}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(h,C){return new M(this.buffer.subarray(h,C))}set(h,C){if(h instanceof M)this.buffer.set(h.buffer,C);else if(h instanceof Uint8Array)this.buffer.set(h,C);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),C);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return w(this.buffer,h)}writeUInt32BE(h,C){p(this.buffer,h,C)}readUInt32LE(h){return b(this.buffer,h)}writeUInt32LE(h,C){y(this.buffer,h,C)}readUInt8(h){return f(this.buffer,h)}writeUInt8(h,C){d(this.buffer,h,C)}}e.VSBuffer=M;function I(r,h){return r[h+0]<<0>>>0|r[h+1]<<8>>>0}e.readUInt16LE=I;function m(r,h,C){r[C+0]=h&255,h=h>>>8,r[C+1]=h&255}e.writeUInt16LE=m;function w(r,h){return r[h]*2**24+r[h+1]*2**16+r[h+2]*2**8+r[h+3]}e.readUInt32BE=w;function p(r,h,C){r[C+3]=h,h=h>>>8,r[C+2]=h,h=h>>>8,r[C+1]=h,h=h>>>8,r[C]=h}e.writeUInt32BE=p;function b(r,h){return r[h+0]<<0>>>0|r[h+1]<<8>>>0|r[h+2]<<16>>>0|r[h+3]<<24>>>0}e.readUInt32LE=b;function y(r,h,C){r[C+0]=h&255,h=h>>>8,r[C+1]=h&255,h=h>>>8,r[C+2]=h&255,h=h>>>8,r[C+3]=h&255}e.writeUInt32LE=y;function f(r,h){return r[h]}e.readUInt8=f;function d(r,h,C){r[C]=h}e.writeUInt8=d;function v(r){return S.consumeReadable(r,h=>M.concat(h))}e.readableToBuffer=v;function a(r){return S.toReadable(r)}e.bufferToReadable=a;function u(r){return S.consumeStream(r,h=>M.concat(h))}e.streamToBuffer=u;async function g(r){return r.ended?M.concat(r.buffer):M.concat([...r.buffer,await u(r.stream)])}e.bufferedStreamToBuffer=g;function k(r){return S.toStream(r,h=>M.concat(h))}e.bufferToStream=k;function E(r){return S.transform(r,{data:h=>typeof h=="string"?M.fromString(h):M.wrap(h)},h=>M.concat(h))}e.streamToBufferReadableStream=E;function D(r){return S.newWriteableStream(h=>M.concat(h),r)}e.newWriteableBufferStream=D;function i(r,h){return S.prefixedReadable(r,h,C=>M.concat(C))}e.prefixedBufferReadable=i;function l(r,h){return S.prefixedStream(r,h,C=>M.concat(C))}e.prefixedBufferStream=l;function n(r){let h=0,C=0,L=0;const O=new Uint8Array(Math.floor(r.length/4*3)),B=V=>{switch(C){case 3:O[L++]=h|V,C=0;break;case 2:O[L++]=h|V>>>2,h=V<<6,C=3;break;case 1:O[L++]=h|V>>>4,h=V<<4,C=2;break;default:h=V<<2,C=1}};for(let V=0;V<r.length;V++){const J=r.charCodeAt(V);if(J>=65&&J<=90)B(J-65);else if(J>=97&&J<=122)B(J-97+26);else if(J>=48&&J<=57)B(J-48+52);else if(J===43||J===45)B(62);else if(J===47||J===95)B(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${r[V]}`)}}const K=L;for(;C>0;)B(0);return M.wrap(O).slice(0,K)}e.decodeBase64=n;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:r},h=!0,C=!1){const L=C?o:s;let O="";const B=r.byteLength%3;let K=0;for(;K<r.byteLength-B;K+=3){const V=r[K+0],J=r[K+1],re=r[K+2];O+=L[V>>>2],O+=L[(V<<4|J>>>4)&63],O+=L[(J<<2|re>>>6)&63],O+=L[re&63]}if(B===1){const V=r[K+0];O+=L[V>>>2],O+=L[V<<4&63],h&&(O+="==")}else if(B===2){const V=r[K+0],J=r[K+1];O+=L[V>>>2],O+=L[(V<<4|J>>>4)&63],O+=L[J<<2&63],h&&(O+="=")}return O}e.encodeBase64=c}),define(ee[11],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function S(l){return typeof l=="string"}e.isString=S;function t(l){return Array.isArray(l)&&l.every(n=>S(n))}e.isStringArray=t;function P(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=P;function R(l){const n=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof n}e.isTypedArray=R;function M(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=M;function I(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=I;function m(l){return l===!0||l===!1}e.isBoolean=m;function w(l){return typeof l>"u"}e.isUndefined=w;function p(l){return!b(l)}e.isDefined=p;function b(l){return w(l)||l===null}e.isUndefinedOrNull=b;function y(l,n){if(!l)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=y;function f(l){if(b(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=f;function d(...l){const n=[];for(let s=0;s<l.length;s++){const o=l[s];if(b(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(o)}return n}e.assertAllDefined=d;const v=Object.prototype.hasOwnProperty;function a(l){if(!P(l))return!1;for(const n in l)if(v.call(l,n))return!1;return!0}e.isEmptyObject=a;function u(l){return typeof l=="function"}e.isFunction=u;function g(...l){return l.length>0&&l.every(u)}e.areFunctions=g;function k(l,n){const s=Math.min(l.length,n.length);for(let o=0;o<s;o++)E(l[o],n[o])}e.validateConstraints=k;function E(l,n){if(S(n)){if(typeof l!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(u(n)){try{if(l instanceof n)return}catch{}if(!b(l)&&l.constructor===n||n.length===1&&n.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=E;function D(l){return l===null?void 0:l}e.withNullAsUndefined=D;function i(l){return typeof l>"u"?null:l}e.withUndefinedAsNull=i}),define(ee[44],te([0,1,11]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([k,E])=>{g[k]=E&&typeof E=="object"?t(E):E}),g}e.deepClone=t;function P(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const k=g.shift();Object.freeze(k);for(const E in k)if(R.call(k,E)){const D=k[E];typeof D=="object"&&!Object.isFrozen(D)&&!(0,S.isTypedArray)(D)&&g.push(D)}}return u}e.deepFreeze=P;const R=Object.prototype.hasOwnProperty;function M(u,g){return I(u,g,new Set)}e.cloneAndChange=M;function I(u,g,k){if((0,S.isUndefinedOrNull)(u))return u;const E=g(u);if(typeof E<"u")return E;if(Array.isArray(u)){const D=[];for(const i of u)D.push(I(i,g,k));return D}if((0,S.isObject)(u)){if(k.has(u))throw new Error("Cannot clone recursive data-structure");k.add(u);const D={};for(const i in u)R.call(u,i)&&(D[i]=I(u[i],g,k));return k.delete(u),D}return u}function m(u,g,k=!0){return(0,S.isObject)(u)?((0,S.isObject)(g)&&Object.keys(g).forEach(E=>{E in u?k&&((0,S.isObject)(u[E])&&(0,S.isObject)(g[E])?m(u[E],g[E],k):u[E]=g[E]):u[E]=g[E]}),u):g}e.mixin=m;function w(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let k,E;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(k=0;k<u.length;k++)if(!w(u[k],g[k]))return!1}else{const D=[];for(E in u)D.push(E);D.sort();const i=[];for(E in g)i.push(E);if(i.sort(),!w(D,i))return!1;for(k=0;k<D.length;k++)if(!w(u[D[k]],g[D[k]]))return!1}return!0}e.equals=w;function p(u){const g=new Set;return JSON.stringify(u,(k,E)=>{if((0,S.isObject)(E)||Array.isArray(E)){if(g.has(E))return"[Circular]";g.add(E)}return E})}e.safeStringify=p;function b(u,g){const k=Object.create(null);return!u||!g||Object.keys(g).forEach(D=>{const i=u[D],l=g[D];w(i,l)||(k[D]=l)}),k}e.distinct=b;function y(u,g){const k=g.toLowerCase(),E=Object.keys(u).find(D=>D.toLowerCase()===k);return E?u[E]:u[g]}e.getCaseInsensitive=y;function f(u,g){const k=Object.create(null);for(const[E,D]of Object.entries(u))g(E,D)&&(k[E]=D);return k}e.filter=f;function d(u){let g=[],k=Object.getPrototypeOf(u);for(;Object.prototype!==k;)g=g.concat(Object.getOwnPropertyNames(k)),k=Object.getPrototypeOf(k);return g}e.getAllPropertyNames=d;function v(u){const g=[];for(const k of d(u))typeof u[k]=="function"&&g.push(k);return g}e.getAllMethodNames=v;function a(u,g){const k=D=>function(){const i=Array.prototype.slice.call(arguments,0);return g(D,i)},E={};for(const D of u)E[D]=k(D);return E}e.createProxyObject=a}),define(ee[31],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(P){return S.test(P)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(I){for(let m=0;m<I.length;m++)I[m]=Math.floor(Math.random()*256);return I};const R=new Uint8Array(16),M=[];for(let I=0;I<256;I++)M.push(I.toString(16).padStart(2,"0"));return function(){P(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let m=0,w="";return w+=M[R[m++]],w+=M[R[m++]],w+=M[R[m++]],w+=M[R[m++]],w+="-",w+=M[R[m++]],w+=M[R[m++]],w+="-",w+=M[R[m++]],w+=M[R[m++]],w+="-",w+=M[R[m++]],w+=M[R[m++]],w+="-",w+=M[R[m++]],w+=M[R[m++]],w+=M[R[m++]],w+=M[R[m++]],w+=M[R[m++]],w+=M[R[m++]],w}}()}),define(ee[129],te([0,1,79,41,50]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(M,I){if(await new Promise((p,b)=>{const y=t.createReadStream(M),f=S.createHash("sha1");y.pipe(f);const d=(0,P.once)((v,a)=>{y.removeAllListeners(),f.removeAllListeners(),v?b(v):p(a)});y.once("error",d),y.once("end",d),f.once("error",d),f.once("data",v=>d(void 0,v.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=R}),define(ee[130],te([0,1,26]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(M){const I=M.replace(/\-/g,":").toLowerCase();return!t.has(I)}function R(){const M=(0,S.networkInterfaces)();for(const I in M){const m=M[I];if(m){for(const{mac:w}of m)if(P(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(ee[98],te([0,1,80]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(I,m,w,p=1){let b=!1;return new Promise(y=>{const f=setTimeout(()=>{if(!b)return b=!0,y(0)},w);P(I,m,p,d=>{if(!b)return b=!0,clearTimeout(f),y(d)})})}e.findFreePort=t;function P(I,m,w,p){if(m===0)return p(0);const b=new S.Socket;b.once("connect",()=>(M(b),P(I+w,m-1,w,p))),b.once("data",()=>{}),b.once("error",y=>(M(b),y.code!=="ECONNREFUSED"?P(I+w,m-1,w,p):p(I))),b.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(I,m,w,p="127.0.0.1"){let b=!1,y,f=1;const d=S.createServer({pauseOnConnect:!0});function v(a,u){b||(b=!0,d.removeAllListeners(),d.close(),y&&clearTimeout(y),u(a))}return new Promise(a=>{y=setTimeout(()=>{v(0,a)},w),d.on("listening",()=>{v(I,a)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&f<m?(I++,f++,d.listen(I,p)):v(0,a)}),d.on("close",()=>{v(0,a)}),d.listen(I,p)})}e.findFreePortFaster=R;function M(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(m){console.error(m)}}}),define(ee[131],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[132],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class S{constructor(P,R){this.a=P,this.onMessage=R}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=S}),define(ee[42],te([0,1,14,13]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class P{constructor(){this.a=new WeakMap}on(M,I){const m=(w,...p)=>{this.b(M,w)&&I(w,...p)};return this.a.set(I,m),S.ipcMain.on(M,m),this}once(M,I){return S.ipcMain.once(M,(m,...w)=>{this.b(M,m)&&I(m,...w)}),this}handle(M,I){return S.ipcMain.handle(M,(m,...w)=>this.b(M,m)?I(m,...w):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return S.ipcMain.removeHandler(M),this}removeListener(M,I){const m=this.a.get(I);return m&&(S.ipcMain.removeListener(M,m),this.a.delete(I)),this}b(M,I){if(!M||!M.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const m=I.senderFrame,w=m.url;if(!w)return!0;let p="unknown";try{p=new URL(w).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${w}'.`),!1}return p!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${p}'.`),!1):m.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new P}),define(ee[133],te([0,1,14,42,11,131]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(m,w,p,b,y)=>{const f=I(m,b,p);f.popup({window:(0,P.withNullAsUndefined)(S.BrowserWindow.fromWebContents(m.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{f&&m.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=M;function I(m,w,p){const b=new S.Menu;return p.forEach(y=>{let f;y.type==="separator"?f=new S.MenuItem({type:y.type}):Array.isArray(y.submenu)?f=new S.MenuItem({submenu:I(m,w,y.submenu),label:y.label}):f=new S.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(d,v,a)=>m.sender.send(w,y.id,a)}),b.append(f)}),b}}),define(ee[99],te([0,1,14]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.canUseUtilityProcess=e.UtilityProcess=void 0,e.UtilityProcess=S.utilityProcess,e.canUseUtilityProcess=typeof e.UtilityProcess<"u"}),define(ee[134],te([12,10]),function(H,e){return H.create("vs/base/common/date",e)}),define(ee[135],te([0,1,134]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,P=t*60,R=P*24,M=R*7,I=R*30,m=R*365;function w(b,y,f,d){typeof b!="number"&&(b=b.getTime());const v=Math.round((new Date().getTime()-b)/1e3);if(v<-30)return(0,S.localize)(0,null,w(new Date().getTime()+v*1e3,!1));if(!d&&v<30)return(0,S.localize)(1,null);let a;return v<t?(a=v,y?a===1?f?(0,S.localize)(2,null,a):(0,S.localize)(3,null,a):f?(0,S.localize)(4,null,a):(0,S.localize)(5,null,a):a===1?f?(0,S.localize)(6,null,a):(0,S.localize)(7,null,a):f?(0,S.localize)(8,null,a):(0,S.localize)(9,null,a)):v<P?(a=Math.floor(v/t),y?a===1?f?(0,S.localize)(10,null,a):(0,S.localize)(11,null,a):f?(0,S.localize)(12,null,a):(0,S.localize)(13,null,a):a===1?f?(0,S.localize)(14,null,a):(0,S.localize)(15,null,a):f?(0,S.localize)(16,null,a):(0,S.localize)(17,null,a)):v<R?(a=Math.floor(v/P),y?a===1?f?(0,S.localize)(18,null,a):(0,S.localize)(19,null,a):f?(0,S.localize)(20,null,a):(0,S.localize)(21,null,a):a===1?f?(0,S.localize)(22,null,a):(0,S.localize)(23,null,a):f?(0,S.localize)(24,null,a):(0,S.localize)(25,null,a)):v<M?(a=Math.floor(v/R),y?a===1?(0,S.localize)(26,null,a):(0,S.localize)(27,null,a):a===1?(0,S.localize)(28,null,a):(0,S.localize)(29,null,a)):v<I?(a=Math.floor(v/M),y?a===1?f?(0,S.localize)(30,null,a):(0,S.localize)(31,null,a):f?(0,S.localize)(32,null,a):(0,S.localize)(33,null,a):a===1?f?(0,S.localize)(34,null,a):(0,S.localize)(35,null,a):f?(0,S.localize)(36,null,a):(0,S.localize)(37,null,a)):v<m?(a=Math.floor(v/I),y?a===1?f?(0,S.localize)(38,null,a):(0,S.localize)(39,null,a):f?(0,S.localize)(40,null,a):(0,S.localize)(41,null,a):a===1?f?(0,S.localize)(42,null,a):(0,S.localize)(43,null,a):f?(0,S.localize)(44,null,a):(0,S.localize)(45,null,a)):(a=Math.floor(v/m),y?a===1?f?(0,S.localize)(46,null,a):(0,S.localize)(47,null,a):f?(0,S.localize)(48,null,a):(0,S.localize)(49,null,a):a===1?f?(0,S.localize)(50,null,a):(0,S.localize)(51,null,a):f?(0,S.localize)(52,null,a):(0,S.localize)(53,null,a))}e.fromNow=w;function p(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=p}),define(ee[136],te([12,10]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(ee[45],te([0,1,25,11,136]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(b,y){return y&&(b.stack||b.stacktrace)?P.localize(0,null,I(b),M(b.stack)||M(b.stacktrace)):I(b)}function M(b){return Array.isArray(b)?b.join(`
`):b}function I(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?P.localize(1,null,b.message):b.message||P.localize(2,null)}function m(b=null,y=!1){if(!b)return P.localize(3,null);if(Array.isArray(b)){const f=S.coalesce(b),d=m(f[0],y);return f.length>1?P.localize(4,null,d,f.length):d}if(t.isString(b))return b;if(b.detail){const f=b.detail;if(f.error)return R(f.error,y);if(f.exception)return R(f.exception,y)}return b.stack?R(b,y):b.message?b.message:P.localize(5,null)}e.toErrorMessage=m;function w(b){const y=b;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=w;function p(b,y){let f;return typeof b=="string"?f=new Error(b):f=b,f.actions=y,f}e.createErrorWithActions=p}),define(ee[137],te([12,10]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(ee[138],te([0,1,137]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(P){switch(P){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(ee[139],te([12,10]),function(H,e){return H.create("vs/base/common/platform",e)}),define(ee[4],te([0,1,139]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,P=!1,R=!1,M=!1,I=!1,m=!1,w=!1,p=!1,b=!1,y=!1,f,d=e.LANGUAGE_DEFAULT,v,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",k=g&&u?.type==="renderer";if(typeof navigator=="object"&&!k)a=navigator.userAgent,t=a.indexOf("Windows")>=0,P=a.indexOf("Macintosh")>=0,p=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=a.indexOf("Linux")>=0,y=a?.indexOf("Mobi")>=0,m=!0,f=S.getConfiguredDefaultLocale(S.localize(0,null))||e.LANGUAGE_DEFAULT,d=f;else if(typeof u=="object"){t=u.platform==="win32",P=u.platform==="darwin",R=u.platform==="linux",M=R&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,w=g,b=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const r=u.env.VSCODE_NLS_CONFIG;if(r)try{const h=JSON.parse(r),C=h.availableLanguages["*"];f=h.locale,d=C||e.LANGUAGE_DEFAULT,v=h._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var E;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function D(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let i=0;P?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=P,e.isLinux=R,e.isLinuxSnap=M,e.isNative=I,e.isElectron=w,e.isWeb=m,e.isWebWorker=m&&typeof e.globals.importScripts=="function",e.isIOS=p,e.isMobile=y,e.isCI=b,e.platform=i,e.userAgent=a,e.language=d;var l;(function(r){function h(){return e.language}r.value=h;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=C;function L(){return e.language==="en"}r.isDefault=L})(l=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const r=[];e.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let L=0,O=r.length;L<O;L++){const B=r[L];if(B.id===C.data.vscodeScheduleAsyncWork){r.splice(L,1),B.callback();return}}});let h=0;return C=>{const L=++h;r.push({id:L,callback:C}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return r=>setTimeout(r)})();var n;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||p?2:t?1:3;let s=!0,o=!1;function c(){if(!o){o=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,s=new Uint16Array(r.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ee[35],te([0,1,4]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof S.globals.vscode<"u"&&typeof S.globals.vscode.process<"u"){const P=S.globals.vscode.process;t={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return S.isWindows?"win32":S.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ee[9],te([0,1,35]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,P=97,R=90,M=122,I=46,m=47,w=92,p=58,b=63;class y extends Error{constructor(l,n,s){let o;typeof n=="string"&&n.indexOf("not ")===0?(o="must not be",n=n.replace(/^not /,"")):o="must be";const c=l.indexOf(".")!==-1?"property":"argument";let r=`The "${l}" ${c} ${o} of type ${n}`;r+=`. Received type ${typeof s}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,l){if(i===null||typeof i!="object")throw new y(l,"Object",i)}function d(i,l){if(typeof i!="string")throw new y(l,"string",i)}const v=S.platform==="win32";function a(i){return i===m||i===w}function u(i){return i===m}function g(i){return i>=t&&i<=R||i>=P&&i<=M}function k(i,l,n,s){let o="",c=0,r=-1,h=0,C=0;for(let L=0;L<=i.length;++L){if(L<i.length)C=i.charCodeAt(L);else{if(s(C))break;C=m}if(s(C)){if(!(r===L-1||h===1))if(h===2){if(o.length<2||c!==2||o.charCodeAt(o.length-1)!==I||o.charCodeAt(o.length-2)!==I){if(o.length>2){const O=o.lastIndexOf(n);O===-1?(o="",c=0):(o=o.slice(0,O),c=o.length-1-o.lastIndexOf(n)),r=L,h=0;continue}else if(o.length!==0){o="",c=0,r=L,h=0;continue}}l&&(o+=o.length>0?`${n}..`:"..",c=2)}else o.length>0?o+=`${n}${i.slice(r+1,L)}`:o=i.slice(r+1,L),c=L-r-1;r=L,h=0}else C===I&&h!==-1?++h:h=-1}return o}function E(i,l){f(l,"pathObject");const n=l.dir||l.root,s=l.base||`${l.name||""}${l.ext||""}`;return n?n===l.root?`${n}${s}`:`${n}${i}${s}`:s}e.win32={resolve(...i){let l="",n="",s=!1;for(let o=i.length-1;o>=-1;o--){let c;if(o>=0){if(c=i[o],d(c,"path"),c.length===0)continue}else l.length===0?c=S.cwd():(c=S.env[`=${l}`]||S.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==l.toLowerCase()&&c.charCodeAt(2)===w)&&(c=`${l}\\`));const r=c.length;let h=0,C="",L=!1;const O=c.charCodeAt(0);if(r===1)a(O)&&(h=1,L=!0);else if(a(O))if(L=!0,a(c.charCodeAt(1))){let B=2,K=B;for(;B<r&&!a(c.charCodeAt(B));)B++;if(B<r&&B!==K){const V=c.slice(K,B);for(K=B;B<r&&a(c.charCodeAt(B));)B++;if(B<r&&B!==K){for(K=B;B<r&&!a(c.charCodeAt(B));)B++;(B===r||B!==K)&&(C=`\\\\${V}\\${c.slice(K,B)}`,h=B)}}}else h=1;else g(O)&&c.charCodeAt(1)===p&&(C=c.slice(0,2),h=2,r>2&&a(c.charCodeAt(2))&&(L=!0,h=3));if(C.length>0)if(l.length>0){if(C.toLowerCase()!==l.toLowerCase())continue}else l=C;if(s){if(l.length>0)break}else if(n=`${c.slice(h)}\\${n}`,s=L,L&&l.length>0)break}return n=k(n,!s,"\\",a),s?`${l}\\${n}`:`${l}${n}`||"."},normalize(i){d(i,"path");const l=i.length;if(l===0)return".";let n=0,s,o=!1;const c=i.charCodeAt(0);if(l===1)return u(c)?"\\":i;if(a(c))if(o=!0,a(i.charCodeAt(1))){let h=2,C=h;for(;h<l&&!a(i.charCodeAt(h));)h++;if(h<l&&h!==C){const L=i.slice(C,h);for(C=h;h<l&&a(i.charCodeAt(h));)h++;if(h<l&&h!==C){for(C=h;h<l&&!a(i.charCodeAt(h));)h++;if(h===l)return`\\\\${L}\\${i.slice(C)}\\`;h!==C&&(s=`\\\\${L}\\${i.slice(C,h)}`,n=h)}}}else n=1;else g(c)&&i.charCodeAt(1)===p&&(s=i.slice(0,2),n=2,l>2&&a(i.charCodeAt(2))&&(o=!0,n=3));let r=n<l?k(i.slice(n),!o,"\\",a):"";return r.length===0&&!o&&(r="."),r.length>0&&a(i.charCodeAt(l-1))&&(r+="\\"),s===void 0?o?`\\${r}`:r:o?`${s}\\${r}`:`${s}${r}`},isAbsolute(i){d(i,"path");const l=i.length;if(l===0)return!1;const n=i.charCodeAt(0);return a(n)||l>2&&g(n)&&i.charCodeAt(1)===p&&a(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let l,n;for(let c=0;c<i.length;++c){const r=i[c];d(r,"path"),r.length>0&&(l===void 0?l=n=r:l+=`\\${r}`)}if(l===void 0)return".";let s=!0,o=0;if(typeof n=="string"&&a(n.charCodeAt(0))){++o;const c=n.length;c>1&&a(n.charCodeAt(1))&&(++o,c>2&&(a(n.charCodeAt(2))?++o:s=!1))}if(s){for(;o<l.length&&a(l.charCodeAt(o));)o++;o>=2&&(l=`\\${l.slice(o)}`)}return e.win32.normalize(l)},relative(i,l){if(d(i,"from"),d(l,"to"),i===l)return"";const n=e.win32.resolve(i),s=e.win32.resolve(l);if(n===s||(i=n.toLowerCase(),l=s.toLowerCase(),i===l))return"";let o=0;for(;o<i.length&&i.charCodeAt(o)===w;)o++;let c=i.length;for(;c-1>o&&i.charCodeAt(c-1)===w;)c--;const r=c-o;let h=0;for(;h<l.length&&l.charCodeAt(h)===w;)h++;let C=l.length;for(;C-1>h&&l.charCodeAt(C-1)===w;)C--;const L=C-h,O=r<L?r:L;let B=-1,K=0;for(;K<O;K++){const J=i.charCodeAt(o+K);if(J!==l.charCodeAt(h+K))break;J===w&&(B=K)}if(K!==O){if(B===-1)return s}else{if(L>O){if(l.charCodeAt(h+K)===w)return s.slice(h+K+1);if(K===2)return s.slice(h+K)}r>O&&(i.charCodeAt(o+K)===w?B=K:K===2&&(B=3)),B===-1&&(B=0)}let V="";for(K=o+B+1;K<=c;++K)(K===c||i.charCodeAt(K)===w)&&(V+=V.length===0?"..":"\\..");return h+=B,V.length>0?`${V}${s.slice(h,C)}`:(s.charCodeAt(h)===w&&++h,s.slice(h,C))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const l=e.win32.resolve(i);if(l.length<=2)return i;if(l.charCodeAt(0)===w){if(l.charCodeAt(1)===w){const n=l.charCodeAt(2);if(n!==b&&n!==I)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(g(l.charCodeAt(0))&&l.charCodeAt(1)===p&&l.charCodeAt(2)===w)return`\\\\?\\${l}`;return i},dirname(i){d(i,"path");const l=i.length;if(l===0)return".";let n=-1,s=0;const o=i.charCodeAt(0);if(l===1)return a(o)?i:".";if(a(o)){if(n=s=1,a(i.charCodeAt(1))){let h=2,C=h;for(;h<l&&!a(i.charCodeAt(h));)h++;if(h<l&&h!==C){for(C=h;h<l&&a(i.charCodeAt(h));)h++;if(h<l&&h!==C){for(C=h;h<l&&!a(i.charCodeAt(h));)h++;if(h===l)return i;h!==C&&(n=s=h+1)}}}}else g(o)&&i.charCodeAt(1)===p&&(n=l>2&&a(i.charCodeAt(2))?3:2,s=n);let c=-1,r=!0;for(let h=l-1;h>=s;--h)if(a(i.charCodeAt(h))){if(!r){c=h;break}}else r=!1;if(c===-1){if(n===-1)return".";c=n}return i.slice(0,c)},basename(i,l){l!==void 0&&d(l,"ext"),d(i,"path");let n=0,s=-1,o=!0,c;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===p&&(n=2),l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let r=l.length-1,h=-1;for(c=i.length-1;c>=n;--c){const C=i.charCodeAt(c);if(a(C)){if(!o){n=c+1;break}}else h===-1&&(o=!1,h=c+1),r>=0&&(C===l.charCodeAt(r)?--r===-1&&(s=c):(r=-1,s=h))}return n===s?s=h:s===-1&&(s=i.length),i.slice(n,s)}for(c=i.length-1;c>=n;--c)if(a(i.charCodeAt(c))){if(!o){n=c+1;break}}else s===-1&&(o=!1,s=c+1);return s===-1?"":i.slice(n,s)},extname(i){d(i,"path");let l=0,n=-1,s=0,o=-1,c=!0,r=0;i.length>=2&&i.charCodeAt(1)===p&&g(i.charCodeAt(0))&&(l=s=2);for(let h=i.length-1;h>=l;--h){const C=i.charCodeAt(h);if(a(C)){if(!c){s=h+1;break}continue}o===-1&&(c=!1,o=h+1),C===I?n===-1?n=h:r!==1&&(r=1):n!==-1&&(r=-1)}return n===-1||o===-1||r===0||r===1&&n===o-1&&n===s+1?"":i.slice(n,o)},format:E.bind(null,"\\"),parse(i){d(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const n=i.length;let s=0,o=i.charCodeAt(0);if(n===1)return a(o)?(l.root=l.dir=i,l):(l.base=l.name=i,l);if(a(o)){if(s=1,a(i.charCodeAt(1))){let B=2,K=B;for(;B<n&&!a(i.charCodeAt(B));)B++;if(B<n&&B!==K){for(K=B;B<n&&a(i.charCodeAt(B));)B++;if(B<n&&B!==K){for(K=B;B<n&&!a(i.charCodeAt(B));)B++;B===n?s=B:B!==K&&(s=B+1)}}}}else if(g(o)&&i.charCodeAt(1)===p){if(n<=2)return l.root=l.dir=i,l;if(s=2,a(i.charCodeAt(2))){if(n===3)return l.root=l.dir=i,l;s=3}}s>0&&(l.root=i.slice(0,s));let c=-1,r=s,h=-1,C=!0,L=i.length-1,O=0;for(;L>=s;--L){if(o=i.charCodeAt(L),a(o)){if(!C){r=L+1;break}continue}h===-1&&(C=!1,h=L+1),o===I?c===-1?c=L:O!==1&&(O=1):c!==-1&&(O=-1)}return h!==-1&&(c===-1||O===0||O===1&&c===h-1&&c===r+1?l.base=l.name=i.slice(r,h):(l.name=i.slice(r,c),l.base=i.slice(r,h),l.ext=i.slice(c,h))),r>0&&r!==s?l.dir=i.slice(0,r-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const D=(()=>{if(v){const i=/\\/g;return()=>{const l=S.cwd().replace(i,"/");return l.slice(l.indexOf("/"))}}return()=>S.cwd()})();e.posix={resolve(...i){let l="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const o=s>=0?i[s]:D();d(o,"path"),o.length!==0&&(l=`${o}/${l}`,n=o.charCodeAt(0)===m)}return l=k(l,!n,"/",u),n?`/${l}`:l.length>0?l:"."},normalize(i){if(d(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===m,n=i.charCodeAt(i.length-1)===m;return i=k(i,!l,"/",u),i.length===0?l?"/":n?"./":".":(n&&(i+="/"),l?`/${i}`:i)},isAbsolute(i){return d(i,"path"),i.length>0&&i.charCodeAt(0)===m},join(...i){if(i.length===0)return".";let l;for(let n=0;n<i.length;++n){const s=i[n];d(s,"path"),s.length>0&&(l===void 0?l=s:l+=`/${s}`)}return l===void 0?".":e.posix.normalize(l)},relative(i,l){if(d(i,"from"),d(l,"to"),i===l||(i=e.posix.resolve(i),l=e.posix.resolve(l),i===l))return"";const n=1,s=i.length,o=s-n,c=1,r=l.length-c,h=o<r?o:r;let C=-1,L=0;for(;L<h;L++){const B=i.charCodeAt(n+L);if(B!==l.charCodeAt(c+L))break;B===m&&(C=L)}if(L===h)if(r>h){if(l.charCodeAt(c+L)===m)return l.slice(c+L+1);if(L===0)return l.slice(c+L)}else o>h&&(i.charCodeAt(n+L)===m?C=L:L===0&&(C=0));let O="";for(L=n+C+1;L<=s;++L)(L===s||i.charCodeAt(L)===m)&&(O+=O.length===0?"..":"/..");return`${O}${l.slice(c+C)}`},toNamespacedPath(i){return i},dirname(i){if(d(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===m;let n=-1,s=!0;for(let o=i.length-1;o>=1;--o)if(i.charCodeAt(o)===m){if(!s){n=o;break}}else s=!1;return n===-1?l?"/":".":l&&n===1?"//":i.slice(0,n)},basename(i,l){l!==void 0&&d(l,"ext"),d(i,"path");let n=0,s=-1,o=!0,c;if(l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let r=l.length-1,h=-1;for(c=i.length-1;c>=0;--c){const C=i.charCodeAt(c);if(C===m){if(!o){n=c+1;break}}else h===-1&&(o=!1,h=c+1),r>=0&&(C===l.charCodeAt(r)?--r===-1&&(s=c):(r=-1,s=h))}return n===s?s=h:s===-1&&(s=i.length),i.slice(n,s)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===m){if(!o){n=c+1;break}}else s===-1&&(o=!1,s=c+1);return s===-1?"":i.slice(n,s)},extname(i){d(i,"path");let l=-1,n=0,s=-1,o=!0,c=0;for(let r=i.length-1;r>=0;--r){const h=i.charCodeAt(r);if(h===m){if(!o){n=r+1;break}continue}s===-1&&(o=!1,s=r+1),h===I?l===-1?l=r:c!==1&&(c=1):l!==-1&&(c=-1)}return l===-1||s===-1||c===0||c===1&&l===s-1&&l===n+1?"":i.slice(l,s)},format:E.bind(null,"/"),parse(i){d(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const n=i.charCodeAt(0)===m;let s;n?(l.root="/",s=1):s=0;let o=-1,c=0,r=-1,h=!0,C=i.length-1,L=0;for(;C>=s;--C){const O=i.charCodeAt(C);if(O===m){if(!h){c=C+1;break}continue}r===-1&&(h=!1,r=C+1),O===I?o===-1?o=C:L!==1&&(L=1):o!==-1&&(L=-1)}if(r!==-1){const O=c===0&&n?1:c;o===-1||L===0||L===1&&o===r-1&&o===c+1?l.base=l.name=i.slice(O,r):(l.name=i.slice(O,o),l.base=i.slice(O,r),l.ext=i.slice(o,r))}return c>0?l.dir=i.slice(0,c-1):n&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(ee[81],te([0,1,4]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var P;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(I,...m){const w=m.reduce((y,f)=>(y[f]=!0,y),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(y=>!w[y]).forEach(y=>{for(let f=0;f<p.length;f++)if(y.search(p[f])!==-1){delete I[y];break}})}e.sanitizeProcessEnvironment=R;function M(I){!I||(delete I.DEBUG,S.isMacintosh&&delete I.DYLD_LIBRARY_PATH,S.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(ee[69],te([0,1,4]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=S.globals.performance&&typeof S.globals.performance.now=="function";class P{static create(M=!0){return new P(M)}constructor(M){this.a=t&&M,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?S.globals.performance.now():Date.now()}}e.StopWatch=P}),define(ee[3],te([0,1,13,50,2,97,69]),function(H,e,S,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,m=!1;var w;(function(c){c.None=()=>P.Disposable.None;function r(N){if(m){const{onDidAddListener:$}=N,G=d.create();let j=0;N.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),$?.()}}}function h(N,$){return se(N,()=>{},0,void 0,void 0,$)}c.defer=h;function C(N){return($,G=null,j)=>{let X=!1,Z;return Z=N(oe=>{if(!X)return Z?Z.dispose():X=!0,$.call(G,oe)},null,j),X&&Z.dispose(),Z}}c.once=C;function L(N,$,G){return re((j,X=null,Z)=>N(oe=>j.call(X,$(oe)),null,Z),G)}c.map=L;function O(N,$,G){return re((j,X=null,Z)=>N(oe=>{$(oe),j.call(X,oe)},null,Z),G)}c.forEach=O;function B(N,$,G){return re((j,X=null,Z)=>N(oe=>$(oe)&&j.call(X,oe),null,Z),G)}c.filter=B;function K(N){return N}c.signal=K;function V(...N){return($,G=null,j)=>(0,P.combinedDisposable)(...N.map(X=>X(Z=>$.call(G,Z),null,j)))}c.any=V;function J(N,$,G,j){let X=G;return L(N,Z=>(X=$(X,Z),X),j)}c.reduce=J;function re(N,$){let G;const j={onWillAddFirstListener(){G=N(X.fire,X)},onDidRemoveLastListener(){G?.dispose()}};$||r(j);const X=new a(j);return $?.add(X),X.event}function se(N,$,G=100,j=!1,X,Z){let oe,de,ke,De=0;const Pe={leakWarningThreshold:X,onWillAddFirstListener(){oe=N(ve=>{De++,de=$(de,ve),j&&!ke&&(Ae.fire(de),de=void 0),clearTimeout(ke),ke=setTimeout(()=>{const me=de;de=void 0,ke=void 0,(!j||De>1)&&Ae.fire(me),De=0},G)})},onDidRemoveLastListener(){oe.dispose()}};Z||r(Pe);const Ae=new a(Pe);return Z?.add(Ae),Ae.event}c.debounce=se;function ae(N,$=0,G){return c.debounce(N,(j,X)=>j?(j.push(X),j):[X],$,void 0,void 0,G)}c.accumulate=ae;function fe(N,$=(j,X)=>j===X,G){let j=!0,X;return B(N,Z=>{const oe=j||!$(Z,X);return j=!1,X=Z,oe},G)}c.latch=fe;function ge(N,$,G){return[c.filter(N,$,G),c.filter(N,j=>!$(j),G)]}c.split=ge;function q(N,$=!1,G=[]){let j=G.slice(),X=N(de=>{j?j.push(de):oe.fire(de)});const Z=()=>{j?.forEach(de=>oe.fire(de)),j=null},oe=new a({onWillAddFirstListener(){X||(X=N(de=>oe.fire(de)))},onDidAddFirstListener(){j&&($?setTimeout(Z):Z())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return oe.event}c.buffer=q;class T{constructor($){this.event=$,this.c=new P.DisposableStore}map($){return new T(L(this.event,$,this.c))}forEach($){return new T(O(this.event,$,this.c))}filter($){return new T(B(this.event,$,this.c))}reduce($,G){return new T(J(this.event,$,G,this.c))}latch(){return new T(fe(this.event,void 0,this.c))}debounce($,G=100,j=!1,X){return new T(se(this.event,$,G,j,X,this.c))}on($,G,j){return this.event($,G,j)}once($,G,j){return C(this.event)($,G,j)}dispose(){this.c.dispose()}}function U(N){return new T(N)}c.chain=U;function z(N,$,G=j=>j){const j=(...de)=>oe.fire(G(...de)),X=()=>N.on($,j),Z=()=>N.removeListener($,j),oe=new a({onWillAddFirstListener:X,onDidRemoveLastListener:Z});return oe.event}c.fromNodeEventEmitter=z;function Q(N,$,G=j=>j){const j=(...de)=>oe.fire(G(...de)),X=()=>N.addEventListener($,j),Z=()=>N.removeEventListener($,j),oe=new a({onWillAddFirstListener:X,onDidRemoveLastListener:Z});return oe.event}c.fromDOMEventEmitter=Q;function ne(N){return new Promise($=>C(N)($))}c.toPromise=ne;function x(N,$){return $(void 0),N(G=>$(G))}c.runAndSubscribe=x;function A(N,$){let G=null;function j(Z){G?.dispose(),G=new P.DisposableStore,$(Z,G)}j(void 0);const X=N(Z=>j(Z));return(0,P.toDisposable)(()=>{X.dispose(),G?.dispose()})}c.runAndSubscribeWithStore=A;class F{constructor($,G){this.obs=$,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};G||r(j),this.emitter=new a(j),G&&G.add(this.emitter)}beginUpdate($){this.c++}handleChange($,G){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function W(N,$){return new F(N,$).emitter.event}c.fromObservable=W})(w=e.Event||(e.Event={}));class p{constructor(r){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${r}_${p.c++}`,p.all.add(this)}start(r){this.d=new M.StopWatch(!0),this.listenerCount=r}stop(){if(this.d){const r=this.d.elapsed();this.durations.push(r),this.elapsedOverall+=r,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=p,p.all=new Set,p.c=0;let b=-1;function y(c){const r=b;return b=c,{dispose(){b=r}}}e.setGlobalLeakWarningThreshold=y;class f{constructor(r,h=Math.random().toString(18).slice(2,5)){this.threshold=r,this.name=h,this.d=0}dispose(){this.c?.clear()}check(r,h){const C=this.threshold;if(C<=0||h<C)return;this.c||(this.c=new Map);const L=this.c.get(r.value)||0;if(this.c.set(r.value,L+1),this.d-=1,this.d<=0){this.d=C*.5;let O,B=0;for(const[K,V]of this.c)(!O||B<V)&&(O=K,B=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${B}):`),console.warn(O)}return()=>{const O=this.c.get(r.value)||0;this.c.set(r.value,O-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(r){this.value=r}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(r,h,C){this.callback=r,this.callbackThis=h,this.stack=C,this.subscription=new P.SafeDisposable}invoke(r){this.callback.call(this.callbackThis,r)}}class a{constructor(r){this.j=!1,this.d=r,this.f=b>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??b):void 0,this.g=this.d?._profName?new p(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(I){const r=Array.from(this.q);queueMicrotask(()=>{for(const h of r)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(r,h,C)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.Disposable.None;const L=this.q.isEmpty();L&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,B;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(B=d.create(),O=this.f.check(B,this.q.size+1)),I&&(B=B??d.create());const K=new v(r,h,B),V=this.q.push(K);L&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,r,h);const J=K.subscription.set(()=>{O?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return C instanceof P.DisposableStore?C.add(J):Array.isArray(C)&&C.push(J),J}),this.l}fire(r){if(this.q){this.m||(this.m=new g);for(const h of this.q)this.m.push(this,h,r);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=a;class u{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(r,h,C){this.c.push(new k(r,h,C))}clear(r){const h=new R.LinkedList;for(const C of this.c)C.emitter!==r&&h.push(C);this.c=h}deliver(){for(;this.c.size>0;){const r=this.c.shift();try{r.listener.invoke(r.event)}catch(h){(0,S.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=u;class g extends u{clear(r){this.c.clear()}}class k{constructor(r,h,C){this.emitter=r,this.listener=h,this.event=C}}class E extends a{async fireAsync(r,h,C){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const L of this.q)this.c.push([L,r]);for(;this.c.size>0&&!h.isCancellationRequested;){const[L,O]=this.c.shift(),B=[],K={...O,token:h,waitUntil:V=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");C&&(V=C(V,L.callback)),B.push(V)}};try{L.invoke(K)}catch(V){(0,S.onUnexpectedError)(V);continue}Object.freeze(B),await Promise.allSettled(B).then(V=>{for(const J of V)J.status==="rejected"&&(0,S.onUnexpectedError)(J.reason)})}}}}e.AsyncEmitter=E;class D extends a{constructor(r){super(r),this.h=0,this.s=new R.LinkedList,this.t=r?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const r=Array.from(this.s);this.s.clear(),super.fire(this.t(r))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(r){this.q&&(this.h!==0?this.s.push(r):super.fire(r))}}e.PauseableEmitter=D;class i extends D{constructor(r){super(r),this.c=r.delay??100}fire(r){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(r)}}e.DebounceEmitter=i;class l extends a{constructor(r){super(r),this.c=[],this.h=r?.merge}fire(r){!this.hasListeners()||(this.c.push(r),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(h=>super.fire(h)),this.c=[]}))}}e.MicrotaskEmitter=l;class n{constructor(){this.d=!1,this.f=[],this.c=new a({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(r){const h={event:r,listener:null};this.f.push(h),this.d&&this.j(h);const C=()=>{this.d&&this.k(h);const L=this.f.indexOf(h);this.f.splice(L,1)};return(0,P.toDisposable)((0,t.once)(C))}g(){this.d=!0,this.f.forEach(r=>this.j(r))}h(){this.d=!1,this.f.forEach(r=>this.k(r))}j(r){r.listener=r.event(h=>this.c.fire(h))}k(r){r.listener&&r.listener.dispose(),r.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=n;class s{constructor(){this.c=[]}wrapEvent(r){return(h,C,L)=>r(O=>{const B=this.c[this.c.length-1];B?B.push(()=>h.call(C,O)):h.call(C,O)},void 0,L)}bufferEvents(r){const h=[];this.c.push(h);const C=r();return this.c.pop(),h.forEach(L=>L()),C}}e.EventBufferer=s;class o{constructor(){this.c=!1,this.d=w.None,this.f=P.Disposable.None,this.g=new a({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(r){this.d=r,this.c&&(this.f.dispose(),this.f=r(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(ee[22],te([0,1,3]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(I,m){const w=setTimeout(I.bind(m),0);return{dispose(){clearTimeout(w)}}});var P;(function(I){function m(w){return w===I.None||w===I.Cancelled||w instanceof R?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}I.isCancellationToken=m,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(P=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new S.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class M{constructor(m){this.a=void 0,this.b=void 0,this.b=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=P.Cancelled}dispose(m=!1){m&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=P.None}}e.CancellationTokenSource=M}),define(ee[140],te([0,1,22]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(I){this.b=I,this.a=null}get(){if(this.a)return this.a;const I=new S.CancellationTokenSource,m=this.b(I.token);return this.a={promise:m,dispose:()=>{this.a=null,I.cancel(),I.dispose()}},this.a}}e.Cache=t;class P{constructor(I){this.c=I,this.a=void 0,this.b=void 0}get(I){const m=JSON.stringify(I);return this.b!==m&&(this.b=m,this.a=this.c(I)),this.a}}e.LRUCachedFunction=P;class R{get cachedValues(){return this.a}constructor(I){this.b=I,this.a=new Map}get(I){if(this.a.has(I))return this.a.get(I);const m=this.b(I);return this.a.set(I,m),m}}e.CachedFunction=R}),define(ee[27],te([0,1,140,126]),function(H,e,S,t){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=R;const M=/{(\d+)}/g;function I(Y,...ce){return ce.length===0?Y:Y.replace(M,function(le,we){const Se=parseInt(we,10);return isNaN(Se)||Se<0||Se>=ce.length?le:ce[Se]})}e.format=I;const m=/{([^}]+)}/g;function w(Y,ce){return Y.replace(m,(le,we)=>ce[we]??le)}e.format2=w;function p(Y){return Y.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=p;function b(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function y(Y,ce){let le=0;const we=ce.charCodeAt(0);for(let Se=Y.length-1;Se>=0;Se--)Y.charCodeAt(Se)===we&&le++;return le}e.count=y;function f(Y,ce,le="\u2026"){return Y.length<=ce?Y:`${Y.substr(0,ce)}${le}`}e.truncate=f;function d(Y,ce=" "){const le=v(Y,ce);return a(le,ce)}e.trim=d;function v(Y,ce){if(!Y||!ce)return Y;const le=ce.length;if(le===0||Y.length===0)return Y;let we=0;for(;Y.indexOf(ce,we)===we;)we=we+le;return Y.substring(we)}e.ltrim=v;function a(Y,ce){if(!Y||!ce)return Y;const le=ce.length,we=Y.length;if(le===0||we===0)return Y;let Se=we,Oe=-1;for(;Oe=Y.lastIndexOf(ce,Se-1),!(Oe===-1||Oe+le!==Se);){if(Oe===0)return"";Se=Oe}return Y.substring(0,Se)}e.rtrim=a;function u(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(Y){return Y.replace(/\*/g,"")}e.stripWildcards=g;function k(Y,ce,le={}){if(!Y)throw new Error("Cannot create regex from empty string");ce||(Y=b(Y)),le.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let we="";return le.global&&(we+="g"),le.matchCase||(we+="i"),le.multiline&&(we+="m"),le.unicode&&(we+="u"),new RegExp(Y,we)}e.createRegExp=k;function E(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=E;function D(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function i(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=i;function l(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=l;function n(Y){for(let ce=0,le=Y.length;ce<le;ce++){const we=Y.charCodeAt(ce);if(we!==32&&we!==9)return ce}return-1}e.firstNonWhitespaceIndex=n;function s(Y,ce=0,le=Y.length){for(let we=ce;we<le;we++){const Se=Y.charCodeAt(we);if(Se!==32&&Se!==9)return Y.substring(ce,we)}return Y.substring(ce,le)}e.getLeadingWhitespace=s;function o(Y,ce=Y.length-1){for(let le=ce;le>=0;le--){const we=Y.charCodeAt(le);if(we!==32&&we!==9)return le}return-1}e.lastNonWhitespaceIndex=o;function c(Y,ce,le){const we=[];let Se=0;for(const Oe of Y.matchAll(ce)){if(we.push(Y.slice(Se,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Se=Oe.index+Oe[0].length,we.push(le(Oe[0],...Oe.slice(1),Oe.index,Y,Oe.groups))}return we.push(Y.slice(Se)),Promise.all(we).then(Oe=>Oe.join(""))}e.replaceAsync=c;function r(Y,ce){return Y<ce?-1:Y>ce?1:0}e.compare=r;function h(Y,ce,le=0,we=Y.length,Se=0,Oe=ce.length){for(;le<we&&Se<Oe;le++,Se++){const xe=Y.charCodeAt(le),He=ce.charCodeAt(Se);if(xe<He)return-1;if(xe>He)return 1}const je=we-le,it=Oe-Se;return je<it?-1:je>it?1:0}e.compareSubstring=h;function C(Y,ce){return L(Y,ce,0,Y.length,0,ce.length)}e.compareIgnoreCase=C;function L(Y,ce,le=0,we=Y.length,Se=0,Oe=ce.length){for(;le<we&&Se<Oe;le++,Se++){let xe=Y.charCodeAt(le),He=ce.charCodeAt(Se);if(xe===He)continue;if(xe>=128||He>=128)return h(Y.toLowerCase(),ce.toLowerCase(),le,we,Se,Oe);B(xe)&&(xe-=32),B(He)&&(He-=32);const tt=xe-He;if(tt!==0)return tt}const je=we-le,it=Oe-Se;return je<it?-1:je>it?1:0}e.compareSubstringIgnoreCase=L;function O(Y){return Y>=48&&Y<=57}e.isAsciiDigit=O;function B(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=B;function K(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=K;function V(Y,ce){return Y.length===ce.length&&L(Y,ce)===0}e.equalsIgnoreCase=V;function J(Y,ce){const le=ce.length;return ce.length>Y.length?!1:L(Y,ce,0,le)===0}e.startsWithIgnoreCase=J;function re(Y,ce){const le=Math.min(Y.length,ce.length);let we;for(we=0;we<le;we++)if(Y.charCodeAt(we)!==ce.charCodeAt(we))return we;return le}e.commonPrefixLength=re;function se(Y,ce){const le=Math.min(Y.length,ce.length);let we;const Se=Y.length-1,Oe=ce.length-1;for(we=0;we<le;we++)if(Y.charCodeAt(Se-we)!==ce.charCodeAt(Oe-we))return we;return le}e.commonSuffixLength=se;function ae(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=ae;function fe(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=fe;function ge(Y,ce){return(Y-55296<<10)+(ce-56320)+65536}e.computeCodePoint=ge;function q(Y,ce,le){const we=Y.charCodeAt(le);if(ae(we)&&le+1<ce){const Se=Y.charCodeAt(le+1);if(fe(Se))return ge(we,Se)}return we}e.getNextCodePoint=q;function T(Y,ce){const le=Y.charCodeAt(ce-1);if(fe(le)&&ce>1){const we=Y.charCodeAt(ce-2);if(ae(we))return ge(we,le)}return le}class U{get offset(){return this.e}constructor(ce,le=0){this.c=ce,this.d=ce.length,this.e=le}setOffset(ce){this.e=ce}prevCodePoint(){const ce=T(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=q(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=U;class z{get offset(){return this.c.offset}constructor(ce,le=0){this.c=new U(ce,le)}nextGraphemeLength(){const ce=We.getInstance(),le=this.c,we=le.offset;let Se=ce.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Oe=le.offset,je=ce.getGraphemeBreakType(le.nextCodePoint());if(be(Se,je)){le.setOffset(Oe);break}Se=je}return le.offset-we}prevGraphemeLength(){const ce=We.getInstance(),le=this.c,we=le.offset;let Se=ce.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Oe=le.offset,je=ce.getGraphemeBreakType(le.prevCodePoint());if(be(je,Se)){le.setOffset(Oe);break}Se=je}return we-le.offset}eol(){return this.c.eol()}}e.GraphemeIterator=z;function Q(Y,ce){return new z(Y,ce).nextGraphemeLength()}e.nextCharLength=Q;function ne(Y,ce){return new z(Y,ce).prevGraphemeLength()}e.prevCharLength=ne;function x(Y,ce){ce>0&&fe(Y.charCodeAt(ce))&&ce--;const le=ce+Q(Y,ce);return[le-ne(Y,le),le]}e.getCharContainingOffset=x;function A(Y){const ce=new z(Y);let le=0;for(;!ce.eol();)le++,ce.nextGraphemeLength();return le}e.charCount=A;let F;function W(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(Y){return F||(F=W()),F.test(Y)}e.containsRTL=N;const $=/^[\t\n\r\x20-\x7E]*$/;function G(Y){return $.test(Y)}e.isBasicASCII=G,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=j;function X(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=X;function Z(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.isEmojiImprecise=Z;function oe(Y,ce){if(Y.length<ce)return Y;const le=/\b/g;let we=0;for(;le.test(Y)&&!(Y.length-le.lastIndex<ce);)we=le.lastIndex,le.lastIndex+=1;return Y.substring(we).replace(/^\s/,"")}e.lcut=oe;const de=/\x1B\x5B[12]?K/g,ke=/\x1b\[\d+m/g,De=/\x1b\[0?m/g;function Pe(Y){return Y&&(Y=Y.replace(de,""),Y=Y.replace(ke,""),Y=Y.replace(De,"")),Y}e.removeAnsiEscapeCodes=Pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function ve(Y){return Ae(Y)?Y.substr(1):Y}e.stripUTF8BOM=ve;function me(Y,ce){if(!Y||!ce||Y.length<ce.length)return!1;const le=ce.length,we=Y.toLowerCase();let Se=0,Oe=-1;for(;Se<le;){const je=we.indexOf(ce[Se],Oe+1);if(je<0)return!1;Oe=je,Se++}return!0}e.fuzzyContains=me;function ye(Y,ce=!1){return Y?(ce&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=ye;function Me(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Me;function ie(Y,ce=1){if(ce===0)return"";let le=-1;do le=Y.indexOf(`
`,le+1),ce--;while(ce>0&&le>=0);return le===-1?Y:(Y[le-1]==="\r"&&le--,Y.substr(0,le))}e.getNLines=ie;function ue(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}e.singleLetterHash=ue;function he(Y){return We.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=he;function be(Y,ce){return Y===0?ce!==5&&ce!==7:Y===2&&ce===3?!1:Y===4||Y===2||Y===3||ce===4||ce===2||ce===3?!0:!(Y===8&&(ce===8||ce===9||ce===11||ce===12)||(Y===11||Y===9)&&(ce===9||ce===10)||(Y===12||Y===10)&&ce===10||ce===5||ce===13||ce===7||Y===1||Y===13&&ce===14||Y===6&&ce===6)}var Ce;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Te()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const le=this.d,we=le.length/3;let Se=1;for(;Se<=we;)if(ce<le[3*Se])Se=2*Se;else if(ce>le[3*Se+1])Se=2*Se+1;else return le[3*Se+2];return 0}}We.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(Y,ce){if(Y===0)return 0;const le=Ue(Y,ce);if(le!==void 0)return le;const we=new U(ce,Y);return we.prevCodePoint(),we.offset}e.getLeftDeleteOffset=qe;function Ue(Y,ce){const le=new U(ce,Y);let we=le.prevCodePoint();for(;Be(we)||we===65039||we===8419;){if(le.offset===0)return;we=le.prevCodePoint()}if(!Z(we))return;let Se=le.offset;return Se>0&&le.prevCodePoint()===8205&&(Se=le.offset),Se}function Be(Y){return 127995<=Y&&Y<=127999}var Xe;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.noBreakWhitespace="\xA0";class $e{static getInstance(ce){return $e.d.get(Array.from(ce))}static getLocales(){return $e.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=$e,P=$e,$e.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.d=new S.LRUCachedFunction(Y=>{function ce(He){const tt=new Map;for(let nt=0;nt<He.length;nt+=2)tt.set(He[nt],He[nt+1]);return tt}function le(He,tt){const nt=new Map(He);for(const[lt,at]of tt)nt.set(lt,at);return nt}function we(He,tt){if(!He)return tt;const nt=new Map;for(const[lt,at]of He)tt.has(lt)&&nt.set(lt,at);return nt}const Se=P.c.getValue();let Oe=Y.filter(He=>!He.startsWith("_")&&He in Se);Oe.length===0&&(Oe=["_default"]);let je;for(const He of Oe){const tt=ce(Se[He]);je=we(je,tt)}const it=ce(Se._common),xe=le(it,je);return new $e(xe)}),$e.e=new t.Lazy(()=>Object.keys($e.c.getValue()).filter(Y=>!Y.startsWith("_")));class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(ce){return Ke.e().has(ce)}static get codePoints(){return Ke.e()}}e.InvisibleCharacters=Ke,Ke.d=void 0}),define(ee[32],te([0,1,9,4,27,11]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(o){return o===47||o===92}e.isPathSeparator=M;function I(o){return o.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=I;function m(o){return o.indexOf("/")===-1&&(o=I(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=m;function w(o,c=S.posix.sep){if(!o)return"";const r=o.length,h=o.charCodeAt(0);if(M(h)){if(M(o.charCodeAt(1))&&!M(o.charCodeAt(2))){let L=3;const O=L;for(;L<r&&!M(o.charCodeAt(L));L++);if(O!==L&&!M(o.charCodeAt(L+1))){for(L+=1;L<r;L++)if(M(o.charCodeAt(L)))return o.slice(0,L+1).replace(/[\\/]/g,c)}}return c}else if(u(h)&&o.charCodeAt(1)===58)return M(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let C=o.indexOf("://");if(C!==-1){for(C+=3;C<r;C++)if(M(o.charCodeAt(C)))return o.slice(0,C+1)}return""}e.getRoot=w;function p(o){if(!t.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let r=2;const h=r;for(;r<o.length&&(c=o.charCodeAt(r),c!==92);r++);return!(h===r||(c=o.charCodeAt(r+1),isNaN(c)||c===92))}e.isUNC=p;const b=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,c=t.isWindows){const r=c?b:y;return!(!o||o.length===0||/^\s+$/.test(o)||(r.lastIndex=0,r.test(o))||c&&f.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function v(o,c,r){const h=o===c;return!r||h?h:!o||!c?!1:(0,P.equalsIgnoreCase)(o,c)}e.isEqual=v;function a(o,c,r,h=S.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(r){if(!(0,P.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let L=c.length;return c.charAt(c.length-1)===h&&L--,o.charAt(L)===h}return c.charAt(c.length-1)!==h&&(c+=h),o.indexOf(c)===0}e.isEqualOrParent=a;function u(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=u;function g(o,c){return t.isWindows&&o.endsWith(":")&&(o+=S.sep),(0,S.isAbsolute)(o)||(o=(0,S.join)(c,o)),o=(0,S.normalize)(o),t.isWindows?(o=(0,P.rtrim)(o,S.sep),o.endsWith(":")&&(o+=S.sep)):(o=(0,P.rtrim)(o,S.sep),o||(o=S.sep)),o}e.sanitizeFilePath=g;function k(o){const c=(0,S.normalize)(o);return t.isWindows?o.length>3?!1:E(c)&&(o.length===2||c.charCodeAt(2)===92):c===S.posix.sep}e.isRootOrDriveLetter=k;function E(o,c=t.isWindows){return c?u(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=E;function D(o){return E(o)?o[0]:void 0}e.getDriveLetter=D;function i(o,c,r){return c.length>o.length?-1:o===c?0:(r&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=i;function l(o){const c=o.split(":");let r,h,C;for(const L of c){const O=Number(L);(0,R.isNumber)(O)?h===void 0?h=O:C===void 0&&(C=O):r=r?[r,L].join(":"):L}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:h!==void 0?h:void 0,column:C!==void 0?C:h!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(o,c,r=8){let h="";for(let L=0;L<r;L++)h+=n.charAt(Math.floor(Math.random()*n.length));let C;return c?C=`${c}-${h}`:C=h,o?(0,S.join)(o,C):C}e.randomPath=s}),define(ee[70],te([0,1,27]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(u){return P(u,0)}e.hash=t;function P(u,g){switch(typeof u){case"object":return u===null?R(349,g):Array.isArray(u)?m(u,g):w(u,g);case"string":return I(u,g);case"boolean":return M(u,g);case"number":return R(u,g);case"undefined":return R(937,g);default:return R(617,g)}}e.doHash=P;function R(u,g){return(g<<5)-g+u|0}e.numberHash=R;function M(u,g){return R(u?433:863,g)}function I(u,g){g=R(149417,g);for(let k=0,E=u.length;k<E;k++)g=R(u.charCodeAt(k),g);return g}e.stringHash=I;function m(u,g){return g=R(104579,g),u.reduce((k,E)=>P(E,k),g)}function w(u,g){return g=R(181387,g),Object.keys(u).sort().reduce((k,E)=>(k=I(E,k),P(u[E],k)),g)}class p{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=P(g,this.g),this.g}}e.Hasher=p;var b;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function y(u,g,k=32){const E=k-g,D=~((1<<E)-1);return(u<<g|(D&u)>>>E)>>>0}function f(u,g=0,k=u.byteLength,E=0){for(let D=0;D<k;D++)u[g+D]=E}function d(u,g,k="0"){for(;u.length<g;)u=k+u;return u}function v(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(k=>k.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),g/4)}e.toHexString=v;class a{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const k=g.length;if(k===0)return;const E=this.p;let D=this.r,i=this.u,l,n;for(i!==0?(l=i,n=-1,i=0):(l=g.charCodeAt(0),n=0);;){let s=l;if(S.isHighSurrogate(l))if(n+1<k){const o=g.charCodeAt(n+1);S.isLowSurrogate(o)?(n++,s=S.computeCodePoint(l,o)):s=65533}else{i=l;break}else S.isLowSurrogate(l)&&(s=65533);if(D=this.w(E,D,s),n++,n<k)l=g.charCodeAt(n);else break}this.r=D,this.u=i}w(g,k,E){return E<128?g[k++]=E:E<2048?(g[k++]=192|(E&1984)>>>6,g[k++]=128|(E&63)>>>0):E<65536?(g[k++]=224|(E&61440)>>>12,g[k++]=128|(E&4032)>>>6,g[k++]=128|(E&63)>>>0):(g[k++]=240|(E&1835008)>>>18,g[k++]=128|(E&258048)>>>12,g[k++]=128|(E&4032)>>>6,g[k++]=128|(E&63)>>>0),k>=64&&(this.y(),k-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=a.g,k=this.q;for(let r=0;r<64;r+=4)g.setUint32(r,k.getUint32(r,!1),!1);for(let r=64;r<320;r+=4)g.setUint32(r,y(g.getUint32(r-12,!1)^g.getUint32(r-32,!1)^g.getUint32(r-56,!1)^g.getUint32(r-64,!1),1),!1);let E=this.h,D=this.l,i=this.m,l=this.n,n=this.o,s,o,c;for(let r=0;r<80;r++)r<20?(s=D&i|~D&l,o=1518500249):r<40?(s=D^i^l,o=1859775393):r<60?(s=D&i|D&l|i&l,o=2400959708):(s=D^i^l,o=3395469782),c=y(E,5)+s+n+o+g.getUint32(r*4,!1)&4294967295,n=l,l=i,i=y(D,30),D=E,E=c;this.h=this.h+E&4294967295,this.l=this.l+D&4294967295,this.m=this.m+i&4294967295,this.n=this.n+l&4294967295,this.o=this.o+n&4294967295}}e.StringSHA1=a,a.g=new DataView(new ArrayBuffer(320))}),define(ee[82],te([0,1,27]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(t||(t={})),function(P){const R="error",M="warning",I="warn",m="info",w="ignore";function p(y){return y?S.equalsIgnoreCase(R,y)?P.Error:S.equalsIgnoreCase(M,y)||S.equalsIgnoreCase(I,y)?P.Warning:S.equalsIgnoreCase(m,y)?P.Info:P.Ignore:P.Ignore}P.fromValue=p;function b(y){switch(y){case P.Error:return R;case P.Warning:return M;case P.Info:return m;default:return w}}P.toString=b}(t||(t={})),e.default=t}),define(ee[60],te([0,1,25,27]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class P{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const d=f.charCodeAt(0),v=this.b.charCodeAt(this.c);return d-v}value(){return this.b[this.c]}}e.StringIterator=P;class R{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,t.compareSubstring)(f,this.b,0,f.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class M{constructor(f=!0,d=!0){this.f=f,this.g=d}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let d=f.length-1;d>=0;d--,this.c--){const v=this.b.charCodeAt(d);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,t.compareSubstring)(f,this.b,0,f.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=M;var I;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(I||(I={}));class m{constructor(f,d){this.f=f,this.g=d,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(f,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,t.compare)(f,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=m;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(p||(p={}));class b{static forUris(f=()=>!1,d=()=>!1){return new b(new m(f,d))}static forPaths(f=!1){return new b(new M(void 0,!f))}static forStrings(){return new b(new P)}static forConfigKeys(){return new b(new R)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,d){if(d){const v=d.slice(0);(0,S.shuffle)(v);for(const a of v)this.set(a,f)}else{const v=f.slice(0);(0,S.shuffle)(v);for(const a of v)this.set(a[0],a[1])}}set(f,d){const v=this.b.reset(f);let a;this.c||(this.c=new w,this.c.segment=v.value());const u=[];for(a=this.c;;){const k=v.cmp(a.segment);if(k>0)a.left||(a.left=new w,a.left.segment=v.value()),u.push([-1,a]),a=a.left;else if(k<0)a.right||(a.right=new w,a.right.segment=v.value()),u.push([1,a]),a=a.right;else if(v.hasNext())v.next(),a.mid||(a.mid=new w,a.mid.segment=v.value()),u.push([0,a]),a=a.mid;else break}const g=a.value;a.value=d,a.key=f;for(let k=u.length-1;k>=0;k--){const E=u[k][1];E.updateHeight();const D=E.balanceFactor();if(D<-1||D>1){const i=u[k][0],l=u[k+1][0];if(i===1&&l===1)u[k][1]=E.rotateLeft();else if(i===-1&&l===-1)u[k][1]=E.rotateRight();else if(i===1&&l===-1)E.right=u[k+1][1]=u[k+1][1].rotateRight(),u[k][1]=E.rotateLeft();else if(i===-1&&l===1)E.left=u[k+1][1]=u[k+1][1].rotateLeft(),u[k][1]=E.rotateRight();else throw new Error;if(k>0)switch(u[k-1][0]){case-1:u[k-1][1].left=u[k][1];break;case 1:u[k-1][1].right=u[k][1];break;case 0:u[k-1][1].mid=u[k][1];break}else this.c=u[0][1]}}return g}get(f){return this.d(f)?.value}d(f){const d=this.b.reset(f);let v=this.c;for(;v;){const a=d.cmp(v.segment);if(a>0)v=v.left;else if(a<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else break}return v}has(f){const d=this.d(f);return!(d?.value===void 0&&d?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,d){const v=this.b.reset(f),a=[];let u=this.c;for(;u;){const g=v.cmp(u.segment);if(g>0)a.push([-1,u]),u=u.left;else if(g<0)a.push([1,u]),u=u.right;else if(v.hasNext())v.next(),a.push([0,u]),u=u.mid;else break}if(!!u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this.f(u.right);if(g.key){const{key:k,value:E,segment:D}=g;this.e(g.key,!1),u.key=k,u.value=E,u.segment=D}}else{const g=u.left??u.right;if(a.length>0){const[k,E]=a[a.length-1];switch(k){case-1:E.left=g;break;case 0:E.mid=g;break;case 1:E.right=g;break}}else this.c=g}for(let g=a.length-1;g>=0;g--){const k=a[g][1];k.updateHeight();const E=k.balanceFactor();if(E>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),a[g][1]=k.rotateLeft()):E<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),a[g][1]=k.rotateRight()),g>0)switch(a[g-1][0]){case-1:a[g-1][1].left=a[g][1];break;case 1:a[g-1][1].right=a[g][1];break;case 0:a[g-1][1].mid=a[g][1];break}else this.c=a[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const d=this.b.reset(f);let v=this.c,a;for(;v;){const u=d.cmp(v.segment);if(u>0)v=v.left;else if(u<0)v=v.right;else if(d.hasNext())d.next(),a=v.value||a,v=v.mid;else break}return v&&v.value||a}findSuperstr(f){return this.g(f,!1)}g(f,d){const v=this.b.reset(f);let a=this.c;for(;a;){const u=v.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(v.hasNext())v.next(),a=a.mid;else return a.mid?this.h(a.mid):d?a.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[d,v]of this)f(v,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const d=[];return this.j(f,d),d[Symbol.iterator]()}j(f,d){!f||(f.left&&this.j(f.left,d),f.value&&d.push([f.key,f.value]),f.mid&&this.j(f.mid,d),f.right&&this.j(f.right,d))}_isBalanced(){const f=d=>{if(!d)return!0;const v=d.balanceFactor();return v<-1||v>1?!1:f(d.left)&&f(d.right)};return f(this.c)}}e.TernarySearchTree=b}),define(ee[7],te([0,1,9,4]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function I(n,s){if(!n.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!P.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(n,s){return!n&&!s?"file":n}function w(n,s){switch(n){case"https":case"http":case"file":s?s[0]!==b&&(s=b+s):s=b;break}return s}const p="",b="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(s){return s instanceof f?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,o,c,r,h,C=!1){typeof s=="object"?(this.scheme=s.scheme||p,this.authority=s.authority||p,this.path=s.path||p,this.query=s.query||p,this.fragment=s.fragment||p):(this.scheme=m(s,C),this.authority=o||p,this.path=w(this.scheme,c||p),this.query=r||p,this.fragment=h||p,I(this,C))}get fsPath(){return k(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:c,path:r,query:h,fragment:C}=s;return o===void 0?o=this.scheme:o===null&&(o=p),c===void 0?c=this.authority:c===null&&(c=p),r===void 0?r=this.path:r===null&&(r=p),h===void 0?h=this.query:h===null&&(h=p),C===void 0?C=this.fragment:C===null&&(C=p),o===this.scheme&&c===this.authority&&r===this.path&&h===this.query&&C===this.fragment?this:new v(o,c,r,h,C)}static parse(s,o=!1){const c=y.exec(s);return c?new v(c[2]||p,l(c[4]||p),l(c[5]||p),l(c[7]||p),l(c[9]||p),o):new v(p,p,p,p,p)}static file(s){let o=p;if(t.isWindows&&(s=s.replace(/\\/g,b)),s[0]===b&&s[1]===b){const c=s.indexOf(b,2);c===-1?(o=s.substring(2),s=b):(o=s.substring(2,c),s=s.substring(c)||b)}return new v("file",o,s,p,p)}static from(s){const o=new v(s.scheme,s.authority,s.path,s.query,s.fragment);return I(o,!0),o}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&s.scheme==="file"?c=f.file(S.win32.join(k(s,!0),...o)).path:c=S.posix.join(s.path,...o),s.with({path:c})}toString(s=!1){return E(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof f)return s;{const o=new v(s);return o._formatted=s.external,o._fsPath=s._sep===d?s.fsPath:null,o}}else return s}}e.URI=f;const d=t.isWindows?1:void 0;class v extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(s=!1){return s?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(n,s,o){let c,r=-1;for(let h=0;h<n.length;h++){const C=n.charCodeAt(h);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||s&&C===47||o&&C===91||o&&C===93||o&&C===58)r!==-1&&(c+=encodeURIComponent(n.substring(r,h)),r=-1),c!==void 0&&(c+=n.charAt(h));else{c===void 0&&(c=n.substr(0,h));const L=a[C];L!==void 0?(r!==-1&&(c+=encodeURIComponent(n.substring(r,h)),r=-1),c+=L):r===-1&&(r=h)}}return r!==-1&&(c+=encodeURIComponent(n.substring(r))),c!==void 0?c:n}function g(n){let s;for(let o=0;o<n.length;o++){const c=n.charCodeAt(o);c===35||c===63?(s===void 0&&(s=n.substr(0,o)),s+=a[c]):s!==void 0&&(s+=n[o])}return s!==void 0?s:n}function k(n,s){let o;return n.authority&&n.path.length>1&&n.scheme==="file"?o=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?s?o=n.path.substr(1):o=n.path[1].toLowerCase()+n.path.substr(2):o=n.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=k;function E(n,s){const o=s?g:u;let c="",{scheme:r,authority:h,path:C,query:L,fragment:O}=n;if(r&&(c+=r,c+=":"),(h||r==="file")&&(c+=b,c+=b),h){let B=h.indexOf("@");if(B!==-1){const K=h.substr(0,B);h=h.substr(B+1),B=K.lastIndexOf(":"),B===-1?c+=o(K,!1,!1):(c+=o(K.substr(0,B),!1,!1),c+=":",c+=o(K.substr(B+1),!1,!0)),c+="@"}h=h.toLowerCase(),B=h.lastIndexOf(":"),B===-1?c+=o(h,!1,!0):(c+=o(h.substr(0,B),!1,!0),c+=h.substr(B))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const B=C.charCodeAt(1);B>=65&&B<=90&&(C=`/${String.fromCharCode(B+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const B=C.charCodeAt(0);B>=65&&B<=90&&(C=`${String.fromCharCode(B+32)}:${C.substr(2)}`)}c+=o(C,!0,!1)}return L&&(c+="?",c+=o(L,!1,!1)),O&&(c+="#",c+=s?O:u(O,!1,!1)),c}function D(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+D(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(n){return n.match(i)?n.replace(i,s=>D(s)):n}}),define(ee[141],te([0,1,7]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(w){const p=w;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.isRemoteConsoleLog=t;function P(w){const p=[];let b;try{const y=JSON.parse(w.arguments),f=y[y.length-1];f&&f.__$stack&&(y.pop(),b=f.__$stack),p.push(...y)}catch{p.push("Unable to log remote console arguments",w.arguments)}return{args:p,stack:b}}e.parse=P;function R(w){if(typeof w!="string")return R(P(w).stack);const p=w;if(p){const b=M(p),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(y&&y.length===4)return{uri:S.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=R;function M(w){if(!w)return w;const p=w.indexOf(`
`);return p===-1?w:w.substring(0,p)}function I(w,p){const{args:b,stack:y}=P(w),f=typeof b[0]=="string"&&b.length===1;let d=M(y);d&&(d=`(${d.trim()})`);let v=[];if(typeof b[0]=="string"?d&&f?v=[`%c[${p}] %c${b[0]} %c${d}`,m("blue"),m(""),m("grey")]:v=[`%c[${p}] %c${b[0]}`,m("blue"),m(""),...b.slice(1)]:v=[`%c[${p}]%`,m("blue"),...b],d&&!f&&v.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,v)}e.log=I;function m(w){return`color: ${w}`}}),define(ee[71],te([0,1,17,27,7]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(w){return JSON.stringify(w,I)}e.stringify=R;function M(w){let p=JSON.parse(w);return p=m(p),p}e.parse=M;function I(w,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,t.regExpFlags)(p)}:p}function m(w,p=0){if(!w||p>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return P.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 16:return new Date(w.source)}if(w instanceof S.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let b=0;b<w.length;++b)w[b]=m(w[b],p+1);else for(const b in w)Object.hasOwnProperty.call(w,b)&&(w[b]=m(w[b],p+1))}return w}e.revive=m}),define(ee[15],te([0,1,13,4,7]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${R.vscodeRemoteResource}`}set(p,b,y){this.a[p]=b,this.b[p]=y}setConnectionToken(p,b){this.c[p]=b}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(a){return S.onUnexpectedError(a),p}const b=p.authority;let y=this.a[b];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const f=this.b[b],d=this.c[b];let v=`path=${encodeURIComponent(p.path)}`;return typeof d=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(d)}`),P.URI.from({scheme:t.isWeb?this.d:R.vscodeRemoteResource,authority:`${y}:${f}`,path:this.f,query:v})}}e.RemoteAuthorities=new M,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class I{asBrowserUri(p){const b=this.b(p,H);return this.uriToBrowserUri(b)}uriToBrowserUri(p){return p.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(p):p.scheme===R.file&&(t.isNative||t.isWebWorker&&t.globals.origin===`${R.vscodeFileResource}://${I.a}`)?p.with({scheme:R.vscodeFileResource,authority:p.authority||I.a,query:null,fragment:null}):p}asFileUri(p){const b=this.b(p,H);return this.uriToFileUri(b)}uriToFileUri(p){return p.scheme===R.vscodeFileResource?p.with({scheme:R.file,authority:p.authority!==I.a?p.authority:null,query:null,fragment:null}):p}b(p,b){return P.URI.isUri(p)?p:P.URI.parse(b.toUrl(p))}}I.a="vscode-app",e.FileAccess=new I;var m;(function(w){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(p.get("3"));const b="vscode-coi";function y(d){let v;typeof d=="string"?v=new URL(d).searchParams:d instanceof URL?v=d.searchParams:P.URI.isUri(d)&&(v=new URL(d.toString(!0)).searchParams);const a=v?.get(b);if(!!a)return p.get(a)}w.getHeadersFromQuery=y;function f(d,v,a){if(!globalThis.crossOriginIsolated)return;const u=v&&a?"3":a?"2":"1";d instanceof URLSearchParams?d.set(b,u):d[b]=u}w.addSearchParam=f})(m=e.COI||(e.COI={}))}),define(ee[20],te([0,1,32,15,9,4,27,7]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(f){return(0,I.uriToFsPath)(f,!0)}e.originalFSPath=m;class w{constructor(d){this.a=d}compare(d,v,a=!1){return d===v?0:(0,M.compare)(this.getComparisonKey(d,a),this.getComparisonKey(v,a))}isEqual(d,v,a=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,a)===this.getComparisonKey(v,a)}getComparisonKey(d,v=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,v,a=!1){if(d.scheme===v.scheme){if(d.scheme===t.Schemas.file)return S.isEqualOrParent(m(d),m(v),this.a(d))&&d.query===v.query&&(a||d.fragment===v.fragment);if((0,e.isEqualAuthority)(d.authority,v.authority))return S.isEqualOrParent(d.path,v.path,this.a(d),"/")&&d.query===v.query&&(a||d.fragment===v.fragment)}return!1}joinPath(d,...v){return I.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return P.posix.basename(d.path)}extname(d){return P.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===t.Schemas.file?v=I.URI.file(P.dirname(m(d))).path:(v=P.posix.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===t.Schemas.file?v=I.URI.file(P.normalize(m(d))).path:v=P.posix.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.isEqualAuthority)(d.authority,v.authority))return;if(d.scheme===t.Schemas.file){const g=P.relative(m(d),m(v));return R.isWindows?S.toSlashes(g):g}let a=d.path||"/";const u=v.path||"/";if(this.a(d)){let g=0;for(const k=Math.min(a.length,u.length);g<k&&!(a.charCodeAt(g)!==u.charCodeAt(g)&&a.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);a=u.substr(0,g)+a.substr(g)}return P.posix.relative(a,u)}resolvePath(d,v){if(d.scheme===t.Schemas.file){const a=I.URI.file(P.resolve(m(d),v));return d.with({authority:a.authority,path:a.path})}return v=S.toPosixPath(v),d.with({path:P.posix.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||d!==void 0&&v!==void 0&&(0,M.equalsIgnoreCase)(d,v)}hasTrailingPathSeparator(d,v=P.sep){if(d.scheme===t.Schemas.file){const a=m(d);return a.length>S.getRoot(a).length&&a[a.length-1]===v}else{const a=d.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=P.sep){return(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=P.sep){let a=!1;if(d.scheme===t.Schemas.file){const u=m(d);a=u!==void 0&&u.length===S.getRoot(u).length&&u[u.length-1]===v}else{v="/";const u=d.path;a=u.length===1&&u.charCodeAt(u.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(f=>f.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new w(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function p(f,d){const v=[];for(let a=0;a<f.length;a++){const u=d(f[a]);f.some((g,k)=>k===a?!1:(0,e.isEqualOrParent)(u,d(g)))||v.push(f[a])}return v}e.distinctParents=p;var b;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function d(v){const a=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(k=>{const[E,D]=k.split(":");E&&D&&a.set(E,D)});const g=v.path.substring(0,v.path.indexOf(";"));return g&&a.set(f.META_DATA_MIME,g),a}f.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function y(f,d,v){if(d){let a=f.path;return a&&a[0]!==P.posix.sep&&(a=P.posix.sep+a),f.with({scheme:v,authority:d,path:a})}return f.with({scheme:v})}e.toLocalResource=y}),define(ee[8],te([0,1,22,13,3,2,20,4]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(x){return!!x&&typeof x.then=="function"}e.isThenable=m;function w(x){const A=new S.CancellationTokenSource,F=x(A.token),W=new Promise((N,$)=>{const G=A.token.onCancellationRequested(()=>{G.dispose(),A.dispose(),$(new t.CancellationError)});Promise.resolve(F).then(j=>{G.dispose(),A.dispose(),N(j)},j=>{G.dispose(),A.dispose(),$(j)})});return new class{cancel(){A.cancel()}then(N,$){return W.then(N,$)}catch(N){return this.then(void 0,N)}finally(N){return W.finally(N)}}}e.createCancelablePromise=w;function p(x,A,F){return new Promise((W,N)=>{const $=A.onCancellationRequested(()=>{$.dispose(),W(F)});x.then(W,N).finally(()=>$.dispose())})}e.raceCancellation=p;function b(x,A){return new Promise((F,W)=>{const N=A.onCancellationRequested(()=>{N.dispose(),W(new t.CancellationError)});x.then(F,W).finally(()=>N.dispose())})}e.raceCancellationError=b;async function y(x){let A=-1;const F=x.map((N,$)=>N.then(G=>(A=$,G))),W=await Promise.race(F);return x.forEach((N,$)=>{$!==A&&N.cancel()}),W}e.raceCancellablePromises=y;function f(x,A,F){let W;const N=setTimeout(()=>{W?.(void 0),F?.()},A);return Promise.race([x.finally(()=>clearTimeout(N)),new Promise($=>W=$)])}e.raceTimeout=f;function d(x){return new Promise((A,F)=>{const W=x();m(W)?W.then(A,F):A(W)})}e.asPromise=d;class v{constructor(){this.a=null,this.b=null,this.d=null}queue(A){if(this.a){if(this.d=A,!this.b){const F=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(F,F).then(W)})}return new Promise((F,W)=>{this.b.then(F,W)})}return this.a=A(),new Promise((F,W)=>{this.a.then(N=>{this.a=null,F(N)},N=>{this.a=null,W(N)})})}}e.Throttler=v;class a{constructor(){this.a=Promise.resolve(null)}queue(A){return this.a=this.a.then(()=>A(),()=>A())}}e.Sequencer=a;class u{constructor(){this.a=new Map}queue(A,F){const N=(this.a.get(A)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(A)===N&&this.a.delete(A)});return this.a.set(A,N),N}}e.SequencerByKey=u;const g=(x,A)=>{let F=!0;const W=setTimeout(()=>{F=!1,A()},x);return{isTriggered:()=>F,dispose:()=>{clearTimeout(W),F=!1}}},k=x=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,x())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class E{constructor(A){this.defaultDelay=A,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(A,F=this.defaultDelay){this.g=A,this.h(),this.b||(this.b=new Promise((N,$)=>{this.d=N,this.f=$}).then(()=>{if(this.b=null,this.d=null,this.g){const N=this.g;return this.g=null,N()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=F===e.MicrotaskDelay?k(W):g(F,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=E;class D{constructor(A){this.a=new E(A),this.b=new v}trigger(A,F){return this.a.trigger(()=>this.b.queue(A),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=D;class i{constructor(){this.a=!1,this.b=new Promise((A,F)=>{this.d=A})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class l extends i{constructor(A){super(),this.f=setTimeout(()=>this.open(),A)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=l;function n(x,A){return A?new Promise((F,W)=>{const N=setTimeout(()=>{$.dispose(),F()},x),$=A.onCancellationRequested(()=>{clearTimeout(N),$.dispose(),W(new t.CancellationError)})}):w(F=>n(x,F))}e.timeout=n;function s(x,A=0){const F=setTimeout(x,A);return(0,R.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=s;function o(x){const A=[];let F=0;const W=x.length;function N(){return F<W?x[F++]():null}function $(G){G!=null&&A.push(G);const j=N();return j?j.then($):Promise.resolve(A)}return Promise.resolve(null).then($)}e.sequence=o;function c(x,A=W=>!!W,F=null){let W=0;const N=x.length,$=()=>{if(W>=N)return Promise.resolve(F);const G=x[W++];return Promise.resolve(G()).then(X=>A(X)?Promise.resolve(X):$())};return $()}e.first=c;function r(x,A=W=>!!W,F=null){if(x.length===0)return Promise.resolve(F);let W=x.length;const N=()=>{W=-1;for(const $ of x)$.cancel?.()};return new Promise(($,G)=>{for(const j of x)j.then(X=>{--W>=0&&A(X)?(N(),$(X)):W===0&&$(F)}).catch(X=>{--W>=0&&(N(),G(X))})})}e.firstParallel=r;class h{constructor(A){this.a=0,this.d=A,this.f=[],this.b=0,this.g=new P.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(A){return this.a++,new Promise((F,W)=>{this.f.push({factory:A,c:F,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const A=this.f.shift();this.b++;const F=A.factory();F.then(A.c,A.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class C extends h{constructor(){super(1)}}e.Queue=C;class L{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const A=new q;return this.b.add(A),A.p}d(){for(const[,A]of this.a)if(A.size>0)return!1;return!0}queueFor(A,F=M.extUri){const W=F.getComparisonKey(A);let N=this.a.get(W);return N||(N=new C,P.Event.once(N.onDrained)(()=>{N?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,N)),N}f(){!this.d()||this.g()}g(){for(const A of this.b)A.complete();this.b.clear()}dispose(){for(const[,A]of this.a)A.dispose();this.a.clear(),this.g()}}e.ResourceQueue=L;class O{constructor(A,F){this.a=-1,typeof A=="function"&&typeof F=="number"&&this.setIfNotSet(A,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(A,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,A()},F)}setIfNotSet(A,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,A()},F))}}e.TimeoutTimer=O;class B{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(A,F){this.cancel(),this.a=setInterval(()=>{A()},F)}}e.IntervalTimer=B;class K{constructor(A,F){this.b=-1,this.a=A,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(A=this.d){this.cancel(),this.b=setTimeout(this.f,A)}get delay(){return this.d}set delay(A){this.d=A}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class V{constructor(A,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=A,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(A=this.b){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(A/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class J extends K{constructor(A,F){super(A,F),this.j=[]}work(A){this.j.push(A),this.isScheduled()||this.schedule()}h(){const A=this.j;this.j=[],this.a?.(A)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=J;class re extends R.Disposable{constructor(A,F){super(),this.g=A,this.h=F,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(A){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+A.length>this.g.maxBufferedWork)return!1}else if(this.pending+A.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of A)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=re,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,I.setTimeout0)(()=>{if(A)return;const F=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(x,A)=>{const F=requestIdleCallback(x,typeof A=="number"?{timeout:A}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(F))}}}}();class se{constructor(A){this.d=!1,this.a=()=>{try{this.f=A()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=se;async function ae(x,A,F){let W;for(let N=0;N<F;N++)try{return await x()}catch($){W=$,await n(A)}throw W}e.retry=ae;class fe{hasPending(A){return this.a?typeof A=="number"?this.a.taskId===A:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(A,F,W){return this.a={taskId:A,cancel:()=>W?.(),promise:F},F.then(()=>this.d(A),()=>this.d(A)),F}d(A){this.a&&A===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const A=this.b;this.b=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this.b)this.b.run=A;else{let F,W;const N=new Promise(($,G)=>{F=$,W=G});this.b={run:A,promise:N,promiseResolve:F,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=fe;class ge{constructor(A,F=()=>Date.now()){this.d=A,this.f=F,this.a=0,this.b=0}increment(){const A=this.f();return A-this.a>this.d&&(this.a=A,this.b=0),this.b++,this.b}}e.IntervalCounter=ge;class q{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((A,F)=>{this.a=A,this.b=F})}complete(A){return new Promise(F=>{this.a(A),this.f=!0,F()})}error(A){return new Promise(F=>{this.b(A),this.d=!0,F()})}cancel(){new Promise(A=>{this.b(new t.CancellationError),this.d=!0,A()})}}e.DeferredPromise=q;var T;(function(x){async function A(W){let N;const $=await Promise.all(W.map(G=>G.then(j=>j,j=>{N||(N=j)})));if(typeof N<"u")throw N;return $}x.settled=A;function F(W){return new Promise(async(N,$)=>{try{await W(N,$)}catch(G){$(G)}})}x.withAsyncBody=F})(T=e.Promises||(e.Promises={}));var U;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(U||(U={}));class z{static fromArray(A){return new z(F=>{F.emitMany(A)})}static fromPromise(A){return new z(async F=>{F.emitMany(await A)})}static fromPromises(A){return new z(async F=>{await Promise.all(A.map(async W=>F.emitOne(await W)))})}static merge(A){return new z(async F=>{await Promise.all(A.map(async W=>{for await(const N of W)F.emitOne(N)}))})}constructor(A){this.a=0,this.b=[],this.d=null,this.f=new P.Emitter,queueMicrotask(async()=>{const F={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(A(F)),this.j()}catch(W){this.k(W)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(A<this.b.length)return{done:!1,value:this.b[A++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(A,F){return new z(async W=>{for await(const N of A)W.emitOne(F(N))})}map(A){return z.map(this,A)}static filter(A,F){return new z(async W=>{for await(const N of A)F(N)&&W.emitOne(N)})}filter(A){return z.filter(this,A)}static coalesce(A){return z.filter(A,F=>!!F)}coalesce(){return z.coalesce(this)}static async toPromise(A){const F=[];for await(const W of A)F.push(W);return F}toPromise(){return z.toPromise(this)}g(A){this.a===0&&(this.b.push(A),this.f.fire())}h(A){this.a===0&&(this.b=this.b.concat(A),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(A){this.a===0&&(this.a=2,this.d=A,this.f.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class Q extends z{constructor(A,F){super(F),this.l=A}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Q;function ne(x){const A=new S.CancellationTokenSource,F=x(A.token);return new Q(A,async W=>{const N=A.token.onCancellationRequested(()=>{N.dispose(),A.dispose(),W.reject(new t.CancellationError)});try{for await(const $ of F){if(A.token.isCancellationRequested)return;W.emitOne($)}N.dispose(),A.dispose()}catch($){N.dispose(),A.dispose(),W.reject($)}})}e.createCancelableAsyncIterable=ne}),define(ee[100],te([0,1,25,8,32,40,9,4,27]),function(H,e,S,t,P,R,M,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const p="[/\\\\]",b="[^/\\\\]",y=/\//g;function f(q,T){switch(q){case 0:return"";case 1:return`${b}*?`;default:return`(?:${p}|${b}+${p}${T?`|${p}${b}+`:""})*?`}}function d(q,T){if(!q)return[];const U=[];let z=!1,Q=!1,ne="";for(const x of q){switch(x){case T:if(!z&&!Q){U.push(ne),ne="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}ne+=x}return ne&&U.push(ne),U}e.splitGlobAware=d;function v(q){if(!q)return"";let T="";const U=d(q,e.GLOB_SPLIT);if(U.every(z=>z===e.GLOBSTAR))T=".*";else{let z=!1;U.forEach((Q,ne)=>{if(Q===e.GLOBSTAR){if(z)return;T+=f(2,ne===U.length-1)}else{let x=!1,A="",F=!1,W="";for(const N of Q){if(N!=="}"&&x){A+=N;continue}if(F&&(N!=="]"||!W)){let $;N==="-"?$=N:(N==="^"||N==="!")&&!W?$="^":N===e.GLOB_SPLIT?$="":$=(0,m.escapeRegExpCharacters)(N),W+=$;continue}switch(N){case"{":x=!0;continue;case"[":F=!0;continue;case"}":{T+=`(?:${d(A,",").map(j=>v(j)).join("|")})`,x=!1,A="";break}case"]":{T+="["+W+"]",F=!1,W="";break}case"?":T+=b;continue;case"*":T+=f(1);continue;default:T+=(0,m.escapeRegExpCharacters)(N)}}ne<U.length-1&&(U[ne+1]!==e.GLOBSTAR||ne+2<U.length)&&(T+=p)}z=Q===e.GLOBSTAR})}return T}const a=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),l=function(){return!1},n=function(){return null};function s(q,T){if(!q)return n;let U;typeof q!="string"?U=q.pattern:U=q,U=U.trim();const z=`${U}_${!!T.trimForExclusions}`;let Q=i.get(z);if(Q)return o(Q,q);let ne;return a.test(U)?Q=r(U.substr(4),U):(ne=u.exec(c(U,T)))?Q=h(ne[1],U):(T.trimForExclusions?k:g).test(U)?Q=C(U,T):(ne=E.exec(c(U,T)))?Q=L(ne[1].substr(1),U,!0):(ne=D.exec(c(U,T)))?Q=L(ne[1],U,!1):Q=O(U),i.set(z,Q),o(Q,q)}function o(q,T){if(typeof T=="string")return q;const U=function(z,Q){return(0,P.isEqualOrParent)(z,T.base,!I.isLinux)?q((0,m.ltrim)(z.substr(T.base.length),M.sep),Q):null};return U.allBasenames=q.allBasenames,U.allPaths=q.allPaths,U.basenames=q.basenames,U.patterns=q.patterns,U}function c(q,T){return T.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function r(q,T){return function(U,z){return typeof U=="string"&&U.endsWith(q)?T:null}}function h(q,T){const U=`/${q}`,z=`\\${q}`,Q=function(x,A){return typeof x!="string"?null:A?A===q?T:null:x===q||x.endsWith(U)||x.endsWith(z)?T:null},ne=[q];return Q.basenames=ne,Q.patterns=[T],Q.allBasenames=ne,Q}function C(q,T){const U=fe(q.slice(1,-1).split(",").map(A=>s(A,T)).filter(A=>A!==n),q),z=U.length;if(!z)return n;if(z===1)return U[0];const Q=function(A,F){for(let W=0,N=U.length;W<N;W++)if(U[W](A,F))return q;return null},ne=U.find(A=>!!A.allBasenames);ne&&(Q.allBasenames=ne.allBasenames);const x=U.reduce((A,F)=>F.allPaths?A.concat(F.allPaths):A,[]);return x.length&&(Q.allPaths=x),Q}function L(q,T,U){const z=M.sep===M.posix.sep,Q=z?q:q.replace(y,M.sep),ne=M.sep+Q,x=M.posix.sep+q;let A;return U?A=function(F,W){return typeof F=="string"&&(F===Q||F.endsWith(ne)||!z&&(F===q||F.endsWith(x)))?T:null}:A=function(F,W){return typeof F=="string"&&(F===Q||!z&&F===q)?T:null},A.allPaths=[(U?"*/":"./")+q],A}function O(q){try{const T=new RegExp(`^${v(q)}$`);return function(U){return T.lastIndex=0,typeof U=="string"&&T.test(U)?q:null}}catch{return n}}function B(q,T,U){return!q||typeof T!="string"?!1:K(q)(T,void 0,U)}e.match=B;function K(q,T={}){if(!q)return l;if(typeof q=="string"||V(q)){const U=s(q,T);if(U===n)return l;const z=function(Q,ne){return!!U(Q,ne)};return U.allBasenames&&(z.allBasenames=U.allBasenames),U.allPaths&&(z.allPaths=U.allPaths),z}return se(q,T)}e.parse=K;function V(q){const T=q;return T?typeof T.base=="string"&&typeof T.pattern=="string":!1}e.isRelativePattern=V;function J(q){return q.allBasenames||[]}e.getBasenameTerms=J;function re(q){return q.allPaths||[]}e.getPathTerms=re;function se(q,T){const U=fe(Object.getOwnPropertyNames(q).map(A=>ae(A,q[A],T)).filter(A=>A!==n)),z=U.length;if(!z)return n;if(!U.some(A=>!!A.requiresSiblings)){if(z===1)return U[0];const A=function(N,$){let G;for(let j=0,X=U.length;j<X;j++){const Z=U[j](N,$);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&(G||(G=[]),G.push(Z))}return G?(async()=>{for(const j of G){const X=await j;if(typeof X=="string")return X}return null})():null},F=U.find(N=>!!N.allBasenames);F&&(A.allBasenames=F.allBasenames);const W=U.reduce((N,$)=>$.allPaths?N.concat($.allPaths):N,[]);return W.length&&(A.allPaths=W),A}const Q=function(A,F,W){let N,$;for(let G=0,j=U.length;G<j;G++){const X=U[G];X.requiresSiblings&&W&&(F||(F=(0,M.basename)(A)),N||(N=F.substr(0,F.length-(0,M.extname)(A).length)));const Z=X(A,F,N,W);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&($||($=[]),$.push(Z))}return $?(async()=>{for(const G of $){const j=await G;if(typeof j=="string")return j}return null})():null},ne=U.find(A=>!!A.allBasenames);ne&&(Q.allBasenames=ne.allBasenames);const x=U.reduce((A,F)=>F.allPaths?A.concat(F.allPaths):A,[]);return x.length&&(Q.allPaths=x),Q}function ae(q,T,U){if(T===!1)return n;const z=s(q,U);if(z===n)return n;if(typeof T=="boolean")return z;if(T){const Q=T.when;if(typeof Q=="string"){const ne=(x,A,F,W)=>{if(!W||!z(x,A))return null;const N=Q.replace("$(basename)",()=>F),$=W(N);return(0,t.isThenable)($)?$.then(G=>G?q:null):$?q:null};return ne.requiresSiblings=!0,ne}}return z}function fe(q,T){const U=q.filter(A=>!!A.basenames);if(U.length<2)return q;const z=U.reduce((A,F)=>{const W=F.basenames;return W?A.concat(W):A},[]);let Q;if(T){Q=[];for(let A=0,F=z.length;A<F;A++)Q.push(T)}else Q=U.reduce((A,F)=>{const W=F.patterns;return W?A.concat(W):A},[]);const ne=function(A,F){if(typeof A!="string")return null;if(!F){let N;for(N=A.length;N>0;N--){const $=A.charCodeAt(N-1);if($===47||$===92)break}F=A.substr(N)}const W=z.indexOf(F);return W!==-1?Q[W]:null};ne.basenames=z,ne.patterns=Q,ne.allBasenames=z;const x=q.filter(A=>!A.basenames);return x.push(ne),x}function ge(q,T){return(0,S.equals)(q,T,(U,z)=>typeof U=="string"&&typeof z=="string"?U===z:typeof U!="string"&&typeof z!="string"?U.base===z.base&&U.pattern===z.pattern:!1)}e.patternsEquals=ge}),define(ee[36],te([0,1,25,32,9,4,20,27]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function m(n,s){const{os:o,tildify:c,relative:r}=s;if(r){const L=w(n,r,o);if(typeof L=="string")return L}let h=n.fsPath;if(o===1&&!R.isWindows?h=h.replace(/\//g,"\\"):o!==1&&R.isWindows&&(h=h.replace(/\\/g,"/")),o!==1&&c?.userHome){const L=c.userHome.fsPath;let O;n.scheme!==c.userHome.scheme&&n.path.startsWith(P.posix.sep)?O=c.userHome.with({path:n.path}).fsPath:O=n.fsPath,h=y(O,L,o)}return(o===1?P.win32:P.posix).normalize(p(h,o===1))}e.getPathLabel=m;function w(n,s,o){const c=o===1?P.win32:P.posix,r=o===3?M.extUri:M.extUriIgnorePathCase,h=s.getWorkspace(),C=(0,S.firstOrDefault)(h.folders);if(!C)return;n.scheme!==C.uri.scheme&&n.path.startsWith(P.posix.sep)&&(n=C.uri.with({path:n.path}));const L=s.getWorkspaceFolder(n);if(!L)return;let O;if(r.isEqual(L.uri,n)?O="":O=r.relativePath(L.uri,n)??"",O&&(O=c.normalize(O)),h.folders.length>1&&!s.noPrefix){const B=L.name?L.name:r.basenameOrAuthority(L.uri);O=O?`${B} \u2022 ${O}`:B}return O}function p(n,s=R.isWindows){return(0,t.hasDriveLetter)(n,s)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=p;let b=Object.create(null);function y(n,s,o=R.OS){if(o===1||!n||!s)return n;let c=b.original===s?b.normalized:void 0;c||(c=s,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,I.rtrim)(c,P.posix.sep)}${P.posix.sep}`,b={original:s,normalized:c});let r=n;return R.isWindows&&(r=(0,t.toSlashes)(r)),(o===3?r.startsWith(c):(0,I.startsWithIgnoreCase)(r,c))?`~/${r.substr(c.length)}`:n}e.tildify=y;function f(n,s){return n.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=f;const d="\u2026",v="\\\\",a="~";function u(n,s=P.sep){const o=new Array(n.length);let c=!1;for(let r=0;r<n.length;r++){const h=n[r];if(h===""){o[r]=`.${s}`;continue}if(!h){o[r]=h;continue}c=!0;let C="",L=h;L.indexOf(v)===0?(C=L.substr(0,L.indexOf(v)+v.length),L=L.substr(L.indexOf(v)+v.length)):L.indexOf(s)===0?(C=L.substr(0,L.indexOf(s)+s.length),L=L.substr(L.indexOf(s)+s.length)):L.indexOf(a)===0&&(C=L.substr(0,L.indexOf(a)+a.length),L=L.substr(L.indexOf(a)+a.length));const O=L.split(s);for(let B=1;c&&B<=O.length;B++)for(let K=O.length-B;c&&K>=0;K--){c=!1;let V=O.slice(K,K+B).join(s);for(let J=0;!c&&J<n.length;J++)if(J!==r&&n[J]&&n[J].indexOf(V)>-1){const re=K+B===O.length,se=K>0&&n[J].indexOf(s)>-1?s+V:V,ae=n[J].endsWith(se);c=!re||ae}if(!c){let J="";(O[0].endsWith(":")||C!=="")&&(K===1&&(K=0,B++,V=O[0]+s+V),K>0&&(J=O[0]+s),J=C+J),K>0&&(J=J+d+s),J=J+V,K+B<O.length&&(J=J+s+d),o[r]=J}}c&&(o[r]=h)}return o}e.shorten=u;var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function k(n,s=Object.create(null)){const o=[];let c=!1,r="";for(const h of n)if(h==="$"||c&&h==="{")r&&o.push({value:r,type:g.TEXT}),r="",c=!0;else if(h==="}"&&c){const C=s[r];if(typeof C=="string")C.length&&o.push({value:C,type:g.VARIABLE});else if(C){const L=o[o.length-1];(!L||L.type!==g.SEPARATOR)&&o.push({value:C.label,type:g.SEPARATOR})}r="",c=!1}else r+=h;return r&&!c&&o.push({value:r,type:g.TEXT}),o.filter((h,C)=>{if(h.type===g.SEPARATOR){const L=o[C-1],O=o[C+1];return[L,O].every(B=>B&&(B.type===g.VARIABLE||B.type===g.TEXT)&&B.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=k;function E(n,s){return R.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function D(n,s){return R.isMacintosh||s?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,o=>o==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=D;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function l(n){const s=n.indexOf("/")!==-1?P.posix:P.win32,o=s.basename(n),c=s.dirname(n);return o.length?{name:o,parentPath:c}:{name:c,parentPath:""}}e.splitName=l}),define(ee[142],te([0,1,7]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(p){return p.toJSON()}class P{constructor(b){this.a=b}transformIncoming(b){const y=this.a.transformIncoming(b);return y===b?b:t(S.URI.from(y))}transformOutgoing(b){const y=this.a.transformOutgoing(b);return y===b?b:t(S.URI.from(y))}transformOutgoingURI(b){const y=this.a.transformOutgoing(b);return y===b?b:S.URI.from(y)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function R(p,b,y){if(!p||y>200)return null;if(typeof p=="object"){if(p instanceof S.URI)return b.transformOutgoing(p);for(const f in p)if(Object.hasOwnProperty.call(p,f)){const d=R(p[f],b,y+1);d!==null&&(p[f]=d)}}return null}function M(p,b){const y=R(p,b,0);return y===null?p:y}e.transformOutgoingURIs=M;function I(p,b,y,f){if(!p||f>200)return null;if(typeof p=="object"){if(p.$mid===1)return y?S.URI.revive(b.transformIncoming(p)):b.transformIncoming(p);for(const d in p)if(Object.hasOwnProperty.call(p,d)){const v=I(p[d],b,y,f+1);v!==null&&(p[d]=v)}}return null}function m(p,b){const y=I(p,b,!1,0);return y===null?p:y}e.transformIncomingURIs=m;function w(p,b){const y=I(p,b,!0,0);return y===null?p:y}e.transformAndReviveIncomingURIs=w}),define(ee[83],te([0,1,26,13,60,31,130]),function(H,e,S,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(p){return this.a||(this.a=P.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,b=0;const y=(0,S.networkInterfaces)();for(const f in y){const d=y[f];if(d)for(const{mac:v,internal:a}of d)a||(b+=1,this.c(v.toUpperCase())&&(p+=1))}this.b=b>0?p/b:0}return this.b}};let I;async function m(){return I||(I=(async()=>await w()||R.generateUuid())()),I}e.getMachineId=m;async function w(){try{const p=await new Promise((y,f)=>{H(["crypto"],y,f)}),b=(0,M.getMac)();return p.createHash("sha256").update(b,"utf8").digest("hex")}catch(p){t.onUnexpectedError(p);return}}}),define(ee[23],te([0,1,41,26,143,8,32,78,9,4,20,7]),function(H,e,S,t,P,R,M,I,m,w,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function f(se,ae=y.UNLINK){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ae===y.UNLINK?v(se):d(se)}async function d(se){try{const ae=(0,M.randomPath)((0,t.tmpdir)());try{await S.promises.rename(se,ae)}catch(fe){return fe.code==="ENOENT"?void 0:v(se)}v(ae).catch(fe=>{})}catch(ae){if(ae.code!=="ENOENT")throw ae}}async function v(se){return(0,P.promisify)(S.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function a(se){if((0,M.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function u(se,ae){return E(await(ae?g(se):(0,P.promisify)(S.readdir)(se)))}async function g(se){try{return await(0,P.promisify)(S.readdir)(se,{withFileTypes:!0})}catch(ge){console.warn("[node.js fs] readdir with filetypes failed with error: ",ge)}const ae=[],fe=await u(se);for(const ge of fe){let q=!1,T=!1,U=!1;try{const z=await e.Promises.lstat((0,m.join)(se,ge));q=z.isFile(),T=z.isDirectory(),U=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}ae.push({name:ge,isFile:()=>q,isDirectory:()=>T,isSymbolicLink:()=>U})}return ae}function k(se){return E(S.readdirSync(se))}e.readdirSync=k;function E(se){return se.map(ae=>typeof ae=="string"?w.isMacintosh?(0,I.normalizeNFC)(ae):ae:(ae.name=w.isMacintosh?(0,I.normalizeNFC)(ae.name):ae.name,ae))}async function D(se){const ae=await u(se),fe=[];for(const ge of ae)await l.existsDirectory((0,m.join)(se,ge))&&fe.push(ge);return fe}function i(se,ae=1e3){return new Promise(fe=>{let ge=!1;const q=setInterval(()=>{ge||(ge=!0,S.access(se,T=>{ge=!1,T&&(clearInterval(q),fe(void 0))}))},ae)})}e.whenDeleted=i;var l;(function(se){async function ae(q){let T;try{if(T=await e.Promises.lstat(q),!T.isSymbolicLink())return{stat:T}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:T?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(w.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw z}throw U}}se.stat=ae;async function fe(q){try{const{stat:T,symbolicLink:U}=await se.stat(q);return T.isFile()&&U?.dangling!==!0}catch{}return!1}se.existsFile=fe;async function ge(q){try{const{stat:T,symbolicLink:U}=await se.stat(q);return T.isDirectory()&&U?.dangling!==!0}catch{}return!1}se.existsDirectory=ge})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function s(se,ae,fe){return n.queueFor(b.URI.file(se),p.extUriBiasedIgnorePathCase).queue(()=>{const ge=C(fe);return new Promise((q,T)=>r(se,ae,ge,U=>U?T(U):q()))})}let o=!0;function c(se){o=se}e.configureFlushOnWrite=c;function r(se,ae,fe,ge){if(!o)return S.writeFile(se,ae,{mode:fe.mode,flag:fe.flag},ge);S.open(se,fe.flag,fe.mode,(q,T)=>{if(q)return ge(q);S.writeFile(T,ae,U=>{if(U)return S.close(T,()=>ge(U));S.fdatasync(T,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),c(!1)),S.close(T,Q=>ge(Q))))})})}function h(se,ae,fe){const ge=C(fe);if(!o)return S.writeFileSync(se,ae,{mode:ge.mode,flag:ge.flag});const q=S.openSync(se,ge.flag,ge.mode);try{S.writeFileSync(q,ae);try{S.fdatasyncSync(q)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),c(!1)}}finally{S.closeSync(q)}}e.writeFileSync=h;function C(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function L(se,ae){if(se!==ae)try{await e.Promises.rename(se,ae)}catch(fe){if(se.toLowerCase()!==ae.toLowerCase()&&fe.code==="EXDEV"||se.endsWith("."))await O(se,ae,{preserveSymlinks:!1}),await f(se,y.MOVE);else throw fe}}async function O(se,ae,fe){return K(se,ae,{root:{source:se,target:ae},options:fe,handledSourcePaths:new Set})}const B=511;async function K(se,ae,fe){if(fe.handledSourcePaths.has(se))return;fe.handledSourcePaths.add(se);const{stat:ge,symbolicLink:q}=await l.stat(se);if(q){if(fe.options.preserveSymlinks)try{return await re(se,ae,fe)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(q.dangling)return}return ge.isDirectory()?V(se,ae,ge.mode&B,fe):J(se,ae,ge.mode&B)}async function V(se,ae,fe,ge){await e.Promises.mkdir(ae,{recursive:!0,mode:fe});const q=await u(se);for(const T of q)await K((0,m.join)(se,T),(0,m.join)(ae,T),ge)}async function J(se,ae,fe){await e.Promises.copyFile(se,ae),await e.Promises.chmod(ae,fe)}async function re(se,ae,fe){let ge=await e.Promises.readlink(se);(0,M.isEqualOrParent)(ge,fe.root.source,!w.isLinux)&&(ge=(0,m.join)(fe.root.target,ge.substr(fe.root.source.length+1))),await e.Promises.symlink(ge,ae)}e.Promises=new class{get access(){return(0,P.promisify)(S.access)}get stat(){return(0,P.promisify)(S.stat)}get lstat(){return(0,P.promisify)(S.lstat)}get utimes(){return(0,P.promisify)(S.utimes)}get read(){return(se,ae,fe,ge,q)=>new Promise((T,U)=>{S.read(se,ae,fe,ge,q,(z,Q,ne)=>z?U(z):T({bytesRead:Q,buffer:ne}))})}get readFile(){return(0,P.promisify)(S.readFile)}get write(){return(se,ae,fe,ge,q)=>new Promise((T,U)=>{S.write(se,ae,fe,ge,q,(z,Q,ne)=>z?U(z):T({bytesWritten:Q,buffer:ne}))})}get appendFile(){return(0,P.promisify)(S.appendFile)}get fdatasync(){return(0,P.promisify)(S.fdatasync)}get truncate(){return(0,P.promisify)(S.truncate)}get rename(){return(0,P.promisify)(S.rename)}get copyFile(){return(0,P.promisify)(S.copyFile)}get open(){return(0,P.promisify)(S.open)}get close(){return(0,P.promisify)(S.close)}get symlink(){return(0,P.promisify)(S.symlink)}get readlink(){return(0,P.promisify)(S.readlink)}get chmod(){return(0,P.promisify)(S.chmod)}get mkdir(){return(0,P.promisify)(S.mkdir)}get unlink(){return(0,P.promisify)(S.unlink)}get rmdir(){return(0,P.promisify)(S.rmdir)}get realpath(){return(0,P.promisify)(S.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return D}get writeFile(){return s}get rm(){return f}get move(){return L}get copy(){return O}}}),define(ee[101],te([0,1,41,9,4,27,23]),function(H,e,S,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(y){if(P.isLinux)return y;const f=(0,t.dirname)(y);if(y===f)return y;const d=((0,t.basename)(y)||y).toLowerCase();try{const a=(0,M.readdirSync)(f).filter(u=>u.toLowerCase()===d);if(a.length===1){const u=I(f);if(u)return(0,t.join)(u,a[0])}else if(a.length>1){const u=a.indexOf(d);if(u>=0){const g=I(f);if(g)return(0,t.join)(g,a[u])}}}catch{}return null}e.realcaseSync=I;async function m(y){if(P.isLinux)return y;const f=(0,t.dirname)(y);if(y===f)return y;const d=((0,t.basename)(y)||y).toLowerCase();try{const a=(await M.Promises.readdir(f)).filter(u=>u.toLowerCase()===d);if(a.length===1){const u=await m(f);if(u)return(0,t.join)(u,a[0])}else if(a.length>1){const u=a.indexOf(d);if(u>=0){const g=await m(f);if(g)return(0,t.join)(g,a[u])}}}catch{}return null}e.realcase=m;async function w(y){try{return await M.Promises.realpath(y)}catch{const d=b(y);return await M.Promises.access(d,S.constants.R_OK),d}}e.realpath=w;function p(y){try{return S.realpathSync(y)}catch{const d=b(y);return S.accessSync(d,S.constants.R_OK),d}}e.realpathSync=p;function b(y){return(0,R.rtrim)((0,t.normalize)(y),t.sep)}}),define(ee[144],te([0,1,26,9,23]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,M=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var m;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(m||(m={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class b{constructor(D,i,l){this.exePath=D,this.displayName=i,this.a=l}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:E=!1}={}){return E?w===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:E=!1,findPreview:D=!1}={}){const i=y({useAlternateBitness:E});if(!i)return null;const l=t.join(i,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(l))return null;let n=-1,s=null;for(const r of await P.Promises.readdir(l)){let h=-1;if(D){const L=r.indexOf("-");if(L<0)continue;const O=r.substring(0,L);if(!R.test(O)||r.substring(L+1)!=="preview")continue;h=parseInt(O,10)}else{if(!R.test(r))continue;h=parseInt(r,10)}if(h<=n)continue;const C=t.join(l,r,"pwsh.exe");!await P.SymlinkSupport.existsFile(C)||(s=C,n=h)}if(!s)return null;const o=i.includes("x86")?" (x86)":"",c=D?" Preview":"";return new b(s,`PowerShell${c}${o}`,!0)}async function d({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const D=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(D))return null;const{pwshMsixDirRegex:i,pwshMsixName:l}=E?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const n of await P.Promises.readdir(D))if(i.test(n)){const s=t.join(D,n,"pwsh.exe");return new b(s,l)}return null}function v(){const E=t.join(S.homedir(),".dotnet","tools","pwsh.exe");return new b(E,".NET Core PowerShell Global Tool")}function a(){const E=t.join(process.env.windir,w===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(E,"Windows PowerShell",!0)}async function*u(){let E=await f();E&&(yield E),E=await f({useAlternateBitness:!0}),E&&(yield E),E=await d(),E&&(yield E),E=v(),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await d({findPreview:!0}),E&&(yield E),E=await f({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=a(),E&&(yield E)}async function*g(){for await(const E of u())await E.exists()&&(yield E)}e.enumeratePowerShellInstallations=g;async function k(){for await(const E of g())return E;return null}e.getFirstAvailablePowerShellInstallation=k}),define(ee[84],te([0,1,9,4,35,81,11,23]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function m(b=P.env){return b.comspec||"cmd.exe"}e.getWindowsShell=m;function w(b){let y=[],f=!1;const d=function(v){if(f){y.push(v);return}(!b.send(v,u=>{if(u&&console.error(u),f=!1,y.length>0){const g=y.slice(0);y=[],g.forEach(k=>d(k))}})||t.isWindows)&&(f=!0)};return{send:d}}e.createQueuedSender=w;var p;(function(b){async function y(f,d,v){if(S.isAbsolute(f))return f;if(d===void 0&&(d=P.cwd()),S.dirname(f)!=="."||(v===void 0&&M.isString(P.env.PATH)&&(v=P.env.PATH.split(S.delimiter)),v===void 0||v.length===0))return S.join(d,f);async function u(g){if(await I.Promises.exists(g)){let k;try{k=await I.Promises.stat(g)}catch(E){E.message.startsWith("EACCES")&&(k=await I.Promises.lstat(g))}return k?!k.isDirectory():!1}return!1}for(const g of v){let k;if(S.isAbsolute(g)?k=S.join(g,f):k=S.join(d,g,f),await u(k))return k;let E=k+".com";if(await u(E)||(E=k+".exe",await u(E)))return E}return S.join(d,f)}b.findExecutable=y})(p=e.win32||(e.win32={}))}),define(ee[102],te([0,1,46,15]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function P(M){return new Promise((I,m)=>{let w;const p=new Map;function b(f,d,v,a,u){const g=p.get(d);if(f===M||g){const k={name:y(v),cmd:v,pid:f,ppid:d,load:a,mem:u};p.set(f,k),f===M&&(w=k),g&&(g.children||(g.children=[]),g.children.push(k),g.children.length>1&&(g.children=g.children.sort((E,D)=>E.pid-D.pid)))}}function y(f){const d=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,a=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,k=/--crashes-directory/,E=/\\pipe\\winpty-control/,D=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(k.exec(f))return"electron-crash-reporter";if(E.exec(f))return"winpty-process";if(D.exec(f))return"console-window-host (Windows internal process)";let l=i.exec(f);if(l&&l.length===2){if(l[1]==="renderer")return d.exec(f)?"shared-process":v.exec(f)?"issue-reporter":a.exec(f)?"process-explorer":"window";if(l[1]==="utility"){if(u.exec(f))return"utility-network-service";if(g.exec(f))return"extension-host"}else if(l[1]==="extensionHost")return"extension-host";return l[1]}const n=/[a-zA-Z-]+\.js/g;let s="";do l=n.exec(f),l&&(s+=l+" ");while(l);return s&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron_node ${s}`:f}if(process.platform==="win32"){const f=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,v)=>{H(["windows-process-tree"],d,v)}).then(d=>{d.getProcessList(M,v=>{if(!v){m(new Error(`Root process ${M} not found`));return}d.getProcessCpuUsage(v,a=>{const u=new Map;a.forEach(g=>{const k=f(g.commandLine||"");u.set(g.pid,{name:y(k),cmd:k,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),w=u.get(M),w?(u.forEach(g=>{const k=u.get(g.ppid);k&&(k.children||(k.children=[]),k.children.push(g))}),u.forEach(g=>{g.children&&(g.children=g.children.sort((k,E)=>k.pid-E.pid))}),I(w)):m(new Error(`Root process ${M} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let f=function(){let d=[w];const v=[];for(;d.length;){const u=d.shift();u&&(v.push(u.pid),u.children&&(d=d.concat(u.children)))}let a=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+v.join(" "),(0,S.exec)(a,{},(u,g,k)=>{if(u||k)m(u||new Error(k.toString()));else{const E=g.toString().split(`
`);for(let D=0;D<v.length;D++){const i=p.get(v[D]);i.load=parseFloat(E[D])}if(!w){m(new Error(`Root process ${M} not found`));return}I(w)}})};(0,S.exec)("which ps",{},(d,v,a)=>{if(d||a)if(process.platform!=="linux")m(d||new Error(a.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(u,{},(g,k,E)=>{g||E?m(g||new Error(E.toString())):(R(k,b),f())})}else{const u=v.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${u} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(k,E,D)=>{k||D&&!D.includes("screen size is bogus")?m(k||new Error(D.toString())):(R(E,b),process.platform==="linux"?f():w?I(w):m(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=P;function R(M,I){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=M.toString().split(`
`);for(const p of w){const b=m.exec(p.trim());b&&b.length===6&&I(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(ee[145],te([0,1,26,4,144,84]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function M(b,y){return b===1?t.isWindows?p():R.getWindowsShell(y):m(b,y)}e.getSystemShell=M;let I=null;function m(b,y){if(t.isLinux&&b===2||t.isMacintosh&&b===3)return"/bin/bash";if(!I){let f;if(t.isWindows)f="/bin/bash";else{if(f=y.SHELL,!f)try{f=(0,S.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}I=f}return I}let w=null;async function p(){return w||(w=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),w}});var pe=this&&this.__decorate||function(H,e,S,t){var P=arguments.length,R=P<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,S):t,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(H,e,S,t);else for(var I=H.length-1;I>=0;I--)(M=H[I])&&(R=(P<3?M(R):P>3?M(e,S,R):M(e,S))||R);return P>3&&R&&Object.defineProperty(e,S,R),R};define(ee[47],te([0,1,25,8,17,22,54,13,3,2,71,27,11]),function(H,e,S,t,P,R,M,I,m,w,p,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(f||(f={}));function d(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(v||(v={}));function a(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(u||(u={}));function g(T){let U=0;for(let z=0;;z+=7){const Q=T.read(1);if(U|=(Q.buffer[0]&127)<<z,!(Q.buffer[0]&128))return U}}const k=n(0);function E(T,U){if(U===0){T.write(k);return}let z=0;for(let ne=U;ne!==0;ne=ne>>>7)z++;const Q=P.VSBuffer.alloc(z);for(let ne=0;U!==0;ne++)Q.buffer[ne]=U&127,U=U>>>7,U>0&&(Q.buffer[ne]|=128);T.write(Q)}class D{constructor(U){this.b=U,this.a=0}read(U){const z=this.b.slice(this.a,this.a+U);return this.a+=z.byteLength,z}}e.BufferReader=D;class i{constructor(){this.a=[]}get buffer(){return P.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=i;var l;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(l||(l={}));function n(T){const U=P.VSBuffer.alloc(1);return U.writeUInt8(T,0),U}const s={Undefined:n(l.Undefined),String:n(l.String),Buffer:n(l.Buffer),VSBuffer:n(l.VSBuffer),Array:n(l.Array),Object:n(l.Object),Uint:n(l.Int)},o=typeof Buffer<"u";function c(T,U){if(typeof U>"u")T.write(s.Undefined);else if(typeof U=="string"){const z=P.VSBuffer.fromString(U);T.write(s.String),E(T,z.byteLength),T.write(z)}else if(o&&Buffer.isBuffer(U)){const z=P.VSBuffer.wrap(U);T.write(s.Buffer),E(T,z.byteLength),T.write(z)}else if(U instanceof P.VSBuffer)T.write(s.VSBuffer),E(T,U.byteLength),T.write(U);else if(Array.isArray(U)){T.write(s.Array),E(T,U.length);for(const z of U)c(T,z)}else if(typeof U=="number"&&(U|0)===U)T.write(s.Uint),E(T,U);else{const z=P.VSBuffer.fromString(JSON.stringify(U));T.write(s.Object),E(T,z.byteLength),T.write(z)}}e.serialize=c;function r(T){switch(T.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return T.read(g(T)).toString();case l.Buffer:return T.read(g(T)).buffer;case l.VSBuffer:return T.read(g(T));case l.Array:{const z=g(T),Q=[];for(let ne=0;ne<z;ne++)Q.push(r(T));return Q}case l.Object:return JSON.parse(T.read(g(T)).toString());case l.Int:return g(T)}}e.deserialize=r;class h{constructor(U,z,Q=null,ne=1e3){this.h=U,this.j=z,this.k=Q,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(U,z){this.b.set(U,z),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const z=this.o([U.type]);this.k?.logOutgoing(z,0,1,a(U.type));return}case 201:case 202:case 204:case 203:{const z=this.o([U.type,U.id],U.data);this.k?.logOutgoing(z,U.id,1,a(U.type),U.data);return}}}o(U,z=void 0){const Q=new i;return c(Q,U),c(Q,z),this.p(Q.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const z=new D(U),Q=r(z),ne=r(z),x=Q[0];switch(x){case 100:return this.k?.logIncoming(U.byteLength,Q[1],1,`${d(x)}: ${Q[2]}.${Q[3]}`,ne),this.s({type:x,id:Q[1],channelName:Q[2],name:Q[3],arg:ne});case 102:return this.k?.logIncoming(U.byteLength,Q[1],1,`${d(x)}: ${Q[2]}.${Q[3]}`,ne),this.t({type:x,id:Q[1],channelName:Q[2],name:Q[3],arg:ne});case 101:return this.k?.logIncoming(U.byteLength,Q[1],1,`${d(x)}`),this.u({type:x,id:Q[1]});case 103:return this.k?.logIncoming(U.byteLength,Q[1],1,`${d(x)}`),this.u({type:x,id:Q[1]})}}s(U){const z=this.b.get(U.channelName);if(!z){this.v(U);return}const Q=new R.CancellationTokenSource;let ne;try{ne=z.call(this.j,U.name,U.arg,Q.token)}catch(F){ne=Promise.reject(F)}const x=U.id;ne.then(F=>{this.m({id:x,data:F,type:201}),this.d.delete(U.id)},F=>{F instanceof Error?this.m({id:x,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:x,data:F,type:203}),this.d.delete(U.id)});const A=(0,w.toDisposable)(()=>Q.cancel());this.d.set(U.id,A)}t(U){const z=this.b.get(U.channelName);if(!z){this.v(U);return}const Q=U.id,x=z.listen(this.j,U.name,U.arg)(A=>this.m({id:Q,data:A,type:204}));this.d.set(U.id,x)}u(U){const z=this.d.get(U.id);z&&(z.dispose(),this.d.delete(U.id))}v(U){let z=this.g.get(U.channelName);z||(z=[],this.g.set(U.channelName,z));const Q=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:U,timeoutTimer:Q})}w(U){const z=this.g.get(U);if(z){for(const Q of z)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=h;var C;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(U,z=null){this.l=U,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=z}getChannel(U){const z=this;return{call(Q,ne,x){return z.a?Promise.reject(new I.CancellationError):z.m(U,Q,ne,x)},listen(Q,ne){return z.a?m.Event.None:z.o(U,Q,ne)}}}m(U,z,Q,ne=R.CancellationToken.None){const x=this.g++,F={id:x,type:100,channelName:U,name:z,arg:Q};if(ne.isCancellationRequested)return Promise.reject(new I.CancellationError);let W;return new Promise(($,G)=>{if(ne.isCancellationRequested)return G(new I.CancellationError);const j=()=>{const de=ke=>{switch(ke.type){case 201:this.f.delete(x),$(ke.data);break;case 202:{this.f.delete(x);const De=new Error(ke.data.message);De.stack=Array.isArray(ke.data.stack)?ke.data.stack.join(`
`):ke.data.stack,De.name=ke.data.name,G(De);break}case 203:this.f.delete(x),G(ke.data);break}};this.f.set(x,de),this.p(F)};let X=null;this.b===u.Idle?j():(X=(0,t.createCancelablePromise)(de=>this.u()),X.then(()=>{X=null,j()}));const Z=()=>{X?(X.cancel(),X=null):this.p({id:x,type:101}),G(new I.CancellationError)},oe=ne.onCancellationRequested(Z);W=(0,w.combinedDisposable)((0,w.toDisposable)(Z),oe),this.d.add(W)}).finally(()=>{this.d.delete(W)})}o(U,z,Q){const ne=this.g++,A={id:ne,type:102,channelName:U,name:z,arg:Q};let F=null;const W=new m.Emitter({onWillAddFirstListener:()=>{F=(0,t.createCancelablePromise)($=>this.u()),F.then(()=>{F=null,this.d.add(W),this.p(A)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(W),this.p({id:ne,type:103}))}}),N=$=>W.fire($.data);return this.f.set(ne,N),W.event}p(U){switch(U.type){case 100:case 102:{const z=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(z,U.id,0,`${d(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const z=this.q([U.type,U.id]);this.j?.logOutgoing(z,U.id,0,d(U.type));return}}}q(U,z=void 0){const Q=new i;return c(Q,U),c(Q,z),this.r(Q.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const z=new D(U),Q=r(z),ne=r(z),x=Q[0];switch(x){case 200:return this.j?.logIncoming(U.byteLength,0,0,a(x)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,Q[1],0,a(x),ne),this.t({type:Q[0],id:Q[1],data:ne})}}t(U){if(U.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.dispose)(this.d.values()),this.d.clear()}}pe([M.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class O{get connections(){const U=[];return this.f.forEach(z=>U.push(z)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new m.Emitter,this.onDidAddConnection=this.g.event,this.h=new m.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:z,onDidClientDisconnect:Q})=>{m.Event.once(z.onMessage)(x=>{const A=new D(x),F=r(A),W=new h(z,F),N=new L(z);this.a.forEach((G,j)=>W.registerChannel(j,G));const $={channelServer:W,channelClient:N,ctx:F};this.f.add($),this.g.fire($),Q(()=>{W.dispose(),N.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(U,z){const Q=this;return{call(ne,x,A){let F;if((0,y.isFunction)(z)){const N=(0,S.getRandomElement)(Q.connections.filter(z));F=N?Promise.resolve(N):m.Event.toPromise(m.Event.filter(Q.onDidAddConnection,z))}else F=z.routeCall(Q,ne,x);const W=F.then(N=>N.channelClient.getChannel(U));return K(W).call(ne,x,A)},listen(ne,x){if((0,y.isFunction)(z))return Q.j(U,z,ne,x);const A=z.routeEvent(Q,ne,x).then(F=>F.channelClient.getChannel(U));return K(A).listen(ne,x)}}}j(U,z,Q,ne){const x=this;let A=new w.DisposableStore;const F=new m.Emitter({onWillAddFirstListener:()=>{A=new w.DisposableStore;const W=new m.EventMultiplexer,N=new Map,$=j=>{const Z=j.channelClient.getChannel(U).listen(Q,ne),oe=W.add(Z);N.set(j,oe)},G=j=>{const X=N.get(j);!X||(X.dispose(),N.delete(j))};x.connections.filter(z).forEach($),m.Event.filter(x.onDidAddConnection,z)($,void 0,A),x.onDidRemoveConnection(G,void 0,A),W.event(F.fire,F,A),A.add(W)},onDidRemoveLastListener:()=>{A.dispose()}});return F.event}registerChannel(U,z){this.a.set(U,z),this.f.forEach(Q=>{Q.channelServer.registerChannel(U,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class B{constructor(U,z,Q=null){const ne=new i;c(ne,z),U.send(ne.buffer),this.a=new L(U,Q),this.d=new h(U,z,Q)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,z){this.d.registerChannel(U,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=B;function K(T){return{call(U,z,Q){return T.then(ne=>ne.call(U,z,Q))},listen(U,z){const Q=new m.Relay;return T.then(ne=>Q.input=ne.listen(U,z)),Q.event}}}e.getDelayedChannel=K;function V(T){let U=!1;return{call(z,Q,ne){return U?T.call(z,Q,ne):(0,t.timeout)(0).then(()=>U=!0).then(()=>T.call(z,Q,ne))},listen(z,Q){if(U)return T.listen(z,Q);const ne=new m.Relay;return(0,t.timeout)(0).then(()=>U=!0).then(()=>ne.input=T.listen(z,Q)),ne.event}}}e.getNextTickChannel=V;class J{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const z of U.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await m.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=J;var re;(function(T){function U(x,A){const F=x,W=A&&A.disableMarshalling,N=new Map;for(const $ in F)Q($)&&N.set($,m.Event.buffer(F[$],!0));return new class{listen($,G,j){const X=N.get(G);if(X)return X;if(ne(G)){const Z=F[G];if(typeof Z=="function")return Z.call(F,j)}throw new Error(`Event not found: ${G}`)}call($,G,j){const X=F[G];if(typeof X=="function"){if(!W&&Array.isArray(j))for(let Z=0;Z<j.length;Z++)j[Z]=(0,p.revive)(j[Z]);return X.apply(F,j)}throw new Error(`Method not found: ${G}`)}}}T.fromService=U;function z(x,A){const F=A&&A.disableMarshalling;return new Proxy({},{get(W,N){if(typeof N=="string")return A?.properties?.has(N)?A.properties.get(N):ne(N)?function($){return x.listen(N,$)}:Q(N)?x.listen(N):async function(...$){let G;A&&!(0,y.isUndefinedOrNull)(A.context)?G=[A.context,...$]:G=$;const j=await x.call(N,G);return F?j:(0,p.revive)(j)};throw new Error(`Property not found: ${String(N)}`)}})}T.toService=z;function Q(x){return x[0]==="o"&&x[1]==="n"&&b.isUpperAsciiLetter(x.charCodeAt(2))}function ne(x){return/^onDynamic/.test(x)&&b.isUpperAsciiLetter(x.charCodeAt(9))}})(re=e.ProxyChannel||(e.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const U=T.toString();if(U!=="[object Object]")return U}return T}function fe(T){return Array.isArray(T)?T.map(ae):ae(T)}function ge(T,U,z,Q,ne,x,A){A=fe(A);const F=se[ne],W=F[Q%F.length];let N=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(x)?(N=N.concat(A),N.push(")")):N.push(A),console.log.apply(console,N)}class q{constructor(U,z){this.d=U,this.f=z,this.a=0,this.b=0}logOutgoing(U,z,Q,ne,x){this.b+=U,ge(this.d,this.b,U,z,Q,ne,x)}logIncoming(U,z,Q,ne,x){this.a+=U,ge(this.f,this.a,U,z,Q,ne,x)}}e.IPCLogger=q}),define(ee[146],te([0,1,17,3,47]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(m){this.a=m,this.onMessage=t.Event.fromDOMEventEmitter(this.a,"message",w=>S.VSBuffer.wrap(w.data)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}e.Protocol=R;class M extends P.IPCClient{constructor(m,w){const p=new R(m);super(p,w),this.b=p}dispose(){this.b.disconnect()}}e.Client=M}),define(ee[103],te([0,1,8,17,3,2,47]),function(H,e,S,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(L){L.Created="created",L.Read="read",L.Write="write",L.Open="open",L.Error="error",L.Close="close",L.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",L.NodeEndReceived="nodeEndReceived",L.NodeEndSent="nodeEndSent",L.NodeDrainBegin="nodeDrainBegin",L.NodeDrainEnd="nodeDrainEnd",L.zlibInflateError="zlibInflateError",L.zlibInflateData="zlibInflateData",L.zlibInflateInitialWrite="zlibInflateInitialWrite",L.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",L.zlibInflateWrite="zlibInflateWrite",L.zlibInflateFlushFired="zlibInflateFlushFired",L.zlibDeflateError="zlibDeflateError",L.zlibDeflateData="zlibDeflateData",L.zlibDeflateWrite="zlibDeflateWrite",L.zlibDeflateFlushFired="zlibDeflateFlushFired",L.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",L.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",L.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",L.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",L.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",L.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",L.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",L.ProtocolHeaderRead="protocolHeaderRead",L.ProtocolMessageRead="protocolMessageRead",L.ProtocolHeaderWrite="protocolHeaderWrite",L.ProtocolMessageWrite="protocolMessageWrite",L.ProtocolWrite="protocolWrite"})(I=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var m;(function(L){L.enableDiagnostics=!1,L.records=[];const O=new WeakMap;let B=0;function K(J,re){if(!O.has(J)){const se=String(++B);O.set(J,se)}return O.get(J)}function V(J,re,se,ae){if(!L.enableDiagnostics)return;const fe=K(J,re);if(ae instanceof t.VSBuffer||ae instanceof Uint8Array||ae instanceof ArrayBuffer||ArrayBuffer.isView(ae)){const ge=t.VSBuffer.alloc(ae.byteLength);ge.set(ae),L.records.push({timestamp:Date.now(),id:fe,label:re,type:se,buff:ge})}else L.records.push({timestamp:Date.now(),id:fe,label:re,type:se,data:ae})}L.traceSocketEvent=V})(m=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(L){L[L.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",L[L.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let p=null;function b(){return p||(p=t.VSBuffer.alloc(0)),p}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,B){if(O===0)return b();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const re=this.a[0];return B&&(this.a.shift(),this.b-=O),re}if(this.a[0].byteLength>O){const re=this.a[0].slice(0,O);return B&&(this.a[0]=this.a[0].slice(O),this.b-=O),re}const K=t.VSBuffer.alloc(O);let V=0,J=0;for(;O>0;){const re=this.a[J];if(re.byteLength>O){const se=re.slice(0,O);K.set(se,V),V+=O,B&&(this.a[J]=re.slice(O),this.b-=O),O-=O}else K.set(re,V),V+=re.byteLength,B?(this.a.shift(),this.b-=re.byteLength):J++,O-=re.byteLength}return K}}e.ChunkStream=y;var f;(function(L){L[L.None=0]="None",L[L.Regular=1]="Regular",L[L.Control=2]="Control",L[L.Ack=3]="Ack",L[L.Disconnect=5]="Disconnect",L[L.ReplayRequest=6]="ReplayRequest",L[L.Pause=7]="Pause",L[L.Resume=8]="Resume",L[L.KeepAlive=9]="KeepAlive",L[L.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",L[L.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function d(L){switch(L){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var v;(function(L){L[L.HeaderLength=13]="HeaderLength",L[L.AcknowledgeTime=2e3]="AcknowledgeTime",L[L.TimeoutTime=2e4]="TimeoutTime",L[L.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",L[L.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",L[L.KeepAliveSendTime=5e3]="KeepAliveSendTime",L[L.LatencySampleTime=6e4]="LatencySampleTime",L[L.LatencySampleCount=5]="LatencySampleCount",L[L.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",L[L.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class a{constructor(O,B,K,V){this.type=O,this.id=B,this.ack=K,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends R.Disposable{constructor(O){super(),this.f=this.B(new P.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new y,this.B(this.a.onData(B=>this.acceptChunk(B))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const B=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=B.readUInt32BE(9),this.g.messageType=B.readUInt8(0),this.g.id=B.readUInt32BE(1),this.g.ack=B.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const K=this.g.messageType,V=this.g.id,J=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",B),this.f.fire(new a(K,V,J,B)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const B=t.VSBuffer.alloc(13);B.writeUInt8(O.type,0),B.writeUInt32BE(O.id,1),B.writeUInt32BE(O.ack,5),B.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(B,O.data)}g(O,B){const K=this.f===0;return this.d.push(O,B),this.f+=O.byteLength+B.byteLength,K}h(){const O=t.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,B){this.g(O,B)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class k extends R.Disposable{constructor(O){super(),this.f=new P.Emitter,this.onMessage=this.f.event,this.g=new P.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new g(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(B=>{B.type===1&&this.f.fire(B.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new a(1,0,0,O))}}e.Protocol=k;class E extends M.IPCClient{static fromSocket(O,B){return new E(new k(O),B)}get onDidDispose(){return this.b.onDidDispose}constructor(O,B,K=null){super(O,B,K),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=E;class D{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new P.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=D;class i{constructor(O){this.data=O,this.next=null}}class l{constructor(){this.a=null,this.b=null}length(){let O=0,B=this.a;for(;B;)B=B.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let B=0,K=this.a;for(;K;)O[B++]=K.data,K=K.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const B=new i(O);if(!this.a){this.a=B,this.b=B;return}this.b.next=B,this.b=B}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const O=Date.now();for(let B=0;B<n.a;B++)this.c[B]=O-1e3*B;setInterval(()=>{for(let B=n.a;B>=1;B--)this.c[B]=this.c[B-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),B=(1+n.a)*1e3;let K=0;for(let V=0;V<n.a;V++)O-this.c[V]<=B&&K++;return 1-K/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;var s;(function(L){L[L.Good=0]="Good",L[L.Poor=1]="Poor"})(s=e.ConnectionHealth||(e.ConnectionHealth={}));function o(L){switch(L){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class c{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=c;class r{constructor(O,B){this.roundTripTime=O,this.recentHighRoundTripCount=B}}e.HighRoundTripTimeEvent=r;class h{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new D,this.onControlMessage=this.x.event,this.y=new D,this.onMessage=this.y.event,this.z=new D,this.onDidDispose=this.z.event,this.A=new D,this.onSocketClose=this.A.event,this.B=new D,this.onSocketTimeout=this.B.event,this.C=new D,this.onHighRoundTripTime=this.C.event,this.D=new D,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??n.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new l,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=O.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(B=>this.E(B))),this.t.add(this.o.onClose(B=>this.A.fire(B))),this.r=this.t.add(new C),this.t.add(this.r.onSendLatencyRequest(B=>this.J(B))),this.t.add(this.r.onHighRoundTripTime(B=>this.C.fire(B))),this.t.add(this.r.onDidChangeConnectionHealth(B=>this.D.fire(B))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new a(5,0,0,b());this.p.write(O),this.p.flush()}sendPause(){const O=new a(7,0,0,b());this.p.write(O)}sendResume(){const O=new a(8,0,0,b());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,B){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(K=>this.E(K))),this.t.add(this.o.onClose(K=>this.A.fire(K))),this.r=this.t.add(new C),this.t.add(this.r.onSendLatencyRequest(K=>this.J(K))),this.t.add(this.r.onHighRoundTripTime(K=>this.C.fire(K))),this.t.add(this.r.onDidChangeConnectionHealth(K=>this.D.fire(K))),this.q.acceptChunk(B)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new a(3,0,this.h,b());this.p.write(O);const B=this.b.toArray();for(let K=0,V=B.length;K<V;K++)this.p.write(B[K]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const B=this.b.peek();if(B&&B.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const B=Date.now();B-this.m>1e4&&(this.m=B,this.p.write(new a(6,0,0,b())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const B=this.b.toArray();for(let K=0,V=B.length;K<V;K++)this.p.write(B[K]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const B=++this.c;this.h=this.g;const K=new a(1,B,this.h,O);this.b.push(K),this.a||(this.p.write(K),this.G())}sendControl(O){const B=new a(2,0,0,O);this.p.write(B)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),B=Date.now()-O.writtenTime,K=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(B>=2e4&&K>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:B,timeSinceLastReceivedSomeData:K});return}const J=Math.max(2e4-B,2e4-K,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},J)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new a(3,0,this.h,b());this.p.write(O)}I(){this.h=this.g;const O=new a(9,0,this.h,b());this.p.write(O)}J(O){this.h=this.g;const B=new a(10,0,this.h,O);this.p.write(B)}K(O){this.h=this.g;const B=new a(11,0,this.h,O);this.p.write(B)}}e.PersistentProtocol=h;class C extends R.Disposable{constructor(){super(),this.a=this.B(new P.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new P.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new P.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new S.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,B=t.VSBuffer.alloc(4);B.writeUInt32BE(O,0),this.a.fire(B)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const B=O.readUInt32BE(0);if(this.g<=0||B!==this.h)return;const K=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=K;const J=this.l,re=this.j.filter(se=>se>=1e3).length;this.l=re>=3?1:0,K>1e3&&this.b.fire(new r(K,re)),J!==this.l&&this.c.fire(this.l)}}}),define(ee[147],te([0,1,42,17,3,2,47,132]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function m(p,b){const y=P.Event.fromNodeEventEmitter(S.validatedIpcMain,b,(d,v)=>({event:d,message:v})),f=P.Event.filter(y,({event:d})=>d.sender.id===p);return P.Event.map(f,({message:d})=>d&&t.VSBuffer.wrap(d))}class w extends M.IPCServer{static d(){const b=P.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:hello",({sender:y})=>y);return P.Event.map(b,y=>{const f=y.id;w.b.get(f)?.dispose();const v=new P.Emitter;w.b.set(f,(0,R.toDisposable)(()=>v.fire()));const a=m(f,"vscode:message"),u=P.Event.any(P.Event.signal(m(f,"vscode:disconnect")),v.event);return{protocol:new I.Protocol(y,a),onDidClientDisconnect:u}})}constructor(){super(w.d())}}e.Server=w,w.b=new Map}),define(ee[104],te([0,1,42,3,31,146]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends R.Client{constructor(w,p){super({addEventListener:(b,y)=>w.addListener(b,y),removeEventListener:(b,y)=>w.removeListener(b,y),postMessage:b=>w.postMessage(b),start:()=>w.start(),close:()=>w.close()},p)}}e.Client=M;async function I(m){if(m.isDestroyed()||m.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,P.generateUuid)();m.webContents.send("vscode:createMessageChannel",w);const p=t.Event.fromNodeEventEmitter(S.validatedIpcMain,"vscode:createMessageChannelResult",(y,f)=>({nonce:f,port:y.ports[0]})),{port:b}=await t.Event.toPromise(t.Event.once(t.Event.filter(p,y=>y.nonce===w)));return b}e.connect=I}),define(ee[148],te([0,1,46,8,17,22,141,13,3,2,44,84,81,47]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends f.ChannelServer{constructor(u){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",g=>P.VSBuffer.wrap(Buffer.from(g,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=d;class v{constructor(u,g){this.i=u,this.j=g,this.c=new Set,this.g=new Map,this.h=new m.Emitter,this.onDidProcessExit=this.h.event;const k=g&&g.timeout?g.timeout:6e4;this.b=new t.Delayer(k),this.d=null,this.f=null}getChannel(u){const g=this;return{call(k,E,D){return g.k(u,k,E,D)},listen(k,E){return g.l(u,k,E)}}}k(u,g,k,E=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(I.canceled());this.b.cancel();const D=this.n(u),i=(0,t.createCancelablePromise)(s=>D.call(g,k,s)),l=E.onCancellationRequested(()=>i.cancel()),n=(0,w.toDisposable)(()=>i.cancel());return this.c.add(n),i.finally(()=>{l.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,g,k){if(!this.b)return m.Event.None;this.b.cancel();let E;const D=new m.Emitter({onWillAddFirstListener:()=>{E=this.n(u).listen(g,k)(D.fire,D),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return D.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,y.removeDangerousEnvVariables)(g.env),this.d=(0,S.fork)(this.i,u,g);const k=new m.Emitter;m.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,M.isRemoteConsoleLog)(o)){(0,M.log)(o,`IPC Library: ${this.j.serverName}`);return}k.fire(P.VSBuffer.wrap(Buffer.from(o,"base64")))});const D=this.j.useQueue?(0,b.createQueuedSender)(this.d):this.d,i=o=>this.d&&this.d.connected&&D.send(o.buffer.toString("base64")),l=k.event,n={send:i,onMessage:l};this.f=new f.ChannelClient(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",s),this.c.forEach(r=>(0,w.dispose)(r)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(u){let g=this.g.get(u);return g||(g=this.m.getChannel(u),this.g.set(u,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=v}),define(ee[85],te([0,1,17,13,3,2,9,4,31,47,103]),function(H,e,S,t,P,R,M,I,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class y{traceSocketEvent(r,h){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,r,h)}constructor(r,h=""){this.f=!0,this.debugLabel=h,this.socket=r,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,t.onUnexpectedError)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(r){const h=C=>{this.traceSocketEvent("read",C),r(S.VSBuffer.wrap(C))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(r){const h=C=>{r({type:0,hadError:C,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(r){const h=()=>{r()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(r){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",r),this.socket.write(r.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((r,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),r();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),r()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.NodeSocket=y;var f;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var d;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(d||(d={}));class v extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(r,h){this.socket.traceSocketEvent(r,h)}constructor(r,h,C,L){super(),this.f=this.B(new P.Emitter),this.g=this.B(new P.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=r,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:C?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new a(this,h,C,L,this.f,(O,B)=>this.k(O,B))),this.B(this.a.onError(O=>{console.error(O),(0,t.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new p.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(O=>this.g.fire(O)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(r){return this.f.event(r)}onClose(r){return this.g.event(r)}onEnd(r){return this.socket.onEnd(r)}write(r){this.a.writeMessage(r)}k(r,h){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",r);let C=2;r.byteLength<126?C+=0:r.byteLength<2**16?C+=2:C+=8;const L=S.VSBuffer.alloc(C);if(h?L.writeUInt8(194,0):L.writeUInt8(130,0),r.byteLength<126)L.writeUInt8(r.byteLength,1);else if(r.byteLength<2**16){L.writeUInt8(126,1);let O=1;L.writeUInt8(r.byteLength>>>8&255,++O),L.writeUInt8(r.byteLength>>>0&255,++O)}else{L.writeUInt8(127,1);let O=1;L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(r.byteLength>>>24&255,++O),L.writeUInt8(r.byteLength>>>16&255,++O),L.writeUInt8(r.byteLength>>>8&255,++O),L.writeUInt8(r.byteLength>>>0&255,++O)}this.socket.write(S.VSBuffer.concat([L,r]))}end(){this.h=!0,this.socket.end()}l(r){if(r.byteLength!==0){for(this.b.acceptChunk(r);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const h=this.b.peek(this.j.readLen),C=h.readUInt8(0),L=(C&128)>>>7,O=(C&64)>>>6,B=h.readUInt8(1),K=(B&128)>>>7,V=B&127;this.j.state=2,this.j.readLen=2+(K?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(L),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const h=this.b.read(this.j.readLen),C=h.readUInt8(1),L=(C&128)>>>7;let O=C&127,B=1;O===126?O=h.readUInt8(++B)*2**8+h.readUInt8(++B):O===127&&(O=h.readUInt8(++B)*0+h.readUInt8(++B)*0+h.readUInt8(++B)*0+h.readUInt8(++B)*0+h.readUInt8(++B)*2**24+h.readUInt8(++B)*2**16+h.readUInt8(++B)*2**8+h.readUInt8(++B));let K=0;L&&(K=h.readUInt8(++B)*2**24+h.readUInt8(++B)*2**16+h.readUInt8(++B)*2**8+h.readUInt8(++B)),this.j.state=3,this.j.readLen=O,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const h=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),k(h,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(h,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class a extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:S.VSBuffer.alloc(0)}constructor(r,h,C,L,O,B){super(),this.k=r,this.l=O,this.m=B,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new P.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,h?(this.b=this.B(new u(this.k,L,C,{windowBits:15})),this.f=this.B(new g(this.k,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(r){this.g.push(r),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const r=this.g.shift();if(this.f){const h=await this.r(this.f,r);this.m(h,!0)}else this.m(r,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(r,h){return new Promise((C,L)=>{r.write(h),r.flush(O=>C(O))})}acceptFrame(r,h,C){this.h.push({data:r,isCompressed:h,isLastFrameOfMessage:C}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const r=this.h.shift();if(this.b&&r.isCompressed){const h=await this.u(this.b,r.data,r.isLastFrameOfMessage);this.l.fire(h)}else this.l.fire(r.data)}this.s=!1}}u(r,h,C){return new Promise((L,O)=>{r.write(h),C&&r.write(S.VSBuffer.fromByteArray([0,0,255,255])),r.flush(B=>L(B))})}}class u extends R.Disposable{get recordedInflateBytes(){return this.j?S.VSBuffer.concat(this.f):S.VSBuffer.alloc(0)}constructor(r,h,C,L){super(),this.h=r,this.j=h,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=b().zlib.createInflateRaw(L),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(S.VSBuffer.wrap(O))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(r){this.j&&this.f.push(r.clone()),this.h.traceSocketEvent("zlibInflateWrite",r),this.b.write(r.buffer)}flush(r){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const h=S.VSBuffer.concat(this.g);this.g.length=0,r(h)})}}class g extends R.Disposable{constructor(r,h){super(),this.g=r,this.a=this.B(new P.Emitter),this.onError=this.a.event,this.f=[],this.b=b().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(S.VSBuffer.wrap(C))})}write(r){this.g.traceSocketEvent("zlibDeflateWrite",r.buffer),this.b.write(r.buffer)}flush(r){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let h=S.VSBuffer.concat(this.f);this.f.length=0,h=h.slice(0,h.byteLength-4),r(h)})}}function k(c,r){if(r===0)return;const h=c.byteLength>>>2;for(let V=0;V<h;V++){const J=c.readUInt32BE(V*4);c.writeUInt32BE(J^r,V*4)}const C=h*4,L=c.byteLength-C,O=r>>>24&255,B=r>>>16&255,K=r>>>8&255;L>=1&&c.writeUInt8(c.readUInt8(C)^O,C),L>=2&&c.writeUInt8(c.readUInt8(C+1)^B,C+1),L>=3&&c.writeUInt8(c.readUInt8(C+2)^K,C+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const E={[2]:107,[1]:103};function D(){const c=(0,m.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let r;return e.XDG_RUNTIME_DIR?r=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):r=(0,M.join)(b().os.tmpdir(),`vscode-ipc-${c}.sock`),l(r),r}e.createRandomIPCHandle=D;function i(c,r,h){const C=b().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${h}-${r}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-${C.substr(0,8)}-${h}-${r}.sock`):L=(0,M.join)(c,`${h}-${r}.sock`),l(L),L}e.createStaticIPCHandle=i;function l(c){const r=E[I.platform];typeof r=="number"&&c.length>=r&&console.warn(`WARNING: IPC handle "${c}" is longer than ${r} chars, try a shorter --user-data-dir`)}class n extends w.IPCServer{static b(r){const h=P.Event.fromNodeEventEmitter(r,"connection");return P.Event.map(h,C=>({protocol:new p.Protocol(new y(C,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(C,"close"))}))}constructor(r){super(n.b(r)),this.d=r}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=n;function s(c){return new Promise((r,h)=>{const C=b().net.createServer();C.on("error",h),C.listen(c,()=>{C.removeListener("error",h),r(new n(C))})})}e.serve=s;function o(c,r){return new Promise((h,C)=>{const L=b().net.createConnection(c,()=>{L.removeListener("error",C),h(p.Client.fromSocket(new y(L,`ipc-client${r}`),r))});L.once("error",C)})}e.connect=o}),define(ee[105],te([0,1,8,3,2,11]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(M=e.StorageHint||(e.StorageHint={}));function I(b){const y=b;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var m;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(m=e.StorageState||(e.StorageState={}));class w extends P.Disposable{constructor(y,f=Object.create(null)){super(),this.m=y,this.n=f,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=m.None,this.f=new Map,this.g=new S.ThrottledDelayer(w.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(y=>this.r(y)))}r(y){y.changed?.forEach((f,d)=>this.s(d,f)),y.deleted?.forEach(f=>this.s(f,void 0))}s(y,f){if(this.c===m.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(f)?d=this.f.delete(y):this.f.get(y)!==f&&(this.f.set(y,f),d=!0),d&&this.b.fire(y)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===m.None&&(this.c=m.Initialized,this.n.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(y,f){const d=this.f.get(y);return(0,R.isUndefinedOrNull)(d)?f:d}getBoolean(y,f){const d=this.get(y);return(0,R.isUndefinedOrNull)(d)?f:d==="true"}getNumber(y,f){const d=this.get(y);return(0,R.isUndefinedOrNull)(d)?f:parseInt(d,10)}async set(y,f){if(this.c===m.Closed)return;if((0,R.isUndefinedOrNull)(f))return this.delete(y);const d=String(f);if(this.f.get(y)!==d)return this.f.set(y,d),this.j.set(y,d),this.h.delete(y),this.b.fire(y),this.w()}async delete(y){if(!(this.c===m.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire(y),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=m.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(y).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(y){if(!!this.u)return this.w(y)}async w(y){return this.g.trigger(()=>this.v(),y)}async whenFlushed(){if(!!this.u)return new Promise(y=>this.l.push(y))}isInMemory(){return this.n.hint===M.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=w,w.a=100;class p{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((f,d)=>this.a.set(d,f)),y.delete?.forEach(f=>this.a.delete(f))}async close(){}}e.InMemoryStorageDatabase=p}),define(ee[149],te([0,1,8,3,40,9,23]),function(H,e,S,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{get onDidChangeItemsExternal(){return t.Event.None}constructor(p,b=Object.create(null)){this.g=p,this.h=b,this.c=(0,R.basename)(this.g),this.d=new m(this.h.logging),this.f=this.n(this.g)}async getItems(){const p=await this.f,b=new Map;return(await this.s(p,"SELECT * FROM ItemTable")).forEach(f=>b.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${b.size} rows`),b}async updateItems(p){const b=await this.f;return this.j(b,p)}j(p,b){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${b.insert?(0,P.mapToString)(b.insert):"0"}), delete(${b.delete?(0,P.setToString)(b.delete):"0"})`),this.t(p,()=>{const y=b.insert,f=b.delete;if(y&&y.size>0){const d=[];d.push([]);let v=0;y.forEach((a,u)=>{let g=d[v];g.length>I.b&&(v++,g=[],d.push(g)),g.push(u,a)}),d.forEach(a=>{this.u(p,`INSERT INTO ItemTable VALUES ${new Array(a.length/2).fill("(?,?)").join(",")}`,u=>u.run(a),()=>{const u=[];let g=0;return y.forEach((k,E)=>{u.push(E),g+=k.length}),`Keys: ${u.join(", ")} Length: ${g}`})})}if(f&&f.size){const d=[];d.push([]);let v=0;f.forEach(a=>{let u=d[v];u.length>I.b&&(v++,u=[],d.push(u)),u.push(a)}),d.forEach(a=>{this.u(p,`DELETE FROM ItemTable WHERE key IN (${new Array(a.length).fill("?").join(",")})`,u=>u.run(a),()=>{const u=[];return f.forEach(g=>{u.push(g)}),`Keys: ${u.join(", ")}`})})}})}async close(p){this.d.trace(`[storage ${this.c}] close()`);const b=await this.f;return this.k(b,p)}k(p,b){return new Promise((y,f)=>{p.db.close(d=>(d&&this.o(p,`[storage ${this.c}] close(): ${d}`),this.g===I.IN_MEMORY_PATH?y():!p.isErroneous&&!p.isInMemory?this.l().then(y,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),y())):typeof b=="function"?M.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const a=()=>this.k(v,void 0);return this.j(v,{insert:b()}).then(()=>a(),u=>(a(),Promise.reject(u)))})).then(y,f):f(d||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const p=this.m(this.g);return M.Promises.copy(this.g,p,{preserveSymlinks:!1})}m(p){return`${p}.backup`}async checkIntegrity(p){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${p})`);const b=await this.f,y=await this.r(b,p?"PRAGMA integrity_check":"PRAGMA quick_check"),f=p?y.integrity_check:y.quick_check;return b.isErroneous?`${f} (last error: ${b.lastError})`:b.isInMemory?`${f} (in-memory!)`:f}async n(p,b=!0){this.d.trace(`[storage ${this.c}] open(${p}, retryOnBusy: ${b})`);try{return await this.p(p)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&b)return await(0,S.timeout)(I.a),this.n(p,!1);try{await M.Promises.unlink(p);try{await M.Promises.rename(this.m(p),p)}catch{}return await this.p(p)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(I.IN_MEMORY_PATH)}}}o(p,b){p.isErroneous=!0,p.lastError=b,this.d.error(b)}p(p){return new Promise((b,y)=>{new Promise((f,d)=>{H(["@vscode/sqlite3"],f,d)}).then(f=>{const d={db:new(this.d.isTracing?f.verbose().Database:f.Database)(p,v=>v?d.db&&v.code!=="SQLITE_CANTOPEN"?d.db.close(()=>y(v)):y(v):this.q(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(d),a=>d.db.close(()=>y(a)))),isInMemory:p===I.IN_MEMORY_PATH};d.db.on("error",v=>this.o(d,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&d.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},y)})}q(p,b){return new Promise((y,f)=>{p.db.exec(b,d=>d?(this.o(p,`[storage ${this.c}] exec(): ${d}`),f(d)):y())})}r(p,b){return new Promise((y,f)=>{p.db.get(b,(d,v)=>d?(this.o(p,`[storage ${this.c}] get(): ${d}`),f(d)):y(v))})}s(p,b){return new Promise((y,f)=>{p.db.all(b,(d,v)=>d?(this.o(p,`[storage ${this.c}] all(): ${d}`),f(d)):y(v))})}t(p,b){return new Promise((y,f)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),b(),p.db.run("END TRANSACTION",d=>d?(this.o(p,`[storage ${this.c}] transaction(): ${d}`),f(d)):y())})})}u(p,b,y,f){const d=p.db.prepare(b),v=a=>{this.o(p,`[storage ${this.c}] prepare(): ${a} (${b}). Details: ${f()}`)};d.on("error",v),y(d),d.finalize(a=>{a&&v(a),d.removeListener("error",v)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.a=2e3,I.b=256;class m{constructor(p){p&&typeof p.logTrace=="function"&&process.env[m.VSCODE_TRACE_STORAGE]&&(this.a=p.logTrace),p&&typeof p.logError=="function"&&(this.b=p.logError)}get isTracing(){return!!this.a}trace(p){this.a?.(p)}error(p){this.b?.(p)}}m.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[150],te([12,10]),function(H,e){return H.create("vs/code/electron-main/app",e)}),define(ee[151],te([12,10]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[152],te([12,10]),function(H,e){return H.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[153],te([12,10]),function(H,e){return H.create("vs/platform/environment/node/argv",e)}),define(ee[154],te([12,10]),function(H,e){return H.create("vs/platform/environment/node/argvHelper",e)}),define(ee[155],te([12,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[156],te([12,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ee[157],te([12,10]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ee[158],te([12,10]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[159],te([12,10]),function(H,e){return H.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[160],te([12,10]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(ee[161],te([12,10]),function(H,e){return H.create("vs/platform/files/common/files",e)}),define(ee[162],te([12,10]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(ee[163],te([12,10]),function(H,e){return H.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[164],te([12,10]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[165],te([12,10]),function(H,e){return H.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[166],te([12,10]),function(H,e){return H.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[167],te([12,10]),function(H,e){return H.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[168],te([12,10]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(ee[169],te([12,10]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(ee[170],te([12,10]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[171],te([12,10]),function(H,e){return H.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[172],te([12,10]),function(H,e){return H.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ee[173],te([12,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ee[174],te([12,10]),function(H,e){return H.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[175],te([12,10]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(ee[176],te([12,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[177],te([12,10]),function(H,e){return H.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[178],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function S(P){return P&&P.hasOwnProperty("folderUri")}e.isFolderBackupInfo=S;function t(P){return P&&P.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(ee[179],te([0,1,7]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(M){return typeof M?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function P(M){let I=[];try{Array.isArray(M.workspaces)&&(I=M.workspaces.map(m=>({workspace:{id:m.id,configPath:S.URI.parse(m.configURIPath)},remoteAuthority:m.remoteAuthority})))}catch{}return I}e.deserializeWorkspaceInfos=P;function R(M){let I=[];try{Array.isArray(M.folders)&&(I=M.folders.map(m=>({folderUri:S.URI.parse(m.folderUri),remoteAuthority:m.remoteAuthority})))}catch{}return I}e.deserializeFolderInfos=R}),define(ee[180],te([0,1,3,2]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class P{constructor(){this.a=new S.Emitter,this.b=new S.Emitter,this.c=new S.Emitter,this.d=new S.Emitter}call(I,m,w){switch(m){case"close":return Promise.resolve(this.a.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(I,m,w){switch(m){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=P,P.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,m,w){this.b.call("attach",[I,m,w])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,m){this.b.call("terminate",[I,m])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,m){return this.b.call("openExtensionDevelopmentHostWindow",[I,m])}}e.ExtensionHostDebugChannelClient=R}),define(ee[181],te([0,1,135,54,15,9,35,20,7]),function(H,e,S,t,P,R,M,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,R.dirname)(P.FileAccess.asFileUri("").fsPath)}get userHome(){return m.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return m.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.b.tmpDir)}get cacheHome(){return m.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return m.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return m.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(m.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=M.env.VSCODE_PORTABLE;return d?m.URI.file((0,R.join)(d,"argv.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,R.resolve)(d):(0,R.normalize)((0,R.join)(P.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?m.URI.file((0,R.resolve)(d)):m.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,R.resolve)(d);const v=M.env.VSCODE_EXTENSIONS;if(v)return v;const a=M.env.VSCODE_PORTABLE;return a?(0,R.join)(a,"extensions"):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(v=>/^[^:/?#]+?:\/\//.test(v)?m.URI.parse(v):m.URI.file((0,R.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?m.URI.parse(d):m.URI.file((0,R.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const v of this.args.log||[]){const a=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(v);a&&a[1]&&a[2]&&d.push([a[1],a[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,I.joinPath)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return m.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=M.env.VSCODE_PORTABLE;return d?m.URI.file((0,R.join)(d,"policy.json")):(0,I.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,v,a){this.a=d,this.b=v,this.c=a,this.editSessionId=this.args.editSessionId}}pe([t.memoize],w.prototype,"appRoot",null),pe([t.memoize],w.prototype,"userHome",null),pe([t.memoize],w.prototype,"userDataPath",null),pe([t.memoize],w.prototype,"appSettingsHome",null),pe([t.memoize],w.prototype,"tmpDir",null),pe([t.memoize],w.prototype,"cacheHome",null),pe([t.memoize],w.prototype,"stateResource",null),pe([t.memoize],w.prototype,"userRoamingDataHome",null),pe([t.memoize],w.prototype,"userDataSyncHome",null),pe([t.memoize],w.prototype,"userDataSyncLogResource",null),pe([t.memoize],w.prototype,"editSessionsLogResource",null),pe([t.memoize],w.prototype,"sync",null),pe([t.memoize],w.prototype,"machineSettingsResource",null),pe([t.memoize],w.prototype,"workspaceStorageHome",null),pe([t.memoize],w.prototype,"localHistoryHome",null),pe([t.memoize],w.prototype,"keyboardLayoutResource",null),pe([t.memoize],w.prototype,"argvResource",null),pe([t.memoize],w.prototype,"isExtensionDevelopment",null),pe([t.memoize],w.prototype,"untitledWorkspacesHome",null),pe([t.memoize],w.prototype,"installSourcePath",null),pe([t.memoize],w.prototype,"builtinExtensionsPath",null),pe([t.memoize],w.prototype,"extensionsPath",null),pe([t.memoize],w.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],w.prototype,"extensionDevelopmentKind",null),pe([t.memoize],w.prototype,"extensionTestsLocationURI",null),pe([t.memoize],w.prototype,"debugExtensionHost",null),pe([t.memoize],w.prototype,"logLevel",null),pe([t.memoize],w.prototype,"extensionLogLevel",null),pe([t.memoize],w.prototype,"serviceMachineIdResource",null),pe([t.memoize],w.prototype,"telemetryLogResource",null),pe([t.memoize],w.prototype,"disableWorkspaceTrust",null),pe([t.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function p(f,d){return y(f["inspect-extensions"],f["inspect-brk-extensions"],5870,d,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=p;function b(f,d){return y(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,d,f.extensionEnvironment)}e.parsePtyHostPort=b;function y(f,d,v,a,u,g){const E=Number(d||f)||(a?null:v),D=E?Boolean(!!d):!1;let i;if(g)try{i=JSON.parse(g)}catch{}return{port:E,break:D,debugId:u,env:i}}}),define(ee[106],te([0,1,284,4,153]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},category:{type:"string",cat:"e",description:(0,P.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,P.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(v,a,u=M){const g=v.find(c=>c.length>0&&c[0]!=="-"),k={},E=["_"],D=[],i={};let l;for(const c in a){const r=a[c];r.type==="subcommand"?c===g&&(l=r):(r.alias&&(k[c]=r.alias),r.type==="string"||r.type==="string[]"?(E.push(c),r.deprecates&&E.push(...r.deprecates)):r.type==="boolean"&&(D.push(c),r.deprecates&&D.push(...r.deprecates)),r.global&&(i[c]=r))}if(l&&g){const c=i;for(const L in l.options)c[L]=l.options[L];const r=v.filter(L=>L!==g),h=u.getSubcommandReporter?u.getSubcommandReporter(g):void 0,C=I(r,c,h);return{[g]:C,_:[]}}const n=S(v,{string:E,boolean:D,alias:k}),s={},o=n;s._=n._.map(c=>String(c)).filter(c=>c.length>0),delete o._;for(const c in a){const r=a[c];if(r.type==="subcommand")continue;r.alias&&delete o[r.alias];let h=o[c];if(r.deprecates)for(const C of r.deprecates)o.hasOwnProperty(C)&&(h||(h=o[C],h&&u.onDeprecatedOption(C,r.deprecationMessage||(0,P.localize)(36,null,c))),delete o[C]);if(typeof h<"u"){if(r.type==="string[]"){if(Array.isArray(h)||(h=[h]),!r.allowEmptyValue){const C=h.filter(L=>L.length>0);C.length!==h.length&&(u.onEmptyValue(c),h=C.length>0?C:void 0)}}else r.type==="string"&&(Array.isArray(h)?(h=h.pop(),u.onMultipleValues(c,h)):!h&&!r.allowEmptyValue&&(u.onEmptyValue(c),h=void 0));s[c]=h,r.deprecationMessage&&u.onDeprecatedOption(c,r.deprecationMessage)}delete o[c]}for(const c in o)u.onUnknownOption(c);return s}e.parseArgs=I;function m(v,a){let u="";return a.args&&(Array.isArray(a.args)?u=` <${a.args.join("> <")}>`:u=` <${a.args}>`),a.alias?`-${a.alias} --${v}${u}`:`--${v}${u}`}function w(v,a){const u=[];for(const g in v){const k=v[g],E=m(g,k);u.push([E,k.description])}return p(u,a)}e.formatOptions=w;function p(v,a){const g=v.reduce((D,i)=>Math.max(D,i[0].length),12)+2+1;if(a-g<25)return v.reduce((D,i)=>D.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const k=a-g-1,E=[];for(const D of v){const i=D[0],l=y(D[1],k),n=b(g-i.length-2);E.push("  "+i+n+l[0]);for(let s=1;s<l.length;s++)E.push(b(g)+l[s])}return E}function b(v){return" ".repeat(v)}function y(v,a){const u=[];for(;v.length;){const g=v.length<a?v.length:v.lastIndexOf(" ",a),k=v.slice(0,g).trim();v=v.slice(g),u.push(k)}return u}function f(v,a,u,g,k){const E=process.stdout.isTTY&&process.stdout.columns||80,D=k?.noInputFiles!==!0?`[${(0,P.localize)(37,null)}...]`:"",i=[`${v} ${u}`];i.push(""),i.push(`${(0,P.localize)(38,null)}: ${a} [${(0,P.localize)(39,null)}]${D}`),i.push(""),k?.noPipe!==!0&&(t.isWindows?i.push((0,P.localize)(40,null,a)):i.push((0,P.localize)(41,null,a)),i.push(""));const l={},n=[];for(const s in g){const o=g[s];if(o.type==="subcommand")o.description&&n.push({command:s,description:o.description});else if(o.description&&o.cat){let c=l[o.cat];c||(l[o.cat]=c={}),c[s]=o}}for(const s in l){const o=s,c=l[o];c&&(i.push(R[o]),i.push(...w(c,E)),i.push(""))}return n.length&&(i.push((0,P.localize)(42,null)),i.push(...p(n.map(s=>[s.command,s.description]),E)),i.push("")),i.join(`
`)}e.buildHelpMessage=f;function d(v,a){return`${v||(0,P.localize)(43,null)}
${a||(0,P.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(ee[182],te([0,1,80,180,106]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(I){super(),this.f=I}call(I,m,w){return m==="openExtensionDevelopmentHostWindow"?this.g(w[0],w[1]):super.call(I,m,w)}async g(I,m){const w=(0,P.parseArgs)(I,P.OPTIONS);w.debugRenderer=m;const p=w.extensionDevelopmentPath;if(!p)return{success:!1};const[b]=await this.f.openExtensionDevelopmentHostWindow(p,{context:5,cli:w,forceProfile:w.profile,forceTempProfile:w["profile-temp"]});if(!m)return{success:!0};const y=b.win;if(!y)return{success:!0};const f=y.webContents.debugger;let d=f.isAttached()?1/0:0;const v=(0,S.createServer)(a=>{d++===0&&f.attach();let u=!1;const g=D=>{u||a.write(JSON.stringify(D)+"\0")},k=(D,i,l,n)=>g({method:i,params:l,sessionId:n});y.on("close",()=>{f.removeListener("message",k),a.end(),u=!0}),f.addListener("message",k);let E=Buffer.alloc(0);a.on("data",D=>{E=Buffer.concat([E,D]);for(let i=E.indexOf(0);i!==-1;i=E.indexOf(0)){let l;try{const n=E.slice(0,i).toString("utf8");E=E.slice(i+1),l=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}f.sendCommand(l.method,l.params,l.sessionId).then(n=>g({id:l.id,sessionId:l.sessionId,result:n})).catch(n=>g({id:l.id,sessionId:l.sessionId,error:{code:0,message:n.message}}))}}),a.on("error",D=>{console.error("error on cdp pipe:",D)}),a.on("close",()=>{u=!0,--d===0&&f.detach()})});return await new Promise(a=>v.listen(0,a)),y.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(ee[61],te([0,1,285,154,106]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function M(y,f){const d=(E,D)=>{console.warn((0,t.localize)(0,null,E,D))},v=E=>{console.warn((0,t.localize)(1,null,E))},a=(E,D)=>{console.warn((0,t.localize)(2,null,E,D))},u=E=>({onUnknownOption:D=>{E!=="tunnel"&&console.warn((0,t.localize)(3,null,D,E))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:a,getSubcommandReporter:E!=="tunnel"?u:void 0}),g={onUnknownOption:E=>{console.warn((0,t.localize)(4,null,E))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:a,getSubcommandReporter:u},k=(0,P.parseArgs)(y,P.OPTIONS,f?g:void 0);return k.goto&&k._.forEach(E=>S(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,t.localize)(5,null))),k["max-memory"]&&S(parseInt(k["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),k}function I(y){const f=y.findIndex(d=>!/^-/.test(d));if(f>-1)return[...y.slice(0,f),...y.slice(f+1)]}function m(y){let[,...f]=y;process.env.VSCODE_DEV&&(f=I(f)||[]);const d=!b(process.env);return M(f,d)}e.parseMainProcessArgv=m;function w(y){let[,,...f]=y;return process.env.VSCODE_DEV&&(f=I(f)||[]),M(f,!0)}e.parseCLIProcessArgv=w;function p(y,...f){const d=y.indexOf("--");return d===-1?y.push(...f):y.splice(d,0,...f),y}e.addArg=p;function b(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function H(e,S,t){function P(M,I){const m=R(M,I),w=[m];return e.isAbsolute(m)||w.unshift(t),e.resolve(...w)}function R(M,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,I);const p=M["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(b,"AppData","Roaming")}break;case"darwin":w=e.join(S.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,I)}return{getUserDataPath:P}}if(typeof define=="function")define(ee[183],te([184,26,35]),function(e,S,t){return H(e,S,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=H(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[185],te([0,1,26,181,183]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(I,m){super(I,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,P.getUserDataPath)(I,m.nameShort)},m)}}e.NativeEnvironmentService=R}),define(ee[186],te([0,1,41,26,32]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(M){const I=(0,P.randomPath)((0,t.tmpdir)());try{return(0,S.writeFileSync)(I,""),M&&console.log(`Marker file for --wait created: ${I}`),I}catch(m){M&&console.error(`Failed to create marker file for --wait: ${m}`);return}}e.createWaitMarkerFileSync=R}),define(ee[187],te([0,1,11,156]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function P(M,I,m){try{R(M,I,m)}catch(w){console.error(w?.message??w)}return M}e.localizeManifest=P;function R(M,I,m){const w=(p,b,y)=>{const f=p[b];if((0,S.isString)(f)){const d=f,v=d.length;if(v>1&&d[0]==="%"&&d[v-1]==="%"){const a=d.substr(1,v-2);let u=I[a];u===void 0&&m&&(u=m[a]);const g=typeof u=="string"?u:u?.message,k=m?.[a],E=typeof k=="string"?k:k?.message;if(!g){E||console.warn(`[${M.name}]: ${(0,t.localize)(0,null,a)}`);return}if(y&&(b==="title"||b==="category")&&E&&E!==g){const D={value:g,original:E};p[b]=D}else p[b]=g}}else if((0,S.isObject)(f))for(const d in f)f.hasOwnProperty(d)&&(d==="commands"?w(f,d,!0):w(f,d,y));else if(Array.isArray(f))for(let d=0;d<f.length;d++)w(f,d,y)};for(const p in M)M.hasOwnProperty(p)&&w(M,p)}}),define(ee[188],te([0,1,13]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(R,M){this.a.set(R,M)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const M in R.contributes){const I=this.a.get(M);if(!I)continue;const m=R.contributes[M],w=Array.isArray(m)?m:[m];try{I(w,R.activationEvents)}catch(p){(0,S.onUnexpectedError)(p)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ee[189],te([0,1,20,82,158,190]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function m(u){return u=u.trim(),u==="*"||M.test(u)}e.isValidVersionStr=m;function w(u){if(!m(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(M);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=w;function p(u){if(!u)return null;const g=u.majorBase,k=u.majorMustEqual,E=u.minorBase;let D=u.minorMustEqual;const i=u.patchBase;let l=u.patchMustEqual;u.hasCaret&&(g===0||(D=!1),l=!1);let n=0;if(u.preRelease){const s=I.exec(u.preRelease);if(s){const[,o,c,r]=s;n=Date.UTC(Number(o),Number(c)-1,Number(r))}}return{majorBase:g,majorMustEqual:k,minorBase:E,minorMustEqual:D,patchBase:i,patchMustEqual:l,isMinimum:u.hasGreaterEquals,notBefore:n}}e.normalizeVersion=p;function b(u,g,k){let E;typeof u=="string"?E=p(w(u)):E=u;let D;g instanceof Date?D=g.getTime():typeof g=="string"&&(D=new Date(g).getTime());let i;if(typeof k=="string"?i=p(w(k)):i=k,!E||!i)return!1;const l=E.majorBase,n=E.minorBase,s=E.patchBase;let o=i.majorBase,c=i.minorBase,r=i.patchBase;const h=i.notBefore;let C=i.majorMustEqual,L=i.minorMustEqual,O=i.patchMustEqual;return i.isMinimum?l>o?!0:l<o?!1:n>c?!0:n<c||D&&D<h?!1:s>=r:(l===1&&o===0&&(!C||!L||!O)&&(o=1,c=0,r=0,C=!0,L=!1,O=!1),l<o?!1:l>o?!C:n<c?!1:n>c?!L:s<r?!1:s>r?!O:!(D&&D<h))}e.isValidVersion=b;function y(u,g,k,E,D){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([t.default.Error,P.localize(0,null)]),i;if(typeof E.name!="string")return i.push([t.default.Error,P.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([t.default.Error,P.localize(2,null,"version")]),i;if(!E.engines)return i.push([t.default.Error,P.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([t.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!a(E.extensionDependencies))return i.push([t.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!a(E.activationEvents))return i.push([t.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([t.default.Error,P.localize(7,null,"activationEvents","main")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([t.default.Warning,P.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([t.default.Error,P.localize(9,null,"main")]),i;{const s=(0,S.joinPath)(k,E.main);(0,S.isEqualOrParent)(s,k)||i.push([t.default.Warning,P.localize(10,null,s.path,k.path)])}if(typeof E.activationEvents>"u")return i.push([t.default.Error,P.localize(11,null,"activationEvents","main")]),i}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([t.default.Error,P.localize(12,null,"browser")]),i;{const s=(0,S.joinPath)(k,E.browser);(0,S.isEqualOrParent)(s,k)||i.push([t.default.Warning,P.localize(13,null,s.path,k.path)])}if(typeof E.activationEvents>"u")return i.push([t.default.Error,P.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(E.version))return i.push([t.default.Error,P.localize(15,null)]),i;const l=[];if(!f(u,g,E,D,l))for(const s of l)i.push([t.default.Error,s]);return i}e.validateExtensionManifest=y;function f(u,g,k,E,D){return E||typeof k.main>"u"&&typeof k.browser>"u"?!0:v(u,g,k.engines.vscode,D)}e.isValidExtensionVersion=f;function d(u,g,k){return u==="*"||v(g,k,u)}e.isEngineValid=d;function v(u,g,k,E=[]){const D=p(w(k));if(!D)return E.push(P.localize(16,null,k)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return E.push(P.localize(17,null,k)),!1}else if(!D.majorMustEqual)return E.push(P.localize(18,null,k)),!1;return b(u,g,D)?!0:(E.push(P.localize(19,null,u,k)),!1)}function a(u){if(!Array.isArray(u))return!1;for(let g=0,k=u.length;g<k;g++)if(typeof u[g]!="string")return!1;return!0}}),define(ee[191],te([0,1,17,31]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(R,M,I){let m=I&&I.get("storage.serviceMachineId",-1)||null;if(m)return m;try{const p=(await M.readFile(R.serviceMachineIdResource)).value.toString();m=(0,t.isUUID)(p)?p:null}catch{m=null}if(!m){m=(0,t.generateUuid)();try{await M.writeFile(R.serviceMachineIdResource,S.VSBuffer.fromString(m))}catch{}}return I?.store("storage.serviceMachineId",m,-1,1),m}e.getServiceMachineId=P}),define(ee[72],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class S{constructor(P,R=[],M=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=S}),define(ee[192],te([0,1,72]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var P;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(P=e.InstantiationType||(e.InstantiationType={}));function R(I,m,w){m instanceof S.SyncDescriptor||(m=new S.SyncDescriptor(m,[],Boolean(w))),t.push([I,m])}e.registerSingleton=R;function M(){return t}e.getSingletonServiceDescriptors=M}),define(ee[193],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class S{constructor(R,M){this.key=R,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.Node=S;class t{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const M of this.a.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const I=this.lookupOrInsertNode(R),m=this.lookupOrInsertNode(M);I.outgoing.set(m.key,m),m.incoming.set(I.key,I)}removeNode(R){const M=this.b(R);this.a.delete(M);for(const I of this.a.values())I.outgoing.delete(M),I.incoming.delete(M)}lookupOrInsertNode(R){const M=this.b(R);let I=this.a.get(M);return I||(I=new S(M,R),this.a.set(M,I)),I}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[M,I]of this.a)R.push(`${M}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this.a){const I=new Set([R]),m=this.c(M,I);if(m)return m}}c(R,M){for(const[I,m]of R.outgoing){if(M.has(I))return[...M,I].join(" -> ");M.add(I);const w=this.c(m,M);if(w)return w;M.delete(I)}}}e.Graph=t}),define(ee[5],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var S;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function I(m){return m[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=I})(S=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function t(M,I,m){I[S.DI_TARGET]===I?I[S.DI_DEPENDENCIES].push({id:M,index:m}):(I[S.DI_DEPENDENCIES]=[{id:M,index:m}],I[S.DI_TARGET]=I)}function P(M){if(S.serviceIds.has(M))return S.serviceIds.get(M);const I=function(m,w,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,m,p)};return I.toString=()=>M,S.serviceIds.set(M,I),I}e.createDecorator=P;function R(M){return M}e.refineServiceDecorator=R}),define(ee[62],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,S.createDecorator)("backupMainService")}),define(ee[18],te([0,1,11,7,5]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function R(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationOverrides=R;function M(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=M;var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function m(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=m;function w(u,g){const k=Object.create(null);for(const E in u)p(k,E,u[E],g);return k}e.toValuesTree=w;function p(u,g,k,E){const D=g.split("."),i=D.pop();let l=u;for(let n=0;n<D.length;n++){const s=D[n];let o=l[s];switch(typeof o){case"undefined":o=l[s]=Object.create(null);break;case"object":break;default:E(`Ignoring ${g} as ${D.slice(0,n+1).join(".")} is ${JSON.stringify(o)}`);return}l=o}if(typeof l=="object"&&l!==null)try{l[i]=k}catch{E(`Ignoring ${g} as ${D.join(".")} is ${JSON.stringify(l)}`)}else E(`Ignoring ${g} as ${D.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=p;function b(u,g){const k=g.split(".");y(u,k)}e.removeFromValueTree=b;function y(u,g){const k=g.shift();if(g.length===0){delete u[k];return}if(Object.keys(u).indexOf(k)!==-1){const E=u[k];typeof E=="object"&&!Array.isArray(E)&&(y(E,g),Object.keys(E).length===0&&delete u[k])}}function f(u,g,k){function E(l,n){let s=l;for(const o of n){if(typeof s!="object"||s===null)return;s=s[o]}return s}const D=g.split("."),i=E(u,D);return typeof i>"u"?k:i}e.getConfigurationValue=f;function d(u,g,k){Object.keys(g).forEach(E=>{E!=="__proto__"&&(E in u?S.isObject(u[E])&&S.isObject(g[E])?d(u[E],g[E],k):k&&(u[E]=g[E]):u[E]=g[E])})}e.merge=d;function v(u,g,k){const E=u.inspect(g),D=u.inspect(k);return typeof E.userValue<"u"||typeof E.workspaceValue<"u"||typeof E.workspaceFolderValue<"u"?E.value:typeof D.userValue<"u"||typeof D.workspaceValue<"u"||typeof D.workspaceFolderValue<"u"?D.value:E.defaultValue}e.getMigratedSettingValue=v;function a(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=a}),define(ee[73],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,S.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,S.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(R,M){return this.a[R]?.[M]??null}async setPassword(R,M,I){this.a[R]=this.a[R]??{},this.a[R][M]=I}async deletePassword(R,M){return this.a[R]?.[M]?(delete this.a[R][M],Object.keys(this.a[R]).length===0&&delete this.a[R],!0):!1}async findPassword(R){return JSON.stringify(this.a[R])??null}async findCredentials(R){const M=[];for(const I of Object.keys(this.a[R]||{}))M.push({account:I,password:this.a[R][I]});return M}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(ee[86],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,S.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class P{async getPerformanceInfo(M,I){return{}}async getSystemInfo(M,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,I){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=P}),define(ee[107],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,S.createDecorator)("encryptionMainService")}),define(ee[33],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,S.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,S.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[28],te([0,1,54,9,85,33,185,5]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(R.IEnvironmentService);class m extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,P.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}pe([S.memoize],m.prototype,"cachedLanguagesPath",null),pe([S.memoize],m.prototype,"backupHome",null),pe([S.memoize],m.prototype,"mainIPCHandle",null),pe([S.memoize],m.prototype,"mainLockfile",null),pe([S.memoize],m.prototype,"disableUpdates",null),pe([S.memoize],m.prototype,"disableKeytar",null),pe([S.memoize],m.prototype,"crossOriginIsolated",null),pe([S.memoize],m.prototype,"codeCachePath",null),pe([S.memoize],m.prototype,"useCodeCache",null),e.EnvironmentMainService=m}),define(ee[194],te([0,1,155,5]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function P(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function M(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function I(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function m(u,g,k){return I(g,k)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===k?!0:w(k).includes(u)}e.isTargetPlatformCompatible=m;function w(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function p(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=p;var b;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var y;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var f;(function(u){u.Install="install",u.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var v;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class a extends Error{constructor(g,k){super(g),this.code=k,this.name=k}}e.ExtensionManagementError=a,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,S.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,S.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ee[195],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,S.createDecorator)("extensionUrlTrustService")}),define(ee[196],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,S.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[108],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,S.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,S.createDecorator)("externalTerminal")}),define(ee[197],te([0,1,46,15,9,4,81,23,84,159,108]),function(H,e,S,t,P,R,M,I,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=w.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends y{openTerminal(E,D){return this.spawnTerminal(S,E,m.getWindowsShell(),D)}spawnTerminal(E,D,i,l){const n=D.windowsExec||f.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const s=P.basename(n).toLowerCase();if(s==="cmder"||s==="cmder.exe")return E.spawn(n,l?[l]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return n.indexOf(" ")>=0&&o.push('""'),o.push(n),(s==="wt"||s==="wt.exe")&&o.push("-d ."),new Promise((c,r)=>{const h=a(process),C=E.spawn(i,o,{cwd:l,env:h});C.on("error",r),C.on("exit",()=>c())})}runInTerminal(E,D,i,l,n){const s="windowsExec"in n&&n.windowsExec?n.windowsExec:f.getDefaultTerminalWindows();return new Promise((o,c)=>{const r=`"${D} - ${b}"`,h=`""${i.join('" "')}" & pause"`,C=["/c","start",r,"/wait",s,"/c",h],L=Object.assign({},a(process),l);Object.keys(L).filter(K=>L[K]===null).forEach(K=>delete L[K]);const O={cwd:D,env:L,windowsVerbatimArguments:!0};S.spawn(f.b,C,O).on("error",K=>{c(u(K))}),o(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.WindowsExternalTerminalService=f,f.b="cmd.exe";class d extends y{openTerminal(E,D){return this.spawnTerminal(S,E,D)}runInTerminal(E,D,i,l,n){const s=n.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((o,c)=>{if(s===p.DEFAULT_TERMINAL_OSX||s==="iTerm.app"){const r=s===p.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",C=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${r}.scpt`).fsPath,"-t",E||b,"-w",D];for(const B of i)C.push("-a"),C.push(B);if(l){const B=Object.assign({},a(process),l);for(const K in B){const V=B[K];V===null?(C.push("-u"),C.push(K)):(C.push("-e"),C.push(`${K}=${V}`))}}let L="";const O=S.spawn(d.b,C);O.on("error",B=>{c(u(B))}),O.stderr.on("data",B=>{L+=B.toString()}),O.on("exit",B=>{if(B===0)o(void 0);else if(L){const K=L.split(`
`,1);c(new Error(K[0]))}else c(new Error(w.localize(1,null,r,B)))})}else c(new Error(w.localize(2,null,s)))})}spawnTerminal(E,D,i){const l=D.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((n,s)=>{const o=["-a",l];i&&o.push(i);const c=a(process),r=E.spawn("/usr/bin/open",o,{cwd:i,env:c});r.on("error",s),r.on("exit",()=>n())})}}e.MacExternalTerminalService=d,d.b="/usr/bin/osascript";class v extends y{openTerminal(E,D){return this.spawnTerminal(S,E,D)}runInTerminal(E,D,i,l,n){const s=n.linuxExec?Promise.resolve(n.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((o,c)=>{const r=[];s.then(h=>{h.indexOf("gnome-terminal")>=0?r.push("-x"):r.push("-e"),r.push("bash"),r.push("-c");const C=`${g(i)}; echo; read -p "${v.b}" -n1;`;r.push(`''${C}''`);const L=Object.assign({},a(process),l);Object.keys(L).filter(V=>L[V]===null).forEach(V=>delete L[V]);const O={cwd:D,env:L};let B="";const K=S.spawn(h,r,O);K.on("error",V=>{c(u(V))}),K.stderr.on("data",V=>{B+=V.toString()}),K.on("exit",V=>{if(V===0)o(void 0);else if(B){const J=B.split(`
`,1);c(new Error(J[0]))}else c(new Error(w.localize(4,null,h,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!R.isLinux)v.d=Promise.resolve("xterm");else{const E=await I.Promises.exists("/etc/debian_version");v.d=new Promise(D=>{E?D("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?D("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?D("konsole"):process.env.COLORTERM?D(process.env.COLORTERM):process.env.TERM?D(process.env.TERM):D("xterm")})}return v.d}spawnTerminal(E,D,i){const l=D.linuxExec?Promise.resolve(D.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,s)=>{l.then(o=>{const c=a(process),r=E.spawn(o,[],{cwd:i,env:c});r.on("error",s),r.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=v,v.b=w.localize(3,null);function a(k){const E={...k.env};return(0,M.sanitizeProcessEnvironment)(E),E}function u(k){return"errno"in k&&k.errno==="ENOENT"&&"path"in k&&typeof k.path=="string"?new Error(w.localize(5,null,k.path)):k}function g(k){let E="";for(const D of k)D.indexOf(" ")>=0?E+='"'+D+'"':E+=D,E+=" ";return E}}),define(ee[16],te([0,1,60,9,27,11,7,161,5,4]),function(H,e,S,t,P,R,M,I,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function p(T){return T.create===!0}e.isFileOpenForWriteOptions=p;var b;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var y;(function(T){T[T.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var f;(function(T){T[T.None=0]="None",T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock",T[T.FileAtomicRead=16384]="FileAtomicRead",T[T.FileClone=32768]="FileClone"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(T){return!!(T.capabilities&2)}e.hasReadWriteCapability=d;function v(T){return!!(T.capabilities&8)}e.hasFileFolderCopyCapability=v;function a(T){return!!(T.capabilities&32768)}e.hasFileCloneCapability=a;function u(T){return!!(T.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function g(T){return!!(T.capabilities&16)}e.hasFileReadStreamCapability=g;function k(T){return d(T)?!!(T.capabilities&16384):!1}e.hasFileAtomicReadCapability=k;var E;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class D extends Error{constructor(U,z){super(U),this.code=z}}e.FileSystemProviderError=D;function i(T,U){const z=new D(T.toString(),U);return n(z,U),z}e.createFileSystemProviderError=i;function l(T){return T||i((0,I.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=l;function n(T,U){return T.name=U?`${U} (FileSystemError)`:"FileSystemError",T}e.markAsFileSystemProviderError=n;function s(T){if(!T)return E.Unknown;if(T instanceof D)return T.code;const U=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!U)return E.Unknown;switch(U[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=s;function o(T){if(T instanceof O)return T.fileOperationResult;switch(s(T)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var c;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY",T[T.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class r{constructor(U,z,Q){this.resource=U,this.operation=z,this.target=Q}isOperation(U){return this.operation===U}}e.FileOperationEvent=r;var h;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class C{constructor(U,z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Q=new Map;for(const ne of U){const x=Q.get(ne.type);switch(x?x.push([ne.resource,ne]):Q.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,x]of Q)switch(ne){case 1:this.a=S.TernarySearchTree.forUris(()=>z),this.a.fill(x);break;case 0:this.b=S.TernarySearchTree.forUris(()=>z),this.b.fill(x);break;case 2:this.c=S.TernarySearchTree.forUris(()=>z),this.c.fill(x);break}}contains(U,...z){return this.d(U,{includeChildren:!1},...z)}affects(U,...z){return this.d(U,{includeChildren:!0},...z)}d(U,z,...Q){if(!U)return!1;const ne=Q.length>0;return!!((!ne||Q.includes(1))&&(this.a?.get(U)||z.includeChildren&&this.a?.findSuperstr(U))||(!ne||Q.includes(0))&&(this.b?.get(U)||z.includeChildren&&this.b?.findSuperstr(U))||(!ne||Q.includes(2))&&(this.c?.findSubstr(U)||z.includeChildren&&this.c?.findSuperstr(U)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=C;function L(T,U,z){return!T||!U||T===U||U.length>T.length?!1:(U.charAt(U.length-1)!==t.sep&&(U+=t.sep),z?(0,P.startsWithIgnoreCase)(T,U):T.indexOf(U)===0)}e.isParent=L;class O extends Error{constructor(U,z,Q){super(U),this.fileOperationResult=z,this.options=Q}}e.FileOperationError=O;class B extends O{constructor(U,z,Q,ne){super(U,z,ne),this.fileOperationResult=z,this.size=Q}}e.TooLargeFileOperationError=B;class K extends O{constructor(U,z,Q){super(U,2,Q),this.stat=z}}e.NotModifiedSinceFileOperationError=K;var V;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",T[T.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var J;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(J=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function re(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.etag=re;async function se(T,U){if(!U.hasProvider(M.URI.from({scheme:T.scheme})))return new Promise(z=>{const Q=U.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===T.scheme&&ne.added&&(Q.dispose(),z())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(U){return(0,R.isNumber)(U)||(U=0),U<ae.KB?(0,I.localize)(1,null,U.toFixed(0)):U<ae.MB?(0,I.localize)(2,null,(U/ae.KB).toFixed(2)):U<ae.GB?(0,I.localize)(3,null,(U/ae.MB).toFixed(2)):U<ae.TB?(0,I.localize)(4,null,(U/ae.GB).toFixed(2)):(0,I.localize)(5,null,(U/ae.TB).toFixed(2))}}e.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var fe;(function(T){T[T.IA32=0]="IA32",T[T.OTHER=1]="OTHER"})(fe=e.Arch||(e.Arch={}));function ge(T){return{maxFileSize:T===0?300*ae.MB:16*ae.GB,maxHeapSize:T===0?700*ae.MB:2*700*ae.MB}}e.getPlatformFileLimits=ge;function q(T){return w.isWeb?T?10*ae.MB:50*ae.MB:T?100*ae.MB:1024*ae.MB}e.getLargeFileConfirmationLimit=q}),define(ee[198],te([0,1,17,45,13,3,2,59,7,31,16]),function(H,e,S,t,P,R,M,I,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends M.Disposable{constructor(f,d){super(),this.a=f,this.b=d,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.h=(0,w.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,d){const{buffer:v}=await this.a.call("readFile",[f,d]);return v}readFileStream(f,d,v){const a=(0,I.newWriteableStream)(g=>S.VSBuffer.concat(g.map(k=>S.VSBuffer.wrap(k))).buffer),u=this.a.listen("readFileStream",[f,d])(g=>{if(g instanceof S.VSBuffer)a.write(g.buffer);else{if(g==="end")a.end();else{let k;if(g instanceof Error)k=g;else{const E=g;k=(0,p.createFileSystemProviderError)(E.message??(0,t.toErrorMessage)(E),E.code??p.FileSystemProviderErrorCode.Unknown)}a.error(k),a.end()}u.dispose()}});return v.onCancellationRequested(()=>{a.error((0,P.canceled)()),a.end(),u.dispose()}),a}writeFile(f,d,v){return this.a.call("writeFile",[f,S.VSBuffer.wrap(d),v])}open(f,d){return this.a.call("open",[f,d])}close(f){return this.a.call("close",[f])}async read(f,d,v,a,u){const[g,k]=await this.a.call("read",[f,d,u]);return v.set(g.buffer.slice(0,k),a),k}write(f,d,v,a,u){return this.a.call("write",[f,d,S.VSBuffer.wrap(v),a,u])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,d){return this.a.call("delete",[f,d])}rename(f,d,v){return this.a.call("rename",[f,d,v])}copy(f,d,v){return this.a.call("copy",[f,d,v])}cloneFile(f,d){return this.a.call("cloneFile",[f,d])}i(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const d=f;this.f.fire(d.map(v=>({resource:m.URI.revive(v.resource),type:v.type})))}else{const d=f;this.g.fire(d)}}))}watch(f,d){const v=(0,w.generateUuid)();return this.a.call("watch",[this.h,v,f,d]),(0,M.toDisposable)(()=>this.a.call("unwatch",[this.h,v]))}}e.DiskFileSystemProviderClient=b}),define(ee[109],te([0,1,17,13,162,16]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(p,b,y,f,d,v){let a;try{await I(p,b,y,f,d,v)}catch(u){a=u}finally{a&&d.errorTransformer&&(a=d.errorTransformer(a)),typeof a<"u"&&y.error(a),y.end()}}e.readFileIntoStream=M;async function I(p,b,y,f,d,v){m(v);const a=await p.open(b,{create:!1});try{m(v);let u=0,g=0,k=d&&typeof d.length=="number"?d.length:void 0,E=S.VSBuffer.alloc(Math.min(d.bufferSize,typeof k=="number"?k:d.bufferSize)),D=d&&typeof d.position=="number"?d.position:0,i=0;do g=await p.read(a,D,E.buffer,i,E.byteLength-i),D+=g,i+=g,u+=g,typeof k=="number"&&(k-=g),i===E.byteLength&&(await y.write(f(E)),E=S.VSBuffer.alloc(Math.min(d.bufferSize,typeof k=="number"?k:d.bufferSize)),i=0);while(g>0&&(typeof k!="number"||k>0)&&m(v)&&w(u,d));if(i>0){let l=i;typeof k=="number"&&(l=Math.min(i,k)),y.write(f(E.slice(0,l)))}}catch(u){throw(0,R.ensureFileSystemProviderError)(u)}finally{await p.close(a)}}function m(p){if(p.isCancellationRequested)throw(0,t.canceled)();return!0}function w(p,b){if(b?.limits){if(typeof b.limits.memory=="number"&&p>b.limits.memory)throw(0,R.createFileSystemProviderError)((0,P.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&p>b.limits.size)throw(0,R.createFileSystemProviderError)((0,P.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[74],te([0,1,100,2,9,4,7,16]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function m(u){return u.recursive===!0}e.isRecursiveWatchRequest=m;class w extends t.Disposable{constructor(g,k,E,D){super(),this.h=g,this.i=k,this.j=E,this.k=D,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const g=new t.DisposableStore;this.c.value=g,this.b=this.l(g),this.b.setVerboseLogging(this.j),g.add(this.b.onDidChangeFile(k=>this.h(k))),g.add(this.b.onDidLogMessage(k=>this.i(k))),g.add(this.b.onDidError(k=>this.n(k)))}n(g){this.k.restartOnError?this.g<w.a&&this.f?(this.r(`restarting watcher after error: ${g}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${g}`):this.r(g)}p(g){this.g++,this.m(),this.watch(g)}async watch(g){this.f=g,await this.b?.watch(g)}async setVerboseLogging(g){this.j=g,await this.b?.setVerboseLogging(g)}r(g){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${g}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=w,w.a=5;class p extends w{constructor(g,k,E){super(g,k,E,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=p;class b extends w{constructor(g,k,E){super(g,k,E,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function y(u){return u.map(g=>({type:g.type,resource:M.URI.file(g.path)}))}e.toFileChanges=y;function f(u){const g=new a;for(const k of u)g.processEvent(k);return g.coalesce()}e.coalesceEvents=f;function d(u,g){return typeof g=="string"&&!g.startsWith(S.GLOBSTAR)&&!(0,P.isAbsolute)(g)?{base:u,pattern:g}:g}e.normalizeWatcherPattern=d;function v(u,g){const k=[];for(const E of g)k.push((0,S.parse)(d(u,E)));return k}e.parseWatcherPatterns=v;class a{constructor(){this.a=new Set,this.b=new Map}c(g){return R.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const k=this.b.get(this.c(g));let E=!1;if(k){const D=k.type,i=g.type;k.path!==g.path&&(g.type===2||g.type===1)?E=!0:D===1&&i===2?(this.b.delete(this.c(g)),this.a.delete(k)):D===2&&i===1?k.type=0:D===1&&i===0||(k.type=i)}else E=!0;E&&(this.a.add(g),this.b.set(this.c(g),g))}coalesce(){const g=[],k=[];return Array.from(this.a).filter(E=>E.type!==2?(g.push(E),!1):!0).sort((E,D)=>E.path.length-D.path.length).filter(E=>k.some(D=>(0,I.isParent)(E.path,D,!R.isLinux))?!1:(k.push(E.path),!0)).concat(g)}}}),define(ee[199],te([0,1,41,8,22,32,2,78,9,4,101,23,74]),function(H,e,S,t,P,R,M,I,m,w,p,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends M.Disposable{constructor(a,u,g,k){super(),this.j=a,this.k=u,this.l=g,this.m=k,this.c=this.B(new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.k(E))),this.f=this.B(new t.RunOnceWorker(E=>this.u(E),f.b)),this.g=(0,y.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,y.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new P.CancellationTokenSource,this.ready=this.n()}async n(){try{const a=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await b.Promises.stat(a);this.B(await this.s(a,u.isDirectory()))}catch(a){a.code!=="ENOENT"?this.w(a):this.z(a)}}async r(a){let u=a.path;try{u=await b.Promises.realpath(a.path),a.path===u&&(u=await(0,p.realcase)(a.path)??a.path),a.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${u})`)}catch{}return u}async s(a,u){if(w.isMacintosh&&(0,R.isEqualOrParent)(a,"/Volumes/",!0))return this.w(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const g=new P.CancellationTokenSource(this.i.token),k=new M.DisposableStore;try{const E=(0,m.basename)(a),D=(0,S.watch)(a);k.add((0,M.toDisposable)(()=>{D.removeAllListeners(),D.close()})),this.z(`Started watching: '${a}'`);const i=new Set;if(u)try{for(const n of await b.Promises.readdir(a))i.add(n)}catch(n){this.w(n)}const l=new Map;k.add((0,M.toDisposable)(()=>{for(const[,n]of l)n.dispose();l.clear()})),D.on("error",(n,s)=>{this.w(`Failed to watch ${a} for changes using fs.watch() (${n}, ${s})`),this.dispose()}),D.on("change",(n,s)=>{if(g.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${s}`);let o="";if(s&&(o=s.toString(),w.isMacintosh&&(o=(0,I.normalizeNFC)(o))),!(!o||n!=="change"&&n!=="rename"))if(u)if(n==="rename"){l.get(o)?.dispose();const c=setTimeout(async()=>{if(l.delete(o),o===E&&!await b.Promises.exists(a)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const r=await this.v((0,m.join)(a,o));if(g.token.isCancellationRequested)return;let h;r?i.has(o)?h=0:(h=1,i.add(o)):(i.delete(o),h=2),this.t({path:(0,m.join)(this.j.path,o),type:h})},f.a);l.set(o,(0,M.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(o)?c=0:(c=1,i.add(o)),this.t({path:(0,m.join)(this.j.path,o),type:c})}else if(n==="rename"||o!==E){const c=setTimeout(async()=>{const r=await b.Promises.exists(a);g.token.isCancellationRequested||(r?(this.t({path:this.j.path,type:0},!0),k.add(await this.s(a,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);k.clear(),k.add((0,M.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(E){await b.Promises.exists(a)&&!g.token.isCancellationRequested&&this.w(`Failed to watch ${a} for changes using fs.watch() (${E.toString()})`)}return(0,M.toDisposable)(()=>{g.dispose(!0),k.dispose()})}t(a,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!u&&this.g.some(g=>g(a.path))?this.m&&this.z(` >> ignored (excluded) ${a.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(g=>g(a.path))?this.m&&this.z(` >> ignored (not included) ${a.path}`):this.f.work(a))}u(a){const u=(0,y.coalesceEvents)(a);if(u.length>0){if(this.m)for(const k of u)this.z(`>> normalized ${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(a){if(w.isLinux)return b.Promises.exists(a);try{const u=(0,m.basename)(a);return(await b.Promises.readdir((0,m.dirname)(a))).some(k=>k===u)}catch(u){return this.z(u),!1}}setVerboseLogging(a){this.m=a}w(a){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}y(a){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}z(a){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.a=100,f.b=75;async function d(v,a,u,g,k=512){const E=await b.Promises.open(v,"r"),D=Buffer.allocUnsafe(k),i=new P.CancellationTokenSource(g);let l,n=!1;const s={path:v,excludes:[],recursive:!1},o=new f(s,c=>{(async()=>{for(const{type:r}of c)if(r===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:h}=await b.Promises.read(E,D,0,k,null);if(!h||i.token.isCancellationRequested)break;a(D.slice(0,h))}}catch(h){l=new Error(h),i.dispose(!0)}finally{n=!1}}})()});return await o.ready,u(),new Promise((c,r)=>{i.token.onCancellationRequested(async()=>{o.dispose();try{await b.Promises.close(E)}catch(h){l=new Error(h)}l?r(l):c()})})}e.watchFileContents=d}),define(ee[200],te([0,1,3,100,2,4,199]),function(H,e,S,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new S.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new S.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(w){const p=this.i(w),b=p.filter(f=>{const d=this.c.get(f.path);return d?!(0,t.patternsEquals)(d.request.excludes,f.excludes)||!(0,t.patternsEquals)(d.request.includes,f.includes):!0}),y=Array.from(this.c.values()).filter(({request:f})=>!p.find(d=>d.path===f.path&&(0,t.patternsEquals)(d.excludes,f.excludes)&&(0,t.patternsEquals)(d.includes,f.includes))).map(({request:f})=>f.path);b.length&&this.j(`Request to start watching: ${b.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),y.length&&this.j(`Request to stop watching: ${y.join(",")}`);for(const f of y)this.h(f);for(const f of b)this.g(f)}g(w){const p=new M.NodeJSFileWatcherLibrary(w,y=>this.a.fire(y),y=>this.b.fire(y),this.f),b={request:w,instance:p};this.c.set(w.path,b)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const p=this.c.get(w);p&&(this.c.delete(w),p.instance.dispose())}i(w){const p=new Map;for(const b of w){const y=R.isLinux?b.path:b.path.toLowerCase();p.set(y,b)}return Array.from(p.values())}async setVerboseLogging(w){this.f=w;for(const[,p]of this.c)p.instance.setVerboseLogging(w)}j(w){this.f&&this.b.fire({type:"trace",message:this.k(w)})}k(w,p){return p?`[File Watcher (node.js)] ${w} (path: ${p.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=I}),define(ee[201],te([0,1,74,200]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class P extends S.AbstractNonRecursiveWatcherClient{constructor(M,I,m){super(M,I,m),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=P}),define(ee[202],te([0,1,15,47,148,74]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends R.AbstractUniversalWatcherClient{constructor(m,w,p){super(m,w,p),this.m()}l(m){const w=m.add(new P.Client(S.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(w.onDidProcessExit(({code:p,signal:b})=>this.n(`terminated by itself with code ${p}, signal: ${b}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(ee[87],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class S{constructor(...P){this.a=new Map;for(const[R,M]of P)this.set(R,M)}set(P,R){const M=this.a.get(P);return this.a.set(P,R),M}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.ServiceCollection=S}),define(ee[203],te([0,1,8,13,2,72,193,5,87,97]),function(H,e,S,t,P,R,M,I,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class b extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class y{constructor(a=new m.ServiceCollection,u=!1,g,k=p){this.f=a,this.g=u,this.h=g,this.i=k,this.o=new Set,this.f.set(I.IInstantiationService,this),this._globalGraph=k?g?._globalGraph??new M.Graph(E=>E):void 0}createChild(a){return new y(a,this.g,this,this.i)}invokeFunction(a,...u){const g=d.traceInvocation(this.i,a);let k=!1;try{return a({get:D=>{if(k)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(D,g);if(!i)throw new Error(`[invokeFunction] unknown service '${D}'`);return i}},...u)}finally{k=!0,g.stop()}}createInstance(a,...u){let g,k;return a instanceof R.SyncDescriptor?(g=d.traceCreation(this.i,a.ctor),k=this.j(a.ctor,a.staticArguments.concat(u),g)):(g=d.traceCreation(this.i,a),k=this.j(a,u,g)),g.stop(),k}j(a,u=[],g){const k=I._util.getServiceDependencies(a).sort((i,l)=>i.index-l.index),E=[];for(const i of k){const l=this.m(i.id,g);l||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(l)}const D=k.length>0?k[0].index:u.length;if(u.length!==D){console.trace(`[createInstance] First service dependency of ${a.name} at position ${D+1} conflicts with ${u.length} static arguments`);const i=D-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,D)}return Reflect.construct(a,u.concat(E))}k(a,u){if(this.f.get(a)instanceof R.SyncDescriptor)this.f.set(a,u);else if(this.h)this.h.k(a,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const u=this.f.get(a);return!u&&this.h?this.h.l(a):u}m(a,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const g=this.l(a);return g instanceof R.SyncDescriptor?this.q(a,g,u.branch(a,!0)):(u.branch(a,!1),g)}q(a,u,g){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,u,g)}finally{this.o.delete(a)}}r(a,u,g){const k=new M.Graph(i=>i.id.toString());let E=0;const D=[{id:a,desc:u,_trace:g}];for(;D.length;){const i=D.pop();if(k.lookupOrInsertNode(i),E++>1e3)throw new b(k);for(const l of I._util.getServiceDependencies(i.desc.ctor)){const n=this.l(l.id);if(n||this.u(`[createInstance] ${a} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(l.id)),n instanceof R.SyncDescriptor){const s={id:l.id,desc:n,_trace:i._trace.branch(l.id,!0)};k.insertEdge(i,s),D.push(s)}}}for(;;){const i=k.roots();if(i.length===0){if(!k.isEmpty())throw new b(k);break}for(const{data:l}of i){if(this.l(l.id)instanceof R.SyncDescriptor){const s=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,s)}k.removeNode(l)}}return this.l(a)}s(a,u,g=[],k,E){if(this.f.get(a)instanceof R.SyncDescriptor)return this.t(a,u,g,k,E);if(this.h)return this.h.s(a,u,g,k,E);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(a,u,g=[],k,E){if(k){const D=new y(void 0,this.g,this,this.i);D.c=String(a);const i=new Map,l=new S.IdleValue(()=>{const n=D.j(u,g,E);for(const[s,o]of i){const c=n[s];if(typeof c=="function")for(const r of o)c.apply(n,r)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!l.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let r=i.get(s);return r||(r=new w.LinkedList,i.set(s,r)),(C,L,O)=>{const B=r.push([C,L,O]);return(0,P.toDisposable)(B)}}if(s in n)return n[s];const o=l.value;let c=o[s];return typeof c!="function"||(c=c.bind(o),n[s]=c),c},set(n,s,o){return l.value[s]=o,!0},getPrototypeOf(n){return u.prototype}})}else return this.j(u,g,E)}u(a,u){if(u&&console.warn(a),this.g)throw new Error(a)}}e.InstantiationService=y;var f;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(f||(f={}));class d{static traceInvocation(a,u){return a?new d(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(a,u){return a?new d(1,u.name):d.c}constructor(a,u){this.type=a,this.name=u,this.g=Date.now(),this.h=[]}branch(a,u){const g=new d(3,a.toString());return this.h.push([a,u,g]),g}stop(){const a=Date.now()-this.g;d.f+=a;let u=!1;function g(E,D){const i=[],l=new Array(E+1).join("	");for(const[n,s,o]of D.h)if(s&&o){u=!0,i.push(`${l}CREATES -> ${n}`);const c=g(E+1,o);c&&i.push(c)}else i.push(`${l}uses -> ${n}`);return i.join(`
`)}const k=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(a>2||u)&&d.all.add(k.join(`
`))}}e.Trace=d,d.all=new Set,d.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d.f=0}),define(ee[6],te([0,1,45,3,2,40,4,7,5]),function(H,e,S,t,P,R,M,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function w(){return new Date().toISOString()}var p;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;function b(c,r,h){switch(r){case p.Trace:c.trace(h);break;case p.Debug:c.debug(h);break;case p.Info:c.info(h);break;case p.Warning:c.warn(h);break;case p.Error:c.error(h);break;case p.Off:break;default:throw new Error(`Invalid log level ${r}`)}}e.log=b;function y(c){let r="";for(let h=0;h<c.length;h++){let C=c[h];if(typeof C=="object")try{C=JSON.stringify(C)}catch{}r+=(h>0?" ":"")+C}return r}e.format=y;class f extends P.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(r){this.b!==r&&(this.b=r,this.c.fire(this.b))}getLevel(){return this.b}f(r){return this.b!==p.Off&&this.b<=r}}e.AbstractLogger=f;class d extends f{constructor(r){super(),this.h=r}f(r){return this.h||super.f(r)}trace(r,...h){this.f(p.Trace)&&this.g(p.Trace,y([r,...h]))}debug(r,...h){this.f(p.Debug)&&this.g(p.Debug,y([r,...h]))}info(r,...h){this.f(p.Info)&&this.g(p.Info,y([r,...h]))}warn(r,...h){this.f(p.Warning)&&this.g(p.Warning,y([r,...h]))}error(r,...h){if(this.f(p.Error))if(r instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=r.stack,this.g(p.Error,y(C))}else this.g(p.Error,y([r,...h]))}flush(){}}e.AbstractMessageLogger=d;class v extends f{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r),this.g=!M.isWindows}trace(r,...h){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,r,...h):console.log(`[main ${w()}]`,r,...h))}debug(r,...h){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,r,...h):console.log(`[main ${w()}]`,r,...h))}info(r,...h){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,r,...h):console.log(`[main ${w()}]`,r,...h))}warn(r,...h){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,r,...h):console.warn(`[main ${w()}]`,r,...h))}error(r,...h){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,r,...h):console.error(`[main ${w()}]`,r,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class a extends f{constructor(r=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(r)}trace(r,...h){this.f(p.Trace)&&console.log("%cTRACE","color: #888",r,...h)}debug(r,...h){this.f(p.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",r,...h)}info(r,...h){this.f(p.Info)&&console.log("%c INFO","color: #33f",r,...h)}warn(r,...h){this.f(p.Warning)&&console.log("%c WARN","color: #993",r,...h)}error(r,...h){this.f(p.Error)&&console.log("%c  ERR","color: #f33",r,...h)}dispose(){}flush(){}}e.ConsoleLogger=a;class u extends f{constructor(r,h=e.DEFAULT_LOG_LEVEL){super(),this.g=r,this.setLevel(h)}trace(r,...h){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(r),...h])}debug(r,...h){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(r),...h])}info(r,...h){this.f(p.Info)&&this.g.log(p.Info,[this.h(r),...h])}warn(r,...h){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(r),...h])}error(r,...h){this.f(p.Error)&&this.g.log(p.Error,[this.h(r),...h])}h(r){return typeof r=="string"?r:(0,S.toErrorMessage)(r,this.f(p.Trace))}dispose(){}flush(){}}e.AdapterLogger=u;class g extends f{constructor(r){super(),this.g=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const h of this.g)h.setLevel(r);super.setLevel(r)}trace(r,...h){for(const C of this.g)C.trace(r,...h)}debug(r,...h){for(const C of this.g)C.debug(r,...h)}info(r,...h){for(const C of this.g)C.info(r,...h)}warn(r,...h){for(const C of this.g)C.warn(r,...h)}error(r,...h){for(const C of this.g)C.error(r,...h)}flush(){for(const r of this.g)r.flush()}dispose(){for(const r of this.g)r.dispose()}}e.MultiplexLogService=g;class k extends P.Disposable{constructor(r){super(),this.b=r,this.B(r)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(r){this.b.setLevel(r)}getLevel(){return this.b.getLevel()}trace(r,...h){this.b.trace(r,...h)}debug(r,...h){this.b.debug(r,...h)}info(r,...h){this.b.info(r,...h)}warn(r,...h){this.b.warn(r,...h)}error(r,...h){this.b.error(r,...h)}flush(){this.b.flush()}}e.LogService=k;class E extends P.Disposable{constructor(r,h){super(),this.c=r,this.b=new R.ResourceMap,this.B(h(C=>this.setLevel(C)))}getLoggers(){return[...this.b.values()].map(({logger:r})=>r)}getLogger(r){return this.b.get(r)?.logger}createLogger(r,h,C){let L=this.b.get(r)?.logger;return L||(C=h?.always?p.Trace:C,L=this.f(r,C??this.c,h),this.b.set(r,{logger:L,logLevel:C})),L}setLevel(r,h){const C=I.URI.isUri(r)?r:void 0,L=C?h:r;if(C){const O=this.b.get(C);O&&O.logLevel!==L&&(O.logLevel=L,O.logger.setLevel(L))}else this.c=L,this.b.forEach(({logLevel:O,logger:B})=>{O===void 0&&B.setLevel(this.c)})}getLogLevel(r){return this.b.get(r)?.logLevel}dispose(){this.b.forEach(({logger:r})=>r.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=E;class D{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return p.Info}trace(r,...h){}debug(r,...h){}info(r,...h){}warn(r,...h){}error(r,...h){}critical(r,...h){}dispose(){}flush(){}}e.NullLogger=D;class i extends D{}e.NullLogService=i;class l extends E{constructor(){super(p.Info,t.Event.None)}f(r,h,C){return new D}}e.NullLoggerService=l;function n(c){if(c.verbose)return p.Trace;if(typeof c.logLevel=="string"){const r=o(c.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function s(c){switch(c){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.LogLevelToString=s;function o(c){switch(c){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.parseLogLevel=o});var _=this&&this.__param||function(H,e){return function(S,t){e(S,t,H)}};define(ee[204],te([0,1,73,3,2,6,4,8]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let m=class Et extends P.Disposable{constructor(p){super(),this.g=p,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(p,b){this.g.trace("Getting password from keytar:",p,b);let y;try{y=await this.h()}catch{return null}const f=await(0,I.retry)(()=>y.getPassword(p,b),50,3);if(!f)return this.g.trace("Did not get a password from keytar for account:",b),f;let d,v;try{const a=JSON.parse(f);d=a.content,v=a.hasNextChunk}catch{}if(!d||!v)return this.g.trace("Got password from keytar for account:",b),f;try{let a=1;for(;v;){const u=await(0,I.retry)(()=>y.getPassword(p,`${b}-${a}`),50,3),g=JSON.parse(u);d+=g.content,v=g.hasNextChunk,a++}return this.g.trace(`Got ${a}-chunked password from keytar for account:`,b),d}catch(a){return this.g.error(a),f}}async setPassword(p,b,y){this.g.trace("Setting password using keytar:",p,b);let f;try{f=await this.h()}catch(d){throw this.i?.(d),d}if(M.isWindows&&y.length>Et.a){let d=0,v=0,a=!0;for(;a;){const u=y.substring(d,d+Et.b);d+=Et.b,a=y.length-d>0;const g={content:u,hasNextChunk:a};await(0,I.retry)(()=>f.setPassword(p,v?`${b}-${v}`:b,JSON.stringify(g)),50,3),v++}this.g.trace(`Got${v?` ${v}-chunked`:""} password from keytar for account:`,b)}else await(0,I.retry)(()=>f.setPassword(p,b,y),50,3),this.g.trace("Got password from keytar for account:",b);this.c.fire({service:p,account:b})}async deletePassword(p,b){this.g.trace("Deleting password using keytar:",p,b);let y;try{y=await this.h()}catch(u){throw this.i?.(u),u}const f=await y.getPassword(p,b);if(!f)return this.g.trace("Did not get a password to delete from keytar for account:",b),!1;let d,v;try{const u=JSON.parse(f);d=u.content,v=u.hasNextChunk}catch{}let a=0;if(d&&v)try{for(a++;v;){const u=`${b}-${a}`,g=await y.getPassword(p,u);await y.deletePassword(p,u),v=JSON.parse(g).hasNextChunk,a++}}catch(u){this.g.error(u)}return await y.deletePassword(p,b)?(this.c.fire({service:p,account:b}),this.g.trace(`Deleted${a?` ${a}-chunked`:""} password from keytar for account:`,b),!0):(this.g.trace(`Keytar failed to delete${a?` ${a}-chunked`:""} password for account:`,b),!1)}async findPassword(p){let b;try{b=await this.h()}catch{return null}return await b.findPassword(p)}async findCredentials(p){let b;try{b=await this.h()}catch{return[]}return await b.findCredentials(p)}clear(){return this.f instanceof S.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};m.a=2500,m.b=m.a-100,m=pe([_(0,R.ILogService)],m),e.BaseCredentialsMainService=m}),define(ee[205],te([0,1,6]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(R,M){this.a=R,this.b=M}c(){return new Promise((R,M)=>H(["vscode-encrypt"],R,M))}async encrypt(R){let M;try{M=await this.c()}catch{return R}try{return M.encrypt(this.a,R)}catch(I){return this.b.error(I),R}}async decrypt(R){let M;try{M=await this.c()}catch{return R}try{return M.decrypt(this.a,R)}catch(I){return this.b.error(I),R}}};t=pe([_(1,S.ILogService)],t),e.EncryptionMainService=t}),define(ee[206],te([0,1,25,8,13,3,2,9,74,6]),function(H,e,S,t,P,R,M,I,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class p extends M.Disposable{constructor(y,f){super(),this.a=y,this.b=f,this.c=this.B(new R.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(y,f){return f.recursive||this.b?.watcher?.forceUniversal?this.l(y,f):this.u(y,f)}l(y,f){const d={path:this.C(y),excludes:f.excludes,includes:f.includes,recursive:f.recursive},v=(0,S.insert)(this.j,d);return this.m(),(0,M.toDisposable)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(y=>(0,P.onUnexpectedError)(y))}n(){this.h||(this.h=this.B(this.p(f=>this.c.fire((0,m.toFileChanges)(f)),f=>this.z(f),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const f of this.j)(0,m.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const f of this.j)(0,m.isRecursiveWatchRequest)(f)&&y.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(y,f){const d={path:this.C(y),excludes:f.excludes,includes:f.includes,recursive:!1},v=(0,S.insert)(this.s,d);return this.v(),(0,M.toDisposable)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(y=>(0,P.onUnexpectedError)(y))}w(){return this.r||(this.r=this.B(this.y(y=>this.c.fire((0,m.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.r.watch(this.s)}z(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}C(y){return(0,I.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=p}),define(ee[207],te([0,1,25,8,17,22,3,70,68,2,60,15,63,20,59,160,16,109,6,13]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let E=class extends w.Disposable{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new M.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new M.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new M.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new M.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new t.ResourceQueue)}registerProvider(i,l){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${i}`);const n=new w.DisposableStore;return this.h.set(i,l),this.c.fire({added:!0,scheme:i,provider:l}),n.add(l.onDidChangeFile(s=>this.R.fire(new a.FileChangesEvent(s,!this.O(l))))),typeof l.onDidWatchError=="function"&&n.add(l.onDidWatchError(s=>this.S.fire(new Error(s)))),n.add(l.onDidChangeCapabilities(()=>this.g.fire({provider:l,scheme:i}))),(0,w.toDisposable)(()=>{this.c.fire({added:!1,scheme:i,provider:l}),this.h.delete(i),(0,w.dispose)(n)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const l=[];this.f.fire({scheme:i,join(n){l.push(n)}}),!this.h.has(i)&&await t.Promises.settled(l)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,l){const n=this.h.get(i.scheme);return!!(n&&n.capabilities&l)}listCapabilities(){return m.Iterable.map(this.h,([i,l])=>({scheme:i,capabilities:l.capabilities}))}async j(i){if(!(0,f.isAbsolutePath)(i))throw new a.FileOperationError((0,v.localize)(0,null,this.nb(i)),8);await this.activateProvider(i.scheme);const l=this.h.get(i.scheme);if(!l){const n=new k.ErrorNoTelemetry;throw n.message=(0,v.localize)(1,null,i.toString()),n}return l}async k(i){const l=await this.j(i);if((0,a.hasOpenReadWriteCloseCapability)(l)||(0,a.hasReadWriteCapability)(l)||(0,a.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(i){const l=await this.j(i);if((0,a.hasOpenReadWriteCloseCapability)(l)||(0,a.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,l){try{return await this.n(i,l)}catch(n){throw(0,a.toFileSystemProviderErrorCode)(n)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,v.localize)(2,null,this.nb(i)),1):(0,a.ensureFileSystemProviderError)(n)}}async n(i,l){const n=await this.j(i),s=this.O(n),o=l?.resolveTo,c=l?.resolveSingleChildDescendants,r=l?.resolveMetadata,h=await n.stat(i);let C;return this.p(n,i,h,void 0,!!r,(L,O)=>(C||(C=p.TernarySearchTree.forUris(()=>!s),C.set(i,!0),o&&C.fill(!0,o)),C.get(L.resource)||C.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&c?O===1:!1))}async p(i,l,n,s,o,c){const{providerExtUri:r}=this.N(i),h={resource:l,name:r.basename(l),isFile:(n.type&a.FileType.File)!==0,isDirectory:(n.type&a.FileType.Directory)!==0,isSymbolicLink:(n.type&a.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&a.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,a.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(h.isDirectory&&c(h,s)){try{const C=await i.readdir(l),L=await t.Promises.settled(C.map(async([O,B])=>{try{const K=r.joinPath(l,O),V=o?await i.stat(K):{type:B};return await this.p(i,K,V,C.length,o,c)}catch(K){return this.b.trace(K),null}}));h.children=(0,S.coalesce)(L)}catch(C){this.b.trace(C),h.children=[]}return h}return h}async resolveAll(i){return t.Promises.settled(i.map(async l=>{try{return{stat:await this.n(l.resource,l.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(i){const l=await this.j(i),n=await l.stat(i);return this.p(l,i,n,void 0,!0,()=>!1)}async exists(i){const l=await this.j(i);try{return!!await l.stat(i)}catch{return!1}}async canCreateFile(i,l){try{await this.r(i,l)}catch(n){return n}return!0}async r(i,l){if(!l?.overwrite&&await this.exists(i))throw new a.FileOperationError((0,v.localize)(3,null,this.nb(i)),3,l)}async createFile(i,l=P.VSBuffer.fromString(""),n){await this.r(i,n);const s=await this.writeFile(i,l);return this.m.fire(new a.FileOperationEvent(i,0,s)),s}async writeFile(i,l,n){const s=this.lb(await this.l(i),i),{providerExtUri:o}=this.N(s);try{await this.s(s,i,n)||await this.P(s,o.dirname(i));let r;if((0,a.hasReadWriteCapability)(s)&&!(l instanceof P.VSBuffer))if((0,d.isReadableStream)(l)){const h=await(0,d.peekStream)(l,3);h.ended?r=P.VSBuffer.concat(h.buffer):r=h}else r=(0,d.peekReadable)(l,h=>P.VSBuffer.concat(h),3);else r=l;!(0,a.hasOpenReadWriteCloseCapability)(s)||(0,a.hasReadWriteCapability)(s)&&r instanceof P.VSBuffer?await this.cb(s,i,n,r):await this.Y(s,i,n,r instanceof P.VSBuffer?(0,P.bufferToReadable)(r):r),this.m.fire(new a.FileOperationEvent(i,4))}catch(c){throw new a.FileOperationError((0,v.localize)(4,null,this.nb(i),(0,a.ensureFileSystemProviderError)(c).toString()),(0,a.toFileOperationResult)(c),n)}return this.resolve(i,{resolveMetadata:!0})}async s(i,l,n){if(!!n?.unlock&&!(i.capabilities&8192))throw new Error((0,v.localize)(5,null,this.nb(l)));let o;try{o=await i.stat(l)}catch{return}if((o.type&a.FileType.Directory)!==0)throw new a.FileOperationError((0,v.localize)(6,null,this.nb(l)),0,n);if(this.mb(l,o),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==a.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&n.mtime<o.mtime&&n.etag!==(0,a.etag)({mtime:n.mtime,size:o.size}))throw new a.FileOperationError((0,v.localize)(7,null),3,n);return o}async readFile(i,l,n){const s=await this.k(i);return l?.atomic?this.t(s,i,l,n):this.u(s,i,l,n)}async t(i,l,n,s){return new Promise((o,c)=>{this.X.queueFor(l,this.N(i).providerExtUri).queue(async()=>{try{const r=await this.u(i,l,n,s);o(r)}catch(r){c(r)}})})}async u(i,l,n,s){const o=await this.v(i,l,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,P.streamToBuffer)(o.value)}}async readFileStream(i,l,n){const s=await this.k(i);return this.v(s,i,l,n)}async v(i,l,n,s){const o=new R.CancellationTokenSource(s),c=this.F(l,n).then(h=>h,h=>{throw o.cancel(),h});let r;try{return typeof n?.etag=="string"&&n.etag!==a.ETAG_DISABLED&&await c,n?.atomic&&(0,a.hasFileAtomicReadCapability)(i)||!((0,a.hasOpenReadWriteCloseCapability)(i)||(0,a.hasFileReadStreamCapability)(i))||(0,a.hasReadWriteCapability)(i)&&n?.preferUnbuffered?r=this.D(i,l,n):(0,a.hasFileReadStreamCapability)(i)?r=this.z(i,l,o.token,n):r=this.C(i,l,o.token,n),{...await c,value:r}}catch(h){throw r&&await(0,d.consumeStream)(r),this.w(h,l,n)}}w(i,l,n){const s=(0,v.localize)(8,null,this.nb(l),(0,a.ensureFileSystemProviderError)(i).toString());return i instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(s,i.stat,n):i instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(s,i.fileOperationResult,i.size,i.options):new a.FileOperationError(s,(0,a.toFileOperationResult)(i),n)}z(i,l,n,s=Object.create(null)){const o=i.readFileStream(l,s,n);return(0,d.transform)(o,{data:c=>c instanceof P.VSBuffer?c:P.VSBuffer.wrap(c),error:c=>this.w(c,l,s)},c=>P.VSBuffer.concat(c))}C(i,l,n,s=Object.create(null)){const o=(0,P.newWriteableBufferStream)();return(0,u.readFileIntoStream)(i,l,o,c=>c,{...s,bufferSize:this.a,errorTransformer:c=>this.w(c,l,s)},n),o}D(i,l,n){const s=(0,d.newWriteableStream)(o=>P.VSBuffer.concat(o));return(async()=>{try{let o;n?.atomic&&(0,a.hasFileAtomicReadCapability)(i)?o=await i.readFile(l,{atomic:!0}):o=await i.readFile(l),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.G(l,o.byteLength,n),s.end(P.VSBuffer.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async F(i,l){const n=await this.resolve(i,{resolveMetadata:!0});if(n.isDirectory)throw new a.FileOperationError((0,v.localize)(9,null,this.nb(i)),0,l);if(typeof l?.etag=="string"&&l.etag!==a.ETAG_DISABLED&&l.etag===n.etag)throw new a.NotModifiedSinceFileOperationError((0,v.localize)(10,null),n,l);return this.G(i,n.size,l),n}G(i,l,n){if(n?.limits){let s;if(typeof n.limits.memory=="number"&&l>n.limits.memory&&(s=9),typeof n.limits.size=="number"&&l>n.limits.size&&(s=7),typeof s=="number")throw new a.TooLargeFileOperationError((0,v.localize)(11,null,this.nb(i)),s,l,n)}}async canMove(i,l,n){return this.H(i,l,"move",n)}async canCopy(i,l,n){return this.H(i,l,"copy",n)}async H(i,l,n,s){if(i.toString()!==l.toString())try{const o=n==="move"?this.lb(await this.l(i),i):await this.k(i),c=this.lb(await this.l(l),l);await this.M(o,i,c,l,n,s)}catch(o){return o}return!0}async move(i,l,n){const s=this.lb(await this.l(i),i),o=this.lb(await this.l(l),l),c=await this.I(s,i,o,l,"move",!!n),r=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(i,c==="move"?2:3,r)),r}async copy(i,l,n){const s=await this.k(i),o=this.lb(await this.l(l),l),c=await this.I(s,i,o,l,"copy",!!n),r=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(i,c==="copy"?3:2,r)),r}async I(i,l,n,s,o,c){if(l.toString()===s.toString())return o;const{exists:r,isSameResourceWithDifferentPathCase:h}=await this.M(i,l,n,s,o,c);if(r&&!h&&c&&await this.del(s,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(s)),o==="copy"){if(i===n&&(0,a.hasFileFolderCopyCapability)(i))await i.copy(l,s,{overwrite:c});else{const C=await this.resolve(l);C.isDirectory?await this.L(i,C,n,s):await this.J(i,l,n,s)}return o}else return i===n?(await i.rename(l,s,{overwrite:c}),o):(await this.I(i,l,n,s,"copy",c),await this.del(l,{recursive:!0}),"copy")}async J(i,l,n,s){if((0,a.hasOpenReadWriteCloseCapability)(i)&&(0,a.hasOpenReadWriteCloseCapability)(n))return this.eb(i,l,n,s);if((0,a.hasOpenReadWriteCloseCapability)(i)&&(0,a.hasReadWriteCapability)(n))return this.kb(i,l,n,s);if((0,a.hasReadWriteCapability)(i)&&(0,a.hasOpenReadWriteCloseCapability)(n))return this.ib(i,l,n,s);if((0,a.hasReadWriteCapability)(i)&&(0,a.hasReadWriteCapability)(n))return this.gb(i,l,n,s)}async L(i,l,n,s){await n.mkdir(s),Array.isArray(l.children)&&await t.Promises.settled(l.children.map(async o=>{const c=this.N(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.L(i,await this.resolve(o.resource),n,c):this.J(i,o.resource,n,c)}))}async M(i,l,n,s,o,c){let r=!1;if(i===n){const{providerExtUri:C,isPathCaseSensitive:L}=this.N(i);if(L||(r=C.isEqual(l,s)),r&&o==="copy")throw new Error((0,v.localize)(12,null,this.nb(l),this.nb(s)));if(!r&&C.isEqualOrParent(s,l))throw new Error((0,v.localize)(13,null,this.nb(l),this.nb(s)))}const h=await this.exists(s);if(h&&!r){if(!c)throw new a.FileOperationError((0,v.localize)(14,null,this.nb(l),this.nb(s)),4);if(i===n){const{providerExtUri:C}=this.N(i);if(C.isEqualOrParent(l,s))throw new Error((0,v.localize)(15,null,this.nb(l),this.nb(s)))}}return{exists:h,isSameResourceWithDifferentPathCase:r}}N(i){const l=this.O(i);return{providerExtUri:l?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:l}}O(i){return!!(i.capabilities&1024)}async createFolder(i){const l=this.lb(await this.j(i),i);await this.P(l,i);const n=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(i,0,n)),n}async P(i,l){const n=[],{providerExtUri:s}=this.N(i);for(;!s.isEqual(l,s.dirname(l));)try{if(((await i.stat(l)).type&a.FileType.Directory)===0)throw new Error((0,v.localize)(16,null,this.nb(l)));break}catch(o){if((0,a.toFileSystemProviderErrorCode)(o)!==a.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(l)),l=s.dirname(l)}for(let o=n.length-1;o>=0;o--){l=s.joinPath(l,n[o]);try{await i.mkdir(l)}catch(c){if((0,a.toFileSystemProviderErrorCode)(c)!==a.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(i,l){try{await this.Q(i,l)}catch(n){return n}return!0}async Q(i,l){const n=this.lb(await this.j(i),i);if(!!l?.useTrash&&!(n.capabilities&4096))throw new Error((0,v.localize)(17,null,this.nb(i)));let o;try{o=await n.stat(i)}catch{}if(o)this.mb(i,o);else throw new a.FileOperationError((0,v.localize)(18,null,this.nb(i)),1);if(!!!l?.recursive){const r=await this.resolve(i);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,v.localize)(19,null,this.nb(i)))}return n}async del(i,l){const n=await this.Q(i,l),s=!!l?.useTrash,o=!!l?.recursive;await n.delete(i,{recursive:o,useTrash:s}),this.m.fire(new a.FileOperationEvent(i,1))}async cloneFile(i,l){const n=await this.j(i),s=this.lb(await this.l(l),l);if(n===s&&this.N(n).providerExtUri.isEqual(i,l))return;if(n===s&&(0,a.hasFileCloneCapability)(n))return n.cloneFile(i,l);await this.P(s,this.N(s).providerExtUri.dirname(l));const o=this.X.queueFor(i,this.N(n).providerExtUri);return n===s&&(0,a.hasFileFolderCopyCapability)(n)?o.queue(()=>n.copy(i,l,{overwrite:!0})):o.queue(()=>this.J(n,i,s,l))}watch(i,l={recursive:!1,excludes:[]}){const n=new w.DisposableStore;let s=!1,o=()=>{s=!0};return n.add((0,w.toDisposable)(()=>o())),(async()=>{try{const c=await this.W(i,l);s?(0,w.dispose)(c):o=()=>(0,w.dispose)(c)}catch(c){this.b.error(c)}})(),n}async W(i,l){const n=await this.j(i),s=(0,I.hash)([this.N(n).providerExtUri.getComparisonKey(i),l]);let o=this.U.get(s);return o||(o={count:0,disposable:n.watch(i,l)},this.U.set(s,o)),o.count+=1,(0,w.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,w.dispose)(o.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.U)(0,w.dispose)(i.disposable);this.U.clear()}async Y(i,l,n,s){return this.X.queueFor(l,this.N(i).providerExtUri).queue(async()=>{const o=await i.open(l,{create:!0,unlock:n?.unlock??!1});try{(0,d.isReadableStream)(s)||(0,d.isReadableBufferedStream)(s)?await this.Z(i,o,s):await this.ab(i,o,s)}catch(c){throw(0,a.ensureFileSystemProviderError)(c)}finally{await i.close(o)}})}async Z(i,l,n){let s=0,o;if((0,d.isReadableBufferedStream)(n)){if(n.buffer.length>0){const c=P.VSBuffer.concat(n.buffer);await this.bb(i,l,c,c.byteLength,s,0),s+=c.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((c,r)=>{(0,d.listenStream)(o,{onData:async h=>{o.pause();try{await this.bb(i,l,h,h.byteLength,s,0)}catch(C){return r(C)}s+=h.byteLength,setTimeout(()=>o.resume())},onError:h=>r(h),onEnd:()=>c()})})}async ab(i,l,n){let s=0,o;for(;(o=n.read())!==null;)await this.bb(i,l,o,o.byteLength,s,0),s+=o.byteLength}async bb(i,l,n,s,o,c){let r=0;for(;r<s;)r+=await i.write(l,o+r,n.buffer,c+r,s-r)}async cb(i,l,n,s){return this.X.queueFor(l,this.N(i).providerExtUri).queue(()=>this.db(i,l,n,s))}async db(i,l,n,s){let o;s instanceof P.VSBuffer?o=s:(0,d.isReadableStream)(s)?o=await(0,P.streamToBuffer)(s):(0,d.isReadableBufferedStream)(s)?o=await(0,P.bufferedStreamToBuffer)(s):o=(0,P.readableToBuffer)(s),await i.writeFile(l,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async eb(i,l,n,s){return this.X.queueFor(s,this.N(n).providerExtUri).queue(()=>this.fb(i,l,n,s))}async fb(i,l,n,s){let o,c;try{o=await i.open(l,{create:!1}),c=await n.open(s,{create:!0,unlock:!1});const r=P.VSBuffer.alloc(this.a);let h=0,C=0,L=0;do L=await i.read(o,h,r.buffer,C,r.byteLength-C),await this.bb(n,c,r,L,h,C),h+=L,C+=L,C===r.byteLength&&(C=0);while(L>0)}catch(r){throw(0,a.ensureFileSystemProviderError)(r)}finally{await t.Promises.settled([typeof o=="number"?i.close(o):Promise.resolve(),typeof c=="number"?n.close(c):Promise.resolve()])}}async gb(i,l,n,s){return this.X.queueFor(s,this.N(n).providerExtUri).queue(()=>this.hb(i,l,n,s))}async hb(i,l,n,s){return n.writeFile(s,await i.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async ib(i,l,n,s){return this.X.queueFor(s,this.N(n).providerExtUri).queue(()=>this.jb(i,l,n,s))}async jb(i,l,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const c=await i.readFile(l);await this.bb(n,o,P.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,a.ensureFileSystemProviderError)(c)}finally{await n.close(o)}}async kb(i,l,n,s){const o=await(0,P.streamToBuffer)(this.C(i,l,R.CancellationToken.None));await this.cb(n,s,void 0,o)}lb(i,l){if(i.capabilities&2048)throw new a.FileOperationError((0,v.localize)(20,null,this.nb(l)),6);return i}mb(i,l){if((l.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,v.localize)(21,null,this.nb(i)),6)}nb(i){return i.scheme===b.Schemas.file?i.fsPath:i.toString(!0)}};E=pe([_(0,g.ILogService)],E),e.FileService=E}),define(ee[88],te([0,1,41,286,8,40,17,3,32,2,9,4,20,59,23,164,16,109,206,45,202,201]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(S)}catch(l){console.error(`Error enabling graceful-fs: ${(0,k.toErrorMessage)(l)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(n,s){super(n,s),this.onDidChangeCapabilities=I.Event.None,this.H=new R.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,b.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:s,symbolicLink:o}=await d.SymlinkSupport.stat(this.C(n));return{type:this.G(s,o),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.Y(s)}}async readdir(n){try{const s=await d.Promises.readdir(this.C(n),{withFileTypes:!0}),o=[];return await Promise.all(s.map(async c=>{try{let r;c.isSymbolicLink()?r=(await this.stat((0,y.joinPath)(n,c.name))).type:r=this.G(c),o.push([c.name,r])}catch(r){this.a.trace(r)}})),o}catch(s){throw this.Y(s)}}G(n,s){let o;return s?.dangling?o=a.FileType.Unknown:n.isFile()?o=a.FileType.File:n.isDirectory()?o=a.FileType.Directory:o=a.FileType.Unknown,s&&(o|=a.FileType.SymbolicLink),o}async I(n){const s=this.C(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let o;for(;o=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await o.wait();const c=new P.Barrier;return this.H.set(n,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,w.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.H.get(n)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),c.open()})}async readFile(n,s){let o;try{s?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),o=await this.I(n));const c=this.C(n);return await d.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{o?.dispose()}}J(n){i.D&&this.a.trace(n)}readFileStream(n,s,o){const c=(0,f.newWriteableStream)(r=>M.VSBuffer.concat(r.map(h=>M.VSBuffer.wrap(h))).buffer);return(0,u.readFileIntoStream)(this,n,c,r=>r.buffer,{...s,bufferSize:256*1024},o),c}async writeFile(n,s,o){let c;try{const r=this.C(n);if(!o.create||!o.overwrite){if(await d.Promises.exists(r)){if(!o.overwrite)throw(0,a.createFileSystemProviderError)((0,v.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,a.createFileSystemProviderError)((0,v.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:o.unlock}),await this.write(c,0,s,0,s.byteLength)}catch(r){throw await this.Z(n,r)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){i.O=n}async open(n,s){const o=this.C(n);let c;(0,a.isFileOpenForWriteOptions)(s)&&(c=await this.I(n));let r;try{if((0,a.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:C}=await d.SymlinkSupport.stat(o);C.mode&128||await d.Promises.chmod(o,C.mode|128)}catch(C){this.a.trace(C)}let h;if((0,a.isFileOpenForWriteOptions)(s)){if(b.isWindows)try{await d.Promises.truncate(o,0),h="r+"}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}h||(h="w")}else h="r";r=await d.Promises.open(o,h)}catch(h){throw c?.dispose(),(0,a.isFileOpenForWriteOptions)(s)?await this.Z(n,h):this.Y(h)}if(this.L.set(r,0),(0,a.isFileOpenForWriteOptions)(s)&&this.N.set(r,n),c){const h=this.M.get(r);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${r} (${o})`),this.M.set(r,c),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${r} (${o})`),h.dispose())}return r}async close(n){const s=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&i.O)try{await d.Promises.fdatasync(n)}catch(o){i.configureFlushOnWrite(!1),this.a.error(o)}return await d.Promises.close(n)}catch(o){throw this.Y(o)}finally{s&&(this.M.get(n)===s&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,o,c,r){const h=this.P(n,s);let C=null;try{C=(await d.Promises.read(n,o,c,r,h)).bytesRead}catch(L){throw this.Y(L)}finally{this.Q(n,h,C)}return C}P(n,s){return s===this.L.get(n)?null:s}Q(n,s,o){const c=this.L.get(n);typeof c=="number"&&(typeof s=="number"||(typeof o=="number"?this.L.set(n,c+o):this.L.delete(n)))}async write(n,s,o,c,r){return(0,P.retry)(()=>this.R(n,s,o,c,r),100,3)}async R(n,s,o,c,r){const h=this.P(n,s);let C=null;try{C=(await d.Promises.write(n,o,c,r,h)).bytesWritten}catch(L){throw await this.Z(this.N.get(n),L)}finally{this.Q(n,h,C)}return C}async mkdir(n){try{await d.Promises.mkdir(this.C(n))}catch(s){throw this.Y(s)}}async delete(n,s){try{const o=this.C(n);s.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(n,s,o){const c=this.C(n),r=this.C(s);if(c!==r)try{await this.S(n,s,"move",o.overwrite),await d.Promises.move(c,r)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,v.localize)(2,null,(0,p.basename)(c),(0,p.basename)((0,p.dirname)(r)),h.toString()))),this.Y(h)}}async copy(n,s,o){const c=this.C(n),r=this.C(s);if(c!==r)try{await this.S(n,s,"copy",o.overwrite),await d.Promises.copy(c,r,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,v.localize)(3,null,(0,p.basename)(c),(0,p.basename)((0,p.dirname)(r)),h.toString()))),this.Y(h)}}async S(n,s,o,c){const r=this.C(n),h=this.C(s);let C=!1;if(!!(this.capabilities&1024)||(C=(0,m.isEqual)(r,h,!0)),C&&o==="copy")throw(0,a.createFileSystemProviderError)((0,v.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!C&&await d.Promises.exists(h)){if(!c)throw(0,a.createFileSystemProviderError)((0,v.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(n,s){return this.U(n,s,!1)}async U(n,s,o){const c=this.C(n),r=this.C(s),h=!!(this.capabilities&1024);if((0,m.isEqual)(c,r,!h))return;const C=new w.DisposableStore;try{const[L,O]=await Promise.all([this.I(n),this.I(s)]);C.add(L),C.add(O),o&&await d.Promises.mkdir((0,p.dirname)(r),{recursive:!0}),await d.Promises.copyFile(c,r)}catch(L){if(L.code==="ENOENT"&&!o)return this.U(n,s,!0);throw this.Y(L)}finally{C.dispose()}}p(n,s,o){return new E.UniversalWatcherClient(c=>n(c),c=>s(c),o)}y(n,s,o){return new D.NodeJSWatcherClient(c=>n(c),c=>s(c),o)}Y(n){if(n instanceof a.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=a.FileSystemProviderErrorCode.NoPermissions;break;default:s=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(n,s)}async Z(n,s){let o=this.Y(s);if(n&&o.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.C(n));c.mode&128||(o=(0,a.createFileSystemProviderError)(s,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return o}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(ee[208],te([0,1,3,88,2,17,59,22]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class m extends P.Disposable{constructor(b,y){super(),this.a=b,this.b=y,this.w=new Map,this.y=new Map}call(b,y,f){const d=this.c(b);switch(y){case"stat":return this.g(d,f[0]);case"readdir":return this.h(d,f[0]);case"open":return this.l(d,f[0],f[1]);case"close":return this.m(f[0]);case"read":return this.n(f[0],f[1],f[2]);case"readFile":return this.i(d,f[0],f[1]);case"write":return this.p(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.k(d,f[0],f[1],f[2]);case"rename":return this.t(d,f[0],f[1],f[2]);case"copy":return this.u(d,f[0],f[1],f[2]);case"cloneFile":return this.v(d,f[0],f[1]);case"mkdir":return this.r(d,f[0]);case"delete":return this.s(d,f[0],f[1]);case"watch":return this.C(d,f[0],f[1],f[2],f[3]);case"unwatch":return this.D(f[0],f[1])}throw new Error(`IPC Command ${y} not found`)}listen(b,y,f){const d=this.c(b);switch(y){case"fileChange":return this.z(d,f[0]);case"readFileStream":return this.j(d,f[0],f[1])}throw new Error(`Unknown event ${y}`)}g(b,y){const f=this.f(b,y,!0);return this.a.stat(f)}h(b,y){const f=this.f(b,y);return this.a.readdir(f)}async i(b,y,f){const d=this.f(b,y,!0),v=await this.a.readFile(d,f);return R.VSBuffer.wrap(v)}j(b,y,f){const d=this.f(b,y,!0),v=new I.CancellationTokenSource,a=new S.Emitter({onDidRemoveLastListener:()=>{v.cancel()}}),u=this.a.readFileStream(d,f,v.token);return(0,M.listenStream)(u,{onData:g=>a.fire(R.VSBuffer.wrap(g)),onError:g=>a.fire(g),onEnd:()=>{a.fire("end"),a.dispose(),v.dispose()}}),a.event}k(b,y,f,d){const v=this.f(b,y);return this.a.writeFile(v,f.buffer,d)}l(b,y,f){const d=this.f(b,y,!0);return this.a.open(d,f)}m(b){return this.a.close(b)}async n(b,y,f){const d=R.VSBuffer.alloc(f),v=0,a=await this.a.read(b,y,d.buffer,v,f);return[d,a]}p(b,y,f,d,v){return this.a.write(b,y,f.buffer,d,v)}r(b,y){const f=this.f(b,y);return this.a.mkdir(f)}s(b,y,f){const d=this.f(b,y);return this.a.delete(d,f)}t(b,y,f,d){const v=this.f(b,y),a=this.f(b,f);return this.a.rename(v,a,d)}u(b,y,f,d){const v=this.f(b,y),a=this.f(b,f);return this.a.copy(v,a,d)}v(b,y,f){const d=this.f(b,y),v=this.f(b,f);return this.a.cloneFile(d,v)}z(b,y){const f=new S.Emitter({onWillAddFirstListener:()=>{this.w.set(y,this.F(b,f))},onDidRemoveLastListener:()=>{(0,P.dispose)(this.w.get(y)),this.w.delete(y)}});return f.event}async C(b,y,f,d,v){const a=this.w.get(y);if(a){const u=this.f(b,d),g=a.watch(f,u,v);this.y.set(y+f,g)}}async D(b,y){const f=b+y,d=this.y.get(f);d&&((0,P.dispose)(d),this.y.delete(f))}dispose(){super.dispose();for(const[,b]of this.y)b.dispose();this.y.clear();for(const[,b]of this.w)b.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=m;class w extends P.Disposable{constructor(b,y,f,d){super(),this.c=b,this.f=f,this.g=d,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(y)}h(b){const y=this.B(new S.Emitter);this.B(y.event(f=>{b.fire(f.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type})))})),this.B(this.b.onDidChangeFile(f=>y.fire(f))),this.B(this.b.onDidWatchError(f=>b.fire(f)))}i(b){}j(b){}watch(b,y,f){const d=this.j(this.g);return Array.isArray(d)&&(f.excludes=[...f.excludes,...d]),this.a.set(b,this.b.watch(y,f)),(0,P.toDisposable)(()=>{(0,P.dispose)(this.a.get(b)),this.a.delete(b)})}dispose(){super.dispose();for(const[,b]of this.a)b.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=w}),define(ee[209],te([0,1,14,163,4,7,16,9,208,142]),function(H,e,S,t,P,R,M,I,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class p extends m.AbstractDiskFileSystemProviderChannel{constructor(f,d,v){super(f,d),this.G=v}c(f){return w.DefaultURITransformer}f(f,d){return R.URI.revive(d)}async s(f,d,v){if(!v.useTrash)return super.s(f,d,v);const a=this.f(f,d),u=(0,I.normalize)(a.fsPath);try{await S.shell.trashItem(u)}catch{throw(0,M.createFileSystemProviderError)(P.isWindows?(0,t.localize)(0,null,(0,I.basename)(u)):(0,t.localize)(1,null,(0,I.basename)(u)),M.FileSystemProviderErrorCode.Unknown)}}F(f,d){return new b(f,d,this.b,this.G)}}e.DiskFileSystemProviderChannel=p;class b extends m.AbstractSessionFileWatcher{watch(f,d,v){if(v.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(f,d,v)}}}),define(ee[210],te([0,1,6]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;class t extends S.AbstractMessageLogger{constructor(R=S.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(M=>{this.l?.setLevel(M)}))}set logger(R){this.l=R;for(const{level:M,message:I}of this.k)(0,S.log)(R,M,I);this.k=[]}g(R,M){this.l?(0,S.log)(this.l,R,M):this.getLevel()<=R&&this.k.push({level:R,message:M})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogService=t}),define(ee[211],te([0,1,3,7,6]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(y,f){this.a=y,this.b=f,this.onDidChangeLogLevel=S.Event.buffer(y.onDidChangeLogLevel,!0)}listen(y,f){switch(f){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${f}`)}async call(y,f,d){switch(f){case"setLevel":return d[1]?this.b.setLevel(t.URI.revive(d[1]),d[0]):this.a.setLevel(d[0])}throw new Error(`Call not found: ${f}`)}}e.LogLevelChannel=R;class M{constructor(y){this.a=y}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(y,f){M.setLevel(this.a,y,f)}static setLevel(y,f,d){return y.call("setLevel",[f,d])}}e.LogLevelChannelClient=M;class I{constructor(y){this.b=y,this.a=new Map}listen(y,f){throw new Error(`Event not found: ${f}`)}async call(y,f,d){switch(f){case"createLogger":this.c(t.URI.revive(d[0]),d[1]);return;case"log":return this.e(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1])}throw new Error(`Call not found: ${f}`)}c(y,f){this.a.set(y.toString(),this.b.createLogger(y,f))}d(y,f){let d=console.log;switch(y){case P.LogLevel.Error:d=console.error;break;case P.LogLevel.Warning:d=console.warn;break;case P.LogLevel.Info:d=console.info;break}d.call(console,...f)}e(y,f){const d=this.a.get(y.toString());if(!d)throw new Error("Create the logger before logging");for(const[v,a]of f)(0,P.log)(d,v,a)}}e.LoggerChannel=I;class m extends P.AbstractLoggerService{constructor(y,f,d){super(y,f),this.g=d}createConsoleMainLogger(){return new P.AdapterLogger({log:(y,f)=>{this.g.call("consoleLog",[y,f])}})}f(y,f,d){return new w(this.g,y,f,d)}}e.LoggerChannelClient=m;class w extends P.AbstractMessageLogger{constructor(y,f,d,v){super(v?.always),this.m=y,this.n=f,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[f,v]).then(()=>{this.r(this.l),this.k=!0})}g(y,f){const d=[[y,f]];this.k?this.r(d):this.l.push(...d)}r(y){this.m.call("log",[this.n,y])}}class p extends P.LogService{constructor(y,f){super(f),this.c=y,this.B(y.onDidChangeLogLevel(d=>f.setLevel(d)))}setLevel(y){super.setLevel(y),this.c.setLevel(y)}}e.FollowerLogService=p}),define(ee[212],te([0,1,16,6]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var P;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(P||(P={}));async function R(w,p,b,y,f){try{const d=await new Promise((a,u)=>{H(["spdlog"],a,u)});d.setFlushOn(P.Trace);const v=await d.createAsyncRotatingLogger(w,p,b,y);return f?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(d){console.error(d)}return null}function M(w,p,b){switch(p){case t.LogLevel.Trace:w.trace(b);break;case t.LogLevel.Debug:w.debug(b);break;case t.LogLevel.Info:w.info(b);break;case t.LogLevel.Warning:w.warn(b);break;case t.LogLevel.Error:w.error(b);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function I(w,p){switch(p){case t.LogLevel.Trace:w.setLevel(P.Trace);break;case t.LogLevel.Debug:w.setLevel(P.Debug);break;case t.LogLevel.Info:w.setLevel(P.Info);break;case t.LogLevel.Warning:w.setLevel(P.Warning);break;case t.LogLevel.Error:w.setLevel(P.Error);break;case t.LogLevel.Off:w.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class m extends t.AbstractMessageLogger{constructor(p,b,y,f,d){super(),this.k=[],this.setLevel(d),this.l=this.n(p,b,y,f),this.B(this.onDidChangeLogLevel(v=>{this.m&&I(this.m,v)}))}async n(p,b,y,f){const d=y?6:1,v=30/d*S.ByteSize.MB,a=await R(p,b,v,d,f);if(a){this.m=a,I(this.m,this.getLevel());for(const{level:u,message:g}of this.k)M(this.m,u,g);this.k=[]}}g(p,b){this.m?M(this.m,p,b):this.getLevel()<=p&&this.k.push({level:p,message:b})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=m}),define(ee[213],te([0,1,31,6,212]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let R=class extends t.AbstractLoggerService{constructor(I){super(I.getLevel(),I.onDidChangeLogLevel)}f(I,m,w){return new P.SpdLogLogger(w?.name||(0,S.generateUuid)(),I.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,m)}};R=pe([_(0,t.ILogService)],R),e.LoggerService=R}),define(ee[214],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function S(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=S;function t(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function P(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=P;function R(M){return!S(M)&&!t(M)&&!P(M)}e.isMenubarMenuItemAction=R}),define(ee[38],te([0,1,3,68,2,5]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class M extends P.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const p=Object.keys(this.f).length;return this.f={...w,...this.f},p!==Object.keys(this.f).length&&await this.i(w),t.Iterable.reduce(this.g.entries(),(b,[y,f])=>({...b,[y]:f}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(w,[p,b])=>({...w,[p]:{definition:b,value:this.g.get(p)}}),{})}}e.AbstractPolicyService=M;class I{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(ee[215],te([0,1,8,3,68,11,16,6,38]),function(H,e,S,t,P,R,M,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function w(b,y){const f=[];for(const d of new Set(P.Iterable.concat(b.keys(),y.keys())))b.get(d)!==y.get(d)&&f.push(d);return f}let p=class extends m.AbstractPolicyService{constructor(y,f,d){super(),this.j=y,this.k=f,this.l=d,this.c=this.B(new S.ThrottledDelayer(500));const v=t.Event.filter(f.onDidFilesChange,a=>a.affects(y));this.B(f.watch(y)),this.B(v(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const y=new Map;try{const f=await this.k.readFile(this.j),d=JSON.parse(f.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(d))this.f[v]&&y.set(v,d[v])}catch(f){f.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",f)}return y}async p(){const y=await this.n(),f=w(this.g,y);this.g=y,f.length>0&&this.h.fire(f)}};p=pe([_(1,M.IFileService),_(2,I.ILogService)],p),e.FilePolicyService=p}),define(ee[216],te([0,1,3,2,38]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(m){this.b=m,this.a=new t.DisposableStore}listen(m,w){switch(w){case"onDidChange":return S.Event.map(this.b.onDidChange,p=>p.reduce((b,y)=>({...b,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${w}`)}call(m,w,p){switch(w){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${w}`)}dispose(){this.a.dispose()}}e.PolicyChannel=R;class M extends P.AbstractPolicyService{constructor(m,w){super(),this.a=w;for(const p in m){const{definition:b,value:y}=m[p];this.f[p]=b,y!==void 0&&this.g.set(p,y)}this.a.listen("onDidChange")(p=>{for(const b in p){const y=p[b];y===null?this.g.delete(b):this.g.set(b,y)}this.h.fire(Object.keys(p))})}async i(m){const w=await this.a.call("updatePolicyDefinitions",m);for(const p in w)this.g.set(p,w[p])}}e.PolicyChannelClient=M}),define(ee[64],te([0,1,4,35]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof S.globals.vscode<"u"&&typeof S.globals.vscode.context<"u"){const R=S.globals.vscode.context.configuration();if(R)P=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(P=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`,serverDataFolderName:P.serverDataFolderName?`${P.serverDataFolderName}-dev`:void 0}),!P.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(P,{version:R.version})}}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=P}),define(ee[19],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,S.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[217],te([0,1,79,6,19]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(I,m){this.b=I,this.c=m,this.a=new Map}async isExtensionUrlTrusted(I,m){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(m);if(!w)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",m),!1;const[,p,b]=w;let y=this.a.get(I);if(!y){if(y=this.b.trustedExtensionUrlPublicKeys[I],!y||y.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.a.set(I,[...y])}const f=Buffer.from(decodeURIComponent(b),"base64");if(f.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",m),!1;const d=f.slice(0,6),v=f.readUIntBE(0,6),a=Date.now()-v;if(a<0||a>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",m),!1;const u=f.slice(6),g=S.createVerify("SHA256");g.write(d),g.write(Buffer.from(p)),g.end();for(let k=0;k<y.length;k++){let E=y[k];if(E!==null){if(typeof E=="string")try{E=S.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),y[k]=E}catch(D){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${k+1} for ${I}:`,D),y[k]=null;continue}if(g.verify(E,u))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",m),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",m),!1}};R=pe([_(0,P.IProductService),_(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(ee[218],te([0,1,8,6]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let P=class{constructor(M,I,m){this.a=M,this.b=I,this.c=m}async inspect(M){await this.d();const I=this.a.webContents.debugger;await I.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.timeout)(M);const m=await I.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),m.profile}async d(){const M=this.a.webContents.debugger;M.attach(),await M.sendCommand("Profiler.enable")}async e(){const M=this.a.webContents.debugger;await M.sendCommand("Profiler.disable"),M.detach()}};P=pe([_(2,t.ILogService)],P),e.WindowProfiler=P}),define(ee[65],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,S.createDecorator)("protocolMainService")}),define(ee[48],te([0,1,123,11]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.a=new Map}add(M,I){S.ok(t.isString(M)),S.ok(t.isObject(I)),S.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,I)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.Registry=new P}),define(ee[219],te([0,1,3,48]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class R{constructor(){this.b=new S.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,w){this.a[P(m)]=w,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const M=new R;t.Registry.add(e.Extensions.JSONContribution,M)}),define(ee[66],te([0,1,25,3,11,151,18,219,48]),function(H,e,S,t,P,R,M,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=m.Registry.as(I.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,l=!0){this.registerConfigurations([i],l)}registerConfigurations(i,l=!0){const n=new Set;this.n(i,l,n),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const l=new Set;this.o(i,l),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:i,remove:l}){const n=new Set;this.o(l,n),this.n(i,!1,n),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const l=new Set;this.k(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(i,l){const n=[];for(const{overrides:s,source:o}of i)for(const c in s)if(l.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const r=this.a.get(c),h=r?.valuesSources??new Map;if(o)for(const B of Object.keys(s[c]))h.set(B,o);const C={...r?.value||{},...s[c]};this.a.set(c,{source:o,value:C,valuesSources:h});const L=(0,M.getLanguageTagSettingPlainKey)(c),O={type:"object",default:C,description:R.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:P.isString(o)?void 0:o,defaultValueSource:o};n.push(...v(c)),this.d[c]=O,this.b.properties[c]=O}else{this.a.set(c,{value:s[c],source:o});const r=this.d[c];r&&(this.w(c,r),this.r(c,r))}this.m(n)}deregisterDefaultConfigurations(i){const l=new Set;this.l(i,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(i,l){for(const{overrides:n,source:s}of i)for(const o in n){const c=this.a.get(o),r=P.isString(s)?s:s?.id,h=P.isString(c?.source)?c?.source:c?.source?.id;if(r===h)if(l.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const C=this.d[o];C&&(this.w(o,C),this.r(o,C))}}this.u()}deltaConfiguration(i){let l=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),l=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),l=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const l of i)this.h.add(l);this.u()}n(i,l,n){i.forEach(s=>{this.p(s,l,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,l){const n=s=>{if(s.properties)for(const o in s.properties){l.add(o);const c=this.d[o];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[o],this.s(o,s.properties[o])}s.allOf?.forEach(o=>n(o))};for(const s of i){n(s);const o=this.c.indexOf(s);o!==-1&&this.c.splice(o,1)}}p(i,l=!0,n,s,o=3,c){o=P.isUndefinedOrNull(i.scope)?o:i.scope;const r=i.properties;if(r)for(const C in r){const L=r[C];if(l&&k(C,L)){delete r[C];continue}if(L.source=n,L.defaultDefaultValue=r[C].default,this.w(C,L),e.OVERRIDE_PROPERTY_REGEX.test(C)?L.scope=void 0:(L.scope=P.isUndefinedOrNull(L.scope)?o:L.scope,L.restricted=P.isUndefinedOrNull(L.restricted)?!!s?.includes(C):L.restricted),r[C].hasOwnProperty("included")&&!r[C].included){this.f[C]=r[C],delete r[C];continue}else this.d[C]=r[C],r[C].policy?.name&&this.e.set(r[C].policy.name,C);!r[C].deprecationMessage&&r[C].markdownDeprecationMessage&&(r[C].deprecationMessage=r[C].markdownDeprecationMessage),c.add(C)}const h=i.allOf;if(h)for(const C of h)this.p(C,l,n,s,o,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const l=n=>{const s=n.properties;if(s)for(const c in s)this.r(c,s[c]);n.allOf?.forEach(l)};l(i)}r(i,l){switch(e.allSettings.properties[i]=l,l.scope){case 1:e.applicationSettings.properties[i]=l;break;case 2:e.machineSettings.properties[i]=l;break;case 6:e.machineOverridableSettings.properties[i]=l;break;case 3:e.windowSettings.properties[i]=l;break;case 4:e.resourceSettings.properties[i]=l;break;case 5:e.resourceSettings.properties[i]=l,this.g.properties[i]=l;break}}s(i,l){switch(delete e.allSettings.properties[i],l.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const l=`[${i}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(l,n),e.allSettings.properties[l]=n,e.applicationSettings.properties[l]=n,e.machineSettings.properties[l]=n,e.machineOverridableSettings.properties[l]=n,e.windowSettings.properties[l]=n,e.resourceSettings.properties[l]=n}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,l){const n=this.a.get(i);let s=n?.value,o=n?.source;P.isUndefined(s)&&(s=l.defaultDefaultValue,o=void 0),P.isUndefined(s)&&(s=u(l.type)),l.default=s,l.defaultValueSource=o}}const f="\\[([^\\]]+)\\]",d=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(D){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let l=d.exec(D);for(;l?.length;){const n=l[1].trim();n&&i.push(n),l=d.exec(D)}}return(0,S.distinct)(i)}e.overrideIdentifiersFromKey=v;function a(D){return D.reduce((i,l)=>`${i}[${l}]`,"")}e.keyFromOverrideIdentifiers=a;function u(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new y;m.Registry.add(e.Extensions.Configuration,g);function k(D,i){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?R.localize(7,null,D):g.getConfigurationProperties()[D]!==void 0?R.localize(8,null,D):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,D,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=k;function E(){const D=[],i=g.getConfigurationProperties();for(const l of Object.keys(i))D.push([l,i[l].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=E}),define(ee[110],te([0,1,25,3,43,2,40,44,11,7,18,66,48]),function(H,e,S,t,P,R,M,I,m,w,p,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(l){return Object.isFrozen(l)?l:I.deepFreeze(l)}class d{constructor(n={},s=[],o=[],c){this.b=n,this.c=s,this.d=o,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof d)return s;const o=new v("");return o.parseRaw(s),o.configurationModel});this.f=n.reduce((s,o)=>o===s?o:s.merge(o),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,p.getConfigurationValue)(this.contents,n):this.contents}inspect(n,s){const o=this.rawConfiguration.getValue(n),c=s?this.rawConfiguration.getOverrideValue(n,s):void 0,r=s?this.rawConfiguration.override(s).getValue(n):o;return{value:o,override:c,merged:r}}getOverrideValue(n,s){const o=this.i(s);return o?n?(0,p.getConfigurationValue)(o,n):o:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const o of this.overrides)o.identifiers.includes(n)&&s.push(...o.keys);return S.distinct(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return S.distinct(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=I.deepClone(this.contents),o=I.deepClone(this.overrides),c=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const h of n)if(r.push(...h.raw?.length?h.raw:[h]),!h.isEmpty()){this.h(s,h.contents);for(const C of h.overrides){const[L]=o.filter(O=>S.equals(O.identifiers,C.identifiers));L?(this.h(L.contents,C.contents),L.keys.push(...C.keys),L.keys=S.distinct(L.keys)):o.push(I.deepClone(C))}for(const C of h.keys)c.indexOf(C)===-1&&c.push(C)}return new d(s,c,o,r.every(h=>h instanceof d)?void 0:r)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const o={};for(const c of S.distinct([...Object.keys(this.contents),...Object.keys(s)])){let r=this.contents[c];const h=s[c];h&&(typeof r=="object"&&typeof h=="object"?(r=I.deepClone(r),this.h(r,h)):r=h),o[c]=r}return new d(o,this.keys,this.overrides)}h(n,s){for(const o of Object.keys(s)){if(o in n&&m.isObject(n[o])&&m.isObject(s[o])){this.h(n[o],s[o]);continue}n[o]=I.deepClone(s[o])}}i(n){let s=null,o=null;const c=r=>{r&&(o?this.h(o,r):o=I.deepClone(r))};for(const r of this.overrides)S.equals(r.identifiers,[n])?s=r.contents:r.identifiers.includes(n)&&c(r.contents);return c(s),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,p.removeFromValueTree)(this.contents,n),b.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(o=>S.equals(o.identifiers,(0,b.overrideIdentifiersFromKey)(n))),1))}j(n,s,o){(0,p.addToValueTree)(this.contents,n,s,c=>console.error(c)),o=o||this.keys.indexOf(n)===-1,o&&this.keys.push(n),b.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,p.toValuesTree)(this.contents[n],c=>console.error(c))})}}e.ConfigurationModel=d;class v{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!m.isUndefinedOrNull(n)){const o=this.g(n);this.parseRaw(o,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:o,keys:c,overrides:r,restricted:h,hasExcludedProperties:C}=this.h(n,s);this.b=new d(o,c,r,C?[n]:void 0),this.c=h||[]}g(n){let s={},o=null,c=[];const r=[],h=[];function C(O){Array.isArray(c)?c.push(O):o!==null&&(c[o]=O)}const L={onObjectBegin:()=>{const O={};C(O),r.push(c),c=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{c=r.pop()},onArrayBegin:()=>{const O=[];C(O),r.push(c),c=O,o=null},onArrayEnd:()=>{c=r.pop()},onLiteralValue:C,onError:(O,B,K)=>{h.push({error:O,offset:B,length:K})}};if(n)try{P.visit(n,L),s=c[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return s}h(n,s){const o=y.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),c=this.i(n,o,!0,s);n=c.raw;const r=(0,p.toValuesTree)(n,L=>console.error(`Conflict in settings file ${this.f}: ${L}`)),h=Object.keys(n),C=this.j(n,L=>console.error(`Conflict in settings file ${this.f}: ${L}`));return{contents:r,keys:h,overrides:C,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(n,s,o,c){let r=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:r};const h={},C=[];for(const L in n)if(b.OVERRIDE_PROPERTY_REGEX.test(L)&&o){const O=this.i(n[L],s,!1,c);h[L]=O.raw,r=r||O.hasExcludedProperties,C.push(...O.restricted)}else{const O=s[L],B=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&C.push(L),(B===void 0||c.scopes===void 0||c.scopes.includes(B))&&!(c.skipRestricted&&O?.restricted)?h[L]=n[L]:r=!0}return{raw:h,restricted:C,hasExcludedProperties:r}}j(n,s){const o=[];for(const c of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(c)){const r={};for(const h in n[c])r[h]=n[c][h];o.push({identifiers:(0,b.overrideIdentifiersFromKey)(c),keys:Object.keys(r),contents:(0,p.toValuesTree)(r,s)})}return o}}e.ConfigurationModelParser=v;class a extends R.Disposable{constructor(n,s,o,c){super(),this.f=n,this.g=s,this.h=c,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,r=>r.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&o.isEqual(r.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new d}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=a;class u{constructor(n,s,o,c,r,h,C,L,O,B,K,V,J){this.a=n,this.b=s,this.c=o,this.overrideIdentifiers=c,this.d=r,this.f=h,this.g=C,this.h=L,this.i=O,this.j=B,this.k=K,this.l=V,this.m=J}get value(){return f(this.c)}n(n,s,o){const c=n.inspect(s,o);return{get value(){return f(c.value)},get override(){return f(c.override)},get merged(){return f(c.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(n,s,o,c,r=new d,h=new d,C=new M.ResourceMap,L=new d,O=new M.ResourceMap){this.c=n,this.d=s,this.f=o,this.g=c,this.h=r,this.i=h,this.j=C,this.l=L,this.m=O,this.a=null,this.b=new M.ResourceMap,this.n=null}getValue(n,s,o){return this.q(n,s,o).getValue(n)}updateValue(n,s,o={}){let c;o.resource?(c=this.m.get(o.resource),c||(c=new d,this.m.set(o.resource,c))):c=this.l,s===void 0?c.removeValue(n):c.setValue(n,s),o.resource||(this.a=null)}inspect(n,s,o){const c=this.q(n,s,o),r=this.u(s.resource,o),h=s.resource?this.m.get(s.resource)||this.l:this.l,C=new Set;for(const L of c.overrides)for(const O of L.identifiers)c.getOverrideValue(n,O)!==void 0&&C.add(O);return new u(n,s,c.getValue(n),C.size?[...C]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,r||void 0,h)}keys(n){const s=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const o=[];if(!s){const{added:c,updated:r,removed:h}=D(this.c,n);s=[...c,...r,...h]}for(const c of s)for(const r of(0,b.overrideIdentifiersFromKey)(c)){const h=this.c.getKeysForOverrideIdentifier(r),C=n.getKeysForOverrideIdentifier(r),L=[...C.filter(O=>h.indexOf(O)===-1),...h.filter(O=>C.indexOf(O)===-1),...h.filter(O=>!I.equals(this.c.override(r).getValue(O),n.override(r).getValue(O)))];o.push([r,L])}return this.updateDefaultConfiguration(n),{keys:s,overrides:o}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:o,removed:c}=D(this.d,n),r=[...s,...o,...c];return r.length&&this.updatePolicyConfiguration(n),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:o,removed:c,overrides:r}=D(this.applicationConfiguration,n),h=[...s,...o,...c];return h.length&&this.updateApplicationConfiguration(n),{keys:h,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:o,removed:c,overrides:r}=D(this.localUserConfiguration,n),h=[...s,...o,...c];return h.length&&this.updateLocalUserConfiguration(n),{keys:h,overrides:r}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:o,removed:c,overrides:r}=D(this.remoteUserConfiguration,n),h=[...s,...o,...c];return h.length&&this.updateRemoteUserConfiguration(n),{keys:h,overrides:r}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:o,removed:c,overrides:r}=D(this.workspaceConfiguration,n),h=[...s,...o,...c];return h.length&&this.updateWorkspaceConfiguration(n),{keys:h,overrides:r}}compareAndUpdateFolderConfiguration(n,s){const o=this.p.get(n),{added:c,updated:r,removed:h,overrides:C}=D(o,s),L=[...c,...r,...h];return(L.length||!o)&&this.updateFolderConfiguration(n,s),{keys:L,overrides:C}}compareAndDeleteFolderConfiguration(n){const s=this.p.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:o,updated:c,removed:r,overrides:h}=D(s,void 0);return{keys:[...o,...c,...r],overrides:h}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,s,o){let c=this.r(s,o);return s.overrideIdentifier&&(c=c.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(c=c.merge(this.d)),c}r({resource:n},s){let o=this.s();if(s&&n){const c=s.getFolder(n);c&&(o=this.t(c.uri)||o);const r=this.m.get(n);r&&(o=o.merge(r))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let s=this.b.get(n);if(!s){const o=this.s(),c=this.j.get(n);c?(s=o.merge(c),this.b.set(n,s)):s=o}return s}u(n,s){if(s&&n){const o=s.getFolder(n);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:o,overrides:c,keys:r}=this.j.get(s);return n.push([s,{contents:o,overrides:c,keys:r}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(o=>n.add(o))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(o=>n.add(o))),[...n.values()]}w(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(o=>s.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>s.add(o)),this.i.getKeysForOverrideIdentifier(n).forEach(o=>s.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(n).forEach(c=>s.add(c))),[...s.values()]}static parse(n){const s=this.x(n.defaults),o=this.x(n.policy),c=this.x(n.application),r=this.x(n.user),h=this.x(n.workspace),C=n.folders.reduce((L,O)=>(L.set(w.URI.revive(O[0]),this.x(O[1])),L),new M.ResourceMap);return new g(s,o,c,r,new d,h,C,new d,new M.ResourceMap)}static x(n){return new d(n.contents,n.keys,n.overrides)}}e.Configuration=g;function k(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const n=new Set,s=new Map;for(const c of l)c.keys.forEach(r=>n.add(r)),c.overrides.forEach(([r,h])=>{const C=(0,M.getOrSet)(s,r,new Set);h.forEach(L=>C.add(L))});const o=[];return s.forEach((c,r)=>o.push([r,[...c.values()]])),{keys:[...n.values()],overrides:o}}e.mergeChanges=k;class E{constructor(n,s,o,c){this.change=n,this.f=s,this.g=o,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const r of n.keys)this.affectedKeys.add(r);for(const[,r]of n.overrides)for(const h of r)this.affectedKeys.add(h);this.d=this.a;for(const r of this.affectedKeys)this.d+=r+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(n,s){const o=this.a+n,c=this.d.indexOf(o);if(c<0)return!1;const r=c+o.length;if(r>=this.d.length)return!1;const h=this.d.charCodeAt(r);if(h!==this.b&&h!==this.c)return!1;if(s){const C=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,L=this.g.getValue(n,s,this.h);return!I.equals(C,L)}return!0}}e.ConfigurationChangeEvent=E;function D(l,n){const{added:s,removed:o,updated:c}=i(n?.rawConfiguration,l?.rawConfiguration),r=[],h=l?.getAllOverrideIdentifiers()||[],C=n?.getAllOverrideIdentifiers()||[];if(n){const L=C.filter(O=>!h.includes(O));for(const O of L)r.push([O,n.getKeysForOverrideIdentifier(O)])}if(l){const L=h.filter(O=>!C.includes(O));for(const O of L)r.push([O,l.getKeysForOverrideIdentifier(O)])}if(n&&l){for(const L of h)if(C.includes(L)){const O=i({contents:l.getOverrideValue(void 0,L)||{},keys:l.getKeysForOverrideIdentifier(L)},{contents:n.getOverrideValue(void 0,L)||{},keys:n.getKeysForOverrideIdentifier(L)});r.push([L,[...O.added,...O.removed,...O.updated]])}}return{added:s,removed:o,updated:c,overrides:r}}function i(l,n){const s=l?n?l.keys.filter(r=>n.keys.indexOf(r)===-1):[...l.keys]:[],o=n?l?n.keys.filter(r=>l.keys.indexOf(r)===-1):[...n.keys]:[],c=[];if(l&&n){for(const r of n.keys)if(l.keys.indexOf(r)!==-1){const h=(0,p.getConfigurationValue)(n.contents,r),C=(0,p.getConfigurationValue)(l.contents,r);I.equals(h,C)||c.push(r)}}return{added:s,removed:o,updated:c}}}),define(ee[220],te([0,1,25,3,2,44,11,110,66,6,38,48]),function(H,e,S,t,P,R,M,I,m,w,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class y extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new I.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:u})=>this.c(Array.from(a),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(a,u){this.h(a,b.Registry.as(m.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:a})}f(){return{}}g(){this.b=new I.ConfigurationModel;const a=b.Registry.as(m.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(a),a)}h(a,u){const g=this.f();for(const k of a){const E=g[k],D=u[k];E!==void 0?this.b.addValue(k,E):D?this.b.addValue(k,D.default):this.b.removeValue(k)}}}e.DefaultConfiguration=y;class f{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let d=class extends P.Disposable{get configurationModel(){return this.b}constructor(a,u,g){super(),this.c=a,this.f=u,this.g=g,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new I.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(a=>this.i(a))),this.B(this.c.onDidChangeConfiguration(async({properties:a})=>this.j(await this.h(a),!0))),this.b}async h(a){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",a);const u={},g=[],k=b.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const E of a){const D=k[E];if(!D){g.push(E);continue}if(D.policy){if(D.type!=="string"&&D.type!=="number"){this.g.warn(`Policy ${D.policy.name} has unsupported type ${D.type}`);continue}g.push(E),u[D.policy.name]={type:D.type}}}return(0,M.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),g}i(a){this.g.trace("PolicyConfiguration#onDidChangePolicies",a);const u=b.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),g=(0,S.coalesce)(a.map(k=>u.get(k)));this.j(g,!0)}j(a,u){this.g.trace("PolicyConfiguration#update",a);const g=b.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),k=[],E=this.b.isEmpty();for(const D of a){const i=g[D]?.policy?.name;if(i){const l=this.f.getPolicyValue(i);(E?l!==void 0:!(0,R.equals)(this.b.getValue(D),l))&&k.push([D,l])}else this.b.getValue(D)!==void 0&&k.push([D,void 0])}if(k.length){this.g.trace("PolicyConfiguration#changed",k);const D=this.b;this.b=new I.ConfigurationModel;for(const i of D.keys)this.b.setValue(i,D.getValue(i));for(const[i,l]of k)l===void 0?this.b.removeValue(i):this.b.setValue(i,l);u&&this.a.fire(this.b)}}};d=pe([_(1,p.IPolicyService),_(2,w.ILogService)],d),e.PolicyConfiguration=d}),define(ee[221],te([0,1,8,3,2,20,18,110,220,38]),function(H,e,S,t,P,R,M,I,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class p extends P.Disposable{constructor(y,f,d,v){super(),this.i=y,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new m.DefaultConfiguration),this.c=d instanceof w.NullPolicyService?new m.NullPolicyConfiguration:this.B(new m.PolicyConfiguration(this.b,d,v)),this.f=this.B(new I.UserSettings(this.i,void 0,R.extUriBiasedIgnorePathCase,f)),this.a=new I.Configuration(this.b.configurationModel,this.c.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.g=this.B(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:u})=>this.k(a,u))),this.B(this.c.onDidChangeConfiguration(a=>this.l(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,f,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.Configuration(y,f,new I.ConfigurationModel,d)}getConfigurationData(){return this.a.toData()}getValue(y,f){const d=typeof y=="string"?y:void 0,v=(0,M.isConfigurationOverrides)(y)?y:(0,M.isConfigurationOverrides)(f)?f:{};return this.a.getValue(d,v,void 0)}updateValue(y,f,d,v){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.j(y)}j(y){const f=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(y);this.m(d,f,2)}k(y,f){const d=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(y,f);this.m(v,d,7)}l(y){const f=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(y);this.m(d,f,7)}m(y,f,d){const v=new I.ConfigurationChangeEvent(y,{data:f},this.a);v.source=d,v.sourceConfig=this.n(d),this.h.fire(v)}n(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=p}),define(ee[222],te([0,1,13,5]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var P;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends S.ErrorNoTelemetry{static isNotAvailable(m){return m instanceof R&&m._code===P.NotAvailable}static isTemporarilyNotAvailable(m){return m instanceof R&&m._code===P.TemporarilyNotAvailable}static isNoResolverFound(m){return m instanceof R&&m._code===P.NoResolverFound}static isHandled(m){return m instanceof R&&m.isHandled}constructor(m,w=P.Unknown,p){super(m),this._message=m,this._code=w,this._detail=p,this.isHandled=w===P.NotAvailable&&p===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function M(I){const m=I.indexOf("+");return m===-1?I:I.substring(0,m)}e.getRemoteAuthorityPrefix=M}),define(ee[55],te([0,1,15]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(w){return w.scheme===S.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=t;function P(w){if(!w)return;const p=w.indexOf("+");return p<0?w:w.substr(0,p)}e.getRemoteName=P;function R(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=R;function M(w){const{host:p,port:b}=m(w);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:p,port:b}}e.parseAuthorityWithPort=M;function I(w,p){let{host:b,port:y}=m(w);return typeof y>"u"&&(y=p),{host:b,port:y}}e.parseAuthorityWithOptionalPort=I;function m(w){const p=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const b=w.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const y=w.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:w,port:void 0}}}),define(ee[89],te([0,1,27,5,55]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R;function M(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var m;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(m=e.TargetPlatform||(e.TargetPlatform={}));class w{constructor(v){this.value=v,this.c=v.toLowerCase()}static equals(v,a){if(typeof v>"u"||v===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof v=="string"||typeof a=="string"){const u=typeof v=="string"?v:v.value,g=typeof a=="string"?a:a.value;return S.equalsIgnoreCase(u,g)}return v.c===a.c}static toKey(v){return typeof v=="string"?v.toLowerCase():v.c}}e.ExtensionIdentifier=w;function p(d){return b(d)}e.isApplicationScopedExtension=p;function b(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function y(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function f(d,v){if(v){const a=`onResolveRemoteAuthority:${(0,P.getRemoteName)(v)}`;return d.activationEvents?.indexOf(a)!==-1}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[223],te([0,1,8,17,22,13,3,2,63,69,31,103,222,55]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const d=30*1e3;var v;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function a(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(W){const N=new P.CancellationTokenSource;return setTimeout(()=>N.cancel(),W),N.token}function g(W,N){if(W.isCancellationRequested||N.isCancellationRequested)return P.CancellationToken.Cancelled;const $=new P.CancellationTokenSource;return W.onCancellationRequested(()=>$.cancel()),N.onCancellationRequested(()=>$.cancel()),$.token}class k{get didTimeout(){return this.c==="timedout"}constructor(N){this.c="pending",this.d=new I.DisposableStore,this.promise=new Promise(($,G)=>{this.f=$,this.g=G}),N.isCancellationRequested?this.h():this.d.add(N.onCancellationRequested(()=>this.h()))}registerDisposable(N){this.c==="pending"?this.d.add(N):N.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const N=new Error("Time limit reached");return N.code="ETIMEDOUT",N.syscall="connect",N}resolve(N){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(N))}reject(N){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(N))}}function E(W,N){const $=new k(N);return $.registerDisposable(W.onControlMessage(G=>{const j=JSON.parse(G.toString()),X=z(j);X?$.reject(X):$.resolve(j)})),$.promise}function D(W,N,$,G,j,X,Z,oe,de){const ke=new k(de),De=w.StopWatch.create(!1);return W.info(`Creating a socket (${oe})...`),m.mark(`code/willCreateSocket/${Z}`),N.connect($,G,j,X,oe,(Pe,Ae)=>{ke.didTimeout?(m.mark(`code/didCreateSocketError/${Z}`),W.info(`Creating a socket (${oe}) finished after ${De.elapsed()} ms, but this is too late and has timed out already.`),Pe&&W.error(Pe),Ae?.dispose()):Pe||!Ae?(m.mark(`code/didCreateSocketError/${Z}`),W.info(`Creating a socket (${oe}) returned an error after ${De.elapsed()} ms.`),ke.reject(Pe)):(m.mark(`code/didCreateSocketOK/${Z}`),W.info(`Creating a socket (${oe}) was successful after ${De.elapsed()} ms.`),ke.resolve(Ae))}),ke.promise}function i(W,N){const $=new k(N);return W.then(G=>{$.didTimeout||$.resolve(G)},G=>{$.didTimeout||$.reject(G)}),$.promise}async function l(W,N,$,G){const j=A(W,N);W.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let X;try{X=await D(W.logService,W.socketFactory,W.host,W.port,(0,f.getRemoteServerRootPath)(W),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,a(N),`renderer-${a(N)}-${W.reconnectionToken}`,G)}catch(De){throw W.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),W.logService.error(De),De}W.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let Z,oe;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(X,null),Z=W.reconnectionProtocol,oe=!1):(Z=new b.PersistentProtocol({socket:X,measureRoundTripTime:!0}),oe=!0),W.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const de=await i(W.signService.createNewMessage((0,p.generateUuid)()),G),ke={type:"auth",auth:W.connectionToken||"00000000000000000000",data:de.data};Z.sendControl(t.VSBuffer.fromString(JSON.stringify(ke)));try{const De=await E(Z,g(G,u(1e4)));if(De.type!=="sign"||typeof De.data!="string"){const me=new Error("Unexpected handshake message");throw me.code="VSCODE_CONNECTION_ERROR",me}if(W.logService.trace(`${j} 4/6. received SignRequest control message.`),!await i(W.signService.validate(de,De.signedData),G)){const me=new Error("Refused to connect to unsupported server");throw me.code="VSCODE_CONNECTION_ERROR",me}const Ae=await i(W.signService.sign(De.data),G),ve={type:"connectionType",commit:W.commit,signedData:Ae,desiredConnectionType:N};return $&&(ve.args=$),W.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(t.VSBuffer.fromString(JSON.stringify(ve))),{protocol:Z,ownsProtocol:oe}}catch(De){throw De&&De.code==="ETIMEDOUT"&&(W.logService.error(`${j} the handshake timed out. Error:`),W.logService.error(De)),De&&De.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${j} received error control message when negotiating connection. Error:`),W.logService.error(De)),oe&&U(Z),De}}async function n(W,N,$,G){const j=Date.now(),X=A(W,N),{protocol:Z,ownsProtocol:oe}=await l(W,N,$,G),de=new k(G);return de.registerDisposable(Z.onControlMessage(ke=>{const De=JSON.parse(ke.toString()),Pe=z(De);Pe?(W.logService.error(`${X} received error control message when negotiating connection. Error:`),W.logService.error(Pe),oe&&U(Z),de.reject(Pe)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${F(j)}!`),de.resolve({protocol:Z,firstMessage:De}))})),de.promise}async function s(W,N){const{protocol:$}=await n(W,1,void 0,N);return{protocol:$}}async function o(W,N,$){const{protocol:G,firstMessage:j}=await n(W,2,N,$),X=j&&j.debugPort;return{protocol:G,debugPort:X}}async function c(W,N,$){const G=Date.now(),j=A(W,3),{protocol:X}=await l(W,3,N,$);return W.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${F(G)}!`),X}async function r(W,N,$){const{host:G,port:j,connectionToken:X}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,host:G,port:j,connectionToken:X,reconnectionToken:N,reconnectionProtocol:$,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function h(W,N,$){return L(W,async G=>{const{protocol:j}=await s(G,P.CancellationToken.None);return new q(W,N,$,G.reconnectionToken,j)})}e.connectRemoteAgentManagement=h;async function C(W,N){return L(W,async $=>{const{protocol:G,debugPort:j}=await o($,N,P.CancellationToken.None);return new T(W,N,$.reconnectionToken,G,j)})}e.connectRemoteAgentExtensionHost=C;async function L(W,N){for(let G=1;;G++)try{const j=(0,p.generateUuid)(),X=await r(W,j,null);return await N(X)}catch(j){if(G<5)W.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(j);else throw W.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(j),ge.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(j)),j}}async function O(W,N,$){const G=await r(W,(0,p.generateUuid)(),null);return await c(G,{host:N,port:$},P.CancellationToken.None)}e.connectRemoteAgentTunnel=O;function B(W){return(0,S.createCancelablePromise)(N=>new Promise(($,G)=>{const j=setTimeout($,W*1e3);N.onCancellationRequested(()=>{clearTimeout(j),$()})}))}var K;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain",W[W.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(K=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class V{constructor(N,$){this.reconnectionToken=N,this.millisSinceLastIncomingData=$,this.type=0}}e.ConnectionLostEvent=V;class J{constructor(N,$,G,j){this.reconnectionToken=N,this.millisSinceLastIncomingData=$,this.durationSeconds=G,this.c=j,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=J;class re{constructor(N,$,G){this.reconnectionToken=N,this.millisSinceLastIncomingData=$,this.attempt=G,this.type=2}}e.ReconnectionRunningEvent=re;class se{constructor(N,$,G){this.reconnectionToken=N,this.millisSinceLastIncomingData=$,this.attempt=G,this.type=4}}e.ConnectionGainEvent=se;class ae{constructor(N,$){this.reconnectionToken=N,this.connectionHealth=$,this.type=5}}e.ConnectionHealthChangedEvent=ae;class fe{constructor(N,$,G,j){this.reconnectionToken=N,this.millisSinceLastIncomingData=$,this.attempt=G,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=fe;class ge extends I.Disposable{static triggerPermanentFailure(N,$,G){this._permanentFailure=!0,this.f=N,this.g=$,this.h=G,this.i.forEach(j=>j.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(N=>N.r())}static debugPauseSocketWriting(){this.i.forEach(N=>N.v())}get k(){return this.c||ge._permanentFailure}constructor(N,$,G,j,X){super(),this.m=N,this.n=$,this.reconnectionToken=G,this.protocol=j,this.p=X,this.j=this.B(new M.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new se(this.reconnectionToken,0,0)),this.B(j.onSocketClose(Z=>{const oe=x(this.m,this.reconnectionToken,!0);Z?Z.type===0?(this.n.logService.info(`${oe} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.n.logService.error(Z.error)):(this.n.logService.info(`${oe} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.n.logService.error(Z.event)):this.n.logService.info(`${oe} received socket close event.`),this.r()})),this.B(j.onSocketTimeout(Z=>{const oe=x(this.m,this.reconnectionToken,!0);this.n.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(j.onHighRoundTripTime(Z=>{const oe=ne(this.m,this.reconnectionToken);this.n.logService.info(`${oe} high roundtrip time: ${Z.roundTripTime}ms (${Z.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(j.onDidChangeConnectionHealth(Z=>{this.j.fire(new ae(this.reconnectionToken,Z))})),ge.i.push(this),this.B((0,I.toDisposable)(()=>{const Z=ge.i.indexOf(this);Z>=0&&ge.i.splice(Z,1)})),this.k&&this.u(ge.f,ge.g,ge.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const N=x(this.m,this.reconnectionToken,!0);this.n.logService.info(`${N} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const $=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const j=G<$.length?$[G]:$[$.length-1];try{if(j>0){const Z=B(j);this.j.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,Z)),this.n.logService.info(`${N} waiting for ${j} seconds before reconnecting...`);try{await Z}catch{}}if(this.k){this.n.logService.error(`${N} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this.n.logService.info(`${N} resolving connection...`);const X=await r(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${N} connecting to ${X.host}:${X.port}...`),await this.w(X,u(d)),this.n.logService.info(`${N} reconnected!`),this.j.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${N} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this.n.logService.error(`${N} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(X)){this.n.logService.info(`${N} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this.n.logService.info(`${N} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(X);continue}if((0,R.isCancellationError)(X)){this.n.logService.info(`${N} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(X);continue}if(X instanceof y.RemoteAuthorityResolverError){this.n.logService.error(`${N} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,y.RemoteAuthorityResolverError.isHandled(X));break}this.n.logService.error(`${N} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(X),this.t(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this.k)}t(N,$,G){this.p?ge.triggerPermanentFailure(N,$,G):this.u(N,$,G)}u(N,$,G){this.j.fire(new fe(this.reconnectionToken,N,$,G)),U(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ge,ge._permanentFailure=!1,ge.f=0,ge.g=0,ge.h=!1,ge.i=[];class q extends ge{constructor(N,$,G,j,X){super(1,N,j,X,!0),this.client=this.B(new b.Client(X,{remoteAuthority:$,clientId:G},N.ipcLogger))}async w(N,$){await s(N,$)}}e.ManagementPersistentConnection=q;class T extends ge{constructor(N,$,G,j,X){super(2,N,G,j,!1),this.y=$,this.debugPort=X}async w(N,$){await o(N,this.y,$)}}e.ExtensionHostPersistentConnection=T;function U(W){try{W.acceptDisconnect();const N=W.getSocket();W.dispose(),N.dispose()}catch(N){(0,R.onUnexpectedError)(N)}}function z(W){if(W&&W.type==="error"){const N=new Error(`Connection error: ${W.reason}`);return N.code="VSCODE_CONNECTION_ERROR",N}return null}function Q(W,N){for(;W.length<N;)W+=" ";return W}function ne(W,N){return`[remote-connection][${Q(a(W),13)}][${N.substr(0,5)}\u2026]`}function x(W,N,$){return`${ne(W,N)}[${$?"reconnect":"initial"}]`}function A(W,N){return`${x(N,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function F(W){return`${Date.now()-W} ms`}}),define(ee[224],te([0,1,80,85]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(P,R,M,I,m,w){const p=y=>w(y,void 0),b=S.createConnection({host:P,port:R},()=>{b.removeListener("error",p);const y=Buffer.alloc(16);for(let a=0;a<16;a++)y[a]=Math.round(Math.random()*256);const f=y.toString("base64"),d=[`GET ws://${/:/.test(P)?`[${P}]`:P}:${R}${M}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];b.write(d.join(`\r
`)+`\r
\r
`);const v=a=>{a.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",v),w(void 0,new t.NodeSocket(b,m)))};b.on("data",v)});b.setNoDelay(!0),b.once("error",p)}}}),define(ee[225],te([0,1,26,46,41,184]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let M;async function I(f=!1){return(M===void 0||f)&&(M=m()),M}e.hasWSLFeatureInstalled=I;async function m(){const f=w();if(f===void 0)return!1;if(f>=22e3){const d=b();if(d)return new Promise(v=>{t.execFile(d,["--status"],a=>v(!a))})}else{const d=y();if(d)try{if((await P.promises.stat(d)).isFile())return!0}catch{}}return!1}function w(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(f)return parseInt(f[3])}function p(f){const d=process.env.SystemRoot;if(d){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(d,v?"Sysnative":"System32",f)}}function b(){return p("wsl.exe")}function y(){return p("lxss\\LxssManager.dll")}}),define(ee[56],te([0,1,17,168,66,5,48]),function(H,e,S,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function I(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=I;function m(v){return v.res.statusCode===204}async function w(v){return m(v)?null:(await(0,S.streamToBuffer)(v.stream)).toString()}e.asText=w;async function p(v){if(!I(v))throw new Error("Server returned "+v.res.statusCode);return w(v)}e.asTextOrError=p;async function b(v){if(!I(v))throw new Error("Server returned "+v.res.statusCode);if(m(v))return null;const u=(await(0,S.streamToBuffer)(v.stream)).toString();try{return JSON.parse(u)}catch(g){throw g.message+=`:
`+u,g}}e.asJson=b;function y(v){d(v)}e.updateProxyConfigurationsScope=y;let f;function d(v){const a=M.Registry.as(P.Extensions.Configuration),u=f;f={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},a.updateConfigurations({add:[f],remove:u?[u]:[]})}d(2)}),define(ee[226],te([0,1,17,22]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class P{constructor(I){this.a=I}listen(I,m){throw new Error("Invalid listen")}call(I,m,w,p=t.CancellationToken.None){switch(m){case"request":return this.a.request(w[0],p).then(async({res:b,stream:y})=>{const f=await(0,S.streamToBuffer)(y);return[{statusCode:b.statusCode,headers:b.headers},f]});case"resolveProxy":return this.a.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=P;class R{constructor(I){this.a=I}async request(I,m){const[w,p]=await this.a.call("request",[I],m);return{res:w,stream:(0,S.bufferToStream)(p)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}}e.RequestChannelClient=R}),define(ee[227],te([0,1,228,11]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function P(M,I){return M.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:M.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function R(M,I,m={}){const w=(0,S.parse)(M),p=m.proxyUrl||P(w,I);if(!p)return null;const b=(0,S.parse)(p);if(!/^https?:$/.test(b.protocol||""))return null;const y={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,t.isBoolean)(m.strictSSL)?m.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((f,d)=>{H(["http-proxy-agent"],f,d)}))(y):new(await new Promise((f,d)=>{H(["https-proxy-agent"],f,d)}))(y)}e.getProxyAgent=R}),define(ee[111],te([0,1,46,9,169,22,45,13,4,31,145,61,8,127]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let d;async function v(u,g,k,E){return k["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):m.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(E)&&!k["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(E)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=y.Promises.withAsyncBody(async(D,i)=>{const l=new R.CancellationTokenSource;let n=1e4;const s=u.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(n=(0,f.clamp)(s,1,120)*1e3);const o=setTimeout(()=>{l.dispose(!0),i(new Error((0,P.localize)(0,null)))},n);try{D(await a(g,l.token))}catch(c){!(0,I.isCancellationError)(c)&&!l.token.isCancellationRequested?i(new Error((0,P.localize)(1,null,(0,M.toErrorMessage)(c)))):D({})}finally{clearTimeout(o),l.dispose()}})),d)}e.getResolvedShellEnv=v;async function a(u,g){const k=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",k);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",E);const D=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(D+"({.*})"+D),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",l);const n=await(0,p.getSystemShell)(m.OS,l);return u.trace("getUnixShellEnvironment#shell",n),new Promise((s,o)=>{if(g.isCancellationRequested)return o(new I.CancellationError);const c=(0,t.basename)(n);let r,h;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(r=`& '${process.execPath}' ${C} -p '''${D}'' + JSON.stringify(process.env) + ''${D}'''`,h=["-Login","-Command"]):(r=`'${process.execPath}' ${C} -p '"${D}" + JSON.stringify(process.env) + "${D}"'`,c==="tcsh"||c==="csh"?h=["-ic"]:h=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),r);const L=(0,S.spawn)(n,[...h,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});g.onCancellationRequested(()=>(L.kill(),o(new I.CancellationError))),L.on("error",K=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(K)),o(K)});const O=[];L.stdout.on("data",K=>O.push(K));const B=[];L.stderr.on("data",K=>B.push(K)),L.on("close",(K,V)=>{const J=Buffer.concat(O).toString("utf8");u.trace("getUnixShellEnvironment#raw",J);const re=Buffer.concat(B).toString("utf8");if(re.trim()&&u.trace("getUnixShellEnvironment#stderr",re),K||V)return o(new Error((0,P.localize)(2,null,K,V)));const se=i.exec(J),ae=se?se[1]:"{}";try{const fe=JSON.parse(ae);k?fe.ELECTRON_RUN_AS_NODE=k:delete fe.ELECTRON_RUN_AS_NODE,E?fe.ELECTRON_NO_ATTACH_CONSOLE=E:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",fe),s(fe)}catch(fe){u.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(fe)),o(fe)}})})}}),define(ee[90],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,S.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[229],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class S{constructor(){this.b=new Map}c(){return new Promise((P,R)=>H(["vsda"],P,R))}async createNewMessage(P){try{const R=await this.c(),M=new R.validator;if(M){const I=String(S.a++);return this.b.set(I,M),{id:I,data:M.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,R){if(!P.id)return!0;const M=this.b.get(P.id);if(!M)return!1;this.b.delete(P.id);try{return M.validate(R)==="ok"}catch{return!1}}async sign(P){try{const R=await this.c(),M=new R.signer;if(M)return M.sign(P)}catch{}return P}}e.SignService=S,S.a=1}),define(ee[34],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,S.createDecorator)("stateMainService")}),define(ee[21],te([0,1,14,42,8,3,2,4,35,11,5,6,34,28]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,p.createDecorator)("lifecycleMainService");var d;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var v;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(v=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let a=class It extends M.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(g,k,E){super(),this.v=g,this.w=k,this.y=E,this.c=this.B(new R.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new R.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(It.b),this.j&&this.w.removeItem(It.b)}C(){const g=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),I.isMacintosh&&this.n===0&&this.D(1))};S.app.addListener("before-quit",g);const k=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!I.isMacintosh)&&S.app.quit()};S.app.addListener("window-all-closed",k),S.app.once("will-quit",E=>{this.L("Lifecycle#app.on(will-quit)"),E.preventDefault(),this.D(1).finally(()=>{this.H(!1),S.app.removeListener("before-quit",g),S.app.removeListener("window-all-closed",k),S.app.quit()})})}D(g){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const k=[];return this.f.fire({reason:g,join(E){k.push(E)}}),this.s=(async()=>{try{await P.Promises.settled(k)}catch(E){this.v.error(E)}try{await this.w.close()}catch(E){this.v.error(E)}})(),this.s}set phase(g){if(g<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===g)return;this.L(`lifecycle (main): phase changed (value: ${g})`),this.k=g;const k=this.u.get(this.k);k&&(k.open(),this.u.delete(this.k))}async when(g){if(g<=this.k)return;let k=this.u.get(g);k||(k=new P.Barrier,this.u.set(g,k)),await k.wait()}registerWindow(g){const k=new M.DisposableStore;this.n++,k.add(g.onWillLoad(D=>this.g.fire({window:g,workspace:D.workspace,reason:D.reason})));const E=(0,w.assertIsDefined)(g.win);E.on("close",D=>{const i=g.id;if(this.l.has(i)){this.l.delete(i);return}this.L(`Lifecycle#window.on('close') - window ID ${g.id}`),D.preventDefault(),this.unload(g,1).then(l=>{if(l){this.l.delete(i);return}this.l.add(i),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this.h.fire(g),g.close()})}),E.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${g.id}`),this.n--,k.dispose(),this.n===0&&(!I.isMacintosh||this.i)&&this.D(1)})}async reload(g,k){await this.unload(g,3)||g.reload(k)}unload(g,k){const E=this.t.get(g.id);if(E)return E;const D=this.F(g,k).finally(()=>{this.t.delete(g.id)});return this.t.set(g.id,D),D}async F(g,k){if(!g.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${g.id}`);const E=this.i?2:k,D=await this.I(g,E);return D?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${g.id})`),this.G(D)):(await this.J(g,E),!1)}G(g){return g?(this.H(!0),this.i=!1,!0):!1}H(g){this.r&&(this.r(g),this.r=void 0,this.p=void 0)}I(g,k){return new Promise(E=>{const D=this.m++,i=`vscode:ok${D}`,l=`vscode:cancel${D}`;t.validatedIpcMain.once(i,()=>{E(!1)}),t.validatedIpcMain.once(l,()=>{E(!0)}),g.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:l,reason:k})})}J(g,k){return new Promise(E=>{const i=`vscode:reply${this.m++}`;t.validatedIpcMain.once(i,()=>E()),g.send("vscode:onWillUnload",{replyChannel:i,reason:k})})}quit(g){return this.L(`Lifecycle#quit() - begin (willRestart: ${g})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(g&&this.w.setItem(It.b,!0),this.p=new Promise(k=>{this.r=k,this.L("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.p)}L(g){this.y.args["enable-smoke-test-driver"]?this.v.info(g):this.v.trace(g)}async relaunch(g){this.L("Lifecycle#relaunch()");const k=process.argv.slice(1);if(g?.addArgs&&k.push(...g.addArgs),g?.removeArgs)for(const i of g.removeArgs){const l=k.indexOf(i);l>=0&&k.splice(l,1)}const E=()=>{try{if(I.isWindows){const i=(0,m.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.v.error(i)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:k})};S.app.once("quit",E),await this.quit(!0)&&S.app.removeListener("quit",E)}async kill(g){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,P.timeout)(1e3),(async()=>{for(const k of S.BrowserWindow.getAllWindows())if(k&&!k.isDestroyed()){let E;k.webContents&&!k.webContents.isDestroyed()?E=new Promise(D=>k.once("closed",D)):E=Promise.resolve(),k.destroy(),await E}})()]),S.app.exit(g)}};a.b="lifecycle.quitAndRestart",a=pe([_(0,b.ILogService),_(1,y.IStateMainService),_(2,f.IEnvironmentMainService)],a),e.LifecycleMainService=a}),define(ee[230],te([0,1,4,3,2,5,21]),function(H,e,S,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let I=class extends P.Disposable{constructor(p){super(),this.a=this.B(new t.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,p.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const p=await new Promise((b,y)=>{H(["native-keymap"],b,y)});this.c=m(p),S.isCI||p.onDidChangeKeyboardLayout(()=>{this.c=m(p),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};I=pe([_(0,M.ILifecycleMainService)],I),e.KeyboardLayoutMainService=I;function m(w){const p=w.getKeyMap(),b=w.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:b}}}),define(ee[231],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,S.createDecorator)("stateService")}),define(ee[232],te([0,1,8,17,11,33,16,6]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class m{constructor(b,y,f){this.f=b,this.g=y,this.h=f,this.a=Object.create(null),this.b="",this.c=new S.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(b){b.fileOperationResult!==1&&this.g.error(b)}}getItem(b,y){const f=this.a[b];return(0,P.isUndefinedOrNull)(f)?y:f}setItem(b,y){this.setItems([{key:b,data:y}])}setItems(b){let y=!1;for(const{key:f,data:d}of b)this.a[f]!==d&&((0,P.isUndefinedOrNull)(d)?(0,P.isUndefined)(this.a[f])||(this.a[f]=void 0,y=!0):(this.a[f]=d,y=!0));y&&this.j()}removeItem(b){(0,P.isUndefined)(this.a[b])||(this.a[b]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const b=JSON.stringify(this.a,null,4);if(b!==this.b)try{await this.h.writeFile(this.f,t.VSBuffer.fromString(b)),this.b=b}catch(y){this.g.error(y)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=m;let w=class{constructor(b,y,f){this.a=new m(b.stateResource,y,f)}async init(){await this.a.init()}getItem(b,y){return this.a.getItem(b,y)}};w=pe([_(0,R.IEnvironmentService),_(1,I.ILogService),_(2,M.IFileService)],w),e.StateService=w}),define(ee[233],te([0,1,232]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends S.StateService{setItem(R,M){this.a.setItem(R,M)}setItems(R){this.a.setItems(R)}removeItem(R){this.a.removeItem(R)}close(){return this.a.close()}}e.StateMainService=t}),define(ee[91],te([0,1,4,35,7,31]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(w){if(S.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function I(w,p,b,y,f,d,v,a,u,g){const k=Object.create(null);k["common.machineId"]=v,k.sessionID=(0,R.generateUuid)()+Date.now(),k.commitHash=f,k.version=d,k["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),k["common.platform"]=(0,S.PlatformToString)(S.platform),k["common.nodePlatform"]=t.platform,k["common.nodeArch"]=y,k["common.product"]=g||"desktop",a&&(k["common.msftInternal"]=a);let E=0;const D=Date.now();Object.defineProperties(k,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-D,enumerable:!0},"common.sequence":{get:()=>E++,enumerable:!0}}),S.isLinuxSnap&&(k["common.snap"]="true");const i=M(b);i&&(k["common.platformDetail"]=i);try{const l=await w.readFile(P.URI.file(u));k["common.source"]=l.value.toString().slice(0,30)}catch{}return k}e.resolveCommonProperties=I;function m(w){const p=t.env.USERDNSDOMAIN;if(!p)return!1;const b=p.toLowerCase();return w.some(y=>b===y)}e.verifyMicrosoftInternalDomain=m}),define(ee[24],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,S.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,S.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[234],te([0,1,26,8,43,15,9,4,7,83,23,102,86,16,19,24]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function u(i,l){const n=`${i}::${l.join(":")}`,s=a.get(n);if(s)return s;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,r=new Map,h=2e4;function C(O,B,K,V){const J=B.substring(O.length+1);return t.Promises.withAsyncBody(async re=>{let se;try{se=await p.Promises.readdir(B,{withFileTypes:!0})}catch{re();return}if(V.count>=h){V.count+=se.length,V.maxReached=!0,re();return}let ae=se.length;if(ae===0){re();return}let fe=se;V.count+se.length>h&&(V.maxReached=!0,ae=h-V.count,fe=se.slice(0,ae)),V.count+=se.length;for(const ge of fe)if(ge.isDirectory()){if(K.includes(ge.name)||await C(O,(0,M.join)(B,ge.name),K,V),--ae===0){re();return}}else{const q=ge.name.lastIndexOf(".");if(q>=0){const T=ge.name.substring(q+1);T&&c.set(T,(c.get(T)??0)+1)}for(const T of o)T.relativePathPattern?.test(J)!==!1&&T.filePattern.test(ge.name)&&r.set(T.tag,(r.get(T.tag)??0)+1);if(--ae===0){re();return}}})}const L=t.Promises.withAsyncBody(async O=>{const B={count:0,maxReached:!1};await C(i,i,l,B);const K=await E(i);O({configFiles:g(r),fileTypes:g(c),fileCount:B.count,maxFilesReached:B.maxReached,launchConfigFiles:K})});return a.set(n,L),L}e.collectWorkspaceStats=u;function g(i){return Array.from(i.entries(),([l,n])=>({name:l,count:n})).sort((l,n)=>n.count-l.count)}function k(){const i={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},l=S.cpus();return l&&l.length>0&&(i.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),i}e.getMachineInfo=k;async function E(i){try{const l=new Map,n=(0,M.join)(i,".vscode","launch.json"),s=await p.Promises.readFile(n),o=[],c=(0,P.parse)(s.toString(),o);if(o.length)return console.log(`Unable to parse ${n}`),[];if((0,P.getNodeType)(c)==="object"&&c.configurations)for(const r of c.configurations){const h=r.type;h&&(l.has(h)?l.set(h,l.get(h)+1):l.set(h,1))}return g(l)}catch{return[]}}e.collectLaunchConfigs=E;let D=class{constructor(l,n){this.c=l,this.d=n}f(l){const n=[];return n.push(`OS Version:       ${l.os}`),n.push(`CPUs:             ${l.cpus}`),n.push(`Memory (System):  ${l.memory}`),n.push(`VM:               ${l.vmHint}`),n.join(`
`)}g(l){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const s=S.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(S.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(S.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),I.isWindows||n.push(`Load (avg):       ${S.loadavg().map(o=>Math.round(o)).join(", ")}`),n.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${l.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(l.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(l,n){return Promise.all([(0,b.listProcesses)(l.mainPID),this.k(l)]).then(async s=>{let[o,c]=s,r=this.m(l,o);return n.forEach(h=>{if((0,y.isRemoteDiagnosticError)(h))r+=`
${h.errorMessage}`,c+=`
${h.errorMessage}`;else if(r+=`

Remote: ${h.hostName}`,h.processes&&(r+=`
${this.m(l,h.processes)}`),h.workspaceMetadata){c+=`
|  Remote: ${h.hostName}`;for(const C of Object.keys(h.workspaceMetadata)){const L=h.workspaceMetadata[C];let O=`${L.fileCount} files`;L.maxFilesReached&&(O=`more than ${O}`),c+=`|    Folder (${C}): ${O}`,c+=this.h(L)}}}),{processInfo:r,workspaceInfo:c}})}async getSystemInfo(l,n){const{memory:s,vmHint:o,os:c,cpus:r}=k(),h={os:c,memory:s,cpus:r,vmHint:o,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:n};return I.isWindows||(h.load=`${S.loadavg().map(C=>Math.round(C)).join(", ")}`),I.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(l,n){const s=[];return(0,b.listProcesses)(l.mainPID).then(async o=>(s.push(""),s.push(this.g(l)),s.push(""),s.push(this.m(l,o)),l.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(l))),n.forEach(c=>{if((0,y.isRemoteDiagnosticError)(c))s.push(`
${c.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${c.hostName}`),s.push(this.f(c.machineInfo)),c.processes&&s.push(this.m(l,c.processes)),c.workspaceMetadata)for(const r of Object.keys(c.workspaceMetadata)){const h=c.workspaceMetadata[r];let C=`${h.fileCount} files`;h.maxFilesReached&&(C=`more than ${C}`),s.push(`Folder (${r}): ${C}`),s.push(this.h(h))}}),s.push(""),s.push(""),s.join(`
`)))}h(l){const n=[];let o=0;const c=(L,O)=>{const B=` ${L}(${O})`;o+B.length>60?(n.push(r),r="|                 ",o=r.length):o+=B.length,r+=B};let r="|      File types:";const h=10,C=l.fileTypes.length>h?h:l.fileTypes.length;for(let L=0;L<C;L++){const O=l.fileTypes[L];c(O.name,O.count)}if(n.push(r),l.configFiles.length>=0&&(r="|      Conf files:",o=0,l.configFiles.forEach(L=>{c(L.name,L.count)}),n.push(r)),l.launchConfigFiles.length>0){let L="|      Launch Configs:";l.launchConfigFiles.forEach(O=>{L+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(L)}return n.join(`
`)}j(l){const n=Math.max(...Object.keys(l).map(s=>s.length));return Object.keys(l).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${l[s]}`).join(`
                  `)}k(l){const n=[],s=[];return l.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(n.push(`|  Window (${o.title})`),o.folderURIs.forEach(c=>{const r=m.URI.revive(c);if(r.scheme===R.Schemas.file){const h=r.fsPath;s.push(u(h,["node_modules",".git"]).then(C=>{let L=`${C.fileCount} files`;C.maxFilesReached&&(L=`more than ${L}`),n.push(`|    Folder (${(0,M.basename)(h)}): ${L}`),n.push(this.h(C))}).catch(C=>{n.push(`|      Error: Unable to collect workspace stats for folder ${h} (${C.toString()})`)}))}else n.push(`|    Folder (${r.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(o=>n.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(l,n){const s=new Map;l.windows.forEach(c=>s.set(c.pid,c.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),n&&this.n(l.mainPID,s,o,n,0),o.join(`
`)}n(l,n,s,o,c){const r=c===0;let h;r?h=o.pid===l?`${this.d.applicationName} main`:"remote agent":(h=`${"  ".repeat(c)} ${o.name}`,o.name==="window"&&(h=`${h} (${n.get(o.pid)})`));const C=process.platform==="win32"?o.mem:S.totalmem()*(o.mem/100);s.push(`${o.load.toFixed(0).padStart(5," ")}	${(C/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(o.children)&&o.children.forEach(L=>this.n(l,n,s,L,c+1))}async getWorkspaceFileExtensions(l){const n=new Set;for(const{uri:s}of l.folders){const o=m.URI.revive(s);if(o.scheme!==R.Schemas.file)continue;const c=o.fsPath;try{(await u(c,["node_modules",".git"])).fileTypes.forEach(h=>n.add(h.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(l){for(const{uri:n}of l.folders){const s=m.URI.revive(n);if(s.scheme!==R.Schemas.file)continue;const o=s.fsPath;try{const c=await u(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),c.fileTypes.forEach(r=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:r.name,count:r.count})}),c.launchConfigFiles.forEach(r=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:r.name,count:r.count})}),c.configFiles.forEach(r=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:r.name,count:r.count})})}catch{}}}};D=pe([_(0,v.ITelemetryService),_(1,d.IProductService)],D),e.DiagnosticsService=D}),define(ee[235],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class S{constructor(R){this.b=R}listen(R,M){throw new Error(`Event not found: ${M}`)}call(R,M,{eventName:I,data:m}){return this.b.forEach(w=>w.log(I,m)),Promise.resolve(null)}}e.TelemetryAppenderChannel=S;class t{constructor(R){this.b=R}log(R,M){return this.b.call("log",{eventName:R,data:M}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(ee[51],te([0,1,44,11,3,18,55,91,24]),function(H,e,S,t,P,R,M,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class w{constructor(r){this.value=r}}e.TelemetryTrustedValue=w;class p{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,h){return Promise.resolve(void 0)}publicLog2(r,h){return this.publicLog(r,h)}publicLogError(r,h){return Promise.resolve(void 0)}publicLogError2(r,h){return this.publicLogError(r,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class b{async publicLog(r,h,C){}async publicLogError(r,h,C){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(c,r){return P.Event.debounce(r.onDidChangeConfiguration,(C,L)=>{const O=C?new Set([...C.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:O}},1e3,!0)(C=>{C.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(C.source),configurationKeys:E(C.affectedKeys)})})}e.configurationTelemetry=y;function f(c,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!c.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=f;function d(c,r){return!(r.isBuilt||r.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=d;function v(c){const r=c.getValue(m.TELEMETRY_SETTING_ID),h=c.getValue(m.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(m.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function a(c){const r={},h={},C={};k(c,C);for(let L in C){L=L.length>150?L.substr(L.length-149):L;const O=C[L];typeof O=="number"?h[L]=O:typeof O=="boolean"?h[L]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${O.length}`),r[L]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(r[L]=O)}return{properties:r,measurements:h}}e.validateTelemetryData=a;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(c){if(!c)return"none";const r=(0,M.getRemoteName)(c);return u.has(r)?r:"other"}e.cleanRemoteAuthority=g;function k(c,r,h=0,C){if(!!c)for(const L of Object.getOwnPropertyNames(c)){const O=c[L],B=C?C+L:L;Array.isArray(O)?r[B]=(0,S.safeStringify)(O):O instanceof Date?r[B]=O.toISOString():(0,t.isObject)(O)?h<2?k(O,r,h+1,B+"."):r[B]=(0,S.safeStringify)(O):r[B]=O}}function E(c){if(!c)return[];const r=[];return D(r,"",c),r}function D(c,r,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(C=>D(c,r?`${r}.${C}`:C,h[C])):c.push(r)}function i(c,r){const h=c.msftInternalDomains||[],C=r.getValue("telemetry.internalTesting");return(0,I.verifyMicrosoftInternalDomain)(h)||C}e.isInternalTelemetry=i;function l(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=l;function n(c,r){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let h=c;const C=[];for(const K of r)for(;;){const V=K.exec(c);if(!V)break;C.push([V.index,K.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let B=0;for(h="";;){const K=O.exec(c);if(!K)break;const V=C.some(([J,re])=>K.index<re&&J<O.lastIndex);!L.test(K[0])&&!V&&(h+=c.substring(B,K.index)+"<REDACTED: user-file-path>",B=O.lastIndex)}return B<c.length&&(h+=c.substr(B)),h}function s(c){if(!c)return c;const r=c.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const C of h)if(C.regex.test(r))return`<REDACTED: ${C.label}>`;return c}function o(c,r){return(0,S.cloneAndChange)(c,h=>{if(h instanceof w)return h.value;if(typeof h=="string"){let C=h.replaceAll("%20"," ");C=n(C,r);for(const L of r)C=C.replace(L,"");return C=s(C),C}})}e.cleanData=o}),define(ee[112],te([0,1,27,194,89,4,7,13,35,51]),function(H,e,S,t,P,R,M,I,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,S.compareIgnoreCase)(n.id,s.id)===0}e.areSameExtensions=p;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(s){const o=s.manifest?s.manifest.version:s.version,c=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new y(s.identifier,o,c)}static parse(s){const o=b.exec(s);return o&&o[1]&&o[2]?new y({id:o[1]},o[2],o[4]||void 0):null}constructor(s,o,c="undefined"){this.version=o,this.targetPlatform=c,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof y?p(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=y;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(n){const s=f.exec(n);return s&&s[1]?[a(s[1]),s[2]]:[a(n),void 0]}e.getIdAndVersion=d;function v(n,s){return`${n}.${s}`}e.getExtensionId=v;function a(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function u(n,s){return a(v(n,s))}e.getGalleryExtensionId=u;function g(n,s){const o=[],c=r=>{for(const h of o)if(h.some(C=>p(s(C),s(r))))return h;return null};for(const r of n){const h=c(r);h?h.push(r):o.push([r])}return o}e.groupByExtension=g;function k(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=k;function E(n){return{id:new w.TelemetryTrustedValue(n.identifier.id),name:new w.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function D(n,s){const o=[],c=s.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const r=c.shift();if(r&&o.every(h=>!p(h.identifier,{id:r}))){const h=n.filter(C=>p(C.identifier,{id:r}));h.length===1&&(o.push(h[0]),c.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=D;async function i(n,s){if(!R.isLinux)return!1;let o;try{o=(await n.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await n.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){s.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(r))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function l(n,s){const o=await i(n,s),c=(0,t.getTargetPlatform)(o?"alpine":R.platform,m.arch);return s.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=l}),define(ee[236],te([0,1,191,51]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function P(R,M,I,m,w,p,b){const y={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${M.nameShort})`};if((0,t.supportsTelemetry)(M,I)&&(0,t.getTelemetryLevel)(m)===3){const f=await(0,S.getServiceMachineId)(I,w,p),{machineId:d}=await b.getTelemetryInfo();y["X-Market-User-Id"]=f,y["VSCode-SessionId"]=d||f}return y}e.resolveMarketplaceHeaders=P}),define(ee[237],te([0,1,13,44,51]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",M="https://mobile.events.data.microsoft.com/ping";async function I(w,p,b){const y=await new Promise((u,g)=>{H(["@microsoft/1ds-core-js"],u,g)}),f=await new Promise((u,g)=>{H(["@microsoft/1ds-post-js"],u,g)}),d=new y.AppInsightsCore,v=new f.PostChannel,a={instrumentationKey:w,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(b){a.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:b};a.extensionConfig[v.identifier]=u}return d.initialize(a,[]),d.addTelemetryInitializer(u=>{p&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),d}class m{constructor(p,b,y,f,d){this.e=p,this.f=b,this.g=y,this.h=d,this.c=R,this.d=M,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(p){if(!!this.a){if(typeof this.a!="string"){p(this.a);return}this.b||(this.b=I(this.a,this.e,this.h)),this.b.then(b=>{p(b)},b=>{(0,S.onUnexpectedError)(b),console.error(b)})}}log(p,b){if(!this.a)return;b=(0,t.mixin)(b,this.g),b=(0,P.validateTelemetryData)(b);const y=this.f+"/"+p;try{this.i(f=>{f.pluginVersionString=b?.properties.version??"Unknown",f.track({name:y,baseData:{name:y,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(p=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=m}),define(ee[113],te([0,1,2,44,4,27,170,18,66,64,19,48,24,51]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(u,g,k){this.k=g,this.l=k,this.d={},this.i=new S.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,R.escapeRegExpCharacters)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.escapeRegExpCharacters)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(y.TELEMETRY_SETTING_ID)||E.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||E.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,g){this.d[u]=g}m(){let u=(0,f.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const k=g.usage?3:g.error?2:0;u=Math.min(u,k)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,g=u.sessionID,k=u["common.machineId"],E=u["common.firstSessionDate"],D=u["common.msftInternal"];return{sessionId:g,machineId:k,firstSessionDate:E,msftInternal:D}}dispose(){this.i.dispose()}n(u,g,k){return this.g<g?Promise.resolve(void 0):this.c.then(E=>{k=(0,t.mixin)(k,this.d),k=(0,f.cleanData)(k,this.j),k=(0,t.mixin)(k,E),this.b.forEach(D=>D.log(u,k))},E=>{console.error(E)})}publicLog(u,g){return this.n(u,3,g)}publicLog2(u,g){return this.publicLog(u,g)}publicLogError(u,g){return this.h?this.n(u,2,g):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=pe([_(1,I.IConfigurationService),_(2,p.IProductService)],d),e.TelemetryService=d;function v(){const a=(0,M.localize)(0,null,w.default.nameLong),u=w.default.privacyStatementUrl?(0,M.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,M.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=P.isWeb?"":(0,M.localize)(3,null),k=(0,M.localize)(4,null),E=(0,M.localize)(5,null),D=(0,M.localize)(6,null),i=(0,M.localize)(7,null),l=`
|       | ${k} | ${E} | ${D} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,M.localize)(8,null);return`
${a} ${u} ${g}

&nbsp;

${i}
${l}

&nbsp;

${n}
`}b.Registry.as(m.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,M.localize)(10,null),(0,M.localize)(11,null),(0,M.localize)(12,null),(0,M.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(m.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,M.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,M.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,M.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,M.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[238],te([0,1,287,237]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class P extends t.AbstractOneDataSystemAppender{constructor(M,I,m,w){const p={sendPOST:(b,y)=>{const f={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const d=S.request(b.urlString,f,v=>{v.on("data",function(a){y(v.statusCode??200,v.headers,a.toString())}),v.on("error",function(a){y(0,{})})});d.write(b.data),d.end()}catch{y(0,{})}}};super(M,I,m,w,p)}}e.OneDataSystemAppender=P}),define(ee[239],te([0,1,4,83,24]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function R(M){let I=M.getItem(P.machineIdKey);return(typeof I!="string"||S.isMacintosh&&I==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(I=await(0,t.getMachineId)()),I}e.resolveMachineId=R}),define(ee[114],te([0,1,24,239]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function P(R){const M=await(0,t.resolveMachineId)(R);return R.setItem(S.machineIdKey,M),M}e.resolveMachineId=P}),define(ee[240],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var S;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(S=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===S.HIGH_CONTRAST_DARK||R===S.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function P(R){return R===S.DARK||R===S.HIGH_CONTRAST_DARK}e.isDark=P}),define(ee[241],te([0,1,121,3,2,5,48,240]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var m;(function(a){function u(g){return g&&typeof g=="object"&&typeof g.id=="string"}a.isThemeColor=u})(m=e.ThemeColor||(e.ThemeColor={}));function w(a){return{id:a}}e.themeColorFromId=w;var p;(function(a){function u(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||m.isThemeColor(s.color))}a.isThemeIcon=u;const g=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function k(s){const o=g.exec(s);if(!o)return;const[,c]=o;return{id:c}}a.fromString=k;function E(s){return{id:s}}a.fromId=E;function D(s,o){let c=s.id;const r=c.lastIndexOf("~");return r!==-1&&(c=c.substring(0,r)),o&&(c=`${c}~${o}`),{id:c}}a.modify=D;function i(s){const o=s.id.lastIndexOf("~");if(o!==-1)return s.id.substring(o+1)}a.getModifier=i;function l(s,o){return s.id===o.id&&s.color?.id===o.color?.id}a.isEqual=l;function n(s,o){return{id:s.id,color:o?w(o):void 0}}a.asThemeIcon=n,a.asClassNameArray=S.CSSIcon.asClassNameArray,a.asClassName=S.CSSIcon.asClassName,a.asCSSSelector=S.CSSIcon.asCSSSelector})(p=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function b(a){switch(a){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class y{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,P.toDisposable)(()=>{const g=this.a.indexOf(u);this.a.splice(g,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const f=new y;M.Registry.add(e.Extensions.ThemingContribution,f);function d(a){return f.onColorThemeChange(a)}e.registerThemingParticipant=d;class v extends P.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(g=>this.n(g)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,g){let k=this.h.getColor(u);return k&&g&&(k=g(k,this.h)),k?k.toString():null}}e.Themable=v}),define(ee[67],te([0,1,14,3,2,4,18,5,34]),function(H,e,S,t,P,R,M,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const w="#FFFFFF",p="#1E1E1E",b="#000000",y="#FFFFFF",f="theme",d="themeBackground",v="windowSplash";e.IThemeMainService=(0,I.createDecorator)("themeMainService");let a=class extends P.Disposable{constructor(g,k){super(),this.b=g,this.c=k,this.a=this.B(new t.Emitter),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const g=this.getColorScheme();if(g.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return g.dark?b:y;let k=this.b.getItem(d,null);if(!k)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":k=w;break;case"hc-black":k=b;break;case"hc-light":k=y;break;default:k=p}return R.isMacintosh&&k.toUpperCase()===p&&(k="#171717"),k}saveWindowSplash(g,k){this.b.setItems([{key:f,data:k.baseTheme},{key:d,data:k.colorInfo.background},{key:v,data:k}]),typeof g=="number"&&this.f(g,k)}f(g,k){for(const E of S.BrowserWindow.getAllWindows())if(E.id===g){E.setBackgroundColor(k.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};a=pe([_(0,m.IStateMainService),_(1,M.IConfigurationService)],a),e.ThemeMainService=a}),define(ee[115],te([0,1,3,18,5,6]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,P.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,P.createDecorator)("sharedTunnelsService");var M;(function(v){v.Http="http",v.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var m;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(m=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=p,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=b;function y(v,a,u,g){if(u===1)return!1;if(u===2&&b(a)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(k?.length===4&&parseInt(k[1])>=18)return!1}return v<1024}e.isPortPrivileged=y;class f{constructor(a,u,g){this.remoteAddress=a,this.localAddress=u,this.b=g,this.a=new S.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=f;let d=class{constructor(a,u){this.i=a,this.j=u,this.a=new S.Emitter,this.onTunnelOpened=this.a.event,this.b=new S.Emitter,this.onTunnelClosed=this.b.event,this.c=new S.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const a=this.j.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.e=a,a?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.f=a.elevation,this.g=a.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const a=[],u=Array.from(this.d.values());for(const g of u){const k=Array.from(g.values());for(const E of k){const D=await E.value;D&&a.push(D)}}return a}async dispose(){for(const a of this.d.values()){for(const{value:u}of a.values())await u.then(g=>g?.dispose());a.clear()}this.d.clear()}setEnvironmentTunnel(a,u,g,k,E){this.o(a,u,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:u,localAddress:g,privacy:k,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,u){(b(a)||p(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const g=this.q(a,u);if(g)return++g.refcount,g.value}openTunnel(a,u,g,k,E=!1,D,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${k}.`),!a)return;if(u||(u="localhost"),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.r(a,u,g,k,E,D,i);return l?l.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}m(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const u=this.d.get(a.tunnelRemoteHost);if(u){const g=u.get(a.tunnelRemotePort);g&&(g.refcount--,await this.n(a.tunnelRemoteHost,a.tunnelRemotePort,g))}}}}async n(a,u,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${u}.`);const k=g.value.then(async E=>{E&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.d.has(a)&&this.d.get(a).delete(u),k}}async closeTunnel(a,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${u} `);const g=this.d.get(a);if(g&&g.has(u)){const k=g.get(u);k.refcount=0,await this.n(a,u,k)}}o(a,u,g){this.d.has(a)||this.d.set(a,new Map),this.d.get(a).set(u,{refcount:1,value:g})}async p(a,u){const g=this.d.get(a);g&&(await g.get(u)||g.delete(u),g.size===0&&this.d.delete(a))}q(a,u){const g=[a];p(a)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):b(a)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const k=g.map(E=>this.d.get(E));for(const E of k){const D=E?.get(u);if(D)return D}}canTunnel(a){return!!w(a)}s(a,u,g,k,E,D,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${k}.`);const l=g;this.h.add(l);const n=k===void 0?g:k,s={elevationRequired:E?this.isPortPrivileged(n):!1},o={remoteAddress:{host:u,port:g},localAddressPort:k,privacy:D,public:D?D!==I.Private:void 0,protocol:i},c=a.forwardPort(o,s);return c?(this.o(u,g,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(l)})):this.h.delete(l),c}};d=pe([_(0,R.ILogService),_(1,t.IConfigurationService)],d),e.AbstractTunnelService=d}),define(ee[242],te([0,1,80,26,98,224,8,2,18,6,19,223,115,90,4]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(E,D,i,l,n){let s;for(let o=3;o&&(s?.dispose(),s=await new a(E,D,i,l,n).waitForReady(),!(n&&P.BROWSER_RESTRICTED_PORTS[n]||!P.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));o--);return s}class a extends I.Disposable{constructor(D,i,l,n,s){super(),this.j=i,this.k=s,this.privacy=y.TunnelPrivacyId.Private,this.i=new Map,this.a=D,this.b=S.createServer(),this.c=new M.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const D=this.k??this.tunnelRemotePort,i=(0,y.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let l=await(0,P.findFreePortFaster)(D,2,1e3,i),n=null;return this.b.listen(l,this.j),await this.c.wait(),n=this.b.address(),n||(l=0,this.b.listen(l,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(D){D.pause();const i=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,b.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),n=l.getSocket().socket,s=l.readEntireBuffer();l.dispose(),s.byteLength>0&&D.write(s.buffer),D.on("end",()=>{D.localAddress&&this.i.delete(D.localAddress),n.end()}),D.on("close",()=>n.end()),D.on("error",()=>{D.localAddress&&this.i.delete(D.localAddress),n.destroy()}),n.on("end",()=>D.end()),n.on("close",()=>D.end()),n.on("error",()=>{D.destroy()}),D.pipe(n),n.pipe(D),D.localAddress&&this.i.set(D.localAddress,()=>{D.end(),n.end()})}}let u=class extends y.AbstractTunnelService{constructor(D,i,l,n,s){super(i,s),this.t=D,this.u=l,this.v=n}isPortPrivileged(D){return(0,y.isPortPrivileged)(D,this.k,d.OS,t.release())}r(D,i,l,n,s,o,c){const r=this.q(i,l);if(r)return++r.refcount,r.value;if(this.e)return this.s(this.e,i,l,n,s,o,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${l} on local port ${n}.`);const h={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:D,signService:this.u,logService:this.i,ipcLogger:null},C=v(h,this.k,i,l,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,l,C),C}}};u=pe([_(1,w.ILogService),_(2,f.ISignService),_(3,p.IProductService),_(4,m.IConfigurationService)],u),e.BaseTunnelService=u;let g=class extends u{constructor(D,i,l,n){super(R.nodeSocketFactory,D,i,l,n)}};g=pe([_(0,w.ILogService),_(1,f.ISignService),_(2,p.IProductService),_(3,m.IConfigurationService)],g),e.TunnelService=g;let k=class extends I.Disposable{constructor(D,i,l,n){super(),this.b=D,this.c=i,this.f=l,this.g=n,this.a=new Map}async openTunnel(D,i,l,n,s,o,c,r){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${n} on local port ${s}.`),!this.a.has(D)){const h=new g(this.b,this.f,this.c,this.g);this.B(h),this.a.set(D,h),h.onTunnelClosed(async()=>{(await h.tunnels).length===0&&(h.dispose(),this.a.delete(D))})}return this.a.get(D).openTunnel(i,l,n,s,o,c,r)}};k=pe([_(0,w.ILogService),_(1,p.IProductService),_(2,f.ISignService),_(3,m.IConfigurationService)],k),e.SharedTunnelsService=k}),define(ee[49],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var P;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(P=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,M)=>({type:"idle",updateType:R,error:M}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,S.createDecorator)("updateService")}),define(ee[243],te([0,1,4,171,66,48]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(P.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[244],te([0,1,3,49]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class P{constructor(I){this.a=I}listen(I,m){switch(m){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${m}`)}call(I,m,w){switch(m){case"checkForUpdates":return this.a.checkForUpdates(w);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(w)}throw new Error(`Call not found: ${m}`)}}e.UpdateChannel=P;class R{get state(){return this.b}set state(I){this.b=I,this.a.fire(I)}constructor(I){this.c=I,this.a=new S.Emitter,this.onStateChange=this.a.event,this.b=t.State.Uninitialized,this.c.listen("onStateChange")(m=>this.state=m),this.c.call("_getInitialState").then(m=>this.state=m)}checkForUpdates(I){return this.c.call("checkForUpdates",I)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(I){return this.c.call("_applySpecificUpdate",I)}}e.UpdateChannelClient=R}),define(ee[92],te([0,1,8,22,3,18,28,21,6,19,56,49]),function(H,e,S,t,P,R,M,I,m,w,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(d,v,a){return`${a.updateUrl}/api/update/${d}/${v}/${a.commit}`}e.createUpdateURL=y;let f=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,a,u,g,k,E){this.f=v,this.g=a,this.h=u,this.i=g,this.j=k,this.k=E,this.b=b.State.Uninitialized,this.c=new P.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.l(),a=this.m(v);if(!a){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(a),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(b.State.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,u=>this.j.error(u))}l(){return(0,R.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,S.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(v){}q(){return 1}r(){}};f=pe([_(0,I.ILifecycleMainService),_(1,R.IConfigurationService),_(2,M.IEnvironmentMainService),_(3,p.IRequestService),_(4,m.ILogService),_(5,w.IProductService)],f),e.AbstractUpdateService=f}),define(ee[245],te([0,1,14,54,3,2,18,28,21,6,19,56,24,49,92]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=class extends d.AbstractUpdateService{get v(){return P.Event.fromNodeEventEmitter(S.autoUpdater,"error",(u,g)=>g)}get w(){return P.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return P.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(u,g,k)=>({url:g,version:k,productVersion:k}))}get y(){return P.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(u,g,k,E)=>({releaseNotes:g,version:k,productVersion:k,date:E}))}constructor(u,g,k,E,D,i,l){super(u,g,E,D,i,l),this.z=k,this.u=new R.DisposableStore}async initialize(){await super.initialize(),this.v(this.A,this,this.u),this.x(this.D,this,this.u),this.y(this.E,this,this.u),this.w(this.F,this,this.u)}A(u){this.j.error("UpdateService error:",u);const k=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.d(f.State.Idle(1,k))}s(u){let g;this.k.darwinUniversalAssetId?g=this.k.darwinUniversalAssetId:g=process.arch==="x64"?"darwin":"darwin-arm64";const k=(0,d.createUpdateURL)(g,u,this.k);try{S.autoUpdater.setFeedURL({url:k})}catch(E){this.j.error("Failed to set update feed URL",E);return}return k}t(u){this.d(f.State.CheckingForUpdates(u)),S.autoUpdater.checkForUpdates()}D(u){this.state.type==="checking for updates"&&this.d(f.State.Downloading(u))}E(u){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:u.version}),this.d(f.State.Ready(u)))}F(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([t.memoize],v.prototype,"v",null),pe([t.memoize],v.prototype,"w",null),pe([t.memoize],v.prototype,"x",null),pe([t.memoize],v.prototype,"y",null),v=pe([_(0,m.ILifecycleMainService),_(1,M.IConfigurationService),_(2,y.ITelemetryService),_(3,I.IEnvironmentMainService),_(4,b.IRequestService),_(5,w.ILogService),_(6,p.IProductService)],v),e.DarwinUpdateService=v}),define(ee[246],te([0,1,46,41,8,3,9,28,21,6,24,49]),function(H,e,S,t,P,R,M,I,m,w,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,a,u){if(this.f=v,this.g=u,this.a=b.State.Uninitialized,this.b=new R.Emitter,this.onStateChange=this.b.event,a.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(b.State.Idle(this.k())),this.h(30*1e3).then(void 0,g=>this.g.error(g))}h(v=60*60*1e3){return(0,P.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};y=pe([_(0,m.ILifecycleMainService),_(1,I.IEnvironmentMainService),_(2,w.ILogService)],y);let f=class extends y{constructor(v,a,u,g,k,E){super(u,g,k),this.o=v,this.p=a,this.q=E;const D=(0,t.watch)(M.dirname(this.o)),i=R.Event.fromNodeEventEmitter(D,"change",(o,c)=>c),l=R.Event.filter(i,o=>o==="current"),s=R.Event.debounce(l,(o,c)=>c,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{s.dispose(),D.close()})}m(){this.d(b.State.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(b.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.State.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.State.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise((u,g)=>(0,t.realpath)(`${M.dirname(this.o)}/current`,(k,E)=>k?g(k):u(E))),a=M.basename(v);return this.p!==a}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};f=pe([_(2,m.ILifecycleMainService),_(3,I.IEnvironmentMainService),_(4,w.ILogService),_(5,p.ITelemetryService)],f),e.SnapUpdateService=f}),define(ee[39],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,S.createDecorator)("IUriIdentityService")}),define(ee[247],te([0,1,39,192,16,20,128,3,2]),function(H,e,S,t,P,R,M,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(y){this.uri=y,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let p=class{constructor(y){this.g=y,this.c=new m.DisposableStore,this.f=2**16;const f=new Map,d=v=>{let a=f.get(v.scheme);return a===void 0&&(a=y.hasProvider(v)&&!this.g.hasCapability(v,1024),f.set(v.scheme,a)),a};this.c.add(I.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(v=>{f.delete(v.scheme)})),this.extUri=new R.ExtUri(d),this.d=new M.SkipList((v,a)=>this.extUri.compare(v,a,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,R.normalizePath)(y));const f=this.d.get(y);return f?f.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new w(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((d,v)=>d[1].touch<v[1].touch?1:d[1].touch>v[1].touch?-1:0);w._clock=0,this.d.clear();const f=this.f*.5;for(let d=0;d<f;d++)this.d.set(y[d][0],y[d][1].touch())}};p=pe([_(0,P.IFileService)],p),e.UriIdentityService=p,(0,t.registerSingleton)(S.IUriIdentityService,p,1)}),define(ee[116],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,S.createDecorator)("urlService")}),define(ee[248],te([0,1,7]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(I){this.a=I}listen(I,m){throw new Error(`Event not found: ${m}`)}call(I,m,w){switch(m){case"handleURL":return this.a.handleURL(S.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${m}`)}}e.URLHandlerChannel=t;class P{constructor(I){this.a=I}handleURL(I,m){return this.a.call("handleURL",[I.toJSON(),m])}}e.URLHandlerChannelClient=P;class R{constructor(I){this.a=I}async routeCall(I,m,w,p){if(m!=="handleURL")throw new Error(`Call not found: ${m}`);if(w){const b=S.URI.revive(w);if(b&&b.query){const y=/\bwindowId=(\d+)/.exec(b.query);if(y){const f=y[1],d=new RegExp(`window:${f}`),v=I.connections.find(a=>d.test(a.ctx));if(v)return v}}}return this.a.routeCall(I,m,w,p)}routeEvent(I,m){throw new Error(`Event not found: ${m}`)}}e.URLHandlerRouter=R}),define(ee[249],te([0,1,8,2,7,19]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends t.Disposable{constructor(){super(...arguments),this.a=new Set}open(w,p){const b=[...this.a.values()];return(0,S.first)(b.map(y=>()=>y.handleURL(w,p)),void 0,!1).then(y=>y||!1)}registerHandler(w){return this.a.add(w),(0,t.toDisposable)(()=>this.a.delete(w))}}e.AbstractURLService=M;let I=class extends M{constructor(w){super(),this.b=w}create(w){let{authority:p,path:b,query:y,fragment:f}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&b&&b.indexOf("/")!==0&&(b=`/${b}`),P.URI.from({scheme:this.b.urlProtocol,authority:p,path:b,query:y,fragment:f})}};I=pe([_(0,R.IProductService)],I),e.NativeURLService=I}),define(ee[250],te([0,1,14,8,3,2,4,7]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function m(p){try{return I.URI.parse(p)}catch{return null}}class w{constructor(b,y,f,d,v){if(this.f=y,this.a=[],this.b=0,this.c=R.Disposable.None,this.d=new R.DisposableStore,this.a=b,M.isWindows){const g=d.isBuilt?[]:[`"${d.appRoot}"`];g.push("--open-url","--"),S.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,g)}const a=P.Event.map(P.Event.fromNodeEventEmitter(S.app,"open-url",(g,k)=>({event:g,url:k})),({event:g,url:k})=>(g.preventDefault(),k));this.d.add(a(g=>{const k=m(g);!k||this.f.open(k,{originalUrl:g})})),f.getWindows().filter(g=>g.isReady).length>0?this.g():P.Event.once(f.onDidSignalReadyWindow)(this.g,this,this.d)}async g(){if(this.b++>10)return;const b=[];for(const y of this.a)await this.f.open(y.uri,{originalUrl:y.url})||b.push(y);b.length!==0&&(this.a=b,this.c=(0,t.disposableTimeout)(()=>this.g(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=w}),define(ee[251],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,S.createDecorator)("webviewManagerService")}),define(ee[252],te([0,1,14,2,15,7]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends t.Disposable{constructor(){super();const m=this.b.bind(this);S.protocol.registerFileProtocol(P.Schemas.vscodeWebview,m)}b(m,w){try{const p=R.URI.parse(m.url),b=M.a.get(p.path);if(typeof b=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${b}`,f=P.FileAccess.asFileUri(y);return w({path:decodeURIComponent(f.fsPath),headers:{...P.COI.getHeadersFromQuery(m.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=M,M.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(ee[75],te([0,1,4]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(p){return!!p.workspaceUri}e.isWorkspaceToOpen=t;function P(p){return!!p.folderUri}e.isFolderToOpen=P;function R(p){return!!p.fileUri}e.isFileToOpen=R;function M(p){const b=I(p),y=p.getValue("window.menuBarVisibility");return y==="default"||b==="native"&&y==="compact"||S.isMacintosh&&S.isNative?"classic":y}e.getMenuBarVisibility=M;function I(p){if(S.isWeb)return"custom";const b=p.getValue("window");if(b){if(S.isMacintosh&&b.nativeTabs===!0||S.isMacintosh&&b.nativeFullScreen===!1)return"native";const d=b.titleBarStyle;if(d==="native"||d==="custom")return d}return S.isLinux?"native":"custom"}e.getTitleBarStyle=I;function m(p){if(!S.isWindows||S.isWeb||I(p)==="native")return!1;const b=p.getValue("window.experimental.windowControlsOverlay.enabled");return typeof b=="boolean"?b:!0}e.useWindowControlsOverlay=m;function w(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=w}),define(ee[117],te([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var S;(function(I){I[I.INITIAL=1]="INITIAL",I[I.LOAD=2]="LOAD",I[I.RELOAD=3]="RELOAD"})(S=e.LoadReason||(e.LoadReason={}));var t;(function(I){I[I.CLOSE=1]="CLOSE",I[I.QUIT=2]="QUIT",I[I.RELOAD=3]="RELOAD",I[I.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const P=function(I=1){return{width:1024,height:768,mode:I}};e.defaultWindowState=P;var R;(function(I){I[I.Maximized=0]="Maximized",I[I.Normal=1]="Normal",I[I.Minimized=2]="Minimized",I[I.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var M;(function(I){I[I.UNRESPONSIVE=1]="UNRESPONSIVE",I[I.PROCESS_GONE=2]="PROCESS_GONE",I[I.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(ee[30],te([0,1,5]),function(H,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,S.createDecorator)("windowsMainService");var t;(function(P){P[P.CLI=0]="CLI",P[P.DOCK=1]="DOCK",P[P.MENU=2]="MENU",P[P.DIALOG=3]="DIALOG",P[P.DESKTOP=4]="DESKTOP",P[P.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(ee[253],te([0,1,14,22,3,70,2,31,73,107,6,19,30]),function(H,e,S,t,P,R,M,I,m,w,p,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let d=class extends M.Disposable{constructor(a,u,g,k,E){super(),this.g=a,this.h=u,this.i=g,this.j=k,this.k=E,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=f.Initial,this.f=void 0,this.l()}l(){const a=P.Event.fromNodeEventEmitter(S.app,"login",(u,g,k,E,D)=>({event:u,webContents:g,req:k,authInfo:E,callback:D}));this.B(a(this.m,this))}async m({event:a,authInfo:u,req:g,callback:k}){if(!u.isProxy)return;if(!this.b&&this.c===f.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}a.preventDefault();let E;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),E=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(u);try{E=await this.b}finally{this.b=void 0}}k(E?.username,E?.password)}async n(a){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.p(a);if(u)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(a){this.g.trace("auth#doResolveProxyCredentials - enter",a);const u=String((0,R.hash)({scheme:a.scheme,host:a.host,port:a.port}));let g,k;try{const l=await this.i.getPassword(this.a,u);if(l){const n=JSON.parse(await this.j.decrypt(l));g=n.username,k=n.password}}catch(l){this.g.error(l)}if(this.c!==f.StoredCredentialsUsed&&typeof g=="string"&&typeof k=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=f.StoredCredentialsUsed,{username:g,password:k};const E=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!E){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${E.id} to handle proxy login`);const D={authInfo:a,username:this.f?.username??g,password:this.f?.password??k,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};E.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,D),this.c=f.LoginDialogShown;const i=await new Promise(l=>{const n=async(s,o,c)=>{if(o===D.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${E.id}`),E.win?.webContents.off("ipc-message",n),c){const r={username:c.username,password:c.password};try{if(c.remember){const h=await this.j.encrypt(JSON.stringify(r));await this.i.setPassword(this.a,u,h)}else await this.i.deletePassword(this.a,u)}catch(h){this.g.error(h)}l({username:r.username,password:r.password})}else l(void 0)};E.win?.webContents.on("ipc-message",n)});return this.f=i,i}};d=pe([_(0,p.ILogService),_(1,y.IWindowsMainService),_(2,m.ICredentialsMainService),_(3,w.IEncryptionMainService),_(4,b.IProductService)],d),e.ProxyAuthHandler=d}),define(ee[254],te([0,1,73,6,33,19,30,204]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let m=class extends I.BaseCredentialsMainService{constructor(p,b,y,f){super(p),this.j=b,this.k=y,this.l=f,this.i=d=>{this.l.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new S.InMemoryCredentialsProvider,this.f;const p=await new Promise((b,y)=>{H(["keytar"],b,y)});return await p.findCredentials("test-keytar-loads"),this.f=p,this.f}};m=pe([_(0,t.ILogService),_(1,P.INativeEnvironmentService),_(2,R.IProductService),_(3,M.IWindowsMainService)],m),e.CredentialsNativeMainService=m}),define(ee[255],te([0,1,14,25,4,7,23,18,61,5,6,116,30]),function(H,e,S,t,P,R,M,I,m,w,p,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,w.createDecorator)(e.ID);let f=class{constructor(v,a,u,g){this.a=v,this.b=a,this.c=u,this.d=g}async start(v,a){this.a.trace("Received data from other instance: ",v,a),P.isMacintosh&&S.app.focus({steal:!0});const u=this.e(v);if(u.length){let g=Promise.resolve();if(this.b.getWindowCount()===0){const k=(0,t.firstOrDefault)(await this.b.openEmptyWindow({context:4}));k&&(g=k.ready())}g.then(()=>{for(const{uri:k,url:E}of u)this.c.open(k,{originalUrl:E})})}else return this.f(v,a)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,t.coalesce)(v._urls.map(a=>{try{return{uri:R.URI.parse(a),url:a}}catch{return null}})):[]}async f(v,a){const u=(0,m.isLaunchedFromCli)(a)?0:4;let g=[];const k=v.wait&&v.waitMarkerFilePath?R.URI.file(v.waitMarkerFilePath):void 0,E=v.remote||void 0,D={context:u,cli:v,userEnv:a,waitMarkerFileURI:k,remoteAuthority:E,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,D);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let i=!1;if(v["new-window"]||v["unity-launch"]||D.forceProfile||D.forceTempProfile)i=!0;else if(v["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!P.isMacintosh}if(i)g=await this.b.open({...D,forceNewWindow:!0,forceEmpty:!0});else{const l=this.b.getLastActiveWindow();l?(this.b.openExistingWindow(l,D),g=[l]):g=await this.b.open({...D,forceEmpty:!0})}}else g=await this.b.open({...D,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(k&&g.length===1&&g[0])return Promise.race([g[0].whenClosedOrLoaded,(0,M.whenDeleted)(k.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};f=pe([_(0,p.ILogService),_(1,y.IWindowsMainService),_(2,b.IURLService),_(3,I.IConfigurationService)],f),e.LaunchMainService=f}),define(ee[256],te([0,1,14,2,3,6,257,8,15,99,30,82,24]),function(H,e,S,t,P,R,M,I,m,w,p,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcess=void 0;let f=class Ut extends t.Disposable{constructor(v,a,u){super(),this.n=v,this.p=a,this.r=u,this.b=String(++Ut.a),this.c=this.B(new P.Emitter),this.onStdout=this.c.event,this.f=this.B(new P.Emitter),this.onStderr=this.f.event,this.g=this.B(new P.Emitter),this.onMessage=this.g.event,this.h=this.B(new P.Emitter),this.onExit=this.h.event,this.i=this.B(new P.Emitter),this.onCrash=this.i.event,this.j=void 0,this.k=void 0,this.l=void 0,this.m=!1}s(v,a){let u;switch(this.l?.correlationId?u=`[UtilityProcess id: ${this.l?.correlationId}, type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${v}`:u=`[UtilityProcess type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${v}`,a){case b.default.Error:this.n.error(u);break;case b.default.Warning:this.n.warn(u);break;case b.default.Info:this.n.info(u);break}}t(v){if(!w.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess API from Electron!");if(this.j){this.s("Cannot start utility process because it is already running...",b.default.Error);return}const a=this.p.getWindowById(v.responseWindowId)?.win;if(!a||a.isDestroyed()||a.webContents.isDestroyed()){this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",b.default.Error);return}return a}start(v){const a=this.t(v);if(!a)return;this.l=v;const u=`${this.l.type}-${this.b}`,g=m.FileAccess.asFileUri("bootstrap-fork.js").fsPath,k=[...this.l.args??[],`--type=${this.l.type}`],E=this.l.execArgv,D=this.l.allowLoadingUnsignedLibraries,i="pipe";let l=this.l.env;if(l){l={...l};for(const n of Object.keys(l))l[n]=String(l[n])}this.s("creating new...",b.default.Info),this.j=w.UtilityProcess.fork(g,k,{serviceName:u,env:l,execArgv:E,allowLoadingUnsignedLibraries:D,stdio:i}),this.u(this.j,this.l,u),this.v(this.j,this.l,a)}u(v,a,u){if(v.stdout){const g=new M.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(v.stdout,"data")(k=>this.c.fire(typeof k=="string"?k:g.write(k))))}if(v.stderr){const g=new M.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(v.stderr,"data")(k=>this.f.fire(typeof k=="string"?k:g.write(k))))}this.B(P.Event.fromNodeEventEmitter(v,"message")(g=>this.g.fire(g))),this.B(P.Event.fromNodeEventEmitter(v,"spawn")(()=>{this.k=v.pid,this.s("successfully created",b.default.Info)})),this.B(P.Event.fromNodeEventEmitter(v,"exit")(g=>{this.s(`received exit event with code ${g}`,b.default.Info),this.m=!0,this.h.fire({pid:this.k,code:g,signal:"unknown"})})),this.B(P.Event.fromNodeEventEmitter(S.app,"child-process-gone",(g,k)=>({event:g,details:k}))(({details:g})=>{g.type==="Utility"&&g.name===u&&(this.s(`crashed with code ${g.exitCode} and reason '${g.reason}'`,b.default.Error),this.r.publicLog2("utilityprocesscrash",{type:a.type,reason:g.reason,code:g.exitCode}),this.i.fire({pid:this.k,code:g.exitCode,reason:g.reason}))}))}v(v,a,u){const{port1:g,port2:k}=new S.MessageChannelMain;v.postMessage("null",[k]),u.webContents.postMessage(a.responseChannel,a.responseNonce,[g])}enableInspectPort(){if(typeof this.k!="number")return!1;this.s("enabling inspect port",b.default.Info);const v=process;return typeof v._debugProcess=="function"?(v._debugProcess(this.k),!0):!1}kill(){if(!this.j){this.s("no running process to kill",b.default.Warning);return}this.s("attempting to kill the process...",b.default.Info),this.j.kill()?this.s("successfully killed the process",b.default.Info):this.s("unable to kill the process",b.default.Warning)}async waitForExit(v){if(!this.j){this.s("no running process to wait for exit",b.default.Warning);return}this.m||(this.s("waiting to exit...",b.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,I.timeout)(v)]),this.m||(this.s("did not exit within ${maxWaitTimeMs}ms, will kill it now...",b.default.Info),this.kill()))}};f.a=0,f=pe([_(0,R.ILogService),_(1,p.IWindowsMainService),_(2,y.ITelemetryService)],f),e.UtilityProcess=f}),define(ee[258],te([0,1,13,2,3,6,21,69,46,257,8,15,44,4,35,99,256,30,24]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let k=class Nt{constructor(i,l,n,s){this.d=i,this.f=n,this.g=s,this.c=!1,this.b=new Map,l.onWillShutdown(o=>{this.c=!0,o.join(this._waitForAllExit(6e3))})}dispose(){}h(i){const l=this.b.get(i);if(!l)throw new Error("Unknown extension host!");return l}onDynamicStdout(i){return this.h(i).onStdout}onDynamicStderr(i){return this.h(i).onStderr}onDynamicMessage(i){return this.h(i).onMessage}onDynamicError(i){const l=this.h(i);return l instanceof a.UtilityProcess?P.Event.None:l.onError}onDynamicExit(i){return this.h(i).onExit}async canUseUtilityProcess(){return v.canUseUtilityProcess}async createExtensionHost(i){if(this.c)throw(0,S.canceled)();const l=String(++Nt.a);let n;if(i){if(!v.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess!");n=new a.UtilityProcess(this.d,this.f,this.g)}else n=new E(l,this.d);return this.b.set(l,n),n.onExit(({pid:s,code:o,signal:c})=>{this.d.info(`Extension host with pid ${s} exited with code: ${o}, signal: ${c}.`),setTimeout(()=>{n.dispose(),this.b.delete(l)})}),{id:l}}async start(i,l){if(this.c)throw(0,S.canceled)();return this.h(i).start({...l,type:"extensionHost",args:["--skipWorkspaceStorageLock"],execArgv:l.execArgv??[],allowLoadingUnsignedLibraries:!0,correlationId:i})}async enableInspectPort(i){if(this.c)throw(0,S.canceled)();const l=this.b.get(i);return l?l.enableInspectPort():!1}async kill(i){if(this.c)throw(0,S.canceled)();const l=this.b.get(i);!l||l.kill()}async _killAllNow(){for(const[,i]of this.b)i.kill()}async _waitForAllExit(i){const l=[];for(const[,n]of this.b)l.push(n.waitForExit(i));return p.Promises.settled(l).then(()=>{})}};k.a=0,k=pe([_(0,R.ILogService),_(1,M.ILifecycleMainService),_(2,u.IWindowsMainService),_(3,g.ITelemetryService)],k),e.ExtensionHostStarter=k;let E=class extends t.Disposable{constructor(i,l){super(),this.id=i,this.c=l,this._onStdout=this.B(new P.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new P.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new P.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new P.Emitter),this.onError=this._onError.event,this._onExit=this.B(new P.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(i){f.isCI&&this.c.info("Calling fork to start extension host...");const l=I.StopWatch.create(!1);this.a=(0,m.fork)(b.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,d.cwd)()},i));const n=l.elapsed(),s=this.a.pid;this.c.info(`Starting extension host with pid ${s} (fork() took ${n} ms).`);const o=new w.StringDecoder("utf-8");this.a.stdout?.on("data",r=>{const h=typeof r=="string"?r:o.write(r);this._onStdout.fire(h)});const c=new w.StringDecoder("utf-8");this.a.stderr?.on("data",r=>{const h=typeof r=="string"?r:c.write(r);this._onStderr.fire(h)}),this.a.on("message",r=>{this._onMessage.fire(r)}),this.a.on("error",r=>{this._onError.fire({error:(0,S.transformErrorForSerialization)(r)})}),this.a.on("exit",(r,h)=>{this.b=!0,this._onExit.fire({pid:s,code:r,signal:h})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):f.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(i){if(!this.a)return;const l=this.a.pid;this.c.info(`Waiting for extension host with pid ${l} to exit.`),await Promise.race([P.Event.toPromise(this.onExit),(0,p.timeout)(i)]),this.b||(this.c.info(`Extension host with pid ${l} did not exit within ${i}ms.`),this.a.kill())}};E=pe([_(1,R.ILogService)],E)}),define(ee[259],te([0,1,14,3,2,252,30]),function(H,e,S,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends P.Disposable{constructor(w){super(),this.b=w,this.a=this.B(new t.Emitter),this.onFoundInFrame=this.a.event,this.B(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,p){let b;if(typeof w.windowId=="number"){const{windowId:y}=w,f=this.b.getWindowById(y);if(!f?.win)throw new Error(`Invalid windowId: ${y}`);b=f.win.webContents}else{const{webContentsId:y}=w;if(b=S.webContents.fromId(y),!b)throw new Error(`Invalid webContentsId: ${y}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(p)}async findInFrame(w,p,b,y){const d=this.c(w,p);if(typeof d.findInFrame=="function"){d.findInFrame(b,{findNext:y.findNext,forward:y.forward});const v=(a,u)=>{u.finalUpdate&&(this.a.fire(u),d.removeListener("found-in-frame",v))};d.on("found-in-frame",v)}}async stopFindInFrame(w,p,b){const f=this.c(w,p);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}c(w,p){const b=this.b.getWindowById(w.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${w}`);const y=b.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===p);if(!y)throw new Error(`Unknown frame: ${p}`);return y}};I=pe([_(0,M.IWindowsMainService)],I),e.WebviewMainService=I}),define(ee[260],te([0,1,8,3,2]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends P.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:m,getActiveWindowId:w}){super(),this.a=this.B(new P.DisposableStore),t.Event.latch(t.Event.any(I,m))(this.f,this,this.a),this.b=(0,S.createCancelablePromise)(()=>w()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=R}),define(ee[29],te([0,1,175,9,60,20,7,5,15]),function(H,e,S,t,P,R,M,I,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function w(n){const s=n;return typeof s?.id=="string"&&M.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=w;function p(n){return typeof n?.id=="string"&&!w(n)&&!y(n)}e.isEmptyWorkspaceIdentifier=p,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,t.basename)(n)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=b;function y(n){const s=n;return typeof s?.id=="string"&&M.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=y;function f(n){const s=n;if(s?.uri)return{id:s.id,uri:M.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:M.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=f;var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d=e.WorkbenchState||(e.WorkbenchState={}));function v(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=v;function a(n){const s=n;return!!(s&&typeof s=="object"&&M.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=a;class u{constructor(s,o,c,r,h){this.h=s,this.j=c,this.k=r,this.l=h,this.c=P.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=P.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class g{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,R.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function k(n){return new g({uri:n,index:0,name:(0,R.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=k,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,S.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(n,s){return R.extUriBiasedIgnorePathCase.isEqualOrParent(n,s.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function D(n){let s;return M.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===m.Schemas.tmp}e.isTemporaryWorkspace=D;function i(n,s){return!E(n,s)&&!D(n)}e.isSavedWorkspace=i;function l(n){return(typeof n=="string"?(0,t.extname)(n):(0,R.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=l}),define(ee[57],te([0,1,14,8,70,36,2,78,4,11,23,152,5,6,29]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let v=class{constructor(u){this.d=u,this.a=new Map,this.b=new Map,this.c=new t.Queue}pickFileFolder(u,g){return this.e({...u,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},g)}pickFolder(u,g){return this.e({...u,pickFolders:!0,title:(0,b.localize)(1,null)},g)}pickFile(u,g){return this.e({...u,pickFiles:!0,title:(0,b.localize)(2,null)},g)}pickWorkspace(u,g){const k=(0,b.localize)(3,null),E=(0,R.mnemonicButtonLabel)((0,b.localize)(4,null)),D=d.WORKSPACE_FILTER;return this.e({...u,pickFiles:!0,title:k,filters:D,buttonLabel:E},g)}async e(u,g){const k={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(k.properties=void 0,u.pickFiles&&u.pickFolders&&(k.properties=["multiSelections","openDirectory","openFile","createDirectory"])),k.properties||(k.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),m.isMacintosh&&k.properties.push("treatPackageAsDirectory");const E=await this.showOpenDialog(k,(0,w.withNullAsUndefined)(g||S.BrowserWindow.getFocusedWindow()));if(E&&E.filePaths&&E.filePaths.length>0)return E.filePaths}f(u){if(u){let g=this.b.get(u.id);return g||(g=new t.Queue,this.b.set(u.id,g)),g}else return this.c}showMessageBox(u,g){return this.f(g).queue(async()=>g?S.dialog.showMessageBox(g,u):S.dialog.showMessageBox(u))}async showSaveDialog(u,g){const k=this.i(u,g);if(!k)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(g).queue(async()=>{let E;return g?E=await S.dialog.showSaveDialog(g,u):E=await S.dialog.showSaveDialog(u),E.filePath=this.g(E.filePath),E})}finally{(0,M.dispose)(k)}}g(u){return u&&m.isMacintosh&&(u=(0,I.normalizeNFC)(u)),u}h(u){return u.map(g=>this.g(g))}async showOpenDialog(u,g){u.defaultPath&&(await p.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const k=this.i(u,g);if(!k)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(g).queue(async()=>{let E;return g?E=await S.dialog.showOpenDialog(g,u):E=await S.dialog.showOpenDialog(u),E.filePaths=this.h(E.filePaths),E})}finally{(0,M.dispose)(k)}}i(u,g){if(!g)return M.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let k=this.a.get(g.id);k||(k=new Set,this.a.set(g.id,k));const E=(0,P.hash)(u);if(!k.has(E))return this.d.trace("[DialogMainService]: new file dialog lock created",u),k.add(E),(0,M.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),k?.delete(E),k?.size===0&&this.a.delete(g.id)})}};v=pe([_(0,f.ILogService)],v),e.DialogMainService=v}),define(ee[261],te([0,1,3,2,71,29]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends t.Disposable{constructor(m,w){super(),this.f=m,this.g=w,this.b=this.B(new S.Emitter),this.c=new Map,this.h(w.applicationStorage,this.b)}h(m,w){this.B(S.Event.debounce(m.onDidChangeStorage,(p,b)=>(p?p.push(b):p=[b],p),M.a)(p=>{p.length&&w.fire(this.i(p,m))}))}i(m,w){const p=new Map,b=new Set;return m.forEach(y=>{const f=w.get(y.key);typeof f=="string"?p.set(y.key,f):b.add(y.key)}),{changed:Array.from(p.entries()),deleted:Array.from(b.values())}}listen(m,w,p){switch(w){case"onDidChangeStorage":{const b=p.profile?(0,P.revive)(p.profile):void 0;if(!b)return this.b.event;let y=this.c.get(b.id);return y||(y=this.B(new S.Emitter),this.h(this.g.profileStorage(b),y),this.c.set(b.id,y)),y.event}}throw new Error(`Event not found: ${w}`)}async call(m,w,p){const b=p.profile?(0,P.revive)(p.profile):void 0,y=(0,R.reviveIdentifier)(p.workspace),f=await this.j(b,y);switch(w){case"getItems":return Array.from(f.items.entries());case"updateItems":{const d=p;if(d.insert)for(const[v,a]of d.insert)f.set(v,a);d.delete?.forEach(v=>f.delete(v));break}case"isUsed":{const d=p.payload;if(typeof d=="string")return this.g.isUsed(d)}default:throw new Error(`Call not found: ${w}`)}}async j(m,w){let p;w?p=this.g.workspaceStorage(w):m?p=this.g.profileStorage(m):p=this.g.applicationStorage;try{await p.init()}catch(b){this.f.error(`StorageIPC#init: Unable to init ${w?"workspace":m?"profile":"application"} storage due to ${b}`)}return p}}e.StorageDatabaseChannel=M,M.a=100}),define(ee[37],te([0,1,70,3,2,20,7,172,33,16,5,6,29,40,39,8,31,27,11]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function k(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&M.URI.isUri(s.location)&&M.URI.isUri(s.globalStorageHome)&&M.URI.isUri(s.settingsResource)&&M.URI.isUri(s.keybindingsResource)&&M.URI.isUri(s.tasksResource)&&M.URI.isUri(s.snippetsHome)&&M.URI.isUri(s.extensionsResource))}e.isUserDataProfile=k,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,p.createDecorator)("IUserDataProfilesService");function E(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:M.URI.revive(n.location).with({scheme:s}),globalStorageHome:M.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:M.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:M.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:M.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:M.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:M.URI.revive(n.extensionsResource)?.with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=E;function D(n,s,o,c){return{id:n,name:s,location:o,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,R.joinPath)(o,"globalStorage"),settingsResource:(0,R.joinPath)(o,"settings.json"),keybindingsResource:(0,R.joinPath)(o,"keybindings.json"),tasksResource:(0,R.joinPath)(o,"tasks.json"),snippetsHome:(0,R.joinPath)(o,"snippets"),extensionsResource:(0,R.joinPath)(o,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=D;let i=class extends P.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(s,o,c,r){super(),this.m=s,this.n=o,this.r=c,this.s=r,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(s){this.f!==s&&(this.t=void 0,this.f=s)}isEnabled(){return this.f}get u(){if(!this.t){const s=[];if(this.f)for(const h of this.G()){if(!h.name||!(0,g.isString)(h.name)||!h.location){this.s.warn("Skipping the invalid stored profile",h.location||h.name);continue}s.push(D((0,R.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}const o=new f.ResourceMap,c=new Map,r=D((0,S.hash)(this.m.userRoamingDataHome.path).toString(16),(0,I.localize)(0,null),this.m.userRoamingDataHome);if(s.unshift({...r,extensionsResource:this.L()??r.extensionsResource,isDefault:!0}),s.length){const h=this.I();if(h.workspaces)for(const[C,L]of Object.entries(h.workspaces)){const O=M.URI.parse(C),B=M.URI.parse(L),K=s.find(V=>this.r.extUri.isEqual(V.location,B));K&&o.set(O,K)}if(h.emptyWindows)for(const[C,L]of Object.entries(h.emptyWindows)){const O=M.URI.parse(L),B=s.find(K=>this.r.extUri.isEqual(K.location,O));B&&c.set(C,B)}}this.t={profiles:s,workspaces:o,emptyWindows:c}}return this.t}async createTransientProfile(s){const o="Temp",c=new RegExp(`${(0,u.escapeRegExpCharacters)(o)}\\s(\\d+)`);let r=0;for(const C of this.profiles){const L=c.exec(C.name),O=L?parseInt(L[1]):0;r=O>r?O:r}const h=`${o} ${r+1}`;return this.createProfile((0,S.hash)((0,a.generateUuid)()).toString(16),h,{transient:!0},s)}async createNamedProfile(s,o,c){return this.createProfile((0,S.hash)((0,a.generateUuid)()).toString(16),s,o,c)}async createProfile(s,o,c,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const h=await this.v(s,o,c);return r&&await this.setProfileForWorkspace(r,h),h}async v(s,o,c){if(!(0,g.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let r=this.k.get(o);return r||(r=(async()=>{try{const h=this.profiles.find(O=>O.name===o||O.id===s);if(h)return h;const C=D(s,o,(0,R.joinPath)(this.profilesHome,s),c);await this.n.createFolder(C.location);const L=[];return this.h.fire({profile:C,join(O){L.push(O)}}),await v.Promises.settled(L),this.z([C],[],[]),C}finally{this.k.delete(o)}})(),this.k.set(o,r)),r}async updateProfile(s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(r=>r.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);return c=D(c.id,o.name??c.name,c.location,{shortName:o.shortName??c.shortName,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags}),this.z([],[],[c]),c}async removeProfile(s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(r=>r.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const c=[];this.i.fire({profile:o,join(r){c.push(r)}});try{await Promise.allSettled(c)}catch(r){this.s.error(r)}for(const r of[...this.u.emptyWindows.keys()])o.id===this.u.emptyWindows.get(r)?.id&&this.u.emptyWindows.delete(r);for(const r of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(r)?.id&&this.u.workspaces.delete(r);this.F(),this.z([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(r){this.s.error(r)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(r=>r.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.D(s,c)}unsetWorkspace(s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(s,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const s=await this.n.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.l.profiles.filter(o=>!this.y(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.w(s);return M.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindows.get(o)??this.u.emptyWindows.get(o)}w(s){return(0,y.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,y.isWorkspaceIdentifier)(s)?s.configPath:s.id}y(s){return!!([...this.l.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.u.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,s.location)))}z(s,o,c){const r=[...this.profiles,...s],h=[];this.l.profiles=[];for(let C of r)C.isDefault||o.some(L=>C.id===L.id)||(C=c.find(L=>C.id===L.id)??C,C.isTransient?this.l.profiles.push(C):h.push({location:C.location,name:C.name,shortName:C.shortName,useDefaultFlags:C.useDefaultFlags}));this.H(h),this.t=void 0,this.C(s,o,c)}C(s,o,c){this.g.fire({added:s,removed:o,updated:c,all:this.profiles})}D(s,o,c){c=o?.isTransient?!0:c,c||this.D(s,void 0,!0);const r=this.w(s),h=c?this.l:this.u;M.URI.isUri(r)?(h.workspaces.delete(r),o&&h.workspaces.set(r,o)):(h.emptyWindows.delete(r),o&&h.emptyWindows.set(r,o)),c||this.F()}F(){const s={};for(const[c,r]of this.u.workspaces.entries())s[c.toString()]=r.location.toString();const o={};for(const[c,r]of this.u.emptyWindows.entries())o[c.toString()]=r.location.toString();this.J({workspaces:s,emptyWindows:o}),this.t=void 0}G(){return[]}H(s){throw new Error("not implemented")}I(){return{}}J(s){throw new Error("not implemented")}L(){}};i.b="userDataProfiles",i.c="profileAssociations",i=pe([_(0,m.IEnvironmentService),_(1,w.IFileService),_(2,d.IUriIdentityService),_(3,b.ILogService)],i),e.UserDataProfilesService=i;class l extends i{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(s){this.a=s}I(){return this.O}J(s){this.O=s}}e.InMemoryUserDataProfilesService=l}),define(ee[76],te([0,1,8,17,2,3,40,7,112,89,16,5,6,37,39,11,13,24]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class k extends Error{constructor(n,s){super(n),this.code=s}}e.ExtensionsProfileScanningError=k,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let E=class extends P.Disposable{constructor(n,s,o,c,r,h){super(),this.h=n,this.i=s,this.j=o,this.k=c,this.l=r,this.m=h,this.a=this.B(new R.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new R.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new R.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new R.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new M.ResourceMap}scanProfileExtensions(n,s){return this.n(n,void 0,s)}async addExtensionsToProfile(n,s){const o=[],c=[];try{return await this.n(s,r=>{const h=[];for(const C of r)n.some(([L])=>(0,m.areSameExtensions)(L.identifier,C.identifier)&&L.manifest.version!==C.version)?o.push(C):h.push(C);for(const[C,L]of n)if(!h.some(O=>(0,m.areSameExtensions)(O.identifier,C.identifier)&&O.version===C.manifest.version)){const O={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:L};c.push(O),h.push(O)}return c.length&&this.a.fire({extensions:c,profileLocation:s}),o.length&&this.c.fire({extensions:o,profileLocation:s}),h}),c.length&&this.b.fire({extensions:c,profileLocation:s}),o.length&&this.f.fire({extensions:o,profileLocation:s}),c}catch(r){throw c.length&&this.b.fire({extensions:c,error:r,profileLocation:s}),o.length&&this.f.fire({extensions:o,error:r,profileLocation:s}),r}}async removeExtensionFromProfile(n,s){const o=[];this.c.fire({extensions:o,profileLocation:s});try{await this.n(s,c=>{const r=[];for(const h of c)(0,m.areSameExtensions)(h.identifier,n.identifier)?o.push(h):r.push(h);return o.length&&this.c.fire({extensions:o,profileLocation:s}),r}),o.length&&this.f.fire({extensions:o,profileLocation:s})}catch(c){throw o.length&&this.f.fire({extensions:o,error:c,profileLocation:s}),c}}async n(n,s,o){return this.v(n).queue(async()=>{let c=[],r;try{const h=await this.i.readFile(n);r=JSON.parse(h.value.toString())}catch(h){if((0,p.toFileOperationResult)(h)!==1)throw h;if(this.k.extUri.isEqual(n,this.j.defaultProfile.extensionsResource)&&(r=await this.u()),!r&&o?.bailOutWhenFileNotFound)throw new k((0,a.getErrorMessage)(h),"ERROR_PROFILE_NOT_FOUND")}if(r){Array.isArray(r)||this.p(n);let h=!1;for(const C of r){D(C)||this.p(n);let L;if((0,v.isString)(C.location))L=this.s(C.location);else{L=I.URI.revive(C.location);const O=this.r(L);O&&(h=!0,C.location=O)}c.push({identifier:C.identifier,location:L,version:C.version,metadata:C.metadata})}h&&await this.i.writeFile(n,t.VSBuffer.fromString(JSON.stringify(r)))}if(s){c=s(c);const h=c.map(C=>({identifier:C.identifier,version:C.version,location:this.r(C.location)??C.location.toJSON(),metadata:C.metadata}));await this.i.writeFile(n,t.VSBuffer.fromString(JSON.stringify(h)))}return c})}p(n){const s=new k(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}r(n){return this.k.extUri.isEqualOrParent(n,this.h)?this.k.extUri.relativePath(this.h,n):void 0}s(n){return this.k.extUri.joinPath(this.h,n)}async u(){return this.t||(this.t=(async()=>{const n=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let s;try{s=(await this.i.readFile(n)).value.toString()}catch(c){if((0,p.toFileOperationResult)(c)===1)return;throw c}this.m.info("Migrating extensions from old default profile location",n.toString());let o;try{const c=JSON.parse(s);Array.isArray(c)&&c.every(r=>D(r))?o=c:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.m.error(c)}if(o)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",n.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(c){if((0,p.toFileOperationResult)(c)===3)this.m.info("Migration from old default profile location to new location is done by another window",n.toString(),this.j.defaultProfile.extensionsResource.toString());else throw c}try{await this.i.del(n)}catch(c){(0,p.toFileOperationResult)(c)!==1&&this.m.error(c)}return o})()),this.t}v(n){let s=this.g.get(n);return s||(s=new S.Queue,this.g.set(n,s)),s}};E=pe([_(1,p.IFileService),_(2,f.IUserDataProfilesService),_(3,d.IUriIdentityService),_(4,u.ITelemetryService),_(5,y.ILogService)],E),e.AbstractExtensionsProfileScannerService=E;function D(l){return(0,v.isObject)(l)&&(0,w.isIExtensionIdentifier)(l.identifier)&&(i(l.location)||(0,v.isString)(l.location))&&l.version&&(0,v.isString)(l.version)}function i(l){return l?(0,v.isString)(l.path)&&(0,v.isString)(l.scheme):!1}}),define(ee[118],te([0,1,25,8,44,17,13,43,138,2,15,9,4,20,190,82,11,7,157,33,112,89,189,16,5,6,19,3,71,76,37,39,187,188]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k,E,D,i,l,n,s,o,c,r,h,C,L,O,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var K;(function(ge){function q(T,U){if(T===U)return!0;const z=Object.keys(T),Q=new Set;for(const ne of Object.keys(U))Q.add(ne);if(z.length!==Q.size)return!1;for(const ne of z){if(T[ne]!==U[ne])return!1;Q.delete(ne)}return Q.size===0}ge.equals=q})(K=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let V=class extends w.Disposable{constructor(q,T,U,z,Q,ne,x,A,F,W,N,$){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=T,this.l=U,this.m=z,this.n=Q,this.p=ne,this.r=x,this.s=A,this.t=F,this.u=W,this.v=N,this.w=$,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(se,(0,f.joinPath)(this.m,D.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(se,(0,f.joinPath)(this.m,D.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(re,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,E.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(q,T,U){const[z,Q]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(T)]),ne=U?await this.scanExtensionsUnderDevelopment(q,[...z,...Q]):[];return this.F(z,Q,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const T=[];T.push(this.G(!!q.useCache,q.language)),T.push(this.H(q.language,!!q.checkControlFile));const[U,z]=await Promise.all(T);return this.D([...U,...z],0,q,!1)}async scanUserExtensions(q){const T=q.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",T);const U=this.v.extUri.isEqual(q.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.J(T,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,U),Q=q.useCache&&!z.devMode&&z.excludeObsolete?this.j:this.k;let ne;try{ne=await Q.scanExtensions(z)}catch(x){if(x instanceof h.ExtensionsProfileScanningError&&x.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),ne=await Q.scanExtensions(z);else throw x}return ne=await this.D(ne,1,q,!0),this.s.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(q,T){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===p.Schemas.file).map(async z=>{const Q=await this.J(z,!1,1,!0,q.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Q)).map(x=>(x.type=T.find(A=>(0,E.areSameExtensions)(A.identifier,x.identifier))?.type??x.type,this.k.validate(x,Q)))}))).flat();return this.D(U,"development",q,!0)}return[]}async scanExistingExtension(q,T,U){const z=await this.J(q,!1,T,!0,U.language,!0,void 0),Q=await this.k.scanExtension(z);return!Q||!U.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions(q,T,U){const z=await this.J(q,!1,T,!0,U.language,!0,void 0),Q=await this.k.scanOneOrMultipleExtensions(z);return this.D(Q,T,U,!0)}async scanMetadata(q){const T=(0,f.joinPath)(q,"package.json"),U=(await this.r.readFile(T)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(q,T){const U=(0,f.joinPath)(q,"package.json"),z=(await this.r.readFile(U)).value.toString(),Q=JSON.parse(z);T.isMachineScoped=T.isMachineScoped||void 0,T.isBuiltin=T.isBuiltin||void 0,T.installedTimestamp=T.installedTimestamp||void 0,Q.__metadata={...Q.__metadata,...T},await this.r.writeFile((0,f.joinPath)(q,"package.json"),R.VSBuffer.fromString(JSON.stringify(Q,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof h.ExtensionsProfileScanningError&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw q}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.p.addExtensionsToProfile(q.map(T=>[T,T.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify([])))}catch(T){(0,l.toFileOperationResult)(T)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,M.getErrorMessage)(T))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.s.error(q)}finally{this.z=void 0}})()),this.z}async D(q,T,U,z){return U.includeAllVersions||(q=this.F(T===0?q:void 0,T===1?q:void 0,T==="development"?q:void 0,await this.getTargetPlatform(),z)),U.includeInvalid||(q=q.filter(Q=>Q.isValid)),q.sort((Q,ne)=>{const x=b.basename(Q.location.fsPath),A=b.basename(ne.location.fsPath);return x<A?-1:x>A?1:0})}F(q,T,U,z,Q){const ne=(A,F,W)=>{if(A.isValid&&!F.isValid)return!1;if(A.isValid===F.isValid){if(Q&&d.gt(A.manifest.version,F.manifest.version))return this.s.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${A.location.path} with version ${A.manifest.version}`),!1;if(d.eq(A.manifest.version,F.manifest.version)){if(A.type===0)return this.s.debug(`Skipping extension ${F.location.path} in favour of system extension ${A.location.path} with same version`),!1;if(A.targetPlatform===z)return this.s.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${A.location.path} with ${F.location.path}.`):this.s.debug(`Overwriting user extension ${A.location.path} with ${F.location.path}.`),!0},x=new Map;return q?.forEach(A=>{const F=D.ExtensionIdentifier.toKey(A.identifier.id),W=x.get(F);(!W||ne(W,A,!1))&&x.set(F,A)}),T?.forEach(A=>{const F=D.ExtensionIdentifier.toKey(A.identifier.id),W=x.get(F);if(!W&&q&&A.type===0){this.s.debug(`Skipping obsolete system extension ${A.location.path}.`);return}(!W||ne(W,A,!1))&&x.set(F,A)}),U?.forEach(A=>{const F=D.ExtensionIdentifier.toKey(A.identifier.id),W=x.get(F);(!W||ne(W,A,!0))&&x.set(F,A),x.set(F,A)}),[...x.values()]}async G(q,T){this.s.trace("Started scanning system extensions");const U=await this.J(this.systemExtensionsLocation,!1,0,!0,T,!0,void 0),Q=await(q&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",Q.length),Q}async H(q,T){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const z=T?await this.I():{},Q=[],ne=u.URI.file(b.normalize(b.join(p.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const A of U){const F=z[A.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":Q.push((0,f.joinPath)(ne,A.name));break;default:Q.push(u.URI.file(F));break}}const x=await Promise.all(Q.map(async A=>this.k.scanExtension(await this.J(A,!1,0,!0,q,!0,void 0))));return this.s.trace("Scanned dev system extensions:",x.length),(0,S.coalesce)(x)}async I(){try{const q=await this.r.readFile(this.l);return JSON.parse(q.value.toString())}catch{return{}}}async J(q,T,U,z,Q,ne,x){const A=await this.f(Q??y.language),F=await this.L(q),W=T&&!this.v.extUri.isEqual(q,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,N=W?await this.L(W):void 0;return new J(q,F,W,N,T,x,U,z,ne,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Q,A)}async L(q){try{const T=await this.r.stat(q);if(typeof T.mtime=="number")return T.mtime}catch{}}};V=pe([_(4,C.IUserDataProfilesService),_(5,h.IExtensionsProfileScannerService),_(6,l.IFileService),_(7,s.ILogService),_(8,k.IEnvironmentService),_(9,o.IProductService),_(10,L.IUriIdentityService),_(11,n.IInstantiationService)],V),e.AbstractExtensionsScannerService=V;class J{constructor(q,T,U,z,Q,ne,x,A,F,W,N,$,G,j,X){this.location=q,this.mtime=T,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=z,this.profile=Q,this.profileScanOptions=ne,this.type=x,this.excludeObsolete=A,this.validate=F,this.productVersion=W,this.productDate=N,this.productCommit=$,this.devMode=G,this.language=j,this.translations=X}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,T){return(0,f.isEqual)(q.location,T.location)&&q.mtime===T.mtime&&(0,f.isEqual)(q.applicationExtensionslocation,T.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===T.applicationExtensionslocationMtime&&q.profile===T.profile&&P.equals(q.profileScanOptions,T.profileScanOptions)&&q.type===T.type&&q.excludeObsolete===T.excludeObsolete&&q.validate===T.validate&&q.productVersion===T.productVersion&&q.productDate===T.productDate&&q.productCommit===T.productCommit&&q.devMode===T.devMode&&q.language===T.language&&K.equals(q.translations,T.translations)}}e.ExtensionScannerInput=J;let re=class extends w.Disposable{constructor(q,T,U,z,Q){super(),this.f=q,this.g=T,this.h=U,this.i=z,this.j=Q}async scanExtensions(q){const T=q.profile?await this.l(q):await this.k(q);let U={};if(q.excludeObsolete&&q.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(z)}catch{}return(0,a.isEmptyObject)(U)?T:T.filter(z=>!U[E.ExtensionKey.create(z).toString()])}async k(q){const T=await this.i.resolve(q.location);if(!T.children?.length)return[];const U=await Promise.all(T.children.map(async z=>{if(!z.isDirectory||q.type===1&&(0,f.basename)(z.resource).indexOf(".")===0)return null;const Q=new J(z.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(Q)}));return(0,S.coalesce)(U).sort((z,Q)=>z.location.path<Q.location.path?-1:1)}async l(q){let T=await this.m(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){T=T.filter(z=>!z.metadata?.isApplicationScoped);const U=await this.m(q.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,q);T.push(...U)}return T}async m(q,T,U){const z=await this.g.scanProfileExtensions(q,U.profileScanOptions);if(!z.length)return[];const Q=await Promise.all(z.map(async ne=>{if(T(ne)){const x=new J(ne.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(x,ne.metadata)}return null}));return(0,S.coalesce)(Q)}async scanOneOrMultipleExtensions(q){try{if(await this.i.exists((0,f.joinPath)(q.location,"package.json"))){const T=await this.scanExtension(q);return T?[T]:[]}else return await this.scanExtensions(q)}catch(T){return this.j.error(`Error scanning extensions at ${q.location.path}:`,(0,M.getErrorMessage)(T)),[]}}async scanExtension(q,T){try{let U=await this.scanExtensionManifest(q.location);if(U){U.publisher||(U.publisher=D.UNDEFINED_PUBLISHER),T=T??U.__metadata,delete U.__metadata;const z=(0,E.getGalleryExtensionId)(U.publisher,U.name),Q=T?.id?{id:z,uuid:T.id}:{id:z},ne=T?.isSystem?0:q.type,x=ne===0||!!T?.isBuiltin;B.ImplicitActivationEvents.updateManifest(U),U=await this.n(q.location,U,J.createNlsConfiguration(q));const A={type:ne,identifier:Q,manifest:U,location:q.location,isBuiltin:x,targetPlatform:T?.targetPlatform??"undefined",metadata:T,isValid:!0,validations:[]};return q.validate?this.validate(A,q):A}}catch(U){q.type!==0&&this.j.error(U)}return null}validate(q,T){let U=!0;const z=(0,i.validateExtensionManifest)(T.productVersion,T.productDate,T.location,q.manifest,q.isBuiltin);for(const[Q,ne]of z)Q===v.default.Error&&(U=!1,this.j.error(this.t(T.location,ne)));return q.isValid=U,q.validations=z,q}async scanExtensionManifest(q){const T=(0,f.joinPath)(q,"package.json");let U;try{U=(await this.i.readFile(T)).value.toString()}catch(Q){return(0,l.toFileOperationResult)(Q)!==1&&this.j.error(this.t(q,(0,g.localize)(0,null,T.path,Q.message))),null}let z;try{z=JSON.parse(U)}catch{const ne=[];(0,I.parse)(U,ne);for(const x of ne)this.j.error(this.t(q,(0,g.localize)(1,null,T.path,x.offset,x.length,(0,m.getParseErrorMessage)(x.error))));return null}return(0,I.getNodeType)(z)!=="object"?(this.j.error(this.t(q,(0,g.localize)(2,null,T.path))),null):z}async n(q,T,U){const z=await this.p(q,T,U);if(z)try{const Q=[],ne=await this.r(z.default,Q);if(Q.length>0)return Q.forEach(A=>{this.j.error(this.t(q,(0,g.localize)(3,null,z.default?.path,(0,m.getParseErrorMessage)(A.error))))}),T;if((0,I.getNodeType)(z)!=="object")return this.j.error(this.t(q,(0,g.localize)(4,null,z.default?.path))),T;const x=z.values||Object.create(null);return(0,O.localizeManifest)(T,x,ne)}catch{}return T}async p(q,T,U){const z=(0,f.joinPath)(q,"package.nls.json"),Q=(F,W)=>{W.forEach(N=>{this.j.error(this.t(q,(0,g.localize)(5,null,F?.path,(0,m.getParseErrorMessage)(N.error))))})},ne=F=>{this.j.error(this.t(q,(0,g.localize)(6,null,F?.path)))},x=`${T.publisher}.${T.name}`,A=U.translations[x];if(A)try{const F=u.URI.file(A),W=(await this.i.readFile(F)).value.toString(),N=[],$=(0,I.parse)(W,N);return N.length>0?(Q(F,N),{values:void 0,default:z}):(0,I.getNodeType)($)!=="object"?(ne(F),{values:void 0,default:z}):{values:$.contents?$.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let W;try{W=await this.s(q,U)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const N=(await this.i.readFile(W.localized)).value.toString(),$=[],G=(0,I.parse)(N,$);return $.length>0?(Q(W.localized,$),{values:void 0,default:W.original}):(0,I.getNodeType)(G)!=="object"?(ne(W.localized),{values:void 0,default:W.original}):{values:G,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(q,T){if(q)try{const U=(await this.i.readFile(q)).value.toString();return(0,I.parse)(U,T)}catch{}}s(q,T){return new Promise((U,z)=>{const Q=ne=>{const x=(0,f.joinPath)(q,`package.nls.${ne}.json`);this.i.exists(x).then(A=>{A&&U({localized:x,original:(0,f.joinPath)(q,"package.nls.json")});const F=ne.lastIndexOf("-");F===-1?U({localized:(0,f.joinPath)(q,"package.nls.json"),original:null}):(ne=ne.substring(0,F),Q(ne))})};if(T.devMode||T.pseudo||!T.language)return U({localized:(0,f.joinPath)(q,"package.nls.json"),original:null});Q(T.language)})}t(q,T){return`[${q.path}]: ${T}`}};re=pe([_(1,h.IExtensionsProfileScannerService),_(2,L.IUriIdentityService),_(3,l.IFileService),_(4,s.ILogService)],re);let se=class extends re{constructor(q,T,U,z,Q,ne){super(T,U,z,Q,ne),this.y=q,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(q){const T=await this.z();if(this.u=q,T&&T.input&&J.equals(T.input,this.u))return this.j.debug("Using cached extensions scan result",q.location.toString()),this.v.trigger(()=>this.D()),T.result.map(z=>(z.location=u.URI.revive(z.location),z));const U=await super.scanExtensions(q);return await this.C({input:q,result:U}),U}async z(){try{const q=await this.i.readFile(this.y),T=JSON.parse(q.value.toString());return{result:T.result,input:(0,r.revive)(T.input)}}catch(q){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,M.getErrorMessage)(q))}return null}async C(q){try{await this.i.writeFile(this.y,R.VSBuffer.fromString(JSON.stringify(q)))}catch(T){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,M.getErrorMessage)(T))}}async D(){if(!this.u)return;const q=await this.z();if(!q)return;const T=q.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!P.equals(U,T))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};se=pe([_(2,h.IExtensionsProfileScannerService),_(3,L.IUriIdentityService),_(4,l.IFileService),_(5,s.ILogService)],se);function ae(ge,q){const T=(0,E.getExtensionId)(ge.manifest.publisher,ge.manifest.name);return{id:T,identifier:new D.ExtensionIdentifier(T),isBuiltin:ge.type===0,isUserBuiltin:ge.type===1&&ge.isBuiltin,isUnderDevelopment:q,extensionLocation:ge.location,uuid:ge.identifier.uuid,targetPlatform:ge.targetPlatform,...ge.manifest}}e.toExtensionDescription=ae;class fe extends V{constructor(q,T,U,z,Q,ne,x,A,F,W,N,$){super(q,T,(0,f.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,f.joinPath)(z,D.MANIFEST_CACHE_FOLDER),Q,ne,x,A,F,W,N,$),this.M=(async()=>{if(y.translationsConfigFile)try{const G=await this.r.readFile(u.URI.file(y.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(q){return this.M}}e.NativeExtensionsScannerService=fe}),define(ee[262],te([0,1,6,37,39,24,76,16,33,7]),function(H,e,S,t,P,R,M,I,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let p=class extends M.AbstractExtensionsProfileScannerService{constructor(y,f,d,v,a,u){super(w.URI.file(y.extensionsPath),f,d,v,a,u)}};p=pe([_(0,m.INativeEnvironmentService),_(1,I.IFileService),_(2,t.IUserDataProfilesService),_(3,P.IUriIdentityService),_(4,R.ITelemetryService),_(5,S.ILogService)],p),e.ExtensionsProfileScannerService=p}),define(ee[263],te([0,1,7,33,76,118,16,5,6,19,39,37]),function(H,e,S,t,P,R,M,I,m,w,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends R.NativeExtensionsScannerService{constructor(d,v,a,u,g,k,E,D){super(S.URI.file(g.builtinExtensionsPath),S.URI.file(g.extensionsPath),g.userHome,S.URI.file(g.userDataPath),d,v,a,u,g,k,E,D)}};y=pe([_(0,b.IUserDataProfilesService),_(1,P.IExtensionsProfileScannerService),_(2,M.IFileService),_(3,m.ILogService),_(4,t.INativeEnvironmentService),_(5,w.IProductService),_(6,p.IUriIdentityService),_(7,I.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(ee[264],te([0,1,14,2,15,9,4,60,7,31,42,33,6,37]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends t.Disposable{constructor(a,u,g){super(),this.c=a,this.f=g,this.a=I.TernarySearchTree.forPaths(!M.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(a.appRoot),this.addValidFileRoot(a.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(a.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:a}=S.session;a.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,(u,g)=>this.i(u,g)),a.protocol.interceptFileProtocol(P.Schemas.file,(u,g)=>this.h(u,g)),this.B((0,t.toDisposable)(()=>{a.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),a.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(a){const u=(0,R.normalize)(a);return this.a.get(u)?t.Disposable.None:(this.a.set(u,!0),(0,t.toDisposable)(()=>this.a.delete(u)))}h(a,u){const g=m.URI.parse(a.url);return this.f.error(`Refused to load resource ${g.fsPath} from ${P.Schemas.file}: protocol (original URL: ${a.url})`),u({error:-3})}i(a,u){const g=this.j(a);let k;return this.c.crossOriginIsolated&&((0,R.basename)(g)==="workbench.html"||(0,R.basename)(g)==="workbench-dev.html"?k=P.COI.CoopAndCoep:k=P.COI.getHeadersFromQuery(a.url)),this.a.findSubstr(g)?u({path:g,headers:k}):this.b.has((0,R.extname)(g).toLowerCase())?u({path:g}):(this.f.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${g} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${a.url})`),u({error:-3}))}j(a){const u=m.URI.parse(a.url),g=P.FileAccess.uriToFileUri(u);return(0,R.normalize)(g.fsPath)}createIPCObjectUrl(){let a;const u=m.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),g=u.toString(),k=async()=>a;return p.validatedIpcMain.handle(g,k),this.f.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:u,update:E=>a=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${g}.`),p.validatedIpcMain.removeHandler(g)}}}};d=pe([_(0,b.INativeEnvironmentService),_(1,f.IUserDataProfilesService),_(2,y.ILogService)],d),e.ProtocolMainService=d}),define(ee[265],te([0,1,14,42,8,3,2,15,11,104,28,21,6,64,65,67,45,37,38]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let k=class extends M.Disposable{constructor(D,i,l,n,s,o,c,r,h){super(),this.g=D,this.h=i,this.i=l,this.j=n,this.k=s,this.l=o,this.m=c,this.n=r,this.p=h,this.a=new P.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new R.Emitter),this.onDidError=R.Event.buffer(this.f.event),this.w=void 0,this.y=void 0,this.r()}r(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(D,i)=>this.s(D,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(D,i)=>this.t(D,i)),this.B(this.k.onWillShutdown(()=>this.u()))}async s(D,i){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const l=await this.connect();if(D.sender.isDestroyed())return l.close();D.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[l])}t(D,i){this.l.trace("SharedProcess: onWorkerConnection",i);const l=new M.DisposableStore,n=o=>{!this.F()||(this.l.trace(`SharedProcess: disposing worker (reason: '${o}')`,i),l.dispose(),this.v("vscode:electron-main->shared-process=disposeWorker",i))},s=S.BrowserWindow.fromId(i.reply.windowId);if(!s||s.isDestroyed()||s.webContents.isDestroyed()||!i.reply.channel){n("unavailable");return}l.add(R.Event.filter(this.k.onWillLoadWindow,o=>o.window.win===s)(()=>n("load"))),l.add(R.Event.fromNodeEventEmitter(s,"closed")(()=>n("closed"))),s.webContents.postMessage(i.reply.channel,i.reply.nonce,D.ports)}u(){const D=this.b;!D||(this.v("vscode:electron-main->shared-process=exit"),this.c&&(D.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{D.close()}catch{}this.b=void 0},0))}v(D,...i){if(!this.F()){this.l.warn(`Sending IPC message to channel '${D}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(D,...i)}catch(l){this.l.warn(`Error sending IPC message to channel '${D}' of shared process: ${(0,a.toErrorMessage)(l)}`)}}whenReady(){return this.w||(this.w=new Promise(D=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),D()}))),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C(),this.D(),await new Promise(D=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),D()}))})()),this.y}C(){const D=this.B(this.p.createIPCObjectUrl());this.b=new S.BrowserWindow({show:!1,backgroundColor:this.n.getBackgroundColor(),webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${D.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),D.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),product:f.default,policiesData:this.m.serialize()}),this.b.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}D(){!this.b||(this.c=D=>{this.l.trace("SharedProcess#close prevented"),D.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(D,i)=>this.f.fire({type:2,details:i})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(D,i,l)=>this.f.fire({type:3,details:{reason:l,exitCode:i}})))}async connect(){await this.z;const D=(0,m.assertIsDefined)(this.b);return(0,w.connect)(D)}async toggle(){await this.z,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}F(){const D=this.b;return D?!D.isDestroyed()&&!D.webContents.isDestroyed():!1}};k=pe([_(2,p.IEnvironmentMainService),_(3,u.IUserDataProfilesService),_(4,b.ILifecycleMainService),_(5,y.ILogService),_(6,g.IPolicyService),_(7,v.IThemeMainService),_(8,d.IProtocolMainService)],k),e.SharedProcess=k}),define(ee[93],te([0,1,8,3,2,63,11,105,5,37]),function(H,e,S,t,P,R,M,I,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,m.createDecorator)("storageService");var p;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var y;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function f(g){const k=g.get(e.TARGET_KEY);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}e.loadKeyTargets=f;class d extends P.Disposable{constructor(k={flushInterval:d.a}){super(),this.j=k,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new S.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new P.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,S.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,P.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.J()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(k,E){if(E===e.TARGET_KEY){switch(k){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:k})}else this.b.fire({scope:k,key:E,target:this.F(k)[E]})}r(k){this.f.fire({reason:k})}get(k,E,D){return this.L(E)?.get(k,D)}getBoolean(k,E,D){return this.L(E)?.getBoolean(k,D)}getNumber(k,E,D){return this.L(E)?.getNumber(k,D)}store(k,E,D,i){if((0,M.isUndefinedOrNull)(E)){this.remove(k,D);return}this.t(()=>{this.u(k,D,i),this.L(D)?.set(k,E)})}remove(k,E){this.t(()=>{this.u(k,E,void 0),this.L(E)?.delete(k)})}t(k){this.b.pause(),this.c.pause();try{k()}finally{this.b.resume(),this.c.resume()}}keys(k,E){const D=[],i=this.F(k);for(const l of Object.keys(i))i[l]===E&&D.push(l);return D}u(k,E,D){const i=this.F(E);typeof D=="number"?i[k]!==D&&(i[k]=D,this.L(E)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[k]=="number"&&(delete i[k],this.L(E)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(k){switch(k){case-1:return this.D;case 0:return this.z;default:return this.w}}G(k){const E=this.L(k);return E?f(E):Object.create(null)}isNew(k){return this.getBoolean(e.IS_NEW_KEY,k)===!0}async flush(k=p.NONE){this.f.fire({reason:k});const E=this.L(-1),D=this.L(0),i=this.L(1);switch(k){case p.NONE:await S.Promises.settled([E?.whenFlushed()??Promise.resolve(),D?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await S.Promises.settled([E?.flush(0)??Promise.resolve(),D?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const k=this.L(-1)?.items??new Map,E=this.L(0)?.items??new Map,D=this.L(1)?.items??new Map;return u(k,E,D,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(k,E){return this.r(p.NONE),(0,w.isUserDataProfile)(k)?this.N(k,E):this.O(k,E)}H(k,E){return!(k.id===E.id||v(E)&&v(k))}I(k,E,D,i){this.t(()=>{if(i)for(const[l,n]of k)E.set(l,n);else{const l=new Set;for(const[n,s]of k)l.add(n),E.get(n)!==s&&this.n(D,n);for(const[n]of E.items)l.has(n)||this.n(D,n)}})}}e.AbstractStorageService=d,d.a=60*1e3;function v(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class a extends d{constructor(){super(),this.p=this.B(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new I.Storage(new I.InMemoryStorageDatabase,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(k=>this.n(1,k))),this.B(this.P.onDidChangeStorage(k=>this.n(0,k))),this.B(this.p.onDidChangeStorage(k=>this.n(-1,k)))}L(k){switch(k){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(k){switch(k){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(k){return!1}}e.InMemoryStorageService=a;async function u(g,k,E,D,i,l){const n=B=>{try{return JSON.parse(B)}catch{return B}},s=new Map,o=new Map;g.forEach((B,K)=>{s.set(K,B),o.set(K,n(B))});const c=new Map,r=new Map;k.forEach((B,K)=>{c.set(K,B),r.set(K,n(B))});const h=new Map,C=new Map;E.forEach((B,K)=>{h.set(K,B),C.set(K,n(B))}),console.group(D!==i?`Storage: Application (path: ${D})`:`Storage: Application & Profile (path: ${D}, default profile)`);const L=[];if(s.forEach((B,K)=>{L.push({key:K,value:B})}),console.table(L),console.groupEnd(),console.log(o),D!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const B=[];c.forEach((K,V)=>{B.push({key:V,value:K})}),console.table(B),console.groupEnd(),console.log(r)}console.group(`Storage: Workspace (path: ${l})`);const O=[];h.forEach((B,K)=>{O.push({key:K,value:B})}),console.table(O),console.groupEnd(),console.log(C)}e.logStorage=u}),define(ee[266],te([0,1,25,8,3,2,9,69,7,23,105,149,6,93,24,29]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class a extends R.Disposable{get storage(){return this.f}constructor(l,n){super(),this.j=l,this.k=n,this.b=this.B(new P.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new P.Emitter),this.onDidCloseStorage=this.c.event,this.f=new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new t.DeferredPromise,this.whenInit=this.h.p,this.i=p.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===p.StorageState.None)try{const l=await this.n();this.f.dispose(),this.f=l,this.B(l.onDidChangeStorage(s=>this.b.fire({key:s}))),await this.m(l);const n=l.getBoolean(f.IS_NEW_KEY);n===void 0?l.set(f.IS_NEW_KEY,!0):n&&l.set(f.IS_NEW_KEY,!1)}catch(l){this.j.error(`[storage main] initialize(): Unable to init storage due to ${l}`)}finally{this.i=p.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===y.LogLevel.Trace?l=>this.j.trace(l):void 0,logError:l=>this.j.error(l)}}m(l){return l.init()}get items(){return this.f.items}get(l,n){return this.f.get(l,n)}set(l,n){return this.f.set(l,n)}delete(l){return this.f.delete(l)}async close(){const l=new I.StopWatch(!1);await this.s(),l.stop(),l.elapsed()>a.a&&await this.r(l),this.c.fire()}async r(l){if(!!this.path)try{const n=(0,S.top)(Array.from(this.f.items.entries()).map(([o,c])=>({key:o,length:c.length})),(o,c)=>c.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),s=(await this.k.stat(m.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${l.elapsed()}ms, DB size: ${s}b, Large Keys: ${n}`)}catch(n){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async s(){this.g&&await this.g,this.i=p.StorageState.Closed,await this.f.close()}}a.a=2e3;class u extends a{get path(){if(!this.v.useInMemoryStorage)return(0,M.join)(this.u.globalStorageHome.fsPath,u.t)}constructor(l,n,s,o){super(s,o),this.u=l,this.v=n}async n(){return new p.Storage(new b.SQLiteStorageDatabase(this.path??b.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}u.t="state.vscdb";class g extends u{constructor(l,n,s,o){super(l,n,s,o)}}e.ProfileStorageMain=g;class k extends u{constructor(l,n,s,o){super(n.defaultProfile,l,s,o)}async m(l){await super.m(l),this.z(l)}z(l){l.get(d.firstSessionDateStorageKey,void 0)===void 0&&l.set(d.firstSessionDateStorageKey,new Date().toUTCString());const s=l.get(d.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();l.set(d.lastSessionDateStorageKey,typeof s>"u"?null:s),l.set(d.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=k;class E extends a{get path(){if(!this.w.useInMemoryStorage)return(0,M.join)(this.y.workspaceStorageHome.fsPath,this.v.id,E.t)}constructor(l,n,s,o,c){super(s,c),this.v=l,this.w=n,this.y=o}async n(){const{storageFilePath:l,wasCreated:n}=await this.C();return new p.Storage(new b.SQLiteStorageDatabase(l,{logging:this.l()}),{hint:this.w.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:n?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:b.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const l=(0,M.join)(this.y.workspaceStorageHome.fsPath,this.v.id),n=(0,M.join)(l,E.t);return await w.Promises.exists(l)?{storageFilePath:n,wasCreated:!1}:(await w.Promises.mkdir(l,{recursive:!0}),this.D(l),{storageFilePath:n,wasCreated:!0})}async D(l){let n;if((0,v.isSingleFolderWorkspaceIdentifier)(this.v)?n={folder:this.v.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.v)&&(n={workspace:this.v.configPath.toString()}),n)try{const s=(0,M.join)(l,E.u);await w.Promises.exists(s)||await w.Promises.writeFile(s,JSON.stringify(n,void 0,2))}catch(s){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}e.WorkspaceStorageMain=E,E.t="state.vscdb",E.u="workspace.json";class D extends a{get path(){}async n(){return new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=D}),define(ee[267],te([0,1,3,2,93]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(I,m,w){super(),this.b=I,this.c=m,this.f=w;const p=this.B(new t.MutableDisposable);this.a=this.B(new S.Emitter({onWillAddFirstListener:()=>p.value=this.g(),onDidRemoveLastListener:()=>p.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const I=new t.DisposableStore;return I.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(m,w)=>(m?m.push(w.key):m=[w.key],m),100)(m=>this.h(m))),I.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(m,w)=>{m||(m=new Map);let p=m.get(w.profile.id);return p||m.set(w.profile.id,p={profile:w.profile,keys:[],storage:w.storage}),p.keys.push(w.key),m},100)(m=>this.i(m))),I}h(I){const m=I.includes(P.TARGET_KEY)?[this.c.defaultProfile]:[],w=[];if(I=I.filter(p=>p!==P.TARGET_KEY),I.length){const p=(0,P.loadKeyTargets)(this.b.applicationStorage.storage);w.push({profile:this.c.defaultProfile,changes:I.map(b=>({key:b,scope:0,target:p[b]}))})}this.j(m,w)}i(I){const m=[],w=new Map;for(const[p,b]of I.entries()){b.keys.includes(P.TARGET_KEY)&&m.push(b.profile);const y=b.keys.filter(f=>f!==P.TARGET_KEY);if(y.length){const f=(0,P.loadKeyTargets)(b.storage.storage);w.set(p,{profile:b.profile,changes:y.map(d=>({key:d,scope:0,target:f[d]}))})}}this.j(m,[...w.values()])}j(I,m){(I.length||m.length)&&this.a.fire({valueChanges:m,targetChanges:I})}listen(I,m,w){switch(m){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${m}`)}async call(I,m){throw new Error(`Call not found: ${m}`)}}e.ProfileStorageChangesListenerChannel=R}),define(ee[268],te([0,1,71,7,33,16,6,231,39,37]),function(H,e,S,t,P,R,M,I,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let p=class extends w.UserDataProfilesService{constructor(f,d,v,a){super(d,v,f,a),this.a=d}L(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p=pe([_(0,m.IUriIdentityService),_(1,P.INativeEnvironmentService),_(2,R.IFileService),_(3,M.ILogService)],p),e.ServerUserDataProfilesService=p;let b=class Lt extends p{constructor(f,d,v,a,u){super(d,v,a,u),this.N=f}G(){return(0,S.revive)(this.N.getItem(Lt.b,[]))}I(){return(0,S.revive)(this.N.getItem(Lt.c,{}))}L(){return this.r.extUri.joinPath(t.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};b=pe([_(0,I.IStateService),_(1,m.IUriIdentityService),_(2,P.INativeEnvironmentService),_(3,R.IFileService),_(4,M.ILogService)],b),e.UserDataProfilesService=b}),define(ee[52],te([0,1,7,33,16,5,6,34,39,37,268]),function(H,e,S,t,P,R,M,I,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(w.IUserDataProfilesService);let b=class dt extends p.UserDataProfilesService{constructor(f,d,v,a,u){super(f,d,v,a,u),this.R=f}setEnablement(f){super.setEnablement(f),this.f||(this.H([]),this.J({}))}getAssociatedEmptyWindows(){const f=[];for(const d of this.u.emptyWindows.keys())f.push({id:d});return f}H(f){f.length?this.R.setItem(dt.b,f):this.R.removeItem(dt.b)}J(f){f.emptyWindows||f.workspaces?this.R.setItem(dt.c,f):this.R.removeItem(dt.c)}I(){const f="workspaceAndProfileInfo",d=this.R.getItem(f,void 0);if(d){this.R.removeItem(f);const v=d.reduce((a,{workspace:u,profile:g})=>(a[S.URI.revive(u).toString()]=S.URI.revive(g).toString(),a),{});this.R.setItem(dt.c,{workspaces:v})}return super.I()}};b=pe([_(0,I.IStateMainService),_(1,m.IUriIdentityService),_(2,t.INativeEnvironmentService),_(3,P.IFileService),_(4,M.ILogService)],b),e.UserDataProfilesMainService=b}),define(ee[94],te([0,1,7,50,3,2,33,16,5,21,6,93,266,37,52,39]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,m.createDecorator)("storageMainService");let a=class extends R.Disposable{constructor(k,E,D,i,l,n){super(),this.c=k,this.f=E,this.g=D,this.h=i,this.i=l,this.j=n,this.a=void 0,this.b=this.B(new P.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(k=>{k.window.profile&&this.profileStorage(k.window.profile).init(),k.workspace&&this.workspaceStorage(k.workspace).init()})),this.B(this.h.onWillShutdown(k=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=k.reason,k.join(this.applicationStorage.close());for(const[,E]of this.n)k.join(E.close());for(const[,E]of this.r)k.join(E.close())})),this.B(this.g.onWillCreateProfile(k=>{k.join((async()=>{await this.i.exists(k.profile.globalStorageHome)||await this.i.createFolder(k.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(k=>{const E=this.n.get(k.profile.id);E&&k.join(E.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const k=new y.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,t.once)(k.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),k}profileStorage(k){if((0,b.isProfileUsingDefaultStorage)(k))return this.applicationStorage;let E=this.n.get(k.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${k.name})`),E=this.p(k),this.n.set(k.id,E);const D=this.B(E.onDidChangeStorage(i=>this.b.fire({...i,storage:E,profile:k})));(0,t.once)(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${k.name})`),this.n.delete(k.id),D.dispose()})}return E}p(k){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.ProfileStorageMain(k,this.k(),this.c,this.i)}workspaceStorage(k){let E=this.r.get(k.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${k.id})`),E=this.s(k),this.r.set(k.id,E),(0,t.once)(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${k.id})`),this.r.delete(k.id)})),E}s(k){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.WorkspaceStorageMain(k,this.k(),this.c,this.f,this.i)}isUsed(k){const E=S.URI.file(k);for(const D of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!D.path&&this.j.extUri.isEqualOrParent(S.URI.file(D.path),E))return!0;return!1}};a=pe([_(0,p.ILogService),_(1,M.IEnvironmentService),_(2,d.IUserDataProfilesMainService),_(3,w.ILifecycleMainService),_(4,I.IFileService),_(5,v.IUriIdentityService)],a),e.StorageMainService=a,e.IApplicationStorageMainService=(0,m.createDecorator)("applicationStorageMainService");let u=class extends b.AbstractStorageService{constructor(k,E){super(),this.p=k,this.s=E,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(k){if(k===-1)return this.s.applicationStorage.storage}M(k){if(k===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=pe([_(0,f.IUserDataProfilesService),_(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(ee[269],te([0,1,2,21,52,29,8,30]),function(H,e,S,t,P,R,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let m=class extends S.Disposable{constructor(p,b,y){super(),this.a=b,this.b=y,this.B(p.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(p.onBeforeCloseWindow(f=>this.c(f))),this.B(new M.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(p){const b=this.f(p),y=this.a.getProfileForWorkspace(b);y&&((0,R.isEmptyWorkspaceIdentifier)(b)||y.isTransient)&&(this.a.unsetWorkspace(b,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(p){return p.openedWorkspace??(0,R.toWorkspaceIdentifier)(p.backupPath,p.isExtensionDevelopmentHost)}g(){const p=this.a.getAssociatedEmptyWindows();if(p.length===0)return;const b=this.b.getWindows().map(y=>this.f(y));for(const y of p)b.some(f=>f.id===y.id)||this.a.unsetWorkspace(y,!1)}};m=pe([_(0,t.ILifecycleMainService),_(1,P.IUserDataProfilesMainService),_(2,I.IWindowsMainService)],m),e.UserDataProfilesHandler=m}),define(ee[119],te([0,1,20,7,29]),function(H,e,S,t,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(m,w,p){for(const y of m){const f=y.openedWorkspace;if((0,P.isWorkspaceIdentifier)(f)){const d=await p(f);if(d){if(d.folders.some(v=>S.extUriBiasedIgnorePathCase.isEqualOrParent(w,v.uri)))return y}else if(S.extUriBiasedIgnorePathCase.isEqualOrParent(w,f.configPath))return y}}const b=m.filter(y=>(0,P.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqualOrParent(w,y.openedWorkspace.uri));if(b.length)return b.sort((y,f)=>-(y.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function M(m,w){for(const p of m)if((0,P.isWorkspaceIdentifier)(p.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.configPath,w)||(0,P.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.uri,w))return p}e.findWindowOnWorkspaceOrFolder=M;function I(m,w){const p=b=>w.some(y=>S.extUriBiasedIgnorePathCase.isEqual(t.URI.file(y),t.URI.file(b)));for(const b of m)if(b.config?.extensionDevelopmentPath?.some(y=>p(y)))return b}e.findWindowOnExtensionDevelopmentPath=I}),define(ee[270],te([0,1,14,2,4,20,7,18,21,6,34,30,117,29]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class Ot extends t.Disposable{get state(){return this.b}constructor(E,D,i,l,n){super(),this.g=E,this.h=D,this.i=i,this.j=l,this.k=n,this.b=v(this.h.getItem(Ot.a)),this.c=void 0,this.f=!1,this.l()}l(){S.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(E=>this.p(E)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(E=>{E.newCount-E.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(E=>this.p(E))}m(){this.f=!0,this.n()}n(){const E=new Set,D={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!D.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(s=>!s.isExtensionDevelopmentHost)),n&&(D.lastActiveWindow=this.r(n),D.lastActiveWindow.uiState.mode===3&&E.add(D.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);i&&(D.lastPluginDevelopmentHostWindow=this.r(i),D.lastPluginDevelopmentHostWindow.uiState.mode===3&&(E.has(D.lastPluginDevelopmentHostWindow.uiState.display)?P.isMacintosh&&!i.win?.isSimpleFullScreen()&&(D.lastPluginDevelopmentHostWindow.uiState.mode=1):E.add(D.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(D.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const s=this.r(n);return s.uiState.mode===3&&(E.has(s.uiState.display)?P.isMacintosh&&s.windowId!==D.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(s.uiState.mode=1):E.add(s.uiState.display)),s}));const l=u(D);this.h.setItem(Ot.a,l),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",l)}p(E){if(this.i.quitRequested)return;const D=this.r(E);E.isExtensionDevelopmentHost&&!E.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=D:!E.isExtensionDevelopmentHost&&E.openedWorkspace&&this.b.openedWindows.forEach(i=>{const l=(0,f.isWorkspaceIdentifier)(E.openedWorkspace)&&i.workspace?.id===E.openedWorkspace.id,n=(0,f.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&i.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(i.folderUri,E.openedWorkspace.uri);(l||n)&&(i.uiState=D.uiState)}),this.g.getWindowCount()===1&&(this.c=D)}r(E){return{windowId:E.id,workspace:(0,f.isWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)?E.openedWorkspace.uri:void 0,backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.serializeWindowState()}}getNewWindowState(E){const D=this.s(E),i=this.k.getValue("window");if(D.mode===3){let l;D.hasDefaultState?l=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):l=!!(this.i.wasRestarted||i?.restoreFullscreen),l||(D.mode=1)}return D}s(E){const D=this.g.getLastActiveWindow();if(!E.extensionTestsPath){if(!!E.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=E.workspace;if((0,f.isWorkspaceIdentifier)(c)){const h=this.state.openedWindows.filter(C=>C.workspace&&C.workspace.id===c.id).map(C=>C.uiState);if(h.length)return h[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(c)){const h=this.state.openedWindows.filter(C=>C.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(C.folderUri,c.uri)).map(C=>C.uiState);if(h.length)return h[0]}else if(E.backupPath){const h=this.state.openedWindows.filter(C=>C.backupPath===E.backupPath).map(C=>C.uiState);if(h.length)return h[0]}const r=this.c||this.state.lastActiveWindow;if(!D&&r)return r.uiState}let i;const l=S.screen.getAllDisplays();if(l.length===1)i=l[0];else{if(P.isMacintosh){const c=S.screen.getCursorScreenPoint();i=S.screen.getDisplayNearestPoint(c)}!i&&D&&(i=S.screen.getDisplayMatching(D.getBounds())),i||(i=S.screen.getPrimaryDisplay()||l[0])}let n=(0,y.defaultWindowState)();n.x=Math.round(i.bounds.x+i.bounds.width/2-n.width/2),n.y=Math.round(i.bounds.y+i.bounds.height/2-n.height/2);const s=this.k.getValue("window");let o=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")n.mode=0,o=!1;else if(s.newWindowDimensions==="fullscreen")n.mode=3,o=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&D){const c=D.serializeWindowState();c.mode===3?n.mode=3:n=c,o=n.mode!==3&&s.newWindowDimensions==="offset"}}return o&&(n=this.t(n)),n.hasDefaultState=!0,n}t(E){if(this.g.getWindows().length===0)return E;E.x=typeof E.x=="number"?E.x:0,E.y=typeof E.y=="number"?E.y:0;const D=this.g.getWindows().map(i=>i.getBounds());for(;D.some(i=>i.x===E.x||i.y===E.y);)E.x+=30,E.y+=30;return E}};d.a="windowsState",d=pe([_(0,b.IWindowsMainService),_(1,p.IStateMainService),_(2,m.ILifecycleMainService),_(3,w.ILogService),_(4,I.IConfigurationService)],d),e.WindowsStateHandler=d;function v(k){const E={openedWindows:[]},D=k||{openedWindows:[]};return D.lastActiveWindow&&(E.lastActiveWindow=a(D.lastActiveWindow)),D.lastPluginDevelopmentHostWindow&&(E.lastPluginDevelopmentHostWindow=a(D.lastPluginDevelopmentHostWindow)),Array.isArray(D.openedWindows)&&(E.openedWindows=D.openedWindows.map(i=>a(i))),E}e.restoreWindowsState=v;function a(k){const E={uiState:k.uiState};return k.backupPath&&(E.backupPath=k.backupPath),k.remoteAuthority&&(E.remoteAuthority=k.remoteAuthority),k.folder&&(E.folderUri=M.URI.parse(k.folder)),k.workspaceIdentifier&&(E.workspace={id:k.workspaceIdentifier.id,configPath:M.URI.parse(k.workspaceIdentifier.configURIPath)}),E}function u(k){return{lastActiveWindow:k.lastActiveWindow&&g(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&g(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(E=>g(E))}}e.getWindowsStateStoreData=u;function g(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(ee[95],te([0,1,32,43,125,36,15,9,4,20,7,5,55,29]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function d(C){return C.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function v(C){return C.hasOwnProperty("folderUri")}e.isRecentFolder=v;function a(C){return C.hasOwnProperty("fileUri")}e.isRecentFile=a;function u(C){return g(C)||k(C)}e.isStoredWorkspaceFolder=u;function g(C){const L=C;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function k(C){const L=C;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function E(C,L,O,B,K){if(C.scheme!==B.scheme)return{name:O,uri:C.toString(!0)};let V=L?void 0:K.relativePath(B,C);if(V!==void 0)V.length===0?V=".":m.isWindows&&(V=D(V));else if(C.scheme===M.Schemas.file)V=C.fsPath,m.isWindows&&(V=D(V));else if(K.isEqualAuthority(C.authority,B.authority))V=C.path;else return{name:O,uri:C.toString(!0)};return{name:O,path:V}}e.getStoredWorkspaceFolder=E;function D(C){return C=(0,R.normalizeDriveLetter)(C),(0,S.isUNC)(C)||(C=(0,S.toSlashes)(C)),C}function i(C,L,O){const B=[],K=new Set,V=O.dirname(L);for(const J of C){let re;if(g(J))J.path&&(re=O.resolvePath(V,J.path));else if(k(J))try{re=p.URI.parse(J.uri),re.path[0]!==I.posix.sep&&(re=re.with({path:I.posix.sep+re.path}))}catch(se){console.warn(se)}if(re){const se=O.getComparisonKey(re);if(!K.has(se)){K.add(se);const ae=J.name||O.basenameOrAuthority(re);B.push(new f.WorkspaceFolder({uri:re,name:ae,index:B.length},J))}}}return B}e.toWorkspaceFolders=i;function l(C,L,O,B,K){const V=n(L,C),J=K.dirname(L),re=K.dirname(B),se=[];for(const q of V.folders){const T=g(q)?K.resolvePath(J,q.path):p.URI.parse(q.uri);let U;O?U=!1:U=!g(q)||(0,I.isAbsolute)(q.path),se.push(E(T,U,q.name,re,K))}const ae={insertSpaces:!1,tabSize:4,eol:m.isLinux||m.isMacintosh?`
`:`\r
`},fe=P.setProperty(C,["folders"],se,ae);let ge=P.applyEdits(C,fe);return(0,w.isEqualAuthority)(V.remoteAuthority,(0,y.getRemoteAuthority)(B))&&(ge=P.applyEdits(ge,P.removeProperty(ge,["remoteAuthority"],ae))),ge}e.rewriteWorkspaceFileForNewLocation=l;function n(C,L){const O=t.parse(L);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(B=>u(B));else throw new Error(`${C} looks like an invalid workspace file.`);return O}function s(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function o(C){return typeof C.folderUri=="string"}function c(C){return typeof C.fileUri=="string"}function r(C,L){const O={workspaces:[],files:[]};if(C){const B=function(V,J){for(let re=0;re<V.length;re++)try{J(V[re],re)}catch(se){L.warn(`Error restoring recent entry ${JSON.stringify(V[re])}: ${se.toString()}. Skip entry.`)}},K=C;Array.isArray(K.entries)&&B(K.entries,V=>{const J=V.label,re=V.remoteAuthority;s(V)?O.workspaces.push({label:J,remoteAuthority:re,workspace:{id:V.workspace.id,configPath:p.URI.parse(V.workspace.configPath)}}):o(V)?O.workspaces.push({label:J,remoteAuthority:re,folderUri:p.URI.parse(V.folderUri)}):c(V)&&O.files.push({label:J,remoteAuthority:re,fileUri:p.URI.parse(V.fileUri)})})}return O}e.restoreRecentlyOpened=r;function h(C){const L={entries:[]};for(const O of C.workspaces)v(O)?L.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):L.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of C.files)L.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return L}e.toStoreData=h}),define(ee[96],te([0,1,79,15,4,20]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function M(w){function p(){let b=w.scheme===t.Schemas.file?(0,R.originalFSPath)(w):w.toString();return P.isLinux||(b=b.toLowerCase()),(0,S.createHash)("md5").update(b).digest("hex")}return{id:p(),configPath:w}}e.getWorkspaceIdentifier=M;function I(w,p){function b(){if(w.scheme!==t.Schemas.file)return(0,S.createHash)("md5").update(w.toString()).digest("hex");if(!p)return;let f;return P.isLinux?f=p.ino:P.isMacintosh?f=p.birthtime.getTime():P.isWindows&&(typeof p.birthtimeMs=="number"?f=Math.floor(p.birthtimeMs):f=p.birthtime.getTime()),(0,S.createHash)("md5").update(w.fsPath).update(f?String(f):"").digest("hex")}const y=b();if(typeof y=="string")return{id:y,uri:w}}e.getSingleFolderWorkspaceIdentifier=I;function m(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=m}),define(ee[271],te([0,1,79,32,15,9,4,20,23,179,18,28,34,16,6,178,29,96]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let g=class Tt{constructor(E,D,i,l){this.j=E,this.k=D,this.l=i,this.m=l,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=I.extUriBiasedIgnorePathCase,this.i={isEqual:(n,s)=>(0,t.isEqual)(n,s,!M.isLinux)}}async initialize(){const E=this.m.getItem(Tt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(E.emptyWindows),this.d=await this.u((0,w.deserializeWorkspaceInfos)(E)),this.e=await this.v((0,w.deserializeFolderInfos)(E)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.HotExitConfiguration.OFF}q(){return this.s()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(E,D){this.d.some(l=>E.workspace.id===l.workspace.id)||(this.d.push(E),this.C());const i=(0,R.join)(this.c,E.workspace.id);return D?this.t(i,D).then(()=>i):i}async t(E,D){if(await m.Promises.exists(E)&&await this.z(E),await m.Promises.exists(D))try{await m.Promises.rename(D,E)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(E){return this.e.some(D=>this.h.isEqual(E.folderUri,D.folderUri))||(this.e.push(E),this.C()),(0,R.join)(this.c,this.D(E))}registerEmptyWindowBackup(E){return this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,E.backupFolder))||(this.g.push(E),this.C()),(0,R.join)(this.c,E.backupFolder)}async u(E){if(!Array.isArray(E))return[];const D=new Set,i=[];for(const l of E){const n=l.workspace;if(!(0,a.isWorkspaceIdentifier)(n))return[];if(!D.has(n.id)){D.add(n.id);const s=(0,R.join)(this.c,n.id);await this.B(s)?n.configPath.scheme!==P.Schemas.file||await m.Promises.exists(n.configPath.fsPath)?i.push(l):await this.z(s):await this.x(s)}}return i}async v(E){if(!Array.isArray(E))return[];const D=[],i=new Set;for(const l of E){const n=l.folderUri,s=this.h.getComparisonKey(n);if(!i.has(s)){i.add(s);const o=(0,R.join)(this.c,this.D(l));await this.B(o)?n.scheme!==P.Schemas.file||await m.Promises.exists(n.fsPath)?D.push(l):await this.z(o):await this.x(o)}}return D}async w(E){if(!Array.isArray(E))return[];const D=[],i=new Set;for(const l of E){const n=l.backupFolder;if(typeof n!="string")return[];if(!i.has(n)){i.add(n);const s=(0,R.join)(this.c,n);await this.B(s)?D.push(l):await this.x(s)}}return D}async x(E){try{await m.Promises.rm(E,m.RimRafMode.MOVE)}catch(D){this.l.error(`Backup: Could not delete stale backup: ${D.toString()}`)}}y(){let E=(0,u.createEmptyWorkspaceIdentifier)();for(;this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,E.id));)E=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:E.id}}async z(E){const D=this.y(),i=(0,R.join)(this.c,D.backupFolder);try{await m.Promises.rename(E,i)}catch(l){return this.l.error(`Backup: Could not rename backup folder: ${l.toString()}`),!1}return this.g.push(D),!0}async getDirtyWorkspaces(){const E=[];for(const D of this.d)await this.A(D)&&E.push(D);for(const D of this.e)await this.A(D)&&E.push(D);return E}A(E){let D;return(0,w.isEmptyWindowBackupInfo)(E)?D=(0,R.join)(this.c,E.backupFolder):(0,v.isFolderBackupInfo)(E)?D=(0,R.join)(this.c,this.D(E)):D=(0,R.join)(this.c,E.workspace.id),this.B(D)}async B(E){try{const D=await m.Promises.readdir(E);for(const i of D)try{if((await m.Promises.readdir((0,R.join)(E,i))).length>0)return!0}catch{}}catch{}return!1}C(){const E={workspaces:this.d.map(({workspace:D,remoteAuthority:i})=>{const l={id:D.id,configURIPath:D.configPath.toString()};return i&&(l.remoteAuthority=i),l}),folders:this.e.map(({folderUri:D,remoteAuthority:i})=>{const l={folderUri:D.toString()};return i&&(l.remoteAuthority=i),l}),emptyWindows:this.g.map(({backupFolder:D,remoteAuthority:i})=>{const l={backupFolder:D};return i&&(l.remoteAuthority=i),l})};this.m.setItem(Tt.a,E)}D(E){const D=E.folderUri;let i;return D.scheme===P.Schemas.file?i=M.isLinux?D.fsPath:D.fsPath.toLowerCase():i=D.toString().toLowerCase(),(0,S.createHash)("md5").update(i).digest("hex")}};g.a="backupWorkspaces",g=pe([_(0,b.IEnvironmentMainService),_(1,p.IConfigurationService),_(2,d.ILogService),_(3,y.IStateMainService)],g),e.BackupMainService=g}),define(ee[53],te([0,1,14,3,43,36,2,15,9,20,11,23,177,62,57,28,5,6,19,52,119,29,95,96]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k,E,D,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,a.createDecorator)("workspacesManagementMainService");let n=class extends M.Disposable{constructor(o,c,r,h,C,L){super(),this.g=o,this.h=c,this.i=r,this.j=h,this.k=C,this.l=L,this.a=this.B(new t.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new t.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await b.Promises.readdir(this.c.fsPath)).map(c=>(0,w.joinPath)(this.c,c,D.UNTITLED_WORKSPACE_NAME));for(const c of o){const r=(0,l.getWorkspaceIdentifier)(c),h=await this.resolveLocalWorkspace(c);h?this.f.push({workspace:r,remoteAuthority:h.remoteAuthority}):await this.deleteUntitledWorkspace(r)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.m(o,c=>b.Promises.readFile(c,"utf8"))}m(o,c){if(!!this.n(o)&&o.scheme===I.Schemas.file)try{const r=c(o.fsPath);return r instanceof Promise?r.then(h=>this.p(o,h),h=>{}):this.p(o,r)}catch{return}}n(o){return(0,D.isUntitledWorkspace)(o,this.g)||(0,D.hasWorkspaceFileExtension)(o)}p(o,c){try{const r=this.r(o,c),h=(0,l.getWorkspaceIdentifier)(o);return{id:h.id,configPath:h.configPath,folders:(0,i.toWorkspaceFolders)(r.folders,h.configPath,w.extUriBiasedIgnorePathCase),remoteAuthority:r.remoteAuthority,transient:r.transient}}catch(r){this.h.warn(r.toString())}}r(o,c){const r=(0,P.parse)(c);if(r&&Array.isArray(r.folders))r.folders=r.folders.filter(h=>(0,i.isStoredWorkspaceFolder)(h));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return r}async createUntitledWorkspace(o,c){const{workspace:r,storedWorkspace:h}=this.s(o,c),C=r.configPath.fsPath;return await b.Promises.mkdir((0,m.dirname)(C),{recursive:!0}),await b.Promises.writeFile(C,JSON.stringify(h,null,"	")),this.f.push({workspace:r,remoteAuthority:c}),r}s(o=[],c){const r=(Date.now()+Math.round(Math.random()*1e3)).toString(),h=(0,w.joinPath)(this.c,r),C=(0,w.joinPath)(h,D.UNTITLED_WORKSPACE_NAME),L=[];for(const O of o)L.push((0,i.getStoredWorkspaceFolder)(O.uri,!0,O.name,h,w.extUriBiasedIgnorePathCase));return{workspace:(0,l.getWorkspaceIdentifier)(C),storedWorkspace:{folders:L,remoteAuthority:c}}}async getWorkspaceIdentifier(o){return(0,l.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,D.isUntitledWorkspace)(o.configPath,this.g)}async deleteUntitledWorkspace(o){!this.isUntitledWorkspace(o)||(await this.t(o),this.i.isEnabled()&&this.i.unsetWorkspace(o),this.a.fire(o))}async t(o){const c=(0,w.originalFSPath)(o.configPath);try{await b.Promises.rm((0,m.dirname)(c));const r=(0,m.join)(this.g.workspaceStorageHome.fsPath,o.id);await b.Promises.exists(r)&&await b.Promises.writeFile((0,m.join)(r,"obsolete"),""),this.f=this.f.filter(h=>h.workspace.id!==o.id)}catch(r){this.h.warn(`Unable to delete untitled workspace ${c} (${r}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,c,r){if(!o||!o.win||!o.isReady||!await this.u(o,c,r))return;const C=await this.v(o,(0,l.getWorkspaceIdentifier)(r));if(!!C)return this.b.fire({window:o,workspace:C.workspace}),C}async u(o,c,r){if(!r)return!0;if((0,D.isWorkspaceIdentifier)(o.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,r))return!1;if((0,E.findWindowOnWorkspaceOrFolder)(c,r)){const h={title:this.l.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,y.localize)(0,null))],message:(0,y.localize)(1,null,(0,w.basename)(r)),detail:(0,y.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(h,(0,p.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),!1}return!0}async v(o,c){if(!o.config)return;o.focus();let r;return o.config.extensionDevelopmentPath||(o.config.backupPath?r=await this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:o.remoteAuthority},o.config.backupPath):r=this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:o.remoteAuthority})),(0,D.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=c,o.config.backupPath=r,{workspace:c,backupPath:r}}};n=pe([_(0,v.IEnvironmentMainService),_(1,u.ILogService),_(2,k.IUserDataProfilesMainService),_(3,f.IBackupMainService),_(4,d.IDialogMainService),_(5,g.IProductService)],n),e.WorkspacesManagementMainService=n}),define(ee[120],te([0,1,14,42,22,5,30,29,53,11,6]),function(H,e,S,t,P,R,M,I,m,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let b=class{constructor(f,d,v){this.a=f,this.b=d,this.c=v}async getRemoteDiagnostics(f){const d=this.a.getWindows();return(await Promise.all(d.map(async a=>{const u=a.remoteAuthority;if(!u)return;const g=`vscode:getDiagnosticInfoResponse${a.id}`,k={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f(a):void 0};return new Promise(E=>{a.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:g,args:k}),t.validatedIpcMain.once(g,(D,i)=>{i||E({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),E(i)}),setTimeout(()=>{E({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(a=>!!a)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const d of S.BrowserWindow.getAllWindows()){const v=this.a.getWindowById(d.id);v?f.push(await this.d(v)):f.push(this.e(d))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(f){const d=await this.f(f),v=(0,w.assertIsDefined)(f.win);return this.e(v,d,f.remoteAuthority)}e(f,d=[],v){return{pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:d,remoteAuthority:v}}async f(f){const d=[],v=f.openedWorkspace;if((0,I.isSingleFolderWorkspaceIdentifier)(v))d.push(v.uri);else if((0,I.isWorkspaceIdentifier)(v)){const a=await this.b.resolveLocalWorkspace(v.configPath);a&&a.folders.forEach(g=>{d.push(g.uri)})}return d}};b=pe([_(0,M.IWindowsMainService),_(1,m.IWorkspacesManagementMainService),_(2,p.ILogService)],b),e.DiagnosticsMainService=b}),define(ee[58],te([0,1,46,14,26,143,54,3,36,2,15,9,4,7,101,83,23,98,167,57,28,5,21,6,19,67,30,29,53,17,225,218,34]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k,E,D,i,l,n,s,o,c,r,h,C,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,D.createDecorator)("nativeHostMainService");let B=class extends w.Disposable{constructor(V,J,re,se,ae,fe,ge,q,T,U){super(),this.a=V,this.b=J,this.c=re,this.f=se,this.g=ae,this.h=fe,this.i=ge,this.j=q,this.k=T,this.l=U,this.onDidOpenWindow=I.Event.map(this.b.onDidOpenWindow,z=>z.id),this.onDidTriggerSystemContextMenu=I.Event.filter(I.Event.map(this.b.onDidTriggerSystemContextMenu,({window:z,x:Q,y:ne})=>({windowId:z.id,x:Q,y:ne})),({windowId:z})=>!!this.b.getWindowById(z)),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),z=>!!z),z=>z.id),I.Event.filter(I.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new I.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(z,Q,ne)=>ne),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),I.Event.fromNodeEventEmitter(t.screen,"display-added"),I.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(J=>({id:J.id,workspace:J.openedWorkspace??(0,c.toWorkspaceIdentifier)(J.backupPath,J.isExtensionDevelopmentHost),title:J.win?.getTitle()??"",filename:J.getRepresentedFilename(),dirty:J.isDocumentEdited()}))}async getWindowCount(V){return this.b.getWindowCount()}async getActiveWindowId(V){const J=t.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(J)return J.id}openWindow(V,J,re){return Array.isArray(J)?this.n(V,J,re):this.p(V,J)}async n(V,J,re=Object.create(null)){J.length>0&&await this.b.open({context:5,contextWindowId:V,urisToOpen:J,cli:this.g.args,forceNewWindow:re.forceNewWindow,forceReuseWindow:re.forceReuseWindow,preferNewWindow:re.preferNewWindow,diffMode:re.diffMode,mergeMode:re.mergeMode,addMode:re.addMode,gotoLineMode:re.gotoLineMode,noRecentEntry:re.noRecentEntry,waitMarkerFileURI:re.waitMarkerFileURI,remoteAuthority:re.remoteAuthority||void 0,forceProfile:re.forceProfile,forceTempProfile:re.forceTempProfile})}async p(V,J){await this.b.openEmptyWindow({context:5,contextWindowId:V},J)}async toggleFullScreen(V){this.w(V)?.toggleFullScreen()}async handleTitleDoubleClick(V){this.w(V)?.handleTitleDoubleClick()}async isMaximized(V){const J=this.w(V);return J?.win?J.win.isMaximized():!1}async maximizeWindow(V){const J=this.w(V);J?.win&&J.win.maximize()}async unmaximizeWindow(V){const J=this.w(V);J?.win&&J.win.unmaximize()}async minimizeWindow(V){const J=this.w(V);J?.win&&J.win.minimize()}async updateWindowControls(V,J){const re=this.w(V);re&&re.updateWindowControls(J)}async focusWindow(V,J){J&&typeof J.windowId=="number"&&(V=J.windowId),this.w(V)?.focus({force:J?.force??!1})}async setMinimumSize(V,J,re){const se=this.w(V);if(se?.win){const[ae,fe]=se.win.getSize(),[ge,q]=se.win.getMinimumSize(),[T,U]=[J??ge,re??q],[z,Q]=[Math.max(ae,T),Math.max(fe,U)];(ge!==T||q!==U)&&se.win.setMinimumSize(T,U),(ae!==z||fe!==Q)&&se.win.setSize(z,Q)}}async saveWindowSplash(V,J){this.j.saveWindowSplash(V,J)}async installShellCommand(V){const{source:J,target:re}=await this.r();try{const{symbolicLink:se}=await a.SymlinkSupport.stat(J);if(se&&!se.dangling){const ae=await(0,d.realpath)(J);if(re===ae)return}await a.Promises.unlink(J)}catch(se){if(se.code!=="ENOENT")throw se}try{await a.Promises.symlink(re,J)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:ae}=await this.showMessageBox(V,{title:this.i.nameLong,type:"info",message:(0,g.localize)(0,null,this.i.nameShort),buttons:[(0,m.mnemonicButtonLabel)((0,g.localize)(1,null)),(0,m.mnemonicButtonLabel)((0,g.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ae===0)try{const fe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${re}' '${J}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(fe)}catch{throw new Error((0,g.localize)(3,null,J))}}}async uninstallShellCommand(V){const{source:J}=await this.r();try{await a.Promises.unlink(J)}catch(re){switch(re.code){case"EACCES":{const{response:se}=await this.showMessageBox(V,{title:this.i.nameLong,type:"info",message:(0,g.localize)(4,null,this.i.nameShort),buttons:[(0,m.mnemonicButtonLabel)((0,g.localize)(5,null)),(0,m.mnemonicButtonLabel)((0,g.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const ae=`osascript -e "do shell script \\"rm '${J}'\\" with administrator privileges"`;await(0,R.promisify)(S.exec)(ae)}catch{throw new Error((0,g.localize)(7,null,J))}break}case"ENOENT":break;default:throw re}}}async r(){const V=(0,b.resolve)(this.g.appRoot,"bin","code"),J=`/usr/local/bin/${this.i.applicationName}`;if(!await a.Promises.exists(V))throw new Error((0,g.localize)(8,null,V));return{source:J,target:V}}async showMessageBox(V,J){return this.c.showMessageBox(J,this.s(V))}async showSaveDialog(V,J){return this.c.showSaveDialog(J,this.s(V))}async showOpenDialog(V,J){return this.c.showOpenDialog(J,this.s(V))}s(V){const J=this.w(V);if(J?.win)return J.win}async pickFileFolderAndOpen(V,J){const re=await this.c.pickFileFolder(J);re&&await this.t(await Promise.all(re.map(async se=>await a.SymlinkSupport.existsDirectory(se)?{folderUri:f.URI.file(se)}:{fileUri:f.URI.file(se)})),J,V)}async pickFolderAndOpen(V,J){const re=await this.c.pickFolder(J);re&&await this.t(re.map(se=>({folderUri:f.URI.file(se)})),J,V)}async pickFileAndOpen(V,J){const re=await this.c.pickFile(J);re&&await this.t(re.map(se=>({fileUri:f.URI.file(se)})),J,V)}async pickWorkspaceAndOpen(V,J){const re=await this.c.pickWorkspace(J);re&&await this.t(re.map(se=>({workspaceUri:f.URI.file(se)})),J,V)}async t(V,J,re){await this.b.open({context:3,contextWindowId:re,cli:this.g.args,urisToOpen:V,forceNewWindow:J.forceNewWindow})}async showItemInFolder(V,J){t.shell.showItemInFolder(J)}async setRepresentedFilename(V,J){this.w(V)?.setRepresentedFilename(J)}async setDocumentEdited(V,J){this.w(V)?.setDocumentEdited(J)}async openExternal(V,J){return y.isLinuxSnap?this.u(J):t.shell.openExternal(J),!0}u(V){const J=process.env.GDK_PIXBUF_MODULE_FILE,re=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(V),process.env.GDK_PIXBUF_MODULE_FILE=J,process.env.GDK_PIXBUF_MODULEDIR=re}moveItemToTrash(V,J){return t.shell.trashItem(J)}async isAdmin(){let V;return y.isWindows?V=(await new Promise((J,re)=>{H(["native-is-elevated"],J,re)}))():V=process.getuid()===0,V}async writeElevated(V,J,re,se){const ae=await new Promise((fe,ge)=>{H(["@vscode/sudo-prompt"],fe,ge)});return new Promise((fe,ge)=>{const q=[`"${this.v}"`];se?.unlock&&q.push("--file-chmod"),q.push("--file-write",`"${J.fsPath}"`,`"${re.fsPath}"`);const T={name:this.i.nameLong.replace("-",""),icns:y.isMacintosh&&this.g.isBuilt?(0,b.join)((0,b.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};ae.exec(q.join(" "),T,(U,z,Q)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),Q&&this.h.trace(`[sudo-prompt] received stderr: ${Q}`),U?ge(U):fe(void 0)})})}get v(){return y.isWindows?this.g.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,b.join)(this.g.appRoot,"scripts","code-cli.bat"):y.isLinux?this.g.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,b.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,b.join)(this.g.appRoot,"bin","code"):(0,b.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,P.totalmem)(),freemem:(0,P.freemem)(),loadavg:(0,P.loadavg)()}}async getOSProperties(){return{arch:(0,P.arch)(),platform:(0,P.platform)(),release:(0,P.release)(),type:(0,P.type)(),cpus:(0,P.cpus)()}}async getOSVirtualMachineHint(){return v.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return y.isWindows&&(0,C.hasWSLFeatureInstalled)()}async killProcess(V,J,re){process.kill(J,re)}async readClipboardText(V,J){return t.clipboard.readText(J)}async writeClipboardText(V,J,re){return t.clipboard.writeText(J,re)}async readClipboardFindText(V){return t.clipboard.readFindText()}async writeClipboardFindText(V,J){return t.clipboard.writeFindText(J)}async writeClipboardBuffer(V,J,re,se){return t.clipboard.writeBuffer(J,Buffer.from(re.buffer),se)}async readClipboardBuffer(V,J){return h.VSBuffer.wrap(t.clipboard.readBuffer(J))}async hasClipboard(V,J,re){return t.clipboard.has(J,re)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(V,J){this.w(V)?.updateTouchBar(J)}async notifyReady(V){this.w(V)?.setReady()}async relaunch(V,J){return this.f.relaunch(J)}async reload(V,J){const re=this.w(V);if(re){if((0,c.isWorkspaceIdentifier)(re.openedWorkspace)){const se=re.openedWorkspace.configPath;if(se.scheme===p.Schemas.file&&(await this.l.resolveLocalWorkspace(se))?.transient)return this.openWindow(re.id,{forceReuseWindow:!0})}return this.f.reload(re,J?.disableExtensions!==void 0?{_:[],"disable-extensions":J.disableExtensions}:void 0)}}async closeWindow(V){this.closeWindowById(V,V)}async closeWindowById(V,J){const re=this.w(J);if(re?.win)return re.win.close()}async quit(V){const J=this.b.getLastActiveWindow();J?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&J.win?J.win.close():this.f.quit()}async exit(V,J){await this.f.kill(J)}async resolveProxy(V,J){const se=this.w(V)?.win?.webContents?.session;if(se)return se.resolveProxy(J)}findFreePort(V,J,re,se,ae=1){return(0,u.findFreePort)(J,re,se,ae)}async openDevTools(V,J){const re=this.w(V);re?.win&&re.win.webContents.openDevTools(J)}async toggleDevTools(V){const J=this.w(V);J?.win&&J.win.webContents.toggleDevTools()}async sendInputEvent(V,J){const re=this.w(V);re?.win&&(J.type==="mouseDown"||J.type==="mouseUp")&&re.win.webContents.sendInputEvent(J)}async enableSandbox(V,J){J?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(V,J,re){const se=this.w(V);if(!se||!se.win)throw new Error;return await new L.WindowProfiler(se.win,J,this.h).inspect(re)}async windowsGetStringRegKey(V,J,re,se){if(!y.isWindows)return;const ae=await new Promise((fe,ge)=>{H(["@vscode/windows-registry"],fe,ge)});try{return ae.GetStringRegKey(J,re,se)}catch{return}}w(V){if(typeof V=="number")return this.b.getWindowById(V)}};pe([M.memoize],B.prototype,"v",null),B=pe([_(1,o.IWindowsMainService),_(2,k.IDialogMainService),_(3,i.ILifecycleMainService),_(4,E.IEnvironmentMainService),_(5,l.ILogService),_(6,n.IProductService),_(7,s.IThemeMainService),_(8,O.IStateMainService),_(9,r.IWorkspacesManagementMainService)],B),e.NativeHostMainService=B}),define(ee[272],te([0,1,14,42,26,36,2,15,4,102,165,86,120,57,28,5,6,58,64,19,65,75,32,11,34]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k,E,D,i,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,v.createDecorator)("issueMainService");const s="issue.processExplorerWindowState";let o=class Bt{constructor(h,C,L,O,B,K,V,J,re,se){this.g=h,this.h=C,this.i=L,this.j=O,this.k=B,this.l=K,this.m=V,this.n=J,this.o=re,this.p=se,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async h=>{const[C,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),O=await this.j.getSystemInfo(C,L);this.r(h,"vscode:issueSystemInfoResponse",O)}),t.validatedIpcMain.on("vscode:listProcesses",async h=>{const C=[];try{C.push({name:(0,p.localize)(0,null),rootProcess:await(0,w.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(O=>{(0,b.isRemoteDiagnosticError)(O)?C.push({name:O.hostName,rootProcess:O}):O.processes&&C.push({name:O.hostName,rootProcess:O.processes})})}catch(L){this.i.error(`Listing processes failed: ${L}`)}this.r(h,"vscode:listProcessesResponse",C)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async h=>{const C={title:this.o.nameLong,message:(0,p.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,p.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,p.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const L=await this.l.showMessageBox(C,this.b);this.r(h,"vscode:issueReporterClipboardResponse",L.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async h=>{const C=await this.v();this.r(h,"vscode:issuePerformanceInfoResponse",C)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const h={title:this.o.nameLong,message:(0,p.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,p.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,p.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(h,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(h,C)=>{const{id:L,from:O,args:B}=C;let K;switch(O){case"issueReporter":K=this.c;break;case"processExplorer":K=this.f;break;default:throw new Error(`Unexpected command source: ${O}`)}K?.webContents.send("vscode:runAction",{id:L,from:O,args:B})}),t.validatedIpcMain.on("vscode:openExternal",(h,C)=>{this.m.openExternal(void 0,C)}),t.validatedIpcMain.on("vscode:closeIssueReporter",h=>{this.b?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",h=>{this.d?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async h=>{const C=await this.k.getMainDiagnostics();this.r(h,"vscode:windowsInfoResponse",C.windows)})}r(h,C,...L){h.sender.isDestroyed()||h.sender.send(C,...L)}async openReporter(h){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const C=new M.DisposableStore,L=C.add(this.n.createIPCObjectUrl()),O=this.u(this.c,700,800);this.b=this.t(O,L,{backgroundColor:h.styles.backgroundColor,title:(0,p.localize)(7,null),zoomLevel:h.zoomLevel,alwaysOnTop:!1},"issue-reporter"),L.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:h,disableExtensions:!!this.h.disableExtensions,os:{type:(0,P.type)(),arch:(0,P.arch)(),release:(0,P.release)()},product:g.default}),this.b.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,C.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,C.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(h){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const C=new M.DisposableStore,L=C.add(this.n.createIPCObjectUrl()),O=this.p.getItem(s,void 0),B=c(O)?O:this.u(this.f,800,500),K=S.screen.getDisplayNearestPoint({x:B.x,y:B.y});B.width/=K.scaleFactor,B.height/=K.scaleFactor,this.d=this.t(B,L,{backgroundColor:h.styles.backgroundColor,title:(0,p.localize)(8,null),zoomLevel:h.zoomLevel,alwaysOnTop:!0},"process-explorer"),L.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:h,product:g.default}),this.d.loadURL(I.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,C.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,C.dispose())});const V=()=>{if(!this.d)return;const J=this.d.getSize(),re=this.d.getPosition();if(!J||!re)return;const se={width:J[0],height:J[1],x:re[0],y:re[1]};this.p.setItem(s,se)};this.d.on("moved",V),this.d.on("resized",V)}this.d&&this.s(this.d)}s(h){h.isMinimized()&&h.restore(),h.focus()}t(h,C,L,O){const B=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:h.width,height:h.height,minWidth:300,minHeight:200,x:h.x,y:h.y,title:L.title,backgroundColor:L.backgroundColor||Bt.a,webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${C.resource.toString()}`,`--vscode-window-kind=${O}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(L.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:L.alwaysOnTop,experimentalDarkMode:!0});return B.setMenuBarVisibility(!1),B}async getSystemStatus(){const[h,C]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(h,C)}u(h,C,L){let O;const B=S.screen.getAllDisplays();if(B.length===1)O=B[0];else{if(m.isMacintosh){const J=S.screen.getCursorScreenPoint();O=S.screen.getDisplayNearestPoint(J)}!O&&h&&(O=S.screen.getDisplayMatching(h.getBounds())),O||(O=S.screen.getPrimaryDisplay()||B[0])}const K=O.bounds,V={width:C,height:L,x:K.x+K.width/2-C/2,y:K.y+K.height/2-L/2};return K.width>0&&K.height>0&&(V.x<K.x&&(V.x=K.x),V.y<K.y&&(V.y=K.y),V.x>K.x+K.width&&(V.x=K.x),V.y>K.y+K.height&&(V.y=K.y),V.width>K.width&&(V.width=K.width),V.height>K.height&&(V.height=K.height)),V}async v(){try{const[h,C]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(h,C)}catch(h){throw this.i.warn("issueService#getPerformanceInfo ",h.message),h}}async stopTracing(){if(!this.h.args.trace)return;const h=await S.contentTracing.stopRecording(`${(0,i.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,p.localize)(9,null),detail:(0,p.localize)(10,null,h),buttons:[(0,R.mnemonicButtonLabel)((0,p.localize)(11,null))],defaultId:0,noLink:!0},(0,l.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,h)}};o.a="#1E1E1E",o=pe([_(1,d.IEnvironmentMainService),_(2,a.ILogService),_(3,b.IDiagnosticsService),_(4,y.IDiagnosticsMainService),_(5,f.IDialogMainService),_(6,u.INativeHostMainService),_(7,E.IProtocolMainService),_(8,k.IProductService),_(9,n.IStateMainService)],o),e.IssueMainService=o;function c(r){return typeof r!="object"||r===null?!1:"x"in r&&"y"in r&&"width"in r&&"height"in r}}),define(ee[273],te([0,1,22,18,28,21,6,58,19,56,24,49,92]),function(H,e,S,t,P,R,M,I,m,w,p,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends y.AbstractUpdateService{constructor(v,a,u,g,k,E,D,i){super(v,a,g,k,E,i),this.e=u,this.u=D}s(v){return(0,y.createUpdateURL)(`linux-${process.arch}`,v,this.k)}t(v){!this.a||(this.d(b.State.CheckingForUpdates(v)),this.i.request({url:this.a},S.CancellationToken.None).then(w.asJson).then(a=>{!a||!a.url||!a.version||!a.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(b.State.Idle(1))):this.d(b.State.AvailableForDownload(a))}).then(void 0,a=>{this.j.error(a),this.e.publicLog2("update:notAvailable",{explicit:!!v});const u=v?a.message||a:void 0;this.d(b.State.Idle(1,u))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(b.State.Idle(1))}};f=pe([_(0,R.ILifecycleMainService),_(1,t.IConfigurationService),_(2,p.ITelemetryService),_(3,P.IEnvironmentMainService),_(4,w.IRequestService),_(5,M.ILogService),_(6,I.INativeHostMainService),_(7,m.IProductService)],f),e.LinuxUpdateService=f}),define(ee[274],te([0,1,46,41,26,8,22,54,9,7,129,23,18,28,16,21,6,58,19,56,24,49,92]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k,E,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(c,r=1e3){for(;!c();)await(0,R.timeout)(r)}let n;function s(){return typeof n>"u"&&(n=t.existsSync(m.join(m.dirname(process.execPath),"unins000.exe"))?0:1),n}let o=class extends i.AbstractUpdateService{get cachePath(){const r=m.join((0,P.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return b.Promises.mkdir(r,{recursive:!0}).then(()=>r)}constructor(r,h,C,L,O,B,K,V,J){super(r,h,L,O,B,J),this.u=C,this.v=K,this.w=V}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(r){let h="win32";return process.arch!=="ia32"&&(h+=`-${process.arch}`),s()===1?h+="-archive":this.k.target==="user"&&(h+="-user"),(0,i.createUpdateURL)(h,r,this.k)}t(r){!this.a||(this.d(D.State.CheckingForUpdates(r)),this.i.request({url:this.a},M.CancellationToken.None).then(k.asJson).then(h=>{const C=s();return!h||!h.url||!h.version||!h.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!r}),this.d(D.State.Idle(C)),Promise.resolve(null)):C===1?(this.d(D.State.AvailableForDownload(h)),Promise.resolve(null)):(this.d(D.State.Downloading(h)),this.B(h.version).then(()=>this.A(h.version).then(L=>b.Promises.exists(L).then(O=>{if(O)return Promise.resolve(L);const B=h.url,K=h.hash,V=`${L}.tmp`;return this.i.request({url:B},M.CancellationToken.None).then(J=>this.v.writeFile(w.URI.file(V),J.stream)).then(K?()=>(0,p.checksum)(V,h.hash):()=>{}).then(()=>b.Promises.rename(V,L)).then(()=>L)})).then(L=>{const O=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:L},O&&h.supportsFastUpdate?this.k.target==="user"?this.p():this.d(D.State.Downloaded(h)):this.d(D.State.Ready(h))})))}).then(void 0,h=>{this.j.error(h),this.u.publicLog2("update:notAvailable",{explicit:!!r});const C=r?h.message||h:void 0;this.d(D.State.Idle(s(),C))}))}async o(r){r.update.url&&this.w.openExternal(void 0,r.update.url),this.d(D.State.Idle(s()))}async A(r){const h=await this.cachePath;return m.join(h,`CodeSetup-${this.k.quality}-${r}.exe`)}async B(r=null){const h=r?B=>!new RegExp(`${this.k.quality}-${r}\\.exe$`).test(B):()=>!0,C=await this.cachePath,O=(await b.Promises.readdir(C)).filter(h).map(async B=>{try{await b.Promises.unlink(m.join(C,B))}catch{}});await Promise.all(O)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const r=this.state.update;this.d(D.State.Updating(r));const h=await this.cachePath;this.e.updateFilePath=m.join(h,`CodeSetup-${this.k.quality}-${r.version}.flag`),await b.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(D.State.Idle(s()))});const L=`${this.k.win32MutexName}-ready`,O=await new Promise((B,K)=>{H(["windows-mutex"],B,K)});l(()=>O.isActive(L)).then(()=>this.d(D.State.Ready(r)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?t.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return s()}async _applySpecificUpdate(r){if(this.state.type!=="idle")return;const h=this.g.getValue("update.enableWindowsBackgroundUpdates"),C={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!h};this.d(D.State.Downloading(C)),this.e={packagePath:r},h?this.k.target==="user"?this.p():this.d(D.State.Downloaded(C)):this.d(D.State.Ready(C))}};pe([I.memoize],o.prototype,"cachePath",null),o=pe([_(0,v.ILifecycleMainService),_(1,y.IConfigurationService),_(2,E.ITelemetryService),_(3,f.IEnvironmentMainService),_(4,k.IRequestService),_(5,a.ILogService),_(6,d.IFileService),_(7,u.INativeHostMainService),_(8,g.IProductService)],o),e.Win32UpdateService=o}),define(ee[275],te([0,1,14,8,22,45,3,36,2,15,9,63,4,7,173,62,18,57,28,61,16,21,6,19,65,236,94,24,241,67,75,30,29,53,117,122,38,34,52,58,238,113,51,91,26,114]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k,E,D,i,l,n,s,o,c,r,h,C,L,O,B,K,V,J,re,se,ae,fe,ge,q,T,U,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(x){x[x.NONE=0]="NONE",x[x.NAVIGATING=1]="NAVIGATING",x[x.READY=2]="READY"})(Q||(Q={}));let ne=class gt extends m.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const A=this.O.profiles.find(F=>F.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&A?A:this.O.getProfileForWorkspace(this.config.workspace??(0,O.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.O.defaultProfile}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(A,F,W,N,$,G,j,X,Z,oe,de,ke,De,Pe,Ae,ve,me,ye,Me,ie){super(),this.L=F,this.M=W,this.N=N,this.O=$,this.P=G,this.Q=j,this.R=X,this.S=Z,this.U=oe,this.W=de,this.X=ke,this.Y=De,this.Z=Pe,this.ab=Ae,this.bb=ve,this.db=me,this.eb=ye,this.fb=Me,this.gb=ie,this.c=this.B(new M.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new M.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new M.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new M.Emitter),this.onDidClose=this.h.event,this.j=this.B(new M.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.db.createIPCObjectUrl()),this.J=!1,this.hb=0;{const[ue,he]=this.sb(A.state);this.r=ue,this.L.trace("window#ctor: using window state",ue);const be=this.r.mode===0||this.r.mode===3;typeof gt.b>"u"&&(gt.b=this.fb.getItem("window.experimental.useSandbox",!1));const Ce=this.S.getValue("window");let We=!1;typeof Ce?.experimental?.useSandbox=="boolean"?We=Ce.experimental.useSandbox:this.bb.quality==="stable"&&gt.b?We=!0:We=typeof this.bb.quality=="string"&&this.bb.quality!=="stable";const Te={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.U.getBackgroundColor(),minWidth:C.WindowMinimumSize.WIDTH,minHeight:C.WindowMinimumSize.HEIGHT,show:!be,title:this.bb.nameLong,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,C.zoomLevelToZoomFactor)(Ce?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...We?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};y.isLinux?Te.icon=(0,p.join)(this.M.appRoot,"resources/linux/code.png"):y.isWindows&&!this.M.isBuilt&&(Te.icon=(0,p.join)(this.M.appRoot,"resources/win32/code_150x150.png")),y.isMacintosh&&!this.zb()&&(Te.fullscreenable=!1),y.isMacintosh&&(Te.acceptFirstMouse=!0,Ce?.clickThroughInactive===!1&&(Te.acceptFirstMouse=!1));const qe=y.isMacintosh&&Ce?.nativeTabs===!0;qe&&(Te.tabbingIdentifier=this.bb.nameShort);const Ue=(0,C.getTitleBarStyle)(this.S)==="custom";if(Ue&&(Te.titleBarStyle="hidden",y.isMacintosh||(Te.frame=!1),(0,C.useWindowControlsOverlay)(this.S))){const Be=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Xe=V.Color.fromHex(Be).isDarker()?"#FFFFFF":"#000000";Te.titleBarOverlay={height:29,color:Be,symbolColor:Xe},this.z=!0}if((0,b.mark)("code/willCreateCodeBrowserWindow"),this.l=new S.BrowserWindow(Te),(0,b.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,y.isMacintosh&&Ue&&this.l.setSheetOffset(22),Ue&&(y.isWindows&&(0,C.useWindowControlsOverlay)(this.S)||y.isMacintosh)){const Be=this.fb.getItem(gt.a);Be&&this.updateWindowControls({height:Be})}y.isWindows&&Ue&&this.l.hookWindowMessage(278,()=>{const[Xe,$e]=this.l.getPosition(),Ke=S.screen.getCursorScreenPoint(),Y=Ke.x-Xe,ce=Ke.y-$e;return(()=>!(Y>30&&ce>=0&&ce<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:Y,y:ce})),0}),(y.isMacintosh||y.isWindows)&&he&&(!qe||S.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(Be=>typeof Be=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),be&&((0,b.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.vb(!0),this.l.show(),(0,b.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.M.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.pb(),this.Db(),this.ib()}setRepresentedFilename(A){y.isMacintosh?this.l.setRepresentedFilename(A):this.v=A}getRepresentedFilename(){return y.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(A){y.isMacintosh&&this.l.setDocumentEdited(A),this.w=A}isDocumentEdited(){return y.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(A){y.isMacintosh&&A?.force&&S.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.hb=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(A=>{if(this.isReady)return A(this);this.C.push(A)})}get isReady(){return this.hb===2}get whenClosedOrLoaded(){return new Promise(A=>{function F(){W.dispose(),N.dispose(),A()}const W=this.onDidClose(()=>F()),N=this.onWillLoad(()=>F())})}ib(){this.l.on("unresponsive",()=>this.lb(1)),this.l.webContents.on("render-process-gone",(F,W)=>this.lb(2,W)),this.l.webContents.on("did-fail-load",(F,W,N)=>this.lb(3,{reason:N,exitCode:W})),this.l.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",F=>{this.n&&(this.n.maximized=!0),S.app.emit("browser-window-maximize",F,this.l)}),this.l.on("unmaximize",F=>{this.n&&(this.n.maximized=!1),S.app.emit("browser-window-unmaximize",F,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.S.onDidChangeConfiguration(F=>this.pb(F))),this.B(this.W.onDidDeleteUntitledWorkspace(F=>this.ob(F)));const A=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:A},async(F,W)=>{const N=await this.kb();W({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,N)})})}kb(){return this.jb||(this.jb=(0,s.resolveMarketplaceHeaders)(this.bb.version,this.bb,this.M,this.S,this.P,this.Q,this.Y)),this.jb}async lb(A,F){switch(A){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:A,reason:F?.reason,code:F?.exitCode}),A){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ab.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.ab.quit();return}if(A===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const W=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.n?.workspace?(0,d.localize)(5,null):void 0},this.l);if(W.response!==1){const N=W.response===0;await this.nb(N,W.checkboxChecked)}}else if(A===2)if(y.isWindows&&F?.reason==="launch-failed"&&F.exitCode===18&&await this.gb.isAdmin(void 0))await this.mb(F);else{let W;F?W=(0,d.localize)(7,null,F.reason,F.exitCode??"<unknown>"):W=(0,d.localize)(6,null);const N=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[this.n?.workspace?(0,I.mnemonicButtonLabel)((0,d.localize)(8,null)):(0,I.mnemonicButtonLabel)((0,d.localize)(9,null)),(0,I.mnemonicButtonLabel)((0,d.localize)(10,null))],message:W,detail:this.n?.workspace?(0,d.localize)(11,null):(0,d.localize)(12,null),noLink:!0,defaultId:0,checkboxLabel:this.n?.workspace?(0,d.localize)(13,null):void 0},this.l),$=N.response===0;await this.nb($,N.checkboxChecked)}break}}async mb(A){const F=[],W=(0,q.isInternalTelemetry)(this.bb,this.S);if((0,q.supportsTelemetry)(this.bb,this.M)){this.bb.aiConfig&&this.bb.aiConfig.ariaKey&&F.push(new fe.OneDataSystemAppender(W,"monacoworkbench",null,this.bb.aiConfig.ariaKey));const{installSourcePath:$}=this.M,G=await(0,z.resolveMachineId)(this.fb),j={appenders:F,sendErrorTelemetry:!1,commonProperties:(0,T.resolveCommonProperties)(this.P,(0,U.release)(),(0,U.hostname)(),process.arch,this.bb.commit,this.bb.version,G,W,$),piiPaths:(0,q.getPiiPathsFromEnvironment)(this.M)};await new ge.TelemetryService(j,this.S,this.bb).publicLog2("windowadminerror",{reason:A.reason,code:A.exitCode})}(await this.Z.showMessageBox({title:this.bb.nameLong,type:"error",buttons:[(0,I.mnemonicButtonLabel)((0,d.localize)(14,null)),(0,I.mnemonicButtonLabel)((0,d.localize)(15,null))],message:(0,d.localize)(16,null),detail:(0,d.localize)(17,null,this.bb.nameLong),noLink:!0,defaultId:0},this.l)).response===0&&await this.gb.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(F.map($=>$.flush())),await this.nb(!1,!1)}async nb(A,F){const W=this.n?.workspace;if(F&&W)try{const N=this.R.workspaceStorage(W);await N.init(),N.delete("memento/workbench.parts.editor"),await N.close()}catch(N){this.L.error(N)}if(this.j.fire(),this.l?.destroy(),A&&this.n){let N,$;(0,O.isSingleFolderWorkspaceIdentifier)(W)?N={folderUri:W.uri}:(0,O.isWorkspaceIdentifier)(W)?N={workspaceUri:W.configPath}:$=!0;const[G]=await this.eb.open({context:5,userEnv:this.n.userEnv,cli:{...this.M.args,_:[]},urisToOpen:N?[N]:void 0,forceEmpty:$,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});G.focus()}}ob(A){this.n?.workspace?.id===A.id&&(this.n.workspace=void 0)}pb(A){const F=this.Ab();F!==this.s&&(this.s=F,this.Bb(F));let W=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;W?.endsWith("/")&&(W=W.substr(0,W.length-1));const N=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((W||"").indexOf("@")===-1&&(W!==this.F||N!==this.G)){this.F=W,this.G=N;const $=W||"",G=N?`${N},<local>`:"<local>";this.L.trace(`Setting proxy to '${$}', bypassing '${G}'`),this.l.webContents.session.setProxy({proxyRules:$,proxyBypassRules:G,pacScript:""})}}addTabbedWindow(A){y.isMacintosh&&A.win&&this.l.addTabbedWindow(A.win)}load(A,F=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!F.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.bb.nameLong)),this.qb(A,F),this.hb===0?this.n=A:this.I=A,this.hb=1,this.l.loadURL(w.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const W=this.J;this.J=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new t.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:A.workspace,reason:F.isReload?3:W?2:1})}qb(A,F){const W=(this.n??this.I)?.userEnv;if(W){const N=(0,k.isLaunchedFromCli)(W)&&!(0,k.isLaunchedFromCli)(A.userEnv),$=this.isExtensionDevelopmentHost;(N||$)&&(A.userEnv={...W,...A.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(A.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(A["disable-extensions"]=F.disableExtensions),A.fullscreen=this.isFullScreen,A.maximized=this.l.isMaximized(),A.partsSplash=this.U.getWindowSplash(),(0,b.mark)("code/willOpenNewWindow"),A.perfMarks=(0,b.getMarks)(),this.H.update(A)}async reload(A){const F=Object.assign({},this.n);F.workspace=await this.rb(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&A&&(F.verbose=A.verbose,F.debugId=A.debugId,F.extensionEnvironment=A.extensionEnvironment,F["inspect-extensions"]=A["inspect-extensions"],F["inspect-brk-extensions"]=A["inspect-brk-extensions"],F["extensions-dir"]=A["extensions-dir"]),F.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),F.isInitialStartup=!1,F.policiesData=this.N.serialize(),F.continueOn=this.M.continueOn,F.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile},F.logLevel=this.L.getLevel(),this.load(F,{isReload:!0,disableExtensions:A?.["disable-extensions"]})}async rb(A){if((0,O.isWorkspaceIdentifier)(A.workspace)){const F=A.workspace.configPath;if(F.scheme===w.Schemas.file&&!await this.P.exists(F))return}else if((0,O.isSingleFolderWorkspaceIdentifier)(A.workspace)){const F=A.workspace.uri;if(F.scheme===w.Schemas.file&&!await this.P.exists(F))return}return A.workspace}serializeWindowState(){if(!this.l)return(0,K.defaultWindowState)();if(this.isFullScreen){let W;try{W=S.screen.getDisplayMatching(this.getBounds())}catch{}const N=(0,K.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.r.width||N.width,height:this.r.height||N.height,x:this.r.x||0,y:this.r.y||0}}const A=Object.create(null);let F;if(!y.isMacintosh&&this.l.isMaximized()?F=0:F=1,F===0?A.mode=0:A.mode=1,F===1||F===0){let W;F===1?W=this.getBounds():W=this.l.getNormalBounds(),A.x=W.x,A.y=W.y,A.width=W.width,A.height=W.height}return A}updateWindowControls(A){if(A.height&&this.fb.setItem(gt.a,A.height),y.isWindows&&this.z)this.l.setTitleBarOverlay({color:A.backgroundColor?.trim()===""?void 0:A.backgroundColor,symbolColor:A.foregroundColor?.trim()===""?void 0:A.foregroundColor,height:A.height?A.height-1:void 0});else if(y.isMacintosh&&A.height!==void 0){const F=(A.height-15)/2;this.l.setTrafficLightPosition({x:F,y:F})}}sb(A){(0,b.mark)("code/willRestoreCodeWindowState");let F=!1;if(A)try{const W=S.screen.getAllDisplays();F=W.length>1,A=this.tb(A,W)}catch(W){this.L.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return(0,b.mark)("code/didRestoreCodeWindowState"),[A||(0,K.defaultWindowState)(),F]}tb(A,F){if(this.L.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,A),typeof A.x!="number"||typeof A.y!="number"||typeof A.width!="number"||typeof A.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(A.width<=0||A.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const $=this.ub(F[0]);if($){let G=function(){!A||typeof A.x!="number"||typeof A.y!="number"||!$||(A.x<$.x&&(A.x=$.x),A.y<$.y&&(A.y=$.y))};this.L.trace("window#validateWindowState: 1 monitor working area",$),G(),A.width>$.width&&(A.width=$.width),A.height>$.height&&(A.height=$.height),A.x>$.x+$.width-128&&(A.x=$.x+$.width-A.width),A.y>$.y+$.height-128&&(A.y=$.y+$.height-A.height),G()}return A}if(A.display&&A.mode===3){const $=F.find(G=>G.id===A.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const G=(0,K.defaultWindowState)(3);return G.x=$.bounds.x,G.y=$.bounds.y,G}}let W,N;try{W=S.screen.getDisplayMatching({x:A.x,y:A.y,width:A.width,height:A.height}),N=this.ub(W)}catch{}if(W&&N&&A.x+A.width>N.x&&A.y+A.height>N.y&&A.x<N.x+N.width&&A.y<N.y+N.height)return this.L.trace("window#validateWindowState: multi-monitor working area",N),A}ub(A){if(A.workArea.width>0&&A.workArea.height>0)return A.workArea;if(A.bounds.width>0&&A.bounds.height>0)return A.bounds}getBounds(){const[A,F]=this.l.getPosition(),[W,N]=this.l.getSize();return{x:A,y:F,width:W,height:N}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(A){this.zb()?this.wb(A):this.yb(A),this.sendWhenReady(A?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.s&&this.Bb(this.s,!1)}get isFullScreen(){return y.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}wb(A){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.xb(A)}xb(A){y.isMacintosh&&(this.t=A,this.u=new t.DeferredPromise,Promise.race([this.u.p,(0,t.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(A)}yb(A){this.l.isFullScreen()&&this.xb(!1),this.l.setSimpleFullScreen(A),this.l.webContents.focus()}zb(){const A=this.S.getValue("window");return!A||typeof A.nativeFullScreen!="boolean"||A.nativeTabs?!0:A.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Ab(){let A=(0,C.getMenuBarVisibility)(this.S);return["visible","toggle","hidden"].indexOf(A)<0&&(A="classic"),A}Bb(A,F=!0){y.isMacintosh||(A==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,d.localize)(18,null)),A==="hidden"?setTimeout(()=>{this.Cb(A)}):this.Cb(A))}Cb(A){const F=this.isFullScreen;switch(A){case"classic":this.l.setMenuBarVisibility(!F),this.l.autoHideMenuBar=F;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(y.isMacintosh)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(A,F,...W){this.isReady?this.send(A,...W):this.ready().then(()=>{F.isCancellationRequested||this.send(A,...W)})}send(A,...F){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${A}' for window that is destroyed`);return}try{this.l.webContents.send(A,...F)}catch(W){this.L.warn(`Error sending IPC message to channel '${A}' of window ${this.k}: ${(0,R.toErrorMessage)(W)}`)}}}updateTouchBar(A){!y.isMacintosh||this.D.forEach((F,W)=>{const N=A[W];F.segments=this.Fb(N)})}Db(){if(!!y.isMacintosh){for(let A=0;A<10;A++){const F=this.Eb();this.D.push(F)}this.l.setTouchBar(new S.TouchBar({items:this.D}))}}Eb(A=[]){const F=this.Fb(A),W=new S.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:N=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:W.segments[N].id,from:"touchbar"})}});return W}Fb(A=[]){return A.map(W=>{let N;W.icon&&!r.ThemeIcon.isThemeIcon(W.icon)&&W.icon?.dark?.scheme===w.Schemas.file&&(N=S.nativeImage.createFromPath(f.URI.revive(W.icon.dark).fsPath),N.isEmpty()&&(N=void 0));let $;return typeof W.title=="string"?$=W.title:$=W.title.value,{id:W.id,label:N?void 0:$,icon:N}})}dispose(){super.dispose(),this.l=null}};ne.a="windowControlHeight",ne.b=void 0,ne=pe([_(1,i.ILogService),_(2,g.IEnvironmentMainService),_(3,J.IPolicyService),_(4,se.IUserDataProfilesMainService),_(5,E.IFileService),_(6,o.IApplicationStorageMainService),_(7,o.IStorageMainService),_(8,a.IConfigurationService),_(9,h.IThemeMainService),_(10,B.IWorkspacesManagementMainService),_(11,v.IBackupMainService),_(12,c.ITelemetryService),_(13,u.IDialogMainService),_(14,D.ILifecycleMainService),_(15,l.IProductService),_(16,n.IProtocolMainService),_(17,L.IWindowsMainService),_(18,re.IStateMainService),_(19,ae.INativeHostMainService)],ne),e.CodeWindow=ne}),define(ee[77],te([0,1,14,25,8,3,36,2,15,4,20,7,23,176,5,21,6,94,95,29,53,40]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let i=class rt extends I.Disposable{constructor(n,s,o,c){super(),this.f=n,this.g=s,this.h=o,this.j=c,this.c=this.B(new R.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new P.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let s=[],o=[];for(const r of n)if((0,g.isRecentWorkspace)(r))!this.g.isUntitledWorkspace(r.workspace)&&!this.r(s,r.workspace)&&s.push(r);else if((0,g.isRecentFolder)(r))this.s(s,r.folderUri)||s.push(r);else{const h=this.t(o,r.fileUri),C=r.fileUri.scheme===m.Schemas.file&&rt.y.indexOf((0,p.basename)(r.fileUri))>=0;!h&&!C&&(o.push(r),w.isWindows&&r.fileUri.scheme===m.Schemas.file&&S.app.addRecentDocument(r.fileUri.fsPath))}const c=await this.l({workspaces:s,files:o});s=c.workspaces,o=c.files,s.length>rt.a&&(s.length=rt.a),o.length>rt.a&&(o.length=rt.a),await this.n({workspaces:s,files:o}),this.c.fire(),w.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(n){const s=h=>{const C=this.p(h);for(const L of n)if(p.extUriBiasedIgnorePathCase.isEqual(L,C))return!1;return!0},o=await this.getRecentlyOpened(),c=o.workspaces.filter(s),r=o.files.filter(s);(c.length!==o.workspaces.length||r.length!==o.files.length)&&(await this.n({files:r,workspaces:c}),this.c.fire(),w.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(n){const s=new D.ResourceMap(r=>p.extUriBiasedIgnorePathCase.getComparisonKey(r));if(n?.workspaces)for(const r of n.workspaces)s.set(this.p(r),r);const o=new D.ResourceMap(r=>p.extUriBiasedIgnorePathCase.getComparisonKey(r));if(n?.files)for(const r of n.files)o.set(this.p(r),r);const c=await this.m();for(const r of c.workspaces){const h=s.get(this.p(r));h?h.label=h.label??r.label:s.set(this.p(r),r)}for(const r of c.files){const h=o.get(this.p(r));h?h.label=h.label??r.label:o.set(this.p(r),r)}return{workspaces:[...s.values()],files:[...o.values()]}}async m(){await this.j.whenReady;let n;const s=this.j.get(rt.b,-1);if(typeof s=="string")try{n=JSON.parse(s)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,g.restoreRecentlyOpened)(n,this.f)}async n(n){await this.j.whenReady,this.j.store(rt.b,JSON.stringify((0,g.toStoreData)(n)),-1,1)}p(n){return(0,g.isRecentFolder)(n)?n.folderUri:(0,g.isRecentFile)(n)?n.fileUri:n.workspace.configPath}r(n,s){return!!n.find(o=>(0,g.isRecentWorkspace)(o)&&o.workspace.id===s.id)}s(n,s){return!!n.find(o=>(0,g.isRecentFolder)(o)&&p.extUriBiasedIgnorePathCase.isEqual(o.folderUri,s))}t(n,s){return!!n.find(o=>p.extUriBiasedIgnorePathCase.isEqual(o.fileUri,s))}async C(){!w.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!w.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const s=[];for(const r of S.app.getJumpListSettings().removedItems){const h=r.args;if(h){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);C&&s.push(b.URI.parse(C[2]))}}await this.removeRecentlyOpened(s);let o=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.w).map(r=>{const h=(0,g.isRecentWorkspace)(r)?r.workspace:r.folderUri,{title:C,description:L}=this.F(h,r.label);let O;return b.URI.isUri(h)?O=`--folder-uri "${h.toString()}"`:(o=!0,O=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:L.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&n.push({type:"custom",name:o?(0,f.localize)(2,null):(0,f.localize)(3,null),items:c})}n.push({type:"recent"});try{const s=S.app.setJumpList(n);s&&s!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${s}`)}catch(s){this.f.warn("updateWindowsJumpList#setJumpList",s)}}F(n,s){if(s)return{title:(0,M.splitName)(s).name,description:s};if(b.URI.isUri(n))return{title:(0,p.basename)(n),description:this.G(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,f.localize)(4,null),description:""};let o=(0,p.basename)(n.configPath);return o.endsWith(k.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-k.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,o),description:this.G(n.configPath)}}G(n){return n.scheme==="file"?(0,M.normalizeDriveLetter)(n.fsPath):n.toString()}async H(){if(!w.isMacintosh)return;S.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),s=[];let o=0;for(let r=0;r<n.workspaces.length&&o<rt.u;r++){const h=this.p(n.workspaces[r]);if(h.scheme===m.Schemas.file){const C=(0,p.originalFSPath)(h);await y.Promises.exists(C)&&(s.push(C),o++)}}const c=[];for(let r=0;r<n.files.length&&o<rt.v;r++){const h=this.p(n.files[r]);if(h.scheme===m.Schemas.file){const C=(0,p.originalFSPath)(h);if(rt.y.includes((0,p.basename)(h))||s.includes(C))continue;await y.Promises.exists(C)&&(c.push(C),o++)}}c.reverse().forEach(r=>S.app.addRecentDocument(r)),s.reverse().forEach(r=>S.app.addRecentDocument(r))}};i.a=500,i.b="history.recentlyOpenedPathsList",i.u=7,i.v=10,i.w=7,i.y=["COMMIT_EDITMSG","MERGE_MSG"],i=pe([_(0,a.ILogService),_(1,E.IWorkspacesManagementMainService),_(2,v.ILifecycleMainService),_(3,u.IApplicationStorageMainService)],i),e.WorkspacesHistoryMainService=i}),define(ee[276],te([0,1,14,8,22,36,4,7,166,18,28,21,6,214,58,19,34,24,49,75,30,77]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let l=class Ft{constructor(o,c,r,h,C,L,O,B,K,V,J){this.n=o,this.o=c,this.p=r,this.q=h,this.r=C,this.s=L,this.t=O,this.u=B,this.v=K,this.w=V,this.x=J,this.m=Object.create(null),this.g=new t.RunOnceScheduler(()=>this.E(),0),this.h=new t.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(M.isMacintosh||(0,k.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(Ft.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(L,O,B)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.newWindow"]=(L,O,B)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.files.openFileFolder"]=(L,O,B)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(B),telemetryExtraData:{from:i}}),this.m["workbench.action.files.openFolder"]=(L,O,B)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(B),telemetryExtraData:{from:i}}),this.m["workbench.action.openWorkspace"]=(L,O,B)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(B),telemetryExtraData:{from:i}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.twitterUrl;o&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(o,"openTwitterUrl"));const c=this.x.requestFeatureUrl;c&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(c,"openUserVoiceUrl"));const r=this.x.reportIssueUrl;r&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(r,"openReportIssues"));const h=this.x.licenseUrl;h&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(M.language){const L=h.indexOf("?")>0?"&":"?";this.Z(`${h}${L}lang=${M.language}`,"openLicenseUrl")}else this.Z(h,"openLicenseUrl")});const C=this.x.privacyStatementUrl;C&&h&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(C,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!M.isMacintosh)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,c){this.k=o.menus,this.l=o.keybindings,this.t.setItem(Ft.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){!M.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){!M.isMacintosh||(this.f=!S.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=S.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){S.Menu.setApplicationMenu(M.isMacintosh?new S.Menu:null);return}const c=new S.Menu;let r;if(M.isMacintosh){const C=new S.Menu;r=new S.MenuItem({label:this.x.nameShort,submenu:C}),this.I(C),c.append(r)}if(M.isMacintosh&&!this.c){this.c=!0;const C=new S.Menu;C.append(new S.MenuItem({label:this.bb(m.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(C)}if(this.K("File")){const C=new S.Menu,L=new S.MenuItem({label:this.bb(m.localize(1,null)),submenu:C});this.M(C,"File"),c.append(L)}if(this.K("Edit")){const C=new S.Menu,L=new S.MenuItem({label:this.bb(m.localize(2,null)),submenu:C});this.M(C,"Edit"),c.append(L)}if(this.K("Selection")){const C=new S.Menu,L=new S.MenuItem({label:this.bb(m.localize(3,null)),submenu:C});this.M(C,"Selection"),c.append(L)}if(this.K("View")){const C=new S.Menu,L=new S.MenuItem({label:this.bb(m.localize(4,null)),submenu:C});this.M(C,"View"),c.append(L)}if(this.K("Go")){const C=new S.Menu,L=new S.MenuItem({label:this.bb(m.localize(5,null)),submenu:C});this.M(C,"Go"),c.append(L)}if(this.K("Run")){const C=new S.Menu,L=new S.MenuItem({label:this.bb(m.localize(6,null)),submenu:C});this.M(C,"Run"),c.append(L)}if(this.K("Terminal")){const C=new S.Menu,L=new S.MenuItem({label:this.bb(m.localize(7,null)),submenu:C});this.M(C,"Terminal"),c.append(L)}let h;if(this.K("Window")){const C=new S.Menu;h=new S.MenuItem({label:this.bb(m.localize(8,null)),submenu:C,role:"window"}),this.S(C)}if(h&&c.append(h),this.K("Help")){const C=new S.Menu,L=new S.MenuItem({label:this.bb(m.localize(9,null)),submenu:C,role:"help"});this.M(C,"Help"),c.append(L)}c.items&&c.items.length>0?S.Menu.setApplicationMenu(c):S.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const c=this.U(m.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),r=this.T();let h;if(this.K("Preferences")){const re=new S.Menu;this.M(re,"Preferences"),h=new S.MenuItem({label:this.bb(m.localize(11,null)),submenu:re})}const C=new S.Menu,L=new S.MenuItem({label:m.localize(12,null),role:"services",submenu:C}),O=new S.MenuItem({label:m.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),B=new S.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),K=new S.MenuItem({label:m.localize(15,null),role:"unhide"}),V=new S.MenuItem(this.Y("workbench.action.quit",{label:m.localize(16,null,this.x.nameLong),click:async(re,se,ae)=>{const fe=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||fe?.isMinimized())&&await this.J(ae)&&this.w.quit(void 0)}})),J=[c];J.push(...r),h&&J.push(n(),h),J.push(n(),L,n(),O,B,K,n(),V),J.forEach(re=>o.append(re))}async J(o){if(this.p.getWindowCount()===0)return!0;const c=this.o.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.Q(o)){const r={title:this.x.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(m.localize(17,null)),(0,R.mnemonicButtonLabel)(m.localize(18,null))],message:m.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:h}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,r);return h===0}return!0}K(o){if(!M.isMacintosh&&(0,k.getTitleBarStyle)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(M.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(M.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,c){c.forEach(r=>{if((0,f.isMenubarMenuItemSeparator)(r))o.append(n());else if((0,f.isMenubarMenuItemSubmenu)(r)){const h=new S.Menu,C=new S.MenuItem({label:this.bb(r.label),submenu:h});this.L(h,r.submenu.items),o.append(C)}else(0,f.isMenubarMenuItemRecentAction)(r)?o.append(this.O(r)):(0,f.isMenubarMenuItemAction)(r)&&(r.id==="workbench.action.showAboutDialog"&&this.N(o),M.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[r.id]?o.append(new S.MenuItem(this.Y(r.id,{label:this.bb(r.label),click:this.m[r.id]}))):o.append(this.U(r.label,r.id,!1,r.checked)):o.append(this.U(r.label,r.id,r.enabled!==!1,!!r.checked)):o.append(this.U(r.label,r.id,r.enabled!==!1,!!r.checked)))})}M(o,c){this.k&&this.k[c]&&this.L(o,this.k[c].items)}N(o){const c=this.T();c.length&&(c.forEach(r=>o.append(r)),o.append(n()))}O(o){const c=I.URI.revive(o.uri),r=o.id,h=r==="openRecentFile"?{fileUri:c}:r==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new S.MenuItem(this.Y(r,{label:o.label,click:async(C,L,O)=>{const B=this.P(O);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[h],forceNewWindow:B,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([c])}},!1))}P(o){return!!(o&&(!M.isMacintosh&&(o.ctrlKey||o.shiftKey)||M.isMacintosh&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,c,r){const h={label:this.bb(o),role:r,enabled:!0};return new S.MenuItem(this.X(c,h))}S(o){const c=new S.MenuItem({label:m.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),r=new S.MenuItem({label:m.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),h=new S.MenuItem({label:m.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),C=this.U(m.localize(23,null),"workbench.action.switchWindow"),L=[];this.C&&(L.push(n()),L.push(this.U(m.localize(24,null),"workbench.action.newWindowTab")),L.push(this.R(m.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.R(m.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.R(m.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.R(m.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,r,n(),C,...L,n(),h].forEach(O=>o.append(O))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.bb(m.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:m.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.bb(m.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:m.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.bb(m.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:m.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.bb(m.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(o,c,r,h){const C=this.bb(o),L=typeof c=="function"?c:(J,re,se)=>{const ae=J?J.userSettingsLabel:null;let fe=c;Array.isArray(c)&&(fe=this.P(se)?c[1]:c[0]),ae&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ae}):this.W({type:"commandId",commandId:fe})},O=typeof r=="boolean"?r:this.p.getWindowCount()>0,B=typeof h=="boolean"?h:!1,K={label:C,click:L,enabled:O};B&&(K.type="checkbox",K.checked=B);let V;return typeof c=="string"?V=c:Array.isArray(c)&&(V=c[0]),M.isMacintosh&&(V==="editor.action.clipboardCutAction"?K.role="cut":V==="editor.action.clipboardCopyAction"?K.role="copy":V==="editor.action.clipboardPasteAction"&&(K.role="paste"),V==="undo"?K.click=this.V(L,{inDevTools:J=>J.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):V==="redo"?K.click=this.V(L,{inDevTools:J=>J.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):V==="editor.action.selectAll"&&(K.click=this.V(L,{inDevTools:J=>J.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.X(V,K))}V(o,c){return(r,h,C)=>{const L=S.BrowserWindow.getFocusedWindow();if(!L)return c.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return c.inDevTools(L.webContents.devToolsWebContents);o(r,h||L,C)}}W(o){let c=S.BrowserWindow.getFocusedWindow();if(!c){const h=this.p.getLastActiveWindow();h?.isMinimized()&&(c=h.win)}const r=c?this.p.getWindowById(c.id):void 0;if(r){if(this.v.trace("menubar#runActionInRenderer",o),M.isMacintosh&&!this.q.isBuilt&&!r.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const h={id:o.commandId,from:"menu"};r.sendWhenReady("vscode:runAction",P.CancellationToken.None,h)}else{const h={userSettingsLabel:o.userSettingsLabel};r.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,h)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,c){const r=typeof o=="string"?this.l[o]:void 0;if(r?.label){if(r.isNative!==!1)c.accelerator=r.label,c.userSettingsLabel=r.userSettingsLabel;else if(typeof c.label=="string"){const h=c.label.indexOf("[");h>=0?c.label=`${c.label.substr(0,h)} [${r.label}]`:c.label=`${c.label} [${r.label}]`}}else c.accelerator=void 0;return c}Y(o,c,r=!c.accelerator){r&&(c=this.X(o,c));const h=c.click;return c.click=(C,L,O)=>{this.ab(o),h?.(C,L,O)},c}Z(o,c){this.w.openExternal(void 0,o),this.ab(c)}ab(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:i})}bb(o){return(0,R.mnemonicMenuLabel)(o,!this.B)}};l.a="lastKnownMenubarData",l=pe([_(0,g.IUpdateService),_(1,w.IConfigurationService),_(2,E.IWindowsMainService),_(3,p.IEnvironmentMainService),_(4,u.ITelemetryService),_(5,D.IWorkspacesHistoryMainService),_(6,a.IStateMainService),_(7,b.ILifecycleMainService),_(8,y.ILogService),_(9,d.INativeHostMainService),_(10,v.IProductService)],l),e.Menubar=l;function n(){return new S.MenuItem({type:"separator"})}}),define(ee[277],te([0,1,5,21,6,276]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,S.createDecorator)("menubarMainService");let M=class{constructor(m,w,p){this.b=m,this.c=w,this.d=p,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.Menubar)}async updateMenubar(m,w){this.d.trace("menubarService#updateMenubar",m),(await this.a).updateMenu(w,m)}};M=pe([_(0,S.IInstantiationService),_(1,t.ILifecycleMainService),_(2,P.ILogService)],M),e.MenubarMainService=M}),define(ee[278],te([0,1,14,23,26,25,22,3,32,50,36,2,15,9,63,4,35,20,11,7,174,62,18,57,28,16,5,21,6,64,19,65,55,34,75,275,119,270,29,96,77,53,67,38,52]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k,E,D,i,l,n,s,o,c,r,h,C,L,O,B,K,V,J,re,se,ae,fe,ge,q,T,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(x){return(0,se.isWorkspaceIdentifier)(x?.workspace)}function Q(x){return(0,se.isSingleFolderWorkspaceIdentifier)(x?.workspace)}let ne=class mt extends b.Disposable{constructor(A,F,W,N,$,G,j,X,Z,oe,de,ke,De,Pe,Ae,ve,me,ye){super(),this.k=A,this.l=F,this.m=W,this.n=N,this.r=$,this.s=G,this.t=j,this.u=X,this.v=Z,this.w=oe,this.z=de,this.C=ke,this.D=De,this.F=Pe,this.G=Ae,this.H=ve,this.I=me,this.J=ye,this.b=this.B(new I.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new I.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new I.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new I.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new I.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new re.WindowsStateHandler(this,this.n,this.u,this.m,this.w)),this.L()}L(){this.B(this.C.onDidEnterWorkspace(A=>this.c.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const F=new b.DisposableStore;if(F.add(I.Event.any(A.onDidClose,A.onDidDestroy)(()=>F.dispose())),A.config.extensionDevelopmentPath)for(const W of A.config.extensionDevelopmentPath)F.add(this.I.addValidFileRoot(W));A.config.extensionTestsPath&&F.add(this.I.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,F){const W=this.s.args,N=F?.remoteAuthority||void 0,$=!0,G=F?.forceReuseWindow,j=!G;return this.open({...A,cli:W,forceEmpty:$,forceNewWindow:j,forceReuseWindow:G,remoteAuthority:N})}openExistingWindow(A,F){A.focus(),this.M(F,[A])}async open(A){this.m.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const F=[],W=[],N=[],$=[],G=[];let j,X=0;const Z=await this.S(A);this.m.trace("windowsManager#open pathsToOpen",Z);for(const Pe of Z)Q(Pe)?A.addMode?F.push(Pe):W.push(Pe):z(Pe)?N.push(Pe):Pe.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),j.filesToOpenOrCreate.push(Pe)):Pe.backupPath?G.push({backupFolder:(0,f.basename)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):X++;A.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),A.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&A.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?($.push(...this.C.getUntitledWorkspaces()),N.push(...$),G.push(...this.v.getEmptyWindowBackups())):G.length=0;const{windows:oe,filesOpenedInWindow:de}=await this.N(A,N,W,G,X,j,F);if(this.m.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${W.length}, emptyToRestore: ${G.length}, emptyToOpen: ${X})`),oe.length>1)if(de)de.focus();else{const Pe=this.j.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let Ae=!0,ve=!0;if(Pe){const me=oe.filter(ye=>this.j.state.lastActiveWindow&&ye.backupPath===this.j.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Ae=!1,ve=!1)}if(Ae)for(let me=oe.length-1;me>=0;me--){const ye=oe[me];if(!(ye.openedWorkspace&&$.some(Me=>ye.openedWorkspace&&Me.workspace.id===ye.openedWorkspace.id)||ye.backupPath&&G.some(Me=>ye.backupPath&&Me.backupFolder===(0,f.basename)(ye.backupPath)))){ye.focus(),ve=!1;break}}ve&&oe[oe.length-1].focus()}const ke=j&&j.filesToDiff.length>0,De=j&&j.filesToMerge.length>0;if(!oe.some(Pe=>Pe.isExtensionDevelopmentHost)&&!ke&&!De&&!A.noRecentEntry){const Pe=[];for(const Ae of Z)z(Ae)&&!Ae.transient?Pe.push({label:Ae.label,workspace:Ae.workspace,remoteAuthority:Ae.remoteAuthority}):Q(Ae)?Pe.push({label:Ae.label,folderUri:Ae.workspace.uri,remoteAuthority:Ae.remoteAuthority}):Ae.fileUri&&Pe.push({label:Ae.label,fileUri:Ae.fileUri,remoteAuthority:Ae.remoteAuthority});this.z.addRecentlyOpened(Pe)}return this.M(A,oe),oe}M(A,F){const W=A.waitMarkerFileURI;A.context===0&&W&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.G.del(W)}catch{}})()}async N(A,F,W,N,$,G,j){const X=[];let Z;function oe(me,ye){X.push(me),ye&&(Z=me,G=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:ke}=this.fb(A);if(!A.initialStartup&&j.length>0){const me=j[0].remoteAuthority,ye=this.kb(me);ye&&oe(this.P(ye,j.map(Me=>Me.workspace.uri)))}const De=W.length+F.length+N.length;if(G&&De===0){const me=G.filesToOpenOrCreate[0]||G.filesToDiff[0]||G.filesToMerge[3],ye=this.getWindows().filter(ie=>G&&(0,u.isEqualAuthority)(ie.remoteAuthority,G.remoteAuthority));let Me;me?.fileUri&&!ke&&((A.context===4||A.context===0||A.context===1)&&(Me=await(0,J.findWindowOnFile)(ye,me.fileUri,async ie=>ie.configPath.scheme===y.Schemas.file?this.C.resolveLocalWorkspace(ie.configPath):void 0)),Me||(Me=this.lb(ye))),Me?(0,se.isWorkspaceIdentifier)(Me.openedWorkspace)?F.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)?W.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):oe(this.O(A,Me,G),!0):oe(await this.gb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:G,forceNewWindow:!0,remoteAuthority:G.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Pe=(0,R.distinct)(F,me=>me.workspace.id);if(Pe.length>0){const me=(0,R.coalesce)(Pe.map(ye=>(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.configPath)));if(me.length>0){const ye=me[0],Me=(0,u.isEqualAuthority)(G?.remoteAuthority,ye.remoteAuthority)?G:void 0;oe(this.O(A,ye,Me),!!Me),de=!0}for(const ye of Pe){if(me.some(ue=>ue.openedWorkspace&&ue.openedWorkspace.id===ye.workspace.id))continue;const Me=ye.remoteAuthority,ie=(0,u.isEqualAuthority)(G?.remoteAuthority,Me)?G:void 0;oe(await this.R(A,ye,de,ie),!!ie),de=!0}}const Ae=(0,R.distinct)(W,me=>u.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(Ae.length>0){const me=(0,R.coalesce)(Ae.map(ye=>(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.uri)));if(me.length>0){const ye=me[0],Me=(0,u.isEqualAuthority)(G?.remoteAuthority,ye.remoteAuthority)?G:void 0;oe(this.O(A,ye,Me),!!Me),de=!0}for(const ye of Ae){if(me.some(ue=>(0,se.isSingleFolderWorkspaceIdentifier)(ue.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(ue.openedWorkspace.uri,ye.workspace.uri)))continue;const Me=ye.remoteAuthority,ie=(0,u.isEqualAuthority)(G?.remoteAuthority,Me)?G:void 0;oe(await this.R(A,ye,de,ie),!!ie),de=!0}}const ve=(0,R.distinct)(N,me=>me.backupFolder);if(ve.length>0)for(const me of ve){const ye=me.remoteAuthority,Me=(0,u.isEqualAuthority)(G?.remoteAuthority,ye)?G:void 0;oe(await this.Q(A,!0,ye,Me,me),!!Me),de=!0}if(X.length===0||G){G&&!$&&$++;const me=G?G.remoteAuthority:A.remoteAuthority;for(let ye=0;ye<$;ye++)oe(await this.Q(A,de,me,G),!!G),de=!0}return{windows:(0,R.distinct)(X),filesOpenedInWindow:Z}}O(A,F,W){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),F.focus();const N={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",M.CancellationToken.None,N),F}P(A,F){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),A.focus();const W={foldersToAdd:F};return A.sendWhenReady("vscode:addFolders",M.CancellationToken.None,W),A}Q(A,F,W,N,$){this.m.trace("windowsManager#doOpenEmpty",{restore:!!$,remoteAuthority:W,filesToOpen:N,forceNewWindow:F});let G;return!F&&typeof A.contextWindowId=="number"&&(G=this.getWindowById(A.contextWindowId)),this.gb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:W,forceNewWindow:F,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:N,windowToUse:G,emptyWindowBackupInfo:$,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}R(A,F,W,N,$){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:N}),!W&&!$&&typeof A.contextWindowId=="number"&&($=this.getWindowById(A.contextWindowId)),this.gb({workspace:F.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:N,windowToUse:$,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async S(A){let F,W=!1,N=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(F=await this.U(A),W=!0):A.forceEmpty?F=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(F=await this.W(A.cli),F.length===0&&F.push(Object.create(null)),W=!0):(F=await this.Y(),F.length===0&&F.push(Object.create(null)),N=!0),!A.addMode&&W){const $=F.filter(G=>Q(G));if($.length>1){const G=$[0].remoteAuthority;if($.every(j=>(0,u.isEqualAuthority)(j.remoteAuthority,G))){const j=await this.C.createUntitledWorkspace($.map(X=>({uri:X.workspace.uri})));F.push({workspace:j,remoteAuthority:G}),F=F.filter(X=>!Q(X))}}}if(A.initialStartup&&!N&&this.w.getValue("window")?.restoreWindows==="preserve"){const $=await this.Y();F.unshift(...$.filter(G=>z(G)||Q(G)||G.backupPath))}return F}async U(A){const F={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},W=await Promise.all((0,R.coalesce)(A.urisToOpen||[]).map(async N=>{const $=await this.ab(N,F);if($)return $.label=N.label,$;const G=this.cb(N),j={title:this.H.nameLong,type:"info",buttons:[(0,p.mnemonicButtonLabel)((0,E.localize)(0,null))],defaultId:0,message:G.scheme===y.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:G.scheme===y.Schemas.file?(0,E.localize)(3,null,(0,p.getPathLabel)(G,{os:v.OS,tildify:this.s})):(0,E.localize)(4,null,G.toString(!0)),noLink:!0};this.F.showMessageBox(j,(0,g.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(W)}async W(A){const F=[],W={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},N=A["folder-uri"];if(N){const j=await Promise.all(N.map(X=>{const Z=this.X(X);if(!!Z)return this.ab({folderUri:Z},W)}));F.push(...(0,R.coalesce)(j))}const $=A["file-uri"];if($){const j=await Promise.all($.map(X=>{const Z=this.X(X);if(!!Z)return this.ab((0,se.hasWorkspaceFileExtension)(X)?{workspaceUri:Z}:{fileUri:Z},W)}));F.push(...(0,R.coalesce)(j))}const G=await Promise.all(A._.map(j=>W.remoteAuthority?this.eb(j,W):this.db(j,W)));return F.push(...(0,R.coalesce)(G)),F}X(A){try{const F=k.URI.parse(A);if(!F.scheme){this.m.error(`Invalid URI input string, scheme missing: ${A}`);return}return F}catch(F){this.m.error(`Invalid URI input string: ${A}, ${F.message}`)}}async Y(){const A=this.Z();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];A!=="one"&&F.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&F.push(this.j.state.lastActiveWindow);const W=await Promise.all(F.map(async N=>{if(N.workspace){const $=await this.ab({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});if(z($))return $}else if(N.folderUri){const $=await this.ab({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});if(Q($))return $}else if(A!=="folders"&&N.backupPath)return{backupPath:N.backupPath,remoteAuthority:N.remoteAuthority}}));return(0,R.coalesce)(W)}}}Z(){let A;return this.u.wasRestarted?A="all":(A=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async ab(A,F=Object.create(null)){const W=this.cb(A);return W.scheme===y.Schemas.file?((0,K.isFileToOpen)(A)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.db(W.fsPath,F)):this.bb(A,F)}bb(A,F){let W=this.cb(A);const N=(0,O.getRemoteAuthority)(W)||F.remoteAuthority;if(W=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)(W)),(0,K.isFileToOpen)(A)){if(F.gotoLineMode){const{path:$,line:G,column:j}=(0,m.parseLineAndColumnAware)(W.path);return{fileUri:W.with({path:$}),options:{selection:G?{startLineNumber:G,startColumn:j||1}:void 0},remoteAuthority:N}}return{fileUri:W,remoteAuthority:N}}else if((0,K.isWorkspaceToOpen)(A))return{workspace:(0,ae.getWorkspaceIdentifier)(W),remoteAuthority:N};return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(W),remoteAuthority:N}}cb(A){return(0,K.isWorkspaceToOpen)(A)?A.workspaceUri:(0,K.isFolderToOpen)(A)?A.folderUri:A.fileUri}async db(A,F){let W,N;F.gotoLineMode&&({path:A,line:W,column:N}=(0,m.parseLineAndColumnAware)(A)),A=(0,m.sanitizeFilePath)((0,f.normalize)(A),(0,a.cwd)());try{const $=await t.Promises.stat(A);if($.isFile()){if(!F.forceOpenWorkspaceAsFile){const G=await this.C.resolveLocalWorkspace(k.URI.file(A));if(G)return G.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:G.id,configPath:G.configPath},type:s.FileType.File,exists:!0,remoteAuthority:G.remoteAuthority,transient:G.transient}}return{fileUri:k.URI.file(A),type:s.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:N||1}:void 0}}}else{if($.isDirectory())return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(k.URI.file(A),$),type:s.FileType.Directory,exists:!0};if(!v.isWindows&&A==="/dev/null")return{fileUri:k.URI.file(A),type:s.FileType.File,exists:!0}}}catch{const G=k.URI.file(A);if(this.z.removeRecentlyOpened([G]),F.ignoreFileNotFound)return{fileUri:G,type:s.FileType.File,exists:!1}}}eb(A,F){const W=A.charCodeAt(0),N=F.remoteAuthority;let $,G;F.gotoLineMode&&({path:A,line:$,column:G}=(0,m.parseLineAndColumnAware)(A)),W!==47&&((0,m.isWindowsDriveLetter)(W)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,m.toSlashes)(A)),A=`/${A}`);const j=k.URI.from({scheme:y.Schemas.vscodeRemote,authority:N,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(A))return F.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:$?{startLineNumber:$,startColumn:G||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,ae.getWorkspaceIdentifier)(j),remoteAuthority:N};if(F.gotoLineMode||f.posix.basename(A).indexOf(".")!==-1)return{fileUri:j,options:{selection:$?{startLineNumber:$,startColumn:G||1}:void 0},remoteAuthority:N}}return{workspace:(0,ae.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:N}}fb(A){const F=this.w.getValue("window"),W=F?.openFoldersInNewWindow||"default",N=F?.openFilesInNewWindow||"off";let $=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(W==="on"||W==="off")&&($=W==="on");let G=!1;return A.forceNewWindow||A.forceReuseWindow?G=!!A.forceNewWindow&&!A.forceReuseWindow:(v.isMacintosh?A.context===1&&(G=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(G=!0),!A.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(G=N==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:G}}async openExtensionDevelopmentHostWindow(A,F){const W=(0,J.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(W)return this.u.reload(W,F.cli),W.focus(),[W];let N=F.cli["folder-uri"]||[],$=F.cli["file-uri"]||[],G=F.cli._;if(!G.length&&!N.length&&!$.length&&!F.cli.extensionTestsPath){const Z=this.j.state.lastPluginDevelopmentHostWindow,oe=Z?.workspace??Z?.folderUri;oe&&(k.URI.isUri(oe)?oe.scheme===y.Schemas.file?G=[oe.fsPath]:N=[oe.toString()]:oe.configPath.scheme===y.Schemas.file?G=[(0,u.originalFSPath)(oe.configPath)]:$=[oe.configPath.toString()])}let j=F.remoteAuthority;for(const Z of A)if(Z.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const oe=k.URI.parse(Z),de=(0,O.getRemoteAuthority)(oe);de&&(j?(0,u.isEqualAuthority)(de,j)||this.m.error("more than one extension development path authority"):j=de)}G=G.filter(Z=>{const oe=k.URI.file(Z);return(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(oe),j)}),N=N.filter(Z=>{const oe=this.X(Z);return oe&&!!(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(oe),j):!1}),$=$.filter(Z=>{const oe=this.X(Z);return oe&&!!(0,J.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,u.isEqualAuthority)((0,O.getRemoteAuthority)(oe),j):!1}),F.cli._=G,F.cli["folder-uri"]=N,F.cli["file-uri"]=$;const X={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!G.length&&!N.length&&!$.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:j,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(X)}async gb(A){const F=this.w.getValue("window");let W;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(W=A.windowToUse||this.getLastActiveWindow(),W&&W.focus());const N={...this.s.args,...A.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,f.join)(this.s.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.t.profiles,profile:this.t.defaultProfile},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.l,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),logsPath:this.s.logsPath,product:h.default,isInitialStartup:A.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,P.release)(),hostname:(0,P.hostname)()},zoomLevel:typeof F?.zoomLevel=="number"?F.zoomLevel:void 0,autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn};if(W){const $=W.config;!N.extensionDevelopmentPath&&$?.extensionDevelopmentPath&&(N.extensionDevelopmentPath=$.extensionDevelopmentPath,N.extensionDevelopmentKind=$.extensionDevelopmentKind,N["enable-proposed-api"]=$["enable-proposed-api"],N.verbose=$.verbose,N["inspect-extensions"]=$["inspect-extensions"],N["inspect-brk-extensions"]=$["inspect-brk-extensions"],N.debugId=$.debugId,N.extensionEnvironment=$.extensionEnvironment,N["extensions-dir"]=$["extensions-dir"],N["disable-extensions"]=$["disable-extensions"])}else{const $=this.j.getNewWindowState(N);(0,d.mark)("code/willCreateCodeWindow");const G=W=this.D.createInstance(V.CodeWindow,{state:$,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(G),mt.a.push(G),this.b.fire(G),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(G.onDidSignalReady)(()=>this.c.fire(G)),(0,w.once)(G.onDidClose)(()=>this.jb(G)),(0,w.once)(G.onDidDestroy)(()=>this.f.fire(G)),G.onDidTriggerSystemContextMenu(({x:X,y:Z})=>this.h.fire({window:G,x:X,y:Z}));const j=(0,g.assertIsDefined)(G.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.u.reload(G)),this.u.registerWindow(G)}return N.windowId=W.id,W.isReady?this.u.unload(W,4).then(async $=>{$||await this.hb(W,N,A)}):await this.hb(W,N,A),W}async hb(A,F,W){if(F.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(F.workspace)?F.backupPath=this.v.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(F.workspace)?F.backupPath=this.v.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.v.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,ae.createEmptyWorkspaceIdentifier)().id,remoteAuthority:F.remoteAuthority})),this.t.isEnabled()){const N=F.workspace??(0,se.toWorkspaceIdentifier)(F.backupPath,!1),$=this.ib(W,N),G=$ instanceof Promise?await $:$;F.profiles.profile=G,F.extensionDevelopmentPath||await this.t.setProfileForWorkspace(N,G)}A.load(F)}ib(A,F){return A.forceProfile?this.t.profiles.find(W=>W.name===A.forceProfile)??this.t.createNamedProfile(A.forceProfile):A.forceTempProfile?this.t.createTransientProfile():this.t.getProfileForWorkspace(F)??this.t.defaultProfile}jb(A){const F=mt.a.indexOf(A);mt.a.splice(F,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=S.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(A){return this.lb(this.getWindows().filter(F=>(0,u.isEqualAuthority)(F.remoteAuthority,A)))}lb(A){const F=Math.max.apply(Math,A.map(W=>W.lastFocusTime));return A.find(W=>W.lastFocusTime===F)}sendToFocused(A,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,M.CancellationToken.None,...F)}sendToAll(A,F,W){for(const N of this.getWindows())W&&W.indexOf(N.id)>=0||N.sendWhenReady(A,M.CancellationToken.None,F)}getWindows(){return mt.a}getWindowCount(){return mt.a.length}getWindowById(A){const F=this.getWindows().filter(W=>W.id===A);return(0,R.firstOrDefault)(F)}getWindowByWebContents(A){const F=S.BrowserWindow.fromWebContents(A);if(!!F)return this.getWindowById(F.id)}};ne.a=[],ne=pe([_(2,r.ILogService),_(3,B.IStateMainService),_(4,T.IPolicyService),_(5,n.IEnvironmentMainService),_(6,U.IUserDataProfilesMainService),_(7,c.ILifecycleMainService),_(8,D.IBackupMainService),_(9,i.IConfigurationService),_(10,fe.IWorkspacesHistoryMainService),_(11,ge.IWorkspacesManagementMainService),_(12,o.IInstantiationService),_(13,l.IDialogMainService),_(14,s.IFileService),_(15,C.IProductService),_(16,L.IProtocolMainService),_(17,q.IThemeMainService)],ne),e.WindowsMainService=ne}),define(ee[279],te([0,1,62,30,77,53]),function(H,e,S,t,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(m,w,p,b){this.a=m,this.b=w,this.c=p,this.d=b,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(m,w){const p=this.b.getWindowById(m);if(p)return this.a.enterWorkspace(p,this.b.getWindows(),w)}createUntitledWorkspace(m,w,p){return this.a.createUntitledWorkspace(w,p)}deleteUntitledWorkspace(m,w){return this.a.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(m,w){return this.a.getWorkspaceIdentifier(w)}getRecentlyOpened(m){return this.c.getRecentlyOpened()}addRecentlyOpened(m,w){return this.c.addRecentlyOpened(w)}removeRecentlyOpened(m,w){return this.c.removeRecentlyOpened(w)}clearRecentlyOpened(m){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};M=pe([_(0,R.IWorkspacesManagementMainService),_(1,t.IWindowsMainService),_(2,P.IWorkspacesHistoryMainService),_(3,S.IBackupMainService)],M),e.WorkspacesMainService=M}),define(ee[280],te([0,1,14,42,26,17,45,13,32,50,43,36,2,15,9,4,11,7,31,133,47,147,104,253,150,62,271,18,73,182,86,120,57,107,205,28,61,111,195,217,196,258,108,197,198,16,209,88,72,5,87,272,230,255,21,6,211,277,58,19,55,265,90,34,261,94,91,24,235,113,51,49,244,245,273,246,274,116,248,249,250,251,259,30,278,260,29,95,77,279,53,254,38,216,52,226,56,76,118,263,269,267,8,114,262]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k,E,D,i,l,n,s,o,c,r,h,C,L,O,B,K,V,J,re,se,ae,fe,ge,q,T,U,z,Q,ne,x,A,F,W,N,$,G,j,X,Z,oe,de,ke,De,Pe,Ae,ve,me,ye,Me,ie,ue,he,be,Ce,We,Te,qe,Ue,Be,Xe,$e,Ke,Y,ce,le,we,Se,Oe,je,it,xe,He,tt,nt,lt,at,jt,$t,zt,qt,Ht,Vt,Gt,Pt,Kt,Jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends y.Disposable{constructor(Ee,Re,Le,Ie,Fe,ze,_e,et,Ne,Ge,Je){super(),this.c=Ee,this.f=Re,this.g=Le,this.h=Ie,this.i=Fe,this.j=ze,this.k=_e,this.l=et,this.m=Ne,this.n=Ge,this.p=Je,this.r(),this.s()}r(){const Ee=Ne=>Ne?.startsWith(`${f.Schemas.vscodeWebview}://`),Re=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Je(Re.has(Ge)):Je(!1)),S.session.defaultSession.setPermissionCheckHandler((Ne,Ge,Je,Ze)=>Ee(Ze.requestingUrl)?Re.has(Ge):!1);const Le=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),Ie=Ne=>{for(let Ge=Ne;Ge;Ge=Ge.parent)if(Ge.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Fe=Ne=>Ne.resourceType==="xhr"||Ie(Ne.frame),ze=Ne=>{const Ge=Ne.frame;if(!Ge||!this.a)return!1;const Je=S.BrowserWindow.getAllWindows();for(const Ze of Je)if(Ge.processId===Ze.webContents.mainFrame.processId)return!0;return!1},_e=(Ne,Ge)=>{if(Ne.path!=="/index.html")return!0;const Je=Ge.frame;if(!Je||!this.a)return!1;for(const Ze of this.a.getWindows())if(Ze.win&&Je.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((Ne,Ge)=>{const Je=u.URI.parse(Ne.url);return Je.scheme===f.Schemas.vscodeWebview&&!_e(Je,Ne)?(this.h.error("Blocked vscode-webview request",Ne.url),Ge({cancel:!0})):Je.scheme===f.Schemas.vscodeFileResource&&!ze(Ne)?(this.h.error("Blocked vscode-file request",Ne.url),Ge({cancel:!0})):Je.path.endsWith(".svg")&&!Le.has(Je.scheme)?Ge({cancel:!Fe(Ne)}):Ge({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((Ne,Ge)=>{const Je=Ne.responseHeaders,Ze=Je["content-type"]||Je["Content-Type"];if(Ze&&Array.isArray(Ze)){const st=u.URI.parse(Ne.url);if(st.path.endsWith(".svg")&&Le.has(st.scheme))return Je["Content-Type"]=["image/svg+xml"],Ge({cancel:!1,responseHeaders:Je});if(!st.path.endsWith(f.Schemas.vscodeRemoteResource)&&Ze.some(ct=>ct.toLowerCase().includes("image/svg")))return Ge({cancel:!Fe(Ne)})}return Ge({cancel:!1})});const et=S.session.defaultSession;typeof et.setCodeCachePath=="function"&&this.i.codeCachePath&&et.setCodeCachePath((0,d.join)(this.i.codeCachePath,"chrome"))}s(){(0,I.setUnexpectedErrorHandler)(Le=>this.u(Le)),process.on("uncaughtException",Le=>(0,I.onUnexpectedError)(Le)),process.on("unhandledRejection",Le=>(0,I.onUnexpectedError)(Le)),this.j.onWillShutdown(()=>this.dispose()),(0,k.registerContextMenuListener)(),S.app.on("accessibility-support-changed",(Le,Ie)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),S.app.on("activate",async(Le,Ie)=>{this.h.trace("app#activate"),Ie||await this.a?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Le,Ie)=>{Ie.on("will-navigate",Fe=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Ie.setWindowOpenHandler(({url:Fe})=>(this.b?.openExternal(void 0,Fe),{action:"deny"}))});let Ee=[],Re;S.app.on("open-file",(Le,Ie)=>{this.h.trace("app#open-file: ",Ie),Le.preventDefault(),Ee.push((0,Oe.hasWorkspaceFileExtension)(Ie)?{workspaceUri:u.URI.file(Ie)}:{fileUri:u.URI.file(Ie)}),Re!==void 0&&(clearTimeout(Re),Re=void 0),Re=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],Re=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Le=>{const Ie=this.a?.getWindowByWebContents(Le.sender);let Fe,ze;return Ie?.config?(Fe=Ie.config,ze={...process.env,...Ie.config.userEnv}):(Fe=this.i.args,ze=process.env),this.J(Fe,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Le,Ie,Fe)=>{const ze=this.t([Ie]);if(!ze||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(ze,R.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Le,...Ie)=>{const Fe=this.t(Ie);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Le=>Le.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Le=>Le.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Le=>Le.sender.reload())}t(Ee){let Re;for(const Le of Ee)typeof Le=="string"&&(typeof Re!="string"?Re=Le:Re=(0,d.join)(Re,Le));if(!(typeof Re!="string"||!(0,d.isAbsolute)(Re)||!(0,m.isEqualOrParent)(Re,this.i.cachedLanguagesPath,!v.isLinux)))return u.URI.file(Re)}u(Ee){if(Ee){const Re={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Re))}this.h.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.h.error(Ee.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Ee=this.n.win32AppUserModelId;v.isWindows&&Ee&&S.app.setAppUserModelId(Ee);try{v.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Re=new D.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&Re.dispose()}),this.h.trace("Resolving machine identifier...");const Le=await(0,Kt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${Le}`);const{sharedProcess:Ie,sharedProcessReady:Fe,sharedProcessClient:ze}=this.w(Le),_e=await this.y(Le,Ie,Fe);this.v(_e),_e.invokeFunction(Ne=>this.z(Ne,Re,ze)),await _e.invokeFunction(Ne=>this.C(Ne,Re)),_e.invokeFunction(Ne=>this.G(Ne,Ie)),this.B(new Pt.RunOnceScheduler(()=>{this.B((0,Pt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Ee){this.B(Ee.createInstance(l.ProxyAuthHandler)),this.B(Ee.createInstance(Vt.UserDataProfilesHandler))}w(Ee){const Re=this.B(this.g.createInstance(De.SharedProcess,Ee,this.f)),Le=(async()=>{this.h.trace("Main->SharedProcess#connect");const Fe=await Re.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new i.Client(Fe,"main")})(),Ie=(async()=>(await Re.whenReady(),Le))();return{sharedProcess:Re,sharedProcessReady:Ie,sharedProcessClient:Le}}async y(Ee,Re,Le){const Ie=new F.ServiceCollection;switch(process.platform){case"win32":Ie.set(be.IUpdateService,new x.SyncDescriptor(Ue.Win32UpdateService));break;case"linux":v.isLinuxSnap?Ie.set(be.IUpdateService,new x.SyncDescriptor(qe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(be.IUpdateService,new x.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Ie.set(be.IUpdateService,new x.SyncDescriptor(We.DarwinUpdateService));break}Ie.set(le.IWindowsMainService,new x.SyncDescriptor(we.WindowsMainService,[Ee,this.f],!1));const Fe=new O.DialogMainService(this.h);Ie.set(O.IDialogMainService,Fe),Ie.set($.ILaunchMainService,new x.SyncDescriptor($.LaunchMainService,void 0,!1)),Ie.set(L.IDiagnosticsMainService,new x.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),Ie.set(C.IDiagnosticsService,E.ProxyChannel.toService((0,E.getDelayedChannel)(Le.then(et=>et.getChannel("diagnostics"))))),Ie.set(W.IIssueMainService,new x.SyncDescriptor(W.IssueMainService,[this.f])),Ie.set(B.IEncryptionMainService,new x.SyncDescriptor(K.EncryptionMainService,[Ee])),Ie.set(N.IKeyboardLayoutMainService,new x.SyncDescriptor(N.KeyboardLayoutMainService)),Ie.set(oe.INativeHostMainService,new x.SyncDescriptor(oe.NativeHostMainService,[Re],!1)),Ie.set(r.ICredentialsMainService,new x.SyncDescriptor(tt.CredentialsNativeMainService)),Ie.set(Y.IWebviewManagerService,new x.SyncDescriptor(ce.WebviewMainService)),Ie.set(Z.IMenubarMainService,new x.SyncDescriptor(Z.MenubarMainService)),Ie.set(se.IExtensionUrlTrustService,new x.SyncDescriptor(ae.ExtensionUrlTrustService)),Ie.set(fe.IExtensionHostStarter,new x.SyncDescriptor(ge.ExtensionHostStarter)),Ie.set(me.IStorageMainService,new x.SyncDescriptor(me.StorageMainService)),Ie.set(me.IApplicationStorageMainService,new x.SyncDescriptor(me.ApplicationStorageMainService)),v.isWindows?Ie.set(q.IExternalTerminalMainService,new x.SyncDescriptor(T.WindowsExternalTerminalService)):v.isMacintosh?Ie.set(q.IExternalTerminalMainService,new x.SyncDescriptor(T.MacExternalTerminalService)):v.isLinux&&Ie.set(q.IExternalTerminalMainService,new x.SyncDescriptor(T.LinuxExternalTerminalService));const ze=new o.BackupMainService(this.i,this.k,this.h,this.l);Ie.set(s.IBackupMainService,ze);const _e=new He.WorkspacesManagementMainService(this.i,this.h,this.p,ze,Fe,this.n);if(Ie.set(He.IWorkspacesManagementMainService,_e),Ie.set(je.IWorkspacesService,new x.SyncDescriptor(xe.WorkspacesMainService,void 0,!1)),Ie.set(it.IWorkspacesHistoryMainService,new x.SyncDescriptor(it.WorkspacesHistoryMainService,void 0,!1)),Ie.set(Be.IURLService,new x.SyncDescriptor($e.NativeURLService,void 0,!1)),(0,he.supportsTelemetry)(this.n,this.i)){const et=(0,he.isInternalTelemetry)(this.n,this.k),Ne=(0,E.getDelayedChannel)(Le.then(ct=>ct.getChannel("telemetryAppender"))),Ge=new ie.TelemetryAppenderClient(Ne),Je=(0,ye.resolveCommonProperties)(this.m,(0,P.release)(),(0,P.hostname)(),process.arch,this.n.commit,this.n.version,Ee,et,this.i.installSourcePath),Ze=(0,he.getPiiPathsFromEnvironment)(this.i),st={appenders:[Ge],commonProperties:Je,piiPaths:Ze,sendErrorTelemetry:!0};Ie.set(Me.ITelemetryService,new x.SyncDescriptor(ue.TelemetryService,[st],!1))}else Ie.set(Me.ITelemetryService,he.NullTelemetryService);return Ie.set(zt.IExtensionsProfileScannerService,new x.SyncDescriptor(Jt.ExtensionsProfileScannerService,void 0,!0)),Ie.set(qt.IExtensionsScannerService,new x.SyncDescriptor(Ht.ExtensionsScannerService,void 0,!0)),await Pt.Promises.settled([ze.initialize(),_e.initialize()]),this.g.createChild(Ie)}z(Ee,Re,Le){const Ie=E.ProxyChannel.fromService(Ee.get($.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ie);const Fe=E.ProxyChannel.fromService(Ee.get(L.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Fe);const ze=new lt.PolicyChannel(Ee.get(nt.IPolicyService));Re.registerChannel("policy",ze),Le.then(Ye=>Ye.registerChannel("policy",ze));const _e=this.m.getProvider(f.Schemas.file);(0,a.assertType)(_e instanceof ne.DiskFileSystemProvider);const et=new Q.DiskFileSystemProviderChannel(_e,this.h,this.i);Re.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et),Le.then(Ye=>Ye.registerChannel(U.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et));const Ne=E.ProxyChannel.fromService(Ee.get(at.IUserDataProfilesMainService));Re.registerChannel("userDataProfiles",Ne),Le.then(Ye=>Ye.registerChannel("userDataProfiles",Ne));const Ge=new jt.RequestChannel(Ee.get($t.IRequestService));Le.then(Ye=>Ye.registerChannel("request",Ge));const Je=new Ce.UpdateChannel(Ee.get(be.IUpdateService));Re.registerChannel("update",Je);const Ze=E.ProxyChannel.fromService(Ee.get(W.IIssueMainService));Re.registerChannel("issue",Ze);const st=E.ProxyChannel.fromService(Ee.get(B.IEncryptionMainService));Re.registerChannel("encryption",st);const ct=E.ProxyChannel.fromService(Ee.get(r.ICredentialsMainService));Re.registerChannel("credentials",ct);const kt=E.ProxyChannel.fromService(Ee.get(Pe.ISignService));Re.registerChannel("sign",kt);const Qe=E.ProxyChannel.fromService(Ee.get(N.IKeyboardLayoutMainService));Re.registerChannel("keyboardLayout",Qe),this.b=Ee.get(oe.INativeHostMainService);const wt=E.ProxyChannel.fromService(this.b);Re.registerChannel("nativeHost",wt),Le.then(Ye=>Ye.registerChannel("nativeHost",wt));const pt=E.ProxyChannel.fromService(Ee.get(je.IWorkspacesService));Re.registerChannel("workspaces",pt);const yt=E.ProxyChannel.fromService(Ee.get(Z.IMenubarMainService));Re.registerChannel("menubar",yt);const Dt=E.ProxyChannel.fromService(Ee.get(Be.IURLService));Re.registerChannel("url",Dt);const Rt=E.ProxyChannel.fromService(Ee.get(se.IExtensionUrlTrustService));Re.registerChannel("extensionUrlTrust",Rt);const vt=E.ProxyChannel.fromService(Ee.get(Y.IWebviewManagerService));Re.registerChannel("webview",vt);const ut=this.B(new ve.StorageDatabaseChannel(this.h,Ee.get(me.IStorageMainService)));Re.registerChannel("storage",ut),Le.then(Ye=>Ye.registerChannel("storage",ut));const St=this.B(new Gt.ProfileStorageChangesListenerChannel(Ee.get(me.IStorageMainService),Ee.get(at.IUserDataProfilesMainService),this.h));Le.then(Ye=>Ye.registerChannel("profileStorageListener",St));const bt=E.ProxyChannel.fromService(Ee.get(q.IExternalTerminalMainService));Re.registerChannel("externalTerminal",bt);const ht=new X.LogLevelChannel(Ee.get(j.ILogService),Ee.get(j.ILoggerService));Re.registerChannel("logLevel",ht),Le.then(Ye=>Ye.registerChannel("logLevel",ht));const Ve=new X.LoggerChannel(Ee.get(j.ILoggerService));Re.registerChannel("logger",Ve),Le.then(Ye=>Ye.registerChannel("logger",Ve));const ot=new h.ElectronExtensionHostDebugBroadcastChannel(Ee.get(le.IWindowsMainService));Re.registerChannel("extensionhostdebugservice",ot);const ft=E.ProxyChannel.fromService(Ee.get(fe.IExtensionHostStarter));Re.registerChannel(fe.ipcExtensionHostStarterChannelName,ft)}async C(Ee,Re){const Le=this.a=Ee.get(le.IWindowsMainService),Ie=Ee.get(Be.IURLService),Fe=Ee.get(oe.INativeHostMainService);this.j.phase=2;const ze=[],_e=[...this.i.args["open-url"]?this.i.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ve=>{try{return{uri:u.URI.parse(Ve),url:Ve}}catch{return}}).filter(Ve=>{if(!Ve||this.D(Ve.uri))return!1;const ot=this.F(Ve.uri);return ot?(ze.push(ot),!1):!0}),et=this,Ne=this.i,Ge=this.n,Je=this.h;Ie.registerHandler({async handleURL(Ve,ot){if(Je.trace("app#handleURL: ",Ve.toString(!0),ot),Ve.scheme===Ge.urlProtocol&&Ve.path==="workspace"&&(Ve=Ve.with({authority:"file",path:u.URI.parse(Ve.query).path,query:""})),et.D(Ve))return!0;let ft=!1;const Ye=new URLSearchParams(Ve.query);Ye.get("windowId")==="_blank"&&(Ye.delete("windowId"),Ve=Ve.with({query:Ye.toString()}),ft=!0),ft||=v.isMacintosh&&Le.getWindowCount()===0;const Wt=Ye.get("continueOn");Wt!==null&&(Ne.continueOn=Wt??void 0,Ye.delete("continueOn"),Ve=Ve.with({query:Ye.toString()}));const Mt=et.F(Ve);if(Je.trace("app#handleURL: windowOpenableFromProtocolLink = ",Mt),Mt){const[At]=await Le.open({context:5,cli:{...Ne.args},urisToOpen:[Mt],forceNewWindow:ft,gotoLineMode:!0});return At.focus(),!0}if(ft){const[At]=await Le.open({context:5,cli:{...Ne.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(Ve)});return await At.ready(),Ie.open(Ve,ot)}return!1}});const Ze=this.B(new Se.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),st=new E.StaticRouter(Ve=>Ze.getActiveClientId().then(ot=>Ve===ot)),ct=new Xe.URLHandlerRouter(st),kt=Re.getChannel("urlHandler",ct);Ie.registerHandler(new Xe.URLHandlerChannelClient(kt)),this.B(new Ke.ElectronURLListener(_e,Ie,Le,this.i,this.n));const Qe=this.i.args,wt=global.macOpenFiles,pt=(0,J.isLaunchedFromCli)(process.env)?0:4,yt=Qe._.length,Dt=!!Qe["folder-uri"],Rt=!!Qe["file-uri"],vt=Qe["skip-add-to-recently-opened"]===!0,ut=Qe.wait&&Qe.waitMarkerFilePath?u.URI.file(Qe.waitMarkerFilePath):void 0,St=Qe.remote||void 0,bt=Qe.profile,ht=Qe["profile-temp"];if(ze.length>0)return Le.open({context:pt,cli:Qe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});if(!yt&&!Dt&&!Rt){if(Qe["new-window"]||bt||ht)return Le.open({context:pt,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:vt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:St,forceProfile:bt,forceTempProfile:ht});if(wt.length)return Le.open({context:1,cli:Qe,urisToOpen:wt.map(Ve=>(0,Oe.hasWorkspaceFileExtension)(Ve)?{workspaceUri:u.URI.file(Ve)}:{fileUri:u.URI.file(Ve)}),noRecentEntry:vt,waitMarkerFileURI:ut,initialStartup:!0})}return Le.open({context:pt,cli:Qe,forceNewWindow:Qe["new-window"]||!yt&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:vt,waitMarkerFileURI:ut,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:St,forceProfile:bt,forceTempProfile:ht})}D(Ee){return!!(Ee.authority===f.Schemas.file&&v.isWindows&&S.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,b.mnemonicButtonLabel)((0,n.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,n.localize)(1,null))],defaultId:0,cancelId:1,message:(0,n.localize)(2,null,(0,b.getPathLabel)(Ee,{os:v.OS,tildify:this.i}),this.n.nameShort),detail:(0,n.localize)(3,null),noLink:!0})===1)}F(Ee){if(!!Ee.path){if(Ee.authority===f.Schemas.file){const Re=u.URI.file(Ee.fsPath);return(0,Oe.hasWorkspaceFileExtension)(Re)?{workspaceUri:Re}:{fileUri:Re}}else if(Ee.authority===f.Schemas.vscodeRemote){const Re=Ee.path.indexOf(d.posix.sep,1);if(Re!==-1){const Le=Ee.path.substring(1,Re),Ie=Ee.path.substring(Re),Fe=u.URI.from({scheme:f.Schemas.vscodeRemote,authority:Le,path:Ie,query:Ee.query,fragment:Ee.fragment});return(0,Oe.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Fe}:/:[\d]+$/.test(Ie)?{fileUri:Fe}:{folderUri:Fe}}}}}G(Ee,Re){const Le=Ee.get(Me.ITelemetryService),Ie=Ee.get(be.IUpdateService);this.j.phase=3,this.I(Le,Re),this.H(),S.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(Fe,ze)=>{ze({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(Ie instanceof Ue.Win32UpdateService||Ie instanceof Te.LinuxUpdateService||Ie instanceof We.DarwinUpdateService)&&Ie.initialize(),this.J(this.i.args,process.env,!0),this.L()}async H(){const Ee=this.n.win32MutexName;if(v.isWindows&&Ee)try{const Re=await new Promise((Ie,Fe)=>{H(["windows-mutex"],Ie,Fe)}),Le=new Re.Mutex(Ee);(0,w.once)(this.j.onWillShutdown)(()=>Le.release())}catch(Re){this.h.error(Re)}}I(Ee,Re){let Le=!1;(0,w.once)(this.j.onWillShutdown)(()=>Le=!0),this.B(Re.onDidError(({type:Ie,details:Fe})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(ze)),Ee.publicLog2("sharedprocesserror",{type:Ie,reason:Fe?.reason,code:Fe?.exitCode,visible:Re.isVisible(),shuttingdown:Le})}))}async J(Ee,Re,Le){try{return await(0,re.getResolvedShellEnv)(this.k,this.h,Ee,Re)}catch(Ie){const Fe=(0,M.toErrorMessage)(Ie);Le?this.a?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.h.error(Fe)}return{}}async L(){try{const Re=(await this.m.readFile(this.i.argvResource)).value.toString(),Le=JSON.parse((0,p.stripComments)(Re)),Fe=(0,he.getTelemetryLevel)(this.k)>=1;if(Le["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.generateUuid)()}"`,"}"],_e=Re.substring(0,Re.length-2).concat(`,
`,ze.join(`
`));await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(_e))}else{const ze=Re.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);ze!==Re&&await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(ze))}}catch(Ee){this.h.error(Ee)}}};Ct=pe([_(2,A.IInstantiationService),_(3,j.ILogService),_(4,V.IEnvironmentMainService),_(5,G.ILifecycleMainService),_(6,c.IConfigurationService),_(7,Ae.IStateMainService),_(8,z.IFileService),_(9,de.IProductService),_(10,at.IUserDataProfilesMainService)],Ct),e.CodeApplication=Ct}),define(ee[281],te([0,1,38,8,288,2,6]),function(H,e,S,t,P,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let I=class extends S.AbstractPolicyService{constructor(w,p){super(),this.j=w,this.k=p,this.a=new t.Throttler,this.b=this.B(new R.MutableDisposable)}async i(w){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(w).length} policy definitions`),await this.a.queue(()=>new Promise((p,b)=>{try{this.b.value=(0,P.createWatcher)(this.k,w,y=>{this.m(y),p()})}catch(y){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),b(y)}}))}m(w){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(w)}`);for(const p in w){const b=w[p];b===void 0?this.g.delete(p):this.g.set(p,b)}this.h.fire(Object.keys(w))}};I=pe([_(0,M.ILogService)],I),e.NativePolicyService=I}),define(ee[282],te([0,1,228,8,17,13,2,11,18,33,111,6,227,289]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends M.Disposable{constructor(a,u,g){super(),this.h=a,this.i=u,this.j=g,this.k(),this.B(a.onDidChangeConfiguration(k=>{k.affectsConfiguration("http")&&this.k()}))}k(){const a=this.h.getValue("http");this.a=a?.proxy,this.b=!!a?.proxyStrictSSL,this.f=a?.proxyAuthorization}async request(a,u){this.j.trace("RequestService#request (node) - begin",a.url);const{a:g,b:k}=this;let E;try{E=await(0,p.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(l){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",l))}const D={...process.env,...E},i=a.agent?a.agent:await(0,y.getProxyAgent)(a.url||"",D,{proxyUrl:g,strictSSL:k});a.agent=i,a.strictSSL=k,this.f&&(a.headers={...a.headers||{},"Proxy-Authorization":this.f});try{const l=await this.m(a,u);return this.j.trace("RequestService#request (node) - success",a.url),l}catch(l){throw this.j.trace("RequestService#request (node) - error",a.url,l),l}}async l(a){return((0,S.parse)(a.url).protocol==="https:"?await new Promise((k,E)=>{H(["https"],k,E)}):await new Promise((k,E)=>{H(["http"],k,E)})).request}m(a,u){return t.Promises.withAsyncBody(async(g,k)=>{const E=(0,S.parse)(a.url),D=a.getRawRequest?a.getRawRequest(a):await this.l(a),i={hostname:E.hostname,port:E.port?parseInt(E.port):E.protocol==="https:"?443:80,protocol:E.protocol,path:E.path,method:a.type||"GET",headers:a.headers,agent:a.agent,rejectUnauthorized:(0,I.isBoolean)(a.strictSSL)?a.strictSSL:!0};a.user&&a.password&&(i.auth=a.user+":"+a.password);const l=D(i,n=>{const s=(0,I.isNumber)(a.followRedirects)?a.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)this.m({...a,url:n.headers.location,followRedirects:s-1},u).then(g,k);else{let o=n;!a.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,f.createGunzip)())),g({res:n,stream:(0,P.streamToBufferReadableStream)(o)})}});l.on("error",k),a.timeout&&l.setTimeout(a.timeout),a.isChromiumNetwork&&l.removeHeader("Content-Length"),a.data&&typeof a.data=="string"&&l.write(a.data),l.end(),u.onCancellationRequested(()=>{l.abort(),k(new R.CancellationError)})})}async resolveProxy(a){}};d=pe([_(0,m.IConfigurationService),_(1,w.INativeEnvironmentService),_(2,b.ILogService)],d),e.RequestService=d}),define(ee[283],te([0,1,14,282]),function(H,e,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function P(M){return S.net.request}class R extends t.RequestService{request(I,m){return super.request({...I||{},getRawRequest:P,isChromiumNetwork:!0},m)}}e.RequestMainService=R}),define(ee[290],te([0,1,14,41,7,25,8,45,13,32,50,36,15,9,63,4,35,27,23,47,85,280,10,18,221,234,28,61,186,16,207,88,72,203,87,21,210,6,213,64,19,65,264,115,242,56,283,90,229,34,233,51,67,52,38,281,215,2,39,247,37,243]),function(H,e,S,t,P,R,M,I,m,w,p,b,y,f,d,v,a,u,g,k,E,D,i,l,n,s,o,c,r,h,C,L,O,B,K,V,J,re,se,ae,fe,ge,q,T,U,z,Q,ne,x,A,F,W,N,$,G,j,X,Z,oe,de,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class De{main(){try{this.a()}catch(ve){console.error(ve.message),S.app.exit(1)}}async a(){(0,m.setUnexpectedErrorHandler)(Ce=>console.error(Ce));const[ve,me,ye,Me,ie,ue,he,be]=this.b();try{try{await this.d(ye,be,Me,ie,he)}catch(Ce){throw this.f(ye,he.nameLong,Ce),Ce}await ve.invokeFunction(async Ce=>{const We=Ce.get(re.ILogService),Te=Ce.get(V.ILifecycleMainService),qe=Ce.get(h.IFileService),Ue=Ce.get(re.ILoggerService),Be=await this.e(We,ye,Te,ve,he,!0);return g.Promises.writeFile(ye.mainLockfile,String(process.pid)).catch(Xe=>{We.warn(`Error writing main lockfile: ${Xe.stack}`)}),ue.logger=Ue.createLogger(P.URI.file((0,f.join)(ye.logsPath,"main.log")),{name:"main"}),(0,p.once)(Te.onWillShutdown)(Xe=>{qe.dispose(),Me.dispose(),Xe.join(g.Promises.unlink(ye.mainLockfile).catch(()=>{}))}),ve.createInstance(D.CodeApplication,Be,me).startup()})}catch(Ce){ve.invokeFunction(this.i,Ce)}}b(){const ve=new K.ServiceCollection,me=new Z.DisposableStore;process.once("exit",()=>me.dispose());const ye={_serviceBrand:void 0,...ae.default};ve.set(fe.IProductService,ye);const Me=new o.EnvironmentMainService(this.j(),ye),ie=this.c(Me);ve.set(o.IEnvironmentMainService,Me);const ue=new J.BufferLogService,he=me.add(new re.MultiplexLogService([new re.ConsoleMainLogger((0,re.getLogLevel)(Me)),ue]));ve.set(re.ILogService,he);const be=new C.FileService(he);ve.set(h.IFileService,be);const Ce=new L.DiskFileSystemProvider(he);be.registerProvider(y.Schemas.file,Ce);const We=new de.UriIdentityService(be);ve.set(oe.IUriIdentityService,We),ve.set(re.ILoggerService,new se.LoggerService(he));const Te=new F.StateMainService(Me,he,be);ve.set(A.IStateMainService,Te);const qe=new $.UserDataProfilesMainService(Te,We,Me,be,he);ve.set($.IUserDataProfilesMainService,qe);const Ue=v.isWindows&&ye.win32RegValueName?me.add(new j.NativePolicyService(he,ye.win32RegValueName)):Me.policyFile?me.add(new X.FilePolicyService(Me.policyFile,be,he)):new G.NullPolicyService;ve.set(G.IPolicyService,Ue);const Be=new n.ConfigurationService(qe.defaultProfile.settingsResource,be,Ue,he);return ve.set(l.IConfigurationService,Be),ve.set(V.ILifecycleMainService,new O.SyncDescriptor(V.LifecycleMainService,void 0,!1)),ve.set(z.IRequestService,new O.SyncDescriptor(Q.RequestMainService,void 0,!0)),ve.set(N.IThemeMainService,new O.SyncDescriptor(N.ThemeMainService)),ve.set(ne.ISignService,new O.SyncDescriptor(x.SignService,void 0,!1)),ve.set(T.ITunnelService,new O.SyncDescriptor(U.TunnelService)),ve.set(ge.IProtocolMainService,new q.ProtocolMainService(Me,qe,he)),[new B.InstantiationService(ve,!0),ie,Me,Be,Te,ue,ye,qe]}c(ve){const me={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ye=>{const Me=process.env[ye];typeof Me=="string"&&(me[ye]=Me)}),Object.assign(process.env,me),me}async d(ve,me,ye,Me,ie){await M.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsPath,me.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(ue=>ue?g.Promises.mkdir(ue,{recursive:!0}):void 0)),Me.init(),ye.initialize()]),me.setEnablement(ie.quality!=="stable"||ye.getValue(ke.PROFILES_ENABLEMENT_CONFIG))}async e(ve,me,ye,Me,ie,ue){let he;try{(0,d.mark)("code/willStartMainServer"),he=await(0,E.serve)(me.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,p.once)(ye.onWillShutdown)(()=>he.dispose())}catch(be){if(be.code!=="EADDRINUSE")throw this.f(me,ie.nameLong,be),be;let Ce;try{Ce=await(0,E.connect)(me.mainIPCHandle,"main")}catch(Ue){if(!ue||v.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.g((0,i.localize)(0,null,ie.nameShort),(0,i.localize)(1,null),ie.nameLong),Ue;try{(0,t.unlinkSync)(me.mainIPCHandle)}catch(Be){throw ve.warn("Could not delete obsolete instance handle",Be),Be}return this.e(ve,me,ye,Me,ie,!1)}if(me.extensionTestsLocationURI&&!me.debugExtensionHost.break){const Ue=`Running extension tests from the command line is currently only supported if no other instance of ${ie.nameShort} is running.`;throw ve.error(Ue),Ce.dispose(),new Error(Ue)}let We;!me.args.wait&&!me.args.status&&(We=setTimeout(()=>{this.g((0,i.localize)(2,null,ie.nameShort),(0,i.localize)(3,null),ie.nameLong)},1e4));const Te=k.ProxyChannel.toService(Ce.getChannel("launch"),{disableMarshalling:!0}),qe=k.ProxyChannel.toService(Ce.getChannel("diagnostics"),{disableMarshalling:!0});if(me.args.status)return Me.invokeFunction(async()=>{const Ue=new s.DiagnosticsService(W.NullTelemetryService,ie),Be=await qe.getMainDiagnostics(),Xe=await qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),$e=await Ue.getDiagnostics(Be,Xe);throw console.log($e),new m.ExpectedError});throw v.isWindows&&await this.h(Te,ve),ve.trace("Sending env to running instance..."),await Te.start(me.args,process.env),Ce.dispose(),We&&clearTimeout(We),new m.ExpectedError("Sent env to running instance. Terminating...")}if(me.args.status)throw ve.warn(`Warning: The --status argument can only be used if ${ie.nameShort} is already running. Please run it again after {0} has started.`),new m.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),he}f(ve,me,ye){if(ye.code==="EACCES"||ye.code==="EPERM"){const Me=(0,R.coalesce)([ve.userDataPath,ve.extensionsPath,E.XDG_RUNTIME_DIR]).map(ie=>(0,b.getPathLabel)(P.URI.file(ie),{os:v.OS,tildify:ve}));this.g((0,i.localize)(4,null),(0,i.localize)(5,null,(0,I.toErrorMessage)(ye),Me.join(`
`)),me)}}g(ve,me,ye){S.dialog.showMessageBoxSync({title:ye,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,i.localize)(6,null))],message:ve,detail:me,defaultId:0,noLink:!0})}async h(ve,me){if(v.isWindows){const ye=await ve.getMainProcessId();me.trace("Sending some foreground love to the running instance:",ye);try{(await new Promise((Me,ie)=>{H(["windows-foreground-love"],Me,ie)})).allowSetForegroundWindow(ye)}catch(Me){me.error(Me)}}}i(ve,me){const ye=ve.get(re.ILogService),Me=ve.get(V.ILifecycleMainService);let ie=0;me&&(me.isExpected?me.message&&ye.trace(me.message):(ie=1,me.stack?ye.error(me.stack):ye.error(`Startup error: ${me.toString()}`))),Me.kill(ie)}j(){const ve=this.k((0,c.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const me=(0,r.createWaitMarkerFileSync)(ve.verbose);me&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",me),ve.waitMarkerFilePath=me)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const me=this.l(ve._,ve.goto);ve._=me}return ve}l(ve,me){const ye=(0,a.cwd)(),Me=ve.map(he=>{let be=String(he),Ce;me&&(Ce=(0,w.parseLineAndColumnAware)(be),be=Ce.path),be&&(be=this.m(ye,be));const We=(0,w.sanitizeFilePath)(be,ye),Te=(0,f.basename)(We);return Te&&!(0,w.isValidBasename)(Te)?null:me&&Ce?(Ce.path=We,this.n(Ce)):We}),ie=v.isWindows||v.isMacintosh,ue=(0,R.distinct)(Me,he=>he&&ie?he.toLowerCase():he||"");return(0,R.coalesce)(ue)}m(ve,me){return v.isWindows&&(me=(0,u.rtrim)(me,'"')),me=(0,u.trim)((0,u.trim)(me," "),"	"),v.isWindows&&(me=(0,f.resolve)(ve,me),me=(0,u.rtrim)(me,".")),me}n(ve){const me=[ve.path];return typeof ve.line=="number"&&me.push(String(ve.line)),typeof ve.column=="number"&&me.push(String(ve.column)),me.join(":")}}new De().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e7b5449579249db344d473370d56a5df9446c826/core/vs/code/electron-main/main.js.map
