/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/path","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/codicons","vs/base/common/assert","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(te){for(var e=[],c=0,t=te.length;c<t;c++)e[c]=ye[te[c]];return e};define(ye[50],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function c(R){return R?R.replace(/\$\((.*?)\)/g,(k,A)=>` ${A} `).trim():""}e.getCodiconAriaLabel=c;class t{constructor(k,A,y){this.id=k,this.definition=A,this.description=y,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var T;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function A(L){if(L instanceof t)return["codicon","codicon-"+L.id];const P=k.exec(L.id);if(!P)return A(t.error);const[,w,I]=P,v=["codicon","codicon-"+w];return I&&v.push("codicon-modifier-"+I.substring(1)),v}R.asClassNameArray=A;function y(L){return A(L).join(" ")}R.asClassName=y;function D(L){return"."+A(L).join(".")}R.asCSSSelector=D})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ye[61],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function c(k,A){const y=Object.create(null);for(const D of k){const L=A(D);let P=y[L];P||(P=y[L]=[]),P.push(D)}return y}e.groupBy=c;function t(k,A){const y=[],D=[];for(const L of k)A.has(L)||y.push(L);for(const L of A)k.has(L)||D.push(L);return{removed:y,added:D}}e.diffSets=t;function T(k,A){const y=[],D=[];for(const[L,P]of k)A.has(L)||y.push(P);for(const[L,P]of A)k.has(L)||D.push(P);return{removed:y,added:D}}e.diffMaps=T;class R{constructor(){this.a=new Map}add(A,y){let D=this.a.get(A);D||(D=new Set,this.a.set(A,D)),D.add(y)}delete(A,y){const D=this.a.get(A);!D||(D.delete(y),D.size===0&&this.a.delete(A))}forEach(A,y){const D=this.a.get(A);!D||D.forEach(y)}}e.SetMap=R}),define(ye[62],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function c(k){return(A,y,D)=>{let L=null,P=null;if(typeof D.value=="function"?(L="value",P=D.value):typeof D.get=="function"&&(L="get",P=D.get),!P)throw new Error("not supported");D[L]=k(P,y)}}function t(k,A,y){let D=null,L=null;if(typeof y.value=="function"?(D="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(D="get",L=y.get),!L)throw new Error("not supported");const P=`$memoize$${A}`;y[D]=function(...w){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,w)}),this[P]}}e.memoize=t;function T(k,A,y){return c((D,L)=>{const P=`$debounce$${L}`,w=`$debounce$result$${L}`;return function(...I){this[w]||(this[w]=y?y():void 0),clearTimeout(this[P]),A&&(this[w]=A(this[w],...I),I=[this[w]]),this[P]=setTimeout(()=>{D.apply(this,I),this[w]=y?y():void 0},k)}})}e.debounce=T;function R(k,A,y){return c((D,L)=>{const P=`$throttle$timer$${L}`,w=`$throttle$result$${L}`,I=`$throttle$lastRun$${L}`,v=`$throttle$pending$${L}`;return function(...m){if(this[w]||(this[w]=y?y():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),A&&(this[w]=A(this[w],...m)),this[v])return;const d=this[I]+k;d<=Date.now()?(this[I]=Date.now(),D.apply(this,[this[w]]),this[w]=y?y():void 0):(this[v]=!0,this[P]=setTimeout(()=>{this[v]=!1,this[I]=Date.now(),D.apply(this,[this[w]]),this[w]=y?y():void 0},d-Date.now()))}})}e.throttle=R}),define(ye[9],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class c{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?b.isErrorNoTelemetry(r)?new b(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(l=>{l(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.ErrorHandler=c,e.errorHandler=new c;function t(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=t;function T(g){y(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=T;function R(g){y(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=R;function k(g){if(g instanceof Error){const{name:r,message:l}=g,s=g.stacktrace||g.stack;return{$isError:!0,name:r,message:l,stack:s,noTelemetry:b.isErrorNoTelemetry(g)}}return g}e.transformErrorForSerialization=k;const A="Canceled";function y(g){return g instanceof D?!0:g instanceof Error&&g.name===A&&g.message===A}e.isCancellationError=y;class D extends Error{constructor(){super(A),this.name=this.message}}e.CancellationError=D;function L(){const g=new Error(A);return g.name=g.message,g}e.canceled=L;function P(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=P;function w(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=w;function I(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=I;function v(g){const r=new Error(`${g} has been disposed`);return r.name="DISPOSED",r}e.disposed=v;function m(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=m;class d extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=d;class f extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=f;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class b extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof b)return r;const l=new b;return l.message=r.message,l.stack=r.stack,l}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=b;class S extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype);debugger}}e.BugIndicatingError=S}),define(ye[16],Ce([1,0,9]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(se,oe=0){return se[se.length-(1+oe)]}e.tail=t;function T(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.tail2=T;function R(se,oe,fe=(Z,ce)=>Z===ce){if(se===oe)return!0;if(!se||!oe||se.length!==oe.length)return!1;for(let Z=0,ce=se.length;Z<ce;Z++)if(!fe(se[Z],oe[Z]))return!1;return!0}e.equals=R;function k(se,oe){const fe=se.length-1;oe<fe&&(se[oe]=se[fe]),se.pop()}e.removeFastWithoutKeepingOrder=k;function A(se,oe,fe){return y(se.length,Z=>fe(se[Z],oe))}e.binarySearch=A;function y(se,oe){let fe=0,Z=se-1;for(;fe<=Z;){const ce=(fe+Z)/2|0,ie=oe(ce);if(ie<0)fe=ce+1;else if(ie>0)Z=ce-1;else return ce}return-(fe+1)}e.binarySearch2=y;function D(se,oe){let fe=0,Z=se.length;if(Z===0)return 0;for(;fe<Z;){const ce=Math.floor((fe+Z)/2);oe(se[ce])?Z=ce:fe=ce+1}return fe}e.findFirstInSorted=D;function L(se,oe,fe){if(se=se|0,se>=oe.length)throw new TypeError("invalid index");const Z=oe[Math.floor(oe.length*Math.random())],ce=[],ie=[],N=[];for(const H of oe){const Q=fe(H,Z);Q<0?ce.push(H):Q>0?ie.push(H):N.push(H)}return se<ce.length?L(se,ce,fe):se<ce.length+N.length?N[0]:L(se-(ce.length+N.length),ie,fe)}e.quickSelect=L;function P(se,oe){const fe=[];let Z;for(const ce of se.slice(0).sort(oe))!Z||oe(Z[0],ce)!==0?(Z=[ce],fe.push(Z)):Z.push(ce);return fe}e.groupBy=P;function w(se,oe,fe){const Z=[];function ce(H,Q,Y){if(Q===0&&Y.length===0)return;const he=Z[Z.length-1];he&&he.start+he.deleteCount===H?(he.deleteCount+=Q,he.toInsert.push(...Y)):Z.push({start:H,deleteCount:Q,toInsert:Y})}let ie=0,N=0;for(;;){if(ie===se.length){ce(ie,0,oe.slice(N));break}if(N===oe.length){ce(ie,se.length-ie,[]);break}const H=se[ie],Q=oe[N],Y=fe(H,Q);Y===0?(ie+=1,N+=1):Y<0?(ce(ie,1,[]),ie+=1):Y>0&&(ce(ie,0,[Q]),N+=1)}return Z}e.sortedDiff=w;function I(se,oe,fe){const Z=w(se,oe,fe),ce=[],ie=[];for(const N of Z)ce.push(...se.slice(N.start,N.start+N.deleteCount)),ie.push(...N.toInsert);return{removed:ce,added:ie}}e.delta=I;function v(se,oe,fe){if(fe===0)return[];const Z=se.slice(0,fe).sort(oe);return d(se,oe,Z,fe,se.length),Z}e.top=v;function m(se,oe,fe,Z,ce){return fe===0?Promise.resolve([]):new Promise((ie,N)=>{(async()=>{const H=se.length,Q=se.slice(0,fe).sort(oe);for(let Y=fe,he=Math.min(fe+Z,H);Y<H;Y=he,he=Math.min(he+Z,H)){if(Y>fe&&await new Promise(we=>setTimeout(we)),ce&&ce.isCancellationRequested)throw new c.CancellationError;d(se,oe,Q,Y,he)}return Q})().then(ie,N)})}e.topAsync=m;function d(se,oe,fe,Z,ce){for(const ie=fe.length;Z<ce;Z++){const N=se[Z];if(oe(N,fe[ie-1])<0){fe.pop();const H=D(fe,Q=>oe(N,Q)<0);fe.splice(H,0,N)}}}function f(se){return se.filter(oe=>!!oe)}e.coalesce=f;function p(se){let oe=0;for(let fe=0;fe<se.length;fe++)se[fe]&&(se[oe]=se[fe],oe+=1);se.length=oe}e.coalesceInPlace=p;function b(se,oe,fe){se.splice(fe,0,se.splice(oe,1)[0])}e.move=b;function S(se){return!Array.isArray(se)||se.length===0}e.isFalsyOrEmpty=S;function g(se){return Array.isArray(se)&&se.length>0}e.isNonEmptyArray=g;function r(se,oe=fe=>fe){const fe=new Set;return se.filter(Z=>{const ce=oe(Z);return fe.has(ce)?!1:(fe.add(ce),!0)})}e.distinct=r;function l(se){const oe=new Set;return fe=>{const Z=se(fe);return oe.has(Z)?!1:(oe.add(Z),!0)}}e.uniqueFilter=l;function s(se,oe){const fe=a(se,oe);if(fe!==-1)return se[fe]}e.findLast=s;function a(se,oe){for(let fe=se.length-1;fe>=0;fe--){const Z=se[fe];if(oe(Z))return fe}return-1}e.lastIndex=a;function o(se,oe){return se.length>0?se[0]:oe}e.firstOrDefault=o;function u(se,oe){return se.length>0?se[se.length-1]:oe}e.lastOrDefault=u;function i(se,oe,fe=(Z,ce)=>Z===ce){let Z=0;for(let ce=0,ie=Math.min(se.length,oe.length);ce<ie&&fe(se[ce],oe[ce]);ce++)Z++;return Z}e.commonPrefixLength=i;function n(se){return[].concat(...se)}e.flatten=n;function h(se,oe){let fe=typeof oe=="number"?se:0;typeof oe=="number"?fe=se:(fe=0,oe=se);const Z=[];if(fe<=oe)for(let ce=fe;ce<oe;ce++)Z.push(ce);else for(let ce=fe;ce>oe;ce--)Z.push(ce);return Z}e.range=h;function E(se,oe,fe){return se.reduce((Z,ce)=>(Z[oe(ce)]=fe?fe(ce):ce,Z),Object.create(null))}e.index=E;function C(se,oe){return se.push(oe),()=>M(se,oe)}e.insert=C;function M(se,oe){const fe=se.indexOf(oe);if(fe>-1)return se.splice(fe,1),oe}e.remove=M;function K(se,oe,fe){const Z=se.slice(0,oe),ce=se.slice(oe);return Z.concat(fe,ce)}e.arrayInsert=K;function q(se,oe){let fe;if(typeof oe=="number"){let Z=oe;fe=()=>{const ce=Math.sin(Z++)*179426549;return ce-Math.floor(ce)}}else fe=Math.random;for(let Z=se.length-1;Z>0;Z-=1){const ce=Math.floor(fe()*(Z+1)),ie=se[Z];se[Z]=se[ce],se[ce]=ie}}e.shuffle=q;function F(se,oe){const fe=se.indexOf(oe);fe>-1&&(se.splice(fe,1),se.unshift(oe))}e.pushToStart=F;function B(se,oe){const fe=se.indexOf(oe);fe>-1&&(se.splice(fe,1),se.push(oe))}e.pushToEnd=B;function O(se,oe){for(const fe of oe)se.push(fe)}e.pushMany=O;function U(se,oe){return Array.isArray(se)?se.map(oe):oe(se)}e.mapArrayOrNot=U;function z(se){return Array.isArray(se)?se:[se]}e.asArray=z;function j(se){return se[Math.floor(Math.random()*se.length)]}e.getRandomElement=j;function ue(se,oe){for(const fe of se){const Z=oe(fe);if(Z!==void 0)return Z}}e.mapFind=ue;function V(se,oe,fe){const Z=J(se,oe),ce=se.length,ie=fe.length;se.length=ce+ie;for(let N=ce-1;N>=Z;N--)se[N+ie]=se[N];for(let N=0;N<ie;N++)se[N+Z]=fe[N]}e.insertInto=V;function _(se,oe,fe,Z){const ce=J(se,oe),ie=se.splice(ce,fe);return V(se,ce,Z),ie}e.splice=_;function J(se,oe){return oe<0?Math.max(oe+se.length,0):Math.min(oe,se.length)}var ne;(function(se){function oe(ce){return ce<0}se.isLessThan=oe;function fe(ce){return ce>0}se.isGreaterThan=fe;function Z(ce){return ce===0}se.isNeitherLessOrGreaterThan=Z,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(ne=e.CompareResult||(e.CompareResult={}));function ee(se,oe){return(fe,Z)=>oe(se(fe),se(Z))}e.compareBy=ee;function X(...se){return(oe,fe)=>{for(const Z of se){const ce=Z(oe,fe);if(!ne.isNeitherLessOrGreaterThan(ce))return ce}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=X;const G=(se,oe)=>se-oe;e.numberComparator=G;function de(se,oe){if(se.length===0)return;let fe=se[0];for(let Z=1;Z<se.length;Z++){const ce=se[Z];oe(ce,fe)>0&&(fe=ce)}return fe}e.findMaxBy=de;function be(se,oe){if(se.length===0)return;let fe=se[0];for(let Z=1;Z<se.length;Z++){const ce=se[Z];oe(ce,fe)>=0&&(fe=ce)}return fe}e.findLastMaxBy=be;function Ee(se,oe){return de(se,(fe,Z)=>-oe(fe,Z))}e.findMinBy=Ee;class Pe{constructor(oe){this.f=oe,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(oe){let fe=this.c;for(;fe<this.f.length&&oe(this.f[fe]);)fe++;const Z=fe===this.c?null:this.f.slice(this.c,fe);return this.c=fe,Z}takeFromEndWhile(oe){let fe=this.d;for(;fe>=0&&oe(this.f[fe]);)fe--;const Z=fe===this.d?null:this.f.slice(fe+1,this.d+1);return this.d=fe,Z}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const oe=this.f[this.c];return this.c++,oe}removeLast(){const oe=this.f[this.d];return this.d--,oe}takeCount(oe){const fe=this.f.slice(this.c,this.c+oe);return this.c+=oe,fe}}e.ArrayQueue=Pe;class Fe{constructor(oe){this.iterate=oe}forEach(oe){this.iterate(fe=>(oe(fe),!0))}toArray(){const oe=[];return this.iterate(fe=>(oe.push(fe),!0)),oe}filter(oe){return new Fe(fe=>this.iterate(Z=>oe(Z)?fe(Z):!0))}map(oe){return new Fe(fe=>this.iterate(Z=>fe(oe(Z))))}some(oe){let fe=!1;return this.iterate(Z=>(fe=oe(Z),!fe)),fe}findFirst(oe){let fe;return this.iterate(Z=>oe(Z)?(fe=Z,!1):!0),fe}findLast(oe){let fe;return this.iterate(Z=>(oe(Z)&&(fe=Z),!0)),fe}findLastMaxBy(oe){let fe,Z=!0;return this.iterate(ce=>((Z||ne.isGreaterThan(oe(ce,fe)))&&(Z=!1,fe=ce),!0)),fe}}e.CallbackIterable=Fe,Fe.empty=new Fe(se=>{})}),define(ye[51],Ce([1,0,9]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(y,D){if(!y)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=t;function T(y,D="Unreachable"){throw new Error(D)}e.assertNever=T;function R(y){if(!y)throw new c.BugIndicatingError("Assertion Failed")}e.assert=R;function k(y){if(!y()){debugger;y(),(0,c.onUnexpectedError)(new c.BugIndicatingError("Assertion Failed"))}}e.assertFn=k;function A(y,D){let L=0;for(;L<y.length-1;){const P=y[L],w=y[L+1];if(!D(P,w))return!1;L++}return!0}e.checkAdjacentItems=A}),define(ye[63],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function c(t){const T=this;let R=!1,k;return function(){return R||(R=!0,k=t.apply(T,arguments)),k}}e.once=c}),define(ye[101],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(T){this.a=T,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(ye[64],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(t){function T(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}t.is=T;const R=Object.freeze([]);function k(){return R}t.empty=k;function*A(S){yield S}t.single=A;function y(S){return T(S)?S:A(S)}t.wrap=y;function D(S){return S||R}t.from=D;function L(S){return!S||S[Symbol.iterator]().next().done===!0}t.isEmpty=L;function P(S){return S[Symbol.iterator]().next().value}t.first=P;function w(S,g){for(const r of S)if(g(r))return!0;return!1}t.some=w;function I(S,g){for(const r of S)if(g(r))return r}t.find=I;function*v(S,g){for(const r of S)g(r)&&(yield r)}t.filter=v;function*m(S,g){let r=0;for(const l of S)yield g(l,r++)}t.map=m;function*d(...S){for(const g of S)for(const r of g)yield r}t.concat=d;function f(S,g,r){let l=r;for(const s of S)l=g(l,s);return l}t.reduce=f;function*p(S,g,r=S.length){for(g<0&&(g+=S.length),r<0?r+=S.length:r>S.length&&(r=S.length);g<r;g++)yield S[g]}t.slice=p;function b(S,g=Number.POSITIVE_INFINITY){const r=[];if(g===0)return[r,S];const l=S[Symbol.iterator]();for(let s=0;s<g;s++){const a=l.next();if(a.done)return[r,t.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return l}}]}t.consume=b})(c=e.Iterable||(e.Iterable={}))}),define(ye[146],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var t;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(r){r.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function k(r,l=!1){let s=0;const a=r.length;let o="",u=0,i=16,n=0;function h(B){let O=0,U=0;for(;O<B;){const z=r.charCodeAt(s);if(z>=48&&z<=57)U=U*16+z-48;else if(z>=65&&z<=70)U=U*16+z-65+10;else if(z>=97&&z<=102)U=U*16+z-97+10;else break;s++,O++}return O<B&&(U=-1),U}function E(B){s=B,o="",u=0,i=16,n=0}function C(){const B=s;if(r.charCodeAt(s)===48)s++;else for(s++;s<r.length&&D(r.charCodeAt(s));)s++;if(s<r.length&&r.charCodeAt(s)===46)if(s++,s<r.length&&D(r.charCodeAt(s)))for(s++;s<r.length&&D(r.charCodeAt(s));)s++;else return n=3,r.substring(B,s);let O=s;if(s<r.length&&(r.charCodeAt(s)===69||r.charCodeAt(s)===101))if(s++,(s<r.length&&r.charCodeAt(s)===43||r.charCodeAt(s)===45)&&s++,s<r.length&&D(r.charCodeAt(s))){for(s++;s<r.length&&D(r.charCodeAt(s));)s++;O=s}else n=3;return r.substring(B,O)}function M(){let B="",O=s;for(;;){if(s>=a){B+=r.substring(O,s),n=2;break}const U=r.charCodeAt(s);if(U===34){B+=r.substring(O,s),s++;break}if(U===92){if(B+=r.substring(O,s),s++,s>=a){n=2;break}switch(r.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const j=h(4);j>=0?B+=String.fromCharCode(j):n=4;break}default:n=5}O=s;continue}if(U>=0&&U<=31)if(y(U)){B+=r.substring(O,s),n=2;break}else n=6;s++}return B}function K(){if(o="",n=0,u=s,s>=a)return u=a,i=17;let B=r.charCodeAt(s);if(A(B)){do s++,o+=String.fromCharCode(B),B=r.charCodeAt(s);while(A(B));return i=15}if(y(B))return s++,o+=String.fromCharCode(B),B===13&&r.charCodeAt(s)===10&&(s++,o+=`
`),i=14;switch(B){case 123:return s++,i=1;case 125:return s++,i=2;case 91:return s++,i=3;case 93:return s++,i=4;case 58:return s++,i=6;case 44:return s++,i=5;case 34:return s++,o=M(),i=10;case 47:{const O=s-1;if(r.charCodeAt(s+1)===47){for(s+=2;s<a&&!y(r.charCodeAt(s));)s++;return o=r.substring(O,s),i=12}if(r.charCodeAt(s+1)===42){s+=2;const U=a-1;let z=!1;for(;s<U;){if(r.charCodeAt(s)===42&&r.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,n=1),o=r.substring(O,s),i=13}return o+=String.fromCharCode(B),s++,i=16}case 45:if(o+=String.fromCharCode(B),s++,s===a||!D(r.charCodeAt(s)))return i=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=C(),i=11;default:for(;s<a&&q(B);)s++,B=r.charCodeAt(s);if(u!==s){switch(o=r.substring(u,s),o){case"true":return i=8;case"false":return i=9;case"null":return i=7}return i=16}return o+=String.fromCharCode(B),s++,i=16}}function q(B){if(A(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let B;do B=K();while(B>=12&&B<=15);return B}return{setPosition:E,getPosition:()=>s,scan:l?F:K,getToken:()=>i,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>n}}e.createScanner=k;function A(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function y(r){return r===10||r===13||r===8232||r===8233}function D(r){return r>=48&&r<=57}var L;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(L||(L={}));function P(r,l){const s=[],a=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let i=!1;function n(h,E,C,M){u.value=h,u.offset=E,u.length=C,u.type=M,u.colonOffset=void 0,o=u}try{b(r,{onObjectBegin:(h,E)=>{if(l<=h)throw a;o=void 0,i=l>h,s.push("")},onObjectProperty:(h,E,C)=>{if(l<E||(n(h,E,C,"property"),s[s.length-1]=h,l<=E+C))throw a},onObjectEnd:(h,E)=>{if(l<=h)throw a;o=void 0,s.pop()},onArrayBegin:(h,E)=>{if(l<=h)throw a;o=void 0,s.push(0)},onArrayEnd:(h,E)=>{if(l<=h)throw a;o=void 0,s.pop()},onLiteralValue:(h,E,C)=>{if(l<E||(n(h,E,C,g(h)),l<=E+C))throw a},onSeparator:(h,E,C)=>{if(l<=E)throw a;if(h===":"&&o&&o.type==="property")o.colonOffset=E,i=!1,o=void 0;else if(h===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:(i=!0,s[s.length-1]=""),o=void 0}}})}catch(h){if(h!==a)throw h}return{path:s,previousNode:o,isAtPropertyKey:i,matches:h=>{let E=0;for(let C=0;E<h.length&&C<s.length;C++)if(h[E]===s[C]||h[E]==="*")E++;else if(h[E]!=="**")return!1;return E===h.length}}}e.getLocation=P;function w(r,l=[],s=R.DEFAULT){let a=null,o=[];const u=[];function i(h){Array.isArray(o)?o.push(h):a!==null&&(o[a]=h)}return b(r,{onObjectBegin:()=>{const h={};i(h),u.push(o),o=h,a=null},onObjectProperty:h=>{a=h},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const h=[];i(h),u.push(o),o=h,a=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:i,onError:(h,E,C)=>{l.push({error:h,offset:E,length:C})}},s),o[0]}e.parse=w;function I(r,l=[],s=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(h){a.type==="property"&&(a.length=h-a.offset,a=a.parent)}function u(h){return a.children.push(h),h}b(r,{onObjectBegin:h=>{a=u({type:"object",offset:h,length:-1,parent:a,children:[]})},onObjectProperty:(h,E,C)=>{a=u({type:"property",offset:E,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:h,offset:E,length:C,parent:a})},onObjectEnd:(h,E)=>{a.length=h+E-a.offset,a=a.parent,o(h+E)},onArrayBegin:(h,E)=>{a=u({type:"array",offset:h,length:-1,parent:a,children:[]})},onArrayEnd:(h,E)=>{a.length=h+E-a.offset,a=a.parent,o(h+E)},onLiteralValue:(h,E,C)=>{u({type:g(h),offset:E,length:C,parent:a,value:h}),o(E+C)},onSeparator:(h,E,C)=>{a.type==="property"&&(h===":"?a.colonOffset=E:h===","&&o(E))},onError:(h,E,C)=>{l.push({error:h,offset:E,length:C})}},s);const n=a.children[0];return n&&delete n.parent,n}e.parseTree=I;function v(r,l){if(!r)return;let s=r;for(const a of l)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===a){s=u.children[1],o=!0;break}if(!o)return}else{const o=a;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}e.findNodeAtLocation=v;function m(r){if(!r.parent||!r.parent.children)return[];const l=m(r.parent);if(r.parent.type==="property"){const s=r.parent.children[0].value;l.push(s)}else if(r.parent.type==="array"){const s=r.parent.children.indexOf(r);s!==-1&&l.push(s)}return l}e.getNodePath=m;function d(r){switch(r.type){case"array":return r.children.map(d);case"object":{const l=Object.create(null);for(const s of r.children){const a=s.children[1];a&&(l[s.children[0].value]=d(a))}return l}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=d;function f(r,l,s=!1){return l>=r.offset&&l<r.offset+r.length||s&&l===r.offset+r.length}e.contains=f;function p(r,l,s=!1){if(f(r,l,s)){const a=r.children;if(Array.isArray(a))for(let o=0;o<a.length&&a[o].offset<=l;o++){const u=p(a[o],l,s);if(u)return u}return r}}e.findNodeAtOffset=p;function b(r,l,s=R.DEFAULT){const a=k(r,!1);function o(ee){return ee?()=>ee(a.getTokenOffset(),a.getTokenLength()):()=>!0}function u(ee){return ee?X=>ee(X,a.getTokenOffset(),a.getTokenLength()):()=>!0}const i=o(l.onObjectBegin),n=u(l.onObjectProperty),h=o(l.onObjectEnd),E=o(l.onArrayBegin),C=o(l.onArrayEnd),M=u(l.onLiteralValue),K=u(l.onSeparator),q=o(l.onComment),F=u(l.onError),B=s&&s.disallowComments,O=s&&s.allowTrailingComma;function U(){for(;;){const ee=a.scan();switch(a.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:B||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ee){case 12:case 13:B?z(10):q();break;case 16:z(1);break;case 15:case 14:break;default:return ee}}}function z(ee,X=[],G=[]){if(F(ee),X.length+G.length>0){let de=a.getToken();for(;de!==17;){if(X.indexOf(de)!==-1){U();break}else if(G.indexOf(de)!==-1)break;de=U()}}}function j(ee){const X=a.getTokenValue();return ee?M(X):n(X),U(),!0}function ue(){switch(a.getToken()){case 11:{let ee=0;try{ee=JSON.parse(a.getTokenValue()),typeof ee!="number"&&(z(2),ee=0)}catch{z(2)}M(ee);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return U(),!0}function V(){return a.getToken()!==10?(z(3,[],[2,5]),!1):(j(!1),a.getToken()===6?(K(":"),U(),ne()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function _(){i(),U();let ee=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(ee||z(4,[],[]),K(","),U(),a.getToken()===2&&O)break}else ee&&z(6,[],[]);V()||z(4,[],[2,5]),ee=!0}return h(),a.getToken()!==2?z(7,[2],[]):U(),!0}function J(){E(),U();let ee=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(ee||z(4,[],[]),K(","),U(),a.getToken()===4&&O)break}else ee&&z(6,[],[]);ne()||z(4,[],[4,5]),ee=!0}return C(),a.getToken()!==4?z(8,[4],[]):U(),!0}function ne(){switch(a.getToken()){case 3:return J();case 1:return _();case 10:return j(!0);default:return ue()}}return U(),a.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):ne()?(a.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=b;function S(r,l){const s=k(r),a=[];let o,u=0,i;do switch(i=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:u!==i&&a.push(r.substring(u,i)),l!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,l)),u=s.getPosition();break}while(o!==17);return a.join("")}e.stripComments=S;function g(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ye[83],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(T){this.d=T,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(T){this.c=T}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(T){return new c(()=>T(this.getValue()))}}e.Lazy=c}),define(ye[6],Ce([1,0,63,64]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const T=!1;let R=null;function k(u){R=u}if(e.setDisposableTracker=k,T){const u="__is_disposable_tracked__";k(new class{trackDisposable(i){const n=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[u]||console.log(n)},3e3)}setParent(i,n){if(i&&i!==p.None)try{i[u]=!0}catch{}}markAsDisposed(i){if(i&&i!==p.None)try{i[u]=!0}catch{}}markAsSingleton(i){}})}function A(u){return R?.trackDisposable(u),u}function y(u){R?.markAsDisposed(u)}function D(u,i){R?.setParent(u,i)}function L(u,i){if(!!R)for(const n of u)R.setParent(n,i)}function P(u){return R?.markAsSingleton(u),u}e.markAsSingleton=P;function w(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=w;function I(u){if(t.Iterable.is(u)){const i=[];for(const n of u)if(n)try{n.dispose()}catch(h){i.push(h)}if(i.length===1)throw i[0];if(i.length>1)throw new AggregateError(i,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=I;function v(u){for(const i of u)w(i)&&i.dispose();return[]}e.disposeIfDisposable=v;function m(...u){const i=d(()=>I(u));return L(u,i),i}e.combinedDisposable=m;function d(u){const i=A({dispose:(0,c.once)(()=>{y(i),u()})});return i}e.toDisposable=d;class f{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(y(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{I(this.c)}finally{this.c.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return D(i,this),this.f?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(i),i}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this.q=new f,A(this),D(this.q,this)}dispose(){y(this),this.q.dispose()}B(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(i)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class b{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(i){this.b||i===this.a||(this.a?.dispose(),i&&D(i,this),this.a=i)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const i=this.a;return this.a=void 0,i&&D(i,null),i}}e.MutableDisposable=b;class S{constructor(i){this.b=i,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(i){let n=i;return this.unset=()=>n=void 0,this.isset=()=>n!==void 0,this.dispose=()=>{n&&(n(),n=void 0,y(this))},this}}e.SafeDisposable=g;class r{constructor(){this.a=new Map}acquire(i,...n){let h=this.a.get(i);h||(h={counter:0,object:this.b(i,...n)},this.a.set(i,h));const{object:E}=h,C=(0,c.once)(()=>{--h.counter===0&&(this.c(i,h.object),this.a.delete(i))});return h.counter++,{object:E,dispose:C}}}e.ReferenceCollection=r;class l{constructor(i){this.a=i}async acquire(i,...n){const h=this.a.acquire(i,...n);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(E){throw h.dispose(),E}}}e.AsyncReferenceCollection=l;class s{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=s;function a(u){const i=new f;try{u(i)}finally{i.dispose()}}e.disposeOnReturn=a;class o{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{I(this.a.values())}finally{this.a.clear()}}has(i){return this.a.has(i)}get(i){return this.a.get(i)}set(i,n,h=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),h||this.a.get(i)?.dispose(),this.a.set(i,n)}deleteAndDispose(i){this.a.get(i)?.dispose(),this.a.delete(i)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(ye[65],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class c{constructor(R){this.element=R,this.next=c.Undefined,this.prev=c.Undefined}}c.Undefined=new c(void 0);class t{constructor(){this.a=c.Undefined,this.b=c.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===c.Undefined}clear(){let R=this.a;for(;R!==c.Undefined;){const k=R.next;R.prev=c.Undefined,R.next=c.Undefined,R=k}this.a=c.Undefined,this.b=c.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,k){const A=new c(R);if(this.a===c.Undefined)this.a=A,this.b=A;else if(k){const D=this.b;this.b=A,A.prev=D,D.next=A}else{const D=this.a;this.a=A,A.next=D,D.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==c.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==c.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==c.Undefined&&R.next!==c.Undefined){const k=R.prev;k.next=R.next,R.next.prev=k}else R.prev===c.Undefined&&R.next===c.Undefined?(this.a=c.Undefined,this.b=c.Undefined):R.next===c.Undefined?(this.b=this.b.prev,this.b.next=c.Undefined):R.prev===c.Undefined&&(this.a=this.a.next,this.a.prev=c.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==c.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ye[28],Ce([1,0]),function(te,e){"use strict";var c,t,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(v,m,d){let f=v.get(m);return f===void 0&&(f=d,v.set(m,f)),f}e.getOrSet=R;function k(v){const m=[];return v.forEach((d,f)=>{m.push(`${f} => ${d}`)}),`Map(${v.size}) {${m.join(", ")}}`}e.mapToString=k;function A(v){const m=[];return v.forEach(d=>{m.push(d)}),`Set(${v.size}) {${m.join(", ")}}`}e.setToString=A;class y{constructor(m,d){this.uri=m,this.value=d}}class D{constructor(m,d){this[c]="ResourceMap",m instanceof D?(this.b=new Map(m.b),this.c=d??D.a):(this.b=new Map,this.c=m??D.a)}set(m,d){return this.b.set(this.c(m),new y(m,d)),this}get(m){return this.b.get(this.c(m))?.value}has(m){return this.b.has(this.c(m))}get size(){return this.b.size}clear(){this.b.clear()}delete(m){return this.b.delete(this.c(m))}forEach(m,d){typeof d<"u"&&(m=m.bind(d));for(const[f,p]of this.b)m(p.value,p.uri,this)}*values(){for(const m of this.b.values())yield m.value}*keys(){for(const m of this.b.values())yield m.uri}*entries(){for(const m of this.b.values())yield[m.uri,m.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,m]of this.b)yield[m.uri,m.value]}}e.ResourceMap=D,D.a=v=>v.toString();class L{constructor(m,d){this[t]="ResourceSet",!m||typeof m=="function"?this.a=new D(m):(this.a=new D(d),m.forEach(this.add,this))}get size(){return this.a.size}add(m){return this.a.set(m,m),this}clear(){this.a.clear()}delete(m){return this.a.delete(m)}forEach(m,d){this.a.forEach((f,p)=>m.call(d,p,p,this))}has(m){return this.a.has(m)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var P;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class w{constructor(){this[T]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(m){return this.a.has(m)}get(m,d=0){const f=this.a.get(m);if(!!f)return d!==0&&this.j(f,d),f.value}set(m,d,f=0){let p=this.a.get(m);if(p)p.value=d,f!==0&&this.j(p,f);else{switch(p={key:m,value:d,next:void 0,previous:void 0},f){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(m,p),this.d++}return this}delete(m){return!!this.remove(m)}remove(m){const d=this.a.get(m);if(!!d)return this.a.delete(m),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const m=this.b;return this.a.delete(m.key),this.i(m),this.d--,m.value}forEach(m,d){const f=this.e;let p=this.b;for(;p;){if(d?m.bind(d)(p.value,p.key,this):m(p.value,p.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const m=this,d=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(m.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.key,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}values(){const m=this,d=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(m.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:f.value,done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}entries(){const m=this,d=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(m.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const b={value:[f.key,f.value],done:!1};return f=f.next,b}else return{value:void 0,done:!0}}};return p}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(m){if(m>=this.size)return;if(m===0){this.clear();return}let d=this.b,f=this.size;for(;d&&f>m;)this.a.delete(d.key),d=d.next,f--;this.b=d,this.d=f,d&&(d.previous=void 0),this.e++}g(m){if(!this.b&&!this.c)this.c=m;else if(this.b)m.next=this.b,this.b.previous=m;else throw new Error("Invalid list");this.b=m,this.e++}h(m){if(!this.b&&!this.c)this.b=m;else if(this.c)m.previous=this.c,this.c.next=m;else throw new Error("Invalid list");this.c=m,this.e++}i(m){if(m===this.b&&m===this.c)this.b=void 0,this.c=void 0;else if(m===this.b){if(!m.next)throw new Error("Invalid list");m.next.previous=void 0,this.b=m.next}else if(m===this.c){if(!m.previous)throw new Error("Invalid list");m.previous.next=void 0,this.c=m.previous}else{const d=m.next,f=m.previous;if(!d||!f)throw new Error("Invalid list");d.previous=f,f.next=d}m.next=void 0,m.previous=void 0,this.e++}j(m,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(m===this.b)return;const f=m.next,p=m.previous;m===this.c?(p.next=void 0,this.c=p):(f.previous=p,p.next=f),m.previous=void 0,m.next=this.b,this.b.previous=m,this.b=m,this.e++}else if(d===2){if(m===this.c)return;const f=m.next,p=m.previous;m===this.b?(f.previous=void 0,this.b=f):(f.previous=p,p.next=f),m.next=void 0,m.previous=this.c,this.c.next=m,this.c=m,this.e++}}}toJSON(){const m=[];return this.forEach((d,f)=>{m.push([f,d])}),m}fromJSON(m){this.clear();for(const[d,f]of m)this.set(d,f)}}e.LinkedMap=w;class I extends w{constructor(m,d=1){super(),this.k=m,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(m){this.k=m,this.m()}get ratio(){return this.l}set ratio(m){this.l=Math.min(Math.max(0,m),1),this.m()}get(m,d=2){return super.get(m,d)}peek(m){return super.get(m,0)}set(m,d){return super.set(m,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=I}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],Ce([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(se,oe){for(var fe=0;fe<oe.length;fe++){var Z=oe[fe];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(se,Z.key,Z)}}function c(se,oe,fe){return oe&&e(se.prototype,oe),fe&&e(se,fe),Object.defineProperty(se,"prototype",{writable:!1}),se}function t(se,oe){if(!!se){if(typeof se=="string")return T(se,oe);var fe=Object.prototype.toString.call(se).slice(8,-1);if(fe==="Object"&&se.constructor&&(fe=se.constructor.name),fe==="Map"||fe==="Set")return Array.from(se);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return T(se,oe)}}function T(se,oe){(oe==null||oe>se.length)&&(oe=se.length);for(var fe=0,Z=new Array(oe);fe<oe;fe++)Z[fe]=se[fe];return Z}function R(se,oe){var fe=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(fe)return(fe=fe.call(se)).next.bind(fe);if(Array.isArray(se)||(fe=t(se))||oe&&se&&typeof se.length=="number"){fe&&(se=fe);var Z=0;return function(){return Z>=se.length?{done:!0}:{done:!1,value:se[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function k(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=k();function A(se){te.defaults=se}var y=/[&<>"']/,D=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(oe){return w[oe]};function v(se,oe){if(oe){if(y.test(se))return se.replace(D,I)}else if(L.test(se))return se.replace(P,I);return se}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(se){return se.replace(m,function(oe,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var f=/(^|[^\[])\^/g;function p(se,oe){se=typeof se=="string"?se:se.source,oe=oe||"";var fe={replace:function(ce,ie){return ie=ie.source||ie,ie=ie.replace(f,"$1"),se=se.replace(ce,ie),fe},getRegex:function(){return new RegExp(se,oe)}};return fe}var b=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(se,oe,fe){if(se){var Z;try{Z=decodeURIComponent(d(fe)).replace(b,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}oe&&!S.test(fe)&&(fe=o(oe,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var r={},l=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(se,oe){r[" "+se]||(l.test(se)?r[" "+se]=se+"/":r[" "+se]=h(se,"/",!0)),se=r[" "+se];var fe=se.indexOf(":")===-1;return oe.substring(0,2)==="//"?fe?oe:se.replace(s,"$1")+oe:oe.charAt(0)==="/"?fe?oe:se.replace(a,"$1")+oe:se+oe}var u={exec:function(){}};function i(se){for(var oe=1,fe,Z;oe<arguments.length;oe++){fe=arguments[oe];for(Z in fe)Object.prototype.hasOwnProperty.call(fe,Z)&&(se[Z]=fe[Z])}return se}function n(se,oe){var fe=se.replace(/\|/g,function(ie,N,H){for(var Q=!1,Y=N;--Y>=0&&H[Y]==="\\";)Q=!Q;return Q?"|":" |"}),Z=fe.split(/ \|/),ce=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>oe)Z.splice(oe);else for(;Z.length<oe;)Z.push("");for(;ce<Z.length;ce++)Z[ce]=Z[ce].trim().replace(/\\\|/g,"|");return Z}function h(se,oe,fe){var Z=se.length;if(Z===0)return"";for(var ce=0;ce<Z;){var ie=se.charAt(Z-ce-1);if(ie===oe&&!fe)ce++;else if(ie!==oe&&fe)ce++;else break}return se.slice(0,Z-ce)}function E(se,oe){if(se.indexOf(oe[1])===-1)return-1;for(var fe=se.length,Z=0,ce=0;ce<fe;ce++)if(se[ce]==="\\")ce++;else if(se[ce]===oe[0])Z++;else if(se[ce]===oe[1]&&(Z--,Z<0))return ce;return-1}function C(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(se,oe){if(oe<1)return"";for(var fe="";oe>1;)oe&1&&(fe+=se),oe>>=1,se+=se;return fe+se}function K(se,oe,fe,Z){var ce=oe.href,ie=oe.title?v(oe.title):null,N=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){Z.state.inLink=!0;var H={type:"link",raw:fe,href:ce,title:ie,text:N,tokens:Z.inlineTokens(N)};return Z.state.inLink=!1,H}return{type:"image",raw:fe,href:ce,title:ie,text:v(N)}}function q(se,oe){var fe=se.match(/^(\s+)(?:```)/);if(fe===null)return oe;var Z=fe[1];return oe.split(`
`).map(function(ce){var ie=ce.match(/^\s+/);if(ie===null)return ce;var N=ie[0];return N.length>=Z.length?ce.slice(Z.length):ce}).join(`
`)}var F=function(){function se(fe){this.options=fe||te.defaults}var oe=se.prototype;return oe.space=function(Z){var ce=this.rules.block.newline.exec(Z);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},oe.code=function(Z){var ce=this.rules.block.code.exec(Z);if(ce){var ie=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:h(ie,`
`)}}},oe.fences=function(Z){var ce=this.rules.block.fences.exec(Z);if(ce){var ie=ce[0],N=q(ie,ce[3]||"");return{type:"code",raw:ie,lang:ce[2]?ce[2].trim():ce[2],text:N}}},oe.heading=function(Z){var ce=this.rules.block.heading.exec(Z);if(ce){var ie=ce[2].trim();if(/#$/.test(ie)){var N=h(ie,"#");(this.options.pedantic||!N||/ $/.test(N))&&(ie=N.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:ie,tokens:this.lexer.inline(ie)}}},oe.hr=function(Z){var ce=this.rules.block.hr.exec(Z);if(ce)return{type:"hr",raw:ce[0]}},oe.blockquote=function(Z){var ce=this.rules.block.blockquote.exec(Z);if(ce){var ie=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},oe.list=function(Z){var ce=this.rules.block.list.exec(Z);if(ce){var ie,N,H,Q,Y,he,we,Ae,pe,De,ke,je,Ge=ce[1].trim(),et=Ge.length>1,Qe={type:"list",raw:"",ordered:et,start:et?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=et?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=et?Ge:"[*+-]");for(var nt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(je=!1,!(!(ce=nt.exec(Z))||this.rules.block.hr.test(Z)));){if(ie=ce[0],Z=Z.substring(ie.length),Ae=ce[2].split(`
`,1)[0],pe=Z.split(`
`,1)[0],this.options.pedantic?(Q=2,ke=Ae.trimLeft()):(Q=ce[2].search(/[^ ]/),Q=Q>4?1:Q,ke=Ae.slice(Q),Q+=ce[1].length),he=!1,!Ae&&/^ *$/.test(pe)&&(ie+=pe+`
`,Z=Z.substring(pe.length+1),je=!0),!je)for(var st=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,Q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,Q-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,Q-1)+"}#");Z&&(De=Z.split(`
`,1)[0],Ae=De,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(Ae)||it.test(Ae)||st.test(Ae)||ht.test(Z)));){if(Ae.search(/[^ ]/)>=Q||!Ae.trim())ke+=`
`+Ae.slice(Q);else if(!he)ke+=`
`+Ae;else break;!he&&!Ae.trim()&&(he=!0),ie+=De+`
`,Z=Z.substring(De.length+1)}Qe.loose||(we?Qe.loose=!0:/\n *\n *$/.test(ie)&&(we=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(ke),N&&(H=N[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:ie,task:!!N,checked:H,loose:!1,text:ke}),Qe.raw+=ie}Qe.items[Qe.items.length-1].raw=ie.trimRight(),Qe.items[Qe.items.length-1].text=ke.trimRight(),Qe.raw=Qe.raw.trimRight();var ae=Qe.items.length;for(Y=0;Y<ae;Y++){this.lexer.state.top=!1,Qe.items[Y].tokens=this.lexer.blockTokens(Qe.items[Y].text,[]);var $=Qe.items[Y].tokens.filter(function(Ie){return Ie.type==="space"}),le=$.every(function(Ie){for(var Le=Ie.raw.split(""),Be=0,Xe=R(Le),Ze;!(Ze=Xe()).done;){var gt=Ze.value;if(gt===`
`&&(Be+=1),Be>1)return!0}return!1});!Qe.loose&&$.length&&le&&(Qe.loose=!0,Qe.items[Y].loose=!0)}return Qe}},oe.html=function(Z){var ce=this.rules.block.html.exec(Z);if(ce){var ie={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(ce[0]):v(ce[0]);ie.type="paragraph",ie.text=N,ie.tokens=this.lexer.inline(N)}return ie}},oe.def=function(Z){var ce=this.rules.block.def.exec(Z);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ie=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:ce[0],href:ce[2],title:ce[3]}}},oe.table=function(Z){var ce=this.rules.block.table.exec(Z);if(ce){var ie={type:"table",header:n(ce[1]).map(function(we){return{text:we}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=ce[0];var N=ie.align.length,H,Q,Y,he;for(H=0;H<N;H++)/^ *-+: *$/.test(ie.align[H])?ie.align[H]="right":/^ *:-+: *$/.test(ie.align[H])?ie.align[H]="center":/^ *:-+ *$/.test(ie.align[H])?ie.align[H]="left":ie.align[H]=null;for(N=ie.rows.length,H=0;H<N;H++)ie.rows[H]=n(ie.rows[H],ie.header.length).map(function(we){return{text:we}});for(N=ie.header.length,Q=0;Q<N;Q++)ie.header[Q].tokens=this.lexer.inline(ie.header[Q].text);for(N=ie.rows.length,Q=0;Q<N;Q++)for(he=ie.rows[Q],Y=0;Y<he.length;Y++)he[Y].tokens=this.lexer.inline(he[Y].text);return ie}}},oe.lheading=function(Z){var ce=this.rules.block.lheading.exec(Z);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},oe.paragraph=function(Z){var ce=this.rules.block.paragraph.exec(Z);if(ce){var ie=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:ie,tokens:this.lexer.inline(ie)}}},oe.text=function(Z){var ce=this.rules.block.text.exec(Z);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},oe.escape=function(Z){var ce=this.rules.inline.escape.exec(Z);if(ce)return{type:"escape",raw:ce[0],text:v(ce[1])}},oe.tag=function(Z){var ce=this.rules.inline.tag.exec(Z);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):v(ce[0]):ce[0]}},oe.link=function(Z){var ce=this.rules.inline.link.exec(Z);if(ce){var ie=ce[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var N=h(ie.slice(0,-1),"\\");if((ie.length-N.length)%2===0)return}else{var H=E(ce[2],"()");if(H>-1){var Q=ce[0].indexOf("!")===0?5:4,Y=Q+ce[1].length+H;ce[2]=ce[2].substring(0,H),ce[0]=ce[0].substring(0,Y).trim(),ce[3]=""}}var he=ce[2],we="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);Ae&&(he=Ae[1],we=Ae[3])}else we=ce[3]?ce[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(ie)?he=he.slice(1):he=he.slice(1,-1)),K(ce,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},oe.reflink=function(Z,ce){var ie;if((ie=this.rules.inline.reflink.exec(Z))||(ie=this.rules.inline.nolink.exec(Z))){var N=(ie[2]||ie[1]).replace(/\s+/g," ");if(N=ce[N.toLowerCase()],!N||!N.href){var H=ie[0].charAt(0);return{type:"text",raw:H,text:H}}return K(ie,N,ie[0],this.lexer)}},oe.emStrong=function(Z,ce,ie){ie===void 0&&(ie="");var N=this.rules.inline.emStrong.lDelim.exec(Z);if(!!N&&!(N[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=N[1]||N[2]||"";if(!H||H&&(ie===""||this.rules.inline.punctuation.exec(ie))){var Q=N[0].length-1,Y,he,we=Q,Ae=0,pe=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ce=ce.slice(-1*Z.length+Q);(N=pe.exec(ce))!=null;)if(Y=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!Y){if(he=Y.length,N[3]||N[4]){we+=he;continue}else if((N[5]||N[6])&&Q%3&&!((Q+he)%3)){Ae+=he;continue}if(we-=he,!(we>0)){if(he=Math.min(he,he+we+Ae),Math.min(Q,he)%2){var De=Z.slice(1,Q+N.index+he);return{type:"em",raw:Z.slice(0,Q+N.index+he+1),text:De,tokens:this.lexer.inlineTokens(De)}}var ke=Z.slice(2,Q+N.index+he-1);return{type:"strong",raw:Z.slice(0,Q+N.index+he+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},oe.codespan=function(Z){var ce=this.rules.inline.code.exec(Z);if(ce){var ie=ce[2].replace(/\n/g," "),N=/[^ ]/.test(ie),H=/^ /.test(ie)&&/ $/.test(ie);return N&&H&&(ie=ie.substring(1,ie.length-1)),ie=v(ie,!0),{type:"codespan",raw:ce[0],text:ie}}},oe.br=function(Z){var ce=this.rules.inline.br.exec(Z);if(ce)return{type:"br",raw:ce[0]}},oe.del=function(Z){var ce=this.rules.inline.del.exec(Z);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},oe.autolink=function(Z,ce){var ie=this.rules.inline.autolink.exec(Z);if(ie){var N,H;return ie[2]==="@"?(N=v(this.options.mangle?ce(ie[1]):ie[1]),H="mailto:"+N):(N=v(ie[1]),H=N),{type:"link",raw:ie[0],text:N,href:H,tokens:[{type:"text",raw:N,text:N}]}}},oe.url=function(Z,ce){var ie;if(ie=this.rules.inline.url.exec(Z)){var N,H;if(ie[2]==="@")N=v(this.options.mangle?ce(ie[0]):ie[0]),H="mailto:"+N;else{var Q;do Q=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(Q!==ie[0]);N=v(ie[0]),ie[1]==="www."?H="http://"+N:H=N}return{type:"link",raw:ie[0],text:N,href:H,tokens:[{type:"text",raw:N,text:N}]}}},oe.inlineText=function(Z,ce){var ie=this.rules.inline.text.exec(Z);if(ie){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]):ie[0]:N=v(this.options.smartypants?ce(ie[0]):ie[0]),{type:"text",raw:ie[0],text:N}}},se}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=p(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=p(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=p(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=p(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=p(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=p(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=i({},B),B.gfm=i({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=p(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=p(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=i({},B.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:p(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=p(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=p(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=p(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=p(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=p(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=p(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=p(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=p(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=p(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=p(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=p(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=i({},O),O.pedantic=i({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=i({},O.normal,{escape:p(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=p(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=i({},O.gfm,{br:p(O.br).replace("{2,}","*").getRegex(),text:p(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(se){var oe="",fe,Z,ce=se.length;for(fe=0;fe<ce;fe++)Z=se.charCodeAt(fe),Math.random()>.5&&(Z="x"+Z.toString(16)),oe+="&#"+Z+";";return oe}var j=function(){function se(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||te.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:B.normal,inline:O.normal};this.options.pedantic?(Z.block=B.pedantic,Z.inline=O.pedantic):this.options.gfm&&(Z.block=B.gfm,this.options.breaks?Z.inline=O.breaks:Z.inline=O.gfm),this.tokenizer.rules=Z}se.lex=function(Z,ce){var ie=new se(ce);return ie.lex(Z)},se.lexInline=function(Z,ce){var ie=new se(ce);return ie.inlineTokens(Z)};var oe=se.prototype;return oe.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},oe.blockTokens=function(Z,ce){var ie=this;ce===void 0&&(ce=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(we,Ae,pe){return Ae+"    ".repeat(pe.length)});for(var N,H,Q,Y;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(N=we.call({lexer:ie},Z,ce))?(Z=Z.substring(N.raw.length),ce.push(N),!0):!1}))){if(N=this.tokenizer.space(Z)){Z=Z.substring(N.raw.length),N.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(N);continue}if(N=this.tokenizer.code(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(N);continue}if(N=this.tokenizer.fences(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.heading(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.hr(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.blockquote(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.list(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.html(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.def(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+N.raw,H.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.lheading(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(Q=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Ae=Z.slice(1),pe=void 0;ie.options.extensions.startBlock.forEach(function(De){pe=De.call({lexer:this},Ae),typeof pe=="number"&&pe>=0&&(we=Math.min(we,pe))}),we<1/0&&we>=0&&(Q=Z.substring(0,we+1))}(),this.state.top&&(N=this.tokenizer.paragraph(Q))){H=ce[ce.length-1],Y&&H.type==="paragraph"?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(N),Y=Q.length!==Z.length,Z=Z.substring(N.raw.length);continue}if(N=this.tokenizer.text(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&H.type==="text"?(H.raw+=`
`+N.raw,H.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):ce.push(N);continue}if(Z){var he="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,ce},oe.inline=function(Z,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:Z,tokens:ce}),ce},oe.inlineTokens=function(Z,ce){var ie=this;ce===void 0&&(ce=[]);var N,H,Q,Y=Z,he,we,Ae;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(Y))!=null;)pe.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(Y=Y.slice(0,he.index)+"["+M("a",he[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(Y))!=null;)Y=Y.slice(0,he.index)+"["+M("a",he[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(Y))!=null;)Y=Y.slice(0,he.index)+"++"+Y.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(we||(Ae=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(N=ke.call({lexer:ie},Z,ce))?(Z=Z.substring(N.raw.length),ce.push(N),!0):!1}))){if(N=this.tokenizer.escape(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.tag(Z)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&N.type==="text"&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):ce.push(N);continue}if(N=this.tokenizer.link(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(N.raw.length),H=ce[ce.length-1],H&&N.type==="text"&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):ce.push(N);continue}if(N=this.tokenizer.emStrong(Z,Y,Ae)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.codespan(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.br(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.del(Z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(N=this.tokenizer.autolink(Z,z)){Z=Z.substring(N.raw.length),ce.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(Z,z))){Z=Z.substring(N.raw.length),ce.push(N);continue}if(Q=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,je=Z.slice(1),Ge=void 0;ie.options.extensions.startInline.forEach(function(et){Ge=et.call({lexer:this},je),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(Q=Z.substring(0,ke+1))}(),N=this.tokenizer.inlineText(Q,U)){Z=Z.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(Ae=N.raw.slice(-1)),we=!0,H=ce[ce.length-1],H&&H.type==="text"?(H.raw+=N.raw,H.text+=N.text):ce.push(N);continue}if(Z){var De="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return ce},c(se,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),se}(),ue=function(){function se(fe){this.options=fe||te.defaults}var oe=se.prototype;return oe.code=function(Z,ce,ie){var N=(ce||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(Z,N);H!=null&&H!==Z&&(ie=!0,Z=H)}return Z=Z.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+v(N,!0)+'">'+(ie?Z:v(Z,!0))+`</code></pre>
`:"<pre><code>"+(ie?Z:v(Z,!0))+`</code></pre>
`},oe.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},oe.html=function(Z){return Z},oe.heading=function(Z,ce,ie,N){if(this.options.headerIds){var H=this.options.headerPrefix+N.slug(ie);return"<h"+ce+' id="'+H+'">'+Z+"</h"+ce+`>
`}return"<h"+ce+">"+Z+"</h"+ce+`>
`},oe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},oe.list=function(Z,ce,ie){var N=ce?"ol":"ul",H=ce&&ie!==1?' start="'+ie+'"':"";return"<"+N+H+`>
`+Z+"</"+N+`>
`},oe.listitem=function(Z){return"<li>"+Z+`</li>
`},oe.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},oe.paragraph=function(Z){return"<p>"+Z+`</p>
`},oe.table=function(Z,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ce+`</table>
`},oe.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},oe.tablecell=function(Z,ce){var ie=ce.header?"th":"td",N=ce.align?"<"+ie+' align="'+ce.align+'">':"<"+ie+">";return N+Z+("</"+ie+`>
`)},oe.strong=function(Z){return"<strong>"+Z+"</strong>"},oe.em=function(Z){return"<em>"+Z+"</em>"},oe.codespan=function(Z){return"<code>"+Z+"</code>"},oe.br=function(){return this.options.xhtml?"<br/>":"<br>"},oe.del=function(Z){return"<del>"+Z+"</del>"},oe.link=function(Z,ce,ie){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ie;var N='<a href="'+v(Z)+'"';return ce&&(N+=' title="'+ce+'"'),N+=">"+ie+"</a>",N},oe.image=function(Z,ce,ie){if(Z=g(this.options.sanitize,this.options.baseUrl,Z),Z===null)return ie;var N='<img src="'+Z+'" alt="'+ie+'"';return ce&&(N+=' title="'+ce+'"'),N+=this.options.xhtml?"/>":">",N},oe.text=function(Z){return Z},se}(),V=function(){function se(){}var oe=se.prototype;return oe.strong=function(Z){return Z},oe.em=function(Z){return Z},oe.codespan=function(Z){return Z},oe.del=function(Z){return Z},oe.html=function(Z){return Z},oe.text=function(Z){return Z},oe.link=function(Z,ce,ie){return""+ie},oe.image=function(Z,ce,ie){return""+ie},oe.br=function(){return""},se}(),_=function(){function se(){this.seen={}}var oe=se.prototype;return oe.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},oe.getNextSafeSlug=function(Z,ce){var ie=Z,N=0;if(this.seen.hasOwnProperty(ie)){N=this.seen[Z];do N++,ie=Z+"-"+N;while(this.seen.hasOwnProperty(ie))}return ce||(this.seen[Z]=N,this.seen[ie]=0),ie},oe.slug=function(Z,ce){ce===void 0&&(ce={});var ie=this.serialize(Z);return this.getNextSafeSlug(ie,ce.dryrun)},se}(),J=function(){function se(fe){this.options=fe||te.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new _}se.parse=function(Z,ce){var ie=new se(ce);return ie.parse(Z)},se.parseInline=function(Z,ce){var ie=new se(ce);return ie.parseInline(Z)};var oe=se.prototype;return oe.parse=function(Z,ce){ce===void 0&&(ce=!0);var ie="",N,H,Q,Y,he,we,Ae,pe,De,ke,je,Ge,et,Qe,nt,st,ht,Me,it,ae=Z.length;for(N=0;N<ae;N++){if(ke=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(it=this.options.extensions.renderers[ke.type].call({parser:this},ke),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ie+=it||"";continue}switch(ke.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,d(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(pe="",Ae="",Y=ke.header.length,H=0;H<Y;H++)Ae+=this.renderer.tablecell(this.parseInline(ke.header[H].tokens),{header:!0,align:ke.align[H]});for(pe+=this.renderer.tablerow(Ae),De="",Y=ke.rows.length,H=0;H<Y;H++){for(we=ke.rows[H],Ae="",he=we.length,Q=0;Q<he;Q++)Ae+=this.renderer.tablecell(this.parseInline(we[Q].tokens),{header:!1,align:ke.align[Q]});De+=this.renderer.tablerow(Ae)}ie+=this.renderer.table(pe,De);continue}case"blockquote":{De=this.parse(ke.tokens),ie+=this.renderer.blockquote(De);continue}case"list":{for(je=ke.ordered,Ge=ke.start,et=ke.loose,Y=ke.items.length,De="",H=0;H<Y;H++)nt=ke.items[H],st=nt.checked,ht=nt.task,Qe="",nt.task&&(Me=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Me+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Me+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Me}):Qe+=Me),Qe+=this.parse(nt.tokens,et),De+=this.renderer.listitem(Qe,ht,st);ie+=this.renderer.list(De,je,Ge);continue}case"html":{ie+=this.renderer.html(ke.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(De=ke.tokens?this.parseInline(ke.tokens):ke.text;N+1<ae&&Z[N+1].type==="text";)ke=Z[++N],De+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ie+=ce?this.renderer.paragraph(De):De;continue}default:{var $='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error($);return}else throw new Error($)}}}return ie},oe.parseInline=function(Z,ce){ce=ce||this.renderer;var ie="",N,H,Q,Y=Z.length;for(N=0;N<Y;N++){if(H=Z[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(Q=this.options.extensions.renderers[H.type].call({parser:this},H),Q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){ie+=Q||"";continue}switch(H.type){case"escape":{ie+=ce.text(H.text);break}case"html":{ie+=ce.html(H.text);break}case"link":{ie+=ce.link(H.href,H.title,this.parseInline(H.tokens,ce));break}case"image":{ie+=ce.image(H.href,H.title,H.text);break}case"strong":{ie+=ce.strong(this.parseInline(H.tokens,ce));break}case"em":{ie+=ce.em(this.parseInline(H.tokens,ce));break}case"codespan":{ie+=ce.codespan(H.text);break}case"br":{ie+=ce.br();break}case"del":{ie+=ce.del(this.parseInline(H.tokens,ce));break}case"text":{ie+=ce.text(H.text);break}default:{var he='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return ie},se}();function ne(se,oe,fe){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof oe=="function"&&(fe=oe,oe=null),oe=i({},ne.defaults,oe||{}),C(oe),fe){var Z=oe.highlight,ce;try{ce=j.lex(se,oe)}catch(Y){return fe(Y)}var ie=function(he){var we;if(!he)try{oe.walkTokens&&ne.walkTokens(ce,oe.walkTokens),we=J.parse(ce,oe)}catch(Ae){he=Ae}return oe.highlight=Z,he?fe(he):fe(null,we)};if(!Z||Z.length<3||(delete oe.highlight,!ce.length))return ie();var N=0;ne.walkTokens(ce,function(Y){Y.type==="code"&&(N++,setTimeout(function(){Z(Y.text,Y.lang,function(he,we){if(he)return ie(he);we!=null&&we!==Y.text&&(Y.text=we,Y.escaped=!0),N--,N===0&&ie()})},0))}),N===0&&ie();return}function H(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+v(Y.message+"",!0)+"</pre>";throw Y}try{var Q=j.lex(se,oe);if(oe.walkTokens){if(oe.async)return Promise.all(ne.walkTokens(Q,oe.walkTokens)).then(function(){return J.parse(Q,oe)}).catch(H);ne.walkTokens(Q,oe.walkTokens)}return J.parse(Q,oe)}catch(Y){H(Y)}}ne.options=ne.setOptions=function(se){return i(ne.defaults,se),A(ne.defaults),ne},ne.getDefaults=k,ne.defaults=te.defaults,ne.use=function(){for(var se=arguments.length,oe=new Array(se),fe=0;fe<se;fe++)oe[fe]=arguments[fe];var Z=i.apply(void 0,[{}].concat(oe)),ce=ne.defaults.extensions||{renderers:{},childTokens:{}},ie;oe.forEach(function(N){if(N.extensions&&(ie=!0,N.extensions.forEach(function(Q){if(!Q.name)throw new Error("extension name required");if(Q.renderer){var Y=ce.renderers?ce.renderers[Q.name]:null;Y?ce.renderers[Q.name]=function(){for(var he=arguments.length,we=new Array(he),Ae=0;Ae<he;Ae++)we[Ae]=arguments[Ae];var pe=Q.renderer.apply(this,we);return pe===!1&&(pe=Y.apply(this,we)),pe}:ce.renderers[Q.name]=Q.renderer}if(Q.tokenizer){if(!Q.level||Q.level!=="block"&&Q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[Q.level]?ce[Q.level].unshift(Q.tokenizer):ce[Q.level]=[Q.tokenizer],Q.start&&(Q.level==="block"?ce.startBlock?ce.startBlock.push(Q.start):ce.startBlock=[Q.start]:Q.level==="inline"&&(ce.startInline?ce.startInline.push(Q.start):ce.startInline=[Q.start]))}Q.childTokens&&(ce.childTokens[Q.name]=Q.childTokens)})),N.renderer&&function(){var Q=ne.defaults.renderer||new ue,Y=function(Ae){var pe=Q[Ae];Q[Ae]=function(){for(var De=arguments.length,ke=new Array(De),je=0;je<De;je++)ke[je]=arguments[je];var Ge=N.renderer[Ae].apply(Q,ke);return Ge===!1&&(Ge=pe.apply(Q,ke)),Ge}};for(var he in N.renderer)Y(he);Z.renderer=Q}(),N.tokenizer&&function(){var Q=ne.defaults.tokenizer||new F,Y=function(Ae){var pe=Q[Ae];Q[Ae]=function(){for(var De=arguments.length,ke=new Array(De),je=0;je<De;je++)ke[je]=arguments[je];var Ge=N.tokenizer[Ae].apply(Q,ke);return Ge===!1&&(Ge=pe.apply(Q,ke)),Ge}};for(var he in N.tokenizer)Y(he);Z.tokenizer=Q}(),N.walkTokens){var H=ne.defaults.walkTokens;Z.walkTokens=function(Q){var Y=[];return Y.push(N.walkTokens.call(this,Q)),H&&(Y=Y.concat(H.call(this,Q))),Y}}ie&&(Z.extensions=ce),ne.setOptions(Z)})},ne.walkTokens=function(se,oe){for(var fe=[],Z=function(){var H=ie.value;switch(fe=fe.concat(oe.call(ne,H)),H.type){case"table":{for(var Q=R(H.header),Y;!(Y=Q()).done;){var he=Y.value;fe=fe.concat(ne.walkTokens(he.tokens,oe))}for(var we=R(H.rows),Ae;!(Ae=we()).done;)for(var pe=Ae.value,De=R(pe),ke;!(ke=De()).done;){var je=ke.value;fe=fe.concat(ne.walkTokens(je.tokens,oe))}break}case"list":{fe=fe.concat(ne.walkTokens(H.items,oe));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[H.type]?ne.defaults.extensions.childTokens[H.type].forEach(function(Ge){fe=fe.concat(ne.walkTokens(H[Ge],oe))}):H.tokens&&(fe=fe.concat(ne.walkTokens(H.tokens,oe)))}},ce=R(se),ie;!(ie=ce()).done;)Z();return fe},ne.parseInline=function(se,oe){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");oe=i({},ne.defaults,oe||{}),C(oe);try{var fe=j.lexInline(se,oe);return oe.walkTokens&&ne.walkTokens(fe,oe.walkTokens),J.parseInline(fe,oe)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,oe.silent)return"<p>An error occurred:</p><pre>"+v(Z.message+"",!0)+"</pre>";throw Z}},ne.Parser=J,ne.parser=J.parse,ne.Renderer=ue,ne.TextRenderer=V,ne.Lexer=j,ne.lexer=j.lex,ne.Tokenizer=F,ne.Slugger=_,ne.parse=ne;var ee=ne.options,X=ne.setOptions,G=ne.use,de=ne.walkTokens,be=ne.parseInline,Ee=ne,Pe=J.parse,Fe=j.lex;te.Lexer=j,te.Parser=J,te.Renderer=ue,te.Slugger=_,te.TextRenderer=V,te.Tokenizer=F,te.getDefaults=k,te.lexer=Fe,te.marked=ne,te.options=ee,te.parse=Ee,te.parseInline=be,te.parser=Pe,te.setOptions=X,te.use=G,te.walkTokens=de,Object.defineProperty(te,"__esModule",{value:!0})}),define(ye[84],Ce([1,0,28]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new c.LRUCache(1e4);function T(D){return y(D,"NFC",t)}e.normalizeNFC=T;const R=new c.LRUCache(1e4);function k(D){return y(D,"NFD",R)}e.normalizeNFD=k;const A=/[^\u0000-\u0080]/;function y(D,L,P){if(!D)return D;const w=P.get(D);if(w)return w;let I;return A.test(D)?I=D.normalize(L):I=D,P.set(D,I),I}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(L){return k(L).replace(D,"")}}()}),define(ye[102],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(A,y,D){return Math.min(Math.max(A,y),D)}e.clamp=c;function t(A,y){return(y+A%y)%y}e.rot=t;class T{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=T;class R{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class k{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const D=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=k}),function(){function te(T){const R=[];typeof T=="number"&&R.push("code/timeOrigin",T);function k(y){R.push(y,Date.now())}function A(){const y=[];for(let D=0;D<R.length;D+=2)y.push({name:R[D],startTime:R[D+1]});return y}return{mark:k,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const k of performance.getEntriesByType("mark"))R.push({name:k.name,startTime:Math.round(T+k.startTime)});return R}};if(typeof process=="object"){const T=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function c(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=c(t))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var c=e();for(var t in c)(typeof exports=="object"?exports:te)[t]=c[t]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function c(t){if(e[t])return e[t].exports;var T=e[t]={i:t,l:!1,exports:{}};return te[t].call(T.exports,T,T.exports,c),T.l=!0,T.exports}return c.m=te,c.c=e,c.d=function(t,T,R){c.o(t,T)||Object.defineProperty(t,T,{enumerable:!0,get:R})},c.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},c.t=function(t,T){if(1&T&&(t=c(t)),8&T||4&T&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(c.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&T&&typeof t!="string")for(var k in t)c.d(R,k,function(A){return t[A]}.bind(null,k));return R},c.n=function(t){var T=t&&t.__esModule?function(){return t.default}:function(){return t};return c.d(T,"a",T),T},c.o=function(t,T){return Object.prototype.hasOwnProperty.call(t,T)},c.p="",c(c.s=0)}([function(te,e,c){(function(t){var T;e=te.exports=G,T=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var pe=Array.prototype.slice.call(arguments,0);pe.unshift("SEMVER"),console.log.apply(console,pe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],D=0,L=D++;y[L]="0|[1-9]\\d*";var P=D++;y[P]="[0-9]+";var w=D++;y[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=D++;y[I]="("+y[L]+")\\.("+y[L]+")\\.("+y[L]+")";var v=D++;y[v]="("+y[P]+")\\.("+y[P]+")\\.("+y[P]+")";var m=D++;y[m]="(?:"+y[L]+"|"+y[w]+")";var d=D++;y[d]="(?:"+y[P]+"|"+y[w]+")";var f=D++;y[f]="(?:-("+y[m]+"(?:\\."+y[m]+")*))";var p=D++;y[p]="(?:-?("+y[d]+"(?:\\."+y[d]+")*))";var b=D++;y[b]="[0-9A-Za-z-]+";var S=D++;y[S]="(?:\\+("+y[b]+"(?:\\."+y[b]+")*))";var g=D++,r="v?"+y[I]+y[f]+"?"+y[S]+"?";y[g]="^"+r+"$";var l="[v=\\s]*"+y[v]+y[p]+"?"+y[S]+"?",s=D++;y[s]="^"+l+"$";var a=D++;y[a]="((?:<|>)?=?)";var o=D++;y[o]=y[P]+"|x|X|\\*";var u=D++;y[u]=y[L]+"|x|X|\\*";var i=D++;y[i]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[f]+")?"+y[S]+"?)?)?";var n=D++;y[n]="[v=\\s]*("+y[o]+")(?:\\.("+y[o]+")(?:\\.("+y[o]+")(?:"+y[p]+")?"+y[S]+"?)?)?";var h=D++;y[h]="^"+y[a]+"\\s*"+y[i]+"$";var E=D++;y[E]="^"+y[a]+"\\s*"+y[n]+"$";var C=D++;y[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=D++;y[M]="(?:~>?)";var K=D++;y[K]="(\\s*)"+y[M]+"\\s+",A[K]=new RegExp(y[K],"g");var q=D++;y[q]="^"+y[M]+y[i]+"$";var F=D++;y[F]="^"+y[M]+y[n]+"$";var B=D++;y[B]="(?:\\^)";var O=D++;y[O]="(\\s*)"+y[B]+"\\s+",A[O]=new RegExp(y[O],"g");var U=D++;y[U]="^"+y[B]+y[i]+"$";var z=D++;y[z]="^"+y[B]+y[n]+"$";var j=D++;y[j]="^"+y[a]+"\\s*("+l+")$|^$";var ue=D++;y[ue]="^"+y[a]+"\\s*("+r+")$|^$";var V=D++;y[V]="(\\s*)"+y[a]+"\\s*("+l+"|"+y[i]+")",A[V]=new RegExp(y[V],"g");var _=D++;y[_]="^\\s*("+y[i]+")\\s+-\\s+("+y[i]+")\\s*$";var J=D++;y[J]="^\\s*("+y[n]+")\\s+-\\s+("+y[n]+")\\s*$";var ne=D++;y[ne]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)T(ee,y[ee]),A[ee]||(A[ee]=new RegExp(y[ee]));function X(pe,De){if(pe instanceof G)return pe;if(typeof pe!="string"||pe.length>R||!(De?A[s]:A[g]).test(pe))return null;try{return new G(pe,De)}catch{return null}}function G(pe,De){if(pe instanceof G){if(pe.loose===De)return pe;pe=pe.version}else if(typeof pe!="string")throw new TypeError("Invalid Version: "+pe);if(pe.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof G))return new G(pe,De);T("SemVer",pe,De),this.loose=De;var ke=pe.trim().match(De?A[s]:A[g]);if(!ke)throw new TypeError("Invalid Version: "+pe);if(this.raw=pe,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Ge=+je;if(Ge>=0&&Ge<k)return Ge}return je}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=X,e.valid=function(pe,De){var ke=X(pe,De);return ke?ke.version:null},e.clean=function(pe,De){var ke=X(pe.trim().replace(/^[=v]+/,""),De);return ke?ke.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(pe){return T("SemVer.compare",this.version,this.loose,pe),pe instanceof G||(pe=new G(pe,this.loose)),this.compareMain(pe)||this.comparePre(pe)},G.prototype.compareMain=function(pe){return pe instanceof G||(pe=new G(pe,this.loose)),be(this.major,pe.major)||be(this.minor,pe.minor)||be(this.patch,pe.patch)},G.prototype.comparePre=function(pe){if(pe instanceof G||(pe=new G(pe,this.loose)),this.prerelease.length&&!pe.prerelease.length)return-1;if(!this.prerelease.length&&pe.prerelease.length)return 1;if(!this.prerelease.length&&!pe.prerelease.length)return 0;var De=0;do{var ke=this.prerelease[De],je=pe.prerelease[De];if(T("prerelease compare",De,ke,je),ke===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ke===void 0)return-1;if(ke!==je)return be(ke,je)}while(++De)},G.prototype.inc=function(pe,De){switch(pe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+pe)}return this.format(),this.raw=this.version,this},e.inc=function(pe,De,ke,je){typeof ke=="string"&&(je=ke,ke=void 0);try{return new G(pe,ke).inc(De,je).version}catch{return null}},e.diff=function(pe,De){if(se(pe,De))return null;var ke=X(pe),je=X(De);if(ke.prerelease.length||je.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return Ge},e.compareIdentifiers=be;var de=/^[0-9]+$/;function be(pe,De){var ke=de.test(pe),je=de.test(De);return ke&&je&&(pe=+pe,De=+De),ke&&!je?-1:je&&!ke?1:pe<De?-1:pe>De?1:0}function Ee(pe,De,ke){return new G(pe,ke).compare(new G(De,ke))}function Pe(pe,De,ke){return Ee(pe,De,ke)>0}function Fe(pe,De,ke){return Ee(pe,De,ke)<0}function se(pe,De,ke){return Ee(pe,De,ke)===0}function oe(pe,De,ke){return Ee(pe,De,ke)!==0}function fe(pe,De,ke){return Ee(pe,De,ke)>=0}function Z(pe,De,ke){return Ee(pe,De,ke)<=0}function ce(pe,De,ke,je){var Ge;switch(De){case"===":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe===ke;break;case"!==":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe!==ke;break;case"":case"=":case"==":Ge=se(pe,ke,je);break;case"!=":Ge=oe(pe,ke,je);break;case">":Ge=Pe(pe,ke,je);break;case">=":Ge=fe(pe,ke,je);break;case"<":Ge=Fe(pe,ke,je);break;case"<=":Ge=Z(pe,ke,je);break;default:throw new TypeError("Invalid operator: "+De)}return Ge}function ie(pe,De){if(pe instanceof ie){if(pe.loose===De)return pe;pe=pe.value}if(!(this instanceof ie))return new ie(pe,De);T("comparator",pe,De),this.loose=De,this.parse(pe),this.semver===N?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(pe,De){return be(De,pe)},e.major=function(pe,De){return new G(pe,De).major},e.minor=function(pe,De){return new G(pe,De).minor},e.patch=function(pe,De){return new G(pe,De).patch},e.compare=Ee,e.compareLoose=function(pe,De){return Ee(pe,De,!0)},e.rcompare=function(pe,De,ke){return Ee(De,pe,ke)},e.sort=function(pe,De){return pe.sort(function(ke,je){return e.compare(ke,je,De)})},e.rsort=function(pe,De){return pe.sort(function(ke,je){return e.rcompare(ke,je,De)})},e.gt=Pe,e.lt=Fe,e.eq=se,e.neq=oe,e.gte=fe,e.lte=Z,e.cmp=ce,e.Comparator=ie;var N={};function H(pe,De){if(pe instanceof H)return pe.loose===De?pe:new H(pe.raw,De);if(pe instanceof ie)return new H(pe.value,De);if(!(this instanceof H))return new H(pe,De);if(this.loose=De,this.raw=pe,this.set=pe.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+pe);this.format()}function Q(pe){return!pe||pe.toLowerCase()==="x"||pe==="*"}function Y(pe,De,ke,je,Ge,et,Qe,nt,st,ht,Me,it,ae){return((De=Q(ke)?"":Q(je)?">="+ke+".0.0":Q(Ge)?">="+ke+"."+je+".0":">="+De)+" "+(nt=Q(st)?"":Q(ht)?"<"+(+st+1)+".0.0":Q(Me)?"<"+st+"."+(+ht+1)+".0":it?"<="+st+"."+ht+"."+Me+"-"+it:"<="+nt)).trim()}function he(pe,De){for(var ke=0;ke<pe.length;ke++)if(!pe[ke].test(De))return!1;if(De.prerelease.length){for(ke=0;ke<pe.length;ke++)if(T(pe[ke].semver),pe[ke].semver!==N&&pe[ke].semver.prerelease.length>0){var je=pe[ke].semver;if(je.major===De.major&&je.minor===De.minor&&je.patch===De.patch)return!0}return!1}return!0}function we(pe,De,ke){try{De=new H(De,ke)}catch{return!1}return De.test(pe)}function Ae(pe,De,ke,je){var Ge,et,Qe,nt,st;switch(pe=new G(pe,je),De=new H(De,je),ke){case">":Ge=Pe,et=Z,Qe=Fe,nt=">",st=">=";break;case"<":Ge=Fe,et=fe,Qe=Pe,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(pe,De,je))return!1;for(var ht=0;ht<De.set.length;++ht){var Me=De.set[ht],it=null,ae=null;if(Me.forEach(function($){$.semver===N&&($=new ie(">=0.0.0")),it=it||$,ae=ae||$,Ge($.semver,it.semver,je)?it=$:Qe($.semver,ae.semver,je)&&(ae=$)}),it.operator===nt||it.operator===st||(!ae.operator||ae.operator===nt)&&et(pe,ae.semver)||ae.operator===st&&Qe(pe,ae.semver))return!1}return!0}ie.prototype.parse=function(pe){var De=this.loose?A[j]:A[ue],ke=pe.match(De);if(!ke)throw new TypeError("Invalid comparator: "+pe);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new G(ke[2],this.loose):this.semver=N},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(pe){return T("Comparator.test",pe,this.loose),this.semver===N||(typeof pe=="string"&&(pe=new G(pe,this.loose)),ce(pe,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(pe,De){if(!(pe instanceof ie))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new H(pe.value,De),we(this.value,ke,De);if(pe.operator==="")return ke=new H(this.value,De),we(pe.semver,ke,De);var je=!(this.operator!==">="&&this.operator!==">"||pe.operator!==">="&&pe.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||pe.operator!=="<="&&pe.operator!=="<"),et=this.semver.version===pe.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||pe.operator!==">="&&pe.operator!=="<="),nt=ce(this.semver,"<",pe.semver,De)&&(this.operator===">="||this.operator===">")&&(pe.operator==="<="||pe.operator==="<"),st=ce(this.semver,">",pe.semver,De)&&(this.operator==="<="||this.operator==="<")&&(pe.operator===">="||pe.operator===">");return je||Ge||et&&Qe||nt||st},e.Range=H,H.prototype.format=function(){return this.range=this.set.map(function(pe){return pe.join(" ").trim()}).join("||").trim(),this.range},H.prototype.toString=function(){return this.range},H.prototype.parseRange=function(pe){var De=this.loose;pe=pe.trim(),T("range",pe,De);var ke=De?A[J]:A[_];pe=pe.replace(ke,Y),T("hyphen replace",pe),pe=pe.replace(A[V],"$1$2$3"),T("comparator trim",pe,A[V]),pe=(pe=(pe=pe.replace(A[K],"$1~")).replace(A[O],"$1^")).split(/\s+/).join(" ");var je=De?A[j]:A[ue],Ge=pe.split(" ").map(function(et){return function(Qe,nt){return T("comp",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,ae){T("caret",it,ae);var $=ae?A[z]:A[U];return it.replace($,function(le,Ie,Le,Be,Xe){var Ze;return T("caret",it,le,Ie,Le,Be,Xe),Q(Ie)?Ze="":Q(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Q(Be)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":Xe?(T("replaceCaret pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+Xe+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+Xe+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+Xe+" <"+(+Ie+1)+".0.0"):(T("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+" <"+(+Ie+1)+".0.0"),T("caret return",Ze),Ze})}(Me,ht)}).join(" ")}(Qe,nt),T("caret",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Me){return function(it,ae){var $=ae?A[F]:A[q];return it.replace($,function(le,Ie,Le,Be,Xe){var Ze;return T("tilde",it,le,Ie,Le,Be,Xe),Q(Ie)?Ze="":Q(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Q(Be)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":Xe?(T("replaceTilde pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),Ze=">="+Ie+"."+Le+"."+Be+Xe+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0",T("tilde return",Ze),Ze})}(Me,ht)}).join(" ")}(Qe,nt),T("tildes",Qe),Qe=function(st,ht){return T("replaceXRanges",st,ht),st.split(/\s+/).map(function(Me){return function(it,ae){it=it.trim();var $=ae?A[E]:A[h];return it.replace($,function(le,Ie,Le,Be,Xe,Ze){T("xRange",it,le,Ie,Le,Be,Xe,Ze);var gt=Q(Le),mt=gt||Q(Be),lt=mt||Q(Xe);return Ie==="="&&lt&&(Ie=""),gt?le=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&lt?(mt&&(Be=0),lt&&(Xe=0),Ie===">"?(Ie=">=",mt?(Le=+Le+1,Be=0,Xe=0):lt&&(Be=+Be+1,Xe=0)):Ie==="<="&&(Ie="<",mt?Le=+Le+1:Be=+Be+1),le=Ie+Le+"."+Be+"."+Xe):mt?le=">="+Le+".0.0 <"+(+Le+1)+".0.0":lt&&(le=">="+Le+"."+Be+".0 <"+Le+"."+(+Be+1)+".0"),T("xRange return",le),le})}(Me,ht)}).join(" ")}(Qe,nt),T("xrange",Qe),Qe=function(st,ht){return T("replaceStars",st,ht),st.trim().replace(A[ne],"")}(Qe,nt),T("stars",Qe),Qe}(et,De)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(et){return!!et.match(je)})),Ge=Ge.map(function(et){return new ie(et,De)})},H.prototype.intersects=function(pe,De){if(!(pe instanceof H))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(je){return pe.set.some(function(Ge){return Ge.every(function(et){return je.intersects(et,De)})})})})},e.toComparators=function(pe,De){return new H(pe,De).set.map(function(ke){return ke.map(function(je){return je.value}).join(" ").trim().split(" ")})},H.prototype.test=function(pe){if(!pe)return!1;typeof pe=="string"&&(pe=new G(pe,this.loose));for(var De=0;De<this.set.length;De++)if(he(this.set[De],pe))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(pe,De,ke){var je=null,Ge=null;try{var et=new H(De,ke)}catch{return null}return pe.forEach(function(Qe){et.test(Qe)&&(je&&Ge.compare(Qe)!==-1||(Ge=new G(je=Qe,ke)))}),je},e.minSatisfying=function(pe,De,ke){var je=null,Ge=null;try{var et=new H(De,ke)}catch{return null}return pe.forEach(function(Qe){et.test(Qe)&&(je&&Ge.compare(Qe)!==1||(Ge=new G(je=Qe,ke)))}),je},e.validRange=function(pe,De){try{return new H(pe,De).range||"*"}catch{return null}},e.ltr=function(pe,De,ke){return Ae(pe,De,"<",ke)},e.gtr=function(pe,De,ke){return Ae(pe,De,">",ke)},e.outside=Ae,e.prerelease=function(pe,De){var ke=X(pe,De);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(pe,De,ke){return pe=new H(pe,ke),De=new H(De,ke),pe.intersects(De)},e.coerce=function(pe){if(pe instanceof G)return pe;if(typeof pe!="string")return null;var De=pe.match(A[C]);return De==null?null:X((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,c(1))},function(te,e){var c,t,T=te.exports={};function R(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function A(d){if(c===setTimeout)return setTimeout(d,0);if((c===R||!c)&&setTimeout)return c=setTimeout,setTimeout(d,0);try{return c(d,0)}catch{try{return c.call(null,d,0)}catch{return c.call(this,d,0)}}}(function(){try{c=typeof setTimeout=="function"?setTimeout:R}catch{c=R}try{t=typeof clearTimeout=="function"?clearTimeout:k}catch{t=k}})();var y,D=[],L=!1,P=-1;function w(){L&&y&&(L=!1,y.length?D=y.concat(D):P=-1,D.length&&I())}function I(){if(!L){var d=A(w);L=!0;for(var f=D.length;f;){for(y=D,D=[];++P<f;)y&&y[P].run();P=-1,f=D.length}y=null,L=!1,function(p){if(t===clearTimeout)return clearTimeout(p);if((t===k||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(p);try{t(p)}catch{try{return t.call(null,p)}catch{return t.call(this,p)}}}(d)}}function v(d,f){this.fun=d,this.array=f}function m(){}T.nextTick=function(d){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];D.push(new v(d,f)),D.length!==1||L||A(I)},v.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=m,T.addListener=m,T.once=m,T.off=m,T.removeListener=m,T.removeAllListeners=m,T.emit=m,T.prependListener=m,T.prependOnceListener=m,T.listeners=function(d){return[]},T.binding=function(d){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(d){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(ye[103],Ce([1,0,9,6]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(S){const g=S;return g?typeof g.read=="function":!1}e.isReadable=T;function R(S){const g=S;return g?[g.on,g.pause,g.resume,g.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=R;function k(S){const g=S;return g?R(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=k;function A(S,g){return new y(S,g)}e.newWriteableStream=A;class y{constructor(g,r){this.e=g,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(r=>r(g))}h(g){this.c.error.length===0?(0,c.onUnexpectedError)(g):this.c.error.slice(0).forEach(r=>r(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,r){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(g,r){if(this.a.destroyed)return;let l;switch(g){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const s=l.indexOf(r);s>=0&&l.splice(s,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function D(S,g){const r=[];let l;for(;(l=S.read())!==null;)r.push(l);return g(r)}e.consumeReadable=D;function L(S,g,r){const l=[];let s;for(;(s=S.read())!==null&&l.length<r;)l.push(s);return s===null&&l.length>0?g(l):{read:()=>{if(l.length>0)return l.shift();if(typeof s<"u"){const a=s;return s=void 0,a}return S.read()}}}e.peekReadable=L;function P(S,g){return new Promise((r,l)=>{const s=[];w(S,{onData:a=>{g&&s.push(a)},onError:a=>{g?l(a):r(void 0)},onEnd:()=>{r(g?g(s):void 0)}})})}e.consumeStream=P;function w(S,g){let r=!1;return S.on("error",l=>{r||g.onError(l)}),S.on("end",()=>{r||g.onEnd()}),S.on("data",l=>{r||g.onData(l)}),(0,t.toDisposable)(()=>r=!0)}e.listenStream=w;function I(S,g){return new Promise((r,l)=>{const s=new t.DisposableStore,a=[],o=n=>{if(a.push(n),a.length>g)return s.dispose(),S.pause(),r({stream:S,buffer:a,ended:!1})},u=n=>l(n),i=()=>r({stream:S,buffer:a,ended:!0});s.add((0,t.toDisposable)(()=>S.removeListener("error",u))),S.on("error",u),s.add((0,t.toDisposable)(()=>S.removeListener("end",i))),S.on("end",i),s.add((0,t.toDisposable)(()=>S.removeListener("data",o))),S.on("data",o)})}e.peekStream=I;function v(S,g){const r=A(g);return r.end(S),r}e.toStream=v;function m(){const S=A(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=m;function d(S){let g=!1;return{read:()=>g?null:(g=!0,S)}}e.toReadable=d;function f(S,g,r){const l=A(r);return w(S,{onData:s=>l.write(g.data(s)),onError:s=>l.error(g.error?g.error(s):s),onEnd:()=>l.end()}),l}e.transform=f;function p(S,g,r){let l=!1;return{read:()=>{const s=g.read();return l?s:(l=!0,s!==null?r([S,s]):S)}}}e.prefixedReadable=p;function b(S,g,r){let l=!1;const s=A(r);return w(g,{onData:a=>l?s.write(a):(l=!0,s.write(r([S,a]))),onError:a=>s.error(a),onEnd:()=>{l||(l=!0,s.write(S)),s.end()}}),s}e.prefixedStream=b}),define(ye[23],Ce([1,0,103]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let T,R;class k{static alloc(n){return t?new k(Buffer.allocUnsafe(n)):new k(new Uint8Array(n))}static wrap(n){return t&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new k(n)}static fromString(n,h){return!(h?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(n)):(T||(T=new TextEncoder),new k(T.encode(n)))}static fromByteArray(n){const h=k.alloc(n.length);for(let E=0,C=n.length;E<C;E++)h.buffer[E]=n[E];return h}static concat(n,h){if(typeof h>"u"){h=0;for(let M=0,K=n.length;M<K;M++)h+=n[M].byteLength}const E=k.alloc(h);let C=0;for(let M=0,K=n.length;M<K;M++){const q=n[M];E.set(q,C),C+=q.byteLength}return E}constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}clone(){const n=k.alloc(this.byteLength);return n.set(this),n}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(n,h){return new k(this.buffer.subarray(n,h))}set(n,h){if(n instanceof k)this.buffer.set(n.buffer,h);else if(n instanceof Uint8Array)this.buffer.set(n,h);else if(n instanceof ArrayBuffer)this.buffer.set(new Uint8Array(n),h);else if(ArrayBuffer.isView(n))this.buffer.set(new Uint8Array(n.buffer,n.byteOffset,n.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(n){return D(this.buffer,n)}writeUInt32BE(n,h){L(this.buffer,n,h)}readUInt32LE(n){return P(this.buffer,n)}writeUInt32LE(n,h){w(this.buffer,n,h)}readUInt8(n){return I(this.buffer,n)}writeUInt8(n,h){v(this.buffer,n,h)}}e.VSBuffer=k;function A(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0}e.readUInt16LE=A;function y(i,n,h){i[h+0]=n&255,n=n>>>8,i[h+1]=n&255}e.writeUInt16LE=y;function D(i,n){return i[n]*2**24+i[n+1]*2**16+i[n+2]*2**8+i[n+3]}e.readUInt32BE=D;function L(i,n,h){i[h+3]=n,n=n>>>8,i[h+2]=n,n=n>>>8,i[h+1]=n,n=n>>>8,i[h]=n}e.writeUInt32BE=L;function P(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0|i[n+2]<<16>>>0|i[n+3]<<24>>>0}e.readUInt32LE=P;function w(i,n,h){i[h+0]=n&255,n=n>>>8,i[h+1]=n&255,n=n>>>8,i[h+2]=n&255,n=n>>>8,i[h+3]=n&255}e.writeUInt32LE=w;function I(i,n){return i[n]}e.readUInt8=I;function v(i,n,h){i[h]=n}e.writeUInt8=v;function m(i){return c.consumeReadable(i,n=>k.concat(n))}e.readableToBuffer=m;function d(i){return c.toReadable(i)}e.bufferToReadable=d;function f(i){return c.consumeStream(i,n=>k.concat(n))}e.streamToBuffer=f;async function p(i){return i.ended?k.concat(i.buffer):k.concat([...i.buffer,await f(i.stream)])}e.bufferedStreamToBuffer=p;function b(i){return c.toStream(i,n=>k.concat(n))}e.bufferToStream=b;function S(i){return c.transform(i,{data:n=>typeof n=="string"?k.fromString(n):k.wrap(n)},n=>k.concat(n))}e.streamToBufferReadableStream=S;function g(i){return c.newWriteableStream(n=>k.concat(n),i)}e.newWriteableBufferStream=g;function r(i,n){return c.prefixedReadable(i,n,h=>k.concat(h))}e.prefixedBufferReadable=r;function l(i,n){return c.prefixedStream(i,n,h=>k.concat(h))}e.prefixedBufferStream=l;function s(i){let n=0,h=0,E=0;const C=new Uint8Array(Math.floor(i.length/4*3)),M=q=>{switch(h){case 3:C[E++]=n|q,h=0;break;case 2:C[E++]=n|q>>>2,n=q<<6,h=3;break;case 1:C[E++]=n|q>>>4,n=q<<4,h=2;break;default:n=q<<2,h=1}};for(let q=0;q<i.length;q++){const F=i.charCodeAt(q);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${i[q]}`)}}const K=E;for(;h>0;)M(0);return k.wrap(C).slice(0,K)}e.decodeBase64=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:i},n=!0,h=!1){const E=h?o:a;let C="";const M=i.byteLength%3;let K=0;for(;K<i.byteLength-M;K+=3){const q=i[K+0],F=i[K+1],B=i[K+2];C+=E[q>>>2],C+=E[(q<<4|F>>>4)&63],C+=E[(F<<2|B>>>6)&63],C+=E[B&63]}if(M===1){const q=i[K+0];C+=E[q>>>2],C+=E[q<<4&63],n&&(C+="==")}else if(M===2){const q=i[K+0],F=i[K+1];C+=E[q>>>2],C+=E[(q<<4|F>>>4)&63],C+=E[F<<2&63],n&&(C+="=")}return C}e.encodeBase64=u}),define(ye[10],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function c(l){return typeof l=="string"}e.isString=c;function t(l){return Array.isArray(l)&&l.every(s=>c(s))}e.isStringArray=t;function T(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=T;function R(l){const s=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof s}e.isTypedArray=R;function k(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=k;function A(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=A;function y(l){return l===!0||l===!1}e.isBoolean=y;function D(l){return typeof l>"u"}e.isUndefined=D;function L(l){return!P(l)}e.isDefined=L;function P(l){return D(l)||l===null}e.isUndefinedOrNull=P;function w(l,s){if(!l)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=w;function I(l){if(P(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=I;function v(...l){const s=[];for(let a=0;a<l.length;a++){const o=l[a];if(P(o))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);s.push(o)}return s}e.assertAllDefined=v;const m=Object.prototype.hasOwnProperty;function d(l){if(!T(l))return!1;for(const s in l)if(m.call(l,s))return!1;return!0}e.isEmptyObject=d;function f(l){return typeof l=="function"}e.isFunction=f;function p(...l){return l.length>0&&l.every(f)}e.areFunctions=p;function b(l,s){const a=Math.min(l.length,s.length);for(let o=0;o<a;o++)S(l[o],s[o])}e.validateConstraints=b;function S(l,s){if(c(s)){if(typeof l!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(f(s)){try{if(l instanceof s)return}catch{}if(!P(l)&&l.constructor===s||s.length===1&&s.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function g(l){return l===null?void 0:l}e.withNullAsUndefined=g;function r(l){return typeof l>"u"?null:l}e.withUndefinedAsNull=r}),define(ye[22],Ce([1,0,10]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const p=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([b,S])=>{p[b]=S&&typeof S=="object"?t(S):S}),p}e.deepClone=t;function T(f){if(!f||typeof f!="object")return f;const p=[f];for(;p.length>0;){const b=p.shift();Object.freeze(b);for(const S in b)if(R.call(b,S)){const g=b[S];typeof g=="object"&&!Object.isFrozen(g)&&!(0,c.isTypedArray)(g)&&p.push(g)}}return f}e.deepFreeze=T;const R=Object.prototype.hasOwnProperty;function k(f,p){return A(f,p,new Set)}e.cloneAndChange=k;function A(f,p,b){if((0,c.isUndefinedOrNull)(f))return f;const S=p(f);if(typeof S<"u")return S;if(Array.isArray(f)){const g=[];for(const r of f)g.push(A(r,p,b));return g}if((0,c.isObject)(f)){if(b.has(f))throw new Error("Cannot clone recursive data-structure");b.add(f);const g={};for(const r in f)R.call(f,r)&&(g[r]=A(f[r],p,b));return b.delete(f),g}return f}function y(f,p,b=!0){return(0,c.isObject)(f)?((0,c.isObject)(p)&&Object.keys(p).forEach(S=>{S in f?b&&((0,c.isObject)(f[S])&&(0,c.isObject)(p[S])?y(f[S],p[S],b):f[S]=p[S]):f[S]=p[S]}),f):p}e.mixin=y;function D(f,p){if(f===p)return!0;if(f==null||p===null||p===void 0||typeof f!=typeof p||typeof f!="object"||Array.isArray(f)!==Array.isArray(p))return!1;let b,S;if(Array.isArray(f)){if(f.length!==p.length)return!1;for(b=0;b<f.length;b++)if(!D(f[b],p[b]))return!1}else{const g=[];for(S in f)g.push(S);g.sort();const r=[];for(S in p)r.push(S);if(r.sort(),!D(g,r))return!1;for(b=0;b<g.length;b++)if(!D(f[g[b]],p[g[b]]))return!1}return!0}e.equals=D;function L(f){const p=new Set;return JSON.stringify(f,(b,S)=>{if((0,c.isObject)(S)||Array.isArray(S)){if(p.has(S))return"[Circular]";p.add(S)}return S})}e.safeStringify=L;function P(f,p){const b=Object.create(null);return!f||!p||Object.keys(p).forEach(g=>{const r=f[g],l=p[g];D(r,l)||(b[g]=l)}),b}e.distinct=P;function w(f,p){const b=p.toLowerCase(),S=Object.keys(f).find(g=>g.toLowerCase()===b);return S?f[S]:f[p]}e.getCaseInsensitive=w;function I(f,p){const b=Object.create(null);for(const[S,g]of Object.entries(f))p(S,g)&&(b[S]=g);return b}e.filter=I;function v(f){let p=[],b=Object.getPrototypeOf(f);for(;Object.prototype!==b;)p=p.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return p}e.getAllPropertyNames=v;function m(f){const p=[];for(const b of v(f))typeof f[b]=="function"&&p.push(b);return p}e.getAllMethodNames=m;function d(f,p){const b=g=>function(){const r=Array.prototype.slice.call(arguments,0);return p(g,r)},S={};for(const g of f)S[g]=b(g);return S}e.createProxyObject=d}),define(ye[104],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var c;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c=e.Constants||(e.Constants={}));function t(R){return R<0?0:R>255?255:R|0}e.toUint8=t;function T(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=T}),define(ye[30],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(T){return c.test(T)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const R=new Uint8Array(16),k=[];for(let A=0;A<256;A++)k.push(A.toString(16).padStart(2,"0"));return function(){T(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,D="";return D+=k[R[y++]],D+=k[R[y++]],D+=k[R[y++]],D+=k[R[y++]],D+="-",D+=k[R[y++]],D+=k[R[y++]],D+="-",D+=k[R[y++]],D+=k[R[y++]],D+="-",D+=k[R[y++]],D+=k[R[y++]],D+="-",D+=k[R[y++]],D+=k[R[y++]],D+=k[R[y++]],D+=k[R[y++]],D+=k[R[y++]],D+=k[R[y++]],D}}()}),define(ye[148],Ce([1,0,16,30]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function T(A){return{id:(0,t.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=T;function R(A,y,D){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:y,data:D}),value:void 0}}e.createFileDataTransferItem=R;class k{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,D){const L=this.a.get(y);L?L.push(D):this.a.set(this.b(y),[D])}replace(y,D){this.a.set(this.b(y),[D])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,D]of this.a.entries())for(const L of D)yield[y,L]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[D,L]of this.entries())y(L,D)}b(y){return y.toLowerCase()}}e.VSDataTransfer=k,e.UriList=Object.freeze({create:A=>(0,c.distinct)(A.map(y=>y.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(y=>!y.startsWith("#"))})}),define(ye[105],Ce([1,0,104]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(A){const y=(0,c.toUint8)(A);this.c=y,this.a=t.d(y),this.b=new Map}static d(A){const y=new Uint8Array(256);return y.fill(A),y}set(A,y){const D=(0,c.toUint8)(y);A>=0&&A<256?this.a[A]=D:this.b.set(A,D)}get(A){return A>=0&&A<256?this.a[A]:this.b.get(A)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var T;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(T||(T={}));class R{constructor(){this.a=new t(0)}add(A){this.a.set(A,1)}has(A){return this.a.get(A)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(ye[52],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class c{constructor(T,R){this.lineNumber=T,this.column=R}with(T=this.lineNumber,R=this.column){return T===this.lineNumber&&R===this.column?this:new c(T,R)}delta(T=0,R=0){return this.with(this.lineNumber+T,this.column+R)}equals(T){return c.equals(this,T)}static equals(T,R){return!T&&!R?!0:!!T&&!!R&&T.lineNumber===R.lineNumber&&T.column===R.column}isBefore(T){return c.isBefore(this,T)}static isBefore(T,R){return T.lineNumber<R.lineNumber?!0:R.lineNumber<T.lineNumber?!1:T.column<R.column}isBeforeOrEqual(T){return c.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,R){return T.lineNumber<R.lineNumber?!0:R.lineNumber<T.lineNumber?!1:T.column<=R.column}static compare(T,R){const k=T.lineNumber|0,A=R.lineNumber|0;if(k===A){const y=T.column|0,D=R.column|0;return y-D}return k-A}clone(){return new c(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new c(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=c}),define(ye[36],Ce([1,0,52]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(R,k,A,y){R>A||R===A&&k>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=R,this.endColumn=k):(this.startLineNumber=R,this.startColumn=k,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return t.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return t.containsPosition(this,R)}static containsPosition(R,k){return!(k.lineNumber<R.startLineNumber||k.lineNumber>R.endLineNumber||k.lineNumber===R.startLineNumber&&k.column<R.startColumn||k.lineNumber===R.endLineNumber&&k.column>R.endColumn)}static strictContainsPosition(R,k){return!(k.lineNumber<R.startLineNumber||k.lineNumber>R.endLineNumber||k.lineNumber===R.startLineNumber&&k.column<=R.startColumn||k.lineNumber===R.endLineNumber&&k.column>=R.endColumn)}containsRange(R){return t.containsRange(this,R)}static containsRange(R,k){return!(k.startLineNumber<R.startLineNumber||k.endLineNumber<R.startLineNumber||k.startLineNumber>R.endLineNumber||k.endLineNumber>R.endLineNumber||k.startLineNumber===R.startLineNumber&&k.startColumn<R.startColumn||k.endLineNumber===R.endLineNumber&&k.endColumn>R.endColumn)}strictContainsRange(R){return t.strictContainsRange(this,R)}static strictContainsRange(R,k){return!(k.startLineNumber<R.startLineNumber||k.endLineNumber<R.startLineNumber||k.startLineNumber>R.endLineNumber||k.endLineNumber>R.endLineNumber||k.startLineNumber===R.startLineNumber&&k.startColumn<=R.startColumn||k.endLineNumber===R.endLineNumber&&k.endColumn>=R.endColumn)}plusRange(R){return t.plusRange(this,R)}static plusRange(R,k){let A,y,D,L;return k.startLineNumber<R.startLineNumber?(A=k.startLineNumber,y=k.startColumn):k.startLineNumber===R.startLineNumber?(A=k.startLineNumber,y=Math.min(k.startColumn,R.startColumn)):(A=R.startLineNumber,y=R.startColumn),k.endLineNumber>R.endLineNumber?(D=k.endLineNumber,L=k.endColumn):k.endLineNumber===R.endLineNumber?(D=k.endLineNumber,L=Math.max(k.endColumn,R.endColumn)):(D=R.endLineNumber,L=R.endColumn),new t(A,y,D,L)}intersectRanges(R){return t.intersectRanges(this,R)}static intersectRanges(R,k){let A=R.startLineNumber,y=R.startColumn,D=R.endLineNumber,L=R.endColumn;const P=k.startLineNumber,w=k.startColumn,I=k.endLineNumber,v=k.endColumn;return A<P?(A=P,y=w):A===P&&(y=Math.max(y,w)),D>I?(D=I,L=v):D===I&&(L=Math.min(L,v)),A>D||A===D&&y>L?null:new t(A,y,D,L)}equalsRange(R){return t.equalsRange(this,R)}static equalsRange(R,k){return!R&&!k?!0:!!R&&!!k&&R.startLineNumber===k.startLineNumber&&R.startColumn===k.startColumn&&R.endLineNumber===k.endLineNumber&&R.endColumn===k.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(R){return new c.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(R){return new c.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,k){return new t(this.startLineNumber,this.startColumn,R,k)}setStartPosition(R,k){return new t(R,k,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(R){return new t(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return t.collapseToEnd(this)}static collapseToEnd(R){return new t(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new t(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,k=R){return new t(R.lineNumber,R.column,k.lineNumber,k.column)}static lift(R){return R?new t(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,k){return!(R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<k.startColumn||k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<R.startColumn)}static areIntersecting(R,k){return!(R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<=k.startColumn||k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,k){if(R&&k){const D=R.startLineNumber|0,L=k.startLineNumber|0;if(D===L){const P=R.startColumn|0,w=k.startColumn|0;if(P===w){const I=R.endLineNumber|0,v=k.endLineNumber|0;if(I===v){const m=R.endColumn|0,d=k.endColumn|0;return m-d}return I-v}return P-w}return D-L}return(R?1:0)-(k?1:0)}static compareRangesUsingEnds(R,k){return R.endLineNumber===k.endLineNumber?R.endColumn===k.endColumn?R.startLineNumber===k.startLineNumber?R.startColumn-k.startColumn:R.startLineNumber-k.startLineNumber:R.endColumn-k.endColumn:R.endLineNumber-k.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=t}),define(ye[149],Ce([1,0,52,36]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class R extends t.Range{constructor(A,y,D,L){super(A,y,D,L),this.selectionStartLineNumber=A,this.selectionStartColumn=y,this.positionLineNumber=D,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return R.selectionsEqual(this,A)}static selectionsEqual(A,y){return A.selectionStartLineNumber===y.selectionStartLineNumber&&A.selectionStartColumn===y.selectionStartColumn&&A.positionLineNumber===y.positionLineNumber&&A.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,A,y):new R(A,y,this.startLineNumber,this.startColumn)}getPosition(){return new c.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new c.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(A,y){return this.getDirection()===0?new R(A,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,A,y)}static fromPositions(A,y=A){return new R(A.lineNumber,A.column,y.lineNumber,y.column)}static fromRange(A,y){return y===0?new R(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):new R(A.endLineNumber,A.endColumn,A.startLineNumber,A.startColumn)}static liftSelection(A){return new R(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,y){if(A&&!y||!A&&y)return!1;if(!A&&!y)return!0;if(A.length!==y.length)return!1;for(let D=0,L=A.length;D<L;D++)if(!this.selectionsEqual(A[D],y[D]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,y,D,L,P){return P===0?new R(A,y,D,L):new R(D,L,A,y)}}e.Selection=R}),define(ye[150],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[151],Ce([1,0,105]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends c.CharacterClassifier{constructor(A){super(0);for(let y=0,D=A.length;y<D;y++)this.set(A.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function R(k){const A={};return y=>(A.hasOwnProperty(y)||(A[y]=k(y)),A[y])}e.getMapForWordSeparators=R(k=>new T(k))}),define(ye[106],Ce([1,0,64,6,65]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)P.indexOf(I)>=0||(w+="\\"+I);return w+="\\s]+)",new RegExp(w,"g")}e.DEFAULT_WORD_REGEXP=R();function k(P){let w=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)w=P;else{let I="g";P.ignoreCase&&(I+="i"),P.multiline&&(I+="m"),P.unicode&&(I+="u"),w=new RegExp(P.source,I)}return w.lastIndex=0,w}e.ensureValidWordDefinition=k;const A=new T.LinkedList;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(P){const w=A.unshift(P);return(0,t.toDisposable)(w)}e.setDefaultGetWordAtTextConfig=y;function D(P,w,I,v,m){if(m||(m=c.Iterable.first(A)),I.length>m.maxLen){let S=P-m.maxLen/2;return S<0?S=0:v+=S,I=I.substring(S,P+m.maxLen/2),D(P,w,I,v,m)}const d=Date.now(),f=P-1-v;let p=-1,b=null;for(let S=1;!(Date.now()-d>=m.timeBudget);S++){const g=f-m.windowSize*S;w.lastIndex=Math.max(0,g);const r=L(w,I,f,p);if(!r&&b||(b=r,g<=0))break;p=g}if(b){const S={word:b[0],startColumn:v+1+b.index,endColumn:v+1+b.index+b[0].length};return w.lastIndex=0,S}return null}e.getWordAtText=D;function L(P,w,I,v){let m;for(;m=P.exec(w);){const d=m.index||0;if(d<=I&&P.lastIndex>=I)return m;if(v>0&&d>v)return null}return null}}),define(ye[152],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class t{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let y=0,D=A.notIn.length;y<D;y++)switch(A.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const D=A.findTokenIndexAtOffset(y-2),L=A.getStandardTokenType(D);return this.isOK(L)}g(A,y){for(let D=A;D<=y;D++){const L=String.fromCharCode(D);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class T{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=T;function R(k,A,y){k.has(A)?k.get(A).push(y):k.set(A,[y])}}),define(ye[153],Ce([1,0,105]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(I){I[I.Invalid=0]="Invalid",I[I.Start=1]="Start",I[I.H=2]="H",I[I.HT=3]="HT",I[I.HTT=4]="HTT",I[I.HTTP=5]="HTTP",I[I.F=6]="F",I[I.FI=7]="FI",I[I.FIL=8]="FIL",I[I.BeforeColon=9]="BeforeColon",I[I.AfterColon=10]="AfterColon",I[I.AlmostThere=11]="AlmostThere",I[I.End=12]="End",I[I.Accept=13]="Accept",I[I.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class T{constructor(v,m,d){const f=new Uint8Array(v*m);for(let p=0,b=v*m;p<b;p++)f[p]=d;this.a=f,this.rows=v,this.cols=m}get(v,m){return this.a[v*this.cols+m]}set(v,m,d){this.a[v*this.cols+m]=d}}class R{constructor(v){let m=0,d=0;for(let p=0,b=v.length;p<b;p++){const[S,g,r]=v[p];g>m&&(m=g),S>d&&(d=S),r>d&&(d=r)}m++,d++;const f=new T(d,m,0);for(let p=0,b=v.length;p<b;p++){const[S,g,r]=v[p];f.set(S,g,r)}this.a=f,this.b=m}nextState(v,m){return m<0||m>=this.b?0:this.a.get(v,m)}}e.StateMachine=R;let k=null;function A(){return k===null&&(k=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var y;(function(I){I[I.None=0]="None",I[I.ForceTermination=1]="ForceTermination",I[I.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let D=null;function L(){if(D===null){D=new c.CharacterClassifier(0);const I=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<I.length;m++)D.set(I.charCodeAt(m),1);const v=".;:";for(let m=0;m<v.length;m++)D.set(v.charCodeAt(m),2)}return D}class P{static a(v,m,d,f,p){let b=p-1;do{const S=m.charCodeAt(b);if(v.get(S)!==2)break;b--}while(b>f);if(f>0){const S=m.charCodeAt(f-1),g=m.charCodeAt(b);(S===40&&g===41||S===91&&g===93||S===123&&g===125)&&b--}return{range:{startLineNumber:d,startColumn:f+1,endLineNumber:d,endColumn:b+2},url:m.substring(f,b+1)}}static computeLinks(v,m=A()){const d=L(),f=[];for(let p=1,b=v.getLineCount();p<=b;p++){const S=v.getLineContent(p),g=S.length;let r=0,l=0,s=0,a=1,o=!1,u=!1,i=!1,n=!1;for(;r<g;){let h=!1;const E=S.charCodeAt(r);if(a===13){let C;switch(E){case 40:o=!0,C=0;break;case 41:C=o?0:1;break;case 91:i=!0,u=!0,C=0;break;case 93:i=!1,C=u?0:1;break;case 123:n=!0,C=0;break;case 125:C=n?0:1;break;case 39:case 34:case 96:s===E?C=1:s===39||s===34||s===96?C=0:C=1;break;case 42:C=s===42?1:0;break;case 124:C=s===124?1:0;break;case 32:C=i?0:1;break;default:C=d.get(E)}C===1&&(f.push(P.a(d,S,p,l,r)),h=!0)}else if(a===12){let C;E===91?(u=!0,C=0):C=d.get(E),C===1?h=!0:a=13}else a=m.nextState(a,E),a===0&&(h=!0);h&&(a=1,o=!1,u=!1,n=!1,l=r+1,s=E),r++}a===13&&f.push(P.a(d,S,p,l,g))}return f}}e.LinkComputer=P;function w(I){return!I||typeof I.getLineCount!="function"||typeof I.getLineContent!="function"?[]:P.computeLinks(I)}e.computeLinks=w}),define(ye[107],Ce([1,0,22]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var k;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(S){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,S.tabSize|0),S.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,S.indentSize|0),this.a=!1),this.insertSpaces=Boolean(S.insertSpaces),this.defaultEOL=S.defaultEOL|0,this.trimAutoWhitespace=Boolean(S.trimAutoWhitespace),this.bracketPairColorizationOptions=S.bracketPairColorizationOptions}equals(S){return this.tabSize===S.tabSize&&this.a===S.a&&this.indentSize===S.indentSize&&this.insertSpaces===S.insertSpaces&&this.defaultEOL===S.defaultEOL&&this.trimAutoWhitespace===S.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,S.bracketPairColorizationOptions)}createChangeEvent(S){return{tabSize:this.tabSize!==S.tabSize,indentSize:this.indentSize!==S.indentSize,insertSpaces:this.insertSpaces!==S.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==S.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class L{constructor(S,g){this._findMatchBrand=void 0,this.range=S,this.matches=g}}e.FindMatch=L;var P;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function w(b){return b&&typeof b.read=="function"}e.isITextSnapshot=w;var I;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(I=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class m{constructor(S,g,r,l,s,a){this.identifier=S,this.range=g,this.text=r,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=s,this._isTracked=a}}e.ValidAnnotatedEditOperation=m;class d{constructor(S,g,r){this.regex=S,this.wordSeparators=g,this.simpleSearch=r}}e.SearchData=d;class f{constructor(S,g,r){this.reverseEdits=S,this.changes=g,this.trimAutoWhitespaceLineNumbers=r}}e.ApplyEditsResult=f;function p(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=p}),define(ye[154],Ce([1,0,16,104]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class T{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,D){y=(0,t.toUint32)(y);const L=this.a,P=this.b,w=D.length;return w===0?!1:(this.a=new Uint32Array(L.length+w),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y),y+w),this.a.set(D,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(y,D){return y=(0,t.toUint32)(y),D=(0,t.toUint32)(D),this.a[y]===D?!1:(this.a[y]=D,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,D){y=(0,t.toUint32)(y),D=(0,t.toUint32)(D);const L=this.a,P=this.b;if(y>=L.length)return!1;const w=L.length-y;return D>=w&&(D=w),D===0?!1:(this.a=new Uint32Array(L.length-D),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y+D),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,t.toUint32)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let D=this.c[0]+1;D===0&&(this.b[0]=this.a[0],D++),y>=this.a.length&&(y=this.a.length-1);for(let L=D;L<=y;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let D=0,L=this.a.length-1,P=0,w=0,I=0;for(;D<=L;)if(P=D+(L-D)/2|0,w=this.b[P],I=w-this.a[P],y<I)L=P-1;else if(y>=w)D=P+1;else break;return new k(P,y-I)}}e.PrefixSumComputer=T;class R{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const D=this.e[y],L=D>0?this.d[D-1]:0;return new k(D,y-L)}removeValues(y,D){this.a.splice(y,D),this.f(y)}insertValues(y,D){this.a=(0,c.arrayInsert)(this.a,y,D),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,D=this.a.length;y<D;y++){const L=this.a[y],P=y>0?this.d[y-1]:0;this.d[y]=P+L;for(let w=0;w<L;w++)this.e[P+w]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,D){this.a[y]!==D&&(this.a[y]=D,this.f(y))}}e.ConstantTimePrefixSumComputer=R;class k{constructor(y,D){this.index=y,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=D}}e.PrefixSumIndexOfResult=k}),define(ye[155],Ce([19,20]),function(te,e){return te.create("vs/base/common/actions",e)}),define(ye[156],Ce([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(ye[157],Ce([1,0,156]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,T=t*60,R=T*24,k=R*7,A=R*30,y=R*365;function D(P,w,I,v){typeof P!="number"&&(P=P.getTime());const m=Math.round((new Date().getTime()-P)/1e3);if(m<-30)return(0,c.localize)(0,null,D(new Date().getTime()+m*1e3,!1));if(!v&&m<30)return(0,c.localize)(1,null);let d;return m<t?(d=m,w?d===1?I?(0,c.localize)(2,null,d):(0,c.localize)(3,null,d):I?(0,c.localize)(4,null,d):(0,c.localize)(5,null,d):d===1?I?(0,c.localize)(6,null,d):(0,c.localize)(7,null,d):I?(0,c.localize)(8,null,d):(0,c.localize)(9,null,d)):m<T?(d=Math.floor(m/t),w?d===1?I?(0,c.localize)(10,null,d):(0,c.localize)(11,null,d):I?(0,c.localize)(12,null,d):(0,c.localize)(13,null,d):d===1?I?(0,c.localize)(14,null,d):(0,c.localize)(15,null,d):I?(0,c.localize)(16,null,d):(0,c.localize)(17,null,d)):m<R?(d=Math.floor(m/T),w?d===1?I?(0,c.localize)(18,null,d):(0,c.localize)(19,null,d):I?(0,c.localize)(20,null,d):(0,c.localize)(21,null,d):d===1?I?(0,c.localize)(22,null,d):(0,c.localize)(23,null,d):I?(0,c.localize)(24,null,d):(0,c.localize)(25,null,d)):m<k?(d=Math.floor(m/R),w?d===1?(0,c.localize)(26,null,d):(0,c.localize)(27,null,d):d===1?(0,c.localize)(28,null,d):(0,c.localize)(29,null,d)):m<A?(d=Math.floor(m/k),w?d===1?I?(0,c.localize)(30,null,d):(0,c.localize)(31,null,d):I?(0,c.localize)(32,null,d):(0,c.localize)(33,null,d):d===1?I?(0,c.localize)(34,null,d):(0,c.localize)(35,null,d):I?(0,c.localize)(36,null,d):(0,c.localize)(37,null,d)):m<y?(d=Math.floor(m/A),w?d===1?I?(0,c.localize)(38,null,d):(0,c.localize)(39,null,d):I?(0,c.localize)(40,null,d):(0,c.localize)(41,null,d):d===1?I?(0,c.localize)(42,null,d):(0,c.localize)(43,null,d):I?(0,c.localize)(44,null,d):(0,c.localize)(45,null,d)):(d=Math.floor(m/y),w?d===1?I?(0,c.localize)(46,null,d):(0,c.localize)(47,null,d):I?(0,c.localize)(48,null,d):(0,c.localize)(49,null,d):d===1?I?(0,c.localize)(50,null,d):(0,c.localize)(51,null,d):I?(0,c.localize)(52,null,d):(0,c.localize)(53,null,d))}e.fromNow=D;function L(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[158],Ce([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(ye[45],Ce([1,0,16,10,158]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(P,w){return w&&(P.stack||P.stacktrace)?T.localize(0,null,A(P),k(P.stack)||k(P.stacktrace)):A(P)}function k(P){return Array.isArray(P)?P.join(`
`):P}function A(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?T.localize(1,null,P.message):P.message||T.localize(2,null)}function y(P=null,w=!1){if(!P)return T.localize(3,null);if(Array.isArray(P)){const I=c.coalesce(P),v=y(I[0],w);return I.length>1?T.localize(4,null,v,I.length):v}if(t.isString(P))return P;if(P.detail){const I=P.detail;if(I.error)return R(I.error,w);if(I.exception)return R(I.exception,w)}return P.stack?R(P,w):P.message?P.message:T.localize(5,null)}e.toErrorMessage=y;function D(P){const w=P;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=D;function L(P,w){let I;return typeof P=="string"?I=new Error(P):I=P,I.actions=w,I}e.createErrorWithActions=L}),define(ye[159],Ce([19,20]),function(te,e){return te.create("vs/base/common/platform",e)}),define(ye[12],Ce([1,0,159]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,T=!1,R=!1,k=!1,A=!1,y=!1,D=!1,L=!1,P=!1,w=!1,I,v=e.LANGUAGE_DEFAULT,m,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const p=typeof f?.versions?.electron=="string",b=p&&f?.type==="renderer";if(typeof navigator=="object"&&!b)d=navigator.userAgent,t=d.indexOf("Windows")>=0,T=d.indexOf("Macintosh")>=0,L=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=d.indexOf("Linux")>=0,w=d?.indexOf("Mobi")>=0,y=!0,I=c.getConfiguredDefaultLocale(c.localize(0,null))||e.LANGUAGE_DEFAULT,v=I;else if(typeof f=="object"){t=f.platform==="win32",T=f.platform==="darwin",R=f.platform==="linux",k=R&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,D=p,P=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT;const i=f.env.VSCODE_NLS_CONFIG;if(i)try{const n=JSON.parse(i),h=n.availableLanguages["*"];I=n.locale,v=h||e.LANGUAGE_DEFAULT,m=n._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var S;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function g(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let r=0;T?r=1:t?r=3:R&&(r=2),e.isWindows=t,e.isMacintosh=T,e.isLinux=R,e.isLinuxSnap=k,e.isNative=A,e.isElectron=D,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=w,e.isCI=P,e.platform=r,e.userAgent=d,e.language=v;var l;(function(i){function n(){return e.language}i.value=n;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=h;function E(){return e.language==="en"}i.isDefault=E})(l=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const i=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let E=0,C=i.length;E<C;E++){const M=i[E];if(M.id===h.data.vscodeScheduleAsyncWork){i.splice(E,1),M.callback();return}}});let n=0;return h=>{const E=++n;i.push({id:E,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return i=>setTimeout(i)})();var s;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||L?2:t?1:3;let a=!0,o=!1;function u(){if(!o){o=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,a=new Uint16Array(i.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[37],Ce([1,0,12]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.process<"u"){const T=c.globals.vscode.process;t={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return c.isWindows?"win32":c.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ye[11],Ce([1,0,37]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,T=97,R=90,k=122,A=46,y=47,D=92,L=58,P=63;class w extends Error{constructor(l,s,a){let o;typeof s=="string"&&s.indexOf("not ")===0?(o="must not be",s=s.replace(/^not /,"")):o="must be";const u=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${u} ${o} of type ${s}`;i+=`. Received type ${typeof a}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function I(r,l){if(r===null||typeof r!="object")throw new w(l,"Object",r)}function v(r,l){if(typeof r!="string")throw new w(l,"string",r)}const m=c.platform==="win32";function d(r){return r===y||r===D}function f(r){return r===y}function p(r){return r>=t&&r<=R||r>=T&&r<=k}function b(r,l,s,a){let o="",u=0,i=-1,n=0,h=0;for(let E=0;E<=r.length;++E){if(E<r.length)h=r.charCodeAt(E);else{if(a(h))break;h=y}if(a(h)){if(!(i===E-1||n===1))if(n===2){if(o.length<2||u!==2||o.charCodeAt(o.length-1)!==A||o.charCodeAt(o.length-2)!==A){if(o.length>2){const C=o.lastIndexOf(s);C===-1?(o="",u=0):(o=o.slice(0,C),u=o.length-1-o.lastIndexOf(s)),i=E,n=0;continue}else if(o.length!==0){o="",u=0,i=E,n=0;continue}}l&&(o+=o.length>0?`${s}..`:"..",u=2)}else o.length>0?o+=`${s}${r.slice(i+1,E)}`:o=r.slice(i+1,E),u=E-i-1;i=E,n=0}else h===A&&n!==-1?++n:n=-1}return o}function S(r,l){I(l,"pathObject");const s=l.dir||l.root,a=l.base||`${l.name||""}${l.ext||""}`;return s?s===l.root?`${s}${a}`:`${s}${r}${a}`:a}e.win32={resolve(...r){let l="",s="",a=!1;for(let o=r.length-1;o>=-1;o--){let u;if(o>=0){if(u=r[o],v(u,"path"),u.length===0)continue}else l.length===0?u=c.cwd():(u=c.env[`=${l}`]||c.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==l.toLowerCase()&&u.charCodeAt(2)===D)&&(u=`${l}\\`));const i=u.length;let n=0,h="",E=!1;const C=u.charCodeAt(0);if(i===1)d(C)&&(n=1,E=!0);else if(d(C))if(E=!0,d(u.charCodeAt(1))){let M=2,K=M;for(;M<i&&!d(u.charCodeAt(M));)M++;if(M<i&&M!==K){const q=u.slice(K,M);for(K=M;M<i&&d(u.charCodeAt(M));)M++;if(M<i&&M!==K){for(K=M;M<i&&!d(u.charCodeAt(M));)M++;(M===i||M!==K)&&(h=`\\\\${q}\\${u.slice(K,M)}`,n=M)}}}else n=1;else p(C)&&u.charCodeAt(1)===L&&(h=u.slice(0,2),n=2,i>2&&d(u.charCodeAt(2))&&(E=!0,n=3));if(h.length>0)if(l.length>0){if(h.toLowerCase()!==l.toLowerCase())continue}else l=h;if(a){if(l.length>0)break}else if(s=`${u.slice(n)}\\${s}`,a=E,E&&l.length>0)break}return s=b(s,!a,"\\",d),a?`${l}\\${s}`:`${l}${s}`||"."},normalize(r){v(r,"path");const l=r.length;if(l===0)return".";let s=0,a,o=!1;const u=r.charCodeAt(0);if(l===1)return f(u)?"\\":r;if(d(u))if(o=!0,d(r.charCodeAt(1))){let n=2,h=n;for(;n<l&&!d(r.charCodeAt(n));)n++;if(n<l&&n!==h){const E=r.slice(h,n);for(h=n;n<l&&d(r.charCodeAt(n));)n++;if(n<l&&n!==h){for(h=n;n<l&&!d(r.charCodeAt(n));)n++;if(n===l)return`\\\\${E}\\${r.slice(h)}\\`;n!==h&&(a=`\\\\${E}\\${r.slice(h,n)}`,s=n)}}}else s=1;else p(u)&&r.charCodeAt(1)===L&&(a=r.slice(0,2),s=2,l>2&&d(r.charCodeAt(2))&&(o=!0,s=3));let i=s<l?b(r.slice(s),!o,"\\",d):"";return i.length===0&&!o&&(i="."),i.length>0&&d(r.charCodeAt(l-1))&&(i+="\\"),a===void 0?o?`\\${i}`:i:o?`${a}\\${i}`:`${a}${i}`},isAbsolute(r){v(r,"path");const l=r.length;if(l===0)return!1;const s=r.charCodeAt(0);return d(s)||l>2&&p(s)&&r.charCodeAt(1)===L&&d(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let l,s;for(let u=0;u<r.length;++u){const i=r[u];v(i,"path"),i.length>0&&(l===void 0?l=s=i:l+=`\\${i}`)}if(l===void 0)return".";let a=!0,o=0;if(typeof s=="string"&&d(s.charCodeAt(0))){++o;const u=s.length;u>1&&d(s.charCodeAt(1))&&(++o,u>2&&(d(s.charCodeAt(2))?++o:a=!1))}if(a){for(;o<l.length&&d(l.charCodeAt(o));)o++;o>=2&&(l=`\\${l.slice(o)}`)}return e.win32.normalize(l)},relative(r,l){if(v(r,"from"),v(l,"to"),r===l)return"";const s=e.win32.resolve(r),a=e.win32.resolve(l);if(s===a||(r=s.toLowerCase(),l=a.toLowerCase(),r===l))return"";let o=0;for(;o<r.length&&r.charCodeAt(o)===D;)o++;let u=r.length;for(;u-1>o&&r.charCodeAt(u-1)===D;)u--;const i=u-o;let n=0;for(;n<l.length&&l.charCodeAt(n)===D;)n++;let h=l.length;for(;h-1>n&&l.charCodeAt(h-1)===D;)h--;const E=h-n,C=i<E?i:E;let M=-1,K=0;for(;K<C;K++){const F=r.charCodeAt(o+K);if(F!==l.charCodeAt(n+K))break;F===D&&(M=K)}if(K!==C){if(M===-1)return a}else{if(E>C){if(l.charCodeAt(n+K)===D)return a.slice(n+K+1);if(K===2)return a.slice(n+K)}i>C&&(r.charCodeAt(o+K)===D?M=K:K===2&&(M=3)),M===-1&&(M=0)}let q="";for(K=o+M+1;K<=u;++K)(K===u||r.charCodeAt(K)===D)&&(q+=q.length===0?"..":"\\..");return n+=M,q.length>0?`${q}${a.slice(n,h)}`:(a.charCodeAt(n)===D&&++n,a.slice(n,h))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const l=e.win32.resolve(r);if(l.length<=2)return r;if(l.charCodeAt(0)===D){if(l.charCodeAt(1)===D){const s=l.charCodeAt(2);if(s!==P&&s!==A)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(p(l.charCodeAt(0))&&l.charCodeAt(1)===L&&l.charCodeAt(2)===D)return`\\\\?\\${l}`;return r},dirname(r){v(r,"path");const l=r.length;if(l===0)return".";let s=-1,a=0;const o=r.charCodeAt(0);if(l===1)return d(o)?r:".";if(d(o)){if(s=a=1,d(r.charCodeAt(1))){let n=2,h=n;for(;n<l&&!d(r.charCodeAt(n));)n++;if(n<l&&n!==h){for(h=n;n<l&&d(r.charCodeAt(n));)n++;if(n<l&&n!==h){for(h=n;n<l&&!d(r.charCodeAt(n));)n++;if(n===l)return r;n!==h&&(s=a=n+1)}}}}else p(o)&&r.charCodeAt(1)===L&&(s=l>2&&d(r.charCodeAt(2))?3:2,a=s);let u=-1,i=!0;for(let n=l-1;n>=a;--n)if(d(r.charCodeAt(n))){if(!i){u=n;break}}else i=!1;if(u===-1){if(s===-1)return".";u=s}return r.slice(0,u)},basename(r,l){l!==void 0&&v(l,"ext"),v(r,"path");let s=0,a=-1,o=!0,u;if(r.length>=2&&p(r.charCodeAt(0))&&r.charCodeAt(1)===L&&(s=2),l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let i=l.length-1,n=-1;for(u=r.length-1;u>=s;--u){const h=r.charCodeAt(u);if(d(h)){if(!o){s=u+1;break}}else n===-1&&(o=!1,n=u+1),i>=0&&(h===l.charCodeAt(i)?--i===-1&&(a=u):(i=-1,a=n))}return s===a?a=n:a===-1&&(a=r.length),r.slice(s,a)}for(u=r.length-1;u>=s;--u)if(d(r.charCodeAt(u))){if(!o){s=u+1;break}}else a===-1&&(o=!1,a=u+1);return a===-1?"":r.slice(s,a)},extname(r){v(r,"path");let l=0,s=-1,a=0,o=-1,u=!0,i=0;r.length>=2&&r.charCodeAt(1)===L&&p(r.charCodeAt(0))&&(l=a=2);for(let n=r.length-1;n>=l;--n){const h=r.charCodeAt(n);if(d(h)){if(!u){a=n+1;break}continue}o===-1&&(u=!1,o=n+1),h===A?s===-1?s=n:i!==1&&(i=1):s!==-1&&(i=-1)}return s===-1||o===-1||i===0||i===1&&s===o-1&&s===a+1?"":r.slice(s,o)},format:S.bind(null,"\\"),parse(r){v(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const s=r.length;let a=0,o=r.charCodeAt(0);if(s===1)return d(o)?(l.root=l.dir=r,l):(l.base=l.name=r,l);if(d(o)){if(a=1,d(r.charCodeAt(1))){let M=2,K=M;for(;M<s&&!d(r.charCodeAt(M));)M++;if(M<s&&M!==K){for(K=M;M<s&&d(r.charCodeAt(M));)M++;if(M<s&&M!==K){for(K=M;M<s&&!d(r.charCodeAt(M));)M++;M===s?a=M:M!==K&&(a=M+1)}}}}else if(p(o)&&r.charCodeAt(1)===L){if(s<=2)return l.root=l.dir=r,l;if(a=2,d(r.charCodeAt(2))){if(s===3)return l.root=l.dir=r,l;a=3}}a>0&&(l.root=r.slice(0,a));let u=-1,i=a,n=-1,h=!0,E=r.length-1,C=0;for(;E>=a;--E){if(o=r.charCodeAt(E),d(o)){if(!h){i=E+1;break}continue}n===-1&&(h=!1,n=E+1),o===A?u===-1?u=E:C!==1&&(C=1):u!==-1&&(C=-1)}return n!==-1&&(u===-1||C===0||C===1&&u===n-1&&u===i+1?l.base=l.name=r.slice(i,n):(l.name=r.slice(i,u),l.base=r.slice(i,n),l.ext=r.slice(u,n))),i>0&&i!==a?l.dir=r.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(m){const r=/\\/g;return()=>{const l=c.cwd().replace(r,"/");return l.slice(l.indexOf("/"))}}return()=>c.cwd()})();e.posix={resolve(...r){let l="",s=!1;for(let a=r.length-1;a>=-1&&!s;a--){const o=a>=0?r[a]:g();v(o,"path"),o.length!==0&&(l=`${o}/${l}`,s=o.charCodeAt(0)===y)}return l=b(l,!s,"/",f),s?`/${l}`:l.length>0?l:"."},normalize(r){if(v(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===y,s=r.charCodeAt(r.length-1)===y;return r=b(r,!l,"/",f),r.length===0?l?"/":s?"./":".":(s&&(r+="/"),l?`/${r}`:r)},isAbsolute(r){return v(r,"path"),r.length>0&&r.charCodeAt(0)===y},join(...r){if(r.length===0)return".";let l;for(let s=0;s<r.length;++s){const a=r[s];v(a,"path"),a.length>0&&(l===void 0?l=a:l+=`/${a}`)}return l===void 0?".":e.posix.normalize(l)},relative(r,l){if(v(r,"from"),v(l,"to"),r===l||(r=e.posix.resolve(r),l=e.posix.resolve(l),r===l))return"";const s=1,a=r.length,o=a-s,u=1,i=l.length-u,n=o<i?o:i;let h=-1,E=0;for(;E<n;E++){const M=r.charCodeAt(s+E);if(M!==l.charCodeAt(u+E))break;M===y&&(h=E)}if(E===n)if(i>n){if(l.charCodeAt(u+E)===y)return l.slice(u+E+1);if(E===0)return l.slice(u+E)}else o>n&&(r.charCodeAt(s+E)===y?h=E:E===0&&(h=0));let C="";for(E=s+h+1;E<=a;++E)(E===a||r.charCodeAt(E)===y)&&(C+=C.length===0?"..":"/..");return`${C}${l.slice(u+h)}`},toNamespacedPath(r){return r},dirname(r){if(v(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===y;let s=-1,a=!0;for(let o=r.length-1;o>=1;--o)if(r.charCodeAt(o)===y){if(!a){s=o;break}}else a=!1;return s===-1?l?"/":".":l&&s===1?"//":r.slice(0,s)},basename(r,l){l!==void 0&&v(l,"ext"),v(r,"path");let s=0,a=-1,o=!0,u;if(l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let i=l.length-1,n=-1;for(u=r.length-1;u>=0;--u){const h=r.charCodeAt(u);if(h===y){if(!o){s=u+1;break}}else n===-1&&(o=!1,n=u+1),i>=0&&(h===l.charCodeAt(i)?--i===-1&&(a=u):(i=-1,a=n))}return s===a?a=n:a===-1&&(a=r.length),r.slice(s,a)}for(u=r.length-1;u>=0;--u)if(r.charCodeAt(u)===y){if(!o){s=u+1;break}}else a===-1&&(o=!1,a=u+1);return a===-1?"":r.slice(s,a)},extname(r){v(r,"path");let l=-1,s=0,a=-1,o=!0,u=0;for(let i=r.length-1;i>=0;--i){const n=r.charCodeAt(i);if(n===y){if(!o){s=i+1;break}continue}a===-1&&(o=!1,a=i+1),n===A?l===-1?l=i:u!==1&&(u=1):l!==-1&&(u=-1)}return l===-1||a===-1||u===0||u===1&&l===a-1&&l===s+1?"":r.slice(l,a)},format:S.bind(null,"/"),parse(r){v(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const s=r.charCodeAt(0)===y;let a;s?(l.root="/",a=1):a=0;let o=-1,u=0,i=-1,n=!0,h=r.length-1,E=0;for(;h>=a;--h){const C=r.charCodeAt(h);if(C===y){if(!n){u=h+1;break}continue}i===-1&&(n=!1,i=h+1),C===A?o===-1?o=h:E!==1&&(E=1):o!==-1&&(E=-1)}if(i!==-1){const C=u===0&&s?1:u;o===-1||E===0||E===1&&o===i-1&&o===u+1?l.base=l.name=r.slice(C,i):(l.name=r.slice(C,o),l.base=r.slice(C,i),l.ext=r.slice(o,i))}return u>0?l.dir=r.slice(0,u-1):s&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m?e.win32.normalize:e.posix.normalize,e.isAbsolute=m?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m?e.win32.join:e.posix.join,e.resolve=m?e.win32.resolve:e.posix.resolve,e.relative=m?e.win32.relative:e.posix.relative,e.dirname=m?e.win32.dirname:e.posix.dirname,e.basename=m?e.win32.basename:e.posix.basename,e.extname=m?e.win32.extname:e.posix.extname,e.format=m?e.win32.format:e.posix.format,e.parse=m?e.win32.parse:e.posix.parse,e.toNamespacedPath=m?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m?e.win32.sep:e.posix.sep,e.delimiter=m?e.win32.delimiter:e.posix.delimiter}),define(ye[85],Ce([1,0,11]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const P=(0,c.extname)(L),w=t[P.toLowerCase()];return w!==void 0?w:k(L)}e.getMediaOrTextMime=R;function k(L){const P=(0,c.extname)(L);return T[P.toLowerCase()]}e.getMediaMime=k;function A(L){for(const P in T)if(T[P]===L)return P}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function D(L,P){const w=y.exec(L);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:P?void 0:L}e.normalizeMimeType=D}),define(ye[108],Ce([1,0,12]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var T;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(T=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(A,...y){const D=y.reduce((w,I)=>(w[I]=!0,w),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(w=>!D[w]).forEach(w=>{for(let I=0;I<L.length;I++)if(w.search(L[I])!==-1){delete A[w];break}})}e.sanitizeProcessEnvironment=R;function k(A){!A||(delete A.DEBUG,c.isMacintosh&&delete A.DYLD_LIBRARY_PATH,c.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(ye[44],Ce([1,0,12]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=c.globals.performance&&typeof c.globals.performance.now=="function";class T{static create(k=!0){return new T(k)}constructor(k){this.a=t&&k,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?c.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ye[3],Ce([1,0,9,63,6,65,44]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,y=!1;var D;(function(u){u.None=()=>T.Disposable.None;function i(Ee){if(y){const{onDidAddListener:Pe}=Ee,Fe=v.create();let se=0;Ee.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Fe.print()),Pe?.()}}}function n(Ee,Pe){return O(Ee,()=>{},0,void 0,void 0,Pe)}u.defer=n;function h(Ee){return(Pe,Fe=null,se)=>{let oe=!1,fe;return fe=Ee(Z=>{if(!oe)return fe?fe.dispose():oe=!0,Pe.call(Fe,Z)},null,se),oe&&fe.dispose(),fe}}u.once=h;function E(Ee,Pe,Fe){return B((se,oe=null,fe)=>Ee(Z=>se.call(oe,Pe(Z)),null,fe),Fe)}u.map=E;function C(Ee,Pe,Fe){return B((se,oe=null,fe)=>Ee(Z=>{Pe(Z),se.call(oe,Z)},null,fe),Fe)}u.forEach=C;function M(Ee,Pe,Fe){return B((se,oe=null,fe)=>Ee(Z=>Pe(Z)&&se.call(oe,Z),null,fe),Fe)}u.filter=M;function K(Ee){return Ee}u.signal=K;function q(...Ee){return(Pe,Fe=null,se)=>(0,T.combinedDisposable)(...Ee.map(oe=>oe(fe=>Pe.call(Fe,fe),null,se)))}u.any=q;function F(Ee,Pe,Fe,se){let oe=Fe;return E(Ee,fe=>(oe=Pe(oe,fe),oe),se)}u.reduce=F;function B(Ee,Pe){let Fe;const se={onWillAddFirstListener(){Fe=Ee(oe.fire,oe)},onDidRemoveLastListener(){Fe?.dispose()}};Pe||i(se);const oe=new d(se);return Pe?.add(oe),oe.event}function O(Ee,Pe,Fe=100,se=!1,oe,fe){let Z,ce,ie,N=0;const H={leakWarningThreshold:oe,onWillAddFirstListener(){Z=Ee(Y=>{N++,ce=Pe(ce,Y),se&&!ie&&(Q.fire(ce),ce=void 0),clearTimeout(ie),ie=setTimeout(()=>{const he=ce;ce=void 0,ie=void 0,(!se||N>1)&&Q.fire(he),N=0},Fe)})},onDidRemoveLastListener(){Z.dispose()}};fe||i(H);const Q=new d(H);return fe?.add(Q),Q.event}u.debounce=O;function U(Ee,Pe=0,Fe){return u.debounce(Ee,(se,oe)=>se?(se.push(oe),se):[oe],Pe,void 0,void 0,Fe)}u.accumulate=U;function z(Ee,Pe=(se,oe)=>se===oe,Fe){let se=!0,oe;return M(Ee,fe=>{const Z=se||!Pe(fe,oe);return se=!1,oe=fe,Z},Fe)}u.latch=z;function j(Ee,Pe,Fe){return[u.filter(Ee,Pe,Fe),u.filter(Ee,se=>!Pe(se),Fe)]}u.split=j;function ue(Ee,Pe=!1,Fe=[]){let se=Fe.slice(),oe=Ee(ce=>{se?se.push(ce):Z.fire(ce)});const fe=()=>{se?.forEach(ce=>Z.fire(ce)),se=null},Z=new d({onWillAddFirstListener(){oe||(oe=Ee(ce=>Z.fire(ce)))},onDidAddFirstListener(){se&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){oe&&oe.dispose(),oe=null}});return Z.event}u.buffer=ue;class V{constructor(Pe){this.event=Pe,this.c=new T.DisposableStore}map(Pe){return new V(E(this.event,Pe,this.c))}forEach(Pe){return new V(C(this.event,Pe,this.c))}filter(Pe){return new V(M(this.event,Pe,this.c))}reduce(Pe,Fe){return new V(F(this.event,Pe,Fe,this.c))}latch(){return new V(z(this.event,void 0,this.c))}debounce(Pe,Fe=100,se=!1,oe){return new V(O(this.event,Pe,Fe,se,oe,this.c))}on(Pe,Fe,se){return this.event(Pe,Fe,se)}once(Pe,Fe,se){return h(this.event)(Pe,Fe,se)}dispose(){this.c.dispose()}}function _(Ee){return new V(Ee)}u.chain=_;function J(Ee,Pe,Fe=se=>se){const se=(...ce)=>Z.fire(Fe(...ce)),oe=()=>Ee.on(Pe,se),fe=()=>Ee.removeListener(Pe,se),Z=new d({onWillAddFirstListener:oe,onDidRemoveLastListener:fe});return Z.event}u.fromNodeEventEmitter=J;function ne(Ee,Pe,Fe=se=>se){const se=(...ce)=>Z.fire(Fe(...ce)),oe=()=>Ee.addEventListener(Pe,se),fe=()=>Ee.removeEventListener(Pe,se),Z=new d({onWillAddFirstListener:oe,onDidRemoveLastListener:fe});return Z.event}u.fromDOMEventEmitter=ne;function ee(Ee){return new Promise(Pe=>h(Ee)(Pe))}u.toPromise=ee;function X(Ee,Pe){return Pe(void 0),Ee(Fe=>Pe(Fe))}u.runAndSubscribe=X;function G(Ee,Pe){let Fe=null;function se(fe){Fe?.dispose(),Fe=new T.DisposableStore,Pe(fe,Fe)}se(void 0);const oe=Ee(fe=>se(fe));return(0,T.toDisposable)(()=>{oe.dispose(),Fe?.dispose()})}u.runAndSubscribeWithStore=G;class de{constructor(Pe,Fe){this.obs=Pe,this.c=0,this.d=!1;const se={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};Fe||i(se),this.emitter=new d(se),Fe&&Fe.add(this.emitter)}beginUpdate(Pe){this.c++}handleChange(Pe,Fe){this.d=!0}endUpdate(Pe){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function be(Ee,Pe){return new de(Ee,Pe).emitter.event}u.fromObservable=be})(D=e.Event||(e.Event={}));class L{constructor(i){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${i}_${L.c++}`,L.all.add(this)}start(i){this.d=new k.StopWatch(!0),this.listenerCount=i}stop(){if(this.d){const i=this.d.elapsed();this.durations.push(i),this.elapsedOverall+=i,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=L,L.all=new Set,L.c=0;let P=-1;function w(u){const i=P;return P=u,{dispose(){P=i}}}e.setGlobalLeakWarningThreshold=w;class I{constructor(i,n=Math.random().toString(18).slice(2,5)){this.threshold=i,this.name=n,this.d=0}dispose(){this.c?.clear()}check(i,n){const h=this.threshold;if(h<=0||n<h)return;this.c||(this.c=new Map);const E=this.c.get(i.value)||0;if(this.c.set(i.value,E+1),this.d-=1,this.d<=0){this.d=h*.5;let C,M=0;for(const[K,q]of this.c)(!C||M<q)&&(C=K,M=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${n} listeners already. MOST frequent listener (${M}):`),console.warn(C)}return()=>{const C=this.c.get(i.value)||0;this.c.set(i.value,C-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(i){this.value=i}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(i,n,h){this.callback=i,this.callbackThis=n,this.stack=h,this.subscription=new T.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class d{constructor(i){this.j=!1,this.d=i,this.f=P>0||this.d?.leakWarningThreshold?new I(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const i=Array.from(this.q);queueMicrotask(()=>{for(const n of i)n.subscription.isset()&&(n.subscription.unset(),n.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(i,n,h)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),T.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let C,M;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(M=v.create(),C=this.f.check(M,this.q.size+1)),A&&(M=M??v.create());const K=new m(i,n,M),q=this.q.push(K);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,i,n);const F=K.subscription.set(()=>{C?.(),this.j||(q(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return h instanceof T.DisposableStore?h.add(F):Array.isArray(h)&&h.push(F),F}),this.l}fire(i){if(this.q){this.m||(this.m=new p);for(const n of this.q)this.m.push(this,n,i);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=d;class f{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(i,n,h){this.c.push(new b(i,n,h))}clear(i){const n=new R.LinkedList;for(const h of this.c)h.emitter!==i&&n.push(h);this.c=n}deliver(){for(;this.c.size>0;){const i=this.c.shift();try{i.listener.invoke(i.event)}catch(n){(0,c.onUnexpectedError)(n)}}}}e.EventDeliveryQueue=f;class p extends f{clear(i){this.c.clear()}}class b{constructor(i,n,h){this.emitter=i,this.listener=n,this.event=h}}class S extends d{async fireAsync(i,n,h){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const E of this.q)this.c.push([E,i]);for(;this.c.size>0&&!n.isCancellationRequested;){const[E,C]=this.c.shift(),M=[],K={...C,token:n,waitUntil:q=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");h&&(q=h(q,E.callback)),M.push(q)}};try{E.invoke(K)}catch(q){(0,c.onUnexpectedError)(q);continue}Object.freeze(M),await Promise.allSettled(M).then(q=>{for(const F of q)F.status==="rejected"&&(0,c.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=S;class g extends d{constructor(i){super(i),this.h=0,this.s=new R.LinkedList,this.t=i?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const i=Array.from(this.s);this.s.clear(),super.fire(this.t(i))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(i){this.q&&(this.h!==0?this.s.push(i):super.fire(i))}}e.PauseableEmitter=g;class r extends g{constructor(i){super(i),this.c=i.delay??100}fire(i){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(i)}}e.DebounceEmitter=r;class l extends d{constructor(i){super(i),this.c=[],this.h=i?.merge}fire(i){!this.hasListeners()||(this.c.push(i),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(n=>super.fire(n)),this.c=[]}))}}e.MicrotaskEmitter=l;class s{constructor(){this.d=!1,this.f=[],this.c=new d({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(i){const n={event:i,listener:null};this.f.push(n),this.d&&this.j(n);const h=()=>{this.d&&this.k(n);const E=this.f.indexOf(n);this.f.splice(E,1)};return(0,T.toDisposable)((0,t.once)(h))}g(){this.d=!0,this.f.forEach(i=>this.j(i))}h(){this.d=!1,this.f.forEach(i=>this.k(i))}j(i){i.listener=i.event(n=>this.c.fire(n))}k(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=s;class a{constructor(){this.c=[]}wrapEvent(i){return(n,h,E)=>i(C=>{const M=this.c[this.c.length-1];M?M.push(()=>n.call(h,C)):n.call(h,C)},void 0,E)}bufferEvents(i){const n=[];this.c.push(n);const h=i();return this.c.pop(),n.forEach(E=>E()),h}}e.EventBufferer=a;class o{constructor(){this.c=!1,this.d=D.None,this.f=T.Disposable.None,this.g=new d({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(i){this.d=i,this.c&&(this.f.dispose(),this.f=i(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(ye[160],Ce([1,0,3,6,155]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends t.Disposable{constructor(w,I="",v="",m=!0,d){super(),this.h=this.B(new c.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=I,this.u=v,this.w=m,this.C=d}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,I){this.C&&await this.C(w)}}e.Action=R;class k extends t.Disposable{constructor(){super(...arguments),this.f=this.B(new c.Emitter),this.onWillRun=this.f.event,this.h=this.B(new c.Emitter),this.onDidRun=this.h.event}async run(w,I){if(!w.enabled)return;this.f.fire({action:w});let v;try{await this.runAction(w,I)}catch(m){v=m}this.h.fire({action:w,error:v})}async runAction(w,I){await w.run(I)}}e.ActionRunner=k;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let I=[];for(const v of w)v.length&&(I.length?I=[...I,new A,...v]:I=v);return I}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(w,I,v,m){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=I,this.class=m,this.a=v}async run(){}}e.SubmenuAction=y;class D extends R{constructor(){super(D.ID,T.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=D,D.ID="vs.actions.empty";function L(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}e.toAction=L}),define(ye[21],Ce([1,0,3]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(A,y){const D=setTimeout(A.bind(y),0);return{dispose(){clearTimeout(D)}}});var T;(function(A){function y(D){return D===A.None||D===A.Cancelled||D instanceof R?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}A.isCancellationToken=y,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(T=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new c.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class k{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=T.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=T.None}}e.CancellationTokenSource=k}),define(ye[161],Ce([1,0,21]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new c.CancellationTokenSource,y=this.b(A.token);return this.a={promise:y,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=t;class T{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const y=JSON.stringify(A);return this.b!==y&&(this.b=y,this.a=this.c(A)),this.a}}e.LRUCachedFunction=T;class R{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const y=this.b(A);return this.a.set(A,y),y}}e.CachedFunction=R}),define(ye[8],Ce([1,0,161,83]),function(te,e,c,t){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=R;const k=/{(\d+)}/g;function A($,...le){return le.length===0?$:$.replace(k,function(Ie,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=le.length?Ie:le[Be]})}e.format=A;const y=/{([^}]+)}/g;function D($,le){return $.replace(y,(Ie,Le)=>le[Le]??Ie)}e.format2=D;function L($){return $.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=L;function P($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function w($,le){let Ie=0;const Le=le.charCodeAt(0);for(let Be=$.length-1;Be>=0;Be--)$.charCodeAt(Be)===Le&&Ie++;return Ie}e.count=w;function I($,le,Ie="\u2026"){return $.length<=le?$:`${$.substr(0,le)}${Ie}`}e.truncate=I;function v($,le=" "){const Ie=m($,le);return d(Ie,le)}e.trim=v;function m($,le){if(!$||!le)return $;const Ie=le.length;if(Ie===0||$.length===0)return $;let Le=0;for(;$.indexOf(le,Le)===Le;)Le=Le+Ie;return $.substring(Le)}e.ltrim=m;function d($,le){if(!$||!le)return $;const Ie=le.length,Le=$.length;if(Ie===0||Le===0)return $;let Be=Le,Xe=-1;for(;Xe=$.lastIndexOf(le,Be-1),!(Xe===-1||Xe+Ie!==Be);){if(Xe===0)return"";Be=Xe}return $.substring(0,Be)}e.rtrim=d;function f($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function p($){return $.replace(/\*/g,"")}e.stripWildcards=p;function b($,le,Ie={}){if(!$)throw new Error("Cannot create regex from empty string");le||($=P($)),Ie.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=b;function S($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function g($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function r($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=r;function l($){return $.split(/\r\n|\r|\n/)}e.splitLines=l;function s($){for(let le=0,Ie=$.length;le<Ie;le++){const Le=$.charCodeAt(le);if(Le!==32&&Le!==9)return le}return-1}e.firstNonWhitespaceIndex=s;function a($,le=0,Ie=$.length){for(let Le=le;Le<Ie;Le++){const Be=$.charCodeAt(Le);if(Be!==32&&Be!==9)return $.substring(le,Le)}return $.substring(le,Ie)}e.getLeadingWhitespace=a;function o($,le=$.length-1){for(let Ie=le;Ie>=0;Ie--){const Le=$.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=o;function u($,le,Ie){const Le=[];let Be=0;for(const Xe of $.matchAll(le)){if(Le.push($.slice(Be,Xe.index)),Xe.index===void 0)throw new Error("match.index should be defined");Be=Xe.index+Xe[0].length,Le.push(Ie(Xe[0],...Xe.slice(1),Xe.index,$,Xe.groups))}return Le.push($.slice(Be)),Promise.all(Le).then(Xe=>Xe.join(""))}e.replaceAsync=u;function i($,le){return $<le?-1:$>le?1:0}e.compare=i;function n($,le,Ie=0,Le=$.length,Be=0,Xe=le.length){for(;Ie<Le&&Be<Xe;Ie++,Be++){const mt=$.charCodeAt(Ie),lt=le.charCodeAt(Be);if(mt<lt)return-1;if(mt>lt)return 1}const Ze=Le-Ie,gt=Xe-Be;return Ze<gt?-1:Ze>gt?1:0}e.compareSubstring=n;function h($,le){return E($,le,0,$.length,0,le.length)}e.compareIgnoreCase=h;function E($,le,Ie=0,Le=$.length,Be=0,Xe=le.length){for(;Ie<Le&&Be<Xe;Ie++,Be++){let mt=$.charCodeAt(Ie),lt=le.charCodeAt(Be);if(mt===lt)continue;if(mt>=128||lt>=128)return n($.toLowerCase(),le.toLowerCase(),Ie,Le,Be,Xe);M(mt)&&(mt-=32),M(lt)&&(lt-=32);const ot=mt-lt;if(ot!==0)return ot}const Ze=Le-Ie,gt=Xe-Be;return Ze<gt?-1:Ze>gt?1:0}e.compareSubstringIgnoreCase=E;function C($){return $>=48&&$<=57}e.isAsciiDigit=C;function M($){return $>=97&&$<=122}e.isLowerAsciiLetter=M;function K($){return $>=65&&$<=90}e.isUpperAsciiLetter=K;function q($,le){return $.length===le.length&&E($,le)===0}e.equalsIgnoreCase=q;function F($,le){const Ie=le.length;return le.length>$.length?!1:E($,le,0,Ie)===0}e.startsWithIgnoreCase=F;function B($,le){const Ie=Math.min($.length,le.length);let Le;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Le)!==le.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=B;function O($,le){const Ie=Math.min($.length,le.length);let Le;const Be=$.length-1,Xe=le.length-1;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Be-Le)!==le.charCodeAt(Xe-Le))return Le;return Ie}e.commonSuffixLength=O;function U($){return 55296<=$&&$<=56319}e.isHighSurrogate=U;function z($){return 56320<=$&&$<=57343}e.isLowSurrogate=z;function j($,le){return($-55296<<10)+(le-56320)+65536}e.computeCodePoint=j;function ue($,le,Ie){const Le=$.charCodeAt(Ie);if(U(Le)&&Ie+1<le){const Be=$.charCodeAt(Ie+1);if(z(Be))return j(Le,Be)}return Le}e.getNextCodePoint=ue;function V($,le){const Ie=$.charCodeAt(le-1);if(z(Ie)&&le>1){const Le=$.charCodeAt(le-2);if(U(Le))return j(Le,Ie)}return Ie}class _{get offset(){return this.e}constructor(le,Ie=0){this.c=le,this.d=le.length,this.e=Ie}setOffset(le){this.e=le}prevCodePoint(){const le=V(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=ue(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}e.CodePointIterator=_;class J{get offset(){return this.c.offset}constructor(le,Ie=0){this.c=new _(le,Ie)}nextGraphemeLength(){const le=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=le.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const Xe=Ie.offset,Ze=le.getGraphemeBreakType(Ie.nextCodePoint());if(je(Be,Ze)){Ie.setOffset(Xe);break}Be=Ze}return Ie.offset-Le}prevGraphemeLength(){const le=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=le.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const Xe=Ie.offset,Ze=le.getGraphemeBreakType(Ie.prevCodePoint());if(je(Ze,Be)){Ie.setOffset(Xe);break}Be=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function ne($,le){return new J($,le).nextGraphemeLength()}e.nextCharLength=ne;function ee($,le){return new J($,le).prevGraphemeLength()}e.prevCharLength=ee;function X($,le){le>0&&z($.charCodeAt(le))&&le--;const Ie=le+ne($,le);return[Ie-ee($,Ie),Ie]}e.getCharContainingOffset=X;function G($){const le=new J($);let Ie=0;for(;!le.eol();)Ie++,le.nextGraphemeLength();return Ie}e.charCount=G;let de;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ee($){return de||(de=be()),de.test($)}e.containsRTL=Ee;const Pe=/^[\t\n\r\x20-\x7E]*$/;function Fe($){return Pe.test($)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=se;function oe($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=oe;function fe($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=fe;function Z($,le){if($.length<le)return $;const Ie=/\b/g;let Le=0;for(;Ie.test($)&&!($.length-Ie.lastIndex<le);)Le=Ie.lastIndex,Ie.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=Z;const ce=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,N=/\x1b\[0?m/g;function H($){return $&&($=$.replace(ce,""),$=$.replace(ie,""),$=$.replace(N,"")),$}e.removeAnsiEscapeCodes=H,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Q($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Q;function Y($){return Q($)?$.substr(1):$}e.stripUTF8BOM=Y;function he($,le){if(!$||!le||$.length<le.length)return!1;const Ie=le.length,Le=$.toLowerCase();let Be=0,Xe=-1;for(;Be<Ie;){const Ze=Le.indexOf(le[Be],Xe+1);if(Ze<0)return!1;Xe=Ze,Be++}return!0}e.fuzzyContains=he;function we($,le=!1){return $?(le&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=we;function Ae($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=Ae;function pe($,le=1){if(le===0)return"";let Ie=-1;do Ie=$.indexOf(`
`,Ie+1),le--;while(le>0&&Ie>=0);return Ie===-1?$:($[Ie-1]==="\r"&&Ie--,$.substr(0,Ie))}e.getNLines=pe;function De($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=De;function ke($){return et.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=ke;function je($,le){return $===0?le!==5&&le!==7:$===2&&le===3?!1:$===4||$===2||$===3||le===4||le===2||le===3?!0:!($===8&&(le===8||le===9||le===11||le===12)||($===11||$===9)&&(le===9||le===10)||($===12||$===10)&&le===10||le===5||le===13||le===7||$===1||$===13&&le===14||$===6&&le===6)}var Ge;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=Qe()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const Ie=this.d,Le=Ie.length/3;let Be=1;for(;Be<=Le;)if(le<Ie[3*Be])Be=2*Be;else if(le>Ie[3*Be+1])Be=2*Be+1;else return Ie[3*Be+2];return 0}}et.c=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt($,le){if($===0)return 0;const Ie=st($,le);if(Ie!==void 0)return Ie;const Le=new _(le,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st($,le){const Ie=new _(le,$);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!fe(Le))return;let Be=Ie.offset;return Be>0&&Ie.prevCodePoint()===8205&&(Be=Ie.offset),Be}function ht($){return 127995<=$&&$<=127999}var Me;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class it{static getInstance(le){return it.d.get(Array.from(le))}static getLocales(){return it.e.getValue()}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=it,T=it,it.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new c.LRUCachedFunction($=>{function le(lt){const ot=new Map;for(let rt=0;rt<lt.length;rt+=2)ot.set(lt[rt],lt[rt+1]);return ot}function Ie(lt,ot){const rt=new Map(lt);for(const[kt,Tt]of ot)rt.set(kt,Tt);return rt}function Le(lt,ot){if(!lt)return ot;const rt=new Map;for(const[kt,Tt]of lt)ot.has(kt)&&rt.set(kt,Tt);return rt}const Be=T.c.getValue();let Xe=$.filter(lt=>!lt.startsWith("_")&&lt in Be);Xe.length===0&&(Xe=["_default"]);let Ze;for(const lt of Xe){const ot=le(Be[lt]);Ze=Le(Ze,ot)}const gt=le(Be._common),mt=Ie(gt,Ze);return new it(mt)}),it.e=new t.Lazy(()=>Object.keys(it.c.getValue()).filter($=>!$.startsWith("_")));class ae{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ae.c())),this.d}static isInvisibleCharacter(le){return ae.e().has(le)}static get codePoints(){return ae.e()}}e.InvisibleCharacters=ae,ae.d=void 0}),define(ye[32],Ce([1,0,11,12,8,10]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(o){return o===47||o===92}e.isPathSeparator=k;function A(o){return o.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=A;function y(o){return o.indexOf("/")===-1&&(o=A(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=y;function D(o,u=c.posix.sep){if(!o)return"";const i=o.length,n=o.charCodeAt(0);if(k(n)){if(k(o.charCodeAt(1))&&!k(o.charCodeAt(2))){let E=3;const C=E;for(;E<i&&!k(o.charCodeAt(E));E++);if(C!==E&&!k(o.charCodeAt(E+1))){for(E+=1;E<i;E++)if(k(o.charCodeAt(E)))return o.slice(0,E+1).replace(/[\\/]/g,u)}}return u}else if(f(n)&&o.charCodeAt(1)===58)return k(o.charCodeAt(2))?o.slice(0,2)+u:o.slice(0,2);let h=o.indexOf("://");if(h!==-1){for(h+=3;h<i;h++)if(k(o.charCodeAt(h)))return o.slice(0,h+1)}return""}e.getRoot=D;function L(o){if(!t.isWindows||!o||o.length<5)return!1;let u=o.charCodeAt(0);if(u!==92||(u=o.charCodeAt(1),u!==92))return!1;let i=2;const n=i;for(;i<o.length&&(u=o.charCodeAt(i),u!==92);i++);return!(n===i||(u=o.charCodeAt(i+1),isNaN(u)||u===92))}e.isUNC=L;const P=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(o,u=t.isWindows){const i=u?P:w;return!(!o||o.length===0||/^\s+$/.test(o)||(i.lastIndex=0,i.test(o))||u&&I.test(o)||o==="."||o===".."||u&&o[o.length-1]==="."||u&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=v;function m(o,u,i){const n=o===u;return!i||n?n:!o||!u?!1:(0,T.equalsIgnoreCase)(o,u)}e.isEqual=m;function d(o,u,i,n=c.sep){if(o===u)return!0;if(!o||!u||u.length>o.length)return!1;if(i){if(!(0,T.startsWithIgnoreCase)(o,u))return!1;if(u.length===o.length)return!0;let E=u.length;return u.charAt(u.length-1)===n&&E--,o.charAt(E)===n}return u.charAt(u.length-1)!==n&&(u+=n),o.indexOf(u)===0}e.isEqualOrParent=d;function f(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=f;function p(o,u){return t.isWindows&&o.endsWith(":")&&(o+=c.sep),(0,c.isAbsolute)(o)||(o=(0,c.join)(u,o)),o=(0,c.normalize)(o),t.isWindows?(o=(0,T.rtrim)(o,c.sep),o.endsWith(":")&&(o+=c.sep)):(o=(0,T.rtrim)(o,c.sep),o||(o=c.sep)),o}e.sanitizeFilePath=p;function b(o){const u=(0,c.normalize)(o);return t.isWindows?o.length>3?!1:S(u)&&(o.length===2||u.charCodeAt(2)===92):u===c.posix.sep}e.isRootOrDriveLetter=b;function S(o,u=t.isWindows){return u?f(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function g(o){return S(o)?o[0]:void 0}e.getDriveLetter=g;function r(o,u,i){return u.length>o.length?-1:o===u?0:(i&&(o=o.toLowerCase(),u=u.toLowerCase()),o.indexOf(u))}e.indexOfPath=r;function l(o){const u=o.split(":");let i,n,h;for(const E of u){const C=Number(E);(0,R.isNumber)(C)?n===void 0?n=C:h===void 0&&(h=C):i=i?[i,E].join(":"):E}if(!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:n!==void 0?n:void 0,column:h!==void 0?h:n!==void 0?1:void 0}}e.parseLineAndColumnAware=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(o,u,i=8){let n="";for(let E=0;E<i;E++)n+=s.charAt(Math.floor(Math.random()*s.length));let h;return u?h=`${u}-${n}`:h=n,o?(0,c.join)(o,h):h}e.randomPath=a}),define(ye[109],Ce([1,0,28,8]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...ie){return function(N,H){for(let Q=0,Y=ie.length;Q<Y;Q++){const he=ie[Q](N,H);if(he)return he}return null}}e.or=T,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(ie,N,H){if(!H||H.length<N.length)return null;let Q;return ie?Q=t.startsWithIgnoreCase(H,N):Q=H.indexOf(N)===0,Q?N.length>0?[{start:0,end:N.length}]:[]:null}function k(ie,N){const H=N.toLowerCase().indexOf(ie.toLowerCase());return H===-1?null:[{start:H,end:H+ie.length}]}e.matchesContiguousSubString=k;function A(ie,N){return y(ie.toLowerCase(),N.toLowerCase(),0,0)}e.matchesSubString=A;function y(ie,N,H,Q){if(H===ie.length)return[];if(Q===N.length)return null;if(ie[H]===N[Q]){let Y=null;return(Y=y(ie,N,H+1,Q+1))?f({start:Q,end:Q+1},Y):null}return y(ie,N,H,Q+1)}function D(ie){return 97<=ie&&ie<=122}function L(ie){return 65<=ie&&ie<=90}e.isUpper=L;function P(ie){return 48<=ie&&ie<=57}function w(ie){return ie===32||ie===9||ie===10||ie===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>I.add(ie.charCodeAt(0)));function v(ie){return w(ie)||I.has(ie)}function m(ie,N){return ie===N||v(ie)&&v(N)}function d(ie){return D(ie)||L(ie)||P(ie)}function f(ie,N){return N.length===0?N=[ie]:ie.end===N[0].start?N[0].start=ie.start:N.unshift(ie),N}function p(ie,N){for(let H=N;H<ie.length;H++){const Q=ie.charCodeAt(H);if(L(Q)||P(Q)||H>0&&!d(ie.charCodeAt(H-1)))return H}return ie.length}function b(ie,N,H,Q){if(H===ie.length)return[];if(Q===N.length)return null;if(ie[H]!==N[Q].toLowerCase())return null;{let Y=null,he=Q+1;for(Y=b(ie,N,H+1,Q+1);!Y&&(he=p(N,he))<N.length;)Y=b(ie,N,H+1,he),he++;return Y===null?null:f({start:Q,end:Q+1},Y)}}function S(ie){let N=0,H=0,Q=0,Y=0,he=0;for(let ke=0;ke<ie.length;ke++)he=ie.charCodeAt(ke),L(he)&&N++,D(he)&&H++,d(he)&&Q++,P(he)&&Y++;const we=N/ie.length,Ae=H/ie.length,pe=Q/ie.length,De=Y/ie.length;return{upperPercent:we,lowerPercent:Ae,alphaPercent:pe,numericPercent:De}}function g(ie){const{upperPercent:N,lowerPercent:H}=ie;return H===0&&N>.6}function r(ie){const{upperPercent:N,lowerPercent:H,alphaPercent:Q,numericPercent:Y}=ie;return H>.2&&N<.8&&Q>.6&&Y<.2}function l(ie){let N=0,H=0,Q=0,Y=0;for(let he=0;he<ie.length;he++)Q=ie.charCodeAt(he),L(Q)&&N++,D(Q)&&H++,w(Q)&&Y++;return(N===0||H===0)&&Y===0?ie.length<=30:N<=5}function s(ie,N){if(!N||(N=N.trim(),N.length===0)||!l(ie)||N.length>60)return null;const H=S(N);if(!r(H)){if(!g(H))return null;N=N.toLowerCase()}let Q=null,Y=0;for(ie=ie.toLowerCase();Y<N.length&&(Q=b(ie,N,0,Y))===null;)Y=p(N,Y+1);return Q}e.matchesCamelCase=s;function a(ie,N,H=!1){if(!N||N.length===0)return null;let Q=null,Y=0;for(ie=ie.toLowerCase(),N=N.toLowerCase();Y<N.length&&(Q=o(ie,N,0,Y,H))===null;)Y=u(N,Y+1);return Q}e.matchesWords=a;function o(ie,N,H,Q,Y){if(H===ie.length)return[];if(Q===N.length)return null;if(m(ie.charCodeAt(H),N.charCodeAt(Q))){let he=null,we=Q+1;if(he=o(ie,N,H+1,Q+1,Y),!Y)for(;!he&&(we=u(N,we))<N.length;)he=o(ie,N,H+1,we,Y),we++;return he?ie.charCodeAt(H)!==N.charCodeAt(Q)?he:f({start:Q,end:Q+1},he):null}else return null}function u(ie,N){for(let H=N;H<ie.length;H++)if(v(ie.charCodeAt(H))||H>0&&v(ie.charCodeAt(H-1)))return H;return ie.length}const i=T(e.matchesPrefix,s,k),n=T(e.matchesPrefix,s,A),h=new c.LRUCache(1e4);function E(ie,N,H=!1){if(typeof ie!="string"||typeof N!="string")return null;let Q=h.get(ie);Q||(Q=new RegExp(t.convertSimple2RegExpPattern(ie),"i"),h.set(ie,Q));const Y=Q.exec(N);return Y?[{start:Y.index,end:Y.index+Y[0].length}]:H?n(ie,N):i(ie,N)}e.matchesFuzzy=E;function C(ie,N){const H=Pe(ie,ie.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?K(H):null}e.matchesFuzzy2=C;function M(ie,N,H,Q,Y,he){const we=Math.min(13,ie.length);for(;H<we;H++){const Ae=Pe(ie,N,H,Q,Y,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,he]}e.anyScore=M;function K(ie){if(typeof ie>"u")return[];const N=[],H=ie[1];for(let Q=ie.length-1;Q>1;Q--){const Y=ie[Q]+H,he=N[N.length-1];he&&he.end===Y?he.end=Y+1:N.push({start:Y,end:Y+1})}return N}e.createMatches=K;const q=128;function F(){const ie=[],N=[];for(let H=0;H<=q;H++)N[H]=0;for(let H=0;H<=q;H++)ie.push(N.slice(0));return ie}function B(ie){const N=[];for(let H=0;H<=ie;H++)N[H]=0;return N}const O=B(2*q),U=B(2*q),z=F(),j=F(),ue=F(),V=!1;function _(ie,N,H,Q,Y){function he(Ae,pe,De=" "){for(;Ae.length<pe;)Ae=De+Ae;return Ae}let we=` |   |${Q.split("").map(Ae=>he(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=H;Ae++)Ae===0?we+=" |":we+=`${N[Ae-1]}|`,we+=ie[Ae].slice(0,Y+1).map(pe=>he(pe.toString(),3)).join("|")+`
`;return we}function J(ie,N,H,Q){ie=ie.substr(N),H=H.substr(Q),console.log(_(j,ie,ie.length,H,H.length)),console.log(_(ue,ie,ie.length,H,H.length)),console.log(_(z,ie,ie.length,H,H.length))}function ne(ie,N){if(N<0||N>=ie.length)return!1;const H=ie.codePointAt(N);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(H)}}function ee(ie,N){if(N<0||N>=ie.length)return!1;switch(ie.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function X(ie,N,H){return N[ie]!==H[ie]}function G(ie,N,H,Q,Y,he,we=!1){for(;N<H&&Y<he;)ie[N]===Q[Y]&&(we&&(O[N]=Y),N+=1),Y+=1;return N===H}e.isPatternInWord=G;var de;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(de||(de={}));var be;(function(ie){ie.Default=[-100,0];function N(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}ie.isDefault=N})(be=e.FuzzyScore||(e.FuzzyScore={}));class Ee{constructor(N,H){this.firstMatchCanBeWeak=N,this.boostFullMatch=H}}e.FuzzyScoreOptions=Ee,Ee.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Pe(ie,N,H,Q,Y,he,we=Ee.default){const Ae=ie.length>q?q:ie.length,pe=Q.length>q?q:Q.length;if(H>=Ae||he>=pe||Ae-H>pe-he||!G(N,H,Ae,Y,he,pe,!0))return;Fe(Ae,pe,H,he,N,Y);let De=1,ke=1,je=H,Ge=he;const et=[!1];for(De=1,je=H;je<Ae;De++,je++){const Me=O[je],it=U[je],ae=je+1<Ae?U[je+1]:pe;for(ke=Me-he+1,Ge=Me;Ge<ae;ke++,Ge++){let $=Number.MIN_SAFE_INTEGER,le=!1;Ge<=it&&($=se(ie,N,je,H,Q,Y,Ge,pe,he,z[De-1][ke-1]===0,et));let Ie=0;$!==Number.MAX_SAFE_INTEGER&&(le=!0,Ie=$+j[De-1][ke-1]);const Le=Ge>Me,Be=Le?j[De][ke-1]+(z[De][ke-1]>0?-5:0):0,Xe=Ge>Me+1&&z[De][ke-1]>0,Ze=Xe?j[De][ke-2]+(z[De][ke-2]>0?-5:0):0;if(Xe&&(!Le||Ze>=Be)&&(!le||Ze>=Ie))j[De][ke]=Ze,ue[De][ke]=3,z[De][ke]=0;else if(Le&&(!le||Be>=Ie))j[De][ke]=Be,ue[De][ke]=2,z[De][ke]=0;else if(le)j[De][ke]=Ie,ue[De][ke]=1,z[De][ke]=z[De-1][ke-1]+1;else throw new Error("not possible")}}if(V&&J(ie,H,Q,he),!et[0]&&!we.firstMatchCanBeWeak)return;De--,ke--;const Qe=[j[De][ke],he];let nt=0,st=0;for(;De>=1;){let Me=ke;do{const it=ue[De][Me];if(it===3)Me=Me-2;else if(it===2)Me=Me-1;else break}while(Me>=1);nt>1&&N[H+De-1]===Y[he+ke-1]&&!X(Me+he-1,Q,Y)&&nt+1>z[De][Me]&&(Me=ke),Me===ke?nt++:nt=1,st||(st=Me),De--,ke=Me-1,Qe.push(ke)}pe===Ae&&we.boostFullMatch&&(Qe[0]+=2);const ht=st-Ae;return Qe[0]-=ht,Qe}e.fuzzyScore=Pe;function Fe(ie,N,H,Q,Y,he){let we=ie-1,Ae=N-1;for(;we>=H&&Ae>=Q;)Y[we]===he[Ae]&&(U[we]=Ae,we--),Ae--}function se(ie,N,H,Q,Y,he,we,Ae,pe,De,ke){if(N[H]!==he[we])return Number.MIN_SAFE_INTEGER;let je=1,Ge=!1;return we===H-Q?je=ie[H]===Y[we]?7:5:X(we,Y,he)&&(we===0||!X(we-1,Y,he))?(je=ie[H]===Y[we]?7:5,Ge=!0):ne(he,we)&&(we===0||!ne(he,we-1))?je=5:(ne(he,we-1)||ee(he,we-1))&&(je=5,Ge=!0),je>1&&H===Q&&(ke[0]=!0),Ge||(Ge=X(we,Y,he)||ne(he,we-1)||ee(he,we-1)),H===Q?we>pe&&(je-=Ge?3:5):De?je+=Ge?2:0:je+=Ge?0:1,we+1===Ae&&(je-=Ge?3:5),je}function oe(ie,N,H,Q,Y,he,we){return Z(ie,N,H,Q,Y,he,!0,we)}e.fuzzyScoreGracefulAggressive=oe;function fe(ie,N,H,Q,Y,he,we){return Z(ie,N,H,Q,Y,he,!1,we)}e.fuzzyScoreGraceful=fe;function Z(ie,N,H,Q,Y,he,we,Ae){let pe=Pe(ie,N,H,Q,Y,he,Ae);if(pe&&!we)return pe;if(ie.length>=3){const De=Math.min(7,ie.length-1);for(let ke=H+1;ke<De;ke++){const je=ce(ie,ke);if(je){const Ge=Pe(je,je.toLowerCase(),H,Q,Y,he,Ae);Ge&&(Ge[0]-=3,(!pe||Ge[0]>pe[0])&&(pe=Ge))}}}return pe}function ce(ie,N){if(N+1>=ie.length)return;const H=ie[N],Q=ie[N+1];if(H!==Q)return ie.slice(0,N)+Q+H+ie.slice(N+2)}}),define(ye[86],Ce([1,0,8]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(f){return T(f,0)}e.hash=t;function T(f,p){switch(typeof f){case"object":return f===null?R(349,p):Array.isArray(f)?y(f,p):D(f,p);case"string":return A(f,p);case"boolean":return k(f,p);case"number":return R(f,p);case"undefined":return R(937,p);default:return R(617,p)}}e.doHash=T;function R(f,p){return(p<<5)-p+f|0}e.numberHash=R;function k(f,p){return R(f?433:863,p)}function A(f,p){p=R(149417,p);for(let b=0,S=f.length;b<S;b++)p=R(f.charCodeAt(b),p);return p}e.stringHash=A;function y(f,p){return p=R(104579,p),f.reduce((b,S)=>T(S,b),p)}function D(f,p){return p=R(181387,p),Object.keys(f).sort().reduce((b,S)=>(b=A(S,b),T(f[S],b)),p)}class L{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=T(p,this.g),this.g}}e.Hasher=L;var P;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function w(f,p,b=32){const S=b-p,g=~((1<<S)-1);return(f<<p|(g&f)>>>S)>>>0}function I(f,p=0,b=f.byteLength,S=0){for(let g=0;g<b;g++)f[p+g]=S}function v(f,p,b="0"){for(;f.length<p;)f=b+f;return f}function m(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(b=>b.toString(16).padStart(2,"0")).join(""):v((f>>>0).toString(16),p/4)}e.toHexString=m;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const b=p.length;if(b===0)return;const S=this.p;let g=this.r,r=this.u,l,s;for(r!==0?(l=r,s=-1,r=0):(l=p.charCodeAt(0),s=0);;){let a=l;if(c.isHighSurrogate(l))if(s+1<b){const o=p.charCodeAt(s+1);c.isLowSurrogate(o)?(s++,a=c.computeCodePoint(l,o)):a=65533}else{r=l;break}else c.isLowSurrogate(l)&&(a=65533);if(g=this.w(S,g,a),s++,s<b)l=p.charCodeAt(s);else break}this.r=g,this.u=r}w(p,b,S){return S<128?p[b++]=S:S<2048?(p[b++]=192|(S&1984)>>>6,p[b++]=128|(S&63)>>>0):S<65536?(p[b++]=224|(S&61440)>>>12,p[b++]=128|(S&4032)>>>6,p[b++]=128|(S&63)>>>0):(p[b++]=240|(S&1835008)>>>18,p[b++]=128|(S&258048)>>>12,p[b++]=128|(S&4032)>>>6,p[b++]=128|(S&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,I(this.p,this.r),this.r>56&&(this.y(),I(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=d.g,b=this.q;for(let i=0;i<64;i+=4)p.setUint32(i,b.getUint32(i,!1),!1);for(let i=64;i<320;i+=4)p.setUint32(i,w(p.getUint32(i-12,!1)^p.getUint32(i-32,!1)^p.getUint32(i-56,!1)^p.getUint32(i-64,!1),1),!1);let S=this.h,g=this.l,r=this.m,l=this.n,s=this.o,a,o,u;for(let i=0;i<80;i++)i<20?(a=g&r|~g&l,o=1518500249):i<40?(a=g^r^l,o=1859775393):i<60?(a=g&r|g&l|r&l,o=2400959708):(a=g^r^l,o=3395469782),u=w(S,5)+a+s+o+p.getUint32(i*4,!1)&4294967295,s=l,l=r,r=w(g,30),g=S,S=u;this.h=this.h+S&4294967295,this.l=this.l+g&4294967295,this.m=this.m+r&4294967295,this.n=this.n+l&4294967295,this.o=this.o+s&4294967295}}e.StringSHA1=d,d.g=new DataView(new ArrayBuffer(320))}),define(ye[162],Ce([1,0,50,109,8]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",k=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${k.source}`,"g");function y(d){return d.replace(A,(f,p)=>p?f:`\\${f}`)}e.escapeIcons=y;const D=new RegExp(`\\\\${k.source}`,"g");function L(d){return d.replace(D,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=L;const P=new RegExp(`(\\s)?(\\\\)?${k.source}(\\s)?`,"g");function w(d){return d.indexOf(R)===-1?d:d.replace(P,(f,p,b,S)=>b?f:p||S||"")}e.stripIcons=w;const I=new RegExp(`\\$\\(${c.CSSIcon.iconNameCharacter}+\\)`,"g");function v(d){I.lastIndex=0;let f="";const p=[];let b=0;for(;;){const S=I.lastIndex,g=I.exec(d),r=d.substring(S,g?.index);if(r.length>0){f+=r;for(let l=0;l<r.length;l++)p.push(b)}if(!g)break;b+=g[0].length}return{text:f,iconOffsets:p}}e.parseLabelWithIcons=v;function m(d,f,p=!1){const{text:b,iconOffsets:S}=f;if(!S||S.length===0)return(0,t.matchesFuzzy)(d,b,p);const g=(0,T.ltrim)(b," "),r=b.length-g.length,l=(0,t.matchesFuzzy)(d,g,p);if(l)for(const s of l){const a=S[s.start+r]+r;s.start+=a,s.end+=a}return l}e.matchesFuzzyIconAware=m}),define(ye[38],Ce([1,0,8]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(t||(t={})),function(T){const R="error",k="warning",A="warn",y="info",D="ignore";function L(w){return w?c.equalsIgnoreCase(R,w)?T.Error:c.equalsIgnoreCase(k,w)||c.equalsIgnoreCase(A,w)?T.Warning:c.equalsIgnoreCase(y,w)?T.Info:T.Ignore:T.Ignore}T.fromValue=L;function P(w){switch(w){case T.Error:return R;case T.Warning:return k;case T.Info:return y;default:return D}}T.toString=P}(t||(t={})),e.default=t}),define(ye[66],Ce([1,0,16,8]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class T{constructor(){this.b="",this.c=0}reset(I){return this.b=I,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(I){const v=I.charCodeAt(0),m=this.b.charCodeAt(this.c);return v-m}value(){return this.b[this.c]}}e.StringIterator=T;class R{constructor(I=!0){this.e=I}reset(I){return this.b=I,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let I=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(I)this.c++;else break;else I=!1;return this}cmp(I){return this.e?(0,t.compareSubstring)(I,this.b,0,I.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(I,this.b,0,I.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class k{constructor(I=!0,v=!0){this.f=I,this.g=v}reset(I){this.d=0,this.e=0,this.b=I,this.c=I.length;for(let v=I.length-1;v>=0;v--,this.c--){const m=this.b.charCodeAt(v);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let I=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(I)this.d++;else break;else I=!1}return this}cmp(I){return this.g?(0,t.compareSubstring)(I,this.b,0,I.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(I,this.b,0,I.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=k;var A;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(I,v){this.f=I,this.g=v,this.d=[],this.e=0}reset(I){return this.c=I,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new k(!1,!this.f(I)),this.b.reset(I.path),this.b.value()&&this.d.push(3)),this.g(I)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(I){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(I,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(I,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(I);if(this.d[this.e]===4)return(0,t.compare)(I,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(I,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const I=this.right;return this.right=I.left,I.left=this,this.updateHeight(),I.updateHeight(),I}rotateRight(){const I=this.left;return this.left=I.right,I.right=this,this.updateHeight(),I.updateHeight(),I}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(L||(L={}));class P{static forUris(I=()=>!1,v=()=>!1){return new P(new y(I,v))}static forPaths(I=!1){return new P(new k(void 0,!I))}static forStrings(){return new P(new T)}static forConfigKeys(){return new P(new R)}constructor(I){this.b=I}clear(){this.c=void 0}fill(I,v){if(v){const m=v.slice(0);(0,c.shuffle)(m);for(const d of m)this.set(d,I)}else{const m=I.slice(0);(0,c.shuffle)(m);for(const d of m)this.set(d[0],d[1])}}set(I,v){const m=this.b.reset(I);let d;this.c||(this.c=new D,this.c.segment=m.value());const f=[];for(d=this.c;;){const b=m.cmp(d.segment);if(b>0)d.left||(d.left=new D,d.left.segment=m.value()),f.push([-1,d]),d=d.left;else if(b<0)d.right||(d.right=new D,d.right.segment=m.value()),f.push([1,d]),d=d.right;else if(m.hasNext())m.next(),d.mid||(d.mid=new D,d.mid.segment=m.value()),f.push([0,d]),d=d.mid;else break}const p=d.value;d.value=v,d.key=I;for(let b=f.length-1;b>=0;b--){const S=f[b][1];S.updateHeight();const g=S.balanceFactor();if(g<-1||g>1){const r=f[b][0],l=f[b+1][0];if(r===1&&l===1)f[b][1]=S.rotateLeft();else if(r===-1&&l===-1)f[b][1]=S.rotateRight();else if(r===1&&l===-1)S.right=f[b+1][1]=f[b+1][1].rotateRight(),f[b][1]=S.rotateLeft();else if(r===-1&&l===1)S.left=f[b+1][1]=f[b+1][1].rotateLeft(),f[b][1]=S.rotateRight();else throw new Error;if(b>0)switch(f[b-1][0]){case-1:f[b-1][1].left=f[b][1];break;case 1:f[b-1][1].right=f[b][1];break;case 0:f[b-1][1].mid=f[b][1];break}else this.c=f[0][1]}}return p}get(I){return this.d(I)?.value}d(I){const v=this.b.reset(I);let m=this.c;for(;m;){const d=v.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(v.hasNext())v.next(),m=m.mid;else break}return m}has(I){const v=this.d(I);return!(v?.value===void 0&&v?.mid===void 0)}delete(I){return this.e(I,!1)}deleteSuperstr(I){return this.e(I,!0)}e(I,v){const m=this.b.reset(I),d=[];let f=this.c;for(;f;){const p=m.cmp(f.segment);if(p>0)d.push([-1,f]),f=f.left;else if(p<0)d.push([1,f]),f=f.right;else if(m.hasNext())m.next(),d.push([0,f]),f=f.mid;else break}if(!!f){if(v?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const p=this.f(f.right);if(p.key){const{key:b,value:S,segment:g}=p;this.e(p.key,!1),f.key=b,f.value=S,f.segment=g}}else{const p=f.left??f.right;if(d.length>0){const[b,S]=d[d.length-1];switch(b){case-1:S.left=p;break;case 0:S.mid=p;break;case 1:S.right=p;break}}else this.c=p}for(let p=d.length-1;p>=0;p--){const b=d[p][1];b.updateHeight();const S=b.balanceFactor();if(S>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),d[p][1]=b.rotateLeft()):S<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),d[p][1]=b.rotateRight()),p>0)switch(d[p-1][0]){case-1:d[p-1][1].left=d[p][1];break;case 1:d[p-1][1].right=d[p][1];break;case 0:d[p-1][1].mid=d[p][1];break}else this.c=d[0][1]}}}f(I){for(;I.left;)I=I.left;return I}findSubstr(I){const v=this.b.reset(I);let m=this.c,d;for(;m;){const f=v.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(v.hasNext())v.next(),d=m.value||d,m=m.mid;else break}return m&&m.value||d}findSuperstr(I){return this.g(I,!1)}g(I,v){const m=this.b.reset(I);let d=this.c;for(;d;){const f=m.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(m.hasNext())m.next(),d=d.mid;else return d.mid?this.h(d.mid):v?d.value:void 0}}hasElementOrSubtree(I){return this.g(I,!0)!==void 0}forEach(I){for(const[v,m]of this)I(m,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(I){const v=[];return this.j(I,v),v[Symbol.iterator]()}j(I,v){!I||(I.left&&this.j(I.left,v),I.value&&v.push([I.key,I.value]),I.mid&&this.j(I.mid,v),I.right&&this.j(I.right,v))}_isBalanced(){const I=v=>{if(!v)return!0;const m=v.balanceFactor();return m<-1||m>1?!1:I(v.left)&&I(v.right)};return I(this.c)}}e.TernarySearchTree=P}),define(ye[2],Ce([1,0,11,12]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,R=/^\//,k=/^\/\//;function A(s,a){if(!s.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!T.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!R.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(s,a){return!s&&!a?"file":s}function D(s,a){switch(s){case"https":case"http":case"file":a?a[0]!==P&&(a=P+a):a=P;break}return a}const L="",P="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{static isUri(a){return a instanceof I?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,o,u,i,n,h=!1){typeof a=="object"?(this.scheme=a.scheme||L,this.authority=a.authority||L,this.path=a.path||L,this.query=a.query||L,this.fragment=a.fragment||L):(this.scheme=y(a,h),this.authority=o||L,this.path=D(this.scheme,u||L),this.query=i||L,this.fragment=n||L,A(this,h))}get fsPath(){return b(this,!1)}with(a){if(!a)return this;let{scheme:o,authority:u,path:i,query:n,fragment:h}=a;return o===void 0?o=this.scheme:o===null&&(o=L),u===void 0?u=this.authority:u===null&&(u=L),i===void 0?i=this.path:i===null&&(i=L),n===void 0?n=this.query:n===null&&(n=L),h===void 0?h=this.fragment:h===null&&(h=L),o===this.scheme&&u===this.authority&&i===this.path&&n===this.query&&h===this.fragment?this:new m(o,u,i,n,h)}static parse(a,o=!1){const u=w.exec(a);return u?new m(u[2]||L,l(u[4]||L),l(u[5]||L),l(u[7]||L),l(u[9]||L),o):new m(L,L,L,L,L)}static file(a){let o=L;if(t.isWindows&&(a=a.replace(/\\/g,P)),a[0]===P&&a[1]===P){const u=a.indexOf(P,2);u===-1?(o=a.substring(2),a=P):(o=a.substring(2,u),a=a.substring(u)||P)}return new m("file",o,a,L,L)}static from(a){const o=new m(a.scheme,a.authority,a.path,a.query,a.fragment);return A(o,!0),o}static joinPath(a,...o){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return t.isWindows&&a.scheme==="file"?u=I.file(c.win32.join(b(a,!0),...o)).path:u=c.posix.join(a.path,...o),a.with({path:u})}toString(a=!1){return S(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof I)return a;{const o=new m(a);return o._formatted=a.external,o._fsPath=a._sep===v?a.fsPath:null,o}}else return a}}e.URI=I;const v=t.isWindows?1:void 0;class m extends I{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(a=!1){return a?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=v),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(s,a,o){let u,i=-1;for(let n=0;n<s.length;n++){const h=s.charCodeAt(n);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||a&&h===47||o&&h===91||o&&h===93||o&&h===58)i!==-1&&(u+=encodeURIComponent(s.substring(i,n)),i=-1),u!==void 0&&(u+=s.charAt(n));else{u===void 0&&(u=s.substr(0,n));const E=d[h];E!==void 0?(i!==-1&&(u+=encodeURIComponent(s.substring(i,n)),i=-1),u+=E):i===-1&&(i=n)}}return i!==-1&&(u+=encodeURIComponent(s.substring(i))),u!==void 0?u:s}function p(s){let a;for(let o=0;o<s.length;o++){const u=s.charCodeAt(o);u===35||u===63?(a===void 0&&(a=s.substr(0,o)),a+=d[u]):a!==void 0&&(a+=s[o])}return a!==void 0?a:s}function b(s,a){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?a?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=b;function S(s,a){const o=a?p:f;let u="",{scheme:i,authority:n,path:h,query:E,fragment:C}=s;if(i&&(u+=i,u+=":"),(n||i==="file")&&(u+=P,u+=P),n){let M=n.indexOf("@");if(M!==-1){const K=n.substr(0,M);n=n.substr(M+1),M=K.lastIndexOf(":"),M===-1?u+=o(K,!1,!1):(u+=o(K.substr(0,M),!1,!1),u+=":",u+=o(K.substr(M+1),!1,!0)),u+="@"}n=n.toLowerCase(),M=n.lastIndexOf(":"),M===-1?u+=o(n,!1,!0):(u+=o(n.substr(0,M),!1,!0),u+=n.substr(M))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const M=h.charCodeAt(1);M>=65&&M<=90&&(h=`/${String.fromCharCode(M+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const M=h.charCodeAt(0);M>=65&&M<=90&&(h=`${String.fromCharCode(M+32)}:${h.substr(2)}`)}u+=o(h,!0,!1)}return E&&(u+="?",u+=o(E,!1,!1)),C&&(u+="#",u+=a?C:f(C,!1,!1)),u}function g(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(s){return s.match(r)?s.replace(r,a=>g(a)):s}}),define(ye[87],Ce([1,0,23,8,2]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(D){return JSON.stringify(D,A)}e.stringify=R;function k(D){let L=JSON.parse(D);return L=y(L),L}e.parse=k;function A(D,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,t.regExpFlags)(L)}:L}function y(D,L=0){if(!D||L>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return T.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 16:return new Date(D.source)}if(D instanceof c.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let P=0;P<D.length;++P)D[P]=y(D[P],L+1);else for(const P in D)Object.hasOwnProperty.call(D,P)&&(D[P]=y(D[P],L+1))}return D}e.revive=y}),define(ye[17],Ce([1,0,9,12,2]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.vscodeUserData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls",D.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,P,w){this.a[L]=P,this.b[L]=w}setConnectionToken(L,P){this.c[L]=P}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(d){return c.onUnexpectedError(d),L}const P=L.authority;let w=this.a[P];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const I=this.b[P],v=this.c[P];let m=`path=${encodeURIComponent(L.path)}`;return typeof v=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),T.URI.from({scheme:t.isWeb?this.d:R.vscodeRemoteResource,authority:`${w}:${I}`,path:this.f,query:m})}}e.RemoteAuthorities=new k,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(L){const P=this.b(L,te);return this.uriToBrowserUri(P)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===R.file&&(t.isNative||t.isWebWorker&&t.globals.origin===`${R.vscodeFileResource}://${A.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||A.a,query:null,fragment:null}):L}asFileUri(L){const P=this.b(L,te);return this.uriToFileUri(P)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==A.a?L.authority:null,query:null,fragment:null}):L}b(L,P){return T.URI.isUri(L)?L:T.URI.parse(P.toUrl(L))}}A.a="vscode-app",e.FileAccess=new A;var y;(function(D){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);D.CoopAndCoep=Object.freeze(L.get("3"));const P="vscode-coi";function w(v){let m;typeof v=="string"?m=new URL(v).searchParams:v instanceof URL?m=v.searchParams:T.URI.isUri(v)&&(m=new URL(v.toString(!0)).searchParams);const d=m?.get(P);if(!!d)return L.get(d)}D.getHeadersFromQuery=w;function I(v,m,d){if(!globalThis.crossOriginIsolated)return;const f=m&&d?"3":d?"2":"1";v instanceof URLSearchParams?v.set(P,f):v[P]=f}D.addSearchParam=I})(y=e.COI||(e.COI={}))}),define(ye[24],Ce([1,0,32,17,11,12,8,2]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(I){return(0,A.uriToFsPath)(I,!0)}e.originalFSPath=y;class D{constructor(v){this.a=v}compare(v,m,d=!1){return v===m?0:(0,k.compare)(this.getComparisonKey(v,d),this.getComparisonKey(m,d))}isEqual(v,m,d=!1){return v===m?!0:!v||!m?!1:this.getComparisonKey(v,d)===this.getComparisonKey(m,d)}getComparisonKey(v,m=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,m,d=!1){if(v.scheme===m.scheme){if(v.scheme===t.Schemas.file)return c.isEqualOrParent(y(v),y(m),this.a(v))&&v.query===m.query&&(d||v.fragment===m.fragment);if((0,e.isEqualAuthority)(v.authority,m.authority))return c.isEqualOrParent(v.path,m.path,this.a(v),"/")&&v.query===m.query&&(d||v.fragment===m.fragment)}return!1}joinPath(v,...m){return A.URI.joinPath(v,...m)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return T.posix.basename(v.path)}extname(v){return T.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let m;return v.scheme===t.Schemas.file?m=A.URI.file(T.dirname(y(v))).path:(m=T.posix.dirname(v.path),v.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),m="/")),v.with({path:m})}normalizePath(v){if(!v.path.length)return v;let m;return v.scheme===t.Schemas.file?m=A.URI.file(T.normalize(y(v))).path:m=T.posix.normalize(v.path),v.with({path:m})}relativePath(v,m){if(v.scheme!==m.scheme||!(0,e.isEqualAuthority)(v.authority,m.authority))return;if(v.scheme===t.Schemas.file){const p=T.relative(y(v),y(m));return R.isWindows?c.toSlashes(p):p}let d=v.path||"/";const f=m.path||"/";if(this.a(v)){let p=0;for(const b=Math.min(d.length,f.length);p<b&&!(d.charCodeAt(p)!==f.charCodeAt(p)&&d.charAt(p).toLowerCase()!==f.charAt(p).toLowerCase());p++);d=f.substr(0,p)+d.substr(p)}return T.posix.relative(d,f)}resolvePath(v,m){if(v.scheme===t.Schemas.file){const d=A.URI.file(T.resolve(y(v),m));return v.with({authority:d.authority,path:d.path})}return m=c.toPosixPath(m),v.with({path:T.posix.resolve(v.path,m)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,m){return v===m||v!==void 0&&m!==void 0&&(0,k.equalsIgnoreCase)(v,m)}hasTrailingPathSeparator(v,m=T.sep){if(v.scheme===t.Schemas.file){const d=y(v);return d.length>c.getRoot(d).length&&d[d.length-1]===m}else{const d=v.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,m=T.sep){return(0,e.hasTrailingPathSeparator)(v,m)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,m=T.sep){let d=!1;if(v.scheme===t.Schemas.file){const f=y(v);d=f!==void 0&&f.length===c.getRoot(f).length&&f[f.length-1]===m}else{m="/";const f=v.path;d=f.length===1&&f.charCodeAt(f.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(v,m)?v.with({path:v.path+"/"}):v}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(I=>I.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new D(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(I,v){const m=[];for(let d=0;d<I.length;d++){const f=v(I[d]);I.some((p,b)=>b===d?!1:(0,e.isEqualOrParent)(f,v(p)))||m.push(I[d])}return m}e.distinctParents=L;var P;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function v(m){const d=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(b=>{const[S,g]=b.split(":");S&&g&&d.set(S,g)});const p=m.path.substring(0,m.path.indexOf(";"));return p&&d.set(I.META_DATA_MIME,p),d}I.parseMetaData=v})(P=e.DataUri||(e.DataUri={}));function w(I,v,m){if(v){let d=I.path;return d&&d[0]!==T.posix.sep&&(d=T.posix.sep+d),I.with({scheme:m,authority:v,path:d})}return I.with({scheme:m})}e.toLocalResource=w}),define(ye[14],Ce([1,0,21,9,3,6,24,12]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(X){return!!X&&typeof X.then=="function"}e.isThenable=y;function D(X){const G=new c.CancellationTokenSource,de=X(G.token),be=new Promise((Ee,Pe)=>{const Fe=G.token.onCancellationRequested(()=>{Fe.dispose(),G.dispose(),Pe(new t.CancellationError)});Promise.resolve(de).then(se=>{Fe.dispose(),G.dispose(),Ee(se)},se=>{Fe.dispose(),G.dispose(),Pe(se)})});return new class{cancel(){G.cancel()}then(Ee,Pe){return be.then(Ee,Pe)}catch(Ee){return this.then(void 0,Ee)}finally(Ee){return be.finally(Ee)}}}e.createCancelablePromise=D;function L(X,G,de){return new Promise((be,Ee)=>{const Pe=G.onCancellationRequested(()=>{Pe.dispose(),be(de)});X.then(be,Ee).finally(()=>Pe.dispose())})}e.raceCancellation=L;function P(X,G){return new Promise((de,be)=>{const Ee=G.onCancellationRequested(()=>{Ee.dispose(),be(new t.CancellationError)});X.then(de,be).finally(()=>Ee.dispose())})}e.raceCancellationError=P;async function w(X){let G=-1;const de=X.map((Ee,Pe)=>Ee.then(Fe=>(G=Pe,Fe))),be=await Promise.race(de);return X.forEach((Ee,Pe)=>{Pe!==G&&Ee.cancel()}),be}e.raceCancellablePromises=w;function I(X,G,de){let be;const Ee=setTimeout(()=>{be?.(void 0),de?.()},G);return Promise.race([X.finally(()=>clearTimeout(Ee)),new Promise(Pe=>be=Pe)])}e.raceTimeout=I;function v(X){return new Promise((G,de)=>{const be=X();y(be)?be.then(G,de):G(be)})}e.asPromise=v;class m{constructor(){this.a=null,this.b=null,this.d=null}queue(G){if(this.a){if(this.d=G,!this.b){const de=()=>{this.b=null;const be=this.queue(this.d);return this.d=null,be};this.b=new Promise(be=>{this.a.then(de,de).then(be)})}return new Promise((de,be)=>{this.b.then(de,be)})}return this.a=G(),new Promise((de,be)=>{this.a.then(Ee=>{this.a=null,de(Ee)},Ee=>{this.a=null,be(Ee)})})}}e.Throttler=m;class d{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.Sequencer=d;class f{constructor(){this.a=new Map}queue(G,de){const Ee=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(de).finally(()=>{this.a.get(G)===Ee&&this.a.delete(G)});return this.a.set(G,Ee),Ee}}e.SequencerByKey=f;const p=(X,G)=>{let de=!0;const be=setTimeout(()=>{de=!1,G()},X);return{isTriggered:()=>de,dispose:()=>{clearTimeout(be),de=!1}}},b=X=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,X())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,de=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((Ee,Pe)=>{this.d=Ee,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const Ee=this.g;return this.g=null,Ee()}}));const be=()=>{this.a=null,this.d?.(null)};return this.a=de===e.MicrotaskDelay?b(be):p(de,be),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=S;class g{constructor(G){this.a=new S(G),this.b=new m}trigger(G,de){return this.a.trigger(()=>this.b.queue(G),de)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=g;class r{constructor(){this.a=!1,this.b=new Promise((G,de)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class l extends r{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=l;function s(X,G){return G?new Promise((de,be)=>{const Ee=setTimeout(()=>{Pe.dispose(),de()},X),Pe=G.onCancellationRequested(()=>{clearTimeout(Ee),Pe.dispose(),be(new t.CancellationError)})}):D(de=>s(X,de))}e.timeout=s;function a(X,G=0){const de=setTimeout(X,G);return(0,R.toDisposable)(()=>clearTimeout(de))}e.disposableTimeout=a;function o(X){const G=[];let de=0;const be=X.length;function Ee(){return de<be?X[de++]():null}function Pe(Fe){Fe!=null&&G.push(Fe);const se=Ee();return se?se.then(Pe):Promise.resolve(G)}return Promise.resolve(null).then(Pe)}e.sequence=o;function u(X,G=be=>!!be,de=null){let be=0;const Ee=X.length,Pe=()=>{if(be>=Ee)return Promise.resolve(de);const Fe=X[be++];return Promise.resolve(Fe()).then(oe=>G(oe)?Promise.resolve(oe):Pe())};return Pe()}e.first=u;function i(X,G=be=>!!be,de=null){if(X.length===0)return Promise.resolve(de);let be=X.length;const Ee=()=>{be=-1;for(const Pe of X)Pe.cancel?.()};return new Promise((Pe,Fe)=>{for(const se of X)se.then(oe=>{--be>=0&&G(oe)?(Ee(),Pe(oe)):be===0&&Pe(de)}).catch(oe=>{--be>=0&&(Ee(),Fe(oe))})})}e.firstParallel=i;class n{constructor(G){this.a=0,this.d=G,this.f=[],this.b=0,this.g=new T.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(G){return this.a++,new Promise((de,be)=>{this.f.push({factory:G,c:de,e:be}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const G=this.f.shift();this.b++;const de=G.factory();de.then(G.c,G.e),de.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=n;class h extends n{constructor(){super(1)}}e.Queue=h;class E{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const G=new ue;return this.b.add(G),G.p}d(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueFor(G,de=k.extUri){const be=de.getComparisonKey(G);let Ee=this.a.get(be);return Ee||(Ee=new h,T.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.a.delete(be),this.f()}),this.a.set(be,Ee)),Ee}f(){!this.d()||this.g()}g(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.g()}}e.ResourceQueue=E;class C{constructor(G,de){this.a=-1,typeof G=="function"&&typeof de=="number"&&this.setIfNotSet(G,de)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,de){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},de)}setIfNotSet(G,de){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},de))}}e.TimeoutTimer=C;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(G,de){this.cancel(),this.a=setInterval(()=>{G()},de)}}e.IntervalTimer=M;class K{constructor(G,de){this.b=-1,this.a=G,this.d=de,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class q{constructor(G,de){de%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${de}ms is not a multiple of 1000ms.`),this.a=G,this.b=de,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=q;class F extends K{constructor(G,de){super(G,de),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=F;class B extends R.Disposable{constructor(G,de){super(),this.g=G,this.h=de,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const de of G)this.a.push(de);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=X=>{(0,A.setTimeout0)(()=>{if(G)return;const de=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,de-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.runWhenIdle=(X,G)=>{const de=requestIdleCallback(X,typeof G=="number"?{timeout:G}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(de))}}}}();class O{constructor(G){this.d=!1,this.a=()=>{try{this.f=G()}catch(de){this.g=de}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=O;async function U(X,G,de){let be;for(let Ee=0;Ee<de;Ee++)try{return await X()}catch(Pe){be=Pe,await s(G)}throw be}e.retry=U;class z{hasPending(G){return this.a?typeof G=="number"?this.a.taskId===G:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(G,de,be){return this.a={taskId:G,cancel:()=>be?.(),promise:de},de.then(()=>this.d(G),()=>this.d(G)),de}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}setNext(G){if(this.b)this.b.run=G;else{let de,be;const Ee=new Promise((Pe,Fe)=>{de=Pe,be=Fe});this.b={run:G,promise:Ee,promiseResolve:de,promiseReject:be}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class j{constructor(G,de=()=>Date.now()){this.d=G,this.f=de,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.IntervalCounter=j;class ue{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((G,de)=>{this.a=G,this.b=de})}complete(G){return new Promise(de=>{this.a(G),this.f=!0,de()})}error(G){return new Promise(de=>{this.b(G),this.d=!0,de()})}cancel(){new Promise(G=>{this.b(new t.CancellationError),this.d=!0,G()})}}e.DeferredPromise=ue;var V;(function(X){async function G(be){let Ee;const Pe=await Promise.all(be.map(Fe=>Fe.then(se=>se,se=>{Ee||(Ee=se)})));if(typeof Ee<"u")throw Ee;return Pe}X.settled=G;function de(be){return new Promise(async(Ee,Pe)=>{try{await be(Ee,Pe)}catch(Fe){Pe(Fe)}})}X.withAsyncBody=de})(V=e.Promises||(e.Promises={}));var _;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(_||(_={}));class J{static fromArray(G){return new J(de=>{de.emitMany(G)})}static fromPromise(G){return new J(async de=>{de.emitMany(await G)})}static fromPromises(G){return new J(async de=>{await Promise.all(G.map(async be=>de.emitOne(await be)))})}static merge(G){return new J(async de=>{await Promise.all(G.map(async be=>{for await(const Ee of be)de.emitOne(Ee)}))})}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new T.Emitter,queueMicrotask(async()=>{const de={emitOne:be=>this.g(be),emitMany:be=>this.h(be),reject:be=>this.k(be)};try{await Promise.resolve(G(de)),this.j()}catch(be){this.k(be)}finally{de.emitOne=void 0,de.emitMany=void 0,de.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await T.Event.toPromise(this.f.event)}while(!0)}}}static map(G,de){return new J(async be=>{for await(const Ee of G)be.emitOne(de(Ee))})}map(G){return J.map(this,G)}static filter(G,de){return new J(async be=>{for await(const Ee of G)de(Ee)&&be.emitOne(Ee)})}filter(G){return J.filter(this,G)}static coalesce(G){return J.filter(G,de=>!!de)}coalesce(){return J.coalesce(this)}static async toPromise(G){const de=[];for await(const be of G)de.push(be);return de}toPromise(){return J.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class ne extends J{constructor(G,de){super(de),this.l=G}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ne;function ee(X){const G=new c.CancellationTokenSource,de=X(G.token);return new ne(G,async be=>{const Ee=G.token.onCancellationRequested(()=>{Ee.dispose(),G.dispose(),be.reject(new t.CancellationError)});try{for await(const Pe of de){if(G.token.isCancellationRequested)return;be.emitOne(Pe)}Ee.dispose(),G.dispose()}catch(Pe){Ee.dispose(),G.dispose(),be.reject(Pe)}})}e.createCancelableAsyncIterable=ee}),define(ye[110],Ce([1,0,14,11]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new c.IdleValue(()=>{const n=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:n,collatorIsNumeric:n.resolvedOptions().numeric}}),R=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(n,h,E=!1){const C=n||"",M=h||"",K=T.value.collator.compare(C,M);return T.value.collatorIsNumeric&&K===0&&C!==M?C<M?-1:1:K}e.compareFileNames=A;function y(n,h){const E=R.value.collator;return n=n||"",h=h||"",S(E,n,h)}e.compareFileNamesDefault=y;function D(n,h){const E=R.value.collator;return n=n||"",h=h||"",s(n,h)||S(E,n,h)}e.compareFileNamesUpper=D;function L(n,h){const E=R.value.collator;return n=n||"",h=h||"",l(n,h)||S(E,n,h)}e.compareFileNamesLower=L;function P(n,h){return n=n||"",h=h||"",n===h?0:n<h?-1:1}e.compareFileNamesUnicode=P;function w(n,h){const[E,C]=p(n),[M,K]=p(h);let q=T.value.collator.compare(C,K);if(q===0){if(T.value.collatorIsNumeric&&C!==K)return C<K?-1:1;if(q=T.value.collator.compare(E,M),T.value.collatorIsNumeric&&q===0&&E!==M)return E<M?-1:1}return q}e.compareFileExtensions=w;function I(n,h){n=n||"",h=h||"";const E=b(n),C=b(h),M=R.value.collator,K=k.value.collator;return S(K,E,C)||S(M,n,h)}e.compareFileExtensionsDefault=I;function v(n,h){n=n||"",h=h||"";const E=b(n),C=b(h),M=R.value.collator,K=k.value.collator;return S(K,E,C)||s(n,h)||S(M,n,h)}e.compareFileExtensionsUpper=v;function m(n,h){n=n||"",h=h||"";const E=b(n),C=b(h),M=R.value.collator,K=k.value.collator;return S(K,E,C)||l(n,h)||S(M,n,h)}e.compareFileExtensionsLower=m;function d(n,h){n=n||"",h=h||"";const E=b(n).toLowerCase(),C=b(h).toLowerCase();return E!==C?E<C?-1:1:n!==h?n<h?-1:1:0}e.compareFileExtensionsUnicode=d;const f=/^(.*?)(\.([^.]*))?$/;function p(n,h=!1){const E=n?f.exec(n):[];let C=[E&&E[1]||"",E&&E[3]||""];return h&&(!C[0]&&C[1]||C[0]&&C[0].charAt(0)===".")&&(C=[C[0]+"."+C[1],""]),C}function b(n){const h=n?f.exec(n):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function S(n,h,E){const C=n.compare(h,E);return C!==0?C:h.length!==E.length?h.length<E.length?-1:1:0}function g(n){const h=n.charAt(0);return h.toLocaleUpperCase()!==h}function r(n){const h=n.charAt(0);return h.toLocaleLowerCase()!==h}function l(n,h){return g(n)&&r(h)?-1:r(n)&&g(h)?1:0}function s(n,h){return r(n)&&g(h)?-1:g(n)&&r(h)?1:0}function a(n,h,E=!1){return E||(n=n&&n.toLowerCase(),h=h&&h.toLowerCase()),n===h?0:n<h?-1:1}function o(n,h,E=!1){const C=n.split(t.sep),M=h.split(t.sep),K=C.length-1,q=M.length-1;let F,B;for(let O=0;;O++){if(F=K===O,B=q===O,F&&B)return A(C[O],M[O],E);if(F)return-1;if(B)return 1;const U=a(C[O],M[O],E);if(U!==0)return U}}e.comparePaths=o;function u(n,h,E){const C=n.toLowerCase(),M=h.toLowerCase(),K=i(n,h,E);if(K)return K;const q=C.endsWith(E),F=M.endsWith(E);if(q!==F)return q?-1:1;const B=A(C,M);return B!==0?B:C.localeCompare(M)}e.compareAnything=u;function i(n,h,E){const C=n.toLowerCase(),M=h.toLowerCase(),K=C.startsWith(E),q=M.startsWith(E);if(K!==q)return K?-1:1;if(K&&q){if(C.length<M.length)return-1;if(C.length>M.length)return 1}return 0}e.compareByPrefix=i}),define(ye[111],Ce([1,0,110,109,86,11,12,8]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,D=[y,[]];function L(z,j,ue,V){if(!z||!j)return D;const _=z.length,J=j.length;if(_<J)return D;const ne=z.toLowerCase();return P(j,ue,J,z,ne,_,V)}e.scoreFuzzy=L;function P(z,j,ue,V,_,J,ne){const ee=[],X=[];for(let Ee=0;Ee<ue;Ee++){const Pe=Ee*J,Fe=Pe-J,se=Ee>0,oe=z[Ee],fe=j[Ee];for(let Z=0;Z<J;Z++){const ce=Z>0,ie=Pe+Z,N=ie-1,H=Fe+Z-1,Q=ce?ee[N]:0,Y=se&&ce?ee[H]:0,he=se&&ce?X[H]:0;let we;!Y&&se?we=0:we=w(oe,fe,V,_,Z,he),we&&Y+we>=Q&&(ne||se||_.startsWith(j,Z))?(X[ie]=he+1,ee[ie]=Y+we):(X[ie]=y,ee[ie]=Q)}}const G=[];let de=ue-1,be=J-1;for(;de>=0&&be>=0;){const Ee=de*J+be;X[Ee]===y||(G.push(be),de--),be--}return[ee[ue*J-1],G.reverse()]}function w(z,j,ue,V,_,J){let ne=0;if(!I(j,V[_]))return ne;if(ne+=1,J>0&&(ne+=J*5),z===ue[_]&&(ne+=1),_===0)ne+=8;else{const ee=v(ue.charCodeAt(_-1));ee?ne+=ee:(0,t.isUpper)(ue.charCodeAt(_))&&J===0&&(ne+=2)}return ne}function I(z,j){return z===j?!0:z==="/"||z==="\\"?j==="/"||j==="\\":!1}function v(z){switch(z){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const m=[void 0,[]];function d(z,j,ue=0,V=0){const _=j;return _.values&&_.values.length>1?f(z,_.values,ue,V):p(z,j,ue,V)}e.scoreFuzzy2=d;function f(z,j,ue,V){let _=0;const J=[];for(const ne of j){const[ee,X]=p(z,ne,ue,V);if(typeof ee!="number")return m;_+=ee,J.push(...X)}return[_,n(J)]}function p(z,j,ue,V){const _=(0,t.fuzzyScore)(j.original,j.originalLowercase,ue,z,z.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?[_[0],(0,t.createMatches)(_)]:m}const b=Object.freeze({score:0}),S=1<<18,g=1<<17,r=1<<16;function l(z,j,ue,V){const _=V.values?V.values:[V];return(0,T.hash)({[V.normalized]:{values:_.map(ne=>({value:ne.normalized,expectContiguousMatch:ne.expectContiguousMatch})),label:z,description:j,allowNonContiguousMatches:ue}})}function s(z,j,ue,V,_){if(!z||!j.normalized)return b;const J=V.getItemLabel(z);if(!J)return b;const ne=V.getItemDescription(z),ee=l(J,ne,ue,j),X=_[ee];if(X)return X;const G=a(J,ne,V.getItemPath(z),j,ue);return _[ee]=G,G}e.scoreItemFuzzy=s;function a(z,j,ue,V,_){const J=!ue||!V.containsPathSeparator;return ue&&(k.isLinux?V.pathNormalized===ue:(0,A.equalsIgnoreCase)(V.pathNormalized,ue))?{score:S,labelMatch:[{start:0,end:z.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:V.values&&V.values.length>1?o(z,j,ue,V.values,J,_):u(z,j,ue,V,J,_)}function o(z,j,ue,V,_,J){let ne=0;const ee=[],X=[];for(const G of V){const{score:de,labelMatch:be,descriptionMatch:Ee}=u(z,j,ue,G,_,J);if(de===y)return b;ne+=de,be&&ee.push(...be),Ee&&X.push(...Ee)}return{score:ne,labelMatch:n(ee),descriptionMatch:n(X)}}function u(z,j,ue,V,_,J){if(_||!j){const[ne,ee]=L(z,V.normalized,V.normalizedLowercase,J&&!V.expectContiguousMatch);if(ne){const X=(0,t.matchesPrefix)(V.normalized,z);let G;return X?(G=g,G+=Math.round(V.normalized.length/z.length*100)):G=r,{score:G+ne,labelMatch:X||i(ee)}}}if(j){let ne=j;ue&&(ne=`${j}${R.sep}`);const ee=ne.length,X=`${ne}${z}`,[G,de]=L(X,V.normalized,V.normalizedLowercase,J&&!V.expectContiguousMatch);if(G){const be=i(de),Ee=[],Pe=[];return be.forEach(Fe=>{Fe.start<ee&&Fe.end>ee?(Ee.push({start:0,end:Fe.end-ee}),Pe.push({start:Fe.start,end:ee})):Fe.start>=ee?Ee.push({start:Fe.start-ee,end:Fe.end-ee}):Pe.push(Fe)}),{score:G,labelMatch:Ee,descriptionMatch:Pe}}}return b}function i(z){const j=[];if(!z)return j;let ue;for(const V of z)ue&&ue.end===V?ue.end+=1:(ue={start:V,end:V+1},j.push(ue));return j}function n(z){const j=z.sort((_,J)=>_.start-J.start),ue=[];let V;for(const _ of j)!V||!h(V,_)?(V=_,ue.push(_)):(V.start=Math.min(V.start,_.start),V.end=Math.max(V.end,_.end));return ue}function h(z,j){return!(z.end<j.start||j.end<z.start)}function E(z,j,ue,V,_,J){const ne=s(z,ue,V,_,J),ee=s(j,ue,V,_,J),X=ne.score,G=ee.score;if((X===S||G===S)&&X!==G)return X===S?-1:1;if(X>r||G>r){if(X!==G)return X>G?-1:1;if(X<g&&G<g){const oe=M(ne.labelMatch,ee.labelMatch);if(oe!==0)return oe}const Fe=_.getItemLabel(z)||"",se=_.getItemLabel(j)||"";if(Fe.length!==se.length)return Fe.length-se.length}if(X!==G)return X>G?-1:1;const de=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0,be=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0;if(de&&!be)return-1;if(be&&!de)return 1;const Ee=C(z,ne,_),Pe=C(j,ee,_);return Ee&&Pe&&Ee!==Pe?Pe>Ee?-1:1:K(z,j,ue,_)}e.compareItemsByFuzzyScore=E;function C(z,j,ue){let V=-1,_=-1;if(j.descriptionMatch&&j.descriptionMatch.length?V=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(V=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(_=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const J=ue.getItemDescription(z);J&&(_+=J.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(_=j.descriptionMatch[j.descriptionMatch.length-1].end);return _-V}function M(z,j){if(!z&&!j||(!z||!z.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!z||!z.length)return 1;const ue=z[0].start,_=z[z.length-1].end-ue,J=j[0].start,ee=j[j.length-1].end-J;return _===ee?0:ee<_?1:-1}function K(z,j,ue,V){const _=V.getItemLabel(z)||"",J=V.getItemLabel(j)||"",ne=V.getItemDescription(z),ee=V.getItemDescription(j),X=_.length+(ne?ne.length:0),G=J.length+(ee?ee.length:0);if(X!==G)return X-G;const de=V.getItemPath(z),be=V.getItemPath(j);return de&&be&&de.length!==be.length?de.length-be.length:_!==J?(0,c.compareAnything)(_,J,ue.normalized):ne&&ee&&ne!==ee?(0,c.compareAnything)(ne,ee,ue.normalized):de&&be&&de!==be?(0,c.compareAnything)(de,be,ue.normalized):0}function q(z){return z.startsWith('"')&&z.endsWith('"')}const F=" ";function B(z){typeof z!="string"&&(z="");const j=z.toLowerCase(),{pathNormalized:ue,normalized:V,normalizedLowercase:_}=O(z),J=ue.indexOf(R.sep)>=0,ne=q(z);let ee;const X=z.split(F);if(X.length>1)for(const G of X){const de=q(G),{pathNormalized:be,normalized:Ee,normalizedLowercase:Pe}=O(G);Ee&&(ee||(ee=[]),ee.push({original:G,originalLowercase:G.toLowerCase(),pathNormalized:be,normalized:Ee,normalizedLowercase:Pe,expectContiguousMatch:de}))}return{original:z,originalLowercase:j,pathNormalized:ue,normalized:V,normalizedLowercase:_,values:ee,containsPathSeparator:J,expectContiguousMatch:ne}}e.prepareQuery=B;function O(z){let j;k.isWindows?j=z.replace(/\//g,R.sep):j=z.replace(/\\/g,R.sep);const ue=(0,A.stripWildcards)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:ue,normalizedLowercase:ue.toLowerCase()}}function U(z){return Array.isArray(z)?B(z.map(j=>j.original).join(F)):B(z.original)}e.pieceToQuery=U}),define(ye[39],Ce([1,0,16,14,32,28,11,12,8]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",P="[^/\\\\]",w=/\//g;function I(ue,V){switch(ue){case 0:return"";case 1:return`${P}*?`;default:return`(?:${L}|${P}+${L}${V?`|${L}${P}+`:""})*?`}}function v(ue,V){if(!ue)return[];const _=[];let J=!1,ne=!1,ee="";for(const X of ue){switch(X){case V:if(!J&&!ne){_.push(ee),ee="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}ee+=X}return ee&&_.push(ee),_}e.splitGlobAware=v;function m(ue){if(!ue)return"";let V="";const _=v(ue,e.GLOB_SPLIT);if(_.every(J=>J===e.GLOBSTAR))V=".*";else{let J=!1;_.forEach((ne,ee)=>{if(ne===e.GLOBSTAR){if(J)return;V+=I(2,ee===_.length-1)}else{let X=!1,G="",de=!1,be="";for(const Ee of ne){if(Ee!=="}"&&X){G+=Ee;continue}if(de&&(Ee!=="]"||!be)){let Pe;Ee==="-"?Pe=Ee:(Ee==="^"||Ee==="!")&&!be?Pe="^":Ee===e.GLOB_SPLIT?Pe="":Pe=(0,y.escapeRegExpCharacters)(Ee),be+=Pe;continue}switch(Ee){case"{":X=!0;continue;case"[":de=!0;continue;case"}":{V+=`(?:${v(G,",").map(se=>m(se)).join("|")})`,X=!1,G="";break}case"]":{V+="["+be+"]",de=!1,be="";break}case"?":V+=P;continue;case"*":V+=I(1);continue;default:V+=(0,y.escapeRegExpCharacters)(Ee)}}ee<_.length-1&&(_[ee+1]!==e.GLOBSTAR||ee+2<_.length)&&(V+=L)}J=ne===e.GLOBSTAR})}return V}const d=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new R.LRUCache(1e4),l=function(){return!1},s=function(){return null};function a(ue,V){if(!ue)return s;let _;typeof ue!="string"?_=ue.pattern:_=ue,_=_.trim();const J=`${_}_${!!V.trimForExclusions}`;let ne=r.get(J);if(ne)return o(ne,ue);let ee;return d.test(_)?ne=i(_.substr(4),_):(ee=f.exec(u(_,V)))?ne=n(ee[1],_):(V.trimForExclusions?b:p).test(_)?ne=h(_,V):(ee=S.exec(u(_,V)))?ne=E(ee[1].substr(1),_,!0):(ee=g.exec(u(_,V)))?ne=E(ee[1],_,!1):ne=C(_),r.set(J,ne),o(ne,ue)}function o(ue,V){if(typeof V=="string")return ue;const _=function(J,ne){return(0,T.isEqualOrParent)(J,V.base,!A.isLinux)?ue((0,y.ltrim)(J.substr(V.base.length),k.sep),ne):null};return _.allBasenames=ue.allBasenames,_.allPaths=ue.allPaths,_.basenames=ue.basenames,_.patterns=ue.patterns,_}function u(ue,V){return V.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function i(ue,V){return function(_,J){return typeof _=="string"&&_.endsWith(ue)?V:null}}function n(ue,V){const _=`/${ue}`,J=`\\${ue}`,ne=function(X,G){return typeof X!="string"?null:G?G===ue?V:null:X===ue||X.endsWith(_)||X.endsWith(J)?V:null},ee=[ue];return ne.basenames=ee,ne.patterns=[V],ne.allBasenames=ee,ne}function h(ue,V){const _=z(ue.slice(1,-1).split(",").map(G=>a(G,V)).filter(G=>G!==s),ue),J=_.length;if(!J)return s;if(J===1)return _[0];const ne=function(G,de){for(let be=0,Ee=_.length;be<Ee;be++)if(_[be](G,de))return ue;return null},ee=_.find(G=>!!G.allBasenames);ee&&(ne.allBasenames=ee.allBasenames);const X=_.reduce((G,de)=>de.allPaths?G.concat(de.allPaths):G,[]);return X.length&&(ne.allPaths=X),ne}function E(ue,V,_){const J=k.sep===k.posix.sep,ne=J?ue:ue.replace(w,k.sep),ee=k.sep+ne,X=k.posix.sep+ue;let G;return _?G=function(de,be){return typeof de=="string"&&(de===ne||de.endsWith(ee)||!J&&(de===ue||de.endsWith(X)))?V:null}:G=function(de,be){return typeof de=="string"&&(de===ne||!J&&de===ue)?V:null},G.allPaths=[(_?"*/":"./")+ue],G}function C(ue){try{const V=new RegExp(`^${m(ue)}$`);return function(_){return V.lastIndex=0,typeof _=="string"&&V.test(_)?ue:null}}catch{return s}}function M(ue,V,_){return!ue||typeof V!="string"?!1:K(ue)(V,void 0,_)}e.match=M;function K(ue,V={}){if(!ue)return l;if(typeof ue=="string"||q(ue)){const _=a(ue,V);if(_===s)return l;const J=function(ne,ee){return!!_(ne,ee)};return _.allBasenames&&(J.allBasenames=_.allBasenames),_.allPaths&&(J.allPaths=_.allPaths),J}return O(ue,V)}e.parse=K;function q(ue){const V=ue;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=q;function F(ue){return ue.allBasenames||[]}e.getBasenameTerms=F;function B(ue){return ue.allPaths||[]}e.getPathTerms=B;function O(ue,V){const _=z(Object.getOwnPropertyNames(ue).map(G=>U(G,ue[G],V)).filter(G=>G!==s)),J=_.length;if(!J)return s;if(!_.some(G=>!!G.requiresSiblings)){if(J===1)return _[0];const G=function(Ee,Pe){let Fe;for(let se=0,oe=_.length;se<oe;se++){const fe=_[se](Ee,Pe);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Fe||(Fe=[]),Fe.push(fe))}return Fe?(async()=>{for(const se of Fe){const oe=await se;if(typeof oe=="string")return oe}return null})():null},de=_.find(Ee=>!!Ee.allBasenames);de&&(G.allBasenames=de.allBasenames);const be=_.reduce((Ee,Pe)=>Pe.allPaths?Ee.concat(Pe.allPaths):Ee,[]);return be.length&&(G.allPaths=be),G}const ne=function(G,de,be){let Ee,Pe;for(let Fe=0,se=_.length;Fe<se;Fe++){const oe=_[Fe];oe.requiresSiblings&&be&&(de||(de=(0,k.basename)(G)),Ee||(Ee=de.substr(0,de.length-(0,k.extname)(G).length)));const fe=oe(G,de,Ee,be);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Pe||(Pe=[]),Pe.push(fe))}return Pe?(async()=>{for(const Fe of Pe){const se=await Fe;if(typeof se=="string")return se}return null})():null},ee=_.find(G=>!!G.allBasenames);ee&&(ne.allBasenames=ee.allBasenames);const X=_.reduce((G,de)=>de.allPaths?G.concat(de.allPaths):G,[]);return X.length&&(ne.allPaths=X),ne}function U(ue,V,_){if(V===!1)return s;const J=a(ue,_);if(J===s)return s;if(typeof V=="boolean")return J;if(V){const ne=V.when;if(typeof ne=="string"){const ee=(X,G,de,be)=>{if(!be||!J(X,G))return null;const Ee=ne.replace("$(basename)",()=>de),Pe=be(Ee);return(0,t.isThenable)(Pe)?Pe.then(Fe=>Fe?ue:null):Pe?ue:null};return ee.requiresSiblings=!0,ee}}return J}function z(ue,V){const _=ue.filter(G=>!!G.basenames);if(_.length<2)return ue;const J=_.reduce((G,de)=>{const be=de.basenames;return be?G.concat(be):G},[]);let ne;if(V){ne=[];for(let G=0,de=J.length;G<de;G++)ne.push(V)}else ne=_.reduce((G,de)=>{const be=de.patterns;return be?G.concat(be):G},[]);const ee=function(G,de){if(typeof G!="string")return null;if(!de){let Ee;for(Ee=G.length;Ee>0;Ee--){const Pe=G.charCodeAt(Ee-1);if(Pe===47||Pe===92)break}de=G.substr(Ee)}const be=J.indexOf(de);return be!==-1?ne[be]:null};ee.basenames=J,ee.patterns=ne,ee.allBasenames=J;const X=ue.filter(G=>!G.basenames);return X.push(ee),X}function j(ue,V){return(0,c.equals)(ue,V,(_,J)=>typeof _=="string"&&typeof J=="string"?_===J:typeof _!="string"&&typeof J!="string"?_.base===J.base&&_.pattern===J.pattern:!1)}e.patternsEquals=j}),define(ye[112],Ce([1,0,9,162,24,8,2]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",p=!1){if(this.value=f,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(f,p=0){return this.value+=w(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(b,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,p){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(f,p,b){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(f),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(f,p){const b=new RegExp((0,R.escapeRegExpCharacters)(p),"g");return f.replace(b,(S,g)=>f.charAt(g-1)!=="\\"?`\\${S}`:S)}}e.MarkdownString=y;function D(d){return L(d)?!d.value:Array.isArray(d)?d.every(D):!0}e.isEmptyMarkdownString=D;function L(d){return d instanceof y?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function P(d,f){return d===f?!0:!d||!f?!1:d.value===f.value&&d.isTrusted===f.isTrusted&&d.supportThemeIcons===f.supportThemeIcons&&d.supportHtml===f.supportHtml&&(d.baseUri===f.baseUri||!!d.baseUri&&!!f.baseUri&&(0,T.isEqual)(k.URI.from(d.baseUri),k.URI.from(f.baseUri)))}e.markdownStringEqual=P;function w(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=w;function I(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=I;function v(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=v;function m(d){const f=[],p=d.split("|").map(S=>S.trim());d=p[0];const b=p[1];if(b){const S=/height=(\d+)/.exec(b),g=/width=(\d+)/.exec(b),r=S?S[1]:"",l=g?g[1]:"",s=isFinite(parseInt(l)),a=isFinite(parseInt(r));s&&f.push(`width="${l}"`),a&&f.push(`height="${r}"`)}return{href:d,dimensions:f}}e.parseHrefAndDimensions=m}),define(ye[113],Ce([1,0,16,32,11,12,24,8]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(s,a){const{os:o,tildify:u,relative:i}=a;if(i){const E=D(s,i,o);if(typeof E=="string")return E}let n=s.fsPath;if(o===1&&!R.isWindows?n=n.replace(/\//g,"\\"):o!==1&&R.isWindows&&(n=n.replace(/\\/g,"/")),o!==1&&u?.userHome){const E=u.userHome.fsPath;let C;s.scheme!==u.userHome.scheme&&s.path.startsWith(T.posix.sep)?C=u.userHome.with({path:s.path}).fsPath:C=s.fsPath,n=w(C,E,o)}return(o===1?T.win32:T.posix).normalize(L(n,o===1))}e.getPathLabel=y;function D(s,a,o){const u=o===1?T.win32:T.posix,i=o===3?k.extUri:k.extUriIgnorePathCase,n=a.getWorkspace(),h=(0,c.firstOrDefault)(n.folders);if(!h)return;s.scheme!==h.uri.scheme&&s.path.startsWith(T.posix.sep)&&(s=h.uri.with({path:s.path}));const E=a.getWorkspaceFolder(s);if(!E)return;let C;if(i.isEqual(E.uri,s)?C="":C=i.relativePath(E.uri,s)??"",C&&(C=u.normalize(C)),n.folders.length>1&&!a.noPrefix){const M=E.name?E.name:i.basenameOrAuthority(E.uri);C=C?`${M} \u2022 ${C}`:M}return C}function L(s,a=R.isWindows){return(0,t.hasDriveLetter)(s,a)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=L;let P=Object.create(null);function w(s,a,o=R.OS){if(o===1||!s||!a)return s;let u=P.original===a?P.normalized:void 0;u||(u=a,R.isWindows&&(u=(0,t.toSlashes)(u)),u=`${(0,A.rtrim)(u,T.posix.sep)}${T.posix.sep}`,P={original:a,normalized:u});let i=s;return R.isWindows&&(i=(0,t.toSlashes)(i)),(o===3?i.startsWith(u):(0,A.startsWithIgnoreCase)(i,u))?`~/${i.substr(u.length)}`:s}e.tildify=w;function I(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=I;const v="\u2026",m="\\\\",d="~";function f(s,a=T.sep){const o=new Array(s.length);let u=!1;for(let i=0;i<s.length;i++){const n=s[i];if(n===""){o[i]=`.${a}`;continue}if(!n){o[i]=n;continue}u=!0;let h="",E=n;E.indexOf(m)===0?(h=E.substr(0,E.indexOf(m)+m.length),E=E.substr(E.indexOf(m)+m.length)):E.indexOf(a)===0?(h=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(d)===0&&(h=E.substr(0,E.indexOf(d)+d.length),E=E.substr(E.indexOf(d)+d.length));const C=E.split(a);for(let M=1;u&&M<=C.length;M++)for(let K=C.length-M;u&&K>=0;K--){u=!1;let q=C.slice(K,K+M).join(a);for(let F=0;!u&&F<s.length;F++)if(F!==i&&s[F]&&s[F].indexOf(q)>-1){const B=K+M===C.length,O=K>0&&s[F].indexOf(a)>-1?a+q:q,U=s[F].endsWith(O);u=!B||U}if(!u){let F="";(C[0].endsWith(":")||h!=="")&&(K===1&&(K=0,M++,q=C[0]+a+q),K>0&&(F=C[0]+a),F=h+F),K>0&&(F=F+v+a),F=F+q,K+M<C.length&&(F=F+a+v),o[i]=F}}u&&(o[i]=n)}return o}e.shorten=f;var p;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function b(s,a=Object.create(null)){const o=[];let u=!1,i="";for(const n of s)if(n==="$"||u&&n==="{")i&&o.push({value:i,type:p.TEXT}),i="",u=!0;else if(n==="}"&&u){const h=a[i];if(typeof h=="string")h.length&&o.push({value:h,type:p.VARIABLE});else if(h){const E=o[o.length-1];(!E||E.type!==p.SEPARATOR)&&o.push({value:h.label,type:p.SEPARATOR})}i="",u=!1}else i+=n;return i&&!u&&o.push({value:i,type:p.TEXT}),o.filter((n,h)=>{if(n.type===p.SEPARATOR){const E=o[h-1],C=o[h+1];return[E,C].every(M=>M&&(M.type===p.VARIABLE||M.type===p.TEXT)&&M.value.length>0)}return!0}).map(n=>n.value).join("")}e.template=b;function S(s,a){return R.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):s.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function g(s,a){return R.isMacintosh||a?s.replace(/\(&&\w\)|&&/g,""):R.isWindows?s.replace(/&&|&/g,o=>o==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function r(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=r;function l(s){const a=s.indexOf("/")!==-1?T.posix:T.win32,o=a.basename(s),u=a.dirname(s);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=l}),define(ye[114],Ce([1,0,2]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class T{constructor(P){this.a=P}transformIncoming(P){const w=this.a.transformIncoming(P);return w===P?P:t(c.URI.from(w))}transformOutgoing(P){const w=this.a.transformOutgoing(P);return w===P?P:t(c.URI.from(w))}transformOutgoingURI(P){const w=this.a.transformOutgoing(P);return w===P?P:c.URI.from(w)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function R(L,P,w){if(!L||w>200)return null;if(typeof L=="object"){if(L instanceof c.URI)return P.transformOutgoing(L);for(const I in L)if(Object.hasOwnProperty.call(L,I)){const v=R(L[I],P,w+1);v!==null&&(L[I]=v)}}return null}function k(L,P){const w=R(L,P,0);return w===null?L:w}e.transformOutgoingURIs=k;function A(L,P,w,I){if(!L||I>200)return null;if(typeof L=="object"){if(L.$mid===1)return w?c.URI.revive(P.transformIncoming(L)):P.transformIncoming(L);for(const v in L)if(Object.hasOwnProperty.call(L,v)){const m=A(L[v],P,w,I+1);m!==null&&(L[v]=m)}}return null}function y(L,P){const w=A(L,P,!1,0);return w===null?L:w}e.transformIncomingURIs=y;function D(L,P){const w=A(L,P,!0,0);return w===null?L:w}e.transformAndReviveIncomingURIs=D}),define(ye[29],Ce([1,0,67,88,315,14,32,84,11,12,24,2]),function(te,e,c,t,T,R,k,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function I(O,U=w.UNLINK){if((0,k.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return U===w.UNLINK?m(O):v(O)}async function v(O){try{const U=(0,k.randomPath)((0,t.tmpdir)());try{await c.promises.rename(O,U)}catch(z){return z.code==="ENOENT"?void 0:m(O)}m(U).catch(z=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function m(O){return(0,T.promisify)(c.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function d(O){if((0,k.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function f(O,U){return S(await(U?p(O):(0,T.promisify)(c.readdir)(O)))}async function p(O){try{return await(0,T.promisify)(c.readdir)(O,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const U=[],z=await f(O);for(const j of z){let ue=!1,V=!1,_=!1;try{const J=await e.Promises.lstat((0,y.join)(O,j));ue=J.isFile(),V=J.isDirectory(),_=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}U.push({name:j,isFile:()=>ue,isDirectory:()=>V,isSymbolicLink:()=>_})}return U}function b(O){return S(c.readdirSync(O))}e.readdirSync=b;function S(O){return O.map(U=>typeof U=="string"?D.isMacintosh?(0,A.normalizeNFC)(U):U:(U.name=D.isMacintosh?(0,A.normalizeNFC)(U.name):U.name,U))}async function g(O){const U=await f(O),z=[];for(const j of U)await l.existsDirectory((0,y.join)(O,j))&&z.push(j);return z}function r(O,U=1e3){return new Promise(z=>{let j=!1;const ue=setInterval(()=>{j||(j=!0,c.access(O,V=>{j=!1,V&&(clearInterval(ue),z(void 0))}))},U)})}e.whenDeleted=r;var l;(function(O){async function U(ue){let V;try{if(V=await e.Promises.lstat(ue),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(ue),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(D.isWindows&&_.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ue)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw J}throw _}}O.stat=U;async function z(ue){try{const{stat:V,symbolicLink:_}=await O.stat(ue);return V.isFile()&&_?.dangling!==!0}catch{}return!1}O.existsFile=z;async function j(ue){try{const{stat:V,symbolicLink:_}=await O.stat(ue);return V.isDirectory()&&_?.dangling!==!0}catch{}return!1}O.existsDirectory=j})(l=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new R.ResourceQueue;function a(O,U,z){return s.queueFor(P.URI.file(O),L.extUriBiasedIgnorePathCase).queue(()=>{const j=h(z);return new Promise((ue,V)=>i(O,U,j,_=>_?V(_):ue()))})}let o=!0;function u(O){o=O}e.configureFlushOnWrite=u;function i(O,U,z,j){if(!o)return c.writeFile(O,U,{mode:z.mode,flag:z.flag},j);c.open(O,z.flag,z.mode,(ue,V)=>{if(ue)return j(ue);c.writeFile(V,U,_=>{if(_)return c.close(V,()=>j(_));c.fdatasync(V,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),u(!1)),c.close(V,ne=>j(ne))))})})}function n(O,U,z){const j=h(z);if(!o)return c.writeFileSync(O,U,{mode:j.mode,flag:j.flag});const ue=c.openSync(O,j.flag,j.mode);try{c.writeFileSync(ue,U);try{c.fdatasyncSync(ue)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),u(!1)}}finally{c.closeSync(ue)}}e.writeFileSync=n;function h(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function E(O,U){if(O!==U)try{await e.Promises.rename(O,U)}catch(z){if(O.toLowerCase()!==U.toLowerCase()&&z.code==="EXDEV"||O.endsWith("."))await C(O,U,{preserveSymlinks:!1}),await I(O,w.MOVE);else throw z}}async function C(O,U,z){return K(O,U,{root:{source:O,target:U},options:z,handledSourcePaths:new Set})}const M=511;async function K(O,U,z){if(z.handledSourcePaths.has(O))return;z.handledSourcePaths.add(O);const{stat:j,symbolicLink:ue}=await l.stat(O);if(ue){if(z.options.preserveSymlinks)try{return await B(O,U,z)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(ue.dangling)return}return j.isDirectory()?q(O,U,j.mode&M,z):F(O,U,j.mode&M)}async function q(O,U,z,j){await e.Promises.mkdir(U,{recursive:!0,mode:z});const ue=await f(O);for(const V of ue)await K((0,y.join)(O,V),(0,y.join)(U,V),j)}async function F(O,U,z){await e.Promises.copyFile(O,U),await e.Promises.chmod(U,z)}async function B(O,U,z){let j=await e.Promises.readlink(O);(0,k.isEqualOrParent)(j,z.root.source,!D.isLinux)&&(j=(0,y.join)(z.root.target,j.substr(z.root.source.length+1))),await e.Promises.symlink(j,U)}e.Promises=new class{get access(){return(0,T.promisify)(c.access)}get stat(){return(0,T.promisify)(c.stat)}get lstat(){return(0,T.promisify)(c.lstat)}get utimes(){return(0,T.promisify)(c.utimes)}get read(){return(O,U,z,j,ue)=>new Promise((V,_)=>{c.read(O,U,z,j,ue,(J,ne,ee)=>J?_(J):V({bytesRead:ne,buffer:ee}))})}get readFile(){return(0,T.promisify)(c.readFile)}get write(){return(O,U,z,j,ue)=>new Promise((V,_)=>{c.write(O,U,z,j,ue,(J,ne,ee)=>J?_(J):V({bytesWritten:ne,buffer:ee}))})}get appendFile(){return(0,T.promisify)(c.appendFile)}get fdatasync(){return(0,T.promisify)(c.fdatasync)}get truncate(){return(0,T.promisify)(c.truncate)}get rename(){return(0,T.promisify)(c.rename)}get copyFile(){return(0,T.promisify)(c.copyFile)}get open(){return(0,T.promisify)(c.open)}get close(){return(0,T.promisify)(c.close)}get symlink(){return(0,T.promisify)(c.symlink)}get readlink(){return(0,T.promisify)(c.readlink)}get chmod(){return(0,T.promisify)(c.chmod)}get mkdir(){return(0,T.promisify)(c.mkdir)}get unlink(){return(0,T.promisify)(c.unlink)}get rmdir(){return(0,T.promisify)(c.rmdir)}get realpath(){return(0,T.promisify)(c.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return g}get writeFile(){return a}get rm(){return I}get move(){return E}get copy(){return C}}}),define(ye[115],Ce([1,0,67,11,12,8,29]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(w){if(T.isLinux)return w;const I=(0,t.dirname)(w);if(w===I)return w;const v=((0,t.basename)(w)||w).toLowerCase();try{const d=(0,k.readdirSync)(I).filter(f=>f.toLowerCase()===v);if(d.length===1){const f=A(I);if(f)return(0,t.join)(f,d[0])}else if(d.length>1){const f=d.indexOf(v);if(f>=0){const p=A(I);if(p)return(0,t.join)(p,d[f])}}}catch{}return null}e.realcaseSync=A;async function y(w){if(T.isLinux)return w;const I=(0,t.dirname)(w);if(w===I)return w;const v=((0,t.basename)(w)||w).toLowerCase();try{const d=(await k.Promises.readdir(I)).filter(f=>f.toLowerCase()===v);if(d.length===1){const f=await y(I);if(f)return(0,t.join)(f,d[0])}else if(d.length>1){const f=d.indexOf(v);if(f>=0){const p=await y(I);if(p)return(0,t.join)(p,d[f])}}}catch{}return null}e.realcase=y;async function D(w){try{return await k.Promises.realpath(w)}catch{const v=P(w);return await k.Promises.access(v,c.constants.R_OK),v}}e.realpath=D;function L(w){try{return c.realpathSync(w)}catch{const v=P(w);return c.accessSync(v,c.constants.R_OK),v}}e.realpathSync=L;function P(w){return(0,R.rtrim)((0,t.normalize)(w),t.sep)}}),define(ye[116],Ce([1,0,11,12,37,108,10,29]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(P=T.env){return P.comspec||"cmd.exe"}e.getWindowsShell=y;function D(P){let w=[],I=!1;const v=function(m){if(I){w.push(m);return}(!P.send(m,f=>{if(f&&console.error(f),I=!1,w.length>0){const p=w.slice(0);w=[],p.forEach(b=>v(b))}})||t.isWindows)&&(I=!0)};return{send:v}}e.createQueuedSender=D;var L;(function(P){async function w(I,v,m){if(c.isAbsolute(I))return I;if(v===void 0&&(v=T.cwd()),c.dirname(I)!=="."||(m===void 0&&k.isString(T.env.PATH)&&(m=T.env.PATH.split(c.delimiter)),m===void 0||m.length===0))return c.join(v,I);async function f(p){if(await A.Promises.exists(p)){let b;try{b=await A.Promises.stat(p)}catch(S){S.message.startsWith("EACCES")&&(b=await A.Promises.lstat(p))}return b?!b.isDirectory():!1}return!1}for(const p of m){let b;if(c.isAbsolute(p)?b=c.join(p,I):b=c.join(v,p,I),await f(b))return b;let S=b+".com";if(await f(S)||(S=b+".exe",await f(S)))return S}return c.join(v,I)}P.findExecutable=w})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(te,e,c,t){var T=arguments.length,R=T<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,c):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(te,e,c,t);else for(var A=te.length-1;A>=0;A--)(k=te[A])&&(R=(T<3?k(R):T>3?k(e,c,R):k(e,c))||R);return T>3&&R&&Object.defineProperty(e,c,R),R};define(ye[117],Ce([1,0,16,14,23,21,62,9,3,6,87,8,10]),function(te,e,c,t,T,R,k,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var I;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(I||(I={}));function v(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(m||(m={}));function d(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));function p(V){let _=0;for(let J=0;;J+=7){const ne=V.read(1);if(_|=(ne.buffer[0]&127)<<J,!(ne.buffer[0]&128))return _}}const b=s(0);function S(V,_){if(_===0){V.write(b);return}let J=0;for(let ee=_;ee!==0;ee=ee>>>7)J++;const ne=T.VSBuffer.alloc(J);for(let ee=0;_!==0;ee++)ne.buffer[ee]=_&127,_=_>>>7,_>0&&(ne.buffer[ee]|=128);V.write(ne)}class g{constructor(_){this.b=_,this.a=0}read(_){const J=this.b.slice(this.a,this.a+_);return this.a+=J.byteLength,J}}e.BufferReader=g;class r{constructor(){this.a=[]}get buffer(){return T.VSBuffer.concat(this.a)}write(_){this.a.push(_)}}e.BufferWriter=r;var l;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(l||(l={}));function s(V){const _=T.VSBuffer.alloc(1);return _.writeUInt8(V,0),_}const a={Undefined:s(l.Undefined),String:s(l.String),Buffer:s(l.Buffer),VSBuffer:s(l.VSBuffer),Array:s(l.Array),Object:s(l.Object),Uint:s(l.Int)},o=typeof Buffer<"u";function u(V,_){if(typeof _>"u")V.write(a.Undefined);else if(typeof _=="string"){const J=T.VSBuffer.fromString(_);V.write(a.String),S(V,J.byteLength),V.write(J)}else if(o&&Buffer.isBuffer(_)){const J=T.VSBuffer.wrap(_);V.write(a.Buffer),S(V,J.byteLength),V.write(J)}else if(_ instanceof T.VSBuffer)V.write(a.VSBuffer),S(V,_.byteLength),V.write(_);else if(Array.isArray(_)){V.write(a.Array),S(V,_.length);for(const J of _)u(V,J)}else if(typeof _=="number"&&(_|0)===_)V.write(a.Uint),S(V,_);else{const J=T.VSBuffer.fromString(JSON.stringify(_));V.write(a.Object),S(V,J.byteLength),V.write(J)}}e.serialize=u;function i(V){switch(V.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return V.read(p(V)).toString();case l.Buffer:return V.read(p(V)).buffer;case l.VSBuffer:return V.read(p(V));case l.Array:{const J=p(V),ne=[];for(let ee=0;ee<J;ee++)ne.push(i(V));return ne}case l.Object:return JSON.parse(V.read(p(V)).toString());case l.Int:return p(V)}}e.deserialize=i;class n{constructor(_,J,ne=null,ee=1e3){this.h=_,this.j=J,this.k=ne,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(_,J){this.b.set(_,J),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const J=this.o([_.type]);this.k?.logOutgoing(J,0,1,d(_.type));return}case 201:case 202:case 204:case 203:{const J=this.o([_.type,_.id],_.data);this.k?.logOutgoing(J,_.id,1,d(_.type),_.data);return}}}o(_,J=void 0){const ne=new r;return u(ne,_),u(ne,J),this.p(ne.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const J=new g(_),ne=i(J),ee=i(J),X=ne[0];switch(X){case 100:return this.k?.logIncoming(_.byteLength,ne[1],1,`${v(X)}: ${ne[2]}.${ne[3]}`,ee),this.s({type:X,id:ne[1],channelName:ne[2],name:ne[3],arg:ee});case 102:return this.k?.logIncoming(_.byteLength,ne[1],1,`${v(X)}: ${ne[2]}.${ne[3]}`,ee),this.t({type:X,id:ne[1],channelName:ne[2],name:ne[3],arg:ee});case 101:return this.k?.logIncoming(_.byteLength,ne[1],1,`${v(X)}`),this.u({type:X,id:ne[1]});case 103:return this.k?.logIncoming(_.byteLength,ne[1],1,`${v(X)}`),this.u({type:X,id:ne[1]})}}s(_){const J=this.b.get(_.channelName);if(!J){this.v(_);return}const ne=new R.CancellationTokenSource;let ee;try{ee=J.call(this.j,_.name,_.arg,ne.token)}catch(de){ee=Promise.reject(de)}const X=_.id;ee.then(de=>{this.m({id:X,data:de,type:201}),this.d.delete(_.id)},de=>{de instanceof Error?this.m({id:X,data:{message:de.message,name:de.name,stack:de.stack?de.stack.split?de.stack.split(`
`):de.stack:void 0},type:202}):this.m({id:X,data:de,type:203}),this.d.delete(_.id)});const G=(0,D.toDisposable)(()=>ne.cancel());this.d.set(_.id,G)}t(_){const J=this.b.get(_.channelName);if(!J){this.v(_);return}const ne=_.id,X=J.listen(this.j,_.name,_.arg)(G=>this.m({id:ne,data:G,type:204}));this.d.set(_.id,X)}u(_){const J=this.d.get(_.id);J&&(J.dispose(),this.d.delete(_.id))}v(_){let J=this.g.get(_.channelName);J||(J=[],this.g.set(_.channelName,J));const ne=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:_,timeoutTimer:ne})}w(_){const J=this.g.get(_);if(J){for(const ne of J)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,D.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=n;var h;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(_,J=null){this.l=_,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=J}getChannel(_){const J=this;return{call(ne,ee,X){return J.a?Promise.reject(new A.CancellationError):J.m(_,ne,ee,X)},listen(ne,ee){return J.a?y.Event.None:J.o(_,ne,ee)}}}m(_,J,ne,ee=R.CancellationToken.None){const X=this.g++,de={id:X,type:100,channelName:_,name:J,arg:ne};if(ee.isCancellationRequested)return Promise.reject(new A.CancellationError);let be;return new Promise((Pe,Fe)=>{if(ee.isCancellationRequested)return Fe(new A.CancellationError);const se=()=>{const ce=ie=>{switch(ie.type){case 201:this.f.delete(X),Pe(ie.data);break;case 202:{this.f.delete(X);const N=new Error(ie.data.message);N.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,N.name=ie.data.name,Fe(N);break}case 203:this.f.delete(X),Fe(ie.data);break}};this.f.set(X,ce),this.p(de)};let oe=null;this.b===f.Idle?se():(oe=(0,t.createCancelablePromise)(ce=>this.u()),oe.then(()=>{oe=null,se()}));const fe=()=>{oe?(oe.cancel(),oe=null):this.p({id:X,type:101}),Fe(new A.CancellationError)},Z=ee.onCancellationRequested(fe);be=(0,D.combinedDisposable)((0,D.toDisposable)(fe),Z),this.d.add(be)}).finally(()=>{this.d.delete(be)})}o(_,J,ne){const ee=this.g++,G={id:ee,type:102,channelName:_,name:J,arg:ne};let de=null;const be=new y.Emitter({onWillAddFirstListener:()=>{de=(0,t.createCancelablePromise)(Pe=>this.u()),de.then(()=>{de=null,this.d.add(be),this.p(G)})},onDidRemoveLastListener:()=>{de?(de.cancel(),de=null):(this.d.delete(be),this.p({id:ee,type:103}))}}),Ee=Pe=>be.fire(Pe.data);return this.f.set(ee,Ee),be.event}p(_){switch(_.type){case 100:case 102:{const J=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(J,_.id,0,`${v(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const J=this.q([_.type,_.id]);this.j?.logOutgoing(J,_.id,0,v(_.type));return}}}q(_,J=void 0){const ne=new r;return u(ne,_),u(ne,J),this.r(ne.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const J=new g(_),ne=i(J),ee=i(J),X=ne[0];switch(X){case 200:return this.j?.logIncoming(_.byteLength,0,0,d(X)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,ne[1],0,d(X),ee),this.t({type:ne[0],id:ne[1],data:ee})}}t(_){if(_.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,D.dispose)(this.d.values()),this.d.clear()}}qe([k.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class C{get connections(){const _=[];return this.f.forEach(J=>_.push(J)),_}constructor(_){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,_(({protocol:J,onDidClientDisconnect:ne})=>{y.Event.once(J.onMessage)(X=>{const G=new g(X),de=i(G),be=new n(J,de),Ee=new E(J);this.a.forEach((Fe,se)=>be.registerChannel(se,Fe));const Pe={channelServer:be,channelClient:Ee,ctx:de};this.f.add(Pe),this.g.fire(Pe),ne(()=>{be.dispose(),Ee.dispose(),this.f.delete(Pe),this.h.fire(Pe)})})})}getChannel(_,J){const ne=this;return{call(ee,X,G){let de;if((0,w.isFunction)(J)){const Ee=(0,c.getRandomElement)(ne.connections.filter(J));de=Ee?Promise.resolve(Ee):y.Event.toPromise(y.Event.filter(ne.onDidAddConnection,J))}else de=J.routeCall(ne,ee,X);const be=de.then(Ee=>Ee.channelClient.getChannel(_));return K(be).call(ee,X,G)},listen(ee,X){if((0,w.isFunction)(J))return ne.j(_,J,ee,X);const G=J.routeEvent(ne,ee,X).then(de=>de.channelClient.getChannel(_));return K(G).listen(ee,X)}}}j(_,J,ne,ee){const X=this;let G=new D.DisposableStore;const de=new y.Emitter({onWillAddFirstListener:()=>{G=new D.DisposableStore;const be=new y.EventMultiplexer,Ee=new Map,Pe=se=>{const fe=se.channelClient.getChannel(_).listen(ne,ee),Z=be.add(fe);Ee.set(se,Z)},Fe=se=>{const oe=Ee.get(se);!oe||(oe.dispose(),Ee.delete(se))};X.connections.filter(J).forEach(Pe),y.Event.filter(X.onDidAddConnection,J)(Pe,void 0,G),X.onDidRemoveConnection(Fe,void 0,G),be.event(de.fire,de,G),G.add(be)},onDidRemoveLastListener:()=>{G.dispose()}});return de.event}registerChannel(_,J){this.a.set(_,J),this.f.forEach(ne=>{ne.channelServer.registerChannel(_,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=C;class M{constructor(_,J,ne=null){const ee=new r;u(ee,J),_.send(ee.buffer),this.a=new E(_,ne),this.d=new n(_,J,ne)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,J){this.d.registerChannel(_,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=M;function K(V){return{call(_,J,ne){return V.then(ee=>ee.call(_,J,ne))},listen(_,J){const ne=new y.Relay;return V.then(ee=>ne.input=ee.listen(_,J)),ne.event}}}e.getDelayedChannel=K;function q(V){let _=!1;return{call(J,ne,ee){return _?V.call(J,ne,ee):(0,t.timeout)(0).then(()=>_=!0).then(()=>V.call(J,ne,ee))},listen(J,ne){if(_)return V.listen(J,ne);const ee=new y.Relay;return(0,t.timeout)(0).then(()=>_=!0).then(()=>ee.input=V.listen(J,ne)),ee.event}}}e.getNextTickChannel=q;class F{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const J of _.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await y.Event.toPromise(_.onDidAddConnection),await this.b(_)}}e.StaticRouter=F;var B;(function(V){function _(X,G){const de=X,be=G&&G.disableMarshalling,Ee=new Map;for(const Pe in de)ne(Pe)&&Ee.set(Pe,y.Event.buffer(de[Pe],!0));return new class{listen(Pe,Fe,se){const oe=Ee.get(Fe);if(oe)return oe;if(ee(Fe)){const fe=de[Fe];if(typeof fe=="function")return fe.call(de,se)}throw new Error(`Event not found: ${Fe}`)}call(Pe,Fe,se){const oe=de[Fe];if(typeof oe=="function"){if(!be&&Array.isArray(se))for(let fe=0;fe<se.length;fe++)se[fe]=(0,L.revive)(se[fe]);return oe.apply(de,se)}throw new Error(`Method not found: ${Fe}`)}}}V.fromService=_;function J(X,G){const de=G&&G.disableMarshalling;return new Proxy({},{get(be,Ee){if(typeof Ee=="string")return G?.properties?.has(Ee)?G.properties.get(Ee):ee(Ee)?function(Pe){return X.listen(Ee,Pe)}:ne(Ee)?X.listen(Ee):async function(...Pe){let Fe;G&&!(0,w.isUndefinedOrNull)(G.context)?Fe=[G.context,...Pe]:Fe=Pe;const se=await X.call(Ee,Fe);return de?se:(0,L.revive)(se)};throw new Error(`Property not found: ${String(Ee)}`)}})}V.toService=J;function ne(X){return X[0]==="o"&&X[1]==="n"&&P.isUpperAsciiLetter(X.charCodeAt(2))}function ee(X){return/^onDynamic/.test(X)&&P.isUpperAsciiLetter(X.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const _=V.toString();if(_!=="[object Object]")return _}return V}function z(V){return Array.isArray(V)?V.map(U):U(V)}function j(V,_,J,ne,ee,X,G){G=z(G);const de=O[ee],be=de[ne%de.length];let Ee=[`%c[${V}]%c[${String(_).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${be}`];/\($/.test(X)?(Ee=Ee.concat(G),Ee.push(")")):Ee.push(G),console.log.apply(console,Ee)}class ue{constructor(_,J){this.d=_,this.f=J,this.a=0,this.b=0}logOutgoing(_,J,ne,ee,X){this.b+=_,j(this.d,this.b,_,J,ne,ee,X)}logIncoming(_,J,ne,ee,X){this.a+=_,j(this.f,this.a,_,J,ne,ee,X)}}e.IPCLogger=ue}),define(ye[118],Ce([1,0,14,23,3,6,117]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(E){E.enableDiagnostics=!1,E.records=[];const C=new WeakMap;let M=0;function K(F,B){if(!C.has(F)){const O=String(++M);C.set(F,O)}return C.get(F)}function q(F,B,O,U){if(!E.enableDiagnostics)return;const z=K(F,B);if(U instanceof t.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const j=t.VSBuffer.alloc(U.byteLength);j.set(U),E.records.push({timestamp:Date.now(),id:z,label:B,type:O,buff:j})}else E.records.push({timestamp:Date.now(),id:z,label:B,type:O,data:U})}E.traceSocketEvent=q})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var D;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function P(){return L||(L=t.VSBuffer.alloc(0)),L}class w{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(C){this.a.push(C),this.b+=C.byteLength}read(C){return this.c(C,!0)}peek(C){return this.c(C,!1)}c(C,M){if(C===0)return P();if(C>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===C){const B=this.a[0];return M&&(this.a.shift(),this.b-=C),B}if(this.a[0].byteLength>C){const B=this.a[0].slice(0,C);return M&&(this.a[0]=this.a[0].slice(C),this.b-=C),B}const K=t.VSBuffer.alloc(C);let q=0,F=0;for(;C>0;){const B=this.a[F];if(B.byteLength>C){const O=B.slice(0,C);K.set(O,q),q+=C,M&&(this.a[F]=B.slice(C),this.b-=C),C-=C}else K.set(B,q),q+=B.byteLength,M?(this.a.shift(),this.b-=B.byteLength):F++,C-=B.byteLength}return K}}e.ChunkStream=w;var I;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(I||(I={}));function v(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var m;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(C,M,K,q){this.type=C,this.id=M,this.ack=K,this.data=q,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends R.Disposable{constructor(C){super(),this.f=this.B(new T.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=C,this.b=!1,this.c=new w,this.B(this.a.onData(M=>this.acceptChunk(M))),this.lastReadTime=Date.now()}acceptChunk(C){if(!(!C||C.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(C);this.c.byteLength>=this.g.readLen;){const M=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=M.readUInt32BE(9),this.g.messageType=M.readUInt8(0),this.g.id=M.readUInt32BE(1),this.g.ack=M.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const K=this.g.messageType,q=this.g.id,F=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",M),this.f.fire(new d(K,q,F,M)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class p{constructor(C){this.k=null,this.a=!1,this.b=!1,this.c=C,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(C){if(this.a)return;C.writtenTime=Date.now(),this.lastWriteTime=Date.now();const M=t.VSBuffer.alloc(13);M.writeUInt8(C.type,0),M.writeUInt32BE(C.id,1),M.writeUInt32BE(C.ack,5),M.writeUInt32BE(C.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(C.type),id:C.id,ack:C.ack,messageSize:C.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",C.data),this.j(M,C.data)}g(C,M){const K=this.f===0;return this.d.push(C,M),this.f+=C.byteLength+M.byteLength,K}h(){const C=t.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,C}j(C,M){this.g(C,M)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const C=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:C.byteLength}),this.c.write(C)}}class b extends R.Disposable{constructor(C){super(),this.f=new T.Emitter,this.onMessage=this.f.event,this.g=new T.Emitter,this.onDidDispose=this.g.event,this.a=C,this.b=this.B(new p(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(M=>{M.type===1&&this.f.fire(M.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(C){this.b.write(new d(1,0,0,C))}}e.Protocol=b;class S extends k.IPCClient{static fromSocket(C,M){return new S(new b(C),M)}get onDidDispose(){return this.b.onDidDispose}constructor(C,M,K=null){super(C,M,K),this.b=C}dispose(){super.dispose();const C=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),C.end()}}e.Client=S;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(C){this.b?this.d.length>0?this.d.push(C):this.a.fire(C):this.d.push(C)}flushBuffer(){this.d=[]}}e.BufferedEmitter=g;class r{constructor(C){this.data=C,this.next=null}}class l{constructor(){this.a=null,this.b=null}length(){let C=0,M=this.a;for(;M;)M=M.next,C++;return C}peek(){return this.a?this.a.data:null}toArray(){const C=[];let M=0,K=this.a;for(;K;)C[M++]=K.data,K=K.next;return C}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(C){const M=new r(C);if(!this.a){this.a=M,this.b=M;return}this.b.next=M,this.b=M}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const C=Date.now();for(let M=0;M<s.a;M++)this.c[M]=C-1e3*M;setInterval(()=>{for(let M=s.a;M>=1;M--)this.c[M]=this.c[M-1];this.c[0]=Date.now()},1e3)}d(){const C=Date.now(),M=(1+s.a)*1e3;let K=0;for(let q=0;q<s.a;q++)C-this.c[q]<=M&&K++;return 1-K/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;var a;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(a=e.ConnectionHealth||(e.ConnectionHealth={}));function o(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class u{constructor(C){this.connectionHealth=C}}e.ConnectionHealthChangedEvent=u;class i{constructor(C,M){this.roundTripTime=C,this.recentHighRoundTripCount=M}}e.HighRoundTripTimeEvent=i;class n{get unacknowledgedCount(){return this.c-this.d}constructor(C){this.x=new g,this.onControlMessage=this.x.event,this.y=new g,this.onMessage=this.y.event,this.z=new g,this.onDidDispose=this.z.event,this.A=new g,this.onSocketClose=this.A.event,this.B=new g,this.onSocketTimeout=this.B.event,this.C=new g,this.onHighRoundTripTime=this.C.event,this.D=new g,this.onDidChangeConnectionHealth=this.D.event,this.u=C.loadEstimator??s.getInstance(),this.v=C.measureRoundTripTime??!1,this.w=C.sendKeepAlive??!0,this.a=!1,this.b=new l,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=C.socket,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new h),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.v&&this.r.start(),C.initialChunk&&this.q.acceptChunk(C.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const C=new d(5,0,0,P());this.p.write(C),this.p.flush()}sendPause(){const C=new d(7,0,0,P());this.p.write(C)}sendResume(){const C=new d(8,0,0,P());this.p.write(C)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(C,M){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=C,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new f(this.o)),this.t.add(this.q.onMessage(K=>this.E(K))),this.t.add(this.o.onClose(K=>this.A.fire(K))),this.r=this.t.add(new h),this.t.add(this.r.onSendLatencyRequest(K=>this.J(K))),this.t.add(this.r.onHighRoundTripTime(K=>this.C.fire(K))),this.t.add(this.r.onDidChangeConnectionHealth(K=>this.D.fire(K))),this.q.acceptChunk(M)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const C=new d(3,0,this.h,P());this.p.write(C);const M=this.b.toArray();for(let K=0,q=M.length;K<q;K++)this.p.write(M[K]);this.G()}acceptDisconnect(){this.z.fire()}E(C){if(C.ack>this.d){this.d=C.ack;do{const M=this.b.peek();if(M&&M.id<=C.ack)this.b.pop();else break}while(!0)}switch(C.type){case 0:break;case 1:{if(C.id>this.g)if(C.id!==this.g+1){const M=Date.now();M-this.m>1e4&&(this.m=M,this.p.write(new d(6,0,0,P())))}else this.g=C.id,this.j=Date.now(),this.F(),this.y.fire(C.data);break}case 2:{this.x.fire(C.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const M=this.b.toArray();for(let K=0,q=M.length;K<q;K++)this.p.write(M[K]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(C.data);break}case 11:{this.r.handleResponse(C.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(C){const M=++this.c;this.h=this.g;const K=new d(1,M,this.h,C);this.b.push(K),this.a||(this.p.write(K),this.G())}sendControl(C){const M=new d(2,0,0,C);this.p.write(M)}F(){if(this.g<=this.h||this.k)return;const C=Date.now()-this.j;if(C>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-C+5)}G(){if(this.c<=this.d||this.f||this.a)return;const C=this.b.peek(),M=Date.now()-C.writtenTime,K=Date.now()-this.q.lastReadTime,q=Date.now()-this.n;if(M>=2e4&&K>=2e4&&q>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:M,timeSinceLastReceivedSomeData:K});return}const F=Math.max(2e4-M,2e4-K,2e4-q,500);this.f=setTimeout(()=>{this.f=null,this.G()},F)}H(){if(this.g<=this.h)return;this.h=this.g;const C=new d(3,0,this.h,P());this.p.write(C)}I(){this.h=this.g;const C=new d(9,0,this.h,P());this.p.write(C)}J(C){this.h=this.g;const M=new d(10,0,this.h,C);this.p.write(M)}K(C){this.h=this.g;const M=new d(11,0,this.h,C);this.p.write(M)}}e.PersistentProtocol=n;class h extends R.Disposable{constructor(){super(),this.a=this.B(new T.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new T.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new T.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new c.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},C=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const C=++this.h,M=t.VSBuffer.alloc(4);M.writeUInt32BE(C,0),this.a.fire(M)},6e4)}handleResponse(C){if(C.byteLength!==4)return;const M=C.readUInt32BE(0);if(this.g<=0||M!==this.h)return;const K=Date.now()-this.g,q=this.k++;this.j[q%this.j.length]=K;const F=this.l,B=this.j.filter(O=>O>=1e3).length;this.l=B>=3?1:0,K>1e3&&this.b.fire(new i(K,B)),F!==this.l&&this.c.fire(this.l)}}}),define(ye[119],Ce([1,0,23,9,3,6,11,12,30,117,118]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class w{traceSocketEvent(i,n){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,i,n)}constructor(i,n=""){this.f=!0,this.debugLabel=n,this.socket=i,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,t.onUnexpectedError)(h)}},this.socket.on("error",this.a),this.b=h=>{this.traceSocketEvent("close",{hadError:h}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(i){const n=h=>{this.traceSocketEvent("read",h),i(c.VSBuffer.wrap(h))};return this.socket.on("data",n),{dispose:()=>this.socket.off("data",n)}}onClose(i){const n=h=>{i({type:0,hadError:h,error:void 0})};return this.socket.on("close",n),{dispose:()=>this.socket.off("close",n)}}onEnd(i){const n=()=>{i()};return this.socket.on("end",n),{dispose:()=>this.socket.off("end",n)}}write(i){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",i),this.socket.write(i.buffer,n=>{if(n){if(n.code==="EPIPE")return;(0,t.onUnexpectedError)(n)}})}catch(n){if(n.code==="EPIPE")return;(0,t.onUnexpectedError)(n)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((i,n)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),i();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),i()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=w;var I;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(I||(I={}));var v;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(v||(v={}));class m extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(i,n){this.socket.traceSocketEvent(i,n)}constructor(i,n,h,E){super(),this.f=this.B(new T.Emitter),this.g=this.B(new T.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=i,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:n,inflateBytesLength:h?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new d(this,n,h,E,this.f,(C,M)=>this.k(C,M))),this.B(this.a.onError(C=>{console.error(C),(0,t.onUnexpectedError)(C),this.g.fire({type:0,hadError:!0,error:C})})),this.b=new L.ChunkStream,this.B(this.socket.onData(C=>this.l(C))),this.B(this.socket.onClose(C=>this.g.fire(C)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(i){return this.f.event(i)}onClose(i){return this.g.event(i)}onEnd(i){return this.socket.onEnd(i)}write(i){this.a.writeMessage(i)}k(i,n){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",i);let h=2;i.byteLength<126?h+=0:i.byteLength<2**16?h+=2:h+=8;const E=c.VSBuffer.alloc(h);if(n?E.writeUInt8(194,0):E.writeUInt8(130,0),i.byteLength<126)E.writeUInt8(i.byteLength,1);else if(i.byteLength<2**16){E.writeUInt8(126,1);let C=1;E.writeUInt8(i.byteLength>>>8&255,++C),E.writeUInt8(i.byteLength>>>0&255,++C)}else{E.writeUInt8(127,1);let C=1;E.writeUInt8(0,++C),E.writeUInt8(0,++C),E.writeUInt8(0,++C),E.writeUInt8(0,++C),E.writeUInt8(i.byteLength>>>24&255,++C),E.writeUInt8(i.byteLength>>>16&255,++C),E.writeUInt8(i.byteLength>>>8&255,++C),E.writeUInt8(i.byteLength>>>0&255,++C)}this.socket.write(c.VSBuffer.concat([E,i]))}end(){this.h=!0,this.socket.end()}l(i){if(i.byteLength!==0){for(this.b.acceptChunk(i);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const n=this.b.peek(this.j.readLen),h=n.readUInt8(0),E=(h&128)>>>7,C=(h&64)>>>6,M=n.readUInt8(1),K=(M&128)>>>7,q=M&127;this.j.state=2,this.j.readLen=2+(K?4:0)+(q===126?2:0)+(q===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(C)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const n=this.b.read(this.j.readLen),h=n.readUInt8(1),E=(h&128)>>>7;let C=h&127,M=1;C===126?C=n.readUInt8(++M)*2**8+n.readUInt8(++M):C===127&&(C=n.readUInt8(++M)*0+n.readUInt8(++M)*0+n.readUInt8(++M)*0+n.readUInt8(++M)*0+n.readUInt8(++M)*2**24+n.readUInt8(++M)*2**16+n.readUInt8(++M)*2**8+n.readUInt8(++M));let K=0;E&&(K=n.readUInt8(++M)*2**24+n.readUInt8(++M)*2**16+n.readUInt8(++M)*2**8+n.readUInt8(++M)),this.j.state=3,this.j.readLen=C,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const n=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",n),b(n,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",n),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(n,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await T.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=m;class d extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:c.VSBuffer.alloc(0)}constructor(i,n,h,E,C,M){super(),this.k=i,this.l=C,this.m=M,this.a=this.B(new T.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new T.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,n?(this.b=this.B(new f(this.k,E,h,{windowBits:15})),this.f=this.B(new p(this.k,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(i){this.g.push(i),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const i=this.g.shift();if(this.f){const n=await this.r(this.f,i);this.m(n,!0)}else this.m(i,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(i,n){return new Promise((h,E)=>{i.write(n),i.flush(C=>h(C))})}acceptFrame(i,n,h){this.h.push({data:i,isCompressed:n,isLastFrameOfMessage:h}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const i=this.h.shift();if(this.b&&i.isCompressed){const n=await this.u(this.b,i.data,i.isLastFrameOfMessage);this.l.fire(n)}else this.l.fire(i.data)}this.s=!1}}u(i,n,h){return new Promise((E,C)=>{i.write(n),h&&i.write(c.VSBuffer.fromByteArray([0,0,255,255])),i.flush(M=>E(M))})}}class f extends R.Disposable{get recordedInflateBytes(){return this.j?c.VSBuffer.concat(this.f):c.VSBuffer.alloc(0)}constructor(i,n,h,E){super(),this.h=i,this.j=n,this.a=this.B(new T.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(E),this.b.on("error",C=>{this.h.traceSocketEvent("zlibInflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.h.traceSocketEvent("zlibInflateData",C),this.g.push(c.VSBuffer.wrap(C))}),h&&(this.h.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this.b.write(h.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(i){this.j&&this.f.push(i.clone()),this.h.traceSocketEvent("zlibInflateWrite",i),this.b.write(i.buffer)}flush(i){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const n=c.VSBuffer.concat(this.g);this.g.length=0,i(n)})}}class p extends R.Disposable{constructor(i,n){super(),this.g=i,this.a=this.B(new T.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",h=>{this.g.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this.a.fire(h)}),this.b.on("data",h=>{this.g.traceSocketEvent("zlibDeflateData",h),this.f.push(c.VSBuffer.wrap(h))})}write(i){this.g.traceSocketEvent("zlibDeflateWrite",i.buffer),this.b.write(i.buffer)}flush(i){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let n=c.VSBuffer.concat(this.f);this.f.length=0,n=n.slice(0,n.byteLength-4),i(n)})}}function b(u,i){if(i===0)return;const n=u.byteLength>>>2;for(let q=0;q<n;q++){const F=u.readUInt32BE(q*4);u.writeUInt32BE(F^i,q*4)}const h=n*4,E=u.byteLength-h,C=i>>>24&255,M=i>>>16&255,K=i>>>8&255;E>=1&&u.writeUInt8(u.readUInt8(h)^C,h),E>=2&&u.writeUInt8(u.readUInt8(h+1)^M,h+1),E>=3&&u.writeUInt8(u.readUInt8(h+2)^K,h+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const S={[2]:107,[1]:103};function g(){const u=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let i;return e.XDG_RUNTIME_DIR?i=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):i=(0,k.join)(P().os.tmpdir(),`vscode-ipc-${u}.sock`),l(i),i}e.createRandomIPCHandle=g;function r(u,i,n){const h=P().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${n}-${i}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${h.substr(0,8)}-${n}-${i}.sock`):E=(0,k.join)(u,`${n}-${i}.sock`),l(E),E}e.createStaticIPCHandle=r;function l(u){const i=S[A.platform];typeof i=="number"&&u.length>=i&&console.warn(`WARNING: IPC handle "${u}" is longer than ${i} chars, try a shorter --user-data-dir`)}class s extends D.IPCServer{static b(i){const n=T.Event.fromNodeEventEmitter(i,"connection");return T.Event.map(n,h=>({protocol:new L.Protocol(new w(h,"ipc-server-connection")),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(h,"close"))}))}constructor(i){super(s.b(i)),this.d=i}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=s;function a(u){return new Promise((i,n)=>{const h=P().net.createServer();h.on("error",n),h.listen(u,()=>{h.removeListener("error",n),i(new s(h))})})}e.serve=a;function o(u,i){return new Promise((n,h)=>{const E=P().net.createConnection(u,()=>{E.removeListener("error",h),n(L.Client.fromSocket(new w(E,`ipc-client${i}`),i))});E.once("error",h)})}e.connect=o}),define(ye[163],Ce([1,0,39,11]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(R,k,A,y,D,L){if(Array.isArray(R)){let P=0;for(const w of R){const I=T(w,k,A,y,D,L);if(I===10)return I;I>P&&(P=I)}return P}else{if(typeof R=="string")return y?R==="*"?5:R===A?10:0:0;if(R){const{language:P,pattern:w,scheme:I,hasAccessToAllModels:v,notebookType:m}=R;if(!y&&!v)return 0;m&&D&&(k=D);let d=0;if(I)if(I===k.scheme)d=10;else if(I==="*")d=5;else return 0;if(P)if(P===A)d=10;else if(P==="*")d=Math.max(d,5);else return 0;if(m)if(m===L)d=10;else if(m==="*"&&L!==void 0)d=Math.max(d,5);else return 0;if(w){let f;if(typeof w=="string"?f=w:f={...w,base:(0,t.normalize)(w.base)},f===k.fsPath||(0,c.match)(f,k.fsPath))d=10;else return 0}return d}else return 0}}e.score=T}),define(ye[164],Ce([1,0,8,52,154]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(A,y,D,L){this.c=A,this.d=y,this.f=D,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(A){A.eol&&A.eol!==this.f&&(this.f=A.eol,this.h=null);const y=A.changes;for(const D of y)this.n(D.range),this.o(new t.Position(D.range.startLineNumber,D.range.startColumn),D.text);this.g=A.versionId,this.j=null}k(){if(!this.h){const A=this.f.length,y=this.d.length,D=new Uint32Array(y);for(let L=0;L<y;L++)D[L]=this.d[L].length+A;this.h=new T.PrefixSumComputer(D)}}l(A,y){this.d[A]=y,this.h&&this.h.setValue(A,this.d[A].length+this.f.length)}n(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.startLineNumber-1].substring(A.endColumn-1));return}this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.endLineNumber-1].substring(A.endColumn-1)),this.d.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this.h&&this.h.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}o(A,y){if(y.length===0)return;const D=(0,c.splitLines)(y);if(D.length===1){this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+D[0]+this.d[A.lineNumber-1].substring(A.column-1));return}D[D.length-1]+=this.d[A.lineNumber-1].substring(A.column-1),this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+D[0]);const L=new Uint32Array(D.length-1);for(let P=1;P<D.length;P++)this.d.splice(A.lineNumber+P-1,0,D[P]),L[P-1]=D[P].length+this.f.length;this.h&&this.h.insertValues(A.lineNumber,L)}}e.MirrorTextModel=R}),define(ye[165],Ce([1,0,8,151,52,36,107]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class y{constructor(p,b,S,g){this.searchString=p,this.isRegex=b,this.matchCase=S,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=D(this.searchString):p=this.searchString.indexOf(`
`)>=0;let b=null;try{b=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!b)return null;let S=!this.isRegex&&!p;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new k.SearchData(b,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}e.SearchParams=y;function D(f){if(!f||f.length===0)return!1;for(let p=0,b=f.length;p<b;p++){const S=f.charCodeAt(p);if(S===10)return!0;if(S===92){if(p++,p>=b)break;const g=f.charCodeAt(p);if(g===110||g===114||g===87)return!0}}return!1}e.isMultilineRegexSource=D;function L(f,p,b){if(!b)return new k.FindMatch(f,null);const S=[];for(let g=0,r=p.length;g<r;g++)S[g]=p[g];return new k.FindMatch(f,S)}e.createFindMatch=L;class P{constructor(p){const b=[];let S=0;for(let g=0,r=p.length;g<r;g++)p.charCodeAt(g)===10&&(b[S++]=g);this.a=b}findLineFeedCountBeforeOffset(p){const b=this.a;let S=0,g=b.length-1;if(g===-1||p<=b[0])return 0;for(;S<g;){const r=S+((g-S)/2>>0);b[r]>=p?g=r-1:b[r+1]>=p?(S=r,g=r):S=r+1}return S+1}}class w{static findMatches(p,b,S,g,r){const l=b.parseSearchRequest();return l?l.regex.multiline?this.b(p,S,new d(l.wordSeparators,l.regex),g,r):this.c(p,S,l,g,r):[]}static a(p,b,S,g,r,l){let s,a=0;g?(a=g.findLineFeedCountBeforeOffset(r),s=b+r+a):s=b+r;let o;if(g){const h=g.findLineFeedCountBeforeOffset(r+l.length)-a;o=s+l.length+h}else o=s+l.length;const u=p.getPositionAt(s),i=p.getPositionAt(o);return new R.Range(u.lineNumber,u.column,i.lineNumber,i.column)}static b(p,b,S,g,r){const l=p.getOffsetAt(b.getStartPosition()),s=p.getValueInRange(b,1),a=p.getEOL()===`\r
`?new P(s):null,o=[];let u=0,i;for(S.reset(0);i=S.next(s);)if(o[u++]=L(this.a(p,l,s,a,i.index,i[0]),i,g),u>=r)return o;return o}static c(p,b,S,g,r){const l=[];let s=0;if(b.startLineNumber===b.endLineNumber){const o=p.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return s=this.d(S,o,b.startLineNumber,b.startColumn-1,s,l,g,r),l}const a=p.getLineContent(b.startLineNumber).substring(b.startColumn-1);s=this.d(S,a,b.startLineNumber,b.startColumn-1,s,l,g,r);for(let o=b.startLineNumber+1;o<b.endLineNumber&&s<r;o++)s=this.d(S,p.getLineContent(o),o,0,s,l,g,r);if(s<r){const o=p.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);s=this.d(S,o,b.endLineNumber,0,s,l,g,r)}return l}static d(p,b,S,g,r,l,s,a){const o=p.wordSeparators;if(!s&&p.simpleSearch){const n=p.simpleSearch,h=n.length,E=b.length;let C=-h;for(;(C=b.indexOf(n,C+h))!==-1;)if((!o||m(o,b,E,C,h))&&(l[r++]=new k.FindMatch(new R.Range(S,C+1+g,S,C+1+h+g),null),r>=a))return r;return r}const u=new d(p.wordSeparators,p.regex);let i;u.reset(0);do if(i=u.next(b),i&&(l[r++]=L(new R.Range(S,i.index+1+g,S,i.index+1+i[0].length+g),i,s),r>=a))return r;while(i);return r}static findNextMatch(p,b,S,g){const r=b.parseSearchRequest();if(!r)return null;const l=new d(r.wordSeparators,r.regex);return r.regex.multiline?this.e(p,S,l,g):this.f(p,S,l,g)}static e(p,b,S,g){const r=new T.Position(b.lineNumber,1),l=p.getOffsetAt(r),s=p.getLineCount(),a=p.getValueInRange(new R.Range(r.lineNumber,r.column,s,p.getLineMaxColumn(s)),1),o=p.getEOL()===`\r
`?new P(a):null;S.reset(b.column-1);const u=S.next(a);return u?L(this.a(p,l,a,o,u.index,u[0]),u,g):b.lineNumber!==1||b.column!==1?this.e(p,new T.Position(1,1),S,g):null}static f(p,b,S,g){const r=p.getLineCount(),l=b.lineNumber,s=p.getLineContent(l),a=this.g(S,s,l,b.column,g);if(a)return a;for(let o=1;o<=r;o++){const u=(l+o-1)%r,i=p.getLineContent(u+1),n=this.g(S,i,u+1,1,g);if(n)return n}return null}static g(p,b,S,g,r){p.reset(g-1);const l=p.next(b);return l?L(new R.Range(S,l.index+1,S,l.index+1+l[0].length),l,r):null}static findPreviousMatch(p,b,S,g){const r=b.parseSearchRequest();if(!r)return null;const l=new d(r.wordSeparators,r.regex);return r.regex.multiline?this.h(p,S,l,g):this.j(p,S,l,g)}static h(p,b,S,g){const r=this.b(p,new R.Range(1,1,b.lineNumber,b.column),S,g,10*A);if(r.length>0)return r[r.length-1];const l=p.getLineCount();return b.lineNumber!==l||b.column!==p.getLineMaxColumn(l)?this.h(p,new T.Position(l,p.getLineMaxColumn(l)),S,g):null}static j(p,b,S,g){const r=p.getLineCount(),l=b.lineNumber,s=p.getLineContent(l).substring(0,b.column-1),a=this.k(S,s,l,g);if(a)return a;for(let o=1;o<=r;o++){const u=(r+l-o-1)%r,i=p.getLineContent(u+1),n=this.k(S,i,u+1,g);if(n)return n}return null}static k(p,b,S,g){let r=null,l;for(p.reset(0);l=p.next(b);)r=L(new R.Range(S,l.index+1,S,l.index+1+l[0].length),l,g);return r}}e.TextModelSearch=w;function I(f,p,b,S,g){if(S===0)return!0;const r=p.charCodeAt(S-1);if(f.get(r)!==0||r===13||r===10)return!0;if(g>0){const l=p.charCodeAt(S);if(f.get(l)!==0)return!0}return!1}function v(f,p,b,S,g){if(S+g===b)return!0;const r=p.charCodeAt(S+g);if(f.get(r)!==0||r===13||r===10)return!0;if(g>0){const l=p.charCodeAt(S+g-1);if(f.get(l)!==0)return!0}return!1}function m(f,p,b,S,g){return I(f,p,b,S,g)&&v(f,p,b,S,g)}e.isValidMatch=m;class d{constructor(p,b){this._wordSeparators=p,this.a=b,this.b=-1,this.c=0}reset(p){this.a.lastIndex=p,this.b=-1,this.c=0}next(p){const b=p.length;let S;do{if(this.b+this.c===b||(S=this.a.exec(p),!S))return null;const g=S.index,r=S[0].length;if(g===this.b&&r===this.c){if(r===0){c.getNextCodePoint(p,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=g,this.c=r,!this._wordSeparators||m(this._wordSeparators,p,b,g,r))return S}while(S);return null}}e.Searcher=d}),define(ye[120],Ce([1,0,23,12]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(T||(T={}));function R(P){for(let w=0,I=P.length;w<I;w+=4){const v=P[w+0],m=P[w+1],d=P[w+2],f=P[w+3];P[w+0]=f,P[w+1]=d,P[w+2]=m,P[w+3]=v}}function k(P){const w=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return t.isLittleEndian()||R(w),c.VSBuffer.wrap(w)}function A(P){const w=P.buffer;if(t.isLittleEndian()||R(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const I=new Uint8Array(w.byteLength);return I.set(w),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function y(P){const w=new Uint32Array(D(P));let I=0;if(w[I++]=P.id,P.type==="full")w[I++]=1,w[I++]=P.data.length,w.set(P.data,I),I+=P.data.length;else{w[I++]=2,w[I++]=P.deltas.length;for(const v of P.deltas)w[I++]=v.start,w[I++]=v.deleteCount,v.data?(w[I++]=v.data.length,w.set(v.data,I),I+=v.data.length):w[I++]=0}return k(w)}e.encodeSemanticTokensDto=y;function D(P){let w=0;if(w+=1+1,P.type==="full")w+=1+P.data.length;else{w+=1,w+=(1+1+1)*P.deltas.length;for(const I of P.deltas)I.data&&(w+=I.data.length)}return w}function L(P){const w=A(P);let I=0;const v=w[I++];if(w[I++]===1){const p=w[I++],b=w.subarray(I,I+p);return I+=p,{id:v,type:"full",data:b}}const d=w[I++],f=[];for(let p=0;p<d;p++){const b=w[I++],S=w[I++],g=w[I++];let r;g>0&&(r=w.subarray(I,I+g),I+=g),f[p]={start:b,deleteCount:S,data:r}}return{id:v,type:"delta",deltas:f}}e.decodeSemanticTokensDto=L}),define(ye[166],Ce([1,0,3,6]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class T{constructor(){this.a=new Map,this.b=new Map,this.c=new c.Emitter,this.onDidChange=this.c.event,this.d=null}fire(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,y){return this.a.set(A,y),this.fire([A]),(0,t.toDisposable)(()=>{this.a.get(A)===y&&(this.a.delete(A),this.fire([A]))})}registerFactory(A,y){this.b.get(A)?.dispose();const D=new R(this,A,y);return this.b.set(A,D),(0,t.toDisposable)(()=>{const L=this.b.get(A);!L||L!==D||(this.b.delete(A),L.dispose())})}async getOrCreate(A){const y=this.get(A);if(y)return y;const D=this.b.get(A);return!D||D.isResolved?null:(await D.resolve(),this.get(A))}get(A){return this.a.get(A)||null}isResolved(A){if(this.get(A))return!0;const D=this.b.get(A);return!!(!D||D.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=T;class R extends t.Disposable{get isResolved(){return this.c}constructor(A,y,D){super(),this.f=A,this.g=y,this.h=D,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(ye[68],Ce([1,0,50,2,36,166]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class k{constructor(h,E,C){this._tokenBrand=void 0,this.offset=h,this.type=E,this.language=C}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=k;class A{constructor(h,E){this._tokenizationResultBrand=void 0,this.tokens=h,this.endState=E}}e.TokenizationResult=A;class y{constructor(h,E){this._encodedTokenizationResultBrand=void 0,this.tokens=h,this.endState=E}}e.EncodedTokenizationResult=y;var D;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(D=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(n){const h=new Map;h.set(0,c.Codicon.symbolMethod),h.set(1,c.Codicon.symbolFunction),h.set(2,c.Codicon.symbolConstructor),h.set(3,c.Codicon.symbolField),h.set(4,c.Codicon.symbolVariable),h.set(5,c.Codicon.symbolClass),h.set(6,c.Codicon.symbolStruct),h.set(7,c.Codicon.symbolInterface),h.set(8,c.Codicon.symbolModule),h.set(9,c.Codicon.symbolProperty),h.set(10,c.Codicon.symbolEvent),h.set(11,c.Codicon.symbolOperator),h.set(12,c.Codicon.symbolUnit),h.set(13,c.Codicon.symbolValue),h.set(15,c.Codicon.symbolEnum),h.set(14,c.Codicon.symbolConstant),h.set(15,c.Codicon.symbolEnum),h.set(16,c.Codicon.symbolEnumMember),h.set(17,c.Codicon.symbolKeyword),h.set(27,c.Codicon.symbolSnippet),h.set(18,c.Codicon.symbolText),h.set(19,c.Codicon.symbolColor),h.set(20,c.Codicon.symbolFile),h.set(21,c.Codicon.symbolReference),h.set(22,c.Codicon.symbolCustomColor),h.set(23,c.Codicon.symbolFolder),h.set(24,c.Codicon.symbolTypeParameter),h.set(25,c.Codicon.account),h.set(26,c.Codicon.issues);function E(K){let q=h.get(K);return q||(console.info("No codicon found for CompletionItemKind "+K),q=c.Codicon.symbolProperty),q}n.toIcon=E;const C=new Map;C.set("method",0),C.set("function",1),C.set("constructor",2),C.set("field",3),C.set("variable",4),C.set("class",5),C.set("struct",6),C.set("interface",7),C.set("module",8),C.set("property",9),C.set("event",10),C.set("operator",11),C.set("unit",12),C.set("value",13),C.set("constant",14),C.set("enum",15),C.set("enum-member",16),C.set("enumMember",16),C.set("keyword",17),C.set("snippet",27),C.set("text",18),C.set("color",19),C.set("file",20),C.set("reference",21),C.set("customcolor",22),C.set("folder",23),C.set("type-parameter",24),C.set("typeParameter",24),C.set("account",25),C.set("issue",26);function M(K,q){let F=C.get(K);return typeof F>"u"&&!q&&(F=9),F}n.fromString=M})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(n){n[n.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var m;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(m=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(n){return n&&t.URI.isUri(n.uri)&&T.Range.isIRange(n.range)&&(T.Range.isIRange(n.originSelectionRange)||T.Range.isIRange(n.targetSelectionRange))}e.isLocationLink=p;var b;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(b=e.SymbolKind||(e.SymbolKind={}));var S;(function(n){n[n.Deprecated=1]="Deprecated"})(S=e.SymbolTag||(e.SymbolTag={}));var g;(function(n){const h=new Map;h.set(0,c.Codicon.symbolFile),h.set(1,c.Codicon.symbolModule),h.set(2,c.Codicon.symbolNamespace),h.set(3,c.Codicon.symbolPackage),h.set(4,c.Codicon.symbolClass),h.set(5,c.Codicon.symbolMethod),h.set(6,c.Codicon.symbolProperty),h.set(7,c.Codicon.symbolField),h.set(8,c.Codicon.symbolConstructor),h.set(9,c.Codicon.symbolEnum),h.set(10,c.Codicon.symbolInterface),h.set(11,c.Codicon.symbolFunction),h.set(12,c.Codicon.symbolVariable),h.set(13,c.Codicon.symbolConstant),h.set(14,c.Codicon.symbolString),h.set(15,c.Codicon.symbolNumber),h.set(16,c.Codicon.symbolBoolean),h.set(17,c.Codicon.symbolArray),h.set(18,c.Codicon.symbolObject),h.set(19,c.Codicon.symbolKey),h.set(20,c.Codicon.symbolNull),h.set(21,c.Codicon.symbolEnumMember),h.set(22,c.Codicon.symbolStruct),h.set(23,c.Codicon.symbolEvent),h.set(24,c.Codicon.symbolOperator),h.set(25,c.Codicon.symbolTypeParameter);function E(C){let M=h.get(C);return M||(console.info("No codicon found for SymbolKind "+C),M=c.Codicon.symbolProperty),M}n.toIcon=E})(g=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(h){this.value=h}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var l;(function(n){function h(E){return!E||typeof E!="object"?!1:typeof E.id=="string"&&typeof E.title=="string"}n.is=h})(l=e.Command||(e.Command={}));var s;(function(n){n[n.Collapsed=0]="Collapsed",n[n.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(n){n[n.Unresolved=0]="Unresolved",n[n.Resolved=1]="Resolved"})(a=e.CommentThreadState||(e.CommentThreadState={}));var o;(function(n){n[n.Editing=0]="Editing",n[n.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var u;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(u=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var i;(function(n){n[n.None=0]="None",n[n.Option=1]="Option",n[n.Default=2]="Default",n[n.Preferred=3]="Preferred"})(i=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[167],Ce([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(ye[121],Ce([1,0,167,12,106,16,22,150]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor($){this.c=$}hasChanged($){return this.c[$]}}e.ConfigurationChangedEvent=D;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class P{constructor($,le,Ie,Le){this.id=$,this.name=le,this.defaultValue=Ie,this.schema=Le}applyUpdate($,le){return I($,le)}compute($,le,Ie){return Ie}}class w{constructor($,le){this.newValue=$,this.didChange=le}}e.ApplyUpdateResult=w;function I(ae,$){if(typeof ae!="object"||typeof $!="object"||!ae||!$)return new w($,ae!==$);if(Array.isArray(ae)||Array.isArray($)){const Ie=Array.isArray(ae)&&Array.isArray($)&&R.equals(ae,$);return new w($,!Ie)}let le=!1;for(const Ie in $)if($.hasOwnProperty(Ie)){const Le=I(ae[Ie],$[Ie]);Le.didChange&&(ae[Ie]=Le.newValue,le=!0)}return new w(ae,le)}class v{constructor($){this.schema=void 0,this.id=$,this.name="_never_",this.defaultValue=void 0}applyUpdate($,le){return I($,le)}validate($){return this.defaultValue}}class m{constructor($,le,Ie,Le){this.id=$,this.name=le,this.defaultValue=Ie,this.schema=Le}applyUpdate($,le){return I($,le)}validate($){return typeof $>"u"?this.defaultValue:$}compute($,le,Ie){return Ie}}function d(ae,$){return typeof ae>"u"?$:ae==="false"?!1:Boolean(ae)}e.boolean=d;class f extends m{constructor($,le,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super($,le,Ie,Le)}validate($){return d($,this.defaultValue)}}function p(ae,$,le,Ie){if(typeof ae>"u")return $;let Le=parseInt(ae,10);return isNaN(Le)?$:(Le=Math.max(le,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=p;class b extends m{static clampedInt($,le,Ie,Le){return p($,le,Ie,Le)}constructor($,le,Ie,Le,Be,Xe=void 0){typeof Xe<"u"&&(Xe.type="integer",Xe.default=Ie,Xe.minimum=Le,Xe.maximum=Be),super($,le,Ie,Xe),this.minimum=Le,this.maximum=Be}validate($){return b.clampedInt($,this.defaultValue,this.minimum,this.maximum)}}class S extends m{static clamp($,le,Ie){return $<le?le:$>Ie?Ie:$}static float($,le){if(typeof $=="number")return $;if(typeof $>"u")return le;const Ie=parseFloat($);return isNaN(Ie)?le:Ie}constructor($,le,Ie,Le,Be){typeof Be<"u"&&(Be.type="number",Be.default=Ie),super($,le,Ie,Be),this.validationFn=Le}validate($){return this.validationFn(S.float($,this.defaultValue))}}class g extends m{static string($,le){return typeof $!="string"?le:$}constructor($,le,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super($,le,Ie,Le)}validate($){return g.string($,this.defaultValue)}}function r(ae,$,le){return typeof ae!="string"||le.indexOf(ae)===-1?$:ae}e.stringSet=r;class l extends m{constructor($,le,Ie,Le,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.enum=Le,Be.default=Ie),super($,le,Ie,Be),this.c=Le}validate($){return r($,this.defaultValue,this.c)}}class s extends P{constructor($,le,Ie,Le,Be,Xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Be,Ze.default=Le),super($,le,Ie,Ze),this.c=Be,this.d=Xe}validate($){return typeof $!="string"?this.defaultValue:this.c.indexOf($)===-1?this.defaultValue:this.d($)}}function a(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate($){switch($){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute($,le,Ie){return Ie===0?$.accessibilitySupport:Ie}}class u extends P{constructor(){const $={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",$,{"editor.comments.insertSpace":{type:"boolean",default:$.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:$.ignoreEmptyLines,description:c.localize(5,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{insertSpace:d(le.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(le.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function n(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E(ae){switch(ae){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function C(ae){switch(ae){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class M extends v{constructor(){super(135)}compute($,le,Ie){const Le=["monaco-editor"];return le.get(36)&&Le.push(le.get(36)),$.extraEditorClassName&&Le.push($.extraEditorClassName),le.get(70)==="default"?Le.push("mouse-default"):le.get(70)==="copy"&&Le.push("mouse-copy"),le.get(105)&&Le.push("showUnused"),le.get(133)&&Le.push("showDeprecated"),Le.join(" ")}}class K extends f{constructor(){super(34,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute($,le,Ie){return Ie&&$.emptySelectionClipboard}}class q extends P{constructor(){const $={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",$,{"editor.find.cursorMoveOnType":{type:"boolean",default:$.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:$.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:$.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:$.globalFindClipboard,description:c.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:$.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:$.loop,description:c.localize(18,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{cursorMoveOnType:d(le.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof $.seedSearchStringFromSelection=="boolean"?$.seedSearchStringFromSelection?"always":"never":r(le.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof $.autoFindInSelection=="boolean"?$.autoFindInSelection?"always":"never":r(le.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(le.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(le.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(le.loop,this.defaultValue.loop)}}}class F extends P{constructor(){super(48,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?F.OFF:$==="true"?F.ON:$:Boolean($)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class B extends P{constructor(){super(51,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?B.OFF:$==="true"?B.TRANSLATE:$:Boolean($)?B.TRANSLATE:B.OFF}compute($,le,Ie){return $.fontInfo.fontVariationSettings}}e.EditorFontVariations=B,B.OFF="normal",B.TRANSLATE="translate";class O extends v{constructor(){super(47)}compute($,le,Ie){return $.fontInfo}}class U extends m{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate($){const le=S.float($,this.defaultValue);return le===0?e.EDITOR_FONT_DEFAULTS.fontSize:S.clamp(le,6,100)}compute($,le,Ie){return $.fontInfo.fontSize}}class z extends P{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate($){return $==="normal"||$==="bold"?$:String(b.clampedInt($,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class j extends P{constructor(){const $={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},le={type:"string",enum:["peek","gotoAndPeek","goto"],default:$.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",$,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...le},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...le},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...le},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...le},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...le},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:$.alternativeDefinitionCommand,enum:Ie,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:$.alternativeTypeDefinitionCommand,enum:Ie,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:$.alternativeDeclarationCommand,enum:Ie,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:$.alternativeImplementationCommand,enum:Ie,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:$.alternativeReferenceCommand,enum:Ie,description:c.localize(41,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{multiple:r(le.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:le.multipleDefinitions??r(le.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:le.multipleTypeDefinitions??r(le.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:le.multipleDeclarations??r(le.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:le.multipleImplementations??r(le.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:le.multipleReferences??r(le.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(le.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(le.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(le.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(le.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(le.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ue extends P{constructor(){const $={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",$,{"editor.hover.enabled":{type:"boolean",default:$.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:$.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:$.sticky,description:c.localize(44,null)},"editor.hover.above":{type:"boolean",default:$.above,description:c.localize(45,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{enabled:d(le.enabled,this.defaultValue.enabled),delay:b.clampedInt(le.delay,this.defaultValue.delay,0,1e4),sticky:d(le.sticky,this.defaultValue.sticky),above:d(le.above,this.defaultValue.above)}}}var V;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class _ extends v{constructor(){super(138)}compute($,le,Ie){return _.computeLayout(le,{memory:$.memory,outerWidth:$.outerWidth,outerHeight:$.outerHeight,isDominatedByLongLines:$.isDominatedByLongLines,lineHeight:$.fontInfo.lineHeight,viewLineCount:$.viewLineCount,lineNumbersDigitCount:$.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:$.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:$.fontInfo.maxDigitWidth,pixelRatio:$.pixelRatio})}static computeContainedMinimapLineCount($){const le=$.height/$.lineHeight,Ie=Math.floor($.paddingTop/$.lineHeight);let Le=Math.floor($.paddingBottom/$.lineHeight);$.scrollBeyondLastLine&&(Le=Math.max(Le,le-1));const Be=(Ie+$.viewLineCount+Le)/($.pixelRatio*$.height),Xe=Math.floor($.viewLineCount/Be);return{typicalViewportLineCount:le,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:Be,minimapLineCount:Xe}}static c($,le){const Ie=$.outerWidth,Le=$.outerHeight,Be=$.pixelRatio;if(!$.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Xe=le.stableMinimapLayoutInput,Ze=Xe&&$.outerHeight===Xe.outerHeight&&$.lineHeight===Xe.lineHeight&&$.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&$.pixelRatio===Xe.pixelRatio&&$.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&$.paddingTop===Xe.paddingTop&&$.paddingBottom===Xe.paddingBottom&&$.minimap.enabled===Xe.minimap.enabled&&$.minimap.side===Xe.minimap.side&&$.minimap.size===Xe.minimap.size&&$.minimap.showSlider===Xe.minimap.showSlider&&$.minimap.renderCharacters===Xe.minimap.renderCharacters&&$.minimap.maxColumn===Xe.minimap.maxColumn&&$.minimap.scale===Xe.minimap.scale&&$.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&$.isViewportWrapping===Xe.isViewportWrapping,gt=$.lineHeight,mt=$.typicalHalfwidthCharacterWidth,lt=$.scrollBeyondLastLine,ot=$.minimap.renderCharacters;let rt=Be>=2?Math.round($.minimap.scale*2):$.minimap.scale;const kt=$.minimap.maxColumn,Tt=$.minimap.size,Nt=$.minimap.side,pt=$.verticalScrollbarWidth,Dt=$.viewLineCount,$t=$.remainingWidth,Ft=$.isViewportWrapping,xe=ot?2:3;let Mt=Math.floor(Be*Le);const Ut=Mt/Be;let Bt=!1,wt=!1,Pt=xe*rt,Re=rt/Be,Oe=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeforeFirstLine:St,extraLinesBeyondLastLine:Et,desiredRatio:Lt,minimapLineCount:vt}=_.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:lt,paddingTop:$.paddingTop,paddingBottom:$.paddingBottom,height:Le,lineHeight:gt,pixelRatio:Be});if(Dt/vt>1)Bt=!0,wt=!0,rt=1,Pt=1,Re=rt/Be;else{let ft=!1,Gt=rt+1;if(Tt==="fit"){const jt=Math.ceil((St+Dt+Et)*Pt);Ft&&Ze&&$t<=le.stableFitRemainingWidth?(ft=!0,Gt=le.stableFitMaxMinimapScale):ft=jt>Mt}if(Tt==="fill"||ft){Bt=!0;const jt=rt;Pt=Math.min(gt*Be,Math.max(1,Math.floor(1/Lt))),Ft&&Ze&&$t<=le.stableFitRemainingWidth&&(Gt=le.stableFitMaxMinimapScale),rt=Math.min(Gt,Math.max(1,Math.floor(Pt/xe))),rt>jt&&(Oe=Math.min(2,rt/jt)),Re=rt/Be/Oe,Mt=Math.ceil(Math.max(tt,St+Dt+Et)*Pt),Ft?(le.stableMinimapLayoutInput=$,le.stableFitRemainingWidth=$t,le.stableFitMaxMinimapScale=rt):(le.stableMinimapLayoutInput=null,le.stableFitRemainingWidth=0)}}}const Se=Math.floor(kt*Re),re=Math.min(Se,Math.max(0,Math.floor(($t-pt-2)*Re/(mt+Re)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor(Be*re);const ze=Ne/Be;Ne=Math.floor(Ne*Oe);const _e=ot?1:2,Ve=Nt==="left"?0:Ie-re-pt;return{renderMinimap:_e,minimapLeft:Ve,minimapWidth:re,minimapHeightIsEditorHeight:Bt,minimapIsSampling:wt,minimapScale:rt,minimapLineHeight:Pt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:ze,minimapCanvasOuterHeight:Ut}}static computeLayout($,le){const Ie=le.outerWidth|0,Le=le.outerHeight|0,Be=le.lineHeight|0,Xe=le.lineNumbersDigitCount|0,Ze=le.typicalHalfwidthCharacterWidth,gt=le.maxDigitWidth,mt=le.pixelRatio,lt=le.viewLineCount,ot=$.get(130),rt=ot==="inherit"?$.get(129):ot,kt=rt==="inherit"?$.get(125):rt,Tt=$.get(128),Nt=le.isDominatedByLongLines,pt=$.get(54),Dt=$.get(64).renderType!==0,$t=$.get(65),Ft=$.get(99),xe=$.get(80),Mt=$.get(69),Ut=$.get(97),Bt=Ut.verticalScrollbarSize,wt=Ut.verticalHasArrows,Pt=Ut.arrowSize,Re=Ut.horizontalScrollbarSize,Oe=$.get(40),Se=$.get(104)!=="never";let re=$.get(62);Oe&&Se&&(re+=16);let Ne=0;if(Dt){const Qt=Math.max(Xe,$t);Ne=Math.round(Qt*gt)}let ze=0;pt&&(ze=Be);let _e=0,Ve=_e+ze,tt=Ve+Ne,St=tt+re;const Et=Ie-ze-Ne-re;let Lt=!1,vt=!1,It=-1;rt==="inherit"&&Nt?(Lt=!0,vt=!0):kt==="on"||kt==="bounded"?vt=!0:kt==="wordWrapColumn"&&(It=Tt);const ft=_.c({outerWidth:Ie,outerHeight:Le,lineHeight:Be,typicalHalfwidthCharacterWidth:Ze,pixelRatio:mt,scrollBeyondLastLine:Ft,paddingTop:xe.top,paddingBottom:xe.bottom,minimap:Mt,verticalScrollbarWidth:Bt,viewLineCount:lt,remainingWidth:Et,isViewportWrapping:vt},le.memory||new L);ft.renderMinimap!==0&&ft.minimapLeft===0&&(_e+=ft.minimapWidth,Ve+=ft.minimapWidth,tt+=ft.minimapWidth,St+=ft.minimapWidth);const Gt=Et-ft.minimapWidth,jt=Math.max(1,Math.floor((Gt-Bt-2)/Ze)),yt=wt?Pt:0;return vt&&(It=Math.max(1,jt),kt==="bounded"&&(It=Math.min(It,Tt))),{width:Ie,height:Le,glyphMarginLeft:_e,glyphMarginWidth:ze,lineNumbersLeft:Ve,lineNumbersWidth:Ne,decorationsLeft:tt,decorationsWidth:re,contentLeft:St,contentWidth:Gt,minimap:ft,viewportColumn:jt,isWordWrapMinified:Lt,isViewportWrapping:vt,wrappingColumn:It,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:Re,overviewRuler:{top:yt,width:Bt,height:Le-2*yt,right:0}}}}e.EditorLayoutInfoComputer=_;class J extends P{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(46,null),c.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(48,null)}})}validate($){return r($,"simple",["simple","advanced"])}compute($,le,Ie){return le.get(2)===2?"advanced":Ie}}class ne extends P{constructor(){const $={enabled:!0};super(61,"lightbulb",$,{"editor.lightbulb.enabled":{type:"boolean",default:$.enabled,description:c.localize(49,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:d($.enabled,this.defaultValue.enabled)}}}class ee extends P{constructor(){const $={enabled:!1,maxLineCount:5};super(109,"stickyScroll",$,{"editor.stickyScroll.enabled":{type:"boolean",default:$.enabled,description:c.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:$.maxLineCount,minimum:1,maximum:10,description:c.localize(51,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{enabled:d(le.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(le.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class X extends P{constructor(){const $={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",$,{"editor.inlayHints.enabled":{type:"string",default:$.enabled,description:c.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(53,null),c.localize(54,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),c.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:$.fontSize,markdownDescription:c.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:$.fontFamily,markdownDescription:c.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:$.padding,description:c.localize(59,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return typeof le.enabled=="boolean"&&(le.enabled=le.enabled?"on":"off"),{enabled:r(le.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(le.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(le.fontFamily,this.defaultValue.fontFamily),padding:d(le.padding,this.defaultValue.padding)}}}class G extends P{constructor(){super(62,"lineDecorationsWidth",10)}validate($){return typeof $=="string"&&/^\d+(\.\d+)?ch$/.test($)?-parseFloat($.substring(0,$.length-2)):b.clampedInt($,this.defaultValue,0,1e3)}compute($,le,Ie){return Ie<0?b.clampedInt(-Ie*$.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class de extends S{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,$=>S.clamp($,0,150),{markdownDescription:c.localize(60,null)})}compute($,le,Ie){return $.fontInfo.lineHeight}}class be extends P{constructor(){const $={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",$,{"editor.minimap.enabled":{type:"boolean",default:$.enabled,description:c.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:$.autohide,description:c.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(63,null),c.localize(64,null),c.localize(65,null)],default:$.size,description:c.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:$.side,description:c.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:$.showSlider,description:c.localize(68,null)},"editor.minimap.scale":{type:"number",default:$.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:$.renderCharacters,description:c.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:$.maxColumn,description:c.localize(71,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{enabled:d(le.enabled,this.defaultValue.enabled),autohide:d(le.autohide,this.defaultValue.autohide),size:r(le.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(le.side,this.defaultValue.side,["right","left"]),showSlider:r(le.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(le.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(le.scale,1,1,3),maxColumn:b.clampedInt(le.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ee(ae){return ae==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Pe extends P{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(73,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{top:b.clampedInt(le.top,0,0,1e3),bottom:b.clampedInt(le.bottom,0,0,1e3)}}}class Fe extends P{constructor(){const $={enabled:!0,cycle:!0};super(81,"parameterHints",$,{"editor.parameterHints.enabled":{type:"boolean",default:$.enabled,description:c.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:$.cycle,description:c.localize(75,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{enabled:d(le.enabled,this.defaultValue.enabled),cycle:d(le.cycle,this.defaultValue.cycle)}}}class se extends v{constructor(){super(136)}compute($,le,Ie){return $.pixelRatio}}class oe extends P{constructor(){const $={other:"on",comments:"off",strings:"off"},le=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(76,null),c.localize(77,null),c.localize(78,null)]}];super(84,"quickSuggestions",$,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:le,default:$.strings,description:c.localize(79,null)},comments:{anyOf:le,default:$.comments,description:c.localize(80,null)},other:{anyOf:le,default:$.other,description:c.localize(81,null)}},default:$,markdownDescription:c.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=$}validate($){if(typeof $=="boolean"){const mt=$?"on":"off";return{comments:mt,strings:mt,other:mt}}if(!$||typeof $!="object")return this.defaultValue;const{other:le,comments:Ie,strings:Le}=$,Be=["on","inline","off"];let Xe,Ze,gt;return typeof le=="boolean"?Xe=le?"on":"off":Xe=r(le,this.defaultValue.other,Be),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=r(Ie,this.defaultValue.comments,Be),typeof Le=="boolean"?gt=Le?"on":"off":gt=r(Le,this.defaultValue.strings,Be),{other:Xe,comments:Ze,strings:gt}}}var fe;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Z extends P{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(83,null),c.localize(84,null),c.localize(85,null),c.localize(86,null)],default:"on",description:c.localize(87,null)})}validate($){let le=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof $<"u"&&(typeof $=="function"?(le=4,Ie=$):$==="interval"?le=3:$==="relative"?le=2:$==="on"?le=1:le=0),{renderType:le,renderFn:Ie}}}function ce(ae){const $=ae.get(92);return $==="editable"?ae.get(86):$!=="on"}e.filterValidationDecorations=ce;class ie extends P{constructor(){const $=[],le={type:"number",description:c.localize(88,null)};super(96,"rulers",$,{type:"array",items:{anyOf:[le,{type:["object"],properties:{column:le,color:{type:"string",description:c.localize(89,null),format:"color-hex"}}}]},default:$,description:c.localize(90,null)})}validate($){if(Array.isArray($)){const le=[];for(const Ie of $)if(typeof Ie=="number")le.push({column:b.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;le.push({column:b.clampedInt(Le.column,0,0,1e4),color:Le.color})}return le.sort((Ie,Le)=>Ie.column-Le.column),le}return this.defaultValue}}function N(ae,$){if(typeof ae!="string")return $;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends P{constructor(){const $={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",$,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(91,null),c.localize(92,null),c.localize(93,null)],default:"auto",description:c.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(95,null),c.localize(96,null),c.localize(97,null)],default:"auto",description:c.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:$.verticalScrollbarSize,description:c.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:$.horizontalScrollbarSize,description:c.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:$.scrollByPage,description:c.localize(101,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$,Ie=b.clampedInt(le.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=b.clampedInt(le.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(le.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(le.vertical,this.defaultValue.vertical),horizontal:N(le.horizontal,this.defaultValue.horizontal),useShadows:d(le.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(le.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(le.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(le.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(le.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:b.clampedInt(le.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:b.clampedInt(le.verticalSliderSize,Le,0,1e3),scrollByPage:d(le.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends P{constructor(){const $={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",$,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.nonBasicASCII,description:c.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:$.invisibleCharacters,description:c.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:$.ambiguousCharacters,description:c.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeComments,description:c.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeStrings,description:c.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:$.allowedCharacters,description:c.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:$.allowedLocales,description:c.localize(108,null)}})}applyUpdate($,le){let Ie=!1;le.allowedCharacters&&$&&(k.equals($.allowedCharacters,le.allowedCharacters)||($={...$,allowedCharacters:le.allowedCharacters},Ie=!0)),le.allowedLocales&&$&&(k.equals($.allowedLocales,le.allowedLocales)||($={...$,allowedLocales:le.allowedLocales},Ie=!0));const Le=super.applyUpdate($,le);return Ie?new w(Le.newValue,!0):Le}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{nonBasicASCII:Ae(le.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(le.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(le.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(le.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(le.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c($.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c($.allowedLocales,this.defaultValue.allowedLocales)}}c($,le){if(typeof $!="object"||!$)return le;const Ie={};for(const[Le,Be]of Object.entries($))Be===!0&&(Ie[Le]=!0);return Ie}}class Y extends P{constructor(){const $={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",$,{"editor.inlineSuggest.enabled":{type:"boolean",default:$.enabled,description:c.localize(109,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{enabled:d(le.enabled,this.defaultValue.enabled),mode:r(le.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class he extends P{constructor(){const $={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",$,{"editor.bracketPairColorization.enabled":{type:"boolean",default:$.enabled,markdownDescription:c.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:$.independentColorPoolPerBracketType,description:c.localize(111,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{enabled:d(le.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(le.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends P{constructor(){const $={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",$,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(112,null),c.localize(113,null),c.localize(114,null)],default:$.bracketPairs,description:c.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(116,null),c.localize(117,null),c.localize(118,null)],default:$.bracketPairsHorizontal,description:c.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:$.highlightActiveBracketPair,description:c.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:$.indentation,description:c.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(122,null),c.localize(123,null),c.localize(124,null)],default:$.highlightActiveIndentation,description:c.localize(125,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{bracketPairs:Ae(le.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(le.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(le.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(le.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(le.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(ae,$,le){const Ie=le.indexOf(ae);return Ie===-1?$:le[Ie]}class pe extends P{constructor(){const $={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",$,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(126,null),c.localize(127,null)],default:$.insertMode,description:c.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:$.filterGraceful,description:c.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:$.localityBonus,description:c.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:$.shareSuggestSelections,markdownDescription:c.localize(131,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(132,null),c.localize(133,null),c.localize(134,null),c.localize(135,null)],default:$.selectionMode,markdownDescription:c.localize(136,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:$.snippetsPreventQuickSuggestions,description:c.localize(137,null)},"editor.suggest.showIcons":{type:"boolean",default:$.showIcons,description:c.localize(138,null)},"editor.suggest.showStatusBar":{type:"boolean",default:$.showStatusBar,description:c.localize(139,null)},"editor.suggest.preview":{type:"boolean",default:$.preview,description:c.localize(140,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:$.showInlineDetails,description:c.localize(141,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(142,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(143,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(144,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(145,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(146,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(147,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(148,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(149,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(150,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(151,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(166,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(167,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const le=$;return{insertMode:r(le.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(le.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(le.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(le.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(le.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(le.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(le.showIcons,this.defaultValue.showIcons),showStatusBar:d(le.showStatusBar,this.defaultValue.showStatusBar),preview:d(le.preview,this.defaultValue.preview),previewMode:r(le.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(le.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(le.showMethods,this.defaultValue.showMethods),showFunctions:d(le.showFunctions,this.defaultValue.showFunctions),showConstructors:d(le.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(le.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(le.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(le.showFields,this.defaultValue.showFields),showVariables:d(le.showVariables,this.defaultValue.showVariables),showClasses:d(le.showClasses,this.defaultValue.showClasses),showStructs:d(le.showStructs,this.defaultValue.showStructs),showInterfaces:d(le.showInterfaces,this.defaultValue.showInterfaces),showModules:d(le.showModules,this.defaultValue.showModules),showProperties:d(le.showProperties,this.defaultValue.showProperties),showEvents:d(le.showEvents,this.defaultValue.showEvents),showOperators:d(le.showOperators,this.defaultValue.showOperators),showUnits:d(le.showUnits,this.defaultValue.showUnits),showValues:d(le.showValues,this.defaultValue.showValues),showConstants:d(le.showConstants,this.defaultValue.showConstants),showEnums:d(le.showEnums,this.defaultValue.showEnums),showEnumMembers:d(le.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(le.showKeywords,this.defaultValue.showKeywords),showWords:d(le.showWords,this.defaultValue.showWords),showColors:d(le.showColors,this.defaultValue.showColors),showFiles:d(le.showFiles,this.defaultValue.showFiles),showReferences:d(le.showReferences,this.defaultValue.showReferences),showFolders:d(le.showFolders,this.defaultValue.showFolders),showTypeParameters:d(le.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(le.showSnippets,this.defaultValue.showSnippets),showUsers:d(le.showUsers,this.defaultValue.showUsers),showIssues:d(le.showIssues,this.defaultValue.showIssues)}}}class De extends P{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(174,null),default:!0,type:"boolean"}})}validate($){return!$||typeof $!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d($.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends v{constructor(){super(137)}compute($,le,Ie){return le.get(86)?!0:$.tabFocusMode}}var je;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(je=e.WrappingIndent||(e.WrappingIndent={}));class Ge extends P{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(175,null),c.localize(176,null),c.localize(177,null),c.localize(178,null)],description:c.localize(179,null),default:"same"}})}validate($){switch($){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute($,le,Ie){return le.get(2)===2?0:Ie}}class et extends v{constructor(){super(139)}compute($,le,Ie){const Le=le.get(138);return{isDominatedByLongLines:$.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class Qe extends P{constructor(){const $={enabled:!0};super(33,"dropIntoEditor",$,{"editor.dropIntoEditor.enabled":{type:"boolean",default:$.enabled,markdownDescription:c.localize(180,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:d($.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?st:t.isLinux?ht:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var it;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.autoClosingBrackets=5]="autoClosingBrackets",ae[ae.autoClosingDelete=6]="autoClosingDelete",ae[ae.autoClosingOvertype=7]="autoClosingOvertype",ae[ae.autoClosingQuotes=8]="autoClosingQuotes",ae[ae.autoIndent=9]="autoIndent",ae[ae.automaticLayout=10]="automaticLayout",ae[ae.autoSurround=11]="autoSurround",ae[ae.bracketPairColorization=12]="bracketPairColorization",ae[ae.guides=13]="guides",ae[ae.codeLens=14]="codeLens",ae[ae.codeLensFontFamily=15]="codeLensFontFamily",ae[ae.codeLensFontSize=16]="codeLensFontSize",ae[ae.colorDecorators=17]="colorDecorators",ae[ae.colorDecoratorsLimit=18]="colorDecoratorsLimit",ae[ae.columnSelection=19]="columnSelection",ae[ae.comments=20]="comments",ae[ae.contextmenu=21]="contextmenu",ae[ae.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=23]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=25]="cursorStyle",ae[ae.cursorSurroundingLines=26]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=28]="cursorWidth",ae[ae.disableLayerHinting=29]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",ae[ae.domReadOnly=31]="domReadOnly",ae[ae.dragAndDrop=32]="dragAndDrop",ae[ae.dropIntoEditor=33]="dropIntoEditor",ae[ae.emptySelectionClipboard=34]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=36]="extraEditorClassName",ae[ae.fastScrollSensitivity=37]="fastScrollSensitivity",ae[ae.find=38]="find",ae[ae.fixedOverflowWidgets=39]="fixedOverflowWidgets",ae[ae.folding=40]="folding",ae[ae.foldingStrategy=41]="foldingStrategy",ae[ae.foldingHighlight=42]="foldingHighlight",ae[ae.foldingImportsByDefault=43]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=44]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=46]="fontFamily",ae[ae.fontInfo=47]="fontInfo",ae[ae.fontLigatures=48]="fontLigatures",ae[ae.fontSize=49]="fontSize",ae[ae.fontWeight=50]="fontWeight",ae[ae.fontVariations=51]="fontVariations",ae[ae.formatOnPaste=52]="formatOnPaste",ae[ae.formatOnType=53]="formatOnType",ae[ae.glyphMargin=54]="glyphMargin",ae[ae.gotoLocation=55]="gotoLocation",ae[ae.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",ae[ae.hover=57]="hover",ae[ae.inDiffEditor=58]="inDiffEditor",ae[ae.inlineSuggest=59]="inlineSuggest",ae[ae.letterSpacing=60]="letterSpacing",ae[ae.lightbulb=61]="lightbulb",ae[ae.lineDecorationsWidth=62]="lineDecorationsWidth",ae[ae.lineHeight=63]="lineHeight",ae[ae.lineNumbers=64]="lineNumbers",ae[ae.lineNumbersMinChars=65]="lineNumbersMinChars",ae[ae.linkedEditing=66]="linkedEditing",ae[ae.links=67]="links",ae[ae.matchBrackets=68]="matchBrackets",ae[ae.minimap=69]="minimap",ae[ae.mouseStyle=70]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=72]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=74]="multiCursorModifier",ae[ae.multiCursorPaste=75]="multiCursorPaste",ae[ae.multiCursorLimit=76]="multiCursorLimit",ae[ae.occurrencesHighlight=77]="occurrencesHighlight",ae[ae.overviewRulerBorder=78]="overviewRulerBorder",ae[ae.overviewRulerLanes=79]="overviewRulerLanes",ae[ae.padding=80]="padding",ae[ae.parameterHints=81]="parameterHints",ae[ae.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=84]="quickSuggestions",ae[ae.quickSuggestionsDelay=85]="quickSuggestionsDelay",ae[ae.readOnly=86]="readOnly",ae[ae.renameOnType=87]="renameOnType",ae[ae.renderControlCharacters=88]="renderControlCharacters",ae[ae.renderFinalNewline=89]="renderFinalNewline",ae[ae.renderLineHighlight=90]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=92]="renderValidationDecorations",ae[ae.renderWhitespace=93]="renderWhitespace",ae[ae.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",ae[ae.roundedSelection=95]="roundedSelection",ae[ae.rulers=96]="rulers",ae[ae.scrollbar=97]="scrollbar",ae[ae.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=99]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=100]="scrollPredominantAxis",ae[ae.selectionClipboard=101]="selectionClipboard",ae[ae.selectionHighlight=102]="selectionHighlight",ae[ae.selectOnLineNumbers=103]="selectOnLineNumbers",ae[ae.showFoldingControls=104]="showFoldingControls",ae[ae.showUnused=105]="showUnused",ae[ae.snippetSuggestions=106]="snippetSuggestions",ae[ae.smartSelect=107]="smartSelect",ae[ae.smoothScrolling=108]="smoothScrolling",ae[ae.stickyScroll=109]="stickyScroll",ae[ae.stickyTabStops=110]="stickyTabStops",ae[ae.stopRenderingLineAfter=111]="stopRenderingLineAfter",ae[ae.suggest=112]="suggest",ae[ae.suggestFontSize=113]="suggestFontSize",ae[ae.suggestLineHeight=114]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",ae[ae.suggestSelection=116]="suggestSelection",ae[ae.tabCompletion=117]="tabCompletion",ae[ae.tabIndex=118]="tabIndex",ae[ae.unicodeHighlighting=119]="unicodeHighlighting",ae[ae.unusualLineTerminators=120]="unusualLineTerminators",ae[ae.useShadowDOM=121]="useShadowDOM",ae[ae.useTabStops=122]="useTabStops",ae[ae.wordBreak=123]="wordBreak",ae[ae.wordSeparators=124]="wordSeparators",ae[ae.wordWrap=125]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=128]="wordWrapColumn",ae[ae.wordWrapOverride1=129]="wordWrapOverride1",ae[ae.wordWrapOverride2=130]="wordWrapOverride2",ae[ae.wrappingIndent=131]="wrappingIndent",ae[ae.wrappingStrategy=132]="wrappingStrategy",ae[ae.showDeprecated=133]="showDeprecated",ae[ae.inlayHints=134]="inlayHints",ae[ae.editorClassName=135]="editorClassName",ae[ae.pixelRatio=136]="pixelRatio",ae[ae.tabFocusMode=137]="tabFocusMode",ae[ae.layoutInfo=138]="layoutInfo",ae[ae.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(181,null)})),acceptSuggestionOnEnter:Me(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(182,null),""],markdownDescription:c.localize(183,null)})),accessibilitySupport:Me(new o),accessibilityPageSize:Me(new b(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(184,null),tags:["accessibility"]})),ariaLabel:Me(new g(4,"ariaLabel",c.localize(185,null))),autoClosingBrackets:Me(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(186,null),c.localize(187,null),""],description:c.localize(188,null)})),autoClosingDelete:Me(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(189,null),""],description:c.localize(190,null)})),autoClosingOvertype:Me(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(191,null),""],description:c.localize(192,null)})),autoClosingQuotes:Me(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(193,null),c.localize(194,null),""],description:c.localize(195,null)})),autoIndent:Me(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[c.localize(196,null),c.localize(197,null),c.localize(198,null),c.localize(199,null),c.localize(200,null)],description:c.localize(201,null)})),automaticLayout:Me(new f(10,"automaticLayout",!1)),autoSurround:Me(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(202,null),c.localize(203,null),c.localize(204,null),""],description:c.localize(205,null)})),bracketPairColorization:Me(new he),bracketPairGuides:Me(new we),stickyTabStops:Me(new f(110,"stickyTabStops",!1,{description:c.localize(206,null)})),codeLens:Me(new f(14,"codeLens",!0,{description:c.localize(207,null)})),codeLensFontFamily:Me(new g(15,"codeLensFontFamily","",{description:c.localize(208,null)})),codeLensFontSize:Me(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(209,null)})),colorDecorators:Me(new f(17,"colorDecorators",!0,{description:c.localize(210,null)})),colorDecoratorsLimit:Me(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(211,null)})),columnSelection:Me(new f(19,"columnSelection",!1,{description:c.localize(212,null)})),comments:Me(new u),contextmenu:Me(new f(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new f(22,"copyWithSyntaxHighlighting",!0,{description:c.localize(213,null)})),cursorBlinking:Me(new s(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],n,{description:c.localize(214,null)})),cursorSmoothCaretAnimation:Me(new l(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(215,null),c.localize(216,null),c.localize(217,null)],description:c.localize(218,null)})),cursorStyle:Me(new s(25,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:c.localize(219,null)})),cursorSurroundingLines:Me(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(220,null)})),cursorSurroundingLinesStyle:Me(new l(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(221,null),c.localize(222,null)],description:c.localize(223,null)})),cursorWidth:Me(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(224,null)})),disableLayerHinting:Me(new f(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new f(30,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new f(31,"domReadOnly",!1)),dragAndDrop:Me(new f(32,"dragAndDrop",!0,{description:c.localize(225,null)})),emptySelectionClipboard:Me(new K),dropIntoEditor:Me(new Qe),stickyScroll:Me(new ee),experimentalWhitespaceRendering:Me(new l(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(226,null),c.localize(227,null),c.localize(228,null)],description:c.localize(229,null)})),extraEditorClassName:Me(new g(36,"extraEditorClassName","")),fastScrollSensitivity:Me(new S(37,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:c.localize(230,null)})),find:Me(new q),fixedOverflowWidgets:Me(new f(39,"fixedOverflowWidgets",!1)),folding:Me(new f(40,"folding",!0,{description:c.localize(231,null)})),foldingStrategy:Me(new l(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(232,null),c.localize(233,null)],description:c.localize(234,null)})),foldingHighlight:Me(new f(42,"foldingHighlight",!0,{description:c.localize(235,null)})),foldingImportsByDefault:Me(new f(43,"foldingImportsByDefault",!1,{description:c.localize(236,null)})),foldingMaximumRegions:Me(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(237,null)})),unfoldOnClickAfterEndOfLine:Me(new f(45,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(238,null)})),fontFamily:Me(new g(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(239,null)})),fontInfo:Me(new O),fontLigatures2:Me(new F),fontSize:Me(new U),fontWeight:Me(new z),fontVariations:Me(new B),formatOnPaste:Me(new f(52,"formatOnPaste",!1,{description:c.localize(240,null)})),formatOnType:Me(new f(53,"formatOnType",!1,{description:c.localize(241,null)})),glyphMargin:Me(new f(54,"glyphMargin",!0,{description:c.localize(242,null)})),gotoLocation:Me(new j),hideCursorInOverviewRuler:Me(new f(56,"hideCursorInOverviewRuler",!1,{description:c.localize(243,null)})),hover:Me(new ue),inDiffEditor:Me(new f(58,"inDiffEditor",!1)),letterSpacing:Me(new S(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>S.clamp(ae,-5,20),{description:c.localize(244,null)})),lightbulb:Me(new ne),lineDecorationsWidth:Me(new G),lineHeight:Me(new de),lineNumbers:Me(new Z),lineNumbersMinChars:Me(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new f(66,"linkedEditing",!1,{description:c.localize(245,null)})),links:Me(new f(67,"links",!0,{description:c.localize(246,null)})),matchBrackets:Me(new l(68,"matchBrackets","always",["always","near","never"],{description:c.localize(247,null)})),minimap:Me(new be),mouseStyle:Me(new l(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new S(71,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:c.localize(248,null)})),mouseWheelZoom:Me(new f(72,"mouseWheelZoom",!1,{markdownDescription:c.localize(249,null)})),multiCursorMergeOverlapping:Me(new f(73,"multiCursorMergeOverlapping",!0,{description:c.localize(250,null)})),multiCursorModifier:Me(new s(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ee,{markdownEnumDescriptions:[c.localize(251,null),c.localize(252,null)],markdownDescription:c.localize(253,null)})),multiCursorPaste:Me(new l(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(254,null),c.localize(255,null)],markdownDescription:c.localize(256,null)})),multiCursorLimit:Me(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(257,null)})),occurrencesHighlight:Me(new f(77,"occurrencesHighlight",!0,{description:c.localize(258,null)})),overviewRulerBorder:Me(new f(78,"overviewRulerBorder",!0,{description:c.localize(259,null)})),overviewRulerLanes:Me(new b(79,"overviewRulerLanes",3,0,3)),padding:Me(new Pe),parameterHints:Me(new Fe),peekWidgetDefaultFocus:Me(new l(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(260,null),c.localize(261,null)],description:c.localize(262,null)})),definitionLinkOpensInPeek:Me(new f(83,"definitionLinkOpensInPeek",!1,{description:c.localize(263,null)})),quickSuggestions:Me(new oe),quickSuggestionsDelay:Me(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(264,null)})),readOnly:Me(new f(86,"readOnly",!1)),renameOnType:Me(new f(87,"renameOnType",!1,{description:c.localize(265,null),markdownDeprecationMessage:c.localize(266,null)})),renderControlCharacters:Me(new f(88,"renderControlCharacters",!0,{description:c.localize(267,null),restricted:!0})),renderFinalNewline:Me(new l(89,"renderFinalNewline",t.isLinux?"dimmed":"on",["off","on","dimmed"],{description:c.localize(268,null)})),renderLineHighlight:Me(new l(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(269,null)],description:c.localize(270,null)})),renderLineHighlightOnlyWhenFocus:Me(new f(91,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(271,null)})),renderValidationDecorations:Me(new l(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new l(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(272,null),c.localize(273,null),c.localize(274,null),""],description:c.localize(275,null)})),revealHorizontalRightPadding:Me(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new f(95,"roundedSelection",!0,{description:c.localize(276,null)})),rulers:Me(new ie),scrollbar:Me(new H),scrollBeyondLastColumn:Me(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(277,null)})),scrollBeyondLastLine:Me(new f(99,"scrollBeyondLastLine",!0,{description:c.localize(278,null)})),scrollPredominantAxis:Me(new f(100,"scrollPredominantAxis",!0,{description:c.localize(279,null)})),selectionClipboard:Me(new f(101,"selectionClipboard",!0,{description:c.localize(280,null),included:t.isLinux})),selectionHighlight:Me(new f(102,"selectionHighlight",!0,{description:c.localize(281,null)})),selectOnLineNumbers:Me(new f(103,"selectOnLineNumbers",!0)),showFoldingControls:Me(new l(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(282,null),c.localize(283,null),c.localize(284,null)],description:c.localize(285,null)})),showUnused:Me(new f(105,"showUnused",!0,{description:c.localize(286,null)})),showDeprecated:Me(new f(133,"showDeprecated",!0,{description:c.localize(287,null)})),inlayHints:Me(new X),snippetSuggestions:Me(new l(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(288,null),c.localize(289,null),c.localize(290,null),c.localize(291,null)],description:c.localize(292,null)})),smartSelect:Me(new De),smoothScrolling:Me(new f(108,"smoothScrolling",!1,{description:c.localize(293,null)})),stopRenderingLineAfter:Me(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new pe),inlineSuggest:Me(new Y),suggestFontSize:Me(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(294,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(295,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new f(115,"suggestOnTriggerCharacters",!0,{description:c.localize(296,null)})),suggestSelection:Me(new l(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(297,null),c.localize(298,null),c.localize(299,null)],description:c.localize(300,null)})),tabCompletion:Me(new l(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null)],description:c.localize(304,null)})),tabIndex:Me(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new Q),unusualLineTerminators:Me(new l(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(305,null),c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)})),useShadowDOM:Me(new f(121,"useShadowDOM",!0)),useTabStops:Me(new f(122,"useTabStops",!0,{description:c.localize(309,null)})),wordBreak:Me(new l(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(310,null),c.localize(311,null)],description:c.localize(312,null)})),wordSeparators:Me(new g(124,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:c.localize(313,null)})),wordWrap:Me(new l(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(314,null),c.localize(315,null),c.localize(316,null),c.localize(317,null)],description:c.localize(318,null)})),wordWrapBreakAfterCharacters:Me(new g(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new g(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(319,null)})),wordWrapOverride1:Me(new l(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new l(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new M),pixelRatio:Me(new se),tabFocusMode:Me(new ke),layoutInfo:Me(new _),wrappingInfo:Me(new et),wrappingIndent:Me(new Ge),wrappingStrategy:Me(new J)}}),define(ye[168],Ce([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[169],Ce([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[170],Ce([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[171],Ce([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[172],Ce([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(ye[173],Ce([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(ye[174],Ce([19,20]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[175],Ce([19,20]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(ye[176],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[177],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[178],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[179],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[180],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[181],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[182],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[183],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[184],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[185],Ce([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(ye[186],Ce([19,20]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(ye[187],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[188],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[189],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[190],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[191],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[192],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[193],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[194],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[195],Ce([1,0,9]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(R,k){this.a.set(R,k)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const k in R.contributes){const A=this.a.get(k);if(!A)continue;const y=R.contributes[k],D=Array.isArray(y)?y:[y];try{A(D,R.activationEvents)}catch(L){(0,c.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ye[196],Ce([1,0,24,38,170,316]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(f){return f=f.trim(),f==="*"||k.test(f)}e.isValidVersionStr=y;function D(f){if(!y(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=f.match(k);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=D;function L(f){if(!f)return null;const p=f.majorBase,b=f.majorMustEqual,S=f.minorBase;let g=f.minorMustEqual;const r=f.patchBase;let l=f.patchMustEqual;f.hasCaret&&(p===0||(g=!1),l=!1);let s=0;if(f.preRelease){const a=A.exec(f.preRelease);if(a){const[,o,u,i]=a;s=Date.UTC(Number(o),Number(u)-1,Number(i))}}return{majorBase:p,majorMustEqual:b,minorBase:S,minorMustEqual:g,patchBase:r,patchMustEqual:l,isMinimum:f.hasGreaterEquals,notBefore:s}}e.normalizeVersion=L;function P(f,p,b){let S;typeof f=="string"?S=L(D(f)):S=f;let g;p instanceof Date?g=p.getTime():typeof p=="string"&&(g=new Date(p).getTime());let r;if(typeof b=="string"?r=L(D(b)):r=b,!S||!r)return!1;const l=S.majorBase,s=S.minorBase,a=S.patchBase;let o=r.majorBase,u=r.minorBase,i=r.patchBase;const n=r.notBefore;let h=r.majorMustEqual,E=r.minorMustEqual,C=r.patchMustEqual;return r.isMinimum?l>o?!0:l<o?!1:s>u?!0:s<u||g&&g<n?!1:a>=i:(l===1&&o===0&&(!h||!E||!C)&&(o=1,u=0,i=0,h=!0,E=!1,C=!1),l<o?!1:l>o?!h:s<u?!1:s>u?!E:a<i?!1:a>i?!C:!(g&&g<n))}e.isValidVersion=P;function w(f,p,b,S,g){const r=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return r.push([t.default.Error,T.localize(0,null)]),r;if(typeof S.name!="string")return r.push([t.default.Error,T.localize(1,null,"name")]),r;if(typeof S.version!="string")return r.push([t.default.Error,T.localize(2,null,"version")]),r;if(!S.engines)return r.push([t.default.Error,T.localize(3,null,"engines")]),r;if(typeof S.engines.vscode!="string")return r.push([t.default.Error,T.localize(4,null,"engines.vscode")]),r;if(typeof S.extensionDependencies<"u"&&!d(S.extensionDependencies))return r.push([t.default.Error,T.localize(5,null,"extensionDependencies")]),r;if(typeof S.activationEvents<"u"){if(!d(S.activationEvents))return r.push([t.default.Error,T.localize(6,null,"activationEvents")]),r;if(typeof S.main>"u"&&typeof S.browser>"u")return r.push([t.default.Error,T.localize(7,null,"activationEvents","main")]),r}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&r.push([t.default.Warning,T.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return r.push([t.default.Error,T.localize(9,null,"main")]),r;{const a=(0,c.joinPath)(b,S.main);(0,c.isEqualOrParent)(a,b)||r.push([t.default.Warning,T.localize(10,null,a.path,b.path)])}if(typeof S.activationEvents>"u")return r.push([t.default.Error,T.localize(11,null,"activationEvents","main")]),r}if(typeof S.browser<"u"){if(typeof S.browser!="string")return r.push([t.default.Error,T.localize(12,null,"browser")]),r;{const a=(0,c.joinPath)(b,S.browser);(0,c.isEqualOrParent)(a,b)||r.push([t.default.Warning,T.localize(13,null,a.path,b.path)])}if(typeof S.activationEvents>"u")return r.push([t.default.Error,T.localize(14,null,"activationEvents","browser")]),r}if(!R.valid(S.version))return r.push([t.default.Error,T.localize(15,null)]),r;const l=[];if(!I(f,p,S,g,l))for(const a of l)r.push([t.default.Error,a]);return r}e.validateExtensionManifest=w;function I(f,p,b,S,g){return S||typeof b.main>"u"&&typeof b.browser>"u"?!0:m(f,p,b.engines.vscode,g)}e.isValidExtensionVersion=I;function v(f,p,b){return f==="*"||m(p,b,f)}e.isEngineValid=v;function m(f,p,b,S=[]){const g=L(D(b));if(!g)return S.push(T.localize(16,null,b)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return S.push(T.localize(17,null,b)),!1}else if(!g.majorMustEqual)return S.push(T.localize(18,null,b)),!1;return P(f,p,g)?!0:(S.push(T.localize(19,null,f,b)),!1)}function d(f){if(!Array.isArray(f))return!1;for(let p=0,b=f.length;p<b;p++)if(typeof f[p]!="string")return!1;return!0}}),define(ye[122],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(T,R=[],k=!1){this.ctor=T,this.staticArguments=R,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=c}),define(ye[89],Ce([1,0,122]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var T;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(T=e.InstantiationType||(e.InstantiationType={}));function R(A,y,D){y instanceof c.SyncDescriptor||(y=new c.SyncDescriptor(y,[],Boolean(D))),t.push([A,y])}e.registerSingleton=R;function k(){return t}e.getSingletonServiceDescriptors=k}),define(ye[197],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(R,k){this.key=R,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=c;class t{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const k of this.a.values())k.outgoing.size===0&&R.push(k);return R}insertEdge(R,k){const A=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(k);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(R){const k=this.b(R);this.a.delete(k);for(const A of this.a.values())A.outgoing.delete(k),A.incoming.delete(k)}lookupOrInsertNode(R){const k=this.b(R);let A=this.a.get(k);return A||(A=new c(k,R),this.a.set(k,A)),A}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[k,A]of this.a)R.push(`${k}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,k]of this.a){const A=new Set([R]),y=this.c(k,A);if(y)return y}}c(R,k){for(const[A,y]of R.outgoing){if(k.has(A))return[...k,A].join(" -> ");k.add(A);const D=this.c(y,k);if(D)return D;k.delete(A)}}}e.Graph=t}),define(ye[4],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=A})(c=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function t(k,A,y){A[c.DI_TARGET]===A?A[c.DI_DEPENDENCIES].push({id:k,index:y}):(A[c.DI_DEPENDENCIES]=[{id:k,index:y}],A[c.DI_TARGET]=A)}function T(k){if(c.serviceIds.has(k))return c.serviceIds.get(k);const A=function(y,D,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(A,y,L)};return A.toString=()=>k,c.serviceIds.set(k,A),A}e.createDecorator=T;function R(k){return k}e.refineServiceDecorator=R}),define(ye[53],Ce([1,0,10,2,4]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function R(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationOverrides=R;function k(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var A;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function D(f,p){const b=Object.create(null);for(const S in f)L(b,S,f[S],p);return b}e.toValuesTree=D;function L(f,p,b,S){const g=p.split("."),r=g.pop();let l=f;for(let s=0;s<g.length;s++){const a=g[s];let o=l[a];switch(typeof o){case"undefined":o=l[a]=Object.create(null);break;case"object":break;default:S(`Ignoring ${p} as ${g.slice(0,s+1).join(".")} is ${JSON.stringify(o)}`);return}l=o}if(typeof l=="object"&&l!==null)try{l[r]=b}catch{S(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(l)}`)}else S(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=L;function P(f,p){const b=p.split(".");w(f,b)}e.removeFromValueTree=P;function w(f,p){const b=p.shift();if(p.length===0){delete f[b];return}if(Object.keys(f).indexOf(b)!==-1){const S=f[b];typeof S=="object"&&!Array.isArray(S)&&(w(S,p),Object.keys(S).length===0&&delete f[b])}}function I(f,p,b){function S(l,s){let a=l;for(const o of s){if(typeof a!="object"||a===null)return;a=a[o]}return a}const g=p.split("."),r=S(f,g);return typeof r>"u"?b:r}e.getConfigurationValue=I;function v(f,p,b){Object.keys(p).forEach(S=>{S!=="__proto__"&&(S in f?c.isObject(f[S])&&c.isObject(p[S])?v(f[S],p[S],b):b&&(f[S]=p[S]):f[S]=p[S])})}e.merge=v;function m(f,p,b){const S=f.inspect(p),g=f.inspect(b);return typeof S.userValue<"u"||typeof S.workspaceValue<"u"||typeof S.workspaceFolderValue<"u"?S.value:typeof g.userValue<"u"||typeof g.workspaceValue<"u"||typeof g.workspaceFolderValue<"u"?g.value:S.defaultValue}e.getMigratedSettingValue=m;function d(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(ye[54],Ce([1,0,12,8,4]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",c.isMacintosh),R.set("isLinux",c.isLinux),R.set("isWindows",c.isWindows),R.set("isWeb",c.isWeb),R.set("isMacNative",c.isMacintosh&&!c.isWeb),R.set("isEdge",c.isEdge),R.set("isFirefox",c.isFirefox),R.set("isChrome",c.isChrome),R.set("isSafari",c.isSafari);const k=Object.prototype.hasOwnProperty;var A;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return P.INSTANCE}static true(){return w.INSTANCE}static has(F){return I.create(F)}static equals(F,B){return v.create(F,B)}static notEquals(F,B){return f.create(F,B)}static regex(F,B){return s.create(F,B)}static in(F,B){return m.create(F,B)}static notIn(F,B){return d.create(F,B)}static not(F){return p.create(F)}static and(...F){return u.create(F,null,!0)}static or(...F){return i.create(F,null,!0)}static greater(F,B){return S.create(F,B)}static greaterEquals(F,B){return g.create(F,B)}static smaller(F,B){return r.create(F,B)}static smallerEquals(F,B){return l.create(F,B)}static deserialize(F,B=!1){if(!!F)return this.c(F,B)}static c(F,B){const O=F.split("||");return i.create(O.map(U=>this.d(U,B)),null,!0)}static d(F,B){const O=F.split("&&");return u.create(O.map(U=>this.f(U,B)),null,!0)}static f(F,B){if(F=F.trim(),F.indexOf("!=")>=0){const O=F.split("!=");return f.create(O[0].trim(),this.g(O[1],B))}if(F.indexOf("==")>=0){const O=F.split("==");return v.create(O[0].trim(),this.g(O[1],B))}if(F.indexOf("=~")>=0){const O=F.split("=~");return s.create(O[0].trim(),this.h(O[1],B))}if(F.indexOf(" not in ")>=0){const O=F.split(" not in ");return d.create(O[0].trim(),this.g(O[1],B))}if(F.indexOf(" in ")>=0){const O=F.split(" in ");return m.create(O[0].trim(),this.g(O[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const O=F.split(">=");return g.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const O=F.split(">");return S.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const O=F.split("<=");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const O=F.split("<");return r.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(F)?p.create(F.substr(1).trim()):I.create(F)}static g(F,B){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const O=/^'([^']*)'$/.exec(F);return O?O[1].trim():F}static h(F,B){if((0,t.isFalsyOrWhitespace)(F)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const O=F.indexOf("/"),U=F.lastIndexOf("/");if(O===U||O<0){if(B)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}const z=F.slice(O+1,U),j=F[U+1]==="i"?"i":"";try{return new RegExp(z,j)}catch(ue){if(B)throw new Error(`bad regexp-value '${F}', parse error: ${ue}`);return console.warn(`bad regexp-value '${F}', parse error: ${ue}`),null}}}e.ContextKeyExpr=y;function D(q,F){const B=q?q.substituteConstants():void 0,O=F?F.substituteConstants():void 0;return!B&&!O?!0:!B||!O?!1:B.equals(O)}e.expressionsAreEqualWithConstantSubstitution=D;function L(q,F){return q.cmp(F)}class P{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class w{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class I{static create(F,B=null){const O=R.get(F);return typeof O=="boolean"?O?w.INSTANCE:P.INSTANCE:new I(F,B)}constructor(F,B){this.key=F,this.c=B,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:h(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=R.get(this.key);return typeof F=="boolean"?F?w.INSTANCE:P.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=p.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=I;class v{static create(F,B,O=null){if(typeof B=="boolean")return B?I.create(F,O):p.create(F,O);const U=R.get(F);return typeof U=="boolean"?B===(U?"true":"false")?w.INSTANCE:P.INSTANCE:new v(F,B,O)}constructor(F,B,O){this.c=F,this.d=B,this.f=O,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=R.get(this.c);if(typeof F=="boolean"){const B=F?"true":"false";return this.d===B?w.INSTANCE:P.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=v;class m{static create(F,B){return new m(F,B)}constructor(F,B){this.d=F,this.f=B,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:E(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const B=F.getValue(this.f),O=F.getValue(this.d);return Array.isArray(B)?B.includes(O):typeof O=="string"&&typeof B=="object"&&B!==null?k.call(B,O):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=m;class d{static create(F,B){return new d(F,B)}constructor(F,B){this.d=F,this.f=B,this.type=11,this.c=m.create(F,B)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=d;class f{static create(F,B,O=null){if(typeof B=="boolean")return B?p.create(F,O):I.create(F,O);const U=R.get(F);return typeof U=="boolean"?B===(U?"true":"false")?P.INSTANCE:w.INSTANCE:new f(F,B,O)}constructor(F,B,O){this.c=F,this.d=B,this.f=O,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=R.get(this.c);if(typeof F=="boolean"){const B=F?"true":"false";return this.d===B?P.INSTANCE:w.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=f;class p{static create(F,B=null){const O=R.get(F);return typeof O=="boolean"?O?P.INSTANCE:w.INSTANCE:new p(F,B)}constructor(F,B){this.c=F,this.d=B,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:h(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=R.get(this.c);return typeof F=="boolean"?F?P.INSTANCE:w.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.ContextKeyNotExpr=p;function b(q,F){if(typeof q=="string"){const B=parseFloat(q);isNaN(B)||(q=B)}return typeof q=="string"||typeof q=="number"?F(q):P.INSTANCE}class S{static create(F,B,O=null){return b(B,U=>new S(F,U,O))}constructor(F,B,O){this.c=F,this.d=B,this.f=O,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=S;class g{static create(F,B,O=null){return b(B,U=>new g(F,U,O))}constructor(F,B,O){this.c=F,this.d=B,this.f=O,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=g;class r{static create(F,B,O=null){return b(B,U=>new r(F,U,O))}constructor(F,B,O){this.c=F,this.d=B,this.f=O,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=r;class l{static create(F,B,O=null){return b(B,U=>new l(F,U,O))}constructor(F,B,O){this.c=F,this.d=B,this.f=O,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:E(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=l;class s{static create(F,B){return new s(F,B)}constructor(F,B){this.d=F,this.f=B,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const B=this.f?this.f.source:"",O=F.f?F.f.source:"";return B<O?-1:B>O?1:0}equals(F){if(F.type===this.type){const B=this.f?this.f.source:"",O=F.f?F.f.source:"";return this.d===F.d&&B===O}return!1}substituteConstants(){return this}evaluate(F){const B=F.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=a.create(this)),this.c}}e.ContextKeyRegexExpr=s;class a{static create(F){return new a(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new a(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=a;function o(q){let F=null;for(let B=0,O=q.length;B<O;B++){const U=q[B].substituteConstants();if(q[B]!==U&&F===null){F=[];for(let z=0;z<B;z++)F[z]=q[z]}F!==null&&(F[B]=U)}return F===null?q:F}class u{static create(F,B,O){return u.d(F,B,O)}constructor(F,B){this.expr=F,this.c=B,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const U=L(this.expr[B],F.expr[B]);if(U!==0)return U}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(F.expr[B]))return!1;return!0}return!1}substituteConstants(){const F=o(this.expr);return F===this.expr?this:u.create(F,this.c,!1)}evaluate(F){for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].evaluate(F))return!1;return!0}static d(F,B,O){const U=[];let z=!1;for(const j of F)if(!!j){if(j.type===1){z=!0;continue}if(j.type===0)return P.INSTANCE;if(j.type===6){U.push(...j.expr);continue}U.push(j)}if(U.length===0&&z)return w.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(L);for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];for(;U.length>1;){const j=U[U.length-1];if(j.type!==9)break;U.pop();const ue=U.pop(),V=U.length===0,_=i.create(j.expr.map(J=>u.create([J,ue],null,O)),null,V);_&&(U.push(_),U.sort(L))}if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let ue=j+1;ue<U.length;ue++)if(U[j].negate().equals(U[ue]))return P.INSTANCE;if(U.length===1)return U[0]}return new u(U,B)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const B of this.expr)F.push(...B.keys());return F}map(F){return new u(this.expr.map(B=>B.map(F)),null)}negate(){if(!this.c){const F=[];for(const B of this.expr)F.push(B.negate());this.c=i.create(F,this,!0)}return this.c}}class i{static create(F,B,O){return i.d(F,B,O)}constructor(F,B){this.expr=F,this.c=B,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const U=L(this.expr[B],F.expr[B]);if(U!==0)return U}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(F.expr[B]))return!1;return!0}return!1}substituteConstants(){const F=o(this.expr);return F===this.expr?this:i.create(F,this.c,!1)}evaluate(F){for(let B=0,O=this.expr.length;B<O;B++)if(this.expr[B].evaluate(F))return!0;return!1}static d(F,B,O){let U=[],z=!1;if(F){for(let j=0,ue=F.length;j<ue;j++){const V=F[j];if(!!V){if(V.type===0){z=!0;continue}if(V.type===1)return w.INSTANCE;if(V.type===9){U=U.concat(V.expr);continue}U.push(V)}}if(U.length===0&&z)return P.INSTANCE;U.sort(L)}if(U.length!==0){if(U.length===1)return U[0];for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let ue=j+1;ue<U.length;ue++)if(U[j].negate().equals(U[ue]))return w.INSTANCE;if(U.length===1)return U[0]}return new i(U,B)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const B of this.expr)F.push(...B.keys());return F}map(F){return new i(this.expr.map(B=>B.map(F)),null)}negate(){if(!this.c){const F=[];for(const B of this.expr)F.push(B.negate());for(;F.length>1;){const B=F.shift(),O=F.shift(),U=[];for(const z of K(B))for(const j of K(O))U.push(u.create([z,j],null,!1));F.unshift(i.create(U,null,!1))}this.c=i.create(F,this,!0)}return this.c}}class n extends I{static all(){return n.d.values()}constructor(F,B,O){super(F,null),this.f=B,typeof O=="object"?n.d.push({...O,key:F}):O!==!0&&n.d.push({key:F,description:O,type:B!=null?typeof B:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return v.create(this.key,F)}notEqualsTo(F){return f.create(this.key,F)}}e.RawContextKey=n,n.d=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService");function h(q,F){return q<F?-1:q>F?1:0}function E(q,F,B,O){return q<B?-1:q>B?1:F<O?-1:F>O?1:0}function C(q,F){if(q.type===0||F.type===1)return!0;if(q.type===9)return F.type===9?M(q.expr,F.expr):!1;if(F.type===9){for(const B of F.expr)if(C(q,B))return!0;return!1}if(q.type===6){if(F.type===6)return M(F.expr,q.expr);for(const B of q.expr)if(C(B,F))return!0;return!1}return q.equals(F)}e.implies=C;function M(q,F){let B=0,O=0;for(;B<q.length&&O<F.length;){const U=q[B].cmp(F[O]);if(U<0)return!1;U===0&&B++,O++}return B===q.length}function K(q){return q.type===9?q.expr:[q]}}),define(ye[198],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[123],Ce([1,0,169,4]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function T(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function R(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function k(f,p){switch(f){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function A(f,p){return p==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(f,p,b){return A(p,b)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===b?!0:D(b).includes(f)}e.isTargetPlatformCompatible=y;function D(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=L;var P;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var w;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(w=e.SortOrder||(e.SortOrder={}));var I;(function(f){f.Install="install",f.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var v;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var m;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(p,b){super(p),this.code=b,this.name=b}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,c.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,c.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ye[199],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,c.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,c.createDecorator)("externalTerminal")}),define(ye[200],Ce([1,0,46,17,11,12,108,29,116,171,199]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=D.localize(0,null);class w{async getDefaultTerminalForPlatforms(){return{windows:I.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class I extends w{openTerminal(S,g){return this.spawnTerminal(c,S,y.getWindowsShell(),g)}spawnTerminal(S,g,r,l){const s=g.windowsExec||I.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const a=T.basename(s).toLowerCase();if(a==="cmder"||a==="cmder.exe")return S.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return s.indexOf(" ")>=0&&o.push('""'),o.push(s),(a==="wt"||a==="wt.exe")&&o.push("-d ."),new Promise((u,i)=>{const n=d(process),h=S.spawn(r,o,{cwd:l,env:n});h.on("error",i),h.on("exit",()=>u())})}runInTerminal(S,g,r,l,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:I.getDefaultTerminalWindows();return new Promise((o,u)=>{const i=`"${g} - ${P}"`,n=`""${r.join('" "')}" & pause"`,h=["/c","start",i,"/wait",a,"/c",n],E=Object.assign({},d(process),l);Object.keys(E).filter(K=>E[K]===null).forEach(K=>delete E[K]);const C={cwd:g,env:E,windowsVerbatimArguments:!0};c.spawn(I.b,h,C).on("error",K=>{u(f(K))}),o(void 0)})}static getDefaultTerminalWindows(){if(!I.d){const S=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");I.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${S?"Sysnative":"System32"}\\cmd.exe`}return I.d}}e.WindowsExternalTerminalService=I,I.b="cmd.exe";class v extends w{openTerminal(S,g){return this.spawnTerminal(c,S,g)}runInTerminal(S,g,r,l,s){const a=s.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((o,u)=>{if(a===L.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const i=a===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${i}.scpt`).fsPath,"-t",S||P,"-w",g];for(const M of r)h.push("-a"),h.push(M);if(l){const M=Object.assign({},d(process),l);for(const K in M){const q=M[K];q===null?(h.push("-u"),h.push(K)):(h.push("-e"),h.push(`${K}=${q}`))}}let E="";const C=c.spawn(v.b,h);C.on("error",M=>{u(f(M))}),C.stderr.on("data",M=>{E+=M.toString()}),C.on("exit",M=>{if(M===0)o(void 0);else if(E){const K=E.split(`
`,1);u(new Error(K[0]))}else u(new Error(D.localize(1,null,i,M)))})}else u(new Error(D.localize(2,null,a)))})}spawnTerminal(S,g,r){const l=g.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,a)=>{const o=["-a",l];r&&o.push(r);const u=d(process),i=S.spawn("/usr/bin/open",o,{cwd:r,env:u});i.on("error",a),i.on("exit",()=>s())})}}e.MacExternalTerminalService=v,v.b="/usr/bin/osascript";class m extends w{openTerminal(S,g){return this.spawnTerminal(c,S,g)}runInTerminal(S,g,r,l,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((o,u)=>{const i=[];a.then(n=>{n.indexOf("gnome-terminal")>=0?i.push("-x"):i.push("-e"),i.push("bash"),i.push("-c");const h=`${p(r)}; echo; read -p "${m.b}" -n1;`;i.push(`''${h}''`);const E=Object.assign({},d(process),l);Object.keys(E).filter(q=>E[q]===null).forEach(q=>delete E[q]);const C={cwd:g,env:E};let M="";const K=c.spawn(n,i,C);K.on("error",q=>{u(f(q))}),K.stderr.on("data",q=>{M+=q.toString()}),K.on("exit",q=>{if(q===0)o(void 0);else if(M){const F=M.split(`
`,1);u(new Error(F[0]))}else u(new Error(D.localize(4,null,n,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!R.isLinux)m.d=Promise.resolve("xterm");else{const S=await A.Promises.exists("/etc/debian_version");m.d=new Promise(g=>{S?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return m.d}spawnTerminal(S,g,r){const l=g.linuxExec?Promise.resolve(g.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{l.then(o=>{const u=d(process),i=S.spawn(o,[],{cwd:r,env:u});i.on("error",a),i.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=m,m.b=D.localize(3,null);function d(b){const S={...b.env};return(0,k.sanitizeProcessEnvironment)(S),S}function f(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(D.localize(5,null,b.path)):b}function p(b){let S="";for(const g of b)g.indexOf(" ")>=0?S+='"'+g+'"':S+=g,S+=" ";return S}}),define(ye[40],Ce([1,0,66,11,8,10,2,172,4,12]),function(te,e,c,t,T,R,k,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function L(V){return V.create===!0}e.isFileOpenForWriteOptions=L;var P;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var w;(function(V){V[V.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var I;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=v;function m(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=m;function d(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=d;function f(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function p(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=p;function b(V){return v(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var S;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(_,J){super(_),this.code=J}}e.FileSystemProviderError=g;function r(V,_){const J=new g(V.toString(),_);return s(J,_),J}e.createFileSystemProviderError=r;function l(V){return V||r((0,A.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=l;function s(V,_){return V.name=_?`${_} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=s;function a(V){if(!V)return S.Unknown;if(V instanceof g)return V.code;const _=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!_)return S.Unknown;switch(_[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=a;function o(V){if(V instanceof C)return V.fileOperationResult;switch(a(V)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var u;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(u=e.FileOperation||(e.FileOperation={}));class i{constructor(_,J,ne){this.resource=_,this.operation=J,this.target=ne}isOperation(_){return this.operation===_}}e.FileOperationEvent=i;var n;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class h{constructor(_,J){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ne=new Map;for(const ee of _){const X=ne.get(ee.type);switch(X?X.push([ee.resource,ee]):ne.set(ee.type,[[ee.resource,ee]]),ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}}for(const[ee,X]of ne)switch(ee){case 1:this.a=c.TernarySearchTree.forUris(()=>J),this.a.fill(X);break;case 0:this.b=c.TernarySearchTree.forUris(()=>J),this.b.fill(X);break;case 2:this.c=c.TernarySearchTree.forUris(()=>J),this.c.fill(X);break}}contains(_,...J){return this.d(_,{includeChildren:!1},...J)}affects(_,...J){return this.d(_,{includeChildren:!0},...J)}d(_,J,...ne){if(!_)return!1;const ee=ne.length>0;return!!((!ee||ne.includes(1))&&(this.a?.get(_)||J.includeChildren&&this.a?.findSuperstr(_))||(!ee||ne.includes(0))&&(this.b?.get(_)||J.includeChildren&&this.b?.findSuperstr(_))||(!ee||ne.includes(2))&&(this.c?.findSubstr(_)||J.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=h;function E(V,_,J){return!V||!_||V===_||_.length>V.length?!1:(_.charAt(_.length-1)!==t.sep&&(_+=t.sep),J?(0,T.startsWithIgnoreCase)(V,_):V.indexOf(_)===0)}e.isParent=E;class C extends Error{constructor(_,J,ne){super(_),this.fileOperationResult=J,this.options=ne}}e.FileOperationError=C;class M extends C{constructor(_,J,ne,ee){super(_,J,ee),this.fileOperationResult=J,this.size=ne}}e.TooLargeFileOperationError=M;class K extends C{constructor(_,J,ne){super(_,2,ne),this.stat=J}}e.NotModifiedSinceFileOperationError=K;var q;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=B;async function O(V,_){if(!_.hasProvider(k.URI.from({scheme:V.scheme})))return new Promise(J=>{const ne=_.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===V.scheme&&ee.added&&(ne.dispose(),J())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(_){return(0,R.isNumber)(_)||(_=0),_<U.KB?(0,A.localize)(1,null,_.toFixed(0)):_<U.MB?(0,A.localize)(2,null,(_/U.KB).toFixed(2)):_<U.GB?(0,A.localize)(3,null,(_/U.MB).toFixed(2)):_<U.TB?(0,A.localize)(4,null,(_/U.GB).toFixed(2)):(0,A.localize)(5,null,(_/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var z;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(z=e.Arch||(e.Arch={}));function j(V){return{maxFileSize:V===0?300*U.MB:16*U.GB,maxHeapSize:V===0?700*U.MB:2*700*U.MB}}e.getPlatformFileLimits=j;function ue(V){return D.isWeb?V?10*U.MB:50*U.MB:V?100*U.MB:1024*U.MB}e.getLargeFileConfirmationLimit=ue}),define(ye[90],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...T){this.a=new Map;for(const[R,k]of T)this.set(R,k)}set(T,R){const k=this.a.get(T);return this.a.set(T,R),k}has(T){return this.a.has(T)}get(T){return this.a.get(T)}}e.ServiceCollection=c}),define(ye[201],Ce([1,0,14,9,6,122,197,4,90,65]),function(te,e,c,t,T,R,k,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class P extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class w{constructor(d=new y.ServiceCollection,f=!1,p,b=L){this.f=d,this.g=f,this.h=p,this.i=b,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=b?p?._globalGraph??new k.Graph(S=>S):void 0}createChild(d){return new w(d,this.g,this,this.i)}invokeFunction(d,...f){const p=v.traceInvocation(this.i,d);let b=!1;try{return d({get:g=>{if(b)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const r=this.m(g,p);if(!r)throw new Error(`[invokeFunction] unknown service '${g}'`);return r}},...f)}finally{b=!0,p.stop()}}createInstance(d,...f){let p,b;return d instanceof R.SyncDescriptor?(p=v.traceCreation(this.i,d.ctor),b=this.j(d.ctor,d.staticArguments.concat(f),p)):(p=v.traceCreation(this.i,d),b=this.j(d,f,p)),p.stop(),b}j(d,f=[],p){const b=A._util.getServiceDependencies(d).sort((r,l)=>r.index-l.index),S=[];for(const r of b){const l=this.m(r.id,p);l||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${r.id}.`,!1),S.push(l)}const g=b.length>0?b[0].index:f.length;if(f.length!==g){console.trace(`[createInstance] First service dependency of ${d.name} at position ${g+1} conflicts with ${f.length} static arguments`);const r=g-f.length;r>0?f=f.concat(new Array(r)):f=f.slice(0,g)}return Reflect.construct(d,f.concat(S))}k(d,f){if(this.f.get(d)instanceof R.SyncDescriptor)this.f.set(d,f);else if(this.h)this.h.k(d,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const f=this.f.get(d);return!f&&this.h?this.h.l(d):f}m(d,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const p=this.l(d);return p instanceof R.SyncDescriptor?this.q(d,p,f.branch(d,!0)):(f.branch(d,!1),p)}q(d,f,p){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,f,p)}finally{this.o.delete(d)}}r(d,f,p){const b=new k.Graph(r=>r.id.toString());let S=0;const g=[{id:d,desc:f,_trace:p}];for(;g.length;){const r=g.pop();if(b.lookupOrInsertNode(r),S++>1e3)throw new P(b);for(const l of A._util.getServiceDependencies(r.desc.ctor)){const s=this.l(l.id);if(s||this.u(`[createInstance] ${d} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(l.id)),s instanceof R.SyncDescriptor){const a={id:l.id,desc:s,_trace:r._trace.branch(l.id,!0)};b.insertEdge(r,a),g.push(a)}}}for(;;){const r=b.roots();if(r.length===0){if(!b.isEmpty())throw new P(b);break}for(const{data:l}of r){if(this.l(l.id)instanceof R.SyncDescriptor){const a=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,a)}b.removeNode(l)}}return this.l(d)}s(d,f,p=[],b,S){if(this.f.get(d)instanceof R.SyncDescriptor)return this.t(d,f,p,b,S);if(this.h)return this.h.s(d,f,p,b,S);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(d,f,p=[],b,S){if(b){const g=new w(void 0,this.g,this,this.i);g.c=String(d);const r=new Map,l=new c.IdleValue(()=>{const s=g.j(f,p,S);for(const[a,o]of r){const u=s[a];if(typeof u=="function")for(const i of o)u.apply(s,i)}return r.clear(),s});return new Proxy(Object.create(null),{get(s,a){if(!l.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let i=r.get(a);return i||(i=new D.LinkedList,r.set(a,i)),(h,E,C)=>{const M=i.push([h,E,C]);return(0,T.toDisposable)(M)}}if(a in s)return s[a];const o=l.value;let u=o[a];return typeof u!="function"||(u=u.bind(o),s[a]=u),u},set(s,a,o){return l.value[a]=o,!0},getPrototypeOf(s){return f.prototype}})}else return this.j(f,p,S)}u(d,f){if(f&&console.warn(d),this.g)throw new Error(d)}}e.InstantiationService=w;var I;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(I||(I={}));class v{static traceInvocation(d,f){return d?new v(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(d,f){return d?new v(1,f.name):v.c}constructor(d,f){this.type=d,this.name=f,this.g=Date.now(),this.h=[]}branch(d,f){const p=new v(3,d.toString());return this.h.push([d,f,p]),p}stop(){const d=Date.now()-this.g;v.f+=d;let f=!1;function p(S,g){const r=[],l=new Array(S+1).join("	");for(const[s,a,o]of g.h)if(a&&o){f=!0,r.push(`${l}CREATES -> ${s}`);const u=p(S+1,o);u&&r.push(u)}else r.push(`${l}uses -> ${s}`);return r.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(d>2||f)&&v.all.add(b.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v.f=0}),define(ye[13],Ce([1,0,45,3,6,28,12,2,4]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function D(){return new Date().toISOString()}var L;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(L=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=L.Info;function P(u,i,n){switch(i){case L.Trace:u.trace(n);break;case L.Debug:u.debug(n);break;case L.Info:u.info(n);break;case L.Warning:u.warn(n);break;case L.Error:u.error(n);break;case L.Off:break;default:throw new Error(`Invalid log level ${i}`)}}e.log=P;function w(u){let i="";for(let n=0;n<u.length;n++){let h=u[n];if(typeof h=="object")try{h=JSON.stringify(h)}catch{}i+=(n>0?" ":"")+h}return i}e.format=w;class I extends T.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(i){this.b!==i&&(this.b=i,this.c.fire(this.b))}getLevel(){return this.b}f(i){return this.b!==L.Off&&this.b<=i}}e.AbstractLogger=I;class v extends I{constructor(i){super(),this.h=i}f(i){return this.h||super.f(i)}trace(i,...n){this.f(L.Trace)&&this.g(L.Trace,w([i,...n]))}debug(i,...n){this.f(L.Debug)&&this.g(L.Debug,w([i,...n]))}info(i,...n){this.f(L.Info)&&this.g(L.Info,w([i,...n]))}warn(i,...n){this.f(L.Warning)&&this.g(L.Warning,w([i,...n]))}error(i,...n){if(this.f(L.Error))if(i instanceof Error){const h=Array.prototype.slice.call(arguments);h[0]=i.stack,this.g(L.Error,w(h))}else this.g(L.Error,w([i,...n]))}flush(){}}e.AbstractMessageLogger=v;class m extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.g=!k.isWindows}trace(i,...n){this.f(L.Trace)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,i,...n):console.log(`[main ${D()}]`,i,...n))}debug(i,...n){this.f(L.Debug)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,i,...n):console.log(`[main ${D()}]`,i,...n))}info(i,...n){this.f(L.Info)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,i,...n):console.log(`[main ${D()}]`,i,...n))}warn(i,...n){this.f(L.Warning)&&(this.g?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,i,...n):console.warn(`[main ${D()}]`,i,...n))}error(i,...n){this.f(L.Error)&&(this.g?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,i,...n):console.error(`[main ${D()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class d extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i)}trace(i,...n){this.f(L.Trace)&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.f(L.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.f(L.Info)&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.f(L.Warning)&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.f(L.Error)&&console.log("%c  ERR","color: #f33",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class f extends I{constructor(i,n=e.DEFAULT_LOG_LEVEL){super(),this.g=i,this.setLevel(n)}trace(i,...n){this.f(L.Trace)&&this.g.log(L.Trace,[this.h(i),...n])}debug(i,...n){this.f(L.Debug)&&this.g.log(L.Debug,[this.h(i),...n])}info(i,...n){this.f(L.Info)&&this.g.log(L.Info,[this.h(i),...n])}warn(i,...n){this.f(L.Warning)&&this.g.log(L.Warning,[this.h(i),...n])}error(i,...n){this.f(L.Error)&&this.g.log(L.Error,[this.h(i),...n])}h(i){return typeof i=="string"?i:(0,c.toErrorMessage)(i,this.f(L.Trace))}dispose(){}flush(){}}e.AdapterLogger=f;class p extends I{constructor(i){super(),this.g=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.g)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const h of this.g)h.trace(i,...n)}debug(i,...n){for(const h of this.g)h.debug(i,...n)}info(i,...n){for(const h of this.g)h.info(i,...n)}warn(i,...n){for(const h of this.g)h.warn(i,...n)}error(i,...n){for(const h of this.g)h.error(i,...n)}flush(){for(const i of this.g)i.flush()}dispose(){for(const i of this.g)i.dispose()}}e.MultiplexLogService=p;class b extends T.Disposable{constructor(i){super(),this.b=i,this.B(i)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(i){this.b.setLevel(i)}getLevel(){return this.b.getLevel()}trace(i,...n){this.b.trace(i,...n)}debug(i,...n){this.b.debug(i,...n)}info(i,...n){this.b.info(i,...n)}warn(i,...n){this.b.warn(i,...n)}error(i,...n){this.b.error(i,...n)}flush(){this.b.flush()}}e.LogService=b;class S extends T.Disposable{constructor(i,n){super(),this.c=i,this.b=new R.ResourceMap,this.B(n(h=>this.setLevel(h)))}getLoggers(){return[...this.b.values()].map(({logger:i})=>i)}getLogger(i){return this.b.get(i)?.logger}createLogger(i,n,h){let E=this.b.get(i)?.logger;return E||(h=n?.always?L.Trace:h,E=this.f(i,h??this.c,n),this.b.set(i,{logger:E,logLevel:h})),E}setLevel(i,n){const h=A.URI.isUri(i)?i:void 0,E=h?n:i;if(h){const C=this.b.get(h);C&&C.logLevel!==E&&(C.logLevel=E,C.logger.setLevel(E))}else this.c=E,this.b.forEach(({logLevel:C,logger:M})=>{C===void 0&&M.setLevel(this.c)})}getLogLevel(i){return this.b.get(i)?.logLevel}dispose(){this.b.forEach(({logger:i})=>i.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=S;class g{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(i){}getLevel(){return L.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogger=g;class r extends g{}e.NullLogService=r;class l extends S{constructor(){super(L.Info,t.Event.None)}f(i,n,h){return new g}}e.NullLoggerService=l;function s(u){if(u.verbose)return L.Trace;if(typeof u.logLevel=="string"){const i=o(u.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function a(u){switch(u){case L.Trace:return"trace";case L.Debug:return"debug";case L.Info:return"info";case L.Warning:return"warn";case L.Error:return"error";case L.Off:return"off"}}e.LogLevelToString=a;function o(u){switch(u){case"trace":return L.Trace;case"debug":return L.Debug;case"info":return L.Info;case"warn":return L.Warning;case"error":return L.Error;case"critical":return L.Error;case"off":return L.Off}}e.parseLogLevel=o}),define(ye[202],Ce([1,0,40,13]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var T;(function(D){D[D.Trace=0]="Trace",D[D.Debug=1]="Debug",D[D.Info=2]="Info",D[D.Warning=3]="Warning",D[D.Error=4]="Error",D[D.Critical=5]="Critical",D[D.Off=6]="Off"})(T||(T={}));async function R(D,L,P,w,I){try{const v=await new Promise((d,f)=>{te(["spdlog"],d,f)});v.setFlushOn(T.Trace);const m=await v.createAsyncRotatingLogger(D,L,P,w);return I?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(v){console.error(v)}return null}function k(D,L,P){switch(L){case t.LogLevel.Trace:D.trace(P);break;case t.LogLevel.Debug:D.debug(P);break;case t.LogLevel.Info:D.info(P);break;case t.LogLevel.Warning:D.warn(P);break;case t.LogLevel.Error:D.error(P);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function A(D,L){switch(L){case t.LogLevel.Trace:D.setLevel(T.Trace);break;case t.LogLevel.Debug:D.setLevel(T.Debug);break;case t.LogLevel.Info:D.setLevel(T.Info);break;case t.LogLevel.Warning:D.setLevel(T.Warning);break;case t.LogLevel.Error:D.setLevel(T.Error);break;case t.LogLevel.Off:D.setLevel(T.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class y extends t.AbstractMessageLogger{constructor(L,P,w,I,v){super(),this.k=[],this.setLevel(v),this.l=this.n(L,P,w,I),this.B(this.onDidChangeLogLevel(m=>{this.m&&A(this.m,m)}))}async n(L,P,w,I){const v=w?6:1,m=30/v*c.ByteSize.MB,d=await R(L,P,m,v,I);if(d){this.m=d,A(this.m,this.getLevel());for(const{level:f,message:p}of this.k)k(this.m,f,p);this.k=[]}}g(L,P){this.m?k(this.m,L,P):this.getLevel()<=L&&this.k.push({level:L,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(ye[124],Ce([1,0,38,173,4]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var k;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function D(v,m){return m-v}y.compare=D;const L=Object.create(null);L[y.Error]=(0,t.localize)(0,null),L[y.Warning]=(0,t.localize)(1,null),L[y.Info]=(0,t.localize)(2,null);function P(v){return L[v]||""}y.toString=P;function w(v){switch(v){case c.default.Error:return y.Error;case c.default.Warning:return y.Warning;case c.default.Info:return y.Info;case c.default.Ignore:return y.Hint}}y.fromSeverity=w;function I(v){switch(v){case y.Error:return c.default.Error;case y.Warning:return c.default.Warning;case y.Info:return c.default.Info;case y.Hint:return c.default.Ignore}}y.toSeverity=I}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const D="";function L(w){return P(w,!0)}y.makeKey=L;function P(w,I){const v=[D];return w.source?v.push(w.source.replace("\xA6","\\\xA6")):v.push(D),w.code?typeof w.code=="string"?v.push(w.code.replace("\xA6","\\\xA6")):v.push(w.code.value.replace("\xA6","\\\xA6")):v.push(D),w.severity!==void 0&&w.severity!==null?v.push(k.toString(w.severity)):v.push(D),w.message&&I?v.push(w.message.replace("\xA6","\\\xA6")):v.push(D),w.startLineNumber!==void 0&&w.startLineNumber!==null?v.push(w.startLineNumber.toString()):v.push(D),w.startColumn!==void 0&&w.startColumn!==null?v.push(w.startColumn.toString()):v.push(D),w.endLineNumber!==void 0&&w.endLineNumber!==null?v.push(w.endLineNumber.toString()):v.push(D),w.endColumn!==void 0&&w.endColumn!==null?v.push(w.endColumn.toString()):v.push(D),v.push(D),v.join("\xA6")}y.makeKeyOptionalMessage=P})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,T.createDecorator)("markerService")}),define(ye[203],Ce([1,0,3,38,4]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,T.createDecorator)("notificationService");var R;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=y}),define(ye[125],Ce([1,0,8,2,4]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService");function R(D,L){return t.URI.isUri(D)?(0,c.equalsIgnoreCase)(D.scheme,L):(0,c.startsWithIgnoreCase)(D,L+":")}e.matchesScheme=R;function k(D,...L){return L.some(P=>R(D,P))}e.matchesSomeScheme=k;function A(D,L){return D.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=A;function y(D){let L;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(D.fragment);return P&&(L={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},D=D.with({fragment:""})),{selection:L,uri:D}}e.extractSelection=y}),define(ye[204],Ce([1,0,12,37]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof c.globals.vscode<"u"&&typeof c.globals.vscode.context<"u"){const R=c.globals.vscode.context.configuration();if(R)T=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(T=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:R.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ye[205],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,c.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(te,e){return function(c,t){e(c,t,te)}};define(ye[126],Ce([1,0,14,21,6,4]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var k;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends T.Disposable{constructor(P,w){super(),this.a=new c.DeferredPromise,w.withProgress(P,I=>(this.b=I,this.c&&I.report(this.c),this.a.p)),this.B((0,T.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};y=qe([We(1,e.IProgressService)],y),e.UnmanagedProgress=y;class D extends T.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new T.DisposableStore)}start(P){this.stop();const w=++this.a,I=new t.CancellationTokenSource;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,T.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,T.toDisposable)(()=>I.cancel())),this.b.add((0,T.toDisposable)(()=>this.c?this.c.done():void 0)),{id:w,token:I.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(ye[33],Ce([1,0,51,10]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.a=new Map}add(k,A){c.ok(t.isString(k)),c.ok(t.isObject(A)),c.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,A)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}e.Registry=new T}),define(ye[91],Ce([1,0,3,33]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class R{constructor(){this.b=new c.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,D){this.a[T(y)]=D,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const k=new R;t.Registry.add(e.Extensions.JSONContribution,k)}),define(ye[127],Ce([1,0,16,3,10,168,53,91,33]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=y.Registry.as(A.Extensions.JSONContribution);class w{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(r,l=!0){this.registerConfigurations([r],l)}registerConfigurations(r,l=!0){const s=new Set;this.n(r,l,s),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(r){const l=new Set;this.o(r,l),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:r,remove:l}){const s=new Set;this.o(l,s),this.n(r,!1,s),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(r){const l=new Set;this.k(r,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(r,l){const s=[];for(const{overrides:a,source:o}of r)for(const u in a)if(l.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const i=this.a.get(u),n=i?.valuesSources??new Map;if(o)for(const M of Object.keys(a[u]))n.set(M,o);const h={...i?.value||{},...a[u]};this.a.set(u,{source:o,value:h,valuesSources:n});const E=(0,k.getLanguageTagSettingPlainKey)(u),C={type:"object",default:h,description:R.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:T.isString(o)?void 0:o,defaultValueSource:o};s.push(...m(u)),this.d[u]=C,this.b.properties[u]=C}else{this.a.set(u,{value:a[u],source:o});const i=this.d[u];i&&(this.w(u,i),this.r(u,i))}this.m(s)}deregisterDefaultConfigurations(r){const l=new Set;this.l(r,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(r,l){for(const{overrides:s,source:a}of r)for(const o in s){const u=this.a.get(o),i=T.isString(a)?a:a?.id,n=T.isString(u?.source)?u?.source:u?.source?.id;if(i===n)if(l.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const h=this.d[o];h&&(this.w(o,h),this.r(o,h))}}this.u()}deltaConfiguration(r){let l=!1;const s=new Set;r.removedDefaults&&(this.l(r.removedDefaults,s),l=!0),r.addedDefaults&&(this.k(r.addedDefaults,s),l=!0),r.removedConfigurations&&this.o(r.removedConfigurations,s),r.addedConfigurations&&this.n(r.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const l of r)this.h.add(l);this.u()}n(r,l,s){r.forEach(a=>{this.p(a,l,a.extensionInfo,a.restrictedProperties,void 0,s),this.c.push(a),this.q(a)})}o(r,l){const s=a=>{if(a.properties)for(const o in a.properties){l.add(o);const u=this.d[o];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[o],this.s(o,a.properties[o])}a.allOf?.forEach(o=>s(o))};for(const a of r){s(a);const o=this.c.indexOf(a);o!==-1&&this.c.splice(o,1)}}p(r,l=!0,s,a,o=3,u){o=T.isUndefinedOrNull(r.scope)?o:r.scope;const i=r.properties;if(i)for(const h in i){const E=i[h];if(l&&b(h,E)){delete i[h];continue}if(E.source=s,E.defaultDefaultValue=i[h].default,this.w(h,E),e.OVERRIDE_PROPERTY_REGEX.test(h)?E.scope=void 0:(E.scope=T.isUndefinedOrNull(E.scope)?o:E.scope,E.restricted=T.isUndefinedOrNull(E.restricted)?!!a?.includes(h):E.restricted),i[h].hasOwnProperty("included")&&!i[h].included){this.f[h]=i[h],delete i[h];continue}else this.d[h]=i[h],i[h].policy?.name&&this.e.set(i[h].policy.name,h);!i[h].deprecationMessage&&i[h].markdownDeprecationMessage&&(i[h].deprecationMessage=i[h].markdownDeprecationMessage),u.add(h)}const n=r.allOf;if(n)for(const h of n)this.p(h,l,s,a,o,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const l=s=>{const a=s.properties;if(a)for(const u in a)this.r(u,a[u]);s.allOf?.forEach(l)};l(r)}r(r,l){switch(e.allSettings.properties[r]=l,l.scope){case 1:e.applicationSettings.properties[r]=l;break;case 2:e.machineSettings.properties[r]=l;break;case 6:e.machineOverridableSettings.properties[r]=l;break;case 3:e.windowSettings.properties[r]=l;break;case 4:e.resourceSettings.properties[r]=l;break;case 5:e.resourceSettings.properties[r]=l,this.g.properties[r]=l;break}}s(r,l){switch(delete e.allSettings.properties[r],l.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const l=`[${r}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(l,s),e.allSettings.properties[l]=s,e.applicationSettings.properties[l]=s,e.machineSettings.properties[l]=s,e.machineOverridableSettings.properties[l]=s,e.windowSettings.properties[l]=s,e.resourceSettings.properties[l]=s}}v(){const r={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this.i.fire()}w(r,l){const s=this.a.get(r);let a=s?.value,o=s?.source;T.isUndefined(a)&&(a=l.defaultDefaultValue,o=void 0),T.isUndefined(a)&&(a=f(l.type)),l.default=a,l.defaultValueSource=o}}const I="\\[([^\\]]+)\\]",v=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function m(g){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let l=v.exec(g);for(;l?.length;){const s=l[1].trim();s&&r.push(s),l=v.exec(g)}}return(0,c.distinct)(r)}e.overrideIdentifiersFromKey=m;function d(g){return g.reduce((r,l)=>`${r}[${l}]`,"")}e.keyFromOverrideIdentifiers=d;function f(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const p=new w;y.Registry.add(e.Extensions.Configuration,p);function b(g,r){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?R.localize(7,null,g):p.getConfigurationProperties()[g]!==void 0?R.localize(8,null,g):r.policy?.name&&p.getPolicyConfigurations().get(r.policy?.name)!==void 0?R.localize(9,null,g,r.policy?.name,p.getPolicyConfigurations().get(r.policy?.name)):null:R.localize(6,null)}e.validateProperty=b;function S(){const g=[],r=p.getConfigurationProperties();for(const l of Object.keys(r))g.push([l,r[l].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=S}),define(ye[206],Ce([1,0,16,3,146,6,28,22,10,2,53,127,33]),function(te,e,c,t,T,R,k,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function I(l){return Object.isFrozen(l)?l:A.deepFreeze(l)}class v{constructor(s={},a=[],o=[],u){this.b=s,this.c=a,this.d=o,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof v)return a;const o=new m("");return o.parseRaw(a),o.configurationModel});this.f=s.reduce((a,o)=>o===a?o:a.merge(o),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,L.getConfigurationValue)(this.contents,s):this.contents}inspect(s,a){const o=this.rawConfiguration.getValue(s),u=a?this.rawConfiguration.getOverrideValue(s,a):void 0,i=a?this.rawConfiguration.override(a).getValue(s):o;return{value:o,override:u,merged:i}}getOverrideValue(s,a){const o=this.i(a);return o?s?(0,L.getConfigurationValue)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const o of this.overrides)o.identifiers.includes(s)&&a.push(...o.keys);return c.distinct(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return c.distinct(s)}override(s){let a=this.a.get(s);return a||(a=this.g(s),this.a.set(s,a)),a}merge(...s){const a=A.deepClone(this.contents),o=A.deepClone(this.overrides),u=[...this.keys],i=this.raw?.length?[...this.raw]:[this];for(const n of s)if(i.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.h(a,n.contents);for(const h of n.overrides){const[E]=o.filter(C=>c.equals(C.identifiers,h.identifiers));E?(this.h(E.contents,h.contents),E.keys.push(...h.keys),E.keys=c.distinct(E.keys)):o.push(A.deepClone(h))}for(const h of n.keys)u.indexOf(h)===-1&&u.push(h)}return new v(a,u,o,i.every(n=>n instanceof v)?void 0:i)}g(s){const a=this.i(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const o={};for(const u of c.distinct([...Object.keys(this.contents),...Object.keys(a)])){let i=this.contents[u];const n=a[u];n&&(typeof i=="object"&&typeof n=="object"?(i=A.deepClone(i),this.h(i,n)):i=n),o[u]=i}return new v(o,this.keys,this.overrides)}h(s,a){for(const o of Object.keys(a)){if(o in s&&y.isObject(s[o])&&y.isObject(a[o])){this.h(s[o],a[o]);continue}s[o]=A.deepClone(a[o])}}i(s){let a=null,o=null;const u=i=>{i&&(o?this.h(o,i):o=A.deepClone(i))};for(const i of this.overrides)c.equals(i.identifiers,[s])?a=i.contents:i.identifiers.includes(s)&&u(i.contents);return u(a),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,a){this.j(s,a,!0)}setValue(s,a){this.j(s,a,!1)}removeValue(s){const a=this.keys.indexOf(s);a!==-1&&(this.keys.splice(a,1),(0,L.removeFromValueTree)(this.contents,s),P.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(o=>c.equals(o.identifiers,(0,P.overrideIdentifiersFromKey)(s))),1))}j(s,a,o){(0,L.addToValueTree)(this.contents,s,a,u=>console.error(u)),o=o||this.keys.indexOf(s)===-1,o&&this.keys.push(s),P.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,P.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,L.toValuesTree)(this.contents[s],u=>console.error(u))})}}e.ConfigurationModel=v;class m{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!y.isUndefinedOrNull(s)){const o=this.g(s);this.parseRaw(o,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:o,keys:u,overrides:i,restricted:n,hasExcludedProperties:h}=this.h(s,a);this.b=new v(o,u,i,h?[s]:void 0),this.c=n||[]}g(s){let a={},o=null,u=[];const i=[],n=[];function h(C){Array.isArray(u)?u.push(C):o!==null&&(u[o]=C)}const E={onObjectBegin:()=>{const C={};h(C),i.push(u),u=C,o=null},onObjectProperty:C=>{o=C},onObjectEnd:()=>{u=i.pop()},onArrayBegin:()=>{const C=[];h(C),i.push(u),u=C,o=null},onArrayEnd:()=>{u=i.pop()},onLiteralValue:h,onError:(C,M,K)=>{n.push({error:C,offset:M,length:K})}};if(s)try{T.visit(s,E),a=u[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return a}h(s,a){const o=w.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),u=this.i(s,o,!0,a);s=u.raw;const i=(0,L.toValuesTree)(s,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),n=Object.keys(s),h=this.j(s,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:i,keys:n,overrides:h,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(s,a,o,u){let i=!1;if(!u?.scopes&&!u?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:i};const n={},h=[];for(const E in s)if(P.OVERRIDE_PROPERTY_REGEX.test(E)&&o){const C=this.i(s[E],a,!1,u);n[E]=C.raw,i=i||C.hasExcludedProperties,h.push(...C.restricted)}else{const C=a[E],M=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&h.push(E),(M===void 0||u.scopes===void 0||u.scopes.includes(M))&&!(u.skipRestricted&&C?.restricted)?n[E]=s[E]:i=!0}return{raw:n,restricted:h,hasExcludedProperties:i}}j(s,a){const o=[];for(const u of Object.keys(s))if(P.OVERRIDE_PROPERTY_REGEX.test(u)){const i={};for(const n in s[u])i[n]=s[u][n];o.push({identifiers:(0,P.overrideIdentifiersFromKey)(u),keys:Object.keys(i),contents:(0,L.toValuesTree)(i,a)})}return o}}e.ConfigurationModelParser=m;class d extends R.Disposable{constructor(s,a,o,u){super(),this.f=s,this.g=a,this.h=u,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new m(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,i=>i.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,i=>(i.isOperation(0)||i.isOperation(3)||i.isOperation(1)||i.isOperation(4))&&o.isEqual(i.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new v}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class f{constructor(s,a,o,u,i,n,h,E,C,M,K,q,F){this.a=s,this.b=a,this.c=o,this.overrideIdentifiers=u,this.d=i,this.f=n,this.g=h,this.h=E,this.i=C,this.j=M,this.k=K,this.l=q,this.m=F}get value(){return I(this.c)}n(s,a,o){const u=s.inspect(a,o);return{get value(){return I(u.value)},get override(){return I(u.override)},get merged(){return I(u.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(s,a,o,u,i=new v,n=new v,h=new k.ResourceMap,E=new v,C=new k.ResourceMap){this.c=s,this.d=a,this.f=o,this.g=u,this.h=i,this.i=n,this.j=h,this.l=E,this.m=C,this.a=null,this.b=new k.ResourceMap,this.n=null}getValue(s,a,o){return this.q(s,a,o).getValue(s)}updateValue(s,a,o={}){let u;o.resource?(u=this.m.get(o.resource),u||(u=new v,this.m.set(o.resource,u))):u=this.l,a===void 0?u.removeValue(s):u.setValue(s,a),o.resource||(this.a=null)}inspect(s,a,o){const u=this.q(s,a,o),i=this.u(a.resource,o),n=a.resource?this.m.get(a.resource)||this.l:this.l,h=new Set;for(const E of u.overrides)for(const C of E.identifiers)u.getOverrideValue(s,C)!==void 0&&h.add(C);return new f(s,a,u.getValue(s),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,i||void 0,n)}keys(s){const a=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,a){this.j.set(s,a),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const o=[];if(!a){const{added:u,updated:i,removed:n}=g(this.c,s);a=[...u,...i,...n]}for(const u of a)for(const i of(0,P.overrideIdentifiersFromKey)(u)){const n=this.c.getKeysForOverrideIdentifier(i),h=s.getKeysForOverrideIdentifier(i),E=[...h.filter(C=>n.indexOf(C)===-1),...n.filter(C=>h.indexOf(C)===-1),...n.filter(C=>!A.equals(this.c.override(i).getValue(C),s.override(i).getValue(C)))];o.push([i,E])}return this.updateDefaultConfiguration(s),{keys:a,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:o,removed:u}=g(this.d,s),i=[...a,...o,...u];return i.length&&this.updatePolicyConfiguration(s),{keys:i,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:o,removed:u,overrides:i}=g(this.applicationConfiguration,s),n=[...a,...o,...u];return n.length&&this.updateApplicationConfiguration(s),{keys:n,overrides:i}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:o,removed:u,overrides:i}=g(this.localUserConfiguration,s),n=[...a,...o,...u];return n.length&&this.updateLocalUserConfiguration(s),{keys:n,overrides:i}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:o,removed:u,overrides:i}=g(this.remoteUserConfiguration,s),n=[...a,...o,...u];return n.length&&this.updateRemoteUserConfiguration(s),{keys:n,overrides:i}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:o,removed:u,overrides:i}=g(this.workspaceConfiguration,s),n=[...a,...o,...u];return n.length&&this.updateWorkspaceConfiguration(s),{keys:n,overrides:i}}compareAndUpdateFolderConfiguration(s,a){const o=this.p.get(s),{added:u,updated:i,removed:n,overrides:h}=g(o,a),E=[...u,...i,...n];return(E.length||!o)&&this.updateFolderConfiguration(s,a),{keys:E,overrides:h}}compareAndDeleteFolderConfiguration(s){const a=this.p.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:u,removed:i,overrides:n}=g(a,void 0);return{keys:[...o,...u,...i],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,a,o){let u=this.r(a,o);return a.overrideIdentifier&&(u=u.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(u=u.merge(this.d)),u}r({resource:s},a){let o=this.s();if(a&&s){const u=a.getFolder(s);u&&(o=this.t(u.uri)||o);const i=this.m.get(s);i&&(o=o.merge(i))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let a=this.b.get(s);if(!a){const o=this.s(),u=this.j.get(s);u?(a=o.merge(u),this.b.set(s,a)):a=o}return a}u(s,a){if(a&&s){const o=a.getFolder(s);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,a)=>{const{contents:o,overrides:u,keys:i}=this.j.get(a);return s.push([a,{contents:o,overrides:u,keys:i}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(a=>s.add(a)),this.userConfiguration.keys.forEach(a=>s.add(a)),this.i.keys.forEach(a=>s.add(a)),this.j.forEach(a=>a.keys.forEach(o=>s.add(o))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.i.getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.j.forEach(a=>a.getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}w(s){const a=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(o=>a.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>a.add(o)),this.i.getKeysForOverrideIdentifier(s).forEach(o=>a.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(u=>a.add(u))),[...a.values()]}static parse(s){const a=this.x(s.defaults),o=this.x(s.policy),u=this.x(s.application),i=this.x(s.user),n=this.x(s.workspace),h=s.folders.reduce((E,C)=>(E.set(D.URI.revive(C[0]),this.x(C[1])),E),new k.ResourceMap);return new p(a,o,u,i,new v,n,h,new v,new k.ResourceMap)}static x(s){return new v(s.contents,s.keys,s.overrides)}}e.Configuration=p;function b(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const s=new Set,a=new Map;for(const u of l)u.keys.forEach(i=>s.add(i)),u.overrides.forEach(([i,n])=>{const h=(0,k.getOrSet)(a,i,new Set);n.forEach(E=>h.add(E))});const o=[];return a.forEach((u,i)=>o.push([i,[...u.values()]])),{keys:[...s.values()],overrides:o}}e.mergeChanges=b;class S{constructor(s,a,o,u){this.change=s,this.f=a,this.g=o,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const i of s.keys)this.affectedKeys.add(i);for(const[,i]of s.overrides)for(const n of i)this.affectedKeys.add(n);this.d=this.a;for(const i of this.affectedKeys)this.d+=i+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(s,a){const o=this.a+s,u=this.d.indexOf(o);if(u<0)return!1;const i=u+o.length;if(i>=this.d.length)return!1;const n=this.d.charCodeAt(i);if(n!==this.b&&n!==this.c)return!1;if(a){const h=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.f?.workspace):void 0,E=this.g.getValue(s,a,this.h);return!A.equals(h,E)}return!0}}e.ConfigurationChangeEvent=S;function g(l,s){const{added:a,removed:o,updated:u}=r(s?.rawConfiguration,l?.rawConfiguration),i=[],n=l?.getAllOverrideIdentifiers()||[],h=s?.getAllOverrideIdentifiers()||[];if(s){const E=h.filter(C=>!n.includes(C));for(const C of E)i.push([C,s.getKeysForOverrideIdentifier(C)])}if(l){const E=n.filter(C=>!h.includes(C));for(const C of E)i.push([C,l.getKeysForOverrideIdentifier(C)])}if(s&&l){for(const E of n)if(h.includes(E)){const C=r({contents:l.getOverrideValue(void 0,E)||{},keys:l.getKeysForOverrideIdentifier(E)},{contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)});i.push([E,[...C.added,...C.removed,...C.updated]])}}return{added:a,removed:o,updated:u,overrides:i}}function r(l,s){const a=l?s?l.keys.filter(i=>s.keys.indexOf(i)===-1):[...l.keys]:[],o=s?l?s.keys.filter(i=>l.keys.indexOf(i)===-1):[...s.keys]:[],u=[];if(l&&s){for(const i of s.keys)if(l.keys.indexOf(i)!==-1){const n=(0,L.getConfigurationValue)(s.contents,i),h=(0,L.getConfigurationValue)(l.contents,i);A.equals(n,h)||u.push(i)}}return{added:a,removed:o,updated:u}}}),define(ye[128],Ce([1,0,9,4]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var T;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends c.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof R&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===T.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}constructor(y,D=T.Unknown,L){super(y),this._message=y,this._code=D,this._detail=L,this.isHandled=D===T.NotAvailable&&L===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function k(A){const y=A.indexOf("+");return y===-1?A:A.substring(0,y)}e.getRemoteAuthorityPrefix=k}),define(ye[69],Ce([1,0,17]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(D){return D.scheme===c.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=t;function T(D){if(!D)return;const L=D.indexOf("+");return L<0?D:D.substr(0,L)}e.getRemoteName=T;function R(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.getRemoteServerRootPath=R;function k(D){const{host:L,port:P}=y(D);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:P}}e.parseAuthorityWithPort=k;function A(D,L){let{host:P,port:w}=y(D);return typeof w>"u"&&(w=L),{host:P,port:w}}e.parseAuthorityWithOptionalPort=A;function y(D){const L=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const P=D.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const w=D.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:D,port:void 0}}}),define(ye[27],Ce([1,0,8,4,69]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=R;function k(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(m){this.value=m,this.c=m.toLowerCase()}static equals(m,d){if(typeof m>"u"||m===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof m=="string"||typeof d=="string"){const f=typeof m=="string"?m:m.value,p=typeof d=="string"?d:d.value;return c.equalsIgnoreCase(f,p)}return m.c===d.c}static toKey(m){return typeof m=="string"?m.toLowerCase():m.c}}e.ExtensionIdentifier=D;function L(v){return P(v)}e.isApplicationScopedExtension=L;function P(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function w(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function I(v,m){if(m){const d=`onResolveRemoteAuthority:${(0,T.getRemoteName)(m)}`;return v.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[207],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class c{constructor(){this.b=new Map}c(){return new Promise((T,R)=>te(["vsda"],T,R))}async createNewMessage(T){try{const R=await this.c(),k=new R.validator;if(k){const A=String(c.a++);return this.b.set(A,k),{id:A,data:k.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,R){if(!T.id)return!0;const k=this.b.get(T.id);if(!k)return!1;this.b.delete(T.id);try{return k.validate(R)==="ok"}catch{return!1}}async sign(T){try{const R=await this.c(),k=new R.signer;if(k)return k.sign(T)}catch{}return T}}e.SignService=c,c.a=1}),define(ye[208],Ce([1,0,12,37,2,30]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(D){if(c.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}async function A(D,L,P,w,I,v,m,d,f,p){const b=Object.create(null);b["common.machineId"]=m,b.sessionID=(0,R.generateUuid)()+Date.now(),b.commitHash=I,b.version=v,b["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,c.PlatformToString)(c.platform),b["common.nodePlatform"]=t.platform,b["common.nodeArch"]=w,b["common.product"]=p||"desktop",d&&(b["common.msftInternal"]=d);let S=0;const g=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),c.isLinuxSnap&&(b["common.snap"]="true");const r=k(P);r&&(b["common.platformDetail"]=r);try{const l=await D.readFile(T.URI.file(f));b["common.source"]=l.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=A;function y(D){const L=t.env.USERDNSDOMAIN;if(!L)return!1;const P=L.toLowerCase();return D.some(w=>P===w)}e.verifyMicrosoftInternalDomain=y}),define(ye[209],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,c.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,c.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var T;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(T=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[70],Ce([1,0,22,10,3,53,69,208,209]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class D{constructor(i){this.value=i}}e.TelemetryTrustedValue=D;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(i,n){return Promise.resolve(void 0)}publicLog2(i,n){return this.publicLog(i,n)}publicLogError(i,n){return Promise.resolve(void 0)}publicLogError2(i,n){return this.publicLogError(i,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class P{async publicLog(i,n,h){}async publicLogError(i,n,h){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(u,i){return T.Event.debounce(i.onDidChangeConfiguration,(h,E)=>{const C=h?new Set([...h.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:C}},1e3,!0)(h=>{h.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(h.source),configurationKeys:S(h.affectedKeys)})})}e.configurationTelemetry=w;function I(u,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!u.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=I;function v(u,i){return!(i.isBuilt||i.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.isLoggingOnly=v;function m(u){const i=u.getValue(y.TELEMETRY_SETTING_ID),n=u.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(u.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function d(u){const i={},n={},h={};b(u,h);for(let E in h){E=E.length>150?E.substr(E.length-149):E;const C=h[E];typeof C=="number"?n[E]=C:typeof C=="boolean"?n[E]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${C.length}`),i[E]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(i[E]=C)}return{properties:i,measurements:n}}e.validateTelemetryData=d;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function p(u){if(!u)return"none";const i=(0,k.getRemoteName)(u);return f.has(i)?i:"other"}e.cleanRemoteAuthority=p;function b(u,i,n=0,h){if(!!u)for(const E of Object.getOwnPropertyNames(u)){const C=u[E],M=h?h+E:E;Array.isArray(C)?i[M]=(0,c.safeStringify)(C):C instanceof Date?i[M]=C.toISOString():(0,t.isObject)(C)?n<2?b(C,i,n+1,M+"."):i[M]=(0,c.safeStringify)(C):i[M]=C}}function S(u){if(!u)return[];const i=[];return g(i,"",u),i}function g(u,i,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(h=>g(u,i?`${i}.${h}`:h,n[h])):u.push(i)}function r(u,i){const n=u.msftInternalDomains||[],h=i.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(n)||h}e.isInternalTelemetry=r;function l(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.getPiiPathsFromEnvironment=l;function s(u,i){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let n=u;const h=[];for(const K of i)for(;;){const q=K.exec(u);if(!q)break;h.push([q.index,K.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(n="";;){const K=C.exec(u);if(!K)break;const q=h.some(([F,B])=>K.index<B&&F<C.lastIndex);!E.test(K[0])&&!q&&(n+=u.substring(M,K.index)+"<REDACTED: user-file-path>",M=C.lastIndex)}return M<u.length&&(n+=u.substr(M)),n}function a(u){if(!u)return u;const i=u.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of n)if(h.regex.test(i))return`<REDACTED: ${h.label}>`;return u}function o(u,i){return(0,c.cloneAndChange)(u,n=>{if(n instanceof D)return n.value;if(typeof n=="string"){let h=n.replaceAll("%20"," ");h=s(h,i);for(const E of i)h=h.replace(E,"");return h=a(h),h}})}e.cleanData=o}),define(ye[210],Ce([1,0,8,123,27,12,2,9,37,70]),function(te,e,c,t,T,R,k,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(s,a){return s.uuid&&a.uuid?s.uuid===a.uuid:s.id===a.id?!0:(0,c.compareIgnoreCase)(s.id,a.id)===0}e.areSameExtensions=L;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(a){const o=a.manifest?a.manifest.version:a.version,u=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new w(a.identifier,o,u)}static parse(a){const o=P.exec(a);return o&&o[1]&&o[2]?new w({id:o[1]},o[2],o[4]||void 0):null}constructor(a,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof w?L(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=w;const I=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(s){const a=I.exec(s);return a&&a[1]?[d(a[1]),a[2]]:[d(s),void 0]}e.getIdAndVersion=v;function m(s,a){return`${s}.${a}`}e.getExtensionId=m;function d(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function f(s,a){return d(m(s,a))}e.getGalleryExtensionId=f;function p(s,a){const o=[],u=i=>{for(const n of o)if(n.some(h=>L(a(h),a(i))))return n;return null};for(const i of s){const n=u(i);n?n.push(i):o.push([i])}return o}e.groupByExtension=p;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function S(s){return{id:new D.TelemetryTrustedValue(s.identifier.id),name:new D.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function g(s,a){const o=[],u=a.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const i=u.shift();if(i&&o.every(n=>!L(n.identifier,{id:i}))){const n=s.filter(h=>L(h.identifier,{id:i}));n.length===1&&(o.push(n[0]),u.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=g;async function r(s,a){if(!R.isLinux)return!1;let o;try{o=(await s.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await s.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(i){a.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(i))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=r;async function l(s,a){const o=await r(s,a),u=(0,t.getTargetPlatform)(o?"alpine":R.platform,y.arch);return a.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=l}),define(ye[211],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(T){this.b=T,this.a=new Map}dispose(){for(const T of this.a.values())T.dispose()}startBuffering(T,R,k=5){const A=R(y=>{const D=typeof y=="string"?y:y.data;let L=this.a.get(T);if(L){L.data.push(D);return}const P=setTimeout(()=>this.flushBuffer(T),k);L={data:[D],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(T),A.dispose()}},this.a.set(T,L)});return A}stopBuffering(T){this.a.get(T)?.dispose()}flushBuffer(T){const R=this.a.get(T);R&&(this.a.delete(T),this.b(T,R.data.join("")))}}e.TerminalDataBufferer=c}),define(ye[212],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var c;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(c=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===c.HIGH_CONTRAST_DARK||R===c.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function T(R){return R===c.DARK||R===c.HIGH_CONTRAST_DARK}e.isDark=T}),define(ye[71],Ce([1,0,50,3,6,4,33,212]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var y;(function(d){function f(p){return p&&typeof p=="object"&&typeof p.id=="string"}d.isThemeColor=f})(y=e.ThemeColor||(e.ThemeColor={}));function D(d){return{id:d}}e.themeColorFromId=D;var L;(function(d){function f(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||y.isThemeColor(a.color))}d.isThemeIcon=f;const p=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function b(a){const o=p.exec(a);if(!o)return;const[,u]=o;return{id:u}}d.fromString=b;function S(a){return{id:a}}d.fromId=S;function g(a,o){let u=a.id;const i=u.lastIndexOf("~");return i!==-1&&(u=u.substring(0,i)),o&&(u=`${u}~${o}`),{id:u}}d.modify=g;function r(a){const o=a.id.lastIndexOf("~");if(o!==-1)return a.id.substring(o+1)}d.getModifier=r;function l(a,o){return a.id===o.id&&a.color?.id===o.color?.id}d.isEqual=l;function s(a,o){return{id:a.id,color:o?D(o):void 0}}d.asThemeIcon=s,d.asClassNameArray=c.CSSIcon.asClassNameArray,d.asClassName=c.CSSIcon.asClassName,d.asCSSSelector=c.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function P(d){switch(d){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(f){return this.a.push(f),this.b.fire(f),(0,T.toDisposable)(()=>{const p=this.a.indexOf(f);this.a.splice(p,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const I=new w;k.Registry.add(e.Extensions.ThemingContribution,I);function v(d){return I.onColorThemeChange(d)}e.registerThemingParticipant=v;class m extends T.Disposable{constructor(f){super(),this.k=f,this.h=f.getColorTheme(),this.B(this.k.onDidColorThemeChange(p=>this.n(p)))}n(f){this.h=f,this.updateStyles()}updateStyles(){}w(f,p){let b=this.h.getColor(f);return b&&p&&(b=p(b,this.h)),b?b.toString():null}}e.Themable=m}),define(ye[213],Ce([1,0,14,50,3,10,2,174,91,33,71]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var P;(function(S){function g(r,l){let s=r.defaults;for(;L.ThemeIcon.isThemeIcon(s);){const a=v.getIcon(s.id);if(!a)return;s=a.defaults}return s}S.getDefinition=g})(P=e.IconContribution||(e.IconContribution={}));var w;(function(S){function g(l){return{weight:l.weight,style:l.style,src:l.src.map(s=>({format:s.format,location:s.location.toString()}))}}S.toJSONObject=g;function r(l){const s=a=>(0,R.isString)(a)?a:void 0;if(l&&Array.isArray(l.src)&&l.src.every(a=>(0,R.isString)(a.format)&&(0,R.isString)(a.location)))return{weight:s(l.weight),style:s(l.style),src:l.src.map(a=>({format:a.format,location:k.URI.parse(a.location)}))}}S.fromJSONObject=r})(w=e.IconFontDefinition||(e.IconFontDefinition={}));class I{constructor(){this.a=new T.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${t.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,r,l,s){const a=this.b[g];if(a){if(l&&!a.description){a.description=l,this.d.properties[g].markdownDescription=`${l} $(${g})`;const i=this.e.enum.indexOf(g);i!==-1&&(this.e.enumDescriptions[i]=l),this.a.fire()}return a}const o={id:g,description:l,defaults:r,deprecationMessage:s};this.b[g]=o;const u={$ref:"#/definitions/icons"};return s&&(u.deprecationMessage=s),l&&(u.markdownDescription=`${l}: $(${g})`),this.d.properties[g]=u,this.e.enum.push(g),this.e.enumDescriptions.push(l||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const r=this.e.enum.indexOf(g);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,r){const l=this.f[g];return l||(this.f[g]=r,this.a.fire(),r)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(a,o)=>a.id.localeCompare(o.id),r=a=>{for(;L.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(a=>this.b[a]);for(const a of s.filter(o=>!!o.description).sort(g))l.push(`|<i class="${r(a)}"></i>|${a.id}|${L.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const a of s.filter(o=>!L.ThemeIcon.isThemeIcon(o.defaults)).sort(g))l.push(`|<i class="${r(a)}"></i>|${a.id}|`);return l.join(`
`)}}const v=new I;D.Registry.add(e.Extensions.IconContribution,v);function m(S,g,r,l){return v.registerIcon(S,g,r,l)}e.registerIcon=m;function d(){return v}e.getIconRegistry=d;function f(){for(const S of t.Codicon.getAll())v.registerIcon(S.id,S.definition,S.description)}f(),e.iconsSchemaId="vscode://schemas/icons";const p=D.Registry.as(y.Extensions.JSONContribution);p.registerSchema(e.iconsSchemaId,v.getIconSchema());const b=new c.RunOnceScheduler(()=>p.notifySchemaChanged(e.iconsSchemaId),200);v.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=m("widget-close",t.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=m("goto-previous-location",t.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=m("goto-next-location",t.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=L.ThemeIcon.modify(t.Codicon.sync,"spin"),e.spinningLoading=L.ThemeIcon.modify(t.Codicon.loading,"spin")}),define(ye[129],Ce([1,0,3,53,4,13]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var k;(function(m){m.Http="http",m.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=P;function w(m,d,f,p){if(f===1)return!1;if(f===2&&P(d)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(b?.length===4&&parseInt(b[1])>=18)return!1}return m<1024}e.isPortPrivileged=w;class I{constructor(d,f,p){this.remoteAddress=d,this.localAddress=f,this.b=p,this.a=new c.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=I;let v=class{constructor(d,f){this.i=d,this.j=f,this.a=new c.Emitter,this.onTunnelOpened=this.a.event,this.b=new c.Emitter,this.onTunnelClosed=this.b.event,this.c=new c.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const d=this.j.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.e=d,d?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.f=d.elevation,this.g=d.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const d=[],f=Array.from(this.d.values());for(const p of f){const b=Array.from(p.values());for(const S of b){const g=await S.value;g&&d.push(g)}}return d}async dispose(){for(const d of this.d.values()){for(const{value:f}of d.values())await f.then(p=>p?.dispose());d.clear()}this.d.clear()}setEnvironmentTunnel(d,f,p,b,S){this.o(d,f,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:f,localAddress:p,privacy:b,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,f){(P(d)||L(d))&&(d=e.LOCALHOST_ADDRESSES[0]);const p=this.q(d,f);if(p)return++p.refcount,p.value}openTunnel(d,f,p,b,S=!1,g,r){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${p} on local port ${b}.`),!d)return;if(f||(f="localhost"),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.r(d,f,p,b,S,g,r);return l?l.then(s=>{if(!s){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(f,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(s);return(s.tunnelRemoteHost!==f||s.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}m(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const f=this.d.get(d.tunnelRemoteHost);if(f){const p=f.get(d.tunnelRemotePort);p&&(p.refcount--,await this.n(d.tunnelRemoteHost,d.tunnelRemotePort,p))}}}}async n(d,f,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${f}.`);const b=p.value.then(async S=>{S&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.d.has(d)&&this.d.get(d).delete(f),b}}async closeTunnel(d,f){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${f} `);const p=this.d.get(d);if(p&&p.has(f)){const b=p.get(f);b.refcount=0,await this.n(d,f,b)}}o(d,f,p){this.d.has(d)||this.d.set(d,new Map),this.d.get(d).set(f,{refcount:1,value:p})}async p(d,f){const p=this.d.get(d);p&&(await p.get(f)||p.delete(f),p.size===0&&this.d.delete(d))}q(d,f){const p=[d];L(d)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):P(d)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const b=p.map(S=>this.d.get(S));for(const S of b){const g=S?.get(f);if(g)return g}}canTunnel(d){return!!D(d)}s(d,f,p,b,S,g,r){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${p} on local port ${b}.`);const l=p;this.h.add(l);const s=b===void 0?p:b,a={elevationRequired:S?this.isPortPrivileged(s):!1},o={remoteAddress:{host:f,port:p},localAddressPort:b,privacy:g,public:g?g!==A.Private:void 0,protocol:r},u=d.forwardPort(o,a);return u?(this.o(f,p,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(l)})):this.h.delete(l),u}};v=qe([We(0,R.ILogService),We(1,t.IConfigurationService)],v),e.AbstractTunnelService=v}),define(ye[214],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,c.createDecorator)("editSessionIdentityService");var t;(function(T){T[T.Complete=100]="Complete",T[T.Partial=50]="Partial",T[T.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[215],Ce([1,0,17]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(y){return y.scheme!==c.Schemas.file&&y.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=t;function T(y){if(y.folders.length)return y.folders.every(D=>t(D.uri))?y.folders[0].uri:void 0;if(y.configuration&&t(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=T;function R(y){return T(y)?.scheme}e.getVirtualWorkspaceScheme=R;function k(y){return T(y)?.authority}e.getVirtualWorkspaceAuthority=k;function A(y){return T(y)!==void 0}e.isVirtualWorkspace=A}),define(ye[47],Ce([1,0,175,11,66,24,2,4,17]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function D(s){const a=s;return typeof a?.id=="string"&&k.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=D;function L(s){return typeof s?.id=="string"&&!D(s)&&!w(s)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function P(s,a){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,t.basename)(s)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=s;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=P;function w(s){const a=s;return typeof a?.id=="string"&&k.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=w;function I(s){const a=s;if(a?.uri)return{id:a.id,uri:k.URI.revive(a.uri)};const o=s;if(o?.configPath)return{id:o.id,configPath:k.URI.revive(o.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=I;var v;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function m(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=m;function d(s){const a=s;return!!(a&&typeof a=="object"&&k.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=d;class f{constructor(a,o,u,i,n){this.h=a,this.j=u,this.k=i,this.l=n,this.c=T.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=T.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class p{constructor(a,o){this.raw=o,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,R.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function b(s){return new p({uri:s,index:0,name:(0,R.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,c.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(s,a){return R.extUriBiasedIgnorePathCase.isEqualOrParent(s,a.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function g(s){let a;return k.URI.isUri(s)?a=s:a=s.configuration,a?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=g;function r(s,a){return!S(s,a)&&!g(s)}e.isSavedWorkspace=r;function l(s){return(typeof s=="string"?(0,t.extname)(s):(0,R.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=l}),define(ye[72],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(T){this.d=T,this.b=new Map,this.c=1}add(T){const R=this.c++;return this.b.set(R,T),this.e(),R}get(T,R){return this.b.has(T)?this.b.get(T)[R]:void 0}delete(T){this.b.delete(T),this.e()}e(){!c.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=c,c.a=!1}),define(ye[48],Ce([1,0,17,24,4]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(c.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(A=>{const y=this.b.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this.b.delete(A.scheme):this.b.set(A.scheme,y)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,T.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(ye[216],Ce([1,0,14]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(k,A,y){this.h=new Map,this.a=k,this.b=A,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(D=>(this.f=D,this)),this.g=this.c.onDidChangeStorage(D=>{D.shared===this.b&&D.key===this.a&&(this.f=D.value)}),this.i=new c.RunOnceScheduler(()=>{const D=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of D.values())L.complete()}catch(L){for(const P of D.values())P.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this.d}get(k,A){let y=this.f[k];return typeof y>"u"&&(y=A),y}update(k,A){this.f[k]=A;const y=this.h.get(k);if(y!==void 0)return y.p;const D=new c.DeferredPromise;return this.h.set(k,D),this.i.isScheduled()||this.i.schedule(),D.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class T extends t{setKeysForSync(k){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},k)}constructor(k,A){super(k.identifier.value,!0,A),this.j=k}}e.ExtensionGlobalMemento=T}),define(ye[217],Ce([1,0,3,2]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class T{constructor(k){this.c=k,this.a=new c.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new c.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(k,A,y,D){const P=this.c.getNotebookDocument(t.URI.revive(k)).acceptModelChanged(A.value,y,D);this.b.fire(P)}$acceptDirtyStateChanged(k,A){this.c.getNotebookDocument(t.URI.revive(k)).acceptDirty(A)}$acceptModelSaved(k){const A=this.c.getNotebookDocument(t.URI.revive(k));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=T}),define(ye[18],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class t{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=t});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,c):T?T.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[218],Ce([1,0,27,3]),function(te,e,c,t){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(A,y){T.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=c.ExtensionIdentifier.toKey(A.identifier),Je(this,T,y,"f"),Ue(this,T,"f").onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(A){return Ue(this,T,"f").get(this.a,A)}store(A,y){return Ue(this,T,"f").store(this.a,A,y)}delete(A){return Ue(this,T,"f").delete(this.a,A)}}e.ExtensionSecrets=R,T=new WeakMap}),define(ye[55],Ce([1,0,4,129,3,18]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var k;(function(y){function D(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:P.protocol}}y.fromApiTunnel=D;function L(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==t.TunnelPrivacyId.ConstantPrivate&&P.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}y.fromServiceTunnel=L})(k=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let A=class{constructor(D){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,L){}async getTunnels(){return[]}async setTunnelFactory(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,L){return{dispose:()=>{}}}async $providePortAttributes(D,L,P,w,I){return[]}async $forwardPort(D,L){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([We(0,R.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(ye[56],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class t{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=t}),define(ye[219],Ce([1,0,23]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(y){let D=this.buffers.indexOf(y);return D<0&&(D=this.buffers.length,this.buffers.push(y)),D}}function T(A,y){if(y.serializeBuffersForPostMessage){const D=new t,L=(I,v)=>{if(v instanceof ArrayBuffer){const m=D.add(v);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(v)){const m=R(v);if(m){const d=D.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:m,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},P=JSON.stringify(A,L),w=D.buffers.map(I=>{const v=new Uint8Array(I);return c.VSBuffer.wrap(v)});return{message:P,buffers:w}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=T;function R(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(A,y){const D=y.map(w=>{const I=new ArrayBuffer(w.byteLength);return new Uint8Array(I).set(w.buffer),I}),L=y.length?(w,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const v=I,{index:m}=v,d=D[m];if(v.view)switch(v.view.type){case 1:return new Int8Array(d,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return I}:void 0;return{message:JSON.parse(A,L),arrayBuffers:D}}e.deserializeWebviewMessage=k}),define(ye[220],Ce([1,0,114]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(R){return{transformIncoming:k=>k.scheme==="vscode-remote"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="file"?{scheme:"vscode-local",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoing:k=>k.scheme==="file"?{scheme:"vscode-remote",authority:R,path:k.path,query:k.query,fragment:k.fragment}:k.scheme==="vscode-local"?{scheme:"file",path:k.path,query:k.query,fragment:k.fragment}:k,transformOutgoingScheme:k=>k==="file"?"vscode-remote":k==="vscode-local"?"file":k}}function T(R){return new c.URITransformer(t(R))}e.createURITransformer=T}),define(ye[130],Ce([1,0,185,10,2,6,4,33,40,17,45,160,38]),function(te,e,c,t,T,R,k,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var I;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(I=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var v;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(v=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(X){const G=X;return!!G&&typeof G.getSelection=="function"&&!!G.onDidChangeSelection}e.isEditorPaneWithSelection=m;function d(X,G,de){for(const be of de.visibleEditorPanes)if(be.group.id===G&&X.matches(be.input))return be.getViewState()}e.findViewStateForEditor=d;function f(X){if(n(X))return!1;const G=X;return T.URI.isUri(G?.resource)}e.isResourceEditorInput=f;function p(X){if(n(X))return!1;const G=X;return G?.original!==void 0&&G.modified!==void 0}e.isResourceDiffEditorInput=p;function b(X){if(n(X)||p(X))return!1;const G=X;return G?.primary!==void 0&&G.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function S(X){if(n(X))return!1;const G=X;return G?G.resource===void 0||G.resource.scheme===D.Schemas.untitled||G.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=S;const g=/Untitled-\d+/;function r(X){return X.scheme===D.Schemas.untitled&&X.path.length>1&&!g.test(X.path)}e.isUntitledWithAssociatedResource=r;function l(X){if(n(X))return!1;const G=X;return T.URI.isUri(G?.base?.resource)&&T.URI.isUri(G?.input1?.resource)&&T.URI.isUri(G?.input2?.resource)&&T.URI.isUri(G?.result?.resource)}e.isResourceMergeEditorInput=l;var s;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var a;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.a=new Map}registerSource(G,de){let be=this.a.get(G);return be||(be={source:G,label:de},this.a.set(G,be)),be.source}getSourceLabel(G){return this.a.get(G)?.label??G}}e.SaveSourceRegistry=new o;var u;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends R.Disposable{}e.AbstractEditorInput=i;function n(X){return X instanceof i}e.isEditorInput=n;function h(X){const G=X;return T.URI.isUri(G?.preferredResource)}function E(X){const G=X;return n(G?.primary)&&n(G?.secondary)}e.isSideBySideEditorInput=E;function C(X){const G=X;return n(G?.modified)&&n(G?.original)}e.isDiffEditorInput=C;function M(X,G,de,be,Ee){return ee(be,[(0,P.toAction)({id:"workbench.action.openLargeFile",label:(0,c.localize)(2,null),run:()=>{const Pe={...de,limits:{size:Number.MAX_VALUE}};X.openEditor(G,Pe)}}),(0,P.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,c.localize)(3,null),run:()=>Ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.createTooLargeFileError=M;function K(X){return n(X?.editor)}e.isEditorInputWithOptions=K;function q(X){const G=X;return K(X)&&G?.group!==void 0}e.isEditorInputWithOptionsAndGroup=q;function F(X){const G=X;return typeof G?.groupId=="number"&&n(G.editor)}e.isEditorIdentifier=F;var B;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var O;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(O=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri(G,de){if(!G)return;if(l(G))return e.EditorResourceAccessor.getOriginalUri(G.result,de);if(de?.supportSideBySide){const{primary:Ee,secondary:Pe}=this.a(G);if(Ee&&Pe){if(de?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:de.filterByScheme}),secondary:this.getOriginalUri(Pe,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===U.ANY)return this.getOriginalUri(Ee,{filterByScheme:de.filterByScheme})??this.getOriginalUri(Pe,{filterByScheme:de.filterByScheme});G=de.supportSideBySide===U.PRIMARY?Ee:Pe}}if(p(G)||b(G)||l(G))return;const be=h(G)?G.preferredResource:G.resource;return!be||!de||!de.filterByScheme?be:this.b(be,de.filterByScheme)}a(G){return E(G)||b(G)?{primary:G.primary,secondary:G.secondary}:C(G)||p(G)?{primary:G.modified,secondary:G.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(G,de){if(!G)return;if(l(G))return e.EditorResourceAccessor.getCanonicalUri(G.result,de);if(de?.supportSideBySide){const{primary:Ee,secondary:Pe}=this.a(G);if(Ee&&Pe){if(de?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:de.filterByScheme}),secondary:this.getCanonicalUri(Pe,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===U.ANY)return this.getCanonicalUri(Ee,{filterByScheme:de.filterByScheme})??this.getCanonicalUri(Pe,{filterByScheme:de.filterByScheme});G=de.supportSideBySide===U.PRIMARY?Ee:Pe}}if(p(G)||b(G)||l(G))return;const be=G.resource;return!be||!de||!de.filterByScheme?be:this.b(be,de.filterByScheme)}b(G,de){if(Array.isArray(de)){if(de.some(be=>G.scheme===be))return G}else if(de===G.scheme)return G}}e.EditorResourceAccessor=new z;var j;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class ue{constructor(){this.c=new Map,this.d=new Map}start(G){const de=this.a=G.get(k.IInstantiationService);for(const[be,Ee]of this.c)this.e(be,Ee,de);this.c.clear()}e(G,de,be){const Ee=be.createInstance(de);this.d.set(G,Ee)}registerFileEditorFactory(G){if(this.b)throw new Error("Can only register one file editor factory.");this.b=G}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(G,de){if(this.c.has(G)||this.d.has(G))throw new Error(`A editor serializer with type ID '${G}' was already registered.`);return this.a?this.e(G,de,this.a):this.c.set(G,de),(0,R.toDisposable)(()=>{this.c.delete(G),this.d.delete(G)})}getEditorSerializer(G){return this.d.get(typeof G=="string"?G:G.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new ue);async function V(X,G,de){return!X||!X.length?[]:await Promise.all(X.map(async be=>{const Ee=T.URI.revive(be.fileUri);if(!Ee){de.info("Cannot resolve the path because it is not valid.",be);return}if(!await G.canHandleResource(Ee)){de.info("Cannot resolve the path because it cannot be handled",be);return}let Fe=be.exists,se=be.type;if(typeof Fe!="boolean"||typeof se!="number")try{se=(await G.stat(Ee)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Fe=!0}catch(fe){de.error(fe),Fe=!1}if(!Fe&&be.openOnlyIfExists){de.info("Cannot resolve the path because it does not exist",be);return}if(se===y.FileType.Directory){de.info("Cannot resolve the path because it is a directory",be);return}const oe={...be.options,pinned:!0};return Fe?{resource:Ee,options:oe}:{resource:Ee,options:oe,forceUntitled:!0}}))}e.pathsToEditors=V;var _;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(_=e.EditorsOrder||(e.EditorsOrder={}));function J(X){const G=X;if(!G)return!1;const de=G;if(de.modified)return J(de.modified);const be=G;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}e.isTextEditorViewState=J;function ne(X){return(0,L.isErrorWithActions)(X)}e.isEditorOpenError=ne;function ee(X,G,de){const be=(0,L.createErrorWithActions)(X,G);return be.forceMessage=de?.forceMessage,be.forceSeverity=de?.forceSeverity,be.allowDialog=de?.allowDialog,be}e.createEditorOpenError=ee}),define(ye[221],Ce([1,0,3,186,4,6,28,33,16,61,22,50,213]),function(te,e,c,t,T,R,k,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,w.registerIcon)("default-view-icon",P.Codicon.window,(0,t.localize)(0,null));var I;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(I=e.Extensions||(e.Extensions={}));var v;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(v=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function m(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=m;class d extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new c.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new c.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(a,o,u){const i=this.get(a.id);if(i)return i;const n=a;return n.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:n.openCommandActionDescriptor??{id:n.id},(0,k.getOrSet)(this.g,o,[]).push(n),u?.isDefault&&this.h.push(n),this.c.fire({viewContainer:n,viewContainerLocation:o}),n}deregisterViewContainer(a){for(const o of this.g.keys()){const u=this.g.get(o),i=u?.indexOf(a);if(i!==-1){u?.splice(i,1),u.length===0&&this.g.delete(o),this.f.fire({viewContainer:a,viewContainerLocation:o});return}}}get(a){return this.all.filter(o=>o.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(u=>u?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(o=>this.getViewContainerLocation(o)===a)}}A.Registry.add(I.ViewContainersRegistry,new d);var f;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(f=e.ViewContentGroups||(e.ViewContentGroups={}));function p(s,a){const o=s.group??f.More,u=a.group??f.More;return o!==u?o.localeCompare(u):(s.order??5)-(a.order??5)}class b extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new c.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new c.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new c.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new c.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new D.SetMap}registerViews(a,o){this.registerViews2([{views:a,viewContainer:o}])}registerViews2(a){a.forEach(({views:o,viewContainer:u})=>this.l(o,u)),this.c.fire(a)}deregisterViews(a,o){const u=this.m(a,o);u.length&&this.f.fire({views:u,viewContainer:o})}moveViews(a,o){for(const u of this.j.keys())if(u!==o){const i=this.m(a,u);i.length&&(this.l(i,o),this.g.fire({views:i,from:u,to:o}))}}getViews(a){return this.j.get(a)||[]}getView(a){for(const o of this.i){const u=(this.j.get(o)||[]).filter(i=>i.id===a)[0];if(u)return u}return null}getViewContainer(a){for(const o of this.i)if((this.j.get(o)||[]).filter(i=>i.id===a)[0])return o;return null}registerViewWelcomeContent(a,o){return this.k.add(a,o),this.h.fire(a),(0,R.toDisposable)(()=>{this.k.delete(a,o),this.h.fire(a)})}registerViewWelcomeContent2(a,o){const u=new Map;for(const[i,n]of o)this.k.add(a,n),u.set(i,(0,R.toDisposable)(()=>{this.k.delete(a,n),this.h.fire(a)}));return this.h.fire(a),u}getViewWelcomeContent(a){const o=[];return this.k.forEach(a,u=>o.push(u)),o.sort(p)}l(a,o){let u=this.j.get(o);u||(u=[],this.j.set(o,u),this.i.push(o));for(const i of a){if(this.getView(i.id)!==null)throw new Error((0,t.localize)(1,null,i.id));u.push(i)}}m(a,o){const u=this.j.get(o);if(!u)return[];const i=[],n=[];for(const h of u)a.includes(h)?i.push(h):n.push(h);return i.length&&(n.length?this.j.set(o,n):(this.j.delete(o),this.i.splice(this.i.indexOf(o),1))),i}}A.Registry.add(I.ViewsRegistry,new b),e.IViewsService=(0,T.createDecorator)("viewsService"),e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var S;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(S=e.ViewVisibilityState||(e.ViewVisibilityState={}));var g;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(g=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class r{constructor(a,o){this.c=!1,this.d=!1,(0,L.mixin)(this,a),this.d=!!o,this.resolve=async u=>{if(o&&!this.c){const i=await o(u);i&&(this.tooltip=this.tooltip??i.tooltip,this.command=this.command??i.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=r;class l extends Error{constructor(a){super((0,t.localize)(2,null,a))}}e.NoTreeViewError=l}),define(ye[131],Ce([1,0,3,14,187]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new c.Emitter,this.n=new c.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,y,D,L){const P={command:A};if(y&&Object.keys(y).length>0&&(P.arguments=y),this.s("request",P),typeof L=="number"){const w=setTimeout(()=>{clearTimeout(w);const I=this.f.get(P.seq);if(I){this.f.delete(P.seq);const v={type:"response",seq:0,request_seq:P.seq,success:!1,command:A,message:(0,T.localize)(0,null,L,A)};I(v)}},L)}return D&&this.f.set(P.seq,D),P.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,y){return A.type!=="event"||y.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,t.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const y=A,D=this.f.get(y.request_seq);D&&(this.f.delete(y.request_seq),D(y));break}}}}s(A,y){y.type=A,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((y,D)=>A.set(D,y)),await(0,t.timeout)(500),A.forEach((y,D)=>{y({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.f.delete(D)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(ye[222],Ce([1,0,188,54,4]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:c.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:c.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:c.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:c.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new t.RawContextKey("hasDebugged",!1,{type:"boolean",description:c.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:c.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:c.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:c.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:c.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:c.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:c.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:c.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:c.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:c.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:c.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:c.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:c.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:c.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:c.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:c.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:c.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:c.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:c.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:c.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:c.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:c.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:c.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:c.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:c.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:c.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:c.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:c.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:c.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:c.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:c.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:c.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:c.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:c.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:c.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:c.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:c.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:c.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:c.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:c.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:c.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:c.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:c.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:c.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:c.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:c.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:c.localize(50,null)});const R=w=>c.localize(51,null,w);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:c.localize(52,null)};var k;(function(w){w[w.Inactive=0]="Inactive",w[w.Initializing=1]="Initializing",w[w.Stopped=2]="Stopped",w[w.Running=3]="Running"})(k=e.State||(e.State={}));function A(w){switch(w){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(w){w[w.Valid=0]="Valid",w[w.Unreadable=1]="Unreadable",w[w.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var D;(function(w){w[w.Initial=1]="Initial",w[w.Dynamic=2]="Dynamic"})(D=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(w){w.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,T.createDecorator)("debugService");var P;(function(w){w[w.CONDITION=0]="CONDITION",w[w.HIT_COUNT=1]="HIT_COUNT",w[w.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[223],Ce([1,0,8,2,11,22,17]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(s,a,o){return s.replace(A,function(u,i){return a&&i.length>0&&i[0]!=="_"?u:o&&o.hasOwnProperty(i)?o[i]:u})}e.formatPII=y;function D(s){const a={};for(const o of Object.keys(s))o.startsWith("!")||(a[o]=s[o]);return a}e.filterExceptionsFromTelemetry=D;function L(s){return s.configuration.request==="attach"&&!P(s)&&(!s.parentSession||L(s.parentSession))}e.isSessionAttach=L;function P(s){let a=s.configuration.type;if(!!a)return a==="vslsShare"&&(a=s.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(a,"extensionhost")||(0,c.equalsIgnoreCase)(a,"pwa-extensionhost")?s:s.parentSession?P(s.parentSession):void 0}e.getExtensionHostDebugSession=P;function w(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=w;function I(s,a,o){let u,i=0;const n=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=n.exec(s);){const E=h.index+1,C=E+h[0].length;if(E<=a&&C>=o){u=h[0],i=E;break}}if(u){const E=/\w+/g;let C=null;for(;(C=E.exec(u))&&!(C.index+1+i+C[0].length>=o););C&&(u=u.substring(0,E.lastIndex))}return u?{start:i,end:i+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=I;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(s){return!!(s&&s.match(v))}e.isUri=m;function d(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(m(s.path))return t.URI.parse(s.path);if((0,T.isAbsolute)(s.path))return t.URI.file(s.path)}return s.path}function f(s){if(typeof s.path=="object"){const a=t.URI.revive(s.path);if(a)return a.scheme===k.Schemas.file?a.fsPath:a.toString()}return s.path}function p(s,a){const o=a?d:f,u=(0,R.deepClone)(s);return S(u,(i,n)=>{i&&n&&(n.path=o(n))}),u}e.convertToDAPaths=p;function b(s,a){const o=a?d:f,u=(0,R.deepClone)(s);return S(u,(i,n)=>{!i&&n&&(n.path=o(n))}),u}e.convertToVSCPaths=b;function S(s,a){switch(s.type){case"event":{const o=s;switch(o.event){case"output":a(!1,o.body.source);break;case"loadedSource":a(!1,o.body.source);break;case"breakpoint":a(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=s;switch(o.command){case"setBreakpoints":a(!0,o.arguments.source);break;case"breakpointLocations":a(!0,o.arguments.source);break;case"source":a(!0,o.arguments.source);break;case"gotoTargets":a(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(u=>a(!1,u));break;default:break}break}case"response":{const o=s;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(u=>a(!1,u.source));break;case"loadedSources":o.body.sources.forEach(u=>a(!1,u));break;case"scopes":o.body.scopes.forEach(u=>a(!1,u.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(u=>a(!1,u.source));break;case"setBreakpoints":o.body.breakpoints.forEach(u=>a(!1,u.source));break;case"disassemble":o.body?.instructions.forEach(i=>a(!1,i.location));break;default:break}break}}}function g(s){return s.filter(a=>!a.presentation?.hidden).sort((a,o)=>a.presentation?o.presentation?a.presentation.group?o.presentation.group?a.presentation.group!==o.presentation.group?a.presentation.group.localeCompare(o.presentation.group):r(a.presentation.order,o.presentation.order):-1:o.presentation.group?1:r(a.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.getVisibleAndSorted=g;function r(s,a){return typeof s!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:s-a}async function l(s,a){const o=s.getValue("debug.saveBeforeStart",{overrideIdentifier:a.activeTextEditorLanguageId});if(o!=="none"&&(await a.saveAll(),o==="allEditorsInActiveGroup")){const u=a.activeEditorPane;u&&u.input.resource?.scheme===k.Schemas.untitled&&await a.save({editor:u.input,groupId:u.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=l}),define(ye[224],Ce([1,0,46,225,22,11,12,8,29,189,131]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(f,p){this.p=p,this.r=Buffer.allocUnsafe(0),this.t=-1,f.on("data",b=>this.w(b))}sendMessage(f){if(this.p){const p=JSON.stringify(f);this.p.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${P.a}${p}`,"utf8")}}w(f){for(this.r=Buffer.concat([this.r,f]);;){if(this.t>=0){if(this.r.length>=this.t){const p=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(b){this.m.fire(new Error((b.message||b)+`
`+p))}continue}}else{const p=this.r.indexOf(P.a);if(p!==-1){const S=this.r.toString("utf8",0,p).split(P.b);for(const g of S){const r=g.split(P.l);r[0]==="Content-Length"&&(this.t=Number(r[1]))}this.r=this.r.slice(p+P.a.length);continue}}break}}}e.StreamDebugAdapter=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class w extends P{startSession(){return new Promise((f,p)=>{let b=!1;this.x=this.y(()=>{this.v(this.x,this.x),f(),b=!0}),this.x.on("close",()=>{b?this.m.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.x.on("error",S=>{b?this.m.fire(S):p(S)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=w;class I extends w{constructor(f){super(),this.z=f}y(f){return t.createConnection(this.z.port,this.z.host||"127.0.0.1",f)}}e.SocketDebugAdapter=I;class v extends w{constructor(f){super(),this.z=f}y(f){return t.createConnection(this.z.path,f)}}e.NamedPipeDebugAdapter=v;class m extends P{constructor(f,p){super(),this.y=f,this.z=p}async startSession(){const f=this.y.command,p=this.y.args,b=this.y.options||{};try{if(f)if(R.isAbsolute(f)){if(!await y.Promises.exists(f))throw new Error(D.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.z));let S=process.env;if(b.env&&Object.keys(b.env).length>0&&(S=T.mixin(T.deepClone(process.env),b.env)),f==="node")if(Array.isArray(p)&&p.length>0){const g=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:S,execArgv:g?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};b.cwd&&(r.cwd=b.cwd);const l=c.fork(p[0],p.slice(1),r);if(!l.pid)throw new Error(D.localize(2,null,p[0]));this.x=l}else throw new Error(D.localize(3,null));else{const g={env:S};b.cwd&&(g.cwd=b.cwd),this.x=c.spawn(f,p,g)}this.x.on("error",g=>{this.m.fire(g)}),this.x.on("exit",(g,r)=>{this.n.fire(g)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",g=>{this.m.fire(g)}),this.x.stdin.on("error",g=>{this.m.fire(g)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(S){this.m.fire(S)}}async stopSession(){return this.x?(await this.u(),k.isWindows?new Promise((f,p)=>{const b=c.exec(`taskkill /F /T /PID ${this.x.pid}`,function(S,g,r){if(S)return p(S)});b.on("exit",f),b.on("error",p)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(f,p){if(!f)return;const b=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?b.runtime=R.join(p,f.runtime):b.runtime=f.runtime),f.runtimeArgs&&(b.runtimeArgs=f.runtimeArgs),f.program&&(R.isAbsolute(f.program)?b.program=f.program:b.program=R.join(p,f.program)),f.args&&(b.args=f.args);const S=f;return S.win&&(b.win=m.A(S.win,p)),S.winx86&&(b.winx86=m.A(S.winx86,p)),S.windows&&(b.windows=m.A(S.windows,p)),S.osx&&(b.osx=m.A(S.osx,p)),S.linux&&(b.linux=m.A(S.linux,p)),b}static platformAdapterExecutable(f,p){let b=Object.create(null);p=p.toLowerCase();for(const a of f)if(a.contributes){const o=a.contributes.debuggers;o&&o.length>0&&o.filter(u=>typeof u.type=="string"&&A.equalsIgnoreCase(u.type,p)).forEach(u=>{const i=m.A(u,a.extensionLocation.fsPath);b=T.mixin(b,i,a.isBuiltin)})}let S;k.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?S=b.winx86||b.win||b.windows:k.isWindows?S=b.win||b.windows:k.isMacintosh?S=b.osx:k.isLinux&&(S=b.linux),S=S||b;const g=S.program||b.program,r=S.args||b.args,l=S.runtime||b.runtime,s=S.runtimeArgs||b.runtimeArgs;if(l)return{type:"executable",command:l,args:(s||[]).concat(typeof g=="string"?[g]:[]).concat(r||[])};if(g)return{type:"executable",command:g,args:r||[]}}}e.ExecutableDebugAdapter=m}),define(ye[226],Ce([1,0,46,32,12]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(D,L){return new Promise((P,w)=>{let I="";const v=c.spawn(D,L);v.pid&&v.stdout.on("data",m=>{I+=m.toString()}),v.on("error",m=>{w(m)}),v.on("close",m=>{P(I)})})}async function k(D){if(D)if(T.isWindows){const L=await new Promise((P,w)=>{te(["windows-process-tree"],P,w)});return new Promise(P=>{L.getProcessTree(D,w=>{P(!!w&&w.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(D)]).then(L=>{const P=L.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=k;var A;(function(D){D[D.cmd=0]="cmd",D[D.powershell=1]="powershell",D[D.bash=2]="bash"})(A||(A={}));function y(D,L,P,w,I){D=D.trim().toLowerCase();let v;D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0?v=1:D.indexOf("cmd.exe")>=0?v=0:D.indexOf("bash")>=0?v=2:T.isWindows?v=0:v=2;let m,d=" ";switch(v){case 1:if(m=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),w){const f=(0,t.getDriveLetter)(w);f&&(d+=`${f}:; `),d+=`cd ${m(w)}; `}if(I)for(const f in I){const p=I[f];p===null?d+=`Remove-Item env:${f}; `:d+=`\${env:${f}}='${p}'; `}if(L.length>0){const f=L.shift(),p=P?f:m(f);d+=p[0]==="'"?`& ${p} `:`${p} `;for(const b of L)d+=b==="<"||b===">"||P?b:m(b),d+=" "}break;case 0:if(m=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(p=>f.includes(p))||f.length===0?`"${f}"`:f),w){const f=(0,t.getDriveLetter)(w);f&&(d+=`${f}: && `),d+=`cd ${m(w)} && `}if(I){d+='cmd /C "';for(const f in I){let p=I[f];p===null?d+=`set "${f}=" && `:(p=p.replace(/[&^|<>]/g,b=>`^${b}`),d+=`set "${f}=${p}" && `)}}for(const f of L)d+=f==="<"||f===">"||P?f:m(f),d+=" ";I&&(d+='"');break;case 2:{m=p=>(p=p.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),p.length===0?'""':p);const f=p=>/[^\w@%\/+=,.:^-]/.test(p)?`'${p.replace(/'/g,"'\\''")}'`:p;if(w&&(d+=`cd ${m(w)} ; `),I){d+="/usr/bin/env";for(const p in I){const b=I[p];b===null?d+=` -u ${f(p)}`:d+=` ${f(`${p}=${b}`)}`}d+=" "}for(const p of L)d+=p==="<"||p===">"||P?p:m(p),d+=" ";break}}return d}e.prepareCommand=y}),define(ye[92],Ce([1,0,23,39,64,85,17,11,12,54]),function(te,e,c,t,T,R,k,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var w;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(w=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var p;(function(U){U.scheme=k.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${z.join("")}]+`),ue=7;function V(G,de){const be=de.toString(ue),Pe=`${be.length<z.length?z[be.length-1]:"z"}${be}s${(0,c.encodeBase64)(c.VSBuffer.fromString(G.scheme),!0,!0)}`;return G.with({scheme:U.scheme,fragment:Pe})}U.generate=V;function _(G){if(G.scheme!==U.scheme)return;const de=G.fragment.indexOf("s");if(de<0)return;const be=parseInt(G.fragment.substring(0,de).replace(j,""),ue),Ee=(0,c.decodeBase64)(G.fragment.substring(de+1)).toString();if(!isNaN(be))return{handle:be,notebook:G.with({scheme:Ee,fragment:null})}}U.parse=_;function J(G,de){return G.with({scheme:k.Schemas.vscodeNotebookCellOutput,fragment:`op${de??""},${G.scheme!==k.Schemas.file?G.scheme:""}`})}U.generateCellOutputUri=J;function ne(G){if(G.scheme!==k.Schemas.vscodeNotebookCellOutput)return;const de=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(G.fragment);if(!de)return;const be=de[1]&&de[1]!==""?de[1]:void 0,Ee=de[2];return{outputId:be,notebook:G.with({scheme:Ee||k.Schemas.file,fragment:null})}}U.parseCellOutputUri=ne;function ee(G,de,be){return U.generate(G,de).with({scheme:be})}U.generateCellPropertyUri=ee;function X(G,de){if(G.scheme===de)return U.parse(G.with({scheme:U.scheme}))}U.parseCellPropertyUri=X})(p=e.CellUri||(e.CellUri={}));const b=U=>y.isWindows?U.replace(/\//g,"\\"):U;class S{constructor(z=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(z)].map(ue=>({pattern:ue,matches:t.parse(b(ue))}))}sort(z){const j=new Map(T.Iterable.map(z,V=>[V,b(V)]));let ue=[];for(const{matches:V}of this.d)for(const[_,J]of j)if(V(J)){ue.push(_),j.delete(_);break}return j.size&&(ue=ue.concat([...j.keys()].sort((V,_)=>this.e.indexOf(V)-this.e.indexOf(_)))),ue}prioritize(z,j){const ue=this.f(z);if(ue===-1){this.d.unshift({pattern:z,matches:t.parse(b(z))});return}const V=new Set(j.map(J=>this.f(J,ue)));V.delete(-1);const _=Array.from(V).sort();this.d.splice(ue+1,0,..._.map(J=>this.d[J]));for(let J=_.length-1;J>=0;J--)this.d.splice(_[J],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,j=this.d.length){const ue=b(z);for(let V=0;V<j;V++)if(this.d[V].matches(ue))return V;return-1}}e.MimeTypeDisplayOrder=S;function g(U,z,j,ue=(V,_)=>V===_){const V=[];function _(ee,X,G){if(X===0&&G.length===0)return;const de=V[V.length-1];de&&de.start+de.deleteCount===ee?(de.deleteCount+=X,de.toInsert.push(...G)):V.push({start:ee,deleteCount:X,toInsert:G})}let J=0,ne=0;for(;;){if(J===U.length){_(J,0,z.slice(ne));break}if(ne===z.length){_(J,U.length-J,[]);break}const ee=U[J],X=z[ne];if(ue(ee,X)){J+=1,ne+=1;continue}j(X)?(_(J,1,[]),J+=1):(_(J,0,[X]),ne+=1)}return V}e.diff=g,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(U){U.default="default",U.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(U){const z=U;return!!((typeof z.include=="string"||t.isRelativePattern(z.include))&&(typeof z.exclude=="string"||t.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=l;function s(U,z,j){if(Array.isArray(U.viewType)&&U.viewType.indexOf(z)>=0||U.viewType===z)return!0;if(U.filenamePattern){const ue=l(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,V=l(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(t.match(ue,(0,A.basename)(j.fsPath).toLowerCase()))return!(V&&t.match(V,(0,A.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var a;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(a=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(z){return`${o.d}${z}`}static parse(z){if(z.startsWith(o.d))return z.substring(o.d.length)}}e.NotebookWorkingCopyTypeIdentifier=o,o.d="notebook/";function u(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=u;const i=new TextDecoder;function n(U){const z=[];let j=!1;for(const ue of U)(z.length===0||j)&&(z.push(ue),j=!0);return M(z),O(c.VSBuffer.concat(z.map(ue=>c.VSBuffer.wrap(ue))))}e.compressOutputItemStreams=n;const h=`${String.fromCharCode(27)}[A`,E=h.split("").map(U=>U.charCodeAt(0)),C=10;function M(U){U.forEach((z,j)=>{if(j===0||z.length<h.length)return;const ue=U[j-1],V=z.subarray(0,h.length);if(V[0]===E[0]&&V[1]===E[1]&&V[2]===E[2]){const _=ue.lastIndexOf(C);if(_===-1)return;U[j-1]=ue.subarray(0,_),U[j]=z.subarray(h.length)}})}function K(U){let z=U;do U=z,z=U.replace(/[^\n]\x08/gm,"");while(z.length<U.length);return U}function q(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const z=U.match(/^(.*)\r+/m)[1];let j=U.match(/\r+(.*)$/m)[1];j=j+z.slice(j.length,z.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return U}const F="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(U){return!U.buffer.includes(F)&&!U.buffer.includes(B)?U:c.VSBuffer.fromString(q(K(i.decode(U.buffer))))}}),define(ye[227],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(T){T[T.Output=1]="Output",T[T.OutputItems=2]="OutputItems",T[T.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(ye[228],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=c;function t(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=t;function T(k){return Array.from(k.entries()).map(A=>[A[0],c(A[1].map)])}e.serializeEnvironmentVariableCollections=T;function R(k){return new Map(k.map(A=>[A[0],{map:t(A[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(ye[57],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(R){R.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class T{static fromExtHostTestItem(k,A,y=k.parent){if(k._isRoot)return new T([A]);const D=[k.id];for(let L=y;L&&L.id!==A;L=L.parent)D.push(L.id);return D.push(A),new T(D.reverse())}static isRoot(k){return!k.includes("\0")}static root(k){const A=k.indexOf("\0");return A===-1?k:k.slice(0,A)}static fromString(k){return new T(k.split("\0"))}static join(k,A){return new T([...k.path,A])}static joinToString(k,A){return k.toString()+"\0"+A}static parentId(k){const A=k.lastIndexOf("\0");return A===-1?void 0:k.slice(0,A)}static localId(k){const A=k.lastIndexOf("\0");return A===-1?k:k.slice(A+1)}static compare(k,A){return k===A?0:A.startsWith(k+"\0")?2:k.startsWith(A+"\0")?3:1}constructor(k,A=k.length){if(this.path=k,this.d=A,k.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new T(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let k=1;k<=this.d;k++)yield new T(this.path,k)}*idsToRoot(){for(let k=this.d;k>0;k--)yield new T(this.path,k)}compare(k){if(typeof k=="string")return T.compare(this.toString(),k);for(let A=0;A<k.d&&A<this.d;A++)if(k.path[A]!==this.path[A])return 1;return k.d>this.d?2:k.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let k=1;k<this.d;k++)this.c+="\0",this.c+=this.path[k]}return this.c}}e.TestId=T}),define(ye[73],Ce([1,0,2,36,57]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var k;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable",i[i.SupportsContinuousRun=64]="SupportsContinuousRun"})(k=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=i=>"runIn"in i;e.isStartControllerTests=A;var y;(function(i){i.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),i.deserialize=n=>({range:t.Range.lift(n.range),uri:c.URI.revive(n.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var D;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(D=e.TestMessageType||(e.TestMessageType={}));var L;(function(i){i.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&y.serialize(n.location)}),i.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&y.deserialize(n.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const P=(i,n)=>`${n?"s":"e"}${i}`;e.getMarkId=P;var w;(function(i){i.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&y.serialize(n.location)}),i.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&y.deserialize(n.location)})})(w=e.ITestOutputMessage||(e.ITestOutputMessage={}));var I;(function(i){i.serialize=n=>n.type===0?L.serialize(n):w.serialize(n),i.deserialize=n=>n.type===0?L.deserialize(n):w.deserialize(n)})(I=e.ITestMessage||(e.ITestMessage={}));var v;(function(i){i.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),i.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(I.serialize)}),i.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(I.deserialize)})})(v=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",d=(i,n)=>i+m+n;e.namespaceTestTag=d;const f=i=>{const n=i.indexOf(m);return{ctrlId:i.slice(0,n),tagId:i.slice(n+1)}};e.denamespaceTestTag=f;var p;(function(i){i.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),i.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?c.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(p=e.ITestItem||(e.ITestItem={}));var b;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var S;(function(i){i.serialize=n=>({expand:n.expand,item:p.serialize(n.item)}),i.deserialize=n=>({controllerId:T.TestId.root(n.item.extId),expand:n.expand,item:p.deserialize(n.item)})})(S=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(i){i.serialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.uri!==void 0&&(h.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(h.range=n.item.range?.toJSON()),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}},i.deserialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.range!==void 0&&(h.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const r=(i,n)=>{n.expand!==void 0&&(i.expand=n.expand),n.item!==void 0&&(i.item=i.item?Object.assign(i.item,n.item):n.item)};e.applyTestItemUpdate=r;var l;(function(i){i.serializeWithoutMessages=n=>({...S.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(v.serializeWithoutMessages),retired:n.retired}),i.serialize=n=>({...S.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(v.serialize),retired:n.retired}),i.deserialize=n=>({...S.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(v.deserialize),retired:!0})})(l=e.TestResultItem||(e.TestResultItem={}));var s;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var a;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.DocumentSynced=2]="DocumentSynced",i[i.Remove=3]="Remove",i[i.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",i[i.Retire=5]="Retire",i[i.AddTag=6]="AddTag",i[i.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(i){i.deserialize=n=>n.op===0?{op:n.op,item:S.deserialize(n.item)}:n.op===1?{op:n.op,item:g.deserialize(n.item)}:n.op===2?{op:n.op,uri:c.URI.revive(n.uri),docv:n.docv}:n,i.serialize=n=>n.op===0?{op:n.op,item:S.serialize(n.item)}:n.op===1?{op:n.op,item:g.serialize(n.item)}:n})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class u{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const h=this.o();for(const E of n)switch(E.op){case 0:this.j(S.deserialize(E.item),h);break;case 1:this.k(g.deserialize(E.item),h);break;case 3:this.l(E.itemId,h);break;case 5:this.m(E.itemId);break;case 4:this.updatePendingRoots(E.amount);break;case 6:this.c.set(E.tag.id,E.tag);break;case 7:this.c.delete(E.id);break}h.complete?.()}j(n,h){const E=T.TestId.parentId(n.item.extId)?.toString();let C;if(!E)C=this.p(n),this.f.add(C),this.d.set(n.item.extId,C);else if(this.d.has(E)){const M=this.d.get(E);M.children.add(n.item.extId),C=this.p(n,M),this.d.set(n.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return h.add?.(C),n.expand===2&&this.g++,C}k(n,h){const E=this.d.get(n.extId);if(!!E)return n.expand!==void 0&&(E.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(E,n),h.update?.(E),E}l(n,h){const E=this.d.get(n);if(!E)return;const C=T.TestId.parentId(E.item.extId)?.toString();C?this.d.get(C).children.delete(E.item.extId):this.f.delete(E);const M=[[n]];for(;M.length;)for(const K of M.pop()){const q=this.d.get(K);q&&(M.push(q.children),this.d.delete(K),h.remove?.(q,q!==E),q.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=u}),define(ye[93],Ce([1,0,14,3,6,51,73,57]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const D=(p,b)=>p===b,P=Object.entries({range:(p,b)=>p===b?!0:!p||!b?!1:p.equalsRange(b),busy:D,label:D,description:D,error:D,sortText:D,tags:(p,b)=>!(p.length!==b.length||p.some(S=>!b.includes(S)))}),w=(p,b)=>{let S;for(const[g,r]of P)r(p[g],b[g])||(S?S[g]=b[g]:S={[g]:b[g]});return S};class I extends T.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const S of this.tree.values())this.G(S)}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const S of this.k)if(S.op===2&&S.uri===b.uri){S.docv=b.docv;return}break}case 1:{const S=this.k[this.k.length-1];if(S){if(S.op===1&&S.item.extId===b.item.extId){(0,k.applyTestItemUpdate)(S.item,b.item);return}if(S.op===0&&S.item.item.extId===b.item.extId){(0,k.applyTestItemUpdate)(S.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,S){const g=this.tree.get(b);if(!!g){if((g.expandLevels===void 0||S>g.expandLevels)&&(g.expandLevels=S),g.expand===1){const r=this.I(g);return r.isOpen()?this.H(g,S-1):r.wait().then(()=>this.H(g,S-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.H(g,S-1)):this.H(g,S-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,S){switch(S.op){case 3:this.L(A.TestId.joinToString(b.fullId,S.id));break;case 0:this.u(S.item,b);break;case 5:for(const g of S.ops)this.p(b,g);break;case 1:this.w(S.new,S.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:S.update}});break;case 6:this.s(b.actual.uri);break;default:(0,R.assertNever)(S)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,S){const g=A.TestId.fromExtHostTestItem(b,this.root.id,S?.actual),r=this.m.getApiFor(b);r.parent&&r.parent!==S?.actual&&this.m.getChildren(r.parent).delete(b.id);let l=this.tree.get(g.toString());if(!l){l={fullId:g,actual:b,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(l.fullId.toString(),l),this.C(b,S),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:l.expand,item:this.m.toITestItem(b)}}),this.F(b,l,S);return}if(l.actual===b){this.D(b,l,S);return}if(l.actual.uri?.toString()!==b.uri?.toString())return this.L(g.toString()),this.u(b,S);const s=this.m.getChildren(l.actual),a=l.actual,o=w(this.m.toITestItem(a),this.m.toITestItem(b));this.m.getApiFor(a).listener=void 0,l.actual=b,l.expand=0,o&&(o.hasOwnProperty("tags")&&(this.w(b.tags,a.tags,g.toString()),delete o.tags),this.p(l,{op:4,update:o})),this.F(b,l,S);for(const[u,i]of s)this.m.getChildren(b).get(i.id)||this.L(A.TestId.joinToString(g,i.id));this.s(l.actual.uri)}w(b,S,g){const r=new Set(S.map(l=>l.id));for(const l of b)r.delete(l.id)||this.y(l);this.pushDiff({op:1,item:{extId:g,item:{tags:b.map(l=>(0,k.namespaceTestTag)(this.m.controllerId,l.id))}}}),r.forEach(this.z,this)}y(b){const S=this.j.get(b.id);S?S.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,k.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const S=this.j.get(b);S&&!--S.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,k.namespaceTestTag)(this.m.controllerId,b)}))}C(b,S){this.m.getApiFor(b).parent=S&&S.actual!==this.root?S.actual:void 0}D(b,S,g){this.C(b,g);const r=this.m.getApiFor(b);r.parent=g?.actual,r.listener=l=>this.p(S,l),this.G(S)}F(b,S,g){this.D(b,S,g);for(const[r,l]of this.m.getChildren(b))this.u(l,S)}G(b){let S;this.h?b.resolveBarrier?S=b.resolveBarrier.isOpen()?3:2:S=b.actual.canResolveChildren?1:0:S=0,S!==b.expand&&(b.expand=S,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:S}}),S===1&&b.expandLevels!==void 0&&this.I(b))}H(b,S){if(S<0)return;const g=[];for(const[r,l]of this.m.getChildren(b.actual)){const s=this.expand(A.TestId.joinToString(b.fullId,l.id),S);(0,c.isThenable)(s)&&g.push(s)}if(g.length)return Promise.all(g).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const l=new c.Barrier;return l.open(),l}b.expand=2,this.J(b);const S=b.resolveBarrier=new c.Barrier,g=l=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,l)};let r;try{r=this.h(b.actual===this.root?void 0:b.actual)}catch(l){g(l)}return(0,c.isThenable)(r)?r.catch(g).then(()=>{S.open(),this.G(b)}):(S.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const S=this.tree.get(b);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const g=[S];for(;g.length;){const r=g.pop();if(!!r){this.m.getApiFor(r.actual).listener=void 0;for(const l of r.actual.tags)this.z(l.id);this.tree.delete(r.fullId.toString());for(const[l,s]of this.m.getChildren(r.actual))g.push(this.tree.get(A.TestId.joinToString(r.fullId,s.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=I;class v extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=v;class m extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class d extends Error{constructor(b,S,g){super(`TestItem with ID "${b}" is from controller "${S}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=d;const f=(p,b,S)=>{let g=new Map;return{get size(){return g.size},forEach(r,l){for(const s of g.values())r.call(l,s,this)},[Symbol.iterator](){return g.entries()},replace(r){const l=new Map,s=new Set(g.keys()),a={op:5,ops:[]};for(const o of r){if(!(o instanceof S))throw new m(o.id);const u=b(o).controllerId;if(u!==p.controllerId)throw new d(o.id,u,p.controllerId);if(l.has(o.id))throw new v(o.id);l.set(o.id,o),s.delete(o.id),a.ops.push({op:0,item:o})}for(const o of s.keys())a.ops.push({op:3,id:o});p.listener?.(a),g=l},add(r){if(!(r instanceof S))throw new m(r.id);g.set(r.id,r),p.listener?.({op:0,item:r})},delete(r){g.delete(r)&&p.listener?.({op:3,id:r})},get(r){return g.get(r)},toJSON(){return Array.from(g.values())}}};e.createTestItemChildren=f}),define(ye[132],Ce([1,0,93]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,T=(k,A)=>{const y={controllerId:A};return t.set(k,y),y};e.createPrivateApiFor=T;const R=k=>{const A=t.get(k);if(!A)throw new c.InvalidTestItemError(k?.id||"<unknown>");return A};e.getPrivateApiFor=R}),define(ye[94],Ce([1,0,17,2]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function T(A,y){return A.scheme===c.Schemas.http||A.scheme===c.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===c.Schemas.file&&(A=t.URI.from({scheme:c.Schemas.vscodeRemote,authority:y.authority,path:A.path})),t.URI.from({scheme:c.Schemas.https,authority:`${A.scheme}+${R(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=T;function R(A){return A.replace(/./g,y=>{const D=y.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?y:"-"+D.toString(16).padStart(4,"0")})}function k(A){return A.replace(/-([0-9a-f]{4})/g,(y,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=k}),define(ye[229],Ce([1,0,3,6,94]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(A,y,D){this.d=A,this.e=y,this.f=D,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const P of this.c.values())L.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,y,D,L,P){let w;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===A){w=b;break}if(!w)throw new Error("not a visible editor");const I=this,v=this.a++,m=new c.Emitter,d=new c.Emitter,f=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,T.asWebviewUri)(b,I.f)}get cspSource(){return T.webviewGenericCspSource}set options(b){this.b=b,I.d.$setOptions(v,b)}get options(){return this.b}set html(b){this.a=b,I.d.$setHtml(v,b)}get html(){return this.a}get onDidReceiveMessage(){return m.event}postMessage(b){return I.d.$postMessage(v,b)}},p=new class{constructor(){this.editor=A,this.line=y,this.height=D,this.webview=f,this.onDidDispose=d.event}dispose(){I.c.has(v)&&(I.c.delete(v),I.d.$disposeEditorInset(v),d.fire(),d.dispose(),m.dispose())}};return this.d.$createEditorInset(v,w.id,w.value.document.uri,y+1,D,L||{},P.identifier,P.extensionLocation),this.c.set(v,{editor:A,inset:p,onDidReceiveMessage:m}),p}$onDidDispose(A){const y=this.c.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this.c.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=R}),define(ye[230],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,c.createDecorator)("configurationResolverService");var t;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class T extends Error{constructor(k,A){super(A),this.variable=k}}e.VariableError=T}),define(ye[231],Ce([1,0,11,37,10,22,12,113,192,230,8]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(I,v,m,d){this.g=new Map,this.a=I,this.b=v,this.d=m,d&&(this.c=d.then(f=>this.h(f)))}h(I){if(k.isWindows){const v=Object.create(null);return Object.keys(I).forEach(m=>{v[m.toLowerCase()]=I[m]}),v}return I}resolveWithEnvironment(I,v,m){return this.j({env:this.h(I),userHome:void 0},v?v.uri:void 0,m)}async resolveAsync(I,v){const m={env:await this.c,userHome:await this.d};return this.j(m,I?I.uri:void 0,v)}async i(I,v,m,d){const f=R.deepClone(v);k.isWindows&&f.windows?Object.keys(f.windows).forEach(b=>f[b]=f.windows[b]):k.isMacintosh&&f.osx?Object.keys(f.osx).forEach(b=>f[b]=f.osx[b]):k.isLinux&&f.linux&&Object.keys(f.linux).forEach(b=>f[b]=f.linux[b]),delete f.windows,delete f.osx,delete f.linux;const p={env:await this.c,userHome:await this.d};return this.j(p,I?I.uri:void 0,f,m,d)}async resolveAnyAsync(I,v,m){return this.i(I,v,m)}async resolveAnyMap(I,v,m){const d=new Map;return{newConfig:await this.i(I,v,m,d),resolvedVariables:d}}resolveWithInteractionReplace(I,v,m,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,v,m,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,v){if(this.g.has(I))throw new Error("Variable "+I+" is contributed twice.");this.g.set(I,v)}async j(I,v,m,d,f){if(T.isString(m))return this.l(I,v,m,d,f);if(Array.isArray(m))return Promise.all(m.map(p=>this.j(I,v,p,d,f)));if(T.isObject(m)){const p=Object.create(null),b=await Promise.all(Object.keys(m).map(async S=>[await this.l(I,v,S,d,f),await this.j(I,v,m[S],d,f)]));for(const[S,g]of b)p[S]=g;return p}return m}l(I,v,m,d,f){return(0,L.replaceAsync)(m,P.VARIABLE_REGEXP,async(p,b)=>{if(b.includes(P.VARIABLE_LHS))return p;let S=await this.n(I,p,b,v,d);return f?.set(b,S),S!==p&&T.isString(S)&&S.match(P.VARIABLE_REGEXP)&&(S=await this.l(I,v,S,d,f)),S})}m(I){return this.b?this.b.getUriLabel(I,{noPrefix:!0}):I.fsPath}async n(I,v,m,d,f){let p;const b=m.split(":");b.length>1&&(m=b[0],p=b[1]);const S=l=>{const s=this.a.getFilePath();if(s)return(0,A.normalizeDriveLetter)(s);throw new D.VariableError(l,(0,y.localize)(0,null,v))},g=l=>{const s=S(l);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,A.normalizeDriveLetter)(a)}throw new D.VariableError(l,(0,y.localize)(1,null,v,c.basename(s)))},r=l=>{if(p){const s=this.a.getFolderUri(p);if(s)return s;throw new D.VariableError(l,(0,y.localize)(2,null,v,p))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new D.VariableError(l,(0,y.localize)(3,null,v)):new D.VariableError(l,(0,y.localize)(4,null,v))};switch(m){case"env":if(p){if(I.env){const l=I.env[k.isWindows?p.toLowerCase():p];if(T.isString(l))return l}return""}throw new D.VariableError(D.VariableKind.Env,(0,y.localize)(5,null,v));case"config":if(p){const l=this.a.getConfigurationValue(d,p);if(T.isUndefinedOrNull(l))throw new D.VariableError(D.VariableKind.Config,(0,y.localize)(6,null,v,p));if(T.isObject(l))throw new D.VariableError(D.VariableKind.Config,(0,y.localize)(7,null,v,p));return l}throw new D.VariableError(D.VariableKind.Config,(0,y.localize)(8,null,v));case"command":return this.o(D.VariableKind.Command,v,p,f,"command");case"input":return this.o(D.VariableKind.Input,v,p,f,"input");case"extensionInstallFolder":if(p){const l=await this.a.getExtension(p);if(!l)throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,v,p));return this.m(l.extensionLocation)}throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,v));default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(r(D.VariableKind.WorkspaceFolder)));case"cwd":return d||p?(0,A.normalizeDriveLetter)(this.m(r(D.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(c.basename(this.m(r(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(I.userHome)return I.userHome;throw new D.VariableError(D.VariableKind.UserHome,(0,y.localize)(11,null,v))}case"lineNumber":{const l=this.a.getLineNumber();if(l)return l;throw new D.VariableError(D.VariableKind.LineNumber,(0,y.localize)(12,null,v))}case"selectedText":{const l=this.a.getSelectedText();if(l)return l;throw new D.VariableError(D.VariableKind.SelectedText,(0,y.localize)(13,null,v))}case"file":return S(D.VariableKind.File);case"fileWorkspaceFolder":return g(D.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||p?c.relative(this.m(r(D.VariableKind.RelativeFile)),S(D.VariableKind.RelativeFile)):S(D.VariableKind.RelativeFile);case"relativeFileDirname":{const l=c.dirname(S(D.VariableKind.RelativeFileDirname));if(d||p){const s=c.relative(this.m(r(D.VariableKind.RelativeFileDirname)),l);return s.length===0?".":s}return l}case"fileDirname":return c.dirname(S(D.VariableKind.FileDirname));case"fileExtname":return c.extname(S(D.VariableKind.FileExtname));case"fileBasename":return c.basename(S(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const l=c.basename(S(D.VariableKind.FileBasenameNoExtension));return l.slice(0,l.length-c.extname(l).length)}case"fileDirnameBasename":return c.basename(c.dirname(S(D.VariableKind.FileDirnameBasename)));case"execPath":{const l=this.a.getExecPath();return l||v}case"execInstallFolder":{const l=this.a.getAppRoot();return l||v}case"pathSeparator":return c.sep;default:try{const l=p?`${m}:${p}`:m;return this.o(D.VariableKind.Unknown,v,l,f,void 0)}catch{return v}}}}o(I,v,m,d,f){if(m&&d){const p=f===void 0?d[m]:d[f+":"+m];if(typeof p=="string")return p;throw new D.VariableError(I,(0,y.localize)(14,null,v))}return v}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[133],Ce([1,0,4,130]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var T;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var R;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var A;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function D(v){const m=v;return(0,t.isEditorInput)(m?.editor)&&(0,t.isEditorInput)(m?.replacement)}e.isEditorReplacement=D;var L;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function w(v){const m=v;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.isEditorGroup=w;function I(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(ye[232],Ce([1,0,4,133]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function T(R){const k=R;return typeof R=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=T}),define(ye[233],Ce([1,0,4,198]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[134],Ce([1,0,27,3,11]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=R;class k{static isHostExtension(P,w,I){if(w.getExtensionDescription(P))return!1;const v=I.getExtensionDescription(P);return v?!!((v.main||v.browser)&&v.api==="none"):!1}constructor(P){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(c.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(c.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let w of P.activationEvents)w==="onUri"&&(w=`onUri:${c.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(w)||this.g.set(w,[]),this.g.get(w).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,w){this.d=D(this.d,w),this.d=this.d.concat(P);const I=k.j(this.d);return this.d=D(this.d,I.map(v=>v.identifier)),this.h(),this.c.fire(void 0),new R(I)}static j(P){const w=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,p){this.addNode(f),this.addNode(p),this.c.has(f)?this.c.get(f).push(p):this.c.set(f,[p])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,p){const b=w.getArcs(f);for(let S=0;S<b.length;S++)if(!p.has(b[S]))return!1;return!0}getNodes(){return this.e}},I=new Map;for(const f of P){const p=c.ExtensionIdentifier.toKey(f.identifier);if(I.set(p,f),f.extensionDependencies)for(const b of f.extensionDependencies){const S=c.ExtensionIdentifier.toKey(b);w.addArc(p,S)}}const v=new Set;w.getNodes().filter(f=>w.getArcs(f).length===0).forEach(f=>v.add(f));const m=w.getNodes().filter(f=>!v.has(f));let d;do{d=!1;for(let f=0;f<m.length;f++){const p=m[f];w.hasOnlyGoodArcs(p,v)&&(m.splice(f,1),f--,v.add(p),d=!0)}}while(d);return m.map(f=>I.get(f))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(c.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const w=this.g.get(P);return w?w.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const w=this.e.get(c.ExtensionIdentifier.toKey(P));return w||void 0}getExtensionDescriptionByUUID(P){for(const w of this.f)if(w.uuid===P)return w}getExtensionDescriptionByIdOrUUID(P,w){return this.getExtensionDescription(P)??(w?this.getExtensionDescriptionByUUID(w):void 0)}}e.ExtensionDescriptionRegistry=k;var A;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(A||(A={}));function y(L,P){const w=L.isBuiltin?0:L.isUnderDevelopment?2:1,I=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(w!==I)return w-I;const v=T.posix.basename(L.extensionLocation.path),m=T.posix.basename(P.extensionLocation.path);return v<m?-1:v>m?1:0}function D(L,P){const w=new Set;return P.forEach(I=>w.add(c.ExtensionIdentifier.toKey(I))),L.filter(I=>!w.has(c.ExtensionIdentifier.toKey(I.identifier)))}}),define(ye[234],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var c;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(c=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class T{constructor(){this.type=2}serialize(P){P[T.ENV_KEY]="1"}}e.SocketExtHostConnection=T,T.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class R{constructor(){this.type=3}serialize(P){P[R.ENV_KEY]="1"}}e.MessagePortExtHostConnection=R,R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function k(L){delete L[t.ENV_KEY],delete L[T.ENV_KEY],delete L[R.ENV_KEY]}function A(L,P){k(P),L.serialize(P)}e.writeExtHostConnection=A;function y(L){if(L[t.ENV_KEY])return D(L,new t(L[t.ENV_KEY]));if(L[T.ENV_KEY])return D(L,new T);if(L[R.ENV_KEY])return D(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function D(L,P){return k(L),P}}),define(ye[95],Ce([1,0,23]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var T;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function k(D){const L=c.VSBuffer.alloc(1);switch(D){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=k;function A(D,L){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=A;var y;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[96],Ce([1,0,4,3,13,25,95,69,70,22,2]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let P=class{constructor(m,d){this.i=m,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=d.createLogger(L.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(m,d,f){const p=this.getTelemetryDetails(),b=new w(d,f,m,this.g,this.f,this.getBuiltInCommonProperties(m),{isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled});return this.h.set(m.identifier.value,b),b.apiTelemetryLogger}$initializeTelemetryLevel(m,d,f){this.d=m,this.f=d,this.c=f??{usage:!0,error:!0}}getBuiltInCommonProperties(m){const d={};switch(d["common.extname"]=`${m.publisher}.${m.name}`,d["common.extversion"]=m.version,d["common.vscodemachineid"]=this.i.telemetryInfo.machineId,d["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,d["common.vscodeversion"]=this.i.version,d["common.isnewappinstall"]=I(this.i.telemetryInfo.firstSessionDate),d["common.product"]=this.i.environment.appHost,this.i.uiKind){case k.UIKind.Web:d["common.uikind"]="web";break;case k.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.i.remote.authority)),d}$onDidChangeTelemetryLevel(m){this.e=this.getTelemetryConfiguration(),this.d=m;const d=this.getTelemetryDetails();this.h.forEach(f=>{f.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(m,d){const f=this.h.get(m.value);return!f||f.ignoreUnhandledExtHostErrors?!1:(f.logError(d),!0)}};P=qe([We(0,R.IExtHostInitDataService),We(1,T.ILoggerService)],P),e.ExtHostTelemetry=P;class w{constructor(m,d,f,p,b,S,g){this.g=f,this.h=p,this.i=b,this.j=S,this.b=new t.Emitter,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.e=d?.ignoreBuiltInCommonProperties??!1,this.f=d?.additionalCommonProperties,this.a=m,this.c={isUsageEnabled:g.isUsageEnabled,isErrorsEnabled:g.isErrorsEnabled}}updateTelemetryEnablements(m,d){this.d&&(this.c={isUsageEnabled:m,isErrorsEnabled:d},this.b.fire(this.d))}mixInCommonPropsAndCleanData(m){let d=m.properties??m;return d=(0,y.cleanData)(d,[]),this.f&&(d=(0,D.mixin)(d,this.f)),this.e||(d=(0,D.mixin)(d,this.j)),m.properties?m.properties=d:m=d,m}k(m,d){this.g.publisher==="vscode"?m=this.g.name+"/"+m:m=this.g.identifier.value+"/"+m,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.a.sendEventData(m,d),this.h.trace(m,d)}logUsage(m,d){!this.c.isUsageEnabled||this.k(m,d)}logError(m,d){!this.c.isErrorsEnabled||(typeof m=="string"?this.k(m,d):this.a.sendErrorData(m,d))}get apiTelemetryLogger(){if(!this.d){const m=this,d={logUsage:m.logUsage.bind(m),get isUsageEnabled(){return m.c.isUsageEnabled},get isErrorsEnabled(){return m.c.isErrorsEnabled},logError:m.logError.bind(m),dispose:m.dispose.bind(m),onDidChangeEnableStates:m.b.event.bind(m)};this.d=Object.freeze(d)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=w;function I(v){const m=Date.now()-new Date(v).getTime();return isNaN(m)?!1:m<1e3*60*60*24}e.isNewAppInstall=I,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(ye[26],Ce([1,0,3,2,4,27,210]),function(te,e,c,t,T,R,k){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class y{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class D{constructor(u){this.affinity=u,this.kind=2}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=D;class L{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class P{constructor(u){this.dependency=u}}e.MissingExtensionDependency=P;var w;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(w=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=I;class v{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(u,i){const n=[],h=[],E=[],C=[],M=f(this.c),K=f(u),q=(U,z)=>U.extensionLocation.toString()===z.extensionLocation.toString()||U.isBuiltin===z.isBuiltin||U.isUserBuiltin===z.isUserBuiltin||U.isUnderDevelopment===z.isUnderDevelopment;for(const U of this.c){const z=K.get(R.ExtensionIdentifier.toKey(U.identifier));if(!z){n.push(U.identifier),M.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}if(!q(U,z)){n.push(U.identifier),M.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}}for(const U of u){const z=M.get(R.ExtensionIdentifier.toKey(U.identifier));if(!z){h.push(U);continue}if(!q(z,U)){n.push(z.identifier),M.delete(R.ExtensionIdentifier.toKey(z.identifier));continue}}const F=d(this.d),B=d(i);for(const U of this.d)B.has(R.ExtensionIdentifier.toKey(U))||E.push(U);for(const U of i)F.has(R.ExtensionIdentifier.toKey(U))||C.push(U);const O={toRemove:n,toAdd:h,myToRemove:E,myToAdd:C};return this.delta(O),O}delta(u){const{toRemove:i,toAdd:n,myToRemove:h,myToAdd:E}=u,C=d(i),M=d(h);for(let K=0;K<this.c.length;K++)C.has(R.ExtensionIdentifier.toKey(this.c[K].identifier))&&(this.c.splice(K,1),K--);for(let K=0;K<this.d.length;K++)M.has(R.ExtensionIdentifier.toKey(this.d[K]))&&(this.d.splice(K,1),K--);for(const K of n)this.c.push(K);for(const K of E)this.d.push(K)}containsExtension(u){for(const i of this.d)if(R.ExtensionIdentifier.equals(i,u))return!0;return!1}}e.ExtensionHostExtensions=v;class m{constructor(u){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,u)for(const i of u)this.add(i)}get size(){return this.c.size}add(u){return this.c.set(this.d(u),u),this}clear(){this.c.clear()}delete(u){return this.c.delete(this.d(u))}has(u){return this.c.has(this.d(u))}forEach(u,i){this.c.forEach(n=>u.call(i,n,n,this))}*entries(){for(const[u,i]of this.c)yield[i,i]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=m;function d(o){const u=new Set;for(const i of o)u.add(R.ExtensionIdentifier.toKey(i));return u}e.extensionIdentifiersArrayToSet=d;function f(o){const u=new Map;for(const i of o)u.set(R.ExtensionIdentifier.toKey(i.identifier),i);return u}function p(o,u){return o.enabledApiProposals?o.enabledApiProposals.includes(u):!1}e.isProposedApiEnabled=p;function b(o,u){if(!p(o,u))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=b;class S{constructor(u,i,n,h){this.codeLoadingTime=u,this.activateCallTime=i,this.activateResolvedTime=n,this.activationReason=h}}e.ActivationTimes=S;class g{constructor(u,i){this.description=u,this.value=i}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var r;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function l(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=l;function s(o,u){return{identifier:new R.ExtensionIdentifier((0,k.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!u,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=s;class a{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,i){return Promise.resolve(0)}getInspectPorts(u,i){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=a}),define(ye[235],Ce([1,0,9,134,27,26,13,14]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(f,p,b,S){this.startup=f,this.codeLoadingTime=p,this.activateCallTime=b,this.activateResolvedTime=S}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class D{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,p){return f===-1||p===-1?-1:p-f}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=D;class L{constructor(f,p,b,S,g,r){this.activationFailed=f,this.activationFailedError=p,this.activationTimes=b,this.module=S,this.exports=g,this.subscriptions=r}}e.ActivatedExtension=L;class P extends L{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class w extends L{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=w;class I extends L{constructor(f){super(!0,f,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(f,p,b,S){this.g=S,this.a=f,this.b=p,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[f,p]of this.d)p.dispose()}isActivated(f){const p=this.d.get(T.ExtensionIdentifier.toKey(f));return Boolean(p&&p.value)}getActivatedExtension(f){const p=this.d.get(T.ExtensionIdentifier.toKey(f));if(!p||!p.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return p.value}async activateByEvent(f,p){if(this.f[f])return;const b=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(b.map(S=>({id:S.identifier,reason:{startup:p,extensionId:S.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,p){const b=this.a.getExtensionDescription(f);if(!b)throw new Error(`Extension '${f}' is not known`);return this.h([{id:b.identifier,reason:p}])}async h(f){const p=f.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(p.map(b=>b.wait()))}j(f){if(this.d.has(T.ExtensionIdentifier.toKey(f.id)))return this.d.get(T.ExtensionIdentifier.toKey(f.id));if(this.l(f.id))return this.k(f,null,[],null);const p=this.a.getExtensionDescription(f.id);if(!p){const g=new Error(`Cannot activate unknown extension '${f.id.value}'`),r=this.k(f,null,[],new I(g));return this.c.onExtensionActivationError(f.id,g,new R.MissingExtensionDependency(f.id.value)),r}const b=[],S=typeof p.extensionDependencies>"u"?[]:p.extensionDependencies;for(const g of S){if(this.m(g))continue;const r=this.d.get(T.ExtensionIdentifier.toKey(g));if(r){b.push(r);continue}if(this.l(g)){b.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:f.reason}));continue}const l=this.a.getExtensionDescription(g);if(l){if(!l.main&&!l.browser)continue;b.push(this.j({id:l.identifier,reason:f.reason}));continue}const s=p.displayName||p.identifier.value,a=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${g}'`),o=this.k(f,p.displayName,[],new I(a));return this.c.onExtensionActivationError(p.identifier,a,new R.MissingExtensionDependency(g)),o}return this.k(f,p.displayName,b,null)}k(f,p,b,S){const g=new m(f.id,p,f.reason,b,S,this.c,this.g);return this.d.set(T.ExtensionIdentifier.toKey(f.id),g),g}l(f){return t.ExtensionDescriptionRegistry.isHostExtension(f,this.a,this.b)}m(f){const p=this.b.getExtensionDescription(f);return p?!p.main&&!p.browser:!1}};v=qe([We(3,k.ILogService)],v),e.ExtensionsActivator=v;let m=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,p,b,S,g,r,l){this.c=f,this.d=p,this.f=b,this.g=S,this.h=g,this.j=r,this.k=l,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const p=this.g[f];if(p.value&&!p.value.activationFailed){this.g.splice(f,1),f--;continue}if(p.value&&p.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);b.detail=p.value.activationFailedError,this.h=new I(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const p=new Error;if(f&&f.name&&(p.name=f.name),f&&f.message?p.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:p.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(p.stack=f.stack),this.h=new I(p),this.b&&c.isCancellationError(f))return;this.j.onExtensionActivationError(this.c,p,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};m=qe([We(6,k.ILogService)],m)}),define(ye[236],Ce([1,0,13,25,26]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends c.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:T.ExtensionHostLogFileName}))}};R=qe([We(0,c.ILoggerService),We(1,t.IExtHostInitDataService)],R),e.ExtHostLogService=R});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,c):T?T.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[7],Ce([1,0,16,9,112,28,85,8,10,2,30,40,128,92,26]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v){"use strict";var m,d,f,p,b,S,g,r,l,s,a,o,u,i,n,h,E,C,M,K,q,F,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(x){return Object.assign(x,{apply:function(){const me=arguments.length===1?[]:arguments[1];return Reflect.construct(x,me,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[me,...Te]=arguments;return Reflect.construct(x,Te,me.constructor)}}})}var U;(function(x){x[x.Top=0]="Top",x[x.Bottom=1]="Bottom"})(U=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function(x){x[x.Command=0]="Command",x[x.Opener=1]="Opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=S=class{static from(...W){let me=W;return new S(function(){if(me){for(const Te of me)Te&&typeof Te.dispose=="function"&&Te.dispose();me=void 0}})}constructor(W){m.set(this,void 0),Je(this,m,W,"f")}dispose(){typeof Ue(this,m,"f")=="function"&&(Ue(this,m,"f").call(this),Je(this,m,void 0,"f"))}};m=new WeakMap,j=S=qe([O],j),e.Disposable=j;let ue=g=class{static Min(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isBefore(me)&&(me=Ke)}return me}static Max(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isAfter(me)&&(me=Ke)}return me}static isPosition(W){if(!W)return!1;if(W instanceof g)return!0;const{line:me,character:Te}=W;return typeof me=="number"&&typeof Te=="number"}static of(W){if(W instanceof g)return W;if(this.isPosition(W))return new g(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,me){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(me<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=W,this.e=me}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,me=0){if(W===null||me===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,me=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&me===0?this:new g(this.line+Te,this.character+me)}with(W,me=this.character){if(W===null||me===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,me=typeof W.character=="number"?W.character:this.character),Te===this.line&&me===this.character?this:new g(Te,me)}toJSON(){return{line:this.line,character:this.character}}};ue=g=qe([O],ue),e.Position=ue;let V=r=class{static isRange(W){return W instanceof r?!0:W?ue.isPosition(W.start)&&ue.isPosition(W.end):!1}static of(W){if(W instanceof r)return W;if(this.isRange(W))return new r(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,me,Te,Ke){let Ye,ct;if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new ue(W,me),ct=new ue(Te,Ke)):ue.isPosition(W)&&ue.isPosition(me)&&(Ye=ue.of(W),ct=ue.of(me)),!Ye||!ct)throw new Error("Invalid arguments");Ye.isBefore(ct)?(this.c=Ye,this.e=ct):(this.c=ct,this.e=Ye)}contains(W){return r.isRange(W)?this.contains(W.start)&&this.contains(W.end):ue.isPosition(W)?!(ue.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const me=ue.Max(W.start,this.c),Te=ue.Min(W.end,this.e);if(!me.isAfter(Te))return new r(me,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const me=ue.Min(W.start,this.c),Te=ue.Max(W.end,this.end);return new r(me,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,me=this.end){if(W===null||me===null)throw(0,t.illegalArgument)();let Te;return W?ue.isPosition(W)?Te=W:(Te=W.start||this.start,me=W.end||this.end):Te=this.start,Te.isEqual(this.c)&&me.isEqual(this.end)?this:new r(Te,me)}toJSON(){return[this.start,this.end]}};V=r=qe([O],V),e.Range=V;let _=l=class extends V{static isSelection(W){return W instanceof l?!0:W?V.isRange(W)&&ue.isPosition(W.anchor)&&ue.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,me,Te,Ke){let Ye,ct;if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new ue(W,me),ct=new ue(Te,Ke)):ue.isPosition(W)&&ue.isPosition(me)&&(Ye=ue.of(W),ct=ue.of(me)),!Ye||!ct)throw new Error("Invalid arguments");super(Ye,ct),this.f=Ye,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};_=l=qe([O],_),e.Selection=_;class J{constructor(W,me,Te){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(me),this.connectionToken=Te}}e.ResolvedAuthority=J;class ne extends Error{static NotAvailable(W,me){return new ne(W,w.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(W){return new ne(W,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,me=w.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=me,this._detail=Te,Object.setPrototypeOf(this,ne.prototype)}}e.RemoteAuthorityResolverError=ne;var ee;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(ee=e.EndOfLine||(e.EndOfLine={}));var X;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(X=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=s=class{static isTextEdit(W){return W instanceof s?!0:W?V.isRange(W)&&typeof W.newText=="string":!1}static replace(W,me){return new s(W,me)}static insert(W,me){return s.replace(new V(W,W),me)}static delete(W){return s.replace(W,"")}static setEndOfLine(W){const me=new s(new V(new ue(0,0),new ue(0,0)),"");return me.newEol=W,me}get range(){return this.c}set range(W){if(W&&!V.isRange(W))throw(0,t.illegalArgument)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this.f=W}constructor(W,me){this.c=W,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};G=s=qe([O],G),e.TextEdit=G;let de=a=class{static isNotebookCellEdit(W){return W instanceof a?!0:W?Xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,me){return new a(W,me)}static insertCells(W,me){return new a(new Xt(W,W),me)}static deleteCells(W){return new a(W,[])}static updateCellMetadata(W,me){const Te=new a(new Xt(W,W),[]);return Te.newCellMetadata=me,Te}static updateNotebookMetadata(W){const me=new a(new Xt(0,0),[]);return me.newNotebookMetadata=W,me}constructor(W,me){this.range=W,this.newCells=me}};de=a=qe([O],de),e.NotebookEdit=de;class be{static isSnippetTextEdit(W){return W instanceof be?!0:W?V.isRange(W.range)&&Fe.isSnippetString(W.snippet):!1}static replace(W,me){return new be(W,me)}static insert(W,me){return be.replace(new V(W,W),me)}constructor(W,me){this.range=W,this.snippet=me}}e.SnippetTextEdit=be;var Ee;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,me,Te,Ke){this.c.push({_type:1,from:W,to:me,options:Te,metadata:Ke})}createFile(W,me,Te){this.c.push({_type:1,from:void 0,to:W,options:me,metadata:Te})}deleteFile(W,me,Te){this.c.push({_type:1,from:W,to:void 0,options:me,metadata:Te})}e(W,me,Te){this.c.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:me},notebookMetadata:me})}f(W,me,Te,Ke){const Ye=me.start,ct=me.end;(Ye!==ct||Te.length>0)&&this.c.push({_type:5,uri:W,index:Ye,count:ct-Ye,cells:Te,metadata:Ke})}g(W,me,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:W,edit:{editType:8,index:me,metadata:Te}})}replace(W,me,Te,Ke){this.c.push({_type:2,uri:W,edit:new G(me,Te),metadata:Ke})}insert(W,me,Te,Ke){this.replace(W,new V(me,me),Te,Ke)}delete(W,me,Te){this.replace(W,me,"",Te)}has(W){return this.c.some(me=>me._type===2&&me.uri.toString()===W.toString())}set(W,me){if(me)for(const Te of me){if(!Te)continue;let Ke,Ye;Array.isArray(Te)?(Ke=Te[0],Ye=Te[1]):Ke=Te,de.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(W,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(W,Ke.newNotebookMetadata,Ye):this.f(W,Ke.range,Ke.newCells,Ye):be.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:W,edit:Ke,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this.c[Te]=void 0);break}}(0,c.coalesceInPlace)(this.c)}}get(W){const me=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===W.toString()&&me.push(Te.edit);return me}entries(){const W=new R.ResourceMap;for(const me of this.c)if(me._type===2){let Te=W.get(me.uri);Te||(Te=[me.uri,[]],W.set(me.uri,Te)),Te[1].push(me.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Pe=qe([O],Pe),e.WorkspaceEdit=Pe;let Fe=o=class{static isSnippetString(W){return W instanceof o?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=o.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,me=this.e++){if(typeof W=="function"){const Te=new o;Te.e=this.e,W(Te),this.e=Te.e,W=Te.value}else W=o.c(W);return this.value+="${",this.value+=me,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,me=this.e++){const Te=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,me){if(typeof me=="function"){const Te=new o;Te.e=this.e,me(Te),this.e=Te.e,me=Te.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,me&&(this.value+=":",this.value+=me),this.value+="}",this}};Fe=o=qe([O],Fe),e.SnippetString=Fe;var se;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var oe;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(oe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=u=class{static isLocation(W){return W instanceof u?!0:W?V.isRange(W.range)&&D.URI.isUri(W.uri):!1}constructor(W,me){if(this.uri=W,me)if(V.isRange(me))this.range=V.of(me);else if(ue.isPosition(me))this.range=new V(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};fe=u=qe([O],fe),e.Location=fe;let Z=class{static is(W){return W?typeof W.message=="string"&&W.location&&V.isRange(W.location.range)&&D.URI.isUri(W.location.uri):!1}constructor(W,me){this.location=W,this.message=me}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.location.range.isEqual(me.location.range)&&W.location.uri.toString()===me.location.uri.toString()}};Z=qe([O],Z),e.DiagnosticRelatedInformation=Z;let ce=class{constructor(W,me,Te=oe.Error){if(!V.isRange(W))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=W,this.message=me,this.severity=Te}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.severity===me.severity&&W.code===me.code&&W.severity===me.severity&&W.source===me.source&&W.range.isEqual(me.range)&&(0,c.equals)(W.tags,me.tags)&&(0,c.equals)(W.relatedInformation,me.relatedInformation,Z.isEqual)}};ce=qe([O],ce),e.Diagnostic=ce;let ie=class{constructor(W,me){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=me}};ie=qe([O],ie),e.Hover=ie;var N;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(N=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let H=class{constructor(W,me=N.Text){this.range=W,this.kind=me}toJSON(){return{range:this.range,kind:N[this.kind]}}};H=qe([O],H),e.DocumentHighlight=H;var Q;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Q=e.SymbolKind||(e.SymbolKind={}));var Y;(function(x){x[x.Deprecated=1]="Deprecated"})(Y=e.SymbolTag||(e.SymbolTag={}));let he=i=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,me,Te,Ke,Ye){this.name=W,this.kind=me,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ke instanceof fe?this.location=Ke:Te instanceof V&&(this.location=new fe(Ke,Te)),i.validate(this)}toJSON(){return{name:this.name,kind:Q[this.kind],location:this.location,containerName:this.containerName}}};he=i=qe([O],he),e.SymbolInformation=he;let we=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(n.validate)}constructor(W,me,Te,Ke,Ye){this.name=W,this.detail=me,this.kind=Te,this.range=Ke,this.selectionRange=Ye,this.children=[],n.validate(this)}};we=n=qe([O],we),e.DocumentSymbol=we;var Ae;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(Ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(W,me){this.title=W,this.kind=me}};pe=qe([O],pe),e.CodeAction=pe;let De=h=class{constructor(W){this.value=W}append(W){return new h(this.value?this.value+h.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+h.c)}};De.c=".",De=h=qe([O],De),e.CodeActionKind=De,De.Empty=new De(""),De.QuickFix=De.Empty.append("quickfix"),De.Refactor=De.Empty.append("refactor"),De.RefactorExtract=De.Refactor.append("extract"),De.RefactorInline=De.Refactor.append("inline"),De.RefactorMove=De.Refactor.append("move"),De.RefactorRewrite=De.Refactor.append("rewrite"),De.Source=De.Empty.append("source"),De.SourceOrganizeImports=De.Source.append("organizeImports"),De.SourceFixAll=De.Source.append("fixAll");let ke=class{constructor(W,me){if(this.range=W,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([O],ke),e.SelectionRange=ke;class je{constructor(W,me,Te,Ke,Ye,ct){this.kind=W,this.name=me,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.CallHierarchyItem=je;class Ge{constructor(W,me){this.fromRanges=me,this.from=W}}e.CallHierarchyIncomingCall=Ge;class et{constructor(W,me){this.fromRanges=me,this.to=W}}e.CallHierarchyOutgoingCall=et;var Qe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(W,me){this.range=W,this.command=me}get isResolved(){return!!this.command}};nt=qe([O],nt),e.CodeLens=nt;let st=E=class{static isMarkdownString(W){return W instanceof E?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,me=!1){d.set(this,void 0),Je(this,d,new T.MarkdownString(W,{supportThemeIcons:me}),"f")}get value(){return Ue(this,d,"f").value}set value(W){Ue(this,d,"f").value=W}get isTrusted(){return Ue(this,d,"f").isTrusted}set isTrusted(W){Ue(this,d,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,d,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,d,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,d,"f").supportHtml}set supportHtml(W){Ue(this,d,"f").supportHtml=W}get baseUri(){return Ue(this,d,"f").baseUri}set baseUri(W){Ue(this,d,"f").baseUri=W}appendText(W){return Ue(this,d,"f").appendText(W),this}appendMarkdown(W){return Ue(this,d,"f").appendMarkdown(W),this}appendCodeblock(W,me){return Ue(this,d,"f").appendCodeblock(me??"",W),this}};d=new WeakMap,st=E=qe([O],st),e.MarkdownString=st;let ht=class{constructor(W,me){this.label=W,this.documentation=me}};ht=qe([O],ht),e.ParameterInformation=ht;let Me=class{constructor(W,me){this.label=W,this.documentation=me,this.parameters=[]}};Me=qe([O],Me),e.SignatureInformation=Me;let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};it=qe([O],it),e.SignatureHelp=it;var ae;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(ae=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})($=e.InlayHintKind||(e.InlayHintKind={}));let le=class{constructor(W){this.value=W}};le=qe([O],le),e.InlayHintLabelPart=le;let Ie=class{constructor(W,me,Te){this.position=W,this.label=me,this.kind=Te}};Ie=qe([O],Ie),e.InlayHint=Ie;var Le;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(x){x[x.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(W,me){this.label=W,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([O],Ze),e.CompletionItem=Ze;let gt=class{constructor(W=[],me=!1){this.items=W,this.isIncomplete=me}};gt=qe([O],gt),e.CompletionList=gt;let mt=class{constructor(W,me,Te){this.insertText=W,this.range=me,this.command=Te}};mt=qe([O],mt),e.InlineSuggestion=mt;let lt=class{constructor(W){this.commands=void 0,this.items=W}};lt=qe([O],lt),e.InlineSuggestionList=lt;var ot;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var rt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var kt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(kt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Tt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Nt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var $t;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})($t=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function W(me){switch(me){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=W}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(W,me){if(me&&!D.URI.isUri(me))throw(0,t.illegalArgument)("target");if(!V.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=me}};Ft=qe([O],Ft),e.DocumentLink=Ft;let xe=class{constructor(W,me,Te,Ke){this.red=W,this.green=me,this.blue=Te,this.alpha=Ke}};xe=qe([O],xe),e.Color=xe;let Mt=class{constructor(W,me){if(me&&!(me instanceof xe))throw(0,t.illegalArgument)("color");if(!V.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=me}};Mt=qe([O],Mt),e.ColorInformation=Mt;let Ut=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};Ut=qe([O],Ut),e.ColorPresentation=Ut;var Bt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Bt=e.ColorFormat||(e.ColorFormat={}));var wt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Pt;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(Pt=e.TerminalExitReason||(e.TerminalExitReason={}));class Re{constructor(W,me,Te){if(this.startIndex=W,this.length=me,this.tooltip=Te,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Oe{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Oe;class Se{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=Se;var re;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(re=e.TerminalLocation||(e.TerminalLocation={}));class Ne{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ne;var ze;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(ze=e.TaskRevealKind||(e.TaskRevealKind={}));var _e;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(_e=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=C=class{static from(W){switch(W){case"clean":return C.Clean;case"build":return C.Build;case"rebuild":return C.Rebuild;case"test":return C.Test;default:return}}constructor(W,me){if(this.label=me,typeof W!="string"||typeof me!="string")throw(0,t.illegalArgument)("name");this.c=W}get id(){return this.c}};Ve.Clean=new C("clean","Clean"),Ve.Build=new C("build","Build"),Ve.Rebuild=new C("rebuild","Rebuild"),Ve.Test=new C("test","Test"),Ve=C=qe([O],Ve),e.TaskGroup=Ve;function tt(x){let W="";for(let me=0;me<x.length;me++)W+=x[me].replace(/,/g,",,")+",";return W}let St=class{constructor(W,me,Te){if(typeof W!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=W,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Te):this.f=me)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const me of this.e)W.push(me);return tt(W)}};St=qe([O],St),e.ProcessExecution=St;let Et=class{constructor(W,me,Te){if(this.f=[],Array.isArray(me)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this.e=W,this.f=me,this.g=Te}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this.c=W,this.g=me}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)W.push(typeof me=="string"?me:me.value);return tt(W)}};Et=qe([O],Et),e.ShellExecution=Et;var Lt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(Lt=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class It{constructor(W){this.c=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this.c=W}get callback(){return this.c}}e.CustomExecution=It;let ft=M=class{constructor(W,me,Te,Ke,Ye,ct){this.j=!1,this.k=this.definition=W;let dt;typeof me=="string"?(this.m=this.name=me,this.t=this.source=Te,this.execution=Ke,dt=Ye,this.j=!0):me===vt.Global||me===vt.Workspace?(this.target=me,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct):(this.target=me,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof St?this.k={type:M.e,id:this.n.computeId()}:this.n instanceof Et?this.k={type:M.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:M.c,id:this.n.computeId()}:this.k={type:M.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const me=this.k.type;(M.g===me||M.e===me||M.f===me||M.c===me)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};ft.c="customExecution",ft.e="process",ft.f="shell",ft.g="$empty",ft=M=qe([O],ft),e.Task=ft;var Gt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Gt=e.ProgressLocation||(e.ProgressLocation={}));var jt;(function(x){function W(me){const Te=me;return(0,y.isNumber)(Te.value)?Te.tooltip&&!(0,y.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}x.isViewBadge=W})(jt=e.ViewBadge||(e.ViewBadge={}));let yt=K=class{static isTreeItem(W,me){if(W instanceof K)return!0;const Te=W;if(Te.label!==void 0&&!(0,y.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,y.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,y.isString)(Te.iconPath)&&!D.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,y.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!D.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!D.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,y.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!D.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,y.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<Qt.None&&Te.collapsibleState>Qt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,y.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,v.checkProposedApiEnabled)(me,"treeItemCheckbox");const Ke=(0,y.isNumber)(Te.checkboxState)?Te.checkboxState:(0,y.isObject)(Te.checkboxState)&&(0,y.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,y.isNumber)(Te.checkboxState)&&(0,y.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==sn.Checked&&Ke!==sn.Unchecked||Ye!==void 0&&!(0,y.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(W,me=Qt.None){this.collapsibleState=me,D.URI.isUri(W)?this.resourceUri=W:this.label=W}};yt=K=qe([O],yt),e.TreeItem=yt;var Qt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(Qt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var sn;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(sn=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let en=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,me){this.value=W,this.id=me??(0,L.generateUuid)()}};en=qe([O],en),e.DataTransferItem=en;let vn=class{constructor(W){f.set(this,new Map);for(const[me,Te]of W??[]){const Ke=Ue(this,f,"f").get(me);Ke?Ke.push(Te):Ue(this,f,"f").set(me,[Te])}}get(W){return Ue(this,f,"f").get(W)?.[0]}set(W,me){Ue(this,f,"f").set(W,[me])}forEach(W,me){for(const[Te,Ke]of Ue(this,f,"f"))for(const Ye of Ke)W.call(me,Ye,Te,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[W,me]of Ue(this,f,"f"))for(const Te of me)yield[W,Te]}};vn=qe([O],vn),e.DataTransfer=vn;let At=class{constructor(W){this.insertText=W}};At=qe([O],At),e.DocumentDropEdit=At;let on=class{constructor(W){this.insertText=W}};on=qe([O],on),e.DocumentPasteEdit=on;let Vt=class{constructor(W,me){this.id=W,this.color=me}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};Vt=qe([O],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let tn=class{constructor(W){this.id=W}};tn=qe([O],tn),e.ThemeColor=tn;var an;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(an=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ut=class{get base(){return this.c}set base(W){this.c=W,this.e=D.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,me){if(typeof W!="string"&&(!W||!D.URI.isUri(W)&&!D.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof me!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=D.URI.file(W):D.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ut=qe([O],ut),e.RelativePattern=ut;const On=new WeakMap;function _t(x,W){On.set(x,W)}e.setBreakpointId=_t;let Wt=class{constructor(W,me,Te,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof me=="string"&&(this.condition=me),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=On.get(this)??(0,L.generateUuid)()),this.c}};Wt=qe([O],Wt),e.Breakpoint=Wt;let cn=class extends Wt{constructor(W,me,Te,Ke,Ye){if(super(me,Te,Ke,Ye),W===null)throw(0,t.illegalArgument)("location");this.location=W}};cn=qe([O],cn),e.SourceBreakpoint=cn;let En=class extends Wt{constructor(W,me,Te,Ke,Ye){super(me,Te,Ke,Ye),this.functionName=W}};En=qe([O],En),e.FunctionBreakpoint=En;let ln=class extends Wt{constructor(W,me,Te,Ke,Ye,ct,dt){if(super(Ke,Ye,ct,dt),!me)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=me,this.canPersist=Te}};ln=qe([O],ln),e.DataBreakpoint=ln;let Sn=class{constructor(W,me,Te){this.command=W,this.args=me||[],this.options=Te}};Sn=qe([O],Sn),e.DebugAdapterExecutable=Sn;let un=class{constructor(W,me){this.port=W,this.host=me}};un=qe([O],un),e.DebugAdapterServer=un;let nn=class{constructor(W){this.path=W}};nn=qe([O],nn),e.DebugAdapterNamedPipeServer=nn;let yn=class{constructor(W){this.implementation=W}};yn=qe([O],yn),e.DebugAdapterInlineImplementation=yn;let rn=class{constructor(W,me){this.range=W,this.expression=me}};rn=qe([O],rn),e.EvaluatableExpression=rn;var Cn;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Cn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Dn=class{constructor(W,me){this.range=W,this.text=me}};Dn=qe([O],Dn),e.InlineValueText=Dn;let In=class{constructor(W,me,Te=!0){this.range=W,this.variableName=me,this.caseSensitiveLookup=Te}};In=qe([O],In),e.InlineValueVariableLookup=In;let Yt=class{constructor(W,me){this.range=W,this.expression=me}};Yt=qe([O],Yt),e.InlineValueEvaluatableExpression=Yt;let kn=class{constructor(W,me){this.frameId=W,this.stoppedLocation=me}};kn=qe([O],kn),e.InlineValueContext=kn;var zn;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(zn=e.FileChangeType||(e.FileChangeType={}));let Tn=q=class extends Error{static FileExists(W){return new q(W,P.FileSystemProviderErrorCode.FileExists,q.FileExists)}static FileNotFound(W){return new q(W,P.FileSystemProviderErrorCode.FileNotFound,q.FileNotFound)}static FileNotADirectory(W){return new q(W,P.FileSystemProviderErrorCode.FileNotADirectory,q.FileNotADirectory)}static FileIsADirectory(W){return new q(W,P.FileSystemProviderErrorCode.FileIsADirectory,q.FileIsADirectory)}static NoPermissions(W){return new q(W,P.FileSystemProviderErrorCode.NoPermissions,q.NoPermissions)}static Unavailable(W){return new q(W,P.FileSystemProviderErrorCode.Unavailable,q.Unavailable)}constructor(W,me=P.FileSystemProviderErrorCode.Unknown,Te){super(D.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,q.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Tn=q=qe([O],Tn),e.FileSystemError=Tn;let Pn=class{constructor(W,me,Te){this.start=W,this.end=me,this.kind=Te}};Pn=qe([O],Pn),e.FoldingRange=Pn;var Wn;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Wn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var An;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(An=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Nn;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Nn=e.CommentMode||(e.CommentMode={}));var Fn;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Fn=e.CommentThreadState||(e.CommentThreadState={}));class He{constructor(W,me=[]){this.tokenTypes=W,this.tokenModifiers=me}}e.SemanticTokensLegend=He;function Kt(x){return typeof x>"u"||(0,y.isStringArray)(x)}class dn{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let me=0,Te=W.tokenTypes.length;me<Te;me++)this.j.set(W.tokenTypes[me],me);for(let me=0,Te=W.tokenModifiers.length;me<Te;me++)this.k.set(W.tokenModifiers[me],me)}}push(W,me,Te,Ke,Ye){if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(W,me,Te,Ke,Ye);if(V.isRange(W)&&typeof me=="string"&&Kt(Te))return this.m(W,me,Te);throw(0,t.illegalArgument)()}m(W,me,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(me))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,Ye=W.start.character,ct=W.end.character-W.start.character,dt=this.j.get(me);let Ot=0;if(Te)for(const Ht of Te){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Ht);Ot|=1<<qt>>>0}this.n(Ke,Ye,ct,dt,Ot)}n(W,me,Te,Ke,Ye){if(this.f&&(W<this.c||W===this.c&&me<this.e)){this.f=!1;const Ot=this.g.length/5|0;let Ht=0,qt=0;for(let xt=0;xt<Ot;xt++){let Jt=this.g[5*xt],Rn=this.g[5*xt+1];Jt===0?(Jt=Ht,Rn+=qt):Jt+=Ht,this.g[5*xt]=Jt,this.g[5*xt+1]=Rn,Ht=Jt,qt=Rn}}let ct=W,dt=me;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=W,this.e=me}static o(W){const me=[],Te=W.length/5|0;for(let dt=0;dt<Te;dt++)me[dt]=dt;me.sort((dt,Ot)=>{const Ht=W[5*dt],qt=W[5*Ot];if(Ht===qt){const xt=W[5*dt+1],Jt=W[5*Ot+1];return xt-Jt}return Ht-qt});const Ke=new Uint32Array(W.length);let Ye=0,ct=0;for(let dt=0;dt<Te;dt++){const Ot=5*me[dt],Ht=W[Ot+0],qt=W[Ot+1],xt=W[Ot+2],Jt=W[Ot+3],Rn=W[Ot+4],ii=Ht-Ye,Ri=ii===0?qt-ct:qt,Ln=5*dt;Ke[Ln+0]=ii,Ke[Ln+1]=Ri,Ke[Ln+2]=xt,Ke[Ln+3]=Jt,Ke[Ln+4]=Rn,Ye=Ht,ct=qt}return Ke}build(W){return this.f?new bt(new Uint32Array(this.g),W):new bt(dn.o(this.g),W)}}e.SemanticTokensBuilder=dn;class bt{constructor(W,me){this.resultId=me,this.data=W}}e.SemanticTokens=bt;class Hn{constructor(W,me,Te){this.start=W,this.deleteCount=me,this.data=Te}}e.SemanticTokensEdit=Hn;class jn{constructor(W,me){this.resultId=me,this.edits=W}}e.SemanticTokensEdits=jn;var Mn;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Mn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let hn=class{constructor(){}};hn.Back={iconPath:new Vt("arrow-left")},hn=qe([O],hn),e.QuickInputButtons=hn;var fn;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(fn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vn;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Vn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var qn;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(qn=e.ExtensionKind||(e.ExtensionKind={}));class Gn{static validate(W){if(typeof W.badge=="string"){let me=(0,A.nextCharLength)(W.badge,0);if(me<W.badge.length&&(me+=(0,A.nextCharLength)(W.badge,me)),W.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Vt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,me,Te){this.badge=W,this.tooltip=me,this.color=Te}}e.FileDecoration=Gn;let mn=class{constructor(W){this.kind=W}};mn=qe([O],mn),e.ColorTheme=mn;var Kn;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(Kn=e.ColorThemeKind||(e.ColorThemeKind={}));class Xt{static isNotebookRange(W){return W instanceof Xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,me){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(me<0)throw(0,t.illegalArgument)("end must be positive");W<=me?(this.c=W,this.e=me):(this.c=me,this.e=W)}with(W){let me=this.c,Te=this.e;return W.start!==void 0&&(me=W.start),W.end!==void 0&&(Te=W.end),me===this.c&&Te===this.e?this:new Xt(me,Te)}}e.NotebookRange=Xt;class gn{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(me=>gn.isNotebookCellData(me))}static isNotebookCellData(W){return!0}constructor(W,me,Te,Ke,Ye,ct,dt){this.kind=W,this.value=me,this.languageId=Te,this.mime=Ke,this.outputs=Ye??[],this.metadata=ct,this.executionSummary=dt,gn.validate(this)}}e.NotebookCellData=gn;class Xn{constructor(W){this.cells=W}}e.NotebookData=Xn;class zt{static isNotebookCellOutputItem(W){return W instanceof zt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const me={name:W.name,message:W.message,stack:W.stack};return zt.json(me,"application/vnd.code.notebook.error")}static stdout(W){return zt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return zt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,me="application/octet-stream"){return new zt(W,me)}static text(W,me=k.Mimes.text){const Te=Ue(zt,p,"f",b).encode(String(W));return new zt(Te,me)}static json(W,me="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return zt.text(Te,me)}constructor(W,me){this.data=W,this.mime=me;const Te=(0,k.normalizeMimeType)(me,!0);if(!Te)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=zt,p=zt,b={value:new TextEncoder};class pn{static isNotebookCellOutput(W){return W instanceof pn?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,me=!1){const Te=new Set,Ke=new Set;for(let Ye=0;Ye<W.length;Ye++){const ct=W[Ye],dt=(0,k.normalizeMimeType)(ct.mime);if(!Te.has(dt)||(0,I.isTextStreamMime)(dt)){Te.add(dt);continue}Ke.add(Ye),me&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?W:W.filter((Ye,ct)=>!Ke.has(ct))}constructor(W,me,Te){this.items=pn.ensureUniqueMimeTypes(W,!0),typeof me=="string"?(this.id=me,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=me??Te)}}e.NotebookCellOutput=pn;var ge;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(ge=e.NotebookCellKind||(e.NotebookCellKind={}));var ve;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(ve=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var $e;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})($e=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var at;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(at=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ct{constructor(W,me){this.text=W,this.alignment=me}}e.NotebookCellStatusBarItem=Ct;var Rt;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Rt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var ai;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(ai=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ci{constructor(W,me=[]){this.uri=W,this.provides=(0,c.asArray)(me)}}e.NotebookRendererScript=ci;class li{constructor(W){this.label=W}}e.NotebookKernelSourceAction=li;let xn=class{constructor(W,me){this.label=W,this.timestamp=me}};xn=qe([O],xn),e.TimelineItem=xn;var ui;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(ui=e.ExtensionMode||(e.ExtensionMode={}));var di;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(di=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hi;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(hi=e.StandardTokenType||(e.StandardTokenType={}));class fi{constructor(W,me){this.ranges=W,this.wordPattern=me}}e.LinkedEditingRanges=fi;class mi{constructor(W,me){this.c=W,this.e=me}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mi;var gi;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(gi=e.TestResultState||(e.TestResultState={}));var pi;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(pi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Un=class{constructor(W=void 0,me=void 0,Te=void 0){this.include=W,this.exclude=me,this.profile=Te}};Un=qe([O],Un),e.TestRunRequest=Un;let Qn=class extends Un{constructor(W=void 0,me=void 0,Te=void 0,Ke=!1){super(W,me,Te),this.continuous=Ke}};Qn=qe([O],Qn),e.TestRunRequest2=Qn;let _n=F=class{static diff(W,me,Te){const Ke=new F(W);return Ke.expectedOutput=me,Ke.actualOutput=Te,Ke}constructor(W){this.message=W}};_n=F=qe([O],_n),e.TestMessage=_n;let Yn=class{constructor(W){this.id=W}};Yn=qe([O],Yn),e.TestTag=Yn;let bn=class{constructor(W,me){this.covered=W,this.total=me}};bn=qe([O],bn),e.CoveredCount=bn;let Jn=B=class{static fromDetails(W,me){const Te=new bn(0,0),Ke=new bn(0,0),Ye=new bn(0,0);for(const dt of me)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Ot of dt.branches)Ke.total+=1,Ke.covered+=Ot.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ct=new B(W,Te,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ct.detailedCoverage=me,ct}constructor(W,me,Te,Ke){this.uri=W,this.statementCoverage=me,this.branchCoverage=Te,this.functionCoverage=Ke}};Jn=B=qe([O],Jn),e.FileCoverage=Jn;let Zn=class{constructor(W,me,Te=[]){this.executionCount=W,this.location=me,this.branches=Te}};Zn=qe([O],Zn),e.StatementCoverage=Zn;let ei=class{constructor(W,me){this.executionCount=W,this.location=me}};ei=qe([O],ei),e.BranchCoverage=ei;let ti=class{constructor(W,me){this.executionCount=W,this.location=me}};ti=qe([O],ti),e.FunctionCoverage=ti;var bi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(bi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var wi;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(wi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var vi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(vi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Ei{constructor(W,me,Te,Ke,Ye,ct){this.kind=W,this.name=me,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.TypeHierarchyItem=Ei;class Si{constructor(W){this.uri=W}}e.TextTabInput=Si;class yi{constructor(W,me){this.original=W,this.modified=me}}e.TextDiffTabInput=yi;class Ci{constructor(W,me,Te,Ke){this.base=W,this.input1=me,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=Ci;class Di{constructor(W,me){this.uri=W,this.viewType=me}}e.CustomEditorTabInput=Di;class Ii{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Ii;class ki{constructor(W,me){this.uri=W,this.notebookType=me}}e.NotebookEditorTabInput=ki;class Ti{constructor(W,me,Te){this.original=W,this.modified=me,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Ti;class Pi{constructor(){}}e.TerminalEditorTabInput=Pi;class Ai{constructor(W,me){this.uri=W,this.inputBoxUri=me}}e.InteractiveWindowInput=Ai}),define(ye[135],Ce([1,0,51,17,8,164,106,7,16]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const D=new Map;function L(v,m){m?D.set(v,m):D.delete(v)}e.setWordDefinitionFor=L;function P(v){return D.get(v)}class w extends R.MirrorTextModel{constructor(m,d,f,p,b,S,g,r){super(d,f,p,b),this.m=m,this.p=S,this.q=g,this.notebook=r,this.b=!1}dispose(){(0,c.ok)(!this.b),this.b=!0,this.q=!1}equalLines(m){return(0,y.equals)(this.d,m)}get document(){if(!this.a){const m=this;this.a={get uri(){return m.c},get fileName(){return m.c.fsPath},get isUntitled(){return m.c.scheme===t.Schemas.untitled},get languageId(){return m.p},get version(){return m.g},get isClosed(){return m.b},get isDirty(){return m.q},save(){return m.r()},getText(d){return d?m.s(d):m.getText()},get eol(){return m.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return m.d.length},lineAt(d){return m.t(d)},offsetAt(d){return m.u(d)},positionAt(d){return m.v(d)},validateRange(d){return m.w(d)},validatePosition(d){return m.x(d)},getWordRangeAtPosition(d,f){return m.y(d,f)}}}return Object.freeze(this.a)}_acceptLanguageId(m){(0,c.ok)(!this.b),this.p=m}_acceptIsDirty(m){(0,c.ok)(!this.b),this.q=m}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(m){const d=this.w(m);if(d.isEmpty)return"";if(d.isSingleLine)return this.d[d.start.line].substring(d.start.character,d.end.character);const f=this.f,p=d.start.line,b=d.end.line,S=[];S.push(this.d[p].substring(d.start.character));for(let g=p+1;g<b;g++)S.push(this.d[g]);return S.push(this.d[b].substring(0,d.end.character)),S.join(f)}t(m){let d;if(m instanceof A.Position?d=m.line:typeof m=="number"&&(d=m),typeof d!="number"||d<0||d>=this.d.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new I(d,this.d[d],d===this.d.length-1)}u(m){return m=this.x(m),this.k(),this.h.getPrefixSum(m.line-1)+m.character}v(m){m=Math.floor(m),m=Math.max(0,m),this.k();const d=this.h.getIndexOf(m),f=this.d[d.index].length;return new A.Position(d.index,Math.min(d.remainder,f))}w(m){if(!(m instanceof A.Range))throw new Error("Invalid argument");const d=this.x(m.start),f=this.x(m.end);return d===m.start&&f===m.end?m:new A.Range(d.line,d.character,f.line,f.character)}x(m){if(!(m instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return m.with(0,0);let{line:d,character:f}=m,p=!1;if(d<0)d=0,f=0,p=!0;else if(d>=this.d.length)d=this.d.length-1,f=this.d[d].length,p=!0;else{const b=this.d[d].length;f<0?(f=0,p=!0):f>b&&(f=b,p=!0)}return p?new A.Position(d,f):m}y(m,d){const f=this.x(m);if(!d)d=P(this.p);else if((0,T.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const p=(0,k.getWordAtText)(f.character+1,(0,k.ensureValidWordDefinition)(d),this.d[f.line],0);if(p)return new A.Range(f.line,p.startColumn-1,f.line,p.endColumn-1)}}e.ExtHostDocumentData=w;class I{constructor(m,d,f){this.a=m,this.b=d,this.c=f}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=I}),define(ye[237],Ce([1,0,7,18,3]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(A){this.a=new c.ColorTheme(c.ColorThemeKind.Dark),this.b=new T.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let y;switch(A){case"light":y=c.ColorThemeKind.Light;break;case"hcDark":y=c.ColorThemeKind.HighContrast;break;case"hcLight":y=c.ColorThemeKind.HighContrastLight;break;default:y=c.ColorThemeKind.Dark}this.a=new c.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(ye[15],Ce([1,0,16,23,148,63,112,28,147,87,85,22,10,2,36,68,124,132,130,92,57,73,232,7]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p,b,S,g,r,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Re){function Oe(re){const{selectionStartLineNumber:Ne,selectionStartColumn:ze,positionLineNumber:_e,positionColumn:Ve}=re,tt=new l.Position(Ne-1,ze-1),St=new l.Position(_e-1,Ve-1);return new l.Selection(tt,St)}Re.to=Oe;function Se(re){const{anchor:Ne,active:ze}=re;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}Re.from=Se})(s=e.Selection||(e.Selection={}));var a;(function(Re){function Oe(re){if(!re)return;const{start:Ne,end:ze}=re;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}Re.from=Oe;function Se(re){if(!re)return;const{startLineNumber:Ne,startColumn:ze,endLineNumber:_e,endColumn:Ve}=re;return new l.Range(Ne-1,ze-1,_e-1,Ve-1)}Re.to=Se})(a=e.Range||(e.Range={}));var o;(function(Re){function Oe(Se){switch(Se){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Re.to=Oe})(o=e.TokenType||(e.TokenType={}));var u;(function(Re){function Oe(re){return new l.Position(re.lineNumber-1,re.column-1)}Re.to=Oe;function Se(re){return{lineNumber:re.line+1,column:re.character+1}}Re.from=Se})(u=e.Position||(e.Position={}));var i;(function(Re){function Oe(Ne,ze){return(0,c.coalesce)((0,c.asArray)(Ne).map(_e=>Se(_e,ze)))}Re.from=Oe;function Se(Ne,ze){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:re(Ne.scheme,ze),pattern:$.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function re(Ne,ze){return ze&&typeof Ne=="string"?ze.transformOutgoingScheme(Ne):Ne}})(i=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Re){function Oe(re){switch(re){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Re.from=Oe;function Se(re){switch(re){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var h;(function(Re){function Oe(re){let Ne;return re.code&&((0,w.isString)(re.code)||(0,w.isNumber)(re.code)?Ne=String(re.code):Ne={value:String(re.code.value),target:re.code.target}),{...a.from(re.range),message:re.message,source:re.source,code:Ne,severity:C.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(E.from),tags:Array.isArray(re.tags)?(0,c.coalesce)(re.tags.map(n.from)):void 0}}Re.from=Oe;function Se(re){const Ne=new l.Diagnostic(a.to(re),re.message,C.to(re.severity));return Ne.source=re.source,Ne.code=(0,w.isString)(re.code)?re.code:re.code?.value,Ne.relatedInformation=re.relatedInformation&&re.relatedInformation.map(E.to),Ne.tags=re.tags&&(0,c.coalesce)(re.tags.map(n.to)),Ne}Re.to=Se})(h=e.Diagnostic||(e.Diagnostic={}));var E;(function(Re){function Oe(re){return{...a.from(re.location.range),message:re.message,resource:re.location.uri}}Re.from=Oe;function Se(re){return new l.DiagnosticRelatedInformation(new l.Location(re.resource,a.to(re)),re.message)}Re.to=Se})(E=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var C;(function(Re){function Oe(re){switch(re){case l.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Re.from=Oe;function Se(re){switch(re){case d.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Re.to=Se})(C=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var M;(function(Re){function Oe(re){return typeof re=="number"&&re>=l.ViewColumn.One?re-1:re===l.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}Re.from=Oe;function Se(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(M=e.ViewColumn||(e.ViewColumn={}));function K(Re){return typeof Re.range<"u"}function q(Re){return Re.length===0?!0:!!K(Re[0])}e.isDecorationOptionsArr=q;var F;(function(Re){function Oe(Ve){return Ve.map(Re.from)}Re.fromMany=Oe;function Se(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function re(Ve){let tt;if(Se(Ve)){const{language:vt,value:It}=Ve;tt={value:"```"+vt+`
`+It+"\n```\n"}}else l.MarkdownString.isMarkdownString(Ve)?tt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?tt={value:Ve}:tt={value:""};const St=Object.create(null);tt.uris=St;const Et=vt=>{try{let It=I.URI.parse(vt,!0);It=It.with({query:Ne(It.query,St)}),St[vt]=It}catch{}return""},Lt=new y.marked.Renderer;return Lt.link=Et,Lt.image=vt=>typeof vt=="string"?Et(k.parseHrefAndDimensions(vt).href):"",(0,y.marked)(tt.value,{renderer:Lt}),tt}Re.from=re;function Ne(Ve,tt){if(!Ve)return Ve;let St;try{St=(0,D.parse)(Ve)}catch{}if(!St)return Ve;let Et=!1;return St=(0,P.cloneAndChange)(St,Lt=>{if(I.URI.isUri(Lt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[vt]=Lt,Et=!0,vt}else return}),Et?JSON.stringify(St):Ve}function ze(Ve){const tt=new l.MarkdownString(Ve.value,Ve.supportThemeIcons);return tt.isTrusted=Ve.isTrusted,tt.supportHtml=Ve.supportHtml,tt.baseUri=Ve.baseUri?I.URI.from(Ve.baseUri):void 0,tt}Re.to=ze;function _e(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Re.from(Ve)}Re.fromStrict=_e})(F=e.MarkdownString||(e.MarkdownString={}));function B(Re){return q(Re)?Re.map(Oe=>({range:a.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?F.fromMany(Oe.hoverMessage):Oe.hoverMessage?F.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Re.map(Oe=>({range:a.from(Oe)}))}e.fromRangeOrRangeWithMessage=B;function O(Re){return typeof Re>"u"?Re:typeof Re=="string"?I.URI.file(Re):Re}e.pathOrURIToURI=O;var U;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?O(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Oe})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Oe})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(Re){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Oe})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ue;(function(Re){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?j.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?z.from(Se.light):void 0,dark:Se.dark?z.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Oe})(ue=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Re){function Oe(re){return{text:re.newText,eol:re.newEol&&st.from(re.newEol),range:a.from(re.range)}}Re.from=Oe;function Se(re){const Ne=new l.TextEdit(a.to(re.range),re.text);return Ne.newEol=typeof re.eol>"u"?void 0:st.to(re.eol),Ne}Re.to=Se})(V=e.TextEdit||(e.TextEdit={}));var _;(function(Re){function Oe(re,Ne){const ze={edits:[]};if(re instanceof l.WorkspaceEdit){const _e=new A.ResourceSet;for(const Ve of re._allEntries())Ve._type===1&&I.URI.isUri(Ve.to)&&Ve.from===void 0&&_e.add(Ve.to);for(const Ve of re._allEntries())Ve._type===1?ze.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?ze.edits.push({resource:Ve.uri,textEdit:V.from(Ve.edit),versionId:_e.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?ze.edits.push({resource:Ve.uri,textEdit:{range:a.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:_e.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&ze.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(gt.from)}})}return ze}Re.from=Oe;function Se(re){const Ne=new l.WorkspaceEdit;for(const ze of re.edits)ze.textEdit?Ne.replace(I.URI.revive(ze.resource),a.to(ze.textEdit.range),ze.textEdit.text):Ne.renameFile(I.URI.revive(ze.oldResource),I.URI.revive(ze.newResource),ze.options);return Ne}Re.to=Se})(_=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Re){const Oe=Object.create(null);Oe[l.SymbolKind.File]=0,Oe[l.SymbolKind.Module]=1,Oe[l.SymbolKind.Namespace]=2,Oe[l.SymbolKind.Package]=3,Oe[l.SymbolKind.Class]=4,Oe[l.SymbolKind.Method]=5,Oe[l.SymbolKind.Property]=6,Oe[l.SymbolKind.Field]=7,Oe[l.SymbolKind.Constructor]=8,Oe[l.SymbolKind.Enum]=9,Oe[l.SymbolKind.Interface]=10,Oe[l.SymbolKind.Function]=11,Oe[l.SymbolKind.Variable]=12,Oe[l.SymbolKind.Constant]=13,Oe[l.SymbolKind.String]=14,Oe[l.SymbolKind.Number]=15,Oe[l.SymbolKind.Boolean]=16,Oe[l.SymbolKind.Array]=17,Oe[l.SymbolKind.Object]=18,Oe[l.SymbolKind.Key]=19,Oe[l.SymbolKind.Null]=20,Oe[l.SymbolKind.EnumMember]=21,Oe[l.SymbolKind.Struct]=22,Oe[l.SymbolKind.Event]=23,Oe[l.SymbolKind.Operator]=24,Oe[l.SymbolKind.TypeParameter]=25;function Se(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Re.from=Se;function re(Ne){for(const ze in Oe)if(Oe[ze]===Ne)return Number(ze);return l.SymbolKind.Property}Re.to=re})(J=e.SymbolKind||(e.SymbolKind={}));var ne;(function(Re){function Oe(re){switch(re){case l.SymbolTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return l.SymbolTag.Deprecated}}Re.to=Se})(ne=e.SymbolTag||(e.SymbolTag={}));var ee;(function(Re){function Oe(re){return{name:re.name,kind:J.from(re.kind),tags:re.tags&&re.tags.map(ne.from),containerName:re.containerName,location:Ee.from(re.location)}}Re.from=Oe;function Se(re){const Ne=new l.SymbolInformation(re.name,J.to(re.kind),re.containerName,Ee.to(re.location));return Ne.tags=re.tags&&re.tags.map(ne.to),Ne}Re.to=Se})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var X;(function(Re){function Oe(re){const Ne={name:re.name||"!!MISSING: name!!",detail:re.detail,range:a.from(re.range),selectionRange:a.from(re.selectionRange),kind:J.from(re.kind),tags:re.tags?.map(ne.from)??[]};return re.children&&(Ne.children=re.children.map(Oe)),Ne}Re.from=Oe;function Se(re){const Ne=new l.DocumentSymbol(re.name,re.detail,J.to(re.kind),a.to(re.range),a.to(re.selectionRange));return(0,c.isNonEmptyArray)(re.tags)&&(Ne.tags=re.tags.map(ne.to)),re.children&&(Ne.children=re.children.map(Se)),Ne}Re.to=Se})(X=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(Re){function Oe(re){const Ne=new l.CallHierarchyItem(J.to(re.kind),re.name,re.detail||"",I.URI.revive(re.uri),a.to(re.range),a.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Re.to=Oe;function Se(re,Ne,ze){if(Ne=Ne??re._sessionId,ze=ze??re._itemId,Ne===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:ze,name:re.name,detail:re.detail,kind:J.from(re.kind),uri:re.uri,range:a.from(re.range),selectionRange:a.from(re.selectionRange),tags:re.tags?.map(ne.from)}}Re.from=Se})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(Re){function Oe(Se){return new l.CallHierarchyIncomingCall(G.to(Se.from),Se.fromRanges.map(re=>a.to(re)))}Re.to=Oe})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(Re){function Oe(Se){return new l.CallHierarchyOutgoingCall(G.to(Se.to),Se.fromRanges.map(re=>a.to(re)))}Re.to=Oe})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ee;(function(Re){function Oe(re){return{range:re.range&&a.from(re.range),uri:re.uri}}Re.from=Oe;function Se(re){return new l.Location(I.URI.revive(re.uri),a.to(re.range))}Re.to=Se})(Ee=e.location||(e.location={}));var Pe;(function(Re){function Oe(re){const Ne=re,ze=re;return{originSelectionRange:Ne.originSelectionRange?a.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:ze.uri,range:a.from(Ne.targetRange?Ne.targetRange:ze.range),targetSelectionRange:Ne.targetSelectionRange?a.from(Ne.targetSelectionRange):void 0}}Re.from=Oe;function Se(re){return{targetUri:I.URI.revive(re.uri),targetRange:a.to(re.range),targetSelectionRange:re.targetSelectionRange?a.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?a.to(re.originSelectionRange):void 0}}Re.to=Se})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Re){function Oe(re){return{range:a.from(re.range),contents:F.fromMany(re.contents)}}Re.from=Oe;function Se(re){return new l.Hover(re.contents.map(F.to),a.to(re.range))}Re.to=Se})(Fe=e.Hover||(e.Hover={}));var se;(function(Re){function Oe(re){return{range:a.from(re.range),expression:re.expression}}Re.from=Oe;function Se(re){return new l.EvaluatableExpression(a.to(re.range),re.expression)}Re.to=Se})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var oe;(function(Re){function Oe(re){if(re instanceof l.InlineValueText)return{type:"text",range:a.from(re.range),text:re.text};if(re instanceof l.InlineValueVariableLookup)return{type:"variable",range:a.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Oe;function Se(re){switch(re.type){case"text":return{range:a.to(re.range),text:re.text};case"variable":return{range:a.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:a.to(re.range),expression:re.expression}}}Re.to=Se})(oe=e.InlineValue||(e.InlineValue={}));var fe;(function(Re){function Oe(re){return{frameId:re.frameId,stoppedLocation:a.from(re.stoppedLocation)}}Re.from=Oe;function Se(re){return new l.InlineValueContext(re.frameId,a.to(re.stoppedLocation))}Re.to=Se})(fe=e.InlineValueContext||(e.InlineValueContext={}));var Z;(function(Re){function Oe(re){return{range:a.from(re.range),kind:re.kind}}Re.from=Oe;function Se(re){return new l.DocumentHighlight(a.to(re.range),re.kind)}Re.to=Se})(Z=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Re){function Oe(Se){switch(Se){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Re.to=Oe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ie;(function(Re){function Oe(Se){return{triggerKind:ce.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Oe})(ie=e.CompletionContext||(e.CompletionContext={}));var N;(function(Re){function Oe(re){switch(re){case l.CompletionItemTag.Deprecated:return 1}}Re.from=Oe;function Se(re){switch(re){case 1:return l.CompletionItemTag.Deprecated}}Re.to=Se})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Re){const Oe=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function Se(ze){return Oe.get(ze)??9}Re.from=Se;const re=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ne(ze){return re.get(ze)??l.CompletionItemKind.Property}Re.to=Ne})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(Re){function Oe(Se,re){const Ne=new l.CompletionItem(Se.label);return Ne.insertText=Se.insertText,Ne.kind=H.to(Se.kind),Ne.tags=Se.tags?.map(N.to),Ne.detail=Se.detail,Ne.documentation=k.isMarkdownString(Se.documentation)?F.to(Se.documentation):Se.documentation,Ne.sortText=Se.sortText,Ne.filterText=Se.filterText,Ne.preselect=Se.preselect,Ne.commitCharacters=Se.commitCharacters,v.Range.isIRange(Se.range)?Ne.range=a.to(Se.range):typeof Se.range=="object"&&(Ne.range={inserting:a.to(Se.range.insert),replacing:a.to(Se.range.replace)}),Ne.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Ne.insertText=new l.SnippetString(Se.insertText):(Ne.insertText=Se.insertText,Ne.textEdit=Ne.range instanceof l.Range?new l.TextEdit(Ne.range,Ne.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Se.additionalTextEdits.map(ze=>V.to(ze))),Ne.command=re&&Se.command?re.fromInternal(Se.command):void 0,Ne}Re.to=Oe})(Q=e.CompletionItem||(e.CompletionItem={}));var Y;(function(Re){function Oe(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:F.fromStrict(re.documentation)}}Re.from=Oe;function Se(re){return{label:re.label,documentation:k.isMarkdownString(re.documentation)?F.to(re.documentation):re.documentation}}Re.to=Se})(Y=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Re){function Oe(re){return{label:re.label,documentation:F.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(Y.from):[],activeParameter:re.activeParameter}}Re.from=Oe;function Se(re){return{label:re.label,documentation:k.isMarkdownString(re.documentation)?F.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(Y.to):[],activeParameter:re.activeParameter}}Re.to=Se})(he=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Re){function Oe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(he.from):[]}}Re.from=Oe;function Se(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(he.to):[]}}Re.to=Se})(we=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Oe(Se,re){const Ne=new l.InlayHint(u.to(re.position),typeof re.label=="string"?re.label:re.label.map(pe.to.bind(void 0,Se)),re.kind&&De.to(re.kind));return Ne.textEdits=re.textEdits&&re.textEdits.map(V.to),Ne.tooltip=k.isMarkdownString(re.tooltip)?F.to(re.tooltip):re.tooltip,Ne.paddingLeft=re.paddingLeft,Ne.paddingRight=re.paddingRight,Ne}Re.to=Oe})(Ae=e.InlayHint||(e.InlayHint={}));var pe;(function(Re){function Oe(Se,re){const Ne=new l.InlayHintLabelPart(re.label);return Ne.tooltip=k.isMarkdownString(re.tooltip)?F.to(re.tooltip):re.tooltip,m.Command.is(re.command)&&(Ne.command=Se.fromInternal(re.command)),re.location&&(Ne.location=Ee.to(re.location)),Ne}Re.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var De;(function(Re){function Oe(re){return re}Re.from=Oe;function Se(re){return re}Re.to=Se})(De=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Re){function Oe(re){return{range:a.from(re.range),url:re.target,tooltip:re.tooltip}}Re.from=Oe;function Se(re){let Ne;if(re.url)try{Ne=typeof re.url=="string"?I.URI.parse(re.url,!0):I.URI.revive(re.url)}catch{}return new l.DocumentLink(a.to(re.range),Ne)}Re.to=Se})(ke=e.DocumentLink||(e.DocumentLink={}));var je;(function(Re){function Oe(re){const Ne=new l.ColorPresentation(re.label);return re.textEdit&&(Ne.textEdit=V.to(re.textEdit)),re.additionalTextEdits&&(Ne.additionalTextEdits=re.additionalTextEdits.map(ze=>V.to(ze))),Ne}Re.to=Oe;function Se(re){return{label:re.label,textEdit:re.textEdit?V.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Ne=>V.from(Ne)):void 0}}Re.from=Se})(je=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Re){function Oe(re){return new l.Color(re[0],re[1],re[2],re[3])}Re.to=Oe;function Se(re){return[re.red,re.green,re.blue,re.alpha]}Re.from=Se})(Ge=e.Color||(e.Color={}));var et;(function(Re){function Oe(re){return{range:a.from(re.range)}}Re.from=Oe;function Se(re){return new l.SelectionRange(a.to(re.range))}Re.to=Se})(et=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Re){function Oe(Se){switch(Se){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Re.to=Oe})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Re){function Oe(re){switch(re){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Oe;function Se(re){switch(re){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Re.to=Se})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Re){function Oe(re){if(re===l.EndOfLine.CRLF)return 1;if(re===l.EndOfLine.LF)return 0}Re.from=Oe;function Se(re){if(re===1)return l.EndOfLine.CRLF;if(re===0)return l.EndOfLine.LF}Re.to=Se})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Re){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(Re){function Oe(Se){const re={start:Se.start+1,end:Se.end+1};return Se.kind&&(re.kind=it.from(Se.kind)),re}Re.from=Oe})(Me=e.FoldingRange||(e.FoldingRange={}));var it;(function(Re){function Oe(Se){if(Se)switch(Se){case l.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}Re.from=Oe})(it=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ae;(function(Re){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?a.from(Se.selection):void 0,override:typeof Se.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Oe})(ae=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var $;(function(Re){function Oe(ze){return ze instanceof l.RelativePattern?ze.toJSON():typeof ze=="string"?ze:Se(ze)||re(ze)?new l.RelativePattern(ze.baseUri??ze.base,ze.pattern).toJSON():ze}Re.from=Oe;function Se(ze){const _e=ze;return _e?I.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function re(ze){const _e=ze;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Ne(ze){return typeof ze=="string"?ze:new l.RelativePattern(I.URI.revive(ze.baseUri),ze.pattern)}Re.to=Ne})($=e.GlobPattern||(e.GlobPattern={}));var le;(function(Re){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const re=Se;return{language:re.language,scheme:re.scheme,pattern:$.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Re.from=Oe})(le=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Re){function Oe(re){return{start:re.start,end:re.end}}Re.from=Oe;function Se(re){return new l.NotebookRange(re.start,re.end)}Re.to=Se})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Re){function Oe(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Re.to=Oe;function Se(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Re.from=Se})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Re){function Oe(Se){if(Se===b.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(Se===b.NotebookCellExecutionState.Pending)return;if(Se===b.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Oe})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xe;(function(Re){function Oe(re){switch(re){case l.NotebookCellKind.Markup:return b.CellKind.Markup;case l.NotebookCellKind.Code:default:return b.CellKind.Code}}Re.from=Oe;function Se(re){switch(re){case b.CellKind.Markup:return l.NotebookCellKind.Markup;case b.CellKind.Code:default:return l.NotebookCellKind.Code}}Re.to=Se})(Xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Re){function Oe(re){const Ne={metadata:re.metadata??Object.create(null),cells:[]};for(const ze of re.cells)l.NotebookCellData.validate(ze),Ne.cells.push(gt.from(ze));return Ne}Re.from=Oe;function Se(re){const Ne=new l.NotebookData(re.cells.map(gt.to));return(0,w.isEmptyObject)(re.metadata)||(Ne.metadata=re.metadata),Ne}Re.to=Se})(Ze=e.NotebookData||(e.NotebookData={}));var gt;(function(Re){function Oe(re){return{cellKind:Xe.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Le.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(lt.from):[]}}Re.from=Oe;function Se(re){return new l.NotebookCellData(Xe.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(lt.to):void 0,re.metadata,re.internalMetadata?Le.to(re.internalMetadata):void 0)}Re.to=Se})(gt=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Re){function Oe(re){return{mime:re.mime,valueBytes:t.VSBuffer.wrap(re.data)}}Re.from=Oe;function Se(re){return new l.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Re.to=Se})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(Re){function Oe(re){return{outputId:re.id,items:re.items.map(mt.from),metadata:re.metadata}}Re.from=Oe;function Se(re){const Ne=re.items.map(mt.to);return new l.NotebookCellOutput(Ne,re.outputId,re.metadata)}Re.to=Se})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Re){function Oe(Ne){return re(Ne)?{include:(0,w.withNullAsUndefined)($.from(Ne.include)),exclude:(0,w.withNullAsUndefined)($.from(Ne.exclude))}:(0,w.withNullAsUndefined)($.from(Ne))}Re.from=Oe;function Se(Ne){return re(Ne)?{include:$.to(Ne.include),exclude:$.to(Ne.exclude)}:$.to(Ne)}Re.to=Se;function re(Ne){const ze=Ne;return ze?!(0,w.isUndefinedOrNull)(ze.include)&&!(0,w.isUndefinedOrNull)(ze.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Re){function Oe(Se,re,Ne){const ze=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(ze,Ne),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Oe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var kt;(function(Re){function Oe(Se,re,Ne){const ze=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:re.toInternal(ze,Ne),label:Se.label,description:Se.description,detail:Se.detail}}Re.from=Oe})(kt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Tt;(function(Re){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Oe})(Tt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Nt;(function(Re){function Oe(re){return{uri:re.uri,provides:re.provides}}Re.from=Oe;function Se(re){return new l.NotebookRendererScript(I.URI.revive(re.uri),re.provides)}Re.to=Se})(Nt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var pt;(function(Re){function Oe(re){return{message:F.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,location:re.location&&{range:a.from(re.location.range),uri:re.location.uri}}}Re.from=Oe;function Se(re){const Ne=new l.TestMessage(typeof re.message=="string"?re.message:F.to(re.message));return Ne.actualOutput=re.actual,Ne.expectedOutput=re.expected,Ne.location=re.location?Ee.to(re.location):void 0,Ne}Re.to=Se})(pt=e.TestMessage||(e.TestMessage={}));var Dt;(function(Re){Re.namespace=g.namespaceTestTag,Re.denamespace=g.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var $t;(function(Re){function Oe(re){const Ne=(0,f.getPrivateApiFor)(re).controllerId;return{extId:S.TestId.fromExtHostTestItem(re,Ne).toString(),label:re.label,uri:I.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(ze=>Dt.namespace(Ne,ze.id)),range:v.Range.lift(a.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&F.fromStrict(re.error)||null}}Re.from=Oe;function Se(re){return{parent:void 0,error:void 0,id:S.TestId.fromString(re.extId).localId,label:re.label,uri:I.URI.revive(re.uri),tags:(re.tags||[]).map(Ne=>{const{tagId:ze}=Dt.denamespace(Ne);return new l.TestTag(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Re.toPlain=Se})($t=e.TestItem||(e.TestItem={})),function(Re){function Oe(re){return{id:re.id}}Re.from=Oe;function Se(re){return new l.TestTag(re.id)}Re.to=Se}(Dt=e.TestTag||(e.TestTag={}));var Ft;(function(Re){const Oe=(re,Ne)=>{const ze=[];for(const[Ve,tt]of Ne)S.TestId.compare(tt.item.extId,Ve)===2&&(Ne.delete(Ve),ze.push(tt));const _e={...$t.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(tt=>tt.type===0).map(pt.to)})),children:ze.map(Ve=>Oe(Ve,Ne))};for(const Ve of _e.children)Ve.parent=_e;return _e};function Se(re){const Ne=[],ze=new Map;for(const _e of re.items){ze.set(_e.item.extId,_e);const Ve=S.TestId.root(_e.item.extId);re.request.targets.some(tt=>tt.controllerId===Ve&&tt.testIds.includes(_e.item.extId))&&Ne.push(_e)}return{completedAt:re.completedAt,results:Ne.map(_e=>Oe(_e,ze))}}Re.to=Se})(Ft=e.TestResults||(e.TestResults={}));var xe;(function(Re){function Oe(ze){return{covered:ze.covered,total:ze.covered}}function Se(ze){return"line"in ze?u.from(ze):a.from(ze)}function re(ze){return"branches"in ze?{count:ze.executionCount,location:Se(ze.location),type:1,branches:ze.branches.length?ze.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Se(_e.location)})):void 0}:{type:0,count:ze.executionCount,location:Se(ze.location)}}Re.fromDetailed=re;function Ne(ze){return{uri:ze.uri,statement:Oe(ze.statementCoverage),branch:ze.branchCoverage&&Oe(ze.branchCoverage),function:ze.functionCoverage&&Oe(ze.functionCoverage),details:ze.detailedCoverage?.map(re)}}Re.fromFile=Ne})(xe=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(Re){function Oe(Se){switch(Se){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Re.to=Oe})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ut;(function(Re){function Oe(re){const Ne=new l.TypeHierarchyItem(J.to(re.kind),re.name,re.detail||"",I.URI.revive(re.uri),a.to(re.range),a.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Re.to=Oe;function Se(re,Ne,ze){if(Ne=Ne??re._sessionId,ze=ze??re._itemId,Ne===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:ze,kind:J.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:a.from(re.range),selectionRange:a.from(re.selectionRange),tags:re.tags?.map(ne.from)}}Re.from=Se})(Ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Bt;(function(Re){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Oe})(Bt=e.ViewBadge||(e.ViewBadge={}));var wt;(function(Re){function Oe(ze,_e,Ve){const tt=_e.fileData;return tt?new class extends l.DataTransferItem{asFile(){return{name:tt.name,uri:I.URI.revive(tt.uri),data:(0,R.once)(()=>Ve())}}}("",_e.id):ze===L.Mimes.uriList&&_e.uriListData?new l.DataTransferItem(Ne(_e.uriListData)):new l.DataTransferItem(_e.asString)}Re.to=Oe;async function Se(ze,_e){const Ve=await _e.asString();if(ze===L.Mimes.uriList)return{id:_e.id,asString:"",fileData:void 0,uriListData:re(Ve)};const tt=_e.asFile();return{id:_e.id,asString:Ve,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Re.from=Se;function re(ze){return T.UriList.split(ze).map(_e=>{if(_e.startsWith("#"))return _e;try{return I.URI.parse(_e)}catch{}return _e})}function Ne(ze){return T.UriList.create(ze.map(_e=>typeof _e=="string"?_e:I.URI.revive(_e)))}})(wt=e.DataTransferItem||(e.DataTransferItem={}));var Pt;(function(Re){function Oe(re,Ne){const ze=re.items.map(([_e,Ve])=>[_e,wt.to(_e,Ve,()=>Ne(Ve.id))]);return new l.DataTransfer(ze)}Re.toDataTransfer=Oe;async function Se(re){const Ne={items:[]},ze=[];return re.forEach((_e,Ve)=>{ze.push((async()=>{Ne.items.push([Ve,await wt.from(Ve,_e)])})())}),await Promise.all(ze),Ne}Re.toDataTransferDTO=Se})(Pt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[238],Ce([1,0,2,9,7,15,65]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(D,L,P,w={timeout:1500,errors:3}){this.c=D,this.d=L,this.f=P,this.g=w,this.a=new k.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(D){return(L,P,w)=>{const v={dispose:this.a.push([L,P,D])};return Array.isArray(w)&&w.push(v),v}}async $participateInSave(D,L){const P=c.URI.revive(D);let w=!1;const I=setTimeout(()=>w=!0,this.g.timeout),v=[];try{for(const m of[...this.a]){if(w)break;const d=this.d.getDocument(P),f=await this.h(m,{document:d,reason:R.TextDocumentSaveReason.to(L)});v.push(f)}}finally{clearTimeout(I)}return v}h([D,L,P],w){const I=this.b.get(D);return typeof I=="number"&&I>this.g.errors?Promise.resolve(!1):this.i(P,D,L,w).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const m=this.b.get(D);this.b.set(D,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(D,L,P,w){const I=[],v=Date.now(),{document:m,reason:d}=w,{version:f}=m,p=Object.freeze({document:m,reason:d,waitUntil(b){if(Object.isFrozen(I))throw(0,t.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(b))}});try{L.apply(P,[p])}catch(b){return Promise.reject(b)}return Object.freeze(I),new Promise((b,S)=>{const g=setTimeout(()=>S(new Error("timeout")),this.g.timeout);return Promise.all(I).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(g),b(r)}).catch(r=>{clearTimeout(g),S(r)})}).then(b=>{const S={edits:[]};for(const g of b)if(Array.isArray(g)&&g.every(r=>r instanceof T.TextEdit))for(const{newText:r,newEol:l,range:s}of g)S.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:s&&R.Range.from(s),text:r,eol:l&&R.EndOfLine.from(l)}});if(S.edits.length!==0)return f===m.version?this.f.$tryApplyWorkspaceEdit(S):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ye[239],Ce([1,0,17,2,15,7,92]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(P,w,I,v){this.start=P,this.deletedCount=w,this.deletedItems=I,this.items=v}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(P,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,w,I){this.notebook=P,this.h=w,this.j=I,this.handle=I.handle,this.uri=t.URI.revive(I.uri),this.cellKind=I.cellKind,this.a=I.outputs.map(T.NotebookCellOutput.to),this.e=I.internalMetadata??{},this.b=Object.freeze(I.metadata??{}),this.d=Object.freeze(T.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,w=this.h.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:T.NotebookCellKind.to(this.j.cellKind),document:w.document,get mime(){return P.g},set mime(v){P.g=v},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(I)}return this.f}setOutputs(P){this.a=P.map(T.NotebookCellOutput.to)}setOutputItems(P,w,I){const v=I.map(T.NotebookCellOutputItem.to),m=this.a.find(d=>d.id===P);if(m&&(w||(m.items.length=0),m.items.push(...v),m.items.length>1&&m.items.every(d=>k.isTextStreamMime(d.mime)))){const d=new Map,f=[];m.items.forEach(p=>{let b;d.has(p.mime)?b=d.get(p.mime):(b=[],d.set(p.mime,b),f.push(p.mime)),b.push(p.data)}),m.items.length=0,f.forEach(p=>{const b=k.compressOutputItemStreams(d.get(p));m.items.push({mime:p,data:b.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(T.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=y;class D{constructor(P,w,I,v,m){this.k=P,this.l=w,this.m=I,this.uri=v,this.handle=D.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=m.viewType,this.f=Object.freeze(m.metadata??Object.create(null)),this.r([[0,0,m.cells]],!0,void 0),this.g=m.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,w={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===c.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(I){return I=P.n(I),P.b[I].apiCell},getCells(I){return(I?P.p(I):P.b).map(m=>m.apiCell)},save(){return P.q()}};this.e=Object.freeze(w)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,w,I){this.g=P.versionId,this.h=w,this.acceptDocumentPropertiesChanged({metadata:I});const v={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},m=[];for(const f of P.rawEvents)f.kind===k.NotebookCellsChangeType.ModelChange?this.r(f.changes,!1,v.contentChanges):f.kind===k.NotebookCellsChangeType.Move?this.s(f.index,f.length,f.newIdx,v.contentChanges):f.kind===k.NotebookCellsChangeType.Output?(this.t(f.index,f.outputs),m.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===k.NotebookCellsChangeType.OutputItem?(this.u(f.index,f.outputId,f.append,f.outputItems),m.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===k.NotebookCellsChangeType.ChangeCellLanguage?(this.v(f.index,f.language),m.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document})):f.kind===k.NotebookCellsChangeType.ChangeCellContent?m.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document}):f.kind===k.NotebookCellsChangeType.ChangeCellMime?this.w(f.index,f.mime):f.kind===k.NotebookCellsChangeType.ChangeCellMetadata?(this.x(f.index,f.metadata),m.push({cell:this.b[f.index].apiCell,metadata:this.b[f.index].apiCell.metadata})):f.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(f.index,f.internalMetadata),m.push({cell:this.b[f.index].apiCell,executionSummary:this.b[f.index].apiCell.executionSummary}));const d=new Map;for(let f=0;f<m.length;f++){const p=m[f],b=d.get(p.cell);if(b===void 0){const S=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});d.set(p.cell,S-1)}else v.cellChanges[b]={...v.cellChanges[b],...p}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let w=P.start|0,I=P.end|0;return w<0&&(w=0),I>this.b.length&&(I=this.b.length),P.with({start:w,end:I})}p(P){P=this.o(P);const w=[];for(let I=P.start;I<P.end;I++)w.push(this.b[I]);return w}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,w,I){if(this.j)return;const v=[],m=[],d=[];if(P.reverse().forEach(f=>{const b=f[2].map(r=>{const l=new y(this,this.l,r);return w||m.push(y.asModelAddData(this.apiNotebook,r)),l}),S=new A(f[0],f[1],[],b),g=this.b.splice(f[0],f[1],...b);for(const r of g)d.push(r.uri),S.deletedItems.push(r.apiCell);v.push(S)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:d}),I)for(const f of v)I.push(f.asApiEvent())}s(P,w,I,v){const m=this.b.splice(P,w);this.b.splice(I,0,...m);const d=[new A(P,w,m.map(f=>f.apiCell),[]),new A(I,0,[],m)];for(const f of d)v.push(f.asApiEvent())}t(P,w){this.b[P].setOutputs(w)}u(P,w,I,v){this.b[P].setOutputItems(w,I,v)}v(P,w){const I=this.b[P];I.apiCell.document.languageId!==w&&this.m.$acceptModelLanguageChanged(I.uri,w)}w(P,w){const I=this.b[P];I.apiCell.mime=w}x(P,w){this.b[P].setMetadata(w)}y(P,w){this.b[P].setInternalMetadata(w)}getCellFromApiCell(P){return this.b.find(w=>w.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(w=>w.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.ExtHostNotebookDocument=D,D.a=0}),define(ye[136],Ce([1,0,9,15,7]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(A,y,D,L,P,w){this.id=A,this.f=y,this.notebookData=D,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=L,this.c=w}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(y){this.selections=[y]},get selections(){return A.a},set selections(y){if(!Array.isArray(y)||!y.every(T.NotebookRange.isNotebookRange))throw(0,c.illegalArgument)("selections");A.a=y,A.g(y)},get visibleRanges(){return A.b},revealRange(y,D){A.f.$tryRevealRange(A.id,t.NotebookRange.from(y),D??T.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(t.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(ye[240],Ce([1,0,3,13,15]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(A,y){this.c=A,this.d=y,this.a=new c.Emitter,this.b=new c.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const D=this.d.getEditorById(A);y.visibleRanges&&D._acceptVisibleRanges(y.visibleRanges.ranges.map(T.NotebookRange.to)),y.selections&&D._acceptSelections(y.selections.selections.map(T.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this.d.getEditorById(y)._acceptViewColumn(T.ViewColumn.to(A[y]))}};R=qe([We(0,t.ILogService)],R),e.ExtHostNotebookEditors=R}),define(ye[241],Ce([1,0,15,126,178,21,62,9]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(w){this.b=0,this.c=new Map,this.a=w}async withProgress(w,I,v){const m=this.b++,{title:d,location:f,cancellable:p}=I,b={label:(0,T.localize)(0,null,w.displayName||w.name),id:w.identifier.value};return this.a.$startProgress(m,{location:c.ProgressLocation.from(f),title:d,source:b,cancellable:p},w.isUnderDevelopment?void 0:w.identifier.value).catch(A.onUnexpectedExternalError),this.d(m,v,!!p)}d(w,I,v){let m;v&&(m=new R.CancellationTokenSource,this.c.set(w,m));const d=p=>{this.a.$progressEnd(p),this.c.delete(p),m?.dispose()};let f;try{f=I(new L(this.a,w),v&&m?m.token:R.CancellationToken.None)}catch(p){throw d(w),p}return f.then(p=>d(w),p=>d(w)),f}$acceptProgressCanceled(w){const I=this.c.get(w);I&&(I.cancel(),this.c.delete(w))}}e.ExtHostProgress=y;function D(P,w){return P.message=w.message,typeof w.increment=="number"&&(typeof P.increment=="number"?P.increment+=w.increment:P.increment=w.increment),P}class L extends t.Progress{constructor(w,I){super(v=>this.throttledReport(v)),this.c=w,this.d=I}throttledReport(w){this.c.$progressReport(this.d,w)}}qe([(0,k.throttle)(100,(P,w)=>D(P,w),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[137],Ce([1,0,36,132,57,93,73,15,2]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const D=(b,S,g,r)=>{let l=S;return{enumerable:!0,configurable:!1,get(){return l},set(s){if(!g(l,s)){const a=l;l=s,b.listener?.(r(s,a))}}}},L=(b,S)=>b===S,P={range:(b,S)=>b===S?!0:!b||!S?!1:b.isEqual(S),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(b,S)=>!(b.length!==S.length||b.some(g=>!S.find(r=>g.id===r.id)))},w=b=>S=>({op:4,update:b(S)}),I=(b,S)=>({range:(()=>{let g;const r=w(l=>({range:c.Range.lift(A.Range.from(l))}));return{enumerable:!0,configurable:!1,get(){return g},set(l){b.listener?.({op:6}),P.range(g,l)||(g=l,b.listener?.(r(l)))}}})(),label:D(b,S,P.label,w(g=>({label:g}))),description:D(b,void 0,P.description,w(g=>({description:g}))),sortText:D(b,void 0,P.sortText,w(g=>({sortText:g}))),canResolveChildren:D(b,!1,P.canResolveChildren,g=>({op:2,state:g})),busy:D(b,!1,P.busy,w(g=>({busy:g}))),error:D(b,void 0,P.error,w(g=>({error:A.MarkdownString.fromStrict(g)||null}))),tags:D(b,[],P.tags,(g,r)=>({op:1,new:g.map(A.TestTag.from),old:r.map(A.TestTag.from)}))}),v=b=>{const S=T.TestId.fromString(b.extId),g=new d(S.controllerId,S.localId,b.label,y.URI.revive(b.uri)||void 0);return g.range=A.Range.to(b.range||void 0),g.description=b.description||void 0,g.sortText=b.sortText||void 0,g.tags=b.tags.map(r=>A.TestTag.to({id:(0,k.denamespaceTestTag)(r).tagId})),g},m=b=>{let S;for(const g of b.tests){const r=v(g.item);(0,t.getPrivateApiFor)(r).parent=S,S=r}return S};e.toItemFromContext=m;class d{constructor(S,g,r,l){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const s=(0,t.createPrivateApiFor)(this,S);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof f?void 0:s.parent}},children:{value:(0,R.createTestItemChildren)(s,t.getPrivateApiFor,d),enumerable:!0,writable:!1},...I(s,r)})}}e.TestItemImpl=d;class f extends d{constructor(S,g){super(S,S,g,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class p extends R.TestItemCollection{constructor(S,g,r){super({controllerId:S,getDocumentVersion:l=>l&&r.getDocument(l)?.version,getApiFor:t.getPrivateApiFor,getChildren:l=>l.children,root:new f(S,g),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(ye[138],Ce([1,0,51,9,101,15,7]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(w,I,v){const m=A.c.nextId();w.$registerTextEditorDecorationType(I.identifier,m,R.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:m,dispose(){w.$removeTextEditorDecorationType(m)}})}}e.TextEditorDecorationType=A,A.c=new T.IdGenerator("TextEditorDecorationType");class y{constructor(w,I){this.g=[],this.h=void 0,this.j=!1,this.c=w,this.d=w.version,this.e=I.undoStopBefore,this.f=I.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(w,I){this.k();let v=null;if(w instanceof k.Position)v=new k.Range(w,w);else if(w instanceof k.Range)v=w;else throw new Error("Unrecognized location");this.l(v,I,!1)}insert(w,I){this.k(),this.l(new k.Range(w,w),I,!0)}delete(w){this.k();let I=null;if(w instanceof k.Range)I=w;else throw new Error("Unrecognized location");this.l(I,null,!0)}l(w,I,v){const m=this.c.validateRange(w);this.g.push({range:m,text:I,forceMoveMarkers:v})}setEndOfLine(w){if(this.k(),w!==k.EndOfLine.LF&&w!==k.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=w}}class D{constructor(w,I,v,m){this.c=w,this.d=I,this._accept(v),this.e=m;const d=this;this.value={get tabSize(){return d.f},set tabSize(f){d.m(f)},get indentSize(){return d.g},set indentSize(f){d.o(f)},get insertSpaces(){return d.h},set insertSpaces(f){d.q(f)},get cursorStyle(){return d.j},set cursorStyle(f){d.s(f)},get lineNumbers(){return d.k},set lineNumbers(f){d.t(f)}}}_accept(w){this.f=w.tabSize,this.g=w.indentSize,this.h=w.insertSpaces,this.j=w.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(w.lineNumbers)}l(w){if(w==="auto")return"auto";if(typeof w=="number"){const I=Math.floor(w);return I>0?I:null}if(typeof w=="string"){const I=parseInt(w,10);return isNaN(I)?null:I>0?I:null}return null}m(w){const I=this.l(w);if(I!==null){if(typeof I=="number"){if(this.f===I)return;this.f=I}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:I}))}}n(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const I=Math.floor(w);return I>0?I:null}if(typeof w=="string"){const I=parseInt(w,10);return isNaN(I)?null:I>0?I:null}return null}o(w){const I=this.n(w);if(I!==null){if(typeof I=="number"){if(this.g===I)return;this.g=I}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:I}))}}p(w){return w==="auto"?"auto":w==="false"?!1:Boolean(w)}q(w){const I=this.p(w);if(typeof I=="boolean"){if(this.h===I)return;this.h=I}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:I}))}s(w){this.j!==w&&(this.j=w,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:w})))}t(w){this.k!==w&&(this.k=w,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(w)})))}assign(w){const I={};let v=!1;if(typeof w.tabSize<"u"){const m=this.l(w.tabSize);m==="auto"?(v=!0,I.tabSize=m):typeof m=="number"&&this.f!==m&&(this.f=m,v=!0,I.tabSize=m)}if(typeof w.indentSize<"u"){const m=this.n(w.indentSize);m==="tabSize"?(v=!0,I.indentSize=m):typeof m=="number"&&this.g!==m&&(this.g=m,v=!0,I.indentSize=m)}if(typeof w.insertSpaces<"u"){const m=this.p(w.insertSpaces);m==="auto"?(v=!0,I.insertSpaces=m):this.h!==m&&(this.h=m,v=!0,I.insertSpaces=m)}typeof w.cursorStyle<"u"&&this.j!==w.cursorStyle&&(this.j=w.cursorStyle,v=!0,I.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this.k!==w.lineNumbers&&(this.k=w.lineNumbers,v=!0,I.lineNumbers=R.TextEditorLineNumbersStyle.from(w.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,I))}u(w,I){I.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this.e.warn(v)})}}e.ExtHostTextEditorOptions=D;class L{constructor(w,I,v,m,d,f,p,b){this.id=w,this.j=I,this.k=v,this.g=!1,this.h=new Set,this.c=d,this.d=new D(this.j,this.id,f,v),this.e=p,this.f=b;const S=this;this.value=Object.freeze({get document(){return m.getValue()},set document(g){throw(0,t.readonly)("document")},get selection(){return S.c&&S.c[0]},set selection(g){if(!(g instanceof k.Selection))throw(0,t.illegalArgument)("selection");S.c=[g],S.l()},get selections(){return S.c},set selections(g){if(!Array.isArray(g)||g.some(r=>!(r instanceof k.Selection)))throw(0,t.illegalArgument)("selections");S.c=g,S.l()},get visibleRanges(){return S.e},set visibleRanges(g){throw(0,t.readonly)("visibleRanges")},get options(){return S.d.value},set options(g){S.g||S.d.assign(g)},get viewColumn(){return S.f},set viewColumn(g){throw(0,t.readonly)("viewColumn")},edit(g,r={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const l=new y(m.getValue(),r);return g(l),S.m(l)},insertSnippet(g,r,l={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!r||Array.isArray(r)&&r.length===0)s=S.c.map(a=>R.Range.from(a));else if(r instanceof k.Position){const{lineNumber:a,column:o}=R.Position.from(r);s=[{startLineNumber:a,startColumn:o,endLineNumber:a,endColumn:o}]}else if(r instanceof k.Range)s=[R.Range.from(r)];else{s=[];for(const a of r)if(a instanceof k.Range)s.push(R.Range.from(a));else{const{lineNumber:o,column:u}=R.Position.from(a);s.push({startLineNumber:o,startColumn:u,endLineNumber:o,endColumn:u})}}return I.$tryInsertSnippet(w,m.getValue().version,g.value,s,l)},setDecorations(g,r){const l=r.length===0;l&&!S.h.has(g.key)||(l?S.h.delete(g.key):S.h.add(g.key),S.n(()=>{if(R.isDecorationOptionsArr(r))return I.$trySetDecorations(w,g.key,R.fromRangeOrRangeWithMessage(r));{const s=new Array(4*r.length);for(let a=0,o=r.length;a<o;a++){const u=r[a];s[4*a]=u.start.line+1,s[4*a+1]=u.start.character+1,s[4*a+2]=u.end.line+1,s[4*a+3]=u.end.character+1}return I.$trySetDecorationsFast(w,g.key,s)}}))},revealRange(g,r){S.n(()=>I.$tryRevealRange(w,R.Range.from(g),r||k.TextEditorRevealType.Default))},show(g){I.$tryShowEditor(w,R.ViewColumn.from(g))},hide(){I.$tryHideEditor(w)}})}dispose(){(0,c.ok)(!this.g),this.g=!0}_acceptOptions(w){(0,c.ok)(!this.g),this.d._accept(w)}_acceptVisibleRanges(w){(0,c.ok)(!this.g),this.e=w}_acceptViewColumn(w){(0,c.ok)(!this.g),this.f=w}_acceptSelections(w){(0,c.ok)(!this.g),this.c=w}async l(){const w=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,w)),this.value}m(w){const I=w.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const v=I.edits.map(d=>d.range);v.sort((d,f)=>d.end.line===f.end.line?d.end.character===f.end.character?d.start.line===f.start.line?d.start.character-f.start.character:d.start.line-f.start.line:d.end.character-f.end.character:d.end.line-f.end.line);for(let d=0,f=v.length-1;d<f;d++){const p=v[d].end;if(v[d+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=I.edits.map(d=>({range:R.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,I.documentVersionId,m,{setEndOfLine:typeof I.setEndOfLine=="number"?R.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}n(w){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this.k.warn(I),null))}}e.ExtHostTextEditor=L}),define(ye[242],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[243],Ce([1,0,193,9,38,123,91,33,27,242,205,195]),function(te,e,c,t,T,R,k,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const w=A.Registry.as(k.Extensions.JSONContribution);class I{constructor(g,r,l){this.a=g,this.b=r,this.c=l}d(g,r){this.a({type:g,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(g){this.d(T.default.Error,g)}warn(g){this.d(T.default.Warning,g)}info(g){this.d(T.default.Info,g)}}e.ExtensionMessageCollector=I;class v{static a(g){const r=new Set;for(let l=0,s=g.length;l<s;l++)r.add(y.ExtensionIdentifier.toKey(g[l].description.identifier));return r}static compute(g,r){if(!g||!g.length)return new v(r,[]);if(!r||!r.length)return new v([],g);const l=this.a(g),s=this.a(r),a=r.filter(u=>!l.has(y.ExtensionIdentifier.toKey(u.description.identifier))),o=g.filter(u=>!s.has(y.ExtensionIdentifier.toKey(u.description.identifier)));return new v(a,o)}constructor(g,r){this.added=g,this.removed=r}}e.ExtensionPointUserDelta=v;class m{constructor(g,r){this.name=g,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(g){if(this.a!==null)throw new Error("Handler already set!");this.a=g,this.d()}acceptUsers(g){this.c=v.compute(this.b,g),this.b=g,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(g){(0,t.onUnexpectedError)(g)}}}e.ExtensionPoint=m;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[c.localize(0,null),c.localize(1,null)]},f="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:c.localize(2,null),properties:{vscode:{type:"string",description:c.localize(3,null),default:"^1.22.0"}}},publisher:{description:c.localize(4,null),type:"string"},displayName:{description:c.localize(5,null),type:"string"},categories:{description:c.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:c.localize(7,null)}]}},galleryBanner:{type:"object",description:c.localize(8,null),properties:{color:{description:c.localize(9,null),type:"string"},theme:{description:c.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:c.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:c.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:c.localize(13,null)},enabledApiProposals:{markdownDescription:c.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:c.localize(15,null),type:"string",enum:["none"],enumDescriptions:[c.localize(16,null)]},activationEvents:{description:c.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:c.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:c.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:c.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:c.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:c.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:c.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:c.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:c.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:c.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:c.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:c.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:c.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:c.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:c.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:c.localize(32,null)},{label:"onUri",body:"onUri",description:c.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:c.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:c.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:c.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:c.localize(37,null)},{label:"onRenderer",description:c.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:c.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:c.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:c.localize(41,null)},{label:"*",description:c.localize(42,null),body:"*"}]}},badges:{type:"array",description:c.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:c.localize(44,null)},href:{type:"string",description:c.localize(45,null)},description:{type:"string",description:c.localize(46,null)}}}},markdown:{type:"string",description:c.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:c.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:c.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:c.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:c.localize(51,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:c.localize(52,null)},{body:["workspace"],description:c.localize(53,null)},{body:["ui","workspace"],description:c.localize(54,null)},{body:["workspace","ui"],description:c.localize(55,null)},{body:[],description:c.localize(56,null)}]},capabilities:{description:c.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:c.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:c.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(60,null),c.localize(61,null),c.localize(62,null)]},description:{type:"string",markdownDescription:c.localize(63,null)}}},untrustedWorkspaces:{description:c.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:c.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null)]},restrictedConfigurations:{description:c.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:c.localize(70,null)}}}}},sponsor:{description:c.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:c.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:c.localize(73,null),type:"string"},"vscode:uninstall":{description:c.localize(74,null),type:"string"}}},icon:{type:"string",description:c.localize(75,null)},l10n:{type:"string",description:c.localize(76,null)}}};class p{constructor(){this.a=new Map}registerExtensionPoint(g){if(this.a.has(g.extensionPoint))throw new Error("Duplicate extension point: "+g.extensionPoint);const r=new m(g.extensionPoint,g.defaultExtensionKind);return this.a.set(g.extensionPoint,r),g.activationEventsGenerator&&P.ImplicitActivationEvents.register(g.extensionPoint,g.activationEventsGenerator),e.schema.properties.contributes.properties[g.extensionPoint]=g.jsonSchema,w.registerSchema(f,e.schema),r}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=p;const b={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(b.ExtensionsRegistry,new p),e.ExtensionsRegistry=A.Registry.as(b.ExtensionsRegistry),w.registerSchema(f,e.schema),w.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:c.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(ye[244],Ce([1,0,190,10,22,243,54,3]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:c.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:c.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:c.localize(2,null),default:""}}};var D;(function(w){function I(v,m,d){if(!v)return;const f=t.isString(v.type)?v.type:void 0;if(!f||f.length===0){d.error(c.localize(3,null));return}const p=[];if(Array.isArray(v.required))for(const b of v.required)t.isString(b)&&p.push(b);return{extensionId:m.value,taskType:f,required:p,properties:v.properties?T.deepClone(v.properties):{},when:v.when?k.ContextKeyExpr.deserialize(v.when):void 0}}w.from=I})(D||(D={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:c.localize(4,null),type:"array",items:y}});class P{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((I,v)=>{L.setHandler((m,d)=>{this.c=void 0;try{for(const f of d.removed){const p=f.value;for(const b of p)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const f of d.added){const p=f.value;for(const b of p){const S=D.from(b,f.description.identifier,f.collector);S&&(this.a[S.taskType]=S)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}I(void 0)})})}onReady(){return this.b}get(I){return this.a[I]}all(){return Object.keys(this.a).map(I=>this.a[I])}getJsonSchema(){if(this.c===void 0){const I=[];for(const v of this.all()){const m={type:"object",additionalProperties:!1};v.required.length>0&&(m.required=v.required.slice(0)),v.properties!==void 0?m.properties=T.deepClone(v.properties):m.properties=Object.create(null),m.properties.type={type:"string",enum:[v.taskType]},I.push(m)}this.c={oneOf:I}}return this.c}}e.TaskDefinitionRegistry=new P}),define(ye[245],Ce([1,0,191,10,24,22,54,244]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new k.RawContextKey("taskRunning",!1,c.localize(0,null)),e.TASKS_CATEGORY={value:c.localize(1,null),original:"Tasks"};var y;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function U(z){if(!z)return O.Strong;switch(z.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=U}(y=e.ShellQuoting||(e.ShellQuoting={}));var D;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(D=e.CommandOptions||(e.CommandOptions={}));var L;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(O){function U(z){switch(z.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=U}(L=e.RevealKind||(e.RevealKind={}));var P;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function U(z){switch(z.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=U}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var w;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(w=e.PanelKind||(e.PanelKind={})),function(O){function U(z){switch(z.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=U}(w=e.PanelKind||(e.PanelKind={}));var I;(function(O){O.defaults={echo:!0,reveal:L.Always,revealProblems:P.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(I=e.PresentationOptions||(e.PresentationOptions={}));var v;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(v=e.RuntimeType||(e.RuntimeType={})),function(O){function U(j){switch(j.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=U;function z(j){switch(j){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=z}(v=e.RuntimeType||(e.RuntimeType={}));var m;(function(O){function U(z){return t.isString(z)?z:z.value}O.value=U})(m=e.CommandString||(e.CommandString={}));var d;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function U(j){return j===O.Clean._id||j===O.Build._id||j===O.Rebuild._id||j===O.Test._id}O.is=U;function z(j){if(j!==void 0)return t.isString(j)?U(j)?{_id:j,isDefault:!1}:void 0:j}O.from=z})(d=e.TaskGroup||(e.TaskGroup={}));var f;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var p;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function U(z){switch(z){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=U})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(O){O.parallel="parallel",O.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var S;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(S=e.RunOnOptions||(e.RunOnOptions={}));var g;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:S.default,instanceLimit:1}})(g=e.RunOptions||(e.RunOptions={}));class r{constructor(U,z,j,ue,V,_){this._label="",this._id=U,z&&(this._label=z),j&&(this.type=j),this.runOptions=ue,this.configurationProperties=V,this._source=_}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,z=!1){if(U===void 0)return!1;if(t.isString(U))return U===this._label||U===this.configurationProperties.identifier||z&&U===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.CommonTask=r;class l extends r{constructor(U,z,j,ue,V,_,J,ne){super(U,j,void 0,J,ne,z),this.command={},this._source=z,this.hasDefinedMatchers=_,V&&(this.command=V)}clone(){return new l(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case v.Shell:z="shell";break;case v.Process:z="process";break;case v.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(U){return U instanceof l}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:z};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new l(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=l;class s extends r{constructor(U,z,j,ue,V,_,J){super(U,j,ue,_,J,z),this._source=z,this.configures=V}static is(U){return U instanceof s}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:z};return JSON.stringify(j)}}e.ConfiguringTask=s;class a extends r{constructor(U,z,j,ue,V,_,J,ne,ee){super(U,j,ue,ne,ee,z),this.defines=V,this.hasDefinedMatchers=J,this.command=_,this.icon=ee.icon,this.hide=ee.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof a}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new a(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=a;class o extends r{constructor(U,z,j,ue,V,_){super(U,j,ue,V,_,z),this._source=z}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new o(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=o;var u;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(u=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(u=e.ExecutionEngine||(e.ExecutionEngine={}));var i;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(i=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class n{constructor(U){this.c=new Map;for(let z=0;z<U.length;z++)this.c.set(U[z].uri.toString(),z)}compare(U,z){const j=U.getWorkspaceFolder(),ue=z.getWorkspaceFolder();if(j&&ue){let V=this.c.get(j.uri.toString());V=V===void 0?0:V+1;let _=this.c.get(ue.uri.toString());return _=_===void 0?0:_+1,V===_?U._label.localeCompare(z._label):V-_}else return!j&&ue?-1:j&&!ue?1:0}}e.TaskSorter=n;var h;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var E;(function(O){O.SingleRun="singleRun",O.Background="background"})(E=e.TaskRunType||(e.TaskRunType={}));var C;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(C=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(O){function U(z,j,ue,V){if(j){const _={kind:z,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ue,__task:j};return z==="start"?_.resolvedVariables=V:z==="processStarted"?_.processId=V:z==="processEnded"&&(_.exitCode=V),Object.freeze(_)}else return Object.freeze({kind:"changed"})}O.create=U})(M=e.TaskEvent||(e.TaskEvent={}));var K;(function(O){function U(j){const ue=Object.keys(j).sort();let V="";for(const _ of ue){let J=j[_];J instanceof Object?J=U(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),V+=_+","+J+","}return V}function z(j){const V={_key:U(j),type:j.taskType};return Object.assign(V,j),V}O.create=z})(K=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var q;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(q=e.TaskSettingId||(e.TaskSettingId={}));var F;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(F=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(O){function U(z,j){const ue=A.TaskDefinitionRegistry.get(z.type);if(ue===void 0){const ne=R.deepClone(z);return delete ne._key,K.create(ne)}const V=Object.create(null);V.type=ue.taskType;const _=new Set;ue.required.forEach(ne=>_.add(ne));const J=ue.properties;for(const ne of Object.keys(J)){const ee=z[ne];if(ee!=null)V[ne]=ee;else if(_.has(ne)){const X=J[ne];if(X.default!==void 0)V[ne]=R.deepClone(X.default);else switch(X.type){case"boolean":V[ne]=!1;break;case"number":case"integer":V[ne]=0;break;case"string":V[ne]="";break;default:j.error(c.localize(2,null,JSON.stringify(z,void 0,0),ne));return}}}return K.create(V)}O.createTaskIdentifier=U})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[246],Ce([1,0,9]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((k,A)=>{this.b=k,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(k){this.f||this.h||(this.f=!0,this.g=k,this.a&&this.b(k))}resolveErr(k){this.f||this.h||(this.h=!0,this.i=k,this.a?this.d(k):(0,c.onUnexpectedError)(k))}then(k,A){return this.j().then(k,A)}catch(k){return this.j().then(void 0,k)}finally(k){return this.j().finally(k)}}e.LazyPromise=t;class T extends t{constructor(){super(),this.h=!0,this.i=new c.CancellationError}}e.CanceledLazyPromise=T}),define(ye[58],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const t=[];function T(A){const y=new c(A);return t[y.nid]=y,y}e.createProxyIdentifier=T;function R(A){return t[A].sid}e.getStringIdentifierForProxy=R;class k{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=k}),define(ye[5],Ce([1,0,58]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(m){m[m.UnknownInput=0]="UnknownInput",m[m.TextInput=1]="TextInput",m[m.TextDiffInput=2]="TextDiffInput",m[m.TextMergeInput=3]="TextMergeInput",m[m.NotebookInput=4]="NotebookInput",m[m.NotebookDiffInput=5]="NotebookDiffInput",m[m.CustomEditorInput=6]="CustomEditorInput",m[m.WebviewEditorInput=7]="WebviewEditorInput",m[m.TerminalEditorInput=8]="TerminalEditorInput",m[m.InteractiveEditorInput=9]="InteractiveEditorInput"})(T=e.TabInputKind||(e.TabInputKind={}));var R;(function(m){m[m.TAB_OPEN=0]="TAB_OPEN",m[m.TAB_CLOSE=1]="TAB_CLOSE",m[m.TAB_UPDATE=2]="TAB_UPDATE",m[m.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var k;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var D;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(D=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(d){return d._id=P.a++,d}}e.IdObject=P,P.a=0;var w;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.kindModifier="m",m.commandIdent="n",m.commandId="o",m.commandArguments="p"})(w=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var I;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(I=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,c.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,c.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,c.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,c.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,c.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,c.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,c.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,c.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,c.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,c.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,c.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,c.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,c.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,c.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,c.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,c.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,c.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,c.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,c.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,c.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,c.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,c.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,c.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,c.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,c.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,c.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,c.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,c.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,c.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,c.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,c.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,c.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,c.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,c.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,c.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,c.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,c.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,c.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,c.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,c.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,c.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,c.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,c.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,c.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,c.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,c.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,c.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,c.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,c.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,c.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,c.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,c.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,c.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,c.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,c.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,c.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,c.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,c.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,c.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,c.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,c.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,c.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,c.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,c.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,c.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,c.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,c.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,c.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,c.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,c.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,c.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,c.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,c.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,c.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,c.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,c.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,c.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,c.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,c.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,c.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,c.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,c.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,c.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,c.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,c.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,c.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,c.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,c.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,c.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,c.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,c.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,c.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,c.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,c.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,c.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,c.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,c.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,c.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,c.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,c.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,c.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,c.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,c.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,c.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,c.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,c.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,c.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,c.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,c.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,c.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,c.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[74],Ce([1,0,4,13,5,18]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(y,D){this.c=D,this.a=new Set,this.b=y.getProxy(T.MainContext.MainThreadTelemetry)}report(y,D,L){const P=this.d(y,D);this.a.has(P)||(this.a.add(P),D.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:y}))}d(y,D){return`${y}-${D.identifier.value}`}};k=qe([We(0,R.IExtHostRpcService),We(1,t.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,D){}})}),define(ye[247],Ce([1,0,3,5,7,27]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(y){this.b=new Map,this.c=[],this.d=new c.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,D,L,P={}){const w=R.ExtensionIdentifier.toKey(y.identifier),I=this.f.get(w)||[],v=[...L].sort().join(" ");let m=I.find(d=>d.providerId===D&&d.scopes===v);if(m)return m.result;{const d=this.g(y,w,D,L,P);m={providerId:D,scopes:v,result:d},I.push(m),this.f.set(w,I);try{await d}finally{const f=I.findIndex(p=>p.providerId===D&&p.scopes===v);f>-1&&(I.splice(f),this.f.set(w,I))}return d}}async g(y,D,L,P,w={}){await this.a.$ensureProvider(L);const I=y.displayName||y.name;return this.a.$getSession(L,P,D,I,w)}async removeSession(y,D){const L=this.b.get(y);return L?L.provider.removeSession(D):this.a.$removeSession(y,D)}registerAuthenticationProvider(y,D,L,P){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:D,provider:L,options:P??{supportsMultipleAccounts:!1}}),this.c.find(I=>I.id===y)||this.c.push({id:y,label:D});const w=L.onDidChangeSessions(I=>{this.a.$sendDidChangeSessions(y,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this.a.$registerAuthenticationProvider(y,D,P?.supportsMultipleAccounts??!1),new T.Disposable(()=>{w.dispose(),this.b.delete(y);const I=this.c.findIndex(v=>v.id===y);I>-1&&this.c.splice(I),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,D){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,D){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,D){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,D){return this.d.fire({provider:{id:y,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(ye[248],Ce([1,0,5,18,15]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(A,y){this.a=A.getProxy(c.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:D=>y.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,D){const L=T.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,D?.isRefactoring??!1)}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(ye[249],Ce([1,0,5]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(R){const k=R.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(A){return k.$writeText(A)}})}}e.ExtHostClipboard=t});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,c):T?T.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[41],Ce([1,0,10,7,15,22,5,16,13,87,36,52,2,6,4,18,137,23,58,45,44,70]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p,b,S,g){"use strict";var r,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(h,E){r.set(this,void 0),this.b=new Map,this.c=new Map,l.set(this,void 0),Je(this,r,h.getProxy(k.MainContext.MainThreadCommands),"f"),this.d=E,Je(this,l,h.getProxy(k.MainContext.MainThreadTelemetry),"f"),this.converter=new a(this,C=>{const M=this.c.get(C);return M?.result===u.Void?M:void 0},E),this.f=[{processArgument(C){return(0,D.revive)(C)}},{processArgument(C){return(0,R.cloneAndChange)(C,function(M){if(L.Range.isIRange(M))return T.Range.to(M);if(P.Position.isIPosition(M))return T.Position.to(M);if(L.Range.isIRange(M.range)&&w.URI.isUri(M.uri))return T.location.to(M);if(M instanceof f.VSBuffer)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const E=this.registerCommand(!1,h.id,async(...C)=>{const M=h.args.map((q,F)=>{if(!q.validate(C[F]))throw new Error(`Invalid argument '${q.name}' when running '${h.id}', received: ${C[F]}`);return q.convert(C[F])}),K=await this.executeCommand(h.internalId,...M);return h.result.convert(K,C,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new t.Disposable(()=>{E.dispose(),this.c.delete(h.id)})}registerCommand(h,E,C,M,K,q){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:C,thisArg:M,description:K,extension:q}),h&&Ue(this,r,"f").$registerCommand(E),new t.Disposable(()=>{this.b.delete(E)&&h&&Ue(this,r,"f").$unregisterCommand(E)})}executeCommand(h,...E){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,E,!0)}async g(h,E,C){if(this.b.has(h))return Ue(this,r,"f").$fireCommandActivationEvent(h),this.h(h,E,!1);{let M=!1;const K=(0,R.cloneAndChange)(E,function(q){if(q instanceof t.Position)return T.Position.from(q);if(q instanceof t.Range)return T.Range.from(q);if(q instanceof t.Location)return T.location.from(q);if(t.NotebookRange.isNotebookRange(q))return T.NotebookRange.from(q);if(q instanceof ArrayBuffer)return M=!0,f.VSBuffer.wrap(new Uint8Array(q));if(q instanceof Uint8Array)return M=!0,f.VSBuffer.wrap(q);if(q instanceof f.VSBuffer)return M=!0,q;if(!Array.isArray(q))return q});try{const q=await Ue(this,r,"f").$executeCommand(h,M?new p.SerializableObjectWithBuffers(K):K,C);return(0,D.revive)(q)}catch(q){if(q instanceof Error&&q.message==="$executeCommand:retry")return this.g(h,E,!1);throw q}}}async h(h,E,C){const M=this.b.get(h);if(!M)throw new Error("Unknown command");const{callback:K,thisArg:q,description:F}=M;if(F)for(let O=0;O<F.args.length;O++)try{(0,c.validateConstraint)(E[O],F.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${F.args[O].name}' - ${F.args[O].description}`)}const B=S.StopWatch.create();try{return await K.apply(q,E)}catch(O){if(h===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...E);U&&(h=U.command)}throw this.d.error(O,h,M.extension?.identifier),C?new class extends Error{constructor(){super((0,b.toErrorMessage)(O)),this.id=h,this.source=M.extension?.displayName??M.extension?.name}}:O}finally{this.j(M,h,B.elapsed())}}j(h,E,C){!h.extension||Ue(this,l,"f").$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new g.TelemetryTrustedValue(E),duration:C})}$executeContributedCommand(h,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const C=this.b.get(h);return C?(E=E.map(M=>this.f.reduce((K,q)=>q.processArgument(K,C.extension?.identifier),M)),this.h(h,E,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),Ue(this,r,"f").$getCommands().then(E=>(h&&(E=E.filter(C=>C[0]!=="_")),E))}$getContributedCommandHandlerDescriptions(){const h=Object.create(null);for(const[E,C]of this.b){const{description:M}=C;M&&(h[E]=M)}return Promise.resolve(h)}};r=new WeakMap,l=new WeakMap,s=qe([We(0,m.IExtHostRpcService),We(1,y.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class a{constructor(h,E,C){this.d=h,this.f=E,this.g=C,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,E){if(!h)return;const C={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return C;const M=this.f(h.command);if(M)C.id=M.internalId,C.arguments=M.args.map((K,q)=>K.convert(h.arguments&&h.arguments[q]));else if((0,A.isNonEmptyArray)(h.arguments)){const K=`${h.command}/${++this.c}`;this.b.set(K,h),E.add((0,I.toDisposable)(()=>{this.b.delete(K),this.g.trace("CommandsConverter#DISPOSE",K)})),C.$ident=K,C.id=this.delegatingCommandId,C.arguments=[K],this.g.trace("CommandsConverter#CREATE",h.command,K)}return C}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const E=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.CommandsConverter=a;class o{constructor(h,E,C,M){this.name=h,this.description=E,this.validate=C,this.convert=M}optional(){return new o(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,E){return new o(h??this.name,E??this.description,this.validate,this.convert)}}e.ApiCommandArgument=o,o.Uri=new o("uri","Uri of a text document",n=>w.URI.isUri(n),n=>n),o.Position=new o("position","A position in a text document",n=>t.Position.isPosition(n),T.Position.from),o.Range=new o("range","A range in a text document",n=>t.Range.isRange(n),T.Range.from),o.Selection=new o("selection","A selection in a text document",n=>t.Selection.isSelection(n),T.Selection.from),o.Number=new o("number","",n=>typeof n=="number",n=>n),o.String=new o("string","",n=>typeof n=="string",n=>n),o.CallHierarchyItem=new o("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,T.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,T.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",n=>n instanceof d.TestItemImpl,T.TestItem.from);class u{constructor(h,E){this.description=h,this.convert=E}}e.ApiCommandResult=u,u.Void=new u("no result",n=>n);class i{constructor(h,E,C,M,K){this.id=h,this.internalId=E,this.description=C,this.args=M,this.result=K}}e.ApiCommand=i}),define(ye[250],Ce([1,0,2,15,7,68,41,16,120,125,17]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new k.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(t.DocumentHighlight.to))),new k.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(m,d)=>{if((0,A.isFalsyOrEmpty)(m))return;class f extends T.SymbolInformation{static to(b){const S=new f(b.name,t.SymbolKind.to(b.kind),b.containerName||"",new T.Location(d[0],t.Range.to(b.range)));return S.detail=b.detail,S.range=S.location.range,S.selectionRange=t.Range.to(b.selectionRange),S.children=b.children?b.children.map(f.to):[],S}}return m.map(f.to)})),new k.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(t.TextEdit.to))),new k.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range,new k.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(t.TextEdit.to))),new k.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,new k.ApiCommandArgument("ch","Trigger character",m=>typeof m=="string",m=>m),new k.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new k.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(t.TextEdit.to))),new k.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new k.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new k.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new k.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new k.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(t.location.to))),new k.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(t.Hover.to))),new k.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("position","A position in a text document",m=>Array.isArray(m)&&m.every(d=>T.Position.isPosition(d)),m=>m.map(t.Position.from))],new k.ApiCommandResult("A promise that resolves to an array of ranges.",m=>m.map(d=>{let f;for(const p of d.reverse())f=new T.SelectionRange(t.Range.to(p),f);return f}))),new k.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[k.ApiCommandArgument.String.with("query","Search string")],new k.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",m=>m.map(t.WorkspaceSymbol.to))),new k.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",m=>m.map(t.CallHierarchyItem.to))),new k.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",m=>m.map(t.CallHierarchyIncomingCall.to))),new k.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[k.ApiCommandArgument.CallHierarchyItem],new k.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",m=>m.map(t.CallHierarchyOutgoingCall.to))),new k.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to a range and placeholder text.",m=>{if(!!m)return{range:t.Range.to(m.range),placeholder:m.text}})),new k.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("newName","The new symbol name")],new k.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",m=>{if(!!m){if(m.rejectReason)throw new Error(m.rejectReason);return t.WorkspaceEdit.to(m)}})),new k.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new k.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",m=>m.map(t.DocumentLink.to))),new k.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new T.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const d=(0,y.decodeSemanticTokensDto)(m);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range.optional()],new k.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new T.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new k.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const d=(0,y.decodeSemanticTokensDto)(m);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)})),new k.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new k.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(m,d,f)=>{if(!m)return new T.CompletionList([]);const p=m.suggestions.map(b=>t.CompletionItem.to(b,f));return new T.CompletionList(p,m.incomplete)})),new k.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position,k.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new k.ApiCommandResult("A promise that resolves to SignatureHelp.",m=>{if(m)return t.SignatureHelp.to(m)})),new k.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new k.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(m,d,f)=>I(p=>new T.CodeLens(t.Range.to(p.range),p.command&&f.fromInternal(p.command)))(m))),new k.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[k.ApiCommandArgument.Uri,new k.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",m=>T.Range.isRange(m),m=>T.Selection.isSelection(m)?t.Selection.from(m):t.Range.from(m)),k.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),k.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new k.ApiCommandResult("A promise that resolves to an array of Command-instances.",(m,d,f)=>I(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(p.command)}else{const b=new T.CodeAction(p.title,p.kind?new T.CodeActionKind(p.kind):void 0);return p.edit&&(b.edit=t.WorkspaceEdit.to(p.edit)),p.command&&(b.command=f.fromInternal(p.command)),b.isPreferred=p.isPreferred,b}})(m))),new k.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[k.ApiCommandArgument.Uri],new k.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",m=>m?m.map(d=>new T.ColorInformation(t.Range.to(d.range),t.Color.to(d.color))):[])),new k.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new k.ApiCommandArgument("color","The color to show and insert",m=>m instanceof T.Color,t.Color.from),new k.ApiCommandArgument("context","Context object with uri and range",m=>!0,m=>({uri:m.uri,range:t.Range.from(m.range)}))],new k.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",m=>m?m.map(t.ColorPresentation.to):[])),new k.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of Inlay objects",(m,d,f)=>m.map(t.InlayHint.to.bind(void 0,f)))),new k.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new k.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(m=>({viewType:m.viewType,displayName:m.displayName,options:{transientOutputs:m.options.transientOutputs,transientCellMetadata:m.options.transientCellMetadata,transientDocumentMetadata:m.options.transientDocumentMetadata},filenamePattern:m.filenamePattern.map(d=>t.NotebookExclusiveDocumentPattern.to(d))})))),new k.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Range],new k.ApiCommandResult("A promise that resolves to an array of InlineValue objects",m=>m.map(t.InlineValue.to))),new k.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new k.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",m=>c.URI.isUri(m)||typeof m=="string"&&(0,D.matchesSomeScheme)(m,L.Schemas.http,L.Schemas.https),m=>m),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[t.ViewColumn.from(m),void 0]:[t.ViewColumn.from(m.viewColumn),t.TextEditorOpenOptions.from(m)])).optional(),k.ApiCommandArgument.String.with("label","").optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[k.ApiCommandArgument.Uri.with("resource","Resource to open"),k.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[t.ViewColumn.from(m),void 0]:[t.ViewColumn.from(m.viewColumn),t.TextEditorOpenOptions.from(m)])).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[k.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),k.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),k.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new k.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="object",m=>m&&[t.ViewColumn.from(m.viewColumn),t.TextEditorOpenOptions.from(m)]).optional()],k.ApiCommandResult.Void),new k.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[k.ApiCommandArgument.Uri,k.ApiCommandArgument.Position],new k.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(t.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(t.TypeHierarchyItem.to))),new k.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[k.ApiCommandArgument.TypeHierarchyItem],new k.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(t.TypeHierarchyItem.to))),new k.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[k.ApiCommandArgument.TestItem],k.ApiCommandResult.Void),new k.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[k.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],k.ApiCommandResult.Void),new k.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[k.ApiCommandArgument.String.with("name","The context key name"),new k.ApiCommandArgument("value","The context key value",()=>!0,m=>m)],k.ApiCommandResult.Void)];class w{static register(d){P.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=w;function I(m){return d=>{if(Array.isArray(d))return d.map(m)}}function v(m){if(!Array.isArray(m))return;const d=[];for(const f of m)R.isLocationLink(f)?d.push(t.DefinitionLink.to(f)):d.push(t.location.to(f));return d}}),define(ye[251],Ce([1,0,14,62,3,6,2,68,27,15,7,26,5]),function(te,e,c,t,T,R,k,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function I(v,m,d){const f=v.getProxy(w.MainContext.MainThreadComments);class p{constructor(){this.b=new Map,this.c=new Map,m.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const i=this.b.get(u.handle);return i?i.value:u}else if(u&&u.$mid===7){const i=this.b.get(u.commentControlHandle);if(!i)return u;const n=i.getCommentThread(u.commentThreadHandle);return n?n.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const i=this.b.get(u.thread.commentControlHandle);if(!i)return u;const n=i.getCommentThread(u.thread.commentThreadHandle);return n?u.$mid===8?n.value:{thread:n.value,text:u.text}:u}else if(u&&u.$mid===10){const i=this.b.get(u.thread.commentControlHandle);if(!i)return u;const n=i.getCommentThread(u.thread.commentThreadHandle);if(!n)return u;const h=u.commentUniqueId,E=n.getCommentByUniqueId(h);return E||u}else if(u&&u.$mid===11){const i=this.b.get(u.thread.commentControlHandle);if(!i)return u;const n=i.getCommentThread(u.thread.commentThreadHandle);if(!n)return u;const h=u.text,E=u.commentUniqueId,C=n.getCommentByUniqueId(E);return C?(typeof C.body=="string"?C.body=h:C.body=new L.MarkdownString(h),C):u}return u}})}createCommentController(u,i,n){const h=p.a++,E=new S(u,h,i,n);this.b.set(E.handle,E);const C=this.c.get(y.ExtensionIdentifier.toKey(u.identifier))||[];return C.push(E),this.c.set(y.ExtensionIdentifier.toKey(u.identifier),C),E.value}$createCommentThreadTemplate(u,i,n){const h=this.b.get(u);!h||h.$createCommentThreadTemplate(i,n)}async $updateCommentThreadTemplate(u,i,n){const h=this.b.get(u);!h||h.$updateCommentThreadTemplate(i,n)}$deleteCommentThread(u,i){this.b.get(u)?.$deleteCommentThread(i)}$provideCommentingRanges(u,i,n){const h=this.b.get(u);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const E=d.getDocument(k.URI.revive(i));return(0,c.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(E,n)).then(C=>C?C.map(M=>D.Range.from(M)):void 0)}$toggleReaction(u,i,n,h,E){const C=this.b.get(u);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const M=C.getCommentThread(i);if(M){const K=M.getCommentByUniqueId(h.uniqueIdInThread);if(C!==void 0&&K&&C.reactionHandler)return C.reactionHandler(K,l(E))}return Promise.resolve(void 0)})}dispose(){}}p.a=0;class b{set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){u.isEqual(this.p)||(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(u){(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,i,n,h,E,C,M,K){this.m=i,this.n=n,this.o=h,this.p=E,this.q=C,this.extensionDescription=M,this.r=K,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new T.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${u}.${this.handle}`),f.$createCommentThread(i,this.handle,this.n,this.o,D.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{f.$deleteCommentThread(i,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(F){q.range=F},get comments(){return q.comments},set comments(F){q.comments=F},get collapsibleState(){return q.collapsibleState},set collapsibleState(F){q.collapsibleState=F},get canReply(){return q.canReply},set canReply(F){q.canReply=F},get contextValue(){return q.contextValue},set contextValue(F){q.contextValue=F},get label(){return q.label},set label(F){q.label=F},get state(){return q.state},set state(F){q.state=F},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const u=n=>Object.prototype.hasOwnProperty.call(this.b,n),i={};u("range")&&(i.range=D.Range.from(this.p)),u("label")&&(i.label=this.label),u("contextValue")&&(i.contextValue=this.contextValue??null),u("comments")&&(i.comments=this.q.map(n=>g(this,n,this.k))),u("collapsibleState")&&(i.collapseState=s(this.g)),u("canReply")&&(i.canReply=this.canReply),u("state")&&(i.state=a(this.h)),u("isTemplate")&&(i.isTemplate=this.r),this.b={},f.$updateCommentThread(this.m,this.handle,this.n,this.o,i)}getCommentByUniqueId(u){for(const i of this.k){const n=i[0],h=i[1];if(u===h)return n}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}b.a=0,qe([(0,t.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class S{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,f.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,i,n,h){this.f=u,this.g=i,this.h=n,this.i=h,this.a=new Map,f.$registerCommentController(this.handle,n,h);const E=this;this.value=Object.freeze({id:E.id,label:E.label,get options(){return E.options},set options(C){E.options=C},get commentingRangeProvider(){return E.commentingRangeProvider},set commentingRangeProvider(C){E.commentingRangeProvider=C},get reactionHandler(){return E.reactionHandler},set reactionHandler(C){E.reactionHandler=C},createCommentThread(C,M,K){return E.createCommentThread(C,M,K).value},dispose:()=>{E.dispose()}}),this.e=[],this.e.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(u,i,n,h){if(typeof u=="string"){const E=new b(this.id,this.handle,u,i,n,h,this.f,!1);return this.a.set(E.handle,E),E}else{const E=new b(this.id,this.handle,void 0,u,i,n,this.f,!1);return this.a.set(E.handle,E),E}}$createCommentThreadTemplate(u,i){const n=new b(this.id,this.handle,void 0,k.URI.revive(u),D.Range.to(i),[],this.f,!0);return n.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(n.handle,n),n}$updateCommentThreadTemplate(u,i){const n=this.a.get(u);n&&(n.range=D.Range.to(i))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function g(o,u,i){let n=i.get(u);n||(n=++o.commentHandle,i.set(u,n));const h=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:n,body:typeof u.body=="string"?u.body:D.MarkdownString.from(u.body),userName:u.author.name,userIconPath:h,label:u.label,commentReactions:u.reactions?u.reactions.map(E=>r(E)):void 0,timestamp:u.timestamp?.toJSON()}}function r(o){return{label:o.label,iconPath:o.iconPath?D.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function l(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?k.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function s(o){if(o!==void 0)switch(o){case L.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function a(o){if(o!==void 0)switch(o){case L.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new p}e.createExtHostComments=I}),define(ye[252],Ce([1,0,22,5,25,18]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let k=class{constructor(L,P){this.a=L.getProxy(t.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,P){const w=this,I=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){w.e(L,P,I,arguments)}})}e(L,P,w,I){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:y(I,this.b)}),this.c&&this.f(L,w,I)}};k=qe([We(0,R.IExtHostRpcService),We(1,T.IExtHostInitDataService)],k),e.AbstractExtHostConsoleForwarder=k;const A=1e5;function y(D,L){const P=[];if(D.length)for(let w=0;w<D.length;w++){let I=D[w];if(typeof I>"u")I="undefined";else if(I instanceof Error){const v=I;v.stack?I=v.stack:I=v.toString()}P.push(I)}if(L){const w=new Error().stack;w&&P.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,c.safeStringify)(P);return w.length>A?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(ye[139],Ce([1,0,2,5,7,4,18,13,16,8,11,26]),function(te,e,c,t,T,R,k,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=class Bn{constructor(v,m){this.h=m,this.f=new Map,this.g=v.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(v,m){const d=Bn.c++;this.f.set(d,{provider:v,extensionDescription:m}),this.g.$registerDecorationProvider(d,m.identifier.value);const f=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(d,null);return}const b=(0,y.asArray)(p);if(b.length<=Bn.d){this.g.$onDidChange(d,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,b.length);const S=b.map(l=>({uri:l,rank:(0,D.count)(l.path,"/")})),g=(0,y.groupBy)(S,(l,s)=>l.rank-s.rank||(0,D.compare)(l.uri.path,s.uri.path)),r=[];e:for(const l of g){let s;for(const a of l){const o=(0,L.dirname)(a.uri.path);if(s!==o&&(s=o,r.push(a.uri)>=Bn.d))break e}}this.g.$onDidChange(d,r)});return new T.Disposable(()=>{f?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(v,m,d){if(!this.f.has(v))return Object.create(null);const f=Object.create(null),{provider:p,extensionDescription:b}=this.f.get(v);return await Promise.all(m.map(async S=>{try{const{uri:g,id:r}=S,l=await Promise.resolve(p.provideFileDecoration(c.URI.revive(g),d));if(!l)return;try{T.FileDecoration.validate(l),l.badge&&typeof l.badge!="string"&&(0,P.checkProposedApiEnabled)(b,"codiconDecoration"),f[r]=[l.propagate,l.tooltip,l.badge,l.color]}catch(s){this.h.warn(`INVALID decoration from extension '${b}': ${s}`)}}catch(g){this.h.error(g)}})),f}};w.c=0,w.d=250,w=qe([We(0,k.IExtHostRpcService),We(1,A.ILogService)],w),e.ExtHostDecorations=w,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,c):T?T.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[253],Ce([1,0,176,124,2,5,7,15,3,13,28,48]),function(te,e,c,t,T,R,k,A,y,D,L,P){"use strict";var w,I,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class m{constructor(p,b,S,g,r,l,s){this.d=p,this.e=b,this.f=S,this.g=g,w.set(this,void 0),I.set(this,void 0),v.set(this,void 0),this.c=!1,Je(this,v,new L.ResourceMap(a=>r.getComparisonKey(a)),"f"),Je(this,w,l,"f"),Je(this,I,s,"f")}dispose(){this.c||(Ue(this,I,"f").fire([...Ue(this,v,"f").keys()]),Ue(this,w,"f")?.$clear(this.e),Ue(this,v,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(p,b){if(!p){this.clear();return}this.h();let S=[];if(T.URI.isUri(p)){if(!b){this.delete(p);return}Ue(this,v,"f").set(p,b.slice()),S=[p]}else if(Array.isArray(p)){S=[];let r;p=[...p].sort(m.j);for(const l of p){const[s,a]=l;if((!r||s.toString()!==r.toString())&&(r&&Ue(this,v,"f").get(r).length===0&&Ue(this,v,"f").delete(r),r=s,S.push(s),Ue(this,v,"f").set(s,[])),a)Ue(this,v,"f").get(s)?.push(...a);else{const o=Ue(this,v,"f").get(s);o&&(o.length=0)}}}if(Ue(this,I,"f").fire(S),!Ue(this,w,"f"))return;const g=[];for(const r of S){let l=[];const s=Ue(this,v,"f").get(r);if(s)if(s.length>this.f){l=[];const a=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const u of s)if(u.severity===a[o]&&l.push({...A.Diagnostic.from(u),modelVersionId:this.g(r)})===this.f)break e;l.push({severity:t.MarkerSeverity.Info,message:(0,c.localize)(0,null,s.length-this.f),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=s.map(a=>({...A.Diagnostic.from(a),modelVersionId:this.g(r)}));g.push([r,l])}Ue(this,w,"f").$changeMany(this.e,g)}delete(p){this.h(),Ue(this,I,"f").fire([p]),Ue(this,v,"f").delete(p),Ue(this,w,"f")?.$changeMany(this.e,[[p,void 0]])}clear(){this.h(),Ue(this,I,"f").fire([...Ue(this,v,"f").keys()]),Ue(this,v,"f").clear(),Ue(this,w,"f")?.$clear(this.e)}forEach(p,b){this.h();for(const[S,g]of this)p.call(b,S,g,this)}*[(w=new WeakMap,I=new WeakMap,v=new WeakMap,Symbol.iterator)](){this.h();for(const p of Ue(this,v,"f").keys())yield[p,this.get(p)]}get(p){this.h();const b=Ue(this,v,"f").get(p);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(p){return this.h(),Array.isArray(Ue(this,v,"f").get(p))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(p,b){return p[0].toString()<b[0].toString()?-1:p[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=m;let d=class wn{static _mapper(p){const b=new L.ResourceMap;for(const S of p)b.set(S,S);return{uris:Object.freeze(Array.from(b.values()))}}constructor(p,b,S,g){this.h=b,this.j=S,this.k=g,this.f=new Map,this.g=new y.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,wn._mapper),this.e=p.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,b){const{f:S,e:g,g:r,h:l,j:s,k:a}=this,o=new class{$changeMany(n,h){g.$changeMany(n,h),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,n,h.length===0?"CLEARING":h)}$clear(n){g.$clear(n),l.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,n)}dispose(){g.dispose()}};let u;if(!b)b="_generated_diagnostic_collection_name_#"+wn.c++,u=b;else if(!S.has(b))u=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do u=b+wn.c++;while(S.has(u))}return new class extends m{constructor(){super(b,u,wn.d,n=>a.getDocument(n)?.version,s.extUri,o,r),S.set(u,this)}dispose(){super.dispose(),S.delete(u)}}}getDiagnostics(p){if(p)return this.l(p);{const b=new Map,S=[];for(const g of this.f.values())g.forEach((r,l)=>{let s=b.get(r.toString());typeof s>"u"&&(s=S.length,b.set(r.toString(),s),S.push([r,[]])),S[s][1]=S[s][1].concat(...l)});return S}}l(p){let b=[];for(const S of this.f.values())S.has(p)&&(b=b.concat(S.get(p)));return b}$acceptMarkersChange(p){if(!this.m){const b="_generated_mirror",S=new m(b,b,wn.d,g=>{},this.j.extUri,void 0,this.g);this.f.set(b,S),this.m=S}for(const[b,S]of p)this.m.set(T.URI.revive(b),S.map(A.Diagnostic.to))}};d.c=0,d.d=1e3,d=qe([We(1,D.ILogService),We(2,P.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ye[254],Ce([1,0,2,5]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(k){this.a=k.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(k){return this.a.$showOpenDialog(k).then(A=>A?A.map(y=>c.URI.revive(y)):void 0)}showSaveDialog(k){return this.a.$showSaveDialog(k).then(A=>A?c.URI.revive(A):void 0)}}e.ExtHostDialogs=T}),define(ye[255],Ce([1,0,9,2,7,5,17,21,8]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(P,w,I){this.d=w,this.e=I,this.b=new Map,this.c=P.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,w){if(Object.keys(k.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const I=D.a++;this.b.set(I,w),this.c.$registerTextContentProvider(I,P);let v;return typeof w.onDidChange=="function"&&(v=w.onDidChange(m=>{if(m.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this.d.getDocument(m)&&this.$provideTextDocumentContent(I,m).then(d=>{if(!d&&typeof d!="string")return;const f=this.d.getDocument(m);if(!f)return;const p=(0,y.splitLines)(d);if(!f.equalLines(p))return this.c.$onVirtualDocumentChange(m,d)},c.onUnexpectedError)})),new T.Disposable(()=>{this.b.delete(I)&&this.c.$unregisterTextContentProvider(I),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(P,w){const I=this.b.get(P);return I?Promise.resolve(I.provideTextDocumentContent(t.URI.revive(w),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.ExtHostDocumentContentProvider=D,D.a=0}),define(ye[256],Ce([1,0,3,6,2,5,135,15,10,22,7]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(I,v){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=I.getProxy(R.MainContext.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(m=>{for(const d of m)this.b.fire(d.document)},void 0,this.e),this.g.onDidAddDocuments(m=>{for(const d of m)this.a.fire(d.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(I){if(!I)return;const v=this.g.getDocument(I);if(v)return v}getDocument(I){const v=this.getDocumentData(I);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return v.document}ensureDocumentData(I){const v=this.g.getDocument(I);if(v)return Promise.resolve(v);let m=this.h.get(I.toString());return m||(m=this.f.$tryOpenDocument(I).then(d=>{this.h.delete(I.toString());const f=T.URI.revive(d);return(0,y.assertIsDefined)(this.g.getDocument(f))},d=>(this.h.delete(I.toString()),Promise.reject(d))),this.h.set(I.toString(),m)),m}createDocumentData(I){return this.f.$tryCreateDocument(I).then(v=>T.URI.revive(v))}$acceptModelLanguageChanged(I,v){const m=T.URI.revive(I),d=this.g.getDocument(m);if(!d)throw new Error("unknown document");this.b.fire(d.document),d._acceptLanguageId(v),this.a.fire(d.document)}$acceptModelSaved(I){const v=T.URI.revive(I),m=this.g.getDocument(v);if(!m)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this.d.fire(m.document)}$acceptDirtyStateChanged(I,v){const m=T.URI.revive(I),d=this.g.getDocument(m);if(!d)throw new Error("unknown document");d._acceptIsDirty(v),this.c.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,v,m){const d=T.URI.revive(I),f=this.g.getDocument(d);if(!f)throw new Error("unknown document");f._acceptIsDirty(m),f.onEvents(v);let p;v.isUndoing?p=L.TextDocumentChangeReason.Undo:v.isRedoing&&(p=L.TextDocumentChangeReason.Redo),this.c.fire((0,D.deepFreeze)({document:f.document,contentChanges:v.changes.map(b=>({range:A.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:p}))}setWordDefinitionFor(I,v){(0,k.setWordDefinitionFor)(I,v)}}e.ExtHostDocuments=P}),define(ye[59],Ce([1,0,51,3,6,2,4,5,135,18,138,15,13,28,17,64,83]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(S){this.value=S,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let p=class{constructor(S,g){this.h=S,this.i=g,this.a=null,this.b=new Map,this.c=new I.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(S){this.acceptDocumentsAndEditorsDelta(S)}acceptDocumentsAndEditorsDelta(S){const g=[],r=[],l=[];if(S.removedDocuments)for(const s of S.removedDocuments){const a=R.URI.revive(s),o=this.c.get(a);o?.unref()&&(this.c.delete(a),g.push(o.value))}if(S.addedDocuments)for(const s of S.addedDocuments){const a=R.URI.revive(s.uri);let o=this.c.get(a);if(o&&a.scheme!==v.Schemas.vscodeNotebookCell&&a.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);o||(o=new f(new y.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),a,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(a,o),r.push(o.value)),o.ref()}if(S.removedEditors)for(const s of S.removedEditors){const a=this.b.get(s);this.b.delete(s),a&&l.push(a)}if(S.addedEditors)for(const s of S.addedEditors){const a=R.URI.revive(s.documentUri);c.ok(this.c.has(a),`document '${a}' does not exist`),c.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const o=this.c.get(a).value,u=new L.ExtHostTextEditor(s.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new d.Lazy(()=>o.document),s.selections.map(P.Selection.to),s.options,s.visibleRanges.map(i=>P.Range.to(i)),typeof s.editorPosition=="number"?P.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,u)}S.newActiveEditor!==void 0&&(c.ok(S.newActiveEditor===null||this.b.has(S.newActiveEditor),`active editor '${S.newActiveEditor}' does not exist`),this.a=S.newActiveEditor),(0,T.dispose)(g),(0,T.dispose)(l),S.removedDocuments&&this.e.fire(g),S.addedDocuments&&this.d.fire(r),(S.removedEditors||S.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),S.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(S){return this.c.get(S)?.value}allDocuments(){return m.Iterable.map(this.c.values(),S=>S.value)}getEditor(S){return this.b.get(S)}activeEditor(S){if(!this.a)return;const g=this.b.get(this.a);return S?g:g?.value}allEditors(){return[...this.b.values()]}};p=qe([We(0,D.IExtHostRpcService),We(1,w.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[60],Ce([1,0,15,5,2,3,4,7,18,10,61]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");class P{constructor(d,f,p){this.e=p,this.d=f,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,f={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(f)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(T.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(T.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));default:return}}}class w{constructor(d,f){this.c=[],this.d="",this.b=d,this.e=f;for(const p of d.tabs)p.isActive&&(this.d=p.id),this.c.push(new P(p,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,f={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return c.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(p=>p.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(p=>p.apiObject))}};this.a=Object.freeze(f)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const p=new P(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,p),d.tabDto.isActive&&(this.d=p.tabId),p}else if(d.kind===1){const p=this.c.splice(d.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return p.tabId===this.d&&(this.d=""),p}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this.c.splice(d.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,p),p}const f=this.c.find(p=>p.tabId===d.tabDto.id);if(!f)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),f.acceptDtoUpdate(d.tabDto),f}activeTabId(){return this.d}}let I=class{constructor(d){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=d.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,f={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(p=>p.apiObject))},get activeTabGroup(){const p=d.d;return(0,D.assertIsDefined)(d.e.find(S=>S.groupId===p)?.apiObject)},close:async(p,b)=>{const S=Array.isArray(p)?p:[p];return S.length?v(S[0])?this.j(S,b):this.i(S,b):!0}};this.f=Object.freeze(f)}return this.f}$acceptEditorTabModel(d){const f=new Set(this.e.map(s=>s.groupId)),p=new Set(d.map(s=>s.groupId)),b=(0,L.diffSets)(f,p),S=this.e.filter(s=>b.removed.includes(s.groupId)).map(s=>s.apiObject),g=[],r=[];this.e=d.map(s=>{const a=new w(s,()=>this.d);return b.added.includes(a.groupId)?g.push(a.apiObject):r.push(a.apiObject),a});const l=(0,D.assertIsDefined)(d.find(s=>s.isActive===!0)?.groupId);l!==void 0&&this.d!==l&&(this.d=l),this.c.fire(Object.freeze({opened:g,closed:S,changed:r}))}$acceptTabGroupUpdate(d){const f=this.e.find(p=>p.groupId===d.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const f=this.e.find(b=>b.groupId===d.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const p=f.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}g(d){for(const f of this.e)for(const p of f.tabs)if(p.apiObject===d)return p}h(d){return this.e.find(f=>f.apiObject===d)}async i(d,f){const p=[];for(const b of d){const S=this.g(b);if(!S)throw new Error("Tab close: Invalid tab not found!");p.push(S.tabId)}return this.a.$closeTab(p,f)}async j(d,f){const p=[];for(const b of d){const S=this.h(b);if(!S)throw new Error("Group close: Invalid group not found!");p.push(S.groupId)}return this.a.$closeGroup(p,f)}};I=qe([We(0,y.IExtHostRpcService)],I),e.ExtHostEditorTabs=I;function v(m){return m.tabs!==void 0}}),define(ye[257],Ce([1,0,2,5,6,7,15,153,8,23,26]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const m=this.a.indexOf(v);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),m=[];let d,f,p=14,b=14;for(const S of v){let g=d?(0,y.commonPrefixLength)(d,S):0;for(g===0?f=1:f=b;g<S.length;g++)g+1===S.length?(p=b,b=9):b+=1,m.push([f,S.toUpperCase().charCodeAt(g),b]),m.push([f,S.toLowerCase().charCodeAt(g),b]),f=b;d=S,b=p}m.push([9,58,10]),m.push([10,47,12]),this.b=new A.StateMachine(m)}}provideDocumentLinks(v){this.c();const m=[],d=A.LinkComputer.computeLinks({getLineContent(f){return v.lineAt(f-1).text},getLineCount(){return v.lineCount}},this.b);for(const f of d){const p=k.DocumentLink.to(f);p.target&&m.push(p)}return m}}class w{constructor(v,m){this.i=m,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,m,d,f={}){if(this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const p=this.h++;this.b.add(m),this.d.add(m),this.c.set(p,d);let b=2;f.isCaseSensitive&&(b+=1024),f.isReadonly&&(b+=2048),typeof d.copy=="function"&&(b+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,L.checkProposedApiEnabled)(v,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(p,m,b).catch(g=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${m}`),console.error(g)});const S=d.onDidChangeFile(g=>{const r=[];for(const l of g){const{uri:s,type:a}=l;if(s.scheme!==m)continue;let o;switch(a){case R.FileChangeType.Changed:o=0;break;case R.FileChangeType.Created:o=1;break;case R.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:s,type:o})}this.a.$onFileSystemChange(p,r)});return(0,T.toDisposable)(()=>{S.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(v){const{type:m,ctime:d,mtime:f,size:p,permissions:b}=v;return{type:m,ctime:d,mtime:f,size:p,permissions:b}}$stat(v,m){return Promise.resolve(this.k(v).stat(c.URI.revive(m))).then(d=>w.j(d))}$readdir(v,m){return Promise.resolve(this.k(v).readDirectory(c.URI.revive(m)))}$readFile(v,m){return Promise.resolve(this.k(v).readFile(c.URI.revive(m))).then(d=>D.VSBuffer.wrap(d))}$writeFile(v,m,d,f){return Promise.resolve(this.k(v).writeFile(c.URI.revive(m),d.buffer,f))}$delete(v,m,d){return Promise.resolve(this.k(v).delete(c.URI.revive(m),d))}$rename(v,m,d,f){return Promise.resolve(this.k(v).rename(c.URI.revive(m),c.URI.revive(d),f))}$copy(v,m,d,f){const p=this.k(v);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(c.URI.revive(m),c.URI.revive(d),f))}$mkdir(v,m){return Promise.resolve(this.k(v).createDirectory(c.URI.revive(m)))}$watch(v,m,d,f){const p=this.k(v).watch(c.URI.revive(d),f);this.f.set(m,p)}$unwatch(v,m){const d=this.f.get(m);d&&(d.dispose(),this.f.delete(m))}$open(v,m,d){const f=this.k(v);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(c.URI.revive(m),d))}$close(v,m){const d=this.k(v);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(m))}$read(v,m,d,f){const p=this.k(v);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const b=D.VSBuffer.alloc(f);return Promise.resolve(p.read(m,d,b.buffer,0,f)).then(S=>b.slice(0,S))}$write(v,m,d,f){const p=this.k(v);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(m,d,f.buffer,0,f.byteLength))}k(v){const m=this.c.get(v);if(!m){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return m}}e.ExtHostFileSystem=w}),define(ye[75],Ce([1,0,5,40,7,23,4,18,48,6]),function(te,e,c,t,T,R,k,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Zt{constructor(w,I){this.b=new Map,this.a=w.getProxy(c.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(m){try{const d=v.b.get(m.scheme);if(!d)return await v.a.$stat(m);await v.a.$ensureActivation(m.scheme);const f=await d.stat(m);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(d){Zt.c(d)}},async readDirectory(m){try{const d=v.b.get(m.scheme);return d?(await v.a.$ensureActivation(m.scheme),(await d.readDirectory(m)).slice()):await v.a.$readdir(m)}catch(d){return Zt.c(d)}},async createDirectory(m){try{return await v.a.$mkdir(m)}catch(d){return Zt.c(d)}},async readFile(m){try{const d=v.b.get(m.scheme);return d?(await v.a.$ensureActivation(m.scheme),(await d.readFile(m)).slice()):(await v.a.$readFile(m)).buffer}catch(d){return Zt.c(d)}},async writeFile(m,d){try{return await v.a.$writeFile(m,R.VSBuffer.wrap(d))}catch(f){return Zt.c(f)}},async delete(m,d){try{const f=v.b.get(m.scheme);return f?(await v.a.$ensureActivation(m.scheme),await f.delete(m,{recursive:!1,...d})):await v.a.$delete(m,{recursive:!1,useTrash:!1,...d})}catch(f){return Zt.c(f)}},async rename(m,d,f){try{return await v.a.$rename(m,d,{overwrite:!1,...f})}catch(p){return Zt.c(p)}},async copy(m,d,f){try{return await v.a.$copy(m,d,{overwrite:!1,...f})}catch(p){return Zt.c(p)}},isWritableFileSystem(m){const d=I.getCapabilities(m);if(typeof d=="number")return!(d&2048)}})}static c(w){if(w instanceof T.FileSystemError)throw w;if(!(w instanceof Error))throw new T.FileSystemError(String(w));if(w.name==="ENOPRO"||w.message.includes("ENOPRO"))throw T.FileSystemError.Unavailable(w.message);switch(w.name){case t.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(w.message);case t.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(w.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(w.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(w.message);case t.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(w.message);case t.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(w.message);default:throw new T.FileSystemError(w.message,w.name)}}addFileSystemProvider(w,I){return this.b.set(w,I),(0,D.toDisposable)(()=>this.b.delete(w))}};L=qe([We(0,A.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[258],Ce([1,0,3,39,2,5,15,7]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,w,I,v,m,d,f,p){this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter;const b=this.h(P,I,m);this.g=0,d&&(this.g+=1),f&&(this.g+=2),p&&(this.g+=4);const S=(0,t.parse)(m),g=typeof m=="string",r=v(l=>{if(!d)for(const s of l.created){const a=T.URI.revive(s);S(a.fsPath)&&(!g||w.getWorkspaceFolder(a))&&this.a.fire(a)}if(!f)for(const s of l.changed){const a=T.URI.revive(s);S(a.fsPath)&&(!g||w.getWorkspaceFolder(a))&&this.b.fire(a)}if(!p)for(const s of l.deleted){const a=T.URI.revive(s);S(a.fsPath)&&(!g||w.getWorkspaceFolder(a))&&this.c.fire(a)}});this.d=A.Disposable.from(b,this.a,this.b,this.c,r)}h(P,w,I){const v=A.Disposable.from();if(typeof I=="string")return v;const m=P.getProxy(R.MainContext.MainThreadFileSystem);let d=!1;(I.pattern.includes(t.GLOBSTAR)||I.pattern.includes(t.GLOB_SPLIT))&&(d=!0);const f=Math.random();return m.$watch(w.identifier.value,f,I.baseUri,{recursive:d,excludes:[]}),A.Disposable.from({dispose:()=>m.$unwatch(f)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class D{constructor(P,w,I){this.j=P,this.k=w,this.l=I,this.a=new c.Emitter,this.b=new c.Emitter,this.c=new c.Emitter,this.d=new c.Emitter,this.g=new c.AsyncEmitter,this.h=new c.AsyncEmitter,this.i=new c.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,w,I,v,m,d){return new y(this.j,P,w,this.a.event,k.GlobPattern.from(I),v,m,d)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,w){switch(P){case 2:this.b.fire(Object.freeze({files:w.map(I=>({oldUri:T.URI.revive(I.source),newUri:T.URI.revive(I.target)}))}));break;case 1:this.d.fire(Object.freeze({files:w.map(I=>T.URI.revive(I.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:w.map(I=>T.URI.revive(I.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,w){return(I,v,m)=>{const d=function(p){I.call(v,p)};return d.extension=P,w.event(d,void 0,m)}}async $onWillRunFileOperation(P,w,I,v){switch(P){case 2:return await this.n(this.g,{files:w.map(m=>({oldUri:T.URI.revive(m.source),newUri:T.URI.revive(m.target)}))},I,v);case 1:return await this.n(this.i,{files:w.map(m=>T.URI.revive(m.target))},I,v);case 0:case 3:return await this.n(this.h,{files:w.map(m=>T.URI.revive(m.target))},I,v)}}async n(P,w,I,v){const m=new Set,d=[];if(await P.fireAsync(w,v,async(p,b)=>{const S=Date.now(),g=await Promise.resolve(p);g instanceof A.WorkspaceEdit&&(d.push([b.extension,g]),m.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-S>I&&this.k.warn("SLOW file-participant",b.extension.identifier)}),v.isCancellationRequested||d.length===0)return;const f={edits:[]};for(const[,p]of d){const{edits:b}=k.WorkspaceEdit.from(p,{getTextDocumentVersion:S=>this.l.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(b)}return{edit:f,extensionNames:Array.from(m)}}}e.ExtHostFileSystemEventService=D}),define(ye[259],Ce([1,0,2,41]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class T{constructor(k,A,y,D,L){this.a=A,this.b=y,this.c=D;const P=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",w=>!0,w=>w),new t.ApiCommandArgument("resource","Interactive resource Uri",w=>!0,w=>w),new t.ApiCommandArgument("controllerId","Notebook controller Id",w=>!0,w=>w),new t.ApiCommandArgument("title","Interactive editor title",w=>!0,w=>w)],new t.ApiCommandResult("Notebook and input URI",w=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const I=this.a.getEditorById(w.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",I.id),{notebookUri:c.URI.revive(w.notebookUri),inputUri:c.URI.revive(w.inputUri),notebookEditor:I.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:c.URI.revive(w.notebookUri),inputUri:c.URI.revive(w.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(k,A,y,D){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:k,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(c.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(k,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=T}),define(ye[260],Ce([1,0,6,5]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(k){this.b=0,this.a=k.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,k),(0,c.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=T}),define(ye[261],Ce([1,0,2,22,15,7,68,5,8,36,16,10,149,21,6,120,101,72,44,9,14,26]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p,b,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class r{constructor(N,H){this.d=N,this.e=H}async provideDocumentSymbols(N,H){const Q=this.d.getDocument(N),Y=await this.e.provideDocumentSymbols(Q,H);if(!(0,L.isFalsyOrEmpty)(Y))return Y[0]instanceof R.DocumentSymbol?Y.map(T.DocumentSymbol.from):r.f(Y)}static f(N){N=N.slice(0).sort((Y,he)=>{let we=Y.location.range.start.compareTo(he.location.range.start);return we===0&&(we=he.location.range.end.compareTo(Y.location.range.end)),we});const H=[],Q=[];for(const Y of N){const he={name:Y.name||"!!MISSING: name!!",kind:T.SymbolKind.from(Y.kind),tags:Y.tags?.map(T.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:T.Range.from(Y.location.range),selectionRange:T.Range.from(Y.location.range),children:[]};for(;;){if(Q.length===0){Q.push(he),H.push(he);break}const we=Q[Q.length-1];if(D.Range.containsRange(we.range,he.range)&&!D.Range.equalsRange(we.range,he.range)){we.children?.push(he),Q.push(he);break}Q.pop()}}return H}}class l{constructor(N,H,Q){this.g=N,this.h=H,this.j=Q,this.e=new f.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,H){const Q=this.g.getDocument(N),Y=await this.j.provideCodeLenses(Q,H);if(!Y||H.isCancellationRequested)return;const he=this.e.add(Y),we=new v.DisposableStore;this.f.set(he,we);const Ae={cacheId:he,lenses:[]};for(let pe=0;pe<Y.length;pe++)Ae.lenses.push({cacheId:[he,pe],range:T.Range.from(Y[pe].range),command:this.h.toInternal(Y[pe].command,we)});return Ae}async resolveCodeLens(N,H){const Q=N.cacheId&&this.e.get(...N.cacheId);if(!Q)return;let Y;if(typeof this.j.resolveCodeLens!="function"||Q.isResolved?Y=Q:Y=await this.j.resolveCodeLens(Q,H),Y||(Y=Q),H.isCancellationRequested)return;const he=N.cacheId&&this.f.get(N.cacheId[0]);if(!!he)return N.command=this.h.toInternal(Y.command??l.d,he),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}l.d={command:"missing",title:"!!MISSING: command!!"};function s(ie){return Array.isArray(ie)?ie.map(T.DefinitionLink.from):ie?[T.DefinitionLink.from(ie)]:[]}class a{constructor(N,H){this.d=N,this.e=H}async provideDefinition(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideDefinition(Y,he,Q);return s(we)}}class o{constructor(N,H){this.d=N,this.e=H}async provideDeclaration(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideDeclaration(Y,he,Q);return s(we)}}class u{constructor(N,H){this.d=N,this.e=H}async provideImplementation(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideImplementation(Y,he,Q);return s(we)}}class i{constructor(N,H){this.d=N,this.e=H}async provideTypeDefinition(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideTypeDefinition(Y,he,Q);return s(we)}}class n{constructor(N,H){this.d=N,this.e=H}async provideHover(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideHover(Y,he,Q);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=Y.getWordRangeAtPosition(he)),we.range||(we.range=new R.Range(he,he)),T.Hover.from(we)}}class h{constructor(N,H){this.d=N,this.e=H}async provideEvaluatableExpression(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideEvaluatableExpression(Y,he,Q);if(we)return T.EvaluatableExpression.from(we)}}class E{constructor(N,H){this.d=N,this.e=H}async provideInlineValues(N,H,Q,Y){const he=this.d.getDocument(N),we=await this.e.provideInlineValues(he,T.Range.to(H),T.InlineValueContext.to(Q),Y);if(Array.isArray(we))return we.map(Ae=>T.InlineValue.from(Ae))}}class C{constructor(N,H){this.d=N,this.e=H}async provideDocumentHighlights(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideDocumentHighlights(Y,he,Q);if(Array.isArray(we))return we.map(T.DocumentHighlight.from)}}class M{constructor(N,H){this.d=N,this.e=H}async provideLinkedEditingRanges(N,H,Q){const Y=this.d.getDocument(N),he=T.Position.to(H),we=await this.e.provideLinkedEditingRanges(Y,he,Q);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(T.Range.from)),wordPattern:we.wordPattern}}}class K{constructor(N,H){this.d=N,this.e=H}async provideReferences(N,H,Q,Y){const he=this.d.getDocument(N),we=T.Position.to(H),Ae=await this.e.provideReferences(he,we,Q,Y);if(Array.isArray(Ae))return Ae.map(T.location.from)}}class q{constructor(N,H,Q,Y,he,we,Ae){this.g=N,this.h=H,this.j=Q,this.k=Y,this.l=he,this.m=we,this.n=Ae,this.e=new f.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,H,Q,Y){const he=this.g.getDocument(N),we=w.Selection.isISelection(H)?T.Selection.to(H):T.Range.to(H),Ae=[];for(const et of this.j.getDiagnostics(N))if(we.intersection(et.range)&&Ae.push(et)>q.d)break;const pe={diagnostics:Ae,only:Q.only?new R.CodeActionKind(Q.only):void 0,triggerKind:T.CodeActionTriggerKind.to(Q.trigger)},De=await this.k.provideCodeActions(he,we,pe,Y);if(!(0,L.isNonEmptyArray)(De)||Y.isCancellationRequested)return;const ke=this.e.add(De),je=new v.DisposableStore;this.f.set(ke,je);const Ge=[];for(let et=0;et<De.length;et++){const Qe=De[et];!Qe||(q.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,je)})):(pe.only&&(Qe.kind?pe.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,et],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,je),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(T.Diagnostic.from),edit:Qe.edit&&T.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(N,H){const[Q,Y]=N,he=this.e.get(Q,Y);if(!he||q.o(he)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(he,H)??he;return we?.edit?T.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}q.d=1e3;class F{constructor(N,H,Q,Y){this.d=N,this.e=H,this.f=Q,this.g=Y}async prepareDocumentPaste(N,H,Q,Y){if(!this.f.prepareDocumentPaste)return;const he=this.e.getDocument(N),we=H.map(pe=>T.Range.to(pe)),Ae=T.DataTransfer.toDataTransfer(Q,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(he,we,Ae,Y),T.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(N,H,Q,Y,he){const we=this.e.getDocument(H),Ae=Q.map(ke=>T.Range.to(ke)),pe=T.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolvePasteFileData(this.g,N,ke)).buffer),De=await this.f.provideDocumentPasteEdits(we,Ae,pe,he);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?T.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class B{constructor(N,H){this.d=N,this.e=H}async provideDocumentFormattingEdits(N,H,Q){const Y=this.d.getDocument(N),he=await this.e.provideDocumentFormattingEdits(Y,H,Q);if(Array.isArray(he))return he.map(T.TextEdit.from)}}class O{constructor(N,H){this.d=N,this.e=H}async provideDocumentRangeFormattingEdits(N,H,Q,Y){const he=this.d.getDocument(N),we=T.Range.to(H),Ae=await this.e.provideDocumentRangeFormattingEdits(he,we,Q,Y);if(Array.isArray(Ae))return Ae.map(T.TextEdit.from)}}class U{constructor(N,H){this.d=N,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,H,Q,Y,he){const we=this.d.getDocument(N),Ae=T.Position.to(H),pe=await this.e.provideOnTypeFormattingEdits(we,Ae,Q,Y,he);if(Array.isArray(pe))return pe.map(T.TextEdit.from)}}class z{constructor(N,H){this.e=N,this.f=H,this.d=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,H){const Q=await this.e.provideWorkspaceSymbols(N,H);if(!(0,L.isNonEmptyArray)(Q))return{symbols:[]};const Y=this.d.add(Q),he={cacheId:Y,symbols:[]};for(let we=0;we<Q.length;we++){const Ae=Q[we];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}he.symbols.push({...T.WorkspaceSymbol.from(Ae),cacheId:[Y,we]})}return he}async resolveWorkspaceSymbol(N,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const Q=this.d.get(...N.cacheId);if(Q){const Y=await this.e.resolveWorkspaceSymbol(Q,H);return Y&&(0,t.mixin)(N,T.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class j{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,H,Q){this.d=N,this.e=H,this.f=Q}async provideRenameEdits(N,H,Q,Y){const he=this.d.getDocument(N),we=T.Position.to(H);try{const Ae=await this.e.provideRenameEdits(he,we,Q,Y);return Ae?T.WorkspaceEdit.from(Ae):void 0}catch(Ae){const pe=j.g(Ae);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(N,H,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Y=this.d.getDocument(N),he=T.Position.to(H);try{const we=await this.e.prepareRename(Y,he,Q);let Ae,pe;if(R.Range.isRange(we)?(Ae=we,pe=Y.getText(we)):(0,P.isObject)(we)&&(Ae=we.range,pe=we.placeholder),!Ae||!pe)return;if(Ae.start.line>he.line||Ae.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Ae),text:pe}}catch(we){const Ae=j.g(we);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(we)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class ue{constructor(N,H){this.resultId=N,this.tokens=H}}class V{constructor(N,H){this.f=N,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,H,Q){const Y=this.f.getDocument(N),he=H!==0?this.d.get(H):null;let we=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Y,he.resultId,Q):await this.g.provideDocumentSemanticTokens(Y,Q);return he&&this.d.delete(H),we?(we=V.h(we),this.o(V.n(he,we),we)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return V.j(N)?V.k(N)?N:new R.SemanticTokens(new Uint32Array(N.data),N.resultId):V.l(N)?V.m(N)?N:new R.SemanticTokensEdits(N.edits.map(H=>new R.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const H of N.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(N,H){if(!V.j(H)||!N||!N.tokens)return H;const Q=N.tokens,Y=Q.length,he=H.data,we=he.length;let Ae=0;const pe=Math.min(Y,we);for(;Ae<pe&&Q[Ae]===he[Ae];)Ae++;if(Ae===Y&&Ae===we)return new R.SemanticTokensEdits([],H.resultId);let De=0;const ke=pe-Ae;for(;De<ke&&Q[Y-De-1]===he[we-De-1];)De++;return new R.SemanticTokensEdits([{start:Ae,deleteCount:Y-Ae-De,data:he.subarray(Ae,we-De)}],H.resultId)}o(N,H){if(V.j(N)){const Q=this.e++;return this.d.set(Q,new ue(N.resultId,N.data)),(0,m.encodeSemanticTokensDto)({id:Q,type:"full",data:N.data})}if(V.l(N)){const Q=this.e++;return V.j(H)?this.d.set(Q,new ue(H.resultId,H.data)):this.d.set(Q,new ue(N.resultId)),(0,m.encodeSemanticTokensDto)({id:Q,type:"delta",deltas:(N.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}class _{constructor(N,H){this.d=N,this.e=H}async provideDocumentRangeSemanticTokens(N,H,Q){const Y=this.d.getDocument(N),he=await this.e.provideDocumentRangeSemanticTokens(Y,T.Range.to(H),Q);return he?this.f(he):null}f(N){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class J{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,H,Q,Y,he){this.f=N,this.g=H,this.h=Q,this.j=Y,this.k=he,this.d=new f.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,H,Q,Y){const he=this.f.getDocument(N),we=T.Position.to(H),Ae=he.getWordRangeAtPosition(we)||new R.Range(we,we),pe=Ae.with({end:we}),De=new p.StopWatch(!0),ke=await this.h.provideCompletionItems(he,we,Y,T.CompletionContext.to(Q));if(!ke||Y.isCancellationRequested)return;const je=Array.isArray(ke)?new R.CompletionList(ke):ke,Ge=J.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),et=new v.DisposableStore;this.e.set(Ge,et);const Qe=[],nt={x:Ge,b:Qe,a:{replace:T.Range.from(Ae),insert:T.Range.from(pe)},c:je.isIncomplete||void 0,d:De.elapsed()};for(let st=0;st<je.items.length;st++){const ht=je.items[st],Me=this.l(ht,[Ge,st],pe,Ae);Qe.push(Me)}return nt}async resolveCompletionItem(N,H){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...N);if(!Q)return;const Y=await this.h.resolveCompletionItem(Q,H);if(!!Y)return this.l(Y,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,H,Q,Y){const he=this.e.get(H[0]);if(!he)throw Error("DisposableStore is missing...");const we=this.g.toInternal(N.command,he),Ae={x:H,a:N.label,b:N.kind!==void 0?T.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(T.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:T.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(T.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=N.textEdit.newText):typeof N.insertText=="string"?Ae.h=N.insertText:N.insertText instanceof R.SnippetString&&(Ae.h=N.insertText.value,Ae.i|=4);let pe;return N.textEdit?pe=N.textEdit.range:N.range&&(pe=N.range),R.Range.isRange(pe)?Ae.j=T.Range.from(pe):pe&&(!Q?.isEqual(pe.inserting)||!Y?.isEqual(pe.replacing))&&(Ae.j={insert:T.Range.from(pe.inserting),replace:T.Range.from(pe.replacing)}),Ae}}class ne{async provideInlineCompletions(N,H,Q,Y){}disposeCompletions(N){}handleDidShowCompletionItem(N,H){}}class ee extends ne{constructor(N,H,Q,Y){super(),this.f=N,this.g=H,this.h=Q,this.j=Y,this.d=new X,this.e=(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[k.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[k.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(N,H,Q,Y){const he=this.g.getDocument(N),we=T.Position.to(H),Ae=await this.h.provideInlineCompletionItems(he,we,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:T.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},Y);if(!Ae||Y.isCancellationRequested)return;const pe=Array.isArray(Ae)?Ae:Ae.items,De=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:pe}),items:pe.map((Ge,et)=>{let Qe;Ge.command&&(ke||(ke=new v.DisposableStore),Qe=this.j.toInternal(Ge.command,ke));const nt=Ge.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ge.filterText,range:Ge.range?T.Range.from(Ge.range):void 0,command:Qe,idx:et,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:De.map(Ge=>(ke||(ke=new v.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,H){const Q=this.d.get(N)?.items[H];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q)}}class X{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const H=this.e++;return this.d.set(H,N),H}disposeReferenceId(N){const H=this.d.get(N);return this.d.delete(N),H}get(N){return this.d.get(N)}}class G{constructor(N,H){this.e=N,this.f=H,this.d=new f.Cache("SignatureHelp")}async provideSignatureHelp(N,H,Q,Y){const he=this.e.getDocument(N),we=T.Position.to(H),Ae=this.g(Q),pe=await this.f.provideSignatureHelp(he,we,Y,Ae);if(pe){const De=this.d.add([pe]);return{...T.SignatureHelp.from(pe),id:De}}}g(N){let H;if(N.activeSignatureHelp){const Q=T.SignatureHelp.to(N.activeSignatureHelp),Y=this.d.get(N.activeSignatureHelp.id,0);Y?(H=Y,H.activeSignature=Q.activeSignature,H.activeParameter=Q.activeParameter):H=Q}return{...N,activeSignatureHelp:H}}releaseSignatureHelp(N){this.d.delete(N)}}class de{constructor(N,H,Q,Y,he){this.f=N,this.g=H,this.h=Q,this.j=Y,this.k=he,this.d=new f.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,H,Q){const Y=this.f.getDocument(N),he=T.Range.to(H),we=await this.h.provideInlayHints(Y,he,Q);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${H}`);return}if(Q.isCancellationRequested)return;const Ae=this.d.add(we);this.e.set(Ae,new v.DisposableStore);const pe={hints:[],cacheId:Ae};for(let De=0;De<we.length;De++)this.l(we[De],he)&&pe.hints.push(this.m(we[De],[Ae,De]));return this.j.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this.k.identifier.value}' for ${H}`),pe}async resolveInlayHint(N,H){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...N);if(!Q)return;const Y=await this.h.resolveInlayHint(Q,H);if(!!Y&&!!this.l(Y))return this.m(Y,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,H){return N.label.length===0||Array.isArray(N.label)&&N.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(H&&!H.contains(N.position))}m(N,H){const Q=this.e.get(H[0]);if(!Q)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:H,tooltip:T.MarkdownString.fromStrict(N.tooltip),position:T.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(T.TextEdit.from),kind:N.kind&&T.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?Y.label=N.label:Y.label=N.label.map(he=>{const we={label:he.value};return we.tooltip=T.MarkdownString.fromStrict(he.tooltip),R.Location.isLocation(he.location)&&(we.location=T.location.from(he.location)),he.command&&(we.command=this.g.toInternal(he.command,Q)),we}),Y}}class be{constructor(N,H){this.e=N,this.f=H,this.d=new f.Cache("DocumentLink")}async provideLinks(N,H){const Q=this.e.getDocument(N),Y=await this.f.provideDocumentLinks(Q,H);if(!(!Array.isArray(Y)||Y.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Y.filter(be.g).map(T.DocumentLink.from)};{const he=this.d.add(Y),we={links:[],cacheId:he};for(let Ae=0;Ae<Y.length;Ae++){if(!be.g(Y[Ae]))continue;const pe=T.DocumentLink.from(Y[Ae]);pe.cacheId=[he,Ae],we.links.push(pe)}return we}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,H){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...N);if(!Q)return;const Y=await this.f.resolveDocumentLink(Q,H);if(!(!Y||!be.g(Y)))return T.DocumentLink.from(Y)}releaseLinks(N){this.d.delete(N)}}class Ee{constructor(N,H){this.d=N,this.e=H}async provideColors(N,H){const Q=this.d.getDocument(N),Y=await this.e.provideDocumentColors(Q,H);return Array.isArray(Y)?Y.map(we=>({color:T.Color.from(we.color),range:T.Range.from(we.range)})):[]}async provideColorPresentations(N,H,Q){const Y=this.d.getDocument(N),he=T.Range.to(H.range),we=T.Color.to(H.color),Ae=await this.e.provideColorPresentations(we,{document:Y,range:he},Q);if(!!Array.isArray(Ae))return Ae.map(T.ColorPresentation.from)}}class Pe{constructor(N,H){this.d=N,this.e=H}async provideFoldingRanges(N,H,Q){const Y=this.d.getDocument(N),he=await this.e.provideFoldingRanges(Y,H,Q);if(!!Array.isArray(he))return he.map(T.FoldingRange.from)}}class Fe{constructor(N,H,Q){this.d=N,this.e=H,this.f=Q}async provideSelectionRanges(N,H,Q){const Y=this.d.getDocument(N),he=H.map(T.Position.to),we=await this.e.provideSelectionRanges(Y,he,Q);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let pe=0;pe<he.length;pe++){const De=[];Ae.push(De);let ke=he[pe],je=we[pe];for(;;){if(!je.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(De.push(T.SelectionRange.from(je)),!je.parent)break;ke=je.range,je=je.parent}}return Ae}}class se{constructor(N,H){this.f=N,this.g=H,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(N,H,Q){const Y=this.f.getDocument(N),he=T.Position.to(H),we=await this.g.prepareCallHierarchy(Y,he,Q);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(pe=>this.h(Ae,pe)):[this.h(Ae,we)]}async provideCallsTo(N,H,Q){const Y=this.j(N,H);if(!Y)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(Y,Q);if(!!he)return he.map(we=>({from:this.h(N,we.from),fromRanges:we.fromRanges.map(Ae=>T.Range.from(Ae))}))}async provideCallsFrom(N,H,Q){const Y=this.j(N,H);if(!Y)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(Y,Q);if(!!he)return he.map(we=>({to:this.h(N,we.to),fromRanges:we.fromRanges.map(Ae=>T.Range.from(Ae))}))}releaseSession(N){this.e.delete(N)}h(N,H){const Q=this.e.get(N),Y=T.CallHierarchyItem.from(H,N,Q.size.toString(36));return Q.set(Y._itemId,H),Y}j(N,H){return this.e.get(N)?.get(H)}}class oe{constructor(N,H){this.f=N,this.g=H,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(N,H,Q){const Y=this.f.getDocument(N),he=T.Position.to(H),we=await this.g.prepareTypeHierarchy(Y,he,Q);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(pe=>this.h(Ae,pe)):[this.h(Ae,we)]}async provideSupertypes(N,H,Q){const Y=this.j(N,H);if(!Y)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(Y,Q);if(!!he)return he.map(we=>this.h(N,we))}async provideSubtypes(N,H,Q){const Y=this.j(N,H);if(!Y)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(Y,Q);if(!!he)return he.map(we=>this.h(N,we))}releaseSession(N){this.e.delete(N)}h(N,H){const Q=this.e.get(N),Y=T.TypeHierarchyItem.from(H,N,Q.size.toString(36));return Q.set(Y._itemId,H),Y}j(N,H){return this.e.get(N)?.get(H)}}class fe{constructor(N,H,Q,Y){this.d=N,this.e=H,this.f=Q,this.g=Y}async provideDocumentOnDropEdits(N,H,Q,Y,he){const we=this.e.getDocument(H),Ae=T.Position.to(Q),pe=T.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,ke)).buffer),De=await this.f.provideDocumentDropEdits(we,Ae,pe,he);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?T.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class Z{constructor(N,H){this.adapter=N,this.extension=H}}class ce{constructor(N,H,Q,Y,he,we,Ae,pe){this.g=H,this.h=Q,this.j=Y,this.k=he,this.l=we,this.m=Ae,this.n=pe,this.f=new Map,this.e=N.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(N){return T.DocumentSelector.from(N,this.g)}p(N){return new R.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return ce.d++}async s(N,H,Q,Y,he,we=!1){const Ae=this.f.get(N);if(!Ae||!(Ae.adapter instanceof H))return Y;const pe=Date.now();we||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const De=Q(Ae.adapter,Ae.extension);return Promise.resolve(De).catch(ke=>{(0,b.isCancellationError)(ke)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Ae.extension.identifier,ke))}).finally(()=>{we||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),I.CancellationToken.isCancellationToken(he)?(0,S.raceCancellationError)(De,he):De}t(N,H){const Q=this.q();return this.f.set(Q,new Z(N,H)),Q}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,H,Q,Y){const he=this.t(new r(this.h,Q),N),we=Y&&Y.label||ce.u(N);return this.e.$registerDocumentSymbolProvider(he,this.o(H),we),this.p(he)}$provideDocumentSymbols(N,H,Q){return this.s(N,r,Y=>Y.provideDocumentSymbols(c.URI.revive(H),Q),void 0,Q)}registerCodeLensProvider(N,H,Q){const Y=this.q(),he=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Y,new Z(new l(this.h,this.j.converter,Q),N)),this.e.$registerCodeLensSupport(Y,this.o(H),he);let we=this.p(Y);if(he!==void 0){const Ae=Q.onDidChangeCodeLenses(pe=>this.e.$emitCodeLensEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideCodeLenses(N,H,Q){return this.s(N,l,Y=>Y.provideCodeLenses(c.URI.revive(H),Q),void 0,Q)}$resolveCodeLens(N,H,Q){return this.s(N,l,Y=>Y.resolveCodeLens(H,Q),void 0,void 0)}$releaseCodeLenses(N,H){this.s(N,l,Q=>Promise.resolve(Q.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(N,H,Q){const Y=this.t(new a(this.h,Q),N);return this.e.$registerDefinitionSupport(Y,this.o(H)),this.p(Y)}$provideDefinition(N,H,Q,Y){return this.s(N,a,he=>he.provideDefinition(c.URI.revive(H),Q,Y),[],Y)}registerDeclarationProvider(N,H,Q){const Y=this.t(new o(this.h,Q),N);return this.e.$registerDeclarationSupport(Y,this.o(H)),this.p(Y)}$provideDeclaration(N,H,Q,Y){return this.s(N,o,he=>he.provideDeclaration(c.URI.revive(H),Q,Y),[],Y)}registerImplementationProvider(N,H,Q){const Y=this.t(new u(this.h,Q),N);return this.e.$registerImplementationSupport(Y,this.o(H)),this.p(Y)}$provideImplementation(N,H,Q,Y){return this.s(N,u,he=>he.provideImplementation(c.URI.revive(H),Q,Y),[],Y)}registerTypeDefinitionProvider(N,H,Q){const Y=this.t(new i(this.h,Q),N);return this.e.$registerTypeDefinitionSupport(Y,this.o(H)),this.p(Y)}$provideTypeDefinition(N,H,Q,Y){return this.s(N,i,he=>he.provideTypeDefinition(c.URI.revive(H),Q,Y),[],Y)}registerHoverProvider(N,H,Q,Y){const he=this.t(new n(this.h,Q),N);return this.e.$registerHoverProvider(he,this.o(H)),this.p(he)}$provideHover(N,H,Q,Y){return this.s(N,n,he=>he.provideHover(c.URI.revive(H),Q,Y),void 0,Y)}registerEvaluatableExpressionProvider(N,H,Q,Y){const he=this.t(new h(this.h,Q),N);return this.e.$registerEvaluatableExpressionProvider(he,this.o(H)),this.p(he)}$provideEvaluatableExpression(N,H,Q,Y){return this.s(N,h,he=>he.provideEvaluatableExpression(c.URI.revive(H),Q,Y),void 0,Y)}registerInlineValuesProvider(N,H,Q,Y){const he=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new E(this.h,Q),N);this.e.$registerInlineValuesProvider(we,this.o(H),he);let Ae=this.p(we);if(he!==void 0){const pe=Q.onDidChangeInlineValues(De=>this.e.$emitInlineValuesEvent(he));Ae=R.Disposable.from(Ae,pe)}return Ae}$provideInlineValues(N,H,Q,Y,he){return this.s(N,E,we=>we.provideInlineValues(c.URI.revive(H),Q,Y,he),void 0,he)}registerDocumentHighlightProvider(N,H,Q){const Y=this.t(new C(this.h,Q),N);return this.e.$registerDocumentHighlightProvider(Y,this.o(H)),this.p(Y)}$provideDocumentHighlights(N,H,Q,Y){return this.s(N,C,he=>he.provideDocumentHighlights(c.URI.revive(H),Q,Y),void 0,Y)}registerLinkedEditingRangeProvider(N,H,Q){const Y=this.t(new M(this.h,Q),N);return this.e.$registerLinkedEditingRangeProvider(Y,this.o(H)),this.p(Y)}$provideLinkedEditingRanges(N,H,Q,Y){return this.s(N,M,async he=>{const we=await he.provideLinkedEditingRanges(c.URI.revive(H),Q,Y);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ce.w(we.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(N,H,Q){const Y=this.t(new K(this.h,Q),N);return this.e.$registerReferenceSupport(Y,this.o(H)),this.p(Y)}$provideReferences(N,H,Q,Y,he){return this.s(N,K,we=>we.provideReferences(c.URI.revive(H),Q,Y,he),void 0,he)}registerCodeActionProvider(N,H,Q,Y){const he=new v.DisposableStore,we=this.t(new q(this.h,this.j.converter,this.k,Q,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(we,this.o(H),{providedKinds:Y?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:Y?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,he)}))},ce.u(N),Boolean(Q.resolveCodeAction)),he.add(this.p(we)),he}$provideCodeActions(N,H,Q,Y,he){return this.s(N,q,we=>we.provideCodeActions(c.URI.revive(H),Q,Y,he),void 0,he)}$resolveCodeAction(N,H,Q){return this.s(N,q,Y=>Y.resolveCodeAction(H,Q),void 0,void 0)}$releaseCodeActions(N,H){this.s(N,q,Q=>Promise.resolve(Q.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(N,H,Q){const Y=this.t(new B(this.h,Q),N);return this.e.$registerDocumentFormattingSupport(Y,this.o(H),N.identifier,N.displayName||N.name),this.p(Y)}$provideDocumentFormattingEdits(N,H,Q,Y){return this.s(N,B,he=>he.provideDocumentFormattingEdits(c.URI.revive(H),Q,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(N,H,Q){const Y=this.t(new O(this.h,Q),N);return this.e.$registerRangeFormattingSupport(Y,this.o(H),N.identifier,N.displayName||N.name),this.p(Y)}$provideDocumentRangeFormattingEdits(N,H,Q,Y,he){return this.s(N,O,we=>we.provideDocumentRangeFormattingEdits(c.URI.revive(H),Q,Y,he),void 0,he)}registerOnTypeFormattingEditProvider(N,H,Q,Y){const he=this.t(new U(this.h,Q),N);return this.e.$registerOnTypeFormattingSupport(he,this.o(H),Y,N.identifier),this.p(he)}$provideOnTypeFormattingEdits(N,H,Q,Y,he,we){return this.s(N,U,Ae=>Ae.provideOnTypeFormattingEdits(c.URI.revive(H),Q,Y,he,we),void 0,we)}registerWorkspaceSymbolProvider(N,H){const Q=this.t(new z(H,this.l),N);return this.e.$registerNavigateTypeSupport(Q,typeof H.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(N,H,Q){return this.s(N,z,Y=>Y.provideWorkspaceSymbols(H,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(N,H,Q){return this.s(N,z,Y=>Y.resolveWorkspaceSymbol(H,Q),void 0,void 0)}$releaseWorkspaceSymbols(N,H){this.s(N,z,Q=>Q.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(N,H,Q){const Y=this.t(new j(this.h,Q,this.l),N);return this.e.$registerRenameSupport(Y,this.o(H),j.supportsResolving(Q)),this.p(Y)}$provideRenameEdits(N,H,Q,Y,he){return this.s(N,j,we=>we.provideRenameEdits(c.URI.revive(H),Q,Y,he),void 0,he)}$resolveRenameLocation(N,H,Q,Y){return this.s(N,j,he=>he.resolveRenameLocation(c.URI.revive(H),Q,Y),void 0,Y)}registerDocumentSemanticTokensProvider(N,H,Q,Y){const he=this.t(new V(this.h,Q),N),we=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(H),Y,we);let Ae=this.p(he);if(we){const pe=Q.onDidChangeSemanticTokens(De=>this.e.$emitDocumentSemanticTokensEvent(we));Ae=R.Disposable.from(Ae,pe)}return Ae}$provideDocumentSemanticTokens(N,H,Q,Y){return this.s(N,V,he=>he.provideDocumentSemanticTokens(c.URI.revive(H),Q,Y),null,Y)}$releaseDocumentSemanticTokens(N,H){this.s(N,V,Q=>Q.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,H,Q,Y){const he=this.t(new _(this.h,Q),N);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(H),Y),this.p(he)}$provideDocumentRangeSemanticTokens(N,H,Q,Y){return this.s(N,_,he=>he.provideDocumentRangeSemanticTokens(c.URI.revive(H),Q,Y),null,Y)}registerCompletionItemProvider(N,H,Q,Y){const he=this.t(new J(this.h,this.j.converter,Q,this.m,N),N);return this.e.$registerCompletionsProvider(he,this.o(H),Y,J.supportsResolving(Q),`${N.identifier.value}(${Y.join("")})`),this.p(he)}$provideCompletionItems(N,H,Q,Y,he){return this.s(N,J,we=>we.provideCompletionItems(c.URI.revive(H),Q,Y,he),void 0,he)}$resolveCompletionItem(N,H,Q){return this.s(N,J,Y=>Y.resolveCompletionItem(H,Q),void 0,Q)}$releaseCompletionItems(N,H){this.s(N,J,Q=>Q.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(N,H,Q){const Y=new ee(N,this.h,Q,this.j.converter),he=this.t(Y,N);return this.e.$registerInlineCompletionsSupport(he,this.o(H),Y.supportsHandleDidShowCompletionItem),this.p(he)}$provideInlineCompletions(N,H,Q,Y,he){return this.s(N,ne,we=>we.provideInlineCompletions(c.URI.revive(H),Q,Y,he),void 0,he)}$handleInlineCompletionDidShow(N,H,Q){this.s(N,ne,async Y=>{Y.handleDidShowCompletionItem(H,Q)},void 0,void 0)}$freeInlineCompletionsList(N,H){this.s(N,ne,async Q=>{Q.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(N,H,Q,Y){const he=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,we=this.t(new G(this.h,Q),N);return this.e.$registerSignatureHelpProvider(we,this.o(H),he),this.p(we)}$provideSignatureHelp(N,H,Q,Y,he){return this.s(N,G,we=>we.provideSignatureHelp(c.URI.revive(H),Q,Y,he),void 0,he)}$releaseSignatureHelp(N,H){this.s(N,G,Q=>Q.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(N,H,Q){const Y=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new de(this.h,this.j.converter,Q,this.l,N),N);this.e.$registerInlayHintsProvider(he,this.o(H),typeof Q.resolveInlayHint=="function",Y,ce.u(N));let we=this.p(he);if(Y!==void 0){const Ae=Q.onDidChangeInlayHints(pe=>this.e.$emitInlayHintsEvent(Y));we=R.Disposable.from(we,Ae)}return we}$provideInlayHints(N,H,Q,Y){return this.s(N,de,he=>he.provideInlayHints(c.URI.revive(H),Q,Y),void 0,Y)}$resolveInlayHint(N,H,Q){return this.s(N,de,Y=>Y.resolveInlayHint(H,Q),void 0,Q)}$releaseInlayHints(N,H){this.s(N,de,Q=>Q.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(N,H,Q){const Y=this.t(new be(this.h,Q),N);return this.e.$registerDocumentLinkProvider(Y,this.o(H),typeof Q.resolveDocumentLink=="function"),this.p(Y)}$provideDocumentLinks(N,H,Q){return this.s(N,be,Y=>Y.provideLinks(c.URI.revive(H),Q),void 0,Q,H.scheme==="output")}$resolveDocumentLink(N,H,Q){return this.s(N,be,Y=>Y.resolveLink(H,Q),void 0,void 0,!0)}$releaseDocumentLinks(N,H){this.s(N,be,Q=>Q.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(N,H,Q){const Y=this.t(new Ee(this.h,Q),N);return this.e.$registerDocumentColorProvider(Y,this.o(H)),this.p(Y)}$provideDocumentColors(N,H,Q){return this.s(N,Ee,Y=>Y.provideColors(c.URI.revive(H),Q),[],Q)}$provideColorPresentations(N,H,Q,Y){return this.s(N,Ee,he=>he.provideColorPresentations(c.URI.revive(H),Q,Y),void 0,Y)}registerFoldingRangeProvider(N,H,Q){const Y=this.q(),he=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Y,new Z(new Pe(this.h,Q),N)),this.e.$registerFoldingRangeProvider(Y,this.o(H),N.identifier,he);let we=this.p(Y);if(he!==void 0){const Ae=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideFoldingRanges(N,H,Q,Y){return this.s(N,Pe,he=>he.provideFoldingRanges(c.URI.revive(H),Q,Y),void 0,Y)}registerSelectionRangeProvider(N,H,Q){const Y=this.t(new Fe(this.h,Q,this.l),N);return this.e.$registerSelectionRangeProvider(Y,this.o(H)),this.p(Y)}$provideSelectionRanges(N,H,Q,Y){return this.s(N,Fe,he=>he.provideSelectionRanges(c.URI.revive(H),Q,Y),[],Y)}registerCallHierarchyProvider(N,H,Q){const Y=this.t(new se(this.h,Q),N);return this.e.$registerCallHierarchyProvider(Y,this.o(H)),this.p(Y)}$prepareCallHierarchy(N,H,Q,Y){return this.s(N,se,he=>Promise.resolve(he.prepareSession(c.URI.revive(H),Q,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(N,H,Q,Y){return this.s(N,se,he=>he.provideCallsTo(H,Q,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(N,H,Q,Y){return this.s(N,se,he=>he.provideCallsFrom(H,Q,Y),void 0,Y)}$releaseCallHierarchy(N,H){this.s(N,se,Q=>Promise.resolve(Q.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(N,H,Q){const Y=this.t(new oe(this.h,Q),N);return this.e.$registerTypeHierarchyProvider(Y,this.o(H)),this.p(Y)}$prepareTypeHierarchy(N,H,Q,Y){return this.s(N,oe,he=>Promise.resolve(he.prepareSession(c.URI.revive(H),Q,Y)),void 0,Y)}$provideTypeHierarchySupertypes(N,H,Q,Y){return this.s(N,oe,he=>he.provideSupertypes(H,Q,Y),void 0,Y)}$provideTypeHierarchySubtypes(N,H,Q,Y){return this.s(N,oe,he=>he.provideSubtypes(H,Q,Y),void 0,Y)}$releaseTypeHierarchy(N,H){this.s(N,oe,Q=>Promise.resolve(Q.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(N,H,Q){const Y=this.q();return this.f.set(Y,new Z(new fe(this.e,this.h,Q,Y),N)),this.e.$registerDocumentOnDropEditProvider(Y,this.o(H)),this.p(Y)}$provideDocumentOnDropEdits(N,H,Q,Y,he,we){return this.s(N,fe,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(H,c.URI.revive(Q),Y,he,we)),void 0,void 0)}registerDocumentPasteEditProvider(N,H,Q,Y){const he=this.q();return this.f.set(he,new Z(new F(this.e,this.h,Q,he),N)),this.e.$registerPasteEditProvider(he,this.o(H),!!Q.prepareDocumentPaste,Y.pasteMimeTypes),this.p(he)}$prepareDocumentPaste(N,H,Q,Y,he){return this.s(N,F,we=>we.prepareDocumentPaste(c.URI.revive(H),Q,Y,he),void 0,he)}$providePasteEdits(N,H,Q,Y,he,we){return this.s(N,F,Ae=>Ae.providePasteEdits(H,c.URI.revive(Q),Y,he,we),void 0,we)}static w(N){return{pattern:N.source,flags:(0,y.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:ce.w(N.decreaseIndentPattern),increaseIndentPattern:ce.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?ce.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?ce.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:ce.w(N.beforeText),afterText:N.afterText?ce.w(N.afterText):void 0,previousLineText:N.previousLineText?ce.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(ce.z)}setLanguageConfiguration(N,H,Q){const{wordPattern:Y}=Q;if(Y&&(0,y.regExpLeadsToEndlessLoop)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this.h.setWordDefinitionFor(H,Y):this.h.setWordDefinitionFor(H,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const he=this.q(),we={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?ce.w(Q.wordPattern):void 0,indentationRules:Q.indentationRules?ce.y(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?ce.B(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport};return this.e.$setLanguageConfiguration(he,H,we),this.p(he)}$setWordDefinitions(N){for(const H of N)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(ye[262],Ce([1,0,5,15,7,38,14,6]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,P,w,I){this.c=P,this.d=w,this.e=I,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,P){await this.a.$changeLanguage(L,P);const w=this.c.getDocumentData(L);if(!w)throw new Error(`document '${L.toString()}' NOT found`);return w.document}async tokenAtPosition(L,P){const w=L.version,I=t.Position.from(P),v=await this.a.$tokensAtPosition(L.uri,I),m={type:T.StandardTokenType.Other,range:L.getWordRangeAtPosition(P)??new T.Range(P.line,P.character,P.line,P.character)};if(!v)return m;const d={range:t.Range.to(v.range),type:t.TokenType.to(v.type)};return!d.range.contains(P)||w!==L.version?m:d}createLanguageStatusItem(L,P,w){const I=this.f++,v=this.a,m=this.g,d=`${L.identifier.value}/${P}`;if(m.has(d))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);m.add(d);const f={selector:w,id:P,name:L.displayName??L.name,severity:T.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const b=new A.DisposableStore,S=()=>{p?.dispose(),p=(0,k.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(I,{id:d,name:f.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(f.selector,this.e),label:f.text,detail:f.detail??"",severity:f.severity===T.LanguageStatusSeverity.Error?R.default.Error:f.severity===T.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:f.command&&this.d.toInternal(f.command,b),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},g={dispose(){b.dispose(),p?.dispose(),v.$removeLanguageStatus(I),m.delete(d)},get id(){return f.id},get name(){return f.name},set name(r){f.name=r,S()},get selector(){return f.selector},set selector(r){f.selector=r,S()},get text(){return f.text},set text(r){f.text=r,S()},get detail(){return f.detail},set detail(r){f.detail=r,S()},get severity(){return f.severity},set severity(r){f.severity=r,S()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(r){f.accessibilityInformation=r,S()},get command(){return f.command},set command(r){f.command=r,S()},get busy(){return f.busy},set busy(r){f.busy=r,S()}};return S(),g}}e.ExtHostLanguages=y}),define(ye[97],Ce([1,0,12,8,2,4,13,5,25,18]),function(te,e,c,t,T,R,k,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(w,I,v){this.f=v,this.d=new Map,this.a=I.getProxy(A.MainContext.MainThreadLocalization),this.b=w.environment.appLanguage,this.c=this.b===c.LANGUAGE_DEFAULT}getMessage(w,I){const{message:v,args:m,comment:d}=I;if(this.c)return(0,t.format2)(v,m??{});let f=v;d&&d.length>0&&(f+=`/${Array.isArray(d)?d.join():d}`);const p=this.d.get(w)?.contents[f];return p||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,t.format2)(p??v,m??{})}getBundle(w){return this.d.get(w)?.contents}getBundleUri(w){return this.d.get(w)?.uri}async initializeLocalizedMessages(w){if(this.c||!w.l10n&&!w.isBuiltin||this.d.has(w.identifier.value))return;let I;const v=await this.g(w);if(!v){this.f.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const m=await this.a.$fetchBundleContents(v),d=JSON.parse(m);I=w.isBuiltin?d.contents?.bundle:d}catch(m){this.f.error(`Failed to load translations for ${w.identifier.value} from ${v}: ${m.message}`);return}I&&this.d.set(w.identifier.value,{contents:I,uri:v})}async g(w){if(w.isBuiltin){const I=await this.a.$fetchBuiltInBundleUri(w.identifier.value);return T.URI.revive(I)}return w.l10n?T.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=qe([We(0,y.IExtHostInitDataService),We(1,D.IExtHostRpcService),We(2,k.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(ye[140],Ce([1,0,13,5,25,18,2,3,10]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends c.AbstractLoggerService{constructor(w,I){super(I.logLevel,A.Event.None),this.g=w.getProxy(t.MainContext.MainThreadLogger)}$setLevel(w,I){I?this.setLevel(k.URI.revive(I),w):(0,y.isUndefined)(w)||this.setLevel(w)}f(w,I,v){return new L(this.g,w,I,v)}};D=qe([We(0,R.IExtHostRpcService),We(1,T.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class L extends c.AbstractMessageLogger{constructor(w,I,v,m){super(m?.always),this.m=w,this.n=I,this.k=!1,this.l=[],this.setLevel(v),this.m.$createLogger(I,m).then(()=>{this.r(this.l),this.k=!0})}g(w,I){const v=[[w,I]];this.k?this.r(v):this.l.push(...v)}r(w){this.m.$log(this.n,w)}}}),define(ye[263],Ce([1,0,5,13,26]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(A){return A&&A.title}let k=class{constructor(y,D){this.b=D,this.a=y.getProxy(c.MainContext.MainThreadMessageService)}showMessage(y,D,L,P,w){const I={source:{identifier:y.identifier,label:y.displayName||y.name}};let v;typeof P=="string"||R(P)?v=[P,...w]:(I.modal=P?.modal,I.useCustom=P?.useCustom,I.detail=P?.detail,v=w),I.useCustom&&(0,T.checkProposedApiEnabled)(y,"resolvers");const m=[];for(let d=0;d<v.length;d++){const f=v[d];if(typeof f=="string")m.push({title:f,handle:d,isCloseAffordance:!1});else if(typeof f=="object"){const{title:p,isCloseAffordance:b}=f;m.push({title:p,isCloseAffordance:!!b,handle:d})}else this.b.warn("Invalid message item:",f)}return this.a.$showMessage(D,L,I,m).then(d=>{if(typeof d=="number")return v[d]})}};k=qe([We(1,t.ILogService)],k),e.ExtHostMessageService=k}),define(ye[264],Ce([1,0,23,3,6,28,8,10,2,72,5,41,15,7,58,239,136]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,S,g,r){this.q=g,this.r=r,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(L.MainContext.MainThreadNotebook),this.c=b.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===13){const s=l.notebookEditor?.notebookUri,a=l.cell.handle,u=this.g.get(s)?.getCell(a);if(u)return u.apiCell}if(l&&l.$mid===14){const s=l.uri,a=this.g.get(s);if(a)return a.apiNotebook}return l}}),f.x(S)}getEditorById(b){const S=this.h.get(b);if(!S)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(b){for(const[S,g]of this.h)if(g.apiEditor===b)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,S){const g=this.g.get(b);if(!g&&!S)throw new Error(`NO notebook document for '${b}'`);return g}static s(b,S){if(!S)return;const g=S.filenamePattern.map(r=>w.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(S.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:S.displayName,filenamePattern:g,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,S,g){const r=f.a++,l=typeof g.onDidChangeCellStatusBarItems=="function"?f.a++:void 0;this.f.set(r,g),this.b.$registerNotebookCellStatusBarItemProvider(r,l,S);let s;return l!==void 0&&(s=g.onDidChangeCellStatusBarItems(a=>this.b.$emitCellStatusBarEvent(l))),new I.Disposable(()=>{this.f.delete(r),this.b.$unregisterNotebookCellStatusBarItemProvider(r,l),s?.dispose()})}async createNotebookDocument(b){const S=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&w.NotebookData.from(b.content)});return y.URI.revive(S)}async openNotebookDocument(b){const S=this.g.get(b);if(S)return S.apiNotebook;const g=await this.c.$tryOpenNotebook(b),r=this.g.get(y.URI.revive(g));return(0,A.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(b,S){y.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let g;typeof S=="object"?g={position:w.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(w.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:g={preserveFocus:!1};const r=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,g),l=r&&this.h.get(r)?.apiEditor;if(l)return l;throw r?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,S,g,r){const l=this.f.get(b),s=y.URI.revive(S),a=this.g.get(s);if(!a||!l)return;const o=a.getCellFromIndex(g);if(!o)return;const u=await l.provideCellStatusBarItems(o.apiCell,r);if(!u)return;const i=new T.DisposableStore,n=this.p.add([i]),E=(Array.isArray(u)?u:[u]).map(C=>w.NotebookStatusBarItem.from(C,this.i,i));return{cacheId:n,items:E}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,S,g,r,l){if((0,k.isFalsyOrWhitespace)(S))throw new Error("viewType cannot be empty or just whitespace");const s=this.t++;return this.u.set(s,g),this.b.$registerNotebookSerializer(s,{id:b.identifier,location:b.extensionLocation},S,w.NotebookDocumentContentOptions.from(r),f.s(b,l)),(0,T.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(s)})}async $dataToNotebook(b,S,g){const r=this.u.get(b);if(!r)throw new Error("NO serializer found");const l=await r.deserializeNotebook(S.buffer,g);return new v.SerializableObjectWithBuffers(w.NotebookData.from(l))}async $notebookToData(b,S,g){const r=this.u.get(b);if(!r)throw new Error("NO serializer found");const l=await r.serializeNotebook(w.NotebookData.to(S.value),g);return c.VSBuffer.wrap(l)}w(b,S,g){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const r=new d.ExtHostNotebookEditor(S,this.d,b,g.visibleRanges.map(w.NotebookRange.to),g.selections.map(w.NotebookRange.to),typeof g.viewColumn=="number"?w.ViewColumn.to(g.viewColumn):void 0);this.h.set(S,r)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const g of b.value.removedDocuments){const r=y.URI.revive(g),l=this.g.get(r);l&&(l.dispose(),this.g.delete(r),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:l.apiNotebook.getCells().map(s=>s.document.uri)}),this.n.fire(l.apiNotebook));for(const s of this.h.values())s.notebookData.uri.toString()===r.toString()&&this.h.delete(s.id)}if(b.value.addedDocuments){const g=[];for(const r of b.value.addedDocuments){const l=y.URI.revive(r.uri);if(this.g.has(l))throw new Error(`adding EXISTING notebook ${l} `);const s=new m.ExtHostNotebookDocument(this.c,this.q,this.r,l,r);g.push(...r.cells.map(a=>m.ExtHostCell.asModelAddData(s.apiNotebook,a))),this.g.get(l)?.dispose(),this.g.set(l,s),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(s.apiNotebook)}}if(b.value.addedEditors)for(const g of b.value.addedEditors){if(this.h.has(g.id))return;const r=y.URI.revive(g.documentUri),l=this.g.get(r);l&&this.w(l,g.id,g)}const S=[];if(b.value.removedEditors)for(const g of b.value.removedEditors){const r=this.h.get(g);r&&(this.h.delete(g),this.k?.id===r.id&&(this.k=void 0),S.push(r))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(r=>this.h.get(r)).filter(r=>!!r);const g=new Set;this.l.forEach(r=>g.add(r.id));for(const r of this.h.values()){const l=g.has(r.id);r._acceptVisibility(l)}this.l=[...this.h.values()].map(r=>r).filter(r=>r.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const S=P.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new P.ApiCommandArgument("data","Bytes to convert to data",l=>l instanceof Uint8Array,l=>c.VSBuffer.wrap(l))],new P.ApiCommandResult("Notebook Data",l=>w.NotebookData.to(l.value))),r=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",l=>!0,l=>new v.SerializableObjectWithBuffers(w.NotebookData.from(l)))],new P.ApiCommandResult("Bytes",l=>l.buffer));b.registerApiCommand(g),b.registerApiCommand(r)}}e.ExtHostNotebookController=f,f.a=0}),define(ye[265],Ce([1,0,16,14,21,3,6,28,2,27,13,72,5,41,15,7,94,227,26,58]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let S=class{constructor(o,u,i,n,h){this.k=u,this.l=i,this.m=n,this.n=h,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=o.getProxy(w.MainContext.MainThreadNotebookKernels);const E=new I.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new I.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const M=this.l.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:M}}else if(C&&"notebookEditor"in C){const M=this.l.getIdByEditor(C.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return C})],I.ApiCommandResult.Void);this.m.registerApiCommand(E)}createNotebookController(o,u,i,n,h,E){for(const ne of this.h.values())if(ne.controller.id===u&&D.ExtensionIdentifier.equals(o.identifier,ne.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const C=this.i++,M=this;this.n.trace(`NotebookController[${C}], CREATED by ${o.identifier.value}, ${u}`);const K=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${o.identifier}'`);let q=!1;const F=new k.DisposableStore,B=new R.Emitter,O=new R.Emitter,U={id:s(o.identifier,u),notebookType:i,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:n||o.identifier.value,preloads:E?E.map(v.NotebookRendererScript.from):[]};let z=h??K,j;this.a.$addKernel(C,U).catch(ne=>{console.log(ne),q=!0});let ue=0;const V=()=>{if(q)return;const ne=++ue;Promise.resolve().then(()=>{ne===ue&&this.a.$updateKernel(C,U)})},_=new A.ResourceMap,J={get id(){return u},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(ne){U.label=ne??o.displayName??o.name,V()},get detail(){return U.detail??""},set detail(ne){U.detail=ne,V()},get description(){return U.description??""},set description(ne){U.description=ne,V()},get kind(){return(0,p.checkProposedApiEnabled)(o,"notebookControllerKind"),U.kind??""},set kind(ne){(0,p.checkProposedApiEnabled)(o,"notebookControllerKind"),U.kind=ne,V()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(ne){U.supportedLanguages=ne,V()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){U.supportsExecutionOrder=ne,V()},get rendererScripts(){return U.preloads?U.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(ne){z=ne??K},get interruptHandler(){return j},set interruptHandler(ne){j=ne,U.supportsInterrupt=Boolean(ne),V()},createNotebookCellExecution(ne){if(q)throw new Error("notebook controller is DISPOSED");if(!_.has(ne.notebook.uri))throw M.n.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(_.keys()).map(ee=>ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return M._createNotebookCellExecution(ne,s(o.identifier,this.id))},dispose:()=>{q||(this.n.trace(`NotebookController[${C}], DISPOSED`),q=!0,this.h.delete(C),F.dispose(),B.dispose(),O.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(ne,ee){ee===m.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(o,"notebookControllerAffinityHidden"),M.a.$updateNotebookPriority(C,ne.uri,ee)},onDidReceiveMessage:O.event,postMessage(ne,ee){return(0,p.checkProposedApiEnabled)(o,"notebookMessaging"),M.a.$postMessage(C,ee&&M.l.getIdByEditor(ee),ne)},asWebviewUri(ne){return(0,p.checkProposedApiEnabled)(o,"notebookMessaging"),(0,d.asWebviewUri)(ne,M.k.remote)}};return this.h.set(C,{extensionId:o.identifier,controller:J,onDidReceiveMessage:O,onDidChangeSelection:B,associatedNotebooks:_}),J}getIdByController(o){for(const[u,i]of this.h)if(i.controller===o)return s(i.extensionId,o.id);return null}createNotebookControllerDetectionTask(o,u){const i=this.d++,n=this;this.n.trace(`NotebookControllerDetectionTask[${i}], CREATED by ${o.identifier.value}`),this.a.$addKernelDetectionTask(i,u);const h={dispose:()=>{this.c.delete(i),n.a.$removeKernelDetectionTask(i)}};return this.c.set(i,h),h}registerKernelSourceActionProvider(o,u,i){const n=this.f++,h=this;return this.e.set(n,i),this.n.trace(`NotebookKernelSourceActionProvider[${n}], CREATED by ${o.identifier.value}`),this.a.$addKernelSourceActionProvider(n,u),{dispose:()=>{this.e.delete(n),h.a.$removeKernelSourceActionProvider(n)}}}async $provideKernelSourceActions(o,u){const i=this.e.get(o);if(i){const n=new k.DisposableStore;return this.g.add([n]),(await i.provideNotebookKernelSourceActions(u)??[]).map(E=>v.NotebookKernelSourceAction.from(E,this.m.converter,n))}return[]}$acceptNotebookAssociation(o,u,i){const n=this.h.get(o);if(n){const h=this.l.getNotebookDocument(y.URI.revive(u));i?n.associatedNotebooks.set(h.uri,!0):n.associatedNotebooks.delete(h.uri),this.n.trace(`NotebookController[${o}] ASSOCIATE notebook`,h.uri.toString(),i),n.onDidChangeSelection.fire({selected:i,notebook:h.apiNotebook})}}async $executeCells(o,u,i){const n=this.h.get(o);if(!n)return;const h=this.l.getNotebookDocument(y.URI.revive(u)),E=[];for(const C of i){const M=h.getCell(C);M&&E.push(M.apiCell)}try{this.n.trace(`NotebookController[${o}] EXECUTE cells`,h.uri.toString(),E.length),await n.controller.executeHandler.call(n.controller,E,h.apiNotebook,n.controller)}catch(C){this.n.error(`NotebookController[${o}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(o,u,i){const n=this.h.get(o);if(!n)return;const h=this.l.getNotebookDocument(y.URI.revive(u));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,h.apiNotebook);else for(const E of i){const C=h.getCell(E);C&&this.b.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,u,i){const n=this.h.get(o);if(!n)return;const h=this.l.getEditorById(u);n.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:i}))}$cellExecutionChanged(o,u,i){const h=this.l.getNotebookDocument(y.URI.revive(o)).getCell(u);if(h){const E=i?v.NotebookCellExecutionState.to(i):m.NotebookCellExecutionState.Idle;E!==void 0&&this.j.fire({cell:h.apiCell,state:E})}}_createNotebookCellExecution(o,u){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this.l.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!n)throw new Error("invalid cell");if(this.b.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const h=new r(u,n,this.a);this.b.set(n.uri,h);const E=h.onDidChangeState(()=>{h.state===g.Resolved&&(h.dispose(),E.dispose(),this.b.delete(n.uri))});return h.asApiObject()}};S=qe([We(4,L.ILogService)],S),e.ExtHostNotebookKernels=S;var g;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(g||(g={}));class r extends k.Disposable{get state(){return this.f}constructor(o,u,i){super(),this.j=u,this.k=i,this.b=r.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new T.CancellationTokenSource),this.h=new l(10,n=>this.m(n)),this.i=u.internalMetadata.executionOrder,this.k.$createExecution(this.b,o,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(o){await this.h.addItem(o)}async m(o){const u=Array.isArray(o)?o:[o];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(u))}n(){if(this.f===g.Init)throw new Error("Must call start before modifying cell output");if(this.f===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(o){let u=this.j;if(o&&(u=this.j.notebook.getCellFromApiCell(o)),!u)throw new Error("INVALID cell");return u.handle}s(o){return o.map(u=>{const i=m.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return i===u.items?v.NotebookCellOutput.from(u):v.NotebookCellOutput.from({items:i,id:u.id,metadata:u.metadata})})}async t(o,u,i){const n=this.r(u),h=this.s((0,c.asArray)(o));return this.l({editType:f.CellExecutionUpdateType.Output,cellHandle:n,append:i,outputs:h})}async w(o,u,i){return o=m.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(o),!0),this.l({editType:f.CellExecutionUpdateType.OutputItems,items:o.map(v.NotebookCellOutputItem.from),outputId:u.id,append:i})}asApiObject(){const o=this;return Object.freeze({get token(){return o.g.token},get cell(){return o.j.apiCell},get executionOrder(){return o.i},set executionOrder(i){o.i=i,o.m([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:o.i}])},start(i){if(o.f===g.Resolved||o.f===g.Started)throw new Error("Cannot call start again");o.f=g.Started,o.c.fire(),o.m({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,n){if(o.f===g.Resolved)throw new Error("Cannot call resolve twice");o.f=g.Resolved,o.c.fire(),o.h.flush(),o.k.$completeExecution(o.b,new b.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:i}))},clearOutput(i){return o.n(),o.t([],i,!1)},appendOutput(i,n){return o.n(),o.t(i,n,!0)},replaceOutput(i,n){return o.n(),o.t(i,n,!1)},appendOutputItems(i,n){return o.n(),o.w(i,n,!0)},replaceOutputItems(i,n){return o.n(),o.w(i,n,!1)}})}}r.a=0;class l{constructor(o,u){this.d=o,this.e=u,this.a=[],this.b=Date.now()}addItem(o){return this.a.push(o),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const o=this.c;this.c=void 0;const u=this.a;return this.a=[],this.e(u).finally(()=>o.complete())}}function s(a,o){return`${a.value}/${o}`}e.createKernelId=s}),define(ye[266],Ce([1,0,3,5,136]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(A,y){this.c=y,this.a=new Map,this.b=A.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,D){const L=this.c.getEditorById(A);this.a.get(y)?.fire({editor:L.apiEditor,message:D})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(L=>L.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(L,P,w)=>this.d(y).event(L,P,w),postMessage:(L,P)=>{T.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,P]=[P,L]);const w=P&&T.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(w?.id,y,L)}}}d(A){let y=this.a.get(A);return y||(y=new c.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(A)}}),this.a.set(A,y),y)}}e.ExtHostNotebookRenderers=R}),define(ye[267],Ce([1,0,6,10,2,26,5]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(D){this.b=new Map,this.a=D.getProxy(k.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(D,L,P){if((0,R.checkProposedApiEnabled)(D,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,P),this.a.$registerProfileContentHandler(L,P.name,P.description,D.identifier.value),(0,c.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(D,L,P,w){const I=this.b.get(D);if(!I)throw new Error(`Unknown handler with id: ${D}`);return I.saveProfile(L,P,w)}async $readProfile(D,L,P){const w=this.b.get(D);if(!w)throw new Error(`Unknown handler with id: ${D}`);return w.readProfile((0,t.isString)(L)?L:T.URI.revive(L),P)}}e.ExtHostProfileContentHandlers=A}),define(ye[268],Ce([1,0,21,3,6,5,2,7,9,16,38,71]),function(te,e,c,t,T,R,k,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function w(I,v,m){const d=I.getProxy(R.MainContext.MainThreadQuickOpen);class f{constructor(o,u){this.e=new Map,this.f=0,this.a=o,this.b=u}showQuickPick(o,u,i=c.CancellationToken.None){this.c=void 0;const n=Promise.resolve(o),h=++this.f,E=d.$show(h,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},i),C={},M=E.then(()=>C);return Promise.race([M,n]).then(K=>{if(K!==C)return n.then(q=>{const F=[];for(let B=0;B<q.length;B++){const O=q[B];typeof O=="string"?F.push({label:O,handle:B}):O.kind===A.QuickPickItemKind.Separator?F.push({type:"separator",label:O.label}):F.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:B})}return u&&typeof u.onDidSelectItem=="function"&&(this.c=B=>{u.onDidSelectItem(q[B])}),d.$setItems(h,F),E.then(B=>{if(typeof B=="number")return q[B];if(Array.isArray(B))return B.map(O=>q[O])})})}).then(void 0,K=>{if(!(0,y.isCancellationError)(K))return d.$setError(h,K),Promise.reject(K)})}$onItemSelected(o){this.c?.(o)}showInput(o,u=c.CancellationToken.None){return this.d=o?.validateInput,d.$input(o,typeof this.d=="function",u).then(void 0,i=>{if(!(0,y.isCancellationError)(i))return Promise.reject(i)})}async $validateInput(o){if(!this.d)return;const u=await this.d(o);if(!u||typeof u=="string")return u;let i;switch(u.severity){case A.InputBoxValidationSeverity.Info:i=L.default.Info;break;case A.InputBoxValidationSeverity.Warning:i=L.default.Warning;break;case A.InputBoxValidationSeverity.Error:i=L.default.Error;break;default:i=u.message?L.default.Error:L.default.Ignore;break}return{content:u.message,severity:i}}async showWorkspaceFolderPick(o,u=c.CancellationToken.None){const i=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!i)return;const n=await this.a.getWorkspaceFolders2();if(!!n)return n.find(h=>h.uri.toString()===i.uri.toString())}createQuickPick(o){const u=new l(o,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(o){const u=new s(o,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(o,u){this.e.get(o)?._fireDidChangeValue(u)}$onDidAccept(o){this.e.get(o)?._fireDidAccept()}$onDidChangeActive(o,u){const i=this.e.get(o);i instanceof l&&i._fireDidChangeActive(u)}$onDidChangeSelection(o,u){const i=this.e.get(o);i instanceof l&&i._fireDidChangeSelection(u)}$onDidTriggerButton(o,u){this.e.get(o)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(o,u,i){const n=this.e.get(o);n instanceof l&&n._fireDidTriggerItemButton(u,i)}$onDidHide(o){this.e.get(o)?._fireDidHide()}}class p{constructor(o,u){this.x=o,this.y=u,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(o){this.b=o,this.z({title:o})}get step(){return this.c}set step(o){this.c=o,this.z({step:o})}get totalSteps(){return this.d}set totalSteps(o){this.d=o,this.z({totalSteps:o})}get enabled(){return this.g}set enabled(o){this.g=o,this.z({enabled:o})}get busy(){return this.j}set busy(o){this.j=o,this.z({busy:o})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(o){this.k=o,this.z({ignoreFocusOut:o})}get value(){return this.l}set value(o){this.l=o,this.z({value:o})}get placeholder(){return this.m}set placeholder(o){this.m=o,this.z({placeholder:o})}get buttons(){return this.n}set buttons(o){this.n=o.slice(),this.o.clear(),o.forEach((u,i)=>{const n=u===A.QuickInputButtons.Back?-1:i;this.o.set(n,u)}),this.z({buttons:o.map((u,i)=>({...r(u),tooltip:u.tooltip,handle:u===A.QuickInputButtons.Back?-1:i}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(o){this.l=o,this.q.fire(o)}_fireDidTriggerButton(o){const u=this.o.get(o);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,T.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(o){if(!this.v){for(const u of Object.keys(o)){const i=o[u];this.u[u]=i===void 0?null:i}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}p.a=1;function b(a){if(a instanceof A.ThemeIcon)return{id:a.id};const o=g(a),u=S(a);return{dark:typeof o=="string"?k.URI.file(o):o,light:typeof u=="string"?k.URI.file(u):u}}function S(a){return typeof a=="object"&&"light"in a?a.light:a}function g(a){return typeof a=="object"&&"dark"in a?a.dark:a}function r(a){const o=b(a.iconPath);let u,i;return"id"in o?i=P.ThemeIcon.asClassName(o):u=o,{iconPath:u,iconClass:i}}class l extends p{constructor(o,u){super(o.identifier,u),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new t.Emitter,this.L=[],this.M=new t.Emitter,this.N=new t.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(o){this.B=o.slice(),this.C.clear(),this.D.clear(),o.forEach((i,n)=>{this.C.set(n,i),this.D.set(i,n)});const u=[];for(let i=0;i<o.length;i++){const n=o[i];n.kind===A.QuickPickItemKind.Separator?u.push({type:"separator",label:n.label}):u.push({handle:i,label:n.label,description:n.description,detail:n.detail,picked:n.picked,alwaysShow:n.alwaysShow,buttons:n.buttons?.map((h,E)=>({...r(h),tooltip:h.tooltip,handle:E}))})}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(o){this.E=o,this.z({canSelectMany:o})}get matchOnDescription(){return this.F}set matchOnDescription(o){this.F=o,this.z({matchOnDescription:o})}get matchOnDetail(){return this.G}set matchOnDetail(o){this.G=o,this.z({matchOnDetail:o})}get sortByLabel(){return this.H}set sortByLabel(o){this.H=o,this.z({sortByLabel:o})}get keepScrollPosition(){return this.I}set keepScrollPosition(o){this.I=o,this.z({keepScrollPosition:o})}get activeItems(){return this.J}set activeItems(o){this.J=o.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(o){this.L=o.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(o){const u=(0,D.coalesce)(o.map(i=>this.C.get(i)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(o){const u=(0,D.coalesce)(o.map(i=>this.C.get(i)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(o,u){const i=this.C.get(o);if(!i||!i.buttons||!i.buttons.length)return;const n=i.buttons[u];n&&this.N.fire({button:n,item:i})}}class s extends p{constructor(o,u){super(o.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(o){this.B=o,this.z({password:o})}get prompt(){return this.C}set prompt(o){this.C=o,this.z({prompt:o})}get valueSelection(){return this.D}set valueSelection(o){this.D=o,this.z({valueSelection:o})}get validationMessage(){return this.E}set validationMessage(o){this.E=o,o?typeof o=="string"?this.z({validationMessage:o,severity:L.default.Error}):this.z({validationMessage:o.message,severity:o.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new f(v,m)}e.createExtHostQuickOpen=w});var Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,c):T?T.value=c:e.set(te,c),c};define(ye[269],Ce([1,0,2,3,62,6,14,5,16,110,13,27,71,15,26]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v){"use strict";var m,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(n){if(n)return typeof n.iconPath=="string"?c.URI.file(n.iconPath):c.URI.isUri(n.iconPath)||w.ThemeIcon.isThemeIcon(n.iconPath)?n.iconPath:void 0}function p(n,h){if(!n.iconPath&&!h.iconPath)return 0;if(n.iconPath){if(!h.iconPath)return 1}else return-1;const E=typeof n.iconPath=="string"?n.iconPath:c.URI.isUri(n.iconPath)?n.iconPath.fsPath:n.iconPath.id,C=typeof h.iconPath=="string"?h.iconPath:c.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,D.comparePaths)(E,C)}function b(n,h){let E=0;if(n.strikeThrough!==h.strikeThrough)return n.strikeThrough?1:-1;if(n.faded!==h.faded)return n.faded?1:-1;if(n.tooltip!==h.tooltip)return(n.tooltip||"").localeCompare(h.tooltip||"");if(E=p(n,h),E!==0)return E;if(n.light&&h.light)E=p(n.light,h.light);else{if(n.light)return 1;if(h.light)return-1}if(E!==0)return E;if(n.dark&&h.dark)E=p(n.dark,h.dark);else{if(n.dark)return 1;if(h.dark)return-1}return E}function S(n,h){if(n.command!==h.command)return n.command<h.command?-1:1;if(n.title!==h.title)return n.title<h.title?-1:1;if(n.tooltip!==h.tooltip){if(n.tooltip!==void 0&&h.tooltip!==void 0)return n.tooltip<h.tooltip?-1:1;if(n.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(n.arguments===h.arguments)return 0;if(n.arguments)if(h.arguments){if(n.arguments.length!==h.arguments.length)return n.arguments.length-h.arguments.length}else return 1;else return-1;for(let E=0;E<n.arguments.length;E++){const C=n.arguments[E],M=h.arguments[E];if(C!==M)return C<M?-1:1}return 0}function g(n,h){let E=(0,D.comparePaths)(n.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(E!==0)return E;if(n.command&&h.command)E=S(n.command,h.command);else{if(n.command)return 1;if(h.command)return-1}if(E!==0)return E;if(n.decorations&&h.decorations)E=b(n.decorations,h.decorations);else{if(n.decorations)return 1;if(h.decorations)return-1}return E}function r(n,h){for(let E=0;E<n.length;E++)if(n[E]!==h[E])return!1;return!0}function l(n,h){return n.command===h.command&&n.title===h.title&&n.tooltip===h.tooltip&&(n.arguments&&h.arguments?r(n.arguments,h.arguments):n.arguments===h.arguments)}function s(n,h){return(0,y.equals)(n,h,l)}class a{get value(){return this.d}set value(h){h=h??"",Ue(this,m,"f").$setInputBoxValue(this.l,h),this.m(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){Ue(this,m,"f").$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,v.checkProposedApiEnabled)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,Ue(this,m,"f").$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,Ue(this,m,"f").$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,Ue(this,m,"f").$setInputBoxVisibility(this.l,h))}constructor(h,E,C){this.k=h,this.l=C,m.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,m,E,"f")}showValidationMessage(h,E){(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),Ue(this,m,"f").$showValidationMessage(this.l,h,E)}$onInputBoxValueChange(h){this.m(h)}m(h){this.d=h,this.e.fire(h)}}e.ExtHostSCMInputBox=a,m=new WeakMap;class o{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,E,C,M,K){this.q=h,this.s=E,this.t=C,this.u=M,this.v=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=o.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,E){const C=this.h.get(h);return C?(0,k.asPromise)(()=>this.s.executeCommand(C.command,...C.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(g),C=(0,y.sortedDiff)(this.o,h,g).map(q=>{const F=q.toInsert.map(B=>{const O=this.e++;this.g.set(O,B);const U=B.resourceUri;let z;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const de=new R.DisposableStore;z=this.s.converter.toInternal(B.command,de),this.j.set(O,de)}else this.h.set(O,B.command);const j=f(B.decorations),ue=B.decorations&&f(B.decorations.light)||j,V=B.decorations&&f(B.decorations.dark)||j,_=[ue,V],J=B.decorations&&B.decorations.tooltip||"",ne=B.decorations&&!!B.decorations.strikeThrough,ee=B.decorations&&!!B.decorations.faded,X=B.contextValue||"";return{rawResource:[O,U,_,J,ne,ee,X,z],handle:O}});return{start:q.start,deleteCount:q.deleteCount,toInsert:F}}),M=C.map(({start:q,deleteCount:F,toInsert:B})=>[q,F,B.map(O=>O.rawResource)]),K=C.reverse();for(const{start:q,deleteCount:F,toInsert:B}of K){const O=B.map(z=>z.handle),U=this.n.splice(q,F,...O);for(const z of U)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=h,M}dispose(){this.l=!0,this.m.fire()}}o.d=0;class u{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,Ue(this,d,"f").$updateSourceControl(this.t,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h,Ue(this,d,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this.j}set commitTemplate(h){h!==this.j&&(this.j=h,Ue(this,d,"f").$updateSourceControl(this.t,{commitTemplate:h}))}get acceptInputCommand(){return this.l}set acceptInputCommand(h){this.k.value=new R.DisposableStore,this.l=h;const E=this.v.converter.toInternal(h,this.k.value);Ue(this,d,"f").$updateSourceControl(this.t,{acceptInputCommand:E})}get actionButton(){return(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(h){(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=h;const E=h!==void 0?{command:this.v.converter.toInternal(h.command,this.m.value),secondaryCommands:h.secondaryCommands?.map(C=>C.map(M=>this.v.converter.toInternal(M,this.m.value))),description:h.description,enabled:h.enabled}:void 0;Ue(this,d,"f").$updateSourceControl(this.t,{actionButton:E??null})}get statusBarCommands(){return this.p}set statusBarCommands(h){if(this.p&&h&&s(this.p,h))return;this.o.value=new R.DisposableStore,this.p=h;const E=(h||[]).map(C=>this.v.converter.toInternal(C,this.o.value));Ue(this,d,"f").$updateSourceControl(this.t,{statusBarCommands:E})}get selected(){return this.q}constructor(h,E,C,M,K,q){this.u=h,this.v=C,this.w=M,this.x=K,this.y=q,d.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=u.d++,this.z=new Map,this.A=new Set,Je(this,d,E,"f"),this.f=new a(h,Ue(this,d,"f"),this.t),Ue(this,d,"f").$registerSourceControl(this.t,M,K,q)}createResourceGroup(h,E){const C=new o(Ue(this,d,"f"),this.v,this.t,h,E),M=t.Event.once(C.onDidDispose)(()=>this.z.delete(C));return this.z.set(C,M),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const h=[],E=[];for(const[C,M]of this.z){M.dispose();const K=C.onDidUpdateResourceStates(()=>{this.A.add(C),this.eventuallyUpdateResourceStates()});t.Event.once(C.onDidDispose)(()=>{this.A.delete(C),K.dispose(),this.e.delete(C.handle),Ue(this,d,"f").$unregisterGroup(this.t,C.handle)}),h.push([C.handle,C.id,C.label,C.features]);const q=C._takeResourceStateSnapshot();q.length>0&&E.push([C.handle,q]),this.e.set(C.handle,C)}Ue(this,d,"f").$registerGroups(this.t,h,E),this.z.clear()}eventuallyUpdateResourceStates(){const h=[];this.A.forEach(E=>{const C=E._takeResourceStateSnapshot();C.length!==0&&h.push([E.handle,C])}),h.length>0&&Ue(this,d,"f").$spliceResourceStates(this.t,h),this.A.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.q=h,this.s.fire(h)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(h=>h.dispose()),Ue(this,d,"f").$unregisterSourceControl(this.t)}}d=new WeakMap,u.d=0,qe([(0,T.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),qe([(0,T.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let i=class ri{get onDidChangeActiveProvider(){return this.j.event}constructor(h,E,C){this.l=E,this.m=C,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=h.getProxy(A.MainContext.MainThreadSCM),this.f=h.getProxy(A.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const K=this.g.get(M.sourceControlHandle);if(!K)return M;const q=K.getResourceGroup(M.groupHandle);return q?q.getResourceState(M.handle):M}else if(M&&M.$mid===4){const K=this.g.get(M.sourceControlHandle);return K?K.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const K=this.g.get(M.handle);return K||M}return M}})}createSourceControl(h,E,C,M){this.m.trace("ExtHostSCM#createSourceControl",h.identifier.value,E,C,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const K=ri.d++,q=new u(h,this.e,this.l,E,C,M);this.g.set(K,q);const F=this.h.get(P.ExtensionIdentifier.toKey(h.identifier))||[];return F.push(q),this.h.set(P.ExtensionIdentifier.toKey(h.identifier),F),q}getLastInputBox(h){this.m.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const E=this.h.get(P.ExtensionIdentifier.toKey(h.identifier)),C=E&&E[E.length-1];return C&&C.inputBox}$provideOriginalResource(h,E,C){const M=c.URI.revive(E);this.m.trace("ExtHostSCM#$provideOriginalResource",h,M.toString());const K=this.g.get(h);return!K||!K.quickDiffProvider||!K.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>K.quickDiffProvider.provideOriginalResource(M,C)).then(q=>q||null)}$onInputBoxValueChange(h,E){this.m.trace("ExtHostSCM#$onInputBoxValueChange",h);const C=this.g.get(h);return C&&C.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(h,E,C,M){this.m.trace("ExtHostSCM#$executeResourceCommand",h,E,C);const K=this.g.get(h);if(!K)return Promise.resolve(void 0);const q=K.getResourceGroup(E);return q?q.$executeResourceCommand(C,M):Promise.resolve(void 0)}$validateInput(h,E,C){this.m.trace("ExtHostSCM#$validateInput",h);const M=this.g.get(h);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>M.inputBox.validateInput(E,C)).then(K=>{if(!K)return Promise.resolve(void 0);const q=I.MarkdownString.fromStrict(K.message);return q?Promise.resolve([q,K.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}};i.d=0,i=qe([We(2,L.ILogService)],i),e.ExtHostSCM=i}),define(ye[98],Ce([1,0,5,3,4]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(A){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,y){return this.a.$getPassword(A,y)}store(A,y,D){return this.a.$setPassword(A,y,D)}delete(A,y){return this.a.$deletePassword(A,y)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,c):T?T.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[270],Ce([1,0,7,5,179,6,15,10]),function(te,e,c,t,T,R,k,A){"use strict";var y,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(v,m,d,f,p=c.StatusBarAlignment.Left,b){y.set(this,void 0),D.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,Je(this,y,v,"f"),Je(this,D,m,"f"),this.c=L.a++,this.e=d,this.f=f,this.g=p,this.h=this.u(b)}u(v){if(!!(0,A.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(v){this.k=v,this.v()}set name(v){this.m=v,this.v()}set tooltip(v){this.l=v,this.v()}set color(v){this.n=v,this.v()}set backgroundColor(v){v&&!L.b.has(v.id)&&(v=void 0),this.o=v,this.v()}set command(v){this.r?.fromApi!==v&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof v=="string"?this.r={fromApi:v,internal:Ue(this,D,"f").toInternal({title:"",command:v},this.p)}:v?this.r={fromApi:v,internal:Ue(this,D,"f").toInternal(v,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(v){this.t=v,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ue(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let m;this.m?m=this.m:m=(0,T.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=L.b.get(this.o.id));const f=k.MarkdownString.fromStrict(this.l);Ue(this,y,"f").$setEntry(this.c,v,m,this.k,f,this.r?.internal,d,this.o,this.g===c.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=L,y=new WeakMap,D=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,T.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const m={message:v};return this.b.unshift(m),this.c(),new c.Disposable(()=>{const d=this.b.indexOf(m);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class w{constructor(v,m){this.a=v.getProxy(t.MainContext.MainThreadStatusBar),this.b=m,this.c=new P(this)}createStatusBarEntry(v,m,d,f){return new L(this.a,this.b,v,m,d,f)}setStatusBarMessage(v,m){const d=this.c.setMessage(v);let f;return typeof m=="number"?f=setTimeout(()=>d.dispose(),m):typeof m<"u"&&m.then(()=>d.dispose(),()=>d.dispose()),new c.Disposable(()=>{d.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=w}),define(ye[99],Ce([1,0,5,3,4]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(A,y){this.c=y,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this.a.$registerExtensionStorageKeysToSync(A,y)}async initializeExtensionStorage(A,y,D){const L=await this.a.$initializeExtensionStorage(A,y);let P;return L&&(P=this.d(A,y,L)),P||D}setValue(A,y,D){return this.a.$setValue(A,y,D)}$acceptValue(A,y,D){const L=this.d(A,y,D);L&&this.b.fire({shared:A,key:y,value:L})}d(A,y,D){try{return JSON.parse(D)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${A}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(ye[76],Ce([1,0,4,25,13,75,2]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let A=class{constructor(D,L,P){this.d=L,this.f=P,this.a=D.workspace??void 0,this.b=D.environment,this.whenReady=this.h().then(w=>this.c=w)}async g(D){return k.URI.joinPath(this.b.workspaceStorageHome,D)}async h(){if(!this.a)return Promise.resolve(void 0);const D=this.a.id,L=await this.g(D);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(k.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:k.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(D){if(this.c)return k.URI.joinPath(this.c,D.identifier.value)}globalValue(D){return k.URI.joinPath(this.b.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=qe([We(0,t.IExtHostInitDataService),We(1,T.ILogService),We(2,R.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ye[42],Ce([1,0,3,5,4,2,18,6,7,180,9,228,21,30,211,71,10,14,15]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class b{constructor(i,n,h,E){this.k=i,this._id=n,this.l=h,this.m=E,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(M=>this.f=M);const C=this;this.value={get name(){return C.m||""},get processId(){return C.b},get creationOptions(){return C.l},get exitStatus(){return C.h},get state(){return C.j},sendText(M,K=!0){C.o(),C.k.$sendText(C._id,M,K)},show(M){C.o(),C.k.$show(C._id,M)},hide(){C.o(),C.k.$hide(C._id)},dispose(){C.a||(C.a=!0,C.k.$dispose(C._id))},get dimensions(){if(!(C.d===void 0||C.g===void 0))return{columns:C.d,rows:C.g}}}}async create(i,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:i.name,shellPath:(0,d.withNullAsUndefined)(i.shellPath),shellArgs:(0,d.withNullAsUndefined)(i.shellArgs),cwd:(0,d.withNullAsUndefined)(i.cwd),env:(0,d.withNullAsUndefined)(i.env),icon:(0,d.withNullAsUndefined)(a(i.iconPath)),color:m.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,d.withNullAsUndefined)(i.message),strictEnv:(0,d.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(n?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(n?.useShellEnvironment),location:n?.location||this.n(i.location,n?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,n,h,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:h,color:m.ThemeColor.isThemeColor(E)?E.id:void 0,location:this.n(i,n),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(i,n){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&n?{parentTerminal:n}:"viewColumn"in i?{viewColumn:p.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus}:void 0:i}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(i){this.m=i}setExitStatus(i,n){this.h=Object.freeze({code:i,reason:n})}setDimensions(i,n){return i===this.d&&n===this.g||i===0||n===0?!1:(this.d=i,this.g=n,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(i){this.f?(this.f(i),this.f=void 0):this.b.then(n=>{n!==i&&(this.b=Promise.resolve(i))})}}e.ExtHostTerminal=b;class S{get onProcessReady(){return this.b.event}constructor(i){this.g=i,this.id=0,this.shouldPersist=!1,this.a=new c.Emitter,this.onProcessData=this.a.event,this.b=new c.Emitter,this.d=new c.Emitter,this.onDidChangeProperty=this.d.event,this.f=new c.Emitter,this.onProcessExit=this.f.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,n){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${n}`)}async start(){}shutdown(){this.g.close()}input(i){this.g.handleInput?.(i)}resize(i,n){this.g.setDimensions?.({columns:i,rows:n})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this.g.onDidWrite(n=>this.a.fire(n)),this.g.onDidClose?.((n=void 0)=>{this.f.fire(n===void 0?void 0:n)}),this.g.onDidOverrideDimensions?.(n=>{n&&this.d.fire({type:"overrideDimensions",value:{cols:n.columns,rows:n.rows}})}),this.g.onDidChangeName?.(n=>{this.d.fire({type:"title",value:n})}),this.g.open(i||void 0),i&&this.g.setDimensions?.(i),this.b.fire({pid:-1,cwd:""})}}let g=1,r=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(i=>i.value)}get onDidWriteTerminalData(){return this.I.event}constructor(i,n){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new c.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new c.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new c.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new c.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new c.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new c.Emitter,this.onDidChangeShell=this.J.event,this.a=n.getProxy(t.MainContext.MainThreadTerminalService),this.s=new v.TerminalDataBufferer(this.a.$sendProcessData),this.I=new c.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(i),this.B({dispose:()=>{for(const[h,E]of this.g)E.shutdown(!0)}})}getDefaultShell(i){return(i?this.n:this.m)?.path||""}getDefaultShellArgs(i){return(i?this.n:this.m)?.args||[]}createExtensionTerminal(i,n){const h=new b(this.a,(0,I.generateUuid)(),i,i.name),E=new S(i.pty);return h.createExtensionTerminal(i.location,this.L(i,n).resolvedExtHostIdentifier,a(i.iconPath),o(i.color)).then(C=>{const M=this.M(C,E);this.h[C]=M}),this.f.push(h),h.value}L(i,n){if(n=n||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const h=i.location.parentTerminal;if(h){const E=this.f.find(C=>C.value===h);E&&(n.resolvedExtHostIdentifier=E._id)}}else i.location&&typeof i.location!="object"?n.location=i.location:n.location&&typeof n.location=="object"&&"splitActiveTerminal"in n.location&&(n.location={splitActiveTerminal:!0});return n}attachPtyToTerminal(i,n){if(!this.O(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const E=new S(n),C=this.M(i,E);this.h[i]=C}async $acceptActiveTerminalChanged(i){const n=this.b;if(i===null){this.b=void 0,n!==this.b&&this.F.fire(this.b);return}const h=this.O(i);h&&(this.b=h,n!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(i,n){const h=this.O(i);h&&this.I.fire({terminal:h.value,data:n})}async $acceptTerminalDimensions(i,n,h){const E=this.O(i);E&&E.setDimensions(n,h)&&this.G.fire({terminal:E.value,dimensions:E.value.dimensions})}async $acceptTerminalMaximumDimensions(i,n,h){this.g.get(i)?.resize(n,h)}async $acceptTerminalTitleChange(i,n){const h=this.O(i);h&&(h.name=n)}async $acceptTerminalClosed(i,n,h){const E=this.Q(this.f,i);if(E!==null){const C=this.f.splice(E,1)[0];C.setExitStatus(n,h),this.C.fire(C.value)}}$acceptTerminalOpened(i,n,h,E){if(n){const K=this.Q(this.f,n);if(K!==null){this.f[K]._id=i,this.D.fire(this.terminals[K]),this.f[K].isOpen=!0;return}}const C={name:E.name,shellPath:E.executable,shellArgs:E.args,cwd:typeof E.cwd=="string"?E.cwd:R.URI.revive(E.cwd),env:E.env,hideFromUser:E.hideFromUser},M=new b(this.a,i,C,h);this.f.push(M),this.D.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(i,n){this.O(i)?._setProcessId(n)}async $startExtensionTerminal(i,n){const h=this.O(i);if(!h)return{message:(0,D.localize)(0,null,i)};h.isOpen||await new Promise(C=>{const M=this.onDidOpenTerminal(async K=>{K===h.value&&(M.dispose(),C())})});const E=this.g.get(i);E?E.startSendingEvents(n):this.j[i]={initialDimensions:n}}M(i,n){const h=new A.DisposableStore;h.add(n.onProcessReady(C=>this.a.$sendProcessReady(i,C.pid,C.cwd))),h.add(n.onDidChangeProperty(C=>this.a.$sendProcessProperty(i,C))),this.s.startBuffering(i,n.onProcessData),h.add(n.onProcessExit(C=>this.N(i,C))),this.g.set(i,n);const E=this.j[i];return E&&n instanceof S&&(n.startSendingEvents(E.initialDimensions),delete this.j[i]),h}$acceptProcessAckDataEvent(i,n){this.g.get(i)?.acknowledgeDataEvent(n)}$acceptProcessInput(i,n){this.g.get(i)?.input(n)}$acceptTerminalInteraction(i){const n=this.O(i);n?.setInteractedWith()&&this.H.fire(n.value)}$acceptProcessResize(i,n,h){try{this.g.get(i)?.resize(n,h)}catch(E){if(E.code!=="EPIPE"&&E.code!=="ERR_IPC_CHANNEL_CLOSED")throw E}}$acceptProcessShutdown(i,n){this.g.get(i)?.shutdown(n)}$acceptProcessRequestInitialCwd(i){this.g.get(i)?.getInitialCwd().then(n=>this.a.$sendProcessProperty(i,{type:"initialCwd",value:n}))}$acceptProcessRequestCwd(i){this.g.get(i)?.getCwd().then(n=>this.a.$sendProcessProperty(i,{type:"cwd",value:n}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this.u.add(i),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(i),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(i,n,h){if(this.v.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this.v.set(n,h),this.a.$registerProfileProvider(n,i.identifier.value),new y.Disposable(()=>{this.v.delete(n),this.a.$unregisterProfileProvider(n)})}registerTerminalQuickFixProvider(i,n,h){if(this.w.has(i))throw new Error(`Terminal quick fix provider "${i}" is already registered`);return this.w.set(i,h),this.a.$registerQuickFixProvider(i,n),new y.Disposable(()=>{this.w.delete(i),this.a.$unregisterQuickFixProvider(i)})}async $provideTerminalQuickFixes(i,n){const h=new w.CancellationTokenSource().token;if(h.isCancellationRequested)return;const E=this.w.get(i);if(!E)return;const C=await E.provideTerminalQuickFixes(n,h);if(C!==null)return C}async $createContributedProfileTerminal(i,n){const h=new w.CancellationTokenSource().token;let E=await this.v.get(i)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(E&&!("options"in E)&&(E={options:E}),!E||!("options"in E))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in E.options){this.createExtensionTerminal(E.options,n);return}this.createTerminalFromOptions(E.options,n)}}async $provideLinks(i,n){const h=this.O(i);if(!h)return[];this.y.delete(i),this.z.get(i)?.dispose(!0);const C=new w.CancellationTokenSource;this.z.set(i,C);const M=[],K={terminal:h.value,line:n},q=[];for(const O of this.u)q.push(f.Promises.withAsyncBody(async U=>{C.token.onCancellationRequested(()=>U({provider:O,links:[]}));const z=await O.provideTerminalLinks(K,C.token)||[];C.token.isCancellationRequested||U({provider:O,links:z})}));const F=await Promise.all(q);if(C.token.isCancellationRequested)return[];const B=new Map;for(const O of F)O&&O.links.length>0&&M.push(...O.links.map(U=>{const z={id:g++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return B.set(z.id,{provider:O.provider,link:U}),z}));return this.y.set(i,B),M}$activateLink(i,n){const h=this.y.get(i)?.get(n);!h||h.provider.handleTerminalLink(h.link)}N(i,n){this.s.stopBuffering(i),this.g.delete(i),delete this.j[i];const h=this.h[i];h&&(h.dispose(),delete this.h[i]),this.a.$sendProcessExit(i,n)}O(i){return this.P(this.f,i)}P(i,n){const h=this.Q(i,n);return h!==null?i[h]:null}Q(i,n){let h=null;return i.some((E,C)=>E._id===n?(h=C,!0):!1),h}getEnvironmentVariableCollection(i){let n=this.l.get(i.identifier.value);return n||(n=new l,this.S(i.identifier.value,n)),n}R(i,n){const h=(0,P.serializeEnvironmentVariableCollection)(n.map);this.a.$setEnvironmentVariableCollection(i,n.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(i){i.forEach(n=>{const h=n[0],E=new l(n[1]);this.S(h,E)})}$acceptDefaultProfile(i,n){const h=this.m;this.m=i,this.n=n,h?.path!==i.path&&this.J.fire(i.path)}S(i,n){this.l.set(i,n),n.onDidChangeCollection(()=>{this.R(i,n)})}};r=qe([We(1,k.IExtHostRpcService)],r),e.BaseExtHostTerminalService=r;class l{get persistent(){return this.a}set persistent(i){this.a=i,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(i){this.map=new Map,this.a=!0,this.b=new c.Emitter,this.map=new Map(i)}get size(){return this.map.size}replace(i,n){this.d(i,{value:n,type:y.EnvironmentVariableMutatorType.Replace})}append(i,n){this.d(i,{value:n,type:y.EnvironmentVariableMutatorType.Append})}prepend(i,n){this.d(i,{value:n,type:y.EnvironmentVariableMutatorType.Prepend})}d(i,n){const h=this.map.get(i);(!h||h.value!==n.value||h.type!==n.type)&&(this.map.set(i,n),this.b.fire())}get(i){return this.map.get(i)}forEach(i,n){this.map.forEach((h,E)=>i.call(n,E,h,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let s=class extends r{constructor(i){super(!1,i)}createTerminal(i,n,h){throw new L.NotSupportedError}createTerminalFromOptions(i,n){throw new L.NotSupportedError}};s=qe([We(0,k.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function a(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function o(u){return m.ThemeColor.isThemeColor(u)?u:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,c):T?T.value=c:e.set(te,c),c};define(ye[271],Ce([1,0,16,14,23,21,3,63,86,6,22,10,30,5,18,137,15,7,57,93,73,26]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p,b,S,g){"use strict";var r,l;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(O,U,z){this.j=z,this.c=new k.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=O.getProxy(I.MainContext.MainThreadTesting),this.h=new K(this.f),this.g=new i(this.f),U.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const ue=j,V=ue.tests[ue.tests.length-1].item.extId;return this.d.get(p.TestId.root(V))?.collection.tree.get(V)?.actual??(0,m.toItemFromContext)(j)}})}createTestController(O,U,z,j){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const ue=new D.DisposableStore,V=ue.add(new m.ExtHostTestItemCollection(U,z,this.j));V.root.label=z;const _=new Map,J=this.f,ne={items:V.root.children,get label(){return z},set label(X){z=X,V.root.label=X,J.$updateController(U,{label:z})},get refreshHandler(){return j},set refreshHandler(X){j=X,J.$updateController(U,{canRefresh:!!X})},get id(){return U},createRunProfile:(X,G,de,be,Ee,Pe)=>{let Fe=(0,y.hash)(X);for(;_.has(Fe);)Fe++;return Pe!==void 0&&(0,g.checkProposedApiEnabled)(O,"testContinuousRun"),new q(this.f,_,U,Fe,X,G,de,be,Ee,Pe)},createTestItem(X,G,de){return new m.TestItemImpl(U,X,G,de)},createTestRun:(X,G,de=!0)=>this.g.createTestRun(U,V,X,G,de),set resolveHandler(X){V.resolveHandler=X},get resolveHandler(){return V.resolveHandler},dispose:()=>{ue.dispose()}};J.$registerTestController(U,z,!!j),ue.add((0,D.toDisposable)(()=>J.$unregisterTestController(U)));const ee={controller:ne,collection:V,profiles:_};return this.d.set(U,ee),ue.add((0,D.toDisposable)(()=>this.d.delete(U))),ue.add(V.onDidGenerateDiff(X=>J.$publishDiff(U,X.map(S.TestsDiffOp.serialize)))),ne}createTestObserver(){return this.h.checkout()}async runTests(O,U=R.CancellationToken.None){const z=n(O);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(z.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(ue=>p.TestId.fromExtHostTestItem(ue,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:F[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:O.exclude?.map(ue=>ue.id)},U)}$syncTests(){for(const{collection:O}of this.d.values())O.flushDiff();return Promise.resolve()}$provideFileCoverage(O,U,z){return(0,c.mapFind)(this.g.trackers,ue=>ue.id===O?ue.getCoverage(U):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(O,U,z,j){return(0,c.mapFind)(this.g.trackers,V=>V.id===O?V.getCoverage(U):void 0)?.resolveFileCoverage(z,j)??Promise.resolve([])}$configureRunProfile(O,U){this.d.get(O)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(O,U){await this.d.get(O)?.controller.refreshHandler?.(U)}$publishTestResults(O){this.results=Object.freeze(O.map(U=>(0,L.deepFreeze)(d.TestResults.to(U))).concat(this.results).sort((U,z)=>z.completedAt-U.completedAt).slice(0,32)),this.c.fire()}async $expandTest(O,U){const z=this.d.get(p.TestId.fromString(O).controllerId)?.collection;z&&(await z.expand(O,U<0?1/0:U),z.flushDiff())}$acceptDiff(O){this.h.applyDiff(O.map(S.TestsDiffOp.deserialize))}async $runControllerTests(O,U){return Promise.all(O.map(z=>this.k(z,!1,U)))}async $startContinuousRun(O,U){const z=new R.CancellationTokenSource(U),j=await Promise.all(O.map(ue=>this.k(ue,!0,z.token)));return!U.isCancellationRequested&&!j.some(ue=>ue.error)&&await new Promise(ue=>U.onCancellationRequested(ue)),z.dispose(!0),j}async k(O,U,z){const j=this.d.get(O.controllerId);if(!j)return{};const{collection:ue,profiles:V}=j,_=V.get(O.profileId);if(!_)return{};const J=O.testIds.map(G=>ue.tree.get(G)).filter(P.isDefined),ne=O.excludeExtIds.map(G=>j.collection.tree.get(G)).filter(P.isDefined).filter(G=>J.some(de=>de.fullId.compare(G.fullId)===2));if(!J.length)return{};const ee=new f.TestRunRequest2(J.some(G=>G.actual instanceof m.TestItemRootImpl)?void 0:J.map(G=>G.actual),ne.map(G=>G.actual),_,U),X=(0,S.isStartControllerTests)(O)&&this.g.prepareForMainThreadTestRun(ee,h.fromInternal(O,j.collection),z);try{return await _.runHandler(ee,z),{}}catch(G){return{error:String(G)}}finally{X&&(X.hasRunningTasks&&!z.isCancellationRequested&&await k.Event.toPromise(X.onEnd),X.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.g.cancelAllRuns():this.g.cancelRunById(O)}};s=qe([We(0,v.IExtHostRpcService)],s),e.ExtHostTesting=s;const a=1e4;var o;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(o||(o={}));class u extends D.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(O,U,z){super(),this.k=O,this.l=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new k.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource(z));const j=this.B(new t.RunOnceScheduler(()=>this.m(),a));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(O){return this.f.get(O)?.coverage}createRun(O){const U=this.k.id,z=this.k.controllerId,j=(0,w.generateUuid)(),ue=new E(this.l,U,j),V=ee=>(X,...G)=>{if(J){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(X)||(this.s(X),ee(X,...G))},_=(ee,X)=>{const G=X instanceof Array?X.map(d.TestMessage.from):[d.TestMessage.from(X)];if(ee.uri&&ee.range){const de={range:d.Range.from(ee.range),uri:ee.uri};for(const be of G)be.location=be.location||de}this.l.$appendTestMessagesInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),G)};let J=!1;const ne={isPersisted:this.k.isPersisted,token:this.h.token,name:O,get coverageProvider(){return ue.coverageProvider},set coverageProvider(ee){ue.coverageProvider=ee},enqueued:V(ee=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),1)}),skipped:V(ee=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),5)}),started:V(ee=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),2)}),errored:V((ee,X,G)=>{_(ee,X),this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),6,G)}),failed:V((ee,X,G)=>{_(ee,X),this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,z).toString(),4,G)}),passed:V((ee,X)=>{this.l.$updateTestStateInRun(U,j,p.TestId.fromExtHostTestItem(ee,this.k.controllerId).toString(),3,X)}),appendOutput:(ee,X,G)=>{J||(G&&(this.k.isIncluded(G)?this.s(G):G=void 0),this.l.$appendOutputToRun(U,j,T.VSBuffer.fromString(ee),X&&d.location.from(X),G&&p.TestId.fromExtHostTestItem(G,z).toString()))},end:()=>{J||(J=!0,this.l.$finishedTestRunTask(U,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:ne,coverage:ue}),this.l.$startedTestRunTask(U,{id:j,name:O,running:!0}),ne}m(){for(const{run:O}of this.f.values())O.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(O){if(!(O instanceof m.TestItemImpl))throw new b.InvalidTestItemError(O.id);if(this.g.has(p.TestId.fromExtHostTestItem(O,this.k.controllerId).toString()))return;const U=[],z=this.k.colllection.root;for(;;){const j=d.TestItem.from(O);if(U.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),O===z))break;O=O.parent||z}this.l.$addTestsToRun(this.k.controllerId,this.k.id,U)}}class i{get trackers(){return this.c.values()}constructor(O){this.d=O,this.c=new Map}prepareForMainThreadTestRun(O,U,z){return this.f(O,U,z)}cancelRunById(O){for(const U of this.c.values())if(U.id===O){U.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,U,z,j,ue){const V=this.c.get(z);if(V)return V.createRun(j);const _=h.fromPublic(O,U,z,ue),J=n(z);this.d.$startedExtensionTestRun({controllerId:O,continuous:!!z.continuous,profile:J&&{group:F[J.kind],id:J.profileId},exclude:z.exclude?.map(ee=>p.TestId.fromExtHostTestItem(ee,U.root.id).toString())??[],id:_.id,include:z.include?.map(ee=>p.TestId.fromExtHostTestItem(ee,U.root.id).toString())??[U.root.id],persist:ue});const ne=this.f(z,_);return ne.onEnd(()=>{this.d.$finishedExtensionTestRun(_.id),ne.dispose()}),ne.createRun(j)}f(O,U,z){const j=new u(U,this.d,z);return this.c.set(O,j),j.onEnd(()=>this.c.delete(O)),j}}e.TestRunCoordinator=i;const n=B=>{if(!!B.profile){if(!(B.profile instanceof q))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class h{static fromPublic(O,U,z,j){return new h(O,(0,w.generateUuid)(),z.include?.map(ue=>p.TestId.fromExtHostTestItem(ue,O).toString())??[O],z.exclude?.map(ue=>p.TestId.fromExtHostTestItem(ue,O).toString())??[],j,U)}static fromInternal(O,U){return new h(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,U)}constructor(O,U,z,j,ue,V){this.controllerId=O,this.id=U,this.isPersisted=ue,this.colllection=V,this.c=z.map(_=>_+"\0"),this.d=j.map(_=>_+"\0")}isIncluded(O){const U=p.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const z of this.d)if(U===z||U.startsWith(z))return!1;for(const z of this.c)if(U===z||U.startsWith(z))return!0;return!1}}e.TestRunDto=h;class E{set coverageProvider(O){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this.c=O,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(O,U,z){this.f=O,this.g=U,this.h=z}async provideFileCoverage(O){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(O))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(U){throw this.d=void 0,U}}async resolveFileCoverage(O,U){const z=await this.d;let j=z?.[O];return!this.c||!z||!j?[]:(j.detailedCoverage||(j=z[O]=await this.c.resolveFileCoverage?.(j,U)??j),j.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class C{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,d.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const U=p.TestId.parentId(O.item.extId);if(U&&this.g.has(U.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:U,f:z}=this;return{get added(){return[...O].map(j=>j.revived)},get updated(){return[...U].map(j=>j.revived)},get removed(){return[...z].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class M extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new k.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,U){return{...O,revived:d.TestItem.toPlain(O.item),depth:U?U.depth+1:0,children:new Set}}o(){return new C(this.q)}}class K{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(U=>U.revived)},dispose:(0,A.once)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new M;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class q{get label(){return this.d}set label(O){O!==this.d&&(this.d=O,Ue(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,Ue(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,Ue(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Ue(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?d.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,Ue(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}constructor(O,U,z,j,ue,V,_,J=!1,ne=void 0,ee=!1){this.controllerId=z,this.profileId=j,this.d=ue,this.kind=V,this.runHandler=_,this.f=J,this._tag=ne,this.g=ee,r.set(this,void 0),l.set(this,void 0),Je(this,r,O,"f"),Je(this,l,U,"f"),U.set(j,this);const X=F[V];if(typeof X!="number")throw new Error(`Unknown TestRunProfile.group ${V}`);Ue(this,r,"f").$publishTestRunProfile({profileId:j,controllerId:z,tag:ne?d.TestTag.namespace(this.controllerId,ne.id):null,label:ue,group:X,isDefault:J,hasConfigurationHandler:!1,supportsContinuousRun:ee})}dispose(){Ue(this,l,"f")?.delete(this.profileId)&&(Je(this,l,void 0,"f"),Ue(this,r,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=q,r=new WeakMap,l=new WeakMap;const F={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(ye[272],Ce([1,0,16,3,5,138,15,7]),function(te,e,c,t,T,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(L,P){this.i=P,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(T.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(w=>this.g.fire(w)),this.i.onDidChangeActiveTextEditor(w=>this.f.fire(w))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const P=this.i.allEditors();return L?P:P.map(w=>w.value)}async showTextDocument(L,P,w){let I;typeof P=="number"?I={position:k.ViewColumn.from(P),preserveFocus:w}:typeof P=="object"?I={position:k.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?k.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:I={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(L.uri,I),m=v&&this.i.getEditor(v);if(m)return m.value;throw v?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,P){return new R.TextEditorDecorationType(this.h,L,P).value}$acceptEditorPropertiesChanged(L,P){const w=this.i.getEditor(L);if(!w)throw new Error("unknown text editor");if(P.options&&w._acceptOptions(P.options),P.selections){const I=P.selections.selections.map(k.Selection.to);w._acceptSelections(I)}if(P.visibleRanges){const I=c.coalesce(P.visibleRanges.map(k.Range.to));w._acceptVisibleRanges(I)}if(P.options&&this.b.fire({textEditor:w.value,options:{...P.options,lineNumbers:k.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const I=A.TextEditorSelectionChangeKind.fromValue(P.selections.source),v=P.selections.selections.map(k.Selection.to);this.a.fire({textEditor:w.value,selections:v,kind:I})}if(P.visibleRanges){const I=c.coalesce(P.visibleRanges.map(k.Range.to));this.c.fire({textEditor:w.value,visibleRanges:I})}}$acceptEditorPositionData(L){for(const P in L){const w=this.i.getEditor(P);if(!w)throw new Error("Unknown text editor");const I=k.ViewColumn.to(L[P]);w.value.viewColumn!==I&&(w._acceptViewColumn(I),this.d.fire({textEditor:w.value,viewColumn:I}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=y}),define(ye[273],Ce([1,0,2,4,5,6,7,15,27,10]),function(te,e,c,t,T,R,k,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class L{constructor(I,v){this.b=new Map,this.c=new Map,this.a=I.getProxy(T.MainContext.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(m,d)=>{if(m&&m.$mid===12)if(this.b.get(m.source)&&y.ExtensionIdentifier.equals(d,this.b.get(m.source)?.extension)){const f=m.uri===void 0?void 0:c.URI.revive(m.uri);return this.c.get(m.source)?.get(P(f))?.get(m.handle)}else return;return m}})}async $getTimeline(I,v,m,d){return this.b.get(I)?.provider.provideTimeline(c.URI.revive(v),m,d)}registerTimelineProvider(I,v,m,d){const f=new R.DisposableStore,p=this.d(v.id,d,f).bind(this);let b;v.onDidChange&&(b=v.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:v.id}),this));const S=this.c;return this.f({...v,scheme:I,onDidChange:void 0,async provideTimeline(g,r,l){r?.resetCache&&(f.clear(),S.get(v.id)?.clear());const s=await v.provideTimeline(g,r,l);if(s==null)return;const a=p(g,r);return{...s,source:v.id,items:s.items.map(a)}},dispose(){for(const g of S.values())g.get(v.id)?.clear();b?.dispose(),f.dispose()}},m)}d(I,v,m){return(d,f)=>{let p;if(f?.cacheResults){let b=this.c.get(I);b===void 0&&(b=new Map,this.c.set(I,b));const S=P(d);p=b.get(S),p===void 0&&(p=new Map,b.set(S,p))}return b=>{const{iconPath:S,...g}=b,r=`${I}|${b.id??b.timestamp}`;p?.set(r,b);let l,s,a;b.iconPath&&(S instanceof k.ThemeIcon?a={id:S.id,color:S.color}:c.URI.isUri(S)?(l=S,s=S):{light:l,dark:s}=S);let o;return k.MarkdownString.isMarkdownString(g.tooltip)?o=A.MarkdownString.from(g.tooltip):(0,D.isString)(g.tooltip)?o=g.tooltip:k.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=A.MarkdownString.from(g.detail)):(0,D.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=g.detail),{...g,id:g.id??void 0,handle:r,source:I,command:b.command?v.toInternal(b.command,m):void 0,icon:l,iconDark:s,themeIcon:a,tooltip:o,accessibilityInformation:b.accessibilityInformation}}}}f(I,v){if(this.b.get(I.id))throw new Error(`Timeline Provider ${I.id} already exists.`);return this.a.$registerTimelineProvider({id:I.id,label:I.label,scheme:I.scheme}),this.b.set(I.id,{provider:I,extension:v}),(0,R.toDisposable)(()=>{for(const d of this.c.values())d.get(I.id)?.clear();this.b.delete(I.id),this.a.$unregisterTimelineProvider(I.id),I.dispose()})}}e.ExtHostTimeline=L;function P(w){return w?.toString()}}),define(ye[274],Ce([1,0,6,17,2,5]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(y){this.c=new Map,this.b=y.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,D,L,P){if(this.c.has(D))throw new Error(`Opener with id '${D}' already registered`);const w=P.schemes.find(I=>!k.a.has(I));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this.c.set(D,L),this.b.$registerUriOpener(D,P.schemes,y,P.label),(0,c.toDisposable)(()=>{this.c.delete(D),this.b.$unregisterUriOpener(D)})}async $canOpenUri(y,D,L){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener with id: ${y}`);const w=T.URI.revive(D);return P.canOpenExternalUri(w,L)}async $openUri(y,D,L){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener id: '${y}'`);return P.openExternalUri(T.URI.revive(D.resolvedUri),{sourceUri:T.URI.revive(D.sourceUri)},L)}}e.ExtHostUriOpeners=k,k.a=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[275],Ce([1,0,5,2,6,9,27]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(D){this.c=new Set,this.d=new Map,this.b=D.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(D,L){if(this.c.has(k.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const P=A.a++;return this.c.add(k.ExtensionIdentifier.toKey(D)),this.d.set(P,L),this.b.$registerUriHandler(P,D),(0,T.toDisposable)(()=>{this.c.delete(k.ExtensionIdentifier.toKey(D)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(D,L){const P=this.d.get(D);if(!P)return Promise.resolve(void 0);try{P.handleUri(t.URI.revive(L))}catch(w){(0,R.onUnexpectedError)(w)}return Promise.resolve(void 0)}async createAppUri(D){return t.URI.revive(await this.b.$createAppUri(D))}}e.ExtHostUrls=A,A.a=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,c):T?T.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[77],Ce([1,0,3,17,22,2,196,219,94,5]),function(te,e,c,t,T,R,k,A,y,D){"use strict";var L,P,w,I,v,m,d,f,p,b,S,g,r;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(C,M,K,q,F,B,O){L.set(this,void 0),P.set(this,void 0),w.set(this,void 0),I.set(this,void 0),v.set(this,void 0),m.set(this,void 0),d.set(this,""),f.set(this,void 0),p.set(this,!1),b.set(this,!1),S.set(this,void 0),g.set(this,void 0),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new c.Emitter),this._onDidDispose=Ue(this,r,"f").event,Je(this,L,C,"f"),Je(this,P,M,"f"),Je(this,f,K,"f"),Je(this,I,q,"f"),Je(this,v,F,"f"),Je(this,m,B,"f"),Je(this,S,s(B),"f"),Je(this,g,a(B),"f"),Je(this,w,O,"f")}dispose(){Je(this,p,!0,"f"),Ue(this,r,"f").fire(),Ue(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(C){return Je(this,b,!0,"f"),(0,y.asWebviewUri)(C,Ue(this,I,"f"))}get cspSource(){const C=Ue(this,m,"f").extensionLocation;if(C.scheme===t.Schemas.https||C.scheme===t.Schemas.http){let M=C.toString();return M.endsWith("/")||(M+="/"),M+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Ue(this,d,"f")}set html(C){this.a(),Ue(this,d,"f")!==C&&(Je(this,d,C,"f"),Ue(this,g,"f")&&!Ue(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(C)&&(Je(this,b,!0,"f"),Ue(this,w,"f").report("Webview vscode-resource: uris",Ue(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,P,"f").$setHtml(Ue(this,L,"f"),this.b(C)))}get options(){return this.a(),Ue(this,f,"f")}set options(C){this.a(),T.equals(Ue(this,f,"f"),C)||Ue(this,P,"f").$setOptions(Ue(this,L,"f"),i(Ue(this,m,"f"),Ue(this,v,"f"),C)),Je(this,f,C,"f")}async postMessage(C){if(Ue(this,p,"f"))return!1;const M=(0,A.serializeWebviewMessage)(C,{serializeBuffersForPostMessage:Ue(this,S,"f")});return Ue(this,P,"f").$postMessage(Ue(this,L,"f"),M.message,...M.buffers)}a(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}b(C){if(!Ue(this,g,"f"))return C;const M=Ue(this,m,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,K=Ue(this,m,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Ue(this,m,"f").extensionLocation.authority:void 0;return C.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,F,B,O,U,z)=>{const j=R.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),ue=(0,y.asWebviewUri)(j,{isRemote:M,authority:K}).toString();return`${F}${ue}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(q,F,B,O,U,z)=>{const j=R.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),ue=(0,y.asWebviewUri)(j,{isRemote:M,authority:K}).toString();return`${F}${ue}${z}`})}}e.ExtHostWebview=l,L=new WeakMap,P=new WeakMap,w=new WeakMap,I=new WeakMap,v=new WeakMap,m=new WeakMap,d=new WeakMap,f=new WeakMap,p=new WeakMap,b=new WeakMap,S=new WeakMap,g=new WeakMap,r=new WeakMap;function s(E){try{const C=(0,k.normalizeVersion)((0,k.parseVersion)(E.engines.vscode));return!!C&&C.majorBase>=1&&C.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function a(E){try{const C=(0,k.normalizeVersion)((0,k.parseVersion)(E.engines.vscode));return C?C.majorBase<1||C.majorBase===1&&C.minorBase<60:!1}catch{return!1}}class o{constructor(C,M,K,q,F){this.c=M,this.d=K,this.e=q,this.f=F,this.b=new Map,this.a=C.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(C,M,K){const q=this.g(C);if(q){const{message:F}=(0,A.deserializeWebviewMessage)(M,K.value);q._onMessageEmitter.fire(F)}}$onMissingCsp(C,M){this.e.warn(`${M} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(C,M,K){const q=new l(C,this.a,n(M),this.c,this.d,K,this.f);return this.b.set(C,q),q._onDidDispose(()=>{this.b.delete(C)}),q}deleteWebview(C){this.b.delete(C)}g(C){return this.b.get(C)}}e.ExtHostWebviews=o;function u(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=u;function i(E,C,M){return{enableCommandUris:M.enableCommandUris,enableScripts:M.enableScripts,enableForms:M.enableForms,portMapping:M.portMapping,localResourceRoots:M.localResourceRoots||h(E,C)}}e.serializeWebviewOptions=i;function n(E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots?.map(C=>R.URI.from(C))}}function h(E,C){return[...(C?.getWorkspaceFolders()||[]).map(M=>M.uri),E.extensionLocation]}}),define(ye[276],Ce([1,0,21,86,6,17,24,2,15,77,72,5,7]),function(te,e,c,t,T,R,k,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(l,s){this.document=l,this.b=s,this.a=1,this.c=new L.Cache("custom documents")}addEdit(l){return this.c.add([l])}async undo(l,s){await this.f(l).undo(),s||this.disposeBackup()}async redo(l,s){await this.f(l).redo(),s||this.disposeBackup()}disposeEdits(l){for(const s of l)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const l=g(this.document.uri)+this.a++;return(0,k.joinPath)(this.b,l)}updateBackup(l){this.d?.delete(),this.d=l}disposeBackup(){this.d?.delete(),this.d=void 0}f(l){const s=this.c.get(l,0);if(!s)throw new Error("No edit found");return s}}class v{constructor(){this.a=new Map}get(l,s){return this.a.get(this.b(l,s))}add(l,s,a){const o=this.b(l,s.uri);if(this.a.has(o))throw new Error(`Document already exists for viewType:${l} resource:${s.uri}`);const u=new I(s,a);return this.a.set(o,u),u}delete(l,s){const a=this.b(l,s.uri);this.a.delete(a)}b(l,s){return`${l}@@@${s}`}}var m;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(m||(m={}));class d{constructor(){this.a=new Map}addTextProvider(l,s,a){return this.b(0,l,s,a)}addCustomProvider(l,s,a){return this.b(1,l,s,a)}get(l){return this.a.get(l)}b(l,s,a,o){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:l,extension:a,provider:o}),new w.Disposable(()=>this.a.delete(s))}}class f{constructor(l,s,a,o,u){this.d=s,this.f=a,this.g=o,this.h=u,this.b=new d,this.c=new v,this.a=l.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,s,a,o){const u=new T.DisposableStore;return b(a)?(u.add(this.b.addTextProvider(s,l,a)),this.a.$registerTextEditorProvider((0,D.toExtensionData)(l),s,o.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(l))):(u.add(this.b.addCustomProvider(s,l,a)),p(a)&&u.add(a.onDidChangeCustomDocument(i=>{const n=this.i(s,i.document.uri);if(S(i)){const h=n.addEdit(i);this.a.$onDidEdit(i.document.uri,s,h,i.label)}else this.a.$onContentChange(i.document.uri,s)})),this.a.$registerCustomEditorProvider((0,D.toExtensionData)(l),s,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(l))),w.Disposable.from(u,new w.Disposable(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(l,s,a,o,u){const i=this.b.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${s}'`);const n=A.URI.revive(l),h=await i.provider.openCustomDocument(n,{backupId:a,untitledDocumentData:o?.buffer},u);let E;return p(i.provider)&&this.f&&(E=this.f.workspaceValue(i.extension)??this.f.globalValue(i.extension)),this.c.add(s,h,E),{editable:p(i.provider)}}async $disposeCustomDocument(l,s){const a=this.b.get(s);if(!a)throw new Error(`No provider found for '${s}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${s}'`);const o=A.URI.revive(l),{document:u}=this.i(s,o);this.c.delete(s,u),u.dispose()}async $resolveCustomEditor(l,s,a,o,u,i){console.log("xxxx");const n=this.b.get(a);if(!n)throw new Error(`No provider found for '${a}'`);const h=y.ViewColumn.to(u),E=this.g.createNewWebview(s,o.contentOptions,n.extension),C=this.h.createNewWebviewPanel(s,a,o.title,h,o.options,E,!0),M=A.URI.revive(l);switch(n.type){case 1:{const{document:K}=this.i(a,M);return n.provider.resolveCustomEditor(K,C,i)}case 0:{const K=this.d.getDocument(M);return n.provider.resolveCustomTextEditor(K,C,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,s,a){this.i(s,l).disposeEdits(a)}async $onMoveCustomEditor(l,s,a){const o=this.b.get(a);if(!o)throw new Error(`No provider found for '${a}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const u=this.h.getWebviewPanel(l);if(!u)throw new Error("No webview found");const i=A.URI.revive(s),n=this.d.getDocument(i);await o.provider.moveCustomTextEditor(n,u,c.CancellationToken.None)}async $undo(l,s,a,o){return this.i(s,l).undo(a,o)}async $redo(l,s,a,o){return this.i(s,l).redo(a,o)}async $revert(l,s,a){const o=this.i(s,l);await this.j(s).revertCustomDocument(o.document,a),o.disposeBackup()}async $onSave(l,s,a){const o=this.i(s,l);await this.j(s).saveCustomDocument(o.document,a),o.disposeBackup()}async $onSaveAs(l,s,a,o){const u=this.i(s,l);return this.j(s).saveCustomDocumentAs(u.document,A.URI.revive(a),o)}async $backup(l,s,a){const o=this.i(s,l),i=await this.j(s).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},a);return o.updateBackup(i),i.id}i(l,s){const a=this.c.get(l,A.URI.revive(s));if(!a)throw new Error("No custom document found");return a}j(l){const a=this.b.get(l)?.provider;if(!a||!p(a))throw new Error("Custom document is not editable");return a}}e.ExtHostCustomEditors=f;function p(r){return!!r.onDidChangeCustomDocument}function b(r){return typeof r.resolveCustomTextEditor=="function"}function S(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function g(r){const l=r.scheme===R.Schemas.file||r.scheme===R.Schemas.untitled?r.fsPath:r.toString();return(0,t.hash)(l)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,c):T?T.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[277],Ce([1,0,3,6,2,30,15,77,5,7]),function(te,e,c,t,T,R,k,A,y,D){"use strict";var L,P,w,I,v,m,d,f,p,b,S,g,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class l extends t.Disposable{constructor(u,i,n,h){super(),L.set(this,void 0),P.set(this,void 0),w.set(this,void 0),I.set(this,void 0),v.set(this,void 0),m.set(this,void 0),d.set(this,void 0),f.set(this,void 0),p.set(this,!0),b.set(this,void 0),S.set(this,!1),g.set(this,this.B(new c.Emitter)),this.onDidDispose=Ue(this,g,"f").event,r.set(this,this.B(new c.Emitter)),this.onDidChangeViewState=Ue(this,r,"f").event,Je(this,L,u,"f"),Je(this,P,i,"f"),Je(this,I,n,"f"),Je(this,w,h.viewType,"f"),Je(this,v,h.panelOptions,"f"),Je(this,f,h.viewColumn,"f"),Je(this,m,h.title,"f"),Je(this,b,h.active,"f")}dispose(){Ue(this,S,"f")||(Je(this,S,!0,"f"),Ue(this,g,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,I,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,I,"f")}get viewType(){return this.c(),Ue(this,w,"f")}get title(){return this.c(),Ue(this,m,"f")}set title(u){this.c(),Ue(this,m,"f")!==u&&(Je(this,m,u,"f"),Ue(this,P,"f").$setTitle(Ue(this,L,"f"),u))}get iconPath(){return this.c(),Ue(this,d,"f")}set iconPath(u){this.c(),Ue(this,d,"f")!==u&&(Je(this,d,u,"f"),Ue(this,P,"f").$setIconPath(Ue(this,L,"f"),T.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Ue(this,v,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,f,"f")=="number"&&Ue(this,f,"f")<0))return Ue(this,f,"f")}get active(){return this.c(),Ue(this,b,"f")}get visible(){return this.c(),Ue(this,p,"f")}_updateViewState(u){Ue(this,S,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(Je(this,b,u.active,"f"),Je(this,p,u.visible,"f"),Je(this,f,u.viewColumn,"f"),Ue(this,r,"f").fire({webviewPanel:this}))}reveal(u,i){this.c(),Ue(this,P,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof u>"u"?void 0:k.ViewColumn.from(u),preserveFocus:!!i})}c(){if(Ue(this,S,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,P=new WeakMap,w=new WeakMap,I=new WeakMap,v=new WeakMap,m=new WeakMap,d=new WeakMap,f=new WeakMap,p=new WeakMap,b=new WeakMap,S=new WeakMap,g=new WeakMap,r=new WeakMap;class s{static c(){return(0,R.generateUuid)()}constructor(u,i,n){this.g=i,this.h=n,this.e=new Map,this.f=new Map,this.d=u.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(u,i,n,h,E={}){const C=typeof h=="object"?h.viewColumn:h,M={viewColumn:k.ViewColumn.from(C),preserveFocus:typeof h=="object"&&!!h.preserveFocus},K=(0,A.shouldSerializeBuffersForPostMessage)(u),q=s.c();this.d.$createWebviewPanel((0,A.toExtensionData)(u),q,i,{title:n,panelOptions:a(E),webviewOptions:(0,A.serializeWebviewOptions)(u,this.h,E),serializeBuffersForPostMessage:K},M);const F=this.g.createNewWebview(q,E,u);return this.createNewWebviewPanel(q,i,n,C,E,F,!0)}$onDidChangeWebviewPanelViewStates(u){const i=Object.keys(u);i.sort((n,h)=>{const E=u[n],C=u[h];return E.active?1:C.active?-1:+E.visible-+C.visible});for(const n of i){const h=this.getWebviewPanel(n);if(!h)continue;const E=u[n];h._updateViewState({active:E.active,visible:E.visible,viewColumn:k.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this.e.delete(u),this.g.deleteWebview(u)}registerWebviewPanelSerializer(u,i,n){if(this.f.has(i))throw new Error(`Serializer for '${i}' already registered`);return this.f.set(i,{serializer:n,extension:u}),this.d.$registerSerializer(i,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(u)}),new D.Disposable(()=>{this.f.delete(i),this.d.$unregisterSerializer(i)})}async $deserializeWebviewPanel(u,i,n,h){const E=this.f.get(i);if(!E)throw new Error(`No serializer found for '${i}'`);const{serializer:C,extension:M}=E,K=this.g.createNewWebview(u,n.webviewOptions,M),q=this.createNewWebviewPanel(u,i,n.title,h,n.panelOptions,K,n.active);await C.deserializeWebviewPanel(q,n.state)}createNewWebviewPanel(u,i,n,h,E,C,M){const K=new l(u,this.d,C,{viewType:i,title:n,viewColumn:h,panelOptions:E,active:M});return this.e.set(u,K),K}getWebviewPanel(u){return this.e.get(u)}}e.ExtHostWebviewPanels=s;function a(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,c):T?T.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[278],Ce([1,0,3,6,77,15,5,7]),function(te,e,c,t,T,R,k,A){"use strict";var y,D,L,P,w,I,v,m,d,f,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends t.Disposable{constructor(r,l,s,a,o,u){super(),y.set(this,void 0),D.set(this,void 0),L.set(this,void 0),P.set(this,void 0),w.set(this,!1),I.set(this,void 0),v.set(this,void 0),m.set(this,void 0),d.set(this,void 0),f.set(this,this.B(new c.Emitter)),this.onDidChangeVisibility=Ue(this,f,"f").event,p.set(this,this.B(new c.Emitter)),this.onDidDispose=Ue(this,p,"f").event,Je(this,L,s,"f"),Je(this,v,a,"f"),Je(this,y,r,"f"),Je(this,D,l,"f"),Je(this,P,o,"f"),Je(this,I,u,"f")}dispose(){Ue(this,w,"f")||(Je(this,w,!0,"f"),Ue(this,p,"f").fire(),Ue(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,v,"f")}set title(r){this.a(),Ue(this,v,"f")!==r&&(Je(this,v,r,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,y,"f"),r))}get description(){return this.a(),Ue(this,m,"f")}set description(r){this.a(),Ue(this,m,"f")!==r&&(Je(this,m,r,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,y,"f"),r))}get visible(){return Ue(this,I,"f")}get webview(){return Ue(this,P,"f")}get viewType(){return Ue(this,L,"f")}_setVisible(r){r===Ue(this,I,"f")||Ue(this,w,"f")||(Je(this,I,r,"f"),Ue(this,f,"f").fire())}get badge(){return this.a(),Ue(this,d,"f")}set badge(r){this.a(),!(r?.value===Ue(this,d,"f")?.value&&r?.tooltip===Ue(this,d,"f")?.tooltip)&&(Je(this,d,R.ViewBadge.from(r),"f"),Ue(this,D,"f").$setWebviewViewBadge(Ue(this,y,"f"),r))}show(r){this.a(),Ue(this,D,"f").$show(Ue(this,y,"f"),!!r)}a(){if(Ue(this,w,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,D=new WeakMap,L=new WeakMap,P=new WeakMap,w=new WeakMap,I=new WeakMap,v=new WeakMap,m=new WeakMap,d=new WeakMap,f=new WeakMap,p=new WeakMap;class S{constructor(r,l){this.d=l,this.b=new Map,this.c=new Map,this.a=r.getProxy(k.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,l,s,a){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:s,extension:r}),this.a.$registerWebviewViewProvider((0,T.toExtensionData)(r),l,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(r)}),new A.Disposable(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(r,l,s,a,o){const u=this.b.get(l);if(!u)throw new Error(`No view provider found for '${l}'`);const{provider:i,extension:n}=u,h=this.d.createNewWebview(r,{},n),E=new b(r,this.a,l,s,h,!0);this.c.set(r,E),await i.resolveWebviewView(E,{state:a},o)}async $onDidChangeWebviewViewVisibility(r,l){this.e(r)._setVisible(l)}async $disposeWebviewView(r){const l=this.e(r);this.c.delete(r),l.dispose(),this.d.deleteWebview(r)}e(r){const l=this.c.get(r);if(!l)throw new Error("No webview found");return l}}e.ExtHostWebviewViews=S}),define(ye[141],Ce([1,0,3,5,2,17,8,4,18]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class si{get state(){return this.d}constructor(P){this.c=new c.Emitter,this.onDidChangeWindowState=this.c.event,this.d=si.a,this.b=P.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(w=>this.$onDidChangeWindowFocus(w))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,w){let I;if(typeof P=="string"){I=P;try{P=T.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,k.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,I,w)}async asExternalUri(P,w){if((0,k.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this.b.$asExternalUri(P,w);return T.URI.from(I)}};D.a={focused:!0},D=qe([We(0,y.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ye[279],Ce([1,0,119,280,67,41,2,13,47]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(w,I,v){this.b=w,this.c=I,this.f=v,this.a=t.createServer((m,d)=>this.h(m,d)),this.g().catch(m=>(I.error(m),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,I){const v=(d,f)=>{I.writeHead(d,{"content-type":"application/json"}),I.end(JSON.stringify(f||null),p=>p&&this.c.error(p))},m=[];w.setEncoding("utf8"),w.on("data",d=>m.push(d)),w.on("end",async()=>{try{const d=JSON.parse(m.join(""));let f;switch(d.type){case"open":f=await this.i(d);break;case"openExternal":f=await this.j(d);break;case"status":f=await this.l(d);break;case"extensionManagement":f=await this.k(d);break;default:v(404,`Unknown message type: ${d.type}`);break}v(200,f)}catch(d){const f=d instanceof Error?d.message:JSON.stringify(d);v(500,f),this.c.error("Error while processing pipe request",d)}})}async i(w){const{fileURIs:I,folderURIs:v,forceNewWindow:m,diffMode:d,mergeMode:f,addMode:p,forceReuseWindow:b,gotoLineMode:S,waitMarkerFilePath:g,remoteAuthority:r}=w,l=[];if(Array.isArray(v))for(const u of v)try{l.push({folderUri:k.URI.parse(u)})}catch{}if(Array.isArray(I))for(const u of I)try{(0,y.hasWorkspaceFileExtension)(u)?l.push({workspaceUri:k.URI.parse(u)}):l.push({fileUri:k.URI.parse(u)})}catch{}const s=g?k.URI.file(g):void 0,o={forceNewWindow:m,diffMode:d,mergeMode:f,addMode:p,gotoLineMode:S,forceReuseWindow:b,preferNewWindow:!b&&!s&&!p,waitMarkerFileURI:s,remoteAuthority:r};return this.b.executeCommand("_remoteCLI.windowOpen",l,o),""}async j(w){for(const I of w.uris){const v=k.URI.parse(I),m=v.scheme==="file"?v:I;await this.b.executeCommand("_remoteCLI.openExternal",m)}}async k(w){const I=m=>m?.map(d=>/\.vsix$/i.test(d)?k.URI.parse(d):d),v={list:w.list,install:I(w.install),uninstall:I(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&T.existsSync(this.f)&&T.unlinkSync(this.f)}}e.CLIServerBase=D;let L=class extends D{constructor(w,I){super(w,I,(0,c.createRandomIPCHandle)())}};L=qe([We(0,R.IExtHostCommands),We(1,A.ILogService)],L),e.CLIServer=L}),define(ye[281],Ce([1,0,252,25,18]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let k=class extends c.AbstractExtHostConsoleForwarder{constructor(y,D){super(y,D),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,D,L){const P=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),D.apply(console,L),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,D){const L=process[y],P=L.write;let w="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(I,v,m)=>{if(!this.g){w+=I.toString(v);const d=w.length>R?w.length:w.lastIndexOf(`
`);d!==-1&&(console[D](w.slice(0,d)),w=w.slice(d+1))}P.call(L,I,v,m)}})}};k=qe([We(0,T.IExtHostRpcService),We(1,t.IExtHostInitDataService)],k),e.ExtHostConsoleForwarder=k}),define(ye[282],Ce([1,0,11,88,30,41,6,5,2,18]),function(te,e,c,t,T,R,k,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends k.Disposable{constructor(w,I){super();const v=w.getProxy(A.MainContext.MainThreadDownloadService);I.registerCommand(!1,"_workbench.downloadResource",async m=>{const d=y.URI.file((0,c.join)((0,t.tmpdir)(),(0,T.generateUuid)()));return await v.$download(m,d),d})}};L=qe([We(0,D.IExtHostRpcService),We(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ye[283],Ce([1,0,140,17,202,30]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class k extends c.ExtHostLoggerService{f(y,D,L){return y.scheme===t.Schemas.file?new T.SpdLogLogger(L?.name||(0,R.generateUuid)(),y.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,D):super.f(y,D,L)}}e.ExtHostLoggerService=k}),define(ye[284],Ce([1,0,67,11,2,76,6,17,14,29]),function(te,e,c,t,T,R,k,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(r){const l=await super.g(r);if(l.scheme!==A.Schemas.file)return l;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${l.fsPath}.`),l;const s=l.fsPath;let a=0;do{let o;a===0?o=s:o=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${a}`:`${s}-${a}`,await P(o);const u=t.join(o,"vscode.lock"),i=await m(this.d,u,!1);if(i)return this.i=i,process.on("exit",()=>{i.dispose()}),T.URI.file(o);a++}while(a<10);return l}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function P(g){try{await D.Promises.stat(g);return}catch{}try{await D.Promises.mkdir(g,{recursive:!0})}catch{}}const w=1e3,I=10*60*1e3;class v extends k.Disposable{constructor(r,l){super(),this.b=r,this.c=l,this.a=this.B(new y.IntervalTimer),this.a.cancelAndSet(async()=>{const s=await d(r,l);(!s||s.pid!==process.pid)&&(r.info(`Lock '${l}': The lock was lost unexpectedly.`),this.a.cancel());try{await D.Promises.utimes(l,new Date,new Date)}catch(a){r.error(a),r.info(`Lock '${l}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{c.unlinkSync(this.c)}catch{}}async setWillRelease(r){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${r} ms.`);try{const l={pid:process.pid,willReleaseAt:Date.now()+r};await D.Promises.writeFile(this.c,JSON.stringify(l),{flag:"w"})}catch(l){this.b.error(l)}}}async function m(g,r,l){try{const a={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(r,JSON.stringify(a),{flag:"wx"})}catch(a){g.error(a)}const s=await d(g,r);return!s||s.pid!==process.pid?l?(g.info(`Lock '${r}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${r}': Could not acquire lock, checking if the file is stale.`),b(g,r)):(g.info(`Lock '${r}': Lock acquired.`),new v(g,r))}async function d(g,r){let l;try{l=await D.Promises.readFile(r)}catch(s){return g.error(s),null}try{return JSON.parse(String(l))}catch(s){return g.error(s),null}}async function f(g,r){let l;try{l=await D.Promises.stat(r)}catch(s){return g.error(s),0}return l.mtime.getTime()}function p(g){try{return process.kill(g,0),!0}catch{return!1}}async function b(g,r){const l=await d(g,r);if(!l)return g.info(`Lock '${r}': Could not read pid of lock holder.`),S(g,r);if(l.willReleaseAt){let i=l.willReleaseAt-Date.now();if(i<5e3){for(i>0?g.info(`Lock '${r}': The lockfile is scheduled to be released in ${i} ms.`):g.info(`Lock '${r}': The lockfile is scheduled to have been released.`);i>0;){if(await(0,y.timeout)(Math.min(100,i)),await f(g,r)===0)return S(g,r);i=l.willReleaseAt-Date.now()}return S(g,r)}}if(!p(l.pid))return g.info(`Lock '${r}': The pid ${l.pid} appears to be gone.`),S(g,r);const s=await f(g,r),a=Date.now()-s;if(a<=I)return g.info(`Lock '${r}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;g.info(`Lock '${r}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const o=await f(g,r),u=Date.now()-o;return u<=I?(g.info(`Lock '${r}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(g.info(`Lock '${r}': The lock looks stale even after waiting for 2s.`),S(g,r))}async function S(g,r){g.info(`Lock '${r}': Deleting a stale lock.`);try{await D.Promises.unlink(r)}catch{}return m(g,r,!0)}}),define(ye[285],Ce([1,0,30,18,42]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends T.BaseExtHostTerminalService{constructor(A){super(!0,A)}createTerminal(A,y,D){return this.createTerminalFromOptions({name:A,shellPath:y,shellArgs:D})}createTerminalFromOptions(A,y){const D=new T.ExtHostTerminal(this.a,(0,c.generateUuid)(),A,A.name);return this.f.push(D),D.create(A,this.L(A,y)),D.value}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(ye[286],Ce([1,0,5,18,184,6,25,2,46,24,29,7,12,55,3,129,102,13]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class p extends m.DisposableTunnel{}function b(i){const n=i.trim().split(`
`),h=[];return n.forEach(C=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(C);M&&M.length>=3&&h.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),h.reduce((C,M)=>(C[M.socket]=M,C),{})}e.getSockets=b;function S(...i){const n=[].concat(...i.map(r));return[...new Map(n.filter(h=>h.st==="0A").map(h=>{const E=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:g(E[0]),port:parseInt(E[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=S;function g(i){let n="";if(i.length===8)for(let h=i.length-2;h>=0;h-=2)n+=parseInt(i.substr(h,2),16),h!==0&&(n+=".");else for(let h=i.length-4;h>=0;h-=4)n+=parseInt(i.substr(h,4),16).toString(16),h!==0&&(n+=":");return n}function r(i){const n=i.trim().split(`
`),h=n.shift().trim().split(/\s+/).filter(C=>C!=="rx_queue"&&C!=="tm->when");return n.map(C=>C.trim().split(/\s+/).reduce((M,K,q)=>(M[h[q]||q]=K,M),{}))}e.loadConnectionTable=r;function l(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function s(i){const n=i.trim().split(`
`),h=[];return n.forEach(E=>{const C=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);C&&C.length>=4&&h.push({pid:parseInt(C[1],10),ppid:parseInt(C[2]),cmd:C[3]})}),h}e.getRootProcesses=s;async function a(i,n,h){const E=h.reduce((M,K)=>(M[K.pid]=K,M),{}),C=[];return i.forEach(({socket:M,ip:K,port:q})=>{const F=n[M]?n[M].pid:void 0,B=F?E[F]?.cmd:void 0;F&&B&&!l(B)&&C.push({host:K,port:q,detail:B,pid:F})}),C}e.findPorts=a;function o(i,n,h){const E=new Map,C=s(n);for(const M of i){const K=h.get(M.port);if(K){E.set(M.port,K);continue}const q=C.find(F=>F.cmd.includes(`${M.port}`));if(q){let F=q,B;do B=C.find(O=>O.ppid===F.pid),B&&(F=B);while(B);E.set(M.port,{host:M.ip,port:M.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else E.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=o;let u=class extends R.Disposable{constructor(n,h,E){super(),this.n=E,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new v.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=n.getProxy(c.MainContext.MainThreadTunnelService),w.isLinux&&h.remote.isRemote&&h.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(n,h){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const E=await this.a.$openTunnel(h,n.displayName);if(E){const C=new p(E.remoteAddress,E.localAddress,()=>this.a.$closeTunnel(E.remoteAddress));return this.B(C),C}}async getTunnels(){return this.a.$getTunnels()}p(n){return Math.max(n*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(n,h){const E=this.r();return this.l.set(E,{selector:n,provider:h}),this.a.$registerPortsAttributesProvider(n,E),new P.Disposable(()=>{this.l.delete(E),this.a.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(n,h,E,C,M){const K=[];for(const F of n){const B=this.l.get(F);if(!B)return[];K.push(...await Promise.all(h.map(async O=>B.provider.providePortAttributes(O,E,C,M))))}const q=K.filter(F=>!!F);return q.length>0?q.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(n){if(n&&this.h)return;this.h=n;const h=new d.MovingAverage;let E;for(;this.h;){const C=new Date().getTime(),M=(await this.findCandidatePorts()).filter(q=>(0,m.isLocalhost)(q.host)||(0,m.isAllInterfaces)(q.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(q=>q.port).join(", ")}`);const K=new Date().getTime()-C;h.update(K),(!E||JSON.stringify(E)!==JSON.stringify(M))&&(E=M,await this.a.$onFoundNewCandidates(E)),await new Promise(q=>setTimeout(()=>q(),this.p(h.value)))}}async setTunnelFactory(n){if(n){if(n.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this.c=n.showCandidatePort,this.a.$setCandidateFilter()),n.tunnelFactory){this.b=n.tunnelFactory;let h=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const E=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:h}:void 0;this.a.$setTunnelProvider(E)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(n,h){if(this.f.has(n.host)){const E=this.f.get(n.host);E.has(n.port)&&(h&&E.get(n.port).disposeListener.dispose(),await E.get(n.port).tunnel.dispose(),E.delete(n.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(n,h){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this.b(n,h);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const C=await E;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(n.remoteAddress.host)||this.f.set(n.remoteAddress.host,new Map);const M=this.B(C.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(C.remoteAddress))));return this.f.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:C,disposeListener:M}),I.TunnelDtoConverter.fromApiTunnel(C)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(n){const h=await Promise.all(n.map(C=>this.c(C.host,C.port,C.detail??""))),E=n.filter((C,M)=>h[M]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(C=>C.port).join(", ")} to ${E.map(C=>C.port).join(", ")}`),E}async findCandidatePorts(){let n="",h="";try{n=await L.Promises.readFile("/proc/net/tcp","utf8"),h=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const E=S(n,h),C=await new Promise(z=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,ue,V)=>{z(ue)})}),M=b(C),K=await L.Promises.readdir("/proc"),q=[];for(const z of K)try{const j=Number(z),ue=D.joinPath(A.URI.file("/proc"),z);if((await L.Promises.stat(ue.fsPath)).isDirectory()&&!isNaN(j)){const _=await L.Promises.readlink(D.joinPath(ue,"cwd").fsPath),J=await L.Promises.readFile(D.joinPath(ue,"cmdline").fsPath,"utf8");q.push({pid:j,cwd:_,cmd:J})}}catch{}const F=[],B=E.filter(z=>{const j=M[z.socket];return j||F.push(z),j}),O=a(B,M,q);let U;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const z=await new Promise(j=>{(0,y.exec)("ps -F -A -l | grep root",(ue,V,_)=>{j(V)})});this.j=o(F,z,this.j),U=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(j=>j.port).join(", ")}`)}return O.then(z=>U?z.concat(U):z)}};u=qe([We(0,t.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,f.ILogService)],u),e.ExtHostTunnelService=u}),define(ye[287],Ce([1,0,14,23,21,9,3,6,114,246,58]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function w(E,C){try{return JSON.stringify(E,C)}catch{return"null"}}const I="$$ref$$",v={[I]:-1};class m{constructor(C,M){this.jsonString=C,this.referencedBuffers=M}}function d(E,C=null,M=!1){const K=[];return{jsonString:(M?w:JSON.stringify)(E,(F,B)=>{if(typeof B>"u")return v;if(typeof B=="object"){if(B instanceof t.VSBuffer){const O=K.push(B)-1;return{[I]:O}}if(C)return C(F,B)}return B}),referencedBuffers:K}}e.stringifyJsonWithBufferRefs=d;function f(E,C,M){return JSON.parse(E,(K,q)=>{if(q){const F=q[I];if(typeof F=="number")return C[F];if(M&&q.$mid===1)return M.transformIncoming(q)}return q})}e.parseJsonAndRestoreBufferRefs=f;function p(E,C){return JSON.stringify(E,C)}function b(E){return E?(C,M)=>M&&M.$mid===1?E.transformOutgoing(M):M:null}var S;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},l=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class a extends A.Disposable{constructor(C,M=null,K=null){super(),this[P]=!0,this.b=this.B(new k.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=M,this.g=K,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let q=0,F=L.ProxyIdentifier.count;q<F;q++)this.k[q]=null,this.l[q]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new c.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(q=>this.G(q))}dispose(){this.j=!0,Object.keys(this.s).forEach(C=>{this.s[C].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(C){this.u===0&&(this.v=Date.now()+a.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(C){this.v=Date.now()+a.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(C){this.t!==C&&(this.t=C,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(C){return this.g?(0,y.transformIncomingURIs)(C,this.g):C}getProxy(C){const{nid:M,sid:K}=C;return this.l[M]||(this.l[M]=this.F(M,K)),this.l[M]}F(C,M){const K={get:(q,F)=>(typeof F=="string"&&!q[F]&&F.charCodeAt(0)===36&&(q[F]=(...B)=>this.O(C,F,B)),F===s?M:q[F])};return new Proxy(Object.create(null),K)}set(C,M){return this.k[C.nid]=M,M}assertRegistered(C){for(let M=0,K=C.length;M<K;M++){const q=C[M];if(!this.k[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}G(C){if(this.j)return;const M=C.byteLength,K=o.read(C,0),q=K.readUInt8(),F=K.readUInt32();switch(q){case 1:case 2:{let{rpcId:B,method:O,args:U}=i.deserializeRequestJSONArgs(K);this.g&&(U=(0,y.transformIncomingURIs)(U,this.g)),this.H(M,F,B,O,U,q===2);break}case 3:case 4:{let{rpcId:B,method:O,args:U}=i.deserializeRequestMixedArgs(K);this.g&&(U=(0,y.transformIncomingURIs)(U,this.g)),this.H(M,F,B,O,U,q===4);break}case 5:{this.f?.logIncoming(M,F,0,"ack"),this.z(F);break}case 6:{this.I(M,F);break}case 7:{this.J(M,F,void 0);break}case 9:{let B=i.deserializeReplyOKJSON(K);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.J(M,F,B);break}case 10:{const B=i.deserializeReplyOKJSONWithBuffers(K,this.g);this.J(M,F,B);break}case 8:{const B=i.deserializeReplyOKVSBuffer(K);this.J(M,F,B);break}case 11:{let B=i.deserializeReplyErrError(K);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.L(M,F,B);break}case 12:{this.L(M,F,void 0);break}default:console.error("received unexpected message"),console.error(C)}}H(C,M,K,q,F,B){this.f?.logIncoming(C,M,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(K)}.${q}(`,F);const O=String(M);let U,z;if(B){const ue=new T.CancellationTokenSource;F.push(ue.token),U=this.M(K,q,F),z=()=>ue.cancel()}else U=this.M(K,q,F),z=r;this.p[O]=z;const j=i.serializeAcknowledged(M);this.f?.logOutgoing(j.byteLength,M,1,"ack"),this.c.send(j),U.then(ue=>{delete this.p[O];const V=i.serializeReplyOK(M,ue,this.h);this.f?.logOutgoing(V.byteLength,M,1,"reply:",ue),this.c.send(V)},ue=>{delete this.p[O];const V=i.serializeReplyErr(M,ue);this.f?.logOutgoing(V.byteLength,M,1,"replyErr:",ue),this.c.send(V)})}I(C,M){this.f?.logIncoming(C,M,1,"receiveCancel");const K=String(M);this.p[K]?.()}J(C,M,K){this.f?.logIncoming(C,M,0,"receiveReply:",K);const q=String(M);if(!this.s.hasOwnProperty(q))return;const F=this.s[q];delete this.s[q],F.resolveOk(K)}L(C,M,K){this.f?.logIncoming(C,M,0,"receiveReplyErr:",K);const q=String(M);if(!this.s.hasOwnProperty(q))return;const F=this.s[q];delete this.s[q];let B;K&&(K.$isError?(B=new Error,B.name=K.name,B.message=K.message,B.stack=K.stack):B=K),F.resolveErr(B)}M(C,M,K){try{return Promise.resolve(this.N(C,M,K))}catch(q){return Promise.reject(q)}}N(C,M,K){const q=this.k[C];if(!q)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(C));const F=q[M];if(typeof F!="function")throw new Error("Unknown method "+M+" on actor "+(0,L.getStringIdentifierForProxy)(C));return F.apply(q,K)}O(C,M,K){if(this.j)return new D.CanceledLazyPromise;let q=null;if(K.length>0&&T.CancellationToken.isCancellationToken(K[K.length-1])&&(q=K.pop()),q&&q.isCancellationRequested)return Promise.reject(R.canceled());const F=i.serializeRequestArguments(K,this.h),B=++this.m,O=String(B),U=new D.LazyPromise;q&&q.onCancellationRequested(()=>{const j=i.serializeCancel(B);this.f?.logOutgoing(j.byteLength,B,0,"cancel"),this.c.send(i.serializeCancel(B))}),this.s[O]=U,this.y(B);const z=i.serializeRequest(B,C,M,F,!!q);return this.f?.logOutgoing(z.byteLength,B,0,`request: ${(0,L.getStringIdentifierForProxy)(C)}.${M}(`,K),this.c.send(z),U}}e.RPCProtocol=a,P=l,a.a=3*1e3;class o{static alloc(C,M,K){const q=new o(t.VSBuffer.alloc(K+1+4),0);return q.writeUInt8(C),q.writeUInt32(M),q}static read(C,M){return new o(C,M)}get buffer(){return this.a}constructor(C,M){this.a=C,this.b=M}static sizeUInt8(){return 1}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+C).toString();return this.b+=C,K}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+C).toString();return this.b+=C,K}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+C);return this.b+=C,M}static sizeMixedArray(C){let M=0;M+=1;for(let K=0,q=C.length;K<q;K++){const F=C[K];switch(M+=1,F.type){case 1:M+=this.sizeLongString(F.value);break;case 2:M+=this.sizeVSBuffer(F.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(F.value);for(let B=0;B<F.buffers.length;++B)M+=this.sizeVSBuffer(F.buffers[B]);break;case 4:break}}return M}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let M=0,K=C.length;M<K;M++){const q=C[M];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let F=0;F<q.buffers.length;++F)this.writeBuffer(q.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const M=new Array(C);for(let K=0;K<C;K++)switch(this.readUInt8()){case 1:M[K]=this.readLongString();break;case 2:M[K]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),B=this.readLongString(),O=[];for(let U=0;U<F;++U)O.push(this.readVSBuffer());M[K]=new L.SerializableObjectWithBuffers(f(B,O,null));break}case 4:M[K]=void 0;break}return M}}o.sizeUInt32=4;var u;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(u||(u={}));class i{static a(C){for(let M=0,K=C.length;M<K;M++)if(C[M]instanceof t.VSBuffer||C[M]instanceof L.SerializableObjectWithBuffers||typeof C[M]>"u")return!0;return!1}static serializeRequestArguments(C,M){if(this.a(C)){const K=[];for(let q=0,F=C.length;q<F;q++){const B=C[q];if(B instanceof t.VSBuffer)K[q]={type:2,value:B};else if(typeof B>"u")K[q]={type:4};else if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:U}=d(B.value,M);K[q]={type:3,value:t.VSBuffer.fromString(O),buffers:U}}else K[q]={type:1,value:t.VSBuffer.fromString(p(B,M))}}return{type:1,args:K}}return{type:0,args:p(C,M)}}static serializeRequest(C,M,K,q,F){switch(q.type){case 0:return this.b(C,M,K,q.args,F);case 1:return this.c(C,M,K,q.args,F)}}static b(C,M,K,q,F){const B=t.VSBuffer.fromString(K),O=t.VSBuffer.fromString(q);let U=0;U+=o.sizeUInt8(),U+=o.sizeShortString(B),U+=o.sizeLongString(O);const z=o.alloc(F?2:1,C,U);return z.writeUInt8(M),z.writeShortString(B),z.writeLongString(O),z.buffer}static deserializeRequestJSONArgs(C){const M=C.readUInt8(),K=C.readShortString(),q=C.readLongString();return{rpcId:M,method:K,args:JSON.parse(q)}}static c(C,M,K,q,F){const B=t.VSBuffer.fromString(K);let O=0;O+=o.sizeUInt8(),O+=o.sizeShortString(B),O+=o.sizeMixedArray(q);const U=o.alloc(F?4:3,C,O);return U.writeUInt8(M),U.writeShortString(B),U.writeMixedArray(q),U.buffer}static deserializeRequestMixedArgs(C){const M=C.readUInt8(),K=C.readShortString(),q=C.readMixedArray(),F=new Array(q.length);for(let B=0,O=q.length;B<O;B++){const U=q[B];typeof U=="string"?F[B]=JSON.parse(U):F[B]=U}return{rpcId:M,method:K,args:F}}static serializeAcknowledged(C){return o.alloc(5,C,0).buffer}static serializeCancel(C){return o.alloc(6,C,0).buffer}static serializeReplyOK(C,M,K){if(typeof M>"u")return this.d(C);if(M instanceof t.VSBuffer)return this.e(C,M);if(M instanceof L.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:F}=d(M.value,K,!0);return this.g(C,q,F)}else return this.f(C,w(M,K))}static d(C){return o.alloc(7,C,0).buffer}static e(C,M){let K=0;K+=o.sizeVSBuffer(M);const q=o.alloc(8,C,K);return q.writeVSBuffer(M),q.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,M){const K=t.VSBuffer.fromString(M);let q=0;q+=o.sizeLongString(K);const F=o.alloc(9,C,q);return F.writeLongString(K),F.buffer}static g(C,M,K){const q=t.VSBuffer.fromString(M);let F=0;F+=o.sizeUInt32,F+=o.sizeLongString(q);for(const O of K)F+=o.sizeVSBuffer(O);const B=o.alloc(10,C,F);B.writeUInt32(K.length),B.writeLongString(q);for(const O of K)B.writeBuffer(O);return B.buffer}static deserializeReplyOKJSON(C){const M=C.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(C,M){const K=C.readUInt32(),q=C.readLongString(),F=[];for(let B=0;B<K;++B)F.push(C.readVSBuffer());return new L.SerializableObjectWithBuffers(f(q,F,M))}static serializeReplyErr(C,M){const K=M?w(R.transformErrorForSerialization(M),null):void 0;if(typeof K!="string")return this.h(C);const q=t.VSBuffer.fromString(K);let F=0;F+=o.sizeLongString(q);const B=o.alloc(11,C,F);return B.writeLongString(q),B.buffer}static deserializeReplyErrError(C){const M=C.readLongString();return JSON.parse(M)}static h(C){return o.alloc(12,C,0).buffer}}var n;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(n||(n={}));var h;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(h||(h={}))}),define(ye[288],Ce([1,0,3,33,54,4,40,9,14]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new T.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new T.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new T.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(I){I[I.Append=1]="Append",I[I.Replace=2]="Replace",I[I.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.a=new Map,this.b=new c.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new c.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(m=>v.push(m)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}t.Registry.add(e.Extensions.OutputChannels,new L);function P(I,v,m,d,f){return(0,y.createCancelablePromise)(async p=>{await(0,k.whenProviderRegistered)(m,d);const b=t.Registry.as(e.Extensions.OutputChannels);try{await w(m,1,d,f,p),b.registerChannel({id:I,label:v,file:m,log:!0})}catch(S){(0,A.isCancellationError)(S)||f.error("Error while registering log channel",m.toString(),(0,A.getErrorMessage)(S))}})}e.registerLogChannel=P;async function w(I,v,m,d,f){if(!await m.exists(I)){if(f.isCancellationRequested)throw new A.CancellationError;if(v>10)throw new Error("Timed out while waiting for file to be created");d.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",I.toString()),await(0,y.timeout)(1e3,f),await w(I,v+1,m,d,f)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new T.RawContextKey("activeOutputChannel","")}),define(ye[142],Ce([1,0,5,4,18,27,13,288,75,25,48,157,23,10,40,3,6]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class f extends k.AbstractMessageLogger{get disposed(){return this.l}constructor(g,r,l,s,a){super(),this.id=g,this.name=r,this.m=l,this.n=s,this.extension=a,this.k=0,this.l=!1,this.visible=!1,this.setLevel(l.getLevel()),this.B(l.onDidChangeLogLevel(o=>this.setLevel(o)))}get logLevel(){return this.getLevel()}appendLine(g){this.append(g+`
`)}append(g){this.info(g)}clear(){const g=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,g)}replace(g){const r=this.k;this.info(g),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,r),this.visible&&this.m.flush()}show(g,r){this.m.flush(),this.n.$reveal(this.id,!!(typeof g=="boolean"?g:r))}hide(){this.n.$close(this.id)}g(g,r){this.k+=w.VSBuffer.fromString(r).byteLength,(0,k.log)(this.m,g,r),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class p extends f{appendLine(g){this.append(g)}}let b=class{constructor(g,r,l,s,a,o){this.i=r,this.j=l,this.k=s,this.l=a,this.m=o,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=g.getProxy(c.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.h=g;for(const[r,l]of this.g)l.visible=r===this.h}createOutputChannel(g,r,l){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const s=typeof r=="object"&&r.log,a=(0,I.isString)(r)?r:void 0;if((0,I.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let o;const u=this.i.environment.extensionLogLevel?.find(([n])=>R.ExtensionIdentifier.equals(l.identifier,n))?.[1];u&&(o=(0,k.parseLogLevel)(u));const i=s?this.o(g,o,l):this.n(g,a,l);return i.then(n=>{this.g.set(n.id,n),n.visible=n.id===this.h}),s?this.r(g,o??this.m.getLevel(),i):this.q(g,i)}async n(g,r,l){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,a=this.k.extUri.joinPath(s,`${this.f++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(a,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.a.$register(g,a,!1,r,l.identifier.value);return new f(u,g,o,this.a,l)}async o(g,r,l){const s=await this.p(l),a=this.k.extUri.joinPath(s,`${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(a,{name:g},r),u=await this.a.$register(g,a,!0,void 0,l.identifier.value);return new p(u,g,o,this.a,l)}p(g){let r=this.d.get(g.identifier.value);if(!r){const l=this.k.extUri.joinPath(this.i.logsLocation,g.identifier.value);this.d.set(g.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(l)}catch(s){if((0,v.toFileSystemProviderErrorCode)(s)!==v.FileSystemProviderErrorCode.FileExists)throw s}return l})())}return r}q(g,r){let l=!1;const s=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return g},append(a){s(),r.then(o=>o.append(a))},appendLine(a){s(),r.then(o=>o.appendLine(a))},clear(){s(),r.then(a=>a.clear())},replace(a){s(),r.then(o=>o.replace(a))},show(a,o){s(),r.then(u=>u.show(a,o))},hide(){s(),r.then(a=>a.hide())},dispose(){l=!0,r.then(a=>a.dispose())}}}r(g,r,l){const s=new d.DisposableStore,a=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},o=s.add(new m.Emitter);return l.then(u=>{s.add(u),s.add(u.onDidChangeLogLevel(i=>{r=i,o.fire(i)}))}),{...this.q(g,l),get logLevel(){return r},onDidChangeLogLevel:o.event,trace(u,...i){a(),l.then(n=>n.trace(u,...i))},debug(u,...i){a(),l.then(n=>n.debug(u,...i))},info(u,...i){a(),l.then(n=>n.info(u,...i))},warn(u,...i){a(),l.then(n=>n.warn(u,...i))},error(u,...i){a(),l.then(n=>n.error(u,...i))},dispose(){s.dispose()}}}};b=qe([We(0,T.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,y.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,k.ILoggerService),We(5,k.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(ye[289],Ce([1,0,4]),function(te,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(ye[290],Ce([1,0,32,17,11,12,24,2,4,215,47,233,289]),function(te,e,c,t,T,R,k,A,y,D,L,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let I=class oi{constructor(m,d,f,p){this.d=m,this.e=d,this.f=f,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??m})()}hasValidBasename(m,d,f){return typeof d=="string"||typeof d>"u"?this.a.then(p=>this.h(m,p,d)):this.h(m,d,f)}h(m,d,f){return m.scheme===t.Schemas.file||m.scheme===t.Schemas.vscodeRemote?(0,c.isValidBasename)(f??(0,k.basename)(m),d===1):!0}get defaultUriScheme(){return oi.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,d){if(m.remoteAuthority)return t.Schemas.vscodeRemote;const f=(0,D.getVirtualWorkspaceScheme)(d.getWorkspace());if(f)return f;const p=d.getWorkspace().folders[0];if(p)return p.uri.scheme;const b=d.getWorkspace().configuration;return b?b.scheme:t.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?T.win32:T.posix)}async fileURI(m){let d="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const p=m.indexOf("/",2);p===-1?(d=m.substring(2),m="/"):(d=m.substring(2,p),m=m.substring(p)||"/")}return A.URI.from({scheme:t.Schemas.file,authority:d,path:m,query:"",fragment:""})}};I=qe([We(1,w.IRemoteAgentService),We(2,P.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(ye[78],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(k,A){this.line=k,this.character=A}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,A){return new c(0,0)}with(k){return new c(0,0)}}e.Position=c;class t{constructor(k,A,y,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(k,A),this.end=new c(y,D)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new t(0,0,0,0)}with(k){return new t(0,0,0,0)}}e.Range=t;var T;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(T=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],Ce([1,0,16,39,22,32,8,4,11,9,78,14]),function(te,e,c,t,T,R,k,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const w="\u27EA ",I=" characters skipped \u27EB",v=(w.length+I.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var m;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function f(J){return!!J.preview}e.resultIsMatch=f;function p(J){return!!J.resource}e.isFileMatch=p;function b(J){return!!J.message}e.isProgressMessage=b;var S;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(S=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(ne){this.resource=ne,this.results=[]}}e.FileMatch=g;class r{constructor(ne,ee,X){this.ranges=ee;const G=Array.isArray(ee)?ee:[ee];if(X&&X.matchLines===1&&l(G)){ne=(0,k.getNLines)(ne,X.matchLines);let de="",be=0,Ee=0;const Pe=Math.floor(X.charsPerLine/5),Fe=[];for(const se of G){const oe=Math.max(se.startColumn-Pe,0),fe=se.startColumn+X.charsPerLine;if(oe>Ee+Pe+v){const Z=w+(oe-Ee)+I;de+=Z+ne.slice(oe,fe),be+=oe-(Ee+Z.length)}else de+=ne.slice(Ee,fe);Fe.push(new a(0,se.startColumn-be,se.endColumn-be)),Ee=fe}this.preview={text:de,matches:Array.isArray(this.ranges)?Fe:Fe[0]}}else{const de=Array.isArray(ee)?ee[0].startLineNumber:ee.startLineNumber;this.preview={text:ne,matches:(0,c.mapArrayOrNot)(ee,be=>new s(be.startLineNumber-de,be.startColumn,be.endLineNumber-de,be.endColumn))}}}}e.TextSearchMatch=r;function l(J){const ne=J[0].startLineNumber;for(const ee of J)if(ee.startLineNumber!==ne||ee.endLineNumber!==ne)return!1;return!0}class s{constructor(ne,ee,X,G){this.startLineNumber=ne,this.startColumn=ee,this.endLineNumber=X,this.endColumn=G}}e.SearchRange=s;class a extends s{constructor(ne,ee,X){super(ne,ee,ne,X)}}e.OneLineRange=a;var o;(function(J){J.List="list",J.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var u;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function i(J,ne=!0){const ee=J&&J.files&&J.files.exclude,X=ne&&J&&J.search&&J.search.exclude;if(!ee&&!X)return;if(!ee||!X)return ee||X;let G=Object.create(null);return G=T.mixin(G,T.deepClone(ee)),G=T.mixin(G,T.deepClone(X),!0),G}e.getExcludes=i;function n(J,ne){return J.excludePattern&&t.match(J.excludePattern,ne)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&t.match(J.includePattern,ne)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ee=>{const X=ee.folder.fsPath;if(R.isEqualOrParent(ne,X)){const G=y.relative(X,ne);return!ee.includePattern||!!t.match(ee.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=n;var h;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(ne,ee){super(ne),this.code=ee}}e.SearchError=E;function C(J){const ne=J.message;if((0,D.isCancellationError)(J))return new E(ne,h.canceled);try{const ee=JSON.parse(ne);return new E(ee.message,ee.code)}catch{return new E(ne,h.other)}}e.deserializeSearchError=C;function M(J){const ne={message:J.message,code:J.code};return new Error(JSON.stringify(ne))}e.serializeSearchError=M;function K(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=K;function q(J){return J.type==="success"}e.isSerializedSearchSuccess=q;function F(J){return!!J.path}e.isSerializedFileMatch=F;function B(J,ne){const ee=J.searchPath?J.searchPath:J.relativePath;return(0,k.fuzzyContains)(ee,ne)}e.isFilePatternMatch=B;class O{constructor(ne){this.path=ne,this.results=[]}addMatch(ne){this.results.push(ne)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function U(J,ne){const ee={...J||{},...ne||{}};return Object.keys(ee).filter(X=>{const G=ee[X];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=U;class z{constructor(ne,ee){this.c=null,this.a={...ne.excludePattern||{},...ee.excludePattern||{}},this.b=t.parse(this.a);let X=ne.includePattern;ee.includePattern&&(X?X={...X,...ee.includePattern}:X=ee.includePattern),X&&(this.c=t.parse(X))}matchesExcludesSync(ne,ee,X){return!!(this.b&&this.b(ne,ee,X))}includedInQuerySync(ne,ee,X){return!(this.b&&this.b(ne,ee,X)||this.c&&!this.c(ne,ee,X))}includedInQuery(ne,ee,X){const G=this.b(ne,ee,X),de=()=>this.c?!!this.c(ne,ee,X):!0;return(0,P.isThenable)(G)?G.then(be=>be?!1:de()):de()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=z;function j(J){for(const ne in J)if(typeof J[ne]!="boolean")return!0;return!1}function ue(J){if(!J)return;let ne;return ee=>(ne||(ne=(J()||Promise.resolve([])).then(X=>X?_(X):{})),ne.then(X=>!!X[ee]))}e.hasSiblingPromiseFn=ue;function V(J){if(!J)return;let ne;return ee=>{if(!ne){const X=J();ne=X?_(X):{}}return!!ne[ee]}}e.hasSiblingFn=V;function _(J){const ne={};for(const ee of J)ne[ee]=!0;return ne}}),define(ye[34],Ce([1,0,16,14,21,3,6,66,17,102,24,8,10,2,182,4,13,203,47,48,25,18,15,7,56,31,5]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p,b,S,g,r,l,s,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(q,F,B){return new L.ExtUri(O=>E(O,B)).isEqual(q,F)}function i(q,F,B){return u(q.uri,F.uri,B)?0:(0,P.compare)(q.uri.toString(),F.uri.toString())}function n(q,F,B){return q.index!==F.index?q.index<F.index?-1:1:u(q.uri,F.uri,B)?(0,P.compare)(q.name,F.name):(0,P.compare)(q.uri.toString(),F.uri.toString())}function h(q,F,B,O){const U=q.slice(0).sort((j,ue)=>B(j,ue,O)),z=F.slice(0).sort((j,ue)=>B(j,ue,O));return(0,c.delta)(U,z,(j,ue)=>B(j,ue,O))}function E(q,F){const B=F.getCapabilities(q.scheme);return!(B&&B&1024)}class C extends p.Workspace{static toExtHostWorkspace(F,B,O,U){if(!F)return{workspace:null,added:[],removed:[]};const{id:z,name:j,folders:ue,configuration:V,transient:_,isUntitled:J}=F,ne=[],ee=B;B?ue.forEach((be,Ee)=>{const Pe=I.URI.revive(be.uri),Fe=C.e(O||B,Pe,U);Fe?(Fe.name=be.name,Fe.index=be.index,ne.push(Fe)):ne.push({uri:Pe,name:be.name,index:Ee})}):ne.push(...ue.map(({uri:be,name:Ee,index:Pe})=>({uri:I.URI.revive(be),name:Ee,index:Pe}))),ne.sort((be,Ee)=>be.index<Ee.index?-1:1);const X=new C(z,j,ne,!!_,V?I.URI.revive(V):null,!!J,be=>E(be,U)),{added:G,removed:de}=h(ee?ee.workspaceFolders:[],X.workspaceFolders,i,U);return{workspace:X,added:G,removed:de}}static e(F,B,O){for(let U=0;U<F.folders.length;U++){const z=F.workspaceFolders[U];if(u(z.uri,B,O))return z}}constructor(F,B,O,U,z,j,ue){super(F,O.map(V=>new p.WorkspaceFolder(V)),U,z,ue),this.s=B,this.t=j,this.o=[],this.q=A.TernarySearchTree.forUris(ue),O.forEach(V=>{this.o.push(V),this.q.set(V.uri,V)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(F,B){return B&&this.q.get(F)&&(F=(0,L.dirname)(F)),this.q.findSubstr(F)}resolveWorkspaceFolder(F){return this.q.get(F)}}let M=class{constructor(F,B,O,U,z){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new R.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=U,this.q=O,this.s=z,this.h=new D.Counter,this.j=new t.Barrier,this.n=F.getProxy(o.MainContext.MainThreadWorkspace),this.o=F.getProxy(o.MainContext.MainThreadMessageService);const j=B.workspace;this.k=j?new C(j.id,j.name,[],!!j.transient,j.configuration?I.URI.revive(j.configuration):null,!!j.isUntitled,ue=>E(ue,O)):void 0}$initializeWorkspace(F,B){this.u=B,this.$acceptWorkspaceData(F),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?I.URI.from({scheme:y.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(F,B,O,...U){const z=[];if(Array.isArray(U)&&U.forEach(J=>{I.URI.isUri(J.uri)&&!z.some(ne=>u(ne.uri,J.uri,this.q))&&z.push({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri)})}),this.l||[B,O].some(J=>typeof J!="number"||J<0)||O===0&&z.length===0)return!1;const j=this.w?this.w.workspaceFolders:[];if(B+O>j.length)return!1;const ue=j.slice(0);ue.splice(B,O,...z.map(J=>({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<ue.length;J++){const ne=ue[J];if(ue.some((ee,X)=>X!==J&&u(ne.uri,ee.uri,this.q)))return!1}ue.forEach((J,ne)=>J.index=ne);const{added:V,removed:_}=h(j,ue,n,this.q);if(V.length===0&&_.length===0)return!1;if(this.n){const J=F.displayName||F.name;this.n.$updateWorkspaceFolders(J,B,O,z).then(void 0,ne=>{this.l=void 0;const ee={source:{identifier:F.identifier,label:F.displayName||F.name}};this.o.$showMessage(f.Severity.Error,(0,v.localize)(0,null,J,ne.toString()),ee,[])})}return this.x(ue),!0}getWorkspaceFolder(F,B){if(!!this.w)return this.w.getWorkspaceFolder(F,B)}async getWorkspaceFolder2(F,B){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(F,B)}async resolveWorkspaceFolder(F){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(F)}getPath(){if(!this.w)return;const{folders:F}=this.w;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,B){let O,U="";if(typeof F=="string"?(O=I.URI.file(F),U=F):typeof F<"u"&&(O=F,U=F.fsPath),!O)return U;const z=this.getWorkspaceFolder(O,!0);if(!z)return U;typeof B>"u"&&this.w&&(B=this.w.folders.length>1);let j=(0,L.relativePath)(z.uri,O);return B&&z.name&&(j=`${z.name}/${j}`),j}x(F){this.w&&(this.l=C.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:F,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:B,added:O,removed:U}=C.toExtHostWorkspace(F,this.k,this.l,this.q);this.k=B||void 0,this.l=void 0,this.c.fire(Object.freeze({added:O,removed:U}))}findFiles(F,B,O,U,z=T.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let j;if(B===null?j=!1:B&&(typeof B=="string"?j=B:j=B.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:ue,folder:V}=K(r.GlobPattern.from(F));return this.n.$startFileSearch((0,w.withUndefinedAsNull)(ue),(0,w.withUndefinedAsNull)(V),(0,w.withUndefinedAsNull)(j),(0,w.withUndefinedAsNull)(O),z).then(_=>Array.isArray(_)?_.map(J=>I.URI.revive(J)):[])}async findTextInFiles(F,B,O,U,z=T.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const j=this.h.getNext(),ue=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:V,folder:_}=K(r.GlobPattern.from(B.include)),J=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ne={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:ue,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:V,excludePattern:J},ee=!1;if(this.t[j]=X=>{if(ee)return;const G=I.URI.revive(X.resource);X.results.forEach(de=>{(0,a.resultIsMatch)(de)?O({uri:G,preview:{text:de.preview.text,matches:(0,c.mapArrayOrNot)(de.preview.matches,be=>new l.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,c.mapArrayOrNot)(de.ranges,be=>new l.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):O({uri:G,text:de.text,lineNumber:de.lineNumber})})},z.isCancellationRequested)return{};try{const X=await this.n.$startTextSearch(F,(0,w.withUndefinedAsNull)(_),ne,j,z);return delete this.t[j],X||{}}catch(X){throw delete this.t[j],X}}$handleTextSearchResult(F,B){this.t[B]?.(F)}saveAll(F){return this.n.$saveAll(F)}resolveProxy(F){return this.n.$resolveProxy(F)}get trusted(){return this.u}requestWorkspaceTrust(F){return this.n.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(F,B){if(this.v.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.v.set(F,B);const O=this.s.transformOutgoingScheme(F),U=this.y++;return this.n.$registerEditSessionIdentityProvider(U,O),(0,k.toDisposable)(()=>{this.v.delete(F),this.n.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(F,B){this.g.info("Getting edit session identifier for workspaceFolder",F);const O=await this.resolveWorkspaceFolder(I.URI.revive(F));if(!O){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const U=this.v.get(O.uri.scheme);if(this.g.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!U),!U)return;const z=await U.provideEditSessionIdentity(O,B);if(this.g.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(F,B,O,U){this.g.info("Getting edit session identifier for workspaceFolder",F);const z=await this.resolveWorkspaceFolder(I.URI.revive(F));if(!z){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const j=this.v.get(z.uri.scheme);if(this.g.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!j),!j)return;const ue=await j.provideEditSessionIdentityMatch?.(B,O,U);if(this.g.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}};M=qe([We(0,g.IExtHostRpcService),We(1,S.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,d.ILogService),We(4,s.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,m.createDecorator)("IExtHostWorkspace");function K(q){let F,B;return q&&(typeof q=="string"?F=q:(F=q.pattern,B=I.URI.revive(q.baseUri))),{includePattern:F,folder:B}}}),define(ye[35],Ce([1,0,22,3,34,5,7,206,127,10,14,4,18,13,2]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(l,s){if(s){const a=s.split(".");let o=l;for(let u=0;o&&u<a.length;u++)o=o[a[u]];return o}}function d(l){return l instanceof v.URI}function f(l){return l&&l.uri instanceof v.URI&&l.languageId&&typeof l.languageId=="string"}function p(l){return l&&!l.uri&&l.languageId&&typeof l.languageId=="string"}function b(l){return l&&l.uri instanceof v.URI&&(!l.name||typeof l.name=="string")&&(!l.index||typeof l.index=="number")}function S(l){if(d(l))return{resource:l};if(f(l))return{resource:l.uri,overrideIdentifier:l.languageId};if(p(l))return{overrideIdentifier:l.languageId};if(b(l))return{resource:l.uri};if(l===null)return{resource:null}}let g=class{constructor(s,a,o){this.a=s.getProxy(R.MainContext.MainThreadConfiguration),this.c=a,this.b=o,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new r(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,a){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,a))}};g=qe([We(0,w.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,I.ILogService)],g),e.ExtHostConfiguration=g;class r{constructor(s,a,o,u){this.a=new t.Emitter,this.b=s,this.f=u,this.c=a,this.e=A.Configuration.parse(o),this.d=this.k(o.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,a){const o={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(a,o))}getConfiguration(s,a,o){const u=S(a)||{},i=this.g(s?m(this.e.getValue(void 0,u,this.c.workspace),s):this.e.getValue(void 0,u,this.c.workspace));s&&this.h(s,u,o?.identifier);function n(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case k.ConfigurationTarget.Global:return 2;case k.ConfigurationTarget.Workspace:return 5;case k.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(E){return typeof m(i,E)<"u"},get:(E,C)=>{this.h(s?`${s}.${E}`:E,u,o?.identifier);let M=m(i,E);if(typeof M>"u")M=C;else{let K;const q=(F,B)=>{let O;const U=()=>{K=K||(0,c.deepClone)(i),O=O||m(K,B)};return(0,D.isObject)(F)?new Proxy(F,{get:(z,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return U(),()=>O;if(K)return O=O||m(K,B),O[j];const ue=z[j];return typeof j=="string"?q(ue,`${B}.${j}`):ue},set:(z,j,ue)=>(U(),O&&(O[j]=ue),!0),deleteProperty:(z,j)=>(U(),O&&delete O[j],!0),defineProperty:(z,j,ue)=>(U(),O&&Object.defineProperty(O,j,ue),!0)}):F};M=q(M,E)}return M},update:(E,C,M,K)=>{E=s?`${s}.${E}`:E;const q=n(M);return C!==void 0?this.b.$updateConfigurationOption(q,E,C,u,K):this.b.$removeConfigurationOption(q,E,u,K)},inspect:E=>{E=s?`${s}.${E}`:E;const C=this.e.inspect(E,u,this.c.workspace);if(C)return{key:E,defaultValue:(0,c.deepClone)(C.policy?.value??C.default?.value),globalValue:(0,c.deepClone)(C.user?.value??C.application?.value),workspaceValue:(0,c.deepClone)(C.workspace?.value),workspaceFolderValue:(0,c.deepClone)(C.workspaceFolder?.value),defaultLanguageValue:(0,c.deepClone)(C.default?.override),globalLanguageValue:(0,c.deepClone)(C.user?.override??C.application?.override),workspaceLanguageValue:(0,c.deepClone)(C.workspace?.override),workspaceFolderLanguageValue:(0,c.deepClone)(C.workspaceFolder?.override),languageIds:(0,c.deepClone)(C.overrideIdentifiers)}}};return typeof i=="object"&&(0,c.mixin)(h,i,!1),Object.freeze(h)}g(s){const a=o=>(0,D.isObject)(o)?new Proxy(o,{get:(u,i)=>a(u[i]),set:(u,i,n)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(i)}' of object`)},deleteProperty:(u,i)=>{throw new Error(`TypeError: Cannot delete read only property '${String(i)}' of object`)},defineProperty:(u,i)=>{throw new Error(`TypeError: Cannot define property '${String(i)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return a(s)}h(s,a,o){const u=y.OVERRIDE_PROPERTY_REGEX.test(s)?4:this.d.get(s),i=o?`[${o.value}] `:"";if(u===4){typeof a?.resource>"u"&&this.f.warn(`${i}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){a?.resource&&this.f.warn(`${i}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,a){const o=new A.ConfigurationChangeEvent(s,a,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(u,i)=>o.affectsConfiguration(u,S(i))})}k(s){return s.reduce((a,o)=>(a.set(o[0],o[1]),a),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,c):T?T.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[79],Ce([1,0,2,14,3,5,7,34,59,35,21,42,18,25,4,17,12,13,74,245,9]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p,b,S){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var r;(function(F){function B(U){if(U!=null)return U}F.from=B;function O(U){if(U!=null)return U}F.to=O})(r||(r={}));var l;(function(F){function B(U){if(U!=null)return U}F.from=B;function O(U){if(U!=null)return U}F.to=O})(l||(l={}));var s;(function(F){function B(U){if(U!=null)return U}F.from=B;function O(U){if(U!=null)return U}F.to=O})(s||(s={}));var a;(function(F){function B(z){if(z){const j=z;return j&&!!j.process}else return!1}F.is=B;function O(z){if(z==null)return;const j={process:z.process,args:z.args};return z.options&&(j.options=s.from(z.options)),j}F.from=O;function U(z){if(z!=null)return new k.ProcessExecution(z.process,z.args,z.options)}F.to=U})(a||(a={}));var o;(function(F){function B(U){if(U!=null)return U}F.from=B;function O(U){if(U!=null)return U}F.to=O})(o||(o={}));var u;(function(F){function B(z){if(z){const j=z;return j&&(!!j.commandLine||!!j.command)}else return!1}F.is=B;function O(z){if(z==null)return;const j={};return z.commandLine!==void 0?j.commandLine=z.commandLine:(j.command=z.command,j.args=z.args),z.options&&(j.options=o.from(z.options)),j}F.from=O;function U(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new k.ShellExecution(z.commandLine,z.options):new k.ShellExecution(z.command,z.args?z.args:[],z.options)}F.to=U})(u||(u={}));var i;(function(F){function B(z){if(z){const j=z;return j&&j.customExecution==="customExecution"}else return!1}F.is=B;function O(z){return{customExecution:"customExecution"}}F.from=O;function U(z,j){return j.get(z)}F.to=U})(i=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var n;(function(F){function B(O,U){let z;return O.scope!==void 0&&typeof O.scope!="number"?z=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===k.TaskScope.Workspace&&U&&U.workspaceFile?z=U.workspaceFile:z=b.USER_TASKS_GROUP_KEY),{id:O._id,workspaceFolder:z}}F.from=B})(n=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(F){function B(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}F.from=B})(h||(h={}));var E;(function(F){function B(z,j){if(z==null)return[];const ue=[];for(const V of z){const _=O(V,j);_&&ue.push(_)}return ue}F.fromMany=B;function O(z,j){if(z==null)return;let ue;z.execution instanceof k.ProcessExecution?ue=a.from(z.execution):z.execution instanceof k.ShellExecution?ue=u.from(z.execution):z.execution&&z.execution instanceof k.CustomExecution&&(ue=i.from(z.execution));const V=r.from(z.definition);let _;return z.scope?typeof z.scope=="number"?_=z.scope:_=z.scope.uri:_=k.TaskScope.Workspace,!V||!_?void 0:{_id:z._id,definition:V,name:z.name,source:{extensionId:j.identifier.value,label:z.source,scope:_},execution:ue,isBackground:z.isBackground,group:h.from(z.group),presentationOptions:l.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}F.from=O;async function U(z,j,ue){if(z==null)return;let V;a.is(z.execution)?V=a.to(z.execution):u.is(z.execution)?V=u.to(z.execution):i.is(z.execution)&&(V=i.to(z._id,ue));const _=r.to(z.definition);let J;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?J=z.source.scope:J=await j.resolveWorkspaceFolder(c.URI.revive(z.source.scope)):J=k.TaskScope.Workspace),!_||!J)return;const ne=new k.Task(_,J,z.name,z.source.label,V,z.problemMatchers);return z.isBackground!==void 0&&(ne.isBackground=z.isBackground),z.group!==void 0&&(ne.group=k.TaskGroup.from(z.group._id),ne.group&&z.group.isDefault&&(ne.group=new k.TaskGroup(ne.group.id,ne.group.label),z.group.isDefault===!0&&(ne.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ne.presentationOptions=l.to(z.presentationOptions)),z._id&&(ne._id=z._id),z.detail&&(ne.detail=z.detail),ne}F.to=U})(E=e.TaskDTO||(e.TaskDTO={}));var C;(function(F){function B(U){return U}F.from=B;function O(U){if(!!U)return Object.assign(Object.create(null),U)}F.to=O})(C||(C={}));class M{constructor(B,O,U){this._id=O,this.a=U,g.set(this,void 0),Je(this,g,B,"f")}get task(){return this.a}terminate(){Ue(this,g,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}g=new WeakMap;let K=class{constructor(B,O,U,z,j,ue,V,_){this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.t=new T.Emitter,this.a=B.getProxy(R.MainContext.MainThreadTask),this.b=U,this.c=z,this.d=j,this.e=ue,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=V,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,O,U){if(!U)return new k.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:O,provider:U,extension:B}),this.a.$registerTaskProvider(z,O),new k.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(B,O){this.a.$registerTaskSystem(B,O)}fetchTasks(B){return this.a.$fetchTasks(C.from(B)).then(async O=>{const U=[];for(const z of O){const j=await E.to(z,this.b,this.m);j&&U.push(j)}return U})}get taskExecutions(){const B=[];return this.k.forEach(O=>B.push(O)),B}terminateTask(B){if(!(B instanceof M))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,O,U){const z=this.m.get(B.id);z&&(this.o.set(B.id,z),this.e.attachPtyToTerminal(O,await z.callback(U))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const O=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const O=await this.y(B.id);this.s.fire({execution:O,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const O=await this.y(B.id);this.t.fire({execution:O,exitCode:B.exitCode})}$provideTasks(B,O){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));const z=[],j=(0,t.asPromise)(()=>U.provider.provideTasks(L.CancellationToken.None)).then(ue=>this.u(O,z,U,ue));return new Promise(ue=>{j.then(V=>{Promise.all(z).then(()=>{ue(V)})})})}async $resolveTask(B,O){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));if(O.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${U.type}].`);const z=await E.to(O,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const j=await U.provider.resolveTask(z,L.CancellationToken.None);if(!j)return;this.z(j,U);const ue=E.from(j,U.extension);if(!ue)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return i.is(ue.execution)&&await this.x(ue,j,!0),await this.v(ue)}w(){return this.h++}async x(B,O,U){const z=await this.a.$createTaskId(B);!U&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,O.execution)),this.m.set(z,O.execution)}async y(B,O){if(typeof B=="string"){const j=this.l.get(B);if(!j)throw new S.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const U=this.l.get(B.id);if(U)return U;const z=new Promise((j,ue)=>{function V(_,J,ne){ne?j(new M(_,J.id,ne)):ue("Unexpected: Task does not exist.")}O?V(this,B,O):E.to(B.task,this.b,this.m).then(_=>V(this,B,_))});return this.l.set(B.id,z),z.then(j=>(this.k.set(B.id,j),j),j=>Promise.reject(j))}z(B,O){B._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const U=this.n.values();let z=U.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=U.next()}};K=qe([We(0,w.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,f.ILogService),We(7,p.IExtHostApiDeprecationService)],K),e.ExtHostTaskBase=K;let q=class extends K{constructor(B,O,U,z,j,ue,V,_){super(B,O,U,z,j,ue,V,_),this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(B,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const U=E.from(O,B);if(U===void 0)throw new Error("Task is not valid");if(i.is(U.execution))await this.x(U,O,!1);else throw new S.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution(U),O);return this.a.$executeTask(U).catch(j=>{throw new Error(j)}),z}u(B,O,U,z){const j=[];if(z)for(const ue of z){this.z(ue,U),(!ue.definition||!B[ue.definition.type])&&this.f.warn(`The task [${ue.source}, ${ue.name}] uses an undefined task type. The task will be ignored in the future.`);const V=E.from(ue,U.extension);V&&i.is(V.execution)?(j.push(V),O.push(this.x(V,ue,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:U.extension}}async v(B){if(i.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,O,U){}};q=qe([We(0,w.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,f.ILogService),We(7,p.IExtHostApiDeprecationService)],q),e.WorkerExtHostTask=q,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(ye[291],Ce([1,0,11,21,45,39,24,44,31]),function(te,e,c,t,T,R,k,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(w,I,v){this.k=w,this.l=I,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=w.filePattern,this.b=w.includePattern&&R.parse(w.includePattern),this.c=w.maxResults||void 0,this.d=w.exists,this.h=new Set,this.j=w.excludePattern&&R.parse(w.excludePattern)}cancel(){this.g=!0,this.h.forEach(w=>w.cancel()),this.h=new Set}search(w){const I=this.k.folderQueries||[];return new Promise((v,m)=>{const d=f=>{this.f++,w(f)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(f=>{const p=f.toString(),b=c.basename(p);this.j&&this.j(p,b)||this.v(d,{base:f,basename:b})}),Promise.all(I.map(f=>this.p(f,d))).then(f=>{v({limitHit:this.e,stats:f[0]||void 0})},f=>{m(new Error((0,T.toErrorMessage)(f)))})})}async p(w,I){const v=new t.CancellationTokenSource,m=this.q(w),d=this.r(),f=new y.QueryGlobTester(this.k,w),p=!f.hasSiblingExcludeClauses();let b;try{this.h.add(v),b=A.StopWatch.create();const S=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},m,v.token),g=b.elapsed(),r=A.StopWatch.create();return this.g&&!this.e||(S&&S.forEach(l=>{const s=c.posix.relative(w.folder.path,l.path);if(p){const a=c.basename(l.path);this.v(I,{base:w.folder,relativePath:s,basename:a});return}this.s(d,w.folder,s,I)}),this.g&&!this.e)?null:(this.u(d,f,I),{providerTime:g,postProcessTime:r.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(w){const I=(0,y.resolvePatternsForProvider)(this.k.includePattern,w.includePattern),v=(0,y.resolvePatternsForProvider)(this.k.excludePattern,w.excludePattern);return{folder:w.folder,excludes:v,includes:I,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}s({pathToEntries:w},I,v,m){if(v===this.a){const f=c.basename(this.a);this.v(m,{base:I,relativePath:this.a,basename:f})}function d(f){const p=c.basename(f),b=c.dirname(f);let S=w[b];S||(S=w[b]=[],d(b)),S.push({base:I,relativePath:f,basename:p})}d(v)}u({rootEntries:w,pathToEntries:I},v,m){const d=this,f=this.a;function p(b){const S=(0,y.hasSiblingFn)(()=>b.map(g=>g.basename));for(let g=0,r=b.length;g<r;g++){const l=b[g],{relativePath:s,basename:a}=l;if(v.matchesExcludesSync(s,a,f!==a?S:void 0))continue;const o=I[s];if(o)p(o);else{if(s===f)continue;d.v(m,l)}if(d.e)break}}p(w)}v(w,I){(!this.b||I.relativePath&&this.b(I.relativePath,I.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||w(I))}}class L{constructor(){this.b=new Map}fileSearch(w,I,v,m){const d=this.c(w.cacheKey),f=new D(w,I,d&&d.token);let p=0;const b=S=>{p+=S.length,v(S.map(g=>this.d(g)))};return this.e(f,L.a,b,m).then(S=>({limitHit:S.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:S.stats}}))}clearCache(w){this.c(w)?.cancel()}c(w){if(!!w)return this.b.has(w)||this.b.set(w,new t.CancellationTokenSource),this.b.get(w)}d(w){return w.relativePath?{resource:k.joinPath(w.base,w.relativePath)}:{resource:w.base}}e(w,I,v,m){m.onCancellationRequested(()=>{w.cancel()});const d=p=>{p&&(f.push(p),I>0&&f.length>=I&&(v(f),f=[]))};let f=[];return w.search(d).then(p=>(f.length&&v(f),p),p=>(f.length&&v(f),Promise.reject(p)))}}e.FileSearchManager=L,L.a=512}),define(ye[292],Ce([1,0,16,61,39,113,28,17,11,24,8,10,2,165,194,53,13,47,133,290,31]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(h,E,C,M,K){this.a=h,this.b=E,this.c=C,this.d=M,this.e=K}text(h,E,C={}){h=this.f(h,C);const M=this.a.getValue(),K=E&&E.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(E?.map(f.toWorkspaceFolder),C),type:2,contentPattern:h,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:M.search.usePCRE2||K||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(h,E){const C=this.a.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const M={...h,wordSeparators:C.editor.wordSeparators};return this.j(h,E)&&(M.isCaseSensitive=!0),this.k(h)&&(M.isMultiline=!0),M}file(h,E={}){return{...this.h(h,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(h,E){return h?(h=Array.isArray(h)?h.map(o):o(h),E?this.parseSearchPaths(h):{pattern:l(...Array.isArray(h)?h:[h])}):{}}h(h=[],E={}){const C=this.g(E.includePattern,E.expandPatterns),M=this.g(E.excludePattern,E.expandPatterns),K=h.length>1,q=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(O=>this.q(O,E,M)):h.map(O=>this.r(O,E,M,K))).filter(O=>!!O),F={_reason:E._reason,folderQueries:q,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:M.pattern,includePattern:C.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const O=c.coalesce(c.flatten(this.c.groups.map(j=>j.editors.map(ue=>ue.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const U=O.filter(j=>(0,S.pathIncludedInQuery)(F,j.fsPath)),z=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...F,...z}}const B=E.extraFileResources&&E.extraFileResources.filter(O=>(0,S.pathIncludedInQuery)(F,O.fsPath));return F.extraFileResources=B&&B.length?B:void 0,F}i(h){const E=[],C=new k.ResourceMap,M={};let K=!1;return h.forEach(q=>{if(q.scheme===A.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(q)){const B=this.b.getWorkspaceFolder(q)?.uri??q.with({path:y.dirname(q.fsPath)});let O=C.get(B);O||(K=!0,O={folder:B,includePattern:{}},E.push(O),C.set(B,O));const U=y.relative(B.fsPath,q.fsPath);(0,P.assertIsDefined)(O.includePattern)[U.replace(/\\/g,"/")]=!0}else q.fsPath&&(K=!0,M[q.fsPath]=!0)}),{folderQueries:E,includePattern:M,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(h,E){if(E.isSmartCase){if(h.isRegExp){if(L.containsUppercaseCharacter(h.pattern,!0))return!0}else if(L.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}k(h){return h.isMultiline||h.isRegExp&&(0,I.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const E=z=>y.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),M=(Array.isArray(h)?h:s(h)).map(z=>{const j=this.e.resolvedUserHome;return j?(0,R.untildify)(z,j.scheme===A.Schemas.file?j.fsPath:j.path):z}),K=t.groupBy(M,z=>E(z)?"searchPaths":"exprSegments"),q=(K.exprSegments||[]).map(z=>L.rtrim(z,"/")).map(z=>L.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),a(z))),F={},B=this.m(K.searchPaths||[]);B&&B.length&&(F.searchPaths=B);const O=c.flatten(q),U=l(...O);return U&&(F.pattern=U),F}l(h,E){return E.disregardExcludeSettings?void 0:(0,S.getExcludes)(h,!E.disregardSearchExcludeSettings)}m(h){if(!h||!h.length)return[];const E=h.flatMap(M=>{let{pathPortion:K,globPortion:q}=r(M);return q&&(q=u(q)),this.n(K).flatMap(B=>this.o(B,q))}),C=new Map;return E.forEach(M=>{const K=M.searchPath.toString(),q=C.get(K);q?M.pattern&&(q.pattern=q.pattern||{},q.pattern[M.pattern]=!0):C.set(K,{searchPath:M.searchPath,pattern:M.pattern?l(M.pattern):void 0})}),Array.from(C.values())}n(h){if(y.isAbsolute(h)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==A.Schemas.file?[{searchPath:E[0].uri.with({path:h})}]:[{searchPath:w.URI.file(y.normalize(h))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(h=o(h),h.startsWith("../")||h===".."){const M=y.posix.resolve(E.path,h);return[{searchPath:E.with({path:M})}]}const C=u(h);return[{searchPath:E,pattern:C}]}else{if(h==="./"||h===".\\")return[];{const E=h.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(K=>{const q=E.match(new RegExp(`^${L.escapeRegExpCharacters(K.name)}(?:/(.*)|$)`));return q?{match:q,folder:K}:null}).filter(P.isDefined);if(M.length)return M.map(K=>{const q=K.match[1];return{searchPath:K.folder.uri,pattern:q&&u(q)}});{const K=h.match(/\.[\/\\](.+)[\/\\]?/),q=K?K[1]:h,F=v.localize(0,null,q);throw new Error(F)}}}}o(h,E){const C=h.pattern&&E?`${h.pattern}/${E}`:h.pattern||E,M=[{searchPath:h.searchPath,pattern:C}];return C&&!C.endsWith("**")&&M.push({searchPath:h.searchPath,pattern:C+"/**"}),M}q(h,E,C){const M=this.r((0,f.toWorkspaceFolder)(h.searchPath),E,C,!1);return M?{...M,includePattern:h.pattern}:null}r(h,E,C,M){let K;const q=w.URI.isUri(h)?h:h.uri;if(C.searchPaths){const z=C.searchPaths.filter(j=>(0,D.isEqual)(j.searchPath,q))[0];if(z&&!z.pattern)return null;z&&(K=z.pattern)}const F=this.a.getValue({resource:q}),O={...this.l(F,E)||{},...K||{}},U=w.URI.isUri(h)?(0,D.basename)(h):h.name;return{folder:q,folderName:M?U:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!F.search.followSymlinks}}};g=qe([We(0,m.IConfigurationService),We(1,f.IWorkspaceContextService),We(2,p.IEditorGroupsService),We(3,d.ILogService),We(4,b.IPathService)],g),e.QueryBuilder=g;function r(n){const h=n.match(/[\*\{\}\(\)\[\]\?]/);if(h){const E=h.index,C=n.substr(0,E).match(/[/|\\][^/\\]*$/);if(C){let M=n.substr(0,C.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:n.substr((C.index||0)+1)}}}return{pathPortion:n}}function l(...n){return n.length?n.reduce((h,E)=>(h[E]=!0,h),Object.create(null)):void 0}function s(n){return T.splitGlobAware(n,",").map(h=>h.trim()).filter(h=>!!h.length)}function a(n){return[`**/${n}/**`,`**/${n}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function o(n){return n.replace(/\\/g,"/")}function u(n){return o(n).replace(/^\.\//,"").replace(/\/+$/g,"")}function i(n,h){n=c.distinct(n,M=>M.toString());const E=[],C=h.getWorkspace();return n&&n.forEach(M=>{let K;if(h.getWorkbenchState()===2)K=(0,D.relativePath)(C.folders[0].uri,M),K&&K!=="."&&(K="./"+K);else{const q=h.getWorkspaceFolder(M);if(q){const F=q.name;if(C.folders.filter(O=>O.name===F).length===1){const O=(0,D.relativePath)(q.uri,M);O===""?K=`./${q.name}`:K=`./${q.name}/${O}`}else K=M.fsPath}}K&&E.push(K)}),E}e.resolveResourcesForSearchIncludes=i}),define(ye[293],Ce([1,0,24,2,21,9,4,292,31,47]),function(te,e,c,t,T,R,k,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function P(m,d){const f=d.activationEvents;if(!f)return Promise.resolve(void 0);const p=[],b=[];for(const a of f)if(/^workspaceContains:/.test(a)){const o=a.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||m.forceUsingSearch?b.push(o):p.push(o)}if(p.length===0&&b.length===0)return Promise.resolve(void 0);let S;const g=new Promise((a,o)=>{S=a}),r=a=>S({activationEvent:a}),l=Promise.all(p.map(a=>w(m,a,r))).then(()=>{}),s=I(m,d.identifier,b,r);return Promise.all([l,s]).then(()=>{S(void 0)}),g}e.checkActivateWorkspaceContainsExtension=P;async function w(m,d,f){for(const p of m.folders)if(await m.exists(c.joinPath(t.URI.revive(p),d))){f(`workspaceContains:${d}`);return}}async function I(m,d,f,p){if(f.length===0)return Promise.resolve(void 0);const b=new T.CancellationTokenSource,S=m.checkExists(m.folders,f,b.token),g=setTimeout(async()=>{b.cancel(),m.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},L);let r=!1;try{r=await S}catch(l){R.isCancellationError(l)||R.onUnexpectedError(l)}b.dispose(),clearTimeout(g),r&&p(`workspaceContains:${f.join(",")}`)}function v(m,d,f,p){const b=m.get(k.IInstantiationService),S=m.get(y.ISearchService),r=b.createInstance(A.QueryBuilder).file(d.map(l=>(0,D.toWorkspaceFolder)(t.URI.revive(l))),{_reason:"checkExists",includePattern:f,exists:!0});return S.fileSearch(r,p).then(l=>!!l.limitHit,l=>R.isCancellationError(l)?!1:Promise.reject(l))}e.checkGlobFileExists=v});var Je=this&&this.__classPrivateFieldSet||function(te,e,c,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,c):T?T.value=c:e.set(te,c),c},Ue=this&&this.__classPrivateFieldGet||function(te,e,c,t){if(c==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?t:c==="a"?t.call(te):t?t.value:e.get(te)};define(ye[43],Ce([1,0,177,11,80,24,14,6,66,2,13,5,35,235,99,34,26,134,9,27,23,216,7,128,4,25,76,18,90,55,42,3,293,98,218,17,97,44]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p,b,S,g,r,l,s,a,o,u,i,n,h,E,C,M,K,q,F,B){"use strict";var O,U,z;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let j=class $n extends A.Disposable{constructor(ee,X,G,de,be,Ee,Pe,Fe,se,oe,fe){super(),this.a=this.B(new E.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=X,this.g=G,this.f=Pe,this.j=de,this.k=be,this.l=Ee,this.m=se,this.p=oe,this.s=fe,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new k.Barrier,this.y=new k.Barrier,this.z=new k.Barrier,this.C=new k.Barrier,this.F=new f.ExtensionDescriptionRegistry(this.f.allExtensions);const Z=(0,d.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new f.ExtensionDescriptionRegistry(_(this.F,Z)),this.G=new v.ExtHostStorage(this.g,this.l),this.H=new M.ExtHostSecretState(this.g),this.I=Fe,this.h=ee.createChild(new i.ServiceCollection([v.IExtHostStorage,this.G],[M.IExtHostSecretState,this.H])),this.J=this.B(new I.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,ie,N)=>{this.v.$onExtensionActivationError(ce,p.transformErrorForSerialization(ie),N)},actualActivateExtension:async(ce,ie)=>{if(f.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,ie),new I.HostExtension;const N=this.D.getExtensionDescription(ce);return this.Y(N,ie)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),T.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(ee){p.onUnexpectedError(ee)}}async Q(){this.I.onWillDeactivateAll();let ee=[];try{ee=this.D.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this.X(be))}catch{}await Promise.all(ee)}terminate(ee,X=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${ee}`),this.l.flush(),this.p.dispose(),this.J.dispose(),p.setUnexpectedErrorHandler(de=>{this.l.error(de)}),this.g.dispose();const G=this.Q();Promise.race([(0,k.timeout)(5e3),G]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${X}`):this.l.info(`Extension host exiting with code ${X}`),this.l.flush(),this.l.dispose(),this.c.exit(X)})}isActivated(ee){return this.z.isOpen()?this.J.isActivated(ee):!1}async getExtension(ee){const X=await this.v.$getExtension(ee);let G;if(X?.browserNlsBundleUris){G={};for(const de of Object.keys(X.browserNlsBundleUris))G[de]=D.URI.revive(X.browserNlsBundleUris[de])}return X&&{...X,identifier:new b.ExtensionIdentifier(X.identifier.value),extensionLocation:D.URI.revive(X.extensionLocation),browserNlsBundleUris:G}}R(ee,X){return this.J.activateByEvent(ee,X)}S(ee,X){return this.J.activateById(ee,X)}activateByIdWithErrors(ee,X){return this.S(ee,X).then(()=>{const G=this.J.getActivatedExtension(ee);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(ee=>this.D)}getExtensionExports(ee){return this.z.isOpen()?this.J.getActivatedExtension(ee).exports:null}async U(ee){if(ee.scheme!==q.Schemas.file)return ee;const X=await this.c.realpath(ee.fsPath);return D.URI.file(X)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(ee=>new J(ee))),this.L}async W(ee){const X=y.TernarySearchTree.forUris(G=>R.extUriBiasedIgnorePathCase.ignorePathCasing(G));return await Promise.all(ee.map(async G=>{if(this.ob(G)){const de=await this.U(G.extensionLocation);X.set(de,G)}})),X}X(ee){let X=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(ee))return X;const G=this.J.getActivatedExtension(ee);if(!G)return X;try{typeof G.module.deactivate=="function"&&(X=Promise.resolve(G.module.deactivate()).then(void 0,de=>(this.l.error(de),Promise.resolve(void 0))))}catch(de){this.l.error(`An error occurred when deactivating the extension '${ee.value}':`),this.l.error(de)}try{(0,A.dispose)(G.subscriptions)}catch(de){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ee.value}':`),this.l.error(de)}return X}async Y(ee,X){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ee.identifier):await this.v.$onWillActivateExtension(ee.identifier),this.ab(ee,X).then(G=>{const de=G.activationTimes;return this.v.$onDidActivateExtension(ee.identifier,de.codeLoadingTime,de.activateCallTime,de.activateResolvedTime,X),this.Z(ee,X,"success",de),G},G=>{throw this.Z(ee,X,"failure"),G})}Z(ee,X,G,de){const be=ue(ee,X);this.u.$publicLog2("extensionActivationTimes",{...be,...de||{},outcome:G})}ab(ee,X){const G=ue(ee,X);this.u.$publicLog2("activatePlugin",G);const de=this.ob(ee);if(!de)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ee.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${ee.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this.l.flush();const be=new I.ExtensionActivationTimesBuilder(X.startup);return Promise.all([this.pb(ee,(0,R.joinPath)(ee.extensionLocation,de),be),this.bb(ee)]).then(Ee=>(T.mark(`code/extHost/willActivateExtension/${ee.identifier.value}`),$n.cb(this.l,ee.identifier,Ee[0],Ee[1],be))).then(Ee=>(T.mark(`code/extHost/didActivateExtension/${ee.identifier.value}`),Ee))}bb(ee){const X=new g.ExtensionGlobalMemento(ee,this.G),G=new g.ExtensionMemento(ee.identifier.value,!1,this.G),de=new K.ExtensionSecrets(ee,this.H),be=ee.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Ee=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ee.identifier.value}`),Promise.all([X.whenReady,G.whenReady,this.I.whenReady]).then(()=>{const Pe=this;let Fe,se;const oe=(0,d.isProposedApiEnabled)(ee,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(ee.identifier)):void 0;return Object.freeze({globalState:X,workspaceState:G,secrets:de,subscriptions:[],get extensionUri(){return ee.extensionLocation},get extensionPath(){return ee.extensionLocation.fsPath},asAbsolutePath(fe){return t.join(ee.extensionLocation.fsPath,fe)},get storagePath(){return Pe.I.workspaceValue(ee)?.fsPath},get globalStoragePath(){return Pe.I.globalValue(ee).fsPath},get logPath(){return t.join(Pe.f.logsLocation.fsPath,ee.identifier.value)},get logUri(){return D.URI.joinPath(Pe.f.logsLocation,ee.identifier.value)},get storageUri(){return Pe.I.workspaceValue(ee)},get globalStorageUri(){return Pe.I.globalValue(ee)},get extensionMode(){return be},get extension(){return Fe===void 0&&(Fe=new V(Pe,ee.identifier,ee,Ee,!1)),Fe},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(ee,"extensionRuntime"),Pe.extensionRuntime},get environmentVariableCollection(){return Pe.p.getEnvironmentVariableCollection(ee)},get messagePassingProtocol(){if(!se){if(!oe)return;const fe=E.Event.buffer(E.Event.fromDOMEventEmitter(oe,"message",Z=>Z.data));oe.start(),se={onDidReceiveMessage:fe,postMessage:oe.postMessage.bind(oe)}}return se}})})}static cb(ee,X,G,de,be){return G=G||{activate:void 0,deactivate:void 0},this.db(ee,X,G,de,be).then(Ee=>new I.ActivatedExtension(!1,null,be.build(),G,Ee,de.subscriptions))}static db(ee,X,G,de,be){if(typeof G.activate=="function")try{be.activateCallStart(),ee.trace(`ExtensionService#_callActivateOptional ${X.value}`);const Ee=typeof global=="object"?global:self,Pe=G.activate.apply(Ee,[de]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Pe).then(Fe=>(be.activateResolveStop(),Fe))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(G)}eb(ee,X){this.S(ee.identifier,{startup:!1,extensionId:ee.identifier,activationEvent:X}).then(void 0,G=>{this.l.error(G)})}fb(){this.v.$setPerformanceMarks(T.getMarks());for(const ee of this.D.getAllExtensionDescriptions())if(ee.activationEvents)for(const X of ee.activationEvents)X==="onStartupFinished"&&this.eb(ee,X)}gb(){const ee=this.R("*",!0).then(void 0,be=>{this.l.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.hb(be.added)));const X=this.j.workspace?this.j.workspace.folders:[],G=this.hb(X),de=Promise.all([ee,G]).then(()=>{});return Promise.race([de,(0,k.timeout)(1e4)]).then(()=>{this.fb()}),de}hb(ee){return ee.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(X=>this.ib(ee,X))).then(()=>{})}async ib(ee,X){if(this.isActivated(X.identifier))return;const G=!this.f.remote.isRemote&&!!this.f.remote.authority,de={logService:this.l,folders:ee.map(Ee=>Ee.uri),forceUsingSearch:G,exists:Ee=>this.c.exists(Ee.fsPath),checkExists:(Ee,Pe,Fe)=>this.t.$checkExists(Ee,Pe,Fe)},be=await(0,C.checkActivateWorkspaceContainsExtension)(de,X);if(!!be)return this.S(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:be.activationEvent}).then(void 0,Ee=>this.l.error(Ee))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(ee){throw console.error(ee),ee}}async jb(){const{extensionDevelopmentLocationURI:ee,extensionTestsLocationURI:X}=this.f.environment;if(!ee||!X)throw new Error(c.localize(0,null));const G=await this.pb(null,X,new I.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(c.localize(1,null,X.toString()));return new Promise((de,be)=>{const Ee=(se,oe)=>{se?be(se):de(typeof oe=="number"&&oe>0?1:0)},Pe=(0,R.originalFSPath)(X),Fe=G.run(Pe,Ee);Fe&&Fe.then&&Fe.then(()=>{de(0)}).catch(se=>{be(se instanceof Error&&se.stack?se.stack:String(se))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ee,X){return this.M[ee]=X,(0,A.toDisposable)(()=>{delete this.M[ee]})}async lb(ee){const X=ee.indexOf("+");if(X===-1)throw new Error("Not an authority that can be resolved!");const G=ee.substr(0,X);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${G}`,!1),{authorityPrefix:G,resolver:this.M[G]}}async $resolveAuthority(ee,X){const G=B.StopWatch.create(!1),de=()=>`[resolveAuthority(${(0,l.getRemoteAuthorityPrefix)(ee)},${X})][${G.elapsed()}ms] `,be=oe=>this.l.info(`${de()}${oe}`),Ee=(oe,fe=void 0)=>this.l.error(`${de()}${oe}`,fe);be("activating resolver...");const{authorityPrefix:Pe,resolver:Fe}=await this.lb(ee);if(!Fe)return Ee("no resolver"),{type:"error",error:{code:l.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Pe}.`,detail:void 0}};const se=new k.IntervalTimer;try{be("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Fe)),se.cancelAndSet(()=>be("waiting..."),1e3),be("invoking resolve()..."),T.mark(`code/extHost/willResolveAuthority/${Pe}`);const oe=await Fe.resolve(ee,{resolveAttempt:X});T.mark(`code/extHost/didResolveAuthorityOK/${Pe}`),se.dispose(),be(`returned ${oe.host}:${oe.port}`);const fe={authority:ee,host:oe.host,port:oe.port,connectionToken:oe.connectionToken},Z={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted,authenticationSession:oe.authenticationSessionForInitializingExtensions?{id:oe.authenticationSessionForInitializingExtensions.id,providerId:oe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:fe,options:Z,tunnelInformation:{environmentTunnels:oe.environmentTunnels,features:oe.tunnelFeatures}}}}catch(oe){if(T.mark(`code/extHost/didResolveAuthorityError/${Pe}`),se.dispose(),Ee("returned an error",oe),oe instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe}}async $getCanonicalURI(ee,X){this.l.info(`$getCanonicalURI invoked for authority (${(0,l.getRemoteAuthorityPrefix)(ee)})`);const{resolver:G}=await this.lb(ee);if(!G)return null;const de=D.URI.revive(X);if(typeof G.getCanonicalURI>"u")return de;const be=await(0,k.asPromise)(()=>G.getCanonicalURI(de));return be||de}static mb(ee,X,G){const de=new f.ExtensionDescriptionRegistry(ee.getAllExtensionDescriptions());de.deltaExtensions(G.toAdd,G.toRemove);const be=(0,d.extensionIdentifiersArrayToSet)(X.getAllExtensionDescriptions().map(Pe=>Pe.identifier));for(const Pe of G.myToRemove)be.delete(b.ExtensionIdentifier.toKey(Pe));for(const Pe of G.myToAdd)be.add(b.ExtensionIdentifier.toKey(Pe));const Ee=_(de,be);return{globalRegistry:de,myExtensions:Ee}}$startExtensionHost(ee){ee.toAdd.forEach(de=>de.extensionLocation=D.URI.revive(de.extensionLocation));const{globalRegistry:X,myExtensions:G}=$n.mb(this.F,this.D,ee);return this.F.set(X.getAllExtensionDescriptions()),this.D.set(G),this.kb()}$activateByEvent(ee,X){return X===1?this.R(ee,!1):this.z.wait().then(G=>this.R(ee,!1))}async $activate(ee,X){return await this.z.wait(),this.D.getExtensionDescription(ee)?(await this.S(ee,X),!0):!1}async $deltaExtensions(ee){ee.toAdd.forEach(Ee=>Ee.extensionLocation=D.URI.revive(Ee.extensionLocation));const{globalRegistry:X,myExtensions:G}=$n.mb(this.F,this.D,ee),de=await this.W(G);return(await this.getExtensionPathIndex()).setSearchTree(de),this.F.set(X.getAllExtensionDescriptions()),this.D.set(G),Promise.resolve(void 0)}async $test_latency(ee){return ee}async $test_up(ee){return ee.byteLength}async $test_down(ee){const X=S.VSBuffer.alloc(ee),G=Math.random()%256;for(let de=0;de<ee;de++)X.writeUInt8(G,de);return X}async $updateRemoteConnectionData(ee){this.P=ee,this.a.fire()}};j=qe([We(0,s.IInstantiationService),We(1,e.IHostUtils),We(2,u.IExtHostRpcService),We(3,m.IExtHostWorkspace),We(4,w.IExtHostConfiguration),We(5,L.ILogService),We(6,a.IExtHostInitDataService),We(7,o.IExtensionStoragePaths),We(8,n.IExtHostTunnelService),We(9,h.IExtHostTerminalService),We(10,F.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function ue(ne,ee){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:ee.activationEvent,reasonId:ee.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class V{constructor(ee,X,G,de,be){O.set(this,void 0),U.set(this,void 0),z.set(this,void 0),Je(this,O,ee,"f"),Je(this,U,X,"f"),Je(this,z,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=t.normalize((0,R.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=de,this.isFromDifferentExtensionHost=be}get isActive(){return Ue(this,O,"f").isActivated(Ue(this,z,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,O,"f").getExtensionExports(Ue(this,z,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,O,"f").activateByIdWithErrors(Ue(this,z,"f"),{startup:!1,extensionId:Ue(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=V,O=new WeakMap,U=new WeakMap,z=new WeakMap;function _(ne,ee){return ne.getAllExtensionDescriptions().filter(X=>ee.has(b.ExtensionIdentifier.toKey(X.identifier)))}class J{constructor(ee){this.a=ee}setSearchTree(ee){this.a=ee}findSubstr(ee){return this.a.findSubstr(ee)}forEach(ee){return this.a.forEach(ee)}}e.ExtensionPaths=J}),define(ye[294],Ce([1,0,80,2,5,35,26,27,18,25,4,43,37,13,8]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let m=class{constructor(g,r,l,s,a,o,u){this.c=g,this.d=r,this.e=l,this.f=s,this.g=a,this.h=o,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),c.mark("code/extHost/willWaitForConfig");const g=await this.f.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const r=await this.g.getExtensionPathIndex();this.register(new f(this.c,r,this.d,g,this.i)),this.register(this.e.createInstance(p,r)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,r,this.h.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const r of g.nodeModuleName)this.a.set(r,g);else this.a.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this.b.push(r=>g.alternativeModuleName(r))}};m=qe([We(2,L.IInstantiationService),We(3,R.IExtHostConfiguration),We(4,P.IExtHostExtensionService),We(5,D.IExtHostInitDataService),We(6,I.ILogService)],m),e.RequireInterceptor=m;let d=class ni{constructor(g){if(g.environment.appRoot&&ni.a.size){const r=(0,v.escapeRegExpCharacters)(this.c(g.environment.appRoot.fsPath)),l="[a-z0-9_.-]",s=`@${l}+\\/${l}+|${l}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${r}/${a}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(g){if(!this.b)return;const r=this.b.exec(this.c(g));if(!r)return;const[,l,s,a]=r,o=ni.a.get(s);if(o!==void 0)return console.warn(`${s} as been renamed to ${o}, please update your imports`),l+o+a}c(g){return g.replace(/\\/g,"/")}};d.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=qe([We(0,D.IExtHostInitDataService)],d);class f{constructor(g,r,l,s,a){this.c=g,this.d=r,this.e=l,this.f=s,this.g=a,this.nodeModuleName="vscode",this.a=new Map}load(g,r){const l=this.d.findSubstr(r);if(l){let s=this.a.get(A.ExtensionIdentifier.toKey(l.identifier));return s||(s=this.c(l,this.e,this.f),this.a.set(A.ExtensionIdentifier.toKey(l.identifier),s)),s}if(!this.b){let s="";this.d.forEach((a,o)=>s+=`	${o} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${s}`),this.b=this.c(k.nullExtensionDescription,this.e,this.f)}return this.b}}let p=class{constructor(g,r,l){this.d=g,this.nodeModuleName="keytar",this.a=r.getProxy(T.MainContext.MainThreadTelemetry);const{environment:s}=l,a=r.getProxy(T.MainContext.MainThreadKeytar);if(s.appRoot){let o=s.appRoot.fsPath;w.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.b=new Set,this.b.add(`${o}/node_modules.asar/keytar`),this.b.add(`${o}/node_modules/keytar`)}this.c={getPassword:(o,u)=>a.$getPassword(o,u),setPassword:(o,u,i)=>a.$setPassword(o,u,i),deletePassword:(o,u)=>a.$deletePassword(o,u),findPassword:o=>a.$findPassword(o),findCredentials(o){return a.$findCredentials(o)}}}load(g,r){const l=this.d.findSubstr(r);return this.a.$publicLog2("shimming.keytar",{extension:l?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(g){const r=g.length;if(r<=7||!this.b)return;const l=r-7;if((g.charAt(l)==="/"||g.charAt(l)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.b.has(g)))return"keytar"}};p=qe([We(1,y.IExtHostRpcService),We(2,D.IExtHostInitDataService)],p);let b=class{constructor(g,r,l){this.e=g,this.f=r,this.nodeModuleName=["open","opn"],this.d=l.getProxy(T.MainContext.MainThreadTelemetry);const s=l.getProxy(T.MainContext.MainThreadWindow);this.c=(a,o)=>{const u=t.URI.parse(a);return o?this.g(a,o):u.scheme==="http"||u.scheme==="https"?s.$openUri(u,a,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?s.$openUri(u,a,{}):this.g(a,o)}}load(g,r,l){const s=this.e.findSubstr(r);return s&&(this.a=s.identifier.value,this.h()),this.b=l(g),this.c}g(g,r){return this.i(),this.b(g,r)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=qe([We(2,y.IExtHostRpcService)],b)}),define(ye[49],Ce([1,0,83,6,11,37,4,59,60,43,7,34,231,35]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,k.createDecorator)("IExtHostVariableResolverProvider");class v extends w.AbstractVariableResolverService{constructor(f,p,b,S,g,r,l){function s(){if(b){const a=b.activeEditor();if(a)return a.document.uri;const o=S.tabGroups.all.find(u=>u.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof L.TextDiffTabInput||o.input instanceof L.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof L.TextTabInput||o.input instanceof L.NotebookEditorTabInput||o.input instanceof L.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:a=>{const o=r.folders.filter(u=>u.name===a);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(a,o)=>g.getConfiguration(void 0,a).get(o),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=s();if(a)return T.normalize(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const a=s();if(a){const o=p.getWorkspaceFolder(a);if(o)return T.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(b){const a=b.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(b){const a=b.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>f.getExtension(a)},void 0,l?Promise.resolve(l):void 0,Promise.resolve(R.env))}}let m=class extends t.Disposable{constructor(f,p,b,S,g){super(),this.b=f,this.c=p,this.g=b,this.h=S,this.i=g,this.a=new c.Lazy(async()=>{const r=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.i,r,s,this.j())})}getResolver(){return this.a.getValue()}j(){}};m=qe([We(0,D.IExtHostExtensionService),We(1,P.IExtHostWorkspace),We(2,A.IExtHostDocumentsAndEditors),We(3,I.IExtHostConfiguration),We(4,y.IExtHostEditorTabs)],m),e.ExtHostVariableResolverProviderService=m}),define(ye[81],Ce([1,0,14,3,10,2,4,5,60,43,18,7,34,131,223,35,49]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,k.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,a,o,u,i,n){this.D=a,this.E=o,this.F=u,this.G=i,this.H=n,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=s.getProxy(A.MainContext.MainThreadDebugService),this.z=new t.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(h=>{h.onDidChange(E=>{this.I(h)}),this.I(h)})}asDebugSourceUri(s,a){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let u=`debug:${encodeURIComponent(o.path||"")}`,i="?";return a&&(u+=`${i}session=${encodeURIComponent(a.id)}`,i="&"),u+=`${i}ref=${o.sourceReference}`,R.URI.parse(u)}else{if(o.path)return R.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(s){const a=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const u=o.contributes.debuggers;if(u&&u.length>0)for(const i of u)(0,v.isDebuggerMainContribution)(i)&&a.push(i.type)}this.k.$registerDebugTypes(a)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const s=[];return this.w.forEach(a=>s.push(a)),s}addBreakpoints(s){this.T();const a=s.filter(i=>{const n=i.id;return this.w.has(n)?!1:(this.w.set(n,i),!0)});this.U(a,[],[]);const o=[],u=new Map;for(const i of a)if(i instanceof P.SourceBreakpoint){let n=u.get(i.location.uri.toString());n||(n={type:"sourceMulti",uri:i.location.uri,lines:[]},u.set(i.location.uri.toString(),n),o.push(n)),n.lines.push({id:i.id,enabled:i.enabled,condition:i.condition,hitCondition:i.hitCondition,logMessage:i.logMessage,line:i.location.range.start.line,character:i.location.range.start.character})}else i instanceof P.FunctionBreakpoint&&o.push({type:"function",id:i.id,enabled:i.enabled,hitCondition:i.hitCondition,logMessage:i.logMessage,condition:i.condition,functionName:i.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(s){this.T();const a=s.filter(n=>this.w.delete(n.id));this.U([],a,[]);const o=a.filter(n=>n instanceof P.SourceBreakpoint).map(n=>n.id),u=a.filter(n=>n instanceof P.FunctionBreakpoint).map(n=>n.id),i=a.filter(n=>n instanceof P.DataBreakpoint).map(n=>n.id);return this.k.$unregisterBreakpoints(o,u,i)}startDebugging(s,a,o){return this.k.$startDebugging(s?s.uri:void 0,a,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,a,o){if(!a)return new P.Disposable(()=>{});const u=this.d++;return this.f.push({type:s,handle:u,provider:a}),this.k.$registerDebugConfigurationProvider(s,o,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,u),new P.Disposable(()=>{this.f=this.f.filter(i=>i.provider!==a),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(s,a,o){if(!o)return new P.Disposable(()=>{});if(!this.P(s,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.M(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:a,handle:u,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(a,u),new P.Disposable(()=>{this.h=this.h.filter(i=>i.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(s,a){if(!a)return new P.Disposable(()=>{});const o=this.i++;return this.j.push({type:s,handle:o,factory:a}),new P.Disposable(()=>{this.j=this.j.filter(u=>u.factory!==a)})}async $runInTerminal(s,a){return Promise.resolve(void 0)}async $substituteVariables(s,a){let o;const u=await this.W(s);return u&&(o={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(o,a)}J(s,a){if(s.type==="implementation")return new g(s.implementation)}K(){}async $startDASession(s,a){const o=this,u=await this.V(a);return this.R(this.M(u.type),u).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const n=this.L(i),h=this.J(n,u);if(!h)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const E=h;return this.A.set(s,E),this.Q(u).then(C=>(C&&this.B.set(s,C),E.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const K=M,q={type:"response",seq:0,command:K.command,request_seq:K.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const F=await this.C.sign(K.arguments.value);q.body={signature:F},E.sendResponse(q)}else throw new Error("no signer")}catch(F){q.success=!1,q.message=F.message,E.sendResponse(q)}}else C&&C.onDidSendMessage&&C.onDidSendMessage(M),M=(0,v.convertToVSCPaths)(M,!0),o.k.$acceptDAMessage(s,M)}),E.onError(M=>{C&&C.onError&&C.onError(M),this.k.$acceptDAError(s,M.name,M.message,M.stack)}),E.onExit(M=>{C&&C.onExit&&C.onExit((0,T.withNullAsUndefined)(M),void 0),this.k.$acceptDAExit(s,(0,T.withNullAsUndefined)(M),void 0)}),C&&C.onWillStartSession&&C.onWillStartSession(),E.startSession()))})}$sendDAMessage(s,a){a=(0,v.convertToDAPaths)(a,!1);const o=this.B.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(a),this.A.get(s)?.sendMessage(a)}$stopDASession(s){const a=this.B.get(s);this.B.delete(s),a&&a.onWillStopSession&&a.onWillStopSession();const o=this.A.get(s);return this.A.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const a=[],o=[],u=[];if(s.added)for(const i of s.added){const n=i.id;if(n&&!this.w.has(n)){let h;if(i.type==="function")h=new P.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if(i.type==="data")h=new P.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const E=R.URI.revive(i.uri);h=new P.SourceBreakpoint(new P.Location(E,new P.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}(0,P.setBreakpointId)(h,n),this.w.set(n,h),a.push(h)}}if(s.removed)for(const i of s.removed){const n=this.w.get(i);n&&(this.w.delete(i),o.push(n))}if(s.changed){for(const i of s.changed)if(i.id){const n=this.w.get(i.id);if(n){if(n instanceof P.FunctionBreakpoint&&i.type==="function"){const h=n;h.enabled=i.enabled,h.condition=i.condition,h.hitCondition=i.hitCondition,h.logMessage=i.logMessage,h.functionName=i.functionName}else if(n instanceof P.SourceBreakpoint&&i.type==="source"){const h=n;h.enabled=i.enabled,h.condition=i.condition,h.hitCondition=i.hitCondition,h.logMessage=i.logMessage,h.location=new P.Location(R.URI.revive(i.uri),new P.Position(i.line,i.character))}u.push(n)}}}this.U(a,o,u)}$provideDebugConfigurations(s,a,o){return(0,c.asPromise)(async()=>{const u=this.O(s);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const i=await this.W(a);return u.provideDebugConfigurations(i,o)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(s,a,o,u){return(0,c.asPromise)(async()=>{const i=this.O(s);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const n=await this.W(a);return i.resolveDebugConfiguration(n,o,u)})}$resolveDebugConfigurationWithSubstitutedVariables(s,a,o,u){return(0,c.asPromise)(async()=>{const i=this.O(s);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const n=await this.W(a);return i.resolveDebugConfigurationWithSubstitutedVariables(n,o,u)})}async $provideDebugAdapter(s,a){const o=this.N(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.V(a);return this.R(o,u).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.L(i)})}async $acceptDebugSessionStarted(s){const a=await this.V(s);this.m.fire(a)}async $acceptDebugSessionTerminated(s){const a=await this.V(s);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,a){(await this.V(s))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(s,a){const u={session:await this.V(s),event:a.event,body:a.body};this.u.fire(u)}L(s){if(s instanceof P.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof P.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}M(s){const a=this.h.filter(o=>o.type===s);if(a.length>0)return a[0].factory}N(s){const a=this.h.filter(o=>o.handle===s);if(a.length>0)return a[0].factory}O(s){const a=this.f.filter(o=>o.handle===s);if(a.length>0)return a[0].provider}P(s,a){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const u of o)if(u.label&&u.type&&u.type===a)return!0}}return!1}Q(s){const o=s.configuration.type,u=this.j.filter(i=>i.type===o||i.type==="*").map(i=>(0,c.asPromise)(()=>i.factory.createDebugAdapterTracker(s)).then(n=>n,n=>null));return Promise.race([Promise.all(u).then(i=>{const n=i.filter(h=>!!h);if(n.length>0)return new S(n)}),new Promise(i=>setTimeout(()=>i(void 0),1e3))]).catch(i=>{})}async R(s,a){const o=a.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.DebugAdapterServer(o));if(s){const i=await this.E.getExtensionRegistry();return(0,c.asPromise)(()=>s.createDebugAdapterDescriptor(a,this.S(a,i))).then(n=>{if(n)return n})}const u=await this.E.getExtensionRegistry();return Promise.resolve(this.S(a,u))}S(s,a){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(s,a,o){(s.length>0||a.length>0||o.length>0)&&this.z.fire(Object.freeze({added:s,removed:a,changed:o}))}async V(s){if(s)if(typeof s=="string"){const a=this.l.get(s);if(a)return a}else{let a=this.l.get(s.id);if(!a){const o=await this.W(s.folderUri),u=s.parent?this.l.get(s.parent):void 0;a=new p(this.k,s.id,s.type,s.name,o,s.configuration,u),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(s){if(s){const a=R.URI.revive(s);return this.D.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};f=qe([We(0,L.IExtHostRpcService),We(1,w.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,m.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class p{constructor(s,a,o,u,i,n,h){this.d=s,this.f=a,this.g=o,this.h=u,this.i=i,this.j=n,this.k=h}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,a){return this.d.$customDebugAdapterRequest(this.f,s,a)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.ExtHostDebugSession=p;class b{constructor(s){this.value=Object.freeze({append(a){s.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.ExtHostDebugConsole=b;class S{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(a=>a.onError?a.onError(s):void 0)}onExit(s,a){this.d.forEach(o=>o.onExit?o.onExit(s,a):void 0)}}class g extends I.AbstractDebugAdapter{constructor(s){super(),this.h=s,s.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let r=class extends f{constructor(s,a,o,u,i,n){super(s,a,o,u,i,n)}};r=qe([We(0,L.IExtHostRpcService),We(1,w.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,m.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],r),e.WorkerExtHostDebugService=r}),define(ye[295],Ce([1,0,9,80,2,5,287,13,89,90,25,201,18,56,43,96]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{static async installEarlyHandler(b){const S=b.get(A.ILogService),r=b.get(w.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);c.setUnexpectedErrorHandler(l=>{S.error(l);const s=c.transformErrorForSerialization(l);r.$onUnexpectedError(s)})}static async installFullHandler(b){const S=b.get(A.ILogService),g=b.get(w.IExtHostRpcService),r=b.get(v.IExtHostExtensionService),l=b.get(m.IExtHostTelemetry),s=g.getProxy(R.MainContext.MainThreadExtensionService),a=g.getProxy(R.MainContext.MainThreadErrors),o=await r.getExtensionPathIndex(),u=new WeakMap;Error.prepareStackTrace=(i,n)=>{let h="",E,C;for(const M of n)h+=`
	at ${M.toString()}`,C=M.getFileName(),!E&&C&&(E=o.findSubstr(T.URI.file(C)));return u.set(i,E?.identifier),`${i.name||"Error"}: ${i.message||""}${h}`},c.setUnexpectedErrorHandler(i=>{S.error(i);const n=c.transformErrorForSerialization(i),h=u.get(i);if(!h){a.$onUnexpectedError(n);return}s.$onExtensionRuntimeError(h,n);const E=l.onExtensionError(h,i);S.trace("forwarded error to extension?",E,h)})}}Error.stackTraceLimit=100;class f{constructor(b,S,g,r,l){this.a=g,this.b=new k.RPCProtocol(b,null,r),S=f.e(S,this.b);const s=new D.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());s.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...S,messagePorts:l}),s.set(w.IExtHostRpcService,new w.ExtHostRpcService(this.b)),s.set(I.IURITransformerService,new I.URITransformerService(r)),s.set(v.IHostUtils,g);const a=new P.InstantiationService(s,!0);a.invokeFunction(d.installEarlyHandler),this.d=a.invokeFunction(o=>o.get(A.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",S),this.c=a.invokeFunction(o=>o.get(v.IExtHostExtensionService)),this.c.initialize(),a.invokeFunction(d.installFullHandler)}async asBrowserUri(b){const S=this.b.getProxy(R.MainContext.MainThreadExtensionService);return T.URI.revive(await S.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,S){b.allExtensions.forEach(r=>{r.extensionLocation=T.URI.revive(S.transformIncomingURIs(r.extensionLocation));const l={};r.browserNlsBundleUris&&(Object.keys(r.browserNlsBundleUris).forEach(s=>l[s]=T.URI.revive(S.transformIncomingURIs(r.browserNlsBundleUris[s]))),r.browserNlsBundleUris=l)}),b.environment.appRoot=T.URI.revive(S.transformIncomingURIs(b.environment.appRoot));const g=b.environment.extensionDevelopmentLocationURI;return g&&(b.environment.extensionDevelopmentLocationURI=g.map(r=>T.URI.revive(S.transformIncomingURIs(r)))),b.environment.extensionTestsLocationURI=T.URI.revive(S.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=T.URI.revive(S.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=T.URI.revive(S.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=T.URI.revive(S.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=T.URI.revive(S.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=T.URI.revive(S.transformIncomingURIs(b.logsLocation)),b.logFile=T.URI.revive(S.transformIncomingURIs(b.logFile)),b.workspace=S.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=f}),define(ye[296],Ce([1,0,14,12,183,200,207,81,60,43,18,42,7,49,34,224,226,35]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let p=class extends A.ExtHostDebugServiceBase{constructor(l,s,a,o,u,i,n){super(l,s,a,o,i,n),this.Z=u,this.X=new g}J(l,s){switch(l.type){case"server":return new m.SocketDebugAdapter(l);case"pipeServer":return new m.NamedPipeDebugAdapter(l);case"executable":return new m.ExecutableDebugAdapter(l,s.type)}return super.J(l,s)}S(l,s){const a=m.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),l.type);if(a)return new w.DebugAdapterExecutable(a.command,a.args,a.options)}K(){return new k.SignService}async $runInTerminal(l,s){if(l.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const a=await this.F.getConfigProvider(),o=this.Z.getDefaultShell(!0),u=this.Z.getDefaultShellArgs(!0),i=l.title||T.localize(0,null),n=JSON.stringify({shell:o,shellArgs:u});let h=await this.X.checkout(n,i),E,C=!1;if(h)E=l.cwd;else{const F={shellPath:o,shellArgs:u,cwd:l.cwd,name:i,iconPath:new w.ThemeIcon("debug")};C=!0,h=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(h,n)}h.show(!0);const M=await h.processId;C?await new Promise(F=>setTimeout(F,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(o.indexOf("powershell")>=0||o.indexOf("pwsh")>=0||o.indexOf("cmd.exe")>=0?h.sendText("cls"):o.indexOf("bash")>=0?h.sendText("clear"):t.isWindows?h.sendText("cls"):h.sendText("clear"));const K=(0,d.prepareCommand)(o,l.args,!!l.argsCanBeInterpretedByShell,E,l.env);h.sendText(K);const q=this.onDidTerminateDebugSession(F=>{F.id===s&&(this.X.free(h),q.dispose())});return M}else if(l.kind==="external")return S(l,await this.F.getConfigProvider());return super.$runInTerminal(l,s)}};p=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,P.IExtHostTerminalService),We(5,y.IExtHostEditorTabs),We(6,I.IExtHostVariableResolverProvider)],p),e.ExtHostDebugService=p;let b;function S(r,l){if(!b)if(t.isWindows)b=new R.WindowsExternalTerminalService;else if(t.isMacintosh)b=new R.MacExternalTerminalService;else if(t.isLinux)b=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=l.getConfiguration("terminal");return b.runInTerminal(r.title,r.cwd,r.args,r.env||{},s.external||{})}class g{constructor(){this.b=new Map}async checkout(l,s){const o=[...this.b.entries()].map(([u,i])=>(0,c.createCancelablePromise)(async n=>{if(u.name!==s||i.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await u.processId))return null;const h=Date.now();return i.lastUsedAt+g.a>h||n.isCancellationRequested||i.config!==l?null:(i.lastUsedAt=h,u)}));return await(0,c.firstParallel)(o,u=>!!u)}insert(l,s){this.b.set(l,{lastUsedAt:Date.now(),config:s})}free(l){const s=this.b.get(l);s&&(s.lastUsedAt=-1)}onTerminalClosed(l){this.b.delete(l)}}g.a=1e3}),define(ye[297],Ce([1,0,11,2,116,34,59,35,47,42,18,25,79,17,13,74,24,88,49]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends w.ExtHostTaskBase{constructor(g,r,l,s,a,o,u,i,n){super(g,r,l,s,a,o,u,i),this.B=l,this.C=n,r.remote.isRemote&&r.remote.authority?this.registerTaskSystem(I.Schemas.vscodeRemote,{scheme:I.Schemas.vscodeRemote,authority:r.remote.authority,platform:process.platform}):this.registerTaskSystem(I.Schemas.file,{scheme:I.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,r){const l=r;if(!r.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const s=w.TaskHandleDTO.from(l,this.B),a=await this.a.$getTaskExecution(s);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.y(a,r);return this.a.$executeTask(s).catch(()=>{}),o}else{const s=w.TaskDTO.from(r,g);if(s===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(s.execution)&&await this.x(s,r,!1);const a=await this.y(await this.a.$getTaskExecution(s),r);return this.a.$executeTask(s).catch(()=>{}),a}}u(g,r,l,s){const a=[];if(s)for(const o of s){this.z(o,l),(!o.definition||!g[o.definition.type])&&this.f.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const u=w.TaskDTO.from(o,l.extension);u&&(a.push(u),w.CustomExecutionDTO.is(u.execution)&&r.push(this.x(u,o,!0)))}return{tasks:a,extension:l.extension}}async v(g){return g}async F(g){let r=g&&g.length>0?g[0]:void 0;if(!r){const l=t.URI.file((0,f.homedir)());r=new y.WorkspaceFolder({uri:l,name:d.basename(l),index:0})}return{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,r){const l=t.URI.revive(g),s={process:void 0,variables:Object.create(null)},a=await this.b.resolveWorkspaceFolder(l),o=await this.b.getWorkspaceFolders2()??[],u=await this.C.getResolver(),i=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(o);for(const n of r.variables)s.variables[n]=await u.resolveAsync(i,n);if(r.process!==void 0){let n;if(r.process.path!==void 0){n=r.process.path.split(c.delimiter);for(let h=0;h<n.length;h++)n[h]=await u.resolveAsync(i,n[h])}s.process=await T.win32.findExecutable(await u.resolveAsync(i,r.process.name),r.process.cwd!==void 0?await u.resolveAsync(i,r.process.cwd):void 0,n)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(g,r,l){return T.win32.findExecutable(g,r,l)}};b=qe([We(0,L.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,R.IExtHostWorkspace),We(3,k.IExtHostDocumentsAndEditors),We(4,A.IExtHostConfiguration),We(5,D.IExtHostTerminalService),We(6,v.ILogService),We(7,m.IExtHostApiDeprecationService),We(8,p.IExtHostVariableResolverProvider)],b),e.ExtHostTask=b}),define(ye[298],Ce([1,0,88,49]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class T extends t.ExtHostVariableResolverProviderService{j(){return(0,c.homedir)()}}e.NodeExtHostVariableResolverProviderService=T}),define(ye[143],Ce([1,0,16,14,21,45,17,11,24,2,31]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(p,b,S,g){this.d=p,this.e=b,this.f=S,this.g=g,this.a=null,this.b=!1,this.c=0}search(p,b){const S=this.d.folderQueries||[],g=new T.CancellationTokenSource;return b.onCancellationRequested(()=>g.cancel()),new Promise((r,l)=>{this.a=new I(p);let s=!1;const a=(o,u)=>{if(!s&&!this.b){const i=this.h(o);m(o)&&typeof this.d.maxResults=="number"&&this.c+i>this.d.maxResults&&(this.b=!0,s=!0,g.cancel(),o=this.j(o,this.d.maxResults-this.c));const n=this.h(o);this.c+=n,(n>0||!m(o))&&this.a.add(o,u)}};Promise.all(S.map((o,u)=>this.k(o,i=>a(i,u),g.token))).then(o=>{g.dispose(),this.a.flush();const u=o.some(i=>!!i&&!!i.limitHit);r({limitHit:this.b||u,messages:(0,c.flatten)(o.map(i=>i?.message?Array.isArray(i.message)?i.message:[i.message]:[])),stats:{type:this.g}})},o=>{g.dispose();const u=(0,R.toErrorMessage)(o);l(new Error(u))})})}h(p){return m(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}j(p,b){const S=Array.isArray(p.ranges)?p.ranges:[p.ranges],g=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:S.slice(0,b),preview:{matches:g.slice(0,b),text:p.preview.text},uri:p.uri}}async k(p,b,S){const g=new L.QueryGlobTester(this.d,p),r=[],l={report:o=>{if(!this.l(o))return;const u=p.folder.scheme===k.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(o.uri))):void 0,i=y.relativePath(p.folder,o.uri);if(i){const n=g.includedInQuery(i,A.basename(i),u);(0,t.isThenable)(n)?r.push(n.then(h=>{h&&b(o)})):n&&b(o)}}},s=this.n(p),a=await this.e.provideTextSearchResults(w(this.d.contentPattern),s,l,S);return r.length&&await Promise.all(r),a}l(p){if(m(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(p){const b=(0,L.resolvePatternsForProvider)(this.d.includePattern,p.includePattern),S=(0,L.resolvePatternsForProvider)(this.d.excludePattern,p.excludePattern),g={folder:D.URI.from(p.folder),excludes:S,includes:b,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.f.toCanonicalName(p.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return g.usePCRE2=this.d.usePCRE2,g}}e.TextSearchManager=P;function w(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class I{constructor(p){this.e=p,this.b=-1,this.d=null,this.a=new d(512,b=>this.g(b))}add(p,b){this.d&&(this.b!==b||!y.isEqual(this.c,p.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:p.uri,results:[]}),this.d.results.push(v(p))}f(){const p=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,p)}flush(){this.f(),this.a.flush()}g(p){this.e(p)}}e.TextSearchResultsCollector=I;function v(f){return m(f)?{preview:{matches:(0,c.mapArrayOrNot)(f.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:f.preview.text},ranges:(0,c.mapArrayOrNot)(f.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function m(f){return!!f.preview}e.extensionResultIsMatch=m;class d{constructor(p,b){this.g=p,this.h=b,this.c=0,this.d=[],this.e=0}addItem(p,b){!p||this.j(p,b)}addItems(p,b){!p||this.k(p,b)}j(p,b){this.d.push(p),this.e+=b,this.l()}k(p,b){this.d=this.d.concat(p),this.e+=b,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=d,d.a=4e3,d.b=50}),define(ye[82],Ce([1,0,6,5,4,291,18,56,13,2,143]),function(te,e,c,t,T,R,k,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let P=class{constructor(m,d,f){this.k=m,this.l=d,this.n=f,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(m){return this.l.transformOutgoingScheme(m)}registerTextSearchProvider(m,d){if(this.g.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this.g.add(m);const f=this.d++;return this.e.set(f,d),this.c.$registerTextSearchProvider(f,this.o(m)),(0,c.toDisposable)(()=>{this.g.delete(m),this.e.delete(f),this.c.$unregisterProvider(f)})}registerFileSearchProvider(m,d){if(this.i.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this.i.add(m);const f=this.d++;return this.h.set(f,d),this.c.$registerFileSearchProvider(f,this.o(m)),(0,c.toDisposable)(()=>{this.i.delete(m),this.h.delete(f),this.c.$unregisterProvider(f)})}$provideFileSearchResults(m,d,f,p){const b=w(f),S=this.h.get(m);if(S)return this.j.fileSearch(b,S,g=>{this.c.$handleFileMatch(m,d,g.map(r=>r.resource))},p);throw new Error("unknown provider: "+m)}$clearCache(m){return this.j.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,d,f,p){const b=this.e.get(m);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const S=w(f);return this.q(S,b).search(r=>this.c.$handleTextMatch(m,d,r),p)}$enableExtensionHostSearch(){}q(m,d){return new L.TextSearchManager(m,d,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};P=qe([We(0,k.IExtHostRpcService),We(1,A.IURITransformerService),We(2,y.ILogService)],P),e.ExtHostSearch=P;function w(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(I),extraFileResources:v.extraFileResources&&v.extraFileResources.map(m=>D.URI.revive(m))}}e.reviveQuery=w;function I(v){return{...v,folder:D.URI.revive(v.folder)}}}),define(ye[299],Ce([1,0,89,142,34,139,35,41,59,42,79,81,82,99,55,74,141,75,48,98,96,60,140,13,236,49,97]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p,b,S,g,r,l,s,a,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,c.registerSingleton)(l.ILoggerService,r.ExtHostLoggerService,1),(0,c.registerSingleton)(l.ILogService,s.ExtHostLogService,1),(0,c.registerSingleton)(m.IExtHostApiDeprecationService,m.ExtHostApiDeprecationService,1),(0,c.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,c.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration,0),(0,c.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,0),(0,c.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,c.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,c.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,c.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,c.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,c.registerSingleton)(w.IExtHostSearch,w.ExtHostSearch,0),(0,c.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage,0),(0,c.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,c.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService,0),(0,c.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService,0),(0,c.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,0),(0,c.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace,0),(0,c.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,c.registerSingleton)(S.IExtHostTelemetry,S.ExtHostTelemetry,0),(0,c.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,0),(0,c.registerSingleton)(a.IExtHostVariableResolverProvider,a.ExtHostVariableResolverProviderService,0)}),define(ye[100],Ce([1,0,16,13,31,78]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function k(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=k;function A(P,w,I,v){const m=(0,c.mapArrayOrNot)(I,y),d=new T.TextSearchMatch(w,m,v),f=d.preview.matches;return{ranges:(0,c.mapArrayOrNot)(m,D),uri:P,preview:{text:d.preview.text,matches:(0,c.mapArrayOrNot)(f,D)}}}e.createTextSearchResult=A;function y(P){return new T.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function D(P){return new R.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let L=class{constructor(w,I){this.a=w,this.b=I}appendLine(w){this.b.debug(`${this.a}#search`,w)}};L=qe([We(1,t.ILogService)],L),e.OutputChannel=L}),define(ye[300],Ce([1,0,46,11,84,32,12,8,100,301]),function(te,e,c,t,T,R,k,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(b,S,g,r){const l=w(b,S,g,r),s=S.folder.fsPath;return{cmd:c.spawn(L,l.args,{cwd:s}),rgDiskPath:L,siblingClauses:l.siblingClauses,rgArgs:l,cwd:s}}e.spawnRipgrepCmd=P;function w(b,S,g,r){const l=["--files","--hidden","--case-sensitive"];v([S],g,!1).forEach(a=>{const o=(0,y.anchorGlob)(a);if(l.push("-g",o),k.isMacintosh){const u=(0,T.normalizeNFD)(o);u!==o&&l.push("-g",u)}});const s=I([S],r,void 0,!1);return s.globArgs.forEach(a=>{const o=`!${(0,y.anchorGlob)(a)}`;if(l.push("-g",o),k.isMacintosh){const u=(0,T.normalizeNFD)(o);u!==o&&l.push("-g",u)}}),S.disregardIgnoreFiles!==!1?l.push("--no-ignore"):S.disregardParentIgnoreFiles!==!1&&l.push("--no-ignore-parent"),S.ignoreSymlinks||l.push("--follow"),b.exists&&l.push("--quiet"),l.push("--no-config"),S.disregardGlobalIgnoreFiles&&l.push("--no-ignore-global"),{args:l,siblingClauses:s.siblingClauses}}function I(b,S,g,r=!0){const l=[];let s={};return b.forEach(a=>{const o=Object.assign({},a.excludePattern||{},S||{}),u=m(o,r?a.folder.fsPath:void 0,g);l.push(...u.globArgs),u.siblingClauses&&(s=Object.assign(s,u.siblingClauses))}),{globArgs:l,siblingClauses:s}}function v(b,S,g=!0){const r=[];return b.forEach(l=>{const s=Object.assign({},S||{},l.includePattern||{}),a=m(s,g?l.folder.fsPath:void 0);r.push(...a.globArgs)}),r}function m(b,S,g){const r=[],l={};return Object.keys(b).forEach(s=>{if(g&&g.has(s)||!s)return;const a=b[s];s=f(S?d(S,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof a=="boolean"&&a?(s.startsWith("\\\\")&&(s+="**"),r.push(p(s))):a&&a.when&&(l[s]=a)}),{globArgs:r,siblingClauses:l}}function d(b,S){return t.isAbsolute(S)?S:t.join(b,S)}e.getAbsoluteGlob=d;function f(b){return b=A.rtrim(b,"\\"),A.rtrim(b,"/")}function p(b){return R.getRoot(b).toLowerCase()==="c:/"?b.replace(/^c:[/\\]/i,"/"):b}e.fixDriveC=p}),define(ye[302],Ce([1,0,46,67,11,303,16,45,39,84,32,12,44,8,10,29,31,300,111]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const b=new Set;process.on("exit",()=>{b.forEach(s=>s())});class S{constructor(a){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=a,this.b=a.filePattern||"",this.d=a.includePattern&&y.parse(a.includePattern),this.f=a.maxResults||null,this.g=!!a.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,p.prepareQuery)(this.b).normalizedLowercase),this.u=a.excludePattern&&y.parse(a.excludePattern),this.t=new Map,a.folderQueries.forEach(o=>{const u=Object.assign({},o.excludePattern||{},this.a.excludePattern||{}),i=o.folder.fsPath;a.folderQueries.map(n=>n.folder.fsPath).filter(n=>n!==i).forEach(n=>{(0,L.isEqualOrParent)(n,i)&&(u[T.relative(i,n)]=!0)}),this.t.set(i,new r(u,i))})}cancel(){this.l=!0,b.forEach(a=>a())}walk(a,o,u,i,n){if(this.m=w.StopWatch.create(!1),this.l)return n(null,this.j);o.forEach(h=>{const E=T.basename(h.fsPath);this.u&&this.u(h.fsPath,E)||this.J(u,{relativePath:h.fsPath,searchPath:void 0})}),this.r=w.StopWatch.create(!1),this.w(a,(h,E)=>{this.x(this.y,this,h,u,i,C=>{if(C){const M=(0,A.toErrorMessage)(C);console.error(M),this.q.push(M),E(C,void 0)}else E(null,void 0)})},(h,E)=>{this.m.stop();const C=h?k.coalesce(h)[0]:null;n(C,this.j)})}w(a,o,u){const i=new Array(a.length),n=new Array(a.length);let h=!1,E=0;if(a.length===0)return u(null,[]);a.forEach((C,M)=>{o(C,(K,q)=>{if(K?(h=!0,i[M]=null,n[M]=K):(i[M]=q,n[M]=null),++E===a.length)return u(h?n:null,i)})})}x(a,o,...u){try{a.apply(o,u)}catch(i){u[u.length-1](i)}}y(a,o,u,i){const n=a.folder.fsPath,h=P.isMacintosh,E=()=>F&&F.kill();b.add(E);let C=z=>{b.delete(E),C=()=>{},i(z)},M="";const K=this.D(),q=(0,f.spawnRipgrepCmd)(this.a,a,this.a.includePattern,this.t.get(a.folder.fsPath).expression),F=q.cmd,B=!Object.keys(q.siblingClauses).length,O=q.rgArgs.args.map(z=>z.match(/^-/)?z:`'${z}'`).join(" ");let U=`${q.rgDiskPath} ${O}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),u({message:U}),this.s=0,this.z(F,"utf8",u,(z,j,ue)=>{if(z){C(z);return}if(this.j){C();return}const _=(M+(h?D.normalizeNFC(j||""):j)).split(`
`);if(ue){const J=_.length;_[J-1]=_[J-1].trim(),_[J-1]||_.pop()}else M=_.pop()||"";if(_.length&&_[0].indexOf(`
`)!==-1){C(new Error("Splitting up files failed"));return}if(this.s+=_.length,B){for(const J of _)if(this.J(o,{base:n,relativePath:J,searchPath:this.N(a,J)}),this.j){E();break}(ue||this.j)&&C();return}this.G(a,K,n,_,o),ue&&(this.H(K,n,o),C())})}spawnFindCmd(a){const o=this.t.get(a.folder.fsPath),u=o.getBasenameTerms(),i=o.getPathTerms(),n=["-L","."];if(u.length||i.length){n.push("-not","(","(");for(const h of u)n.push("-name",h),n.push("-o");for(const h of i)n.push("-path",h),n.push("-o");n.pop(),n.push(")","-prune",")")}return n.push("-type","f"),c.spawn("find",n,{cwd:a.folder.fsPath})}readStdout(a,o,u){let i="";this.z(a,o,()=>{},(n,h,E)=>{if(n){u(n);return}i+=h,E&&u(null,i)})}z(a,o,u,i){let n=(C,M,K)=>{(C||K)&&(n=()=>{},this.r?.stop()),i(C,M,K)},h=!1;a.stdout?(this.A(a.stdout,o,n),a.stdout.once("data",()=>h=!0)):u({message:"stdout is null"});let E;a.stderr?E=this.B(a.stderr):u({message:"stderr is null"}),a.on("error",C=>{n(C)}),a.on("close",C=>{let M;!h&&(M=this.C(E,o))&&l(M)?n(new Error(`command failed with error code ${C}: ${this.C(E,o)}`)):(this.g&&C===0&&(this.j=!0),n(null,"",!0))})}A(a,o,u){const i=new R.StringDecoder(o);return a.on("data",n=>{u(null,i.write(n))}),i}B(a){const o=[];return a.on("data",u=>{o.push(u)}),o}C(a,o){const u=new R.StringDecoder(o);return a.map(i=>u.write(i)).join("")}D(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}G(a,{pathToEntries:o},u,i,n){i.indexOf(this.b)!==-1&&this.J(n,{base:u,relativePath:this.b,searchPath:this.N(a,this.b)});const h=E=>{const C=T.basename(E),M=T.dirname(E);let K=o[M];K||(K=o[M]=[],h(M)),K.push({base:u,relativePath:E,basename:C,searchPath:this.N(a,E)})};i.forEach(h)}H({rootEntries:a,pathToEntries:o},u,i){const n=this,h=this.t.get(u),E=this.b;function C(M){n.o++;const K=(0,d.hasSiblingFn)(()=>M.map(q=>q.basename));for(let q=0,F=M.length;q<F;q++){const B=M[q],{relativePath:O,basename:U}=B;if(h.test(O,U,E!==U?K:void 0))continue;const z=o[O];if(z)C(z);else{if(n.p++,O===E)continue;n.J(i,B)}if(n.j)break}}C(a)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(a,o,u,i,n){const h=a.folder,E=(0,d.hasSiblingFn)(()=>u);this.w(u,(C,M)=>{if(this.l||this.j)return M(null);const K=o?[o,C].join(T.sep):C;if(this.t.get(a.folder.fsPath).test(K,C,this.a.filePattern!==C?E:void 0))return M(null);const q=[h.fsPath,K].join(T.sep);t.lstat(q,(F,B)=>{if(F||this.l||this.j)return M(null);this.L(q,B,(O,U)=>O||this.l||this.j?M(null):U.isDirectory()?(this.o++,this.M(q,B,(z,j)=>z||this.l||this.j||(j=j||"",this.v[j])?M(null):(this.v[j]=!0,m.Promises.readdir(q).then(ue=>{if(this.l||this.j)return M(null);this.I(a,K,ue,i,V=>M(V||null))},ue=>{M(null)})))):(this.p++,K===this.b||this.h&&v.isNumber(U.size)&&U.size>this.h||this.J(i,{base:h.fsPath,relativePath:K,searchPath:this.N(a,K)}),M(null,void 0)))})},C=>{const M=C&&k.coalesce(C);return n(M&&M.length>0?M[0]:void 0)})}J(a,o){this.K(o)&&(!this.d||this.d(o.relativePath,T.basename(o.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||a(o))}K(a){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.isFilePatternMatch)(a,this.c)}return!0}L(a,o,u){return o.isSymbolicLink()?t.stat(a,u):u(null,o)}M(a,o,u){return o.isSymbolicLink()?t.realpath(a,(i,n)=>i?u(i):u(null,n)):u(null,a)}N(a,o){return a.folderName?T.join(a.folderName,o):o}}e.FileWalker=S;class g{constructor(a){this.a=a.folderQueries,this.b=a.extraFileResources||[],this.c=new S(a)}search(a,o,u){this.c.walk(this.a,this.b,a,o,(i,n)=>{u(i,{limitHit:n,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=g;class r{constructor(a,o){this.expression=a,this.c=o,this.d(a)}d(a){let o,u;Object.keys(a).filter(i=>a[i]).forEach(i=>{T.isAbsolute(i)?(o=o||y.getEmptyExpression(),o[i]=a[i]):(u=u||y.getEmptyExpression(),u[i]=a[i])}),this.a=o&&y.parse(o,{trimForExclusions:!0}),this.b=u&&y.parse(u,{trimForExclusions:!0})}test(a,o,u){return this.b&&this.b(a,o,u)||this.a&&this.a(T.join(this.c,a),o,u)}getBasenameTerms(){const a=[];return this.a&&a.push(...y.getBasenameTerms(this.a)),this.b&&a.push(...y.getBasenameTerms(this.b)),a}getPathTerms(){const a=[];return this.a&&a.push(...y.getPathTerms(this.a)),this.b&&a.push(...y.getPathTerms(this.b)),a}}function l(s){const a=s.trim().split(`
`),o=a[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return I.uppercaseFirstLetter(a[a.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}}),define(ye[304],Ce([1,0,103,23]),function(te,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(a=>a===s)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,k=512,A=512*8,y=512*128;var D;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(a,o){super(a),this.decodeStreamErrorKind=o}}e.DecodeStreamError=L;class P{static async create(a){let o;if(a!==e.UTF8)o=(await new Promise((i,n)=>{te(["@vscode/iconv-lite-umd"],i,n)})).getDecoder(m(a));else{const u=new TextDecoder;o={write(i){return u.decode(i,{stream:!0})},end(){return u.decode()}}}return new P(o)}constructor(a){this.a=a}write(a){return this.a.write(a)}end(){return this.a.end()}}function w(s,a){const o=a.minBytesRequiredForDetection??a.guessEncoding?A:k;return new Promise((u,i)=>{const n=(0,c.newWriteableStream)(q=>q.join("")),h=[];let E=0,C,M;const K=async()=>{try{const q=await l({buffer:t.VSBuffer.concat(h),bytesRead:E},a.guessEncoding);if(q.seemsBinary&&a.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);q.encoding=await a.overwriteEncoding(q.encoding),C=await P.create(q.encoding);const F=C.write(t.VSBuffer.concat(h).buffer);n.write(F),h.length=0,E=0,u({stream:n,detected:q})}catch(q){M?.dispose(),n.destroy(),i(q)}};M=(0,c.listenStream)(s,{onData:async q=>{C?n.write(C.write(q.buffer)):(h.push(q),E+=q.byteLength,E>=o&&(s.pause(),await K(),setTimeout(()=>s.resume())))},onError:q=>n.error(q),onEnd:async()=>{C||await K(),n.end(C?.end())}})})}e.toDecodeStream=w;async function I(s,a,o){const i=(await new Promise((E,C)=>{te(["@vscode/iconv-lite-umd"],E,C)})).getEncoder(m(a),o);let n=!1,h=!1;return{read(){if(h)return null;const E=s.read();if(typeof E!="string"){if(h=!0,!n&&o?.addBOM)switch(a){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const C=i.end();return C&&C.length>0?(n=!0,t.VSBuffer.wrap(C)):null}return n=!0,t.VSBuffer.wrap(i.write(E))}}}e.toEncodeReadable=I;async function v(s){return(await new Promise((o,u)=>{te(["@vscode/iconv-lite-umd"],o,u)})).encodingExists(m(s))}e.encodingExists=v;function m(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=m;function d(s,a){if(!s||a<e.UTF16be_BOM.length)return null;const o=s.readUInt8(0),u=s.readUInt8(1);if(o===e.UTF16be_BOM[0]&&u===e.UTF16be_BOM[1])return e.UTF16be;if(o===e.UTF16le_BOM[0]&&u===e.UTF16le_BOM[1])return e.UTF16le;if(a<e.UTF8_BOM.length)return null;const i=s.readUInt8(2);return o===e.UTF8_BOM[0]&&u===e.UTF8_BOM[1]&&i===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const f=["ascii","utf-16","utf-32"];async function p(s){const a=await new Promise((h,E)=>{te(["jschardet"],h,E)}),o=s.slice(0,y),u=g(o.buffer),i=a.detect(u);if(!i||!i.encoding)return null;const n=i.encoding.toLowerCase();return 0<=f.indexOf(n)?null:S(i.encoding)}const b={ibm866:"cp866",big5:"cp950"};function S(s){const a=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[a]||a}function g(s){let a="";for(let o=0;o<s.length;o++)a+=String.fromCharCode(s[o]);return a}function r(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const a=s.match(/windows(\d+)/);return a?"windows-"+a[1]:s}}}e.toCanonicalName=r;function l({buffer:s,bytesRead:a},o){let u=d(s,a),i=!1;if(u!==e.UTF16be&&u!==e.UTF16le&&s){let n=!0,h=!0,E=!1;for(let C=0;C<a&&C<R;C++){const M=C%2===1,K=s.readUInt8(C)===0;if(K&&(E=!0),n&&(M&&!K||!M&&K)&&(n=!1),h&&(M&&K||!M&&!K)&&(h=!1),K&&!n&&!h)break}E&&(n?u=e.UTF16le:h?u=e.UTF16be:i=!0)}return o&&!i&&!u&&s?p(s.slice(0,a)).then(n=>({seemsBinary:!1,encoding:n})):{seemsBinary:i,encoding:u}}e.detectEncodingFromBuffer=l,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],Ce([1,0,304,29,143]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends T.TextSearchManager{constructor(A,y,D=t,L="searchProcess"){super(A,y,{readdir:P=>D.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,c.toCanonicalName)(P)},L)}}e.NativeTextSearchManager=R}),define(ye[305],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class c{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const R=this.a.get(T);return this.a.delete(T),R}}addDragOperationTransfer(T,R){this.a.set(T,R)}getRenderedTreeElement(T){if(this.b.has(T))return this.b.get(T)}addRenderedTreeItemElement(T,R){this.b.set(T,R)}removeRenderedTreeItemElement(T){this.b.has(T)&&this.b.delete(T)}}e.TreeviewsService=c}),define(ye[306],Ce([1,0,181,7,24,2,3,6,221,14,7,10,16,15,21,305,26]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(S,g){if((0,P.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let r;return Array.isArray(S.highlights)&&(r=S.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),r=r.length?r:void 0),{label:S.label,highlights:r}}}class p{constructor(g,r,l){this.d=g,this.e=r,this.f=l,this.a=new Map,this.b=new m.TreeviewsService;function s(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:a=>s(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(o=>s(o)?this.i(o):o):a})}registerTreeDataProvider(g,r,l){const s=this.createTreeView(g,{treeDataProvider:r},l);return{dispose:()=>s.dispose()}}createTreeView(g,r,l){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=r.dragAndDropController?.dropMimeTypes??[],a=r.dragAndDropController?.dragMimeTypes??[],o=!!r.dragAndDropController?.handleDrag,u=!!r.dragAndDropController?.handleDrop,i=this.h(g,r,l),n=this.d.$registerTreeViewDataProvider(g,{showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:s,dragMimeTypes:a,hasHandleDrag:o,hasHandleDrop:u});return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(l,"treeItemCheckbox"),i.onDidChangeCheckboxState},get message(){return i.message},set message(h){i.message=h},get title(){return i.title},set title(h){i.title=h},get description(){return i.description},set description(h){i.description=h},get badge(){return i.badge},set badge(h){h!==void 0&&L.ViewBadge.isViewBadge(h)?i.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(i.badge=void 0)},reveal:(h,E)=>i.reveal(h,E),dispose:async()=>{await n,this.a.delete(g),i.dispose()}}}$getChildren(g,r){const l=this.a.get(g);return l?l.getChildren(r):Promise.reject(new y.NoTreeViewError(g))}async $handleDrop(g,r,l,s,a,o,u,i){const n=this.a.get(g);if(!n)return Promise.reject(new y.NoTreeViewError(g));const h=I.DataTransfer.toDataTransfer(l,async E=>(await this.d.$resolveDropFileData(g,r,E)).buffer);return u===g&&i&&await this.g(h,n,i,a,o),n.onDrop(h,s,a)}async g(g,r,l,s,a){const o=this.b.removeDragOperationTransfer(a);if(o)(await o)?.forEach((u,i)=>{u&&g.set(i,u)});else if(a&&r.handleDrag){const u=r.handleDrag(l,g,s);this.b.addDragOperationTransfer(a,u),await u}return g}async $handleDrag(g,r,l,s){const a=this.a.get(g);if(!a)return Promise.reject(new y.NoTreeViewError(g));const o=await this.g(new t.DataTransfer,a,r,s,l);if(!!o)return I.DataTransfer.toDataTransferDTO(o)}async $hasResolve(g){const r=this.a.get(g);if(!r)throw new y.NoTreeViewError(g);return r.hasResolve}$resolve(g,r,l){const s=this.a.get(g);if(!s)throw new y.NoTreeViewError(g);return s.resolveTreeItem(r,l)}$setExpanded(g,r,l){const s=this.a.get(g);if(!s)throw new y.NoTreeViewError(g);s.setExpanded(r,l)}$setSelection(g,r){const l=this.a.get(g);if(!l)throw new y.NoTreeViewError(g);l.setSelection(r)}$setFocus(g,r){const l=this.a.get(g);if(!l)throw new y.NoTreeViewError(g);l.setFocus(r)}$setVisible(g,r){const l=this.a.get(g);if(!l)throw new y.NoTreeViewError(g);l.setVisible(r)}$changeCheckboxState(g,r){const l=this.a.get(g);if(!l)throw new y.NoTreeViewError(g);l.setCheckboxState(r)}h(g,r,l){const s=new b(g,r,this.d,this.e.converter,this.f,l);return this.a.set(g,s),s}i(g){const r=this.a.get(g.$treeViewId);return r&&"$treeItemHandle"in g?r.getExtensionElement(g.$treeItemHandle):r&&"$focusedTreeItem"in g&&g.$focusedTreeItem?r.focusedElement:null}}e.ExtHostTreeViews=p;class b extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,P.isUndefinedOrNull)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,r,l,s,a,o){if(super(),this.C=g,this.D=l,this.F=s,this.G=a,this.H=o,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new k.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new k.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new k.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new k.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new k.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new k.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new v.CancellationTokenSource,o.contributes&&o.contributes.views)for(const n in o.contributes.views)for(const h of o.contributes.views[n])h.id===g&&(this.J=h.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let u,i;this.B(k.Event.debounce(this.w.event,(n,h)=>(n||(n={message:!1,elements:[]}),h.element!==!1&&(u||(u=new Promise(E=>i=E),this.y=this.y.then(()=>u)),Array.isArray(h.element)?n.elements.push(...h.element):n.elements.push(h.element)),h.message&&(n.message=!0),n),200,!0)(({message:n,elements:h})=>{h.length&&(this.z=this.z.then(()=>{const E=i;return u=null,this.U(h).then(()=>E())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(g){const r=g?this.getExtensionElement(g):void 0;if(g&&!r)return this.G.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let l=this.Q(g);return l||(l=await this.R(r)),l?l.map(s=>s.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,r){r=r||{select:!0,focus:!1};const l=(0,P.isUndefinedOrNull)(r.select)?!0:r.select,s=(0,P.isUndefinedOrNull)(r.focus)?!1:r.focus,a=(0,P.isUndefinedOrNull)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.y.then(()=>this.N(g)).then(o=>this.P(g,o[o.length-1]).then(u=>this.D.$reveal(this.C,{item:u.item,parentChain:o.map(i=>i.item)},{select:l,focus:s,expand:a})),o=>this.G.error(o)):this.D.$reveal(this.C,void 0,{select:l,focus:s,expand:a})}get message(){return this.I}set message(g){this.I=g,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(g){this.J=g,this.D.$setTitle(this.C,g,this.L)}get description(){return this.L}set description(g){this.L=g,this.D.$setTitle(this.C,this.J,g)}get badge(){return this.M}set badge(g){this.M?.value===g?.value&&this.M?.tooltip===g?.tooltip||(this.M=I.ViewBadge.from(g),this.D.$setBadge(this.C,g))}setExpanded(g,r){const l=this.getExtensionElement(g);l&&(r?this.r.fire(Object.freeze({element:l})):this.s.fire(Object.freeze({element:l})))}setSelection(g){(0,w.equals)(this.l,g)||(this.l=g,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(g){this.m=g}setVisible(g){g!==this.k&&(this.k=g,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const r=(await Promise.all(g.map(async l=>{const s=this.getExtensionElement(l.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:l.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(l=>l!==void 0);r.forEach(l=>{l.treeItem.checkboxState=l.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.v.fire({items:r.map(l=>[l.extensionItem,l.newState])})}async handleDrag(g,r,l){const s=[];for(const a of g){const o=this.getExtensionElement(a);o&&s.push(o)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,r,l),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,r,l){const s=r?this.getExtensionElement(r):void 0;if(!(!s&&r||!this.g?.handleDrop))return(0,D.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,g,l):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,r){if(!this.f.resolveTreeItem)return;const l=this.i.get(g);if(l){const s=this.j.get(l);if(s){const a=await this.f.resolveTreeItem(s.extensionItem,l,r)??s.extensionItem;return this.db(a),s.item.tooltip=this.ab(a.tooltip),s.item.command=this.bb(s.disposableStore,a.command),s.item}}}N(g){return this.O(g).then(r=>r?this.N(r).then(l=>this.P(r,l[l.length-1]).then(s=>(l.push(s),l))):Promise.resolve([]))}O(g){const r=this.j.get(g);return r?Promise.resolve(r.parent?this.i.get(r.parent.item.handle):void 0):(0,D.asPromise)(()=>this.f.getParent(g))}P(g,r){const l=this.j.get(g);return l?Promise.resolve(l):(0,D.asPromise)(()=>this.f.getTreeItem(g)).then(s=>this.gb(g,s,r,!0)).then(s=>this.getChildren(r?r.item.handle:void 0).then(()=>{const a=this.getExtensionElement(s);if(a){const o=this.j.get(a);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(g){if(g){let r;if(typeof g=="string"){const l=this.getExtensionElement(g);r=l?this.j.get(l):void 0}else r=g;return r&&r.children||void 0}return this.h}async R(g){this.nb(g);const r=new v.CancellationTokenSource(this.S.token);try{const l=g?this.j.get(g):void 0,s=await this.f.getChildren(g);if(r.token.isCancellationRequested)return;const a=await Promise.all((0,w.coalesce)(s||[]).map(async o=>{const u=await this.f.getTreeItem(o);return u&&!r.token.isCancellationRequested?this.Z(o,u,l):null}));return r.token.isCancellationRequested?void 0:(0,w.coalesce)(a)}finally{r.dispose()}}U(g){if(g.some(l=>!l))return this.S.dispose(!0),this.S=new v.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const l=this.W(g);if(l.length)return this.X(l)}return Promise.resolve(void 0)}W(g){const r=new Set,l=g.map(a=>this.j.get(a));for(const a of l)if(a&&!r.has(a.item.handle)){let o=a;for(;o&&o.parent&&l.findIndex(u=>o&&o.parent&&u&&u.item.handle===o.parent.item.handle)===-1;){const u=this.i.get(o.parent.item.handle);o=u?this.j.get(u):void 0}o&&!o.parent&&r.add(a.item.handle)}const s=[];return r.forEach(a=>{const o=this.i.get(a);if(o){const u=this.j.get(o);u&&(!u.parent||!r.has(u.parent.item.handle))&&s.push(a)}}),s}X(g){const r={};return Promise.all(g.map(l=>this.Y(l).then(s=>{s&&(r[l]=s.item)}))).then(()=>Object.keys(r).length?this.D.$refresh(this.C,r):void 0)}Y(g){const r=this.getExtensionElement(g);if(r){const l=this.j.get(r);if(l)return this.nb(r),(0,D.asPromise)(()=>this.f.getTreeItem(r)).then(s=>{if(s){const a=this.eb(r,s,l.parent);return this.lb(r,a,l,l.parent),l.dispose(),a}return null})}return Promise.resolve(null)}Z(g,r,l){const s=this.eb(g,r,l);if(r.id&&this.i.has(s.item.handle))throw new Error((0,c.localize)(0,null,r.id));return this.kb(g,s),this.mb(s,l),s}ab(g){return L.MarkdownString.isMarkdownString(g)?I.MarkdownString.from(g):g}bb(g,r){return r?{...this.F.toInternal(r,g),originalId:r.command}:void 0}cb(g){if(!g.checkboxState)return;let r,l;return typeof g.checkboxState=="number"?r=g.checkboxState:(r=g.checkboxState.state,l=g.checkboxState.tooltip),{isChecked:r===L.TreeItemCheckboxState.Checked,tooltip:l}}db(g){if(!L.TreeItem.isTreeItem(g,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(g,r,l){this.db(r);const s=new A.DisposableStore,a=this.gb(g,r,l),o=this.hb(r);return{item:{handle:a,parentHandle:l?l.item.handle:void 0,label:f(r.label,this.H),description:r.description,resourceUri:r.resourceUri,tooltip:this.ab(r.tooltip),command:this.bb(s,r.command),contextValue:r.contextValue,icon:o,iconDark:this.ib(r)||o,themeIcon:this.fb(r),collapsibleState:(0,P.isUndefinedOrNull)(r.collapsibleState)?L.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.cb(r)},extensionItem:r,parent:l,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(g){return g.iconPath instanceof L.ThemeIcon?g.iconPath:void 0}gb(g,{id:r,label:l,resourceUri:s},a,o){if(r)return`${b.b}/${r}`;const u=f(l,this.H),i=a?a.item.handle:b.a;let n=u?u.label:s?(0,T.basename)(s):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const h=this.j.has(g)?this.j.get(g).item.handle:void 0,E=this.Q(a)||[];let C,M=0;do{if(C=`${i}/${M}:${n}`,o||!this.i.has(C)||h===C)break;M++}while(M<=E.length);return C}hb(g){if(g.iconPath&&!(g.iconPath instanceof L.ThemeIcon))return typeof g.iconPath=="string"||R.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof L.ThemeIcon)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return R.URI.isUri(g)?g:R.URI.file(g)}kb(g,r){this.i.set(r.item.handle,g),this.j.set(g,r)}lb(g,r,l,s){this.i.delete(r.item.handle),this.j.delete(g),r.item.handle!==l.item.handle&&this.i.delete(l.item.handle),this.kb(g,r);const a=this.Q(s)||[],o=a.filter(u=>u.item.handle===l.item.handle)[0];o&&a.splice(a.indexOf(o),1,r)}mb(g,r){r?(r.children||(r.children=[]),r.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const r=this.j.get(g);if(r){if(r.children)for(const l of r.children){const s=this.i.get(l.item.handle);s&&this.ob(s)}r.children=void 0}}else this.pb()}ob(g){const r=this.j.get(g);if(r){if(r.children)for(const l of r.children){const s=this.i.get(l.item.handle);s&&this.ob(s)}this.j.delete(g),this.i.delete(r.item.handle),r.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(ye[307],Ce([1,0,21,9,3,38,2,121,107,152,163,40,5,95,250,249,41,251,35,253,254,255,238,256,59,43,257,258,261,262,263,142,241,268,269,270,99,42,272,306,15,7,70,275,77,141,34,229,260,69,139,79,81,82,13,56,18,25,264,237,55,74,247,273,76,75,278,276,277,248,48,271,274,98,60,96,265,78,266,17,125,240,217,259,6,26,222,97,214,267]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p,b,S,g,r,l,s,a,o,u,i,n,h,E,C,M,K,q,F,B,O,U,z,j,ue,V,_,J,ne,ee,X,G,de,be,Ee,Pe,Fe,se,oe,fe,Z,ce,ie,N,H,Q,Y,he,we,Ae,pe,De,ke,je,Ge,et,Qe,nt,st,ht,Me,it,ae,$,le,Ie,Le,Be,Xe,Ze,gt,mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function lt(ot){const rt=ot.get(fe.IExtHostInitDataService),kt=ot.get(ke.IExtHostFileSystemInfo),Tt=ot.get(he.IExtHostConsumerFileSystem),Nt=ot.get(a.IExtHostExtensionService),pt=ot.get(ne.IExtHostWorkspace),Dt=ot.get(nt.IExtHostTelemetry),$t=ot.get(p.IExtHostConfiguration),Ft=ot.get(se.IURITransformerService),xe=ot.get(oe.IExtHostRpcService),Mt=ot.get(F.IExtHostStorage),Ut=ot.get(Y.IExtensionStoragePaths),Bt=ot.get(Fe.ILoggerService),wt=ot.get(Fe.ILogService),Pt=ot.get(ie.IExtHostTunnelService),Re=ot.get(N.IExtHostApiDeprecationService),Oe=ot.get(J.IExtHostWindow),Se=ot.get(et.IExtHostSecretState),re=ot.get(Qe.IExtHostEditorTabs);xe.set(w.ExtHostContext.ExtHostFileSystemInfo,kt),xe.set(w.ExtHostContext.ExtHostLogLevelServiceShape,Bt),xe.set(w.ExtHostContext.ExtHostWorkspace,pt),xe.set(w.ExtHostContext.ExtHostConfiguration,$t),xe.set(w.ExtHostContext.ExtHostExtensionService,Nt),xe.set(w.ExtHostContext.ExtHostStorage,Mt),xe.set(w.ExtHostContext.ExtHostTunnelService,Pt),xe.set(w.ExtHostContext.ExtHostWindow,Oe),xe.set(w.ExtHostContext.ExtHostSecretState,Se),xe.set(w.ExtHostContext.ExtHostTelemetry,Dt),xe.set(w.ExtHostContext.ExtHostEditorTabs,re);const Ne=xe.set(w.ExtHostContext.ExtHostDecorations,ot.get(de.IExtHostDecorations)),ze=xe.set(w.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(s.IExtHostDocumentsAndEditors)),_e=xe.set(w.ExtHostContext.ExtHostCommands,ot.get(d.IExtHostCommands)),Ve=xe.set(w.ExtHostContext.ExtHostTerminalService,ot.get(B.IExtHostTerminalService)),tt=xe.set(w.ExtHostContext.ExtHostDebugService,ot.get(Ee.IExtHostDebugService)),St=xe.set(w.ExtHostContext.ExtHostSearch,ot.get(Pe.IExtHostSearch)),Et=xe.set(w.ExtHostContext.ExtHostTask,ot.get(be.IExtHostTask)),Lt=xe.set(w.ExtHostContext.ExtHostOutputService,ot.get(E.IExtHostOutputService)),vt=xe.set(w.ExtHostContext.ExtHostLocalization,ot.get(Ze.IExtHostLocalizationService)),It=xe.set(w.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(xe)),ft=xe.set(w.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(xe,ze)),Gt=xe.set(w.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(xe,ze,wt)),jt=xe.set(w.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(wt,ft,xe.getProxy(w.MainContext.MainThreadBulkEdits))),yt=xe.set(w.ExtHostContext.ExtHostNotebook,new Z.ExtHostNotebookController(xe,_e,ze,ft)),Qt=xe.set(w.ExtHostContext.ExtHostNotebookDocuments,new le.ExtHostNotebookDocuments(yt)),sn=xe.set(w.ExtHostContext.ExtHostNotebookEditors,new $.ExtHostNotebookEditors(wt,yt)),en=xe.set(w.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(xe,rt,yt,_e,wt)),vn=xe.set(w.ExtHostContext.ExtHostNotebookRenderers,new Me.ExtHostNotebookRenderers(xe,yt)),At=xe.set(w.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(xe,ze)),on=xe.set(w.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(xe.getProxy(w.MainContext.MainThreadTreeViews),_e,wt)),Vt=xe.set(w.ExtHostContext.ExtHostEditorInsets,new ee.ExtHostEditorInsets(xe.getProxy(w.MainContext.MainThreadEditorInsets),At,rt.remote)),tn=xe.set(w.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(xe,wt,kt,ze)),an=xe.set(w.ExtHostContext.ExtHostLanguages,new n.ExtHostLanguages(xe,ft,_e.converter,Ft)),ut=xe.set(w.ExtHostContext.ExtHostLanguageFeatures,new i.ExtHostLanguageFeatures(xe,Ft,ft,_e,tn,wt,Re,Dt)),On=xe.set(w.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(xe,ut)),_t=xe.set(w.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(xe,wt,ze)),Wt=xe.set(w.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(xe,pt,_e)),cn=xe.set(w.ExtHostContext.ExtHostSCM,new K.ExtHostSCM(xe,_e,wt)),En=xe.set(w.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(xe,_e,ft)),ln=xe.set(w.ExtHostContext.ExtHostProgress,new C.ExtHostProgress(xe.getProxy(w.MainContext.MainThreadProgress))),Sn=xe.set(w.ExtHostContext.ExtHosLabelService,new X.ExtHostLabelService(xe)),un=xe.set(w.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(xe)),nn=xe.set(w.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(xe)),yn=xe.set(w.ExtHostContext.ExtHostTimeline,new Q.ExtHostTimeline(xe,_e)),rn=xe.set(w.ExtHostContext.ExtHostWebviews,new _.ExtHostWebviews(xe,rt.remote,pt,wt,Re)),Cn=xe.set(w.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(xe,rn,pt)),Dn=xe.set(w.ExtHostContext.ExtHostCustomEditors,new Ae.ExtHostCustomEditors(xe,ft,Ut,rn,Cn)),In=xe.set(w.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(xe,rn)),Yt=xe.set(w.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(xe,_e,ze)),kn=xe.set(w.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(xe)),zn=xe.set(w.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(xe));xe.set(w.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(xe,yt,ze,_e,wt));const Tn=Object.values(w.ExtHostContext);xe.assertRegistered(Tn);const Pn=new De.ExtHostBulkEdits(xe,ze),Wn=new m.ExtHostClipboard(xe),An=new h.ExtHostMessageService(xe,wt),Nn=new S.ExtHostDialogs(xe),Fn=new q.ExtHostStatusBar(xe,_e.converter);return v.ExtHostApiCommands.register(_e),function(He,Kt,dn){const bt=function(){let ge=!He.isUnderDevelopment;function ve(){ge||(wt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function $e(at){if(Array.isArray(at))at.forEach($e);else if(typeof at=="string")ve();else{const Ct=at;typeof Ct.scheme>"u"&&ve(),typeof Ct.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),Hn={getSession(ge,ve,$e){return nn.getSession(He,ge,ve,$e)},async hasSession(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"authSession"),!!await nn.getSession(He,ge,ve,{silent:!0})},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(ge,ve,$e,at){return nn.registerAuthenticationProvider(ge,ve,$e,at)}},jn={registerCommand(ge,ve,$e){return _e.registerCommand(!0,ge,ve,$e,void 0,He)},registerTextEditorCommand(ge,ve,$e){return _e.registerCommand(!0,ge,(...at)=>{const Ct=At.getActiveTextEditor();if(!Ct){wt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return Ct.edit(Rt=>{ve.apply($e,[Ct,Rt,...at])}).then(Rt=>{Rt||wt.warn("Edits from command "+ge+" were not applied.")},Rt=>{wt.warn("An error occurred while running command "+ge,Rt)})},void 0,void 0,He)},registerDiffInformationCommand:(ge,ve,$e)=>((0,Be.checkProposedApiEnabled)(He,"diffCommand"),_e.registerCommand(!0,ge,async(...at)=>{const Ct=ze.activeEditor(!0);if(!Ct){wt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Ct.id);ve.apply($e,[Rt,...at])},void 0,void 0,He)),executeCommand(ge,...ve){return _e.executeCommand(ge,...ve)},getCommands(ge=!1){return _e.getCommands(ge)}},Mn={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return Wn.value},get shell(){return Ve.getDefaultShell(!1)},get onDidChangeShell(){return(0,Be.checkProposedApiEnabled)(He,"envShellEvent"),Ve.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge){return(0,Be.checkProposedApiEnabled)(He,"telemetryLogger"),Dt.instantiateLogger(He,ge)},openExternal(ge,ve){return Oe.openUri(ge,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===rt.environment.appUriScheme)return It.createAppUri(ge);try{return await Oe.asExternalUri(ge,{allowTunneling:!!rt.remote.authority})}catch(ve){if((0,ae.matchesScheme)(ge,it.Schemas.http)||(0,ae.matchesScheme)(ge,it.Schemas.https))return ge;throw ve}},get remoteName(){return(0,G.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(He,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return wt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Mn);const hn={createTestController(ge,ve,$e){return Yt.createTestController(He,ge,ve,$e)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Yt.createTestObserver()},runTests(ge){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Yt.runTests(ge)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Yt.results}},fn=rt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,Vn={getExtension(ge,ve){(0,Be.isProposedApiEnabled)(He,"extensionsAny")||(ve=!1);const $e=Kt.mine.getExtensionDescription(ge);if($e)return new a.Extension(Nt,He.identifier,$e,fn,!1);if(ve){const at=Kt.all.getExtensionDescription(ge);if(at)return new a.Extension(Nt,He.identifier,at,fn,!0)}},get all(){const ge=[];for(const ve of Kt.mine.getAllExtensionDescriptions())ge.push(new a.Extension(Nt,He.identifier,ve,fn,!1));return ge},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(He,"extensionsAny");const ge=new Be.ExtensionIdentifierSet(Kt.mine.getAllExtensionDescriptions().map($e=>$e.identifier)),ve=[];for(const $e of Kt.all.getAllExtensionDescriptions()){const at=!ge.has($e.identifier);ve.push(new a.Extension(Nt,He.identifier,$e,fn,at))}return ve},get onDidChange(){return(0,Be.isProposedApiEnabled)(He,"extensionsAny")?T.Event.any(Kt.mine.onDidChange,Kt.all.onDidChange):Kt.mine.onDidChange}},qn={createDiagnosticCollection(ge){return tn.createDiagnosticCollection(He.identifier,ge)},get onDidChangeDiagnostics(){return tn.onDidChangeDiagnostics},getDiagnostics:ge=>tn.getDiagnostics(ge),getLanguages(){return an.getLanguages()},setTextDocumentLanguage(ge,ve){return an.changeLanguage(ge.uri,ve)},match(ge,ve){const $e=ft.getDocumentData(ve.uri)?.notebook;return(0,L.score)(z.LanguageSelector.from(ge),ve.uri,ve.languageId,!0,$e?.uri,$e?.notebookType)},registerCodeActionsProvider(ge,ve,$e){return ut.registerCodeActionProvider(He,bt(ge),ve,$e)},registerDocumentPasteEditProvider(ge,ve,$e){return(0,Be.checkProposedApiEnabled)(He,"documentPaste"),ut.registerDocumentPasteEditProvider(He,bt(ge),ve,$e)},registerCodeLensProvider(ge,ve){return ut.registerCodeLensProvider(He,bt(ge),ve)},registerDefinitionProvider(ge,ve){return ut.registerDefinitionProvider(He,bt(ge),ve)},registerDeclarationProvider(ge,ve){return ut.registerDeclarationProvider(He,bt(ge),ve)},registerImplementationProvider(ge,ve){return ut.registerImplementationProvider(He,bt(ge),ve)},registerTypeDefinitionProvider(ge,ve){return ut.registerTypeDefinitionProvider(He,bt(ge),ve)},registerHoverProvider(ge,ve){return ut.registerHoverProvider(He,bt(ge),ve,He.identifier)},registerEvaluatableExpressionProvider(ge,ve){return ut.registerEvaluatableExpressionProvider(He,bt(ge),ve,He.identifier)},registerInlineValuesProvider(ge,ve){return ut.registerInlineValuesProvider(He,bt(ge),ve,He.identifier)},registerDocumentHighlightProvider(ge,ve){return ut.registerDocumentHighlightProvider(He,bt(ge),ve)},registerLinkedEditingRangeProvider(ge,ve){return ut.registerLinkedEditingRangeProvider(He,bt(ge),ve)},registerReferenceProvider(ge,ve){return ut.registerReferenceProvider(He,bt(ge),ve)},registerRenameProvider(ge,ve){return ut.registerRenameProvider(He,bt(ge),ve)},registerDocumentSymbolProvider(ge,ve,$e){return ut.registerDocumentSymbolProvider(He,bt(ge),ve,$e)},registerWorkspaceSymbolProvider(ge){return ut.registerWorkspaceSymbolProvider(He,ge)},registerDocumentFormattingEditProvider(ge,ve){return ut.registerDocumentFormattingEditProvider(He,bt(ge),ve)},registerDocumentRangeFormattingEditProvider(ge,ve){return ut.registerDocumentRangeFormattingEditProvider(He,bt(ge),ve)},registerOnTypeFormattingEditProvider(ge,ve,$e,...at){return ut.registerOnTypeFormattingEditProvider(He,bt(ge),ve,[$e].concat(at))},registerDocumentSemanticTokensProvider(ge,ve,$e){return ut.registerDocumentSemanticTokensProvider(He,bt(ge),ve,$e)},registerDocumentRangeSemanticTokensProvider(ge,ve,$e){return ut.registerDocumentRangeSemanticTokensProvider(He,bt(ge),ve,$e)},registerSignatureHelpProvider(ge,ve,$e,...at){return typeof $e=="object"?ut.registerSignatureHelpProvider(He,bt(ge),ve,$e):ut.registerSignatureHelpProvider(He,bt(ge),ve,typeof $e>"u"?[]:[$e,...at])},registerCompletionItemProvider(ge,ve,...$e){return ut.registerCompletionItemProvider(He,bt(ge),ve,$e)},registerInlineCompletionItemProvider(ge,ve){return ve.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(He,bt(ge),ve)},registerDocumentLinkProvider(ge,ve){return ut.registerDocumentLinkProvider(He,bt(ge),ve)},registerColorProvider(ge,ve){return ut.registerColorProvider(He,bt(ge),ve)},registerFoldingRangeProvider(ge,ve){return ut.registerFoldingRangeProvider(He,bt(ge),ve)},registerSelectionRangeProvider(ge,ve){return ut.registerSelectionRangeProvider(He,ge,ve)},registerCallHierarchyProvider(ge,ve){return ut.registerCallHierarchyProvider(He,ge,ve)},registerTypeHierarchyProvider(ge,ve){return ut.registerTypeHierarchyProvider(He,ge,ve)},setLanguageConfiguration:(ge,ve)=>ut.setLanguageConfiguration(He,ge,ve),getTokenInformationAtPosition(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"tokenInformation"),an.tokenAtPosition(ge,ve)},registerInlayHintsProvider(ge,ve){return ut.registerInlayHintsProvider(He,ge,ve)},createLanguageStatusItem(ge,ve){return an.createLanguageStatusItem(He,ge,ve)},registerDocumentDropEditProvider(ge,ve){return ut.registerDocumentOnDropEditProvider(He,ge,ve)}},Gn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ve.activeTerminal},get terminals(){return Ve.terminals},async showTextDocument(ge,ve,$e){const at=await(k.URI.isUri(ge)?Promise.resolve(mn.openTextDocument(ge)):Promise.resolve(ge));return At.showTextDocument(at,ve,$e)},createTextEditorDecorationType(ge){return At.createTextEditorDecorationType(He,ge)},onDidChangeActiveTextEditor(ge,ve,$e){return At.onDidChangeActiveTextEditor(ge,ve,$e)},onDidChangeVisibleTextEditors(ge,ve,$e){return At.onDidChangeVisibleTextEditors(ge,ve,$e)},onDidChangeTextEditorSelection(ge,ve,$e){return At.onDidChangeTextEditorSelection(ge,ve,$e)},onDidChangeTextEditorOptions(ge,ve,$e){return At.onDidChangeTextEditorOptions(ge,ve,$e)},onDidChangeTextEditorVisibleRanges(ge,ve,$e){return At.onDidChangeTextEditorVisibleRanges(ge,ve,$e)},onDidChangeTextEditorViewColumn(ge,ve,$e){return At.onDidChangeTextEditorViewColumn(ge,ve,$e)},onDidCloseTerminal(ge,ve,$e){return Ve.onDidCloseTerminal(ge,ve,$e)},onDidOpenTerminal(ge,ve,$e){return Ve.onDidOpenTerminal(ge,ve,$e)},onDidChangeActiveTerminal(ge,ve,$e){return Ve.onDidChangeActiveTerminal(ge,ve,$e)},onDidChangeTerminalDimensions(ge,ve,$e){return(0,Be.checkProposedApiEnabled)(He,"terminalDimensions"),Ve.onDidChangeTerminalDimensions(ge,ve,$e)},onDidChangeTerminalState(ge,ve,$e){return Ve.onDidChangeTerminalState(ge,ve,$e)},onDidWriteTerminalData(ge,ve,$e){return(0,Be.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Ve.onDidWriteTerminalData(ge,ve,$e)},get state(){return Oe.state},onDidChangeWindowState(ge,ve,$e){return Oe.onDidChangeWindowState(ge,ve,$e)},showInformationMessage(ge,...ve){return An.showMessage(He,R.default.Info,ge,ve[0],ve.slice(1))},showWarningMessage(ge,...ve){return An.showMessage(He,R.default.Warning,ge,ve[0],ve.slice(1))},showErrorMessage(ge,...ve){return An.showMessage(He,R.default.Error,ge,ve[0],ve.slice(1))},showQuickPick(ge,ve,$e){return Wt.showQuickPick(ge,ve,$e)},showWorkspaceFolderPick(ge){return Wt.showWorkspaceFolderPick(ge)},showInputBox(ge,ve){return Wt.showInput(ge,ve)},showOpenDialog(ge){return Nn.showOpenDialog(ge)},showSaveDialog(ge){return Nn.showSaveDialog(ge)},createStatusBarItem(ge,ve,$e){let at,Ct,Rt;return typeof ge=="string"?(at=ge,Ct=ve,Rt=$e):(Ct=ge,Rt=ve),Fn.createStatusBarEntry(He,at,Ct,Rt)},setStatusBarMessage(ge,ve){return Fn.setStatusBarMessage(ge,ve)},withScmProgress(ge){return Re.report("window.withScmProgress",He,"Use 'withProgress' instead."),ln.withProgress(He,{location:j.ProgressLocation.SourceControl},(ve,$e)=>ge({report(at){}}))},withProgress(ge,ve){return ln.withProgress(He,ge,ve)},createOutputChannel(ge,ve){return Lt.createOutputChannel(ge,ve,He)},createWebviewPanel(ge,ve,$e,at){return Cn.createWebviewPanel(He,ge,ve,$e,at)},createWebviewTextEditorInset(ge,ve,$e,at){return(0,Be.checkProposedApiEnabled)(He,"editorInsets"),Vt.createWebviewEditorInset(ge,ve,$e,at,He)},createTerminal(ge,ve,$e){return typeof ge=="object"?"pty"in ge?Ve.createExtensionTerminal(ge):Ve.createTerminalFromOptions(ge):Ve.createTerminal(ge,ve,$e)},registerTerminalLinkProvider(ge){return Ve.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ve){return Ve.registerProfileProvider(He,ge,ve)},registerTerminalQuickFixProvider(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"terminalQuickFixProvider"),Ve.registerTerminalQuickFixProvider(ge,He.identifier.value,ve)},registerTreeDataProvider(ge,ve){return on.registerTreeDataProvider(ge,ve,He)},createTreeView(ge,ve){return on.createTreeView(ge,ve,He)},registerWebviewPanelSerializer:(ge,ve)=>Cn.registerWebviewPanelSerializer(He,ge,ve),registerCustomEditorProvider:(ge,ve,$e={})=>Dn.registerCustomEditorProvider(He,ge,ve,$e),registerFileDecorationProvider(ge){return Ne.registerFileDecorationProvider(ge,He)},registerUriHandler(ge){return It.registerUriHandler(He.identifier,ge)},createQuickPick(){return Wt.createQuickPick(He)},createInputBox(){return Wt.createInputBox(He)},get activeColorTheme(){return un.activeColorTheme},onDidChangeActiveColorTheme(ge,ve,$e){return un.onDidChangeActiveColorTheme(ge,ve,$e)},registerWebviewViewProvider(ge,ve,$e){return In.registerWebviewViewProvider(He,ge,ve,$e?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ve,$e){return yt.onDidChangeActiveNotebookEditor(ge,ve,$e)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,ve,$e){return sn.onDidChangeNotebookEditorSelection(ge,ve,$e)},onDidChangeNotebookEditorVisibleRanges(ge,ve,$e){return sn.onDidChangeNotebookEditorVisibleRanges(ge,ve,$e)},showNotebookDocument(ge,ve){return yt.showNotebookDocument(ge,ve)},registerExternalUriOpener(ge,ve,$e){return(0,Be.checkProposedApiEnabled)(He,"externalUriOpener"),kn.registerExternalUriOpener(He.identifier,ge,ve,$e)},registerProfileContentHandler(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"profileContentHandlers"),zn.registrProfileContentHandler(He,ge,ve)},get tabGroups(){return re.tabGroups}},mn={get rootPath(){return Re.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(ge){throw t.readonly()},getWorkspaceFolder(ge){return pt.getWorkspaceFolder(ge)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(ge){throw t.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(ge){throw t.readonly()},updateWorkspaceFolders:(ge,ve,...$e)=>pt.updateWorkspaceFolders(He,ge,ve||0,...$e),onDidChangeWorkspaceFolders:function(ge,ve,$e){return pt.onDidChangeWorkspace(ge,ve,$e)},asRelativePath:(ge,ve)=>pt.getRelativePath(ge,ve),findFiles:(ge,ve,$e,at)=>pt.findFiles(ge,ve,$e,He.identifier,at),findTextInFiles:(ge,ve,$e,at)=>{(0,Be.checkProposedApiEnabled)(He,"findTextInFiles");let Ct,Rt;return typeof ve=="object"?(Ct=ve,Rt=$e):(Ct={},Rt=ve,at=$e),pt.findTextInFiles(ge,Ct||{},Rt,He.identifier,at)},saveAll:ge=>pt.saveAll(ge),applyEdit(ge,ve){return Pn.applyWorkspaceEdit(ge,He,ve)},createFileSystemWatcher:(ge,ve,$e,at)=>_t.createFileSystemWatcher(pt,He,ge,ve,$e,at),get textDocuments(){return ft.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw t.readonly()},openTextDocument(ge){let ve;const $e=ge;if(typeof ge=="string")ve=Promise.resolve(k.URI.file(ge));else if(k.URI.isUri(ge))ve=Promise.resolve(ge);else if(!$e||typeof $e=="object")ve=ft.createDocumentData($e);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(at=>ft.ensureDocumentData(at).then(Ct=>Ct.document))},onDidOpenTextDocument:(ge,ve,$e)=>ft.onDidAddDocument(ge,ve,$e),onDidCloseTextDocument:(ge,ve,$e)=>ft.onDidRemoveDocument(ge,ve,$e),onDidChangeTextDocument:(ge,ve,$e)=>ft.onDidChangeDocument(ge,ve,$e),onDidSaveTextDocument:(ge,ve,$e)=>ft.onDidSaveDocument(ge,ve,$e),onWillSaveTextDocument:(ge,ve,$e)=>jt.getOnWillSaveTextDocumentEvent(He)(ge,ve,$e),get notebookDocuments(){return yt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ve){let $e;if(k.URI.isUri(ge))$e=ge,await yt.openNotebookDocument(ge);else if(typeof ge=="string")$e=k.URI.revive(await yt.createNotebookDocument({viewType:ge,content:ve}));else throw new Error("Invalid arguments");return yt.getNotebookDocument($e).apiNotebook},onDidSaveNotebookDocument(ge,ve,$e){return Qt.onDidSaveNotebookDocument(ge,ve,$e)},onDidChangeNotebookDocument(ge,ve,$e){return Qt.onDidChangeNotebookDocument(ge,ve,$e)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,ve,$e,at){return yt.registerNotebookSerializer(He,ge,ve,$e,(0,Be.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ge,ve,$e)=>dn.onDidChangeConfiguration(ge,ve,$e),getConfiguration(ge,ve){return ve=arguments.length===1?void 0:ve,dn.getConfiguration(ge,ve,He)},registerTextDocumentContentProvider(ge,ve){return Gt.registerTextDocumentContentProvider(ge,ve)},registerTaskProvider:(ge,ve)=>(Re.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(He,ge,ve)),registerFileSystemProvider(ge,ve,$e){return(0,Le.combinedDisposable)(On.registerFileSystemProvider(He,ge,ve,$e),Tt.addFileSystemProvider(ge,ve))},get fs(){return Tt.value},registerFileSearchProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"fileSearchProvider"),St.registerFileSearchProvider(ge,ve)),registerTextSearchProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"textSearchProvider"),St.registerTextSearchProvider(ge,ve)),registerRemoteAuthorityResolver:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),Nt.registerRemoteAuthorityResolver(ge,ve)),registerResourceLabelFormatter:ge=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),Sn.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,ve,$e)=>_t.onDidCreateFile(ge,ve,$e),onDidDeleteFiles:(ge,ve,$e)=>_t.onDidDeleteFile(ge,ve,$e),onDidRenameFiles:(ge,ve,$e)=>_t.onDidRenameFile(ge,ve,$e),onWillCreateFiles:(ge,ve,$e)=>_t.getOnWillCreateFileEvent(He)(ge,ve,$e),onWillDeleteFiles:(ge,ve,$e)=>_t.getOnWillDeleteFileEvent(He)(ge,ve,$e),onWillRenameFiles:(ge,ve,$e)=>_t.getOnWillRenameFileEvent(He)(ge,ve,$e),openTunnel:ge=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.openTunnel(He,ge).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.getTunnels()},onDidChangeTunnels:(ge,ve,$e)=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.onDidChangeTunnels(ge,ve,$e)),registerPortAttributesProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"portsAttributes"),Pt.registerPortsAttributesProvider(ge,ve)),registerTimelineProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"timeline"),yn.registerTimelineProvider(ge,ve,He.identifier,_e.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:ge=>((0,Be.checkProposedApiEnabled)(He,"workspaceTrust"),pt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ve,$e)=>pt.onDidGrantWorkspaceTrust(ge,ve,$e),registerEditSessionIdentityProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(ge,ve))},Kn={get inputBox(){return Re.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(He)},createSourceControl(ge,ve,$e){return cn.createSourceControl(He,ge,ve,$e)}},Xt={createCommentController(ge,ve){return En.createCommentController(He,ge,ve)}},gn={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(ge,ve,$e){return tt.onDidStartDebugSession(ge,ve,$e)},onDidTerminateDebugSession(ge,ve,$e){return tt.onDidTerminateDebugSession(ge,ve,$e)},onDidChangeActiveDebugSession(ge,ve,$e){return tt.onDidChangeActiveDebugSession(ge,ve,$e)},onDidReceiveDebugSessionCustomEvent(ge,ve,$e){return tt.onDidReceiveDebugSessionCustomEvent(ge,ve,$e)},onDidChangeBreakpoints(ge,ve,$e){return tt.onDidChangeBreakpoints(ge,ve,$e)},registerDebugConfigurationProvider(ge,ve,$e){return tt.registerDebugConfigurationProvider(ge,ve,$e||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ve){return tt.registerDebugAdapterDescriptorFactory(He,ge,ve)},registerDebugAdapterTrackerFactory(ge,ve){return tt.registerDebugAdapterTrackerFactory(ge,ve)},startDebugging(ge,ve,$e){return!$e||typeof $e=="object"&&"configuration"in $e?tt.startDebugging(ge,ve,{parentSession:$e}):tt.startDebugging(ge,ve,$e||{})},stopDebugging(ge){return tt.stopDebugging(ge)},addBreakpoints(ge){return tt.addBreakpoints(ge)},removeBreakpoints(ge){return tt.removeBreakpoints(ge)},asDebugSourceUri(ge,ve){return tt.asDebugSourceUri(ge,ve)}},Xn={registerTaskProvider:(ge,ve)=>Et.registerTaskProvider(He,ge,ve),fetchTasks:ge=>Et.fetchTasks(ge),executeTask:ge=>Et.executeTask(He,ge),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ge,ve,$e)=>Et.onDidStartTask(ge,ve,$e),onDidEndTask:(ge,ve,$e)=>Et.onDidEndTask(ge,ve,$e),onDidStartTaskProcess:(ge,ve,$e)=>Et.onDidStartTaskProcess(ge,ve,$e),onDidEndTaskProcess:(ge,ve,$e)=>Et.onDidEndTaskProcess(ge,ve,$e)},zt={createNotebookController(ge,ve,$e,at,Ct){return en.createNotebookController(He,ge,ve,$e,at,(0,Be.isProposedApiEnabled)(He,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ve)=>yt.registerNotebookCellStatusBarItemProvider(He,ge,ve),createRendererMessaging(ge){return vn.createRendererMessaging(He,ge)},createNotebookControllerDetectionTask(ge){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),en.createNotebookControllerDetectionTask(He,ge)},registerKernelSourceActionProvider(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),en.registerKernelSourceActionProvider(He,ge,ve)},onDidChangeNotebookCellExecutionState(ge,ve,$e){return(0,Be.checkProposedApiEnabled)(He,"notebookCellExecutionState"),en.onDidChangeNotebookCellExecutionState(ge,ve,$e)}},pn={t(...ge){if(typeof ge[0]=="string"){const ve=ge.shift(),$e=!ge||typeof ge[0]!="object"?ge:ge[0];return vt.getMessage(He.identifier.value,{message:ve,args:$e})}return vt.getMessage(He.identifier.value,ge[0])},get bundle(){return vt.getBundle(He.identifier.value)},get uri(){return vt.getBundleUri(He.identifier.value)}};return{version:rt.version,authentication:Hn,commands:jn,comments:Xt,debug:gn,env:Mn,extensions:Vn,l10n:pn,languages:qn,notebooks:zt,scm:Kn,tasks:Xn,tests:hn,window:Gn,workspace:mn,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:w.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:T.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:D.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:I.UIKind,Uri:k.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:ue.TelemetryTrustedValue,LogLevel:Fe.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=lt}),define(ye[308],Ce([1,0,280,317,318,2,319]),function(te,e,c,t,T,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(P,w,I,v,m,d){const f=d.environment.useHostProxy,p=typeof f=="boolean"?f:!d.remote.isRemote,b=(0,k.createProxyResolver)({resolveProxy:g=>P.resolveProxy(g),getHttpProxySetting:()=>w.getConfiguration("http").get("proxy"),log:(g,r,...l)=>{switch(g){case k.LogLevel.Trace:v.trace(r,...l);break;case k.LogLevel.Debug:v.debug(r,...l);break;case k.LogLevel.Info:v.info(r,...l);break;case k.LogLevel.Warning:v.warn(r,...l);break;case k.LogLevel.Error:v.error(r,...l);break;case k.LogLevel.Critical:v.error(r,...l);break;case k.LogLevel.Off:break;default:s(g,r,l);break}function s(a,o,...u){v.error("Unknown log level",a),v.error(o,...u)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:p,env:process.env}),S=y(w,b);return L(I,S)}e.connectProxyResolver=A;function y(P,w){const I={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(m=>{I.config=P.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(m=>{v.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},c,(0,k.createHttpPatch)(c,w,{config:"off"},v,!0)),on:Object.assign({},c,(0,k.createHttpPatch)(c,w,{config:"on"},v,!0)),override:Object.assign({},c,(0,k.createHttpPatch)(c,w,{config:"override"},v,!0)),onRequest:Object.assign({},c,(0,k.createHttpPatch)(c,w,I,v,!0)),default:Object.assign(c,(0,k.createHttpPatch)(c,w,I,v,!1))},https:{off:Object.assign({},t,(0,k.createHttpPatch)(t,w,{config:"off"},v,!0)),on:Object.assign({},t,(0,k.createHttpPatch)(t,w,{config:"on"},v,!0)),override:Object.assign({},t,(0,k.createHttpPatch)(t,w,{config:"override"},v,!0)),onRequest:Object.assign({},t,(0,k.createHttpPatch)(t,w,I,v,!0)),default:Object.assign(t,(0,k.createHttpPatch)(t,w,I,v,!1))},tls:Object.assign(T,(0,k.createTlsPatch)(T))}}const D=new Map;function L(P,w){return P.getExtensionPathIndex().then(I=>{const v=globalThis._VSCODE_NODE_MODULES.module,m=v._load;v._load=function(f,p,b){if(f==="tls")return w.tls;if(f!=="http"&&f!=="https")return m.apply(this,arguments);const S=w[f],g=I.findSubstr(R.URI.file(p.filename));let r=D.get(g);if(r||D.set(g,r={}),!r[f]){const l=S.default;r[f]={...l}}return r[f]}})}}),define(ye[309],Ce([1,0,80,307,294,308,43,282,2,17,7,279,115,281]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends T.RequireInterceptor{j(){const f=this,p=globalThis._VSCODE_NODE_MODULES.module,b=p._load;p._load=function(l,s,a){return l=g(l),f.a.has(l)?f.a.get(l).load(l,y.URI.file((0,w.realpathSync)(s.filename)),o=>b.apply(this,[o,s,a])):b.apply(this,arguments)};const S=p._resolveLookupPaths;p._resolveLookupPaths=(r,l)=>S.call(this,g(r),l);const g=r=>{for(const l of f.b){const s=l(r);if(s){r=s;break}}return r}}}class m extends k.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async nb(){this.h.createInstance(I.ExtHostConsoleForwarder);const f=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);if(this.h.createInstance(A.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const S=this.h.createInstance(P.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=S.ipcHandlePath}await this.h.createInstance(v,f,{mine:this.D,all:this.F}).install(),c.mark("code/extHost/didInitAPI");const b=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,b,this,this.l,this.u,this.f),c.mark("code/extHost/didInitProxyResolver")}ob(f){return f.main}async pb(f,p,b){if(p.scheme!==D.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let S=null;b.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this.l.flush();const g=f?.identifier.value;f&&await this.s.initializeLocalizedMessages(f);try{g&&c.mark(`code/extHost/willLoadExtensionCode/${g}`),S=te.__$__nodeRequire(p.fsPath)}finally{g&&c.mark(`code/extHost/didLoadExtensionCode/${g}`),b.codeLoadingStop()}return S}async $setRemoteEnvironment(f){if(!!this.f.remote.isRemote)for(const p in f){const b=f[p];b===null?delete process.env[p]:process.env[p]=b}}}e.ExtHostExtensionService=m}),define(ye[145],Ce([1,0,46,320,303,16,61,39,11,8,2,31,78,321,301,100]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const d=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(h){this.a=h}provideTextSearchResults(h,E,C,M){return this.a.appendLine(`provideTextSearchResults ${h.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((K,q)=>{M.onCancellationRequested(()=>V());const F=l(h,E),B=E.folder.fsPath,O=F.map(X=>X.match(/^-/)?X:`'${X}'`).join(" ");this.a.appendLine(`${d} ${O}
 - cwd: ${B}`);let U=c.spawn(d,F,{cwd:B});U.on("error",X=>{console.error(X),this.a.appendLine("Error: "+(X&&X.message)),q((0,P.serializeSearchError)(new P.SearchError(X&&X.message,P.SearchErrorCode.rgProcessError)))});let z=!1;const j=new S(E.maxResults,B,E.previewOptions);j.on("result",X=>{z=!0,J="",C.report(X)});let ue=!1;const V=()=>{ue=!0,U?.kill(),j?.cancel()};let _=!1;j.on("hitLimit",()=>{_=!0,V()});let J="";U.stdout.on("data",X=>{j.handleData(X),z||(J+=X)});let ne=!1;U.stdout.once("data",()=>ne=!0);let ee="";U.stderr.on("data",X=>{const G=X.toString();this.a.appendLine(G),ee.length+G.length<1e6&&(ee+=G)}),U.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(z?"Got result from parser":"No result from parser"),J&&this.a.appendLine(`Got data without result: ${J}`),this.a.appendLine(""),ue)K({limitHit:_});else{j.flush(),U=null;let X;ee&&!ne&&(X=p(ee))?q((0,P.serializeSearchError)(new P.SearchError(X.message,X.code))):K({limitHit:_})}})})}}e.RipgrepTextSearchEngine=f;function p(n){const h=n.split(`
`),E=h[0].trim();if(h.some(M=>M.startsWith("regex parse error")))return new P.SearchError(b(h),P.SearchErrorCode.regexParseError);const C=E.match(/grep config error: unknown encoding: (.*)/);if(C)return new P.SearchError(`Unknown encoding: ${C[1]}`,P.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new P.SearchError(E.charAt(0).toUpperCase()+E.substr(1),P.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new P.SearchError(E.charAt(0).toUpperCase()+E.substr(1),P.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(E,P.SearchErrorCode.regexParseError)}function b(n){const h=["Regex parse error"],E=n.filter(C=>C.startsWith("PCRE2:"));if(E.length>=1){const C=E[0].replace("PCRE2:","");if(C.indexOf(":")!==-1&&C.split(":").length>=2){const M=C.split(":")[1];h.push(":"+M)}}return h.join("")}class S extends t.EventEmitter{constructor(h,E,C){super(),this.g=h,this.h=E,this.j=C,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new T.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(h,E){return super.on(h,E),this}handleData(h){if(this.b)return;const E=typeof h=="string"?h:this.d.write(h);this.k(E)}k(h){let E=h.indexOf(`
`);const C=this.a+h;if(E>=0)E+=this.a.length;else{this.a=C;return}let M=0;for(;E>=0;)this.m(C.substring(M,E).trim()),M=E+1,E=C.indexOf(`
`,M);this.a=C.substring(M)}m(h){if(this.b||!h)return;let E;try{E=JSON.parse(h)}catch{throw new Error(`malformed line from rg: ${h}`)}if(E.type==="match"){const C=g(E.data.path),M=L.URI.file(y.join(this.h,C)),K=this.n(E.data,M);this.p(K),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const C=g(E.data.path),M=L.URI.file(y.join(this.h,C));this.o(E.data,M).forEach(q=>this.p(q))}}n(h,E){const C=h.line_number-1,M=g(h.lines),K=Buffer.from(M);let q=0,F=0,B=C;h.submatches.length===0&&h.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const O=(0,R.coalesce)(h.submatches.map((U,z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const j=g(U.match),ue=K.slice(q,U.start).toString(),V=r(ue),_=V.numLines>0?V.lastLineLength:V.lastLineLength+F,J=r(j),ne=V.numLines+B,ee=J.numLines+ne,X=J.numLines>0?J.lastLineLength:J.lastLineLength+_;return q=U.end,F=X,B=ee,new w.Range(ne,_,ee,X)}));return(0,m.createTextSearchResult)(E,M,O,this.j)}o(h,E){const C=g(h.lines),M=h.line_number;return C.replace(/\r?\n$/,"").split(`
`).map((K,q)=>({text:K,uri:E,lineNumber:M+q}))}p(h){this.emit("result",h)}}e.RipgrepParser=S;function g(n){return n.bytes?Buffer.from(n.bytes,"base64").toString():n.text}function r(n){const h=/\n/g;let E=0,C=-1,M;for(;M=h.exec(n);)E++,C=M.index;const K=C>=0?n.length-C-1:n.length;return{numLines:E,lastLineLength:K}}function l(n,h){const E=["--hidden"];E.push(n.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:C,otherIncludes:M}=(0,k.groupBy)(h.includes,q=>q.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const q=new Set;M.forEach(F=>{q.add(F)}),E.push("-g","!*"),q.forEach(F=>{s(F).map(m.anchorGlob).forEach(B=>{E.push("-g",B)})})}C&&C.length&&C.forEach(q=>{E.push("-g",q)}),h.excludes.map(m.anchorGlob).forEach(q=>E.push("-g",`!${q}`)),h.maxFileSize&&E.push("--max-filesize",h.maxFileSize+""),h.useIgnoreFiles?h.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),h.followSymlinks&&E.push("--follow"),h.encoding&&h.encoding!=="utf8"&&E.push("--encoding",h.encoding),n.pattern==="--"&&(n.isRegExp=!0,n.pattern="\\-\\-"),n.isMultiline&&!n.isRegExp&&(n.pattern=(0,D.escapeRegExpCharacters)(n.pattern),n.isRegExp=!0),h.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),n.isRegExp&&(n.pattern=a(n.pattern),E.push("--engine","auto"));let K;if(n.isWordMatch){const F=(0,D.createRegExp)(n.pattern,!!n.isRegExp,{wholeWord:n.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",F)}else if(n.isRegExp){let q=u(n.pattern);q=i(q),E.push("--regexp",q)}else K=n.pattern,E.push("--fixed-strings");return E.push("--no-config"),h.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),n.isMultiline&&E.push("--multiline"),h.beforeContext&&E.push("--before-context",h.beforeContext+""),h.afterContext&&E.push("--after-context",h.afterContext+""),E.push("--"),K&&E.push(K),E.push("."),E}function s(n){const h=(0,A.splitGlobAware)(n,"/");return h.map((E,C)=>h.slice(0,C+1).join("/"))}function a(n){const h=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;n.match(h);)n=n.replace(h,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;n.match(E);)n=n.replace(E,"$1\\x{$2}");return n}e.unicodeEscapesToPCRE2=a;const o=n=>n.type==="Assertion"&&n.kind==="lookbehind";function u(n){let h;try{h=new I.RegExpParser().parsePattern(n)}catch{return n}let E="",C=0;const M=(F,B,O)=>{E+=n.slice(C,F)+O,C=B},K=[];return new I.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const B=K[0];if(!B)M(F.start,F.end,"\\r?\\n");else if(!K.some(o))if(B.type==="CharacterClass")if(B.negate){const O=n.slice(B.start+2,F.start)+n.slice(F.end,B.end-1);B.parent?.type==="Quantifier"?M(B.start,B.end,O?`[^${O}]`:"."):M(B.start,B.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=n.slice(B.start+1,F.start)+n.slice(F.end,B.end-1);M(B.start,B.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else B.type==="Quantifier"&&M(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){K.unshift(F)},onQuantifierLeave(){K.shift()},onCharacterClassRangeEnter(F){K.unshift(F)},onCharacterClassRangeLeave(){K.shift()},onCharacterClassEnter(F){K.unshift(F)},onCharacterClassLeave(){K.shift()},onAssertionEnter(F){o(F)&&K.push(F)},onAssertionLeave(F){K[0]===F&&K.shift()}}).visit(h),E+=n.slice(C),E}e.fixRegexNewline=u;function i(n){return n.replace(/\n/g,"\\r?\\n")}e.fixNewline=i}),define(ye[310],Ce([1,0,21,145,126,17]),function(te,e,c,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class k{constructor(D){this.b=D,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(D,L,P,w){const I=new t.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const v={...L,folder:L.folder.with({scheme:R.Schemas.file})},m=new T.Progress(d=>P.report({...d,uri:d.uri.with({scheme:L.folder.scheme})}));return this.c(w,d=>I.provideTextSearchResults(D,v,m,d))}else return this.c(w,v=>I.provideTextSearchResults(D,L,P,v))}async c(D,L){const P=A(D);this.a.add(P);const w=await L(P.token);return this.a.delete(P),w}d(){this.a.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=k;function A(y){const D=new c.CancellationTokenSource;return y.onCancellationRequested(()=>D.cancel()),D}}),define(ye[311],Ce([1,0,29,145,144]),function(te,e,c,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(y){this.a=y}search(y,D,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(I){L({message:I})}},w=new T.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(P),c);return new Promise((I,v)=>w.search(m=>{D(m.map(k))},y).then(m=>I({limitHit:m.limitHit,type:"success",stats:m.stats}),v))}}e.TextSearchEngineAdapter=R;function k(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((y,D)=>{if(D.ranges){const L=D;return y+(Array.isArray(L.ranges)?L.ranges.length:1)}else return y+1},0)}}}),define(ye[312],Ce([1,0,16,14,9,3,111,11,44,2,40,31,302,311]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(S="searchProcess"){this.d=S,this.b=Object.create(null)}fileSearch(S){let g;const r=f(S),l=new R.Emitter({onDidAddFirstListener:()=>{g=(0,t.createCancelablePromise)(s=>this.doFileSearchWithEngine(w.Engine,r,a=>l.fire(a),s)),g.then(s=>l.fire(s),s=>l.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return l.event}textSearch(S){let g;const r=f(S),l=new R.Emitter({onDidAddFirstListener:()=>{g=(0,t.createCancelablePromise)(s=>this.f(r,a=>l.fire(a),s)),g.then(s=>l.fire(s),s=>l.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return l.event}f(S,g,r){return S.maxFileSize=(0,L.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new I.TextSearchEngineAdapter(S).search(r,g,g)}doFileSearch(S,g,r){return this.doFileSearchWithEngine(w.Engine,S,g,r)}doFileSearchWithEngine(S,g,r,l,s=v.a){let a=0;const o=i=>{Array.isArray(i)?(a+=i.length,r(i.map(n=>this.g(n)))):i.relativePath?(a++,r(this.g(i))):r(i)};if(g.sortByScore){let i=this.k(g,o,l);if(!i){const n=g.maxResults?Object.assign({},g,{maxResults:null}):g,h=new S(n);i=this.h(h,g,r,o,l)}return new Promise((n,h)=>{i.then(([E,C])=>{const M=C.map(K=>this.g(K));this.n(M,r,s),n(E)},h)})}const u=new S(g);return this.q(u,o,s,l).then(i=>({limitHit:i.limitHit,type:"success",stats:{detailStats:i.stats,type:this.d,fromCache:!1,resultCount:a,sortingTime:void 0}}))}g(S){return{path:S.base?(0,A.join)(S.base,S.relativePath):S.relativePath}}h(S,g,r,l,s){const a=new R.Emitter;let o=(0,t.createCancelablePromise)(i=>{let n=[];const h=E=>{Array.isArray(E)?n=E:(l(E),a.fire(E))};return this.q(S,h,-1,i).then(E=>[E,n])}),u;if(g.cacheKey){u=this.j(g.cacheKey);const i={promise:o,event:a.event,resolved:!1};u.resultsToSearchCache[g.filePattern||""]=i,o.then(()=>{i.resolved=!0},n=>{delete u.resultsToSearchCache[g.filePattern||""]}),o=this.r(o)}return o.then(([i,n])=>{const h=u?u.scorerCache:Object.create(null),E=(typeof g.maxResults!="number"||g.maxResults>0)&&y.StopWatch.create(!1);return this.l(g,n,h,s).then(C=>{const M=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:i.stats,sortingTime:M,fromCache:!1,type:this.d,workspaceFolderCount:g.folderQueries.length,resultCount:C.length},messages:i.messages,limitHit:i.limitHit||typeof g.maxResults=="number"&&n.length>g.maxResults},C]})})}j(S){const g=this.b[S];return g||(this.b[S]=new m)}k(S,g,r){const l=S.cacheKey&&this.b[S.cacheKey];if(!l)return;const s=this.o(l,S.filePattern||"",g,r);if(s)return s.then(([a,o,u])=>{const i=y.StopWatch.create(!1);return this.l(S,o,l.scorerCache,r).then(n=>{const h=i.elapsed(),E={fromCache:!0,detailStats:u,type:this.d,resultCount:o.length,sortingTime:h};return[{type:"success",limitHit:a.limitHit||typeof S.maxResults=="number"&&o.length>S.maxResults,stats:E},n]})})}l(S,g,r,l){const s=(0,k.prepareQuery)(S.filePattern||""),a=(u,i)=>(0,k.compareItemsByFuzzyScore)(u,i,s,!0,d,r),o=typeof S.maxResults=="number"?S.maxResults:Number.MAX_VALUE;return c.topAsync(g,a,o,1e4,l)}n(S,g,r){if(r&&r>0)for(let l=0;l<S.length;l+=r)g(S.slice(l,l+r));else g(S)}o(S,g,r,l){const s=y.StopWatch.create(!1),a=g.indexOf(A.sep)>=0;let o;for(const h in S.resultsToSearchCache)if(g.startsWith(h)){if(a&&h.indexOf(A.sep)<0&&h!=="")continue;const E=S.resultsToSearchCache[h];o={promise:this.r(E.promise),event:E.event,resolved:E.resolved};break}if(!o)return null;const u=s.elapsed(),i=y.StopWatch.create(!1),n=o.event(r);return l&&l.onCancellationRequested(()=>{n.dispose()}),o.promise.then(([h,E])=>{if(l&&l.isCancellationRequested)throw(0,T.canceled)();const C=[],M=(0,k.prepareQuery)(g).normalizedLowercase;for(const K of E)!(0,P.isFilePatternMatch)(K,M)||C.push(K);return[h,C,{cacheWasResolved:o.resolved,cacheLookupTime:u,cacheFilterTime:i.elapsed(),cacheEntryCount:E.length}]})}q(S,g,r,l){return new Promise((s,a)=>{let o=[];l?.onCancellationRequested(()=>S.cancel()),S.search(u=>{u&&(r?(o.push(u),r>0&&o.length>=r&&(g(o),o=[])):g(u))},u=>{g(u)},(u,i)=>{o.length&&g(o),u?a(u):s(i)})})}clearCache(S){return delete this.b[S],Promise.resolve(void 0)}r(S){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,r){return S.then(g,r)}catch(g){return this.then(void 0,g)}finally(g){return S.finally(g)}}}}e.SearchService=v,v.a=512;class m{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(b){return(0,A.basename)(b.relativePath)}getItemDescription(b){return(0,A.dirname)(b.relativePath)}getItemPath(b){return b.relativePath}};function f(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(p),extraFileResources:b.extraFileResources&&b.extraFileResources.map(S=>D.URI.revive(S))}}function p(b){return{...b,folder:D.URI.revive(b.folder)}}}),define(ye[313],Ce([1,0,6,17,2,29,13,25,18,82,56,31,312,310,100,144]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let d=class extends D.ExtHostSearch{constructor(p,b,S,g){super(p,S,g),this.s=R,this.t=-1,this.v=null,this.w=!1;const r=new v.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new I.RipgrepSearchProvider(r)),b.remote.isRemote&&b.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const p=new v.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new I.RipgrepSearchProvider(p)),this.y(t.Schemas.file,new w.SearchService("fileSearchProvider"))}y(p,b){const S=this.d++;return this.v=b,this.t=S,this.c.$registerFileSearchProvider(S,this.o(p)),(0,c.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(S)})}$provideFileSearchResults(p,b,S,g){const r=(0,D.reviveQuery)(S);return p===this.t?this.z(p,b,r,g):super.$provideFileSearchResults(p,b,S,g)}z(p,b,S,g){const r=l=>{if((0,P.isSerializedFileMatch)(l)&&(l=[l]),Array.isArray(l)){this.c.$handleFileMatch(p,b,l.map(s=>T.URI.file(s.path)));return}l.message&&this.n.debug("ExtHostSearch",l.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(S,r,g)}$clearCache(p){return this.v?.clearCache(p),super.$clearCache(p)}q(p,b){return new m.NativeTextSearchManager(p,b,void 0,"textSearchProvider")}};d=qe([We(0,y.IExtHostRpcService),We(1,A.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,k.ILogService)],d),e.NativeExtHostSearch=d}),define(ye[314],Ce([1,0,89,285,297,296,313,309,286,81,43,82,79,42,55,76,284,283,13,298,49]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f,p,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(L.IExtHostExtensionService,A.ExtHostExtensionService,0),(0,c.registerSingleton)(p.ILoggerService,f.ExtHostLoggerService,1),(0,c.registerSingleton)(m.IExtensionStoragePaths,d.ExtensionStoragePaths,0),(0,c.registerSingleton)(D.IExtHostDebugService,R.ExtHostDebugService,0),(0,c.registerSingleton)(P.IExtHostSearch,k.NativeExtHostSearch,0),(0,c.registerSingleton)(w.IExtHostTask,T.ExtHostTask,0),(0,c.registerSingleton)(I.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,c.registerSingleton)(v.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,c.registerSingleton)(S.IExtHostVariableResolverProvider,b.NodeExtHostVariableResolverProviderService,0)}),define(ye[322],Ce([1,0,225,323,80,9,118,119,204,95,295,23,29,115,14,121,220,234,299,314]),function(te,e,c,t,T,R,k,A,y,D,L,P,w,I,v,m,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const p=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const o=globalThis._VSCODE_NODE_MODULES.module,u=o._load;o._load=function(i){if(i==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return u.apply(this,arguments)}})();const b=process.exit.bind(process);function S(o){process.exit=function(u){if(o)b(u);else{const i=new Error("An extension called process.exit() and this was prevented.");console.warn(i.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(o){b()};function r(){const o=(0,f.readExtHostConnection)(process.env);if(o.type===3)return new Promise((u,i)=>{const n=h=>{const E=h[0],C=new k.BufferedEmitter;E.on("message",M=>C.fire(P.VSBuffer.wrap(M.data))),E.on("close",()=>{g("renderer closed the MessagePort")}),E.start(),u({onMessage:C.event,send:M=>E.postMessage(M.buffer)})};process.parentPort.on("message",h=>n(h.ports))});if(o.type===2)return new Promise((u,i)=>{let n=null;const h=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,C=3e5,M=new v.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (1)"),E),K=new v.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (2)"),C);process.on("message",(F,B)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const O=P.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let U;if(F.skipWebSocketFrames)U=new A.NodeSocket(B,"extHost-socket");else{const z=P.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));U=new A.WebSocketNodeSocket(new A.NodeSocket(B,"extHost-socket"),F.permessageDeflate,z,!1)}n?(M.cancel(),K.cancel(),n.beginAcceptReconnection(U,O),n.endAcceptReconnection(),n.sendResume()):(clearTimeout(h),n=new k.PersistentProtocol({socket:U,initialChunk:O}),n.sendResume(),n.onDidDispose(()=>g("renderer disconnected")),u(n),n.onSocketClose(()=>{M.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(K.isScheduled())return;M.isScheduled()&&K.schedule()}});const q={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(q)});{const u=o.pipeName;return new Promise((i,n)=>{const h=c.createConnection(u,()=>{h.removeListener("error",n);const E=new k.PersistentProtocol({socket:new A.NodeSocket(h,"extHost-renderer")});E.sendResume(),i(E)});h.once("error",n),h.on("close",()=>{g("renderer closed the socket")})})}}async function l(){const o=await r();return new class{constructor(){this.a=new k.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,o.onMessage(u=>{(0,D.isMessageOfType)(u,2)?(this.b=!0,g("received terminate message from renderer")):this.a.fire(u)})}send(u){this.b||o.send(u)}async drain(){if(o.drain)return o.drain()}}}function s(o){return new Promise(u=>{const i=o.onMessage(n=>{i.dispose();const h=JSON.parse(n.toString()),E=h.commit,C=y.default.commit;if(E&&C&&E!==C&&b(55),h.parentPid){let M=0;setInterval(function(){try{process.kill(h.parentPid,0),M=0}catch(q){q&&q.code==="EPERM"?(M++,M>=3&&g(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${q.message} (code: ${q.code}) (errno: ${q.errno})`)):g(`parent process ${h.parentPid} does not exist anymore: ${q.message} (code: ${q.code}) (errno: ${q.errno})`)}},1e3);let K;try{K=globalThis._VSCODE_NODE_MODULES["native-watchdog"],K.start(h.parentPid)}catch(q){(0,R.onUnexpectedError)(q)}}o.send((0,D.createMessageOfType)(0)),u({protocol:o,initData:h})});o.send((0,D.createMessageOfType)(1))})}async function a(){const o=[];process.on("unhandledRejection",(M,K)=>{o.push(K),setTimeout(()=>{const q=o.indexOf(K);q>=0&&K.catch(F=>{o.splice(q,1),(0,R.isCancellationError)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),M&&(0,R.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const K=o.indexOf(M);K>=0&&o.splice(K,1)}),process.on("uncaughtException",function(M){(0,R.onUnexpectedError)(M)}),T.mark("code/extHost/willConnectToRenderer");const u=await l();T.mark("code/extHost/didConnectToRenderer");const i=await s(u);T.mark("code/extHost/didWaitForInitData");const{initData:n}=i;S(!!n.environment.extensionTestsLocationURI),n.environment.useHostProxy=p.useHostProxy!==void 0?p.useHostProxy!=="false":void 0,n.environment.skipWorkspaceStorageLock=(0,m.boolean)(p.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(K){b(K)}exists(K){return w.Promises.exists(K)}realpath(K){return(0,I.realpath)(K)}};let E=null;n.remote.authority&&p.transformURIs&&(E=(0,d.createURITransformer)(n.remote.authority));const C=new L.ExtensionHostMain(i.protocol,n,h,E);g=M=>C.terminate(M)}a().catch(o=>console.log(o))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e7b5449579249db344d473370d56a5df9446c826/core/vs/workbench/api/node/extensionHostProcess.js.map
