/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/base/common/async","vs/platform/log/common/log","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/codicons","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(ee){for(var e=[],i=0,C=ee.length;i<C;i++)e[i]=Ie[ee[i]];return e};define(Ie[62],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(I,R){const y=Object.create(null);for(const k of I){const O=R(k);let w=y[O];w||(w=y[O]=[]),w.push(k)}return y}e.groupBy=i;function C(I,R){const y=[],k=[];for(const O of I)R.has(O)||y.push(O);for(const O of R)I.has(O)||k.push(O);return{removed:y,added:k}}e.diffSets=C;function S(I,R){const y=[],k=[];for(const[O,w]of I)R.has(O)||y.push(w);for(const[O,w]of R)I.has(O)||k.push(w);return{removed:y,added:k}}e.diffMaps=S;class L{constructor(){this.a=new Map}add(R,y){let k=this.a.get(R);k||(k=new Set,this.a.set(R,k)),k.add(y)}delete(R,y){const k=this.a.get(R);!k||(k.delete(y),k.size===0&&this.a.delete(R))}forEach(R,y){const k=this.a.get(R);!k||k.forEach(y)}}e.SetMap=L}),define(Ie[63],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(I){return(R,y,k)=>{let O=null,w=null;if(typeof k.value=="function"?(O="value",w=k.value):typeof k.get=="function"&&(O="get",w=k.get),!w)throw new Error("not supported");k[O]=I(w,y)}}function C(I,R,y){let k=null,O=null;if(typeof y.value=="function"?(k="value",O=y.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(k="get",O=y.get),!O)throw new Error("not supported");const w=`$memoize$${R}`;y[k]=function(...m){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,m)}),this[w]}}e.memoize=C;function S(I,R,y){return i((k,O)=>{const w=`$debounce$${O}`,m=`$debounce$result$${O}`;return function(...b){this[m]||(this[m]=y?y():void 0),clearTimeout(this[w]),R&&(this[m]=R(this[m],...b),b=[this[m]]),this[w]=setTimeout(()=>{k.apply(this,b),this[m]=y?y():void 0},I)}})}e.debounce=S;function L(I,R,y){return i((k,O)=>{const w=`$throttle$timer$${O}`,m=`$throttle$result$${O}`,b=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...r){if(this[m]||(this[m]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...r)),this[f])return;const o=this[b]+I;o<=Date.now()?(this[b]=Date.now(),k.apply(this,[this[m]]),this[m]=y?y():void 0):(this[f]=!0,this[w]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),k.apply(this,[this[m]]),this[m]=y?y():void 0},o-Date.now()))}})}e.throttle=L}),define(Ie[83],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(S){this.a=S,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(Ie[110],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var C;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function I(n,d=!1){let t=0;const u=n.length;let s="",h=0,a=16,c=0;function g($){let T=0,M=0;for(;T<$;){const V=n.charCodeAt(t);if(V>=48&&V<=57)M=M*16+V-48;else if(V>=65&&V<=70)M=M*16+V-65+10;else if(V>=97&&V<=102)M=M*16+V-97+10;else break;t++,T++}return T<$&&(M=-1),M}function A($){t=$,s="",h=0,a=16,c=0}function F(){const $=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&k(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&k(n.charCodeAt(t)))for(t++;t<n.length&&k(n.charCodeAt(t));)t++;else return c=3,n.substring($,t);let T=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&k(n.charCodeAt(t))){for(t++;t<n.length&&k(n.charCodeAt(t));)t++;T=t}else c=3;return n.substring($,T)}function j(){let $="",T=t;for(;;){if(t>=u){$+=n.substring(T,t),c=2;break}const M=n.charCodeAt(t);if(M===34){$+=n.substring(T,t),t++;break}if(M===92){if($+=n.substring(T,t),t++,t>=u){c=2;break}switch(n.charCodeAt(t++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const q=g(4);q>=0?$+=String.fromCharCode(q):c=4;break}default:c=5}T=t;continue}if(M>=0&&M<=31)if(y(M)){$+=n.substring(T,t),c=2;break}else c=6;t++}return $}function te(){if(s="",c=0,h=t,t>=u)return h=u,a=17;let $=n.charCodeAt(t);if(R($)){do t++,s+=String.fromCharCode($),$=n.charCodeAt(t);while(R($));return a=15}if(y($))return t++,s+=String.fromCharCode($),$===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),a=14;switch($){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,s=j(),a=10;case 47:{const T=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<u&&!y(n.charCodeAt(t));)t++;return s=n.substring(T,t),a=12}if(n.charCodeAt(t+1)===42){t+=2;const M=u-1;let V=!1;for(;t<M;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,V=!0;break}t++}return V||(t++,c=1),s=n.substring(T,t),a=13}return s+=String.fromCharCode($),t++,a=16}case 45:if(s+=String.fromCharCode($),t++,t===u||!k(n.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=F(),a=11;default:for(;t<u&&x($);)t++,$=n.charCodeAt(t);if(h!==t){switch(s=n.substring(h,t),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode($),t++,a=16}}function x($){if(R($)||y($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let $;do $=te();while($>=12&&$<=15);return $}return{setPosition:A,getPosition:()=>t,scan:d?N:te,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>h,getTokenLength:()=>t-h,getTokenError:()=>c}}e.createScanner=I;function R(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function y(n){return n===10||n===13||n===8232||n===8233}function k(n){return n>=48&&n<=57}var O;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(O||(O={}));function w(n,d){const t=[],u=new Object;let s;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function c(g,A,F,j){h.value=g,h.offset=A,h.length=F,h.type=j,h.colonOffset=void 0,s=h}try{E(n,{onObjectBegin:(g,A)=>{if(d<=g)throw u;s=void 0,a=d>g,t.push("")},onObjectProperty:(g,A,F)=>{if(d<A||(c(g,A,F,"property"),t[t.length-1]=g,d<=A+F))throw u},onObjectEnd:(g,A)=>{if(d<=g)throw u;s=void 0,t.pop()},onArrayBegin:(g,A)=>{if(d<=g)throw u;s=void 0,t.push(0)},onArrayEnd:(g,A)=>{if(d<=g)throw u;s=void 0,t.pop()},onLiteralValue:(g,A,F)=>{if(d<A||(c(g,A,F,p(g)),d<=A+F))throw u},onSeparator:(g,A,F)=>{if(d<=A)throw u;if(g===":"&&s&&s.type==="property")s.colonOffset=A,a=!1,s=void 0;else if(g===","){const j=t[t.length-1];typeof j=="number"?t[t.length-1]=j+1:(a=!0,t[t.length-1]=""),s=void 0}}})}catch(g){if(g!==u)throw g}return{path:t,previousNode:s,isAtPropertyKey:a,matches:g=>{let A=0;for(let F=0;A<g.length&&F<t.length;F++)if(g[A]===t[F]||g[A]==="*")A++;else if(g[A]!=="**")return!1;return A===g.length}}}e.getLocation=w;function m(n,d=[],t=L.DEFAULT){let u=null,s=[];const h=[];function a(g){Array.isArray(s)?s.push(g):u!==null&&(s[u]=g)}return E(n,{onObjectBegin:()=>{const g={};a(g),h.push(s),s=g,u=null},onObjectProperty:g=>{u=g},onObjectEnd:()=>{s=h.pop()},onArrayBegin:()=>{const g=[];a(g),h.push(s),s=g,u=null},onArrayEnd:()=>{s=h.pop()},onLiteralValue:a,onError:(g,A,F)=>{d.push({error:g,offset:A,length:F})}},t),s[0]}e.parse=m;function b(n,d=[],t=L.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(g){u.type==="property"&&(u.length=g-u.offset,u=u.parent)}function h(g){return u.children.push(g),g}E(n,{onObjectBegin:g=>{u=h({type:"object",offset:g,length:-1,parent:u,children:[]})},onObjectProperty:(g,A,F)=>{u=h({type:"property",offset:A,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:g,offset:A,length:F,parent:u})},onObjectEnd:(g,A)=>{u.length=g+A-u.offset,u=u.parent,s(g+A)},onArrayBegin:(g,A)=>{u=h({type:"array",offset:g,length:-1,parent:u,children:[]})},onArrayEnd:(g,A)=>{u.length=g+A-u.offset,u=u.parent,s(g+A)},onLiteralValue:(g,A,F)=>{h({type:p(g),offset:A,length:F,parent:u,value:g}),s(A+F)},onSeparator:(g,A,F)=>{u.type==="property"&&(g===":"?u.colonOffset=A:g===","&&s(A))},onError:(g,A,F)=>{d.push({error:g,offset:A,length:F})}},t);const c=u.children[0];return c&&delete c.parent,c}e.parseTree=b;function f(n,d){if(!n)return;let t=n;for(const u of d)if(typeof u=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const h of t.children)if(Array.isArray(h.children)&&h.children[0].value===u){t=h.children[1],s=!0;break}if(!s)return}else{const s=u;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=f;function r(n){if(!n.parent||!n.parent.children)return[];const d=r(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;d.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&d.push(t)}return d}e.getNodePath=r;function o(n){switch(n.type){case"array":return n.children.map(o);case"object":{const d=Object.create(null);for(const t of n.children){const u=t.children[1];u&&(d[t.children[0].value]=o(u))}return d}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=o;function l(n,d,t=!1){return d>=n.offset&&d<n.offset+n.length||t&&d===n.offset+n.length}e.contains=l;function v(n,d,t=!1){if(l(n,d,t)){const u=n.children;if(Array.isArray(u))for(let s=0;s<u.length&&u[s].offset<=d;s++){const h=v(u[s],d,t);if(h)return h}return n}}e.findNodeAtOffset=v;function E(n,d,t=L.DEFAULT){const u=I(n,!1);function s(re){return re?()=>re(u.getTokenOffset(),u.getTokenLength()):()=>!0}function h(re){return re?G=>re(G,u.getTokenOffset(),u.getTokenLength()):()=>!0}const a=s(d.onObjectBegin),c=h(d.onObjectProperty),g=s(d.onObjectEnd),A=s(d.onArrayBegin),F=s(d.onArrayEnd),j=h(d.onLiteralValue),te=h(d.onSeparator),x=s(d.onComment),N=h(d.onError),$=t&&t.disallowComments,T=t&&t.allowTrailingComma;function M(){for(;;){const re=u.scan();switch(u.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:$||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(re){case 12:case 13:$?V(10):x();break;case 16:V(1);break;case 15:case 14:break;default:return re}}}function V(re,G=[],H=[]){if(N(re),G.length+H.length>0){let oe=u.getToken();for(;oe!==17;){if(G.indexOf(oe)!==-1){M();break}else if(H.indexOf(oe)!==-1)break;oe=M()}}}function q(re){const G=u.getTokenValue();return re?j(G):c(G),M(),!0}function le(){switch(u.getToken()){case 11:{let re=0;try{re=JSON.parse(u.getTokenValue()),typeof re!="number"&&(V(2),re=0)}catch{V(2)}j(re);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return M(),!0}function _(){return u.getToken()!==10?(V(3,[],[2,5]),!1):(q(!1),u.getToken()===6?(te(":"),M(),de()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function pe(){a(),M();let re=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(re||V(4,[],[]),te(","),M(),u.getToken()===2&&T)break}else re&&V(6,[],[]);_()||V(4,[],[2,5]),re=!0}return g(),u.getToken()!==2?V(7,[2],[]):M(),!0}function ue(){A(),M();let re=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(re||V(4,[],[]),te(","),M(),u.getToken()===4&&T)break}else re&&V(6,[],[]);de()||V(4,[],[4,5]),re=!0}return F(),u.getToken()!==4?V(8,[4],[]):M(),!0}function de(){switch(u.getToken()){case 3:return ue();case 1:return pe();case 10:return q(!0);default:return le()}}return M(),u.getToken()===17?t.allowEmptyContent?!0:(V(4,[],[]),!1):de()?(u.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=E;function P(n,d){const t=I(n),u=[];let s,h=0,a;do switch(a=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:h!==a&&u.push(n.substring(h,a)),d!==void 0&&u.push(t.getTokenValue().replace(/[^\r\n]/g,d)),h=t.getPosition();break}while(s!==17);return u.join("")}e.stripComments=P;function p(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Ie[28],Ce([1,0]),function(ee,e){"use strict";var i,C,S;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(f,r,o){let l=f.get(r);return l===void 0&&(l=o,f.set(r,l)),l}e.getOrSet=L;function I(f){const r=[];return f.forEach((o,l)=>{r.push(`${l} => ${o}`)}),`Map(${f.size}) {${r.join(", ")}}`}e.mapToString=I;function R(f){const r=[];return f.forEach(o=>{r.push(o)}),`Set(${f.size}) {${r.join(", ")}}`}e.setToString=R;class y{constructor(r,o){this.uri=r,this.value=o}}class k{constructor(r,o){this[i]="ResourceMap",r instanceof k?(this.b=new Map(r.b),this.c=o??k.a):(this.b=new Map,this.c=r??k.a)}set(r,o){return this.b.set(this.c(r),new y(r,o)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,o){typeof o<"u"&&(r=r.bind(o));for(const[l,v]of this.b)r(v.value,v.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}e.ResourceMap=k,k.a=f=>f.toString();class O{constructor(r,o){this[C]="ResourceSet",!r||typeof r=="function"?this.a=new k(r):(this.a=new k(o),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,o){this.a.forEach((l,v)=>r.call(o,v,v,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var w;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class m{constructor(){this[S]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,o=0){const l=this.a.get(r);if(!!l)return o!==0&&this.j(l,o),l.value}set(r,o,l=0){let v=this.a.get(r);if(v)v.value=o,l!==0&&this.j(v,l);else{switch(v={key:r,value:o,next:void 0,previous:void 0},l){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(r,v),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this.a.get(r);if(!!o)return this.a.delete(r),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,o){const l=this.e;let v=this.b;for(;v;){if(o?r.bind(o)(v.value,v.key,this):r(v.value,v.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const r=this,o=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(r.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.key,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return v}values(){const r=this,o=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(r.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.value,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return v}entries(){const r=this,o=this.e;let l=this.b;const v={[Symbol.iterator](){return v},next(){if(r.e!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:[l.key,l.value],done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return v}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this.b,l=this.size;for(;o&&l>r;)this.a.delete(o.key),o=o.next,l--;this.b=o,this.d=l,o&&(o.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const o=r.next,l=r.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}r.next=void 0,r.previous=void 0,this.e++}j(r,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this.b)return;const l=r.next,v=r.previous;r===this.c?(v.next=void 0,this.c=v):(l.previous=v,v.next=l),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(o===2){if(r===this.c)return;const l=r.next,v=r.previous;r===this.b?(l.previous=void 0,this.b=l):(l.previous=v,v.next=l),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((o,l)=>{r.push([l,o])}),r}fromJSON(r){this.clear();for(const[o,l]of r)this.set(o,l)}}e.LinkedMap=m;class b extends m{constructor(r,o=1){super(),this.k=r,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=b}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[111],Ce([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(Te,Se){for(var ke=0;ke<Se.length;ke++){var se=Se[ke];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Te,se.key,se)}}function i(Te,Se,ke){return Se&&e(Te.prototype,Se),ke&&e(Te,ke),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function C(Te,Se){if(!!Te){if(typeof Te=="string")return S(Te,Se);var ke=Object.prototype.toString.call(Te).slice(8,-1);if(ke==="Object"&&Te.constructor&&(ke=Te.constructor.name),ke==="Map"||ke==="Set")return Array.from(Te);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return S(Te,Se)}}function S(Te,Se){(Se==null||Se>Te.length)&&(Se=Te.length);for(var ke=0,se=new Array(Se);ke<Se;ke++)se[ke]=Te[ke];return se}function L(Te,Se){var ke=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(ke)return(ke=ke.call(Te)).next.bind(ke);if(Array.isArray(Te)||(ke=C(Te))||Se&&Te&&typeof Te.length=="number"){ke&&(Te=ke);var se=0;return function(){return se>=Te.length?{done:!0}:{done:!1,value:Te[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=I();function R(Te){ee.defaults=Te}var y=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Se){return m[Se]};function f(Te,Se){if(Se){if(y.test(Te))return Te.replace(k,b)}else if(O.test(Te))return Te.replace(w,b);return Te}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Te){return Te.replace(r,function(Se,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var l=/(^|[^\[])\^/g;function v(Te,Se){Te=typeof Te=="string"?Te:Te.source,Se=Se||"";var ke={replace:function(ce,J){return J=J.source||J,J=J.replace(l,"$1"),Te=Te.replace(ce,J),ke},getRegex:function(){return new RegExp(Te,Se)}};return ke}var E=/[^\w:]/g,P=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Te,Se,ke){if(Te){var se;try{se=decodeURIComponent(o(ke)).replace(E,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Se&&!P.test(ke)&&(ke=s(Se,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var n={},d=/^[^:]+:\/*[^/]*$/,t=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Te,Se){n[" "+Te]||(d.test(Te)?n[" "+Te]=Te+"/":n[" "+Te]=g(Te,"/",!0)),Te=n[" "+Te];var ke=Te.indexOf(":")===-1;return Se.substring(0,2)==="//"?ke?Se:Te.replace(t,"$1")+Se:Se.charAt(0)==="/"?ke?Se:Te.replace(u,"$1")+Se:Te+Se}var h={exec:function(){}};function a(Te){for(var Se=1,ke,se;Se<arguments.length;Se++){ke=arguments[Se];for(se in ke)Object.prototype.hasOwnProperty.call(ke,se)&&(Te[se]=ke[se])}return Te}function c(Te,Se){var ke=Te.replace(/\|/g,function(J,D,B){for(var W=!1,K=D;--K>=0&&B[K]==="\\";)W=!W;return W?"|":" |"}),se=ke.split(/ \|/),ce=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Se)se.splice(Se);else for(;se.length<Se;)se.push("");for(;ce<se.length;ce++)se[ce]=se[ce].trim().replace(/\\\|/g,"|");return se}function g(Te,Se,ke){var se=Te.length;if(se===0)return"";for(var ce=0;ce<se;){var J=Te.charAt(se-ce-1);if(J===Se&&!ke)ce++;else if(J!==Se&&ke)ce++;else break}return Te.slice(0,se-ce)}function A(Te,Se){if(Te.indexOf(Se[1])===-1)return-1;for(var ke=Te.length,se=0,ce=0;ce<ke;ce++)if(Te[ce]==="\\")ce++;else if(Te[ce]===Se[0])se++;else if(Te[ce]===Se[1]&&(se--,se<0))return ce;return-1}function F(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(Te,Se){if(Se<1)return"";for(var ke="";Se>1;)Se&1&&(ke+=Te),Se>>=1,Te+=Te;return ke+Te}function te(Te,Se,ke,se){var ce=Se.href,J=Se.title?f(Se.title):null,D=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){se.state.inLink=!0;var B={type:"link",raw:ke,href:ce,title:J,text:D,tokens:se.inlineTokens(D)};return se.state.inLink=!1,B}return{type:"image",raw:ke,href:ce,title:J,text:f(D)}}function x(Te,Se){var ke=Te.match(/^(\s+)(?:```)/);if(ke===null)return Se;var se=ke[1];return Se.split(`
`).map(function(ce){var J=ce.match(/^\s+/);if(J===null)return ce;var D=J[0];return D.length>=se.length?ce.slice(se.length):ce}).join(`
`)}var N=function(){function Te(ke){this.options=ke||ee.defaults}var Se=Te.prototype;return Se.space=function(se){var ce=this.rules.block.newline.exec(se);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},Se.code=function(se){var ce=this.rules.block.code.exec(se);if(ce){var J=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?J:g(J,`
`)}}},Se.fences=function(se){var ce=this.rules.block.fences.exec(se);if(ce){var J=ce[0],D=x(J,ce[3]||"");return{type:"code",raw:J,lang:ce[2]?ce[2].trim():ce[2],text:D}}},Se.heading=function(se){var ce=this.rules.block.heading.exec(se);if(ce){var J=ce[2].trim();if(/#$/.test(J)){var D=g(J,"#");(this.options.pedantic||!D||/ $/.test(D))&&(J=D.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:J,tokens:this.lexer.inline(J)}}},Se.hr=function(se){var ce=this.rules.block.hr.exec(se);if(ce)return{type:"hr",raw:ce[0]}},Se.blockquote=function(se){var ce=this.rules.block.blockquote.exec(se);if(ce){var J=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},Se.list=function(se){var ce=this.rules.block.list.exec(se);if(ce){var J,D,B,W,K,Z,he,ye,ae,be,Ee,We,He=ce[1].trim(),tt=He.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(We=!1,!(!(ce=et.exec(se))||this.rules.block.hr.test(se)));){if(J=ce[0],se=se.substring(J.length),ye=ce[2].split(`
`,1)[0],ae=se.split(`
`,1)[0],this.options.pedantic?(W=2,Ee=ye.trimLeft()):(W=ce[2].search(/[^ ]/),W=W>4?1:W,Ee=ye.slice(W),W+=ce[1].length),Z=!1,!ye&&/^ *$/.test(ae)&&(J+=ae+`
`,se=se.substring(ae.length+1),We=!0),!We)for(var it=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");se&&(be=se.split(`
`,1)[0],ye=be,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(ye)||st.test(ye)||it.test(ye)||dt.test(se)));){if(ye.search(/[^ ]/)>=W||!ye.trim())Ee+=`
`+ye.slice(W);else if(!Z)Ee+=`
`+ye;else break;!Z&&!ye.trim()&&(Z=!0),J+=be+`
`,se=se.substring(be.length+1)}Xe.loose||(he?Xe.loose=!0:/\n *\n *$/.test(J)&&(he=!0)),this.options.gfm&&(D=/^\[[ xX]\] /.exec(Ee),D&&(B=D[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:J,task:!!D,checked:B,loose:!1,text:Ee}),Xe.raw+=J}Xe.items[Xe.items.length-1].raw=J.trimRight(),Xe.items[Xe.items.length-1].text=Ee.trimRight(),Xe.raw=Xe.raw.trimRight();var Y=Xe.items.length;for(K=0;K<Y;K++){this.lexer.state.top=!1,Xe.items[K].tokens=this.lexer.blockTokens(Xe.items[K].text,[]);var Q=Xe.items[K].tokens.filter(function(Me){return Me.type==="space"}),ge=Q.every(function(Me){for(var $e=Me.raw.split(""),je=0,Ye=L($e),nt;!(nt=Ye()).done;){var wt=nt.value;if(wt===`
`&&(je+=1),je>1)return!0}return!1});!Xe.loose&&Q.length&&ge&&(Xe.loose=!0,Xe.items[K].loose=!0)}return Xe}},Se.html=function(se){var ce=this.rules.block.html.exec(se);if(ce){var J={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var D=this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]);J.type="paragraph",J.text=D,J.tokens=this.lexer.inline(D)}return J}},Se.def=function(se){var ce=this.rules.block.def.exec(se);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var J=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:ce[0],href:ce[2],title:ce[3]}}},Se.table=function(se){var ce=this.rules.block.table.exec(se);if(ce){var J={type:"table",header:c(ce[1]).map(function(he){return{text:he}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=ce[0];var D=J.align.length,B,W,K,Z;for(B=0;B<D;B++)/^ *-+: *$/.test(J.align[B])?J.align[B]="right":/^ *:-+: *$/.test(J.align[B])?J.align[B]="center":/^ *:-+ *$/.test(J.align[B])?J.align[B]="left":J.align[B]=null;for(D=J.rows.length,B=0;B<D;B++)J.rows[B]=c(J.rows[B],J.header.length).map(function(he){return{text:he}});for(D=J.header.length,W=0;W<D;W++)J.header[W].tokens=this.lexer.inline(J.header[W].text);for(D=J.rows.length,W=0;W<D;W++)for(Z=J.rows[W],K=0;K<Z.length;K++)Z[K].tokens=this.lexer.inline(Z[K].text);return J}}},Se.lheading=function(se){var ce=this.rules.block.lheading.exec(se);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},Se.paragraph=function(se){var ce=this.rules.block.paragraph.exec(se);if(ce){var J=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:J,tokens:this.lexer.inline(J)}}},Se.text=function(se){var ce=this.rules.block.text.exec(se);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},Se.escape=function(se){var ce=this.rules.inline.escape.exec(se);if(ce)return{type:"escape",raw:ce[0],text:f(ce[1])}},Se.tag=function(se){var ce=this.rules.inline.tag.exec(se);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]}},Se.link=function(se){var ce=this.rules.inline.link.exec(se);if(ce){var J=ce[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var D=g(J.slice(0,-1),"\\");if((J.length-D.length)%2===0)return}else{var B=A(ce[2],"()");if(B>-1){var W=ce[0].indexOf("!")===0?5:4,K=W+ce[1].length+B;ce[2]=ce[2].substring(0,B),ce[0]=ce[0].substring(0,K).trim(),ce[3]=""}}var Z=ce[2],he="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Z);ye&&(Z=ye[1],he=ye[3])}else he=ce[3]?ce[3].slice(1,-1):"";return Z=Z.trim(),/^</.test(Z)&&(this.options.pedantic&&!/>$/.test(J)?Z=Z.slice(1):Z=Z.slice(1,-1)),te(ce,{href:Z&&Z.replace(this.rules.inline._escapes,"$1"),title:he&&he.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},Se.reflink=function(se,ce){var J;if((J=this.rules.inline.reflink.exec(se))||(J=this.rules.inline.nolink.exec(se))){var D=(J[2]||J[1]).replace(/\s+/g," ");if(D=ce[D.toLowerCase()],!D||!D.href){var B=J[0].charAt(0);return{type:"text",raw:B,text:B}}return te(J,D,J[0],this.lexer)}},Se.emStrong=function(se,ce,J){J===void 0&&(J="");var D=this.rules.inline.emStrong.lDelim.exec(se);if(!!D&&!(D[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var B=D[1]||D[2]||"";if(!B||B&&(J===""||this.rules.inline.punctuation.exec(J))){var W=D[0].length-1,K,Z,he=W,ye=0,ae=D[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,ce=ce.slice(-1*se.length+W);(D=ae.exec(ce))!=null;)if(K=D[1]||D[2]||D[3]||D[4]||D[5]||D[6],!!K){if(Z=K.length,D[3]||D[4]){he+=Z;continue}else if((D[5]||D[6])&&W%3&&!((W+Z)%3)){ye+=Z;continue}if(he-=Z,!(he>0)){if(Z=Math.min(Z,Z+he+ye),Math.min(W,Z)%2){var be=se.slice(1,W+D.index+Z);return{type:"em",raw:se.slice(0,W+D.index+Z+1),text:be,tokens:this.lexer.inlineTokens(be)}}var Ee=se.slice(2,W+D.index+Z-1);return{type:"strong",raw:se.slice(0,W+D.index+Z+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Se.codespan=function(se){var ce=this.rules.inline.code.exec(se);if(ce){var J=ce[2].replace(/\n/g," "),D=/[^ ]/.test(J),B=/^ /.test(J)&&/ $/.test(J);return D&&B&&(J=J.substring(1,J.length-1)),J=f(J,!0),{type:"codespan",raw:ce[0],text:J}}},Se.br=function(se){var ce=this.rules.inline.br.exec(se);if(ce)return{type:"br",raw:ce[0]}},Se.del=function(se){var ce=this.rules.inline.del.exec(se);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},Se.autolink=function(se,ce){var J=this.rules.inline.autolink.exec(se);if(J){var D,B;return J[2]==="@"?(D=f(this.options.mangle?ce(J[1]):J[1]),B="mailto:"+D):(D=f(J[1]),B=D),{type:"link",raw:J[0],text:D,href:B,tokens:[{type:"text",raw:D,text:D}]}}},Se.url=function(se,ce){var J;if(J=this.rules.inline.url.exec(se)){var D,B;if(J[2]==="@")D=f(this.options.mangle?ce(J[0]):J[0]),B="mailto:"+D;else{var W;do W=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(W!==J[0]);D=f(J[0]),J[1]==="www."?B="http://"+D:B=D}return{type:"link",raw:J[0],text:D,href:B,tokens:[{type:"text",raw:D,text:D}]}}},Se.inlineText=function(se,ce){var J=this.rules.inline.text.exec(se);if(J){var D;return this.lexer.state.inRawBlock?D=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):f(J[0]):J[0]:D=f(this.options.smartypants?ce(J[0]):J[0]),{type:"text",raw:J[0],text:D}}},Te}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=v($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=v(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=v($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=v($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=v($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=a({},$),$.gfm=a({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=v($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=a({},$.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:v($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var T={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};T._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",T.punctuation=v(T.punctuation).replace(/punctuation/g,T._punctuation).getRegex(),T.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,T.escapedEmSt=/\\\*|\\_/g,T._comment=v($._comment).replace("(?:-->|$)","-->").getRegex(),T.emStrong.lDelim=v(T.emStrong.lDelim).replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimAst=v(T.emStrong.rDelimAst,"g").replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimUnd=v(T.emStrong.rDelimUnd,"g").replace(/punct/g,T._punctuation).getRegex(),T._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,T._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,T._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,T.autolink=v(T.autolink).replace("scheme",T._scheme).replace("email",T._email).getRegex(),T._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,T.tag=v(T.tag).replace("comment",T._comment).replace("attribute",T._attribute).getRegex(),T._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,T._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,T._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,T.link=v(T.link).replace("label",T._label).replace("href",T._href).replace("title",T._title).getRegex(),T.reflink=v(T.reflink).replace("label",T._label).replace("ref",$._label).getRegex(),T.nolink=v(T.nolink).replace("ref",$._label).getRegex(),T.reflinkSearch=v(T.reflinkSearch,"g").replace("reflink",T.reflink).replace("nolink",T.nolink).getRegex(),T.normal=a({},T),T.pedantic=a({},T.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",T._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",T._label).getRegex()}),T.gfm=a({},T.normal,{escape:v(T.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),T.gfm.url=v(T.gfm.url,"i").replace("email",T.gfm._extended_email).getRegex(),T.breaks=a({},T.gfm,{br:v(T.br).replace("{2,}","*").getRegex(),text:v(T.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Te){var Se="",ke,se,ce=Te.length;for(ke=0;ke<ce;ke++)se=Te.charCodeAt(ke),Math.random()>.5&&(se="x"+se.toString(16)),Se+="&#"+se+";";return Se}var q=function(){function Te(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||ee.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:$.normal,inline:T.normal};this.options.pedantic?(se.block=$.pedantic,se.inline=T.pedantic):this.options.gfm&&(se.block=$.gfm,this.options.breaks?se.inline=T.breaks:se.inline=T.gfm),this.tokenizer.rules=se}Te.lex=function(se,ce){var J=new Te(ce);return J.lex(se)},Te.lexInline=function(se,ce){var J=new Te(ce);return J.inlineTokens(se)};var Se=Te.prototype;return Se.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},Se.blockTokens=function(se,ce){var J=this;ce===void 0&&(ce=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(he,ye,ae){return ye+"    ".repeat(ae.length)});for(var D,B,W,K;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(he){return(D=he.call({lexer:J},se,ce))?(se=se.substring(D.raw.length),ce.push(D),!0):!1}))){if(D=this.tokenizer.space(se)){se=se.substring(D.raw.length),D.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(D);continue}if(D=this.tokenizer.code(se)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+D.raw,B.text+=`
`+D.text,this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(D);continue}if(D=this.tokenizer.fences(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.heading(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.hr(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.blockquote(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.list(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.html(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.def(se)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&(B.type==="paragraph"||B.type==="text")?(B.raw+=`
`+D.raw,B.text+=`
`+D.raw,this.inlineQueue[this.inlineQueue.length-1].src=B.text):this.tokens.links[D.tag]||(this.tokens.links[D.tag]={href:D.href,title:D.title});continue}if(D=this.tokenizer.table(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.lheading(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(W=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var he=1/0,ye=se.slice(1),ae=void 0;J.options.extensions.startBlock.forEach(function(be){ae=be.call({lexer:this},ye),typeof ae=="number"&&ae>=0&&(he=Math.min(he,ae))}),he<1/0&&he>=0&&(W=se.substring(0,he+1))}(),this.state.top&&(D=this.tokenizer.paragraph(W))){B=ce[ce.length-1],K&&B.type==="paragraph"?(B.raw+=`
`+D.raw,B.text+=`
`+D.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(D),K=W.length!==se.length,se=se.substring(D.raw.length);continue}if(D=this.tokenizer.text(se)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=`
`+D.raw,B.text+=`
`+D.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=B.text):ce.push(D);continue}if(se){var Z="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,ce},Se.inline=function(se,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:se,tokens:ce}),ce},Se.inlineTokens=function(se,ce){var J=this;ce===void 0&&(ce=[]);var D,B,W,K=se,Z,he,ye;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(K))!=null;)ae.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(K=K.slice(0,Z.index)+"["+j("a",Z[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(K))!=null;)K=K.slice(0,Z.index)+"["+j("a",Z[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.escapedEmSt.exec(K))!=null;)K=K.slice(0,Z.index)+"++"+K.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(he||(ye=""),he=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(D=Ee.call({lexer:J},se,ce))?(se=se.substring(D.raw.length),ce.push(D),!0):!1}))){if(D=this.tokenizer.escape(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.tag(se)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&D.type==="text"&&B.type==="text"?(B.raw+=D.raw,B.text+=D.text):ce.push(D);continue}if(D=this.tokenizer.link(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(D.raw.length),B=ce[ce.length-1],B&&D.type==="text"&&B.type==="text"?(B.raw+=D.raw,B.text+=D.text):ce.push(D);continue}if(D=this.tokenizer.emStrong(se,K,ye)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.codespan(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.br(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.del(se)){se=se.substring(D.raw.length),ce.push(D);continue}if(D=this.tokenizer.autolink(se,V)){se=se.substring(D.raw.length),ce.push(D);continue}if(!this.state.inLink&&(D=this.tokenizer.url(se,V))){se=se.substring(D.raw.length),ce.push(D);continue}if(W=se,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,We=se.slice(1),He=void 0;J.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},We),typeof He=="number"&&He>=0&&(Ee=Math.min(Ee,He))}),Ee<1/0&&Ee>=0&&(W=se.substring(0,Ee+1))}(),D=this.tokenizer.inlineText(W,M)){se=se.substring(D.raw.length),D.raw.slice(-1)!=="_"&&(ye=D.raw.slice(-1)),he=!0,B=ce[ce.length-1],B&&B.type==="text"?(B.raw+=D.raw,B.text+=D.text):ce.push(D);continue}if(se){var be="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ce},i(Te,null,[{key:"rules",get:function(){return{block:$,inline:T}}}]),Te}(),le=function(){function Te(ke){this.options=ke||ee.defaults}var Se=Te.prototype;return Se.code=function(se,ce,J){var D=(ce||"").match(/\S*/)[0];if(this.options.highlight){var B=this.options.highlight(se,D);B!=null&&B!==se&&(J=!0,se=B)}return se=se.replace(/\n$/,"")+`
`,D?'<pre><code class="'+this.options.langPrefix+f(D,!0)+'">'+(J?se:f(se,!0))+`</code></pre>
`:"<pre><code>"+(J?se:f(se,!0))+`</code></pre>
`},Se.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Se.html=function(se){return se},Se.heading=function(se,ce,J,D){if(this.options.headerIds){var B=this.options.headerPrefix+D.slug(J);return"<h"+ce+' id="'+B+'">'+se+"</h"+ce+`>
`}return"<h"+ce+">"+se+"</h"+ce+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(se,ce,J){var D=ce?"ol":"ul",B=ce&&J!==1?' start="'+J+'"':"";return"<"+D+B+`>
`+se+"</"+D+`>
`},Se.listitem=function(se){return"<li>"+se+`</li>
`},Se.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(se){return"<p>"+se+`</p>
`},Se.table=function(se,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ce+`</table>
`},Se.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Se.tablecell=function(se,ce){var J=ce.header?"th":"td",D=ce.align?"<"+J+' align="'+ce.align+'">':"<"+J+">";return D+se+("</"+J+`>
`)},Se.strong=function(se){return"<strong>"+se+"</strong>"},Se.em=function(se){return"<em>"+se+"</em>"},Se.codespan=function(se){return"<code>"+se+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(se){return"<del>"+se+"</del>"},Se.link=function(se,ce,J){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var D='<a href="'+f(se)+'"';return ce&&(D+=' title="'+ce+'"'),D+=">"+J+"</a>",D},Se.image=function(se,ce,J){if(se=p(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var D='<img src="'+se+'" alt="'+J+'"';return ce&&(D+=' title="'+ce+'"'),D+=this.options.xhtml?"/>":">",D},Se.text=function(se){return se},Te}(),_=function(){function Te(){}var Se=Te.prototype;return Se.strong=function(se){return se},Se.em=function(se){return se},Se.codespan=function(se){return se},Se.del=function(se){return se},Se.html=function(se){return se},Se.text=function(se){return se},Se.link=function(se,ce,J){return""+J},Se.image=function(se,ce,J){return""+J},Se.br=function(){return""},Te}(),pe=function(){function Te(){this.seen={}}var Se=Te.prototype;return Se.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(se,ce){var J=se,D=0;if(this.seen.hasOwnProperty(J)){D=this.seen[se];do D++,J=se+"-"+D;while(this.seen.hasOwnProperty(J))}return ce||(this.seen[se]=D,this.seen[J]=0),J},Se.slug=function(se,ce){ce===void 0&&(ce={});var J=this.serialize(se);return this.getNextSafeSlug(J,ce.dryrun)},Te}(),ue=function(){function Te(ke){this.options=ke||ee.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new pe}Te.parse=function(se,ce){var J=new Te(ce);return J.parse(se)},Te.parseInline=function(se,ce){var J=new Te(ce);return J.parseInline(se)};var Se=Te.prototype;return Se.parse=function(se,ce){ce===void 0&&(ce=!0);var J="",D,B,W,K,Z,he,ye,ae,be,Ee,We,He,tt,Xe,et,it,dt,Fe,st,Y=se.length;for(D=0;D<Y;D++){if(Ee=se[D],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(st=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){J+=st||"";continue}switch(Ee.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,o(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(ae="",ye="",K=Ee.header.length,B=0;B<K;B++)ye+=this.renderer.tablecell(this.parseInline(Ee.header[B].tokens),{header:!0,align:Ee.align[B]});for(ae+=this.renderer.tablerow(ye),be="",K=Ee.rows.length,B=0;B<K;B++){for(he=Ee.rows[B],ye="",Z=he.length,W=0;W<Z;W++)ye+=this.renderer.tablecell(this.parseInline(he[W].tokens),{header:!1,align:Ee.align[W]});be+=this.renderer.tablerow(ye)}J+=this.renderer.table(ae,be);continue}case"blockquote":{be=this.parse(Ee.tokens),J+=this.renderer.blockquote(be);continue}case"list":{for(We=Ee.ordered,He=Ee.start,tt=Ee.loose,K=Ee.items.length,be="",B=0;B<K;B++)et=Ee.items[B],it=et.checked,dt=et.task,Xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):Xe+=Fe),Xe+=this.parse(et.tokens,tt),be+=this.renderer.listitem(Xe,dt,it);J+=this.renderer.list(be,We,He);continue}case"html":{J+=this.renderer.html(Ee.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(be=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;D+1<Y&&se[D+1].type==="text";)Ee=se[++D],be+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);J+=ce?this.renderer.paragraph(be):be;continue}default:{var Q='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return J},Se.parseInline=function(se,ce){ce=ce||this.renderer;var J="",D,B,W,K=se.length;for(D=0;D<K;D++){if(B=se[D],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[B.type]&&(W=this.options.extensions.renderers[B.type].call({parser:this},B),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(B.type))){J+=W||"";continue}switch(B.type){case"escape":{J+=ce.text(B.text);break}case"html":{J+=ce.html(B.text);break}case"link":{J+=ce.link(B.href,B.title,this.parseInline(B.tokens,ce));break}case"image":{J+=ce.image(B.href,B.title,B.text);break}case"strong":{J+=ce.strong(this.parseInline(B.tokens,ce));break}case"em":{J+=ce.em(this.parseInline(B.tokens,ce));break}case"codespan":{J+=ce.codespan(B.text);break}case"br":{J+=ce.br();break}case"del":{J+=ce.del(this.parseInline(B.tokens,ce));break}case"text":{J+=ce.text(B.text);break}default:{var Z='Token with "'+B.type+'" type was not found.';if(this.options.silent){console.error(Z);return}else throw new Error(Z)}}}return J},Te}();function de(Te,Se,ke){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof Se=="function"&&(ke=Se,Se=null),Se=a({},de.defaults,Se||{}),F(Se),ke){var se=Se.highlight,ce;try{ce=q.lex(Te,Se)}catch(K){return ke(K)}var J=function(Z){var he;if(!Z)try{Se.walkTokens&&de.walkTokens(ce,Se.walkTokens),he=ue.parse(ce,Se)}catch(ye){Z=ye}return Se.highlight=se,Z?ke(Z):ke(null,he)};if(!se||se.length<3||(delete Se.highlight,!ce.length))return J();var D=0;de.walkTokens(ce,function(K){K.type==="code"&&(D++,setTimeout(function(){se(K.text,K.lang,function(Z,he){if(Z)return J(Z);he!=null&&he!==K.text&&(K.text=he,K.escaped=!0),D--,D===0&&J()})},0))}),D===0&&J();return}function B(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(K.message+"",!0)+"</pre>";throw K}try{var W=q.lex(Te,Se);if(Se.walkTokens){if(Se.async)return Promise.all(de.walkTokens(W,Se.walkTokens)).then(function(){return ue.parse(W,Se)}).catch(B);de.walkTokens(W,Se.walkTokens)}return ue.parse(W,Se)}catch(K){B(K)}}de.options=de.setOptions=function(Te){return a(de.defaults,Te),R(de.defaults),de},de.getDefaults=I,de.defaults=ee.defaults,de.use=function(){for(var Te=arguments.length,Se=new Array(Te),ke=0;ke<Te;ke++)Se[ke]=arguments[ke];var se=a.apply(void 0,[{}].concat(Se)),ce=de.defaults.extensions||{renderers:{},childTokens:{}},J;Se.forEach(function(D){if(D.extensions&&(J=!0,D.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var K=ce.renderers?ce.renderers[W.name]:null;K?ce.renderers[W.name]=function(){for(var Z=arguments.length,he=new Array(Z),ye=0;ye<Z;ye++)he[ye]=arguments[ye];var ae=W.renderer.apply(this,he);return ae===!1&&(ae=K.apply(this,he)),ae}:ce.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[W.level]?ce[W.level].unshift(W.tokenizer):ce[W.level]=[W.tokenizer],W.start&&(W.level==="block"?ce.startBlock?ce.startBlock.push(W.start):ce.startBlock=[W.start]:W.level==="inline"&&(ce.startInline?ce.startInline.push(W.start):ce.startInline=[W.start]))}W.childTokens&&(ce.childTokens[W.name]=W.childTokens)})),D.renderer&&function(){var W=de.defaults.renderer||new le,K=function(ye){var ae=W[ye];W[ye]=function(){for(var be=arguments.length,Ee=new Array(be),We=0;We<be;We++)Ee[We]=arguments[We];var He=D.renderer[ye].apply(W,Ee);return He===!1&&(He=ae.apply(W,Ee)),He}};for(var Z in D.renderer)K(Z);se.renderer=W}(),D.tokenizer&&function(){var W=de.defaults.tokenizer||new N,K=function(ye){var ae=W[ye];W[ye]=function(){for(var be=arguments.length,Ee=new Array(be),We=0;We<be;We++)Ee[We]=arguments[We];var He=D.tokenizer[ye].apply(W,Ee);return He===!1&&(He=ae.apply(W,Ee)),He}};for(var Z in D.tokenizer)K(Z);se.tokenizer=W}(),D.walkTokens){var B=de.defaults.walkTokens;se.walkTokens=function(W){var K=[];return K.push(D.walkTokens.call(this,W)),B&&(K=K.concat(B.call(this,W))),K}}J&&(se.extensions=ce),de.setOptions(se)})},de.walkTokens=function(Te,Se){for(var ke=[],se=function(){var B=J.value;switch(ke=ke.concat(Se.call(de,B)),B.type){case"table":{for(var W=L(B.header),K;!(K=W()).done;){var Z=K.value;ke=ke.concat(de.walkTokens(Z.tokens,Se))}for(var he=L(B.rows),ye;!(ye=he()).done;)for(var ae=ye.value,be=L(ae),Ee;!(Ee=be()).done;){var We=Ee.value;ke=ke.concat(de.walkTokens(We.tokens,Se))}break}case"list":{ke=ke.concat(de.walkTokens(B.items,Se));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[B.type]?de.defaults.extensions.childTokens[B.type].forEach(function(He){ke=ke.concat(de.walkTokens(B[He],Se))}):B.tokens&&(ke=ke.concat(de.walkTokens(B.tokens,Se)))}},ce=L(Te),J;!(J=ce()).done;)se();return ke},de.parseInline=function(Te,Se){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");Se=a({},de.defaults,Se||{}),F(Se);try{var ke=q.lexInline(Te,Se);return Se.walkTokens&&de.walkTokens(ke,Se.walkTokens),ue.parseInline(ke,Se)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(se.message+"",!0)+"</pre>";throw se}},de.Parser=ue,de.parser=ue.parse,de.Renderer=le,de.TextRenderer=_,de.Lexer=q,de.lexer=q.lex,de.Tokenizer=N,de.Slugger=pe,de.parse=de;var re=de.options,G=de.setOptions,H=de.use,oe=de.walkTokens,ve=de.parseInline,Ae=de,Be=ue.parse,xe=q.lex;ee.Lexer=q,ee.Parser=ue,ee.Renderer=le,ee.Slugger=pe,ee.TextRenderer=_,ee.Tokenizer=N,ee.getDefaults=I,ee.lexer=xe,ee.marked=de,ee.options=re,ee.parse=Ae,ee.parseInline=ve,ee.parser=Be,ee.setOptions=G,ee.use=H,ee.walkTokens=oe,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ie[112],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(R,y,k){return Math.min(Math.max(R,y),k)}e.clamp=i;function C(R,y){return(y+R%y)%y}e.rot=C;class S{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=S;class L{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=L;class I{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const k=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=I}),function(){function ee(S){const L=[];typeof S=="number"&&L.push("code/timeOrigin",S);function I(y){L.push(y,Date.now())}function R(){const y=[];for(let k=0;k<L.length;k+=2)y.push({name:L[k],startTime:L[k+1]});return y}return{mark:I,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const I of performance.getEntriesByType("mark"))L.push({name:I.name,startTime:Math.round(S+I.startTime)});return L}};if(typeof process=="object"){const S=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function i(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=i(C))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var C in i)(typeof exports=="object"?exports:ee)[C]=i[C]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function i(C){if(e[C])return e[C].exports;var S=e[C]={i:C,l:!1,exports:{}};return ee[C].call(S.exports,S,S.exports,i),S.l=!0,S.exports}return i.m=ee,i.c=e,i.d=function(C,S,L){i.o(C,S)||Object.defineProperty(C,S,{enumerable:!0,get:L})},i.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},i.t=function(C,S){if(1&S&&(C=i(C)),8&S||4&S&&typeof C=="object"&&C&&C.__esModule)return C;var L=Object.create(null);if(i.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:C}),2&S&&typeof C!="string")for(var I in C)i.d(L,I,function(R){return C[R]}.bind(null,I));return L},i.n=function(C){var S=C&&C.__esModule?function(){return C.default}:function(){return C};return i.d(S,"a",S),S},i.o=function(C,S){return Object.prototype.hasOwnProperty.call(C,S)},i.p="",i(i.s=0)}([function(ee,e,i){(function(C){var S;e=ee.exports=H,S=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],y=e.src=[],k=0,O=k++;y[O]="0|[1-9]\\d*";var w=k++;y[w]="[0-9]+";var m=k++;y[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=k++;y[b]="("+y[O]+")\\.("+y[O]+")\\.("+y[O]+")";var f=k++;y[f]="("+y[w]+")\\.("+y[w]+")\\.("+y[w]+")";var r=k++;y[r]="(?:"+y[O]+"|"+y[m]+")";var o=k++;y[o]="(?:"+y[w]+"|"+y[m]+")";var l=k++;y[l]="(?:-("+y[r]+"(?:\\."+y[r]+")*))";var v=k++;y[v]="(?:-?("+y[o]+"(?:\\."+y[o]+")*))";var E=k++;y[E]="[0-9A-Za-z-]+";var P=k++;y[P]="(?:\\+("+y[E]+"(?:\\."+y[E]+")*))";var p=k++,n="v?"+y[b]+y[l]+"?"+y[P]+"?";y[p]="^"+n+"$";var d="[v=\\s]*"+y[f]+y[v]+"?"+y[P]+"?",t=k++;y[t]="^"+d+"$";var u=k++;y[u]="((?:<|>)?=?)";var s=k++;y[s]=y[w]+"|x|X|\\*";var h=k++;y[h]=y[O]+"|x|X|\\*";var a=k++;y[a]="[v=\\s]*("+y[h]+")(?:\\.("+y[h]+")(?:\\.("+y[h]+")(?:"+y[l]+")?"+y[P]+"?)?)?";var c=k++;y[c]="[v=\\s]*("+y[s]+")(?:\\.("+y[s]+")(?:\\.("+y[s]+")(?:"+y[v]+")?"+y[P]+"?)?)?";var g=k++;y[g]="^"+y[u]+"\\s*"+y[a]+"$";var A=k++;y[A]="^"+y[u]+"\\s*"+y[c]+"$";var F=k++;y[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=k++;y[j]="(?:~>?)";var te=k++;y[te]="(\\s*)"+y[j]+"\\s+",R[te]=new RegExp(y[te],"g");var x=k++;y[x]="^"+y[j]+y[a]+"$";var N=k++;y[N]="^"+y[j]+y[c]+"$";var $=k++;y[$]="(?:\\^)";var T=k++;y[T]="(\\s*)"+y[$]+"\\s+",R[T]=new RegExp(y[T],"g");var M=k++;y[M]="^"+y[$]+y[a]+"$";var V=k++;y[V]="^"+y[$]+y[c]+"$";var q=k++;y[q]="^"+y[u]+"\\s*("+d+")$|^$";var le=k++;y[le]="^"+y[u]+"\\s*("+n+")$|^$";var _=k++;y[_]="(\\s*)"+y[u]+"\\s*("+d+"|"+y[a]+")",R[_]=new RegExp(y[_],"g");var pe=k++;y[pe]="^\\s*("+y[a]+")\\s+-\\s+("+y[a]+")\\s*$";var ue=k++;y[ue]="^\\s*("+y[c]+")\\s+-\\s+("+y[c]+")\\s*$";var de=k++;y[de]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)S(re,y[re]),R[re]||(R[re]=new RegExp(y[re]));function G(ae,be){if(ae instanceof H)return ae;if(typeof ae!="string"||ae.length>L||!(be?R[t]:R[p]).test(ae))return null;try{return new H(ae,be)}catch{return null}}function H(ae,be){if(ae instanceof H){if(ae.loose===be)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof H))return new H(ae,be);S("SemVer",ae,be),this.loose=be;var Ee=ae.trim().match(be?R[t]:R[p]);if(!Ee)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var He=+We;if(He>=0&&He<I)return He}return We}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=G,e.valid=function(ae,be){var Ee=G(ae,be);return Ee?Ee.version:null},e.clean=function(ae,be){var Ee=G(ae.trim().replace(/^[=v]+/,""),be);return Ee?Ee.version:null},e.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(ae){return S("SemVer.compare",this.version,this.loose,ae),ae instanceof H||(ae=new H(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},H.prototype.compareMain=function(ae){return ae instanceof H||(ae=new H(ae,this.loose)),ve(this.major,ae.major)||ve(this.minor,ae.minor)||ve(this.patch,ae.patch)},H.prototype.comparePre=function(ae){if(ae instanceof H||(ae=new H(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var be=0;do{var Ee=this.prerelease[be],We=ae.prerelease[be];if(S("prerelease compare",be,Ee,We),Ee===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==We)return ve(Ee,We)}while(++be)},H.prototype.inc=function(ae,be){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,be,Ee,We){typeof Ee=="string"&&(We=Ee,Ee=void 0);try{return new H(ae,Ee).inc(be,We).version}catch{return null}},e.diff=function(ae,be){if(Te(ae,be))return null;var Ee=G(ae),We=G(be);if(Ee.prerelease.length||We.prerelease.length){for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==We[He])return"pre"+He;return"prerelease"}for(var He in Ee)if((He==="major"||He==="minor"||He==="patch")&&Ee[He]!==We[He])return He},e.compareIdentifiers=ve;var oe=/^[0-9]+$/;function ve(ae,be){var Ee=oe.test(ae),We=oe.test(be);return Ee&&We&&(ae=+ae,be=+be),Ee&&!We?-1:We&&!Ee?1:ae<be?-1:ae>be?1:0}function Ae(ae,be,Ee){return new H(ae,Ee).compare(new H(be,Ee))}function Be(ae,be,Ee){return Ae(ae,be,Ee)>0}function xe(ae,be,Ee){return Ae(ae,be,Ee)<0}function Te(ae,be,Ee){return Ae(ae,be,Ee)===0}function Se(ae,be,Ee){return Ae(ae,be,Ee)!==0}function ke(ae,be,Ee){return Ae(ae,be,Ee)>=0}function se(ae,be,Ee){return Ae(ae,be,Ee)<=0}function ce(ae,be,Ee,We){var He;switch(be){case"===":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),He=ae===Ee;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof Ee=="object"&&(Ee=Ee.version),He=ae!==Ee;break;case"":case"=":case"==":He=Te(ae,Ee,We);break;case"!=":He=Se(ae,Ee,We);break;case">":He=Be(ae,Ee,We);break;case">=":He=ke(ae,Ee,We);break;case"<":He=xe(ae,Ee,We);break;case"<=":He=se(ae,Ee,We);break;default:throw new TypeError("Invalid operator: "+be)}return He}function J(ae,be){if(ae instanceof J){if(ae.loose===be)return ae;ae=ae.value}if(!(this instanceof J))return new J(ae,be);S("comparator",ae,be),this.loose=be,this.parse(ae),this.semver===D?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(ae,be){return ve(be,ae)},e.major=function(ae,be){return new H(ae,be).major},e.minor=function(ae,be){return new H(ae,be).minor},e.patch=function(ae,be){return new H(ae,be).patch},e.compare=Ae,e.compareLoose=function(ae,be){return Ae(ae,be,!0)},e.rcompare=function(ae,be,Ee){return Ae(be,ae,Ee)},e.sort=function(ae,be){return ae.sort(function(Ee,We){return e.compare(Ee,We,be)})},e.rsort=function(ae,be){return ae.sort(function(Ee,We){return e.rcompare(Ee,We,be)})},e.gt=Be,e.lt=xe,e.eq=Te,e.neq=Se,e.gte=ke,e.lte=se,e.cmp=ce,e.Comparator=J;var D={};function B(ae,be){if(ae instanceof B)return ae.loose===be?ae:new B(ae.raw,be);if(ae instanceof J)return new B(ae.value,be);if(!(this instanceof B))return new B(ae,be);if(this.loose=be,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function W(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function K(ae,be,Ee,We,He,tt,Xe,et,it,dt,Fe,st,Y){return((be=W(Ee)?"":W(We)?">="+Ee+".0.0":W(He)?">="+Ee+"."+We+".0":">="+be)+" "+(et=W(it)?"":W(dt)?"<"+(+it+1)+".0.0":W(Fe)?"<"+it+"."+(+dt+1)+".0":st?"<="+it+"."+dt+"."+Fe+"-"+st:"<="+et)).trim()}function Z(ae,be){for(var Ee=0;Ee<ae.length;Ee++)if(!ae[Ee].test(be))return!1;if(be.prerelease.length){for(Ee=0;Ee<ae.length;Ee++)if(S(ae[Ee].semver),ae[Ee].semver!==D&&ae[Ee].semver.prerelease.length>0){var We=ae[Ee].semver;if(We.major===be.major&&We.minor===be.minor&&We.patch===be.patch)return!0}return!1}return!0}function he(ae,be,Ee){try{be=new B(be,Ee)}catch{return!1}return be.test(ae)}function ye(ae,be,Ee,We){var He,tt,Xe,et,it;switch(ae=new H(ae,We),be=new B(be,We),Ee){case">":He=Be,tt=se,Xe=xe,et=">",it=">=";break;case"<":He=xe,tt=ke,Xe=Be,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(he(ae,be,We))return!1;for(var dt=0;dt<be.set.length;++dt){var Fe=be.set[dt],st=null,Y=null;if(Fe.forEach(function(Q){Q.semver===D&&(Q=new J(">=0.0.0")),st=st||Q,Y=Y||Q,He(Q.semver,st.semver,We)?st=Q:Xe(Q.semver,Y.semver,We)&&(Y=Q)}),st.operator===et||st.operator===it||(!Y.operator||Y.operator===et)&&tt(ae,Y.semver)||Y.operator===it&&Xe(ae,Y.semver))return!1}return!0}J.prototype.parse=function(ae){var be=this.loose?R[q]:R[le],Ee=ae.match(be);if(!Ee)throw new TypeError("Invalid comparator: "+ae);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new H(Ee[2],this.loose):this.semver=D},J.prototype.toString=function(){return this.value},J.prototype.test=function(ae){return S("Comparator.test",ae,this.loose),this.semver===D||(typeof ae=="string"&&(ae=new H(ae,this.loose)),ce(ae,this.operator,this.semver,this.loose))},J.prototype.intersects=function(ae,be){if(!(ae instanceof J))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new B(ae.value,be),he(this.value,Ee,be);if(ae.operator==="")return Ee=new B(this.value,be),he(ae.semver,Ee,be);var We=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),tt=this.semver.version===ae.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),et=ce(this.semver,"<",ae.semver,be)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),it=ce(this.semver,">",ae.semver,be)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return We||He||tt&&Xe||et||it},e.Range=B,B.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},B.prototype.toString=function(){return this.range},B.prototype.parseRange=function(ae){var be=this.loose;ae=ae.trim(),S("range",ae,be);var Ee=be?R[ue]:R[pe];ae=ae.replace(Ee,K),S("hyphen replace",ae),ae=ae.replace(R[_],"$1$2$3"),S("comparator trim",ae,R[_]),ae=(ae=(ae=ae.replace(R[te],"$1~")).replace(R[T],"$1^")).split(/\s+/).join(" ");var We=be?R[q]:R[le],He=ae.split(" ").map(function(tt){return function(Xe,et){return S("comp",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,Y){S("caret",st,Y);var Q=Y?R[V]:R[M];return st.replace(Q,function(ge,Me,$e,je,Ye){var nt;return S("caret",st,ge,Me,$e,je,Ye),W(Me)?nt="":W($e)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(je)?nt=Me==="0"?">="+Me+"."+$e+".0 <"+Me+"."+(+$e+1)+".0":">="+Me+"."+$e+".0 <"+(+Me+1)+".0.0":Ye?(S("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),nt=Me==="0"?$e==="0"?">="+Me+"."+$e+"."+je+Ye+" <"+Me+"."+$e+"."+(+je+1):">="+Me+"."+$e+"."+je+Ye+" <"+Me+"."+(+$e+1)+".0":">="+Me+"."+$e+"."+je+Ye+" <"+(+Me+1)+".0.0"):(S("no pr"),nt=Me==="0"?$e==="0"?">="+Me+"."+$e+"."+je+" <"+Me+"."+$e+"."+(+je+1):">="+Me+"."+$e+"."+je+" <"+Me+"."+(+$e+1)+".0":">="+Me+"."+$e+"."+je+" <"+(+Me+1)+".0.0"),S("caret return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),S("caret",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,Y){var Q=Y?R[N]:R[x];return st.replace(Q,function(ge,Me,$e,je,Ye){var nt;return S("tilde",st,ge,Me,$e,je,Ye),W(Me)?nt="":W($e)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(je)?nt=">="+Me+"."+$e+".0 <"+Me+"."+(+$e+1)+".0":Ye?(S("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),nt=">="+Me+"."+$e+"."+je+Ye+" <"+Me+"."+(+$e+1)+".0"):nt=">="+Me+"."+$e+"."+je+" <"+Me+"."+(+$e+1)+".0",S("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),S("tildes",Xe),Xe=function(it,dt){return S("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(st,Y){st=st.trim();var Q=Y?R[A]:R[g];return st.replace(Q,function(ge,Me,$e,je,Ye,nt){S("xRange",st,ge,Me,$e,je,Ye,nt);var wt=W($e),St=wt||W(je),Ct=St||W(Ye);return Me==="="&&Ct&&(Me=""),wt?ge=Me===">"||Me==="<"?"<0.0.0":"*":Me&&Ct?(St&&(je=0),Ct&&(Ye=0),Me===">"?(Me=">=",St?($e=+$e+1,je=0,Ye=0):Ct&&(je=+je+1,Ye=0)):Me==="<="&&(Me="<",St?$e=+$e+1:je=+je+1),ge=Me+$e+"."+je+"."+Ye):St?ge=">="+$e+".0.0 <"+(+$e+1)+".0.0":Ct&&(ge=">="+$e+"."+je+".0 <"+$e+"."+(+je+1)+".0"),S("xRange return",ge),ge})}(Fe,dt)}).join(" ")}(Xe,et),S("xrange",Xe),Xe=function(it,dt){return S("replaceStars",it,dt),it.trim().replace(R[de],"")}(Xe,et),S("stars",Xe),Xe}(tt,be)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match(We)})),He=He.map(function(tt){return new J(tt,be)})},B.prototype.intersects=function(ae,be){if(!(ae instanceof B))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(We){return ae.set.some(function(He){return He.every(function(tt){return We.intersects(tt,be)})})})})},e.toComparators=function(ae,be){return new B(ae,be).set.map(function(Ee){return Ee.map(function(We){return We.value}).join(" ").trim().split(" ")})},B.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new H(ae,this.loose));for(var be=0;be<this.set.length;be++)if(Z(this.set[be],ae))return!0;return!1},e.satisfies=he,e.maxSatisfying=function(ae,be,Ee){var We=null,He=null;try{var tt=new B(be,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==-1||(He=new H(We=Xe,Ee)))}),We},e.minSatisfying=function(ae,be,Ee){var We=null,He=null;try{var tt=new B(be,Ee)}catch{return null}return ae.forEach(function(Xe){tt.test(Xe)&&(We&&He.compare(Xe)!==1||(He=new H(We=Xe,Ee)))}),We},e.validRange=function(ae,be){try{return new B(ae,be).range||"*"}catch{return null}},e.ltr=function(ae,be,Ee){return ye(ae,be,"<",Ee)},e.gtr=function(ae,be,Ee){return ye(ae,be,">",Ee)},e.outside=ye,e.prerelease=function(ae,be){var Ee=G(ae,be);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(ae,be,Ee){return ae=new B(ae,Ee),be=new B(be,Ee),ae.intersects(be)},e.coerce=function(ae){if(ae instanceof H)return ae;if(typeof ae!="string")return null;var be=ae.match(R[F]);return be==null?null:G((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,i(1))},function(ee,e){var i,C,S=ee.exports={};function L(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function R(o){if(i===setTimeout)return setTimeout(o,0);if((i===L||!i)&&setTimeout)return i=setTimeout,setTimeout(o,0);try{return i(o,0)}catch{try{return i.call(null,o,0)}catch{return i.call(this,o,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:L}catch{i=L}try{C=typeof clearTimeout=="function"?clearTimeout:I}catch{C=I}})();var y,k=[],O=!1,w=-1;function m(){O&&y&&(O=!1,y.length?k=y.concat(k):w=-1,k.length&&b())}function b(){if(!O){var o=R(m);O=!0;for(var l=k.length;l;){for(y=k,k=[];++w<l;)y&&y[w].run();w=-1,l=k.length}y=null,O=!1,function(v){if(C===clearTimeout)return clearTimeout(v);if((C===I||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(v);try{C(v)}catch{try{return C.call(null,v)}catch{return C.call(this,v)}}}(o)}}function f(o,l){this.fun=o,this.array=l}function r(){}S.nextTick=function(o){var l=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)l[v-1]=arguments[v];k.push(new f(o,l)),k.length!==1||O||R(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=r,S.addListener=r,S.once=r,S.off=r,S.removeListener=r,S.removeAllListeners=r,S.emit=r,S.prependListener=r,S.prependOnceListener=r,S.listeners=function(o){return[]},S.binding=function(o){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(o){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Ie[113],Ce([1,0,11,6]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(P){const p=P;return p?typeof p.read=="function":!1}e.isReadable=S;function L(P){const p=P;return p?[p.on,p.pause,p.resume,p.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=L;function I(P){const p=P;return p?L(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=I;function R(P,p){return new y(P,p)}e.newWriteableStream=R;class y{constructor(p,n){this.e=p,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(n=>n(p))}h(p){this.c.error.length===0?(0,i.onUnexpectedError)(p):this.c.error.slice(0).forEach(n=>n(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,n){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(p,n){if(this.a.destroyed)return;let d;switch(p){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const t=d.indexOf(n);t>=0&&d.splice(t,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(P,p){const n=[];let d;for(;(d=P.read())!==null;)n.push(d);return p(n)}e.consumeReadable=k;function O(P,p,n){const d=[];let t;for(;(t=P.read())!==null&&d.length<n;)d.push(t);return t===null&&d.length>0?p(d):{read:()=>{if(d.length>0)return d.shift();if(typeof t<"u"){const u=t;return t=void 0,u}return P.read()}}}e.peekReadable=O;function w(P,p){return new Promise((n,d)=>{const t=[];m(P,{onData:u=>{p&&t.push(u)},onError:u=>{p?d(u):n(void 0)},onEnd:()=>{n(p?p(t):void 0)}})})}e.consumeStream=w;function m(P,p){let n=!1;return P.on("error",d=>{n||p.onError(d)}),P.on("end",()=>{n||p.onEnd()}),P.on("data",d=>{n||p.onData(d)}),(0,C.toDisposable)(()=>n=!0)}e.listenStream=m;function b(P,p){return new Promise((n,d)=>{const t=new C.DisposableStore,u=[],s=c=>{if(u.push(c),u.length>p)return t.dispose(),P.pause(),n({stream:P,buffer:u,ended:!1})},h=c=>d(c),a=()=>n({stream:P,buffer:u,ended:!0});t.add((0,C.toDisposable)(()=>P.removeListener("error",h))),P.on("error",h),t.add((0,C.toDisposable)(()=>P.removeListener("end",a))),P.on("end",a),t.add((0,C.toDisposable)(()=>P.removeListener("data",s))),P.on("data",s)})}e.peekStream=b;function f(P,p){const n=R(p);return n.end(P),n}e.toStream=f;function r(){const P=R(()=>{throw new Error("not supported")});return P.end(),P}e.emptyStream=r;function o(P){let p=!1;return{read:()=>p?null:(p=!0,P)}}e.toReadable=o;function l(P,p,n){const d=R(n);return m(P,{onData:t=>d.write(p.data(t)),onError:t=>d.error(p.error?p.error(t):t),onEnd:()=>d.end()}),d}e.transform=l;function v(P,p,n){let d=!1;return{read:()=>{const t=p.read();return d?t:(d=!0,t!==null?n([P,t]):P)}}}e.prefixedReadable=v;function E(P,p,n){let d=!1;const t=R(n);return m(p,{onData:u=>d?t.write(u):(d=!0,t.write(n([P,u]))),onError:u=>t.error(u),onEnd:()=>{d||(d=!0,t.write(P)),t.end()}}),t}e.prefixedStream=E}),define(Ie[25],Ce([1,0,113]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u";let S,L;class I{static alloc(c){return C?new I(Buffer.allocUnsafe(c)):new I(new Uint8Array(c))}static wrap(c){return C&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new I(c)}static fromString(c,g){return!(g?.dontUseNodeBuffer||!1)&&C?new I(Buffer.from(c)):(S||(S=new TextEncoder),new I(S.encode(c)))}static fromByteArray(c){const g=I.alloc(c.length);for(let A=0,F=c.length;A<F;A++)g.buffer[A]=c[A];return g}static concat(c,g){if(typeof g>"u"){g=0;for(let j=0,te=c.length;j<te;j++)g+=c[j].byteLength}const A=I.alloc(g);let F=0;for(let j=0,te=c.length;j<te;j++){const x=c[j];A.set(x,F),F+=x.byteLength}return A}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=I.alloc(this.byteLength);return c.set(this),c}toString(){return C?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(c,g){return new I(this.buffer.subarray(c,g))}set(c,g){if(c instanceof I)this.buffer.set(c.buffer,g);else if(c instanceof Uint8Array)this.buffer.set(c,g);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),g);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return k(this.buffer,c)}writeUInt32BE(c,g){O(this.buffer,c,g)}readUInt32LE(c){return w(this.buffer,c)}writeUInt32LE(c,g){m(this.buffer,c,g)}readUInt8(c){return b(this.buffer,c)}writeUInt8(c,g){f(this.buffer,c,g)}}e.VSBuffer=I;function R(a,c){return a[c+0]<<0>>>0|a[c+1]<<8>>>0}e.readUInt16LE=R;function y(a,c,g){a[g+0]=c&255,c=c>>>8,a[g+1]=c&255}e.writeUInt16LE=y;function k(a,c){return a[c]*2**24+a[c+1]*2**16+a[c+2]*2**8+a[c+3]}e.readUInt32BE=k;function O(a,c,g){a[g+3]=c,c=c>>>8,a[g+2]=c,c=c>>>8,a[g+1]=c,c=c>>>8,a[g]=c}e.writeUInt32BE=O;function w(a,c){return a[c+0]<<0>>>0|a[c+1]<<8>>>0|a[c+2]<<16>>>0|a[c+3]<<24>>>0}e.readUInt32LE=w;function m(a,c,g){a[g+0]=c&255,c=c>>>8,a[g+1]=c&255,c=c>>>8,a[g+2]=c&255,c=c>>>8,a[g+3]=c&255}e.writeUInt32LE=m;function b(a,c){return a[c]}e.readUInt8=b;function f(a,c,g){a[g]=c}e.writeUInt8=f;function r(a){return i.consumeReadable(a,c=>I.concat(c))}e.readableToBuffer=r;function o(a){return i.toReadable(a)}e.bufferToReadable=o;function l(a){return i.consumeStream(a,c=>I.concat(c))}e.streamToBuffer=l;async function v(a){return a.ended?I.concat(a.buffer):I.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=v;function E(a){return i.toStream(a,c=>I.concat(c))}e.bufferToStream=E;function P(a){return i.transform(a,{data:c=>typeof c=="string"?I.fromString(c):I.wrap(c)},c=>I.concat(c))}e.streamToBufferReadableStream=P;function p(a){return i.newWriteableStream(c=>I.concat(c),a)}e.newWriteableBufferStream=p;function n(a,c){return i.prefixedReadable(a,c,g=>I.concat(g))}e.prefixedBufferReadable=n;function d(a,c){return i.prefixedStream(a,c,g=>I.concat(g))}e.prefixedBufferStream=d;function t(a){let c=0,g=0,A=0;const F=new Uint8Array(Math.floor(a.length/4*3)),j=x=>{switch(g){case 3:F[A++]=c|x,g=0;break;case 2:F[A++]=c|x>>>2,c=x<<6,g=3;break;case 1:F[A++]=c|x>>>4,c=x<<4,g=2;break;default:c=x<<2,g=1}};for(let x=0;x<a.length;x++){const N=a.charCodeAt(x);if(N>=65&&N<=90)j(N-65);else if(N>=97&&N<=122)j(N-97+26);else if(N>=48&&N<=57)j(N-48+52);else if(N===43||N===45)j(62);else if(N===47||N===95)j(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${a[x]}`)}}const te=A;for(;g>0;)j(0);return I.wrap(F).slice(0,te)}e.decodeBase64=t;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:a},c=!0,g=!1){const A=g?s:u;let F="";const j=a.byteLength%3;let te=0;for(;te<a.byteLength-j;te+=3){const x=a[te+0],N=a[te+1],$=a[te+2];F+=A[x>>>2],F+=A[(x<<4|N>>>4)&63],F+=A[(N<<2|$>>>6)&63],F+=A[$&63]}if(j===1){const x=a[te+0];F+=A[x>>>2],F+=A[x<<4&63],c&&(F+="==")}else if(j===2){const x=a[te+0],N=a[te+1];F+=A[x>>>2],F+=A[(x<<4|N>>>4)&63],F+=A[N<<2&63],c&&(F+="=")}return F}e.encodeBase64=h}),define(Ie[34],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(S){return i.test(S)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(R){for(let y=0;y<R.length;y++)R[y]=Math.floor(Math.random()*256);return R};const L=new Uint8Array(16),I=[];for(let R=0;R<256;R++)I.push(R.toString(16).padStart(2,"0"));return function(){S(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let y=0,k="";return k+=I[L[y++]],k+=I[L[y++]],k+=I[L[y++]],k+=I[L[y++]],k+="-",k+=I[L[y++]],k+=I[L[y++]],k+="-",k+=I[L[y++]],k+=I[L[y++]],k+="-",k+=I[L[y++]],k+=I[L[y++]],k+="-",k+=I[L[y++]],k+=I[L[y++]],k+=I[L[y++]],k+=I[L[y++]],k+=I[L[y++]],k+=I[L[y++]],k}}()}),define(Ie[114],Ce([1,0,18,34]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function S(R){return{id:(0,C.generateUuid)(),asString:async()=>R,asFile:()=>{},value:typeof R=="string"?R:void 0}}e.createStringDataTransferItem=S;function L(R,y,k){return{id:(0,C.generateUuid)(),asString:async()=>"",asFile:()=>({name:R,uri:y,data:k}),value:void 0}}e.createFileDataTransferItem=L;class I{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,k){const O=this.a.get(y);O?O.push(k):this.a.set(this.b(y),[k])}replace(y,k){this.a.set(this.b(y),[k])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,k]of this.a.entries())for(const O of k)yield[y,O]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[k,O]of this.entries())y(O,k)}b(y){return y.toLowerCase()}}e.VSDataTransfer=I,e.UriList=Object.freeze({create:R=>(0,i.distinct)(R.map(y=>y.toString())).join(`\r
`),split:R=>R.split(`\r
`),parse:R=>e.UriList.split(R).filter(y=>!y.startsWith("#"))})}),define(Ie[115],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[116],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class C{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let y=0,k=R.notIn.length;y<k;y++)switch(R.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,y){if(R.getTokenCount()===0)return!0;const k=R.findTokenIndexAtOffset(y-2),O=R.getStandardTokenType(k);return this.isOK(O)}g(R,y){for(let k=R;k<=y;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=C;class S{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of R)L(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),L(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),L(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),L(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&L(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=S;function L(I,R,y){I.has(R)?I.get(R).push(y):I.set(R,[y])}}),define(Ie[117],Ce([14,15]),function(ee,e){return ee.create("vs/base/common/actions",e)}),define(Ie[118],Ce([14,15]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ie[119],Ce([1,0,118]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,S=C*60,L=S*24,I=L*7,R=L*30,y=L*365;function k(w,m,b,f){typeof w!="number"&&(w=w.getTime());const r=Math.round((new Date().getTime()-w)/1e3);if(r<-30)return(0,i.localize)(0,null,k(new Date().getTime()+r*1e3,!1));if(!f&&r<30)return(0,i.localize)(1,null);let o;return r<C?(o=r,m?o===1?b?(0,i.localize)(2,null,o):(0,i.localize)(3,null,o):b?(0,i.localize)(4,null,o):(0,i.localize)(5,null,o):o===1?b?(0,i.localize)(6,null,o):(0,i.localize)(7,null,o):b?(0,i.localize)(8,null,o):(0,i.localize)(9,null,o)):r<S?(o=Math.floor(r/C),m?o===1?b?(0,i.localize)(10,null,o):(0,i.localize)(11,null,o):b?(0,i.localize)(12,null,o):(0,i.localize)(13,null,o):o===1?b?(0,i.localize)(14,null,o):(0,i.localize)(15,null,o):b?(0,i.localize)(16,null,o):(0,i.localize)(17,null,o)):r<L?(o=Math.floor(r/S),m?o===1?b?(0,i.localize)(18,null,o):(0,i.localize)(19,null,o):b?(0,i.localize)(20,null,o):(0,i.localize)(21,null,o):o===1?b?(0,i.localize)(22,null,o):(0,i.localize)(23,null,o):b?(0,i.localize)(24,null,o):(0,i.localize)(25,null,o)):r<I?(o=Math.floor(r/L),m?o===1?(0,i.localize)(26,null,o):(0,i.localize)(27,null,o):o===1?(0,i.localize)(28,null,o):(0,i.localize)(29,null,o)):r<R?(o=Math.floor(r/I),m?o===1?b?(0,i.localize)(30,null,o):(0,i.localize)(31,null,o):b?(0,i.localize)(32,null,o):(0,i.localize)(33,null,o):o===1?b?(0,i.localize)(34,null,o):(0,i.localize)(35,null,o):b?(0,i.localize)(36,null,o):(0,i.localize)(37,null,o)):r<y?(o=Math.floor(r/R),m?o===1?b?(0,i.localize)(38,null,o):(0,i.localize)(39,null,o):b?(0,i.localize)(40,null,o):(0,i.localize)(41,null,o):o===1?b?(0,i.localize)(42,null,o):(0,i.localize)(43,null,o):b?(0,i.localize)(44,null,o):(0,i.localize)(45,null,o)):(o=Math.floor(r/y),m?o===1?b?(0,i.localize)(46,null,o):(0,i.localize)(47,null,o):b?(0,i.localize)(48,null,o):(0,i.localize)(49,null,o):o===1?b?(0,i.localize)(50,null,o):(0,i.localize)(51,null,o):b?(0,i.localize)(52,null,o):(0,i.localize)(53,null,o))}e.fromNow=k;function O(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ie[120],Ce([14,15]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ie[39],Ce([1,0,18,9,120]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(w,m){return m&&(w.stack||w.stacktrace)?S.localize(0,null,R(w),I(w.stack)||I(w.stacktrace)):R(w)}function I(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?S.localize(1,null,w.message):w.message||S.localize(2,null)}function y(w=null,m=!1){if(!w)return S.localize(3,null);if(Array.isArray(w)){const b=i.coalesce(w),f=y(b[0],m);return b.length>1?S.localize(4,null,f,b.length):f}if(C.isString(w))return w;if(w.detail){const b=w.detail;if(b.error)return L(b.error,m);if(b.exception)return L(b.exception,m)}return w.stack?L(w,m):w.message?w.message:S.localize(5,null)}e.toErrorMessage=y;function k(w){const m=w;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=k;function O(w,m){let b;return typeof w=="string"?b=new Error(w):b=w,b.actions=m,b}e.createErrorWithActions=O}),define(Ie[64],Ce([1,0,19]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(O){const w=(0,i.extname)(O),m=C[w.toLowerCase()];return m!==void 0?m:I(O)}e.getMediaOrTextMime=L;function I(O){const w=(0,i.extname)(O);return S[w.toLowerCase()]}e.getMediaMime=I;function R(O){for(const w in S)if(S[w]===O)return w}e.getExtensionForMimeType=R;const y=/^(.+)\/(.+?)(;.+)?$/;function k(O,w){const m=y.exec(O);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:w?void 0:O}e.normalizeMimeType=k}),define(Ie[121],Ce([1,0,4,6,117]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class L extends C.Disposable{constructor(m,b="",f="",r=!0,o){super(),this.h=this.B(new i.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=b,this.u=f,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,b){this.C&&await this.C(m)}}e.Action=L;class I extends C.Disposable{constructor(){super(...arguments),this.f=this.B(new i.Emitter),this.onWillRun=this.f.event,this.h=this.B(new i.Emitter),this.onDidRun=this.h.event}async run(m,b){if(!m.enabled)return;this.f.fire({action:m});let f;try{await this.runAction(m,b)}catch(r){f=r}this.h.fire({action:m,error:f})}async runAction(m,b){await m.run(b)}}e.ActionRunner=I;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let b=[];for(const f of m)f.length&&(b.length?b=[...b,new R,...f]:b=f);return b}async run(){}}e.Separator=R,R.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(m,b,f,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=b,this.class=r,this.a=f}async run(){}}e.SubmenuAction=y;class k extends L{constructor(){super(k.ID,S.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=k,k.ID="vs.actions.empty";function O(w){return{id:w.id,label:w.label,class:void 0,enabled:w.enabled??!0,checked:w.checked??!1,run:async()=>w.run(),tooltip:w.label}}e.toAction=O}),define(Ie[40],Ce([1,0,19,20,10,9]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(s){return s===47||s===92}e.isPathSeparator=I;function R(s){return s.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=R;function y(s){return s.indexOf("/")===-1&&(s=R(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=y;function k(s,h=i.posix.sep){if(!s)return"";const a=s.length,c=s.charCodeAt(0);if(I(c)){if(I(s.charCodeAt(1))&&!I(s.charCodeAt(2))){let A=3;const F=A;for(;A<a&&!I(s.charCodeAt(A));A++);if(F!==A&&!I(s.charCodeAt(A+1))){for(A+=1;A<a;A++)if(I(s.charCodeAt(A)))return s.slice(0,A+1).replace(/[\\/]/g,h)}}return h}else if(l(c)&&s.charCodeAt(1)===58)return I(s.charCodeAt(2))?s.slice(0,2)+h:s.slice(0,2);let g=s.indexOf("://");if(g!==-1){for(g+=3;g<a;g++)if(I(s.charCodeAt(g)))return s.slice(0,g+1)}return""}e.getRoot=k;function O(s){if(!C.isWindows||!s||s.length<5)return!1;let h=s.charCodeAt(0);if(h!==92||(h=s.charCodeAt(1),h!==92))return!1;let a=2;const c=a;for(;a<s.length&&(h=s.charCodeAt(a),h!==92);a++);return!(c===a||(h=s.charCodeAt(a+1),isNaN(h)||h===92))}e.isUNC=O;const w=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,h=C.isWindows){const a=h?w:m;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||h&&b.test(s)||s==="."||s===".."||h&&s[s.length-1]==="."||h&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function r(s,h,a){const c=s===h;return!a||c?c:!s||!h?!1:(0,S.equalsIgnoreCase)(s,h)}e.isEqual=r;function o(s,h,a,c=i.sep){if(s===h)return!0;if(!s||!h||h.length>s.length)return!1;if(a){if(!(0,S.startsWithIgnoreCase)(s,h))return!1;if(h.length===s.length)return!0;let A=h.length;return h.charAt(h.length-1)===c&&A--,s.charAt(A)===c}return h.charAt(h.length-1)!==c&&(h+=c),s.indexOf(h)===0}e.isEqualOrParent=o;function l(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=l;function v(s,h){return C.isWindows&&s.endsWith(":")&&(s+=i.sep),(0,i.isAbsolute)(s)||(s=(0,i.join)(h,s)),s=(0,i.normalize)(s),C.isWindows?(s=(0,S.rtrim)(s,i.sep),s.endsWith(":")&&(s+=i.sep)):(s=(0,S.rtrim)(s,i.sep),s||(s=i.sep)),s}e.sanitizeFilePath=v;function E(s){const h=(0,i.normalize)(s);return C.isWindows?s.length>3?!1:P(h)&&(s.length===2||h.charCodeAt(2)===92):h===i.posix.sep}e.isRootOrDriveLetter=E;function P(s,h=C.isWindows){return h?l(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=P;function p(s){return P(s)?s[0]:void 0}e.getDriveLetter=p;function n(s,h,a){return h.length>s.length?-1:s===h?0:(a&&(s=s.toLowerCase(),h=h.toLowerCase()),s.indexOf(h))}e.indexOfPath=n;function d(s){const h=s.split(":");let a,c,g;for(const A of h){const F=Number(A);(0,L.isNumber)(F)?c===void 0?c=F:g===void 0&&(g=F):a=a?[a,A].join(":"):A}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:c!==void 0?c:void 0,column:g!==void 0?g:c!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(s,h,a=8){let c="";for(let A=0;A<a;A++)c+=t.charAt(Math.floor(Math.random()*t.length));let g;return h?g=`${h}-${c}`:g=c,s?(0,i.join)(s,g):g}e.randomPath=u}),define(Ie[122],Ce([1,0,28,10]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...J){return function(D,B){for(let W=0,K=J.length;W<K;W++){const Z=J[W](D,B);if(Z)return Z}return null}}e.or=S,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(J,D,B){if(!B||B.length<D.length)return null;let W;return J?W=C.startsWithIgnoreCase(B,D):W=B.indexOf(D)===0,W?D.length>0?[{start:0,end:D.length}]:[]:null}function I(J,D){const B=D.toLowerCase().indexOf(J.toLowerCase());return B===-1?null:[{start:B,end:B+J.length}]}e.matchesContiguousSubString=I;function R(J,D){return y(J.toLowerCase(),D.toLowerCase(),0,0)}e.matchesSubString=R;function y(J,D,B,W){if(B===J.length)return[];if(W===D.length)return null;if(J[B]===D[W]){let K=null;return(K=y(J,D,B+1,W+1))?l({start:W,end:W+1},K):null}return y(J,D,B,W+1)}function k(J){return 97<=J&&J<=122}function O(J){return 65<=J&&J<=90}e.isUpper=O;function w(J){return 48<=J&&J<=57}function m(J){return J===32||J===9||J===10||J===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>b.add(J.charCodeAt(0)));function f(J){return m(J)||b.has(J)}function r(J,D){return J===D||f(J)&&f(D)}function o(J){return k(J)||O(J)||w(J)}function l(J,D){return D.length===0?D=[J]:J.end===D[0].start?D[0].start=J.start:D.unshift(J),D}function v(J,D){for(let B=D;B<J.length;B++){const W=J.charCodeAt(B);if(O(W)||w(W)||B>0&&!o(J.charCodeAt(B-1)))return B}return J.length}function E(J,D,B,W){if(B===J.length)return[];if(W===D.length)return null;if(J[B]!==D[W].toLowerCase())return null;{let K=null,Z=W+1;for(K=E(J,D,B+1,W+1);!K&&(Z=v(D,Z))<D.length;)K=E(J,D,B+1,Z),Z++;return K===null?null:l({start:W,end:W+1},K)}}function P(J){let D=0,B=0,W=0,K=0,Z=0;for(let Ee=0;Ee<J.length;Ee++)Z=J.charCodeAt(Ee),O(Z)&&D++,k(Z)&&B++,o(Z)&&W++,w(Z)&&K++;const he=D/J.length,ye=B/J.length,ae=W/J.length,be=K/J.length;return{upperPercent:he,lowerPercent:ye,alphaPercent:ae,numericPercent:be}}function p(J){const{upperPercent:D,lowerPercent:B}=J;return B===0&&D>.6}function n(J){const{upperPercent:D,lowerPercent:B,alphaPercent:W,numericPercent:K}=J;return B>.2&&D<.8&&W>.6&&K<.2}function d(J){let D=0,B=0,W=0,K=0;for(let Z=0;Z<J.length;Z++)W=J.charCodeAt(Z),O(W)&&D++,k(W)&&B++,m(W)&&K++;return(D===0||B===0)&&K===0?J.length<=30:D<=5}function t(J,D){if(!D||(D=D.trim(),D.length===0)||!d(J)||D.length>60)return null;const B=P(D);if(!n(B)){if(!p(B))return null;D=D.toLowerCase()}let W=null,K=0;for(J=J.toLowerCase();K<D.length&&(W=E(J,D,0,K))===null;)K=v(D,K+1);return W}e.matchesCamelCase=t;function u(J,D,B=!1){if(!D||D.length===0)return null;let W=null,K=0;for(J=J.toLowerCase(),D=D.toLowerCase();K<D.length&&(W=s(J,D,0,K,B))===null;)K=h(D,K+1);return W}e.matchesWords=u;function s(J,D,B,W,K){if(B===J.length)return[];if(W===D.length)return null;if(r(J.charCodeAt(B),D.charCodeAt(W))){let Z=null,he=W+1;if(Z=s(J,D,B+1,W+1,K),!K)for(;!Z&&(he=h(D,he))<D.length;)Z=s(J,D,B+1,he,K),he++;return Z?J.charCodeAt(B)!==D.charCodeAt(W)?Z:l({start:W,end:W+1},Z):null}else return null}function h(J,D){for(let B=D;B<J.length;B++)if(f(J.charCodeAt(B))||B>0&&f(J.charCodeAt(B-1)))return B;return J.length}const a=S(e.matchesPrefix,t,I),c=S(e.matchesPrefix,t,R),g=new i.LRUCache(1e4);function A(J,D,B=!1){if(typeof J!="string"||typeof D!="string")return null;let W=g.get(J);W||(W=new RegExp(C.convertSimple2RegExpPattern(J),"i"),g.set(J,W));const K=W.exec(D);return K?[{start:K.index,end:K.index+K[0].length}]:B?c(J,D):a(J,D)}e.matchesFuzzy=A;function F(J,D){const B=Be(J,J.toLowerCase(),0,D,D.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?te(B):null}e.matchesFuzzy2=F;function j(J,D,B,W,K,Z){const he=Math.min(13,J.length);for(;B<he;B++){const ye=Be(J,D,B,W,K,Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,Z]}e.anyScore=j;function te(J){if(typeof J>"u")return[];const D=[],B=J[1];for(let W=J.length-1;W>1;W--){const K=J[W]+B,Z=D[D.length-1];Z&&Z.end===K?Z.end=K+1:D.push({start:K,end:K+1})}return D}e.createMatches=te;const x=128;function N(){const J=[],D=[];for(let B=0;B<=x;B++)D[B]=0;for(let B=0;B<=x;B++)J.push(D.slice(0));return J}function $(J){const D=[];for(let B=0;B<=J;B++)D[B]=0;return D}const T=$(2*x),M=$(2*x),V=N(),q=N(),le=N(),_=!1;function pe(J,D,B,W,K){function Z(ye,ae,be=" "){for(;ye.length<ae;)ye=be+ye;return ye}let he=` |   |${W.split("").map(ye=>Z(ye,3)).join("|")}
`;for(let ye=0;ye<=B;ye++)ye===0?he+=" |":he+=`${D[ye-1]}|`,he+=J[ye].slice(0,K+1).map(ae=>Z(ae.toString(),3)).join("|")+`
`;return he}function ue(J,D,B,W){J=J.substr(D),B=B.substr(W),console.log(pe(q,J,J.length,B,B.length)),console.log(pe(le,J,J.length,B,B.length)),console.log(pe(V,J,J.length,B,B.length))}function de(J,D){if(D<0||D>=J.length)return!1;const B=J.codePointAt(D);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise(B)}}function re(J,D){if(D<0||D>=J.length)return!1;switch(J.charCodeAt(D)){case 32:case 9:return!0;default:return!1}}function G(J,D,B){return D[J]!==B[J]}function H(J,D,B,W,K,Z,he=!1){for(;D<B&&K<Z;)J[D]===W[K]&&(he&&(T[D]=K),D+=1),K+=1;return D===B}e.isPatternInWord=H;var oe;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var ve;(function(J){J.Default=[-100,0];function D(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}J.isDefault=D})(ve=e.FuzzyScore||(e.FuzzyScore={}));class Ae{constructor(D,B){this.firstMatchCanBeWeak=D,this.boostFullMatch=B}}e.FuzzyScoreOptions=Ae,Ae.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Be(J,D,B,W,K,Z,he=Ae.default){const ye=J.length>x?x:J.length,ae=W.length>x?x:W.length;if(B>=ye||Z>=ae||ye-B>ae-Z||!H(D,B,ye,K,Z,ae,!0))return;xe(ye,ae,B,Z,D,K);let be=1,Ee=1,We=B,He=Z;const tt=[!1];for(be=1,We=B;We<ye;be++,We++){const Fe=T[We],st=M[We],Y=We+1<ye?M[We+1]:ae;for(Ee=Fe-Z+1,He=Fe;He<Y;Ee++,He++){let Q=Number.MIN_SAFE_INTEGER,ge=!1;He<=st&&(Q=Te(J,D,We,B,W,K,He,ae,Z,V[be-1][Ee-1]===0,tt));let Me=0;Q!==Number.MAX_SAFE_INTEGER&&(ge=!0,Me=Q+q[be-1][Ee-1]);const $e=He>Fe,je=$e?q[be][Ee-1]+(V[be][Ee-1]>0?-5:0):0,Ye=He>Fe+1&&V[be][Ee-1]>0,nt=Ye?q[be][Ee-2]+(V[be][Ee-2]>0?-5:0):0;if(Ye&&(!$e||nt>=je)&&(!ge||nt>=Me))q[be][Ee]=nt,le[be][Ee]=3,V[be][Ee]=0;else if($e&&(!ge||je>=Me))q[be][Ee]=je,le[be][Ee]=2,V[be][Ee]=0;else if(ge)q[be][Ee]=Me,le[be][Ee]=1,V[be][Ee]=V[be-1][Ee-1]+1;else throw new Error("not possible")}}if(_&&ue(J,B,W,Z),!tt[0]&&!he.firstMatchCanBeWeak)return;be--,Ee--;const Xe=[q[be][Ee],Z];let et=0,it=0;for(;be>=1;){let Fe=Ee;do{const st=le[be][Fe];if(st===3)Fe=Fe-2;else if(st===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&D[B+be-1]===K[Z+Ee-1]&&!G(Fe+Z-1,W,K)&&et+1>V[be][Fe]&&(Fe=Ee),Fe===Ee?et++:et=1,it||(it=Fe),be--,Ee=Fe-1,Xe.push(Ee)}ae===ye&&he.boostFullMatch&&(Xe[0]+=2);const dt=it-ye;return Xe[0]-=dt,Xe}e.fuzzyScore=Be;function xe(J,D,B,W,K,Z){let he=J-1,ye=D-1;for(;he>=B&&ye>=W;)K[he]===Z[ye]&&(M[he]=ye,he--),ye--}function Te(J,D,B,W,K,Z,he,ye,ae,be,Ee){if(D[B]!==Z[he])return Number.MIN_SAFE_INTEGER;let We=1,He=!1;return he===B-W?We=J[B]===K[he]?7:5:G(he,K,Z)&&(he===0||!G(he-1,K,Z))?(We=J[B]===K[he]?7:5,He=!0):de(Z,he)&&(he===0||!de(Z,he-1))?We=5:(de(Z,he-1)||re(Z,he-1))&&(We=5,He=!0),We>1&&B===W&&(Ee[0]=!0),He||(He=G(he,K,Z)||de(Z,he-1)||re(Z,he-1)),B===W?he>ae&&(We-=He?3:5):be?We+=He?2:0:We+=He?0:1,he+1===ye&&(We-=He?3:5),We}function Se(J,D,B,W,K,Z,he){return se(J,D,B,W,K,Z,!0,he)}e.fuzzyScoreGracefulAggressive=Se;function ke(J,D,B,W,K,Z,he){return se(J,D,B,W,K,Z,!1,he)}e.fuzzyScoreGraceful=ke;function se(J,D,B,W,K,Z,he,ye){let ae=Be(J,D,B,W,K,Z,ye);if(ae&&!he)return ae;if(J.length>=3){const be=Math.min(7,J.length-1);for(let Ee=B+1;Ee<be;Ee++){const We=ce(J,Ee);if(We){const He=Be(We,We.toLowerCase(),B,W,K,Z,ye);He&&(He[0]-=3,(!ae||He[0]>ae[0])&&(ae=He))}}}return ae}function ce(J,D){if(D+1>=J.length)return;const B=J[D],W=J[D+1];if(B!==W)return J.slice(0,D)+W+B+J.slice(D+2)}}),define(Ie[123],Ce([1,0,65,122,10]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",I=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${I.source}`,"g");function y(o){return o.replace(R,(l,v)=>v?l:`\\${l}`)}e.escapeIcons=y;const k=new RegExp(`\\\\${I.source}`,"g");function O(o){return o.replace(k,l=>`\\${l}`)}e.markdownEscapeEscapedIcons=O;const w=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function m(o){return o.indexOf(L)===-1?o:o.replace(w,(l,v,E,P)=>E?l:v||P||"")}e.stripIcons=m;const b=new RegExp(`\\$\\(${i.CSSIcon.iconNameCharacter}+\\)`,"g");function f(o){b.lastIndex=0;let l="";const v=[];let E=0;for(;;){const P=b.lastIndex,p=b.exec(o),n=o.substring(P,p?.index);if(n.length>0){l+=n;for(let d=0;d<n.length;d++)v.push(E)}if(!p)break;E+=p[0].length}return{text:l,iconOffsets:v}}e.parseLabelWithIcons=f;function r(o,l,v=!1){const{text:E,iconOffsets:P}=l;if(!P||P.length===0)return(0,C.matchesFuzzy)(o,E,v);const p=(0,S.ltrim)(E," "),n=E.length-p.length,d=(0,C.matchesFuzzy)(o,p,v);if(d)for(const t of d){const u=P[t.start+n]+n;t.start+=u,t.end+=u}return d}e.matchesFuzzyIconAware=r}),define(Ie[30],Ce([1,0,10]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(C||(C={})),function(S){const L="error",I="warning",R="warn",y="info",k="ignore";function O(m){return m?i.equalsIgnoreCase(L,m)?S.Error:i.equalsIgnoreCase(I,m)||i.equalsIgnoreCase(R,m)?S.Warning:i.equalsIgnoreCase(y,m)?S.Info:S.Ignore:S.Ignore}S.fromValue=O;function w(m){switch(m){case S.Error:return L;case S.Warning:return I;case S.Info:return y;default:return k}}S.toString=w}(C||(C={})),e.default=C}),define(Ie[46],Ce([1,0,18,10]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class S{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const f=b.charCodeAt(0),r=this.b.charCodeAt(this.c);return f-r}value(){return this.b[this.c]}}e.StringIterator=S;class L{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,C.compareSubstring)(b,this.b,0,b.length,this.c,this.d):(0,C.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=L;class I{constructor(b=!0,f=!0){this.f=b,this.g=f}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let f=b.length-1;f>=0;f--,this.c--){const r=this.b.charCodeAt(f);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,C.compareSubstring)(b,this.b,0,b.length,this.d,this.e):(0,C.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=I;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class y{constructor(b,f){this.f=b,this.g=f,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,C.compareIgnoreCase)(b,this.c.scheme);if(this.d[this.e]===2)return(0,C.compareIgnoreCase)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,C.compare)(b,this.c.query);if(this.d[this.e]===5)return(0,C.compare)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(O||(O={}));class w{static forUris(b=()=>!1,f=()=>!1){return new w(new y(b,f))}static forPaths(b=!1){return new w(new I(void 0,!b))}static forStrings(){return new w(new S)}static forConfigKeys(){return new w(new L)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,f){if(f){const r=f.slice(0);(0,i.shuffle)(r);for(const o of r)this.set(o,b)}else{const r=b.slice(0);(0,i.shuffle)(r);for(const o of r)this.set(o[0],o[1])}}set(b,f){const r=this.b.reset(b);let o;this.c||(this.c=new k,this.c.segment=r.value());const l=[];for(o=this.c;;){const E=r.cmp(o.segment);if(E>0)o.left||(o.left=new k,o.left.segment=r.value()),l.push([-1,o]),o=o.left;else if(E<0)o.right||(o.right=new k,o.right.segment=r.value()),l.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new k,o.mid.segment=r.value()),l.push([0,o]),o=o.mid;else break}const v=o.value;o.value=f,o.key=b;for(let E=l.length-1;E>=0;E--){const P=l[E][1];P.updateHeight();const p=P.balanceFactor();if(p<-1||p>1){const n=l[E][0],d=l[E+1][0];if(n===1&&d===1)l[E][1]=P.rotateLeft();else if(n===-1&&d===-1)l[E][1]=P.rotateRight();else if(n===1&&d===-1)P.right=l[E+1][1]=l[E+1][1].rotateRight(),l[E][1]=P.rotateLeft();else if(n===-1&&d===1)P.left=l[E+1][1]=l[E+1][1].rotateLeft(),l[E][1]=P.rotateRight();else throw new Error;if(E>0)switch(l[E-1][0]){case-1:l[E-1][1].left=l[E][1];break;case 1:l[E-1][1].right=l[E][1];break;case 0:l[E-1][1].mid=l[E][1];break}else this.c=l[0][1]}}return v}get(b){return this.d(b)?.value}d(b){const f=this.b.reset(b);let r=this.c;for(;r;){const o=f.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(f.hasNext())f.next(),r=r.mid;else break}return r}has(b){const f=this.d(b);return!(f?.value===void 0&&f?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,f){const r=this.b.reset(b),o=[];let l=this.c;for(;l;){const v=r.cmp(l.segment);if(v>0)o.push([-1,l]),l=l.left;else if(v<0)o.push([1,l]),l=l.right;else if(r.hasNext())r.next(),o.push([0,l]),l=l.mid;else break}if(!!l){if(f?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const v=this.f(l.right);if(v.key){const{key:E,value:P,segment:p}=v;this.e(v.key,!1),l.key=E,l.value=P,l.segment=p}}else{const v=l.left??l.right;if(o.length>0){const[E,P]=o[o.length-1];switch(E){case-1:P.left=v;break;case 0:P.mid=v;break;case 1:P.right=v;break}}else this.c=v}for(let v=o.length-1;v>=0;v--){const E=o[v][1];E.updateHeight();const P=E.balanceFactor();if(P>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),o[v][1]=E.rotateLeft()):P<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),o[v][1]=E.rotateRight()),v>0)switch(o[v-1][0]){case-1:o[v-1][1].left=o[v][1];break;case 1:o[v-1][1].right=o[v][1];break;case 0:o[v-1][1].mid=o[v][1];break}else this.c=o[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const f=this.b.reset(b);let r=this.c,o;for(;r;){const l=f.cmp(r.segment);if(l>0)r=r.left;else if(l<0)r=r.right;else if(f.hasNext())f.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(b){return this.g(b,!1)}g(b,f){const r=this.b.reset(b);let o=this.c;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):f?o.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[f,r]of this)b(r,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const f=[];return this.j(b,f),f[Symbol.iterator]()}j(b,f){!b||(b.left&&this.j(b.left,f),b.value&&f.push([b.key,b.value]),b.mid&&this.j(b.mid,f),b.right&&this.j(b.right,f))}_isBalanced(){const b=f=>{if(!f)return!0;const r=f.balanceFactor();return r<-1||r>1?!1:b(f.left)&&b(f.right)};return b(this.c)}}e.TernarySearchTree=w}),define(Ie[84],Ce([1,0,25,10,2]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(k){return JSON.stringify(k,R)}e.stringify=L;function I(k){let O=JSON.parse(k);return O=y(O),O}e.parse=I;function R(k,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,C.regExpFlags)(O)}:O}function y(k,O=0){if(!k||O>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return S.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof i.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let w=0;w<k.length;++w)k[w]=y(k[w],O+1);else for(const w in k)Object.hasOwnProperty.call(k,w)&&(k[w]=y(k[w],O+1))}return k}e.revive=y}),define(Ie[16],Ce([1,0,11,20,2]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${L.vscodeRemoteResource}`}set(O,w,m){this.a[O]=w,this.b[O]=m}setConnectionToken(O,w){this.c[O]=w}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(o){return i.onUnexpectedError(o),O}const w=O.authority;let m=this.a[w];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const b=this.b[w],f=this.c[w];let r=`path=${encodeURIComponent(O.path)}`;return typeof f=="string"&&(r+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),S.URI.from({scheme:C.isWeb?this.d:L.vscodeRemoteResource,authority:`${m}:${b}`,path:this.f,query:r})}}e.RemoteAuthorities=new I,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(O){const w=this.b(O,ee);return this.uriToBrowserUri(w)}uriToBrowserUri(O){return O.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===L.file&&(C.isNative||C.isWebWorker&&C.globals.origin===`${L.vscodeFileResource}://${R.a}`)?O.with({scheme:L.vscodeFileResource,authority:O.authority||R.a,query:null,fragment:null}):O}asFileUri(O){const w=this.b(O,ee);return this.uriToFileUri(w)}uriToFileUri(O){return O.scheme===L.vscodeFileResource?O.with({scheme:L.file,authority:O.authority!==R.a?O.authority:null,query:null,fragment:null}):O}b(O,w){return S.URI.isUri(O)?O:S.URI.parse(w.toUrl(O))}}R.a="vscode-app",e.FileAccess=new R;var y;(function(k){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);k.CoopAndCoep=Object.freeze(O.get("3"));const w="vscode-coi";function m(f){let r;typeof f=="string"?r=new URL(f).searchParams:f instanceof URL?r=f.searchParams:S.URI.isUri(f)&&(r=new URL(f.toString(!0)).searchParams);const o=r?.get(w);if(!!o)return O.get(o)}k.getHeadersFromQuery=m;function b(f,r,o){if(!globalThis.crossOriginIsolated)return;const l=r&&o?"3":o?"2":"1";f instanceof URLSearchParams?f.set(w,l):f[w]=l}k.addSearchParam=b})(y=e.COI||(e.COI={}))}),define(Ie[23],Ce([1,0,40,16,19,20,10,2]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(b){return(0,R.uriToFsPath)(b,!0)}e.originalFSPath=y;class k{constructor(f){this.a=f}compare(f,r,o=!1){return f===r?0:(0,I.compare)(this.getComparisonKey(f,o),this.getComparisonKey(r,o))}isEqual(f,r,o=!1){return f===r?!0:!f||!r?!1:this.getComparisonKey(f,o)===this.getComparisonKey(r,o)}getComparisonKey(f,r=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,r,o=!1){if(f.scheme===r.scheme){if(f.scheme===C.Schemas.file)return i.isEqualOrParent(y(f),y(r),this.a(f))&&f.query===r.query&&(o||f.fragment===r.fragment);if((0,e.isEqualAuthority)(f.authority,r.authority))return i.isEqualOrParent(f.path,r.path,this.a(f),"/")&&f.query===r.query&&(o||f.fragment===r.fragment)}return!1}joinPath(f,...r){return R.URI.joinPath(f,...r)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return S.posix.basename(f.path)}extname(f){return S.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let r;return f.scheme===C.Schemas.file?r=R.URI.file(S.dirname(y(f))).path:(r=S.posix.dirname(f.path),f.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),r="/")),f.with({path:r})}normalizePath(f){if(!f.path.length)return f;let r;return f.scheme===C.Schemas.file?r=R.URI.file(S.normalize(y(f))).path:r=S.posix.normalize(f.path),f.with({path:r})}relativePath(f,r){if(f.scheme!==r.scheme||!(0,e.isEqualAuthority)(f.authority,r.authority))return;if(f.scheme===C.Schemas.file){const v=S.relative(y(f),y(r));return L.isWindows?i.toSlashes(v):v}let o=f.path||"/";const l=r.path||"/";if(this.a(f)){let v=0;for(const E=Math.min(o.length,l.length);v<E&&!(o.charCodeAt(v)!==l.charCodeAt(v)&&o.charAt(v).toLowerCase()!==l.charAt(v).toLowerCase());v++);o=l.substr(0,v)+o.substr(v)}return S.posix.relative(o,l)}resolvePath(f,r){if(f.scheme===C.Schemas.file){const o=R.URI.file(S.resolve(y(f),r));return f.with({authority:o.authority,path:o.path})}return r=i.toPosixPath(r),f.with({path:S.posix.resolve(f.path,r)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,r){return f===r||f!==void 0&&r!==void 0&&(0,I.equalsIgnoreCase)(f,r)}hasTrailingPathSeparator(f,r=S.sep){if(f.scheme===C.Schemas.file){const o=y(f);return o.length>i.getRoot(o).length&&o[o.length-1]===r}else{const o=f.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,r=S.sep){return(0,e.hasTrailingPathSeparator)(f,r)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,r=S.sep){let o=!1;if(f.scheme===C.Schemas.file){const l=y(f);o=l!==void 0&&l.length===i.getRoot(l).length&&l[l.length-1]===r}else{r="/";const l=f.path;o=l.length===1&&l.charCodeAt(l.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(f,r)?f.with({path:f.path+"/"}):f}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(b=>b.scheme===C.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new k(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(b,f){const r=[];for(let o=0;o<b.length;o++){const l=f(b[o]);b.some((v,E)=>E===o?!1:(0,e.isEqualOrParent)(l,f(v)))||r.push(b[o])}return r}e.distinctParents=O;var w;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(E=>{const[P,p]=E.split(":");P&&p&&o.set(P,p)});const v=r.path.substring(0,r.path.indexOf(";"));return v&&o.set(b.META_DATA_MIME,v),o}b.parseMetaData=f})(w=e.DataUri||(e.DataUri={}));function m(b,f,r){if(f){let o=b.path;return o&&o[0]!==S.posix.sep&&(o=S.posix.sep+o),b.with({scheme:r,authority:f,path:o})}return b.with({scheme:r})}e.toLocalResource=m}),define(Ie[12],Ce([1,0,21,11,4,6,23,20]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(G){return!!G&&typeof G.then=="function"}e.isThenable=y;function k(G){const H=new i.CancellationTokenSource,oe=G(H.token),ve=new Promise((Ae,Be)=>{const xe=H.token.onCancellationRequested(()=>{xe.dispose(),H.dispose(),Be(new C.CancellationError)});Promise.resolve(oe).then(Te=>{xe.dispose(),H.dispose(),Ae(Te)},Te=>{xe.dispose(),H.dispose(),Be(Te)})});return new class{cancel(){H.cancel()}then(Ae,Be){return ve.then(Ae,Be)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return ve.finally(Ae)}}}e.createCancelablePromise=k;function O(G,H,oe){return new Promise((ve,Ae)=>{const Be=H.onCancellationRequested(()=>{Be.dispose(),ve(oe)});G.then(ve,Ae).finally(()=>Be.dispose())})}e.raceCancellation=O;function w(G,H){return new Promise((oe,ve)=>{const Ae=H.onCancellationRequested(()=>{Ae.dispose(),ve(new C.CancellationError)});G.then(oe,ve).finally(()=>Ae.dispose())})}e.raceCancellationError=w;async function m(G){let H=-1;const oe=G.map((Ae,Be)=>Ae.then(xe=>(H=Be,xe))),ve=await Promise.race(oe);return G.forEach((Ae,Be)=>{Be!==H&&Ae.cancel()}),ve}e.raceCancellablePromises=m;function b(G,H,oe){let ve;const Ae=setTimeout(()=>{ve?.(void 0),oe?.()},H);return Promise.race([G.finally(()=>clearTimeout(Ae)),new Promise(Be=>ve=Be)])}e.raceTimeout=b;function f(G){return new Promise((H,oe)=>{const ve=G();y(ve)?ve.then(H,oe):H(ve)})}e.asPromise=f;class r{constructor(){this.a=null,this.b=null,this.d=null}queue(H){if(this.a){if(this.d=H,!this.b){const oe=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(oe,oe).then(ve)})}return new Promise((oe,ve)=>{this.b.then(oe,ve)})}return this.a=H(),new Promise((oe,ve)=>{this.a.then(Ae=>{this.a=null,oe(Ae)},Ae=>{this.a=null,ve(Ae)})})}}e.Throttler=r;class o{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.Sequencer=o;class l{constructor(){this.a=new Map}queue(H,oe){const Ae=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(H)===Ae&&this.a.delete(H)});return this.a.set(H,Ae),Ae}}e.SequencerByKey=l;const v=(G,H)=>{let oe=!0;const ve=setTimeout(()=>{oe=!1,H()},G);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(ve),oe=!1}}},E=G=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,G())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class P{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,oe=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((Ae,Be)=>{this.d=Ae,this.f=Be}).then(()=>{if(this.b=null,this.d=null,this.g){const Ae=this.g;return this.g=null,Ae()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=oe===e.MicrotaskDelay?E(ve):v(oe,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=P;class p{constructor(H){this.a=new P(H),this.b=new r}trigger(H,oe){return this.a.trigger(()=>this.b.queue(H),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=p;class n{constructor(){this.a=!1,this.b=new Promise((H,oe)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class d extends n{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=d;function t(G,H){return H?new Promise((oe,ve)=>{const Ae=setTimeout(()=>{Be.dispose(),oe()},G),Be=H.onCancellationRequested(()=>{clearTimeout(Ae),Be.dispose(),ve(new C.CancellationError)})}):k(oe=>t(G,oe))}e.timeout=t;function u(G,H=0){const oe=setTimeout(G,H);return(0,L.toDisposable)(()=>clearTimeout(oe))}e.disposableTimeout=u;function s(G){const H=[];let oe=0;const ve=G.length;function Ae(){return oe<ve?G[oe++]():null}function Be(xe){xe!=null&&H.push(xe);const Te=Ae();return Te?Te.then(Be):Promise.resolve(H)}return Promise.resolve(null).then(Be)}e.sequence=s;function h(G,H=ve=>!!ve,oe=null){let ve=0;const Ae=G.length,Be=()=>{if(ve>=Ae)return Promise.resolve(oe);const xe=G[ve++];return Promise.resolve(xe()).then(Se=>H(Se)?Promise.resolve(Se):Be())};return Be()}e.first=h;function a(G,H=ve=>!!ve,oe=null){if(G.length===0)return Promise.resolve(oe);let ve=G.length;const Ae=()=>{ve=-1;for(const Be of G)Be.cancel?.()};return new Promise((Be,xe)=>{for(const Te of G)Te.then(Se=>{--ve>=0&&H(Se)?(Ae(),Be(Se)):ve===0&&Be(oe)}).catch(Se=>{--ve>=0&&(Ae(),xe(Se))})})}e.firstParallel=a;class c{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new S.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((oe,ve)=>{this.f.push({factory:H,c:oe,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const oe=H.factory();oe.then(H.c,H.e),oe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=c;class g extends c{constructor(){super(1)}}e.Queue=g;class A{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const H=new le;return this.b.add(H),H.p}d(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,oe=I.extUri){const ve=oe.getComparisonKey(H);let Ae=this.a.get(ve);return Ae||(Ae=new g,S.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,Ae)),Ae}f(){!this.d()||this.g()}g(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.g()}}e.ResourceQueue=A;class F{constructor(H,oe){this.a=-1,typeof H=="function"&&typeof oe=="number"&&this.setIfNotSet(H,oe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,oe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},oe)}setIfNotSet(H,oe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},oe))}}e.TimeoutTimer=F;class j{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(H,oe){this.cancel(),this.a=setInterval(()=>{H()},oe)}}e.IntervalTimer=j;class te{constructor(H,oe){this.b=-1,this.a=H,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=te;class x{constructor(H,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=H,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=x;class N extends te{constructor(H,oe){super(H,oe),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=N;class $ extends L.Disposable{constructor(H,oe){super(),this.g=H,this.h=oe,this.a=[],this.b=this.B(new L.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of H)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=G=>{(0,R.setTimeout0)(()=>{if(H)return;const oe=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,oe-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.runWhenIdle=(G,H)=>{const oe=requestIdleCallback(G,typeof H=="number"?{timeout:H}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(oe))}}}}();class T{constructor(H){this.d=!1,this.a=()=>{try{this.f=H()}catch(oe){this.g=oe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=T;async function M(G,H,oe){let ve;for(let Ae=0;Ae<oe;Ae++)try{return await G()}catch(Be){ve=Be,await t(H)}throw ve}e.retry=M;class V{hasPending(H){return this.a?typeof H=="number"?this.a.taskId===H:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(H,oe,ve){return this.a={taskId:H,cancel:()=>ve?.(),promise:oe},oe.then(()=>this.d(H),()=>this.d(H)),oe}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}setNext(H){if(this.b)this.b.run=H;else{let oe,ve;const Ae=new Promise((Be,xe)=>{oe=Be,ve=xe});this.b={run:H,promise:Ae,promiseResolve:oe,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=V;class q{constructor(H,oe=()=>Date.now()){this.d=H,this.f=oe,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.IntervalCounter=q;class le{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((H,oe)=>{this.a=H,this.b=oe})}complete(H){return new Promise(oe=>{this.a(H),this.f=!0,oe()})}error(H){return new Promise(oe=>{this.b(H),this.d=!0,oe()})}cancel(){new Promise(H=>{this.b(new C.CancellationError),this.d=!0,H()})}}e.DeferredPromise=le;var _;(function(G){async function H(ve){let Ae;const Be=await Promise.all(ve.map(xe=>xe.then(Te=>Te,Te=>{Ae||(Ae=Te)})));if(typeof Ae<"u")throw Ae;return Be}G.settled=H;function oe(ve){return new Promise(async(Ae,Be)=>{try{await ve(Ae,Be)}catch(xe){Be(xe)}})}G.withAsyncBody=oe})(_=e.Promises||(e.Promises={}));var pe;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(pe||(pe={}));class ue{static fromArray(H){return new ue(oe=>{oe.emitMany(H)})}static fromPromise(H){return new ue(async oe=>{oe.emitMany(await H)})}static fromPromises(H){return new ue(async oe=>{await Promise.all(H.map(async ve=>oe.emitOne(await ve)))})}static merge(H){return new ue(async oe=>{await Promise.all(H.map(async ve=>{for await(const Ae of ve)oe.emitOne(Ae)}))})}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new S.Emitter,queueMicrotask(async()=>{const oe={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(H(oe)),this.j()}catch(ve){this.k(ve)}finally{oe.emitOne=void 0,oe.emitMany=void 0,oe.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.f.event)}while(!0)}}}static map(H,oe){return new ue(async ve=>{for await(const Ae of H)ve.emitOne(oe(Ae))})}map(H){return ue.map(this,H)}static filter(H,oe){return new ue(async ve=>{for await(const Ae of H)oe(Ae)&&ve.emitOne(Ae)})}filter(H){return ue.filter(this,H)}static coalesce(H){return ue.filter(H,oe=>!!oe)}coalesce(){return ue.coalesce(this)}static async toPromise(H){const oe=[];for await(const ve of H)oe.push(ve);return oe}toPromise(){return ue.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class de extends ue{constructor(H,oe){super(oe),this.l=H}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=de;function re(G){const H=new i.CancellationTokenSource,oe=G(H.token);return new de(H,async ve=>{const Ae=H.token.onCancellationRequested(()=>{Ae.dispose(),H.dispose(),ve.reject(new C.CancellationError)});try{for await(const Be of oe){if(H.token.isCancellationRequested)return;ve.emitOne(Be)}Ae.dispose(),H.dispose()}catch(Be){Ae.dispose(),H.dispose(),ve.reject(Be)}})}e.createCancelableAsyncIterable=re}),define(Ie[124],Ce([1,0,12,19]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new i.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),L=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(c,g,A=!1){const F=c||"",j=g||"",te=S.value.collator.compare(F,j);return S.value.collatorIsNumeric&&te===0&&F!==j?F<j?-1:1:te}e.compareFileNames=R;function y(c,g){const A=L.value.collator;return c=c||"",g=g||"",P(A,c,g)}e.compareFileNamesDefault=y;function k(c,g){const A=L.value.collator;return c=c||"",g=g||"",t(c,g)||P(A,c,g)}e.compareFileNamesUpper=k;function O(c,g){const A=L.value.collator;return c=c||"",g=g||"",d(c,g)||P(A,c,g)}e.compareFileNamesLower=O;function w(c,g){return c=c||"",g=g||"",c===g?0:c<g?-1:1}e.compareFileNamesUnicode=w;function m(c,g){const[A,F]=v(c),[j,te]=v(g);let x=S.value.collator.compare(F,te);if(x===0){if(S.value.collatorIsNumeric&&F!==te)return F<te?-1:1;if(x=S.value.collator.compare(A,j),S.value.collatorIsNumeric&&x===0&&A!==j)return A<j?-1:1}return x}e.compareFileExtensions=m;function b(c,g){c=c||"",g=g||"";const A=E(c),F=E(g),j=L.value.collator,te=I.value.collator;return P(te,A,F)||P(j,c,g)}e.compareFileExtensionsDefault=b;function f(c,g){c=c||"",g=g||"";const A=E(c),F=E(g),j=L.value.collator,te=I.value.collator;return P(te,A,F)||t(c,g)||P(j,c,g)}e.compareFileExtensionsUpper=f;function r(c,g){c=c||"",g=g||"";const A=E(c),F=E(g),j=L.value.collator,te=I.value.collator;return P(te,A,F)||d(c,g)||P(j,c,g)}e.compareFileExtensionsLower=r;function o(c,g){c=c||"",g=g||"";const A=E(c).toLowerCase(),F=E(g).toLowerCase();return A!==F?A<F?-1:1:c!==g?c<g?-1:1:0}e.compareFileExtensionsUnicode=o;const l=/^(.*?)(\.([^.]*))?$/;function v(c,g=!1){const A=c?l.exec(c):[];let F=[A&&A[1]||"",A&&A[3]||""];return g&&(!F[0]&&F[1]||F[0]&&F[0].charAt(0)===".")&&(F=[F[0]+"."+F[1],""]),F}function E(c){const g=c?l.exec(c):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function P(c,g,A){const F=c.compare(g,A);return F!==0?F:g.length!==A.length?g.length<A.length?-1:1:0}function p(c){const g=c.charAt(0);return g.toLocaleUpperCase()!==g}function n(c){const g=c.charAt(0);return g.toLocaleLowerCase()!==g}function d(c,g){return p(c)&&n(g)?-1:n(c)&&p(g)?1:0}function t(c,g){return n(c)&&p(g)?-1:p(c)&&n(g)?1:0}function u(c,g,A=!1){return A||(c=c&&c.toLowerCase(),g=g&&g.toLowerCase()),c===g?0:c<g?-1:1}function s(c,g,A=!1){const F=c.split(C.sep),j=g.split(C.sep),te=F.length-1,x=j.length-1;let N,$;for(let T=0;;T++){if(N=te===T,$=x===T,N&&$)return R(F[T],j[T],A);if(N)return-1;if($)return 1;const M=u(F[T],j[T],A);if(M!==0)return M}}e.comparePaths=s;function h(c,g,A){const F=c.toLowerCase(),j=g.toLowerCase(),te=a(c,g,A);if(te)return te;const x=F.endsWith(A),N=j.endsWith(A);if(x!==N)return x?-1:1;const $=R(F,j);return $!==0?$:F.localeCompare(j)}e.compareAnything=h;function a(c,g,A){const F=c.toLowerCase(),j=g.toLowerCase(),te=F.startsWith(A),x=j.startsWith(A);if(te!==x)return te?-1:1;if(te&&x){if(F.length<j.length)return-1;if(F.length>j.length)return 1}return 0}e.compareByPrefix=a}),define(Ie[35],Ce([1,0,18,12,40,28,19,20,10]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",w="[^/\\\\]",m=/\//g;function b(le,_){switch(le){case 0:return"";case 1:return`${w}*?`;default:return`(?:${O}|${w}+${O}${_?`|${O}${w}+`:""})*?`}}function f(le,_){if(!le)return[];const pe=[];let ue=!1,de=!1,re="";for(const G of le){switch(G){case _:if(!ue&&!de){pe.push(re),re="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":de=!0;break;case"]":de=!1;break}re+=G}return re&&pe.push(re),pe}e.splitGlobAware=f;function r(le){if(!le)return"";let _="";const pe=f(le,e.GLOB_SPLIT);if(pe.every(ue=>ue===e.GLOBSTAR))_=".*";else{let ue=!1;pe.forEach((de,re)=>{if(de===e.GLOBSTAR){if(ue)return;_+=b(2,re===pe.length-1)}else{let G=!1,H="",oe=!1,ve="";for(const Ae of de){if(Ae!=="}"&&G){H+=Ae;continue}if(oe&&(Ae!=="]"||!ve)){let Be;Ae==="-"?Be=Ae:(Ae==="^"||Ae==="!")&&!ve?Be="^":Ae===e.GLOB_SPLIT?Be="":Be=(0,y.escapeRegExpCharacters)(Ae),ve+=Be;continue}switch(Ae){case"{":G=!0;continue;case"[":oe=!0;continue;case"}":{_+=`(?:${f(H,",").map(Te=>r(Te)).join("|")})`,G=!1,H="";break}case"]":{_+="["+ve+"]",oe=!1,ve="";break}case"?":_+=w;continue;case"*":_+=b(1);continue;default:_+=(0,y.escapeRegExpCharacters)(Ae)}}re<pe.length-1&&(pe[re+1]!==e.GLOBSTAR||re+2<pe.length)&&(_+=O)}ue=de===e.GLOBSTAR})}return _}const o=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,P=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.LRUCache(1e4),d=function(){return!1},t=function(){return null};function u(le,_){if(!le)return t;let pe;typeof le!="string"?pe=le.pattern:pe=le,pe=pe.trim();const ue=`${pe}_${!!_.trimForExclusions}`;let de=n.get(ue);if(de)return s(de,le);let re;return o.test(pe)?de=a(pe.substr(4),pe):(re=l.exec(h(pe,_)))?de=c(re[1],pe):(_.trimForExclusions?E:v).test(pe)?de=g(pe,_):(re=P.exec(h(pe,_)))?de=A(re[1].substr(1),pe,!0):(re=p.exec(h(pe,_)))?de=A(re[1],pe,!1):de=F(pe),n.set(ue,de),s(de,le)}function s(le,_){if(typeof _=="string")return le;const pe=function(ue,de){return(0,S.isEqualOrParent)(ue,_.base,!R.isLinux)?le((0,y.ltrim)(ue.substr(_.base.length),I.sep),de):null};return pe.allBasenames=le.allBasenames,pe.allPaths=le.allPaths,pe.basenames=le.basenames,pe.patterns=le.patterns,pe}function h(le,_){return _.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function a(le,_){return function(pe,ue){return typeof pe=="string"&&pe.endsWith(le)?_:null}}function c(le,_){const pe=`/${le}`,ue=`\\${le}`,de=function(G,H){return typeof G!="string"?null:H?H===le?_:null:G===le||G.endsWith(pe)||G.endsWith(ue)?_:null},re=[le];return de.basenames=re,de.patterns=[_],de.allBasenames=re,de}function g(le,_){const pe=V(le.slice(1,-1).split(",").map(H=>u(H,_)).filter(H=>H!==t),le),ue=pe.length;if(!ue)return t;if(ue===1)return pe[0];const de=function(H,oe){for(let ve=0,Ae=pe.length;ve<Ae;ve++)if(pe[ve](H,oe))return le;return null},re=pe.find(H=>!!H.allBasenames);re&&(de.allBasenames=re.allBasenames);const G=pe.reduce((H,oe)=>oe.allPaths?H.concat(oe.allPaths):H,[]);return G.length&&(de.allPaths=G),de}function A(le,_,pe){const ue=I.sep===I.posix.sep,de=ue?le:le.replace(m,I.sep),re=I.sep+de,G=I.posix.sep+le;let H;return pe?H=function(oe,ve){return typeof oe=="string"&&(oe===de||oe.endsWith(re)||!ue&&(oe===le||oe.endsWith(G)))?_:null}:H=function(oe,ve){return typeof oe=="string"&&(oe===de||!ue&&oe===le)?_:null},H.allPaths=[(pe?"*/":"./")+le],H}function F(le){try{const _=new RegExp(`^${r(le)}$`);return function(pe){return _.lastIndex=0,typeof pe=="string"&&_.test(pe)?le:null}}catch{return t}}function j(le,_,pe){return!le||typeof _!="string"?!1:te(le)(_,void 0,pe)}e.match=j;function te(le,_={}){if(!le)return d;if(typeof le=="string"||x(le)){const pe=u(le,_);if(pe===t)return d;const ue=function(de,re){return!!pe(de,re)};return pe.allBasenames&&(ue.allBasenames=pe.allBasenames),pe.allPaths&&(ue.allPaths=pe.allPaths),ue}return T(le,_)}e.parse=te;function x(le){const _=le;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=x;function N(le){return le.allBasenames||[]}e.getBasenameTerms=N;function $(le){return le.allPaths||[]}e.getPathTerms=$;function T(le,_){const pe=V(Object.getOwnPropertyNames(le).map(H=>M(H,le[H],_)).filter(H=>H!==t)),ue=pe.length;if(!ue)return t;if(!pe.some(H=>!!H.requiresSiblings)){if(ue===1)return pe[0];const H=function(Ae,Be){let xe;for(let Te=0,Se=pe.length;Te<Se;Te++){const ke=pe[Te](Ae,Be);if(typeof ke=="string")return ke;(0,C.isThenable)(ke)&&(xe||(xe=[]),xe.push(ke))}return xe?(async()=>{for(const Te of xe){const Se=await Te;if(typeof Se=="string")return Se}return null})():null},oe=pe.find(Ae=>!!Ae.allBasenames);oe&&(H.allBasenames=oe.allBasenames);const ve=pe.reduce((Ae,Be)=>Be.allPaths?Ae.concat(Be.allPaths):Ae,[]);return ve.length&&(H.allPaths=ve),H}const de=function(H,oe,ve){let Ae,Be;for(let xe=0,Te=pe.length;xe<Te;xe++){const Se=pe[xe];Se.requiresSiblings&&ve&&(oe||(oe=(0,I.basename)(H)),Ae||(Ae=oe.substr(0,oe.length-(0,I.extname)(H).length)));const ke=Se(H,oe,Ae,ve);if(typeof ke=="string")return ke;(0,C.isThenable)(ke)&&(Be||(Be=[]),Be.push(ke))}return Be?(async()=>{for(const xe of Be){const Te=await xe;if(typeof Te=="string")return Te}return null})():null},re=pe.find(H=>!!H.allBasenames);re&&(de.allBasenames=re.allBasenames);const G=pe.reduce((H,oe)=>oe.allPaths?H.concat(oe.allPaths):H,[]);return G.length&&(de.allPaths=G),de}function M(le,_,pe){if(_===!1)return t;const ue=u(le,pe);if(ue===t)return t;if(typeof _=="boolean")return ue;if(_){const de=_.when;if(typeof de=="string"){const re=(G,H,oe,ve)=>{if(!ve||!ue(G,H))return null;const Ae=de.replace("$(basename)",()=>oe),Be=ve(Ae);return(0,C.isThenable)(Be)?Be.then(xe=>xe?le:null):Be?le:null};return re.requiresSiblings=!0,re}}return ue}function V(le,_){const pe=le.filter(H=>!!H.basenames);if(pe.length<2)return le;const ue=pe.reduce((H,oe)=>{const ve=oe.basenames;return ve?H.concat(ve):H},[]);let de;if(_){de=[];for(let H=0,oe=ue.length;H<oe;H++)de.push(_)}else de=pe.reduce((H,oe)=>{const ve=oe.patterns;return ve?H.concat(ve):H},[]);const re=function(H,oe){if(typeof H!="string")return null;if(!oe){let Ae;for(Ae=H.length;Ae>0;Ae--){const Be=H.charCodeAt(Ae-1);if(Be===47||Be===92)break}oe=H.substr(Ae)}const ve=ue.indexOf(oe);return ve!==-1?de[ve]:null};re.basenames=ue,re.patterns=de,re.allBasenames=ue;const G=le.filter(H=>!H.basenames);return G.push(re),G}function q(le,_){return(0,i.equals)(le,_,(pe,ue)=>typeof pe=="string"&&typeof ue=="string"?pe===ue:typeof pe!="string"&&typeof ue!="string"?pe.base===ue.base&&pe.pattern===ue.pattern:!1)}e.patternsEquals=q}),define(Ie[85],Ce([1,0,11,123,23,10,2]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(R=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(l="",v=!1){if(this.value=l,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(l,v=0){return this.value+=m(this.supportThemeIcons?(0,C.escapeIcons)(l):l).replace(/([ \t]+)/g,(E,P)=>"&nbsp;".repeat(P.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,v){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(l,v,E){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(l),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(l,v){const E=new RegExp((0,L.escapeRegExpCharacters)(v),"g");return l.replace(E,(P,p)=>l.charAt(p-1)!=="\\"?`\\${P}`:P)}}e.MarkdownString=y;function k(o){return O(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function O(o){return o instanceof y?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function w(o,l){return o===l?!0:!o||!l?!1:o.value===l.value&&o.isTrusted===l.isTrusted&&o.supportThemeIcons===l.supportThemeIcons&&o.supportHtml===l.supportHtml&&(o.baseUri===l.baseUri||!!o.baseUri&&!!l.baseUri&&(0,S.isEqual)(I.URI.from(o.baseUri),I.URI.from(l.baseUri)))}e.markdownStringEqual=w;function m(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function b(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function f(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=f;function r(o){const l=[],v=o.split("|").map(P=>P.trim());o=v[0];const E=v[1];if(E){const P=/height=(\d+)/.exec(E),p=/width=(\d+)/.exec(E),n=P?P[1]:"",d=p?p[1]:"",t=isFinite(parseInt(d)),u=isFinite(parseInt(n));t&&l.push(`width="${d}"`),u&&l.push(`height="${n}"`)}return{href:o,dimensions:l}}e.parseHrefAndDimensions=r}),define(Ie[86],Ce([1,0,18,40,19,20,23,10]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(t,u){const{os:s,tildify:h,relative:a}=u;if(a){const A=k(t,a,s);if(typeof A=="string")return A}let c=t.fsPath;if(s===1&&!L.isWindows?c=c.replace(/\//g,"\\"):s!==1&&L.isWindows&&(c=c.replace(/\\/g,"/")),s!==1&&h?.userHome){const A=h.userHome.fsPath;let F;t.scheme!==h.userHome.scheme&&t.path.startsWith(S.posix.sep)?F=h.userHome.with({path:t.path}).fsPath:F=t.fsPath,c=m(F,A,s)}return(s===1?S.win32:S.posix).normalize(O(c,s===1))}e.getPathLabel=y;function k(t,u,s){const h=s===1?S.win32:S.posix,a=s===3?I.extUri:I.extUriIgnorePathCase,c=u.getWorkspace(),g=(0,i.firstOrDefault)(c.folders);if(!g)return;t.scheme!==g.uri.scheme&&t.path.startsWith(S.posix.sep)&&(t=g.uri.with({path:t.path}));const A=u.getWorkspaceFolder(t);if(!A)return;let F;if(a.isEqual(A.uri,t)?F="":F=a.relativePath(A.uri,t)??"",F&&(F=h.normalize(F)),c.folders.length>1&&!u.noPrefix){const j=A.name?A.name:a.basenameOrAuthority(A.uri);F=F?`${j} \u2022 ${F}`:j}return F}function O(t,u=L.isWindows){return(0,C.hasDriveLetter)(t,u)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=O;let w=Object.create(null);function m(t,u,s=L.OS){if(s===1||!t||!u)return t;let h=w.original===u?w.normalized:void 0;h||(h=u,L.isWindows&&(h=(0,C.toSlashes)(h)),h=`${(0,R.rtrim)(h,S.posix.sep)}${S.posix.sep}`,w={original:u,normalized:h});let a=t;return L.isWindows&&(a=(0,C.toSlashes)(a)),(s===3?a.startsWith(h):(0,R.startsWithIgnoreCase)(a,h))?`~/${a.substr(h.length)}`:t}e.tildify=m;function b(t,u){return t.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=b;const f="\u2026",r="\\\\",o="~";function l(t,u=S.sep){const s=new Array(t.length);let h=!1;for(let a=0;a<t.length;a++){const c=t[a];if(c===""){s[a]=`.${u}`;continue}if(!c){s[a]=c;continue}h=!0;let g="",A=c;A.indexOf(r)===0?(g=A.substr(0,A.indexOf(r)+r.length),A=A.substr(A.indexOf(r)+r.length)):A.indexOf(u)===0?(g=A.substr(0,A.indexOf(u)+u.length),A=A.substr(A.indexOf(u)+u.length)):A.indexOf(o)===0&&(g=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length));const F=A.split(u);for(let j=1;h&&j<=F.length;j++)for(let te=F.length-j;h&&te>=0;te--){h=!1;let x=F.slice(te,te+j).join(u);for(let N=0;!h&&N<t.length;N++)if(N!==a&&t[N]&&t[N].indexOf(x)>-1){const $=te+j===F.length,T=te>0&&t[N].indexOf(u)>-1?u+x:x,M=t[N].endsWith(T);h=!$||M}if(!h){let N="";(F[0].endsWith(":")||g!=="")&&(te===1&&(te=0,j++,x=F[0]+u+x),te>0&&(N=F[0]+u),N=g+N),te>0&&(N=N+f+u),N=N+x,te+j<F.length&&(N=N+u+f),s[a]=N}}h&&(s[a]=c)}return s}e.shorten=l;var v;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function E(t,u=Object.create(null)){const s=[];let h=!1,a="";for(const c of t)if(c==="$"||h&&c==="{")a&&s.push({value:a,type:v.TEXT}),a="",h=!0;else if(c==="}"&&h){const g=u[a];if(typeof g=="string")g.length&&s.push({value:g,type:v.VARIABLE});else if(g){const A=s[s.length-1];(!A||A.type!==v.SEPARATOR)&&s.push({value:g.label,type:v.SEPARATOR})}a="",h=!1}else a+=c;return a&&!h&&s.push({value:a,type:v.TEXT}),s.filter((c,g)=>{if(c.type===v.SEPARATOR){const A=s[g-1],F=s[g+1];return[A,F].every(j=>j&&(j.type===v.VARIABLE||j.type===v.TEXT)&&j.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=E;function P(t,u){return L.isMacintosh||u?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):t.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=P;function p(t,u){return L.isMacintosh||u?t.replace(/\(&&\w\)|&&/g,""):L.isWindows?t.replace(/&&|&/g,s=>s==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function n(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=n;function d(t){const u=t.indexOf("/")!==-1?S.posix:S.win32,s=u.basename(t),h=u.dirname(t);return s.length?{name:s,parentPath:h}:{name:h,parentPath:""}}e.splitName=d}),define(Ie[125],Ce([1,0,2]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function C(O){return O.toJSON()}class S{constructor(w){this.a=w}transformIncoming(w){const m=this.a.transformIncoming(w);return m===w?w:C(i.URI.from(m))}transformOutgoing(w){const m=this.a.transformOutgoing(w);return m===w?w:C(i.URI.from(m))}transformOutgoingURI(w){const m=this.a.transformOutgoing(w);return m===w?w:i.URI.from(m)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function L(O,w,m){if(!O||m>200)return null;if(typeof O=="object"){if(O instanceof i.URI)return w.transformOutgoing(O);for(const b in O)if(Object.hasOwnProperty.call(O,b)){const f=L(O[b],w,m+1);f!==null&&(O[b]=f)}}return null}function I(O,w){const m=L(O,w,0);return m===null?O:m}e.transformOutgoingURIs=I;function R(O,w,m,b){if(!O||b>200)return null;if(typeof O=="object"){if(O.$mid===1)return m?i.URI.revive(w.transformIncoming(O)):w.transformIncoming(O);for(const f in O)if(Object.hasOwnProperty.call(O,f)){const r=R(O[f],w,m,b+1);r!==null&&(O[f]=r)}}return null}function y(O,w){const m=R(O,w,!1,0);return m===null?O:m}e.transformIncomingURIs=y;function k(O,w){const m=R(O,w,!0,0);return m===null?O:m}e.transformAndReviveIncomingURIs=k}),define(Ie[126],Ce([1,0,35,19]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(L,I,R,y,k,O){if(Array.isArray(L)){let w=0;for(const m of L){const b=S(m,I,R,y,k,O);if(b===10)return b;b>w&&(w=b)}return w}else{if(typeof L=="string")return y?L==="*"?5:L===R?10:0:0;if(L){const{language:w,pattern:m,scheme:b,hasAccessToAllModels:f,notebookType:r}=L;if(!y&&!f)return 0;r&&k&&(I=k);let o=0;if(b)if(b===I.scheme)o=10;else if(b==="*")o=5;else return 0;if(w)if(w===R)o=10;else if(w==="*")o=Math.max(o,5);else return 0;if(r)if(r===O)o=10;else if(r==="*"&&O!==void 0)o=Math.max(o,5);else return 0;if(m){let l;if(typeof m=="string"?l=m:l={...m,base:(0,C.normalize)(m.base)},l===I.fsPath||(0,i.match)(l,I.fsPath))o=10;else return 0}return o}else return 0}}e.score=S}),define(Ie[87],Ce([1,0,25,20]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(S||(S={}));function L(w){for(let m=0,b=w.length;m<b;m+=4){const f=w[m+0],r=w[m+1],o=w[m+2],l=w[m+3];w[m+0]=l,w[m+1]=o,w[m+2]=r,w[m+3]=f}}function I(w){const m=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return C.isLittleEndian()||L(m),i.VSBuffer.wrap(m)}function R(w){const m=w.buffer;if(C.isLittleEndian()||L(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const b=new Uint8Array(m.byteLength);return b.set(m),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function y(w){const m=new Uint32Array(k(w));let b=0;if(m[b++]=w.id,w.type==="full")m[b++]=1,m[b++]=w.data.length,m.set(w.data,b),b+=w.data.length;else{m[b++]=2,m[b++]=w.deltas.length;for(const f of w.deltas)m[b++]=f.start,m[b++]=f.deleteCount,f.data?(m[b++]=f.data.length,m.set(f.data,b),b+=f.data.length):m[b++]=0}return I(m)}e.encodeSemanticTokensDto=y;function k(w){let m=0;if(m+=1+1,w.type==="full")m+=1+w.data.length;else{m+=1,m+=(1+1+1)*w.deltas.length;for(const b of w.deltas)b.data&&(m+=b.data.length)}return m}function O(w){const m=R(w);let b=0;const f=m[b++];if(m[b++]===1){const v=m[b++],E=m.subarray(b,b+v);return b+=v,{id:f,type:"full",data:E}}const o=m[b++],l=[];for(let v=0;v<o;v++){const E=m[b++],P=m[b++],p=m[b++];let n;p>0&&(n=m.subarray(b,b+p),b+=p),l[v]={start:E,deleteCount:P,data:n}}return{id:f,type:"delta",deltas:l}}e.decodeSemanticTokensDto=O}),define(Ie[127],Ce([14,15]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ie[128],Ce([1,0,127,20,129,18,22,115]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class w{constructor(Q,ge,Me,$e){this.id=Q,this.name=ge,this.defaultValue=Me,this.schema=$e}applyUpdate(Q,ge){return b(Q,ge)}compute(Q,ge,Me){return Me}}class m{constructor(Q,ge){this.newValue=Q,this.didChange=ge}}e.ApplyUpdateResult=m;function b(Y,Q){if(typeof Y!="object"||typeof Q!="object"||!Y||!Q)return new m(Q,Y!==Q);if(Array.isArray(Y)||Array.isArray(Q)){const Me=Array.isArray(Y)&&Array.isArray(Q)&&L.equals(Y,Q);return new m(Q,!Me)}let ge=!1;for(const Me in Q)if(Q.hasOwnProperty(Me)){const $e=b(Y[Me],Q[Me]);$e.didChange&&(Y[Me]=$e.newValue,ge=!0)}return new m(Y,ge)}class f{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ge){return b(Q,ge)}validate(Q){return this.defaultValue}}class r{constructor(Q,ge,Me,$e){this.id=Q,this.name=ge,this.defaultValue=Me,this.schema=$e}applyUpdate(Q,ge){return b(Q,ge)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ge,Me){return Me}}function o(Y,Q){return typeof Y>"u"?Q:Y==="false"?!1:Boolean(Y)}e.boolean=o;class l extends r{constructor(Q,ge,Me,$e=void 0){typeof $e<"u"&&($e.type="boolean",$e.default=Me),super(Q,ge,Me,$e)}validate(Q){return o(Q,this.defaultValue)}}function v(Y,Q,ge,Me){if(typeof Y>"u")return Q;let $e=parseInt(Y,10);return isNaN($e)?Q:($e=Math.max(ge,$e),$e=Math.min(Me,$e),$e|0)}e.clampedInt=v;class E extends r{static clampedInt(Q,ge,Me,$e){return v(Q,ge,Me,$e)}constructor(Q,ge,Me,$e,je,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=Me,Ye.minimum=$e,Ye.maximum=je),super(Q,ge,Me,Ye),this.minimum=$e,this.maximum=je}validate(Q){return E.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class P extends r{static clamp(Q,ge,Me){return Q<ge?ge:Q>Me?Me:Q}static float(Q,ge){if(typeof Q=="number")return Q;if(typeof Q>"u")return ge;const Me=parseFloat(Q);return isNaN(Me)?ge:Me}constructor(Q,ge,Me,$e,je){typeof je<"u"&&(je.type="number",je.default=Me),super(Q,ge,Me,je),this.validationFn=$e}validate(Q){return this.validationFn(P.float(Q,this.defaultValue))}}class p extends r{static string(Q,ge){return typeof Q!="string"?ge:Q}constructor(Q,ge,Me,$e=void 0){typeof $e<"u"&&($e.type="string",$e.default=Me),super(Q,ge,Me,$e)}validate(Q){return p.string(Q,this.defaultValue)}}function n(Y,Q,ge){return typeof Y!="string"||ge.indexOf(Y)===-1?Q:Y}e.stringSet=n;class d extends r{constructor(Q,ge,Me,$e,je=void 0){typeof je<"u"&&(je.type="string",je.enum=$e,je.default=Me),super(Q,ge,Me,je),this.c=$e}validate(Q){return n(Q,this.defaultValue,this.c)}}class t extends w{constructor(Q,ge,Me,$e,je,Ye,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=je,nt.default=$e),super(Q,ge,Me,nt),this.c=je,this.d=Ye}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function u(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ge,Me){return Me===0?Q.accessibilitySupport:Me}}class h extends w{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:i.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertSpace:o(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function A(Y){switch(Y){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=A;function F(Y){switch(Y){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class j extends f{constructor(){super(135)}compute(Q,ge,Me){const $e=["monaco-editor"];return ge.get(36)&&$e.push(ge.get(36)),Q.extraEditorClassName&&$e.push(Q.extraEditorClassName),ge.get(70)==="default"?$e.push("mouse-default"):ge.get(70)==="copy"&&$e.push("mouse-copy"),ge.get(105)&&$e.push("showUnused"),ge.get(133)&&$e.push("showDeprecated"),$e.join(" ")}}class te extends l{constructor(){super(34,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(Q,ge,Me){return Me&&Q.emptySelectionClipboard}}class x extends w{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:i.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:i.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{cursorMoveOnType:o(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":n(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":n(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ge.loop,this.defaultValue.loop)}}}class N extends w{constructor(){super(48,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?N.OFF:Q==="true"?N.ON:Q:Boolean(Q)?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class $ extends w{constructor(){super(51,"fontVariations",$.OFF,{anyOf:[{type:"boolean",description:i.localize(22,null)},{type:"string",description:i.localize(23,null)}],description:i.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?$.OFF:Q==="true"?$.TRANSLATE:Q:Boolean(Q)?$.TRANSLATE:$.OFF}compute(Q,ge,Me){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=$,$.OFF="normal",$.TRANSLATE="translate";class T extends f{constructor(){super(47)}compute(Q,ge,Me){return Q.fontInfo}}class M extends r{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(25,null)})}validate(Q){const ge=P.float(Q,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:P.clamp(ge,6,100)}compute(Q,ge,Me){return Q.fontInfo.fontSize}}class V extends w{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:i.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(E.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}V.c=["normal","bold","100","200","300","400","500","600","700","800","900"],V.d=1,V.e=1e3;class q extends w{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[i.localize(28,null),i.localize(29,null),i.localize(30,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:i.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:i.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:i.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Me,description:i.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Me,description:i.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Me,description:i.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Me,description:i.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Me,description:i.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{multiple:n(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??n(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??n(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??n(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??n(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??n(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends w{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:i.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:i.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:i.localize(44,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:i.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),delay:E.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:o(ge.sticky,this.defaultValue.sticky),above:o(ge.above,this.defaultValue.above)}}}var _;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(_=e.RenderMinimap||(e.RenderMinimap={}));class pe extends f{constructor(){super(138)}compute(Q,ge,Me){return pe.computeLayout(ge,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const ge=Q.height/Q.lineHeight,Me=Math.floor(Q.paddingTop/Q.lineHeight);let $e=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&($e=Math.max($e,ge-1));const je=(Me+Q.viewLineCount+$e)/(Q.pixelRatio*Q.height),Ye=Math.floor(Q.viewLineCount/je);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:$e,desiredRatio:je,minimapLineCount:Ye}}static c(Q,ge){const Me=Q.outerWidth,$e=Q.outerHeight,je=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Ye=ge.stableMinimapLayoutInput,nt=Ye&&Q.outerHeight===Ye.outerHeight&&Q.lineHeight===Ye.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ye.pixelRatio&&Q.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&Q.paddingTop===Ye.paddingTop&&Q.paddingBottom===Ye.paddingBottom&&Q.minimap.enabled===Ye.minimap.enabled&&Q.minimap.side===Ye.minimap.side&&Q.minimap.size===Ye.minimap.size&&Q.minimap.showSlider===Ye.minimap.showSlider&&Q.minimap.renderCharacters===Ye.minimap.renderCharacters&&Q.minimap.maxColumn===Ye.minimap.maxColumn&&Q.minimap.scale===Ye.minimap.scale&&Q.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&Q.isViewportWrapping===Ye.isViewportWrapping,wt=Q.lineHeight,St=Q.typicalHalfwidthCharacterWidth,Ct=Q.scrollBeyondLastLine,lt=Q.minimap.renderCharacters;let at=je>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Bt=Q.minimap.maxColumn,Ot=Q.minimap.size,Ft=Q.minimap.side,ft=Q.verticalScrollbarWidth,Dt=Q.viewLineCount,$t=Q.remainingWidth,Nt=Q.isViewportWrapping,Ge=lt?2:3;let Mt=Math.floor(je*$e);const Lt=Mt/je;let Ut=!1,gt=!1,kt=Ge*at,De=at/je,Pe=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:bt,extraLinesBeyondLastLine:vt,desiredRatio:At,minimapLineCount:pt}=pe.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Ct,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:$e,lineHeight:wt,pixelRatio:je});if(Dt/pt>1)Ut=!0,gt=!0,at=1,kt=1,De=at/je;else{let ht=!1,Kt=at+1;if(Ot==="fit"){const Vt=Math.ceil((bt+Dt+vt)*kt);Nt&&nt&&$t<=ge.stableFitRemainingWidth?(ht=!0,Kt=ge.stableFitMaxMinimapScale):ht=Vt>Mt}if(Ot==="fill"||ht){Ut=!0;const Vt=at;kt=Math.min(wt*je,Math.max(1,Math.floor(1/At))),Nt&&nt&&$t<=ge.stableFitRemainingWidth&&(Kt=ge.stableFitMaxMinimapScale),at=Math.min(Kt,Math.max(1,Math.floor(kt/Ge))),at>Vt&&(Pe=Math.min(2,at/Vt)),De=at/je/Pe,Mt=Math.ceil(Math.max(Ze,bt+Dt+vt)*kt),Nt?(ge.stableMinimapLayoutInput=Q,ge.stableFitRemainingWidth=$t,ge.stableFitMaxMinimapScale=at):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const me=Math.floor(Bt*De),X=Math.min(me,Math.max(0,Math.floor(($t-ft-2)*De/(St+De)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(je*X);const Le=Re/je;Re=Math.floor(Re*Pe);const Qe=lt?1:2,ze=Ft==="left"?0:Me-X-ft;return{renderMinimap:Qe,minimapLeft:ze,minimapWidth:X,minimapHeightIsEditorHeight:Ut,minimapIsSampling:gt,minimapScale:at,minimapLineHeight:kt,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Lt}}static computeLayout(Q,ge){const Me=ge.outerWidth|0,$e=ge.outerHeight|0,je=ge.lineHeight|0,Ye=ge.lineNumbersDigitCount|0,nt=ge.typicalHalfwidthCharacterWidth,wt=ge.maxDigitWidth,St=ge.pixelRatio,Ct=ge.viewLineCount,lt=Q.get(130),at=lt==="inherit"?Q.get(129):lt,Bt=at==="inherit"?Q.get(125):at,Ot=Q.get(128),Ft=ge.isDominatedByLongLines,ft=Q.get(54),Dt=Q.get(64).renderType!==0,$t=Q.get(65),Nt=Q.get(99),Ge=Q.get(80),Mt=Q.get(69),Lt=Q.get(97),Ut=Lt.verticalScrollbarSize,gt=Lt.verticalHasArrows,kt=Lt.arrowSize,De=Lt.horizontalScrollbarSize,Pe=Q.get(40),me=Q.get(104)!=="never";let X=Q.get(62);Pe&&me&&(X+=16);let Re=0;if(Dt){const Qt=Math.max(Ye,$t);Re=Math.round(Qt*wt)}let Le=0;ft&&(Le=je);let Qe=0,ze=Qe+Le,Ze=ze+Re,bt=Ze+X;const vt=Me-Le-Re-X;let At=!1,pt=!1,It=-1;at==="inherit"&&Ft?(At=!0,pt=!0):Bt==="on"||Bt==="bounded"?pt=!0:Bt==="wordWrapColumn"&&(It=Ot);const ht=pe.c({outerWidth:Me,outerHeight:$e,lineHeight:je,typicalHalfwidthCharacterWidth:nt,pixelRatio:St,scrollBeyondLastLine:Nt,paddingTop:Ge.top,paddingBottom:Ge.bottom,minimap:Mt,verticalScrollbarWidth:Ut,viewLineCount:Ct,remainingWidth:vt,isViewportWrapping:pt},ge.memory||new O);ht.renderMinimap!==0&&ht.minimapLeft===0&&(Qe+=ht.minimapWidth,ze+=ht.minimapWidth,Ze+=ht.minimapWidth,bt+=ht.minimapWidth);const Kt=vt-ht.minimapWidth,Vt=Math.max(1,Math.floor((Kt-Ut-2)/nt)),Et=gt?kt:0;return pt&&(It=Math.max(1,Vt),Bt==="bounded"&&(It=Math.min(It,Ot))),{width:Me,height:$e,glyphMarginLeft:Qe,glyphMarginWidth:Le,lineNumbersLeft:ze,lineNumbersWidth:Re,decorationsLeft:Ze,decorationsWidth:X,contentLeft:bt,contentWidth:Kt,minimap:ht,viewportColumn:Vt,isWordWrapMinified:At,isViewportWrapping:pt,wrappingColumn:It,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:De,overviewRuler:{top:Et,width:Ut,height:$e-2*Et,right:0}}}}e.EditorLayoutInfoComputer=pe;class ue extends w{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(46,null),i.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(48,null)}})}validate(Q){return n(Q,"simple",["simple","advanced"])}compute(Q,ge,Me){return ge.get(2)===2?"advanced":Me}}class de extends w{constructor(){const Q={enabled:!0};super(61,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:i.localize(49,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}class re extends w{constructor(){const Q={enabled:!1,maxLineCount:5};super(109,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:i.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:i.localize(51,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class G extends w{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:i.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(53,null),i.localize(54,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(55,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:i.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:i.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:i.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:n(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ge.fontFamily,this.defaultValue.fontFamily),padding:o(ge.padding,this.defaultValue.padding)}}}class H extends w{constructor(){super(62,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):E.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,ge,Me){return Me<0?E.clampedInt(-Me*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Me}}class oe extends P{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>P.clamp(Q,0,150),{markdownDescription:i.localize(60,null)})}compute(Q,ge,Me){return Q.fontInfo.lineHeight}}class ve extends w{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:i.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:i.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)],default:Q.size,description:i.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:i.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:i.localize(68,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:i.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:i.localize(71,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),autohide:o(ge.autohide,this.defaultValue.autohide),size:n(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(ge.side,this.defaultValue.side,["right","left"]),showSlider:n(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ge.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(ge.scale,1,1,3),maxColumn:E.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ae(Y){return Y==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Be extends w{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{top:E.clampedInt(ge.top,0,0,1e3),bottom:E.clampedInt(ge.bottom,0,0,1e3)}}}class xe extends w{constructor(){const Q={enabled:!0,cycle:!0};super(81,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:i.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:i.localize(75,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),cycle:o(ge.cycle,this.defaultValue.cycle)}}}class Te extends f{constructor(){super(136)}compute(Q,ge,Me){return Q.pixelRatio}}class Se extends w{constructor(){const Q={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(76,null),i.localize(77,null),i.localize(78,null)]}];super(84,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:Q.strings,description:i.localize(79,null)},comments:{anyOf:ge,default:Q.comments,description:i.localize(80,null)},other:{anyOf:ge,default:Q.other,description:i.localize(81,null)}},default:Q,markdownDescription:i.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const St=Q?"on":"off";return{comments:St,strings:St,other:St}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ge,comments:Me,strings:$e}=Q,je=["on","inline","off"];let Ye,nt,wt;return typeof ge=="boolean"?Ye=ge?"on":"off":Ye=n(ge,this.defaultValue.other,je),typeof Me=="boolean"?nt=Me?"on":"off":nt=n(Me,this.defaultValue.comments,je),typeof $e=="boolean"?wt=$e?"on":"off":wt=n($e,this.defaultValue.strings,je),{other:Ye,comments:nt,strings:wt}}}var ke;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class se extends w{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(83,null),i.localize(84,null),i.localize(85,null),i.localize(86,null)],default:"on",description:i.localize(87,null)})}validate(Q){let ge=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ge=4,Me=Q):Q==="interval"?ge=3:Q==="relative"?ge=2:Q==="on"?ge=1:ge=0),{renderType:ge,renderFn:Me}}}function ce(Y){const Q=Y.get(92);return Q==="editable"?Y.get(86):Q!=="on"}e.filterValidationDecorations=ce;class J extends w{constructor(){const Q=[],ge={type:"number",description:i.localize(88,null)};super(96,"rulers",Q,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:i.localize(89,null),format:"color-hex"}}}]},default:Q,description:i.localize(90,null)})}validate(Q){if(Array.isArray(Q)){const ge=[];for(const Me of Q)if(typeof Me=="number")ge.push({column:E.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const $e=Me;ge.push({column:E.clampedInt($e.column,0,0,1e4),color:$e.color})}return ge.sort((Me,$e)=>Me.column-$e.column),ge}return this.defaultValue}}function D(Y,Q){if(typeof Y!="string")return Q;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends w{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(91,null),i.localize(92,null),i.localize(93,null)],default:"auto",description:i.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(95,null),i.localize(96,null),i.localize(97,null)],default:"auto",description:i.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:i.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:i.localize(101,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q,Me=E.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=E.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:D(ge.vertical,this.defaultValue.vertical),horizontal:D(ge.horizontal,this.defaultValue.horizontal),useShadows:o(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:E.clampedInt(ge.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:E.clampedInt(ge.verticalSliderSize,$e,0,1e3),scrollByPage:o(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends w{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:i.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:i.localize(108,null)}})}applyUpdate(Q,ge){let Me=!1;ge.allowedCharacters&&Q&&(I.equals(Q.allowedCharacters,ge.allowedCharacters)||(Q={...Q,allowedCharacters:ge.allowedCharacters},Me=!0)),ge.allowedLocales&&Q&&(I.equals(Q.allowedLocales,ge.allowedLocales)||(Q={...Q,allowedLocales:ge.allowedLocales},Me=!0));const $e=super.applyUpdate(Q,ge);return Me?new m($e.newValue,!0):$e}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{nonBasicASCII:ye(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ye(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ye(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,ge){if(typeof Q!="object"||!Q)return ge;const Me={};for(const[$e,je]of Object.entries(Q))je===!0&&(Me[$e]=!0);return Me}}class K extends w{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:i.localize(109,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),mode:n(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Z extends w{constructor(){const Q={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:i.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:i.localize(111,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:o(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class he extends w{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(112,null),i.localize(113,null),i.localize(114,null)],default:Q.bracketPairs,description:i.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(116,null),i.localize(117,null),i.localize(118,null)],default:Q.bracketPairsHorizontal,description:i.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:i.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:i.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(122,null),i.localize(123,null),i.localize(124,null)],default:Q.highlightActiveIndentation,description:i.localize(125,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{bracketPairs:ye(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ye(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:ye(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ye(Y,Q,ge){const Me=ge.indexOf(Y);return Me===-1?Q:ge[Me]}class ae extends w{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(126,null),i.localize(127,null)],default:Q.insertMode,description:i.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:i.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:i.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:i.localize(131,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[i.localize(132,null),i.localize(133,null),i.localize(134,null),i.localize(135,null)],default:Q.selectionMode,markdownDescription:i.localize(136,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:i.localize(137,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:i.localize(138,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:i.localize(139,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:i.localize(140,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:i.localize(141,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(142,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(143,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(169,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(170,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(171,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(172,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(173,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertMode:n(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(ge.showIcons,this.defaultValue.showIcons),showStatusBar:o(ge.showStatusBar,this.defaultValue.showStatusBar),preview:o(ge.preview,this.defaultValue.preview),previewMode:n(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ge.showMethods,this.defaultValue.showMethods),showFunctions:o(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(ge.showFields,this.defaultValue.showFields),showVariables:o(ge.showVariables,this.defaultValue.showVariables),showClasses:o(ge.showClasses,this.defaultValue.showClasses),showStructs:o(ge.showStructs,this.defaultValue.showStructs),showInterfaces:o(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ge.showModules,this.defaultValue.showModules),showProperties:o(ge.showProperties,this.defaultValue.showProperties),showEvents:o(ge.showEvents,this.defaultValue.showEvents),showOperators:o(ge.showOperators,this.defaultValue.showOperators),showUnits:o(ge.showUnits,this.defaultValue.showUnits),showValues:o(ge.showValues,this.defaultValue.showValues),showConstants:o(ge.showConstants,this.defaultValue.showConstants),showEnums:o(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ge.showKeywords,this.defaultValue.showKeywords),showWords:o(ge.showWords,this.defaultValue.showWords),showColors:o(ge.showColors,this.defaultValue.showColors),showFiles:o(ge.showFiles,this.defaultValue.showFiles),showReferences:o(ge.showReferences,this.defaultValue.showReferences),showFolders:o(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ge.showSnippets,this.defaultValue.showSnippets),showUsers:o(ge.showUsers,this.defaultValue.showUsers),showIssues:o(ge.showIssues,this.defaultValue.showIssues)}}}class be extends w{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(174,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ee extends f{constructor(){super(137)}compute(Q,ge,Me){return ge.get(86)?!0:Q.tabFocusMode}}var We;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(We=e.WrappingIndent||(e.WrappingIndent={}));class He extends w{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(175,null),i.localize(176,null),i.localize(177,null),i.localize(178,null)],description:i.localize(179,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ge,Me){return ge.get(2)===2?0:Me}}class tt extends f{constructor(){super(139)}compute(Q,ge,Me){const $e=ge.get(138);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}class Xe extends w{constructor(){const Q={enabled:!0};super(33,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:i.localize(180,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:o(Q.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?it:C.isLinux?dt:et,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var st;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.autoClosingBrackets=5]="autoClosingBrackets",Y[Y.autoClosingDelete=6]="autoClosingDelete",Y[Y.autoClosingOvertype=7]="autoClosingOvertype",Y[Y.autoClosingQuotes=8]="autoClosingQuotes",Y[Y.autoIndent=9]="autoIndent",Y[Y.automaticLayout=10]="automaticLayout",Y[Y.autoSurround=11]="autoSurround",Y[Y.bracketPairColorization=12]="bracketPairColorization",Y[Y.guides=13]="guides",Y[Y.codeLens=14]="codeLens",Y[Y.codeLensFontFamily=15]="codeLensFontFamily",Y[Y.codeLensFontSize=16]="codeLensFontSize",Y[Y.colorDecorators=17]="colorDecorators",Y[Y.colorDecoratorsLimit=18]="colorDecoratorsLimit",Y[Y.columnSelection=19]="columnSelection",Y[Y.comments=20]="comments",Y[Y.contextmenu=21]="contextmenu",Y[Y.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=23]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=25]="cursorStyle",Y[Y.cursorSurroundingLines=26]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=28]="cursorWidth",Y[Y.disableLayerHinting=29]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Y[Y.domReadOnly=31]="domReadOnly",Y[Y.dragAndDrop=32]="dragAndDrop",Y[Y.dropIntoEditor=33]="dropIntoEditor",Y[Y.emptySelectionClipboard=34]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=36]="extraEditorClassName",Y[Y.fastScrollSensitivity=37]="fastScrollSensitivity",Y[Y.find=38]="find",Y[Y.fixedOverflowWidgets=39]="fixedOverflowWidgets",Y[Y.folding=40]="folding",Y[Y.foldingStrategy=41]="foldingStrategy",Y[Y.foldingHighlight=42]="foldingHighlight",Y[Y.foldingImportsByDefault=43]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=44]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=46]="fontFamily",Y[Y.fontInfo=47]="fontInfo",Y[Y.fontLigatures=48]="fontLigatures",Y[Y.fontSize=49]="fontSize",Y[Y.fontWeight=50]="fontWeight",Y[Y.fontVariations=51]="fontVariations",Y[Y.formatOnPaste=52]="formatOnPaste",Y[Y.formatOnType=53]="formatOnType",Y[Y.glyphMargin=54]="glyphMargin",Y[Y.gotoLocation=55]="gotoLocation",Y[Y.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Y[Y.hover=57]="hover",Y[Y.inDiffEditor=58]="inDiffEditor",Y[Y.inlineSuggest=59]="inlineSuggest",Y[Y.letterSpacing=60]="letterSpacing",Y[Y.lightbulb=61]="lightbulb",Y[Y.lineDecorationsWidth=62]="lineDecorationsWidth",Y[Y.lineHeight=63]="lineHeight",Y[Y.lineNumbers=64]="lineNumbers",Y[Y.lineNumbersMinChars=65]="lineNumbersMinChars",Y[Y.linkedEditing=66]="linkedEditing",Y[Y.links=67]="links",Y[Y.matchBrackets=68]="matchBrackets",Y[Y.minimap=69]="minimap",Y[Y.mouseStyle=70]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=72]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=74]="multiCursorModifier",Y[Y.multiCursorPaste=75]="multiCursorPaste",Y[Y.multiCursorLimit=76]="multiCursorLimit",Y[Y.occurrencesHighlight=77]="occurrencesHighlight",Y[Y.overviewRulerBorder=78]="overviewRulerBorder",Y[Y.overviewRulerLanes=79]="overviewRulerLanes",Y[Y.padding=80]="padding",Y[Y.parameterHints=81]="parameterHints",Y[Y.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=84]="quickSuggestions",Y[Y.quickSuggestionsDelay=85]="quickSuggestionsDelay",Y[Y.readOnly=86]="readOnly",Y[Y.renameOnType=87]="renameOnType",Y[Y.renderControlCharacters=88]="renderControlCharacters",Y[Y.renderFinalNewline=89]="renderFinalNewline",Y[Y.renderLineHighlight=90]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=92]="renderValidationDecorations",Y[Y.renderWhitespace=93]="renderWhitespace",Y[Y.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Y[Y.roundedSelection=95]="roundedSelection",Y[Y.rulers=96]="rulers",Y[Y.scrollbar=97]="scrollbar",Y[Y.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=99]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=100]="scrollPredominantAxis",Y[Y.selectionClipboard=101]="selectionClipboard",Y[Y.selectionHighlight=102]="selectionHighlight",Y[Y.selectOnLineNumbers=103]="selectOnLineNumbers",Y[Y.showFoldingControls=104]="showFoldingControls",Y[Y.showUnused=105]="showUnused",Y[Y.snippetSuggestions=106]="snippetSuggestions",Y[Y.smartSelect=107]="smartSelect",Y[Y.smoothScrolling=108]="smoothScrolling",Y[Y.stickyScroll=109]="stickyScroll",Y[Y.stickyTabStops=110]="stickyTabStops",Y[Y.stopRenderingLineAfter=111]="stopRenderingLineAfter",Y[Y.suggest=112]="suggest",Y[Y.suggestFontSize=113]="suggestFontSize",Y[Y.suggestLineHeight=114]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Y[Y.suggestSelection=116]="suggestSelection",Y[Y.tabCompletion=117]="tabCompletion",Y[Y.tabIndex=118]="tabIndex",Y[Y.unicodeHighlighting=119]="unicodeHighlighting",Y[Y.unusualLineTerminators=120]="unusualLineTerminators",Y[Y.useShadowDOM=121]="useShadowDOM",Y[Y.useTabStops=122]="useTabStops",Y[Y.wordBreak=123]="wordBreak",Y[Y.wordSeparators=124]="wordSeparators",Y[Y.wordWrap=125]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=128]="wordWrapColumn",Y[Y.wordWrapOverride1=129]="wordWrapOverride1",Y[Y.wordWrapOverride2=130]="wordWrapOverride2",Y[Y.wrappingIndent=131]="wrappingIndent",Y[Y.wrappingStrategy=132]="wrappingStrategy",Y[Y.showDeprecated=133]="showDeprecated",Y[Y.inlayHints=134]="inlayHints",Y[Y.editorClassName=135]="editorClassName",Y[Y.pixelRatio=136]="pixelRatio",Y[Y.tabFocusMode=137]="tabFocusMode",Y[Y.layoutInfo=138]="layoutInfo",Y[Y.wrappingInfo=139]="wrappingInfo"})(st=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(181,null)})),acceptSuggestionOnEnter:Fe(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(182,null),""],markdownDescription:i.localize(183,null)})),accessibilitySupport:Fe(new s),accessibilityPageSize:Fe(new E(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(184,null),tags:["accessibility"]})),ariaLabel:Fe(new p(4,"ariaLabel",i.localize(185,null))),autoClosingBrackets:Fe(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(186,null),i.localize(187,null),""],description:i.localize(188,null)})),autoClosingDelete:Fe(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(189,null),""],description:i.localize(190,null)})),autoClosingOvertype:Fe(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(191,null),""],description:i.localize(192,null)})),autoClosingQuotes:Fe(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(193,null),i.localize(194,null),""],description:i.localize(195,null)})),autoIndent:Fe(new t(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[i.localize(196,null),i.localize(197,null),i.localize(198,null),i.localize(199,null),i.localize(200,null)],description:i.localize(201,null)})),automaticLayout:Fe(new l(10,"automaticLayout",!1)),autoSurround:Fe(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(202,null),i.localize(203,null),i.localize(204,null),""],description:i.localize(205,null)})),bracketPairColorization:Fe(new Z),bracketPairGuides:Fe(new he),stickyTabStops:Fe(new l(110,"stickyTabStops",!1,{description:i.localize(206,null)})),codeLens:Fe(new l(14,"codeLens",!0,{description:i.localize(207,null)})),codeLensFontFamily:Fe(new p(15,"codeLensFontFamily","",{description:i.localize(208,null)})),codeLensFontSize:Fe(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(209,null)})),colorDecorators:Fe(new l(17,"colorDecorators",!0,{description:i.localize(210,null)})),colorDecoratorsLimit:Fe(new E(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:i.localize(211,null)})),columnSelection:Fe(new l(19,"columnSelection",!1,{description:i.localize(212,null)})),comments:Fe(new h),contextmenu:Fe(new l(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new l(22,"copyWithSyntaxHighlighting",!0,{description:i.localize(213,null)})),cursorBlinking:Fe(new t(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:i.localize(214,null)})),cursorSmoothCaretAnimation:Fe(new d(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[i.localize(215,null),i.localize(216,null),i.localize(217,null)],description:i.localize(218,null)})),cursorStyle:Fe(new t(25,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:i.localize(219,null)})),cursorSurroundingLines:Fe(new E(26,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(220,null)})),cursorSurroundingLinesStyle:Fe(new d(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(221,null),i.localize(222,null)],description:i.localize(223,null)})),cursorWidth:Fe(new E(28,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(224,null)})),disableLayerHinting:Fe(new l(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new l(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new l(31,"domReadOnly",!1)),dragAndDrop:Fe(new l(32,"dragAndDrop",!0,{description:i.localize(225,null)})),emptySelectionClipboard:Fe(new te),dropIntoEditor:Fe(new Xe),stickyScroll:Fe(new re),experimentalWhitespaceRendering:Fe(new d(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[i.localize(226,null),i.localize(227,null),i.localize(228,null)],description:i.localize(229,null)})),extraEditorClassName:Fe(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new P(37,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:i.localize(230,null)})),find:Fe(new x),fixedOverflowWidgets:Fe(new l(39,"fixedOverflowWidgets",!1)),folding:Fe(new l(40,"folding",!0,{description:i.localize(231,null)})),foldingStrategy:Fe(new d(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(232,null),i.localize(233,null)],description:i.localize(234,null)})),foldingHighlight:Fe(new l(42,"foldingHighlight",!0,{description:i.localize(235,null)})),foldingImportsByDefault:Fe(new l(43,"foldingImportsByDefault",!1,{description:i.localize(236,null)})),foldingMaximumRegions:Fe(new E(44,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(237,null)})),unfoldOnClickAfterEndOfLine:Fe(new l(45,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(238,null)})),fontFamily:Fe(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(239,null)})),fontInfo:Fe(new T),fontLigatures2:Fe(new N),fontSize:Fe(new M),fontWeight:Fe(new V),fontVariations:Fe(new $),formatOnPaste:Fe(new l(52,"formatOnPaste",!1,{description:i.localize(240,null)})),formatOnType:Fe(new l(53,"formatOnType",!1,{description:i.localize(241,null)})),glyphMargin:Fe(new l(54,"glyphMargin",!0,{description:i.localize(242,null)})),gotoLocation:Fe(new q),hideCursorInOverviewRuler:Fe(new l(56,"hideCursorInOverviewRuler",!1,{description:i.localize(243,null)})),hover:Fe(new le),inDiffEditor:Fe(new l(58,"inDiffEditor",!1)),letterSpacing:Fe(new P(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>P.clamp(Y,-5,20),{description:i.localize(244,null)})),lightbulb:Fe(new de),lineDecorationsWidth:Fe(new H),lineHeight:Fe(new oe),lineNumbers:Fe(new se),lineNumbersMinChars:Fe(new E(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new l(66,"linkedEditing",!1,{description:i.localize(245,null)})),links:Fe(new l(67,"links",!0,{description:i.localize(246,null)})),matchBrackets:Fe(new d(68,"matchBrackets","always",["always","near","never"],{description:i.localize(247,null)})),minimap:Fe(new ve),mouseStyle:Fe(new d(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new P(71,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:i.localize(248,null)})),mouseWheelZoom:Fe(new l(72,"mouseWheelZoom",!1,{markdownDescription:i.localize(249,null)})),multiCursorMergeOverlapping:Fe(new l(73,"multiCursorMergeOverlapping",!0,{description:i.localize(250,null)})),multiCursorModifier:Fe(new t(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ae,{markdownEnumDescriptions:[i.localize(251,null),i.localize(252,null)],markdownDescription:i.localize(253,null)})),multiCursorPaste:Fe(new d(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(254,null),i.localize(255,null)],markdownDescription:i.localize(256,null)})),multiCursorLimit:Fe(new E(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(257,null)})),occurrencesHighlight:Fe(new l(77,"occurrencesHighlight",!0,{description:i.localize(258,null)})),overviewRulerBorder:Fe(new l(78,"overviewRulerBorder",!0,{description:i.localize(259,null)})),overviewRulerLanes:Fe(new E(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Be),parameterHints:Fe(new xe),peekWidgetDefaultFocus:Fe(new d(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(260,null),i.localize(261,null)],description:i.localize(262,null)})),definitionLinkOpensInPeek:Fe(new l(83,"definitionLinkOpensInPeek",!1,{description:i.localize(263,null)})),quickSuggestions:Fe(new Se),quickSuggestionsDelay:Fe(new E(85,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(264,null)})),readOnly:Fe(new l(86,"readOnly",!1)),renameOnType:Fe(new l(87,"renameOnType",!1,{description:i.localize(265,null),markdownDeprecationMessage:i.localize(266,null)})),renderControlCharacters:Fe(new l(88,"renderControlCharacters",!0,{description:i.localize(267,null),restricted:!0})),renderFinalNewline:Fe(new d(89,"renderFinalNewline",C.isLinux?"dimmed":"on",["off","on","dimmed"],{description:i.localize(268,null)})),renderLineHighlight:Fe(new d(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(269,null)],description:i.localize(270,null)})),renderLineHighlightOnlyWhenFocus:Fe(new l(91,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(271,null)})),renderValidationDecorations:Fe(new d(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new d(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(272,null),i.localize(273,null),i.localize(274,null),""],description:i.localize(275,null)})),revealHorizontalRightPadding:Fe(new E(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new l(95,"roundedSelection",!0,{description:i.localize(276,null)})),rulers:Fe(new J),scrollbar:Fe(new B),scrollBeyondLastColumn:Fe(new E(98,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(277,null)})),scrollBeyondLastLine:Fe(new l(99,"scrollBeyondLastLine",!0,{description:i.localize(278,null)})),scrollPredominantAxis:Fe(new l(100,"scrollPredominantAxis",!0,{description:i.localize(279,null)})),selectionClipboard:Fe(new l(101,"selectionClipboard",!0,{description:i.localize(280,null),included:C.isLinux})),selectionHighlight:Fe(new l(102,"selectionHighlight",!0,{description:i.localize(281,null)})),selectOnLineNumbers:Fe(new l(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new d(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(282,null),i.localize(283,null),i.localize(284,null)],description:i.localize(285,null)})),showUnused:Fe(new l(105,"showUnused",!0,{description:i.localize(286,null)})),showDeprecated:Fe(new l(133,"showDeprecated",!0,{description:i.localize(287,null)})),inlayHints:Fe(new G),snippetSuggestions:Fe(new d(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(288,null),i.localize(289,null),i.localize(290,null),i.localize(291,null)],description:i.localize(292,null)})),smartSelect:Fe(new be),smoothScrolling:Fe(new l(108,"smoothScrolling",!1,{description:i.localize(293,null)})),stopRenderingLineAfter:Fe(new E(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ae),inlineSuggest:Fe(new K),suggestFontSize:Fe(new E(113,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(294,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new E(114,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(295,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new l(115,"suggestOnTriggerCharacters",!0,{description:i.localize(296,null)})),suggestSelection:Fe(new d(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(297,null),i.localize(298,null),i.localize(299,null)],description:i.localize(300,null)})),tabCompletion:Fe(new d(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(301,null),i.localize(302,null),i.localize(303,null)],description:i.localize(304,null)})),tabIndex:Fe(new E(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new W),unusualLineTerminators:Fe(new d(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(305,null),i.localize(306,null),i.localize(307,null)],description:i.localize(308,null)})),useShadowDOM:Fe(new l(121,"useShadowDOM",!0)),useTabStops:Fe(new l(122,"useTabStops",!0,{description:i.localize(309,null)})),wordBreak:Fe(new d(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(310,null),i.localize(311,null)],description:i.localize(312,null)})),wordSeparators:Fe(new p(124,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:i.localize(313,null)})),wordWrap:Fe(new d(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(314,null),i.localize(315,null),i.localize(316,null),i.localize(317,null)],description:i.localize(318,null)})),wordWrapBreakAfterCharacters:Fe(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new E(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(319,null)})),wordWrapOverride1:Fe(new d(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new d(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new j),pixelRatio:Fe(new Te),tabFocusMode:Fe(new Ee),layoutInfo:Fe(new pe),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new He),wrappingStrategy:Fe(new ue)}}),define(Ie[130],Ce([14,15]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[131],Ce([14,15]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[132],Ce([14,15]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[133],Ce([14,15]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ie[134],Ce([14,15]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ie[135],Ce([14,15]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(Ie[136],Ce([14,15]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ie[137],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[138],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[139],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[140],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[141],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[142],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[143],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[144],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ie[145],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(Ie[146],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[147],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[148],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[149],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[150],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[151],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[152],Ce([14,15]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[153],Ce([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class C{constructor(){this.a=new Map}register(L,I){this.a.set(L,I)}updateManifest(L){if(!(typeof L.main>"u"&&typeof L.browser>"u")&&(L.activationEvents===void 0&&Object.assign(L,{activationEvents:[]}),!(!Array.isArray(L.activationEvents)||!L.contributes)))for(const I in L.contributes){const R=this.a.get(I);if(!R)continue;const y=L.contributes[I],k=Array.isArray(y)?y:[y];try{R(k,L.activationEvents)}catch(O){(0,i.onUnexpectedError)(O)}}}}e.ImplicitActivationEventsImpl=C,e.ImplicitActivationEvents=new C}),define(Ie[154],Ce([1,0,23,30,132,254]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||I.test(l)}e.isValidVersionStr=y;function k(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=l.match(I);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=k;function O(l){if(!l)return null;const v=l.majorBase,E=l.majorMustEqual,P=l.minorBase;let p=l.minorMustEqual;const n=l.patchBase;let d=l.patchMustEqual;l.hasCaret&&(v===0||(p=!1),d=!1);let t=0;if(l.preRelease){const u=R.exec(l.preRelease);if(u){const[,s,h,a]=u;t=Date.UTC(Number(s),Number(h)-1,Number(a))}}return{majorBase:v,majorMustEqual:E,minorBase:P,minorMustEqual:p,patchBase:n,patchMustEqual:d,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=O;function w(l,v,E){let P;typeof l=="string"?P=O(k(l)):P=l;let p;v instanceof Date?p=v.getTime():typeof v=="string"&&(p=new Date(v).getTime());let n;if(typeof E=="string"?n=O(k(E)):n=E,!P||!n)return!1;const d=P.majorBase,t=P.minorBase,u=P.patchBase;let s=n.majorBase,h=n.minorBase,a=n.patchBase;const c=n.notBefore;let g=n.majorMustEqual,A=n.minorMustEqual,F=n.patchMustEqual;return n.isMinimum?d>s?!0:d<s?!1:t>h?!0:t<h||p&&p<c?!1:u>=a:(d===1&&s===0&&(!g||!A||!F)&&(s=1,h=0,a=0,g=!0,A=!1,F=!1),d<s?!1:d>s?!g:t<h?!1:t>h?!A:u<a?!1:u>a?!F:!(p&&p<c))}e.isValidVersion=w;function m(l,v,E,P,p){const n=[];if(typeof P.publisher<"u"&&typeof P.publisher!="string")return n.push([C.default.Error,S.localize(0,null)]),n;if(typeof P.name!="string")return n.push([C.default.Error,S.localize(1,null,"name")]),n;if(typeof P.version!="string")return n.push([C.default.Error,S.localize(2,null,"version")]),n;if(!P.engines)return n.push([C.default.Error,S.localize(3,null,"engines")]),n;if(typeof P.engines.vscode!="string")return n.push([C.default.Error,S.localize(4,null,"engines.vscode")]),n;if(typeof P.extensionDependencies<"u"&&!o(P.extensionDependencies))return n.push([C.default.Error,S.localize(5,null,"extensionDependencies")]),n;if(typeof P.activationEvents<"u"){if(!o(P.activationEvents))return n.push([C.default.Error,S.localize(6,null,"activationEvents")]),n;if(typeof P.main>"u"&&typeof P.browser>"u")return n.push([C.default.Error,S.localize(7,null,"activationEvents","main")]),n}if(typeof P.extensionKind<"u"&&typeof P.main>"u"&&n.push([C.default.Warning,S.localize(8,null,"extensionKind")]),typeof P.main<"u"){if(typeof P.main!="string")return n.push([C.default.Error,S.localize(9,null,"main")]),n;{const u=(0,i.joinPath)(E,P.main);(0,i.isEqualOrParent)(u,E)||n.push([C.default.Warning,S.localize(10,null,u.path,E.path)])}if(typeof P.activationEvents>"u")return n.push([C.default.Error,S.localize(11,null,"activationEvents","main")]),n}if(typeof P.browser<"u"){if(typeof P.browser!="string")return n.push([C.default.Error,S.localize(12,null,"browser")]),n;{const u=(0,i.joinPath)(E,P.browser);(0,i.isEqualOrParent)(u,E)||n.push([C.default.Warning,S.localize(13,null,u.path,E.path)])}if(typeof P.activationEvents>"u")return n.push([C.default.Error,S.localize(14,null,"activationEvents","browser")]),n}if(!L.valid(P.version))return n.push([C.default.Error,S.localize(15,null)]),n;const d=[];if(!b(l,v,P,p,d))for(const u of d)n.push([C.default.Error,u]);return n}e.validateExtensionManifest=m;function b(l,v,E,P,p){return P||typeof E.main>"u"&&typeof E.browser>"u"?!0:r(l,v,E.engines.vscode,p)}e.isValidExtensionVersion=b;function f(l,v,E){return l==="*"||r(v,E,l)}e.isEngineValid=f;function r(l,v,E,P=[]){const p=O(k(E));if(!p)return P.push(S.localize(16,null,E)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return P.push(S.localize(17,null,E)),!1}else if(!p.majorMustEqual)return P.push(S.localize(18,null,E)),!1;return w(l,v,p)?!0:(P.push(S.localize(19,null,l,E)),!1)}function o(l){if(!Array.isArray(l))return!1;for(let v=0,E=l.length;v<E;v++)if(typeof l[v]!="string")return!1;return!0}}),define(Ie[88],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(S,L=[],I=!1){this.ctor=S,this.staticArguments=L,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=i}),define(Ie[66],Ce([1,0,88]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var S;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(S=e.InstantiationType||(e.InstantiationType={}));function L(R,y,k){y instanceof i.SyncDescriptor||(y=new i.SyncDescriptor(y,[],Boolean(k))),C.push([R,y])}e.registerSingleton=L;function I(){return C}e.getSingletonServiceDescriptors=I}),define(Ie[155],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(L,I){this.key=L,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class C{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const I of this.a.values())I.outgoing.size===0&&L.push(I);return L}insertEdge(L,I){const R=this.lookupOrInsertNode(L),y=this.lookupOrInsertNode(I);R.outgoing.set(y.key,y),y.incoming.set(R.key,R)}removeNode(L){const I=this.b(L);this.a.delete(I);for(const R of this.a.values())R.outgoing.delete(I),R.incoming.delete(I)}lookupOrInsertNode(L){const I=this.b(L);let R=this.a.get(I);return R||(R=new i(I,L),this.a.set(I,R)),R}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[I,R]of this.a)L.push(`${I}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,I]of this.a){const R=new Set([L]),y=this.c(I,R);if(y)return y}}c(L,I){for(const[R,y]of L.outgoing){if(I.has(R))return[...I,R].join(" -> ");I.add(R);const k=this.c(y,I);if(k)return k;I.delete(R)}}}e.Graph=C}),define(Ie[3],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function R(y){return y[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=R})(i=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function C(I,R,y){R[i.DI_TARGET]===R?R[i.DI_DEPENDENCIES].push({id:I,index:y}):(R[i.DI_DEPENDENCIES]=[{id:I,index:y}],R[i.DI_TARGET]=R)}function S(I){if(i.serviceIds.has(I))return i.serviceIds.get(I);const R=function(y,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(R,y,O)};return R.toString=()=>I,i.serviceIds.set(I,R),R}e.createDecorator=S;function L(I){return I}e.refineServiceDecorator=L}),define(Ie[41],Ce([1,0,9,2,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof C.URI)}e.isConfigurationOverrides=L;function I(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=I;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function k(l,v){const E=Object.create(null);for(const P in l)O(E,P,l[P],v);return E}e.toValuesTree=k;function O(l,v,E,P){const p=v.split("."),n=p.pop();let d=l;for(let t=0;t<p.length;t++){const u=p[t];let s=d[u];switch(typeof s){case"undefined":s=d[u]=Object.create(null);break;case"object":break;default:P(`Ignoring ${v} as ${p.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}d=s}if(typeof d=="object"&&d!==null)try{d[n]=E}catch{P(`Ignoring ${v} as ${p.join(".")} is ${JSON.stringify(d)}`)}else P(`Ignoring ${v} as ${p.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=O;function w(l,v){const E=v.split(".");m(l,E)}e.removeFromValueTree=w;function m(l,v){const E=v.shift();if(v.length===0){delete l[E];return}if(Object.keys(l).indexOf(E)!==-1){const P=l[E];typeof P=="object"&&!Array.isArray(P)&&(m(P,v),Object.keys(P).length===0&&delete l[E])}}function b(l,v,E){function P(d,t){let u=d;for(const s of t){if(typeof u!="object"||u===null)return;u=u[s]}return u}const p=v.split("."),n=P(l,p);return typeof n>"u"?E:n}e.getConfigurationValue=b;function f(l,v,E){Object.keys(v).forEach(P=>{P!=="__proto__"&&(P in l?i.isObject(l[P])&&i.isObject(v[P])?f(l[P],v[P],E):E&&(l[P]=v[P]):l[P]=v[P])})}e.merge=f;function r(l,v,E){const P=l.inspect(v),p=l.inspect(E);return typeof P.userValue<"u"||typeof P.workspaceValue<"u"||typeof P.workspaceFolderValue<"u"?P.value:typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:P.defaultValue}e.getMigratedSettingValue=r;function o(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=o}),define(Ie[42],Ce([1,0,20,10,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",i.isMacintosh),L.set("isLinux",i.isLinux),L.set("isWindows",i.isWindows),L.set("isWeb",i.isWeb),L.set("isMacNative",i.isMacintosh&&!i.isWeb),L.set("isEdge",i.isEdge),L.set("isFirefox",i.isFirefox),L.set("isChrome",i.isChrome),L.set("isSafari",i.isSafari);const I=Object.prototype.hasOwnProperty;var R;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return w.INSTANCE}static true(){return m.INSTANCE}static has(N){return b.create(N)}static equals(N,$){return f.create(N,$)}static notEquals(N,$){return l.create(N,$)}static regex(N,$){return t.create(N,$)}static in(N,$){return r.create(N,$)}static notIn(N,$){return o.create(N,$)}static not(N){return v.create(N)}static and(...N){return h.create(N,null,!0)}static or(...N){return a.create(N,null,!0)}static greater(N,$){return P.create(N,$)}static greaterEquals(N,$){return p.create(N,$)}static smaller(N,$){return n.create(N,$)}static smallerEquals(N,$){return d.create(N,$)}static deserialize(N,$=!1){if(!!N)return this.c(N,$)}static c(N,$){const T=N.split("||");return a.create(T.map(M=>this.d(M,$)),null,!0)}static d(N,$){const T=N.split("&&");return h.create(T.map(M=>this.f(M,$)),null,!0)}static f(N,$){if(N=N.trim(),N.indexOf("!=")>=0){const T=N.split("!=");return l.create(T[0].trim(),this.g(T[1],$))}if(N.indexOf("==")>=0){const T=N.split("==");return f.create(T[0].trim(),this.g(T[1],$))}if(N.indexOf("=~")>=0){const T=N.split("=~");return t.create(T[0].trim(),this.h(T[1],$))}if(N.indexOf(" not in ")>=0){const T=N.split(" not in ");return o.create(T[0].trim(),this.g(T[1],$))}if(N.indexOf(" in ")>=0){const T=N.split(" in ");return r.create(T[0].trim(),this.g(T[1],$))}if(/^[^<=>]+>=[^<=>]+$/.test(N)){const T=N.split(">=");return p.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(N)){const T=N.split(">");return P.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(N)){const T=N.split("<=");return d.create(T[0].trim(),T[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(N)){const T=N.split("<");return n.create(T[0].trim(),T[1].trim())}return/^\!\s*/.test(N)?v.create(N.substr(1).trim()):b.create(N)}static g(N,$){if(N=N.trim(),N==="true")return!0;if(N==="false")return!1;const T=/^'([^']*)'$/.exec(N);return T?T[1].trim():N}static h(N,$){if((0,C.isFalsyOrWhitespace)(N)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const T=N.indexOf("/"),M=N.lastIndexOf("/");if(T===M||T<0){if($)throw new Error(`bad regexp-value '${N}', missing /-enclosure`);return console.warn(`bad regexp-value '${N}', missing /-enclosure`),null}const V=N.slice(T+1,M),q=N[M+1]==="i"?"i":"";try{return new RegExp(V,q)}catch(le){if($)throw new Error(`bad regexp-value '${N}', parse error: ${le}`);return console.warn(`bad regexp-value '${N}', parse error: ${le}`),null}}}e.ContextKeyExpr=y;function k(x,N){const $=x?x.substituteConstants():void 0,T=N?N.substituteConstants():void 0;return!$&&!T?!0:!$||!T?!1:$.equals(T)}e.expressionsAreEqualWithConstantSubstitution=k;function O(x,N){return x.cmp(N)}class w{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class m{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class b{static create(N,$=null){const T=L.get(N);return typeof T=="boolean"?T?m.INSTANCE:w.INSTANCE:new b(N,$)}constructor(N,$){this.key=N,this.c=$,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:g(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=L.get(this.key);return typeof N=="boolean"?N?m.INSTANCE:w.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=v.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=b;class f{static create(N,$,T=null){if(typeof $=="boolean")return $?b.create(N,T):v.create(N,T);const M=L.get(N);return typeof M=="boolean"?$===(M?"true":"false")?m.INSTANCE:w.INSTANCE:new f(N,$,T)}constructor(N,$,T){this.c=N,this.d=$,this.f=T,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:A(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=L.get(this.c);if(typeof N=="boolean"){const $=N?"true":"false";return this.d===$?m.INSTANCE:w.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class r{static create(N,$){return new r(N,$)}constructor(N,$){this.d=N,this.f=$,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:A(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const $=N.getValue(this.f),T=N.getValue(this.d);return Array.isArray($)?$.includes(T):typeof T=="string"&&typeof $=="object"&&$!==null?I.call($,T):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=o.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=r;class o{static create(N,$){return new o(N,$)}constructor(N,$){this.d=N,this.f=$,this.type=11,this.c=r.create(N,$)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=o;class l{static create(N,$,T=null){if(typeof $=="boolean")return $?v.create(N,T):b.create(N,T);const M=L.get(N);return typeof M=="boolean"?$===(M?"true":"false")?w.INSTANCE:m.INSTANCE:new l(N,$,T)}constructor(N,$,T){this.c=N,this.d=$,this.f=T,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:A(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=L.get(this.c);if(typeof N=="boolean"){const $=N?"true":"false";return this.d===$?w.INSTANCE:m.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class v{static create(N,$=null){const T=L.get(N);return typeof T=="boolean"?T?w.INSTANCE:m.INSTANCE:new v(N,$)}constructor(N,$){this.c=N,this.d=$,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:g(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=L.get(this.c);return typeof N=="boolean"?N?w.INSTANCE:m.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.ContextKeyNotExpr=v;function E(x,N){if(typeof x=="string"){const $=parseFloat(x);isNaN($)||(x=$)}return typeof x=="string"||typeof x=="number"?N(x):w.INSTANCE}class P{static create(N,$,T=null){return E($,M=>new P(N,M,T))}constructor(N,$,T){this.c=N,this.d=$,this.f=T,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:A(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=P;class p{static create(N,$,T=null){return E($,M=>new p(N,M,T))}constructor(N,$,T){this.c=N,this.d=$,this.f=T,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:A(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=p;class n{static create(N,$,T=null){return E($,M=>new n(N,M,T))}constructor(N,$,T){this.c=N,this.d=$,this.f=T,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:A(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class d{static create(N,$,T=null){return E($,M=>new d(N,M,T))}constructor(N,$,T){this.c=N,this.d=$,this.f=T,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:A(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=d;class t{static create(N,$){return new t(N,$)}constructor(N,$){this.d=N,this.f=$,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const $=this.f?this.f.source:"",T=N.f?N.f.source:"";return $<T?-1:$>T?1:0}equals(N){if(N.type===this.type){const $=this.f?this.f.source:"",T=N.f?N.f.source:"";return this.d===N.d&&$===T}return!1}substituteConstants(){return this}evaluate(N){const $=N.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=t;class u{static create(N){return new u(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(N){return new u(this.c.map(N))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function s(x){let N=null;for(let $=0,T=x.length;$<T;$++){const M=x[$].substituteConstants();if(x[$]!==M&&N===null){N=[];for(let V=0;V<$;V++)N[V]=x[V]}N!==null&&(N[$]=M)}return N===null?x:N}class h{static create(N,$,T){return h.d(N,$,T)}constructor(N,$){this.expr=N,this.c=$,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let $=0,T=this.expr.length;$<T;$++){const M=O(this.expr[$],N.expr[$]);if(M!==0)return M}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let $=0,T=this.expr.length;$<T;$++)if(!this.expr[$].equals(N.expr[$]))return!1;return!0}return!1}substituteConstants(){const N=s(this.expr);return N===this.expr?this:h.create(N,this.c,!1)}evaluate(N){for(let $=0,T=this.expr.length;$<T;$++)if(!this.expr[$].evaluate(N))return!1;return!0}static d(N,$,T){const M=[];let V=!1;for(const q of N)if(!!q){if(q.type===1){V=!0;continue}if(q.type===0)return w.INSTANCE;if(q.type===6){M.push(...q.expr);continue}M.push(q)}if(M.length===0&&V)return m.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(O);for(let q=1;q<M.length;q++)M[q-1].equals(M[q])&&(M.splice(q,1),q--);if(M.length===1)return M[0];for(;M.length>1;){const q=M[M.length-1];if(q.type!==9)break;M.pop();const le=M.pop(),_=M.length===0,pe=a.create(q.expr.map(ue=>h.create([ue,le],null,T)),null,_);pe&&(M.push(pe),M.sort(O))}if(M.length===1)return M[0];if(T){for(let q=0;q<M.length;q++)for(let le=q+1;le<M.length;le++)if(M[q].negate().equals(M[le]))return w.INSTANCE;if(M.length===1)return M[0]}return new h(M,$)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const $ of this.expr)N.push(...$.keys());return N}map(N){return new h(this.expr.map($=>$.map(N)),null)}negate(){if(!this.c){const N=[];for(const $ of this.expr)N.push($.negate());this.c=a.create(N,this,!0)}return this.c}}class a{static create(N,$,T){return a.d(N,$,T)}constructor(N,$){this.expr=N,this.c=$,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let $=0,T=this.expr.length;$<T;$++){const M=O(this.expr[$],N.expr[$]);if(M!==0)return M}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let $=0,T=this.expr.length;$<T;$++)if(!this.expr[$].equals(N.expr[$]))return!1;return!0}return!1}substituteConstants(){const N=s(this.expr);return N===this.expr?this:a.create(N,this.c,!1)}evaluate(N){for(let $=0,T=this.expr.length;$<T;$++)if(this.expr[$].evaluate(N))return!0;return!1}static d(N,$,T){let M=[],V=!1;if(N){for(let q=0,le=N.length;q<le;q++){const _=N[q];if(!!_){if(_.type===0){V=!0;continue}if(_.type===1)return m.INSTANCE;if(_.type===9){M=M.concat(_.expr);continue}M.push(_)}}if(M.length===0&&V)return w.INSTANCE;M.sort(O)}if(M.length!==0){if(M.length===1)return M[0];for(let q=1;q<M.length;q++)M[q-1].equals(M[q])&&(M.splice(q,1),q--);if(M.length===1)return M[0];if(T){for(let q=0;q<M.length;q++)for(let le=q+1;le<M.length;le++)if(M[q].negate().equals(M[le]))return m.INSTANCE;if(M.length===1)return M[0]}return new a(M,$)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const $ of this.expr)N.push(...$.keys());return N}map(N){return new a(this.expr.map($=>$.map(N)),null)}negate(){if(!this.c){const N=[];for(const $ of this.expr)N.push($.negate());for(;N.length>1;){const $=N.shift(),T=N.shift(),M=[];for(const V of te($))for(const q of te(T))M.push(h.create([V,q],null,!1));N.unshift(a.create(M,null,!1))}this.c=a.create(N,this,!0)}return this.c}}class c extends b{static all(){return c.d.values()}constructor(N,$,T){super(N,null),this.f=$,typeof T=="object"?c.d.push({...T,key:N}):T!==!0&&c.d.push({key:N,description:T,type:$!=null?typeof $:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return f.create(this.key,N)}notEqualsTo(N){return l.create(this.key,N)}}e.RawContextKey=c,c.d=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService");function g(x,N){return x<N?-1:x>N?1:0}function A(x,N,$,T){return x<$?-1:x>$?1:N<T?-1:N>T?1:0}function F(x,N){if(x.type===0||N.type===1)return!0;if(x.type===9)return N.type===9?j(x.expr,N.expr):!1;if(N.type===9){for(const $ of N.expr)if(F(x,$))return!0;return!1}if(x.type===6){if(N.type===6)return j(N.expr,x.expr);for(const $ of x.expr)if(F($,N))return!0;return!1}return x.equals(N)}e.implies=F;function j(x,N){let $=0,T=0;for(;$<x.length&&T<N.length;){const M=x[$].cmp(N[T]);if(M<0)return!1;M===0&&$++,T++}return $===x.length}function te(x){return x.type===9?x.expr:[x]}}),define(Ie[156],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[89],Ce([1,0,131,3]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function L(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function I(l,v){switch(l){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function R(l,v){return v==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function y(l,v,E){return R(v,E)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===E?!0:k(E).includes(l)}e.isTargetPlatformCompatible=y;function k(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function O(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=O;var w;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var m;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var b;(function(l){l.Install="install",l.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var r;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(r=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(v,E){super(v),this.code=E,this.name=E}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ie[36],Ce([1,0,46,19,10,9,2,133,3,20]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function O(_){return _.create===!0}e.isFileOpenForWriteOptions=O;var w;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(w=e.FileType||(e.FileType={}));var m;(function(_){_[_.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var b;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileClone=32768]="FileClone"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=f;function r(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=r;function o(_){return!!(_.capabilities&32768)}e.hasFileCloneCapability=o;function l(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function v(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=v;function E(_){return f(_)?!!(_.capabilities&16384):!1}e.hasFileAtomicReadCapability=E;var P;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(pe,ue){super(pe),this.code=ue}}e.FileSystemProviderError=p;function n(_,pe){const ue=new p(_.toString(),pe);return t(ue,pe),ue}e.createFileSystemProviderError=n;function d(_){return _||n((0,R.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=d;function t(_,pe){return _.name=pe?`${pe} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=t;function u(_){if(!_)return P.Unknown;if(_ instanceof p)return _.code;const pe=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!pe)return P.Unknown;switch(pe[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=u;function s(_){if(_ instanceof F)return _.fileOperationResult;switch(u(_)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var h;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(h=e.FileOperation||(e.FileOperation={}));class a{constructor(pe,ue,de){this.resource=pe,this.operation=ue,this.target=de}isOperation(pe){return this.operation===pe}}e.FileOperationEvent=a;var c;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class g{constructor(pe,ue){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const de=new Map;for(const re of pe){const G=de.get(re.type);switch(G?G.push([re.resource,re]):de.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,G]of de)switch(re){case 1:this.a=i.TernarySearchTree.forUris(()=>ue),this.a.fill(G);break;case 0:this.b=i.TernarySearchTree.forUris(()=>ue),this.b.fill(G);break;case 2:this.c=i.TernarySearchTree.forUris(()=>ue),this.c.fill(G);break}}contains(pe,...ue){return this.d(pe,{includeChildren:!1},...ue)}affects(pe,...ue){return this.d(pe,{includeChildren:!0},...ue)}d(pe,ue,...de){if(!pe)return!1;const re=de.length>0;return!!((!re||de.includes(1))&&(this.a?.get(pe)||ue.includeChildren&&this.a?.findSuperstr(pe))||(!re||de.includes(0))&&(this.b?.get(pe)||ue.includeChildren&&this.b?.findSuperstr(pe))||(!re||de.includes(2))&&(this.c?.findSubstr(pe)||ue.includeChildren&&this.c?.findSuperstr(pe)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=g;function A(_,pe,ue){return!_||!pe||_===pe||pe.length>_.length?!1:(pe.charAt(pe.length-1)!==C.sep&&(pe+=C.sep),ue?(0,S.startsWithIgnoreCase)(_,pe):_.indexOf(pe)===0)}e.isParent=A;class F extends Error{constructor(pe,ue,de){super(pe),this.fileOperationResult=ue,this.options=de}}e.FileOperationError=F;class j extends F{constructor(pe,ue,de,re){super(pe,ue,re),this.fileOperationResult=ue,this.size=de}}e.TooLargeFileOperationError=j;class te extends F{constructor(pe,ue,de){super(pe,2,de),this.stat=ue}}e.NotModifiedSinceFileOperationError=te;var x;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(x=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(N=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function $(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=$;async function T(_,pe){if(!pe.hasProvider(I.URI.from({scheme:_.scheme})))return new Promise(ue=>{const de=pe.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===_.scheme&&re.added&&(de.dispose(),ue())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(pe){return(0,L.isNumber)(pe)||(pe=0),pe<M.KB?(0,R.localize)(1,null,pe.toFixed(0)):pe<M.MB?(0,R.localize)(2,null,(pe/M.KB).toFixed(2)):pe<M.GB?(0,R.localize)(3,null,(pe/M.MB).toFixed(2)):pe<M.TB?(0,R.localize)(4,null,(pe/M.GB).toFixed(2)):(0,R.localize)(5,null,(pe/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var V;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function q(_){return{maxFileSize:_===0?300*M.MB:16*M.GB,maxHeapSize:_===0?700*M.MB:2*700*M.MB}}e.getPlatformFileLimits=q;function le(_){return k.isWeb?_?10*M.MB:50*M.MB:_?100*M.MB:1024*M.MB}e.getLargeFileConfirmationLimit=le}),define(Ie[67],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...S){this.a=new Map;for(const[L,I]of S)this.set(L,I)}set(S,L){const I=this.a.get(S);return this.a.set(S,L),I}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.ServiceCollection=i}),define(Ie[157],Ce([1,0,12,11,6,88,155,3,67,158]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class w extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class m{constructor(o=new y.ServiceCollection,l=!1,v,E=O){this.f=o,this.g=l,this.h=v,this.i=E,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=E?v?._globalGraph??new I.Graph(P=>P):void 0}createChild(o){return new m(o,this.g,this,this.i)}invokeFunction(o,...l){const v=f.traceInvocation(this.i,o);let E=!1;try{return o({get:p=>{if(E)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(p,v);if(!n)throw new Error(`[invokeFunction] unknown service '${p}'`);return n}},...l)}finally{E=!0,v.stop()}}createInstance(o,...l){let v,E;return o instanceof L.SyncDescriptor?(v=f.traceCreation(this.i,o.ctor),E=this.j(o.ctor,o.staticArguments.concat(l),v)):(v=f.traceCreation(this.i,o),E=this.j(o,l,v)),v.stop(),E}j(o,l=[],v){const E=R._util.getServiceDependencies(o).sort((n,d)=>n.index-d.index),P=[];for(const n of E){const d=this.m(n.id,v);d||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${n.id}.`,!1),P.push(d)}const p=E.length>0?E[0].index:l.length;if(l.length!==p){console.trace(`[createInstance] First service dependency of ${o.name} at position ${p+1} conflicts with ${l.length} static arguments`);const n=p-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,p)}return Reflect.construct(o,l.concat(P))}k(o,l){if(this.f.get(o)instanceof L.SyncDescriptor)this.f.set(o,l);else if(this.h)this.h.k(o,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const l=this.f.get(o);return!l&&this.h?this.h.l(o):l}m(o,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const v=this.l(o);return v instanceof L.SyncDescriptor?this.q(o,v,l.branch(o,!0)):(l.branch(o,!1),v)}q(o,l,v){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,l,v)}finally{this.o.delete(o)}}r(o,l,v){const E=new I.Graph(n=>n.id.toString());let P=0;const p=[{id:o,desc:l,_trace:v}];for(;p.length;){const n=p.pop();if(E.lookupOrInsertNode(n),P++>1e3)throw new w(E);for(const d of R._util.getServiceDependencies(n.desc.ctor)){const t=this.l(d.id);if(t||this.u(`[createInstance] ${o} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(d.id)),t instanceof L.SyncDescriptor){const u={id:d.id,desc:t,_trace:n._trace.branch(d.id,!0)};E.insertEdge(n,u),p.push(u)}}}for(;;){const n=E.roots();if(n.length===0){if(!E.isEmpty())throw new w(E);break}for(const{data:d}of n){if(this.l(d.id)instanceof L.SyncDescriptor){const u=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,u)}E.removeNode(d)}}return this.l(o)}s(o,l,v=[],E,P){if(this.f.get(o)instanceof L.SyncDescriptor)return this.t(o,l,v,E,P);if(this.h)return this.h.s(o,l,v,E,P);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(o,l,v=[],E,P){if(E){const p=new m(void 0,this.g,this,this.i);p.c=String(o);const n=new Map,d=new i.IdleValue(()=>{const t=p.j(l,v,P);for(const[u,s]of n){const h=t[u];if(typeof h=="function")for(const a of s)h.apply(t,a)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,u){if(!d.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let a=n.get(u);return a||(a=new k.LinkedList,n.set(u,a)),(g,A,F)=>{const j=a.push([g,A,F]);return(0,S.toDisposable)(j)}}if(u in t)return t[u];const s=d.value;let h=s[u];return typeof h!="function"||(h=h.bind(s),t[u]=h),h},set(t,u,s){return d.value[u]=s,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,v,P)}u(o,l){if(l&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=m;var b;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(b||(b={}));class f{static traceInvocation(o,l){return o?new f(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(o,l){return o?new f(1,l.name):f.c}constructor(o,l){this.type=o,this.name=l,this.g=Date.now(),this.h=[]}branch(o,l){const v=new f(3,o.toString());return this.h.push([o,l,v]),v}stop(){const o=Date.now()-this.g;f.f+=o;let l=!1;function v(P,p){const n=[],d=new Array(P+1).join("	");for(const[t,u,s]of p.h)if(u&&s){l=!0,n.push(`${d}CREATES -> ${t}`);const h=v(P+1,s);h&&n.push(h)}else n.push(`${d}uses -> ${t}`);return n.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(o>2||l)&&f.all.add(E.join(`
`))}}e.Trace=f,f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0}),define(Ie[13],Ce([1,0,39,4,6,28,20,2,3]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function k(){return new Date().toISOString()}var O;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(O=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=O.Info;function w(h,a,c){switch(a){case O.Trace:h.trace(c);break;case O.Debug:h.debug(c);break;case O.Info:h.info(c);break;case O.Warning:h.warn(c);break;case O.Error:h.error(c);break;case O.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=w;function m(h){let a="";for(let c=0;c<h.length;c++){let g=h[c];if(typeof g=="object")try{g=JSON.stringify(g)}catch{}a+=(c>0?" ":"")+g}return a}e.format=m;class b extends S.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new C.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==O.Off&&this.b<=a}}e.AbstractLogger=b;class f extends b{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...c){this.f(O.Trace)&&this.g(O.Trace,m([a,...c]))}debug(a,...c){this.f(O.Debug)&&this.g(O.Debug,m([a,...c]))}info(a,...c){this.f(O.Info)&&this.g(O.Info,m([a,...c]))}warn(a,...c){this.f(O.Warning)&&this.g(O.Warning,m([a,...c]))}error(a,...c){if(this.f(O.Error))if(a instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=a.stack,this.g(O.Error,m(g))}else this.g(O.Error,m([a,...c]))}flush(){}}e.AbstractMessageLogger=f;class r extends b{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.g=!I.isWindows}trace(a,...c){this.f(O.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,a,...c):console.log(`[main ${k()}]`,a,...c))}debug(a,...c){this.f(O.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,a,...c):console.log(`[main ${k()}]`,a,...c))}info(a,...c){this.f(O.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,a,...c):console.log(`[main ${k()}]`,a,...c))}warn(a,...c){this.f(O.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,a,...c):console.warn(`[main ${k()}]`,a,...c))}error(a,...c){this.f(O.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,a,...c):console.error(`[main ${k()}]`,a,...c))}dispose(){}flush(){}}e.ConsoleMainLogger=r;class o extends b{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...c){this.f(O.Trace)&&console.log("%cTRACE","color: #888",a,...c)}debug(a,...c){this.f(O.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...c)}info(a,...c){this.f(O.Info)&&console.log("%c INFO","color: #33f",a,...c)}warn(a,...c){this.f(O.Warning)&&console.log("%c WARN","color: #993",a,...c)}error(a,...c){this.f(O.Error)&&console.log("%c  ERR","color: #f33",a,...c)}dispose(){}flush(){}}e.ConsoleLogger=o;class l extends b{constructor(a,c=e.DEFAULT_LOG_LEVEL){super(),this.g=a,this.setLevel(c)}trace(a,...c){this.f(O.Trace)&&this.g.log(O.Trace,[this.h(a),...c])}debug(a,...c){this.f(O.Debug)&&this.g.log(O.Debug,[this.h(a),...c])}info(a,...c){this.f(O.Info)&&this.g.log(O.Info,[this.h(a),...c])}warn(a,...c){this.f(O.Warning)&&this.g.log(O.Warning,[this.h(a),...c])}error(a,...c){this.f(O.Error)&&this.g.log(O.Error,[this.h(a),...c])}h(a){return typeof a=="string"?a:(0,i.toErrorMessage)(a,this.f(O.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class v extends b{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const c of this.g)c.setLevel(a);super.setLevel(a)}trace(a,...c){for(const g of this.g)g.trace(a,...c)}debug(a,...c){for(const g of this.g)g.debug(a,...c)}info(a,...c){for(const g of this.g)g.info(a,...c)}warn(a,...c){for(const g of this.g)g.warn(a,...c)}error(a,...c){for(const g of this.g)g.error(a,...c)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.MultiplexLogService=v;class E extends S.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...c){this.b.trace(a,...c)}debug(a,...c){this.b.debug(a,...c)}info(a,...c){this.b.info(a,...c)}warn(a,...c){this.b.warn(a,...c)}error(a,...c){this.b.error(a,...c)}flush(){this.b.flush()}}e.LogService=E;class P extends S.Disposable{constructor(a,c){super(),this.c=a,this.b=new L.ResourceMap,this.B(c(g=>this.setLevel(g)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,c,g){let A=this.b.get(a)?.logger;return A||(g=c?.always?O.Trace:g,A=this.f(a,g??this.c,c),this.b.set(a,{logger:A,logLevel:g})),A}setLevel(a,c){const g=R.URI.isUri(a)?a:void 0,A=g?c:a;if(g){const F=this.b.get(g);F&&F.logLevel!==A&&(F.logLevel=A,F.logger.setLevel(A))}else this.c=A,this.b.forEach(({logLevel:F,logger:j})=>{F===void 0&&j.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=P;class p{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(a){}getLevel(){return O.Info}trace(a,...c){}debug(a,...c){}info(a,...c){}warn(a,...c){}error(a,...c){}critical(a,...c){}dispose(){}flush(){}}e.NullLogger=p;class n extends p{}e.NullLogService=n;class d extends P{constructor(){super(O.Info,C.Event.None)}f(a,c,g){return new p}}e.NullLoggerService=d;function t(h){if(h.verbose)return O.Trace;if(typeof h.logLevel=="string"){const a=s(h.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function u(h){switch(h){case O.Trace:return"trace";case O.Debug:return"debug";case O.Info:return"info";case O.Warning:return"warn";case O.Error:return"error";case O.Off:return"off"}}e.LogLevelToString=u;function s(h){switch(h){case"trace":return O.Trace;case"debug":return O.Debug;case"info":return O.Info;case"warn":return O.Warning;case"error":return O.Error;case"critical":return O.Error;case"off":return O.Off}}e.parseLogLevel=s}),define(Ie[90],Ce([1,0,30,134,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var I;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(f,r){return r-f}y.compare=k;const O=Object.create(null);O[y.Error]=(0,C.localize)(0,null),O[y.Warning]=(0,C.localize)(1,null),O[y.Info]=(0,C.localize)(2,null);function w(f){return O[f]||""}y.toString=w;function m(f){switch(f){case i.default.Error:return y.Error;case i.default.Warning:return y.Warning;case i.default.Info:return y.Info;case i.default.Ignore:return y.Hint}}y.fromSeverity=m;function b(f){switch(f){case y.Error:return i.default.Error;case y.Warning:return i.default.Warning;case y.Info:return i.default.Info;case y.Hint:return i.default.Ignore}}y.toSeverity=b}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(y){const k="";function O(m){return w(m,!0)}y.makeKey=O;function w(m,b){const f=[k];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(k),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(k),m.severity!==void 0&&m.severity!==null?f.push(I.toString(m.severity)):f.push(k),m.message&&b?f.push(m.message.replace("\xA6","\\\xA6")):f.push(k),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(k),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(k),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(k),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}y.makeKeyOptionalMessage=w})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(Ie[159],Ce([1,0,4,30,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,S.createDecorator)("notificationService");var L;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new y,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=R;class y{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=y}),define(Ie[91],Ce([1,0,10,2,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,S.createDecorator)("openerService");function L(k,O){return C.URI.isUri(k)?(0,i.equalsIgnoreCase)(k.scheme,O):(0,i.startsWithIgnoreCase)(k,O+":")}e.matchesScheme=L;function I(k,...O){return O.some(w=>L(k,w))}e.matchesSomeScheme=I;function R(k,O){return k.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=R;function y(k){let O;const w=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return w&&(O={startLineNumber:parseInt(w[1]),startColumn:w[2]?parseInt(w[2]):1,endLineNumber:w[4]?parseInt(w[4]):void 0,endColumn:w[4]?w[5]?parseInt(w[5]):1:void 0},k=k.with({fragment:""})),{selection:O,uri:k}}e.extractSelection=y}),define(Ie[160],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ee,e,i,C){var S=arguments.length,L=S<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,i):C,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ee,e,i,C);else for(var R=ee.length-1;R>=0;R--)(I=ee[R])&&(L=(S<3?I(L):S>3?I(e,i,L):I(e,i))||L);return S>3&&L&&Object.defineProperty(e,i,L),L},Ve=this&&this.__param||function(ee,e){return function(i,C){e(i,C,ee)}};define(Ie[161],Ce([1,0,12,21,6,3]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var I;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}e.Progress=R,R.None=Object.freeze({report(){}});let y=class extends S.Disposable{constructor(w,m){super(),this.a=new i.DeferredPromise,m.withProgress(w,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,S.toDisposable)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};y=qe([Ve(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends S.Disposable{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new S.DisposableStore)}start(w){this.stop();const m=++this.a,b=new C.CancellationTokenSource;return this.f=setTimeout(()=>{m===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,S.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,S.toDisposable)(()=>b.cancel())),this.b.add((0,S.toDisposable)(()=>this.c?this.c.done():void 0)),{id:m,token:b.token,stop:()=>this.h(m),isCurrent:()=>this.a===m}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Ie[29],Ce([1,0,47,9]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.a=new Map}add(I,R){i.ok(C.isString(I)),i.ok(C.isObject(R)),i.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,R)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.Registry=new S}),define(Ie[68],Ce([1,0,4,29]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this.b=new i.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,k){this.a[S(y)]=k,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const I=new L;C.Registry.add(e.Extensions.JSONContribution,I)}),define(Ie[92],Ce([1,0,18,4,9,130,41,68,29]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=y.Registry.as(R.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new C.Emitter,this.onDidSchemaChange=this.i.event,this.j=new C.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(n,d=!0){this.registerConfigurations([n],d)}registerConfigurations(n,d=!0){const t=new Set;this.n(n,d,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const d=new Set;this.o(n,d),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:n,remove:d}){const t=new Set;this.o(d,t),this.n(n,!1,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const d=new Set;this.k(n,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(n,d){const t=[];for(const{overrides:u,source:s}of n)for(const h in u)if(d.add(h),e.OVERRIDE_PROPERTY_REGEX.test(h)){const a=this.a.get(h),c=a?.valuesSources??new Map;if(s)for(const j of Object.keys(u[h]))c.set(j,s);const g={...a?.value||{},...u[h]};this.a.set(h,{source:s,value:g,valuesSources:c});const A=(0,I.getLanguageTagSettingPlainKey)(h),F={type:"object",default:g,description:L.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:S.isString(s)?void 0:s,defaultValueSource:s};t.push(...r(h)),this.d[h]=F,this.b.properties[h]=F}else{this.a.set(h,{value:u[h],source:s});const a=this.d[h];a&&(this.w(h,a),this.r(h,a))}this.m(t)}deregisterDefaultConfigurations(n){const d=new Set;this.l(n,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(n,d){for(const{overrides:t,source:u}of n)for(const s in t){const h=this.a.get(s),a=S.isString(u)?u:u?.id,c=S.isString(h?.source)?h?.source:h?.source?.id;if(a===c)if(d.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const g=this.d[s];g&&(this.w(s,g),this.r(s,g))}}this.u()}deltaConfiguration(n){let d=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),d=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),d=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const d of n)this.h.add(d);this.u()}n(n,d,t){n.forEach(u=>{this.p(u,d,u.extensionInfo,u.restrictedProperties,void 0,t),this.c.push(u),this.q(u)})}o(n,d){const t=u=>{if(u.properties)for(const s in u.properties){d.add(s);const h=this.d[s];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[s],this.s(s,u.properties[s])}u.allOf?.forEach(s=>t(s))};for(const u of n){t(u);const s=this.c.indexOf(u);s!==-1&&this.c.splice(s,1)}}p(n,d=!0,t,u,s=3,h){s=S.isUndefinedOrNull(n.scope)?s:n.scope;const a=n.properties;if(a)for(const g in a){const A=a[g];if(d&&E(g,A)){delete a[g];continue}if(A.source=t,A.defaultDefaultValue=a[g].default,this.w(g,A),e.OVERRIDE_PROPERTY_REGEX.test(g)?A.scope=void 0:(A.scope=S.isUndefinedOrNull(A.scope)?s:A.scope,A.restricted=S.isUndefinedOrNull(A.restricted)?!!u?.includes(g):A.restricted),a[g].hasOwnProperty("included")&&!a[g].included){this.f[g]=a[g],delete a[g];continue}else this.d[g]=a[g],a[g].policy?.name&&this.e.set(a[g].policy.name,g);!a[g].deprecationMessage&&a[g].markdownDeprecationMessage&&(a[g].deprecationMessage=a[g].markdownDeprecationMessage),h.add(g)}const c=n.allOf;if(c)for(const g of c)this.p(g,d,t,u,s,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const d=t=>{const u=t.properties;if(u)for(const h in u)this.r(h,u[h]);t.allOf?.forEach(d)};d(n)}r(n,d){switch(e.allSettings.properties[n]=d,d.scope){case 1:e.applicationSettings.properties[n]=d;break;case 2:e.machineSettings.properties[n]=d;break;case 6:e.machineOverridableSettings.properties[n]=d;break;case 3:e.windowSettings.properties[n]=d;break;case 4:e.resourceSettings.properties[n]=d;break;case 5:e.resourceSettings.properties[n]=d,this.g.properties[n]=d;break}}s(n,d){switch(delete e.allSettings.properties[n],d.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const d=`[${n}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(d,t),e.allSettings.properties[d]=t,e.applicationSettings.properties[d]=t,e.machineSettings.properties[d]=t,e.machineOverridableSettings.properties[d]=t,e.windowSettings.properties[d]=t,e.resourceSettings.properties[d]=t}}v(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}w(n,d){const t=this.a.get(n);let u=t?.value,s=t?.source;S.isUndefined(u)&&(u=d.defaultDefaultValue,s=void 0),S.isUndefined(u)&&(u=l(d.type)),d.default=u,d.defaultValueSource=s}}const b="\\[([^\\]]+)\\]",f=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function r(p){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let d=f.exec(p);for(;d?.length;){const t=d[1].trim();t&&n.push(t),d=f.exec(p)}}return(0,i.distinct)(n)}e.overrideIdentifiersFromKey=r;function o(p){return p.reduce((n,d)=>`${n}[${d}]`,"")}e.keyFromOverrideIdentifiers=o;function l(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const v=new m;y.Registry.add(e.Extensions.Configuration,v);function E(p,n){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?L.localize(7,null,p):v.getConfigurationProperties()[p]!==void 0?L.localize(8,null,p):n.policy?.name&&v.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,p,n.policy?.name,v.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.validateProperty=E;function P(){const p=[],n=v.getConfigurationProperties();for(const d of Object.keys(n))p.push([d,n[d].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=P}),define(Ie[162],Ce([1,0,18,4,110,6,28,22,9,2,41,92,29]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function b(d){return Object.isFrozen(d)?d:R.deepFreeze(d)}class f{constructor(t={},u=[],s=[],h){this.b=t,this.c=u,this.d=s,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(u=>{if(u instanceof f)return u;const s=new r("");return s.parseRaw(u),s.configurationModel});this.f=t.reduce((u,s)=>s===u?s:u.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,O.getConfigurationValue)(this.contents,t):this.contents}inspect(t,u){const s=this.rawConfiguration.getValue(t),h=u?this.rawConfiguration.getOverrideValue(t,u):void 0,a=u?this.rawConfiguration.override(u).getValue(t):s;return{value:s,override:h,merged:a}}getOverrideValue(t,u){const s=this.i(u);return s?t?(0,O.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const u=[];for(const s of this.overrides)s.identifiers.includes(t)&&u.push(...s.keys);return i.distinct(u)}getAllOverrideIdentifiers(){const t=[];for(const u of this.overrides)t.push(...u.identifiers);return i.distinct(t)}override(t){let u=this.a.get(t);return u||(u=this.g(t),this.a.set(t,u)),u}merge(...t){const u=R.deepClone(this.contents),s=R.deepClone(this.overrides),h=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const c of t)if(a.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.h(u,c.contents);for(const g of c.overrides){const[A]=s.filter(F=>i.equals(F.identifiers,g.identifiers));A?(this.h(A.contents,g.contents),A.keys.push(...g.keys),A.keys=i.distinct(A.keys)):s.push(R.deepClone(g))}for(const g of c.keys)h.indexOf(g)===-1&&h.push(g)}return new f(u,h,s,a.every(c=>c instanceof f)?void 0:a)}g(t){const u=this.i(t);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const s={};for(const h of i.distinct([...Object.keys(this.contents),...Object.keys(u)])){let a=this.contents[h];const c=u[h];c&&(typeof a=="object"&&typeof c=="object"?(a=R.deepClone(a),this.h(a,c)):a=c),s[h]=a}return new f(s,this.keys,this.overrides)}h(t,u){for(const s of Object.keys(u)){if(s in t&&y.isObject(t[s])&&y.isObject(u[s])){this.h(t[s],u[s]);continue}t[s]=R.deepClone(u[s])}}i(t){let u=null,s=null;const h=a=>{a&&(s?this.h(s,a):s=R.deepClone(a))};for(const a of this.overrides)i.equals(a.identifiers,[t])?u=a.contents:a.identifiers.includes(t)&&h(a.contents);return h(u),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,u){this.j(t,u,!0)}setValue(t,u){this.j(t,u,!1)}removeValue(t){const u=this.keys.indexOf(t);u!==-1&&(this.keys.splice(u,1),(0,O.removeFromValueTree)(this.contents,t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>i.equals(s.identifiers,(0,w.overrideIdentifiersFromKey)(t))),1))}j(t,u,s){(0,O.addToValueTree)(this.contents,t,u,h=>console.error(h)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,O.toValuesTree)(this.contents[t],h=>console.error(h))})}}e.ConfigurationModel=f;class r{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,u){if(!y.isUndefinedOrNull(t)){const s=this.g(t);this.parseRaw(s,u)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,u){this.a=t;const{contents:s,keys:h,overrides:a,restricted:c,hasExcludedProperties:g}=this.h(t,u);this.b=new f(s,h,a,g?[t]:void 0),this.c=c||[]}g(t){let u={},s=null,h=[];const a=[],c=[];function g(F){Array.isArray(h)?h.push(F):s!==null&&(h[s]=F)}const A={onObjectBegin:()=>{const F={};g(F),a.push(h),h=F,s=null},onObjectProperty:F=>{s=F},onObjectEnd:()=>{h=a.pop()},onArrayBegin:()=>{const F=[];g(F),a.push(h),h=F,s=null},onArrayEnd:()=>{h=a.pop()},onLiteralValue:g,onError:(F,j,te)=>{c.push({error:F,offset:j,length:te})}};if(t)try{S.visit(t,A),u=h[0]||{}}catch(F){console.error(`Error while parsing settings file ${this.f}: ${F}`),this.d=[F]}return u}h(t,u){const s=m.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),h=this.i(t,s,!0,u);t=h.raw;const a=(0,O.toValuesTree)(t,A=>console.error(`Conflict in settings file ${this.f}: ${A}`)),c=Object.keys(t),g=this.j(t,A=>console.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:a,keys:c,overrides:g,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(t,u,s,h){let a=!1;if(!h?.scopes&&!h?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:a};const c={},g=[];for(const A in t)if(w.OVERRIDE_PROPERTY_REGEX.test(A)&&s){const F=this.i(t[A],u,!1,h);c[A]=F.raw,a=a||F.hasExcludedProperties,g.push(...F.restricted)}else{const F=u[A],j=F?typeof F.scope<"u"?F.scope:3:void 0;F?.restricted&&g.push(A),(j===void 0||h.scopes===void 0||h.scopes.includes(j))&&!(h.skipRestricted&&F?.restricted)?c[A]=t[A]:a=!0}return{raw:c,restricted:g,hasExcludedProperties:a}}j(t,u){const s=[];for(const h of Object.keys(t))if(w.OVERRIDE_PROPERTY_REGEX.test(h)){const a={};for(const c in t[h])a[c]=t[h][c];s.push({identifiers:(0,w.overrideIdentifiersFromKey)(h),keys:Object.keys(a),contents:(0,O.toValuesTree)(a,u)})}return s}}e.ConfigurationModelParser=r;class o extends L.Disposable{constructor(t,u,s,h){super(),this.f=t,this.g=u,this.h=h,this.c=this.B(new C.Emitter),this.onDidChange=this.c.event,this.a=new r(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(C.Event.any(C.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),C.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&s.isEqual(a.resource,t)))(()=>this.c.fire()))}async loadConfiguration(){try{const t=await this.h.readFile(this.f);return this.a.parse(t.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new f}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=o;class l{constructor(t,u,s,h,a,c,g,A,F,j,te,x,N){this.a=t,this.b=u,this.c=s,this.overrideIdentifiers=h,this.d=a,this.f=c,this.g=g,this.h=A,this.i=F,this.j=j,this.k=te,this.l=x,this.m=N}get value(){return b(this.c)}n(t,u,s){const h=t.inspect(u,s);return{get value(){return b(h.value)},get override(){return b(h.override)},get merged(){return b(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class v{constructor(t,u,s,h,a=new f,c=new f,g=new I.ResourceMap,A=new f,F=new I.ResourceMap){this.c=t,this.d=u,this.f=s,this.g=h,this.h=a,this.i=c,this.j=g,this.l=A,this.m=F,this.a=null,this.b=new I.ResourceMap,this.n=null}getValue(t,u,s){return this.q(t,u,s).getValue(t)}updateValue(t,u,s={}){let h;s.resource?(h=this.m.get(s.resource),h||(h=new f,this.m.set(s.resource,h))):h=this.l,u===void 0?h.removeValue(t):h.setValue(t,u),s.resource||(this.a=null)}inspect(t,u,s){const h=this.q(t,u,s),a=this.u(u.resource,s),c=u.resource?this.m.get(u.resource)||this.l:this.l,g=new Set;for(const A of h.overrides)for(const F of A.identifiers)h.getOverrideValue(t,F)!==void 0&&g.add(F);return new l(t,u,h.getValue(t),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,a||void 0,c)}keys(t){const u=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,u){this.j.set(t,u),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,u){const s=[];if(!u){const{added:h,updated:a,removed:c}=p(this.c,t);u=[...h,...a,...c]}for(const h of u)for(const a of(0,w.overrideIdentifiersFromKey)(h)){const c=this.c.getKeysForOverrideIdentifier(a),g=t.getKeysForOverrideIdentifier(a),A=[...g.filter(F=>c.indexOf(F)===-1),...c.filter(F=>g.indexOf(F)===-1),...c.filter(F=>!R.equals(this.c.override(a).getValue(F),t.override(a).getValue(F)))];s.push([a,A])}return this.updateDefaultConfiguration(t),{keys:u,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:u,updated:s,removed:h}=p(this.d,t),a=[...u,...s,...h];return a.length&&this.updatePolicyConfiguration(t),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:u,updated:s,removed:h,overrides:a}=p(this.applicationConfiguration,t),c=[...u,...s,...h];return c.length&&this.updateApplicationConfiguration(t),{keys:c,overrides:a}}compareAndUpdateLocalUserConfiguration(t){const{added:u,updated:s,removed:h,overrides:a}=p(this.localUserConfiguration,t),c=[...u,...s,...h];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:u,updated:s,removed:h,overrides:a}=p(this.remoteUserConfiguration,t),c=[...u,...s,...h];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:u,updated:s,removed:h,overrides:a}=p(this.workspaceConfiguration,t),c=[...u,...s,...h];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:a}}compareAndUpdateFolderConfiguration(t,u){const s=this.p.get(t),{added:h,updated:a,removed:c,overrides:g}=p(s,u),A=[...h,...a,...c];return(A.length||!s)&&this.updateFolderConfiguration(t,u),{keys:A,overrides:g}}compareAndDeleteFolderConfiguration(t){const u=this.p.get(t);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:h,removed:a,overrides:c}=p(u,void 0);return{keys:[...s,...h,...a],overrides:c}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,u,s){let h=this.r(u,s);return u.overrideIdentifier&&(h=h.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(h=h.merge(this.d)),h}r({resource:t},u){let s=this.s();if(u&&t){const h=u.getFolder(t);h&&(s=this.t(h.uri)||s);const a=this.m.get(t);a&&(s=s.merge(a))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let u=this.b.get(t);if(!u){const s=this.s(),h=this.j.get(t);h?(u=s.merge(h),this.b.set(t,u)):u=s}return u}u(t,u){if(u&&t){const s=u.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,u)=>{const{contents:s,overrides:h,keys:a}=this.j.get(u);return t.push([u,{contents:s,overrides:h,keys:a}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(u=>t.add(u)),this.userConfiguration.keys.forEach(u=>t.add(u)),this.i.keys.forEach(u=>t.add(u)),this.j.forEach(u=>u.keys.forEach(s=>t.add(s))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>t.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>t.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>t.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}w(t){const u=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>u.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>u.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>u.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(h=>u.add(h))),[...u.values()]}static parse(t){const u=this.x(t.defaults),s=this.x(t.policy),h=this.x(t.application),a=this.x(t.user),c=this.x(t.workspace),g=t.folders.reduce((A,F)=>(A.set(k.URI.revive(F[0]),this.x(F[1])),A),new I.ResourceMap);return new v(u,s,h,a,new f,c,g,new f,new I.ResourceMap)}static x(t){return new f(t.contents,t.keys,t.overrides)}}e.Configuration=v;function E(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const t=new Set,u=new Map;for(const h of d)h.keys.forEach(a=>t.add(a)),h.overrides.forEach(([a,c])=>{const g=(0,I.getOrSet)(u,a,new Set);c.forEach(A=>g.add(A))});const s=[];return u.forEach((h,a)=>s.push([a,[...h.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=E;class P{constructor(t,u,s,h){this.change=t,this.f=u,this.g=s,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of t.keys)this.affectedKeys.add(a);for(const[,a]of t.overrides)for(const c of a)this.affectedKeys.add(c);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=v.parse(this.f.data)),this.i}affectsConfiguration(t,u){const s=this.a+t,h=this.d.indexOf(s);if(h<0)return!1;const a=h+s.length;if(a>=this.d.length)return!1;const c=this.d.charCodeAt(a);if(c!==this.b&&c!==this.c)return!1;if(u){const g=this.previousConfiguration?this.previousConfiguration.getValue(t,u,this.f?.workspace):void 0,A=this.g.getValue(t,u,this.h);return!R.equals(g,A)}return!0}}e.ConfigurationChangeEvent=P;function p(d,t){const{added:u,removed:s,updated:h}=n(t?.rawConfiguration,d?.rawConfiguration),a=[],c=d?.getAllOverrideIdentifiers()||[],g=t?.getAllOverrideIdentifiers()||[];if(t){const A=g.filter(F=>!c.includes(F));for(const F of A)a.push([F,t.getKeysForOverrideIdentifier(F)])}if(d){const A=c.filter(F=>!g.includes(F));for(const F of A)a.push([F,d.getKeysForOverrideIdentifier(F)])}if(t&&d){for(const A of c)if(g.includes(A)){const F=n({contents:d.getOverrideValue(void 0,A)||{},keys:d.getKeysForOverrideIdentifier(A)},{contents:t.getOverrideValue(void 0,A)||{},keys:t.getKeysForOverrideIdentifier(A)});a.push([A,[...F.added,...F.removed,...F.updated]])}}return{added:u,removed:s,updated:h,overrides:a}}function n(d,t){const u=d?t?d.keys.filter(a=>t.keys.indexOf(a)===-1):[...d.keys]:[],s=t?d?t.keys.filter(a=>d.keys.indexOf(a)===-1):[...t.keys]:[],h=[];if(d&&t){for(const a of t.keys)if(d.keys.indexOf(a)!==-1){const c=(0,O.getConfigurationValue)(t.contents,a),g=(0,O.getConfigurationValue)(d.contents,a);R.equals(c,g)||h.push(a)}}return{added:u,removed:s,updated:h}}}),define(Ie[93],Ce([1,0,11,3]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var S;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends i.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof L&&y._code===S.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof L&&y._code===S.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof L&&y._code===S.NoResolverFound}static isHandled(y){return y instanceof L&&y.isHandled}constructor(y,k=S.Unknown,O){super(y),this._message=y,this._code=k,this._detail=O,this.isHandled=k===S.NotAvailable&&O===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L;function I(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}e.getRemoteAuthorityPrefix=I}),define(Ie[48],Ce([1,0,16]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(k){return k.scheme===i.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=C;function S(k){if(!k)return;const O=k.indexOf("+");return O<0?k:k.substr(0,O)}e.getRemoteName=S;function L(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=L;function I(k){const{host:O,port:w}=y(k);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:w}}e.parseAuthorityWithPort=I;function R(k,O){let{host:w,port:m}=y(k);return typeof m>"u"&&(m=O),{host:w,port:m}}e.parseAuthorityWithOptionalPort=R;function y(k){const O=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const w=k.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const m=k.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:k,port:void 0}}}),define(Ie[26],Ce([1,0,10,3,48]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L;function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var y;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(r){this.value=r,this.c=r.toLowerCase()}static equals(r,o){if(typeof r>"u"||r===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof r=="string"||typeof o=="string"){const l=typeof r=="string"?r:r.value,v=typeof o=="string"?o:o.value;return i.equalsIgnoreCase(l,v)}return r.c===o.c}static toKey(r){return typeof r=="string"?r.toLowerCase():r.c}}e.ExtensionIdentifier=k;function O(f){return w(f)}e.isApplicationScopedExtension=O;function w(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function b(f,r){if(r){const o=`onResolveRemoteAuthority:${(0,S.getRemoteName)(r)}`;return f.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[163],Ce([1,0,20,49,2,34]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(k){if(i.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function R(k,O,w,m,b,f,r,o,l,v){const E=Object.create(null);E["common.machineId"]=r,E.sessionID=(0,L.generateUuid)()+Date.now(),E.commitHash=b,E.version=f,E["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,i.PlatformToString)(i.platform),E["common.nodePlatform"]=C.platform,E["common.nodeArch"]=m,E["common.product"]=v||"desktop",o&&(E["common.msftInternal"]=o);let P=0;const p=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),i.isLinuxSnap&&(E["common.snap"]="true");const n=I(w);n&&(E["common.platformDetail"]=n);try{const d=await k.readFile(S.URI.file(l));E["common.source"]=d.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=R;function y(k){const O=C.env.USERDNSDOMAIN;if(!O)return!1;const w=O.toLowerCase();return k.some(m=>w===m)}e.verifyMicrosoftInternalDomain=y}),define(Ie[164],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(C=e.TelemetryLevel||(e.TelemetryLevel={}));var S;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(S=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[50],Ce([1,0,22,9,4,41,48,163,164]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class k{constructor(a){this.value=a}}e.TelemetryTrustedValue=k;class O{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,c){return Promise.resolve(void 0)}publicLog2(a,c){return this.publicLog(a,c)}publicLogError(a,c){return Promise.resolve(void 0)}publicLogError2(a,c){return this.publicLogError(a,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class w{async publicLog(a,c,g){}async publicLogError(a,c,g){}}e.NullEndpointTelemetryService=w,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(h,a){return S.Event.debounce(a.onDidChangeConfiguration,(g,A)=>{const F=g?new Set([...g.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:F}},1e3,!0)(g=>{g.source!==7&&h.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(g.source),configurationKeys:P(g.affectedKeys)})})}e.configurationTelemetry=m;function b(h,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!h.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=b;function f(h,a){return!(a.isBuilt||a.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}e.isLoggingOnly=f;function r(h){const a=h.getValue(y.TELEMETRY_SETTING_ID),c=h.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(h.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=r;function o(h){const a={},c={},g={};E(h,g);for(let A in g){A=A.length>150?A.substr(A.length-149):A;const F=g[A];typeof F=="number"?c[A]=F:typeof F=="boolean"?c[A]=F?1:0:typeof F=="string"?(F.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${F.length}`),a[A]=F.substring(0,8191)):typeof F<"u"&&F!==null&&(a[A]=F)}return{properties:a,measurements:c}}e.validateTelemetryData=o;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function v(h){if(!h)return"none";const a=(0,I.getRemoteName)(h);return l.has(a)?a:"other"}e.cleanRemoteAuthority=v;function E(h,a,c=0,g){if(!!h)for(const A of Object.getOwnPropertyNames(h)){const F=h[A],j=g?g+A:A;Array.isArray(F)?a[j]=(0,i.safeStringify)(F):F instanceof Date?a[j]=F.toISOString():(0,C.isObject)(F)?c<2?E(F,a,c+1,j+"."):a[j]=(0,i.safeStringify)(F):a[j]=F}}function P(h){if(!h)return[];const a=[];return p(a,"",h),a}function p(h,a,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(g=>p(h,a?`${a}.${g}`:g,c[g])):h.push(a)}function n(h,a){const c=h.msftInternalDomains||[],g=a.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(c)||g}e.isInternalTelemetry=n;function d(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.getPiiPathsFromEnvironment=d;function t(h,a){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let c=h;const g=[];for(const te of a)for(;;){const x=te.exec(h);if(!x)break;g.push([x.index,te.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,F=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let j=0;for(c="";;){const te=F.exec(h);if(!te)break;const x=g.some(([N,$])=>te.index<$&&N<F.lastIndex);!A.test(te[0])&&!x&&(c+=h.substring(j,te.index)+"<REDACTED: user-file-path>",j=F.lastIndex)}return j<h.length&&(c+=h.substr(j)),c}function u(h){if(!h)return h;const a=h.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of c)if(g.regex.test(a))return`<REDACTED: ${g.label}>`;return h}function s(h,a){return(0,i.cloneAndChange)(h,c=>{if(c instanceof k)return c.value;if(typeof c=="string"){let g=c.replaceAll("%20"," ");g=t(g,a);for(const A of a)g=g.replace(A,"");return g=u(g),g}})}e.cleanData=s}),define(Ie[165],Ce([1,0,10,89,26,20,2,11,49,50]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(t,u){return t.uuid&&u.uuid?t.uuid===u.uuid:t.id===u.id?!0:(0,i.compareIgnoreCase)(t.id,u.id)===0}e.areSameExtensions=O;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(u){const s=u.manifest?u.manifest.version:u.version,h=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new m(u.identifier,s,h)}static parse(u){const s=w.exec(u);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(u,s,h="undefined"){this.version=s,this.targetPlatform=h,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof m?O(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.ExtensionKey=m;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(t){const u=b.exec(t);return u&&u[1]?[o(u[1]),u[2]]:[o(t),void 0]}e.getIdAndVersion=f;function r(t,u){return`${t}.${u}`}e.getExtensionId=r;function o(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function l(t,u){return o(r(t,u))}e.getGalleryExtensionId=l;function v(t,u){const s=[],h=a=>{for(const c of s)if(c.some(g=>O(u(g),u(a))))return c;return null};for(const a of t){const c=h(a);c?c.push(a):s.push([a])}return s}e.groupByExtension=v;function E(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function P(t){return{id:new k.TelemetryTrustedValue(t.identifier.id),name:new k.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function p(t,u){const s=[],h=u.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const a=h.shift();if(a&&s.every(c=>!O(c.identifier,{id:a}))){const c=t.filter(g=>O(g.identifier,{id:a}));c.length===1&&(s.push(c[0]),h.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=p;async function n(t,u){if(!L.isLinux)return!1;let s;try{s=(await t.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){u.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(a))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=n;async function d(t,u){const s=await n(t,u),h=(0,C.getTargetPlatform)(s?"alpine":L.platform,y.arch);return u.debug("ComputeTargetPlatform:",h),h}e.computeTargetPlatform=d}),define(Ie[166],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(S){this.b=S,this.a=new Map}dispose(){for(const S of this.a.values())S.dispose()}startBuffering(S,L,I=5){const R=L(y=>{const k=typeof y=="string"?y:y.data;let O=this.a.get(S);if(O){O.data.push(k);return}const w=setTimeout(()=>this.flushBuffer(S),I);O={data:[k],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(S),R.dispose()}},this.a.set(S,O)});return R}stopBuffering(S){this.a.get(S)?.dispose()}flushBuffer(S){const L=this.a.get(S);L&&(this.a.delete(S),this.b(S,L.data.join("")))}}e.TerminalDataBufferer=i}),define(Ie[167],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var i;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(i=e.ColorScheme||(e.ColorScheme={}));function C(L){return L===i.HIGH_CONTRAST_DARK||L===i.HIGH_CONTRAST_LIGHT}e.isHighContrast=C;function S(L){return L===i.DARK||L===i.HIGH_CONTRAST_DARK}e.isDark=S}),define(Ie[51],Ce([1,0,65,4,6,3,29,167]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var y;(function(o){function l(v){return v&&typeof v=="object"&&typeof v.id=="string"}o.isThemeColor=l})(y=e.ThemeColor||(e.ThemeColor={}));function k(o){return{id:o}}e.themeColorFromId=k;var O;(function(o){function l(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||y.isThemeColor(u.color))}o.isThemeIcon=l;const v=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function E(u){const s=v.exec(u);if(!s)return;const[,h]=s;return{id:h}}o.fromString=E;function P(u){return{id:u}}o.fromId=P;function p(u,s){let h=u.id;const a=h.lastIndexOf("~");return a!==-1&&(h=h.substring(0,a)),s&&(h=`${h}~${s}`),{id:h}}o.modify=p;function n(u){const s=u.id.lastIndexOf("~");if(s!==-1)return u.id.substring(s+1)}o.getModifier=n;function d(u,s){return u.id===s.id&&u.color?.id===s.color?.id}o.isEqual=d;function t(u,s){return{id:u.id,color:s?k(s):void 0}}o.asThemeIcon=t,o.asClassNameArray=i.CSSIcon.asClassNameArray,o.asClassName=i.CSSIcon.asClassName,o.asCSSSelector=i.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function w(o){switch(o){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case R.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.a=[],this.a=[],this.b=new C.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,S.toDisposable)(()=>{const v=this.a.indexOf(l);this.a.splice(v,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const b=new m;I.Registry.add(e.Extensions.ThemingContribution,b);function f(o){return b.onColorThemeChange(o)}e.registerThemingParticipant=f;class r extends S.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(v=>this.n(v)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,v){let E=this.h.getColor(l);return E&&v&&(E=v(E,this.h)),E?E.toString():null}}e.Themable=r}),define(Ie[168],Ce([1,0,12,65,4,9,2,135,68,29,51]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var w;(function(P){function p(n,d){let t=n.defaults;for(;O.ThemeIcon.isThemeIcon(t);){const u=f.getIcon(t.id);if(!u)return;t=u.defaults}return t}P.getDefinition=p})(w=e.IconContribution||(e.IconContribution={}));var m;(function(P){function p(d){return{weight:d.weight,style:d.style,src:d.src.map(t=>({format:t.format,location:t.location.toString()}))}}P.toJSONObject=p;function n(d){const t=u=>(0,L.isString)(u)?u:void 0;if(d&&Array.isArray(d.src)&&d.src.every(u=>(0,L.isString)(u.format)&&(0,L.isString)(u.location)))return{weight:t(d.weight),style:t(d.style),src:d.src.map(u=>({format:u.format,location:I.URI.parse(u.location)}))}}P.fromJSONObject=n})(m=e.IconFontDefinition||(e.IconFontDefinition={}));class b{constructor(){this.a=new S.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,R.localize)(0,null)},fontCharacter:{type:"string",description:(0,R.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,n,d,t){const u=this.b[p];if(u){if(d&&!u.description){u.description=d,this.d.properties[p].markdownDescription=`${d} $(${p})`;const a=this.e.enum.indexOf(p);a!==-1&&(this.e.enumDescriptions[a]=d),this.a.fire()}return u}const s={id:p,description:d,defaults:n,deprecationMessage:t};this.b[p]=s;const h={$ref:"#/definitions/icons"};return t&&(h.deprecationMessage=t),d&&(h.markdownDescription=`${d}: $(${p})`),this.d.properties[p]=h,this.e.enum.push(p),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const n=this.e.enum.indexOf(p);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,n){const d=this.f[p];return d||(this.f[p]=n,this.a.fire(),n)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(u,s)=>u.id.localeCompare(s.id),n=u=>{for(;O.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const t=Object.keys(this.b).map(u=>this.b[u]);for(const u of t.filter(s=>!!s.description).sort(p))d.push(`|<i class="${n(u)}"></i>|${u.id}|${O.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const u of t.filter(s=>!O.ThemeIcon.isThemeIcon(s.defaults)).sort(p))d.push(`|<i class="${n(u)}"></i>|${u.id}|`);return d.join(`
`)}}const f=new b;k.Registry.add(e.Extensions.IconContribution,f);function r(P,p,n,d){return f.registerIcon(P,p,n,d)}e.registerIcon=r;function o(){return f}e.getIconRegistry=o;function l(){for(const P of C.Codicon.getAll())f.registerIcon(P.id,P.definition,P.description)}l(),e.iconsSchemaId="vscode://schemas/icons";const v=k.Registry.as(y.Extensions.JSONContribution);v.registerSchema(e.iconsSchemaId,f.getIconSchema());const E=new i.RunOnceScheduler(()=>v.notifySchemaChanged(e.iconsSchemaId),200);f.onDidChange(()=>{E.isScheduled()||E.schedule()}),e.widgetClose=r("widget-close",C.Codicon.close,(0,R.localize)(2,null)),e.gotoPreviousLocation=r("goto-previous-location",C.Codicon.arrowUp,(0,R.localize)(3,null)),e.gotoNextLocation=r("goto-next-location",C.Codicon.arrowDown,(0,R.localize)(4,null)),e.syncing=O.ThemeIcon.modify(C.Codicon.sync,"spin"),e.spinningLoading=O.ThemeIcon.modify(C.Codicon.loading,"spin")}),define(Ie[169],Ce([1,0,4,41,3,13]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,S.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,S.createDecorator)("sharedTunnelsService");var I;(function(r){r.Http="http",r.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(r){return e.LOCALHOST_ADDRESSES.indexOf(r)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(r){return e.ALL_INTERFACES_ADDRESSES.indexOf(r)>=0}e.isAllInterfaces=w;function m(r,o,l,v){if(l===1)return!1;if(l===2&&w(o)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(E?.length===4&&parseInt(E[1])>=18)return!1}return r<1024}e.isPortPrivileged=m;class b{constructor(o,l,v){this.remoteAddress=o,this.localAddress=l,this.b=v,this.a=new i.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=b;let f=class{constructor(o,l){this.i=o,this.j=l,this.a=new i.Emitter,this.onTunnelOpened=this.a.event,this.b=new i.Emitter,this.onTunnelClosed=this.b.event,this.c=new i.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],l=Array.from(this.d.values());for(const v of l){const E=Array.from(v.values());for(const P of E){const p=await P.value;p&&o.push(p)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:l}of o.values())await l.then(v=>v?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,l,v,E,P){this.o(o,l,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:l,localAddress:v,privacy:E,protocol:P,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,l){(w(o)||O(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const v=this.q(o,l);if(v)return++v.refcount,v.value}openTunnel(o,l,v,E,P=!1,p,n){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${v} on local port ${E}.`),!o)return;if(l||(l="localhost"),this.e&&this.h.has(v)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.r(o,l,v,E,P,p,n);return d?d.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,v);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(t);return(t.tunnelRemoteHost!==l||t.tunnelRemotePort!==v)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const l=this.d.get(o.tunnelRemoteHost);if(l){const v=l.get(o.tunnelRemotePort);v&&(v.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,v))}}}}async n(o,l,v){if(v.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${l}.`);const E=v.value.then(async P=>{P&&(await P.dispose(!0),this.b.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(l),E}}async closeTunnel(o,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${l} `);const v=this.d.get(o);if(v&&v.has(l)){const E=v.get(l);E.refcount=0,await this.n(o,l,E)}}o(o,l,v){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(l,{refcount:1,value:v})}async p(o,l){const v=this.d.get(o);v&&(await v.get(l)||v.delete(l),v.size===0&&this.d.delete(o))}q(o,l){const v=[o];O(o)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):w(o)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const E=v.map(P=>this.d.get(P));for(const P of E){const p=P?.get(l);if(p)return p}}canTunnel(o){return!!k(o)}s(o,l,v,E,P,p,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${v} on local port ${E}.`);const d=v;this.h.add(d);const t=E===void 0?v:E,u={elevationRequired:P?this.isPortPrivileged(t):!1},s={remoteAddress:{host:l,port:v},localAddressPort:E,privacy:p,public:p?p!==R.Private:void 0,protocol:n},h=o.forwardPort(s,u);return h?(this.o(l,v,h),h.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(d)})):this.h.delete(d),h}};f=qe([Ve(0,L.ILogService),Ve(1,C.IConfigurationService)],f),e.AbstractTunnelService=f}),define(Ie[170],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var C;(function(S){S[S.Complete=100]="Complete",S[S.Partial=50]="Partial",S[S.None=0]="None"})(C=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ie[171],Ce([1,0,16]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(y){return y.scheme!==i.Schemas.file&&y.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=C;function S(y){if(y.folders.length)return y.folders.every(k=>C(k.uri))?y.folders[0].uri:void 0;if(y.configuration&&C(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=S;function L(y){return S(y)?.scheme}e.getVirtualWorkspaceScheme=L;function I(y){return S(y)?.authority}e.getVirtualWorkspaceAuthority=I;function R(y){return S(y)!==void 0}e.isVirtualWorkspace=R}),define(Ie[52],Ce([1,0,136,19,46,23,2,3,16]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function k(t){const u=t;return typeof u?.id=="string"&&I.URI.isUri(u.uri)}e.isSingleFolderWorkspaceIdentifier=k;function O(t){return typeof t?.id=="string"&&!k(t)&&!m(t)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(t,u){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,C.basename)(t)}:u?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=t;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=w;function m(t){const u=t;return typeof u?.id=="string"&&I.URI.isUri(u.configPath)}e.isWorkspaceIdentifier=m;function b(t){const u=t;if(u?.uri)return{id:u.id,uri:I.URI.revive(u.uri)};const s=t;if(s?.configPath)return{id:s.id,configPath:I.URI.revive(s.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=b;var f;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function r(t){const u=t;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=r;function o(t){const u=t;return!!(u&&typeof u=="object"&&I.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=o;class l{constructor(u,s,h,a,c){this.h=u,this.j=h,this.k=a,this.l=c,this.c=S.TernarySearchTree.forUris(this.l,()=>!0),this.folders=s}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=S.TernarySearchTree.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class v{constructor(u,s){this.raw=s,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,L.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function E(t){return new v({uri:t,index:0,name:(0,L.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P(t,u){return L.extUriBiasedIgnorePathCase.isEqualOrParent(t,u.untitledWorkspacesHome)}e.isUntitledWorkspace=P;function p(t){let u;return I.URI.isUri(t)?u=t:u=t.configuration,u?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=p;function n(t,u){return!P(t,u)&&!p(t)}e.isSavedWorkspace=n;function d(t){return(typeof t=="string"?(0,C.extname)(t):(0,L.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=d}),define(Ie[53],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(S){this.d=S,this.b=new Map,this.c=1}add(S){const L=this.c++;return this.b.set(L,S),this.e(),L}get(S,L){return this.b.has(S)?this.b.get(S)[L]:void 0}delete(S){this.b.delete(S),this.e()}e(){!i.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=i,i.a=!1}),define(Ie[37],Ce([1,0,16,23,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this.a=new Set(Object.keys(i.Schemas)),this.b=new Map,this.extUri=new C.ExtUri(R=>{const y=this.b.get(R.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(R,y){y===null?this.b.delete(R.scheme):this.b.set(R.scheme,y)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(Ie[172],Ce([1,0,12]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(I,R,y){this.h=new Map,this.a=I,this.b=R,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new i.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of k.values())O.complete()}catch(O){for(const w of k.values())w.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this.d}get(I,R){let y=this.f[I];return typeof y>"u"&&(y=R),y}update(I,R){this.f[I]=R;const y=this.h.get(I);if(y!==void 0)return y.p;const k=new i.DeferredPromise;return this.h.set(I,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=C;class S extends C{setKeysForSync(I){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},I)}constructor(I,R){super(I.identifier.value,!0,R),this.j=I}}e.ExtensionGlobalMemento=S}),define(Ie[173],Ce([1,0,4,2]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class S{constructor(I){this.c=I,this.a=new i.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new i.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(I,R,y,k){const w=this.c.getNotebookDocument(C.URI.revive(I)).acceptModelChanged(R.value,y,k);this.b.fire(w)}$acceptDirtyStateChanged(I,R){this.c.getNotebookDocument(C.URI.revive(I)).acceptDirty(R)}$acceptModelSaved(I){const R=this.c.getNotebookDocument(C.URI.revive(I));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=S}),define(Ie[17],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class C{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=C});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[174],Ce([1,0,26,4]),function(ee,e,i,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(R,y){S.set(this,void 0),this.b=new C.Emitter,this.onDidChange=this.b.event,this.a=i.ExtensionIdentifier.toKey(R.identifier),Je(this,S,y,"f"),Oe(this,S,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(R){return Oe(this,S,"f").get(this.a,R)}store(R,y){return Oe(this,S,"f").store(this.a,R,y)}delete(R){return Oe(this,S,"f").delete(this.a,R)}}e.ExtensionSecrets=L,S=new WeakMap}),define(Ie[69],Ce([1,0,3,169,4,17]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(y){function k(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:w.protocol}}y.fromApiTunnel=k;function O(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==C.TunnelPrivacyId.ConstantPrivate&&w.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}y.fromServiceTunnel=O})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let R=class{constructor(k){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,O){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,O){return{dispose:()=>{}}}async $providePortAttributes(k,O,w,m,b){return[]}async $forwardPort(k,O){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=qe([Ve(0,L.IExtHostRpcService)],R),e.ExtHostTunnelService=R}),define(Ie[54],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class C{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=C}),define(Ie[175],Ce([1,0,25]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function S(R,y){if(y.serializeBuffersForPostMessage){const k=new C,O=(b,f)=>{if(f instanceof ArrayBuffer){const r=k.add(f);return{$$vscode_array_buffer_reference$$:!0,index:r}}else if(ArrayBuffer.isView(f)){const r=L(f);if(r){const o=k.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:r,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},w=JSON.stringify(R,O),m=k.buffers.map(b=>{const f=new Uint8Array(b);return i.VSBuffer.wrap(f)});return{message:w,buffers:m}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=S;function L(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(R,y){const k=y.map(m=>{const b=new ArrayBuffer(m.byteLength);return new Uint8Array(b).set(m.buffer),b}),O=y.length?(m,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const f=b,{index:r}=f,o=k[r];if(f.view)switch(f.view.type){case 1:return new Int8Array(o,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return b}:void 0;return{message:JSON.parse(R,O),arrayBuffers:k}}e.deserializeWebviewMessage=I}),define(Ie[94],Ce([1,0,144,9,2,6,3,29,36,16,39,121,30]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var f;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(f=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function r(G){const H=G;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}e.isEditorPaneWithSelection=r;function o(G,H,oe){for(const ve of oe.visibleEditorPanes)if(ve.group.id===H&&G.matches(ve.input))return ve.getViewState()}e.findViewStateForEditor=o;function l(G){if(c(G))return!1;const H=G;return S.URI.isUri(H?.resource)}e.isResourceEditorInput=l;function v(G){if(c(G))return!1;const H=G;return H?.original!==void 0&&H.modified!==void 0}e.isResourceDiffEditorInput=v;function E(G){if(c(G)||v(G))return!1;const H=G;return H?.primary!==void 0&&H.secondary!==void 0}e.isResourceSideBySideEditorInput=E;function P(G){if(c(G))return!1;const H=G;return H?H.resource===void 0||H.resource.scheme===k.Schemas.untitled||H.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=P;const p=/Untitled-\d+/;function n(G){return G.scheme===k.Schemas.untitled&&G.path.length>1&&!p.test(G.path)}e.isUntitledWithAssociatedResource=n;function d(G){if(c(G))return!1;const H=G;return S.URI.isUri(H?.base?.resource)&&S.URI.isUri(H?.input1?.resource)&&S.URI.isUri(H?.input2?.resource)&&S.URI.isUri(H?.result?.resource)}e.isResourceMergeEditorInput=d;var t;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(t=e.Verbosity||(e.Verbosity={}));var u;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u=e.SaveReason||(e.SaveReason={}));class s{constructor(){this.a=new Map}registerSource(H,oe){let ve=this.a.get(H);return ve||(ve={source:H,label:oe},this.a.set(H,ve)),ve.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.SaveSourceRegistry=new s;var h;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(h=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends L.Disposable{}e.AbstractEditorInput=a;function c(G){return G instanceof a}e.isEditorInput=c;function g(G){const H=G;return S.URI.isUri(H?.preferredResource)}function A(G){const H=G;return c(H?.primary)&&c(H?.secondary)}e.isSideBySideEditorInput=A;function F(G){const H=G;return c(H?.modified)&&c(H?.original)}e.isDiffEditorInput=F;function j(G,H,oe,ve,Ae){return re(ve,[(0,w.toAction)({id:"workbench.action.openLargeFile",label:(0,i.localize)(2,null),run:()=>{const Be={...oe,limits:{size:Number.MAX_VALUE}};G.openEditor(H,Be)}}),(0,w.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,i.localize)(3,null),run:()=>Ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.createTooLargeFileError=j;function te(G){return c(G?.editor)}e.isEditorInputWithOptions=te;function x(G){const H=G;return te(G)&&H?.group!==void 0}e.isEditorInputWithOptionsAndGroup=x;function N(G){const H=G;return typeof H?.groupId=="number"&&c(H.editor)}e.isEditorIdentifier=N;var $;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})($=e.EditorCloseContext||(e.EditorCloseContext={}));var T;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(T=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var M;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(M=e.SideBySideEditor||(e.SideBySideEditor={}));class V{getOriginalUri(H,oe){if(!H)return;if(d(H))return e.EditorResourceAccessor.getOriginalUri(H.result,oe);if(oe?.supportSideBySide){const{primary:Ae,secondary:Be}=this.a(H);if(Ae&&Be){if(oe?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(Ae,{filterByScheme:oe.filterByScheme}),secondary:this.getOriginalUri(Be,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===M.ANY)return this.getOriginalUri(Ae,{filterByScheme:oe.filterByScheme})??this.getOriginalUri(Be,{filterByScheme:oe.filterByScheme});H=oe.supportSideBySide===M.PRIMARY?Ae:Be}}if(v(H)||E(H)||d(H))return;const ve=g(H)?H.preferredResource:H.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}a(H){return A(H)||E(H)?{primary:H.primary,secondary:H.secondary}:F(H)||v(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,oe){if(!H)return;if(d(H))return e.EditorResourceAccessor.getCanonicalUri(H.result,oe);if(oe?.supportSideBySide){const{primary:Ae,secondary:Be}=this.a(H);if(Ae&&Be){if(oe?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(Ae,{filterByScheme:oe.filterByScheme}),secondary:this.getCanonicalUri(Be,{filterByScheme:oe.filterByScheme})};if(oe?.supportSideBySide===M.ANY)return this.getCanonicalUri(Ae,{filterByScheme:oe.filterByScheme})??this.getCanonicalUri(Be,{filterByScheme:oe.filterByScheme});H=oe.supportSideBySide===M.PRIMARY?Ae:Be}}if(v(H)||E(H)||d(H))return;const ve=H.resource;return!ve||!oe||!oe.filterByScheme?ve:this.b(ve,oe.filterByScheme)}b(H,oe){if(Array.isArray(oe)){if(oe.some(ve=>H.scheme===ve))return H}else if(oe===H.scheme)return H}}e.EditorResourceAccessor=new V;var q;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(q=e.CloseDirection||(e.CloseDirection={}));class le{constructor(){this.c=new Map,this.d=new Map}start(H){const oe=this.a=H.get(I.IInstantiationService);for(const[ve,Ae]of this.c)this.e(ve,Ae,oe);this.c.clear()}e(H,oe,ve){const Ae=ve.createInstance(oe);this.d.set(H,Ae)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,C.assertIsDefined)(this.b)}registerEditorSerializer(H,oe){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,oe,this.a):this.c.set(H,oe),(0,L.toDisposable)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new le);async function _(G,H,oe){return!G||!G.length?[]:await Promise.all(G.map(async ve=>{const Ae=S.URI.revive(ve.fileUri);if(!Ae){oe.info("Cannot resolve the path because it is not valid.",ve);return}if(!await H.canHandleResource(Ae)){oe.info("Cannot resolve the path because it cannot be handled",ve);return}let xe=ve.exists,Te=ve.type;if(typeof xe!="boolean"||typeof Te!="number")try{Te=(await H.stat(Ae)).isDirectory?y.FileType.Directory:y.FileType.Unknown,xe=!0}catch(ke){oe.error(ke),xe=!1}if(!xe&&ve.openOnlyIfExists){oe.info("Cannot resolve the path because it does not exist",ve);return}if(Te===y.FileType.Directory){oe.info("Cannot resolve the path because it is a directory",ve);return}const Se={...ve.options,pinned:!0};return xe?{resource:Ae,options:Se}:{resource:Ae,options:Se,forceUntitled:!0}}))}e.pathsToEditors=_;var pe;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(pe=e.EditorsOrder||(e.EditorsOrder={}));function ue(G){const H=G;if(!H)return!1;const oe=H;if(oe.modified)return ue(oe.modified);const ve=H;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}e.isTextEditorViewState=ue;function de(G){return(0,O.isErrorWithActions)(G)}e.isEditorOpenError=de;function re(G,H,oe){const ve=(0,O.createErrorWithActions)(G,H);return ve.forceMessage=oe?.forceMessage,ve.forceSeverity=oe?.forceSeverity,ve.allowDialog=oe?.allowDialog,ve}e.createEditorOpenError=re}),define(Ie[176],Ce([1,0,4,145,3,6,28,29,18,62,22,65,168]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",w.Codicon.window,(0,C.localize)(0,null));var b;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(b=e.Extensions||(e.Extensions={}));var f;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(f=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function r(t){switch(t){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=r;class o extends L.Disposable{constructor(){super(...arguments),this.c=this.B(new i.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new i.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(u,s,h){const a=this.get(u.id);if(a)return a;const c=u;return c.openCommandActionDescriptor=h?.doNotRegisterOpenCommand?void 0:c.openCommandActionDescriptor??{id:c.id},(0,I.getOrSet)(this.g,s,[]).push(c),h?.isDefault&&this.h.push(c),this.c.fire({viewContainer:c,viewContainerLocation:s}),c}deregisterViewContainer(u){for(const s of this.g.keys()){const h=this.g.get(s),a=h?.indexOf(u);if(a!==-1){h?.splice(a,1),h.length===0&&this.g.delete(s),this.f.fire({viewContainer:u,viewContainerLocation:s});return}}}get(u){return this.all.filter(s=>s.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(s=>this.getViewContainers(s).filter(h=>h?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(s=>this.getViewContainerLocation(s)===u)}}R.Registry.add(b.ViewContainersRegistry,new o);var l;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function v(t,u){const s=t.group??l.More,h=u.group??l.More;return s!==h?s.localeCompare(h):(t.order??5)-(u.order??5)}class E extends L.Disposable{constructor(){super(...arguments),this.c=this.B(new i.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new i.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new i.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new i.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new k.SetMap}registerViews(u,s){this.registerViews2([{views:u,viewContainer:s}])}registerViews2(u){u.forEach(({views:s,viewContainer:h})=>this.l(s,h)),this.c.fire(u)}deregisterViews(u,s){const h=this.m(u,s);h.length&&this.f.fire({views:h,viewContainer:s})}moveViews(u,s){for(const h of this.j.keys())if(h!==s){const a=this.m(u,h);a.length&&(this.l(a,s),this.g.fire({views:a,from:h,to:s}))}}getViews(u){return this.j.get(u)||[]}getView(u){for(const s of this.i){const h=(this.j.get(s)||[]).filter(a=>a.id===u)[0];if(h)return h}return null}getViewContainer(u){for(const s of this.i)if((this.j.get(s)||[]).filter(a=>a.id===u)[0])return s;return null}registerViewWelcomeContent(u,s){return this.k.add(u,s),this.h.fire(u),(0,L.toDisposable)(()=>{this.k.delete(u,s),this.h.fire(u)})}registerViewWelcomeContent2(u,s){const h=new Map;for(const[a,c]of s)this.k.add(u,c),h.set(a,(0,L.toDisposable)(()=>{this.k.delete(u,c),this.h.fire(u)}));return this.h.fire(u),h}getViewWelcomeContent(u){const s=[];return this.k.forEach(u,h=>s.push(h)),s.sort(v)}l(u,s){let h=this.j.get(s);h||(h=[],this.j.set(s,h),this.i.push(s));for(const a of u){if(this.getView(a.id)!==null)throw new Error((0,C.localize)(1,null,a.id));h.push(a)}}m(u,s){const h=this.j.get(s);if(!h)return[];const a=[],c=[];for(const g of h)u.includes(g)?a.push(g):c.push(g);return a.length&&(c.length?this.j.set(s,c):(this.j.delete(s),this.i.splice(this.i.indexOf(s),1))),a}}R.Registry.add(b.ViewsRegistry,new E),e.IViewsService=(0,S.createDecorator)("viewsService"),e.IViewDescriptorService=(0,S.createDecorator)("viewDescriptorService");var P;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(P=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(u,s){this.c=!1,this.d=!1,(0,O.mixin)(this,u),this.d=!!s,this.resolve=async h=>{if(s&&!this.c){const a=await s(h);a&&(this.tooltip=this.tooltip??a.tooltip,this.command=this.command??a.command)}h.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n;class d extends Error{constructor(u){super((0,C.localize)(2,null,u))}}e.NoTreeViewError=d}),define(Ie[177],Ce([1,0,4,12,146]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new i.Emitter,this.n=new i.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,y,k,O){const w={command:R};if(y&&Object.keys(y).length>0&&(w.arguments=y),this.s("request",w),typeof O=="number"){const m=setTimeout(()=>{clearTimeout(m);const b=this.f.get(w.seq);if(b){this.f.delete(w.seq);const f={type:"response",seq:0,request_seq:w.seq,success:!1,command:R,message:(0,S.localize)(0,null,O,R)};b(f)}},O)}return k&&this.f.set(w.seq,k),w.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,y){return R.type!=="event"||y.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,C.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const y=R,k=this.f.get(y.request_seq);k&&(this.f.delete(y.request_seq),k(y));break}}}}s(R,y){y.type=R,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((y,k)=>R.set(k,y)),await(0,C.timeout)(500),R.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=L}),define(Ie[178],Ce([1,0,147,42,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new C.RawContextKey("hasDebugged",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(50,null)});const L=m=>i.localize(51,null,m);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(52,null)};var I;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(I=e.State||(e.State={}));function R(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var y;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,S.createDecorator)("debugService");var w;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(w=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[179],Ce([1,0,10,2,19,22,16]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function y(t,u,s){return t.replace(R,function(h,a){return u&&a.length>0&&a[0]!=="_"?h:s&&s.hasOwnProperty(a)?s[a]:h})}e.formatPII=y;function k(t){const u={};for(const s of Object.keys(t))s.startsWith("!")||(u[s]=t[s]);return u}e.filterExceptionsFromTelemetry=k;function O(t){return t.configuration.request==="attach"&&!w(t)&&(!t.parentSession||O(t.parentSession))}e.isSessionAttach=O;function w(t){let u=t.configuration.type;if(!!u)return u==="vslsShare"&&(u=t.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(u,"extensionhost")||(0,i.equalsIgnoreCase)(u,"pwa-extensionhost")?t:t.parentSession?w(t.parentSession):void 0}e.getExtensionHostDebugSession=w;function m(t){return t.type&&(t.label||t.program||t.runtime)}e.isDebuggerMainContribution=m;function b(t,u,s){let h,a=0;const c=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=c.exec(t);){const A=g.index+1,F=A+g[0].length;if(A<=u&&F>=s){h=g[0],a=A;break}}if(h){const A=/\w+/g;let F=null;for(;(F=A.exec(h))&&!(F.index+1+a+F[0].length>=s););F&&(h=h.substring(0,A.lastIndex))}return h?{start:a,end:a+h.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(t){return!!(t&&t.match(f))}e.isUri=r;function o(t){if(typeof t.path=="string"&&!(typeof t.sourceReference=="number"&&t.sourceReference>0)){if(r(t.path))return C.URI.parse(t.path);if((0,S.isAbsolute)(t.path))return C.URI.file(t.path)}return t.path}function l(t){if(typeof t.path=="object"){const u=C.URI.revive(t.path);if(u)return u.scheme===I.Schemas.file?u.fsPath:u.toString()}return t.path}function v(t,u){const s=u?o:l,h=(0,L.deepClone)(t);return P(h,(a,c)=>{a&&c&&(c.path=s(c))}),h}e.convertToDAPaths=v;function E(t,u){const s=u?o:l,h=(0,L.deepClone)(t);return P(h,(a,c)=>{!a&&c&&(c.path=s(c))}),h}e.convertToVSCPaths=E;function P(t,u){switch(t.type){case"event":{const s=t;switch(s.event){case"output":u(!1,s.body.source);break;case"loadedSource":u(!1,s.body.source);break;case"breakpoint":u(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=t;switch(s.command){case"setBreakpoints":u(!0,s.arguments.source);break;case"breakpointLocations":u(!0,s.arguments.source);break;case"source":u(!0,s.arguments.source);break;case"gotoTargets":u(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(h=>u(!1,h));break;default:break}break}case"response":{const s=t;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(h=>u(!1,h.source));break;case"loadedSources":s.body.sources.forEach(h=>u(!1,h));break;case"scopes":s.body.scopes.forEach(h=>u(!1,h.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(h=>u(!1,h.source));break;case"setBreakpoints":s.body.breakpoints.forEach(h=>u(!1,h.source));break;case"disassemble":s.body?.instructions.forEach(a=>u(!1,a.location));break;default:break}break}}}function p(t){return t.filter(u=>!u.presentation?.hidden).sort((u,s)=>u.presentation?s.presentation?u.presentation.group?s.presentation.group?u.presentation.group!==s.presentation.group?u.presentation.group.localeCompare(s.presentation.group):n(u.presentation.order,s.presentation.order):-1:s.presentation.group?1:n(u.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=p;function n(t,u){return typeof t!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:t-u}async function d(t,u){const s=t.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(s!=="none"&&(await u.saveAll(),s==="allEditorsInActiveGroup")){const h=u.activeEditorPane;h&&h.input.resource?.scheme===I.Schemas.untitled&&await u.save({editor:h.input,groupId:h.group.id})}await t.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(Ie[70],Ce([1,0,25,35,180,64,16,19,20,42]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var r;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(r=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var v;(function(M){M.scheme=I.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],q=new RegExp(`^[${V.join("")}]+`),le=7;function _(H,oe){const ve=oe.toString(le),Be=`${ve.length<V.length?V[ve.length-1]:"z"}${ve}s${(0,i.encodeBase64)(i.VSBuffer.fromString(H.scheme),!0,!0)}`;return H.with({scheme:M.scheme,fragment:Be})}M.generate=_;function pe(H){if(H.scheme!==M.scheme)return;const oe=H.fragment.indexOf("s");if(oe<0)return;const ve=parseInt(H.fragment.substring(0,oe).replace(q,""),le),Ae=(0,i.decodeBase64)(H.fragment.substring(oe+1)).toString();if(!isNaN(ve))return{handle:ve,notebook:H.with({scheme:Ae,fragment:null})}}M.parse=pe;function ue(H,oe){return H.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${oe??""},${H.scheme!==I.Schemas.file?H.scheme:""}`})}M.generateCellOutputUri=ue;function de(H){if(H.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const oe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!oe)return;const ve=oe[1]&&oe[1]!==""?oe[1]:void 0,Ae=oe[2];return{outputId:ve,notebook:H.with({scheme:Ae||I.Schemas.file,fragment:null})}}M.parseCellOutputUri=de;function re(H,oe,ve){return M.generate(H,oe).with({scheme:ve})}M.generateCellPropertyUri=re;function G(H,oe){if(H.scheme===oe)return M.parse(H.with({scheme:M.scheme}))}M.parseCellPropertyUri=G})(v=e.CellUri||(e.CellUri={}));const E=M=>y.isWindows?M.replace(/\//g,"\\"):M;class P{constructor(V=[],q=e.NOTEBOOK_DISPLAY_ORDER){this.e=q,this.d=[...new Set(V)].map(le=>({pattern:le,matches:C.parse(E(le))}))}sort(V){const q=new Map(S.Iterable.map(V,_=>[_,E(_)]));let le=[];for(const{matches:_}of this.d)for(const[pe,ue]of q)if(_(ue)){le.push(pe),q.delete(pe);break}return q.size&&(le=le.concat([...q.keys()].sort((_,pe)=>this.e.indexOf(_)-this.e.indexOf(pe)))),le}prioritize(V,q){const le=this.f(V);if(le===-1){this.d.unshift({pattern:V,matches:C.parse(E(V))});return}const _=new Set(q.map(ue=>this.f(ue,le)));_.delete(-1);const pe=Array.from(_).sort();this.d.splice(le+1,0,...pe.map(ue=>this.d[ue]));for(let ue=pe.length-1;ue>=0;ue--)this.d.splice(pe[ue],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,q=this.d.length){const le=E(V);for(let _=0;_<q;_++)if(this.d[_].matches(le))return _;return-1}}e.MimeTypeDisplayOrder=P;function p(M,V,q,le=(_,pe)=>_===pe){const _=[];function pe(re,G,H){if(G===0&&H.length===0)return;const oe=_[_.length-1];oe&&oe.start+oe.deleteCount===re?(oe.deleteCount+=G,oe.toInsert.push(...H)):_.push({start:re,deleteCount:G,toInsert:H})}let ue=0,de=0;for(;;){if(ue===M.length){pe(ue,0,V.slice(de));break}if(de===V.length){pe(ue,M.length-ue,[]);break}const re=M[ue],G=V[de];if(le(re,G)){ue+=1,de+=1;continue}q(G)?(pe(ue,1,[]),ue+=1):(pe(ue,0,[G]),de+=1)}return _}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(M){M.default="default",M.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(M){const V=M;return!!((typeof V.include=="string"||C.isRelativePattern(V.include))&&(typeof V.exclude=="string"||C.isRelativePattern(V.exclude)))}e.isDocumentExcludePattern=d;function t(M,V,q){if(Array.isArray(M.viewType)&&M.viewType.indexOf(V)>=0||M.viewType===V)return!0;if(M.filenamePattern){const le=d(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,_=d(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(C.match(le,(0,R.basename)(q.fsPath).toLowerCase()))return!(_&&C.match(_,(0,R.basename)(q.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=t,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var u;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(V){return`${s.d}${V}`}static parse(V){if(V.startsWith(s.d))return V.substring(s.d.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s.d="notebook/";function h(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}e.isTextStreamMime=h;const a=new TextDecoder;function c(M){const V=[];let q=!1;for(const le of M)(V.length===0||q)&&(V.push(le),q=!0);return j(V),T(i.VSBuffer.concat(V.map(le=>i.VSBuffer.wrap(le))))}e.compressOutputItemStreams=c;const g=`${String.fromCharCode(27)}[A`,A=g.split("").map(M=>M.charCodeAt(0)),F=10;function j(M){M.forEach((V,q)=>{if(q===0||V.length<g.length)return;const le=M[q-1],_=V.subarray(0,g.length);if(_[0]===A[0]&&_[1]===A[1]&&_[2]===A[2]){const pe=le.lastIndexOf(F);if(pe===-1)return;M[q-1]=le.subarray(0,pe),M[q]=V.subarray(g.length)}})}function te(M){let V=M;do M=V,V=M.replace(/[^\n]\x08/gm,"");while(V.length<M.length);return M}function x(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const V=M.match(/^(.*)\r+/m)[1];let q=M.match(/\r+(.*)$/m)[1];q=q+V.slice(q.length,V.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,q)}return M}const N="\b".charCodeAt(0),$="\r".charCodeAt(0);function T(M){return!M.buffer.includes(N)&&!M.buffer.includes($)?M:i.VSBuffer.fromString(x(te(a.decode(M.buffer))))}}),define(Ie[181],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(Ie[182],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=i;function C(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=C;function S(I){return Array.from(I.entries()).map(R=>[R[0],i(R[1].map)])}e.serializeEnvironmentVariableCollections=S;function L(I){return new Map(I.map(R=>[R[0],{map:C(R[1])}]))}e.deserializeEnvironmentVariableCollections=L}),define(Ie[43],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(L){L.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class S{static fromExtHostTestItem(I,R,y=I.parent){if(I._isRoot)return new S([R]);const k=[I.id];for(let O=y;O&&O.id!==R;O=O.parent)k.push(O.id);return k.push(R),new S(k.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const R=I.indexOf("\0");return R===-1?I:I.slice(0,R)}static fromString(I){return new S(I.split("\0"))}static join(I,R){return new S([...I.path,R])}static joinToString(I,R){return I.toString()+"\0"+R}static parentId(I){const R=I.lastIndexOf("\0");return R===-1?void 0:I.slice(0,R)}static localId(I){const R=I.lastIndexOf("\0");return R===-1?I:I.slice(R+1)}static compare(I,R){return I===R?0:R.startsWith(I+"\0")?2:I.startsWith(R+"\0")?3:1}constructor(I,R=I.length){if(this.path=I,this.d=R,I.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new S(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new S(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new S(this.path,I)}compare(I){if(typeof I=="string")return S.compare(this.toString(),I);for(let R=0;R<I.d&&R<this.d;R++)if(I.path[R]!==this.path[R])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.TestId=S}),define(Ie[55],Ce([1,0,2,56,43]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var L;(function(a){a[a.Unset=0]="Unset",a[a.Queued=1]="Queued",a[a.Running=2]="Running",a[a.Passed=3]="Passed",a[a.Failed=4]="Failed",a[a.Skipped=5]="Skipped",a[a.Errored=6]="Errored"})(L=e.TestResultState||(e.TestResultState={}));var I;(function(a){a[a.Run=2]="Run",a[a.Debug=4]="Debug",a[a.Coverage=8]="Coverage",a[a.HasNonDefaultProfile=16]="HasNonDefaultProfile",a[a.HasConfigurable=32]="HasConfigurable",a[a.SupportsContinuousRun=64]="SupportsContinuousRun"})(I=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const R=a=>"runIn"in a;e.isStartControllerTests=R;var y;(function(a){a.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),a.deserialize=c=>({range:C.Range.lift(c.range),uri:i.URI.revive(c.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var k;(function(a){a[a.Error=0]="Error",a[a.Output=1]="Output"})(k=e.TestMessageType||(e.TestMessageType={}));var O;(function(a){a.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&y.serialize(c.location)}),a.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&y.deserialize(c.location)})})(O=e.ITestErrorMessage||(e.ITestErrorMessage={}));const w=(a,c)=>`${c?"s":"e"}${a}`;e.getMarkId=w;var m;(function(a){a.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&y.serialize(c.location)}),a.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&y.deserialize(c.location)})})(m=e.ITestOutputMessage||(e.ITestOutputMessage={}));var b;(function(a){a.serialize=c=>c.type===0?O.serialize(c):m.serialize(c),a.deserialize=c=>c.type===0?O.deserialize(c):m.deserialize(c)})(b=e.ITestMessage||(e.ITestMessage={}));var f;(function(a){a.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),a.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(b.serialize)}),a.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(b.deserialize)})})(f=e.ITestTaskState||(e.ITestTaskState={}));const r="\0",o=(a,c)=>a+r+c;e.namespaceTestTag=o;const l=a=>{const c=a.indexOf(r);return{ctrlId:a.slice(0,c),tagId:a.slice(c+1)}};e.denamespaceTestTag=l;var v;(function(a){a.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),a.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?i.URI.revive(c.uri):void 0,range:c.range?C.Range.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(v=e.ITestItem||(e.ITestItem={}));var E;(function(a){a[a.NotExpandable=0]="NotExpandable",a[a.Expandable=1]="Expandable",a[a.BusyExpanding=2]="BusyExpanding",a[a.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));var P;(function(a){a.serialize=c=>({expand:c.expand,item:v.serialize(c.item)}),a.deserialize=c=>({controllerId:S.TestId.root(c.item.extId),expand:c.expand,item:v.deserialize(c.item)})})(P=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(a){a.serialize=c=>{let g;return c.item&&(g={},c.item.label!==void 0&&(g.label=c.item.label),c.item.tags!==void 0&&(g.tags=c.item.tags),c.item.busy!==void 0&&(g.busy=c.item.busy),c.item.uri!==void 0&&(g.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(g.range=c.item.range?.toJSON()),c.item.description!==void 0&&(g.description=c.item.description),c.item.error!==void 0&&(g.error=c.item.error),c.item.sortText!==void 0&&(g.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:g}},a.deserialize=c=>{let g;return c.item&&(g={},c.item.label!==void 0&&(g.label=c.item.label),c.item.tags!==void 0&&(g.tags=c.item.tags),c.item.busy!==void 0&&(g.busy=c.item.busy),c.item.range!==void 0&&(g.range=c.item.range?C.Range.lift(c.item.range):null),c.item.description!==void 0&&(g.description=c.item.description),c.item.error!==void 0&&(g.error=c.item.error),c.item.sortText!==void 0&&(g.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:g}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const n=(a,c)=>{c.expand!==void 0&&(a.expand=c.expand),c.item!==void 0&&(a.item=a.item?Object.assign(a.item,c.item):c.item)};e.applyTestItemUpdate=n;var d;(function(a){a.serializeWithoutMessages=c=>({...P.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.serializeWithoutMessages),retired:c.retired}),a.serialize=c=>({...P.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.serialize),retired:c.retired}),a.deserialize=c=>({...P.deserialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.deserialize),retired:!0})})(d=e.TestResultItem||(e.TestResultItem={}));var t;(function(a){a[a.Function=0]="Function",a[a.Statement=1]="Statement"})(t=e.DetailType||(e.DetailType={}));var u;(function(a){a[a.Add=0]="Add",a[a.Update=1]="Update",a[a.DocumentSynced=2]="DocumentSynced",a[a.Remove=3]="Remove",a[a.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",a[a.Retire=5]="Retire",a[a.AddTag=6]="AddTag",a[a.RemoveTag=7]="RemoveTag"})(u=e.TestDiffOpType||(e.TestDiffOpType={}));var s;(function(a){a.deserialize=c=>c.op===0?{op:c.op,item:P.deserialize(c.item)}:c.op===1?{op:c.op,item:p.deserialize(c.item)}:c.op===2?{op:c.op,uri:i.URI.revive(c.uri),docv:c.docv}:c,a.serialize=c=>c.op===0?{op:c.op,item:P.serialize(c.item)}:c.op===1?{op:c.op,item:p.serialize(c.item)}:c})(s=e.TestsDiffOp||(e.TestsDiffOp={}));class h{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(c){const g=this.o();for(const A of c)switch(A.op){case 0:this.j(P.deserialize(A.item),g);break;case 1:this.k(p.deserialize(A.item),g);break;case 3:this.l(A.itemId,g);break;case 5:this.m(A.itemId);break;case 4:this.updatePendingRoots(A.amount);break;case 6:this.c.set(A.tag.id,A.tag);break;case 7:this.c.delete(A.id);break}g.complete?.()}j(c,g){const A=S.TestId.parentId(c.item.extId)?.toString();let F;if(!A)F=this.p(c),this.f.add(F),this.d.set(c.item.extId,F);else if(this.d.has(A)){const j=this.d.get(A);j.children.add(c.item.extId),F=this.p(c,j),this.d.set(c.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(c)}`);return}return g.add?.(F),c.expand===2&&this.g++,F}k(c,g){const A=this.d.get(c.extId);if(!!A)return c.expand!==void 0&&(A.expand===2&&this.g--,c.expand===2&&this.g++),(0,e.applyTestItemUpdate)(A,c),g.update?.(A),A}l(c,g){const A=this.d.get(c);if(!A)return;const F=S.TestId.parentId(A.item.extId)?.toString();F?this.d.get(F).children.delete(A.item.extId):this.f.delete(A);const j=[[c]];for(;j.length;)for(const te of j.pop()){const x=this.d.get(te);x&&(j.push(x.children),this.d.delete(te),g.remove?.(x,x!==A),x.expand===2&&this.g--)}}m(c){}updatePendingRoots(c){this.h+=c}o(){return{}}}e.AbstractIncrementalTestCollection=h}),define(Ie[71],Ce([1,0,12,4,6,47,55,43]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(v){v[v.Upsert=0]="Upsert",v[v.SetTags=1]="SetTags",v[v.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",v[v.RemoveChild=3]="RemoveChild",v[v.SetProp=4]="SetProp",v[v.Bulk=5]="Bulk",v[v.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(v,E)=>v===E,w=Object.entries({range:(v,E)=>v===E?!0:!v||!E?!1:v.equalsRange(E),busy:k,label:k,description:k,error:k,sortText:k,tags:(v,E)=>!(v.length!==E.length||v.some(P=>!E.includes(P)))}),m=(v,E)=>{let P;for(const[p,n]of w)n(v[p],E[p])||(P?P[p]=E[p]:P={[p]:E[p]});return P};class b extends S.Disposable{get root(){return this.m.root}constructor(E){super(),this.m=E,this.f=this.B(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new C.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(E){this.h=E;for(const P of this.tree.values())this.G(P)}collectDiff(){const E=this.k;return this.k=[],E}pushDiff(E){switch(E.op){case 2:{for(const P of this.k)if(P.op===2&&P.uri===E.uri){P.docv=E.docv;return}break}case 1:{const P=this.k[this.k.length-1];if(P){if(P.op===1&&P.item.extId===E.item.extId){(0,I.applyTestItemUpdate)(P.item,E.item);return}if(P.op===0&&P.item.item.extId===E.item.extId){(0,I.applyTestItemUpdate)(P.item,E.item);return}}break}}this.k.push(E),this.f.isScheduled()||this.f.schedule()}expand(E,P){const p=this.tree.get(E);if(!!p){if((p.expandLevels===void 0||P>p.expandLevels)&&(p.expandLevels=P),p.expand===1){const n=this.I(p);return n.isOpen()?this.H(p,P-1):n.wait().then(()=>this.H(p,P-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,P-1)):this.H(p,P-1)}}dispose(){for(const E of this.tree.values())this.m.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(E,P){switch(P.op){case 3:this.L(R.TestId.joinToString(E.fullId,P.id));break;case 0:this.u(P.item,E);break;case 5:for(const p of P.ops)this.p(E,p);break;case 1:this.w(P.new,P.old,E.fullId.toString());break;case 2:this.G(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:P.update}});break;case 6:this.s(E.actual.uri);break;default:(0,L.assertNever)(P)}}s(E){E&&this.pushDiff({op:2,uri:E,docv:this.m.getDocumentVersion(E)})}u(E,P){const p=R.TestId.fromExtHostTestItem(E,this.root.id,P?.actual),n=this.m.getApiFor(E);n.parent&&n.parent!==P?.actual&&this.m.getChildren(n.parent).delete(E.id);let d=this.tree.get(p.toString());if(!d){d={fullId:p,actual:E,expandLevels:P?.expandLevels?P.expandLevels-1:void 0,expand:0},E.tags.forEach(this.y,this),this.tree.set(d.fullId.toString(),d),this.C(E,P),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:d.expand,item:this.m.toITestItem(E)}}),this.F(E,d,P);return}if(d.actual===E){this.D(E,d,P);return}if(d.actual.uri?.toString()!==E.uri?.toString())return this.L(p.toString()),this.u(E,P);const t=this.m.getChildren(d.actual),u=d.actual,s=m(this.m.toITestItem(u),this.m.toITestItem(E));this.m.getApiFor(u).listener=void 0,d.actual=E,d.expand=0,s&&(s.hasOwnProperty("tags")&&(this.w(E.tags,u.tags,p.toString()),delete s.tags),this.p(d,{op:4,update:s})),this.F(E,d,P);for(const[h,a]of t)this.m.getChildren(E).get(a.id)||this.L(R.TestId.joinToString(p,a.id));this.s(d.actual.uri)}w(E,P,p){const n=new Set(P.map(d=>d.id));for(const d of E)n.delete(d.id)||this.y(d);this.pushDiff({op:1,item:{extId:p,item:{tags:E.map(d=>(0,I.namespaceTestTag)(this.m.controllerId,d.id))}}}),n.forEach(this.z,this)}y(E){const P=this.j.get(E.id);P?P.refCount++:(this.j.set(E.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.namespaceTestTag)(this.m.controllerId,E.id)}}))}z(E){const P=this.j.get(E);P&&!--P.refCount&&(this.j.delete(E),this.pushDiff({op:7,id:(0,I.namespaceTestTag)(this.m.controllerId,E)}))}C(E,P){this.m.getApiFor(E).parent=P&&P.actual!==this.root?P.actual:void 0}D(E,P,p){this.C(E,p);const n=this.m.getApiFor(E);n.parent=p?.actual,n.listener=d=>this.p(P,d),this.G(P)}F(E,P,p){this.D(E,P,p);for(const[n,d]of this.m.getChildren(E))this.u(d,P)}G(E){let P;this.h?E.resolveBarrier?P=E.resolveBarrier.isOpen()?3:2:P=E.actual.canResolveChildren?1:0:P=0,P!==E.expand&&(E.expand=P,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:P}}),P===1&&E.expandLevels!==void 0&&this.I(E))}H(E,P){if(P<0)return;const p=[];for(const[n,d]of this.m.getChildren(E.actual)){const t=this.expand(R.TestId.joinToString(E.fullId,d.id),P);(0,i.isThenable)(t)&&p.push(t)}if(p.length)return Promise.all(p).then(()=>{})}I(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this.h){const d=new i.Barrier;return d.open(),d}E.expand=2,this.J(E);const P=E.resolveBarrier=new i.Barrier,p=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,d)};let n;try{n=this.h(E.actual===this.root?void 0:E.actual)}catch(d){p(d)}return(0,i.isThenable)(n)?n.catch(p).then(()=>{P.open(),this.G(E)}):(P.open(),this.G(E)),E.resolveBarrier}J(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}L(E){const P=this.tree.get(E);if(!P)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:E});const p=[P];for(;p.length;){const n=p.pop();if(!!n){this.m.getApiFor(n.actual).listener=void 0;for(const d of n.actual.tags)this.z(d.id);this.tree.delete(n.fullId.toString());for(const[d,t]of this.m.getChildren(n.actual))p.push(this.tree.get(R.TestId.joinToString(n.fullId,t.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.g.fire(E)}}e.TestItemCollection=b;class f extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=f;class r extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=r;class o extends Error{constructor(E,P,p){super(`TestItem with ID "${E}" is from controller "${P}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=o;const l=(v,E,P)=>{let p=new Map;return{get size(){return p.size},forEach(n,d){for(const t of p.values())n.call(d,t,this)},[Symbol.iterator](){return p.entries()},replace(n){const d=new Map,t=new Set(p.keys()),u={op:5,ops:[]};for(const s of n){if(!(s instanceof P))throw new r(s.id);const h=E(s).controllerId;if(h!==v.controllerId)throw new o(s.id,h,v.controllerId);if(d.has(s.id))throw new f(s.id);d.set(s.id,s),t.delete(s.id),u.ops.push({op:0,item:s})}for(const s of t.keys())u.ops.push({op:3,id:s});v.listener?.(u),p=d},add(n){if(!(n instanceof P))throw new r(n.id);p.set(n.id,n),v.listener?.({op:0,item:n})},delete(n){p.delete(n)&&v.listener?.({op:3,id:n})},get(n){return p.get(n)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=l}),define(Ie[95],Ce([1,0,71]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,S=(I,R)=>{const y={controllerId:R};return C.set(I,y),y};e.createPrivateApiFor=S;const L=I=>{const R=C.get(I);if(!R)throw new i.InvalidTestItemError(I?.id||"<unknown>");return R};e.getPrivateApiFor=L}),define(Ie[72],Ce([1,0,16,2]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function S(R,y){return R.scheme===i.Schemas.http||R.scheme===i.Schemas.https?R:(y&&y.authority&&y.isRemote&&R.scheme===i.Schemas.file&&(R=C.URI.from({scheme:i.Schemas.vscodeRemote,authority:y.authority,path:R.path})),C.URI.from({scheme:i.Schemas.https,authority:`${R.scheme}+${L(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=S;function L(R){return R.replace(/./g,y=>{const k=y.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?y:"-"+k.toString(16).padStart(4,"0")})}function I(R){return R.replace(/-([0-9a-f]{4})/g,(y,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=I}),define(Ie[183],Ce([1,0,4,6,72]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(R,y,k){this.d=R,this.e=y,this.f=k,this.a=0,this.b=new C.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const O=y.getVisibleTextEditors();for(const w of this.c.values())O.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,y,k,O,w){let m;for(const E of this.e.getVisibleTextEditors(!0))if(E.value===R){m=E;break}if(!m)throw new Error("not a visible editor");const b=this,f=this.a++,r=new i.Emitter,o=new i.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(E){return(0,S.asWebviewUri)(E,b.f)}get cspSource(){return S.webviewGenericCspSource}set options(E){this.b=E,b.d.$setOptions(f,E)}get options(){return this.b}set html(E){this.a=E,b.d.$setHtml(f,E)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(E){return b.d.$postMessage(f,E)}},v=new class{constructor(){this.editor=R,this.line=y,this.height=k,this.webview=l,this.onDidDispose=o.event}dispose(){b.c.has(f)&&(b.c.delete(f),b.d.$disposeEditorInset(f),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(f,m.id,m.value.document.uri,y+1,k,O||{},w.identifier,w.extensionLocation),this.c.set(f,{editor:R,inset:v,onDidReceiveMessage:r}),v}$onDidDispose(R){const y=this.c.get(R);y&&y.inset.dispose()}$onDidReceiveMessage(R,y){this.c.get(R)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=L}),define(Ie[184],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var C;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(C=e.VariableKind||(e.VariableKind={}));class S extends Error{constructor(I,R){super(R),this.variable=I}}e.VariableError=S}),define(Ie[185],Ce([1,0,19,49,9,22,20,86,150,184,10]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(b,f,r,o){this.g=new Map,this.a=b,this.b=f,this.d=r,o&&(this.c=o.then(l=>this.h(l)))}h(b){if(I.isWindows){const f=Object.create(null);return Object.keys(b).forEach(r=>{f[r.toLowerCase()]=b[r]}),f}return b}resolveWithEnvironment(b,f,r){return this.j({env:this.h(b),userHome:void 0},f?f.uri:void 0,r)}async resolveAsync(b,f){const r={env:await this.c,userHome:await this.d};return this.j(r,b?b.uri:void 0,f)}async i(b,f,r,o){const l=L.deepClone(f);I.isWindows&&l.windows?Object.keys(l.windows).forEach(E=>l[E]=l.windows[E]):I.isMacintosh&&l.osx?Object.keys(l.osx).forEach(E=>l[E]=l.osx[E]):I.isLinux&&l.linux&&Object.keys(l.linux).forEach(E=>l[E]=l.linux[E]),delete l.windows,delete l.osx,delete l.linux;const v={env:await this.c,userHome:await this.d};return this.j(v,b?b.uri:void 0,l,r,o)}async resolveAnyAsync(b,f,r){return this.i(b,f,r)}async resolveAnyMap(b,f,r){const o=new Map;return{newConfig:await this.i(b,f,r,o),resolvedVariables:o}}resolveWithInteractionReplace(b,f,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,f,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,f){if(this.g.has(b))throw new Error("Variable "+b+" is contributed twice.");this.g.set(b,f)}async j(b,f,r,o,l){if(S.isString(r))return this.l(b,f,r,o,l);if(Array.isArray(r))return Promise.all(r.map(v=>this.j(b,f,v,o,l)));if(S.isObject(r)){const v=Object.create(null),E=await Promise.all(Object.keys(r).map(async P=>[await this.l(b,f,P,o,l),await this.j(b,f,r[P],o,l)]));for(const[P,p]of E)v[P]=p;return v}return r}l(b,f,r,o,l){return(0,O.replaceAsync)(r,w.VARIABLE_REGEXP,async(v,E)=>{if(E.includes(w.VARIABLE_LHS))return v;let P=await this.n(b,v,E,f,o);return l?.set(E,P),P!==v&&S.isString(P)&&P.match(w.VARIABLE_REGEXP)&&(P=await this.l(b,f,P,o,l)),P})}m(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async n(b,f,r,o,l){let v;const E=r.split(":");E.length>1&&(r=E[0],v=E[1]);const P=d=>{const t=this.a.getFilePath();if(t)return(0,R.normalizeDriveLetter)(t);throw new k.VariableError(d,(0,y.localize)(0,null,f))},p=d=>{const t=P(d);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,R.normalizeDriveLetter)(u)}throw new k.VariableError(d,(0,y.localize)(1,null,f,i.basename(t)))},n=d=>{if(v){const t=this.a.getFolderUri(v);if(t)return t;throw new k.VariableError(d,(0,y.localize)(2,null,f,v))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(d,(0,y.localize)(3,null,f)):new k.VariableError(d,(0,y.localize)(4,null,f))};switch(r){case"env":if(v){if(b.env){const d=b.env[I.isWindows?v.toLowerCase():v];if(S.isString(d))return d}return""}throw new k.VariableError(k.VariableKind.Env,(0,y.localize)(5,null,f));case"config":if(v){const d=this.a.getConfigurationValue(o,v);if(S.isUndefinedOrNull(d))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(6,null,f,v));if(S.isObject(d))throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(7,null,f,v));return d}throw new k.VariableError(k.VariableKind.Config,(0,y.localize)(8,null,f));case"command":return this.o(k.VariableKind.Command,f,v,l,"command");case"input":return this.o(k.VariableKind.Input,f,v,l,"input");case"extensionInstallFolder":if(v){const d=await this.a.getExtension(v);if(!d)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,f,v));return this.m(d.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,f));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.m(n(k.VariableKind.WorkspaceFolder)));case"cwd":return o||v?(0,R.normalizeDriveLetter)(this.m(n(k.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(i.basename(this.m(n(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,y.localize)(11,null,f))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new k.VariableError(k.VariableKind.LineNumber,(0,y.localize)(12,null,f))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new k.VariableError(k.VariableKind.SelectedText,(0,y.localize)(13,null,f))}case"file":return P(k.VariableKind.File);case"fileWorkspaceFolder":return p(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||v?i.relative(this.m(n(k.VariableKind.RelativeFile)),P(k.VariableKind.RelativeFile)):P(k.VariableKind.RelativeFile);case"relativeFileDirname":{const d=i.dirname(P(k.VariableKind.RelativeFileDirname));if(o||v){const t=i.relative(this.m(n(k.VariableKind.RelativeFileDirname)),d);return t.length===0?".":t}return d}case"fileDirname":return i.dirname(P(k.VariableKind.FileDirname));case"fileExtname":return i.extname(P(k.VariableKind.FileExtname));case"fileBasename":return i.basename(P(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=i.basename(P(k.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-i.extname(d).length)}case"fileDirnameBasename":return i.basename(i.dirname(P(k.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||f}case"execInstallFolder":{const d=this.a.getAppRoot();return d||f}case"pathSeparator":return i.sep;default:try{const d=v?`${r}:${v}`:r;return this.o(k.VariableKind.Unknown,f,d,l,void 0)}catch{return f}}}}o(b,f,r,o,l){if(r&&o){const v=l===void 0?o[r]:o[l+":"+r];if(typeof v=="string")return v;throw new k.VariableError(b,(0,y.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=w,w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[96],Ce([1,0,3,94]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var S;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var L;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var R;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function k(f){const r=f;return(0,C.isEditorInput)(r?.editor)&&(0,C.isEditorInput)(r?.replacement)}e.isEditorReplacement=k;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const r=f;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}e.isEditorGroup=m;function b(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(Ie[186],Ce([1,0,3,96]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(L){const I=L;return typeof L=="number"||(0,C.isEditorGroup)(I)}e.isPreferredGroup=S}),define(Ie[187],Ce([1,0,3,156]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(C.IEnvironmentService)}),define(Ie[97],Ce([1,0,26,4,19]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(w){this.removedDueToLooping=w}}e.DeltaExtensionsResult=L;class I{static isHostExtension(w,m,b){if(m.getExtensionDescription(w))return!1;const f=b.getExtensionDescription(w);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(w){this.c=new C.Emitter,this.onDidChange=this.c.event,this.d=w,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const w of this.d){if(this.e.has(i.ExtensionIdentifier.toKey(w.identifier))){console.error("Extension `"+w.identifier.value+"` is already registered");continue}if(this.e.set(i.ExtensionIdentifier.toKey(w.identifier),w),this.f.push(w),Array.isArray(w.activationEvents))for(let m of w.activationEvents)m==="onUri"&&(m=`onUri:${i.ExtensionIdentifier.toKey(w.identifier)}`),this.g.has(m)||this.g.set(m,[]),this.g.get(m).push(w)}}set(w){this.d=w,this.h(),this.c.fire(void 0)}deltaExtensions(w,m){this.d=k(this.d,m),this.d=this.d.concat(w);const b=I.j(this.d);return this.d=k(this.d,b.map(f=>f.identifier)),this.h(),this.c.fire(void 0),new L(b)}static j(w){const m=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,v){this.addNode(l),this.addNode(v),this.c.has(l)?this.c.get(l).push(v):this.c.set(l,[v])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,v){const E=m.getArcs(l);for(let P=0;P<E.length;P++)if(!v.has(E[P]))return!1;return!0}getNodes(){return this.e}},b=new Map;for(const l of w){const v=i.ExtensionIdentifier.toKey(l.identifier);if(b.set(v,l),l.extensionDependencies)for(const E of l.extensionDependencies){const P=i.ExtensionIdentifier.toKey(E);m.addArc(v,P)}}const f=new Set;m.getNodes().filter(l=>m.getArcs(l).length===0).forEach(l=>f.add(l));const r=m.getNodes().filter(l=>!f.has(l));let o;do{o=!1;for(let l=0;l<r.length;l++){const v=r[l];m.hasOnlyGoodArcs(v,f)&&(r.splice(l,1),l--,f.add(v),o=!0)}}while(o);return r.map(l=>b.get(l))}containsActivationEvent(w){return this.g.has(w)}containsExtension(w){return this.e.has(i.ExtensionIdentifier.toKey(w))}getExtensionDescriptionsForActivationEvent(w){const m=this.g.get(w);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(w){const m=this.e.get(i.ExtensionIdentifier.toKey(w));return m||void 0}getExtensionDescriptionByUUID(w){for(const m of this.f)if(m.uuid===w)return m}getExtensionDescriptionByIdOrUUID(w,m){return this.getExtensionDescription(w)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=I;var R;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(R||(R={}));function y(O,w){const m=O.isBuiltin?0:O.isUnderDevelopment?2:1,b=w.isBuiltin?0:w.isUnderDevelopment?2:1;if(m!==b)return m-b;const f=S.posix.basename(O.extensionLocation.path),r=S.posix.basename(w.extensionLocation.path);return f<r?-1:f>r?1:0}function k(O,w){const m=new Set;return w.forEach(b=>m.add(i.ExtensionIdentifier.toKey(b))),O.filter(b=>!m.has(i.ExtensionIdentifier.toKey(b.identifier)))}}),define(Ie[73],Ce([1,0,25]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var S;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function I(k){const O=i.VSBuffer.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=I;function R(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=R;var y;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[74],Ce([1,0,3,4,13,27,73,48,50,22,2]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let w=class{constructor(r,o){this.i=r,this.a=new C.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new C.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=o.createLogger(O.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(r,o,l){const v=this.getTelemetryDetails(),E=new m(o,l,r,this.g,this.f,this.getBuiltInCommonProperties(r),{isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled});return this.h.set(r.identifier.value,E),E.apiTelemetryLogger}$initializeTelemetryLevel(r,o,l){this.d=r,this.f=o,this.c=l??{usage:!0,error:!0}}getBuiltInCommonProperties(r){const o={};switch(o["common.extname"]=`${r.publisher}.${r.name}`,o["common.extversion"]=r.version,o["common.vscodemachineid"]=this.i.telemetryInfo.machineId,o["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,o["common.vscodeversion"]=this.i.version,o["common.isnewappinstall"]=b(this.i.telemetryInfo.firstSessionDate),o["common.product"]=this.i.environment.appHost,this.i.uiKind){case I.UIKind.Web:o["common.uikind"]="web";break;case I.UIKind.Desktop:o["common.uikind"]="desktop";break;default:o["common.uikind"]="unknown"}return o["common.remotename"]=(0,R.getRemoteName)((0,y.cleanRemoteAuthority)(this.i.remote.authority)),o}$onDidChangeTelemetryLevel(r){this.e=this.getTelemetryConfiguration(),this.d=r;const o=this.getTelemetryDetails();this.h.forEach(l=>{l.updateTelemetryEnablements(o.isUsageEnabled,o.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(r,o){const l=this.h.get(r.value);return!l||l.ignoreUnhandledExtHostErrors?!1:(l.logError(o),!0)}};w=qe([Ve(0,L.IExtHostInitDataService),Ve(1,S.ILoggerService)],w),e.ExtHostTelemetry=w;class m{constructor(r,o,l,v,E,P,p){this.g=l,this.h=v,this.i=E,this.j=P,this.b=new C.Emitter,this.ignoreUnhandledExtHostErrors=o?.ignoreUnhandledErrors??!1,this.e=o?.ignoreBuiltInCommonProperties??!1,this.f=o?.additionalCommonProperties,this.a=r,this.c={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(r,o){this.d&&(this.c={isUsageEnabled:r,isErrorsEnabled:o},this.b.fire(this.d))}mixInCommonPropsAndCleanData(r){let o=r.properties??r;return o=(0,y.cleanData)(o,[]),this.f&&(o=(0,k.mixin)(o,this.f)),this.e||(o=(0,k.mixin)(o,this.j)),r.properties?r.properties=o:r=o,r}k(r,o){this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,o=this.mixInCommonPropsAndCleanData(o||{}),this.i||this.a.sendEventData(r,o),this.h.trace(r,o)}logUsage(r,o){!this.c.isUsageEnabled||this.k(r,o)}logError(r,o){!this.c.isErrorsEnabled||(typeof r=="string"?this.k(r,o):this.a.sendErrorData(r,o))}get apiTelemetryLogger(){if(!this.d){const r=this,o={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.c.isUsageEnabled},get isErrorsEnabled(){return r.c.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.b.event.bind(r)};this.d=Object.freeze(o)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=m;function b(f){const r=Date.now()-new Date(f).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.isNewAppInstall=b,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(Ie[24],Ce([1,0,4,2,3,26,165]),function(ee,e,i,C,S,L,I){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class y{constructor(h){this.affinity=h,this.kind=1}equals(h){return this.kind===h.kind&&this.affinity===h.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class k{constructor(h){this.affinity=h,this.kind=2}equals(h){return this.kind===h.kind&&this.affinity===h.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class O{constructor(){this.kind=3,this.affinity=0}equals(h){return this.kind===h.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class w{constructor(h){this.dependency=h}}e.MissingExtensionDependency=w;var m;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=b;class f{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(h,a){const c=[],g=[],A=[],F=[],j=l(this.c),te=l(h),x=(M,V)=>M.extensionLocation.toString()===V.extensionLocation.toString()||M.isBuiltin===V.isBuiltin||M.isUserBuiltin===V.isUserBuiltin||M.isUnderDevelopment===V.isUnderDevelopment;for(const M of this.c){const V=te.get(L.ExtensionIdentifier.toKey(M.identifier));if(!V){c.push(M.identifier),j.delete(L.ExtensionIdentifier.toKey(M.identifier));continue}if(!x(M,V)){c.push(M.identifier),j.delete(L.ExtensionIdentifier.toKey(M.identifier));continue}}for(const M of h){const V=j.get(L.ExtensionIdentifier.toKey(M.identifier));if(!V){g.push(M);continue}if(!x(V,M)){c.push(V.identifier),j.delete(L.ExtensionIdentifier.toKey(V.identifier));continue}}const N=o(this.d),$=o(a);for(const M of this.d)$.has(L.ExtensionIdentifier.toKey(M))||A.push(M);for(const M of a)N.has(L.ExtensionIdentifier.toKey(M))||F.push(M);const T={toRemove:c,toAdd:g,myToRemove:A,myToAdd:F};return this.delta(T),T}delta(h){const{toRemove:a,toAdd:c,myToRemove:g,myToAdd:A}=h,F=o(a),j=o(g);for(let te=0;te<this.c.length;te++)F.has(L.ExtensionIdentifier.toKey(this.c[te].identifier))&&(this.c.splice(te,1),te--);for(let te=0;te<this.d.length;te++)j.has(L.ExtensionIdentifier.toKey(this.d[te]))&&(this.d.splice(te,1),te--);for(const te of c)this.c.push(te);for(const te of A)this.d.push(te)}containsExtension(h){for(const a of this.d)if(L.ExtensionIdentifier.equals(a,h))return!0;return!1}}e.ExtensionHostExtensions=f;class r{constructor(h){if(this[R]="ExtensionIdentifierSet",this.c=new Map,this.d=L.ExtensionIdentifier.toKey,h)for(const a of h)this.add(a)}get size(){return this.c.size}add(h){return this.c.set(this.d(h),h),this}clear(){this.c.clear()}delete(h){return this.c.delete(this.d(h))}has(h){return this.c.has(this.d(h))}forEach(h,a){this.c.forEach(c=>h.call(a,c,c,this))}*entries(){for(const[h,a]of this.c)yield[a,a]}keys(){return this.c.values()}values(){return this.c.values()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=r;function o(s){const h=new Set;for(const a of s)h.add(L.ExtensionIdentifier.toKey(a));return h}e.extensionIdentifiersArrayToSet=o;function l(s){const h=new Map;for(const a of s)h.set(L.ExtensionIdentifier.toKey(a.identifier),a);return h}function v(s,h){return s.enabledApiProposals?s.enabledApiProposals.includes(h):!1}e.isProposedApiEnabled=v;function E(s,h){if(!v(s,h))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=E;class P{constructor(h,a,c,g){this.codeLoadingTime=h,this.activateCallTime=a,this.activateResolvedTime=c,this.activationReason=g}}e.ActivationTimes=P;class p{constructor(h,a){this.description=h,this.value=a}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var n;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function d(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function t(s,h){return{identifier:new L.ExtensionIdentifier((0,I.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!h,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=t;class u{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(h,a){return Promise.resolve(0)}getInspectPorts(h,a){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(Ie[188],Ce([1,0,11,97,26,24,13,12]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(l,v,E,P){this.startup=l,this.codeLoadingTime=v,this.activateCallTime=E,this.activateResolvedTime=P}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class k{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,v){return l===-1||v===-1?-1:v-l}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class O{constructor(l,v,E,P,p,n){this.activationFailed=l,this.activationFailedError=v,this.activationTimes=E,this.module=P,this.exports=p,this.subscriptions=n}}e.ActivatedExtension=O;class w extends O{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=w;class m extends O{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=m;class b extends O{constructor(l){super(!0,l,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(l,v,E,P){this.g=P,this.a=l,this.b=v,this.c=E,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[l,v]of this.d)v.dispose()}isActivated(l){const v=this.d.get(S.ExtensionIdentifier.toKey(l));return Boolean(v&&v.value)}getActivatedExtension(l){const v=this.d.get(S.ExtensionIdentifier.toKey(l));if(!v||!v.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return v.value}async activateByEvent(l,v){if(this.f[l])return;const E=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(E.map(P=>({id:P.identifier,reason:{startup:v,extensionId:P.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,v){const E=this.a.getExtensionDescription(l);if(!E)throw new Error(`Extension '${l}' is not known`);return this.h([{id:E.identifier,reason:v}])}async h(l){const v=l.filter(E=>!this.isActivated(E.id)).map(E=>this.j(E));await Promise.all(v.map(E=>E.wait()))}j(l){if(this.d.has(S.ExtensionIdentifier.toKey(l.id)))return this.d.get(S.ExtensionIdentifier.toKey(l.id));if(this.l(l.id))return this.k(l,null,[],null);const v=this.a.getExtensionDescription(l.id);if(!v){const p=new Error(`Cannot activate unknown extension '${l.id.value}'`),n=this.k(l,null,[],new b(p));return this.c.onExtensionActivationError(l.id,p,new L.MissingExtensionDependency(l.id.value)),n}const E=[],P=typeof v.extensionDependencies>"u"?[]:v.extensionDependencies;for(const p of P){if(this.m(p))continue;const n=this.d.get(S.ExtensionIdentifier.toKey(p));if(n){E.push(n);continue}if(this.l(p)){E.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:l.reason}));continue}const d=this.a.getExtensionDescription(p);if(d){if(!d.main&&!d.browser)continue;E.push(this.j({id:d.identifier,reason:l.reason}));continue}const t=v.displayName||v.identifier.value,u=new Error(`Cannot activate the '${t}' extension because it depends on unknown extension '${p}'`),s=this.k(l,v.displayName,[],new b(u));return this.c.onExtensionActivationError(v.identifier,u,new L.MissingExtensionDependency(p)),s}return this.k(l,v.displayName,E,null)}k(l,v,E,P){const p=new r(l.id,v,l.reason,E,P,this.c,this.g);return this.d.set(S.ExtensionIdentifier.toKey(l.id),p),p}l(l){return C.ExtensionDescriptionRegistry.isHostExtension(l,this.a,this.b)}m(l){const v=this.b.getExtensionDescription(l);return v?!v.main&&!v.browser:!1}};f=qe([Ve(3,I.ILogService)],f),e.ExtensionsActivator=f;let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,v,E,P,p,n,d){this.c=l,this.d=v,this.f=E,this.g=P,this.h=p,this.j=n,this.k=d,this.a=new R.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const v=this.g[l];if(v.value&&!v.value.activationFailed){this.g.splice(l,1),l--;continue}if(v.value&&v.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${v.friendlyName}' failed to activate`);E.detail=v.value.activationFailedError,this.h=new b(E),this.j.onExtensionActivationError(this.c,E,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const v=new Error;if(l&&l.name&&(v.name=l.name),l&&l.message?v.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:v.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(v.stack=l.stack),this.h=new b(v),this.b&&i.isCancellationError(l))return;this.j.onExtensionActivationError(this.c,v,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};r=qe([Ve(6,I.ILogService)],r)}),define(Ie[189],Ce([1,0,13,27,24]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends i.LogService{constructor(R,y){super(R.createLogger(y.logFile,{name:S.ExtensionHostLogFileName}))}};L=qe([Ve(0,i.ILoggerService),Ve(1,C.IExtHostInitDataService)],L),e.ExtHostLogService=L});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[7],Ce([1,0,18,11,85,28,64,10,9,2,34,36,93,70,24]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f){"use strict";var r,o,l,v,E,P,p,n,d,t,u,s,h,a,c,g,A,F,j,te,x,N,$;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function T(z){return Object.assign(z,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ie,...we]=arguments;return Reflect.construct(z,we,ie.constructor)}}})}var M;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(M=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var V;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(V=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let q=P=class{static from(...U){let ie=U;return new P(function(){if(ie){for(const we of ie)we&&typeof we.dispose=="function"&&we.dispose();ie=void 0}})}constructor(U){r.set(this,void 0),Je(this,r,U,"f")}dispose(){typeof Oe(this,r,"f")=="function"&&(Oe(this,r,"f").call(this),Je(this,r,void 0,"f"))}};r=new WeakMap,q=P=qe([T],q),e.Disposable=q;let le=p=class{static Min(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let we=1;we<U.length;we++){const Ke=U[we];Ke.isBefore(ie)&&(ie=Ke)}return ie}static Max(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let we=1;we<U.length;we++){const Ke=U[we];Ke.isAfter(ie)&&(ie=Ke)}return ie}static isPosition(U){if(!U)return!1;if(U instanceof p)return!0;const{line:ie,character:we}=U;return typeof ie=="number"&&typeof we=="number"}static of(U){if(U instanceof p)return U;if(this.isPosition(U))return new p(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,ie){if(U<0)throw(0,C.illegalArgument)("line must be non-negative");if(ie<0)throw(0,C.illegalArgument)("character must be non-negative");this.c=U,this.e=ie}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,ie=0){if(U===null||ie===null)throw(0,C.illegalArgument)();let we;return typeof U>"u"?we=0:typeof U=="number"?we=U:(we=typeof U.lineDelta=="number"?U.lineDelta:0,ie=typeof U.characterDelta=="number"?U.characterDelta:0),we===0&&ie===0?this:new p(this.line+we,this.character+ie)}with(U,ie=this.character){if(U===null||ie===null)throw(0,C.illegalArgument)();let we;return typeof U>"u"?we=this.line:typeof U=="number"?we=U:(we=typeof U.line=="number"?U.line:this.line,ie=typeof U.character=="number"?U.character:this.character),we===this.line&&ie===this.character?this:new p(we,ie)}toJSON(){return{line:this.line,character:this.character}}};le=p=qe([T],le),e.Position=le;let _=n=class{static isRange(U){return U instanceof n?!0:U?le.isPosition(U.start)&&le.isPosition(U.end):!1}static of(U){if(U instanceof n)return U;if(this.isRange(U))return new n(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,ie,we,Ke){let _e,ot;if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"?(_e=new le(U,ie),ot=new le(we,Ke)):le.isPosition(U)&&le.isPosition(ie)&&(_e=le.of(U),ot=le.of(ie)),!_e||!ot)throw new Error("Invalid arguments");_e.isBefore(ot)?(this.c=_e,this.e=ot):(this.c=ot,this.e=_e)}contains(U){return n.isRange(U)?this.contains(U.start)&&this.contains(U.end):le.isPosition(U)?!(le.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const ie=le.Max(U.start,this.c),we=le.Min(U.end,this.e);if(!ie.isAfter(we))return new n(ie,we)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ie=le.Min(U.start,this.c),we=le.Max(U.end,this.end);return new n(ie,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,ie=this.end){if(U===null||ie===null)throw(0,C.illegalArgument)();let we;return U?le.isPosition(U)?we=U:(we=U.start||this.start,ie=U.end||this.end):we=this.start,we.isEqual(this.c)&&ie.isEqual(this.end)?this:new n(we,ie)}toJSON(){return[this.start,this.end]}};_=n=qe([T],_),e.Range=_;let pe=d=class extends _{static isSelection(U){return U instanceof d?!0:U?_.isRange(U)&&le.isPosition(U.anchor)&&le.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,ie,we,Ke){let _e,ot;if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"?(_e=new le(U,ie),ot=new le(we,Ke)):le.isPosition(U)&&le.isPosition(ie)&&(_e=le.of(U),ot=le.of(ie)),!_e||!ot)throw new Error("Invalid arguments");super(_e,ot),this.f=_e,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};pe=d=qe([T],pe),e.Selection=pe;class ue{constructor(U,ie,we){if(typeof U!="string"||U.length===0)throw(0,C.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,C.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z_\-]+$/.test(we)))throw(0,C.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ie),this.connectionToken=we}}e.ResolvedAuthority=ue;class de extends Error{static NotAvailable(U,ie){return new de(U,m.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(U){return new de(U,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ie=m.RemoteAuthorityResolverErrorCode.Unknown,we){super(U),this._message=U,this._code=ie,this._detail=we,Object.setPrototypeOf(this,de.prototype)}}e.RemoteAuthorityResolverError=de;var re;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(re=e.EndOfLine||(e.EndOfLine={}));var G;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(G=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let H=t=class{static isTextEdit(U){return U instanceof t?!0:U?_.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ie){return new t(U,ie)}static insert(U,ie){return t.replace(new _(U,U),ie)}static delete(U){return t.replace(U,"")}static setEndOfLine(U){const ie=new t(new _(new le(0,0),new le(0,0)),"");return ie.newEol=U,ie}get range(){return this.c}set range(U){if(U&&!_.isRange(U))throw(0,C.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,C.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,C.illegalArgument)("newEol");this.f=U}constructor(U,ie){this.c=U,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};H=t=qe([T],H),e.TextEdit=H;let oe=u=class{static isNotebookCellEdit(U){return U instanceof u?!0:U?xt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ie){return new u(U,ie)}static insertCells(U,ie){return new u(new xt(U,U),ie)}static deleteCells(U){return new u(U,[])}static updateCellMetadata(U,ie){const we=new u(new xt(U,U),[]);return we.newCellMetadata=ie,we}static updateNotebookMetadata(U){const ie=new u(new xt(0,0),[]);return ie.newNotebookMetadata=U,ie}constructor(U,ie){this.range=U,this.newCells=ie}};oe=u=qe([T],oe),e.NotebookEdit=oe;class ve{static isSnippetTextEdit(U){return U instanceof ve?!0:U?_.isRange(U.range)&&xe.isSnippetString(U.snippet):!1}static replace(U,ie){return new ve(U,ie)}static insert(U,ie){return ve.replace(new _(U,U),ie)}constructor(U,ie){this.range=U,this.snippet=ie}}e.SnippetTextEdit=ve;var Ae;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ae=e.FileEditType||(e.FileEditType={}));let Be=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,ie,we,Ke){this.c.push({_type:1,from:U,to:ie,options:we,metadata:Ke})}createFile(U,ie,we){this.c.push({_type:1,from:void 0,to:U,options:ie,metadata:we})}deleteFile(U,ie,we){this.c.push({_type:1,from:U,to:void 0,options:ie,metadata:we})}e(U,ie,we){this.c.push({_type:3,metadata:we,uri:U,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(U,ie,we,Ke){const _e=ie.start,ot=ie.end;(_e!==ot||we.length>0)&&this.c.push({_type:5,uri:U,index:_e,count:ot-_e,cells:we,metadata:Ke})}g(U,ie,we,Ke){this.c.push({_type:3,metadata:Ke,uri:U,edit:{editType:8,index:ie,metadata:we}})}replace(U,ie,we,Ke){this.c.push({_type:2,uri:U,edit:new H(ie,we),metadata:Ke})}insert(U,ie,we,Ke){this.replace(U,new _(ie,ie),we,Ke)}delete(U,ie,we){this.replace(U,ie,"",we)}has(U){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===U.toString())}set(U,ie){if(ie)for(const we of ie){if(!we)continue;let Ke,_e;Array.isArray(we)?(Ke=we[0],_e=we[1]):Ke=we,oe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,_e):this.f(U,Ke.range,Ke.newCells,_e):ve.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:U,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:2,uri:U,edit:Ke,metadata:_e})}else{for(let we=0;we<this.c.length;we++){const Ke=this.c[we];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===U.toString()&&(this.c[we]=void 0);break}}(0,i.coalesceInPlace)(this.c)}}get(U){const ie=[];for(const we of this.c)we._type===2&&we.uri.toString()===U.toString()&&ie.push(we.edit);return ie}entries(){const U=new L.ResourceMap;for(const ie of this.c)if(ie._type===2){let we=U.get(ie.uri);we||(we=[ie.uri,[]],U.set(ie.uri,we)),we[1].push(ie.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Be=qe([T],Be),e.WorkspaceEdit=Be;let xe=s=class{static isSnippetString(U){return U instanceof s?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=s.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ie=this.e++){if(typeof U=="function"){const we=new s;we.e=this.e,U(we),this.e=we.e,U=we.value}else U=s.c(U);return this.value+="${",this.value+=ie,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ie=this.e++){const we=U.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(U,ie){if(typeof ie=="function"){const we=new s;we.e=this.e,ie(we),this.e=we.e,ie=we.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};xe=s=qe([T],xe),e.SnippetString=xe;var Te;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=h=class{static isLocation(U){return U instanceof h?!0:U?_.isRange(U.range)&&k.URI.isUri(U.uri):!1}constructor(U,ie){if(this.uri=U,ie)if(_.isRange(ie))this.range=_.of(ie);else if(le.isPosition(ie))this.range=new _(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=h=qe([T],ke),e.Location=ke;let se=class{static is(U){return U?typeof U.message=="string"&&U.location&&_.isRange(U.location.range)&&k.URI.isUri(U.location.uri):!1}constructor(U,ie){this.location=U,this.message=ie}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.location.range.isEqual(ie.location.range)&&U.location.uri.toString()===ie.location.uri.toString()}};se=qe([T],se),e.DiagnosticRelatedInformation=se;let ce=class{constructor(U,ie,we=Se.Error){if(!_.isRange(U))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=U,this.message=ie,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.severity===ie.severity&&U.code===ie.code&&U.severity===ie.severity&&U.source===ie.source&&U.range.isEqual(ie.range)&&(0,i.equals)(U.tags,ie.tags)&&(0,i.equals)(U.relatedInformation,ie.relatedInformation,se.isEqual)}};ce=qe([T],ce),e.Diagnostic=ce;let J=class{constructor(U,ie){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ie}};J=qe([T],J),e.Hover=J;var D;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(D=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let B=class{constructor(U,ie=D.Text){this.range=U,this.kind=ie}toJSON(){return{range:this.range,kind:D[this.kind]}}};B=qe([T],B),e.DocumentHighlight=B;var W;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(W=e.SymbolKind||(e.SymbolKind={}));var K;(function(z){z[z.Deprecated=1]="Deprecated"})(K=e.SymbolTag||(e.SymbolTag={}));let Z=a=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ie,we,Ke,_e){this.name=U,this.kind=ie,this.containerName=_e,typeof we=="string"&&(this.containerName=we),Ke instanceof ke?this.location=Ke:we instanceof _&&(this.location=new ke(Ke,we)),a.validate(this)}toJSON(){return{name:this.name,kind:W[this.kind],location:this.location,containerName:this.containerName}}};Z=a=qe([T],Z),e.SymbolInformation=Z;let he=c=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(c.validate)}constructor(U,ie,we,Ke,_e){this.name=U,this.detail=ie,this.kind=we,this.range=Ke,this.selectionRange=_e,this.children=[],c.validate(this)}};he=c=qe([T],he),e.DocumentSymbol=he;var ye;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(U,ie){this.title=U,this.kind=ie}};ae=qe([T],ae),e.CodeAction=ae;let be=g=class{constructor(U){this.value=U}append(U){return new g(this.value?this.value+g.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+g.c)}};be.c=".",be=g=qe([T],be),e.CodeActionKind=be,be.Empty=new be(""),be.QuickFix=be.Empty.append("quickfix"),be.Refactor=be.Empty.append("refactor"),be.RefactorExtract=be.Refactor.append("extract"),be.RefactorInline=be.Refactor.append("inline"),be.RefactorMove=be.Refactor.append("move"),be.RefactorRewrite=be.Refactor.append("rewrite"),be.Source=be.Empty.append("source"),be.SourceOrganizeImports=be.Source.append("organizeImports"),be.SourceFixAll=be.Source.append("fixAll");let Ee=class{constructor(U,ie){if(this.range=U,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([T],Ee),e.SelectionRange=Ee;class We{constructor(U,ie,we,Ke,_e,ot){this.kind=U,this.name=ie,this.detail=we,this.uri=Ke,this.range=_e,this.selectionRange=ot}}e.CallHierarchyItem=We;class He{constructor(U,ie){this.fromRanges=ie,this.from=U}}e.CallHierarchyIncomingCall=He;class tt{constructor(U,ie){this.fromRanges=ie,this.to=U}}e.CallHierarchyOutgoingCall=tt;var Xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,ie){this.range=U,this.command=ie}get isResolved(){return!!this.command}};et=qe([T],et),e.CodeLens=et;let it=A=class{static isMarkdownString(U){return U instanceof A?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ie=!1){o.set(this,void 0),Je(this,o,new S.MarkdownString(U,{supportThemeIcons:ie}),"f")}get value(){return Oe(this,o,"f").value}set value(U){Oe(this,o,"f").value=U}get isTrusted(){return Oe(this,o,"f").isTrusted}set isTrusted(U){Oe(this,o,"f").isTrusted=U}get supportThemeIcons(){return Oe(this,o,"f").supportThemeIcons}set supportThemeIcons(U){Oe(this,o,"f").supportThemeIcons=U}get supportHtml(){return Oe(this,o,"f").supportHtml}set supportHtml(U){Oe(this,o,"f").supportHtml=U}get baseUri(){return Oe(this,o,"f").baseUri}set baseUri(U){Oe(this,o,"f").baseUri=U}appendText(U){return Oe(this,o,"f").appendText(U),this}appendMarkdown(U){return Oe(this,o,"f").appendMarkdown(U),this}appendCodeblock(U,ie){return Oe(this,o,"f").appendCodeblock(ie??"",U),this}};o=new WeakMap,it=A=qe([T],it),e.MarkdownString=it;let dt=class{constructor(U,ie){this.label=U,this.documentation=ie}};dt=qe([T],dt),e.ParameterInformation=dt;let Fe=class{constructor(U,ie){this.label=U,this.documentation=ie,this.parameters=[]}};Fe=qe([T],Fe),e.SignatureInformation=Fe;let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};st=qe([T],st),e.SignatureHelp=st;var Y;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Y=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Q;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Q=e.InlayHintKind||(e.InlayHintKind={}));let ge=class{constructor(U){this.value=U}};ge=qe([T],ge),e.InlayHintLabelPart=ge;let Me=class{constructor(U,ie,we){this.position=U,this.label=ie,this.kind=we}};Me=qe([T],Me),e.InlayHint=Me;var $e;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})($e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(z){z[z.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,ie){this.label=U,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([T],nt),e.CompletionItem=nt;let wt=class{constructor(U=[],ie=!1){this.items=U,this.isIncomplete=ie}};wt=qe([T],wt),e.CompletionList=wt;let St=class{constructor(U,ie,we){this.insertText=U,this.range=ie,this.command=we}};St=qe([T],St),e.InlineSuggestion=St;let Ct=class{constructor(U){this.commands=void 0,this.items=U}};Ct=qe([T],Ct),e.InlineSuggestionList=Ct;var lt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var at;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(at=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Bt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Bt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ot;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ot=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var $t;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})($t=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(ie){switch(ie){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor(U,ie){if(ie&&!k.URI.isUri(ie))throw(0,C.illegalArgument)("target");if(!_.isRange(U)||U.isEmpty)throw(0,C.illegalArgument)("range");this.range=U,this.target=ie}};Nt=qe([T],Nt),e.DocumentLink=Nt;let Ge=class{constructor(U,ie,we,Ke){this.red=U,this.green=ie,this.blue=we,this.alpha=Ke}};Ge=qe([T],Ge),e.Color=Ge;let Mt=class{constructor(U,ie){if(ie&&!(ie instanceof Ge))throw(0,C.illegalArgument)("color");if(!_.isRange(U)||U.isEmpty)throw(0,C.illegalArgument)("range");this.range=U,this.color=ie}};Mt=qe([T],Mt),e.ColorInformation=Mt;let Lt=class{constructor(U){if(!U||typeof U!="string")throw(0,C.illegalArgument)("label");this.label=U}};Lt=qe([T],Lt),e.ColorPresentation=Lt;var Ut;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Ut=e.ColorFormat||(e.ColorFormat={}));var gt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(gt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var kt;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(kt=e.TerminalExitReason||(e.TerminalExitReason={}));class De{constructor(U,ie,we){if(this.startIndex=U,this.length=ie,this.tooltip=we,typeof U!="number"||U<0)throw(0,C.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,C.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=De;class Pe{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Pe;class me{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=me;var X;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(X=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=Re;var Le;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Le=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let ze=F=class{static from(U){switch(U){case"clean":return F.Clean;case"build":return F.Build;case"rebuild":return F.Rebuild;case"test":return F.Test;default:return}}constructor(U,ie){if(this.label=ie,typeof U!="string"||typeof ie!="string")throw(0,C.illegalArgument)("name");this.c=U}get id(){return this.c}};ze.Clean=new F("clean","Clean"),ze.Build=new F("build","Build"),ze.Rebuild=new F("rebuild","Rebuild"),ze.Test=new F("test","Test"),ze=F=qe([T],ze),e.TaskGroup=ze;function Ze(z){let U="";for(let ie=0;ie<z.length;ie++)U+=z[ie].replace(/,/g,",,")+",";return U}let bt=class{constructor(U,ie,we){if(typeof U!="string")throw(0,C.illegalArgument)("process");this.e=[],this.c=U,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=we):this.f=ie)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,C.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)U.push(ie);return Ze(U)}};bt=qe([T],bt),e.ProcessExecution=bt;let vt=class{constructor(U,ie,we){if(this.f=[],Array.isArray(ie)){if(!U)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,C.illegalArgument)("command");this.e=U,this.f=ie,this.g=we}else{if(typeof U!="string")throw(0,C.illegalArgument)("commandLine");this.c=U,this.g=ie}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,C.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,C.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)U.push(typeof ie=="string"?ie:ie.value);return Ze(U)}};vt=qe([T],vt),e.ShellExecution=vt;var At;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(At=e.ShellQuoting||(e.ShellQuoting={}));var pt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(pt=e.TaskScope||(e.TaskScope={}));class It{constructor(U){this.c=U}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=It;let ht=j=class{constructor(U,ie,we,Ke,_e,ot){this.j=!1,this.k=this.definition=U;let ut;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=we,this.execution=Ke,ut=_e,this.j=!0):ie===pt.Global||ie===pt.Workspace?(this.target=ie,this.m=this.name=we,this.t=this.source=Ke,this.execution=_e,ut=ot):(this.target=ie,this.m=this.name=we,this.t=this.source=Ke,this.execution=_e,ut=ot),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof bt?this.k={type:j.e,id:this.n.computeId()}:this.n instanceof vt?this.k={type:j.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:j.c,id:this.n.computeId()}:this.k={type:j.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,C.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const ie=this.k.type;(j.g===ie||j.e===ie||j.f===ie||j.c===ie)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};ht.c="customExecution",ht.e="process",ht.f="shell",ht.g="$empty",ht=j=qe([T],ht),e.Task=ht;var Kt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(Kt=e.ProgressLocation||(e.ProgressLocation={}));var Vt;(function(z){function U(ie){const we=ie;return(0,y.isNumber)(we.value)?we.tooltip&&!(0,y.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}z.isViewBadge=U})(Vt=e.ViewBadge||(e.ViewBadge={}));let Et=te=class{static isTreeItem(U,ie){if(U instanceof te)return!0;const we=U;if(we.label!==void 0&&!(0,y.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,y.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,y.isString)(we.iconPath)&&!k.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,y.isString)(we.iconPath.id))){const Ke=we.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,y.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!k.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,y.isString)(we.tooltip)&&!(we.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<Qt.None&&we.collapsibleState>Qt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,y.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(ie,"treeItemCheckbox");const Ke=(0,y.isNumber)(we.checkboxState)?we.checkboxState:(0,y.isObject)(we.checkboxState)&&(0,y.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,_e=!(0,y.isNumber)(we.checkboxState)&&(0,y.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==ri.Checked&&Ke!==ri.Unchecked||_e!==void 0&&!(0,y.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(U,ie=Qt.None){this.collapsibleState=ie,k.URI.isUri(U)?this.resourceUri=U:this.label=U}};Et=te=qe([T],Et),e.TreeItem=Et;var Qt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(Qt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var ri;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(ri=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ei=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,ie){this.value=U,this.id=ie??(0,O.generateUuid)()}};ei=qe([T],ei),e.DataTransferItem=ei;let bi=class{constructor(U){l.set(this,new Map);for(const[ie,we]of U??[]){const Ke=Oe(this,l,"f").get(ie);Ke?Ke.push(we):Oe(this,l,"f").set(ie,[we])}}get(U){return Oe(this,l,"f").get(U)?.[0]}set(U,ie){Oe(this,l,"f").set(U,[ie])}forEach(U,ie){for(const[we,Ke]of Oe(this,l,"f"))for(const _e of Ke)U.call(ie,_e,we,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[U,ie]of Oe(this,l,"f"))for(const we of ie)yield[U,we]}};bi=qe([T],bi),e.DataTransfer=bi;let Tt=class{constructor(U){this.insertText=U}};Tt=qe([T],Tt),e.DocumentDropEdit=Tt;let si=class{constructor(U){this.insertText=U}};si=qe([T],si),e.DocumentPasteEdit=si;let jt=class{constructor(U,ie){this.id=U,this.color=ie}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};jt=qe([T],jt),e.ThemeIcon=jt,jt.File=new jt("file"),jt.Folder=new jt("folder");let ti=class{constructor(U){this.id=U}};ti=qe([T],ti),e.ThemeColor=ti;var oi;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(oi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ct=class{get base(){return this.c}set base(U){this.c=U,this.e=k.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,ie){if(typeof U!="string"&&(!U||!k.URI.isUri(U)&&!k.URI.isUri(U.uri)))throw(0,C.illegalArgument)("base");if(typeof ie!="string")throw(0,C.illegalArgument)("pattern");typeof U=="string"?this.baseUri=k.URI.file(U):k.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ct=qe([T],ct),e.RelativePattern=ct;const Oi=new WeakMap;function Yt(z,U){Oi.set(z,U)}e.setBreakpointId=Yt;let Wt=class{constructor(U,ie,we,Ke){this.enabled=typeof U=="boolean"?U:!0,typeof ie=="string"&&(this.condition=ie),typeof we=="string"&&(this.hitCondition=we),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=Oi.get(this)??(0,O.generateUuid)()),this.c}};Wt=qe([T],Wt),e.Breakpoint=Wt;let ai=class extends Wt{constructor(U,ie,we,Ke,_e){if(super(ie,we,Ke,_e),U===null)throw(0,C.illegalArgument)("location");this.location=U}};ai=qe([T],ai),e.SourceBreakpoint=ai;let Ei=class extends Wt{constructor(U,ie,we,Ke,_e){super(ie,we,Ke,_e),this.functionName=U}};Ei=qe([T],Ei),e.FunctionBreakpoint=Ei;let ci=class extends Wt{constructor(U,ie,we,Ke,_e,ot,ut){if(super(Ke,_e,ot,ut),!ie)throw(0,C.illegalArgument)("dataId");this.label=U,this.dataId=ie,this.canPersist=we}};ci=qe([T],ci),e.DataBreakpoint=ci;let wi=class{constructor(U,ie,we){this.command=U,this.args=ie||[],this.options=we}};wi=qe([T],wi),e.DebugAdapterExecutable=wi;let ui=class{constructor(U,ie){this.port=U,this.host=ie}};ui=qe([T],ui),e.DebugAdapterServer=ui;let ii=class{constructor(U){this.path=U}};ii=qe([T],ii),e.DebugAdapterNamedPipeServer=ii;let Si=class{constructor(U){this.implementation=U}};Si=qe([T],Si),e.DebugAdapterInlineImplementation=Si;let ni=class{constructor(U,ie){this.range=U,this.expression=ie}};ni=qe([T],ni),e.EvaluatableExpression=ni;var yi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(yi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Di=class{constructor(U,ie){this.range=U,this.text=ie}};Di=qe([T],Di),e.InlineValueText=Di;let Ii=class{constructor(U,ie,we=!0){this.range=U,this.variableName=ie,this.caseSensitiveLookup=we}};Ii=qe([T],Ii),e.InlineValueVariableLookup=Ii;let _t=class{constructor(U,ie){this.range=U,this.expression=ie}};_t=qe([T],_t),e.InlineValueEvaluatableExpression=_t;let Ci=class{constructor(U,ie){this.frameId=U,this.stoppedLocation=ie}};Ci=qe([T],Ci),e.InlineValueContext=Ci;var $i;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})($i=e.FileChangeType||(e.FileChangeType={}));let ki=x=class extends Error{static FileExists(U){return new x(U,w.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(U){return new x(U,w.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(U){return new x(U,w.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(U){return new x(U,w.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(U){return new x(U,w.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(U){return new x(U,w.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(U,ie=w.FileSystemProviderErrorCode.Unknown,we){super(k.URI.isUri(U)?U.toString(!0):U),this.code=we?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};ki=x=qe([T],ki),e.FileSystemError=ki;let Ti=class{constructor(U,ie,we){this.start=U,this.end=ie,this.kind=we}};Ti=qe([T],Ti),e.FoldingRange=Ti;var zi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Pi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Pi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Fi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Fi=e.CommentMode||(e.CommentMode={}));var Ni;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Ni=e.CommentThreadState||(e.CommentThreadState={}));class Ue{constructor(U,ie=[]){this.tokenTypes=U,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ue;function Gt(z){return typeof z>"u"||(0,y.isStringArray)(z)}class li{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let ie=0,we=U.tokenTypes.length;ie<we;ie++)this.j.set(U.tokenTypes[ie],ie);for(let ie=0,we=U.tokenModifiers.length;ie<we;ie++)this.k.set(U.tokenModifiers[ie],ie)}}push(U,ie,we,Ke,_e){if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(U,ie,we,Ke,_e);if(_.isRange(U)&&typeof ie=="string"&&Gt(we))return this.m(U,ie,we);throw(0,C.illegalArgument)()}m(U,ie,we){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,_e=U.start.character,ot=U.end.character-U.start.character,ut=this.j.get(ie);let Rt=0;if(we)for(const Ht of we){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Ht);Rt|=1<<qt>>>0}this.n(Ke,_e,ot,ut,Rt)}n(U,ie,we,Ke,_e){if(this.f&&(U<this.c||U===this.c&&ie<this.e)){this.f=!1;const Rt=this.g.length/5|0;let Ht=0,qt=0;for(let Xt=0;Xt<Rt;Xt++){let Jt=this.g[5*Xt],Ai=this.g[5*Xt+1];Jt===0?(Jt=Ht,Ai+=qt):Jt+=Ht,this.g[5*Xt]=Jt,this.g[5*Xt+1]=Ai,Ht=Jt,qt=Ai}}let ot=U,ut=ie;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ut-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ut,this.g[this.h++]=we,this.g[this.h++]=Ke,this.g[this.h++]=_e,this.c=U,this.e=ie}static o(U){const ie=[],we=U.length/5|0;for(let ut=0;ut<we;ut++)ie[ut]=ut;ie.sort((ut,Rt)=>{const Ht=U[5*ut],qt=U[5*Rt];if(Ht===qt){const Xt=U[5*ut+1],Jt=U[5*Rt+1];return Xt-Jt}return Ht-qt});const Ke=new Uint32Array(U.length);let _e=0,ot=0;for(let ut=0;ut<we;ut++){const Rt=5*ie[ut],Ht=U[Rt+0],qt=U[Rt+1],Xt=U[Rt+2],Jt=U[Rt+3],Ai=U[Rt+4],nn=Ht-_e,Rn=nn===0?qt-ot:qt,Ri=5*ut;Ke[Ri+0]=nn,Ke[Ri+1]=Rn,Ke[Ri+2]=Xt,Ke[Ri+3]=Jt,Ke[Ri+4]=Ai,_e=Ht,ot=qt}return Ke}build(U){return this.f?new mt(new Uint32Array(this.g),U):new mt(li.o(this.g),U)}}e.SemanticTokensBuilder=li;class mt{constructor(U,ie){this.resultId=ie,this.data=U}}e.SemanticTokens=mt;class Wi{constructor(U,ie,we){this.start=U,this.deleteCount=ie,this.data=we}}e.SemanticTokensEdit=Wi;class Hi{constructor(U,ie){this.resultId=ie,this.edits=U}}e.SemanticTokensEdits=Hi;var Mi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Mi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new jt("arrow-left")},di=qe([T],di),e.QuickInputButtons=di;var hi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(hi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(Vi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var ji;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(ji=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(U){if(typeof U.badge=="string"){let ie=(0,R.nextCharLength)(U.badge,0);if(ie<U.badge.length&&(ie+=(0,R.nextCharLength)(U.badge,ie)),U.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!jt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ie,we){this.badge=U,this.tooltip=ie,this.color=we}}e.FileDecoration=qi;let fi=class{constructor(U){this.kind=U}};fi=qe([T],fi),e.ColorTheme=fi;var Ki;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{static isNotebookRange(U){return U instanceof xt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,ie){if(U<0)throw(0,C.illegalArgument)("start must be positive");if(ie<0)throw(0,C.illegalArgument)("end must be positive");U<=ie?(this.c=U,this.e=ie):(this.c=ie,this.e=U)}with(U){let ie=this.c,we=this.e;return U.start!==void 0&&(ie=U.start),U.end!==void 0&&(we=U.end),ie===this.c&&we===this.e?this:new xt(ie,we)}}e.NotebookRange=xt;class mi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ie=>mi.isNotebookCellData(ie))}static isNotebookCellData(U){return!0}constructor(U,ie,we,Ke,_e,ot,ut){this.kind=U,this.value=ie,this.languageId=we,this.mime=Ke,this.outputs=_e??[],this.metadata=ot,this.executionSummary=ut,mi.validate(this)}}e.NotebookCellData=mi;class Gi{constructor(U){this.cells=U}}e.NotebookData=Gi;class zt{static isNotebookCellOutputItem(U){return U instanceof zt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ie={name:U.name,message:U.message,stack:U.stack};return zt.json(ie,"application/vnd.code.notebook.error")}static stdout(U){return zt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return zt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ie="application/octet-stream"){return new zt(U,ie)}static text(U,ie=I.Mimes.text){const we=Oe(zt,v,"f",E).encode(String(U));return new zt(we,ie)}static json(U,ie="text/x-json"){const we=JSON.stringify(U,void 0,"	");return zt.text(we,ie)}constructor(U,ie){this.data=U,this.mime=ie;const we=(0,I.normalizeMimeType)(ie,!0);if(!we)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=zt,v=zt,E={value:new TextEncoder};class gi{static isNotebookCellOutput(U){return U instanceof gi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ie=!1){const we=new Set,Ke=new Set;for(let _e=0;_e<U.length;_e++){const ot=U[_e],ut=(0,I.normalizeMimeType)(ot.mime);if(!we.has(ut)||(0,b.isTextStreamMime)(ut)){we.add(ut);continue}Ke.add(_e),ie&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?U:U.filter((_e,ot)=>!Ke.has(ot))}constructor(U,ie,we){this.items=gi.ensureUniqueMimeTypes(U,!0),typeof ie=="string"?(this.id=ie,this.metadata=we):(this.id=(0,O.generateUuid)(),this.metadata=ie??we)}}e.NotebookCellOutput=gi;var ne;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(ne=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(fe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ne;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Ne=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var rt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(rt=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class yt{constructor(U,ie){this.text=U,this.alignment=ie}}e.NotebookCellStatusBarItem=yt;var Pt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(Pt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var an;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(an=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class cn{constructor(U,ie=[]){this.uri=U,this.provides=(0,i.asArray)(ie)}}e.NotebookRendererScript=cn;class un{constructor(U){this.label=U}}e.NotebookKernelSourceAction=un;let xi=class{constructor(U,ie){this.label=U,this.timestamp=ie}};xi=qe([T],xi),e.TimelineItem=xi;var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(U,ie){this.ranges=U,this.wordPattern=ie}}e.LinkedEditingRanges=fn;class mn{constructor(U,ie){this.c=U,this.e=ie}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Li=class{constructor(U=void 0,ie=void 0,we=void 0){this.include=U,this.exclude=ie,this.profile=we}};Li=qe([T],Li),e.TestRunRequest=Li;let Xi=class extends Li{constructor(U=void 0,ie=void 0,we=void 0,Ke=!1){super(U,ie,we),this.continuous=Ke}};Xi=qe([T],Xi),e.TestRunRequest2=Xi;let Qi=N=class{static diff(U,ie,we){const Ke=new N(U);return Ke.expectedOutput=ie,Ke.actualOutput=we,Ke}constructor(U){this.message=U}};Qi=N=qe([T],Qi),e.TestMessage=Qi;let Yi=class{constructor(U){this.id=U}};Yi=qe([T],Yi),e.TestTag=Yi;let pi=class{constructor(U,ie){this.covered=U,this.total=ie}};pi=qe([T],pi),e.CoveredCount=pi;let _i=$=class{static fromDetails(U,ie){const we=new pi(0,0),Ke=new pi(0,0),_e=new pi(0,0);for(const ut of ie)if("branches"in ut){we.total+=1,we.covered+=ut.executionCount>0?1:0;for(const Rt of ut.branches)Ke.total+=1,Ke.covered+=Rt.executionCount>0?1:0}else _e.total+=1,_e.covered+=ut.executionCount>0?1:0;const ot=new $(U,we,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return ot.detailedCoverage=ie,ot}constructor(U,ie,we,Ke){this.uri=U,this.statementCoverage=ie,this.branchCoverage=we,this.functionCoverage=Ke}};_i=$=qe([T],_i),e.FileCoverage=_i;let Ji=class{constructor(U,ie,we=[]){this.executionCount=U,this.location=ie,this.branches=we}};Ji=qe([T],Ji),e.StatementCoverage=Ji;let Zi=class{constructor(U,ie){this.executionCount=U,this.location=ie}};Zi=qe([T],Zi),e.BranchCoverage=Zi;let en=class{constructor(U,ie){this.executionCount=U,this.location=ie}};en=qe([T],en),e.FunctionCoverage=en;var vn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(U,ie,we,Ke,_e,ot){this.kind=U,this.name=ie,this.detail=we,this.uri=Ke,this.range=_e,this.selectionRange=ot}}e.TypeHierarchyItem=wn;class Sn{constructor(U){this.uri=U}}e.TextTabInput=Sn;class yn{constructor(U,ie){this.original=U,this.modified=ie}}e.TextDiffTabInput=yn;class Dn{constructor(U,ie,we,Ke){this.base=U,this.input1=ie,this.input2=we,this.result=Ke}}e.TextMergeTabInput=Dn;class In{constructor(U,ie){this.uri=U,this.viewType=ie}}e.CustomEditorTabInput=In;class Cn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Cn;class kn{constructor(U,ie){this.uri=U,this.notebookType=ie}}e.NotebookEditorTabInput=kn;class Tn{constructor(U,ie,we){this.original=U,this.modified=ie,this.notebookType=we}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(U,ie){this.uri=U,this.inputBoxUri=ie}}e.InteractiveWindowInput=An}),define(Ie[98],Ce([1,0,47,16,10,255,129,7,18]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function O(f,r){r?k.set(f,r):k.delete(f)}e.setWordDefinitionFor=O;function w(f){return k.get(f)}class m extends L.MirrorTextModel{constructor(r,o,l,v,E,P,p,n){super(o,l,v,E),this.m=r,this.p=P,this.q=p,this.notebook=n,this.b=!1}dispose(){(0,i.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,y.equals)(this.d,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.c},get fileName(){return r.c.fsPath},get isUntitled(){return r.c.scheme===C.Schemas.untitled},get languageId(){return r.p},get version(){return r.g},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.f===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return r.d.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,l){return r.y(o,l)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,i.ok)(!this.b),this.p=r}_acceptIsDirty(r){(0,i.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.d[o.start.line].substring(o.start.character,o.end.character);const l=this.f,v=o.start.line,E=o.end.line,P=[];P.push(this.d[v].substring(o.start.character));for(let p=v+1;p<E;p++)P.push(this.d[p]);return P.push(this.d[E].substring(0,o.end.character)),P.join(l)}t(r){let o;if(r instanceof R.Position?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.d.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new b(o,this.d[o],o===this.d.length-1)}u(r){return r=this.x(r),this.k(),this.h.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.k();const o=this.h.getIndexOf(r),l=this.d[o.index].length;return new R.Position(o.index,Math.min(o.remainder,l))}w(r){if(!(r instanceof R.Range))throw new Error("Invalid argument");const o=this.x(r.start),l=this.x(r.end);return o===r.start&&l===r.end?r:new R.Range(o.line,o.character,l.line,l.character)}x(r){if(!(r instanceof R.Position))throw new Error("Invalid argument");if(this.d.length===0)return r.with(0,0);let{line:o,character:l}=r,v=!1;if(o<0)o=0,l=0,v=!0;else if(o>=this.d.length)o=this.d.length-1,l=this.d[o].length,v=!0;else{const E=this.d[o].length;l<0?(l=0,v=!0):l>E&&(l=E,v=!0)}return v?new R.Position(o,l):r}y(r,o){const l=this.x(r);if(!o)o=w(this.p);else if((0,S.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const v=(0,I.getWordAtText)(l.character+1,(0,I.ensureValidWordDefinition)(o),this.d[l.line],0);if(v)return new R.Range(l.line,v.startColumn-1,l.line,v.endColumn-1)}}e.ExtHostDocumentData=m;class b{constructor(r,o,l){this.a=r,this.b=o,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=b}),define(Ie[190],Ce([1,0,7,17,4]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(R){this.a=new i.ColorTheme(i.ColorThemeKind.Dark),this.b=new S.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let y;switch(R){case"light":y=i.ColorThemeKind.Light;break;case"hcDark":y=i.ColorThemeKind.HighContrast;break;case"hcLight":y=i.ColorThemeKind.HighContrastLight;break;default:y=i.ColorThemeKind.Dark}this.a=new i.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};L=qe([Ve(0,C.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(Ie[8],Ce([1,0,18,25,114,191,85,28,111,84,64,22,9,2,56,75,90,95,94,70,43,55,186,7]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o,l,v,E,P,p,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var t;(function(De){function Pe(X){const{selectionStartLineNumber:Re,selectionStartColumn:Le,positionLineNumber:Qe,positionColumn:ze}=X,Ze=new d.Position(Re-1,Le-1),bt=new d.Position(Qe-1,ze-1);return new d.Selection(Ze,bt)}De.to=Pe;function me(X){const{anchor:Re,active:Le}=X;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}De.from=me})(t=e.Selection||(e.Selection={}));var u;(function(De){function Pe(X){if(!X)return;const{start:Re,end:Le}=X;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}De.from=Pe;function me(X){if(!X)return;const{startLineNumber:Re,startColumn:Le,endLineNumber:Qe,endColumn:ze}=X;return new d.Range(Re-1,Le-1,Qe-1,ze-1)}De.to=me})(u=e.Range||(e.Range={}));var s;(function(De){function Pe(me){switch(me){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}De.to=Pe})(s=e.TokenType||(e.TokenType={}));var h;(function(De){function Pe(X){return new d.Position(X.lineNumber-1,X.column-1)}De.to=Pe;function me(X){return{lineNumber:X.line+1,column:X.character+1}}De.from=me})(h=e.Position||(e.Position={}));var a;(function(De){function Pe(Re,Le){return(0,i.coalesce)((0,i.asArray)(Re).map(Qe=>me(Qe,Le)))}De.from=Pe;function me(Re,Le){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:X(Re.scheme,Le),pattern:Q.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function X(Re,Le){return Le&&typeof Re=="string"?Le.transformOutgoingScheme(Re):Re}})(a=e.DocumentSelector||(e.DocumentSelector={}));var c;(function(De){function Pe(X){switch(X){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}De.from=Pe;function me(X){switch(X){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}De.to=me})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(De){function Pe(X){let Re;return X.code&&((0,m.isString)(X.code)||(0,m.isNumber)(X.code)?Re=String(X.code):Re={value:String(X.code.value),target:X.code.target}),{...u.from(X.range),message:X.message,source:X.source,code:Re,severity:F.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(A.from),tags:Array.isArray(X.tags)?(0,i.coalesce)(X.tags.map(c.from)):void 0}}De.from=Pe;function me(X){const Re=new d.Diagnostic(u.to(X),X.message,F.to(X.severity));return Re.source=X.source,Re.code=(0,m.isString)(X.code)?X.code:X.code?.value,Re.relatedInformation=X.relatedInformation&&X.relatedInformation.map(A.to),Re.tags=X.tags&&(0,i.coalesce)(X.tags.map(c.to)),Re}De.to=me})(g=e.Diagnostic||(e.Diagnostic={}));var A;(function(De){function Pe(X){return{...u.from(X.location.range),message:X.message,resource:X.location.uri}}De.from=Pe;function me(X){return new d.DiagnosticRelatedInformation(new d.Location(X.resource,u.to(X)),X.message)}De.to=me})(A=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var F;(function(De){function Pe(X){switch(X){case d.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}De.from=Pe;function me(X){switch(X){case o.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}De.to=me})(F=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var j;(function(De){function Pe(X){return typeof X=="number"&&X>=d.ViewColumn.One?X-1:X===d.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}De.from=Pe;function me(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=me})(j=e.ViewColumn||(e.ViewColumn={}));function te(De){return typeof De.range<"u"}function x(De){return De.length===0?!0:!!te(De[0])}e.isDecorationOptionsArr=x;var N;(function(De){function Pe(ze){return ze.map(De.from)}De.fromMany=Pe;function me(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function X(ze){let Ze;if(me(ze)){const{language:pt,value:It}=ze;Ze={value:"```"+pt+`
`+It+"\n```\n"}}else d.MarkdownString.isMarkdownString(ze)?Ze={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Ze={value:ze}:Ze={value:""};const bt=Object.create(null);Ze.uris=bt;const vt=pt=>{try{let It=b.URI.parse(pt,!0);It=It.with({query:Re(It.query,bt)}),bt[pt]=It}catch{}return""},At=new y.marked.Renderer;return At.link=vt,At.image=pt=>typeof pt=="string"?vt(I.parseHrefAndDimensions(pt).href):"",(0,y.marked)(Ze.value,{renderer:At}),Ze}De.from=X;function Re(ze,Ze){if(!ze)return ze;let bt;try{bt=(0,k.parse)(ze)}catch{}if(!bt)return ze;let vt=!1;return bt=(0,w.cloneAndChange)(bt,At=>{if(b.URI.isUri(At)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[pt]=At,vt=!0,pt}else return}),vt?JSON.stringify(bt):ze}function Le(ze){const Ze=new d.MarkdownString(ze.value,ze.supportThemeIcons);return Ze.isTrusted=ze.isTrusted,Ze.supportHtml=ze.supportHtml,Ze.baseUri=ze.baseUri?b.URI.from(ze.baseUri):void 0,Ze}De.to=Le;function Qe(ze){if(!!ze)return typeof ze=="string"?ze:De.from(ze)}De.fromStrict=Qe})(N=e.MarkdownString||(e.MarkdownString={}));function $(De){return x(De)?De.map(Pe=>({range:u.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?N.fromMany(Pe.hoverMessage):Pe.hoverMessage?N.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):De.map(Pe=>({range:u.from(Pe)}))}e.fromRangeOrRangeWithMessage=$;function T(De){return typeof De>"u"?De:typeof De=="string"?b.URI.file(De):De}e.pathOrURIToURI=T;var M;(function(De){function Pe(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?T(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}De.from=Pe})(M=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var V;(function(De){function Pe(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?T(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?M.from(me.before):void 0,after:me.after?M.from(me.after):void 0}}De.from=Pe})(V=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var q;(function(De){function Pe(me){if(typeof me>"u")return me;switch(me){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Pe})(q=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var le;(function(De){function Pe(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?q.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?V.from(me.light):void 0,dark:me.dark?V.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?T(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?M.from(me.before):void 0,after:me.after?M.from(me.after):void 0}}De.from=Pe})(le=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var _;(function(De){function Pe(X){return{text:X.newText,eol:X.newEol&&it.from(X.newEol),range:u.from(X.range)}}De.from=Pe;function me(X){const Re=new d.TextEdit(u.to(X.range),X.text);return Re.newEol=typeof X.eol>"u"?void 0:it.to(X.eol),Re}De.to=me})(_=e.TextEdit||(e.TextEdit={}));var pe;(function(De){function Pe(X,Re){const Le={edits:[]};if(X instanceof d.WorkspaceEdit){const Qe=new R.ResourceSet;for(const ze of X._allEntries())ze._type===1&&b.URI.isUri(ze.to)&&ze.from===void 0&&Qe.add(ze.to);for(const ze of X._allEntries())ze._type===1?Le.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contentsBase64:ze.options?.contents&&(0,C.encodeBase64)(C.VSBuffer.wrap(ze.options.contents))},metadata:ze.metadata}):ze._type===2?Le.edits.push({resource:ze.uri,textEdit:_.from(ze.edit),versionId:Qe.has(ze.uri)?void 0:Re?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Le.edits.push({resource:ze.uri,textEdit:{range:u.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Qe.has(ze.uri)?void 0:Re?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Le.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Le.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Re?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(wt.from)}})}return Le}De.from=Pe;function me(X){const Re=new d.WorkspaceEdit;for(const Le of X.edits)Le.textEdit?Re.replace(b.URI.revive(Le.resource),u.to(Le.textEdit.range),Le.textEdit.text):Re.renameFile(b.URI.revive(Le.oldResource),b.URI.revive(Le.newResource),Le.options);return Re}De.to=me})(pe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(De){const Pe=Object.create(null);Pe[d.SymbolKind.File]=0,Pe[d.SymbolKind.Module]=1,Pe[d.SymbolKind.Namespace]=2,Pe[d.SymbolKind.Package]=3,Pe[d.SymbolKind.Class]=4,Pe[d.SymbolKind.Method]=5,Pe[d.SymbolKind.Property]=6,Pe[d.SymbolKind.Field]=7,Pe[d.SymbolKind.Constructor]=8,Pe[d.SymbolKind.Enum]=9,Pe[d.SymbolKind.Interface]=10,Pe[d.SymbolKind.Function]=11,Pe[d.SymbolKind.Variable]=12,Pe[d.SymbolKind.Constant]=13,Pe[d.SymbolKind.String]=14,Pe[d.SymbolKind.Number]=15,Pe[d.SymbolKind.Boolean]=16,Pe[d.SymbolKind.Array]=17,Pe[d.SymbolKind.Object]=18,Pe[d.SymbolKind.Key]=19,Pe[d.SymbolKind.Null]=20,Pe[d.SymbolKind.EnumMember]=21,Pe[d.SymbolKind.Struct]=22,Pe[d.SymbolKind.Event]=23,Pe[d.SymbolKind.Operator]=24,Pe[d.SymbolKind.TypeParameter]=25;function me(Re){return typeof Pe[Re]=="number"?Pe[Re]:6}De.from=me;function X(Re){for(const Le in Pe)if(Pe[Le]===Re)return Number(Le);return d.SymbolKind.Property}De.to=X})(ue=e.SymbolKind||(e.SymbolKind={}));var de;(function(De){function Pe(X){switch(X){case d.SymbolTag.Deprecated:return 1}}De.from=Pe;function me(X){switch(X){case 1:return d.SymbolTag.Deprecated}}De.to=me})(de=e.SymbolTag||(e.SymbolTag={}));var re;(function(De){function Pe(X){return{name:X.name,kind:ue.from(X.kind),tags:X.tags&&X.tags.map(de.from),containerName:X.containerName,location:Ae.from(X.location)}}De.from=Pe;function me(X){const Re=new d.SymbolInformation(X.name,ue.to(X.kind),X.containerName,Ae.to(X.location));return Re.tags=X.tags&&X.tags.map(de.to),Re}De.to=me})(re=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(De){function Pe(X){const Re={name:X.name||"!!MISSING: name!!",detail:X.detail,range:u.from(X.range),selectionRange:u.from(X.selectionRange),kind:ue.from(X.kind),tags:X.tags?.map(de.from)??[]};return X.children&&(Re.children=X.children.map(Pe)),Re}De.from=Pe;function me(X){const Re=new d.DocumentSymbol(X.name,X.detail,ue.to(X.kind),u.to(X.range),u.to(X.selectionRange));return(0,i.isNonEmptyArray)(X.tags)&&(Re.tags=X.tags.map(de.to)),X.children&&(Re.children=X.children.map(me)),Re}De.to=me})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var H;(function(De){function Pe(X){const Re=new d.CallHierarchyItem(ue.to(X.kind),X.name,X.detail||"",b.URI.revive(X.uri),u.to(X.range),u.to(X.selectionRange));return Re._sessionId=X._sessionId,Re._itemId=X._itemId,Re}De.to=Pe;function me(X,Re,Le){if(Re=Re??X._sessionId,Le=Le??X._itemId,Re===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Le,name:X.name,detail:X.detail,kind:ue.from(X.kind),uri:X.uri,range:u.from(X.range),selectionRange:u.from(X.selectionRange),tags:X.tags?.map(de.from)}}De.from=me})(H=e.CallHierarchyItem||(e.CallHierarchyItem={}));var oe;(function(De){function Pe(me){return new d.CallHierarchyIncomingCall(H.to(me.from),me.fromRanges.map(X=>u.to(X)))}De.to=Pe})(oe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(De){function Pe(me){return new d.CallHierarchyOutgoingCall(H.to(me.to),me.fromRanges.map(X=>u.to(X)))}De.to=Pe})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ae;(function(De){function Pe(X){return{range:X.range&&u.from(X.range),uri:X.uri}}De.from=Pe;function me(X){return new d.Location(b.URI.revive(X.uri),u.to(X.range))}De.to=me})(Ae=e.location||(e.location={}));var Be;(function(De){function Pe(X){const Re=X,Le=X;return{originSelectionRange:Re.originSelectionRange?u.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Le.uri,range:u.from(Re.targetRange?Re.targetRange:Le.range),targetSelectionRange:Re.targetSelectionRange?u.from(Re.targetSelectionRange):void 0}}De.from=Pe;function me(X){return{targetUri:b.URI.revive(X.uri),targetRange:u.to(X.range),targetSelectionRange:X.targetSelectionRange?u.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?u.to(X.originSelectionRange):void 0}}De.to=me})(Be=e.DefinitionLink||(e.DefinitionLink={}));var xe;(function(De){function Pe(X){return{range:u.from(X.range),contents:N.fromMany(X.contents)}}De.from=Pe;function me(X){return new d.Hover(X.contents.map(N.to),u.to(X.range))}De.to=me})(xe=e.Hover||(e.Hover={}));var Te;(function(De){function Pe(X){return{range:u.from(X.range),expression:X.expression}}De.from=Pe;function me(X){return new d.EvaluatableExpression(u.to(X.range),X.expression)}De.to=me})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(De){function Pe(X){if(X instanceof d.InlineValueText)return{type:"text",range:u.from(X.range),text:X.text};if(X instanceof d.InlineValueVariableLookup)return{type:"variable",range:u.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Pe;function me(X){switch(X.type){case"text":return{range:u.to(X.range),text:X.text};case"variable":return{range:u.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:u.to(X.range),expression:X.expression}}}De.to=me})(Se=e.InlineValue||(e.InlineValue={}));var ke;(function(De){function Pe(X){return{frameId:X.frameId,stoppedLocation:u.from(X.stoppedLocation)}}De.from=Pe;function me(X){return new d.InlineValueContext(X.frameId,u.to(X.stoppedLocation))}De.to=me})(ke=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(De){function Pe(X){return{range:u.from(X.range),kind:X.kind}}De.from=Pe;function me(X){return new d.DocumentHighlight(u.to(X.range),X.kind)}De.to=me})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(De){function Pe(me){switch(me){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}De.to=Pe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(De){function Pe(me){return{triggerKind:ce.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}De.to=Pe})(J=e.CompletionContext||(e.CompletionContext={}));var D;(function(De){function Pe(X){switch(X){case d.CompletionItemTag.Deprecated:return 1}}De.from=Pe;function me(X){switch(X){case 1:return d.CompletionItemTag.Deprecated}}De.to=me})(D=e.CompletionItemTag||(e.CompletionItemTag={}));var B;(function(De){const Pe=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function me(Le){return Pe.get(Le)??9}De.from=me;const X=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Re(Le){return X.get(Le)??d.CompletionItemKind.Property}De.to=Re})(B=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(De){function Pe(me,X){const Re=new d.CompletionItem(me.label);return Re.insertText=me.insertText,Re.kind=B.to(me.kind),Re.tags=me.tags?.map(D.to),Re.detail=me.detail,Re.documentation=I.isMarkdownString(me.documentation)?N.to(me.documentation):me.documentation,Re.sortText=me.sortText,Re.filterText=me.filterText,Re.preselect=me.preselect,Re.commitCharacters=me.commitCharacters,f.Range.isIRange(me.range)?Re.range=u.to(me.range):typeof me.range=="object"&&(Re.range={inserting:u.to(me.range.insert),replacing:u.to(me.range.replace)}),Re.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Re.insertText=new d.SnippetString(me.insertText):(Re.insertText=me.insertText,Re.textEdit=Re.range instanceof d.Range?new d.TextEdit(Re.range,Re.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Re.additionalTextEdits=me.additionalTextEdits.map(Le=>_.to(Le))),Re.command=X&&me.command?X.fromInternal(me.command):void 0,Re}De.to=Pe})(W=e.CompletionItem||(e.CompletionItem={}));var K;(function(De){function Pe(X){if(typeof X.label!="string"&&!Array.isArray(X.label))throw new TypeError("Invalid label");return{label:X.label,documentation:N.fromStrict(X.documentation)}}De.from=Pe;function me(X){return{label:X.label,documentation:I.isMarkdownString(X.documentation)?N.to(X.documentation):X.documentation}}De.to=me})(K=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(De){function Pe(X){return{label:X.label,documentation:N.fromStrict(X.documentation),parameters:Array.isArray(X.parameters)?X.parameters.map(K.from):[],activeParameter:X.activeParameter}}De.from=Pe;function me(X){return{label:X.label,documentation:I.isMarkdownString(X.documentation)?N.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(K.to):[],activeParameter:X.activeParameter}}De.to=me})(Z=e.SignatureInformation||(e.SignatureInformation={}));var he;(function(De){function Pe(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(Z.from):[]}}De.from=Pe;function me(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(Z.to):[]}}De.to=me})(he=e.SignatureHelp||(e.SignatureHelp={}));var ye;(function(De){function Pe(me,X){const Re=new d.InlayHint(h.to(X.position),typeof X.label=="string"?X.label:X.label.map(ae.to.bind(void 0,me)),X.kind&&be.to(X.kind));return Re.textEdits=X.textEdits&&X.textEdits.map(_.to),Re.tooltip=I.isMarkdownString(X.tooltip)?N.to(X.tooltip):X.tooltip,Re.paddingLeft=X.paddingLeft,Re.paddingRight=X.paddingRight,Re}De.to=Pe})(ye=e.InlayHint||(e.InlayHint={}));var ae;(function(De){function Pe(me,X){const Re=new d.InlayHintLabelPart(X.label);return Re.tooltip=I.isMarkdownString(X.tooltip)?N.to(X.tooltip):X.tooltip,r.Command.is(X.command)&&(Re.command=me.fromInternal(X.command)),X.location&&(Re.location=Ae.to(X.location)),Re}De.to=Pe})(ae=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(De){function Pe(X){return X}De.from=Pe;function me(X){return X}De.to=me})(be=e.InlayHintKind||(e.InlayHintKind={}));var Ee;(function(De){function Pe(X){return{range:u.from(X.range),url:X.target,tooltip:X.tooltip}}De.from=Pe;function me(X){let Re;if(X.url)try{Re=typeof X.url=="string"?b.URI.parse(X.url,!0):b.URI.revive(X.url)}catch{}return new d.DocumentLink(u.to(X.range),Re)}De.to=me})(Ee=e.DocumentLink||(e.DocumentLink={}));var We;(function(De){function Pe(X){const Re=new d.ColorPresentation(X.label);return X.textEdit&&(Re.textEdit=_.to(X.textEdit)),X.additionalTextEdits&&(Re.additionalTextEdits=X.additionalTextEdits.map(Le=>_.to(Le))),Re}De.to=Pe;function me(X){return{label:X.label,textEdit:X.textEdit?_.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Re=>_.from(Re)):void 0}}De.from=me})(We=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(De){function Pe(X){return new d.Color(X[0],X[1],X[2],X[3])}De.to=Pe;function me(X){return[X.red,X.green,X.blue,X.alpha]}De.from=me})(He=e.Color||(e.Color={}));var tt;(function(De){function Pe(X){return{range:u.from(X.range)}}De.from=Pe;function me(X){return new d.SelectionRange(u.to(X.range))}De.to=me})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(De){function Pe(me){switch(me){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}De.to=Pe})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(De){function Pe(X){switch(X){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Pe;function me(X){switch(X){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}De.to=me})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(De){function Pe(X){if(X===d.EndOfLine.CRLF)return 1;if(X===d.EndOfLine.LF)return 0}De.from=Pe;function me(X){if(X===1)return d.EndOfLine.CRLF;if(X===0)return d.EndOfLine.LF}De.to=me})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(De){function Pe(me){if(typeof me=="object")return me.viewId;switch(me){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(De){function Pe(me){const X={start:me.start+1,end:me.end+1};return me.kind&&(X.kind=st.from(me.kind)),X}De.from=Pe})(Fe=e.FoldingRange||(e.FoldingRange={}));var st;(function(De){function Pe(me){if(me)switch(me){case d.FoldingRangeKind.Comment:return r.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return r.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return r.FoldingRangeKind.Region}}De.from=Pe})(st=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Y;(function(De){function Pe(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?u.from(me.selection):void 0,override:typeof me.override=="boolean"?v.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}De.from=Pe})(Y=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(De){function Pe(Le){return Le instanceof d.RelativePattern?Le.toJSON():typeof Le=="string"?Le:me(Le)||X(Le)?new d.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}De.from=Pe;function me(Le){const Qe=Le;return Qe?b.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function X(Le){const Qe=Le;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Re(Le){return typeof Le=="string"?Le:new d.RelativePattern(b.URI.revive(Le.baseUri),Le.pattern)}De.to=Re})(Q=e.GlobPattern||(e.GlobPattern={}));var ge;(function(De){function Pe(me){if(me){if(Array.isArray(me))return me.map(Pe);if(typeof me=="string")return me;{const X=me;return{language:X.language,scheme:X.scheme,pattern:Q.from(X.pattern),exclusive:X.exclusive,notebookType:X.notebookType}}}else return}De.from=Pe})(ge=e.LanguageSelector||(e.LanguageSelector={}));var Me;(function(De){function Pe(X){return{start:X.start,end:X.end}}De.from=Pe;function me(X){return new d.NotebookRange(X.start,X.end)}De.to=me})(Me=e.NotebookRange||(e.NotebookRange={}));var $e;(function(De){function Pe(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}De.to=Pe;function me(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}De.from=me})($e=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(De){function Pe(me){if(me===E.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(me===E.NotebookCellExecutionState.Pending)return;if(me===E.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}De.to=Pe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ye;(function(De){function Pe(X){switch(X){case d.NotebookCellKind.Markup:return E.CellKind.Markup;case d.NotebookCellKind.Code:default:return E.CellKind.Code}}De.from=Pe;function me(X){switch(X){case E.CellKind.Markup:return d.NotebookCellKind.Markup;case E.CellKind.Code:default:return d.NotebookCellKind.Code}}De.to=me})(Ye=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(De){function Pe(X){const Re={metadata:X.metadata??Object.create(null),cells:[]};for(const Le of X.cells)d.NotebookCellData.validate(Le),Re.cells.push(wt.from(Le));return Re}De.from=Pe;function me(X){const Re=new d.NotebookData(X.cells.map(wt.to));return(0,m.isEmptyObject)(X.metadata)||(Re.metadata=X.metadata),Re}De.to=me})(nt=e.NotebookData||(e.NotebookData={}));var wt;(function(De){function Pe(X){return{cellKind:Ye.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:$e.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Ct.from):[]}}De.from=Pe;function me(X){return new d.NotebookCellData(Ye.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Ct.to):void 0,X.metadata,X.internalMetadata?$e.to(X.internalMetadata):void 0)}De.to=me})(wt=e.NotebookCellData||(e.NotebookCellData={}));var St;(function(De){function Pe(X){return{mime:X.mime,valueBytes:C.VSBuffer.wrap(X.data)}}De.from=Pe;function me(X){return new d.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}De.to=me})(St=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(De){function Pe(X){return{outputId:X.id,items:X.items.map(St.from),metadata:X.metadata}}De.from=Pe;function me(X){const Re=X.items.map(St.to);return new d.NotebookCellOutput(Re,X.outputId,X.metadata)}De.to=me})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var lt;(function(De){function Pe(Re){return X(Re)?{include:(0,m.withNullAsUndefined)(Q.from(Re.include)),exclude:(0,m.withNullAsUndefined)(Q.from(Re.exclude))}:(0,m.withNullAsUndefined)(Q.from(Re))}De.from=Pe;function me(Re){return X(Re)?{include:Q.to(Re.include),exclude:Q.to(Re.exclude)}:Q.to(Re)}De.to=me;function X(Re){const Le=Re;return Le?!(0,m.isUndefinedOrNull)(Le.include)&&!(0,m.isUndefinedOrNull)(Le.exclude):!1}})(lt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(De){function Pe(me,X,Re){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Le,Re),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}De.from=Pe})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Bt;(function(De){function Pe(me,X,Re){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:X.toInternal(Le,Re),label:me.label,description:me.description,detail:me.detail}}De.from=Pe})(Bt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ot;(function(De){function Pe(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}De.from=Pe})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(De){function Pe(X){return{uri:X.uri,provides:X.provides}}De.from=Pe;function me(X){return new d.NotebookRendererScript(b.URI.revive(X.uri),X.provides)}De.to=me})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(De){function Pe(X){return{message:N.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location&&{range:u.from(X.location.range),uri:X.location.uri}}}De.from=Pe;function me(X){const Re=new d.TestMessage(typeof X.message=="string"?X.message:N.to(X.message));return Re.actualOutput=X.actual,Re.expectedOutput=X.expected,Re.location=X.location?Ae.to(X.location):void 0,Re}De.to=me})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(De){De.namespace=p.namespaceTestTag,De.denamespace=p.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var $t;(function(De){function Pe(X){const Re=(0,l.getPrivateApiFor)(X).controllerId;return{extId:P.TestId.fromExtHostTestItem(X,Re).toString(),label:X.label,uri:b.URI.revive(X.uri),busy:X.busy,tags:X.tags.map(Le=>Dt.namespace(Re,Le.id)),range:f.Range.lift(u.from(X.range)),description:X.description||null,sortText:X.sortText||null,error:X.error&&N.fromStrict(X.error)||null}}De.from=Pe;function me(X){return{parent:void 0,error:void 0,id:P.TestId.fromString(X.extId).localId,label:X.label,uri:b.URI.revive(X.uri),tags:(X.tags||[]).map(Re=>{const{tagId:Le}=Dt.denamespace(Re);return new d.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(X.range||void 0),canResolveChildren:!1,busy:X.busy,description:X.description||void 0,sortText:X.sortText||void 0}}De.toPlain=me})($t=e.TestItem||(e.TestItem={})),function(De){function Pe(X){return{id:X.id}}De.from=Pe;function me(X){return new d.TestTag(X.id)}De.to=me}(Dt=e.TestTag||(e.TestTag={}));var Nt;(function(De){const Pe=(X,Re)=>{const Le=[];for(const[ze,Ze]of Re)P.TestId.compare(Ze.item.extId,ze)===2&&(Re.delete(ze),Le.push(Ze));const Qe={...$t.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ze=>Ze.type===0).map(ft.to)})),children:Le.map(ze=>Pe(ze,Re))};for(const ze of Qe.children)ze.parent=Qe;return Qe};function me(X){const Re=[],Le=new Map;for(const Qe of X.items){Le.set(Qe.item.extId,Qe);const ze=P.TestId.root(Qe.item.extId);X.request.targets.some(Ze=>Ze.controllerId===ze&&Ze.testIds.includes(Qe.item.extId))&&Re.push(Qe)}return{completedAt:X.completedAt,results:Re.map(Qe=>Pe(Qe,Le))}}De.to=me})(Nt=e.TestResults||(e.TestResults={}));var Ge;(function(De){function Pe(Le){return{covered:Le.covered,total:Le.covered}}function me(Le){return"line"in Le?h.from(Le):u.from(Le)}function X(Le){return"branches"in Le?{count:Le.executionCount,location:me(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&me(Qe.location)})):void 0}:{type:0,count:Le.executionCount,location:me(Le.location)}}De.fromDetailed=X;function Re(Le){return{uri:Le.uri,statement:Pe(Le.statementCoverage),branch:Le.branchCoverage&&Pe(Le.branchCoverage),function:Le.functionCoverage&&Pe(Le.functionCoverage),details:Le.detailedCoverage?.map(X)}}De.fromFile=Re})(Ge=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(De){function Pe(me){switch(me){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}De.to=Pe})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(De){function Pe(X){const Re=new d.TypeHierarchyItem(ue.to(X.kind),X.name,X.detail||"",b.URI.revive(X.uri),u.to(X.range),u.to(X.selectionRange));return Re._sessionId=X._sessionId,Re._itemId=X._itemId,Re}De.to=Pe;function me(X,Re,Le){if(Re=Re??X._sessionId,Le=Le??X._itemId,Re===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:Le,kind:ue.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:u.from(X.range),selectionRange:u.from(X.selectionRange),tags:X.tags?.map(de.from)}}De.from=me})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ut;(function(De){function Pe(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}De.from=Pe})(Ut=e.ViewBadge||(e.ViewBadge={}));var gt;(function(De){function Pe(Le,Qe,ze){const Ze=Qe.fileData;return Ze?new class extends d.DataTransferItem{asFile(){return{name:Ze.name,uri:b.URI.revive(Ze.uri),data:(0,L.once)(()=>ze())}}}("",Qe.id):Le===O.Mimes.uriList&&Qe.uriListData?new d.DataTransferItem(Re(Qe.uriListData)):new d.DataTransferItem(Qe.asString)}De.to=Pe;async function me(Le,Qe){const ze=await Qe.asString();if(Le===O.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:X(ze)};const Ze=Qe.asFile();return{id:Qe.id,asString:ze,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}De.from=me;function X(Le){return S.UriList.split(Le).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return b.URI.parse(Qe)}catch{}return Qe})}function Re(Le){return S.UriList.create(Le.map(Qe=>typeof Qe=="string"?Qe:b.URI.revive(Qe)))}})(gt=e.DataTransferItem||(e.DataTransferItem={}));var kt;(function(De){function Pe(X,Re){const Le=X.items.map(([Qe,ze])=>[Qe,gt.to(Qe,ze,()=>Re(ze.id))]);return new d.DataTransfer(Le)}De.toDataTransfer=Pe;async function me(X){const Re={items:[]},Le=[];return X.forEach((Qe,ze)=>{Le.push((async()=>{Re.items.push([ze,await gt.from(ze,Qe)])})())}),await Promise.all(Le),Re}De.toDataTransferDTO=me})(kt=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[192],Ce([1,0,2,11,7,8,158]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(k,O,w,m={timeout:1500,errors:3}){this.c=k,this.d=O,this.f=w,this.g=m,this.a=new I.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(O,w,m)=>{const f={dispose:this.a.push([O,w,k])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(k,O){const w=i.URI.revive(k);let m=!1;const b=setTimeout(()=>m=!0,this.g.timeout),f=[];try{for(const r of[...this.a]){if(m)break;const o=this.d.getDocument(w),l=await this.h(r,{document:o,reason:L.TextDocumentSaveReason.to(O)});f.push(l)}}finally{clearTimeout(b)}return f}h([k,O,w],m){const b=this.b.get(k);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(w,k,O,m).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const r=this.b.get(k);this.b.set(k,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,O,w,m){const b=[],f=Date.now(),{document:r,reason:o}=m,{version:l}=r,v=Object.freeze({document:r,reason:o,waitUntil(E){if(Object.isFrozen(b))throw(0,C.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(E))}});try{O.apply(w,[v])}catch(E){return Promise.reject(E)}return Object.freeze(b),new Promise((E,P)=>{const p=setTimeout(()=>P(new Error("timeout")),this.g.timeout);return Promise.all(b).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(p),E(n)}).catch(n=>{clearTimeout(p),P(n)})}).then(E=>{const P={edits:[]};for(const p of E)if(Array.isArray(p)&&p.every(n=>n instanceof S.TextEdit))for(const{newText:n,newEol:d,range:t}of p)P.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:t&&L.Range.from(t),text:n,eol:d&&L.EndOfLine.from(d)}});if(P.edits.length!==0)return l===r.version?this.f.$tryApplyWorkspaceEdit(P):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(Ie[193],Ce([1,0,16,2,8,7,70]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(w,m,b,f){this.start=w,this.deletedCount=m,this.deletedItems=b,this.items=f}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(w,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:w}}constructor(w,m,b){this.notebook=w,this.h=m,this.j=b,this.handle=b.handle,this.uri=C.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(S.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(S.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const w=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:S.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return w.g},set mime(f){w.g=f},get outputs(){return w.a.slice(0)},get metadata(){return w.b},get executionSummary(){return w.d}};this.f=Object.freeze(b)}return this.f}setOutputs(w){this.a=w.map(S.NotebookCellOutput.to)}setOutputItems(w,m,b){const f=b.map(S.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===w);if(r&&(m||(r.items.length=0),r.items.push(...f),r.items.length>1&&r.items.every(o=>I.isTextStreamMime(o.mime)))){const o=new Map,l=[];r.items.forEach(v=>{let E;o.has(v.mime)?E=o.get(v.mime):(E=[],o.set(v.mime,E),l.push(v.mime)),E.push(v.data)}),r.items.length=0,l.forEach(v=>{const E=I.compressOutputItemStreams(o.get(v));r.items.push({mime:v,data:E.buffer})})}}setMetadata(w){this.b=Object.freeze(w)}setInternalMetadata(w){this.e=w,this.d=Object.freeze(S.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=y;class k{constructor(w,m,b,f,r){this.k=w,this.l=m,this.m=b,this.uri=f,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const w=this,m={get uri(){return w.uri},get version(){return w.g},get notebookType(){return w.d},get isDirty(){return w.h},get isUntitled(){return w.uri.scheme===i.Schemas.untitled},get isClosed(){return w.j},get metadata(){return w.f},get cellCount(){return w.b.length},cellAt(b){return b=w.n(b),w.b[b].apiCell},getCells(b){return(b?w.p(b):w.b).map(r=>r.apiCell)},save(){return w.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(w){w.metadata&&(this.f=Object.freeze({...this.f,...w.metadata}))}acceptDirty(w){this.h=w}acceptModelChanged(w,m,b){this.g=w.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:b});const f={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},r=[];for(const l of w.rawEvents)l.kind===I.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,f.contentChanges):l.kind===I.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,f.contentChanges):l.kind===I.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),r.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===I.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),r.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),r.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===I.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===I.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),r.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),r.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const o=new Map;for(let l=0;l<r.length;l++){const v=r[l],E=o.get(v.cell);if(E===void 0){const P=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});o.set(v.cell,P-1)}else f.cellChanges[E]={...f.cellChanges[E],...v}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(w){return w=w|0,w<0?0:w>=this.b.length?this.b.length-1:w}o(w){let m=w.start|0,b=w.end|0;return m<0&&(m=0),b>this.b.length&&(b=this.b.length),w.with({start:m,end:b})}p(w){w=this.o(w);const m=[];for(let b=w.start;b<w.end;b++)m.push(this.b[b]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(w,m,b){if(this.j)return;const f=[],r=[],o=[];if(w.reverse().forEach(l=>{const E=l[2].map(n=>{const d=new y(this,this.l,n);return m||r.push(y.asModelAddData(this.apiNotebook,n)),d}),P=new R(l[0],l[1],[],E),p=this.b.splice(l[0],l[1],...E);for(const n of p)o.push(n.uri),P.deletedItems.push(n.apiCell);f.push(P)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),b)for(const l of f)b.push(l.asApiEvent())}s(w,m,b,f){const r=this.b.splice(w,m);this.b.splice(b,0,...r);const o=[new R(w,m,r.map(l=>l.apiCell),[]),new R(b,0,[],r)];for(const l of o)f.push(l.asApiEvent())}t(w,m){this.b[w].setOutputs(m)}u(w,m,b,f){this.b[w].setOutputItems(m,b,f)}v(w,m){const b=this.b[w];b.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(b.uri,m)}w(w,m){const b=this.b[w];b.apiCell.mime=m}x(w,m){this.b[w].setMetadata(m)}y(w,m){this.b[w].setInternalMetadata(m)}getCellFromApiCell(w){return this.b.find(m=>m.apiCell===w)}getCellFromIndex(w){return this.b[w]}getCell(w){return this.b.find(m=>m.handle===w)}getCellIndex(w){return this.b.indexOf(w)}}e.ExtHostNotebookDocument=k,k.a=0}),define(Ie[99],Ce([1,0,11,8,7]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(R,y,k,O,w,m){this.id=R,this.f=y,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=w,this.b=O,this.c=m}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(y){this.selections=[y]},get selections(){return R.a},set selections(y){if(!Array.isArray(y)||!y.every(S.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");R.a=y,R.g(y)},get visibleRanges(){return R.b},revealRange(y,k){R.f.$tryRevealRange(R.id,C.NotebookRange.from(y),k??S.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(C.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(Ie[194],Ce([1,0,4,13,8]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=class{constructor(R,y){this.c=R,this.d=y,this.a=new i.Emitter,this.b=new i.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,y);const k=this.d.getEditorById(R);y.visibleRanges&&k._acceptVisibleRanges(y.visibleRanges.ranges.map(S.NotebookRange.to)),y.selections&&k._acceptSelections(y.selections.selections.map(S.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const y in R)this.d.getEditorById(y)._acceptViewColumn(S.ViewColumn.to(R[y]))}};L=qe([Ve(0,C.ILogService)],L),e.ExtHostNotebookEditors=L}),define(Ie[195],Ce([1,0,8,161,139,21,63,11]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,b,f){const r=this.b++,{title:o,location:l,cancellable:v}=b,E={label:(0,S.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(r,{location:i.ProgressLocation.from(l),title:o,source:E,cancellable:v},m.isUnderDevelopment?void 0:m.identifier.value).catch(R.onUnexpectedExternalError),this.d(r,f,!!v)}d(m,b,f){let r;f&&(r=new L.CancellationTokenSource,this.c.set(m,r));const o=v=>{this.a.$progressEnd(v),this.c.delete(v),r?.dispose()};let l;try{l=b(new O(this.a,m),f&&r?r.token:L.CancellationToken.None)}catch(v){throw o(m),v}return l.then(v=>o(m),v=>o(m)),l}$acceptProgressCanceled(m){const b=this.c.get(m);b&&(b.cancel(),this.c.delete(m))}}e.ExtHostProgress=y;function k(w,m){return w.message=m.message,typeof m.increment=="number"&&(typeof w.increment=="number"?w.increment+=m.increment:w.increment=m.increment),w}class O extends C.Progress{constructor(m,b){super(f=>this.throttledReport(f)),this.c=m,this.d=b}throttledReport(m){this.c.$progressReport(this.d,m)}}qe([(0,I.throttle)(100,(w,m)=>k(w,m),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ie[100],Ce([1,0,56,95,43,71,55,8,2]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(E,P,p,n)=>{let d=P;return{enumerable:!0,configurable:!1,get(){return d},set(t){if(!p(d,t)){const u=d;d=t,E.listener?.(n(t,u))}}}},O=(E,P)=>E===P,w={range:(E,P)=>E===P?!0:!E||!P?!1:E.isEqual(P),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(E,P)=>!(E.length!==P.length||E.some(p=>!P.find(n=>p.id===n.id)))},m=E=>P=>({op:4,update:E(P)}),b=(E,P)=>({range:(()=>{let p;const n=m(d=>({range:i.Range.lift(R.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return p},set(d){E.listener?.({op:6}),w.range(p,d)||(p=d,E.listener?.(n(d)))}}})(),label:k(E,P,w.label,m(p=>({label:p}))),description:k(E,void 0,w.description,m(p=>({description:p}))),sortText:k(E,void 0,w.sortText,m(p=>({sortText:p}))),canResolveChildren:k(E,!1,w.canResolveChildren,p=>({op:2,state:p})),busy:k(E,!1,w.busy,m(p=>({busy:p}))),error:k(E,void 0,w.error,m(p=>({error:R.MarkdownString.fromStrict(p)||null}))),tags:k(E,[],w.tags,(p,n)=>({op:1,new:p.map(R.TestTag.from),old:n.map(R.TestTag.from)}))}),f=E=>{const P=S.TestId.fromString(E.extId),p=new o(P.controllerId,P.localId,E.label,y.URI.revive(E.uri)||void 0);return p.range=R.Range.to(E.range||void 0),p.description=E.description||void 0,p.sortText=E.sortText||void 0,p.tags=E.tags.map(n=>R.TestTag.to({id:(0,I.denamespaceTestTag)(n).tagId})),p},r=E=>{let P;for(const p of E.tests){const n=f(p.item);(0,C.getPrivateApiFor)(n).parent=P,P=n}return P};e.toItemFromContext=r;class o{constructor(P,p,n,d){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const t=(0,C.createPrivateApiFor)(this,P);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return t.parent instanceof l?void 0:t.parent}},children:{value:(0,L.createTestItemChildren)(t,C.getPrivateApiFor,o),enumerable:!0,writable:!1},...b(t,n)})}}e.TestItemImpl=o;class l extends o{constructor(P,p){super(P,P,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class v extends L.TestItemCollection{constructor(P,p,n){super({controllerId:P,getDocumentVersion:d=>d&&n.getDocument(d)?.version,getApiFor:C.getPrivateApiFor,getChildren:d=>d.children,root:new l(P,p),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ie[101],Ce([1,0,47,11,83,8,7]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class R{constructor(m,b,f){const r=R.c.nextId();m.$registerTextEditorDecorationType(b.identifier,r,L.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){m.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=R,R.c=new S.IdGenerator("TextEditorDecorationType");class y{constructor(m,b){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,b){this.k();let f=null;if(m instanceof I.Position)f=new I.Range(m,m);else if(m instanceof I.Range)f=m;else throw new Error("Unrecognized location");this.l(f,b,!1)}insert(m,b){this.k(),this.l(new I.Range(m,m),b,!0)}delete(m){this.k();let b=null;if(m instanceof I.Range)b=m;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(m,b,f){const r=this.c.validateRange(m);this.g.push({range:r,text:b,forceMoveMarkers:f})}setEndOfLine(m){if(this.k(),m!==I.EndOfLine.LF&&m!==I.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this.h=m}}class k{constructor(m,b,f,r){this.c=m,this.d=b,this._accept(f),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(l){o.m(l)},get indentSize(){return o.g},set indentSize(l){o.o(l)},get insertSpaces(){return o.h},set insertSpaces(l){o.q(l)},get cursorStyle(){return o.j},set cursorStyle(l){o.s(l)},get lineNumbers(){return o.k},set lineNumbers(l){o.t(l)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const b=Math.floor(m);return b>0?b:null}if(typeof m=="string"){const b=parseInt(m,10);return isNaN(b)?null:b>0?b:null}return null}m(m){const b=this.l(m);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const b=Math.floor(m);return b>0?b:null}if(typeof m=="string"){const b=parseInt(m,10);return isNaN(b)?null:b>0?b:null}return null}o(m){const b=this.n(m);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}q(m){const b=this.p(m);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(m)})))}assign(m){const b={};let f=!1;if(typeof m.tabSize<"u"){const r=this.l(m.tabSize);r==="auto"?(f=!0,b.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,f=!0,b.tabSize=r)}if(typeof m.indentSize<"u"){const r=this.n(m.indentSize);r==="tabSize"?(f=!0,b.indentSize=r):typeof r=="number"&&this.g!==r&&(this.g=r,f=!0,b.indentSize=r)}if(typeof m.insertSpaces<"u"){const r=this.p(m.insertSpaces);r==="auto"?(f=!0,b.insertSpaces=r):this.h!==r&&(this.h=r,f=!0,b.insertSpaces=r)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,f=!0,b.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,f=!0,b.lineNumbers=L.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(m,b){b.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(f)})}}e.ExtHostTextEditorOptions=k;class O{constructor(m,b,f,r,o,l,v,E){this.id=m,this.j=b,this.k=f,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,l,f),this.e=v,this.f=E;const P=this;this.value=Object.freeze({get document(){return r.getValue()},set document(p){throw(0,C.readonly)("document")},get selection(){return P.c&&P.c[0]},set selection(p){if(!(p instanceof I.Selection))throw(0,C.illegalArgument)("selection");P.c=[p],P.l()},get selections(){return P.c},set selections(p){if(!Array.isArray(p)||p.some(n=>!(n instanceof I.Selection)))throw(0,C.illegalArgument)("selections");P.c=p,P.l()},get visibleRanges(){return P.e},set visibleRanges(p){throw(0,C.readonly)("visibleRanges")},get options(){return P.d.value},set options(p){P.g||P.d.assign(p)},get viewColumn(){return P.f},set viewColumn(p){throw(0,C.readonly)("viewColumn")},edit(p,n={undoStopBefore:!0,undoStopAfter:!0}){if(P.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new y(r.getValue(),n);return p(d),P.m(d)},insertSnippet(p,n,d={undoStopBefore:!0,undoStopAfter:!0}){if(P.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let t;if(!n||Array.isArray(n)&&n.length===0)t=P.c.map(u=>L.Range.from(u));else if(n instanceof I.Position){const{lineNumber:u,column:s}=L.Position.from(n);t=[{startLineNumber:u,startColumn:s,endLineNumber:u,endColumn:s}]}else if(n instanceof I.Range)t=[L.Range.from(n)];else{t=[];for(const u of n)if(u instanceof I.Range)t.push(L.Range.from(u));else{const{lineNumber:s,column:h}=L.Position.from(u);t.push({startLineNumber:s,startColumn:h,endLineNumber:s,endColumn:h})}}return b.$tryInsertSnippet(m,r.getValue().version,p.value,t,d)},setDecorations(p,n){const d=n.length===0;d&&!P.h.has(p.key)||(d?P.h.delete(p.key):P.h.add(p.key),P.n(()=>{if(L.isDecorationOptionsArr(n))return b.$trySetDecorations(m,p.key,L.fromRangeOrRangeWithMessage(n));{const t=new Array(4*n.length);for(let u=0,s=n.length;u<s;u++){const h=n[u];t[4*u]=h.start.line+1,t[4*u+1]=h.start.character+1,t[4*u+2]=h.end.line+1,t[4*u+3]=h.end.character+1}return b.$trySetDecorationsFast(m,p.key,t)}}))},revealRange(p,n){P.n(()=>b.$tryRevealRange(m,L.Range.from(p),n||I.TextEditorRevealType.Default))},show(p){b.$tryShowEditor(m,L.ViewColumn.from(p))},hide(){b.$tryHideEditor(m)}})}dispose(){(0,i.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,i.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,i.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,i.ok)(!this.g),this.f=m}_acceptSelections(m){(0,i.ok)(!this.g),this.c=m}async l(){const m=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const b=m.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const f=b.edits.map(o=>o.range);f.sort((o,l)=>o.end.line===l.end.line?o.end.character===l.end.character?o.start.line===l.start.line?o.start.character-l.start.character:o.start.line-l.start.line:o.end.character-l.end.character:o.end.line-l.end.line);for(let o=0,l=f.length-1;o<l;o++){const v=f[o].end;if(f[o+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=b.edits.map(o=>({range:L.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,r,{setEndOfLine:typeof b.setEndOfLine=="number"?L.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.ExtHostTextEditor=O}),define(Ie[196],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[197],Ce([1,0,151,11,30,89,68,29,26,196,160,153]),function(ee,e,i,C,S,L,I,R,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=R.Registry.as(I.Extensions.JSONContribution);class b{constructor(p,n,d){this.a=p,this.b=n,this.c=d}d(p,n){this.a({type:p,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(S.default.Error,p)}warn(p){this.d(S.default.Warning,p)}info(p){this.d(S.default.Info,p)}}e.ExtensionMessageCollector=b;class f{static a(p){const n=new Set;for(let d=0,t=p.length;d<t;d++)n.add(y.ExtensionIdentifier.toKey(p[d].description.identifier));return n}static compute(p,n){if(!p||!p.length)return new f(n,[]);if(!n||!n.length)return new f([],p);const d=this.a(p),t=this.a(n),u=n.filter(h=>!d.has(y.ExtensionIdentifier.toKey(h.description.identifier))),s=p.filter(h=>!t.has(y.ExtensionIdentifier.toKey(h.description.identifier)));return new f(u,s)}constructor(p,n){this.added=p,this.removed=n}}e.ExtensionPointUserDelta=f;class r{constructor(p,n){this.name=p,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=f.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,C.onUnexpectedError)(p)}}}e.ExtensionPoint=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:i.localize(15,null),type:"string",enum:["none"],enumDescriptions:[i.localize(16,null)]},activationEvents:{description:i.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(32,null)},{label:"onUri",body:"onUri",description:i.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(37,null)},{label:"onRenderer",description:i.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(41,null)},{label:"*",description:i.localize(42,null),body:"*"}]}},badges:{type:"array",description:i.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(44,null)},href:{type:"string",description:i.localize(45,null)},description:{type:"string",description:i.localize(46,null)}}}},markdown:{type:"string",description:i.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(51,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(52,null)},{body:["workspace"],description:i.localize(53,null)},{body:["ui","workspace"],description:i.localize(54,null)},{body:["workspace","ui"],description:i.localize(55,null)},{body:[],description:i.localize(56,null)}]},capabilities:{description:i.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)]},description:{type:"string",markdownDescription:i.localize(63,null)}}},untrustedWorkspaces:{description:i.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(66,null),i.localize(67,null),i.localize(68,null)]},restrictedConfigurations:{description:i.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(70,null)}}}}},sponsor:{description:i.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(73,null),type:"string"},"vscode:uninstall":{description:i.localize(74,null),type:"string"}}},icon:{type:"string",description:i.localize(75,null)},l10n:{type:"string",description:i.localize(76,null)}}};class v{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const n=new r(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,n),p.activationEventsGenerator&&w.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,m.registerSchema(l,e.schema),n}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=v;const E={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(E.ExtensionsRegistry,new v),e.ExtensionsRegistry=R.Registry.as(E.ExtensionsRegistry),m.registerSchema(l,e.schema),m.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ie[198],Ce([1,0,148,9,22,197,42,4]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var k;(function(m){function b(f,r,o){if(!f)return;const l=C.isString(f.type)?f.type:void 0;if(!l||l.length===0){o.error(i.localize(3,null));return}const v=[];if(Array.isArray(f.required))for(const E of f.required)C.isString(E)&&v.push(E);return{extensionId:r.value,taskType:l,required:v,properties:f.properties?S.deepClone(f.properties):{},when:f.when?I.ContextKeyExpr.deserialize(f.when):void 0}}m.from=b})(k||(k={}));const O=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:i.localize(4,null),type:"array",items:y}});class w{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,f)=>{O.setHandler((r,o)=>{this.c=void 0;try{for(const l of o.removed){const v=l.value;for(const E of v)this.a&&E.type&&this.a[E.type]&&delete this.a[E.type]}for(const l of o.added){const v=l.value;for(const E of v){const P=k.from(E,l.description.identifier,l.collector);P&&(this.a[P.taskType]=P)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const f of this.all()){const r={type:"object",additionalProperties:!1};f.required.length>0&&(r.required=f.required.slice(0)),f.properties!==void 0?r.properties=S.deepClone(f.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[f.taskType]},b.push(r)}this.c={oneOf:b}}return this.c}}e.TaskDefinitionRegistry=new w}),define(Ie[199],Ce([1,0,149,9,23,22,42,198]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new I.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var y;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(T){function M(V){if(!V)return T.Strong;switch(V.toLowerCase()){case"escape":return T.Escape;case"strong":return T.Strong;case"weak":return T.Weak;default:return T.Strong}}T.from=M}(y=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(T){T.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var O;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(T){function M(V){switch(V.toLowerCase()){case"always":return T.Always;case"silent":return T.Silent;case"never":return T.Never;default:return T.Always}}T.fromString=M}(O=e.RevealKind||(e.RevealKind={}));var w;(function(T){T[T.Never=1]="Never",T[T.OnProblem=2]="OnProblem",T[T.Always=3]="Always"})(w=e.RevealProblemKind||(e.RevealProblemKind={})),function(T){function M(V){switch(V.toLowerCase()){case"always":return T.Always;case"never":return T.Never;case"onproblem":return T.OnProblem;default:return T.OnProblem}}T.fromString=M}(w=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(T){function M(V){switch(V.toLowerCase()){case"shared":return T.Shared;case"dedicated":return T.Dedicated;case"new":return T.New;default:return T.Shared}}T.fromString=M}(m=e.PanelKind||(e.PanelKind={}));var b;(function(T){T.defaults={echo:!0,reveal:O.Always,revealProblems:w.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(b=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(T){T[T.Shell=1]="Shell",T[T.Process=2]="Process",T[T.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(T){function M(q){switch(q.toLowerCase()){case"shell":return T.Shell;case"process":return T.Process;case"customExecution":return T.CustomExecution;default:return T.Process}}T.fromString=M;function V(q){switch(q){case T.Shell:return"shell";case T.Process:return"process";case T.CustomExecution:return"customExecution";default:return"process"}}T.toString=V}(f=e.RuntimeType||(e.RuntimeType={}));var r;(function(T){function M(V){return C.isString(V)?V:V.value}T.value=M})(r=e.CommandString||(e.CommandString={}));var o;(function(T){T.Clean={_id:"clean",isDefault:!1},T.Build={_id:"build",isDefault:!1},T.Rebuild={_id:"rebuild",isDefault:!1},T.Test={_id:"test",isDefault:!1};function M(q){return q===T.Clean._id||q===T.Build._id||q===T.Rebuild._id||q===T.Test._id}T.is=M;function V(q){if(q!==void 0)return C.isString(q)?M(q)?{_id:q,isDefault:!1}:void 0:q}T.from=V})(o=e.TaskGroup||(e.TaskGroup={}));var l;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var v;(function(T){T.Workspace="workspace",T.Extension="extension",T.InMemory="inMemory",T.WorkspaceFile="workspaceFile",T.User="user";function M(V){switch(V){case T.User:return 2;case T.WorkspaceFile:return 5;default:return 6}}T.toConfigurationTarget=M})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var E;(function(T){T.parallel="parallel",T.sequence="sequence"})(E=e.DependsOrder||(e.DependsOrder={}));var P;(function(T){T[T.default=1]="default",T[T.folderOpen=2]="folderOpen"})(P=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(T){T.defaults={reevaluateOnRerun:!0,runOn:P.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class n{constructor(M,V,q,le,_,pe){this._label="",this._id=M,V&&(this._label=V),q&&(this.type=q),this.runOptions=le,this.configurationProperties=_,this._source=pe}getDefinition(M){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const M={folder:this.d(),id:this._id};return JSON.stringify(M)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,V=!1){if(M===void 0)return!1;if(C.isString(M))return M===this._label||M===this.configurationProperties.identifier||V&&M===this._id;const q=this.getDefinition(!0);return q!==void 0&&q._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this.c===void 0&&(this.c=[]),M&&(this.c=this.c.concat(M))}get taskLoadMessages(){return this.c}}e.CommonTask=n;class d extends n{constructor(M,V,q,le,_,pe,ue,de){super(M,q,void 0,ue,de,V),this.command={},this._source=V,this.hasDefinedMatchers=pe,_&&(this.command=_)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case f.Shell:V="shell";break;case f.Process:V="process";break;case f.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(M){return M instanceof d}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const M=this.d();if(!M)return;let V=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(V+=this._source.kind);const q={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:V};return JSON.stringify(q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(M){return new d(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.CustomTask=d;class t extends n{constructor(M,V,q,le,_,pe,ue){super(M,q,le,pe,ue,V),this._source=V,this.configures=_}static is(M){return M instanceof t}f(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const M=this.d();if(!M)return;let V=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(V+=this._source.kind);const q={type:e.CUSTOMIZED_TASK_TYPE,folder:M,id:V};return JSON.stringify(q)}}e.ConfiguringTask=t;class u extends n{constructor(M,V,q,le,_,pe,ue,de,re){super(M,q,le,de,re,V),this.defines=_,this.hasDefinedMatchers=ue,this.command=pe,this.icon=re.icon,this.hide=re.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof u}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.d(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(M){return new u(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.ContributedTask=u;class s extends n{constructor(M,V,q,le,_,pe){super(M,q,le,_,pe,V),this._source=V}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(M){return new s(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.InMemoryTask=s;var h;(function(T){T[T.Process=1]="Process",T[T.Terminal=2]="Terminal"})(h=e.ExecutionEngine||(e.ExecutionEngine={})),function(T){T._default=T.Terminal}(h=e.ExecutionEngine||(e.ExecutionEngine={}));var a;(function(T){T[T.V0_1_0=1]="V0_1_0",T[T.V2_0_0=2]="V2_0_0"})(a=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class c{constructor(M){this.c=new Map;for(let V=0;V<M.length;V++)this.c.set(M[V].uri.toString(),V)}compare(M,V){const q=M.getWorkspaceFolder(),le=V.getWorkspaceFolder();if(q&&le){let _=this.c.get(q.uri.toString());_=_===void 0?0:_+1;let pe=this.c.get(le.uri.toString());return pe=pe===void 0?0:pe+1,_===pe?M._label.localeCompare(V._label):_-pe}else return!q&&le?-1:q&&!le?1:0}}e.TaskSorter=c;var g;(function(T){T.DependsOnStarted="dependsOnStarted",T.AcquiredInput="acquiredInput",T.Start="start",T.ProcessStarted="processStarted",T.Active="active",T.Inactive="inactive",T.Changed="changed",T.Terminated="terminated",T.ProcessEnded="processEnded",T.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var A;(function(T){T.SingleRun="singleRun",T.Background="background"})(A=e.TaskRunType||(e.TaskRunType={}));var F;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.FolderOpen=2]="FolderOpen",T[T.ConfigurationChange=3]="ConfigurationChange",T[T.Reconnect=4]="Reconnect"})(F=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(T){function M(V,q,le,_){if(q){const pe={kind:V,taskId:q._id,taskName:q.configurationProperties.name,runType:q.configurationProperties.isBackground?"background":"singleRun",group:q.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:le,__task:q};return V==="start"?pe.resolvedVariables=_:V==="processStarted"?pe.processId=_:V==="processEnded"&&(pe.exitCode=_),Object.freeze(pe)}else return Object.freeze({kind:"changed"})}T.create=M})(j=e.TaskEvent||(e.TaskEvent={}));var te;(function(T){function M(q){const le=Object.keys(q).sort();let _="";for(const pe of le){let ue=q[pe];ue instanceof Object?ue=M(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),_+=pe+","+ue+","}return _}function V(q){const _={_key:M(q),type:q.taskType};return Object.assign(_,q),_}T.create=V})(te=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var x;(function(T){T.AutoDetect="task.autoDetect",T.SaveBeforeRun="task.saveBeforeRun",T.ShowDecorations="task.showDecorations",T.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",T.SlowProviderWarning="task.slowProviderWarning",T.QuickOpenHistory="task.quickOpen.history",T.QuickOpenDetail="task.quickOpen.detail",T.QuickOpenSkip="task.quickOpen.skip",T.QuickOpenShowAll="task.quickOpen.showAll",T.AllowAutomaticTasks="task.allowAutomaticTasks",T.Reconnection="task.reconnection"})(x=e.TaskSettingId||(e.TaskSettingId={}));var N;(function(T){T.Tasks="tasks",T.SuppressTaskName="tasks.suppressTaskName",T.Windows="tasks.windows",T.Osx="tasks.osx",T.Linux="tasks.linux",T.ShowOutput="tasks.showOutput",T.IsShellCommand="tasks.isShellCommand",T.ServiceTestSetting="tasks.service.testSetting"})(N=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(T){function M(V,q){const le=R.TaskDefinitionRegistry.get(V.type);if(le===void 0){const de=L.deepClone(V);return delete de._key,te.create(de)}const _=Object.create(null);_.type=le.taskType;const pe=new Set;le.required.forEach(de=>pe.add(de));const ue=le.properties;for(const de of Object.keys(ue)){const re=V[de];if(re!=null)_[de]=re;else if(pe.has(de)){const G=ue[de];if(G.default!==void 0)_[de]=L.deepClone(G.default);else switch(G.type){case"boolean":_[de]=!1;break;case"number":case"integer":_[de]=0;break;case"string":_[de]="";break;default:q.error(i.localize(2,null,JSON.stringify(V,void 0,0),de));return}}}return te.create(_)}T.createTaskIdentifier=M})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[200],Ce([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((I,R)=>{this.b=I,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(I){this.f||this.h||(this.f=!0,this.g=I,this.a&&this.b(I))}resolveErr(I){this.f||this.h||(this.h=!0,this.i=I,this.a?this.d(I):(0,i.onUnexpectedError)(I))}then(I,R){return this.j().then(I,R)}catch(I){return this.j().then(void 0,I)}finally(I){return this.j().finally(I)}}e.LazyPromise=C;class S extends C{constructor(){super(),this.h=!0,this.i=new i.CancellationError}}e.CanceledLazyPromise=S}),define(Ie[44],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const C=[];function S(R){const y=new i(R);return C[y.nid]=y,y}e.createProxyIdentifier=S;function L(R){return C[R].sid}e.getStringIdentifierForProxy=L;class I{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=I}),define(Ie[5],Ce([1,0,44]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput"})(S=e.TabInputKind||(e.TabInputKind={}));var L;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(L=e.TabModelOperationKind||(e.TabModelOperationKind={}));var I;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var R;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(R=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(o){return o._id=w.a++,o}}e.IdObject=w,w.a=0;var m;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[76],Ce([1,0,3,13,5,17]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(y,k){this.c=k,this.a=new Set,this.b=y.getProxy(S.MainContext.MainThreadTelemetry)}report(y,k,O){const w=this.d(y,k);this.a.has(w)||(this.a.add(w),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}d(y,k){return`${y}-${k.identifier.value}`}};I=qe([Ve(0,L.IExtHostRpcService),Ve(1,C.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(R,y,k){}})}),define(Ie[201],Ce([1,0,4,5,7,26]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(y){this.b=new Map,this.c=[],this.d=new i.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,k,O,w={}){const m=L.ExtensionIdentifier.toKey(y.identifier),b=this.f.get(m)||[],f=[...O].sort().join(" ");let r=b.find(o=>o.providerId===k&&o.scopes===f);if(r)return r.result;{const o=this.g(y,m,k,O,w);r={providerId:k,scopes:f,result:o},b.push(r),this.f.set(m,b);try{await o}finally{const l=b.findIndex(v=>v.providerId===k&&v.scopes===f);l>-1&&(b.splice(l),this.f.set(m,b))}return o}}async g(y,k,O,w,m={}){await this.a.$ensureProvider(O);const b=y.displayName||y.name;return this.a.$getSession(O,w,k,b,m)}async removeSession(y,k){const O=this.b.get(y);return O?O.provider.removeSession(k):this.a.$removeSession(y,k)}registerAuthenticationProvider(y,k,O,w){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:k,provider:O,options:w??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===y)||this.c.push({id:y,label:k});const m=O.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(y,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(y,k,w?.supportsMultipleAccounts??!1),new S.Disposable(()=>{m.dispose(),this.b.delete(y);const b=this.c.findIndex(f=>f.id===y);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this.d.fire({provider:{id:y,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(Ie[202],Ce([1,0,5,17,8]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(R,y){this.a=R.getProxy(i.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>y.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,y,k){const O=S.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,k?.isRefactoring??!1)}};L=qe([Ve(0,C.IExtHostRpcService)],L),e.ExtHostBulkEdits=L}),define(Ie[203],Ce([1,0,5]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(L){const I=L.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(R){return I.$writeText(R)}})}}e.ExtHostClipboard=C});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[38],Ce([1,0,9,7,8,22,5,18,13,84,56,256,2,6,3,17,100,25,44,39,77,50]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o,l,v,E,P,p){"use strict";var n,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let t=class{constructor(g,A){n.set(this,void 0),this.b=new Map,this.c=new Map,d.set(this,void 0),Je(this,n,g.getProxy(I.MainContext.MainThreadCommands),"f"),this.d=A,Je(this,d,g.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,F=>{const j=this.c.get(F);return j?.result===h.Void?j:void 0},A),this.f=[{processArgument(F){return(0,k.revive)(F)}},{processArgument(F){return(0,L.cloneAndChange)(F,function(j){if(O.Range.isIRange(j))return S.Range.to(j);if(w.Position.isIPosition(j))return S.Position.to(j);if(O.Range.isIRange(j.range)&&m.URI.isUri(j.uri))return S.location.to(j);if(j instanceof l.VSBuffer)return j.buffer.buffer;if(!Array.isArray(j))return j})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const A=this.registerCommand(!1,g.id,async(...F)=>{const j=g.args.map((x,N)=>{if(!x.validate(F[N]))throw new Error(`Invalid argument '${x.name}' when running '${g.id}', received: ${F[N]}`);return x.convert(F[N])}),te=await this.executeCommand(g.internalId,...j);return g.result.convert(te,F,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new C.Disposable(()=>{A.dispose(),this.c.delete(g.id)})}registerCommand(g,A,F,j,te,x){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:F,thisArg:j,description:te,extension:x}),g&&Oe(this,n,"f").$registerCommand(A),new C.Disposable(()=>{this.b.delete(A)&&g&&Oe(this,n,"f").$unregisterCommand(A)})}executeCommand(g,...A){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,A,!0)}async g(g,A,F){if(this.b.has(g))return Oe(this,n,"f").$fireCommandActivationEvent(g),this.h(g,A,!1);{let j=!1;const te=(0,L.cloneAndChange)(A,function(x){if(x instanceof C.Position)return S.Position.from(x);if(x instanceof C.Range)return S.Range.from(x);if(x instanceof C.Location)return S.location.from(x);if(C.NotebookRange.isNotebookRange(x))return S.NotebookRange.from(x);if(x instanceof ArrayBuffer)return j=!0,l.VSBuffer.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return j=!0,l.VSBuffer.wrap(x);if(x instanceof l.VSBuffer)return j=!0,x;if(!Array.isArray(x))return x});try{const x=await Oe(this,n,"f").$executeCommand(g,j?new v.SerializableObjectWithBuffers(te):te,F);return(0,k.revive)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this.g(g,A,!1);throw x}}}async h(g,A,F){const j=this.b.get(g);if(!j)throw new Error("Unknown command");const{callback:te,thisArg:x,description:N}=j;if(N)for(let T=0;T<N.args.length;T++)try{(0,i.validateConstraint)(A[T],N.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${N.args[T].name}' - ${N.args[T].description}`)}const $=P.StopWatch.create();try{return await te.apply(x,A)}catch(T){if(g===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...A);M&&(g=M.command)}throw this.d.error(T,g,j.extension?.identifier),F?new class extends Error{constructor(){super((0,E.toErrorMessage)(T)),this.id=g,this.source=j.extension?.displayName??j.extension?.name}}:T}finally{this.j(j,g,$.elapsed())}}j(g,A,F){!g.extension||Oe(this,d,"f").$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new p.TelemetryTrustedValue(A),duration:F})}$executeContributedCommand(g,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const F=this.b.get(g);return F?(A=A.map(j=>this.f.reduce((te,x)=>x.processArgument(te,F.extension?.identifier),j)),this.h(g,A,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),Oe(this,n,"f").$getCommands().then(A=>(g&&(A=A.filter(F=>F[0]!=="_")),A))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(const[A,F]of this.b){const{description:j}=F;j&&(g[A]=j)}return Promise.resolve(g)}};n=new WeakMap,d=new WeakMap,t=qe([Ve(0,r.IExtHostRpcService),Ve(1,y.ILogService)],t),e.ExtHostCommands=t,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class u{constructor(g,A,F){this.d=g,this.f=A,this.g=F,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,A){if(!g)return;const F={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return F;const j=this.f(g.command);if(j)F.id=j.internalId,F.arguments=j.args.map((te,x)=>te.convert(g.arguments&&g.arguments[x]));else if((0,R.isNonEmptyArray)(g.arguments)){const te=`${g.command}/${++this.c}`;this.b.set(te,g),A.add((0,b.toDisposable)(()=>{this.b.delete(te),this.g.trace("CommandsConverter#DISPOSE",te)})),F.$ident=te,F.id=this.delegatingCommandId,F.arguments=[te],this.g.trace("CommandsConverter#CREATE",g.command,te)}return F}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const A=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.CommandsConverter=u;class s{constructor(g,A,F,j){this.name=g,this.description=A,this.validate=F,this.convert=j}optional(){return new s(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,A){return new s(g??this.name,A??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",c=>m.URI.isUri(c),c=>c),s.Position=new s("position","A position in a text document",c=>C.Position.isPosition(c),S.Position.from),s.Range=new s("range","A range in a text document",c=>C.Range.isRange(c),S.Range.from),s.Selection=new s("selection","A selection in a text document",c=>C.Selection.isSelection(c),S.Selection.from),s.Number=new s("number","",c=>typeof c=="number",c=>c),s.String=new s("string","",c=>typeof c=="string",c=>c),s.CallHierarchyItem=new s("item","A call hierarchy item",c=>c instanceof C.CallHierarchyItem,S.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",c=>c instanceof C.TypeHierarchyItem,S.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",c=>c instanceof o.TestItemImpl,S.TestItem.from);class h{constructor(g,A){this.description=g,this.convert=A}}e.ApiCommandResult=h,h.Void=new h("no result",c=>c);class a{constructor(g,A,F,j,te){this.id=g,this.internalId=A,this.description=F,this.args=j,this.result=te}}e.ApiCommand=a}),define(Ie[204],Ce([1,0,2,8,7,75,38,18,87,91,16]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(C.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,R.isFalsyOrEmpty)(r))return;class l extends S.SymbolInformation{static to(E){const P=new l(E.name,C.SymbolKind.to(E.kind),E.containerName||"",new S.Location(o[0],C.Range.to(E.range)));return P.detail=E.detail,P.range=P.location.range,P.selectionRange=C.Range.to(E.selectionRange),P.children=E.children?E.children.map(l.to):[],P}}return r.map(l.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new I.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(C.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(C.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>S.Position.isPosition(o)),r=>r.map(C.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(o=>{let l;for(const v of o.reverse())l=new S.SelectionRange(C.Range.to(v),l);return l}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(C.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(C.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(C.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(C.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",r=>{if(!!r)return{range:C.Range.to(r.range),placeholder:r.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return C.WorkspaceEdit.to(r)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(C.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new S.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,y.decodeSemanticTokensDto)(r);if(o.type==="full")return new S.SemanticTokens(o.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new S.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,y.decodeSemanticTokensDto)(r);if(o.type==="full")return new S.SemanticTokens(o.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,o,l)=>{if(!r)return new S.CompletionList([]);const v=r.suggestions.map(E=>C.CompletionItem.to(E,l));return new S.CompletionList(v,r.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return C.SignatureHelp.to(r)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,o,l)=>b(v=>new S.CodeLens(C.Range.to(v.range),v.command&&l.fromInternal(v.command)))(r))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>S.Range.isRange(r),r=>S.Selection.isSelection(r)?C.Selection.from(r):C.Range.from(r)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,o,l)=>b(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(v.command)}else{const E=new S.CodeAction(v.title,v.kind?new S.CodeActionKind(v.kind):void 0);return v.edit&&(E.edit=C.WorkspaceEdit.to(v.edit)),v.command&&(E.command=l.fromInternal(v.command)),E.isPreferred=v.isPreferred,E}})(r))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new S.ColorInformation(C.Range.to(o.range),C.Color.to(o.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",r=>r instanceof S.Color,C.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:C.Range.from(r.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(C.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(r,o,l)=>r.map(C.InlayHint.to.bind(void 0,l)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>C.NotebookExclusiveDocumentPattern.to(o))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(C.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",r=>i.URI.isUri(r)||typeof r=="string"&&(0,k.matchesSomeScheme)(r,O.Schemas.http,O.Schemas.https),r=>r),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[C.ViewColumn.from(r),void 0]:[C.ViewColumn.from(r.viewColumn),C.TextEditorOpenOptions.from(r)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[C.ViewColumn.from(r),void 0]:[C.ViewColumn.from(r.viewColumn),C.TextEditorOpenOptions.from(r)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[C.ViewColumn.from(r.viewColumn),C.TextEditorOpenOptions.from(r)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(C.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void),new I.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[I.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],I.ApiCommandResult.Void),new I.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[I.ApiCommandArgument.String.with("name","The context key name"),new I.ApiCommandArgument("value","The context key value",()=>!0,r=>r)],I.ApiCommandResult.Void)];class m{static register(o){w.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=m;function b(r){return o=>{if(Array.isArray(o))return o.map(r)}}function f(r){if(!Array.isArray(r))return;const o=[];for(const l of r)L.isLocationLink(l)?o.push(C.DefinitionLink.to(l)):o.push(C.location.to(l));return o}}),define(Ie[205],Ce([1,0,12,63,4,6,2,75,26,8,7,24,5]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function b(f,r,o){const l=f.getProxy(m.MainContext.MainThreadComments);class v{constructor(){this.b=new Map,this.c=new Map,r.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const a=this.b.get(h.handle);return a?a.value:h}else if(h&&h.$mid===7){const a=this.b.get(h.commentControlHandle);if(!a)return h;const c=a.getCommentThread(h.commentThreadHandle);return c?c.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const a=this.b.get(h.thread.commentControlHandle);if(!a)return h;const c=a.getCommentThread(h.thread.commentThreadHandle);return c?h.$mid===8?c.value:{thread:c.value,text:h.text}:h}else if(h&&h.$mid===10){const a=this.b.get(h.thread.commentControlHandle);if(!a)return h;const c=a.getCommentThread(h.thread.commentThreadHandle);if(!c)return h;const g=h.commentUniqueId,A=c.getCommentByUniqueId(g);return A||h}else if(h&&h.$mid===11){const a=this.b.get(h.thread.commentControlHandle);if(!a)return h;const c=a.getCommentThread(h.thread.commentThreadHandle);if(!c)return h;const g=h.text,A=h.commentUniqueId,F=c.getCommentByUniqueId(A);return F?(typeof F.body=="string"?F.body=g:F.body=new O.MarkdownString(g),F):h}return h}})}createCommentController(h,a,c){const g=v.a++,A=new P(h,g,a,c);this.b.set(A.handle,A);const F=this.c.get(y.ExtensionIdentifier.toKey(h.identifier))||[];return F.push(A),this.c.set(y.ExtensionIdentifier.toKey(h.identifier),F),A.value}$createCommentThreadTemplate(h,a,c){const g=this.b.get(h);!g||g.$createCommentThreadTemplate(a,c)}async $updateCommentThreadTemplate(h,a,c){const g=this.b.get(h);!g||g.$updateCommentThreadTemplate(a,c)}$deleteCommentThread(h,a){this.b.get(h)?.$deleteCommentThread(a)}$provideCommentingRanges(h,a,c){const g=this.b.get(h);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const A=o.getDocument(I.URI.revive(a));return(0,i.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(A,c)).then(F=>F?F.map(j=>k.Range.from(j)):void 0)}$toggleReaction(h,a,c,g,A){const F=this.b.get(h);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const j=F.getCommentThread(a);if(j){const te=j.getCommentByUniqueId(g.uniqueIdInThread);if(F!==void 0&&te&&F.reactionHandler)return F.reactionHandler(te,d(A))}return Promise.resolve(void 0)})}dispose(){}}v.a=0;class E{set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){h.isEqual(this.p)||(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return(0,w.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(h){(0,w.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,a,c,g,A,F,j,te){this.m=a,this.n=c,this.o=g,this.p=A,this.q=F,this.extensionDescription=j,this.r=te,this.handle=E.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new S.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.MutableDisposable,this.l.value=new L.DisposableStore,this.n===void 0&&(this.n=`${h}.${this.handle}`),l.$createCommentThread(a,this.handle,this.n,this.o,k.Range.from(this.p),j.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=F,this.i.push({dispose:()=>{l.$deleteCommentThread(a,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(N){x.range=N},get comments(){return x.comments},set comments(N){x.comments=N},get collapsibleState(){return x.collapsibleState},set collapsibleState(N){x.collapsibleState=N},get canReply(){return x.canReply},set canReply(N){x.canReply=N},get contextValue(){return x.contextValue},set contextValue(N){x.contextValue=N},get label(){return x.label},set label(N){x.label=N},get state(){return x.state},set state(N){x.state=N},dispose:()=>{x.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.DisposableStore);const h=c=>Object.prototype.hasOwnProperty.call(this.b,c),a={};h("range")&&(a.range=k.Range.from(this.p)),h("label")&&(a.label=this.label),h("contextValue")&&(a.contextValue=this.contextValue??null),h("comments")&&(a.comments=this.q.map(c=>p(this,c,this.k))),h("collapsibleState")&&(a.collapseState=t(this.g)),h("canReply")&&(a.canReply=this.canReply),h("state")&&(a.state=u(this.h)),h("isTemplate")&&(a.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,a)}getCommentByUniqueId(h){for(const a of this.k){const c=a[0],g=a[1];if(h===g)return c}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}E.a=0,qe([(0,C.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class P{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,l.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,a,c,g){this.f=h,this.g=a,this.h=c,this.i=g,this.a=new Map,l.$registerCommentController(this.handle,c,g);const A=this;this.value=Object.freeze({id:A.id,label:A.label,get options(){return A.options},set options(F){A.options=F},get commentingRangeProvider(){return A.commentingRangeProvider},set commentingRangeProvider(F){A.commentingRangeProvider=F},get reactionHandler(){return A.reactionHandler},set reactionHandler(F){A.reactionHandler=F},createCommentThread(F,j,te){return A.createCommentThread(F,j,te).value},dispose:()=>{A.dispose()}}),this.e=[],this.e.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(h,a,c,g){if(typeof h=="string"){const A=new E(this.id,this.handle,h,a,c,g,this.f,!1);return this.a.set(A.handle,A),A}else{const A=new E(this.id,this.handle,void 0,h,a,c,this.f,!1);return this.a.set(A.handle,A),A}}$createCommentThreadTemplate(h,a){const c=new E(this.id,this.handle,void 0,I.URI.revive(h),k.Range.to(a),[],this.f,!0);return c.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(c.handle,c),c}$updateCommentThreadTemplate(h,a){const c=this.a.get(h);c&&(c.range=k.Range.to(a))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function p(s,h,a){let c=a.get(h);c||(c=++s.commentHandle,a.set(h,c));const g=h.author&&h.author.iconPath?h.author.iconPath.toString():void 0;return{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:c,body:typeof h.body=="string"?h.body:k.MarkdownString.from(h.body),userName:h.author.name,userIconPath:g,label:h.label,commentReactions:h.reactions?h.reactions.map(A=>n(A)):void 0,timestamp:h.timestamp?.toJSON()}}function n(s){return{label:s.label,iconPath:s.iconPath?k.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function d(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?I.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function t(s){if(s!==void 0)switch(s){case O.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function u(s){if(s!==void 0)switch(s){case O.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new v}e.createExtHostComments=b}),define(Ie[206],Ce([1,0,22,5,27,17]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let I=class{constructor(O,w){this.a=O.getProxy(C.MainContext.MainThreadConsole),this.b=w.consoleForward.includeStack,this.c=w.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,w){const m=this,b=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){m.e(O,w,b,arguments)}})}e(O,w,m,b){this.a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:y(b,this.b)}),this.c&&this.f(O,m,b)}};I=qe([Ve(0,L.IExtHostRpcService),Ve(1,S.IExtHostInitDataService)],I),e.AbstractExtHostConsoleForwarder=I;const R=1e5;function y(k,O){const w=[];if(k.length)for(let m=0;m<k.length;m++){let b=k[m];if(typeof b>"u")b="undefined";else if(b instanceof Error){const f=b;f.stack?b=f.stack:b=f.toString()}w.push(b)}if(O){const m=new Error().stack;m&&w.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,i.safeStringify)(w);return m.length>R?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ie[102],Ce([1,0,2,5,7,3,17,13,18,10,19,24]),function(ee,e,i,C,S,L,I,R,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=class Ui{constructor(f,r){this.h=r,this.f=new Map,this.g=f.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,r){const o=Ui.c++;this.f.set(o,{provider:f,extensionDescription:r}),this.g.$registerDecorationProvider(o,r.identifier.value);const l=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(v=>{if(!v){this.g.$onDidChange(o,null);return}const E=(0,y.asArray)(v);if(E.length<=Ui.d){this.g.$onDidChange(o,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",r.identifier.value,E.length);const P=E.map(d=>({uri:d,rank:(0,k.count)(d.path,"/")})),p=(0,y.groupBy)(P,(d,t)=>d.rank-t.rank||(0,k.compare)(d.uri.path,t.uri.path)),n=[];e:for(const d of p){let t;for(const u of d){const s=(0,O.dirname)(u.uri.path);if(t!==s&&(t=s,n.push(u.uri)>=Ui.d))break e}}this.g.$onDidChange(o,n)});return new S.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(f,r,o){if(!this.f.has(f))return Object.create(null);const l=Object.create(null),{provider:v,extensionDescription:E}=this.f.get(f);return await Promise.all(r.map(async P=>{try{const{uri:p,id:n}=P,d=await Promise.resolve(v.provideFileDecoration(i.URI.revive(p),o));if(!d)return;try{S.FileDecoration.validate(d),d.badge&&typeof d.badge!="string"&&(0,w.checkProposedApiEnabled)(E,"codiconDecoration"),l[n]=[d.propagate,d.tooltip,d.badge,d.color]}catch(t){this.h.warn(`INVALID decoration from extension '${E}': ${t}`)}}catch(p){this.h.error(p)}})),l}};m.c=0,m.d=250,m=qe([Ve(0,I.IExtHostRpcService),Ve(1,R.ILogService)],m),e.ExtHostDecorations=m,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[207],Ce([1,0,137,90,2,5,7,8,4,13,28,37]),function(ee,e,i,C,S,L,I,R,y,k,O,w){"use strict";var m,b,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class r{constructor(v,E,P,p,n,d,t){this.d=v,this.e=E,this.f=P,this.g=p,m.set(this,void 0),b.set(this,void 0),f.set(this,void 0),this.c=!1,Je(this,f,new O.ResourceMap(u=>n.getComparisonKey(u)),"f"),Je(this,m,d,"f"),Je(this,b,t,"f")}dispose(){this.c||(Oe(this,b,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this.e),Oe(this,f,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(v,E){if(!v){this.clear();return}this.h();let P=[];if(S.URI.isUri(v)){if(!E){this.delete(v);return}Oe(this,f,"f").set(v,E.slice()),P=[v]}else if(Array.isArray(v)){P=[];let n;v=[...v].sort(r.j);for(const d of v){const[t,u]=d;if((!n||t.toString()!==n.toString())&&(n&&Oe(this,f,"f").get(n).length===0&&Oe(this,f,"f").delete(n),n=t,P.push(t),Oe(this,f,"f").set(t,[])),u)Oe(this,f,"f").get(t)?.push(...u);else{const s=Oe(this,f,"f").get(t);s&&(s.length=0)}}}if(Oe(this,b,"f").fire(P),!Oe(this,m,"f"))return;const p=[];for(const n of P){let d=[];const t=Oe(this,f,"f").get(n);if(t)if(t.length>this.f){d=[];const u=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const h of t)if(h.severity===u[s]&&d.push({...R.Diagnostic.from(h),modelVersionId:this.g(n)})===this.f)break e;d.push({severity:C.MarkerSeverity.Info,message:(0,i.localize)(0,null,t.length-this.f),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=t.map(u=>({...R.Diagnostic.from(u),modelVersionId:this.g(n)}));p.push([n,d])}Oe(this,m,"f").$changeMany(this.e,p)}delete(v){this.h(),Oe(this,b,"f").fire([v]),Oe(this,f,"f").delete(v),Oe(this,m,"f")?.$changeMany(this.e,[[v,void 0]])}clear(){this.h(),Oe(this,b,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this.e)}forEach(v,E){this.h();for(const[P,p]of this)v.call(E,P,p,this)}*[(m=new WeakMap,b=new WeakMap,f=new WeakMap,Symbol.iterator)](){this.h();for(const v of Oe(this,f,"f").keys())yield[v,this.get(v)]}get(v){this.h();const E=Oe(this,f,"f").get(v);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(v){return this.h(),Array.isArray(Oe(this,f,"f").get(v))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(v,E){return v[0].toString()<E[0].toString()?-1:v[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=r;let o=class vi{static _mapper(v){const E=new O.ResourceMap;for(const P of v)E.set(P,P);return{uris:Object.freeze(Array.from(E.values()))}}constructor(v,E,P,p){this.h=E,this.j=P,this.k=p,this.f=new Map,this.g=new y.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,vi._mapper),this.e=v.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(v,E){const{f:P,e:p,g:n,h:d,j:t,k:u}=this,s=new class{$changeMany(c,g){p.$changeMany(c,g),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,c,g.length===0?"CLEARING":g)}$clear(c){p.$clear(c),d.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,c)}dispose(){p.dispose()}};let h;if(!E)E="_generated_diagnostic_collection_name_#"+vi.c++,h=E;else if(!P.has(E))h=E;else{this.h.warn(`DiagnosticCollection with name '${E}' does already exist.`);do h=E+vi.c++;while(P.has(h))}return new class extends r{constructor(){super(E,h,vi.d,c=>u.getDocument(c)?.version,t.extUri,s,n),P.set(h,this)}dispose(){super.dispose(),P.delete(h)}}}getDiagnostics(v){if(v)return this.l(v);{const E=new Map,P=[];for(const p of this.f.values())p.forEach((n,d)=>{let t=E.get(n.toString());typeof t>"u"&&(t=P.length,E.set(n.toString(),t),P.push([n,[]])),P[t][1]=P[t][1].concat(...d)});return P}}l(v){let E=[];for(const P of this.f.values())P.has(v)&&(E=E.concat(P.get(v)));return E}$acceptMarkersChange(v){if(!this.m){const E="_generated_mirror",P=new r(E,E,vi.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(E,P),this.m=P}for(const[E,P]of v)this.m.set(S.URI.revive(E),P.map(R.Diagnostic.to))}};o.c=0,o.d=1e3,o=qe([Ve(1,k.ILogService),Ve(2,w.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(Ie[208],Ce([1,0,2,5]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(I){this.a=I.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(I){return this.a.$showOpenDialog(I).then(R=>R?R.map(y=>i.URI.revive(y)):void 0)}showSaveDialog(I){return this.a.$showSaveDialog(I).then(R=>R?i.URI.revive(R):void 0)}}e.ExtHostDialogs=S}),define(Ie[209],Ce([1,0,11,2,7,5,16,21,10]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(w,m,b){this.d=m,this.e=b,this.b=new Map,this.c=w.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,m){if(Object.keys(I.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const b=k.a++;this.b.set(b,m),this.c.$registerTextContentProvider(b,w);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(r=>{if(r.scheme!==w){this.e.warn(`Provider for scheme '${w}' is firing event for schema '${r.scheme}' which will be IGNORED`);return}this.d.getDocument(r)&&this.$provideTextDocumentContent(b,r).then(o=>{if(!o&&typeof o!="string")return;const l=this.d.getDocument(r);if(!l)return;const v=(0,y.splitLines)(o);if(!l.equalLines(v))return this.c.$onVirtualDocumentChange(r,o)},i.onUnexpectedError)})),new S.Disposable(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(w,m){const b=this.b.get(w);return b?Promise.resolve(b.provideTextDocumentContent(C.URI.revive(m),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=k,k.a=0}),define(Ie[210],Ce([1,0,4,6,2,5,98,8,9,22,7]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(b,f){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new C.DisposableStore,this.h=new Map,this.f=b.getProxy(L.MainContext.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const f=this.g.getDocument(b);if(f)return f}getDocument(b){const f=this.getDocumentData(b);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return f.document}ensureDocumentData(b){const f=this.g.getDocument(b);if(f)return Promise.resolve(f);let r=this.h.get(b.toString());return r||(r=this.f.$tryOpenDocument(b).then(o=>{this.h.delete(b.toString());const l=S.URI.revive(o);return(0,y.assertIsDefined)(this.g.getDocument(l))},o=>(this.h.delete(b.toString()),Promise.reject(o))),this.h.set(b.toString(),r)),r}createDocumentData(b){return this.f.$tryCreateDocument(b).then(f=>S.URI.revive(f))}$acceptModelLanguageChanged(b,f){const r=S.URI.revive(b),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(f),this.a.fire(o.document)}$acceptModelSaved(b){const f=S.URI.revive(b),r=this.g.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(b,f){const r=S.URI.revive(b),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(f),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,f,r){const o=S.URI.revive(b),l=this.g.getDocument(o);if(!l)throw new Error("unknown document");l._acceptIsDirty(r),l.onEvents(f);let v;f.isUndoing?v=O.TextDocumentChangeReason.Undo:f.isRedoing&&(v=O.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:l.document,contentChanges:f.changes.map(E=>({range:R.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:v}))}setWordDefinitionFor(b,f){(0,I.setWordDefinitionFor)(b,f)}}e.ExtHostDocuments=w}),define(Ie[57],Ce([1,0,47,4,6,2,3,5,98,17,101,8,13,28,16,180,211]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(P){this.value=P,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let v=class{constructor(P,p){this.h=P,this.i=p,this.a=null,this.b=new Map,this.c=new b.ResourceMap,this.d=new C.Emitter,this.e=new C.Emitter,this.f=new C.Emitter,this.g=new C.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(P){this.acceptDocumentsAndEditorsDelta(P)}acceptDocumentsAndEditorsDelta(P){const p=[],n=[],d=[];if(P.removedDocuments)for(const t of P.removedDocuments){const u=L.URI.revive(t),s=this.c.get(u);s?.unref()&&(this.c.delete(u),p.push(s.value))}if(P.addedDocuments)for(const t of P.addedDocuments){const u=L.URI.revive(t.uri);let s=this.c.get(u);if(s&&u.scheme!==f.Schemas.vscodeNotebookCell&&u.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);s||(s=new l(new y.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),u,t.lines,t.EOL,t.versionId,t.languageId,t.isDirty,t.notebook)),this.c.set(u,s),n.push(s.value)),s.ref()}if(P.removedEditors)for(const t of P.removedEditors){const u=this.b.get(t);this.b.delete(t),u&&d.push(u)}if(P.addedEditors)for(const t of P.addedEditors){const u=L.URI.revive(t.documentUri);i.ok(this.c.has(u),`document '${u}' does not exist`),i.ok(!this.b.has(t.id),`editor '${t.id}' already exists!`);const s=this.c.get(u).value,h=new O.ExtHostTextEditor(t.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new o.Lazy(()=>s.document),t.selections.map(w.Selection.to),t.options,t.visibleRanges.map(a=>w.Range.to(a)),typeof t.editorPosition=="number"?w.ViewColumn.to(t.editorPosition):void 0);this.b.set(t.id,h)}P.newActiveEditor!==void 0&&(i.ok(P.newActiveEditor===null||this.b.has(P.newActiveEditor),`active editor '${P.newActiveEditor}' does not exist`),this.a=P.newActiveEditor),(0,S.dispose)(p),(0,S.dispose)(d),P.removedDocuments&&this.e.fire(p),P.addedDocuments&&this.d.fire(n),(P.removedEditors||P.addedEditors)&&this.f.fire(this.allEditors().map(t=>t.value)),P.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(P){return this.c.get(P)?.value}allDocuments(){return r.Iterable.map(this.c.values(),P=>P.value)}getEditor(P){return this.b.get(P)}activeEditor(P){if(!this.a)return;const p=this.b.get(this.a);return P?p:p?.value}allEditors(){return[...this.b.values()]}};v=qe([Ve(0,k.IExtHostRpcService),Ve(1,m.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[58],Ce([1,0,8,5,2,4,3,7,17,9,62]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class w{constructor(o,l,v){this.e=v,this.d=l,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(S.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(S.URI.revive(this.b.input.original),S.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(S.URI.revive(this.b.input.base),S.URI.revive(this.b.input.input1),S.URI.revive(this.b.input.input2),S.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(S.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(S.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(S.URI.revive(this.b.input.original),S.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(S.URI.revive(this.b.input.uri),S.URI.revive(this.b.input.inputBoxUri));default:return}}}class m{constructor(o,l){this.c=[],this.d="",this.b=o,this.e=l;for(const v of o.tabs)v.isActive&&(this.d=v.id),this.c.push(new w(v,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,l={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return i.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(v=>v.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(v=>v.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const v=new w(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,v),o.tabDto.isActive&&(this.d=v.tabId),v}else if(o.kind===1){const v=this.c.splice(o.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return v.tabId===this.d&&(this.d=""),v}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this.c.splice(o.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,v),v}const l=this.c.find(v=>v.tabId===o.tabDto.id);if(!l)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(o.tabDto),l}activeTabId(){return this.d}}let b=class{constructor(o){this.b=new L.Emitter,this.c=new L.Emitter,this.e=[],this.a=o.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,l={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(v=>v.apiObject))},get activeTabGroup(){const v=o.d;return(0,k.assertIsDefined)(o.e.find(P=>P.groupId===v)?.apiObject)},close:async(v,E)=>{const P=Array.isArray(v)?v:[v];return P.length?f(P[0])?this.j(P,E):this.i(P,E):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(o){const l=new Set(this.e.map(t=>t.groupId)),v=new Set(o.map(t=>t.groupId)),E=(0,O.diffSets)(l,v),P=this.e.filter(t=>E.removed.includes(t.groupId)).map(t=>t.apiObject),p=[],n=[];this.e=o.map(t=>{const u=new m(t,()=>this.d);return E.added.includes(u.groupId)?p.push(u.apiObject):n.push(u.apiObject),u});const d=(0,k.assertIsDefined)(o.find(t=>t.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:p,closed:P,changed:n}))}$acceptTabGroupUpdate(o){const l=this.e.find(v=>v.groupId===o.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const l=this.e.find(E=>E.groupId===o.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const v=l.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}g(o){for(const l of this.e)for(const v of l.tabs)if(v.apiObject===o)return v}h(o){return this.e.find(l=>l.apiObject===o)}async i(o,l){const v=[];for(const E of o){const P=this.g(E);if(!P)throw new Error("Tab close: Invalid tab not found!");v.push(P.tabId)}return this.a.$closeTab(v,l)}async j(o,l){const v=[];for(const E of o){const P=this.h(E);if(!P)throw new Error("Group close: Invalid group not found!");v.push(P.groupId)}return this.a.$closeGroup(v,l)}};b=qe([Ve(0,y.IExtHostRpcService)],b),e.ExtHostEditorTabs=b;function f(r){return r.tabs!==void 0}}),define(Ie[212],Ce([1,0,2,5,6,7,8,257,10,25,24]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const r=this.a.indexOf(f);r>=0&&(this.a.splice(r,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),r=[];let o,l,v=14,E=14;for(const P of f){let p=o?(0,y.commonPrefixLength)(o,P):0;for(p===0?l=1:l=E;p<P.length;p++)p+1===P.length?(v=E,E=9):E+=1,r.push([l,P.toUpperCase().charCodeAt(p),E]),r.push([l,P.toLowerCase().charCodeAt(p),E]),l=E;o=P,E=v}r.push([9,58,10]),r.push([10,47,12]),this.b=new R.StateMachine(r)}}provideDocumentLinks(f){this.c();const r=[],o=R.LinkComputer.computeLinks({getLineContent(l){return f.lineAt(l-1).text},getLineCount(){return f.lineCount}},this.b);for(const l of o){const v=I.DocumentLink.to(l);v.target&&r.push(v)}return r}}class m{constructor(f,r){this.i=r,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,r,o,l={}){if(this.d.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const v=this.h++;this.b.add(r),this.d.add(r),this.c.set(v,o);let E=2;l.isCaseSensitive&&(E+=1024),l.isReadonly&&(E+=2048),typeof o.copy=="function"&&(E+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),E+=4),this.a.$registerFileSystemProvider(v,r,E).catch(p=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${r}`),console.error(p)});const P=o.onDidChangeFile(p=>{const n=[];for(const d of p){const{uri:t,type:u}=d;if(t.scheme!==r)continue;let s;switch(u){case L.FileChangeType.Changed:s=0;break;case L.FileChangeType.Created:s=1;break;case L.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:t,type:s})}this.a.$onFileSystemChange(v,n)});return(0,S.toDisposable)(()=>{P.dispose(),this.b.delete(r),this.d.delete(r),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(f){const{type:r,ctime:o,mtime:l,size:v,permissions:E}=f;return{type:r,ctime:o,mtime:l,size:v,permissions:E}}$stat(f,r){return Promise.resolve(this.k(f).stat(i.URI.revive(r))).then(o=>m.j(o))}$readdir(f,r){return Promise.resolve(this.k(f).readDirectory(i.URI.revive(r)))}$readFile(f,r){return Promise.resolve(this.k(f).readFile(i.URI.revive(r))).then(o=>k.VSBuffer.wrap(o))}$writeFile(f,r,o,l){return Promise.resolve(this.k(f).writeFile(i.URI.revive(r),o.buffer,l))}$delete(f,r,o){return Promise.resolve(this.k(f).delete(i.URI.revive(r),o))}$rename(f,r,o,l){return Promise.resolve(this.k(f).rename(i.URI.revive(r),i.URI.revive(o),l))}$copy(f,r,o,l){const v=this.k(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(i.URI.revive(r),i.URI.revive(o),l))}$mkdir(f,r){return Promise.resolve(this.k(f).createDirectory(i.URI.revive(r)))}$watch(f,r,o,l){const v=this.k(f).watch(i.URI.revive(o),l);this.f.set(r,v)}$unwatch(f,r){const o=this.f.get(r);o&&(o.dispose(),this.f.delete(r))}$open(f,r,o){const l=this.k(f);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(i.URI.revive(r),o))}$close(f,r){const o=this.k(f);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(r))}$read(f,r,o,l){const v=this.k(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const E=k.VSBuffer.alloc(l);return Promise.resolve(v.read(r,o,E.buffer,0,l)).then(P=>E.slice(0,P))}$write(f,r,o,l){const v=this.k(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(r,o,l.buffer,0,l.byteLength))}k(f){const r=this.c.get(f);if(!r){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return r}}e.ExtHostFileSystem=m}),define(Ie[59],Ce([1,0,5,36,7,25,3,17,37,6]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Zt{constructor(m,b){this.b=new Map,this.a=m.getProxy(i.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(r){try{const o=f.b.get(r.scheme);if(!o)return await f.a.$stat(r);await f.a.$ensureActivation(r.scheme);const l=await o.stat(r);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(o){Zt.c(o)}},async readDirectory(r){try{const o=f.b.get(r.scheme);return o?(await f.a.$ensureActivation(r.scheme),(await o.readDirectory(r)).slice()):await f.a.$readdir(r)}catch(o){return Zt.c(o)}},async createDirectory(r){try{return await f.a.$mkdir(r)}catch(o){return Zt.c(o)}},async readFile(r){try{const o=f.b.get(r.scheme);return o?(await f.a.$ensureActivation(r.scheme),(await o.readFile(r)).slice()):(await f.a.$readFile(r)).buffer}catch(o){return Zt.c(o)}},async writeFile(r,o){try{return await f.a.$writeFile(r,L.VSBuffer.wrap(o))}catch(l){return Zt.c(l)}},async delete(r,o){try{const l=f.b.get(r.scheme);return l?(await f.a.$ensureActivation(r.scheme),await l.delete(r,{recursive:!1,...o})):await f.a.$delete(r,{recursive:!1,useTrash:!1,...o})}catch(l){return Zt.c(l)}},async rename(r,o,l){try{return await f.a.$rename(r,o,{overwrite:!1,...l})}catch(v){return Zt.c(v)}},async copy(r,o,l){try{return await f.a.$copy(r,o,{overwrite:!1,...l})}catch(v){return Zt.c(v)}},isWritableFileSystem(r){const o=b.getCapabilities(r);if(typeof o=="number")return!(o&2048)}})}static c(m){if(m instanceof S.FileSystemError)throw m;if(!(m instanceof Error))throw new S.FileSystemError(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw S.FileSystemError.Unavailable(m.message);switch(m.name){case C.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(m.message);case C.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(m.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(m.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(m.message);case C.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(m.message);case C.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(m.message);default:throw new S.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,b){return this.b.set(m,b),(0,k.toDisposable)(()=>this.b.delete(m))}};O=qe([Ve(0,R.IExtHostRpcService),Ve(1,y.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[213],Ce([1,0,4,35,2,5,8,7]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(w,m,b,f,r,o,l,v){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter;const E=this.h(w,b,r);this.g=0,o&&(this.g+=1),l&&(this.g+=2),v&&(this.g+=4);const P=(0,C.parse)(r),p=typeof r=="string",n=f(d=>{if(!o)for(const t of d.created){const u=S.URI.revive(t);P(u.fsPath)&&(!p||m.getWorkspaceFolder(u))&&this.a.fire(u)}if(!l)for(const t of d.changed){const u=S.URI.revive(t);P(u.fsPath)&&(!p||m.getWorkspaceFolder(u))&&this.b.fire(u)}if(!v)for(const t of d.deleted){const u=S.URI.revive(t);P(u.fsPath)&&(!p||m.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=R.Disposable.from(E,this.a,this.b,this.c,n)}h(w,m,b){const f=R.Disposable.from();if(typeof b=="string")return f;const r=w.getProxy(L.MainContext.MainThreadFileSystem);let o=!1;(b.pattern.includes(C.GLOBSTAR)||b.pattern.includes(C.GLOB_SPLIT))&&(o=!0);const l=Math.random();return r.$watch(m.identifier.value,l,b.baseUri,{recursive:o,excludes:[]}),R.Disposable.from({dispose:()=>r.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(w,m,b){this.j=w,this.k=m,this.l=b,this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.g=new i.AsyncEmitter,this.h=new i.AsyncEmitter,this.i=new i.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,m,b,f,r,o){return new y(this.j,w,m,this.a.event,I.GlobPattern.from(b),f,r,o)}$onFileEvent(w){this.a.fire(w)}$onDidRunFileOperation(w,m){switch(w){case 2:this.b.fire(Object.freeze({files:m.map(b=>({oldUri:S.URI.revive(b.source),newUri:S.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(b=>S.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(b=>S.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,m){return(b,f,r)=>{const o=function(v){b.call(f,v)};return o.extension=w,m.event(o,void 0,r)}}async $onWillRunFileOperation(w,m,b,f){switch(w){case 2:return await this.n(this.g,{files:m.map(r=>({oldUri:S.URI.revive(r.source),newUri:S.URI.revive(r.target)}))},b,f);case 1:return await this.n(this.i,{files:m.map(r=>S.URI.revive(r.target))},b,f);case 0:case 3:return await this.n(this.h,{files:m.map(r=>S.URI.revive(r.target))},b,f)}}async n(w,m,b,f){const r=new Set,o=[];if(await w.fireAsync(m,f,async(v,E)=>{const P=Date.now(),p=await Promise.resolve(v);p instanceof R.WorkspaceEdit&&(o.push([E.extension,p]),r.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-P>b&&this.k.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||o.length===0)return;const l={edits:[]};for(const[,v]of o){const{edits:E}=I.WorkspaceEdit.from(v,{getTextDocumentVersion:P=>this.l.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(E)}return{edit:l,extensionNames:Array.from(r)}}}e.ExtHostFileSystemEventService=k}),define(Ie[214],Ce([1,0,2,38]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(I,R,y,k,O){this.a=R,this.b=y,this.c=k;const w=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new C.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new C.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new C.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new C.ApiCommandResult("Notebook and input URI",m=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const b=this.a.getEditorById(m.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri),notebookEditor:b.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri)}}));this.c.registerApiCommand(w)}$willAddInteractiveDocument(I,R,y,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:y,uri:I,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(i.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=S}),define(Ie[215],Ce([1,0,6,5]),function(ee,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(I){this.b=0,this.a=I.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,I),(0,i.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=S}),define(Ie[216],Ce([1,0,2,22,8,7,75,5,10,56,18,9,258,21,6,87,83,53,77,11,12,24]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o,l,v,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class n{constructor(D,B){this.d=D,this.e=B}async provideDocumentSymbols(D,B){const W=this.d.getDocument(D),K=await this.e.provideDocumentSymbols(W,B);if(!(0,O.isFalsyOrEmpty)(K))return K[0]instanceof L.DocumentSymbol?K.map(S.DocumentSymbol.from):n.f(K)}static f(D){D=D.slice(0).sort((K,Z)=>{let he=K.location.range.start.compareTo(Z.location.range.start);return he===0&&(he=Z.location.range.end.compareTo(K.location.range.end)),he});const B=[],W=[];for(const K of D){const Z={name:K.name||"!!MISSING: name!!",kind:S.SymbolKind.from(K.kind),tags:K.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:S.Range.from(K.location.range),selectionRange:S.Range.from(K.location.range),children:[]};for(;;){if(W.length===0){W.push(Z),B.push(Z);break}const he=W[W.length-1];if(k.Range.containsRange(he.range,Z.range)&&!k.Range.equalsRange(he.range,Z.range)){he.children?.push(Z),W.push(Z);break}W.pop()}}return B}}class d{constructor(D,B,W){this.g=D,this.h=B,this.j=W,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(D,B){const W=this.g.getDocument(D),K=await this.j.provideCodeLenses(W,B);if(!K||B.isCancellationRequested)return;const Z=this.e.add(K),he=new f.DisposableStore;this.f.set(Z,he);const ye={cacheId:Z,lenses:[]};for(let ae=0;ae<K.length;ae++)ye.lenses.push({cacheId:[Z,ae],range:S.Range.from(K[ae].range),command:this.h.toInternal(K[ae].command,he)});return ye}async resolveCodeLens(D,B){const W=D.cacheId&&this.e.get(...D.cacheId);if(!W)return;let K;if(typeof this.j.resolveCodeLens!="function"||W.isResolved?K=W:K=await this.j.resolveCodeLens(W,B),K||(K=W),B.isCancellationRequested)return;const Z=D.cacheId&&this.f.get(D.cacheId[0]);if(!!Z)return D.command=this.h.toInternal(K.command??d.d,Z),D}releaseCodeLenses(D){this.f.get(D)?.dispose(),this.f.delete(D),this.e.delete(D)}}d.d={command:"missing",title:"!!MISSING: command!!"};function t(J){return Array.isArray(J)?J.map(S.DefinitionLink.from):J?[S.DefinitionLink.from(J)]:[]}class u{constructor(D,B){this.d=D,this.e=B}async provideDefinition(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideDefinition(K,Z,W);return t(he)}}class s{constructor(D,B){this.d=D,this.e=B}async provideDeclaration(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideDeclaration(K,Z,W);return t(he)}}class h{constructor(D,B){this.d=D,this.e=B}async provideImplementation(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideImplementation(K,Z,W);return t(he)}}class a{constructor(D,B){this.d=D,this.e=B}async provideTypeDefinition(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideTypeDefinition(K,Z,W);return t(he)}}class c{constructor(D,B){this.d=D,this.e=B}async provideHover(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideHover(K,Z,W);if(!(!he||(0,O.isFalsyOrEmpty)(he.contents)))return he.range||(he.range=K.getWordRangeAtPosition(Z)),he.range||(he.range=new L.Range(Z,Z)),S.Hover.from(he)}}class g{constructor(D,B){this.d=D,this.e=B}async provideEvaluatableExpression(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideEvaluatableExpression(K,Z,W);if(he)return S.EvaluatableExpression.from(he)}}class A{constructor(D,B){this.d=D,this.e=B}async provideInlineValues(D,B,W,K){const Z=this.d.getDocument(D),he=await this.e.provideInlineValues(Z,S.Range.to(B),S.InlineValueContext.to(W),K);if(Array.isArray(he))return he.map(ye=>S.InlineValue.from(ye))}}class F{constructor(D,B){this.d=D,this.e=B}async provideDocumentHighlights(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideDocumentHighlights(K,Z,W);if(Array.isArray(he))return he.map(S.DocumentHighlight.from)}}class j{constructor(D,B){this.d=D,this.e=B}async provideLinkedEditingRanges(D,B,W){const K=this.d.getDocument(D),Z=S.Position.to(B),he=await this.e.provideLinkedEditingRanges(K,Z,W);if(he&&Array.isArray(he.ranges))return{ranges:(0,O.coalesce)(he.ranges.map(S.Range.from)),wordPattern:he.wordPattern}}}class te{constructor(D,B){this.d=D,this.e=B}async provideReferences(D,B,W,K){const Z=this.d.getDocument(D),he=S.Position.to(B),ye=await this.e.provideReferences(Z,he,W,K);if(Array.isArray(ye))return ye.map(S.location.from)}}class x{constructor(D,B,W,K,Z,he,ye){this.g=D,this.h=B,this.j=W,this.k=K,this.l=Z,this.m=he,this.n=ye,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(D,B,W,K){const Z=this.g.getDocument(D),he=m.Selection.isISelection(B)?S.Selection.to(B):S.Range.to(B),ye=[];for(const tt of this.j.getDiagnostics(D))if(he.intersection(tt.range)&&ye.push(tt)>x.d)break;const ae={diagnostics:ye,only:W.only?new L.CodeActionKind(W.only):void 0,triggerKind:S.CodeActionTriggerKind.to(W.trigger)},be=await this.k.provideCodeActions(Z,he,ae,K);if(!(0,O.isNonEmptyArray)(be)||K.isCancellationRequested)return;const Ee=this.e.add(be),We=new f.DisposableStore;this.f.set(Ee,We);const He=[];for(let tt=0;tt<be.length;tt++){const Xe=be[tt];!Xe||(x.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,We)})):(ae.only&&(Xe.kind?ae.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[Ee,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,We),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(S.Diagnostic.from),edit:Xe.edit&&S.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:Ee,actions:He}}async resolveCodeAction(D,B){const[W,K]=D,Z=this.e.get(W,K);if(!Z||x.o(Z)||!this.k.resolveCodeAction)return;const he=await this.k.resolveCodeAction(Z,B)??Z;return he?.edit?S.WorkspaceEdit.from(he.edit,void 0):void 0}releaseCodeActions(D){this.f.get(D)?.dispose(),this.f.delete(D),this.e.delete(D)}static o(D){return typeof D.command=="string"&&typeof D.title=="string"}}x.d=1e3;class N{constructor(D,B,W,K){this.d=D,this.e=B,this.f=W,this.g=K}async prepareDocumentPaste(D,B,W,K){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(D),he=B.map(ae=>S.Range.to(ae)),ye=S.DataTransfer.toDataTransfer(W,()=>{throw new E.NotImplementedError});return await this.f.prepareDocumentPaste(Z,he,ye,K),S.DataTransfer.toDataTransferDTO(ye)}async providePasteEdits(D,B,W,K,Z){const he=this.e.getDocument(B),ye=W.map(Ee=>S.Range.to(Ee)),ae=S.DataTransfer.toDataTransfer(K,async Ee=>(await this.d.$resolvePasteFileData(this.g,D,Ee)).buffer),be=await this.f.provideDocumentPasteEdits(he,ye,ae,Z);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?S.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class ${constructor(D,B){this.d=D,this.e=B}async provideDocumentFormattingEdits(D,B,W){const K=this.d.getDocument(D),Z=await this.e.provideDocumentFormattingEdits(K,B,W);if(Array.isArray(Z))return Z.map(S.TextEdit.from)}}class T{constructor(D,B){this.d=D,this.e=B}async provideDocumentRangeFormattingEdits(D,B,W,K){const Z=this.d.getDocument(D),he=S.Range.to(B),ye=await this.e.provideDocumentRangeFormattingEdits(Z,he,W,K);if(Array.isArray(ye))return ye.map(S.TextEdit.from)}}class M{constructor(D,B){this.d=D,this.e=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(D,B,W,K,Z){const he=this.d.getDocument(D),ye=S.Position.to(B),ae=await this.e.provideOnTypeFormattingEdits(he,ye,W,K,Z);if(Array.isArray(ae))return ae.map(S.TextEdit.from)}}class V{constructor(D,B){this.e=D,this.f=B,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(D,B){const W=await this.e.provideWorkspaceSymbols(D,B);if(!(0,O.isNonEmptyArray)(W))return{symbols:[]};const K=this.d.add(W),Z={cacheId:K,symbols:[]};for(let he=0;he<W.length;he++){const ye=W[he];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Z.symbols.push({...S.WorkspaceSymbol.from(ye),cacheId:[K,he]})}return Z}async resolveWorkspaceSymbol(D,B){if(typeof this.e.resolveWorkspaceSymbol!="function"||!D.cacheId)return D;const W=this.d.get(...D.cacheId);if(W){const K=await this.e.resolveWorkspaceSymbol(W,B);return K&&(0,C.mixin)(D,S.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(D){this.d.delete(D)}}class q{static supportsResolving(D){return typeof D.prepareRename=="function"}constructor(D,B,W){this.d=D,this.e=B,this.f=W}async provideRenameEdits(D,B,W,K){const Z=this.d.getDocument(D),he=S.Position.to(B);try{const ye=await this.e.provideRenameEdits(Z,he,W,K);return ye?S.WorkspaceEdit.from(ye):void 0}catch(ye){const ae=q.g(ye);return ae?{rejectReason:ae,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(D,B,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(D),Z=S.Position.to(B);try{const he=await this.e.prepareRename(K,Z,W);let ye,ae;if(L.Range.isRange(he)?(ye=he,ae=K.getText(he)):(0,w.isObject)(he)&&(ye=he.range,ae=he.placeholder),!ye||!ae)return;if(ye.start.line>Z.line||ye.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(ye),text:ae}}catch(he){const ye=q.g(he);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(he)}}static g(D){return typeof D=="string"?D:D instanceof Error&&typeof D.message=="string"?D.message:void 0}}class le{constructor(D,B){this.resultId=D,this.tokens=B}}class _{constructor(D,B){this.f=D,this.g=B,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(D,B,W){const K=this.f.getDocument(D),Z=B!==0?this.d.get(B):null;let he=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,Z.resultId,W):await this.g.provideDocumentSemanticTokens(K,W);return Z&&this.d.delete(B),he?(he=_.h(he),this.o(_.n(Z,he),he)):null}async releaseDocumentSemanticColoring(D){this.d.delete(D)}static h(D){return _.j(D)?_.k(D)?D:new L.SemanticTokens(new Uint32Array(D.data),D.resultId):_.l(D)?_.m(D)?D:new L.SemanticTokensEdits(D.edits.map(B=>new L.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),D.resultId):D}static j(D){return D&&!!D.data}static k(D){return D.data instanceof Uint32Array}static l(D){return D&&Array.isArray(D.edits)}static m(D){for(const B of D.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static n(D,B){if(!_.j(B)||!D||!D.tokens)return B;const W=D.tokens,K=W.length,Z=B.data,he=Z.length;let ye=0;const ae=Math.min(K,he);for(;ye<ae&&W[ye]===Z[ye];)ye++;if(ye===K&&ye===he)return new L.SemanticTokensEdits([],B.resultId);let be=0;const Ee=ae-ye;for(;be<Ee&&W[K-be-1]===Z[he-be-1];)be++;return new L.SemanticTokensEdits([{start:ye,deleteCount:K-ye-be,data:Z.subarray(ye,he-be)}],B.resultId)}o(D,B){if(_.j(D)){const W=this.e++;return this.d.set(W,new le(D.resultId,D.data)),(0,r.encodeSemanticTokensDto)({id:W,type:"full",data:D.data})}if(_.l(D)){const W=this.e++;return _.j(B)?this.d.set(W,new le(B.resultId,B.data)):this.d.set(W,new le(D.resultId)),(0,r.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(D.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class pe{constructor(D,B){this.d=D,this.e=B}async provideDocumentRangeSemanticTokens(D,B,W){const K=this.d.getDocument(D),Z=await this.e.provideDocumentRangeSemanticTokens(K,S.Range.to(B),W);return Z?this.f(Z):null}f(D){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:D.data})}}class ue{static supportsResolving(D){return typeof D.resolveCompletionItem=="function"}constructor(D,B,W,K,Z){this.f=D,this.g=B,this.h=W,this.j=K,this.k=Z,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(D,B,W,K){const Z=this.f.getDocument(D),he=S.Position.to(B),ye=Z.getWordRangeAtPosition(he)||new L.Range(he,he),ae=ye.with({end:he}),be=new v.StopWatch(!0),Ee=await this.h.provideCompletionItems(Z,he,K,S.CompletionContext.to(W));if(!Ee||K.isCancellationRequested)return;const We=Array.isArray(Ee)?new L.CompletionList(Ee):Ee,He=ue.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),tt=new f.DisposableStore;this.e.set(He,tt);const Xe=[],et={x:He,b:Xe,a:{replace:S.Range.from(ye),insert:S.Range.from(ae)},c:We.isIncomplete||void 0,d:be.elapsed()};for(let it=0;it<We.items.length;it++){const dt=We.items[it],Fe=this.l(dt,[He,it],ae,ye);Xe.push(Fe)}return et}async resolveCompletionItem(D,B){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...D);if(!W)return;const K=await this.h.resolveCompletionItem(W,B);if(!!K)return this.l(K,D)}releaseCompletionItems(D){this.e.get(D)?.dispose(),this.e.delete(D),this.d.delete(D)}l(D,B,W,K){const Z=this.e.get(B[0]);if(!Z)throw Error("DisposableStore is missing...");const he=this.g.toInternal(D.command,Z),ye={x:B,a:D.label,b:D.kind!==void 0?S.CompletionItemKind.from(D.kind):void 0,m:D.tags&&D.tags.map(S.CompletionItemTag.from),c:D.detail,d:typeof D.documentation>"u"?void 0:S.MarkdownString.fromStrict(D.documentation),e:D.sortText!==D.label?D.sortText:void 0,f:D.filterText!==D.label?D.filterText:void 0,g:D.preselect||void 0,i:D.keepWhitespace?1:0,k:D.commitCharacters?.join(""),l:D.additionalTextEdits&&D.additionalTextEdits.map(S.TextEdit.from),n:he?.$ident,o:he?.id,p:he?.$ident?void 0:he?.arguments};D.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=D.textEdit.newText):typeof D.insertText=="string"?ye.h=D.insertText:D.insertText instanceof L.SnippetString&&(ye.h=D.insertText.value,ye.i|=4);let ae;return D.textEdit?ae=D.textEdit.range:D.range&&(ae=D.range),L.Range.isRange(ae)?ye.j=S.Range.from(ae):ae&&(!W?.isEqual(ae.inserting)||!K?.isEqual(ae.replacing))&&(ye.j={insert:S.Range.from(ae.inserting),replace:S.Range.from(ae.replacing)}),ye}}class de{async provideInlineCompletions(D,B,W,K){}disposeCompletions(D){}handleDidShowCompletionItem(D,B){}}class re extends de{constructor(D,B,W,K){super(),this.f=D,this.g=B,this.h=W,this.j=K,this.d=new G,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[I.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(D,B,W,K){const Z=this.g.getDocument(D),he=S.Position.to(B),ye=await this.h.provideInlineCompletionItems(Z,he,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:S.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},K);if(!ye||K.isCancellationRequested)return;const ae=Array.isArray(ye)?ye:ye.items,be=this.e?Array.isArray(ye)?[]:ye.commands||[]:[];let Ee;return{pid:this.d.createReferenceId({dispose(){Ee?.dispose()},items:ae}),items:ae.map((He,tt)=>{let Xe;He.command&&(Ee||(Ee=new f.DisposableStore),Xe=this.j.toInternal(He.command,Ee));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?S.Range.from(He.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:be.map(He=>(Ee||(Ee=new f.DisposableStore),this.j.toInternal(He,Ee)))}}disposeCompletions(D){this.d.disposeReferenceId(D)?.dispose()}handleDidShowCompletionItem(D,B){const W=this.d.get(D)?.items[B];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W)}}class G{constructor(){this.d=new Map,this.e=1}createReferenceId(D){const B=this.e++;return this.d.set(B,D),B}disposeReferenceId(D){const B=this.d.get(D);return this.d.delete(D),B}get(D){return this.d.get(D)}}class H{constructor(D,B){this.e=D,this.f=B,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(D,B,W,K){const Z=this.e.getDocument(D),he=S.Position.to(B),ye=this.g(W),ae=await this.f.provideSignatureHelp(Z,he,K,ye);if(ae){const be=this.d.add([ae]);return{...S.SignatureHelp.from(ae),id:be}}}g(D){let B;if(D.activeSignatureHelp){const W=S.SignatureHelp.to(D.activeSignatureHelp),K=this.d.get(D.activeSignatureHelp.id,0);K?(B=K,B.activeSignature=W.activeSignature,B.activeParameter=W.activeParameter):B=W}return{...D,activeSignatureHelp:B}}releaseSignatureHelp(D){this.d.delete(D)}}class oe{constructor(D,B,W,K,Z){this.f=D,this.g=B,this.h=W,this.j=K,this.k=Z,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(D,B,W){const K=this.f.getDocument(D),Z=S.Range.to(B),he=await this.h.provideInlayHints(K,Z,W);if(!Array.isArray(he)||he.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${B}`);return}if(W.isCancellationRequested)return;const ye=this.d.add(he);this.e.set(ye,new f.DisposableStore);const ae={hints:[],cacheId:ye};for(let be=0;be<he.length;be++)this.l(he[be],Z)&&ae.hints.push(this.m(he[be],[ye,be]));return this.j.trace(`[InlayHints] ${ae.hints.length} inlay hints from '${this.k.identifier.value}' for ${B}`),ae}async resolveInlayHint(D,B){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...D);if(!W)return;const K=await this.h.resolveInlayHint(W,B);if(!!K&&!!this.l(K))return this.m(K,D)}releaseHints(D){this.e.get(D)?.dispose(),this.e.delete(D),this.d.delete(D)}l(D,B){return D.label.length===0||Array.isArray(D.label)&&D.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",D),!1):!(B&&!B.contains(D.position))}m(D,B){const W=this.e.get(B[0]);if(!W)throw Error("DisposableStore is missing...");const K={label:"",cacheId:B,tooltip:S.MarkdownString.fromStrict(D.tooltip),position:S.Position.from(D.position),textEdits:D.textEdits&&D.textEdits.map(S.TextEdit.from),kind:D.kind&&S.InlayHintKind.from(D.kind),paddingLeft:D.paddingLeft,paddingRight:D.paddingRight};return typeof D.label=="string"?K.label=D.label:K.label=D.label.map(Z=>{const he={label:Z.value};return he.tooltip=S.MarkdownString.fromStrict(Z.tooltip),L.Location.isLocation(Z.location)&&(he.location=S.location.from(Z.location)),Z.command&&(he.command=this.g.toInternal(Z.command,W)),he}),K}}class ve{constructor(D,B){this.e=D,this.f=B,this.d=new l.Cache("DocumentLink")}async provideLinks(D,B){const W=this.e.getDocument(D),K=await this.f.provideDocumentLinks(W,B);if(!(!Array.isArray(K)||K.length===0)&&!B.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(ve.g).map(S.DocumentLink.from)};{const Z=this.d.add(K),he={links:[],cacheId:Z};for(let ye=0;ye<K.length;ye++){if(!ve.g(K[ye]))continue;const ae=S.DocumentLink.from(K[ye]);ae.cacheId=[Z,ye],he.links.push(ae)}return he}}}static g(D){return D.target&&D.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(D,B){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...D);if(!W)return;const K=await this.f.resolveDocumentLink(W,B);if(!(!K||!ve.g(K)))return S.DocumentLink.from(K)}releaseLinks(D){this.d.delete(D)}}class Ae{constructor(D,B){this.d=D,this.e=B}async provideColors(D,B){const W=this.d.getDocument(D),K=await this.e.provideDocumentColors(W,B);return Array.isArray(K)?K.map(he=>({color:S.Color.from(he.color),range:S.Range.from(he.range)})):[]}async provideColorPresentations(D,B,W){const K=this.d.getDocument(D),Z=S.Range.to(B.range),he=S.Color.to(B.color),ye=await this.e.provideColorPresentations(he,{document:K,range:Z},W);if(!!Array.isArray(ye))return ye.map(S.ColorPresentation.from)}}class Be{constructor(D,B){this.d=D,this.e=B}async provideFoldingRanges(D,B,W){const K=this.d.getDocument(D),Z=await this.e.provideFoldingRanges(K,B,W);if(!!Array.isArray(Z))return Z.map(S.FoldingRange.from)}}class xe{constructor(D,B,W){this.d=D,this.e=B,this.f=W}async provideSelectionRanges(D,B,W){const K=this.d.getDocument(D),Z=B.map(S.Position.to),he=await this.e.provideSelectionRanges(K,Z,W);if(!(0,O.isNonEmptyArray)(he))return[];if(he.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ae=0;ae<Z.length;ae++){const be=[];ye.push(be);let Ee=Z[ae],We=he[ae];for(;;){if(!We.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(be.push(S.SelectionRange.from(We)),!We.parent)break;Ee=We.range,We=We.parent}}return ye}}class Te{constructor(D,B){this.f=D,this.g=B,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(D,B,W){const K=this.f.getDocument(D),Z=S.Position.to(B),he=await this.g.prepareCallHierarchy(K,Z,W);if(!he)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(he)?he.map(ae=>this.h(ye,ae)):[this.h(ye,he)]}async provideCallsTo(D,B,W){const K=this.j(D,B);if(!K)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(K,W);if(!!Z)return Z.map(he=>({from:this.h(D,he.from),fromRanges:he.fromRanges.map(ye=>S.Range.from(ye))}))}async provideCallsFrom(D,B,W){const K=this.j(D,B);if(!K)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(K,W);if(!!Z)return Z.map(he=>({to:this.h(D,he.to),fromRanges:he.fromRanges.map(ye=>S.Range.from(ye))}))}releaseSession(D){this.e.delete(D)}h(D,B){const W=this.e.get(D),K=S.CallHierarchyItem.from(B,D,W.size.toString(36));return W.set(K._itemId,B),K}j(D,B){return this.e.get(D)?.get(B)}}class Se{constructor(D,B){this.f=D,this.g=B,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(D,B,W){const K=this.f.getDocument(D),Z=S.Position.to(B),he=await this.g.prepareTypeHierarchy(K,Z,W);if(!he)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(he)?he.map(ae=>this.h(ye,ae)):[this.h(ye,he)]}async provideSupertypes(D,B,W){const K=this.j(D,B);if(!K)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(K,W);if(!!Z)return Z.map(he=>this.h(D,he))}async provideSubtypes(D,B,W){const K=this.j(D,B);if(!K)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(K,W);if(!!Z)return Z.map(he=>this.h(D,he))}releaseSession(D){this.e.delete(D)}h(D,B){const W=this.e.get(D),K=S.TypeHierarchyItem.from(B,D,W.size.toString(36));return W.set(K._itemId,B),K}j(D,B){return this.e.get(D)?.get(B)}}class ke{constructor(D,B,W,K){this.d=D,this.e=B,this.f=W,this.g=K}async provideDocumentOnDropEdits(D,B,W,K,Z){const he=this.e.getDocument(B),ye=S.Position.to(W),ae=S.DataTransfer.toDataTransfer(K,async Ee=>(await this.d.$resolveDocumentOnDropFileData(this.g,D,Ee)).buffer),be=await this.f.provideDocumentDropEdits(he,ye,ae,Z);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?S.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class se{constructor(D,B){this.adapter=D,this.extension=B}}class ce{constructor(D,B,W,K,Z,he,ye,ae){this.g=B,this.h=W,this.j=K,this.k=Z,this.l=he,this.m=ye,this.n=ae,this.f=new Map,this.e=D.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(D){return S.DocumentSelector.from(D,this.g)}p(D){return new L.Disposable(()=>{this.f.delete(D),this.e.$unregister(D)})}q(){return ce.d++}async s(D,B,W,K,Z,he=!1){const ye=this.f.get(D);if(!ye||!(ye.adapter instanceof B))return K;const ae=Date.now();he||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const be=W(ye.adapter,ye.extension);return Promise.resolve(be).catch(Ee=>{(0,E.isCancellationError)(Ee)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(Ee),this.n.onExtensionError(ye.extension.identifier,Ee))}).finally(()=>{he||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ae}ms`)}),b.CancellationToken.isCancellationToken(Z)?(0,P.raceCancellationError)(be,Z):be}t(D,B){const W=this.q();return this.f.set(W,new se(D,B)),W}static u(D){return D.displayName||D.name}registerDocumentSymbolProvider(D,B,W,K){const Z=this.t(new n(this.h,W),D),he=K&&K.label||ce.u(D);return this.e.$registerDocumentSymbolProvider(Z,this.o(B),he),this.p(Z)}$provideDocumentSymbols(D,B,W){return this.s(D,n,K=>K.provideDocumentSymbols(i.URI.revive(B),W),void 0,W)}registerCodeLensProvider(D,B,W){const K=this.q(),Z=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new se(new d(this.h,this.j.converter,W),D)),this.e.$registerCodeLensSupport(K,this.o(B),Z);let he=this.p(K);if(Z!==void 0){const ye=W.onDidChangeCodeLenses(ae=>this.e.$emitCodeLensEvent(Z));he=L.Disposable.from(he,ye)}return he}$provideCodeLenses(D,B,W){return this.s(D,d,K=>K.provideCodeLenses(i.URI.revive(B),W),void 0,W)}$resolveCodeLens(D,B,W){return this.s(D,d,K=>K.resolveCodeLens(B,W),void 0,void 0)}$releaseCodeLenses(D,B){this.s(D,d,W=>Promise.resolve(W.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(D,B,W){const K=this.t(new u(this.h,W),D);return this.e.$registerDefinitionSupport(K,this.o(B)),this.p(K)}$provideDefinition(D,B,W,K){return this.s(D,u,Z=>Z.provideDefinition(i.URI.revive(B),W,K),[],K)}registerDeclarationProvider(D,B,W){const K=this.t(new s(this.h,W),D);return this.e.$registerDeclarationSupport(K,this.o(B)),this.p(K)}$provideDeclaration(D,B,W,K){return this.s(D,s,Z=>Z.provideDeclaration(i.URI.revive(B),W,K),[],K)}registerImplementationProvider(D,B,W){const K=this.t(new h(this.h,W),D);return this.e.$registerImplementationSupport(K,this.o(B)),this.p(K)}$provideImplementation(D,B,W,K){return this.s(D,h,Z=>Z.provideImplementation(i.URI.revive(B),W,K),[],K)}registerTypeDefinitionProvider(D,B,W){const K=this.t(new a(this.h,W),D);return this.e.$registerTypeDefinitionSupport(K,this.o(B)),this.p(K)}$provideTypeDefinition(D,B,W,K){return this.s(D,a,Z=>Z.provideTypeDefinition(i.URI.revive(B),W,K),[],K)}registerHoverProvider(D,B,W,K){const Z=this.t(new c(this.h,W),D);return this.e.$registerHoverProvider(Z,this.o(B)),this.p(Z)}$provideHover(D,B,W,K){return this.s(D,c,Z=>Z.provideHover(i.URI.revive(B),W,K),void 0,K)}registerEvaluatableExpressionProvider(D,B,W,K){const Z=this.t(new g(this.h,W),D);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(B)),this.p(Z)}$provideEvaluatableExpression(D,B,W,K){return this.s(D,g,Z=>Z.provideEvaluatableExpression(i.URI.revive(B),W,K),void 0,K)}registerInlineValuesProvider(D,B,W,K){const Z=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,he=this.t(new A(this.h,W),D);this.e.$registerInlineValuesProvider(he,this.o(B),Z);let ye=this.p(he);if(Z!==void 0){const ae=W.onDidChangeInlineValues(be=>this.e.$emitInlineValuesEvent(Z));ye=L.Disposable.from(ye,ae)}return ye}$provideInlineValues(D,B,W,K,Z){return this.s(D,A,he=>he.provideInlineValues(i.URI.revive(B),W,K,Z),void 0,Z)}registerDocumentHighlightProvider(D,B,W){const K=this.t(new F(this.h,W),D);return this.e.$registerDocumentHighlightProvider(K,this.o(B)),this.p(K)}$provideDocumentHighlights(D,B,W,K){return this.s(D,F,Z=>Z.provideDocumentHighlights(i.URI.revive(B),W,K),void 0,K)}registerLinkedEditingRangeProvider(D,B,W){const K=this.t(new j(this.h,W),D);return this.e.$registerLinkedEditingRangeProvider(K,this.o(B)),this.p(K)}$provideLinkedEditingRanges(D,B,W,K){return this.s(D,j,async Z=>{const he=await Z.provideLinkedEditingRanges(i.URI.revive(B),W,K);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?ce.w(he.wordPattern):void 0}},void 0,K)}registerReferenceProvider(D,B,W){const K=this.t(new te(this.h,W),D);return this.e.$registerReferenceSupport(K,this.o(B)),this.p(K)}$provideReferences(D,B,W,K,Z){return this.s(D,te,he=>he.provideReferences(i.URI.revive(B),W,K,Z),void 0,Z)}registerCodeActionProvider(D,B,W,K){const Z=new f.DisposableStore,he=this.t(new x(this.h,this.j.converter,this.k,W,this.l,D,this.m),D);return this.e.$registerQuickFixSupport(he,this.o(B),{providedKinds:K?.providedCodeActionKinds?.map(ye=>ye.value),documentation:K?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Z)}))},ce.u(D),Boolean(W.resolveCodeAction)),Z.add(this.p(he)),Z}$provideCodeActions(D,B,W,K,Z){return this.s(D,x,he=>he.provideCodeActions(i.URI.revive(B),W,K,Z),void 0,Z)}$resolveCodeAction(D,B,W){return this.s(D,x,K=>K.resolveCodeAction(B,W),void 0,void 0)}$releaseCodeActions(D,B){this.s(D,x,W=>Promise.resolve(W.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(D,B,W){const K=this.t(new $(this.h,W),D);return this.e.$registerDocumentFormattingSupport(K,this.o(B),D.identifier,D.displayName||D.name),this.p(K)}$provideDocumentFormattingEdits(D,B,W,K){return this.s(D,$,Z=>Z.provideDocumentFormattingEdits(i.URI.revive(B),W,K),void 0,K)}registerDocumentRangeFormattingEditProvider(D,B,W){const K=this.t(new T(this.h,W),D);return this.e.$registerRangeFormattingSupport(K,this.o(B),D.identifier,D.displayName||D.name),this.p(K)}$provideDocumentRangeFormattingEdits(D,B,W,K,Z){return this.s(D,T,he=>he.provideDocumentRangeFormattingEdits(i.URI.revive(B),W,K,Z),void 0,Z)}registerOnTypeFormattingEditProvider(D,B,W,K){const Z=this.t(new M(this.h,W),D);return this.e.$registerOnTypeFormattingSupport(Z,this.o(B),K,D.identifier),this.p(Z)}$provideOnTypeFormattingEdits(D,B,W,K,Z,he){return this.s(D,M,ye=>ye.provideOnTypeFormattingEdits(i.URI.revive(B),W,K,Z,he),void 0,he)}registerWorkspaceSymbolProvider(D,B){const W=this.t(new V(B,this.l),D);return this.e.$registerNavigateTypeSupport(W,typeof B.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(D,B,W){return this.s(D,V,K=>K.provideWorkspaceSymbols(B,W),{symbols:[]},W)}$resolveWorkspaceSymbol(D,B,W){return this.s(D,V,K=>K.resolveWorkspaceSymbol(B,W),void 0,void 0)}$releaseWorkspaceSymbols(D,B){this.s(D,V,W=>W.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(D,B,W){const K=this.t(new q(this.h,W,this.l),D);return this.e.$registerRenameSupport(K,this.o(B),q.supportsResolving(W)),this.p(K)}$provideRenameEdits(D,B,W,K,Z){return this.s(D,q,he=>he.provideRenameEdits(i.URI.revive(B),W,K,Z),void 0,Z)}$resolveRenameLocation(D,B,W,K){return this.s(D,q,Z=>Z.resolveRenameLocation(i.URI.revive(B),W,K),void 0,K)}registerDocumentSemanticTokensProvider(D,B,W,K){const Z=this.t(new _(this.h,W),D),he=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(B),K,he);let ye=this.p(Z);if(he){const ae=W.onDidChangeSemanticTokens(be=>this.e.$emitDocumentSemanticTokensEvent(he));ye=L.Disposable.from(ye,ae)}return ye}$provideDocumentSemanticTokens(D,B,W,K){return this.s(D,_,Z=>Z.provideDocumentSemanticTokens(i.URI.revive(B),W,K),null,K)}$releaseDocumentSemanticTokens(D,B){this.s(D,_,W=>W.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(D,B,W,K){const Z=this.t(new pe(this.h,W),D);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(B),K),this.p(Z)}$provideDocumentRangeSemanticTokens(D,B,W,K){return this.s(D,pe,Z=>Z.provideDocumentRangeSemanticTokens(i.URI.revive(B),W,K),null,K)}registerCompletionItemProvider(D,B,W,K){const Z=this.t(new ue(this.h,this.j.converter,W,this.m,D),D);return this.e.$registerCompletionsProvider(Z,this.o(B),K,ue.supportsResolving(W),`${D.identifier.value}(${K.join("")})`),this.p(Z)}$provideCompletionItems(D,B,W,K,Z){return this.s(D,ue,he=>he.provideCompletionItems(i.URI.revive(B),W,K,Z),void 0,Z)}$resolveCompletionItem(D,B,W){return this.s(D,ue,K=>K.resolveCompletionItem(B,W),void 0,W)}$releaseCompletionItems(D,B){this.s(D,ue,W=>W.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(D,B,W){const K=new re(D,this.h,W,this.j.converter),Z=this.t(K,D);return this.e.$registerInlineCompletionsSupport(Z,this.o(B),K.supportsHandleDidShowCompletionItem),this.p(Z)}$provideInlineCompletions(D,B,W,K,Z){return this.s(D,de,he=>he.provideInlineCompletions(i.URI.revive(B),W,K,Z),void 0,Z)}$handleInlineCompletionDidShow(D,B,W){this.s(D,de,async K=>{K.handleDidShowCompletionItem(B,W)},void 0,void 0)}$freeInlineCompletionsList(D,B){this.s(D,de,async W=>{W.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(D,B,W,K){const Z=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,he=this.t(new H(this.h,W),D);return this.e.$registerSignatureHelpProvider(he,this.o(B),Z),this.p(he)}$provideSignatureHelp(D,B,W,K,Z){return this.s(D,H,he=>he.provideSignatureHelp(i.URI.revive(B),W,K,Z),void 0,Z)}$releaseSignatureHelp(D,B){this.s(D,H,W=>W.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(D,B,W){const K=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new oe(this.h,this.j.converter,W,this.l,D),D);this.e.$registerInlayHintsProvider(Z,this.o(B),typeof W.resolveInlayHint=="function",K,ce.u(D));let he=this.p(Z);if(K!==void 0){const ye=W.onDidChangeInlayHints(ae=>this.e.$emitInlayHintsEvent(K));he=L.Disposable.from(he,ye)}return he}$provideInlayHints(D,B,W,K){return this.s(D,oe,Z=>Z.provideInlayHints(i.URI.revive(B),W,K),void 0,K)}$resolveInlayHint(D,B,W){return this.s(D,oe,K=>K.resolveInlayHint(B,W),void 0,W)}$releaseInlayHints(D,B){this.s(D,oe,W=>W.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(D,B,W){const K=this.t(new ve(this.h,W),D);return this.e.$registerDocumentLinkProvider(K,this.o(B),typeof W.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(D,B,W){return this.s(D,ve,K=>K.provideLinks(i.URI.revive(B),W),void 0,W,B.scheme==="output")}$resolveDocumentLink(D,B,W){return this.s(D,ve,K=>K.resolveLink(B,W),void 0,void 0,!0)}$releaseDocumentLinks(D,B){this.s(D,ve,W=>W.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(D,B,W){const K=this.t(new Ae(this.h,W),D);return this.e.$registerDocumentColorProvider(K,this.o(B)),this.p(K)}$provideDocumentColors(D,B,W){return this.s(D,Ae,K=>K.provideColors(i.URI.revive(B),W),[],W)}$provideColorPresentations(D,B,W,K){return this.s(D,Ae,Z=>Z.provideColorPresentations(i.URI.revive(B),W,K),void 0,K)}registerFoldingRangeProvider(D,B,W){const K=this.q(),Z=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new se(new Be(this.h,W),D)),this.e.$registerFoldingRangeProvider(K,this.o(B),D.identifier,Z);let he=this.p(K);if(Z!==void 0){const ye=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));he=L.Disposable.from(he,ye)}return he}$provideFoldingRanges(D,B,W,K){return this.s(D,Be,Z=>Z.provideFoldingRanges(i.URI.revive(B),W,K),void 0,K)}registerSelectionRangeProvider(D,B,W){const K=this.t(new xe(this.h,W,this.l),D);return this.e.$registerSelectionRangeProvider(K,this.o(B)),this.p(K)}$provideSelectionRanges(D,B,W,K){return this.s(D,xe,Z=>Z.provideSelectionRanges(i.URI.revive(B),W,K),[],K)}registerCallHierarchyProvider(D,B,W){const K=this.t(new Te(this.h,W),D);return this.e.$registerCallHierarchyProvider(K,this.o(B)),this.p(K)}$prepareCallHierarchy(D,B,W,K){return this.s(D,Te,Z=>Promise.resolve(Z.prepareSession(i.URI.revive(B),W,K)),void 0,K)}$provideCallHierarchyIncomingCalls(D,B,W,K){return this.s(D,Te,Z=>Z.provideCallsTo(B,W,K),void 0,K)}$provideCallHierarchyOutgoingCalls(D,B,W,K){return this.s(D,Te,Z=>Z.provideCallsFrom(B,W,K),void 0,K)}$releaseCallHierarchy(D,B){this.s(D,Te,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(D,B,W){const K=this.t(new Se(this.h,W),D);return this.e.$registerTypeHierarchyProvider(K,this.o(B)),this.p(K)}$prepareTypeHierarchy(D,B,W,K){return this.s(D,Se,Z=>Promise.resolve(Z.prepareSession(i.URI.revive(B),W,K)),void 0,K)}$provideTypeHierarchySupertypes(D,B,W,K){return this.s(D,Se,Z=>Z.provideSupertypes(B,W,K),void 0,K)}$provideTypeHierarchySubtypes(D,B,W,K){return this.s(D,Se,Z=>Z.provideSubtypes(B,W,K),void 0,K)}$releaseTypeHierarchy(D,B){this.s(D,Se,W=>Promise.resolve(W.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(D,B,W){const K=this.q();return this.f.set(K,new se(new ke(this.e,this.h,W,K),D)),this.e.$registerDocumentOnDropEditProvider(K,this.o(B)),this.p(K)}$provideDocumentOnDropEdits(D,B,W,K,Z,he){return this.s(D,ke,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(B,i.URI.revive(W),K,Z,he)),void 0,void 0)}registerDocumentPasteEditProvider(D,B,W,K){const Z=this.q();return this.f.set(Z,new se(new N(this.e,this.h,W,Z),D)),this.e.$registerPasteEditProvider(Z,this.o(B),!!W.prepareDocumentPaste,K.pasteMimeTypes),this.p(Z)}$prepareDocumentPaste(D,B,W,K,Z){return this.s(D,N,he=>he.prepareDocumentPaste(i.URI.revive(B),W,K,Z),void 0,Z)}$providePasteEdits(D,B,W,K,Z,he){return this.s(D,N,ye=>ye.providePasteEdits(B,i.URI.revive(W),K,Z,he),void 0,he)}static w(D){return{pattern:D.source,flags:(0,y.regExpFlags)(D)}}static y(D){return{decreaseIndentPattern:ce.w(D.decreaseIndentPattern),increaseIndentPattern:ce.w(D.increaseIndentPattern),indentNextLinePattern:D.indentNextLinePattern?ce.w(D.indentNextLinePattern):void 0,unIndentedLinePattern:D.unIndentedLinePattern?ce.w(D.unIndentedLinePattern):void 0}}static z(D){return{beforeText:ce.w(D.beforeText),afterText:D.afterText?ce.w(D.afterText):void 0,previousLineText:D.previousLineText?ce.w(D.previousLineText):void 0,action:D.action}}static B(D){return D.map(ce.z)}setLanguageConfiguration(D,B,W){const{wordPattern:K}=W;if(K&&(0,y.regExpLeadsToEndlessLoop)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(B,K):this.h.setWordDefinitionFor(B,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",D,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",D,"Do not use.");const Z=this.q(),he={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?ce.w(W.wordPattern):void 0,indentationRules:W.indentationRules?ce.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?ce.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this.e.$setLanguageConfiguration(Z,B,he),this.p(Z)}$setWordDefinitions(D){for(const B of D)this.h.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(Ie[217],Ce([1,0,5,8,7,30,12,6]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(O,w,m,b){this.c=w,this.d=m,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,w){await this.a.$changeLanguage(O,w);const m=this.c.getDocumentData(O);if(!m)throw new Error(`document '${O.toString()}' NOT found`);return m.document}async tokenAtPosition(O,w){const m=O.version,b=C.Position.from(w),f=await this.a.$tokensAtPosition(O.uri,b),r={type:S.StandardTokenType.Other,range:O.getWordRangeAtPosition(w)??new S.Range(w.line,w.character,w.line,w.character)};if(!f)return r;const o={range:C.Range.to(f.range),type:C.TokenType.to(f.type)};return!o.range.contains(w)||m!==O.version?r:o}createLanguageStatusItem(O,w,m){const b=this.f++,f=this.a,r=this.g,o=`${O.identifier.value}/${w}`;if(r.has(o))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);r.add(o);const l={selector:m,id:w,name:O.displayName??O.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const E=new R.DisposableStore,P=()=>{v?.dispose(),v=(0,I.disposableTimeout)(()=>{E.clear(),this.a.$setLanguageStatus(b,{id:o,name:l.name??O.displayName??O.name,source:O.displayName??O.name,selector:C.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===S.LanguageStatusSeverity.Error?L.default.Error:l.severity===S.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:l.command&&this.d.toInternal(l.command,E),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},p={dispose(){E.dispose(),v?.dispose(),f.$removeLanguageStatus(b),r.delete(o)},get id(){return l.id},get name(){return l.name},set name(n){l.name=n,P()},get selector(){return l.selector},set selector(n){l.selector=n,P()},get text(){return l.text},set text(n){l.text=n,P()},get detail(){return l.detail},set detail(n){l.detail=n,P()},get severity(){return l.severity},set severity(n){l.severity=n,P()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(n){l.accessibilityInformation=n,P()},get command(){return l.command},set command(n){l.command=n,P()},get busy(){return l.busy},set busy(n){l.busy=n,P()}};return P(),p}}e.ExtHostLanguages=y}),define(Ie[78],Ce([1,0,20,10,2,3,13,5,27,17]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(m,b,f){this.f=f,this.d=new Map,this.a=b.getProxy(R.MainContext.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===i.LANGUAGE_DEFAULT}getMessage(m,b){const{message:f,args:r,comment:o}=b;if(this.c)return(0,C.format2)(f,r??{});let l=f;o&&o.length>0&&(l+=`/${Array.isArray(o)?o.join():o}`);const v=this.d.get(m)?.contents[l];return v||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,C.format2)(v??f,r??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let b;const f=await this.g(m);if(!f){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(f),o=JSON.parse(r);b=m.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${m.identifier.value} from ${f}: ${r.message}`);return}b&&this.d.set(m.identifier.value,{contents:b,uri:f})}async g(m){if(m.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(m.identifier.value);return S.URI.revive(b)}return m.l10n?S.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=qe([Ve(0,y.IExtHostInitDataService),Ve(1,k.IExtHostRpcService),Ve(2,I.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(Ie[218],Ce([1,0,13,5,27,17,2,4,9]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends i.AbstractLoggerService{constructor(m,b){super(b.logLevel,R.Event.None),this.g=m.getProxy(C.MainContext.MainThreadLogger)}$setLevel(m,b){b?this.setLevel(I.URI.revive(b),m):(0,y.isUndefined)(m)||this.setLevel(m)}f(m,b,f){return new O(this.g,m,b,f)}};k=qe([Ve(0,L.IExtHostRpcService),Ve(1,S.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class O extends i.AbstractMessageLogger{constructor(m,b,f,r){super(r?.always),this.m=m,this.n=b,this.k=!1,this.l=[],this.setLevel(f),this.m.$createLogger(b,r).then(()=>{this.r(this.l),this.k=!0})}g(m,b){const f=[[m,b]];this.k?this.r(f):this.l.push(...f)}r(m){this.m.$log(this.n,m)}}}),define(Ie[219],Ce([1,0,5,13,24]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(R){return R&&R.title}let I=class{constructor(y,k){this.b=k,this.a=y.getProxy(i.MainContext.MainThreadMessageService)}showMessage(y,k,O,w,m){const b={source:{identifier:y.identifier,label:y.displayName||y.name}};let f;typeof w=="string"||L(w)?f=[w,...m]:(b.modal=w?.modal,b.useCustom=w?.useCustom,b.detail=w?.detail,f=m),b.useCustom&&(0,S.checkProposedApiEnabled)(y,"resolvers");const r=[];for(let o=0;o<f.length;o++){const l=f[o];if(typeof l=="string")r.push({title:l,handle:o,isCloseAffordance:!1});else if(typeof l=="object"){const{title:v,isCloseAffordance:E}=l;r.push({title:v,isCloseAffordance:!!E,handle:o})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(k,O,b,r).then(o=>{if(typeof o=="number")return f[o]})}};I=qe([Ve(1,C.ILogService)],I),e.ExtHostMessageService=I}),define(Ie[220],Ce([1,0,25,4,6,28,10,9,2,53,5,38,8,7,44,193,99]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,P,p,n){this.q=p,this.r=n,this.f=new Map,this.g=new L.ResourceMap,this.h=new Map,this.j=new C.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=E.getProxy(O.MainContext.MainThreadNotebook),this.c=E.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=E.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=P.converter,P.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===13){const t=d.notebookEditor?.notebookUri,u=d.cell.handle,h=this.g.get(t)?.getCell(u);if(h)return h.apiCell}if(d&&d.$mid===14){const t=d.uri,u=this.g.get(t);if(u)return u.apiNotebook}return d}}),l.x(P)}getEditorById(E){const P=this.h.get(E);if(!P)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return P}getIdByEditor(E){for(const[P,p]of this.h)if(p.apiEditor===E)return P}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,P){const p=this.g.get(E);if(!p&&!P)throw new Error(`NO notebook document for '${E}'`);return p}static s(E,P){if(!P)return;const p=P.filenamePattern.map(n=>m.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(P.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${P.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:P.displayName,filenamePattern:p,exclusive:P.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,P,p){const n=l.a++,d=typeof p.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(n,p),this.b.$registerNotebookCellStatusBarItemProvider(n,d,P);let t;return d!==void 0&&(t=p.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(d))),new b.Disposable(()=>{this.f.delete(n),this.b.$unregisterNotebookCellStatusBarItemProvider(n,d),t?.dispose()})}async createNotebookDocument(E){const P=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&m.NotebookData.from(E.content)});return y.URI.revive(P)}async openNotebookDocument(E){const P=this.g.get(E);if(P)return P.apiNotebook;const p=await this.c.$tryOpenNotebook(E),n=this.g.get(y.URI.revive(p));return(0,R.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(E,P){y.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let p;typeof P=="object"?p={position:m.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selections:P.selections&&P.selections.map(m.NotebookRange.from),pinned:typeof P.preview=="boolean"?!P.preview:void 0}:p={preserveFocus:!1};const n=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,p),d=n&&this.h.get(n)?.apiEditor;if(d)return d;throw n?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,P,p,n){const d=this.f.get(E),t=y.URI.revive(P),u=this.g.get(t);if(!u||!d)return;const s=u.getCellFromIndex(p);if(!s)return;const h=await d.provideCellStatusBarItems(s.apiCell,n);if(!h)return;const a=new S.DisposableStore,c=this.p.add([a]),A=(Array.isArray(h)?h:[h]).map(F=>m.NotebookStatusBarItem.from(F,this.i,a));return{cacheId:c,items:A}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,P,p,n,d){if((0,I.isFalsyOrWhitespace)(P))throw new Error("viewType cannot be empty or just whitespace");const t=this.t++;return this.u.set(t,p),this.b.$registerNotebookSerializer(t,{id:E.identifier,location:E.extensionLocation},P,m.NotebookDocumentContentOptions.from(n),l.s(E,d)),(0,S.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(t)})}async $dataToNotebook(E,P,p){const n=this.u.get(E);if(!n)throw new Error("NO serializer found");const d=await n.deserializeNotebook(P.buffer,p);return new f.SerializableObjectWithBuffers(m.NotebookData.from(d))}async $notebookToData(E,P,p){const n=this.u.get(E);if(!n)throw new Error("NO serializer found");const d=await n.serializeNotebook(m.NotebookData.to(P.value),p);return i.VSBuffer.wrap(d)}w(E,P,p){if(this.h.has(P))throw new Error(`editor with id ALREADY EXSIST: ${P}`);const n=new o.ExtHostNotebookEditor(P,this.d,E,p.visibleRanges.map(m.NotebookRange.to),p.selections.map(m.NotebookRange.to),typeof p.viewColumn=="number"?m.ViewColumn.to(p.viewColumn):void 0);this.h.set(P,n)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const p of E.value.removedDocuments){const n=y.URI.revive(p),d=this.g.get(n);d&&(d.dispose(),this.g.delete(n),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(t=>t.document.uri)}),this.n.fire(d.apiNotebook));for(const t of this.h.values())t.notebookData.uri.toString()===n.toString()&&this.h.delete(t.id)}if(E.value.addedDocuments){const p=[];for(const n of E.value.addedDocuments){const d=y.URI.revive(n.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const t=new r.ExtHostNotebookDocument(this.c,this.q,this.r,d,n);p.push(...n.cells.map(u=>r.ExtHostCell.asModelAddData(t.apiNotebook,u))),this.g.get(d)?.dispose(),this.g.set(d,t),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(t.apiNotebook)}}if(E.value.addedEditors)for(const p of E.value.addedEditors){if(this.h.has(p.id))return;const n=y.URI.revive(p.documentUri),d=this.g.get(n);d&&this.w(d,p.id,p)}const P=[];if(E.value.removedEditors)for(const p of E.value.removedEditors){const n=this.h.get(p);n&&(this.h.delete(p),this.k?.id===n.id&&(this.k=void 0),P.push(n))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(n=>this.h.get(n)).filter(n=>!!n);const p=new Set;this.l.forEach(n=>p.add(n.id));for(const n of this.h.values()){const d=p.has(n.id);n._acceptVisibility(d)}this.l=[...this.h.values()].map(n=>n).filter(n=>n.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(E){const P=w.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[P,new w.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>i.VSBuffer.wrap(d))],new w.ApiCommandResult("Notebook Data",d=>m.NotebookData.to(d.value))),n=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[P,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new f.SerializableObjectWithBuffers(m.NotebookData.from(d)))],new w.ApiCommandResult("Bytes",d=>d.buffer));E.registerApiCommand(p),E.registerApiCommand(n)}}e.ExtHostNotebookController=l,l.a=0}),define(Ie[221],Ce([1,0,18,12,21,4,6,28,2,26,13,53,5,38,8,7,72,181,24,44]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o,l,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let P=class{constructor(s,h,a,c,g){this.k=h,this.l=a,this.m=c,this.n=g,this.b=new R.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new w.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=s.getProxy(m.MainContext.MainThreadNotebookKernels);const A=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const j=this.l.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:j}}else if(F&&"notebookEditor"in F){const j=this.l.getIdByEditor(F.notebookEditor);if(j===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:j}}return F})],b.ApiCommandResult.Void);this.m.registerApiCommand(A)}createNotebookController(s,h,a,c,g,A){for(const de of this.h.values())if(de.controller.id===h&&k.ExtensionIdentifier.equals(s.identifier,de.extensionId))throw new Error(`notebook controller with id '${h}' ALREADY exist`);const F=this.i++,j=this;this.n.trace(`NotebookController[${F}], CREATED by ${s.identifier.value}, ${h}`);const te=()=>console.warn(`NO execute handler from notebook controller '${M.id}' of extension: '${s.identifier}'`);let x=!1;const N=new I.DisposableStore,$=new L.Emitter,T=new L.Emitter,M={id:t(s.identifier,h),notebookType:a,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:c||s.identifier.value,preloads:A?A.map(f.NotebookRendererScript.from):[]};let V=g??te,q;this.a.$addKernel(F,M).catch(de=>{console.log(de),x=!0});let le=0;const _=()=>{if(x)return;const de=++le;Promise.resolve().then(()=>{de===le&&this.a.$updateKernel(F,M)})},pe=new R.ResourceMap,ue={get id(){return h},get notebookType(){return M.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return M.label},set label(de){M.label=de??s.displayName??s.name,_()},get detail(){return M.detail??""},set detail(de){M.detail=de,_()},get description(){return M.description??""},set description(de){M.description=de,_()},get kind(){return(0,v.checkProposedApiEnabled)(s,"notebookControllerKind"),M.kind??""},set kind(de){(0,v.checkProposedApiEnabled)(s,"notebookControllerKind"),M.kind=de,_()},get supportedLanguages(){return M.supportedLanguages},set supportedLanguages(de){M.supportedLanguages=de,_()},get supportsExecutionOrder(){return M.supportsExecutionOrder??!1},set supportsExecutionOrder(de){M.supportsExecutionOrder=de,_()},get rendererScripts(){return M.preloads?M.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(de){V=de??te},get interruptHandler(){return q},set interruptHandler(de){q=de,M.supportsInterrupt=Boolean(de),_()},createNotebookCellExecution(de){if(x)throw new Error("notebook controller is DISPOSED");if(!pe.has(de.notebook.uri))throw j.n.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(pe.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${de.notebook.uri.toString()}`);return j._createNotebookCellExecution(de,t(s.identifier,this.id))},dispose:()=>{x||(this.n.trace(`NotebookController[${F}], DISPOSED`),x=!0,this.h.delete(F),N.dispose(),$.dispose(),T.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(de,re){re===r.NotebookControllerAffinity2.Hidden&&(0,v.checkProposedApiEnabled)(s,"notebookControllerAffinityHidden"),j.a.$updateNotebookPriority(F,de.uri,re)},onDidReceiveMessage:T.event,postMessage(de,re){return(0,v.checkProposedApiEnabled)(s,"notebookMessaging"),j.a.$postMessage(F,re&&j.l.getIdByEditor(re),de)},asWebviewUri(de){return(0,v.checkProposedApiEnabled)(s,"notebookMessaging"),(0,o.asWebviewUri)(de,j.k.remote)}};return this.h.set(F,{extensionId:s.identifier,controller:ue,onDidReceiveMessage:T,onDidChangeSelection:$,associatedNotebooks:pe}),ue}getIdByController(s){for(const[h,a]of this.h)if(a.controller===s)return t(a.extensionId,s.id);return null}createNotebookControllerDetectionTask(s,h){const a=this.d++,c=this;this.n.trace(`NotebookControllerDetectionTask[${a}], CREATED by ${s.identifier.value}`),this.a.$addKernelDetectionTask(a,h);const g={dispose:()=>{this.c.delete(a),c.a.$removeKernelDetectionTask(a)}};return this.c.set(a,g),g}registerKernelSourceActionProvider(s,h,a){const c=this.f++,g=this;return this.e.set(c,a),this.n.trace(`NotebookKernelSourceActionProvider[${c}], CREATED by ${s.identifier.value}`),this.a.$addKernelSourceActionProvider(c,h),{dispose:()=>{this.e.delete(c),g.a.$removeKernelSourceActionProvider(c)}}}async $provideKernelSourceActions(s,h){const a=this.e.get(s);if(a){const c=new I.DisposableStore;return this.g.add([c]),(await a.provideNotebookKernelSourceActions(h)??[]).map(A=>f.NotebookKernelSourceAction.from(A,this.m.converter,c))}return[]}$acceptNotebookAssociation(s,h,a){const c=this.h.get(s);if(c){const g=this.l.getNotebookDocument(y.URI.revive(h));a?c.associatedNotebooks.set(g.uri,!0):c.associatedNotebooks.delete(g.uri),this.n.trace(`NotebookController[${s}] ASSOCIATE notebook`,g.uri.toString(),a),c.onDidChangeSelection.fire({selected:a,notebook:g.apiNotebook})}}async $executeCells(s,h,a){const c=this.h.get(s);if(!c)return;const g=this.l.getNotebookDocument(y.URI.revive(h)),A=[];for(const F of a){const j=g.getCell(F);j&&A.push(j.apiCell)}try{this.n.trace(`NotebookController[${s}] EXECUTE cells`,g.uri.toString(),A.length),await c.controller.executeHandler.call(c.controller,A,g.apiNotebook,c.controller)}catch(F){this.n.error(`NotebookController[${s}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(s,h,a){const c=this.h.get(s);if(!c)return;const g=this.l.getNotebookDocument(y.URI.revive(h));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,g.apiNotebook);else for(const A of a){const F=g.getCell(A);F&&this.b.get(F.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,h,a){const c=this.h.get(s);if(!c)return;const g=this.l.getEditorById(h);c.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:a}))}$cellExecutionChanged(s,h,a){const g=this.l.getNotebookDocument(y.URI.revive(s)).getCell(h);if(g){const A=a?f.NotebookCellExecutionState.to(a):r.NotebookCellExecutionState.Idle;A!==void 0&&this.j.fire({cell:g.apiCell,state:A})}}_createNotebookCellExecution(s,h){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this.l.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!c)throw new Error("invalid cell");if(this.b.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const g=new n(h,c,this.a);this.b.set(c.uri,g);const A=g.onDidChangeState(()=>{g.state===p.Resolved&&(g.dispose(),A.dispose(),this.b.delete(c.uri))});return g.asApiObject()}};P=qe([Ve(4,O.ILogService)],P),e.ExtHostNotebookKernels=P;var p;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(p||(p={}));class n extends I.Disposable{get state(){return this.f}constructor(s,h,a){super(),this.j=h,this.k=a,this.b=n.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new S.CancellationTokenSource),this.h=new d(10,c=>this.m(c)),this.i=h.internalMetadata.executionOrder,this.k.$createExecution(this.b,s,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(s){await this.h.addItem(s)}async m(s){const h=Array.isArray(s)?s:[s];return this.k.$updateExecution(this.b,new E.SerializableObjectWithBuffers(h))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(s){let h=this.j;if(s&&(h=this.j.notebook.getCellFromApiCell(s)),!h)throw new Error("INVALID cell");return h.handle}s(s){return s.map(h=>{const a=r.NotebookCellOutput.ensureUniqueMimeTypes(h.items,!0);return a===h.items?f.NotebookCellOutput.from(h):f.NotebookCellOutput.from({items:a,id:h.id,metadata:h.metadata})})}async t(s,h,a){const c=this.r(h),g=this.s((0,i.asArray)(s));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:c,append:a,outputs:g})}async w(s,h,a){return s=r.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(s),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:s.map(f.NotebookCellOutputItem.from),outputId:h.id,append:a})}asApiObject(){const s=this;return Object.freeze({get token(){return s.g.token},get cell(){return s.j.apiCell},get executionOrder(){return s.i},set executionOrder(a){s.i=a,s.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:s.i}])},start(a){if(s.f===p.Resolved||s.f===p.Started)throw new Error("Cannot call start again");s.f=p.Started,s.c.fire(),s.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:a})},end(a,c){if(s.f===p.Resolved)throw new Error("Cannot call resolve twice");s.f=p.Resolved,s.c.fire(),s.h.flush(),s.k.$completeExecution(s.b,new E.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:a}))},clearOutput(a){return s.n(),s.t([],a,!1)},appendOutput(a,c){return s.n(),s.t(a,c,!0)},replaceOutput(a,c){return s.n(),s.t(a,c,!1)},appendOutputItems(a,c){return s.n(),s.w(a,c,!0)},replaceOutputItems(a,c){return s.n(),s.w(a,c,!1)}})}}n.a=0;class d{constructor(s,h){this.d=s,this.e=h,this.a=[],this.b=Date.now()}addItem(s){return this.a.push(s),this.c||(this.c=new C.DeferredPromise,this.b=Date.now(),(0,C.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const s=this.c;this.c=void 0;const h=this.a;return this.a=[],this.e(h).finally(()=>s.complete())}}function t(u,s){return`${u.value}/${s}`}e.createKernelId=t}),define(Ie[222],Ce([1,0,4,5,99]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(R,y){this.c=y,this.a=new Map,this.b=R.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,y,k){const O=this.c.getEditorById(R);this.a.get(y)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(R,y){if(!R.contributes?.notebookRenderer?.some(O=>O.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(O,w,m)=>this.d(y).event(O,w,m),postMessage:(O,w)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,w]=[w,O]);const m=w&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.b.$postMessage(m?.id,y,O)}}}d(R){let y=this.a.get(R);return y||(y=new i.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(R)}}),this.a.set(R,y),y)}}e.ExtHostNotebookRenderers=L}),define(Ie[223],Ce([1,0,6,9,2,24,5]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(k){this.b=new Map,this.a=k.getProxy(I.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(k,O,w){if((0,L.checkProposedApiEnabled)(k,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,w),this.a.$registerProfileContentHandler(O,w.name,w.description,k.identifier.value),(0,i.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(k,O,w,m){const b=this.b.get(k);if(!b)throw new Error(`Unknown handler with id: ${k}`);return b.saveProfile(O,w,m)}async $readProfile(k,O,w){const m=this.b.get(k);if(!m)throw new Error(`Unknown handler with id: ${k}`);return m.readProfile((0,C.isString)(O)?O:S.URI.revive(O),w)}}e.ExtHostProfileContentHandlers=R}),define(Ie[224],Ce([1,0,21,4,6,5,2,7,11,18,30,51]),function(ee,e,i,C,S,L,I,R,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(b,f,r){const o=b.getProxy(L.MainContext.MainThreadQuickOpen);class l{constructor(s,h){this.e=new Map,this.f=0,this.a=s,this.b=h}showQuickPick(s,h,a=i.CancellationToken.None){this.c=void 0;const c=Promise.resolve(s),g=++this.f,A=o.$show(g,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},a),F={},j=A.then(()=>F);return Promise.race([j,c]).then(te=>{if(te!==F)return c.then(x=>{const N=[];for(let $=0;$<x.length;$++){const T=x[$];typeof T=="string"?N.push({label:T,handle:$}):T.kind===R.QuickPickItemKind.Separator?N.push({type:"separator",label:T.label}):N.push({label:T.label,description:T.description,detail:T.detail,picked:T.picked,alwaysShow:T.alwaysShow,handle:$})}return h&&typeof h.onDidSelectItem=="function"&&(this.c=$=>{h.onDidSelectItem(x[$])}),o.$setItems(g,N),A.then($=>{if(typeof $=="number")return x[$];if(Array.isArray($))return $.map(T=>x[T])})})}).then(void 0,te=>{if(!(0,y.isCancellationError)(te))return o.$setError(g,te),Promise.reject(te)})}$onItemSelected(s){this.c?.(s)}showInput(s,h=i.CancellationToken.None){return this.d=s?.validateInput,o.$input(s,typeof this.d=="function",h).then(void 0,a=>{if(!(0,y.isCancellationError)(a))return Promise.reject(a)})}async $validateInput(s){if(!this.d)return;const h=await this.d(s);if(!h||typeof h=="string")return h;let a;switch(h.severity){case R.InputBoxValidationSeverity.Info:a=O.default.Info;break;case R.InputBoxValidationSeverity.Warning:a=O.default.Warning;break;case R.InputBoxValidationSeverity.Error:a=O.default.Error;break;default:a=h.message?O.default.Error:O.default.Ignore;break}return{content:h.message,severity:a}}async showWorkspaceFolderPick(s,h=i.CancellationToken.None){const a=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!a)return;const c=await this.a.getWorkspaceFolders2();if(!!c)return c.find(g=>g.uri.toString()===a.uri.toString())}createQuickPick(s){const h=new d(s,()=>this.e.delete(h._id));return this.e.set(h._id,h),h}createInputBox(s){const h=new t(s,()=>this.e.delete(h._id));return this.e.set(h._id,h),h}$onDidChangeValue(s,h){this.e.get(s)?._fireDidChangeValue(h)}$onDidAccept(s){this.e.get(s)?._fireDidAccept()}$onDidChangeActive(s,h){const a=this.e.get(s);a instanceof d&&a._fireDidChangeActive(h)}$onDidChangeSelection(s,h){const a=this.e.get(s);a instanceof d&&a._fireDidChangeSelection(h)}$onDidTriggerButton(s,h){this.e.get(s)?._fireDidTriggerButton(h)}$onDidTriggerItemButton(s,h,a){const c=this.e.get(s);c instanceof d&&c._fireDidTriggerItemButton(h,a)}$onDidHide(s){this.e.get(s)?._fireDidHide()}}class v{constructor(s,h){this.x=s,this.y=h,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new C.Emitter,this.q=new C.Emitter,this.r=new C.Emitter,this.s=new C.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(s){this.b=s,this.z({title:s})}get step(){return this.c}set step(s){this.c=s,this.z({step:s})}get totalSteps(){return this.d}set totalSteps(s){this.d=s,this.z({totalSteps:s})}get enabled(){return this.g}set enabled(s){this.g=s,this.z({enabled:s})}get busy(){return this.j}set busy(s){this.j=s,this.z({busy:s})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(s){this.k=s,this.z({ignoreFocusOut:s})}get value(){return this.l}set value(s){this.l=s,this.z({value:s})}get placeholder(){return this.m}set placeholder(s){this.m=s,this.z({placeholder:s})}get buttons(){return this.n}set buttons(s){this.n=s.slice(),this.o.clear(),s.forEach((h,a)=>{const c=h===R.QuickInputButtons.Back?-1:a;this.o.set(c,h)}),this.z({buttons:s.map((h,a)=>({...n(h),tooltip:h.tooltip,handle:h===R.QuickInputButtons.Back?-1:a}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(s){this.l=s,this.q.fire(s)}_fireDidTriggerButton(s){const h=this.o.get(s);h&&this.r.fire(h)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,S.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),o.$dispose(this._id))}z(s){if(!this.v){for(const h of Object.keys(s)){const a=s[h];this.u[h]=a===void 0?null:a}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){o.$createOrUpdate(this.u),this.u={id:this._id}}}v.a=1;function E(u){if(u instanceof R.ThemeIcon)return{id:u.id};const s=p(u),h=P(u);return{dark:typeof s=="string"?I.URI.file(s):s,light:typeof h=="string"?I.URI.file(h):h}}function P(u){return typeof u=="object"&&"light"in u?u.light:u}function p(u){return typeof u=="object"&&"dark"in u?u.dark:u}function n(u){const s=E(u.iconPath);let h,a;return"id"in s?a=w.ThemeIcon.asClassName(s):h=s,{iconPath:h,iconClass:a}}class d extends v{constructor(s,h){super(s.identifier,h),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new C.Emitter,this.L=[],this.M=new C.Emitter,this.N=new C.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(s){this.B=s.slice(),this.C.clear(),this.D.clear(),s.forEach((a,c)=>{this.C.set(c,a),this.D.set(a,c)});const h=[];for(let a=0;a<s.length;a++){const c=s[a];c.kind===R.QuickPickItemKind.Separator?h.push({type:"separator",label:c.label}):h.push({handle:a,label:c.label,description:c.description,detail:c.detail,picked:c.picked,alwaysShow:c.alwaysShow,buttons:c.buttons?.map((g,A)=>({...n(g),tooltip:g.tooltip,handle:A}))})}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(s){this.E=s,this.z({canSelectMany:s})}get matchOnDescription(){return this.F}set matchOnDescription(s){this.F=s,this.z({matchOnDescription:s})}get matchOnDetail(){return this.G}set matchOnDetail(s){this.G=s,this.z({matchOnDetail:s})}get sortByLabel(){return this.H}set sortByLabel(s){this.H=s,this.z({sortByLabel:s})}get keepScrollPosition(){return this.I}set keepScrollPosition(s){this.I=s,this.z({keepScrollPosition:s})}get activeItems(){return this.J}set activeItems(s){this.J=s.filter(h=>this.D.has(h)),this.z({activeItems:this.J.map(h=>this.D.get(h))})}get selectedItems(){return this.L}set selectedItems(s){this.L=s.filter(h=>this.D.has(h)),this.z({selectedItems:this.L.map(h=>this.D.get(h))})}_fireDidChangeActive(s){const h=(0,k.coalesce)(s.map(a=>this.C.get(a)));this.J=h,this.K.fire(h)}_fireDidChangeSelection(s){const h=(0,k.coalesce)(s.map(a=>this.C.get(a)));this.L=h,this.M.fire(h)}_fireDidTriggerItemButton(s,h){const a=this.C.get(s);if(!a||!a.buttons||!a.buttons.length)return;const c=a.buttons[h];c&&this.N.fire({button:c,item:a})}}class t extends v{constructor(s,h){super(s.identifier,h),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(s){this.B=s,this.z({password:s})}get prompt(){return this.C}set prompt(s){this.C=s,this.z({prompt:s})}get valueSelection(){return this.D}set valueSelection(s){this.D=s,this.z({valueSelection:s})}get validationMessage(){return this.E}set validationMessage(s){this.E=s,s?typeof s=="string"?this.z({validationMessage:s,severity:O.default.Error}):this.z({validationMessage:s.message,severity:s.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new l(f,r)}e.createExtHostQuickOpen=m});var Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i};define(Ie[225],Ce([1,0,2,4,63,6,12,5,18,124,13,26,51,8,24]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f){"use strict";var r,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(c){if(c)return typeof c.iconPath=="string"?i.URI.file(c.iconPath):i.URI.isUri(c.iconPath)||m.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function v(c,g){if(!c.iconPath&&!g.iconPath)return 0;if(c.iconPath){if(!g.iconPath)return 1}else return-1;const A=typeof c.iconPath=="string"?c.iconPath:i.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,F=typeof g.iconPath=="string"?g.iconPath:i.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,k.comparePaths)(A,F)}function E(c,g){let A=0;if(c.strikeThrough!==g.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==g.faded)return c.faded?1:-1;if(c.tooltip!==g.tooltip)return(c.tooltip||"").localeCompare(g.tooltip||"");if(A=v(c,g),A!==0)return A;if(c.light&&g.light)A=v(c.light,g.light);else{if(c.light)return 1;if(g.light)return-1}if(A!==0)return A;if(c.dark&&g.dark)A=v(c.dark,g.dark);else{if(c.dark)return 1;if(g.dark)return-1}return A}function P(c,g){if(c.command!==g.command)return c.command<g.command?-1:1;if(c.title!==g.title)return c.title<g.title?-1:1;if(c.tooltip!==g.tooltip){if(c.tooltip!==void 0&&g.tooltip!==void 0)return c.tooltip<g.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(c.arguments===g.arguments)return 0;if(c.arguments)if(g.arguments){if(c.arguments.length!==g.arguments.length)return c.arguments.length-g.arguments.length}else return 1;else return-1;for(let A=0;A<c.arguments.length;A++){const F=c.arguments[A],j=g.arguments[A];if(F!==j)return F<j?-1:1}return 0}function p(c,g){let A=(0,k.comparePaths)(c.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(A!==0)return A;if(c.command&&g.command)A=P(c.command,g.command);else{if(c.command)return 1;if(g.command)return-1}if(A!==0)return A;if(c.decorations&&g.decorations)A=E(c.decorations,g.decorations);else{if(c.decorations)return 1;if(g.decorations)return-1}return A}function n(c,g){for(let A=0;A<c.length;A++)if(c[A]!==g[A])return!1;return!0}function d(c,g){return c.command===g.command&&c.title===g.title&&c.tooltip===g.tooltip&&(c.arguments&&g.arguments?n(c.arguments,g.arguments):c.arguments===g.arguments)}function t(c,g){return(0,y.equals)(c,g,d)}class u{get value(){return this.d}set value(g){g=g??"",Oe(this,r,"f").$setInputBoxValue(this.l,g),this.m(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){Oe(this,r,"f").$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,f.checkProposedApiEnabled)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,Oe(this,r,"f").$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,Oe(this,r,"f").$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,Oe(this,r,"f").$setInputBoxVisibility(this.l,g))}constructor(g,A,F){this.k=g,this.l=F,r.set(this,void 0),this.d="",this.e=new C.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,r,A,"f")}showValidationMessage(g,A){(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),Oe(this,r,"f").$showValidationMessage(this.l,g,A)}$onInputBoxValueChange(g){this.m(g)}m(g){this.d=g,this.e.fire(g)}}e.ExtHostSCMInputBox=u,r=new WeakMap;class s{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,A,F,j,te){this.q=g,this.s=A,this.t=F,this.u=j,this.v=te,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new C.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new C.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=s.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,A){const F=this.h.get(g);return F?(0,I.asPromise)(()=>this.s.executeCommand(F.command,...F.arguments||[],A)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(p),F=(0,y.sortedDiff)(this.o,g,p).map(x=>{const N=x.toInsert.map($=>{const T=this.e++;this.g.set(T,$);const M=$.resourceUri;let V;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const oe=new L.DisposableStore;V=this.s.converter.toInternal($.command,oe),this.j.set(T,oe)}else this.h.set(T,$.command);const q=l($.decorations),le=$.decorations&&l($.decorations.light)||q,_=$.decorations&&l($.decorations.dark)||q,pe=[le,_],ue=$.decorations&&$.decorations.tooltip||"",de=$.decorations&&!!$.decorations.strikeThrough,re=$.decorations&&!!$.decorations.faded,G=$.contextValue||"";return{rawResource:[T,M,pe,ue,de,re,G,V],handle:T}});return{start:x.start,deleteCount:x.deleteCount,toInsert:N}}),j=F.map(({start:x,deleteCount:N,toInsert:$})=>[x,N,$.map(T=>T.rawResource)]),te=F.reverse();for(const{start:x,deleteCount:N,toInsert:$}of te){const T=$.map(V=>V.handle),M=this.n.splice(x,N,...T);for(const V of M)this.g.delete(V),this.h.delete(V),this.j.get(V)?.dispose(),this.j.delete(V)}return this.o=g,j}dispose(){this.l=!0,this.m.fire()}}s.d=0;class h{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,Oe(this,o,"f").$updateSourceControl(this.t,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g,Oe(this,o,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this.j}set commitTemplate(g){g!==this.j&&(this.j=g,Oe(this,o,"f").$updateSourceControl(this.t,{commitTemplate:g}))}get acceptInputCommand(){return this.l}set acceptInputCommand(g){this.k.value=new L.DisposableStore,this.l=g;const A=this.v.converter.toInternal(g,this.k.value);Oe(this,o,"f").$updateSourceControl(this.t,{acceptInputCommand:A})}get actionButton(){return(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(g){(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new L.DisposableStore,this.n=g;const A=g!==void 0?{command:this.v.converter.toInternal(g.command,this.m.value),secondaryCommands:g.secondaryCommands?.map(F=>F.map(j=>this.v.converter.toInternal(j,this.m.value))),description:g.description,enabled:g.enabled}:void 0;Oe(this,o,"f").$updateSourceControl(this.t,{actionButton:A??null})}get statusBarCommands(){return this.p}set statusBarCommands(g){if(this.p&&g&&t(this.p,g))return;this.o.value=new L.DisposableStore,this.p=g;const A=(g||[]).map(F=>this.v.converter.toInternal(F,this.o.value));Oe(this,o,"f").$updateSourceControl(this.t,{statusBarCommands:A})}get selected(){return this.q}constructor(g,A,F,j,te,x){this.u=g,this.v=F,this.w=j,this.x=te,this.y=x,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.MutableDisposable,this.l=void 0,this.m=new L.MutableDisposable,this.o=new L.MutableDisposable,this.p=void 0,this.q=!1,this.s=new C.Emitter,this.onDidChangeSelection=this.s.event,this.t=h.d++,this.z=new Map,this.A=new Set,Je(this,o,A,"f"),this.f=new u(g,Oe(this,o,"f"),this.t),Oe(this,o,"f").$registerSourceControl(this.t,j,te,x)}createResourceGroup(g,A){const F=new s(Oe(this,o,"f"),this.v,this.t,g,A),j=C.Event.once(F.onDidDispose)(()=>this.z.delete(F));return this.z.set(F,j),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const g=[],A=[];for(const[F,j]of this.z){j.dispose();const te=F.onDidUpdateResourceStates(()=>{this.A.add(F),this.eventuallyUpdateResourceStates()});C.Event.once(F.onDidDispose)(()=>{this.A.delete(F),te.dispose(),this.e.delete(F.handle),Oe(this,o,"f").$unregisterGroup(this.t,F.handle)}),g.push([F.handle,F.id,F.label,F.features]);const x=F._takeResourceStateSnapshot();x.length>0&&A.push([F.handle,x]),this.e.set(F.handle,F)}Oe(this,o,"f").$registerGroups(this.t,g,A),this.z.clear()}eventuallyUpdateResourceStates(){const g=[];this.A.forEach(A=>{const F=A._takeResourceStateSnapshot();F.length!==0&&g.push([A.handle,F])}),g.length>0&&Oe(this,o,"f").$spliceResourceStates(this.t,g),this.A.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.q=g,this.s.fire(g)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(g=>g.dispose()),Oe(this,o,"f").$unregisterSourceControl(this.t)}}o=new WeakMap,h.d=0,qe([(0,S.debounce)(100)],h.prototype,"eventuallyAddResourceGroups",null),qe([(0,S.debounce)(100)],h.prototype,"eventuallyUpdateResourceStates",null);let a=class rn{get onDidChangeActiveProvider(){return this.j.event}constructor(g,A,F){this.l=A,this.m=F,this.g=new Map,this.h=new Map,this.j=new C.Emitter,this.e=g.getProxy(R.MainContext.MainThreadSCM),this.f=g.getProxy(R.MainContext.MainThreadTelemetry),A.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const te=this.g.get(j.sourceControlHandle);if(!te)return j;const x=te.getResourceGroup(j.groupHandle);return x?x.getResourceState(j.handle):j}else if(j&&j.$mid===4){const te=this.g.get(j.sourceControlHandle);return te?te.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const te=this.g.get(j.handle);return te||j}return j}})}createSourceControl(g,A,F,j){this.m.trace("ExtHostSCM#createSourceControl",g.identifier.value,A,F,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const te=rn.d++,x=new h(g,this.e,this.l,A,F,j);this.g.set(te,x);const N=this.h.get(w.ExtensionIdentifier.toKey(g.identifier))||[];return N.push(x),this.h.set(w.ExtensionIdentifier.toKey(g.identifier),N),x}getLastInputBox(g){this.m.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const A=this.h.get(w.ExtensionIdentifier.toKey(g.identifier)),F=A&&A[A.length-1];return F&&F.inputBox}$provideOriginalResource(g,A,F){const j=i.URI.revive(A);this.m.trace("ExtHostSCM#$provideOriginalResource",g,j.toString());const te=this.g.get(g);return!te||!te.quickDiffProvider||!te.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>te.quickDiffProvider.provideOriginalResource(j,F)).then(x=>x||null)}$onInputBoxValueChange(g,A){this.m.trace("ExtHostSCM#$onInputBoxValueChange",g);const F=this.g.get(g);return F&&F.inputBox.$onInputBoxValueChange(A),Promise.resolve(void 0)}$executeResourceCommand(g,A,F,j){this.m.trace("ExtHostSCM#$executeResourceCommand",g,A,F);const te=this.g.get(g);if(!te)return Promise.resolve(void 0);const x=te.getResourceGroup(A);return x?x.$executeResourceCommand(F,j):Promise.resolve(void 0)}$validateInput(g,A,F){this.m.trace("ExtHostSCM#$validateInput",g);const j=this.g.get(g);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>j.inputBox.validateInput(A,F)).then(te=>{if(!te)return Promise.resolve(void 0);const x=b.MarkdownString.fromStrict(te.message);return x?Promise.resolve([x,te.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}};a.d=0,a=qe([Ve(2,O.ILogService)],a),e.ExtHostSCM=a}),define(Ie[79],Ce([1,0,5,4,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(R){this.b=new C.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,y){return this.a.$getPassword(R,y)}store(R,y,k){return this.a.$setPassword(R,y,k)}delete(R,y){return this.a.$deletePassword(R,y)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[226],Ce([1,0,7,5,140,6,8,9]),function(ee,e,i,C,S,L,I,R){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,r,o,l,v=i.StatusBarAlignment.Left,E){y.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new L.DisposableStore,Je(this,y,f,"f"),Je(this,k,r,"f"),this.c=O.a++,this.e=o,this.f=l,this.g=v,this.h=this.u(E)}u(f){if(!!(0,R.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(f){this.k=f,this.v()}set name(f){this.m=f,this.v()}set tooltip(f){this.l=f,this.v()}set color(f){this.n=f,this.v()}set backgroundColor(f){f&&!O.b.has(f.id)&&(f=void 0),this.o=f,this.v()}set command(f){this.r?.fromApi!==f&&(this.p&&this.q.add(this.p),this.p=new L.DisposableStore,typeof f=="string"?this.r={fromApi:f,internal:Oe(this,k,"f").toInternal({title:"",command:f},this.p)}:f?this.r={fromApi:f,internal:Oe(this,k,"f").toInternal(f,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(f){this.t=f,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Oe(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let r;this.m?r=this.m:r=(0,S.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=O.b.get(this.o.id));const l=I.MarkdownString.fromStrict(this.l);Oe(this,y,"f").$setEntry(this.c,f,r,this.k,l,this.r?.internal,o,this.o,this.g===i.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=O,y=new WeakMap,k=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,S.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const r={message:f};return this.b.unshift(r),this.c(),new i.Disposable(()=>{const o=this.b.indexOf(r);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class m{constructor(f,r){this.a=f.getProxy(C.MainContext.MainThreadStatusBar),this.b=r,this.c=new w(this)}createStatusBarEntry(f,r,o,l){return new O(this.a,this.b,f,r,o,l)}setStatusBarMessage(f,r){const o=this.c.setMessage(f);let l;return typeof r=="number"?l=setTimeout(()=>o.dispose(),r):typeof r<"u"&&r.then(()=>o.dispose(),()=>o.dispose()),new i.Disposable(()=>{o.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=m}),define(Ie[80],Ce([1,0,5,4,3]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(R,y){this.c=y,this.b=new C.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,y){this.a.$registerExtensionStorageKeysToSync(R,y)}async initializeExtensionStorage(R,y,k){const O=await this.a.$initializeExtensionStorage(R,y);let w;return O&&(w=this.d(R,y,O)),w||k}setValue(R,y,k){return this.a.$setValue(R,y,k)}$acceptValue(R,y,k){const O=this.d(R,y,k);O&&this.b.fire({shared:R,key:y,value:O})}d(R,y,k){try{return JSON.parse(k)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${R}): ${O}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(Ie[81],Ce([1,0,3,27,13,59,2]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let R=class{constructor(k,O,w){this.d=O,this.f=w,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(k){return I.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,O=await this.g(k);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(I.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:I.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(w){this.d.error("[ExtHostStorage]",w);return}}workspaceValue(k){if(this.c)return I.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return I.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=qe([Ve(0,C.IExtHostInitDataService),Ve(1,S.ILogService),Ve(2,L.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(Ie[60],Ce([1,0,4,5,3,2,17,6,7,141,11,182,21,34,166,51,9,12,8]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class E{constructor(a,c,g,A){this.k=a,this._id=c,this.l=g,this.m=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(j=>this.f=j);const F=this;this.value={get name(){return F.m||""},get processId(){return F.b},get creationOptions(){return F.l},get exitStatus(){return F.h},get state(){return F.j},sendText(j,te=!0){F.o(),F.k.$sendText(F._id,j,te)},show(j){F.o(),F.k.$show(F._id,j)},hide(){F.o(),F.k.$hide(F._id)},dispose(){F.a||(F.a=!0,F.k.$dispose(F._id))},get dimensions(){if(!(F.d===void 0||F.g===void 0))return{columns:F.d,rows:F.g}}}}async create(a,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:a.name,shellPath:(0,o.withNullAsUndefined)(a.shellPath),shellArgs:(0,o.withNullAsUndefined)(a.shellArgs),cwd:(0,o.withNullAsUndefined)(a.cwd),env:(0,o.withNullAsUndefined)(a.env),icon:(0,o.withNullAsUndefined)(u(a.iconPath)),color:r.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,o.withNullAsUndefined)(a.message),strictEnv:(0,o.withNullAsUndefined)(a.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(a.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this.n(a.location,c?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(a.isTransient)})}async createExtensionTerminal(a,c,g,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:g,color:r.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.n(a,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(a,c){return typeof a=="object"?"parentTerminal"in a&&a.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in a?{viewColumn:v.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus}:void 0:a}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(a){this.m=a}setExitStatus(a,c){this.h=Object.freeze({code:a,reason:c})}setDimensions(a,c){return a===this.d&&c===this.g||a===0||c===0?!1:(this.d=a,this.g=c,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(a){this.f?(this.f(a),this.f=void 0):this.b.then(c=>{c!==a&&(this.b=Promise.resolve(a))})}}e.ExtHostTerminal=E;class P{get onProcessReady(){return this.b.event}constructor(a){this.g=a,this.id=0,this.shouldPersist=!1,this.a=new i.Emitter,this.onProcessData=this.a.event,this.b=new i.Emitter,this.d=new i.Emitter,this.onDidChangeProperty=this.d.event,this.f=new i.Emitter,this.onProcessExit=this.f.event}refreshProperty(a){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${a}`)}updateProperty(a,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${a}, value: ${c}`)}async start(){}shutdown(){this.g.close()}input(a){this.g.handleInput?.(a)}resize(a,c){this.g.setDimensions?.({columns:a,rows:c})}async processBinary(a){}acknowledgeDataEvent(a){}async setUnicodeVersion(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this.g.onDidWrite(c=>this.a.fire(c)),this.g.onDidClose?.((c=void 0)=>{this.f.fire(c===void 0?void 0:c)}),this.g.onDidOverrideDimensions?.(c=>{c&&this.d.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this.g.onDidChangeName?.(c=>{this.d.fire({type:"title",value:c})}),this.g.open(a||void 0),a&&this.g.setDimensions?.(a),this.b.fire({pid:-1,cwd:""})}}let p=1,n=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(a=>a.value)}get onDidWriteTerminalData(){return this.I.event}constructor(a,c){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new i.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new i.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new i.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new i.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new i.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new i.Emitter,this.onDidChangeShell=this.J.event,this.a=c.getProxy(C.MainContext.MainThreadTerminalService),this.s=new f.TerminalDataBufferer(this.a.$sendProcessData),this.I=new i.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(a),this.B({dispose:()=>{for(const[g,A]of this.g)A.shutdown(!0)}})}getDefaultShell(a){return(a?this.n:this.m)?.path||""}getDefaultShellArgs(a){return(a?this.n:this.m)?.args||[]}createExtensionTerminal(a,c){const g=new E(this.a,(0,b.generateUuid)(),a,a.name),A=new P(a.pty);return g.createExtensionTerminal(a.location,this.L(a,c).resolvedExtHostIdentifier,u(a.iconPath),s(a.color)).then(F=>{const j=this.M(F,A);this.h[F]=j}),this.f.push(g),g.value}L(a,c){if(c=c||{},a.location&&typeof a.location=="object"&&"parentTerminal"in a.location){const g=a.location.parentTerminal;if(g){const A=this.f.find(F=>F.value===g);A&&(c.resolvedExtHostIdentifier=A._id)}}else a.location&&typeof a.location!="object"?c.location=a.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(a,c){if(!this.O(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const A=new P(c),F=this.M(a,A);this.h[a]=F}async $acceptActiveTerminalChanged(a){const c=this.b;if(a===null){this.b=void 0,c!==this.b&&this.F.fire(this.b);return}const g=this.O(a);g&&(this.b=g,c!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(a,c){const g=this.O(a);g&&this.I.fire({terminal:g.value,data:c})}async $acceptTerminalDimensions(a,c,g){const A=this.O(a);A&&A.setDimensions(c,g)&&this.G.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptTerminalMaximumDimensions(a,c,g){this.g.get(a)?.resize(c,g)}async $acceptTerminalTitleChange(a,c){const g=this.O(a);g&&(g.name=c)}async $acceptTerminalClosed(a,c,g){const A=this.Q(this.f,a);if(A!==null){const F=this.f.splice(A,1)[0];F.setExitStatus(c,g),this.C.fire(F.value)}}$acceptTerminalOpened(a,c,g,A){if(c){const te=this.Q(this.f,c);if(te!==null){this.f[te]._id=a,this.D.fire(this.terminals[te]),this.f[te].isOpen=!0;return}}const F={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:L.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},j=new E(this.a,a,F,g);this.f.push(j),this.D.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(a,c){this.O(a)?._setProcessId(c)}async $startExtensionTerminal(a,c){const g=this.O(a);if(!g)return{message:(0,k.localize)(0,null,a)};g.isOpen||await new Promise(F=>{const j=this.onDidOpenTerminal(async te=>{te===g.value&&(j.dispose(),F())})});const A=this.g.get(a);A?A.startSendingEvents(c):this.j[a]={initialDimensions:c}}M(a,c){const g=new R.DisposableStore;g.add(c.onProcessReady(F=>this.a.$sendProcessReady(a,F.pid,F.cwd))),g.add(c.onDidChangeProperty(F=>this.a.$sendProcessProperty(a,F))),this.s.startBuffering(a,c.onProcessData),g.add(c.onProcessExit(F=>this.N(a,F))),this.g.set(a,c);const A=this.j[a];return A&&c instanceof P&&(c.startSendingEvents(A.initialDimensions),delete this.j[a]),g}$acceptProcessAckDataEvent(a,c){this.g.get(a)?.acknowledgeDataEvent(c)}$acceptProcessInput(a,c){this.g.get(a)?.input(c)}$acceptTerminalInteraction(a){const c=this.O(a);c?.setInteractedWith()&&this.H.fire(c.value)}$acceptProcessResize(a,c,g){try{this.g.get(a)?.resize(c,g)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(a,c){this.g.get(a)?.shutdown(c)}$acceptProcessRequestInitialCwd(a){this.g.get(a)?.getInitialCwd().then(c=>this.a.$sendProcessProperty(a,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(a){this.g.get(a)?.getCwd().then(c=>this.a.$sendProcessProperty(a,{type:"cwd",value:c}))}$acceptProcessRequestLatency(a){return Promise.resolve(a)}registerLinkProvider(a){return this.u.add(a),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(a),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(a,c,g){if(this.v.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this.v.set(c,g),this.a.$registerProfileProvider(c,a.identifier.value),new y.Disposable(()=>{this.v.delete(c),this.a.$unregisterProfileProvider(c)})}registerTerminalQuickFixProvider(a,c,g){if(this.w.has(a))throw new Error(`Terminal quick fix provider "${a}" is already registered`);return this.w.set(a,g),this.a.$registerQuickFixProvider(a,c),new y.Disposable(()=>{this.w.delete(a),this.a.$unregisterQuickFixProvider(a)})}async $provideTerminalQuickFixes(a,c){const g=new m.CancellationTokenSource().token;if(g.isCancellationRequested)return;const A=this.w.get(a);if(!A)return;const F=await A.provideTerminalQuickFixes(c,g);if(F!==null)return F}async $createContributedProfileTerminal(a,c){const g=new m.CancellationTokenSource().token;let A=await this.v.get(a)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,c);return}this.createTerminalFromOptions(A.options,c)}}async $provideLinks(a,c){const g=this.O(a);if(!g)return[];this.y.delete(a),this.z.get(a)?.dispose(!0);const F=new m.CancellationTokenSource;this.z.set(a,F);const j=[],te={terminal:g.value,line:c},x=[];for(const T of this.u)x.push(l.Promises.withAsyncBody(async M=>{F.token.onCancellationRequested(()=>M({provider:T,links:[]}));const V=await T.provideTerminalLinks(te,F.token)||[];F.token.isCancellationRequested||M({provider:T,links:V})}));const N=await Promise.all(x);if(F.token.isCancellationRequested)return[];const $=new Map;for(const T of N)T&&T.links.length>0&&j.push(...T.links.map(M=>{const V={id:p++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return $.set(V.id,{provider:T.provider,link:M}),V}));return this.y.set(a,$),j}$activateLink(a,c){const g=this.y.get(a)?.get(c);!g||g.provider.handleTerminalLink(g.link)}N(a,c){this.s.stopBuffering(a),this.g.delete(a),delete this.j[a];const g=this.h[a];g&&(g.dispose(),delete this.h[a]),this.a.$sendProcessExit(a,c)}O(a){return this.P(this.f,a)}P(a,c){const g=this.Q(a,c);return g!==null?a[g]:null}Q(a,c){let g=null;return a.some((A,F)=>A._id===c?(g=F,!0):!1),g}getEnvironmentVariableCollection(a){let c=this.l.get(a.identifier.value);return c||(c=new d,this.S(a.identifier.value,c)),c}R(a,c){const g=(0,w.serializeEnvironmentVariableCollection)(c.map);this.a.$setEnvironmentVariableCollection(a,c.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(a){a.forEach(c=>{const g=c[0],A=new d(c[1]);this.S(g,A)})}$acceptDefaultProfile(a,c){const g=this.m;this.m=a,this.n=c,g?.path!==a.path&&this.J.fire(a.path)}S(a,c){this.l.set(a,c),c.onDidChangeCollection(()=>{this.R(a,c)})}};n=qe([Ve(1,I.IExtHostRpcService)],n),e.BaseExtHostTerminalService=n;class d{get persistent(){return this.a}set persistent(a){this.a=a,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(a){this.map=new Map,this.a=!0,this.b=new i.Emitter,this.map=new Map(a)}get size(){return this.map.size}replace(a,c){this.d(a,{value:c,type:y.EnvironmentVariableMutatorType.Replace})}append(a,c){this.d(a,{value:c,type:y.EnvironmentVariableMutatorType.Append})}prepend(a,c){this.d(a,{value:c,type:y.EnvironmentVariableMutatorType.Prepend})}d(a,c){const g=this.map.get(a);(!g||g.value!==c.value||g.type!==c.type)&&(this.map.set(a,c),this.b.fire())}get(a){return this.map.get(a)}forEach(a,c){this.map.forEach((g,A)=>a.call(c,A,g,this))}[Symbol.iterator](){return this.map.entries()}delete(a){this.map.delete(a),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let t=class extends n{constructor(a){super(!1,a)}createTerminal(a,c,g){throw new O.NotSupportedError}createTerminalFromOptions(a,c){throw new O.NotSupportedError}};t=qe([Ve(0,I.IExtHostRpcService)],t),e.WorkerExtHostTerminalService=t;function u(h){if(!(!h||typeof h=="string"))return"id"in h?{id:h.id,color:h.color}:h}function s(h){return r.ThemeColor.isThemeColor(h)?h:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)},Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i};define(Ie[227],Ce([1,0,18,12,25,21,4,191,228,6,22,9,34,5,17,100,8,7,43,71,55,24]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o,l,v,E,P,p){"use strict";var n,d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class{constructor(T,M,V){this.j=V,this.c=new I.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=T.getProxy(b.MainContext.MainThreadTesting),this.h=new te(this.f),this.g=new a(this.f),M.registerArgumentProcessor({processArgument:q=>{if(q?.$mid!==15)return q;const le=q,_=le.tests[le.tests.length-1].item.extId;return this.d.get(v.TestId.root(_))?.collection.tree.get(_)?.actual??(0,r.toItemFromContext)(q)}})}createTestController(T,M,V,q){if(this.d.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const le=new k.DisposableStore,_=le.add(new r.ExtHostTestItemCollection(M,V,this.j));_.root.label=V;const pe=new Map,ue=this.f,de={items:_.root.children,get label(){return V},set label(G){V=G,_.root.label=G,ue.$updateController(M,{label:V})},get refreshHandler(){return q},set refreshHandler(G){q=G,ue.$updateController(M,{canRefresh:!!G})},get id(){return M},createRunProfile:(G,H,oe,ve,Ae,Be)=>{let xe=(0,y.hash)(G);for(;pe.has(xe);)xe++;return Be!==void 0&&(0,p.checkProposedApiEnabled)(T,"testContinuousRun"),new x(this.f,pe,M,xe,G,H,oe,ve,Ae,Be)},createTestItem(G,H,oe){return new r.TestItemImpl(M,G,H,oe)},createTestRun:(G,H,oe=!0)=>this.g.createTestRun(M,_,G,H,oe),set resolveHandler(G){_.resolveHandler=G},get resolveHandler(){return _.resolveHandler},dispose:()=>{le.dispose()}};ue.$registerTestController(M,V,!!q),le.add((0,k.toDisposable)(()=>ue.$unregisterTestController(M)));const re={controller:de,collection:_,profiles:pe};return this.d.set(M,re),le.add((0,k.toDisposable)(()=>this.d.delete(M))),le.add(_.onDidGenerateDiff(G=>ue.$publishDiff(M,G.map(P.TestsDiffOp.serialize)))),de}createTestObserver(){return this.h.checkout()}async runTests(T,M=L.CancellationToken.None){const V=c(T);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.d.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(le=>v.TestId.fromExtHostTestItem(le,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:N[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:T.exclude?.map(le=>le.id)},M)}$syncTests(){for(const{collection:T}of this.d.values())T.flushDiff();return Promise.resolve()}$provideFileCoverage(T,M,V){return(0,i.mapFind)(this.g.trackers,le=>le.id===T?le.getCoverage(M):void 0)?.provideFileCoverage(V)??Promise.resolve([])}$resolveFileCoverage(T,M,V,q){return(0,i.mapFind)(this.g.trackers,_=>_.id===T?_.getCoverage(M):void 0)?.resolveFileCoverage(V,q)??Promise.resolve([])}$configureRunProfile(T,M){this.d.get(T)?.profiles.get(M)?.configureHandler?.()}async $refreshTests(T,M){await this.d.get(T)?.controller.refreshHandler?.(M)}$publishTestResults(T){this.results=Object.freeze(T.map(M=>(0,O.deepFreeze)(o.TestResults.to(M))).concat(this.results).sort((M,V)=>V.completedAt-M.completedAt).slice(0,32)),this.c.fire()}async $expandTest(T,M){const V=this.d.get(v.TestId.fromString(T).controllerId)?.collection;V&&(await V.expand(T,M<0?1/0:M),V.flushDiff())}$acceptDiff(T){this.h.applyDiff(T.map(P.TestsDiffOp.deserialize))}async $runControllerTests(T,M){return Promise.all(T.map(V=>this.k(V,!1,M)))}async $startContinuousRun(T,M){const V=new L.CancellationTokenSource(M),q=await Promise.all(T.map(le=>this.k(le,!0,V.token)));return!M.isCancellationRequested&&!q.some(le=>le.error)&&await new Promise(le=>M.onCancellationRequested(le)),V.dispose(!0),q}async k(T,M,V){const q=this.d.get(T.controllerId);if(!q)return{};const{collection:le,profiles:_}=q,pe=_.get(T.profileId);if(!pe)return{};const ue=T.testIds.map(H=>le.tree.get(H)).filter(w.isDefined),de=T.excludeExtIds.map(H=>q.collection.tree.get(H)).filter(w.isDefined).filter(H=>ue.some(oe=>oe.fullId.compare(H.fullId)===2));if(!ue.length)return{};const re=new l.TestRunRequest2(ue.some(H=>H.actual instanceof r.TestItemRootImpl)?void 0:ue.map(H=>H.actual),de.map(H=>H.actual),pe,M),G=(0,P.isStartControllerTests)(T)&&this.g.prepareForMainThreadTestRun(re,g.fromInternal(T,q.collection),V);try{return await pe.runHandler(re,V),{}}catch(H){return{error:String(H)}}finally{G&&(G.hasRunningTasks&&!V.isCancellationRequested&&await I.Event.toPromise(G.onEnd),G.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.g.cancelAllRuns():this.g.cancelRunById(T)}};t=qe([Ve(0,f.IExtHostRpcService)],t),e.ExtHostTesting=t;const u=1e4;var s;(function($){$[$.Running=0]="Running",$[$.Cancelling=1]="Cancelling",$[$.Ended=2]="Ended"})(s||(s={}));class h extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(T,M,V){super(),this.k=T,this.l=M,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.Emitter),this.onEnd=this.j.event,this.h=this.B(new L.CancellationTokenSource(V));const q=this.B(new C.RunOnceScheduler(()=>this.m(),u));this.B(this.h.token.onCancellationRequested(()=>q.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(T){return this.f.get(T)?.coverage}createRun(T){const M=this.k.id,V=this.k.controllerId,q=(0,m.generateUuid)(),le=new A(this.l,M,q),_=re=>(G,...H)=>{if(ue){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(G)||(this.s(G),re(G,...H))},pe=(re,G)=>{const H=G instanceof Array?G.map(o.TestMessage.from):[o.TestMessage.from(G)];if(re.uri&&re.range){const oe={range:o.Range.from(re.range),uri:re.uri};for(const ve of H)ve.location=ve.location||oe}this.l.$appendTestMessagesInRun(M,q,v.TestId.fromExtHostTestItem(re,V).toString(),H)};let ue=!1;const de={isPersisted:this.k.isPersisted,token:this.h.token,name:T,get coverageProvider(){return le.coverageProvider},set coverageProvider(re){le.coverageProvider=re},enqueued:_(re=>{this.l.$updateTestStateInRun(M,q,v.TestId.fromExtHostTestItem(re,V).toString(),1)}),skipped:_(re=>{this.l.$updateTestStateInRun(M,q,v.TestId.fromExtHostTestItem(re,V).toString(),5)}),started:_(re=>{this.l.$updateTestStateInRun(M,q,v.TestId.fromExtHostTestItem(re,V).toString(),2)}),errored:_((re,G,H)=>{pe(re,G),this.l.$updateTestStateInRun(M,q,v.TestId.fromExtHostTestItem(re,V).toString(),6,H)}),failed:_((re,G,H)=>{pe(re,G),this.l.$updateTestStateInRun(M,q,v.TestId.fromExtHostTestItem(re,V).toString(),4,H)}),passed:_((re,G)=>{this.l.$updateTestStateInRun(M,q,v.TestId.fromExtHostTestItem(re,this.k.controllerId).toString(),3,G)}),appendOutput:(re,G,H)=>{ue||(H&&(this.k.isIncluded(H)?this.s(H):H=void 0),this.l.$appendOutputToRun(M,q,S.VSBuffer.fromString(re),G&&o.location.from(G),H&&v.TestId.fromExtHostTestItem(H,V).toString()))},end:()=>{ue||(ue=!0,this.l.$finishedTestRunTask(M,q),this.f.delete(q),this.f.size||this.p())}};return this.f.set(q,{run:de,coverage:le}),this.l.$startedTestRunTask(M,{id:q,name:T,running:!0}),de}m(){for(const{run:T}of this.f.values())T.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(T){if(!(T instanceof r.TestItemImpl))throw new E.InvalidTestItemError(T.id);if(this.g.has(v.TestId.fromExtHostTestItem(T,this.k.controllerId).toString()))return;const M=[],V=this.k.colllection.root;for(;;){const q=o.TestItem.from(T);if(M.unshift(q),this.g.has(q.extId)||(this.g.add(q.extId),T===V))break;T=T.parent||V}this.l.$addTestsToRun(this.k.controllerId,this.k.id,M)}}class a{get trackers(){return this.c.values()}constructor(T){this.d=T,this.c=new Map}prepareForMainThreadTestRun(T,M,V){return this.f(T,M,V)}cancelRunById(T){for(const M of this.c.values())if(M.id===T){M.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,M,V,q,le){const _=this.c.get(V);if(_)return _.createRun(q);const pe=g.fromPublic(T,M,V,le),ue=c(V);this.d.$startedExtensionTestRun({controllerId:T,continuous:!!V.continuous,profile:ue&&{group:N[ue.kind],id:ue.profileId},exclude:V.exclude?.map(re=>v.TestId.fromExtHostTestItem(re,M.root.id).toString())??[],id:pe.id,include:V.include?.map(re=>v.TestId.fromExtHostTestItem(re,M.root.id).toString())??[M.root.id],persist:le});const de=this.f(V,pe);return de.onEnd(()=>{this.d.$finishedExtensionTestRun(pe.id),de.dispose()}),de.createRun(q)}f(T,M,V){const q=new h(M,this.d,V);return this.c.set(T,q),q.onEnd(()=>this.c.delete(T)),q}}e.TestRunCoordinator=a;const c=$=>{if(!!$.profile){if(!($.profile instanceof x))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class g{static fromPublic(T,M,V,q){return new g(T,(0,m.generateUuid)(),V.include?.map(le=>v.TestId.fromExtHostTestItem(le,T).toString())??[T],V.exclude?.map(le=>v.TestId.fromExtHostTestItem(le,T).toString())??[],q,M)}static fromInternal(T,M){return new g(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,M)}constructor(T,M,V,q,le,_){this.controllerId=T,this.id=M,this.isPersisted=le,this.colllection=_,this.c=V.map(pe=>pe+"\0"),this.d=q.map(pe=>pe+"\0")}isIncluded(T){const M=v.TestId.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const V of this.d)if(M===V||M.startsWith(V))return!1;for(const V of this.c)if(M===V||M.startsWith(V))return!0;return!1}}e.TestRunDto=g;class A{set coverageProvider(T){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!T||(this.c=T,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(T,M,V){this.f=T,this.g=M,this.h=V}async provideFileCoverage(T){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(T))());try{return(await this.d)?.map(o.TestCoverage.fromFile)??[]}catch(M){throw this.d=void 0,M}}async resolveFileCoverage(T,M){const V=await this.d;let q=V?.[T];return!this.c||!V||!q?[]:(q.detailedCoverage||(q=V[T]=await this.c.resolveFileCoverage?.(q,M)??q),q.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class F{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(T){this.h=T,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,o.TestItem.toPlain(T.item)),this.c.has(T)||this.d.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.d.delete(T);const M=v.TestId.parentId(T.item.extId);if(M&&this.g.has(M.toString())){this.g.add(T.item.extId);return}this.f.add(T)}getChangeEvent(){const{c:T,d:M,f:V}=this;return{get added(){return[...T].map(q=>q.revived)},get updated(){return[...M].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class j extends P.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new I.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(T){return this.d.get(T)}getMirroredTestDataByReference(T){return this.d.get(T.id)}p(T,M){return{...T,revived:o.TestItem.toPlain(T.item),depth:M?M.depth+1:0,children:new Set}}o(){return new F(this.q)}}class te{constructor(T){this.d=T}checkout(){this.c||(this.c=this.f());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(M=>M.revived)},dispose:(0,R.once)(()=>{--T.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}f(){const T=new j;return this.d.$subscribeToDiffs(),{observers:0,tests:T}}}class x{get label(){return this.d}set label(T){T!==this.d&&(this.d=T,Oe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,Oe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:T}))}get isDefault(){return this.f}set isDefault(T){T!==this.f&&(this.f=T,Oe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,Oe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?o.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,Oe(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}constructor(T,M,V,q,le,_,pe,ue=!1,de=void 0,re=!1){this.controllerId=V,this.profileId=q,this.d=le,this.kind=_,this.runHandler=pe,this.f=ue,this._tag=de,this.g=re,n.set(this,void 0),d.set(this,void 0),Je(this,n,T,"f"),Je(this,d,M,"f"),M.set(q,this);const G=N[_];if(typeof G!="number")throw new Error(`Unknown TestRunProfile.group ${_}`);Oe(this,n,"f").$publishTestRunProfile({profileId:q,controllerId:V,tag:de?o.TestTag.namespace(this.controllerId,de.id):null,label:le,group:G,isDefault:ue,hasConfigurationHandler:!1,supportsContinuousRun:re})}dispose(){Oe(this,d,"f")?.delete(this.profileId)&&(Je(this,d,void 0,"f"),Oe(this,n,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=x,n=new WeakMap,d=new WeakMap;const N={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Ie[229],Ce([1,0,18,4,5,101,8,7]),function(ee,e,i,C,S,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(O,w){this.i=w,this.a=new C.Emitter,this.b=new C.Emitter,this.c=new C.Emitter,this.d=new C.Emitter,this.f=new C.Emitter,this.g=new C.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(S.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const w=this.i.allEditors();return O?w:w.map(m=>m.value)}async showTextDocument(O,w,m){let b;typeof w=="number"?b={position:I.ViewColumn.from(w),preserveFocus:m}:typeof w=="object"?b={position:I.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?I.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:b={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(O.uri,b),r=f&&this.i.getEditor(f);if(r)return r.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,w){return new L.TextEditorDecorationType(this.h,O,w).value}$acceptEditorPropertiesChanged(O,w){const m=this.i.getEditor(O);if(!m)throw new Error("unknown text editor");if(w.options&&m._acceptOptions(w.options),w.selections){const b=w.selections.selections.map(I.Selection.to);m._acceptSelections(b)}if(w.visibleRanges){const b=i.coalesce(w.visibleRanges.map(I.Range.to));m._acceptVisibleRanges(b)}if(w.options&&this.b.fire({textEditor:m.value,options:{...w.options,lineNumbers:I.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const b=R.TextEditorSelectionChangeKind.fromValue(w.selections.source),f=w.selections.selections.map(I.Selection.to);this.a.fire({textEditor:m.value,selections:f,kind:b})}if(w.visibleRanges){const b=i.coalesce(w.visibleRanges.map(I.Range.to));this.c.fire({textEditor:m.value,visibleRanges:b})}}$acceptEditorPositionData(O){for(const w in O){const m=this.i.getEditor(w);if(!m)throw new Error("Unknown text editor");const b=I.ViewColumn.to(O[w]);m.value.viewColumn!==b&&(m._acceptViewColumn(b),this.d.fire({textEditor:m.value,viewColumn:b}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.ExtHostEditors=y}),define(Ie[230],Ce([1,0,2,3,5,6,7,8,26,9]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class O{constructor(b,f){this.b=new Map,this.c=new Map,this.a=b.getProxy(S.MainContext.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&y.ExtensionIdentifier.equals(o,this.b.get(r.source)?.extension)){const l=r.uri===void 0?void 0:i.URI.revive(r.uri);return this.c.get(r.source)?.get(w(l))?.get(r.handle)}else return;return r}})}async $getTimeline(b,f,r,o){return this.b.get(b)?.provider.provideTimeline(i.URI.revive(f),r,o)}registerTimelineProvider(b,f,r,o){const l=new L.DisposableStore,v=this.d(f.id,o,l).bind(this);let E;f.onDidChange&&(E=f.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:f.id}),this));const P=this.c;return this.f({...f,scheme:b,onDidChange:void 0,async provideTimeline(p,n,d){n?.resetCache&&(l.clear(),P.get(f.id)?.clear());const t=await f.provideTimeline(p,n,d);if(t==null)return;const u=v(p,n);return{...t,source:f.id,items:t.items.map(u)}},dispose(){for(const p of P.values())p.get(f.id)?.clear();E?.dispose(),l.dispose()}},r)}d(b,f,r){return(o,l)=>{let v;if(l?.cacheResults){let E=this.c.get(b);E===void 0&&(E=new Map,this.c.set(b,E));const P=w(o);v=E.get(P),v===void 0&&(v=new Map,E.set(P,v))}return E=>{const{iconPath:P,...p}=E,n=`${b}|${E.id??E.timestamp}`;v?.set(n,E);let d,t,u;E.iconPath&&(P instanceof I.ThemeIcon?u={id:P.id,color:P.color}:i.URI.isUri(P)?(d=P,t=P):{light:d,dark:t}=P);let s;return I.MarkdownString.isMarkdownString(p.tooltip)?s=R.MarkdownString.from(p.tooltip):(0,k.isString)(p.tooltip)?s=p.tooltip:I.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=R.MarkdownString.from(p.detail)):(0,k.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),s=p.detail),{...p,id:p.id??void 0,handle:n,source:b,command:E.command?f.toInternal(E.command,r):void 0,icon:d,iconDark:t,themeIcon:u,tooltip:s,accessibilityInformation:E.accessibilityInformation}}}}f(b,f){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:f}),(0,L.toDisposable)(()=>{for(const o of this.c.values())o.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=O;function w(m){return m?.toString()}}),define(Ie[231],Ce([1,0,6,16,2,5]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(y){this.c=new Map,this.b=y.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,O,w){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const m=w.schemes.find(b=>!I.a.has(b));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(k,O),this.b.$registerUriOpener(k,w.schemes,y,w.label),(0,i.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(y,k,O){const w=this.c.get(y);if(!w)throw new Error(`Unknown opener with id: ${y}`);const m=S.URI.revive(k);return w.canOpenExternalUri(m,O)}async $openUri(y,k,O){const w=this.c.get(y);if(!w)throw new Error(`Unknown opener id: '${y}'`);return w.openExternalUri(S.URI.revive(k.resolvedUri),{sourceUri:S.URI.revive(k.sourceUri)},O)}}e.ExtHostUriOpeners=I,I.a=new Set([C.Schemas.http,C.Schemas.https])}),define(Ie[232],Ce([1,0,5,2,6,11,26]),function(ee,e,i,C,S,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(k,O){if(this.c.has(I.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const w=R.a++;return this.c.add(I.ExtensionIdentifier.toKey(k)),this.d.set(w,O),this.b.$registerUriHandler(w,k),(0,S.toDisposable)(()=>{this.c.delete(I.ExtensionIdentifier.toKey(k)),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(k,O){const w=this.d.get(k);if(!w)return Promise.resolve(void 0);try{w.handleUri(C.URI.revive(O))}catch(m){(0,L.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(k){return C.URI.revive(await this.b.$createAppUri(k))}}e.ExtHostUrls=R,R.a=0});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[61],Ce([1,0,4,16,22,2,154,175,72,5]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";var O,w,m,b,f,r,o,l,v,E,P,p,n;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(F,j,te,x,N,$,T){O.set(this,void 0),w.set(this,void 0),m.set(this,void 0),b.set(this,void 0),f.set(this,void 0),r.set(this,void 0),o.set(this,""),l.set(this,void 0),v.set(this,!1),E.set(this,!1),P.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,n.set(this,new i.Emitter),this._onDidDispose=Oe(this,n,"f").event,Je(this,O,F,"f"),Je(this,w,j,"f"),Je(this,l,te,"f"),Je(this,b,x,"f"),Je(this,f,N,"f"),Je(this,r,$,"f"),Je(this,P,t($),"f"),Je(this,p,u($),"f"),Je(this,m,T,"f")}dispose(){Je(this,v,!0,"f"),Oe(this,n,"f").fire(),Oe(this,n,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(F){return Je(this,E,!0,"f"),(0,y.asWebviewUri)(F,Oe(this,b,"f"))}get cspSource(){const F=Oe(this,r,"f").extensionLocation;if(F.scheme===C.Schemas.https||F.scheme===C.Schemas.http){let j=F.toString();return j.endsWith("/")||(j+="/"),j+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Oe(this,o,"f")}set html(F){this.a(),Oe(this,o,"f")!==F&&(Je(this,o,F,"f"),Oe(this,p,"f")&&!Oe(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(F)&&(Je(this,E,!0,"f"),Oe(this,m,"f").report("Webview vscode-resource: uris",Oe(this,r,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,w,"f").$setHtml(Oe(this,O,"f"),this.b(F)))}get options(){return this.a(),Oe(this,l,"f")}set options(F){this.a(),S.equals(Oe(this,l,"f"),F)||Oe(this,w,"f").$setOptions(Oe(this,O,"f"),a(Oe(this,r,"f"),Oe(this,f,"f"),F)),Je(this,l,F,"f")}async postMessage(F){if(Oe(this,v,"f"))return!1;const j=(0,R.serializeWebviewMessage)(F,{serializeBuffersForPostMessage:Oe(this,P,"f")});return Oe(this,w,"f").$postMessage(Oe(this,O,"f"),j.message,...j.buffers)}a(){if(Oe(this,v,"f"))throw new Error("Webview is disposed")}b(F){if(!Oe(this,p,"f"))return F;const j=Oe(this,r,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,te=Oe(this,r,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Oe(this,r,"f").extensionLocation.authority:void 0;return F.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,N,$,T,M,V)=>{const q=L.URI.from({scheme:T||"file",path:decodeURIComponent(M)}),le=(0,y.asWebviewUri)(q,{isRemote:j,authority:te}).toString();return`${N}${le}${V}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,N,$,T,M,V)=>{const q=L.URI.from({scheme:T||"file",path:decodeURIComponent(M)}),le=(0,y.asWebviewUri)(q,{isRemote:j,authority:te}).toString();return`${N}${le}${V}`})}}e.ExtHostWebview=d,O=new WeakMap,w=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,r=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap,E=new WeakMap,P=new WeakMap,p=new WeakMap,n=new WeakMap;function t(A){try{const F=(0,I.normalizeVersion)((0,I.parseVersion)(A.engines.vscode));return!!F&&F.majorBase>=1&&F.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=t;function u(A){try{const F=(0,I.normalizeVersion)((0,I.parseVersion)(A.engines.vscode));return F?F.majorBase<1||F.majorBase===1&&F.minorBase<60:!1}catch{return!1}}class s{constructor(F,j,te,x,N){this.c=j,this.d=te,this.e=x,this.f=N,this.b=new Map,this.a=F.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(F,j,te){const x=this.g(F);if(x){const{message:N}=(0,R.deserializeWebviewMessage)(j,te.value);x._onMessageEmitter.fire(N)}}$onMissingCsp(F,j){this.e.warn(`${j} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(F,j,te){const x=new d(F,this.a,c(j),this.c,this.d,te,this.f);return this.b.set(F,x),x._onDidDispose(()=>{this.b.delete(F)}),x}deleteWebview(F){this.b.delete(F)}g(F){return this.b.get(F)}}e.ExtHostWebviews=s;function h(A){return{id:A.identifier,location:A.extensionLocation}}e.toExtensionData=h;function a(A,F,j){return{enableCommandUris:j.enableCommandUris,enableScripts:j.enableScripts,enableForms:j.enableForms,portMapping:j.portMapping,localResourceRoots:j.localResourceRoots||g(A,F)}}e.serializeWebviewOptions=a;function c(A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,enableForms:A.enableForms,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots?.map(F=>L.URI.from(F))}}function g(A,F){return[...(F?.getWorkspaceFolders()||[]).map(j=>j.uri),A.extensionLocation]}}),define(Ie[233],Ce([1,0,21,228,6,16,23,2,8,61,53,5,7]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(d,t){this.document=d,this.b=t,this.a=1,this.c=new O.Cache("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,t){await this.f(d).undo(),t||this.disposeBackup()}async redo(d,t){await this.f(d).redo(),t||this.disposeBackup()}disposeEdits(d){for(const t of d)this.c.delete(t)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=p(this.document.uri)+this.a++;return(0,I.joinPath)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const t=this.c.get(d,0);if(!t)throw new Error("No edit found");return t}}class f{constructor(){this.a=new Map}get(d,t){return this.a.get(this.b(d,t))}add(d,t,u){const s=this.b(d,t.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${d} resource:${t.uri}`);const h=new b(t,u);return this.a.set(s,h),h}delete(d,t){const u=this.b(d,t.uri);this.a.delete(u)}b(d,t){return`${d}@@@${t}`}}var r;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(d,t,u){return this.b(0,d,t,u)}addCustomProvider(d,t,u){return this.b(1,d,t,u)}get(d){return this.a.get(d)}b(d,t,u,s){if(this.a.has(t))throw new Error(`Provider for viewType:${t} already registered`);return this.a.set(t,{type:d,extension:u,provider:s}),new m.Disposable(()=>this.a.delete(t))}}class l{constructor(d,t,u,s,h){this.d=t,this.f=u,this.g=s,this.h=h,this.b=new o,this.c=new f,this.a=d.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,t,u,s){const h=new S.DisposableStore;return E(u)?(h.add(this.b.addTextProvider(t,d,u)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(d),t,s.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(d))):(h.add(this.b.addCustomProvider(t,d,u)),v(u)&&h.add(u.onDidChangeCustomDocument(a=>{const c=this.i(t,a.document.uri);if(P(a)){const g=c.addEdit(a);this.a.$onDidEdit(a.document.uri,t,g,a.label)}else this.a.$onContentChange(a.document.uri,t)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(d),t,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(d))),m.Disposable.from(h,new m.Disposable(()=>{this.a.$unregisterEditorProvider(t)}))}async $createCustomDocument(d,t,u,s,h){const a=this.b.get(t);if(!a)throw new Error(`No provider found for '${t}'`);if(a.type!==1)throw new Error(`Invalid provide type for '${t}'`);const c=R.URI.revive(d),g=await a.provider.openCustomDocument(c,{backupId:u,untitledDocumentData:s?.buffer},h);let A;return v(a.provider)&&this.f&&(A=this.f.workspaceValue(a.extension)??this.f.globalValue(a.extension)),this.c.add(t,g,A),{editable:v(a.provider)}}async $disposeCustomDocument(d,t){const u=this.b.get(t);if(!u)throw new Error(`No provider found for '${t}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${t}'`);const s=R.URI.revive(d),{document:h}=this.i(t,s);this.c.delete(t,h),h.dispose()}async $resolveCustomEditor(d,t,u,s,h,a){console.log("xxxx");const c=this.b.get(u);if(!c)throw new Error(`No provider found for '${u}'`);const g=y.ViewColumn.to(h),A=this.g.createNewWebview(t,s.contentOptions,c.extension),F=this.h.createNewWebviewPanel(t,u,s.title,g,s.options,A,!0),j=R.URI.revive(d);switch(c.type){case 1:{const{document:te}=this.i(u,j);return c.provider.resolveCustomEditor(te,F,a)}case 0:{const te=this.d.getDocument(j);return c.provider.resolveCustomTextEditor(te,F,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,t,u){this.i(t,d).disposeEdits(u)}async $onMoveCustomEditor(d,t,u){const s=this.b.get(u);if(!s)throw new Error(`No provider found for '${u}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const h=this.h.getWebviewPanel(d);if(!h)throw new Error("No webview found");const a=R.URI.revive(t),c=this.d.getDocument(a);await s.provider.moveCustomTextEditor(c,h,i.CancellationToken.None)}async $undo(d,t,u,s){return this.i(t,d).undo(u,s)}async $redo(d,t,u,s){return this.i(t,d).redo(u,s)}async $revert(d,t,u){const s=this.i(t,d);await this.j(t).revertCustomDocument(s.document,u),s.disposeBackup()}async $onSave(d,t,u){const s=this.i(t,d);await this.j(t).saveCustomDocument(s.document,u),s.disposeBackup()}async $onSaveAs(d,t,u,s){const h=this.i(t,d);return this.j(t).saveCustomDocumentAs(h.document,R.URI.revive(u),s)}async $backup(d,t,u){const s=this.i(t,d),a=await this.j(t).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},u);return s.updateBackup(a),a.id}i(d,t){const u=this.c.get(d,R.URI.revive(t));if(!u)throw new Error("No custom document found");return u}j(d){const u=this.b.get(d)?.provider;if(!u||!v(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=l;function v(n){return!!n.onDidChangeCustomDocument}function E(n){return typeof n.resolveCustomTextEditor=="function"}function P(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function p(n){const d=n.scheme===L.Schemas.file||n.scheme===L.Schemas.untitled?n.fsPath:n.toString();return(0,C.hash)(d)+""}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[234],Ce([1,0,4,6,2,34,8,61,5,7]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";var O,w,m,b,f,r,o,l,v,E,P,p,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends C.Disposable{constructor(h,a,c,g){super(),O.set(this,void 0),w.set(this,void 0),m.set(this,void 0),b.set(this,void 0),f.set(this,void 0),r.set(this,void 0),o.set(this,void 0),l.set(this,void 0),v.set(this,!0),E.set(this,void 0),P.set(this,!1),p.set(this,this.B(new i.Emitter)),this.onDidDispose=Oe(this,p,"f").event,n.set(this,this.B(new i.Emitter)),this.onDidChangeViewState=Oe(this,n,"f").event,Je(this,O,h,"f"),Je(this,w,a,"f"),Je(this,b,c,"f"),Je(this,m,g.viewType,"f"),Je(this,f,g.panelOptions,"f"),Je(this,l,g.viewColumn,"f"),Je(this,r,g.title,"f"),Je(this,E,g.active,"f")}dispose(){Oe(this,P,"f")||(Je(this,P,!0,"f"),Oe(this,p,"f").fire(),Oe(this,w,"f").$disposeWebview(Oe(this,O,"f")),Oe(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Oe(this,b,"f")}get viewType(){return this.c(),Oe(this,m,"f")}get title(){return this.c(),Oe(this,r,"f")}set title(h){this.c(),Oe(this,r,"f")!==h&&(Je(this,r,h,"f"),Oe(this,w,"f").$setTitle(Oe(this,O,"f"),h))}get iconPath(){return this.c(),Oe(this,o,"f")}set iconPath(h){this.c(),Oe(this,o,"f")!==h&&(Je(this,o,h,"f"),Oe(this,w,"f").$setIconPath(Oe(this,O,"f"),S.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.c(),!(typeof Oe(this,l,"f")=="number"&&Oe(this,l,"f")<0))return Oe(this,l,"f")}get active(){return this.c(),Oe(this,E,"f")}get visible(){return this.c(),Oe(this,v,"f")}_updateViewState(h){Oe(this,P,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(Je(this,E,h.active,"f"),Je(this,v,h.visible,"f"),Je(this,l,h.viewColumn,"f"),Oe(this,n,"f").fire({webviewPanel:this}))}reveal(h,a){this.c(),Oe(this,w,"f").$reveal(Oe(this,O,"f"),{viewColumn:typeof h>"u"?void 0:I.ViewColumn.from(h),preserveFocus:!!a})}c(){if(Oe(this,P,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,w=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,r=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap,E=new WeakMap,P=new WeakMap,p=new WeakMap,n=new WeakMap;class t{static c(){return(0,L.generateUuid)()}constructor(h,a,c){this.g=a,this.h=c,this.e=new Map,this.f=new Map,this.d=h.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(h,a,c,g,A={}){const F=typeof g=="object"?g.viewColumn:g,j={viewColumn:I.ViewColumn.from(F),preserveFocus:typeof g=="object"&&!!g.preserveFocus},te=(0,R.shouldSerializeBuffersForPostMessage)(h),x=t.c();this.d.$createWebviewPanel((0,R.toExtensionData)(h),x,a,{title:c,panelOptions:u(A),webviewOptions:(0,R.serializeWebviewOptions)(h,this.h,A),serializeBuffersForPostMessage:te},j);const N=this.g.createNewWebview(x,A,h);return this.createNewWebviewPanel(x,a,c,F,A,N,!0)}$onDidChangeWebviewPanelViewStates(h){const a=Object.keys(h);a.sort((c,g)=>{const A=h[c],F=h[g];return A.active?1:F.active?-1:+A.visible-+F.visible});for(const c of a){const g=this.getWebviewPanel(c);if(!g)continue;const A=h[c];g._updateViewState({active:A.active,visible:A.visible,viewColumn:I.ViewColumn.to(A.position)})}}async $onDidDisposeWebviewPanel(h){this.getWebviewPanel(h)?.dispose(),this.e.delete(h),this.g.deleteWebview(h)}registerWebviewPanelSerializer(h,a,c){if(this.f.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.f.set(a,{serializer:c,extension:h}),this.d.$registerSerializer(a,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(h)}),new k.Disposable(()=>{this.f.delete(a),this.d.$unregisterSerializer(a)})}async $deserializeWebviewPanel(h,a,c,g){const A=this.f.get(a);if(!A)throw new Error(`No serializer found for '${a}'`);const{serializer:F,extension:j}=A,te=this.g.createNewWebview(h,c.webviewOptions,j),x=this.createNewWebviewPanel(h,a,c.title,g,c.panelOptions,te,c.active);await F.deserializeWebviewPanel(x,c.state)}createNewWebviewPanel(h,a,c,g,A,F,j){const te=new d(h,this.d,F,{viewType:a,title:c,viewColumn:g,panelOptions:A,active:j});return this.e.set(h,te),te}getWebviewPanel(h){return this.e.get(h)}}e.ExtHostWebviewPanels=t;function u(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[235],Ce([1,0,4,6,61,8,5,7]),function(ee,e,i,C,S,L,I,R){"use strict";var y,k,O,w,m,b,f,r,o,l,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends C.Disposable{constructor(n,d,t,u,s,h){super(),y.set(this,void 0),k.set(this,void 0),O.set(this,void 0),w.set(this,void 0),m.set(this,!1),b.set(this,void 0),f.set(this,void 0),r.set(this,void 0),o.set(this,void 0),l.set(this,this.B(new i.Emitter)),this.onDidChangeVisibility=Oe(this,l,"f").event,v.set(this,this.B(new i.Emitter)),this.onDidDispose=Oe(this,v,"f").event,Je(this,O,t,"f"),Je(this,f,u,"f"),Je(this,y,n,"f"),Je(this,k,d,"f"),Je(this,w,s,"f"),Je(this,b,h,"f")}dispose(){Oe(this,m,"f")||(Je(this,m,!0,"f"),Oe(this,v,"f").fire(),Oe(this,w,"f").dispose(),super.dispose())}get title(){return this.a(),Oe(this,f,"f")}set title(n){this.a(),Oe(this,f,"f")!==n&&(Je(this,f,n,"f"),Oe(this,k,"f").$setWebviewViewTitle(Oe(this,y,"f"),n))}get description(){return this.a(),Oe(this,r,"f")}set description(n){this.a(),Oe(this,r,"f")!==n&&(Je(this,r,n,"f"),Oe(this,k,"f").$setWebviewViewDescription(Oe(this,y,"f"),n))}get visible(){return Oe(this,b,"f")}get webview(){return Oe(this,w,"f")}get viewType(){return Oe(this,O,"f")}_setVisible(n){n===Oe(this,b,"f")||Oe(this,m,"f")||(Je(this,b,n,"f"),Oe(this,l,"f").fire())}get badge(){return this.a(),Oe(this,o,"f")}set badge(n){this.a(),!(n?.value===Oe(this,o,"f")?.value&&n?.tooltip===Oe(this,o,"f")?.tooltip)&&(Je(this,o,L.ViewBadge.from(n),"f"),Oe(this,k,"f").$setWebviewViewBadge(Oe(this,y,"f"),n))}show(n){this.a(),Oe(this,k,"f").$show(Oe(this,y,"f"),!!n)}a(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,k=new WeakMap,O=new WeakMap,w=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,r=new WeakMap,o=new WeakMap,l=new WeakMap,v=new WeakMap;class P{constructor(n,d){this.d=d,this.b=new Map,this.c=new Map,this.a=n.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,d,t,u){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:t,extension:n}),this.a.$registerWebviewViewProvider((0,S.toExtensionData)(n),d,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(n)}),new R.Disposable(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(n,d,t,u,s){const h=this.b.get(d);if(!h)throw new Error(`No view provider found for '${d}'`);const{provider:a,extension:c}=h,g=this.d.createNewWebview(n,{},c),A=new E(n,this.a,d,t,g,!0);this.c.set(n,A),await a.resolveWebviewView(A,{state:u},s)}async $onDidChangeWebviewViewVisibility(n,d){this.e(n)._setVisible(d)}async $disposeWebviewView(n){const d=this.e(n);this.c.delete(n),d.dispose(),this.d.deleteWebview(n)}e(n){const d=this.c.get(n);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=P}),define(Ie[103],Ce([1,0,4,5,2,16,10,3,17]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class sn{get state(){return this.d}constructor(w){this.c=new i.Emitter,this.onDidChangeWindowState=this.c.event,this.d=sn.a,this.b=w.getProxy(C.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(w){w!==this.d.focused&&(this.d={...this.d,focused:w},this.c.fire(this.d))}openUri(w,m){let b;if(typeof w=="string"){b=w;try{w=S.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,I.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,b,m)}async asExternalUri(w,m){if((0,I.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(w,m);return S.URI.from(b)}};k.a={focused:!0},k=qe([Ve(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(Ie[236],Ce([1,0,206,27,17]),function(ee,e,i,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends i.AbstractExtHostConsoleForwarder{constructor(R,y){super(R,y)}f(R,y,k){y.apply(console,k)}};L=qe([Ve(0,S.IExtHostRpcService),Ve(1,C.IExtHostInitDataService)],L),e.ExtHostConsoleForwarder=L}),define(Ie[237],Ce([1,0,12,25,21,11,4,6,125,200,44]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(A,F){try{return JSON.stringify(A,F)}catch{return"null"}}const b="$$ref$$",f={[b]:-1};class r{constructor(F,j){this.jsonString=F,this.referencedBuffers=j}}function o(A,F=null,j=!1){const te=[];return{jsonString:(j?m:JSON.stringify)(A,(N,$)=>{if(typeof $>"u")return f;if(typeof $=="object"){if($ instanceof C.VSBuffer){const T=te.push($)-1;return{[b]:T}}if(F)return F(N,$)}return $}),referencedBuffers:te}}e.stringifyJsonWithBufferRefs=o;function l(A,F,j){return JSON.parse(A,(te,x)=>{if(x){const N=x[b];if(typeof N=="number")return F[N];if(j&&x.$mid===1)return j.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=l;function v(A,F){return JSON.stringify(A,F)}function E(A){return A?(F,j)=>j&&j.$mid===1?A.transformOutgoing(j):j:null}var P;(function(A){A[A.LocalSide=0]="LocalSide",A[A.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(A){A[A.Responsive=0]="Responsive",A[A.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},d=Symbol.for("rpcProtocol"),t=Symbol.for("rpcProxy");class u extends R.Disposable{constructor(F,j=null,te=null){super(),this[w]=!0,this.b=this.B(new I.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=F,this.f=j,this.g=te,this.h=E(this.g),this.j=!1,this.k=[],this.l=[];for(let x=0,N=O.ProxyIdentifier.count;x<N;x++)this.k[x]=null,this.l[x]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new i.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(x=>this.G(x))}dispose(){this.j=!0,Object.keys(this.s).forEach(F=>{this.s[F].resolveErr(L.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(F){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(F){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(F){this.t!==F&&(this.t=F,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(F){return this.g?(0,y.transformIncomingURIs)(F,this.g):F}getProxy(F){const{nid:j,sid:te}=F;return this.l[j]||(this.l[j]=this.F(j,te)),this.l[j]}F(F,j){const te={get:(x,N)=>(typeof N=="string"&&!x[N]&&N.charCodeAt(0)===36&&(x[N]=(...$)=>this.O(F,N,$)),N===t?j:x[N])};return new Proxy(Object.create(null),te)}set(F,j){return this.k[F.nid]=j,j}assertRegistered(F){for(let j=0,te=F.length;j<te;j++){const x=F[j];if(!this.k[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}G(F){if(this.j)return;const j=F.byteLength,te=s.read(F,0),x=te.readUInt8(),N=te.readUInt32();switch(x){case 1:case 2:{let{rpcId:$,method:T,args:M}=a.deserializeRequestJSONArgs(te);this.g&&(M=(0,y.transformIncomingURIs)(M,this.g)),this.H(j,N,$,T,M,x===2);break}case 3:case 4:{let{rpcId:$,method:T,args:M}=a.deserializeRequestMixedArgs(te);this.g&&(M=(0,y.transformIncomingURIs)(M,this.g)),this.H(j,N,$,T,M,x===4);break}case 5:{this.f?.logIncoming(j,N,0,"ack"),this.z(N);break}case 6:{this.I(j,N);break}case 7:{this.J(j,N,void 0);break}case 9:{let $=a.deserializeReplyOKJSON(te);this.g&&($=(0,y.transformIncomingURIs)($,this.g)),this.J(j,N,$);break}case 10:{const $=a.deserializeReplyOKJSONWithBuffers(te,this.g);this.J(j,N,$);break}case 8:{const $=a.deserializeReplyOKVSBuffer(te);this.J(j,N,$);break}case 11:{let $=a.deserializeReplyErrError(te);this.g&&($=(0,y.transformIncomingURIs)($,this.g)),this.L(j,N,$);break}case 12:{this.L(j,N,void 0);break}default:console.error("received unexpected message"),console.error(F)}}H(F,j,te,x,N,$){this.f?.logIncoming(F,j,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(te)}.${x}(`,N);const T=String(j);let M,V;if($){const le=new S.CancellationTokenSource;N.push(le.token),M=this.M(te,x,N),V=()=>le.cancel()}else M=this.M(te,x,N),V=n;this.p[T]=V;const q=a.serializeAcknowledged(j);this.f?.logOutgoing(q.byteLength,j,1,"ack"),this.c.send(q),M.then(le=>{delete this.p[T];const _=a.serializeReplyOK(j,le,this.h);this.f?.logOutgoing(_.byteLength,j,1,"reply:",le),this.c.send(_)},le=>{delete this.p[T];const _=a.serializeReplyErr(j,le);this.f?.logOutgoing(_.byteLength,j,1,"replyErr:",le),this.c.send(_)})}I(F,j){this.f?.logIncoming(F,j,1,"receiveCancel");const te=String(j);this.p[te]?.()}J(F,j,te){this.f?.logIncoming(F,j,0,"receiveReply:",te);const x=String(j);if(!this.s.hasOwnProperty(x))return;const N=this.s[x];delete this.s[x],N.resolveOk(te)}L(F,j,te){this.f?.logIncoming(F,j,0,"receiveReplyErr:",te);const x=String(j);if(!this.s.hasOwnProperty(x))return;const N=this.s[x];delete this.s[x];let $;te&&(te.$isError?($=new Error,$.name=te.name,$.message=te.message,$.stack=te.stack):$=te),N.resolveErr($)}M(F,j,te){try{return Promise.resolve(this.N(F,j,te))}catch(x){return Promise.reject(x)}}N(F,j,te){const x=this.k[F];if(!x)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(F));const N=x[j];if(typeof N!="function")throw new Error("Unknown method "+j+" on actor "+(0,O.getStringIdentifierForProxy)(F));return N.apply(x,te)}O(F,j,te){if(this.j)return new k.CanceledLazyPromise;let x=null;if(te.length>0&&S.CancellationToken.isCancellationToken(te[te.length-1])&&(x=te.pop()),x&&x.isCancellationRequested)return Promise.reject(L.canceled());const N=a.serializeRequestArguments(te,this.h),$=++this.m,T=String($),M=new k.LazyPromise;x&&x.onCancellationRequested(()=>{const q=a.serializeCancel($);this.f?.logOutgoing(q.byteLength,$,0,"cancel"),this.c.send(a.serializeCancel($))}),this.s[T]=M,this.y($);const V=a.serializeRequest($,F,j,N,!!x);return this.f?.logOutgoing(V.byteLength,$,0,`request: ${(0,O.getStringIdentifierForProxy)(F)}.${j}(`,te),this.c.send(V),M}}e.RPCProtocol=u,w=d,u.a=3*1e3;class s{static alloc(F,j,te){const x=new s(C.VSBuffer.alloc(te+1+4),0);return x.writeUInt8(F),x.writeUInt32(j),x}static read(F,j){return new s(F,j)}get buffer(){return this.a}constructor(F,j){this.a=F,this.b=j}static sizeUInt8(){return 1}writeUInt8(F){this.a.writeUInt8(F,this.b),this.b+=1}readUInt8(){const F=this.a.readUInt8(this.b);return this.b+=1,F}writeUInt32(F){this.a.writeUInt32BE(F,this.b),this.b+=4}readUInt32(){const F=this.a.readUInt32BE(this.b);return this.b+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this.a.writeUInt8(F.byteLength,this.b),this.b+=1,this.a.set(F,this.b),this.b+=F.byteLength}readShortString(){const F=this.a.readUInt8(this.b);this.b+=1;const te=this.a.slice(this.b,this.b+F).toString();return this.b+=F,te}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readLongString(){const F=this.a.readUInt32BE(this.b);this.b+=4;const te=this.a.slice(this.b,this.b+F).toString();return this.b+=F,te}writeBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readVSBuffer(){const F=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+F);return this.b+=F,j}static sizeMixedArray(F){let j=0;j+=1;for(let te=0,x=F.length;te<x;te++){const N=F[te];switch(j+=1,N.type){case 1:j+=this.sizeLongString(N.value);break;case 2:j+=this.sizeVSBuffer(N.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(N.value);for(let $=0;$<N.buffers.length;++$)j+=this.sizeVSBuffer(N.buffers[$]);break;case 4:break}}return j}writeMixedArray(F){this.a.writeUInt8(F.length,this.b),this.b+=1;for(let j=0,te=F.length;j<te;j++){const x=F[j];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let N=0;N<x.buffers.length;++N)this.writeBuffer(x.buffers[N]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const F=this.a.readUInt8(this.b);this.b+=1;const j=new Array(F);for(let te=0;te<F;te++)switch(this.readUInt8()){case 1:j[te]=this.readLongString();break;case 2:j[te]=this.readVSBuffer();break;case 3:{const N=this.readUInt32(),$=this.readLongString(),T=[];for(let M=0;M<N;++M)T.push(this.readVSBuffer());j[te]=new O.SerializableObjectWithBuffers(l($,T,null));break}case 4:j[te]=void 0;break}return j}}s.sizeUInt32=4;var h;(function(A){A[A.Simple=0]="Simple",A[A.Mixed=1]="Mixed"})(h||(h={}));class a{static a(F){for(let j=0,te=F.length;j<te;j++)if(F[j]instanceof C.VSBuffer||F[j]instanceof O.SerializableObjectWithBuffers||typeof F[j]>"u")return!0;return!1}static serializeRequestArguments(F,j){if(this.a(F)){const te=[];for(let x=0,N=F.length;x<N;x++){const $=F[x];if($ instanceof C.VSBuffer)te[x]={type:2,value:$};else if(typeof $>"u")te[x]={type:4};else if($ instanceof O.SerializableObjectWithBuffers){const{jsonString:T,referencedBuffers:M}=o($.value,j);te[x]={type:3,value:C.VSBuffer.fromString(T),buffers:M}}else te[x]={type:1,value:C.VSBuffer.fromString(v($,j))}}return{type:1,args:te}}return{type:0,args:v(F,j)}}static serializeRequest(F,j,te,x,N){switch(x.type){case 0:return this.b(F,j,te,x.args,N);case 1:return this.c(F,j,te,x.args,N)}}static b(F,j,te,x,N){const $=C.VSBuffer.fromString(te),T=C.VSBuffer.fromString(x);let M=0;M+=s.sizeUInt8(),M+=s.sizeShortString($),M+=s.sizeLongString(T);const V=s.alloc(N?2:1,F,M);return V.writeUInt8(j),V.writeShortString($),V.writeLongString(T),V.buffer}static deserializeRequestJSONArgs(F){const j=F.readUInt8(),te=F.readShortString(),x=F.readLongString();return{rpcId:j,method:te,args:JSON.parse(x)}}static c(F,j,te,x,N){const $=C.VSBuffer.fromString(te);let T=0;T+=s.sizeUInt8(),T+=s.sizeShortString($),T+=s.sizeMixedArray(x);const M=s.alloc(N?4:3,F,T);return M.writeUInt8(j),M.writeShortString($),M.writeMixedArray(x),M.buffer}static deserializeRequestMixedArgs(F){const j=F.readUInt8(),te=F.readShortString(),x=F.readMixedArray(),N=new Array(x.length);for(let $=0,T=x.length;$<T;$++){const M=x[$];typeof M=="string"?N[$]=JSON.parse(M):N[$]=M}return{rpcId:j,method:te,args:N}}static serializeAcknowledged(F){return s.alloc(5,F,0).buffer}static serializeCancel(F){return s.alloc(6,F,0).buffer}static serializeReplyOK(F,j,te){if(typeof j>"u")return this.d(F);if(j instanceof C.VSBuffer)return this.e(F,j);if(j instanceof O.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:N}=o(j.value,te,!0);return this.g(F,x,N)}else return this.f(F,m(j,te))}static d(F){return s.alloc(7,F,0).buffer}static e(F,j){let te=0;te+=s.sizeVSBuffer(j);const x=s.alloc(8,F,te);return x.writeVSBuffer(j),x.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static f(F,j){const te=C.VSBuffer.fromString(j);let x=0;x+=s.sizeLongString(te);const N=s.alloc(9,F,x);return N.writeLongString(te),N.buffer}static g(F,j,te){const x=C.VSBuffer.fromString(j);let N=0;N+=s.sizeUInt32,N+=s.sizeLongString(x);for(const T of te)N+=s.sizeVSBuffer(T);const $=s.alloc(10,F,N);$.writeUInt32(te.length),$.writeLongString(x);for(const T of te)$.writeBuffer(T);return $.buffer}static deserializeReplyOKJSON(F){const j=F.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(F,j){const te=F.readUInt32(),x=F.readLongString(),N=[];for(let $=0;$<te;++$)N.push(F.readVSBuffer());return new O.SerializableObjectWithBuffers(l(x,N,j))}static serializeReplyErr(F,j){const te=j?m(L.transformErrorForSerialization(j),null):void 0;if(typeof te!="string")return this.h(F);const x=C.VSBuffer.fromString(te);let N=0;N+=s.sizeLongString(x);const $=s.alloc(11,F,N);return $.writeLongString(x),$.buffer}static deserializeReplyErrError(F){const j=F.readLongString();return JSON.parse(j)}static h(F){return s.alloc(12,F,0).buffer}}var c;(function(A){A[A.RequestJSONArgs=1]="RequestJSONArgs",A[A.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",A[A.RequestMixedArgs=3]="RequestMixedArgs",A[A.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",A[A.Acknowledged=5]="Acknowledged",A[A.Cancel=6]="Cancel",A[A.ReplyOKEmpty=7]="ReplyOKEmpty",A[A.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",A[A.ReplyOKJSON=9]="ReplyOKJSON",A[A.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",A[A.ReplyErrError=11]="ReplyErrError",A[A.ReplyErrEmpty=12]="ReplyErrEmpty"})(c||(c={}));var g;(function(A){A[A.String=1]="String",A[A.VSBuffer=2]="VSBuffer",A[A.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",A[A.Undefined=4]="Undefined"})(g||(g={}))}),define(Ie[238],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(L){const I=R=>{self.removeEventListener("message",I);const y=R.data;Object.defineProperties(self,{postMessage:{value(k,O){y.postMessage(k,O)}},onmessage:{get(){return y.onmessage},set(k){y.onmessage=k}}}),y.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};self.addEventListener("message",I)}.toString();class C extends EventTarget{constructor(L,I,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${i})('${I}'))`,k=new Blob([y],{type:"application/javascript"}),O=URL.createObjectURL(k),w=new MessageChannel,m=O,b={type:"_newWorker",id:m,port:w.port2,url:O,options:R};L(b,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{L({type:"_terminateWorker",id:m}),URL.revokeObjectURL(O),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(f){w.port1.onmessage=f}},onmessageerror:{get(){return w.port1.onmessageerror},set(f){w.port1.onmessageerror=f}}}),w.port1.addEventListener("messageerror",f=>{const r=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(r)}),w.port1.addEventListener("message",f=>{const r=new MessageEvent("message",{data:f.data});this.dispatchEvent(r)}),w.port1.start()}}e.NestedWorker=C}),define(Ie[239],Ce([1,0,4,29,42,3,36,11,12]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new S.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new S.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new S.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new i.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new i.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(r=>f.push(r)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}C.Registry.add(e.Extensions.OutputChannels,new O);function w(b,f,r,o,l){return(0,y.createCancelablePromise)(async v=>{await(0,I.whenProviderRegistered)(r,o);const E=C.Registry.as(e.Extensions.OutputChannels);try{await m(r,1,o,l,v),E.registerChannel({id:b,label:f,file:r,log:!0})}catch(P){(0,R.isCancellationError)(P)||l.error("Error while registering log channel",r.toString(),(0,R.getErrorMessage)(P))}})}e.registerLogChannel=w;async function m(b,f,r,o,l){if(!await r.exists(b)){if(l.isCancellationRequested)throw new R.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");o.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",b.toString()),await(0,y.timeout)(1e3,l),await m(b,f+1,r,o,l)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new S.RawContextKey("activeOutputChannel","")}),define(Ie[104],Ce([1,0,5,3,17,26,13,239,59,27,37,119,25,9,36,4,6]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends I.AbstractMessageLogger{get disposed(){return this.l}constructor(p,n,d,t,u){super(),this.id=p,this.name=n,this.m=d,this.n=t,this.extension=u,this.k=0,this.l=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Clear,p)}replace(p){const n=this.k;this.info(p),this.n.$update(this.id,R.OutputChannelUpdateMode.Replace,n),this.visible&&this.m.flush()}show(p,n){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:n))}hide(){this.n.$close(this.id)}g(p,n){this.k+=m.VSBuffer.fromString(n).byteLength,(0,I.log)(this.m,p,n),this.visible&&(this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class v extends l{appendLine(p){this.append(p)}}let E=class{constructor(p,n,d,t,u,s){this.i=n,this.j=d,this.k=t,this.l=u,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(i.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[n,d]of this.g)d.visible=n===this.h}createOutputChannel(p,n,d){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const t=typeof n=="object"&&n.log,u=(0,b.isString)(n)?n:void 0;if((0,b.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const h=this.i.environment.extensionLogLevel?.find(([c])=>L.ExtensionIdentifier.equals(d.identifier,c))?.[1];h&&(s=(0,I.parseLogLevel)(h));const a=t?this.o(p,s,d):this.n(p,u,d);return a.then(c=>{this.g.set(c.id,c),c.visible=c.id===this.h}),t?this.r(p,s??this.m.getLevel(),a):this.q(p,a)}async n(p,n,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const t=await this.c,u=this.k.extUri.joinPath(t,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),h=await this.a.$register(p,u,!1,n,d.identifier.value);return new l(h,p,s,this.a,d)}async o(p,n,d){const t=await this.p(d),u=this.k.extUri.joinPath(t,`${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(u,{name:p},n),h=await this.a.$register(p,u,!0,void 0,d.identifier.value);return new v(h,p,s,this.a,d)}p(p){let n=this.d.get(p.identifier.value);if(!n){const d=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(d)}catch(t){if((0,f.toFileSystemProviderErrorCode)(t)!==f.FileSystemProviderErrorCode.FileExists)throw t}return d})())}return n}q(p,n){let d=!1;const t=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return p},append(u){t(),n.then(s=>s.append(u))},appendLine(u){t(),n.then(s=>s.appendLine(u))},clear(){t(),n.then(u=>u.clear())},replace(u){t(),n.then(s=>s.replace(u))},show(u,s){t(),n.then(h=>h.show(u,s))},hide(){t(),n.then(u=>u.hide())},dispose(){d=!0,n.then(u=>u.dispose())}}}r(p,n,d){const t=new o.DisposableStore,u=()=>{if(t.isDisposed)throw new Error("Channel has been closed")},s=t.add(new r.Emitter);return d.then(h=>{t.add(h),t.add(h.onDidChangeLogLevel(a=>{n=a,s.fire(a)}))}),{...this.q(p,d),get logLevel(){return n},onDidChangeLogLevel:s.event,trace(h,...a){u(),d.then(c=>c.trace(h,...a))},debug(h,...a){u(),d.then(c=>c.debug(h,...a))},info(h,...a){u(),d.then(c=>c.info(h,...a))},warn(h,...a){u(),d.then(c=>c.warn(h,...a))},error(h,...a){u(),d.then(c=>c.error(h,...a))},dispose(){t.dispose()}}}};E=qe([Ve(0,S.IExtHostRpcService),Ve(1,k.IExtHostInitDataService),Ve(2,y.IExtHostConsumerFileSystem),Ve(3,O.IExtHostFileSystemInfo),Ve(4,I.ILoggerService),Ve(5,I.ILogService)],E),e.ExtHostOutputService=E,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(Ie[240],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(Ie[241],Ce([1,0,40,16,19,20,23,2,3,171,52,187,240]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let b=class on{constructor(r,o,l,v){this.d=r,this.e=o,this.f=l,this.g=v,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??r})()}hasValidBasename(r,o,l){return typeof o=="string"||typeof o>"u"?this.a.then(v=>this.h(r,v,o)):this.h(r,o,l)}h(r,o,l){return r.scheme===C.Schemas.file||r.scheme===C.Schemas.vscodeRemote?(0,i.isValidBasename)(l??(0,I.basename)(r),o===1):!0}get defaultUriScheme(){return on.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(r,o){if(r.remoteAuthority)return C.Schemas.vscodeRemote;const l=(0,k.getVirtualWorkspaceScheme)(o.getWorkspace());if(l)return l;const v=o.getWorkspace().folders[0];if(v)return v.uri.scheme;const E=o.getWorkspace().configuration;return E?E.scheme:C.Schemas.file}userHome(r){return r?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(r=>r===1?S.win32:S.posix)}async fileURI(r){let o="";if(await this.a===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const v=r.indexOf("/",2);v===-1?(o=r.substring(2),r="/"):(o=r.substring(2,v),r=r.substring(v)||"/")}return R.URI.from({scheme:C.Schemas.file,authority:o,path:r,query:"",fragment:""})}};b=qe([Ve(1,m.IRemoteAgentService),Ve(2,w.IWorkbenchEnvironmentService),Ve(3,O.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(Ie[105],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(I,R){this.line=I,this.character=R}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,R){return new i(0,0)}with(I){return new i(0,0)}}e.Position=i;class C{constructor(I,R,y,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(I,R),this.end=new i(y,k)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new C(0,0,0,0)}with(I){return new C(0,0,0,0)}}e.Range=C;var S;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[45],Ce([1,0,18,35,22,40,10,3,19,11,105,12]),function(ee,e,i,C,S,L,I,R,y,k,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",b=" characters skipped \u27EB",f=(m.length+b.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var r;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function l(ue){return!!ue.preview}e.resultIsMatch=l;function v(ue){return!!ue.resource}e.isFileMatch=v;function E(ue){return!!ue.message}e.isProgressMessage=E;var P;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(P=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=p;class n{constructor(de,re,G){this.ranges=re;const H=Array.isArray(re)?re:[re];if(G&&G.matchLines===1&&d(H)){de=(0,I.getNLines)(de,G.matchLines);let oe="",ve=0,Ae=0;const Be=Math.floor(G.charsPerLine/5),xe=[];for(const Te of H){const Se=Math.max(Te.startColumn-Be,0),ke=Te.startColumn+G.charsPerLine;if(Se>Ae+Be+f){const se=m+(Se-Ae)+b;oe+=se+de.slice(Se,ke),ve+=Se-(Ae+se.length)}else oe+=de.slice(Ae,ke);xe.push(new u(0,Te.startColumn-ve,Te.endColumn-ve)),Ae=ke}this.preview={text:oe,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const oe=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:de,matches:(0,i.mapArrayOrNot)(re,ve=>new t(ve.startLineNumber-oe,ve.startColumn,ve.endLineNumber-oe,ve.endColumn))}}}}e.TextSearchMatch=n;function d(ue){const de=ue[0].startLineNumber;for(const re of ue)if(re.startLineNumber!==de||re.endLineNumber!==de)return!1;return!0}class t{constructor(de,re,G,H){this.startLineNumber=de,this.startColumn=re,this.endLineNumber=G,this.endColumn=H}}e.SearchRange=t;class u extends t{constructor(de,re,G){super(de,re,de,G)}}e.OneLineRange=u;var s;(function(ue){ue.List="list",ue.Tree="tree"})(s=e.ViewMode||(e.ViewMode={}));var h;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(h=e.SearchSortOrder||(e.SearchSortOrder={}));function a(ue,de=!0){const re=ue&&ue.files&&ue.files.exclude,G=de&&ue&&ue.search&&ue.search.exclude;if(!re&&!G)return;if(!re||!G)return re||G;let H=Object.create(null);return H=S.mixin(H,S.deepClone(re)),H=S.mixin(H,S.deepClone(G),!0),H}e.getExcludes=a;function c(ue,de){return ue.excludePattern&&C.match(ue.excludePattern,de)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&C.match(ue.includePattern,de)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(re=>{const G=re.folder.fsPath;if(L.isEqualOrParent(de,G)){const H=y.relative(G,de);return!re.includePattern||!!C.match(re.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var g;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(de,re){super(de),this.code=re}}e.SearchError=A;function F(ue){const de=ue.message;if((0,k.isCancellationError)(ue))return new A(de,g.canceled);try{const re=JSON.parse(de);return new A(re.message,re.code)}catch{return new A(de,g.other)}}e.deserializeSearchError=F;function j(ue){const de={message:ue.message,code:ue.code};return new Error(JSON.stringify(de))}e.serializeSearchError=j;function te(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=te;function x(ue){return ue.type==="success"}e.isSerializedSearchSuccess=x;function N(ue){return!!ue.path}e.isSerializedFileMatch=N;function $(ue,de){const re=ue.searchPath?ue.searchPath:ue.relativePath;return(0,I.fuzzyContains)(re,de)}e.isFilePatternMatch=$;class T{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=T;function M(ue,de){const re={...ue||{},...de||{}};return Object.keys(re).filter(G=>{const H=re[G];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=M;class V{constructor(de,re){this.c=null,this.a={...de.excludePattern||{},...re.excludePattern||{}},this.b=C.parse(this.a);let G=de.includePattern;re.includePattern&&(G?G={...G,...re.includePattern}:G=re.includePattern),G&&(this.c=C.parse(G))}matchesExcludesSync(de,re,G){return!!(this.b&&this.b(de,re,G))}includedInQuerySync(de,re,G){return!(this.b&&this.b(de,re,G)||this.c&&!this.c(de,re,G))}includedInQuery(de,re,G){const H=this.b(de,re,G),oe=()=>this.c?!!this.c(de,re,G):!0;return(0,w.isThenable)(H)?H.then(ve=>ve?!1:oe()):oe()}hasSiblingExcludeClauses(){return q(this.a)}}e.QueryGlobTester=V;function q(ue){for(const de in ue)if(typeof ue[de]!="boolean")return!0;return!1}function le(ue){if(!ue)return;let de;return re=>(de||(de=(ue()||Promise.resolve([])).then(G=>G?pe(G):{})),de.then(G=>!!G[re]))}e.hasSiblingPromiseFn=le;function _(ue){if(!ue)return;let de;return re=>{if(!de){const G=ue();de=G?pe(G):{}}return!!de[re]}}e.hasSiblingFn=_;function pe(ue){const de={};for(const re of ue)de[re]=!0;return de}}),define(Ie[31],Ce([1,0,18,12,21,4,6,46,16,112,23,10,9,2,143,3,13,159,52,37,27,17,8,7,54,45,5]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o,l,v,E,P,p,n,d,t,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function h(x,N,$){return new O.ExtUri(T=>A(T,$)).isEqual(x,N)}function a(x,N,$){return h(x.uri,N.uri,$)?0:(0,w.compare)(x.uri.toString(),N.uri.toString())}function c(x,N,$){return x.index!==N.index?x.index<N.index?-1:1:h(x.uri,N.uri,$)?(0,w.compare)(x.name,N.name):(0,w.compare)(x.uri.toString(),N.uri.toString())}function g(x,N,$,T){const M=x.slice(0).sort((q,le)=>$(q,le,T)),V=N.slice(0).sort((q,le)=>$(q,le,T));return(0,i.delta)(M,V,(q,le)=>$(q,le,T))}function A(x,N){const $=N.getCapabilities(x.scheme);return!($&&$&1024)}class F extends v.Workspace{static toExtHostWorkspace(N,$,T,M){if(!N)return{workspace:null,added:[],removed:[]};const{id:V,name:q,folders:le,configuration:_,transient:pe,isUntitled:ue}=N,de=[],re=$;$?le.forEach((ve,Ae)=>{const Be=b.URI.revive(ve.uri),xe=F.e(T||$,Be,M);xe?(xe.name=ve.name,xe.index=ve.index,de.push(xe)):de.push({uri:Be,name:ve.name,index:Ae})}):de.push(...le.map(({uri:ve,name:Ae,index:Be})=>({uri:b.URI.revive(ve),name:Ae,index:Be}))),de.sort((ve,Ae)=>ve.index<Ae.index?-1:1);const G=new F(V,q,de,!!pe,_?b.URI.revive(_):null,!!ue,ve=>A(ve,M)),{added:H,removed:oe}=g(re?re.workspaceFolders:[],G.workspaceFolders,a,M);return{workspace:G,added:H,removed:oe}}static e(N,$,T){for(let M=0;M<N.folders.length;M++){const V=N.workspaceFolders[M];if(h(V.uri,$,T))return V}}constructor(N,$,T,M,V,q,le){super(N,T.map(_=>new v.WorkspaceFolder(_)),M,V,le),this.s=$,this.t=q,this.o=[],this.q=R.TernarySearchTree.forUris(le),T.forEach(_=>{this.o.push(_),this.q.set(_.uri,_)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(N,$){return $&&this.q.get(N)&&(N=(0,O.dirname)(N)),this.q.findSubstr(N)}resolveWorkspaceFolder(N){return this.q.get(N)}}let j=class{constructor(N,$,T,M,V){this.c=new L.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new L.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=M,this.q=T,this.s=V,this.h=new k.Counter,this.j=new C.Barrier,this.n=N.getProxy(s.MainContext.MainThreadWorkspace),this.o=N.getProxy(s.MainContext.MainThreadMessageService);const q=$.workspace;this.k=q?new F(q.id,q.name,[],!!q.transient,q.configuration?b.URI.revive(q.configuration):null,!!q.isUntitled,le=>A(le,T)):void 0}$initializeWorkspace(N,$){this.u=$,this.$acceptWorkspaceData(N),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?b.URI.from({scheme:y.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(N,$,T,...M){const V=[];if(Array.isArray(M)&&M.forEach(ue=>{b.URI.isUri(ue.uri)&&!V.some(de=>h(de.uri,ue.uri,this.q))&&V.push({uri:ue.uri,name:ue.name||(0,O.basenameOrAuthority)(ue.uri)})}),this.l||[$,T].some(ue=>typeof ue!="number"||ue<0)||T===0&&V.length===0)return!1;const q=this.w?this.w.workspaceFolders:[];if($+T>q.length)return!1;const le=q.slice(0);le.splice($,T,...V.map(ue=>({uri:ue.uri,name:ue.name||(0,O.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<le.length;ue++){const de=le[ue];if(le.some((re,G)=>G!==ue&&h(de.uri,re.uri,this.q)))return!1}le.forEach((ue,de)=>ue.index=de);const{added:_,removed:pe}=g(q,le,c,this.q);if(_.length===0&&pe.length===0)return!1;if(this.n){const ue=N.displayName||N.name;this.n.$updateWorkspaceFolders(ue,$,T,V).then(void 0,de=>{this.l=void 0;const re={source:{identifier:N.identifier,label:N.displayName||N.name}};this.o.$showMessage(l.Severity.Error,(0,f.localize)(0,null,ue,de.toString()),re,[])})}return this.x(le),!0}getWorkspaceFolder(N,$){if(!!this.w)return this.w.getWorkspaceFolder(N,$)}async getWorkspaceFolder2(N,$){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(N,$)}async resolveWorkspaceFolder(N){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(N)}getPath(){if(!this.w)return;const{folders:N}=this.w;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,$){let T,M="";if(typeof N=="string"?(T=b.URI.file(N),M=N):typeof N<"u"&&(T=N,M=N.fsPath),!T)return M;const V=this.getWorkspaceFolder(T,!0);if(!V)return M;typeof $>"u"&&this.w&&($=this.w.folders.length>1);let q=(0,O.relativePath)(V.uri,T);return $&&V.name&&(q=`${V.name}/${q}`),q}x(N){this.w&&(this.l=F.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:N,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:$,added:T,removed:M}=F.toExtHostWorkspace(N,this.k,this.l,this.q);this.k=$||void 0,this.l=void 0,this.c.fire(Object.freeze({added:T,removed:M}))}findFiles(N,$,T,M,V=S.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let q;if($===null?q=!1:$&&(typeof $=="string"?q=$:q=$.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:_}=te(n.GlobPattern.from(N));return this.n.$startFileSearch((0,m.withUndefinedAsNull)(le),(0,m.withUndefinedAsNull)(_),(0,m.withUndefinedAsNull)(q),(0,m.withUndefinedAsNull)(T),V).then(pe=>Array.isArray(pe)?pe.map(ue=>b.URI.revive(ue)):[])}async findTextInFiles(N,$,T,M,V=S.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const q=this.h.getNext(),le=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:_,folder:pe}=te(n.GlobPattern.from($.include)),ue=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,de={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:le,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:_,excludePattern:ue},re=!1;if(this.t[q]=G=>{if(re)return;const H=b.URI.revive(G.resource);G.results.forEach(oe=>{(0,u.resultIsMatch)(oe)?T({uri:H,preview:{text:oe.preview.text,matches:(0,i.mapArrayOrNot)(oe.preview.matches,ve=>new d.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,i.mapArrayOrNot)(oe.ranges,ve=>new d.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):T({uri:H,text:oe.text,lineNumber:oe.lineNumber})})},V.isCancellationRequested)return{};try{const G=await this.n.$startTextSearch(N,(0,m.withUndefinedAsNull)(pe),de,q,V);return delete this.t[q],G||{}}catch(G){throw delete this.t[q],G}}$handleTextSearchResult(N,$){this.t[$]?.(N)}saveAll(N){return this.n.$saveAll(N)}resolveProxy(N){return this.n.$resolveProxy(N)}get trusted(){return this.u}requestWorkspaceTrust(N){return this.n.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(N,$){if(this.v.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.v.set(N,$);const T=this.s.transformOutgoingScheme(N),M=this.y++;return this.n.$registerEditSessionIdentityProvider(M,T),(0,I.toDisposable)(()=>{this.v.delete(N),this.n.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(N,$){this.g.info("Getting edit session identifier for workspaceFolder",N);const T=await this.resolveWorkspaceFolder(b.URI.revive(N));if(!T){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const M=this.v.get(T.uri.scheme);if(this.g.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!M),!M)return;const V=await M.provideEditSessionIdentity(T,$);if(this.g.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(N,$,T,M){this.g.info("Getting edit session identifier for workspaceFolder",N);const V=await this.resolveWorkspaceFolder(b.URI.revive(N));if(!V){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const q=this.v.get(V.uri.scheme);if(this.g.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!q),!q)return;const le=await q.provideEditSessionIdentityMatch?.($,T,M);if(this.g.info("Provider returned edit session identifier match result: ",le),!!le)return le}};j=qe([Ve(0,p.IExtHostRpcService),Ve(1,P.IExtHostInitDataService),Ve(2,E.IExtHostFileSystemInfo),Ve(3,o.ILogService),Ve(4,t.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function te(x){let N,$;return x&&(typeof x=="string"?N=x:(N=x.pattern,$=b.URI.revive(x.baseUri))),{includePattern:N,folder:$}}}),define(Ie[32],Ce([1,0,22,4,31,5,7,162,92,9,12,3,17,13,2]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function r(d,t){if(t){const u=t.split(".");let s=d;for(let h=0;s&&h<u.length;h++)s=s[u[h]];return s}}function o(d){return d instanceof f.URI}function l(d){return d&&d.uri instanceof f.URI&&d.languageId&&typeof d.languageId=="string"}function v(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function E(d){return d&&d.uri instanceof f.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function P(d){if(o(d))return{resource:d};if(l(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(v(d))return{overrideIdentifier:d.languageId};if(E(d))return{resource:d.uri};if(d===null)return{resource:null}}let p=class{constructor(t,u,s){this.a=t.getProxy(L.MainContext.MainThreadConfiguration),this.c=u,this.b=s,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(t=>this.e)}$initializeConfiguration(t){this.e=new n(this.a,this.c,t,this.b),this.d.open()}$acceptConfigurationChanged(t,u){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(t,u))}};p=qe([Ve(0,m.IExtHostRpcService),Ve(1,S.IExtHostWorkspace),Ve(2,b.ILogService)],p),e.ExtHostConfiguration=p;class n{constructor(t,u,s,h){this.a=new C.Emitter,this.b=t,this.f=h,this.c=u,this.e=R.Configuration.parse(s),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(t,u){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(t),this.d=this.k(t.configurationScopes),this.a.fire(this.j(u,s))}getConfiguration(t,u,s){const h=P(u)||{},a=this.g(t?r(this.e.getValue(void 0,h,this.c.workspace),t):this.e.getValue(void 0,h,this.c.workspace));t&&this.h(t,h,s?.identifier);function c(A){if(A==null)return null;if(typeof A=="boolean")return A?2:5;switch(A){case I.ConfigurationTarget.Global:return 2;case I.ConfigurationTarget.Workspace:return 5;case I.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(A){return typeof r(a,A)<"u"},get:(A,F)=>{this.h(t?`${t}.${A}`:A,h,s?.identifier);let j=r(a,A);if(typeof j>"u")j=F;else{let te;const x=(N,$)=>{let T;const M=()=>{te=te||(0,i.deepClone)(a),T=T||r(te,$)};return(0,k.isObject)(N)?new Proxy(N,{get:(V,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return M(),()=>T;if(te)return T=T||r(te,$),T[q];const le=V[q];return typeof q=="string"?x(le,`${$}.${q}`):le},set:(V,q,le)=>(M(),T&&(T[q]=le),!0),deleteProperty:(V,q)=>(M(),T&&delete T[q],!0),defineProperty:(V,q,le)=>(M(),T&&Object.defineProperty(T,q,le),!0)}):N};j=x(j,A)}return j},update:(A,F,j,te)=>{A=t?`${t}.${A}`:A;const x=c(j);return F!==void 0?this.b.$updateConfigurationOption(x,A,F,h,te):this.b.$removeConfigurationOption(x,A,h,te)},inspect:A=>{A=t?`${t}.${A}`:A;const F=this.e.inspect(A,h,this.c.workspace);if(F)return{key:A,defaultValue:(0,i.deepClone)(F.policy?.value??F.default?.value),globalValue:(0,i.deepClone)(F.user?.value??F.application?.value),workspaceValue:(0,i.deepClone)(F.workspace?.value),workspaceFolderValue:(0,i.deepClone)(F.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(F.default?.override),globalLanguageValue:(0,i.deepClone)(F.user?.override??F.application?.override),workspaceLanguageValue:(0,i.deepClone)(F.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(F.workspaceFolder?.override),languageIds:(0,i.deepClone)(F.overrideIdentifiers)}}};return typeof a=="object"&&(0,i.mixin)(g,a,!1),Object.freeze(g)}g(t){const u=s=>(0,k.isObject)(s)?new Proxy(s,{get:(h,a)=>u(h[a]),set:(h,a,c)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(h,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(h,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return u(t)}h(t,u,s){const h=y.OVERRIDE_PROPERTY_REGEX.test(t)?4:this.d.get(t),a=s?`[${s.value}] `:"";if(h===4){typeof u?.resource>"u"&&this.f.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${t}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){u?.resource&&this.f.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${t}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(t,u){const s=new R.ConfigurationChangeEvent(t,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,a)=>s.affectsConfiguration(h,P(a))})}k(t){return t.reduce((u,s)=>(u.set(s[0],s[1]),u),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[106],Ce([1,0,2,12,4,5,7,31,57,32,21,60,17,27,3,16,20,13,76,199,11]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o,l,v,E,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(N){function $(M){if(M!=null)return M}N.from=$;function T(M){if(M!=null)return M}N.to=T})(n||(n={}));var d;(function(N){function $(M){if(M!=null)return M}N.from=$;function T(M){if(M!=null)return M}N.to=T})(d||(d={}));var t;(function(N){function $(M){if(M!=null)return M}N.from=$;function T(M){if(M!=null)return M}N.to=T})(t||(t={}));var u;(function(N){function $(V){if(V){const q=V;return q&&!!q.process}else return!1}N.is=$;function T(V){if(V==null)return;const q={process:V.process,args:V.args};return V.options&&(q.options=t.from(V.options)),q}N.from=T;function M(V){if(V!=null)return new I.ProcessExecution(V.process,V.args,V.options)}N.to=M})(u||(u={}));var s;(function(N){function $(M){if(M!=null)return M}N.from=$;function T(M){if(M!=null)return M}N.to=T})(s||(s={}));var h;(function(N){function $(V){if(V){const q=V;return q&&(!!q.commandLine||!!q.command)}else return!1}N.is=$;function T(V){if(V==null)return;const q={};return V.commandLine!==void 0?q.commandLine=V.commandLine:(q.command=V.command,q.args=V.args),V.options&&(q.options=s.from(V.options)),q}N.from=T;function M(V){if(!(V==null||V.command===void 0&&V.commandLine===void 0))return V.commandLine?new I.ShellExecution(V.commandLine,V.options):new I.ShellExecution(V.command,V.args?V.args:[],V.options)}N.to=M})(h||(h={}));var a;(function(N){function $(V){if(V){const q=V;return q&&q.customExecution==="customExecution"}else return!1}N.is=$;function T(V){return{customExecution:"customExecution"}}N.from=T;function M(V,q){return q.get(V)}N.to=M})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var c;(function(N){function $(T,M){let V;return T.scope!==void 0&&typeof T.scope!="number"?V=T.scope.uri:T.scope!==void 0&&typeof T.scope=="number"&&(T.scope===I.TaskScope.Workspace&&M&&M.workspaceFile?V=M.workspaceFile:V=E.USER_TASKS_GROUP_KEY),{id:T._id,workspaceFolder:V}}N.from=$})(c=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(N){function $(T){if(T!=null)return{_id:T.id,isDefault:T.isDefault}}N.from=$})(g||(g={}));var A;(function(N){function $(V,q){if(V==null)return[];const le=[];for(const _ of V){const pe=T(_,q);pe&&le.push(pe)}return le}N.fromMany=$;function T(V,q){if(V==null)return;let le;V.execution instanceof I.ProcessExecution?le=u.from(V.execution):V.execution instanceof I.ShellExecution?le=h.from(V.execution):V.execution&&V.execution instanceof I.CustomExecution&&(le=a.from(V.execution));const _=n.from(V.definition);let pe;return V.scope?typeof V.scope=="number"?pe=V.scope:pe=V.scope.uri:pe=I.TaskScope.Workspace,!_||!pe?void 0:{_id:V._id,definition:_,name:V.name,source:{extensionId:q.identifier.value,label:V.source,scope:pe},execution:le,isBackground:V.isBackground,group:g.from(V.group),presentationOptions:d.from(V.presentationOptions),problemMatchers:V.problemMatchers,hasDefinedMatchers:V.hasDefinedMatchers,runOptions:V.runOptions?V.runOptions:{reevaluateOnRerun:!0},detail:V.detail}}N.from=T;async function M(V,q,le){if(V==null)return;let _;u.is(V.execution)?_=u.to(V.execution):h.is(V.execution)?_=h.to(V.execution):a.is(V.execution)&&(_=a.to(V._id,le));const pe=n.to(V.definition);let ue;if(V.source&&(V.source.scope!==void 0?typeof V.source.scope=="number"?ue=V.source.scope:ue=await q.resolveWorkspaceFolder(i.URI.revive(V.source.scope)):ue=I.TaskScope.Workspace),!pe||!ue)return;const de=new I.Task(pe,ue,V.name,V.source.label,_,V.problemMatchers);return V.isBackground!==void 0&&(de.isBackground=V.isBackground),V.group!==void 0&&(de.group=I.TaskGroup.from(V.group._id),de.group&&V.group.isDefault&&(de.group=new I.TaskGroup(de.group.id,de.group.label),V.group.isDefault===!0&&(de.group.isDefault=V.group.isDefault))),V.presentationOptions&&(de.presentationOptions=d.to(V.presentationOptions)),V._id&&(de._id=V._id),V.detail&&(de.detail=V.detail),de}N.to=M})(A=e.TaskDTO||(e.TaskDTO={}));var F;(function(N){function $(M){return M}N.from=$;function T(M){if(!!M)return Object.assign(Object.create(null),M)}N.to=T})(F||(F={}));class j{constructor($,T,M){this._id=T,this.a=M,p.set(this,void 0),Je(this,p,$,"f")}get task(){return this.a}terminate(){Oe(this,p,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}p=new WeakMap;let te=class{constructor($,T,M,V,q,le,_,pe){this.q=new S.Emitter,this.r=new S.Emitter,this.s=new S.Emitter,this.t=new S.Emitter,this.a=$.getProxy(L.MainContext.MainThreadTask),this.b=M,this.c=V,this.d=q,this.e=le,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=_,this.g=pe,this.a.$registerSupportedExecutions(!0)}registerTaskProvider($,T,M){if(!M)return new I.Disposable(()=>{});const V=this.w();return this.j.set(V,{type:T,provider:M,extension:$}),this.a.$registerTaskProvider(V,T),new I.Disposable(()=>{this.j.delete(V),this.a.$unregisterTaskProvider(V)})}registerTaskSystem($,T){this.a.$registerTaskSystem($,T)}fetchTasks($){return this.a.$fetchTasks(F.from($)).then(async T=>{const M=[];for(const V of T){const q=await A.to(V,this.b,this.m);q&&M.push(q)}return M})}get taskExecutions(){const $=[];return this.k.forEach(T=>$.push(T)),$}terminateTask($){if(!($ instanceof j))throw new Error("No valid task execution provided");return this.a.$terminateTask($._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask($,T,M){const V=this.m.get($.id);V&&(this.o.set($.id,V),this.e.attachPtyToTerminal(T,await V.callback(M))),this.p=$.id,this.q.fire({execution:await this.y($)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask($){const T=await this.y($);this.l.delete($.id),this.k.delete($.id),this.A($),this.r.fire({execution:T})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess($){const T=await this.y($.id);this.s.fire({execution:T,processId:$.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess($){const T=await this.y($.id);this.t.fire({execution:T,exitCode:$.exitCode})}$provideTasks($,T){const M=this.j.get($);if(!M)return Promise.reject(new Error("no handler found"));const V=[],q=(0,C.asPromise)(()=>M.provider.provideTasks(O.CancellationToken.None)).then(le=>this.u(T,V,M,le));return new Promise(le=>{q.then(_=>{Promise.all(V).then(()=>{le(_)})})})}async $resolveTask($,T){const M=this.j.get($);if(!M)return Promise.reject(new Error("no handler found"));if(T.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${T.definition.type}] cannot be resolved by provider of type [${M.type}].`);const V=await A.to(T,this.b,this.m);if(!V)throw new Error("Unexpected: Task cannot be resolved.");const q=await M.provider.resolveTask(V,O.CancellationToken.None);if(!q)return;this.z(q,M);const le=A.from(q,M.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==V.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(le.execution)&&await this.x(le,q,!0),await this.v(le)}w(){return this.h++}async x($,T,M){const V=await this.a.$createTaskId($);!M&&!this.m.has(V)&&(this.n.add(V),this.o.set(V,T.execution)),this.m.set(V,T.execution)}async y($,T){if(typeof $=="string"){const q=this.l.get($);if(!q)throw new P.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return q}const M=this.l.get($.id);if(M)return M;const V=new Promise((q,le)=>{function _(pe,ue,de){de?q(new j(pe,ue.id,de)):le("Unexpected: Task does not exist.")}T?_(this,$,T):A.to($.task,this.b,this.m).then(pe=>_(this,$,pe))});return this.l.set($.id,V),V.then(q=>(this.k.set($.id,q),q),q=>Promise.reject(q))}z($,T){$._deprecated&&this.g.report("Task.constructor",T.extension,"Use the Task constructor that takes a `scope` instead.")}A($){this.o.get($.id)&&this.o.delete($.id),this.n.has($.id)&&this.p!==$.id&&(this.m.delete($.id),this.n.delete($.id));const M=this.n.values();let V=M.next();for(;!V.done;)!this.o.has(V.value)&&this.p!==V.value&&(this.m.delete(V.value),this.n.delete(V.value)),V=M.next()}};te=qe([Ve(0,m.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,y.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,v.IExtHostApiDeprecationService)],te),e.ExtHostTaskBase=te;let x=class extends te{constructor($,T,M,V,q,le,_,pe){super($,T,M,V,q,le,_,pe),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask($,T){if(!T.execution)throw new Error("Tasks to execute must include an execution");const M=A.from(T,$);if(M===void 0)throw new Error("Task is not valid");if(a.is(M.execution))await this.x(M,T,!1);else throw new P.NotSupportedError;const V=await this.y(await this.a.$getTaskExecution(M),T);return this.a.$executeTask(M).catch(q=>{throw new Error(q)}),V}u($,T,M,V){const q=[];if(V)for(const le of V){this.z(le,M),(!le.definition||!$[le.definition.type])&&this.f.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const _=A.from(le,M.extension);_&&a.is(_.execution)?(q.push(_),T.push(this.x(_,le,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:M.extension}}async v($){if(a.is($.execution))return $;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables($,T){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,T,M){}};x=qe([Ve(0,m.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,R.IExtHostWorkspace),Ve(3,y.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,w.IExtHostTerminalService),Ve(6,l.ILogService),Ve(7,v.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ie[242],Ce([1,0,19,21,39,35,23,77,45]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(m,b,f){this.k=m,this.l=b,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&L.parse(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&L.parse(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const b=this.k.folderQueries||[];return new Promise((f,r)=>{const o=l=>{this.f++,m(l)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const v=l.toString(),E=i.basename(v);this.j&&this.j(v,E)||this.v(o,{base:l,basename:E})}),Promise.all(b.map(l=>this.p(l,o))).then(l=>{f({limitHit:this.e,stats:l[0]||void 0})},l=>{r(new Error((0,S.toErrorMessage)(l)))})})}async p(m,b){const f=new C.CancellationTokenSource,r=this.q(m),o=this.r(),l=new y.QueryGlobTester(this.k,m),v=!l.hasSiblingExcludeClauses();let E;try{this.h.add(f),E=R.StopWatch.create();const P=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,f.token),p=E.elapsed(),n=R.StopWatch.create();return this.g&&!this.e||(P&&P.forEach(d=>{const t=i.posix.relative(m.folder.path,d.path);if(v){const u=i.basename(d.path);this.v(b,{base:m.folder,relativePath:t,basename:u});return}this.s(o,m.folder,t,b)}),this.g&&!this.e)?null:(this.u(o,l,b),{providerTime:p,postProcessTime:n.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(m){const b=(0,y.resolvePatternsForProvider)(this.k.includePattern,m.includePattern),f=(0,y.resolvePatternsForProvider)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:b,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},b,f,r){if(f===this.a){const l=i.basename(this.a);this.v(r,{base:b,relativePath:this.a,basename:l})}function o(l){const v=i.basename(l),E=i.dirname(l);let P=m[E];P||(P=m[E]=[],o(E)),P.push({base:b,relativePath:l,basename:v})}o(f)}u({rootEntries:m,pathToEntries:b},f,r){const o=this,l=this.a;function v(E){const P=(0,y.hasSiblingFn)(()=>E.map(p=>p.basename));for(let p=0,n=E.length;p<n;p++){const d=E[p],{relativePath:t,basename:u}=d;if(f.matchesExcludesSync(t,u,l!==u?P:void 0))continue;const s=b[t];if(s)v(s);else{if(t===l)continue;o.v(r,d)}if(o.e)break}}v(m)}v(m,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(b))}}class O{constructor(){this.b=new Map}fileSearch(m,b,f,r){const o=this.c(m.cacheKey),l=new k(m,b,o&&o.token);let v=0;const E=P=>{v+=P.length,f(P.map(p=>this.d(p)))};return this.e(l,O.a,E,r).then(P=>({limitHit:P.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:P.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(!!m)return this.b.has(m)||this.b.set(m,new C.CancellationTokenSource),this.b.get(m)}d(m){return m.relativePath?{resource:I.joinPath(m.base,m.relativePath)}:{resource:m.base}}e(m,b,f,r){r.onCancellationRequested(()=>{m.cancel()});const o=v=>{v&&(l.push(v),b>0&&l.length>=b&&(f(l),l=[]))};let l=[];return m.search(o).then(v=>(l.length&&f(l),v),v=>(l.length&&f(l),Promise.reject(v)))}}e.FileSearchManager=O,O.a=512}),define(Ie[243],Ce([1,0,18,62,35,86,28,16,19,23,10,9,2,259,152,41,13,52,96,241,45]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o,l,v,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(g,A,F,j,te){this.a=g,this.b=A,this.c=F,this.d=j,this.e=te}text(g,A,F={}){g=this.f(g,F);const j=this.a.getValue(),te=A&&A.some(N=>!this.a.getValue({resource:N}).search.useRipgrep);return{...this.h(A?.map(l.toWorkspaceFolder),F),type:2,contentPattern:g,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:j.search.usePCRE2||te||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}f(g,A){const F=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const j={...g,wordSeparators:F.editor.wordSeparators};return this.j(g,A)&&(j.isCaseSensitive=!0),this.k(g)&&(j.isMultiline=!0),j}file(g,A={}){return{...this.h(g,A),type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey}}g(g,A){return g?(g=Array.isArray(g)?g.map(s):s(g),A?this.parseSearchPaths(g):{pattern:d(...Array.isArray(g)?g:[g])}):{}}h(g=[],A={}){const F=this.g(A.includePattern,A.expandPatterns),j=this.g(A.excludePattern,A.expandPatterns),te=g.length>1,x=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(T=>this.q(T,A,j)):g.map(T=>this.r(T,A,j,te))).filter(T=>!!T),N={_reason:A._reason,folderQueries:x,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:j.pattern,includePattern:F.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const T=i.coalesce(i.flatten(this.c.groups.map(q=>q.editors.map(le=>le.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const M=T.filter(q=>(0,P.pathIncludedInQuery)(N,q.fsPath)),V=this.i(M);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...N,...V}}const $=A.extraFileResources&&A.extraFileResources.filter(T=>(0,P.pathIncludedInQuery)(N,T.fsPath));return N.extraFileResources=$&&$.length?$:void 0,N}i(g){const A=[],F=new I.ResourceMap,j={};let te=!1;return g.forEach(x=>{if(x.scheme===R.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(x)){const $=this.b.getWorkspaceFolder(x)?.uri??x.with({path:y.dirname(x.fsPath)});let T=F.get($);T||(te=!0,T={folder:$,includePattern:{}},A.push(T),F.set($,T));const M=y.relative($.fsPath,x.fsPath);(0,w.assertIsDefined)(T.includePattern)[M.replace(/\\/g,"/")]=!0}else x.fsPath&&(te=!0,j[x.fsPath]=!0)}),{folderQueries:A,includePattern:j,usingSearchPaths:!0,excludePattern:te?void 0:{"**/*":!0}}}j(g,A){if(A.isSmartCase){if(g.isRegExp){if(O.containsUppercaseCharacter(g.pattern,!0))return!0}else if(O.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,b.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const A=V=>y.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),j=(Array.isArray(g)?g:t(g)).map(V=>{const q=this.e.resolvedUserHome;return q?(0,L.untildify)(V,q.scheme===R.Schemas.file?q.fsPath:q.path):V}),te=C.groupBy(j,V=>A(V)?"searchPaths":"exprSegments"),x=(te.exprSegments||[]).map(V=>O.rtrim(V,"/")).map(V=>O.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),u(V))),N={},$=this.m(te.searchPaths||[]);$&&$.length&&(N.searchPaths=$);const T=i.flatten(x),M=d(...T);return M&&(N.pattern=M),N}l(g,A){return A.disregardExcludeSettings?void 0:(0,P.getExcludes)(g,!A.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const A=g.flatMap(j=>{let{pathPortion:te,globPortion:x}=n(j);return x&&(x=h(x)),this.n(te).flatMap($=>this.o($,x))}),F=new Map;return A.forEach(j=>{const te=j.searchPath.toString(),x=F.get(te);x?j.pattern&&(x.pattern=x.pattern||{},x.pattern[j.pattern]=!0):F.set(te,{searchPath:j.searchPath,pattern:j.pattern?d(j.pattern):void 0})}),Array.from(F.values())}n(g){if(y.isAbsolute(g)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==R.Schemas.file?[{searchPath:A[0].uri.with({path:g})}]:[{searchPath:m.URI.file(y.normalize(g))}]}if(this.b.getWorkbenchState()===2){const A=this.b.getWorkspace().folders[0].uri;if(g=s(g),g.startsWith("../")||g===".."){const j=y.posix.resolve(A.path,g);return[{searchPath:A.with({path:j})}]}const F=h(g);return[{searchPath:A,pattern:F}]}else{if(g==="./"||g===".\\")return[];{const A=g.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(te=>{const x=A.match(new RegExp(`^${O.escapeRegExpCharacters(te.name)}(?:/(.*)|$)`));return x?{match:x,folder:te}:null}).filter(w.isDefined);if(j.length)return j.map(te=>{const x=te.match[1];return{searchPath:te.folder.uri,pattern:x&&h(x)}});{const te=g.match(/\.[\/\\](.+)[\/\\]?/),x=te?te[1]:g,N=f.localize(0,null,x);throw new Error(N)}}}}o(g,A){const F=g.pattern&&A?`${g.pattern}/${A}`:g.pattern||A,j=[{searchPath:g.searchPath,pattern:F}];return F&&!F.endsWith("**")&&j.push({searchPath:g.searchPath,pattern:F+"/**"}),j}q(g,A,F){const j=this.r((0,l.toWorkspaceFolder)(g.searchPath),A,F,!1);return j?{...j,includePattern:g.pattern}:null}r(g,A,F,j){let te;const x=m.URI.isUri(g)?g:g.uri;if(F.searchPaths){const V=F.searchPaths.filter(q=>(0,k.isEqual)(q.searchPath,x))[0];if(V&&!V.pattern)return null;V&&(te=V.pattern)}const N=this.a.getValue({resource:x}),T={...this.l(N,A)||{},...te||{}},M=m.URI.isUri(g)?(0,k.basename)(g):g.name;return{folder:x,folderName:j?M:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!N.search.followSymlinks}}};p=qe([Ve(0,r.IConfigurationService),Ve(1,l.IWorkspaceContextService),Ve(2,v.IEditorGroupsService),Ve(3,o.ILogService),Ve(4,E.IPathService)],p),e.QueryBuilder=p;function n(c){const g=c.match(/[\*\{\}\(\)\[\]\?]/);if(g){const A=g.index,F=c.substr(0,A).match(/[/|\\][^/\\]*$/);if(F){let j=c.substr(0,F.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:c.substr((F.index||0)+1)}}}return{pathPortion:c}}function d(...c){return c.length?c.reduce((g,A)=>(g[A]=!0,g),Object.create(null)):void 0}function t(c){return S.splitGlobAware(c,",").map(g=>g.trim()).filter(g=>!!g.length)}function u(c){return[`**/${c}/**`,`**/${c}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function s(c){return c.replace(/\\/g,"/")}function h(c){return s(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(c,g){c=i.distinct(c,j=>j.toString());const A=[],F=g.getWorkspace();return c&&c.forEach(j=>{let te;if(g.getWorkbenchState()===2)te=(0,k.relativePath)(F.folders[0].uri,j),te&&te!=="."&&(te="./"+te);else{const x=g.getWorkspaceFolder(j);if(x){const N=x.name;if(F.folders.filter(T=>T.name===N).length===1){const T=(0,k.relativePath)(x.uri,j);T===""?te=`./${x.name}`:te=`./${x.name}/${T}`}else te=j.fsPath}}te&&A.push(te)}),A}e.resolveResourcesForSearchIncludes=a}),define(Ie[244],Ce([1,0,23,2,21,11,3,243,45,52]),function(ee,e,i,C,S,L,I,R,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function w(r,o){const l=o.activationEvents;if(!l)return Promise.resolve(void 0);const v=[],E=[];for(const u of l)if(/^workspaceContains:/.test(u)){const s=u.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||r.forceUsingSearch?E.push(s):v.push(s)}if(v.length===0&&E.length===0)return Promise.resolve(void 0);let P;const p=new Promise((u,s)=>{P=u}),n=u=>P({activationEvent:u}),d=Promise.all(v.map(u=>m(r,u,n))).then(()=>{}),t=b(r,o.identifier,E,n);return Promise.all([d,t]).then(()=>{P(void 0)}),p}e.checkActivateWorkspaceContainsExtension=w;async function m(r,o,l){for(const v of r.folders)if(await r.exists(i.joinPath(C.URI.revive(v),o))){l(`workspaceContains:${o}`);return}}async function b(r,o,l,v){if(l.length===0)return Promise.resolve(void 0);const E=new S.CancellationTokenSource,P=r.checkExists(r.folders,l,E.token),p=setTimeout(async()=>{E.cancel(),r.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},O);let n=!1;try{n=await P}catch(d){L.isCancellationError(d)||L.onUnexpectedError(d)}E.dispose(),clearTimeout(p),n&&v(`workspaceContains:${l.join(",")}`)}function f(r,o,l,v){const E=r.get(I.IInstantiationService),P=r.get(y.ISearchService),n=E.createInstance(R.QueryBuilder).file(o.map(d=>(0,k.toWorkspaceFolder)(C.URI.revive(d))),{_reason:"checkExists",includePattern:l,exists:!0});return P.fileSearch(n,v).then(d=>!!d.limitHit,d=>L.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(ee,e,i,C,S){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?S.call(ee,i):S?S.value=i:e.set(ee,i),i},Oe=this&&this.__classPrivateFieldGet||function(ee,e,i,C){if(i==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?C:i==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ie[33],Ce([1,0,138,19,82,23,12,6,46,2,13,5,32,188,80,31,24,97,11,26,25,172,7,93,3,27,81,17,67,69,60,4,244,79,174,16,78,77]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o,l,v,E,P,p,n,d,t,u,s,h,a,c,g,A,F,j,te,x,N,$){"use strict";var T,M,V;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,t.createDecorator)("IHostUtils");let q=class Bi extends R.Disposable{constructor(re,G,H,oe,ve,Ae,Be,xe,Te,Se,ke){super(),this.a=this.B(new A.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=G,this.g=H,this.f=Be,this.j=oe,this.k=ve,this.l=Ae,this.m=Te,this.p=Se,this.s=ke,this.t=this.g.getProxy(w.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(w.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(w.MainContext.MainThreadExtensionService),this.w=new I.Barrier,this.y=new I.Barrier,this.z=new I.Barrier,this.C=new I.Barrier,this.F=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const se=(0,o.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new l.ExtensionDescriptionRegistry(pe(this.F,se)),this.G=new f.ExtHostStorage(this.g,this.l),this.H=new j.ExtHostSecretState(this.g),this.I=xe,this.h=re.createChild(new a.ServiceCollection([f.IExtHostStorage,this.G],[j.IExtHostSecretState,this.H])),this.J=this.B(new b.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,J,D)=>{this.v.$onExtensionActivationError(ce,v.transformErrorForSerialization(J),D)},actualActivateExtension:async(ce,J)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,J),new b.HostExtension;const D=this.D.getExtensionDescription(ce);return this.Y(D,J)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),S.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(re){v.onUnexpectedError(re)}}async Q(){this.I.onWillDeactivateAll();let re=[];try{re=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(re)}terminate(re,G=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${re}`),this.l.flush(),this.p.dispose(),this.J.dispose(),v.setUnexpectedErrorHandler(oe=>{this.l.error(oe)}),this.g.dispose();const H=this.Q();Promise.race([(0,I.timeout)(5e3),H]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${G}`):this.l.info(`Extension host exiting with code ${G}`),this.l.flush(),this.l.dispose(),this.c.exit(G)})}isActivated(re){return this.z.isOpen()?this.J.isActivated(re):!1}async getExtension(re){const G=await this.v.$getExtension(re);let H;if(G?.browserNlsBundleUris){H={};for(const oe of Object.keys(G.browserNlsBundleUris))H[oe]=k.URI.revive(G.browserNlsBundleUris[oe])}return G&&{...G,identifier:new E.ExtensionIdentifier(G.identifier.value),extensionLocation:k.URI.revive(G.extensionLocation),browserNlsBundleUris:H}}R(re,G){return this.J.activateByEvent(re,G)}S(re,G){return this.J.activateById(re,G)}activateByIdWithErrors(re,G){return this.S(re,G).then(()=>{const H=this.J.getActivatedExtension(re);if(H.activationFailed)return Promise.reject(H.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(re=>this.D)}getExtensionExports(re){return this.z.isOpen()?this.J.getActivatedExtension(re).exports:null}async U(re){if(re.scheme!==x.Schemas.file)return re;const G=await this.c.realpath(re.fsPath);return k.URI.file(G)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(re=>new ue(re))),this.L}async W(re){const G=y.TernarySearchTree.forUris(H=>L.extUriBiasedIgnorePathCase.ignorePathCasing(H));return await Promise.all(re.map(async H=>{if(this.ob(H)){const oe=await this.U(H.extensionLocation);G.set(oe,H)}})),G}X(re){let G=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(re))return G;const H=this.J.getActivatedExtension(re);if(!H)return G;try{typeof H.module.deactivate=="function"&&(G=Promise.resolve(H.module.deactivate()).then(void 0,oe=>(this.l.error(oe),Promise.resolve(void 0))))}catch(oe){this.l.error(`An error occurred when deactivating the extension '${re.value}':`),this.l.error(oe)}try{(0,R.dispose)(H.subscriptions)}catch(oe){this.l.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this.l.error(oe)}return G}async Y(re,G){return this.f.remote.isRemote?this.v.$onWillActivateExtension(re.identifier):await this.v.$onWillActivateExtension(re.identifier),this.ab(re,G).then(H=>{const oe=H.activationTimes;return this.v.$onDidActivateExtension(re.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,G),this.Z(re,G,"success",oe),H},H=>{throw this.Z(re,G,"failure"),H})}Z(re,G,H,oe){const ve=le(re,G);this.u.$publicLog2("extensionActivationTimes",{...ve,...oe||{},outcome:H})}ab(re,G){const H=le(re,G);this.u.$publicLog2("activatePlugin",H);const oe=this.ob(re);if(!oe)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${G.startup}, activationEvent: '${G.activationEvent}'${re.identifier.value!==G.extensionId.value?`, root cause: ${G.extensionId.value}`:""}`),this.l.flush();const ve=new b.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this.pb(re,(0,L.joinPath)(re.extensionLocation,oe),ve),this.bb(re)]).then(Ae=>(S.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Bi.cb(this.l,re.identifier,Ae[0],Ae[1],ve))).then(Ae=>(S.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),Ae))}bb(re){const G=new p.ExtensionGlobalMemento(re,this.G),H=new p.ExtensionMemento(re.identifier.value,!1,this.G),oe=new te.ExtensionSecrets(re,this.H),ve=re.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Ae=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([G.whenReady,H.whenReady,this.I.whenReady]).then(()=>{const Be=this;let xe,Te;const Se=(0,o.isProposedApiEnabled)(re,"ipc")?this.f.messagePorts?.get(E.ExtensionIdentifier.toKey(re.identifier)):void 0;return Object.freeze({globalState:G,workspaceState:H,secrets:oe,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(ke){return C.join(re.extensionLocation.fsPath,ke)},get storagePath(){return Be.I.workspaceValue(re)?.fsPath},get globalStoragePath(){return Be.I.globalValue(re).fsPath},get logPath(){return C.join(Be.f.logsLocation.fsPath,re.identifier.value)},get logUri(){return k.URI.joinPath(Be.f.logsLocation,re.identifier.value)},get storageUri(){return Be.I.workspaceValue(re)},get globalStorageUri(){return Be.I.globalValue(re)},get extensionMode(){return ve},get extension(){return xe===void 0&&(xe=new _(Be,re.identifier,re,Ae,!1)),xe},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(re,"extensionRuntime"),Be.extensionRuntime},get environmentVariableCollection(){return Be.p.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!Te){if(!Se)return;const ke=A.Event.buffer(A.Event.fromDOMEventEmitter(Se,"message",se=>se.data));Se.start(),Te={onDidReceiveMessage:ke,postMessage:Se.postMessage.bind(Se)}}return Te}})})}static cb(re,G,H,oe,ve){return H=H||{activate:void 0,deactivate:void 0},this.db(re,G,H,oe,ve).then(Ae=>new b.ActivatedExtension(!1,null,ve.build(),H,Ae,oe.subscriptions))}static db(re,G,H,oe,ve){if(typeof H.activate=="function")try{ve.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${G.value}`);const Ae=typeof global=="object"?global:self,Be=H.activate.apply(Ae,[oe]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Be).then(xe=>(ve.activateResolveStop(),xe))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(H)}eb(re,G){this.S(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:G}).then(void 0,H=>{this.l.error(H)})}fb(){this.v.$setPerformanceMarks(S.getMarks());for(const re of this.D.getAllExtensionDescriptions())if(re.activationEvents)for(const G of re.activationEvents)G==="onStartupFinished"&&this.eb(re,G)}gb(){const re=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.hb(ve.added)));const G=this.j.workspace?this.j.workspace.folders:[],H=this.hb(G),oe=Promise.all([re,H]).then(()=>{});return Promise.race([oe,(0,I.timeout)(1e4)]).then(()=>{this.fb()}),oe}hb(re){return re.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(G=>this.ib(re,G))).then(()=>{})}async ib(re,G){if(this.isActivated(G.identifier))return;const H=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.l,folders:re.map(Ae=>Ae.uri),forceUsingSearch:H,exists:Ae=>this.c.exists(Ae.fsPath),checkExists:(Ae,Be,xe)=>this.t.$checkExists(Ae,Be,xe)},ve=await(0,F.checkActivateWorkspaceContainsExtension)(oe,G);if(!!ve)return this.S(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:ve.activationEvent}).then(void 0,Ae=>this.l.error(Ae))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(re){throw console.error(re),re}}async jb(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:G}=this.f.environment;if(!re||!G)throw new Error(i.localize(0,null));const H=await this.pb(null,G,new b.ExtensionActivationTimesBuilder(!1));if(!H||typeof H.run!="function")throw new Error(i.localize(1,null,G.toString()));return new Promise((oe,ve)=>{const Ae=(Te,Se)=>{Te?ve(Te):oe(typeof Se=="number"&&Se>0?1:0)},Be=(0,L.originalFSPath)(G),xe=H.run(Be,Ae);xe&&xe.then&&xe.then(()=>{oe(0)}).catch(Te=>{ve(Te instanceof Error&&Te.stack?Te.stack:String(Te))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,G){return this.M[re]=G,(0,R.toDisposable)(()=>{delete this.M[re]})}async lb(re){const G=re.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const H=re.substr(0,G);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${H}`,!1),{authorityPrefix:H,resolver:this.M[H]}}async $resolveAuthority(re,G){const H=$.StopWatch.create(!1),oe=()=>`[resolveAuthority(${(0,d.getRemoteAuthorityPrefix)(re)},${G})][${H.elapsed()}ms] `,ve=Se=>this.l.info(`${oe()}${Se}`),Ae=(Se,ke=void 0)=>this.l.error(`${oe()}${Se}`,ke);ve("activating resolver...");const{authorityPrefix:Be,resolver:xe}=await this.lb(re);if(!xe)return Ae("no resolver"),{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Be}.`,detail:void 0}};const Te=new I.IntervalTimer;try{ve("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(xe)),Te.cancelAndSet(()=>ve("waiting..."),1e3),ve("invoking resolve()..."),S.mark(`code/extHost/willResolveAuthority/${Be}`);const Se=await xe.resolve(re,{resolveAttempt:G});S.mark(`code/extHost/didResolveAuthorityOK/${Be}`),Te.dispose(),ve(`returned ${Se.host}:${Se.port}`);const ke={authority:re,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},se={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ke,options:se,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(S.mark(`code/extHost/didResolveAuthorityError/${Be}`),Te.dispose(),Ae("returned an error",Se),Se instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(re,G){this.l.info(`$getCanonicalURI invoked for authority (${(0,d.getRemoteAuthorityPrefix)(re)})`);const{resolver:H}=await this.lb(re);if(!H)return null;const oe=k.URI.revive(G);if(typeof H.getCanonicalURI>"u")return oe;const ve=await(0,I.asPromise)(()=>H.getCanonicalURI(oe));return ve||oe}static mb(re,G,H){const oe=new l.ExtensionDescriptionRegistry(re.getAllExtensionDescriptions());oe.deltaExtensions(H.toAdd,H.toRemove);const ve=(0,o.extensionIdentifiersArrayToSet)(G.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of H.myToRemove)ve.delete(E.ExtensionIdentifier.toKey(Be));for(const Be of H.myToAdd)ve.add(E.ExtensionIdentifier.toKey(Be));const Ae=pe(oe,ve);return{globalRegistry:oe,myExtensions:Ae}}$startExtensionHost(re){re.toAdd.forEach(oe=>oe.extensionLocation=k.URI.revive(oe.extensionLocation));const{globalRegistry:G,myExtensions:H}=Bi.mb(this.F,this.D,re);return this.F.set(G.getAllExtensionDescriptions()),this.D.set(H),this.kb()}$activateByEvent(re,G){return G===1?this.R(re,!1):this.z.wait().then(H=>this.R(re,!1))}async $activate(re,G){return await this.z.wait(),this.D.getExtensionDescription(re)?(await this.S(re,G),!0):!1}async $deltaExtensions(re){re.toAdd.forEach(Ae=>Ae.extensionLocation=k.URI.revive(Ae.extensionLocation));const{globalRegistry:G,myExtensions:H}=Bi.mb(this.F,this.D,re),oe=await this.W(H);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.F.set(G.getAllExtensionDescriptions()),this.D.set(H),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){const G=P.VSBuffer.alloc(re),H=Math.random()%256;for(let oe=0;oe<re;oe++)G.writeUInt8(H,oe);return G}async $updateRemoteConnectionData(re){this.P=re,this.a.fire()}};q=qe([Ve(0,t.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,h.IExtHostRpcService),Ve(3,r.IExtHostWorkspace),Ve(4,m.IExtHostConfiguration),Ve(5,O.ILogService),Ve(6,u.IExtHostInitDataService),Ve(7,s.IExtensionStoragePaths),Ve(8,c.IExtHostTunnelService),Ve(9,g.IExtHostTerminalService),Ve(10,N.IExtHostLocalizationService)],q),e.AbstractExtHostExtensionService=q;function le(de,re){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.IExtHostExtensionService=(0,t.createDecorator)("IExtHostExtensionService");class _{constructor(re,G,H,oe,ve){T.set(this,void 0),M.set(this,void 0),V.set(this,void 0),Je(this,T,re,"f"),Je(this,M,G,"f"),Je(this,V,H.identifier,"f"),this.id=H.identifier.value,this.extensionUri=H.extensionLocation,this.extensionPath=C.normalize((0,L.originalFSPath)(H.extensionLocation)),this.packageJSON=H,this.extensionKind=oe,this.isFromDifferentExtensionHost=ve}get isActive(){return Oe(this,T,"f").isActivated(Oe(this,V,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,T,"f").getExtensionExports(Oe(this,V,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,T,"f").activateByIdWithErrors(Oe(this,V,"f"),{startup:!1,extensionId:Oe(this,M,"f"),activationEvent:"api"}),this.exports}}e.Extension=_,T=new WeakMap,M=new WeakMap,V=new WeakMap;function pe(de,re){return de.getAllExtensionDescriptions().filter(G=>re.has(E.ExtensionIdentifier.toKey(G.identifier)))}class ue{constructor(re){this.a=re}setSearchTree(re){this.a=re}findSubstr(re){return this.a.findSubstr(re)}forEach(re){return this.a.forEach(re)}}e.ExtensionPaths=ue}),define(Ie[245],Ce([1,0,82,2,5,32,24,26,17,27,3,33,49,13,10]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(p,n,d,t,u,s,h){this.c=p,this.d=n,this.e=d,this.f=t,this.g=u,this.h=s,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),i.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const n=await this.g.getExtensionPathIndex();this.register(new l(this.c,n,this.d,p,this.i)),this.register(this.e.createInstance(v,n)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(E,n,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const n of p.nodeModuleName)this.a.set(n,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(n=>p.alternativeModuleName(n))}};r=qe([Ve(2,O.IInstantiationService),Ve(3,L.IExtHostConfiguration),Ve(4,w.IExtHostExtensionService),Ve(5,k.IExtHostInitDataService),Ve(6,b.ILogService)],r),e.RequireInterceptor=r;let o=class tn{constructor(p){if(p.environment.appRoot&&tn.a.size){const n=(0,f.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),d="[a-z0-9_.-]",t=`@${d}+\\/${d}+|${d}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${n}/${u}\\/)(${t})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const n=this.b.exec(this.c(p));if(!n)return;const[,d,t,u]=n,s=tn.a.get(t);if(s!==void 0)return console.warn(`${t} as been renamed to ${s}, please update your imports`),d+s+u}c(p){return p.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=qe([Ve(0,k.IExtHostInitDataService)],o);class l{constructor(p,n,d,t,u){this.c=p,this.d=n,this.e=d,this.f=t,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(p,n){const d=this.d.findSubstr(n);if(d){let t=this.a.get(R.ExtensionIdentifier.toKey(d.identifier));return t||(t=this.c(d,this.e,this.f),this.a.set(R.ExtensionIdentifier.toKey(d.identifier),t)),t}if(!this.b){let t="";this.d.forEach((u,s)=>t+=`	${s} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${t}`),this.b=this.c(I.nullExtensionDescription,this.e,this.f)}return this.b}}let v=class{constructor(p,n,d){this.d=p,this.nodeModuleName="keytar",this.a=n.getProxy(S.MainContext.MainThreadTelemetry);const{environment:t}=d,u=n.getProxy(S.MainContext.MainThreadKeytar);if(t.appRoot){let s=t.appRoot.fsPath;m.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.b=new Set,this.b.add(`${s}/node_modules.asar/keytar`),this.b.add(`${s}/node_modules/keytar`)}this.c={getPassword:(s,h)=>u.$getPassword(s,h),setPassword:(s,h,a)=>u.$setPassword(s,h,a),deletePassword:(s,h)=>u.$deletePassword(s,h),findPassword:s=>u.$findPassword(s),findCredentials(s){return u.$findCredentials(s)}}}load(p,n){const d=this.d.findSubstr(n);return this.a.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const n=p.length;if(n<=7||!this.b)return;const d=n-7;if((p.charAt(d)==="/"||p.charAt(d)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};v=qe([Ve(1,y.IExtHostRpcService),Ve(2,k.IExtHostInitDataService)],v);let E=class{constructor(p,n,d){this.e=p,this.f=n,this.nodeModuleName=["open","opn"],this.d=d.getProxy(S.MainContext.MainThreadTelemetry);const t=d.getProxy(S.MainContext.MainThreadWindow);this.c=(u,s)=>{const h=C.URI.parse(u);return s?this.g(u,s):h.scheme==="http"||h.scheme==="https"?t.$openUri(h,u,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?t.$openUri(h,u,{}):this.g(u,s)}}load(p,n,d){const t=this.e.findSubstr(n);return t&&(this.a=t.identifier.value,this.h()),this.b=d(p),this.c}g(p,n){return this.i(),this.b(p,n)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};E=qe([Ve(2,y.IExtHostRpcService)],E)}),define(Ie[107],Ce([1,0,211,6,19,49,3,57,58,33,7,31,185,32]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(l,v,E,P,p,n,d){function t(){if(E){const u=E.activeEditor();if(u)return u.document.uri;const s=P.tabGroups.all.find(h=>h.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof O.TextDiffTabInput||s.input instanceof O.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof O.TextTabInput||s.input instanceof O.NotebookEditorTabInput||s.input instanceof O.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:u=>{const s=n.folders.filter(h=>h.name===u);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(u,s)=>p.getConfiguration(void 0,u).get(s),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=t();if(u)return S.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const u=t();if(u){const s=v.getWorkspaceFolder(u);if(s)return S.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(E){const u=E.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(E){const u=E.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>l.getExtension(u)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(L.env))}}let r=class extends C.Disposable{constructor(l,v,E,P,p){super(),this.b=l,this.c=v,this.g=E,this.h=P,this.i=p,this.a=new i.Lazy(async()=>{const n=await this.h.getConfigProvider(),t={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{t.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.i,n,t,this.j())})}getResolver(){return this.a.getValue()}j(){}};r=qe([Ve(0,k.IExtHostExtensionService),Ve(1,w.IExtHostWorkspace),Ve(2,R.IExtHostDocumentsAndEditors),Ve(3,b.IExtHostConfiguration),Ve(4,y.IExtHostEditorTabs)],r),e.ExtHostVariableResolverProviderService=r}),define(Ie[108],Ce([1,0,12,4,9,2,3,5,58,33,17,7,31,177,179,32,107]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(t,u,s,h,a,c){this.D=u,this.E=s,this.F=h,this.G=a,this.H=c,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new C.Emitter,this.n=new C.Emitter,this.o=new C.Emitter,this.u=new C.Emitter,this.k=t.getProxy(R.MainContext.MainThreadDebugService),this.z=new C.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new E(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(g=>{g.onDidChange(A=>{this.I(g)}),this.I(g)})}asDebugSourceUri(t,u){const s=t;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let h=`debug:${encodeURIComponent(s.path||"")}`,a="?";return u&&(h+=`${a}session=${encodeURIComponent(u.id)}`,a="&"),h+=`${a}ref=${s.sourceReference}`,L.URI.parse(h)}else{if(s.path)return L.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(t){const u=[];for(const s of t.getAllExtensionDescriptions())if(s.contributes){const h=s.contributes.debuggers;if(h&&h.length>0)for(const a of h)(0,f.isDebuggerMainContribution)(a)&&u.push(a.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const t=[];return this.w.forEach(u=>t.push(u)),t}addBreakpoints(t){this.T();const u=t.filter(a=>{const c=a.id;return this.w.has(c)?!1:(this.w.set(c,a),!0)});this.U(u,[],[]);const s=[],h=new Map;for(const a of u)if(a instanceof w.SourceBreakpoint){let c=h.get(a.location.uri.toString());c||(c={type:"sourceMulti",uri:a.location.uri,lines:[]},h.set(a.location.uri.toString(),c),s.push(c)),c.lines.push({id:a.id,enabled:a.enabled,condition:a.condition,hitCondition:a.hitCondition,logMessage:a.logMessage,line:a.location.range.start.line,character:a.location.range.start.character})}else a instanceof w.FunctionBreakpoint&&s.push({type:"function",id:a.id,enabled:a.enabled,hitCondition:a.hitCondition,logMessage:a.logMessage,condition:a.condition,functionName:a.functionName});return this.k.$registerBreakpoints(s)}removeBreakpoints(t){this.T();const u=t.filter(c=>this.w.delete(c.id));this.U([],u,[]);const s=u.filter(c=>c instanceof w.SourceBreakpoint).map(c=>c.id),h=u.filter(c=>c instanceof w.FunctionBreakpoint).map(c=>c.id),a=u.filter(c=>c instanceof w.DataBreakpoint).map(c=>c.id);return this.k.$unregisterBreakpoints(s,h,a)}startDebugging(t,u,s){return this.k.$startDebugging(t?t.uri:void 0,u,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,suppressSaveBeforeStart:s.suppressSaveBeforeStart,suppressDebugStatusbar:s.suppressDebugStatusbar??s.debugUI?.simple,suppressDebugToolbar:s.suppressDebugToolbar??s.debugUI?.simple,suppressDebugView:s.suppressDebugView??s.debugUI?.simple})}stopDebugging(t){return this.k.$stopDebugging(t?t.id:void 0)}registerDebugConfigurationProvider(t,u,s){if(!u)return new w.Disposable(()=>{});const h=this.d++;return this.f.push({type:t,handle:h,provider:u}),this.k.$registerDebugConfigurationProvider(t,s,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,h),new w.Disposable(()=>{this.f=this.f.filter(a=>a.provider!==u),this.k.$unregisterDebugConfigurationProvider(h)})}registerDebugAdapterDescriptorFactory(t,u,s){if(!s)return new w.Disposable(()=>{});if(!this.P(t,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.M(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const h=this.g++;return this.h.push({type:u,handle:h,factory:s}),this.k.$registerDebugAdapterDescriptorFactory(u,h),new w.Disposable(()=>{this.h=this.h.filter(a=>a.factory!==s),this.k.$unregisterDebugAdapterDescriptorFactory(h)})}registerDebugAdapterTrackerFactory(t,u){if(!u)return new w.Disposable(()=>{});const s=this.i++;return this.j.push({type:t,handle:s,factory:u}),new w.Disposable(()=>{this.j=this.j.filter(h=>h.factory!==u)})}async $runInTerminal(t,u){return Promise.resolve(void 0)}async $substituteVariables(t,u){let s;const h=await this.W(t);return h&&(s={uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(s,u)}J(t,u){if(t.type==="implementation")return new p(t.implementation)}K(){}async $startDASession(t,u){const s=this,h=await this.V(u);return this.R(this.M(h.type),h).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}' (extension might have failed to activate)`);const c=this.L(a),g=this.J(c,h);if(!g)throw new Error(`Couldn't create a debug adapter for type '${h.type}'.`);const A=g;return this.A.set(t,A),this.Q(h).then(F=>(F&&this.B.set(t,F),A.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const te=j,x={type:"response",seq:0,command:te.command,request_seq:te.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const N=await this.C.sign(te.arguments.value);x.body={signature:N},A.sendResponse(x)}else throw new Error("no signer")}catch(N){x.success=!1,x.message=N.message,A.sendResponse(x)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(j),j=(0,f.convertToVSCPaths)(j,!0),s.k.$acceptDAMessage(t,j)}),A.onError(j=>{F&&F.onError&&F.onError(j),this.k.$acceptDAError(t,j.name,j.message,j.stack)}),A.onExit(j=>{F&&F.onExit&&F.onExit((0,S.withNullAsUndefined)(j),void 0),this.k.$acceptDAExit(t,(0,S.withNullAsUndefined)(j),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),A.startSession()))})}$sendDAMessage(t,u){u=(0,f.convertToDAPaths)(u,!1);const s=this.B.get(t);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(u),this.A.get(t)?.sendMessage(u)}$stopDASession(t){const u=this.B.get(t);this.B.delete(t),u&&u.onWillStopSession&&u.onWillStopSession();const s=this.A.get(t);return this.A.delete(t),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(t){const u=[],s=[],h=[];if(t.added)for(const a of t.added){const c=a.id;if(c&&!this.w.has(c)){let g;if(a.type==="function")g=new w.FunctionBreakpoint(a.functionName,a.enabled,a.condition,a.hitCondition,a.logMessage);else if(a.type==="data")g=new w.DataBreakpoint(a.label,a.dataId,a.canPersist,a.enabled,a.hitCondition,a.condition,a.logMessage);else{const A=L.URI.revive(a.uri);g=new w.SourceBreakpoint(new w.Location(A,new w.Position(a.line,a.character)),a.enabled,a.condition,a.hitCondition,a.logMessage)}(0,w.setBreakpointId)(g,c),this.w.set(c,g),u.push(g)}}if(t.removed)for(const a of t.removed){const c=this.w.get(a);c&&(this.w.delete(a),s.push(c))}if(t.changed){for(const a of t.changed)if(a.id){const c=this.w.get(a.id);if(c){if(c instanceof w.FunctionBreakpoint&&a.type==="function"){const g=c;g.enabled=a.enabled,g.condition=a.condition,g.hitCondition=a.hitCondition,g.logMessage=a.logMessage,g.functionName=a.functionName}else if(c instanceof w.SourceBreakpoint&&a.type==="source"){const g=c;g.enabled=a.enabled,g.condition=a.condition,g.hitCondition=a.hitCondition,g.logMessage=a.logMessage,g.location=new w.Location(L.URI.revive(a.uri),new w.Position(a.line,a.character))}h.push(c)}}}this.U(u,s,h)}$provideDebugConfigurations(t,u,s){return(0,i.asPromise)(async()=>{const h=this.O(t);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const a=await this.W(u);return h.provideDebugConfigurations(a,s)}).then(h=>{if(!h)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return h})}$resolveDebugConfiguration(t,u,s,h){return(0,i.asPromise)(async()=>{const a=this.O(t);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const c=await this.W(u);return a.resolveDebugConfiguration(c,s,h)})}$resolveDebugConfigurationWithSubstitutedVariables(t,u,s,h){return(0,i.asPromise)(async()=>{const a=this.O(t);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const c=await this.W(u);return a.resolveDebugConfigurationWithSubstitutedVariables(c,s,h)})}async $provideDebugAdapter(t,u){const s=this.N(t);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const h=await this.V(u);return this.R(s,h).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${h.type}'`);return this.L(a)})}async $acceptDebugSessionStarted(t){const u=await this.V(t);this.m.fire(u)}async $acceptDebugSessionTerminated(t){const u=await this.V(t);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(t){this.q=t?await this.V(t):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(t,u){(await this.V(t))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(t,u){const h={session:await this.V(t),event:u.event,body:u.body};this.u.fire(h)}L(t){if(t instanceof w.DebugAdapterExecutable)return{type:"executable",command:t.command,args:t.args,options:t.options};if(t instanceof w.DebugAdapterServer)return{type:"server",port:t.port,host:t.host};if(t instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:t.path};if(t instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:t.implementation};throw new Error("convertToDto unexpected type")}M(t){const u=this.h.filter(s=>s.type===t);if(u.length>0)return u[0].factory}N(t){const u=this.h.filter(s=>s.handle===t);if(u.length>0)return u[0].factory}O(t){const u=this.f.filter(s=>s.handle===t);if(u.length>0)return u[0].provider}P(t,u){if(t.contributes){const s=t.contributes.debuggers;if(s&&s.length>0){for(const h of s)if(h.label&&h.type&&h.type===u)return!0}}return!1}Q(t){const s=t.configuration.type,h=this.j.filter(a=>a.type===s||a.type==="*").map(a=>(0,i.asPromise)(()=>a.factory.createDebugAdapterTracker(t)).then(c=>c,c=>null));return Promise.race([Promise.all(h).then(a=>{const c=a.filter(g=>!!g);if(c.length>0)return new P(c)}),new Promise(a=>setTimeout(()=>a(void 0),1e3))]).catch(a=>{})}async R(t,u){const s=u.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new w.DebugAdapterServer(s));if(t){const a=await this.E.getExtensionRegistry();return(0,i.asPromise)(()=>t.createDebugAdapterDescriptor(u,this.S(u,a))).then(c=>{if(c)return c})}const h=await this.E.getExtensionRegistry();return Promise.resolve(this.S(u,h))}S(t,u){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(t,u,s){(t.length>0||u.length>0||s.length>0)&&this.z.fire(Object.freeze({added:t,removed:u,changed:s}))}async V(t){if(t)if(typeof t=="string"){const u=this.l.get(t);if(u)return u}else{let u=this.l.get(t.id);if(!u){const s=await this.W(t.folderUri),h=t.parent?this.l.get(t.parent):void 0;u=new v(this.k,t.id,t.type,t.name,s,t.configuration,h),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(t){if(t){const u=L.URI.revive(t);return this.D.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};l=qe([Ve(0,O.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,r.IExtHostConfiguration),Ve(4,y.IExtHostEditorTabs),Ve(5,o.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class v{constructor(t,u,s,h,a,c,g){this.d=t,this.f=u,this.g=s,this.h=h,this.i=a,this.j=c,this.k=g}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(t){this.h=t,this.d.$setDebugSessionName(this.f,t)}get parentSession(){return this.k}_acceptNameChanged(t){this.h=t}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(t,u){return this.d.$customDebugAdapterRequest(this.f,t,u)}getDebugProtocolBreakpoint(t){return this.d.$getDebugProtocolBreakpoint(this.f,t.id)}}e.ExtHostDebugSession=v;class E{constructor(t){this.value=Object.freeze({append(u){t.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=E;class P{constructor(t){this.d=t}onWillStartSession(){this.d.forEach(t=>t.onWillStartSession?t.onWillStartSession():void 0)}onWillReceiveMessage(t){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(t):void 0)}onDidSendMessage(t){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(t):void 0)}onWillStopSession(){this.d.forEach(t=>t.onWillStopSession?t.onWillStopSession():void 0)}onError(t){this.d.forEach(u=>u.onError?u.onError(t):void 0)}onExit(t,u){this.d.forEach(s=>s.onExit?s.onExit(t,u):void 0)}}class p extends b.AbstractDebugAdapter{constructor(t){super(),this.h=t,t.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(t){this.h.handleMessage(t)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let n=class extends l{constructor(t,u,s,h,a,c){super(t,u,s,h,a,c)}};n=qe([Ve(0,O.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,r.IExtHostConfiguration),Ve(4,y.IExtHostEditorTabs),Ve(5,o.IExtHostVariableResolverProvider)],n),e.WorkerExtHostDebugService=n}),define(Ie[246],Ce([1,0,11,82,2,5,237,13,66,67,27,157,17,54,33,74]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(E){const P=E.get(R.ILogService),n=E.get(m.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(d=>{P.error(d);const t=i.transformErrorForSerialization(d);n.$onUnexpectedError(t)})}static async installFullHandler(E){const P=E.get(R.ILogService),p=E.get(m.IExtHostRpcService),n=E.get(f.IExtHostExtensionService),d=E.get(r.IExtHostTelemetry),t=p.getProxy(L.MainContext.MainThreadExtensionService),u=p.getProxy(L.MainContext.MainThreadErrors),s=await n.getExtensionPathIndex(),h=new WeakMap;Error.prepareStackTrace=(a,c)=>{let g="",A,F;for(const j of c)g+=`
	at ${j.toString()}`,F=j.getFileName(),!A&&F&&(A=s.findSubstr(S.URI.file(F)));return h.set(a,A?.identifier),`${a.name||"Error"}: ${a.message||""}${g}`},i.setUnexpectedErrorHandler(a=>{P.error(a);const c=i.transformErrorForSerialization(a),g=h.get(a);if(!g){u.$onUnexpectedError(c);return}t.$onExtensionRuntimeError(g,c);const A=d.onExtensionError(g,a);P.trace("forwarded error to extension?",A,g)})}}Error.stackTraceLimit=100;class l{constructor(E,P,p,n,d){this.a=p,this.b=new I.RPCProtocol(E,null,n),P=l.e(P,this.b);const t=new k.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());t.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...P,messagePorts:d}),t.set(m.IExtHostRpcService,new m.ExtHostRpcService(this.b)),t.set(b.IURITransformerService,new b.URITransformerService(n)),t.set(f.IHostUtils,p);const u=new w.InstantiationService(t,!0);u.invokeFunction(o.installEarlyHandler),this.d=u.invokeFunction(s=>s.get(R.ILogService)),C.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",P),this.c=u.invokeFunction(s=>s.get(f.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(o.installFullHandler)}async asBrowserUri(E){const P=this.b.getProxy(L.MainContext.MainThreadExtensionService);return S.URI.revive(await P.$asBrowserUri(E))}terminate(E){this.c.terminate(E)}static e(E,P){E.allExtensions.forEach(n=>{n.extensionLocation=S.URI.revive(P.transformIncomingURIs(n.extensionLocation));const d={};n.browserNlsBundleUris&&(Object.keys(n.browserNlsBundleUris).forEach(t=>d[t]=S.URI.revive(P.transformIncomingURIs(n.browserNlsBundleUris[t]))),n.browserNlsBundleUris=d)}),E.environment.appRoot=S.URI.revive(P.transformIncomingURIs(E.environment.appRoot));const p=E.environment.extensionDevelopmentLocationURI;return p&&(E.environment.extensionDevelopmentLocationURI=p.map(n=>S.URI.revive(P.transformIncomingURIs(n)))),E.environment.extensionTestsLocationURI=S.URI.revive(P.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=S.URI.revive(P.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=S.URI.revive(P.transformIncomingURIs(E.environment.workspaceStorageHome)),E.environment.extensionTelemetryLogResource=S.URI.revive(P.transformIncomingURIs(E.environment.extensionTelemetryLogResource)),E.nlsBaseUrl=S.URI.revive(P.transformIncomingURIs(E.nlsBaseUrl)),E.logsLocation=S.URI.revive(P.transformIncomingURIs(E.logsLocation)),E.logFile=S.URI.revive(P.transformIncomingURIs(E.logFile)),E.workspace=P.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=l}),define(Ie[247],Ce([1,0,18,12,21,39,16,19,23,2,45]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(v,E,P,p){this.d=v,this.e=E,this.f=P,this.g=p,this.a=null,this.b=!1,this.c=0}search(v,E){const P=this.d.folderQueries||[],p=new S.CancellationTokenSource;return E.onCancellationRequested(()=>p.cancel()),new Promise((n,d)=>{this.a=new b(v);let t=!1;const u=(s,h)=>{if(!t&&!this.b){const a=this.h(s);r(s)&&typeof this.d.maxResults=="number"&&this.c+a>this.d.maxResults&&(this.b=!0,t=!0,p.cancel(),s=this.j(s,this.d.maxResults-this.c));const c=this.h(s);this.c+=c,(c>0||!r(s))&&this.a.add(s,h)}};Promise.all(P.map((s,h)=>this.k(s,a=>u(a,h),p.token))).then(s=>{p.dispose(),this.a.flush();const h=s.some(a=>!!a&&!!a.limitHit);n({limitHit:this.b||h,messages:(0,i.flatten)(s.map(a=>a?.message?Array.isArray(a.message)?a.message:[a.message]:[])),stats:{type:this.g}})},s=>{p.dispose();const h=(0,L.toErrorMessage)(s);d(new Error(h))})})}h(v){return r(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}j(v,E){const P=Array.isArray(v.ranges)?v.ranges:[v.ranges],p=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:P.slice(0,E),preview:{matches:p.slice(0,E),text:v.preview.text},uri:v.uri}}async k(v,E,P){const p=new O.QueryGlobTester(this.d,v),n=[],d={report:s=>{if(!this.l(s))return;const h=v.folder.scheme===I.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(s.uri))):void 0,a=y.relativePath(v.folder,s.uri);if(a){const c=p.includedInQuery(a,R.basename(a),h);(0,C.isThenable)(c)?n.push(c.then(g=>{g&&E(s)})):c&&E(s)}}},t=this.n(v),u=await this.e.provideTextSearchResults(m(this.d.contentPattern),t,d,P);return n.length&&await Promise.all(n),u}l(v){if(r(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(v){const E=(0,O.resolvePatternsForProvider)(this.d.includePattern,v.includePattern),P=(0,O.resolvePatternsForProvider)(this.d.excludePattern,v.excludePattern),p={folder:k.URI.from(v.folder),excludes:P,includes:E,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.f.toCanonicalName(v.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=w;function m(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class b{constructor(v){this.e=v,this.b=-1,this.d=null,this.a=new o(512,E=>this.g(E))}add(v,E){this.d&&(this.b!==E||!y.isEqual(this.c,v.uri))&&(this.f(),this.d=null),this.d||(this.b=E,this.d={resource:v.uri,results:[]}),this.d.results.push(f(v))}f(){const v=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,v)}flush(){this.f(),this.a.flush()}g(v){this.e(v)}}e.TextSearchResultsCollector=b;function f(l){return r(l)?{preview:{matches:(0,i.mapArrayOrNot)(l.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:l.preview.text},ranges:(0,i.mapArrayOrNot)(l.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function r(l){return!!l.preview}e.extensionResultIsMatch=r;class o{constructor(v,E){this.g=v,this.h=E,this.c=0,this.d=[],this.e=0}addItem(v,E){!v||this.j(v,E)}addItems(v,E){!v||this.k(v,E)}j(v,E){this.d.push(v),this.e+=E,this.l()}k(v,E){this.d=this.d.concat(v),this.e+=E,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=o,o.a=4e3,o.b=50}),define(Ie[109],Ce([1,0,6,5,3,242,17,54,13,2,247]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let w=class{constructor(r,o,l){this.k=r,this.l=o,this.n=l,this.c=this.k.getProxy(C.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.FileSearchManager}o(r){return this.l.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const l=this.d++;return this.e.set(l,o),this.c.$registerTextSearchProvider(l,this.o(r)),(0,i.toDisposable)(()=>{this.g.delete(r),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(r,o){if(this.i.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.i.add(r);const l=this.d++;return this.h.set(l,o),this.c.$registerFileSearchProvider(l,this.o(r)),(0,i.toDisposable)(()=>{this.i.delete(r),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(r,o,l,v){const E=m(l),P=this.h.get(r);if(P)return this.j.fileSearch(E,P,p=>{this.c.$handleFileMatch(r,o,p.map(n=>n.resource))},v);throw new Error("unknown provider: "+r)}$clearCache(r){return this.j.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,l,v){const E=this.e.get(r);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${r}`);const P=m(l);return this.q(P,E).search(n=>this.c.$handleTextMatch(r,o,n),v)}$enableExtensionHostSearch(){}q(r,o){return new O.TextSearchManager(r,o,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};w=qe([Ve(0,I.IExtHostRpcService),Ve(1,R.IURITransformerService),Ve(2,y.ILogService)],w),e.ExtHostSearch=w;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(r=>k.URI.revive(r))}}e.reviveQuery=m;function b(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Ie[248],Ce([1,0,66,104,31,102,32,38,57,60,106,108,109,80,69,76,103,59,37,79,74,58,218,13,189,107,78]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o,l,v,E,P,p,n,d,t,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,i.registerSingleton)(d.ILoggerService,n.ExtHostLoggerService,1),(0,i.registerSingleton)(d.ILogService,t.ExtHostLogService,1),(0,i.registerSingleton)(r.IExtHostApiDeprecationService,r.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,i.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration,0),(0,i.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,0),(0,i.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,i.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService,1),(0,i.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,i.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage,0),(0,i.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,i.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,0),(0,i.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,i.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace,0),(0,i.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,0),(0,i.registerSingleton)(P.IExtHostTelemetry,P.ExtHostTelemetry,0),(0,i.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,i.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(Ie[249],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(S){if(S&&this.a.has(S)){const L=this.a.get(S);return this.a.delete(S),L}}addDragOperationTransfer(S,L){this.a.set(S,L)}getRenderedTreeElement(S){if(this.b.has(S))return this.b.get(S)}addRenderedTreeItemElement(S,L){this.b.set(S,L)}removeRenderedTreeItemElement(S){this.b.has(S)&&this.b.delete(S)}}e.TreeviewsService=i}),define(Ie[250],Ce([1,0,142,7,23,2,4,6,176,12,7,9,18,8,21,249,24]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(P,p){if((0,w.isString)(P))return{label:P};if(P&&typeof P=="object"&&typeof P.label=="string"){let n;return Array.isArray(P.highlights)&&(n=P.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),n=n.length?n:void 0),{label:P.label,highlights:n}}}class v{constructor(p,n,d){this.d=p,this.e=n,this.f=d,this.a=new Map,this.b=new r.TreeviewsService;function t(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:u=>t(u)?this.i(u):Array.isArray(u)&&u.length>0?u.map(s=>t(s)?this.i(s):s):u})}registerTreeDataProvider(p,n,d){const t=this.createTreeView(p,{treeDataProvider:n},d);return{dispose:()=>t.dispose()}}createTreeView(p,n,d){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=n.dragAndDropController?.dropMimeTypes??[],u=n.dragAndDropController?.dragMimeTypes??[],s=!!n.dragAndDropController?.handleDrag,h=!!n.dragAndDropController?.handleDrop,a=this.h(p,n,d),c=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:t,dragMimeTypes:u,hasHandleDrag:s,hasHandleDrop:h});return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,o.checkProposedApiEnabled)(d,"treeItemCheckbox"),a.onDidChangeCheckboxState},get message(){return a.message},set message(g){a.message=g},get title(){return a.title},set title(g){a.title=g},get description(){return a.description},set description(g){a.description=g},get badge(){return a.badge},set badge(g){g!==void 0&&O.ViewBadge.isViewBadge(g)?a.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(a.badge=void 0)},reveal:(g,A)=>a.reveal(g,A),dispose:async()=>{await c,this.a.delete(p),a.dispose()}}}$getChildren(p,n){const d=this.a.get(p);return d?d.getChildren(n):Promise.reject(new y.NoTreeViewError(p))}async $handleDrop(p,n,d,t,u,s,h,a){const c=this.a.get(p);if(!c)return Promise.reject(new y.NoTreeViewError(p));const g=b.DataTransfer.toDataTransfer(d,async A=>(await this.d.$resolveDropFileData(p,n,A)).buffer);return h===p&&a&&await this.g(g,c,a,u,s),c.onDrop(g,t,u)}async g(p,n,d,t,u){const s=this.b.removeDragOperationTransfer(u);if(s)(await s)?.forEach((h,a)=>{h&&p.set(a,h)});else if(u&&n.handleDrag){const h=n.handleDrag(d,p,t);this.b.addDragOperationTransfer(u,h),await h}return p}async $handleDrag(p,n,d,t){const u=this.a.get(p);if(!u)return Promise.reject(new y.NoTreeViewError(p));const s=await this.g(new C.DataTransfer,u,n,t,d);if(!!s)return b.DataTransfer.toDataTransferDTO(s)}async $hasResolve(p){const n=this.a.get(p);if(!n)throw new y.NoTreeViewError(p);return n.hasResolve}$resolve(p,n,d){const t=this.a.get(p);if(!t)throw new y.NoTreeViewError(p);return t.resolveTreeItem(n,d)}$setExpanded(p,n,d){const t=this.a.get(p);if(!t)throw new y.NoTreeViewError(p);t.setExpanded(n,d)}$setSelection(p,n){const d=this.a.get(p);if(!d)throw new y.NoTreeViewError(p);d.setSelection(n)}$setFocus(p,n){const d=this.a.get(p);if(!d)throw new y.NoTreeViewError(p);d.setFocus(n)}$setVisible(p,n){const d=this.a.get(p);if(!d)throw new y.NoTreeViewError(p);d.setVisible(n)}$changeCheckboxState(p,n){const d=this.a.get(p);if(!d)throw new y.NoTreeViewError(p);d.setCheckboxState(n)}h(p,n,d){const t=new E(p,n,this.d,this.e.converter,this.f,d);return this.a.set(p,t),t}i(p){const n=this.a.get(p.$treeViewId);return n&&"$treeItemHandle"in p?n.getExtensionElement(p.$treeItemHandle):n&&"$focusedTreeItem"in p&&p.$focusedTreeItem?n.focusedElement:null}}e.ExtHostTreeViews=v;class E extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,w.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,n,d,t,u,s){if(super(),this.C=p,this.D=d,this.F=t,this.G=u,this.H=s,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new I.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new I.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new I.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new I.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new I.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new I.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new f.CancellationTokenSource,s.contributes&&s.contributes.views)for(const c in s.contributes.views)for(const g of s.contributes.views[c])g.id===p&&(this.J=g.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(c=>this.w.fire({message:!1,element:c})));let h,a;this.B(I.Event.debounce(this.w.event,(c,g)=>(c||(c={message:!1,elements:[]}),g.element!==!1&&(h||(h=new Promise(A=>a=A),this.y=this.y.then(()=>h)),Array.isArray(g.element)?c.elements.push(...g.element):c.elements.push(g.element)),g.message&&(c.message=!0),c),200,!0)(({message:c,elements:g})=>{g.length&&(this.z=this.z.then(()=>{const A=a;return h=null,this.U(g).then(()=>A())})),c&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const n=p?this.getExtensionElement(p):void 0;if(p&&!n)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let d=this.Q(p);return d||(d=await this.R(n)),d?d.map(t=>t.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,n){n=n||{select:!0,focus:!1};const d=(0,w.isUndefinedOrNull)(n.select)?!0:n.select,t=(0,w.isUndefinedOrNull)(n.focus)?!1:n.focus,u=(0,w.isUndefinedOrNull)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(s=>this.P(p,s[s.length-1]).then(h=>this.D.$reveal(this.C,{item:h.item,parentChain:s.map(a=>a.item)},{select:d,focus:t,expand:u})),s=>this.G.error(s)):this.D.$reveal(this.C,void 0,{select:d,focus:t,expand:u})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=b.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,n){const d=this.getExtensionElement(p);d&&(n?this.r.fire(Object.freeze({element:d})):this.s.fire(Object.freeze({element:d})))}setSelection(p){(0,m.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const n=(await Promise.all(p.map(async d=>{const t=this.getExtensionElement(d.treeItemHandle);return t?{extensionItem:t,treeItem:await this.f.getTreeItem(t),newState:d.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);n.forEach(d=>{d.treeItem.checkboxState=d.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.v.fire({items:n.map(d=>[d.extensionItem,d.newState])})}async handleDrag(p,n,d){const t=[];for(const u of p){const s=this.getExtensionElement(u);s&&t.push(s)}if(!(!this.g?.handleDrag||t.length===0))return await this.g.handleDrag(t,n,d),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,n,d){const t=n?this.getExtensionElement(n):void 0;if(!(!t&&n||!this.g?.handleDrop))return(0,k.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(t,p,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,n){if(!this.f.resolveTreeItem)return;const d=this.i.get(p);if(d){const t=this.j.get(d);if(t){const u=await this.f.resolveTreeItem(t.extensionItem,d,n)??t.extensionItem;return this.db(u),t.item.tooltip=this.ab(u.tooltip),t.item.command=this.bb(t.disposableStore,u.command),t.item}}}N(p){return this.O(p).then(n=>n?this.N(n).then(d=>this.P(n,d[d.length-1]).then(t=>(d.push(t),d))):Promise.resolve([]))}O(p){const n=this.j.get(p);return n?Promise.resolve(n.parent?this.i.get(n.parent.item.handle):void 0):(0,k.asPromise)(()=>this.f.getParent(p))}P(p,n){const d=this.j.get(p);return d?Promise.resolve(d):(0,k.asPromise)(()=>this.f.getTreeItem(p)).then(t=>this.gb(p,t,n,!0)).then(t=>this.getChildren(n?n.item.handle:void 0).then(()=>{const u=this.getExtensionElement(t);if(u){const s=this.j.get(u);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${t}`)}))}Q(p){if(p){let n;if(typeof p=="string"){const d=this.getExtensionElement(p);n=d?this.j.get(d):void 0}else n=p;return n&&n.children||void 0}return this.h}async R(p){this.nb(p);const n=new f.CancellationTokenSource(this.S.token);try{const d=p?this.j.get(p):void 0,t=await this.f.getChildren(p);if(n.token.isCancellationRequested)return;const u=await Promise.all((0,m.coalesce)(t||[]).map(async s=>{const h=await this.f.getTreeItem(s);return h&&!n.token.isCancellationRequested?this.Z(s,h,d):null}));return n.token.isCancellationRequested?void 0:(0,m.coalesce)(u)}finally{n.dispose()}}U(p){if(p.some(d=>!d))return this.S.dispose(!0),this.S=new f.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const d=this.W(p);if(d.length)return this.X(d)}return Promise.resolve(void 0)}W(p){const n=new Set,d=p.map(u=>this.j.get(u));for(const u of d)if(u&&!n.has(u.item.handle)){let s=u;for(;s&&s.parent&&d.findIndex(h=>s&&s.parent&&h&&h.item.handle===s.parent.item.handle)===-1;){const h=this.i.get(s.parent.item.handle);s=h?this.j.get(h):void 0}s&&!s.parent&&n.add(u.item.handle)}const t=[];return n.forEach(u=>{const s=this.i.get(u);if(s){const h=this.j.get(s);h&&(!h.parent||!n.has(h.parent.item.handle))&&t.push(u)}}),t}X(p){const n={};return Promise.all(p.map(d=>this.Y(d).then(t=>{t&&(n[d]=t.item)}))).then(()=>Object.keys(n).length?this.D.$refresh(this.C,n):void 0)}Y(p){const n=this.getExtensionElement(p);if(n){const d=this.j.get(n);if(d)return this.nb(n),(0,k.asPromise)(()=>this.f.getTreeItem(n)).then(t=>{if(t){const u=this.eb(n,t,d.parent);return this.lb(n,u,d,d.parent),d.dispose(),u}return null})}return Promise.resolve(null)}Z(p,n,d){const t=this.eb(p,n,d);if(n.id&&this.i.has(t.item.handle))throw new Error((0,i.localize)(0,null,n.id));return this.kb(p,t),this.mb(t,d),t}ab(p){return O.MarkdownString.isMarkdownString(p)?b.MarkdownString.from(p):p}bb(p,n){return n?{...this.F.toInternal(n,p),originalId:n.command}:void 0}cb(p){if(!p.checkboxState)return;let n,d;return typeof p.checkboxState=="number"?n=p.checkboxState:(n=p.checkboxState.state,d=p.checkboxState.tooltip),{isChecked:n===O.TreeItemCheckboxState.Checked,tooltip:d}}db(p){if(!O.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,n,d){this.db(n);const t=new R.DisposableStore,u=this.gb(p,n,d),s=this.hb(n);return{item:{handle:u,parentHandle:d?d.item.handle:void 0,label:l(n.label,this.H),description:n.description,resourceUri:n.resourceUri,tooltip:this.ab(n.tooltip),command:this.bb(t,n.command),contextValue:n.contextValue,icon:s,iconDark:this.ib(n)||s,themeIcon:this.fb(n),collapsibleState:(0,w.isUndefinedOrNull)(n.collapsibleState)?O.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.cb(n)},extensionItem:n,parent:d,children:void 0,disposableStore:t,dispose(){t.dispose()}}}fb(p){return p.iconPath instanceof O.ThemeIcon?p.iconPath:void 0}gb(p,{id:n,label:d,resourceUri:t},u,s){if(n)return`${E.b}/${n}`;const h=l(d,this.H),a=u?u.item.handle:E.a;let c=h?h.label:t?(0,S.basename)(t):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const g=this.j.has(p)?this.j.get(p).item.handle:void 0,A=this.Q(u)||[];let F,j=0;do{if(F=`${a}/${j}:${c}`,s||!this.i.has(F)||g===F)break;j++}while(j<=A.length);return F}hb(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon))return typeof p.iconPath=="string"||L.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return L.URI.isUri(p)?p:L.URI.file(p)}kb(p,n){this.i.set(n.item.handle,p),this.j.set(p,n)}lb(p,n,d,t){this.i.delete(n.item.handle),this.j.delete(p),n.item.handle!==d.item.handle&&this.i.delete(d.item.handle),this.kb(p,n);const u=this.Q(t)||[],s=u.filter(h=>h.item.handle===d.item.handle)[0];s&&u.splice(u.indexOf(s),1,n)}mb(p,n){n?(n.children||(n.children=[]),n.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const n=this.j.get(p);if(n){if(n.children)for(const d of n.children){const t=this.i.get(d.item.handle);t&&this.ob(t)}n.children=void 0}}else this.pb()}ob(p){const n=this.j.get(p);if(n){if(n.children)for(const d of n.children){const t=this.i.get(d.item.handle);t&&this.ob(t)}this.j.delete(p),this.i.delete(n.item.handle),n.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}E.a="0",E.b="1"}),define(Ie[251],Ce([1,0,21,11,4,30,2,128,260,116,126,36,5,73,204,203,38,205,32,207,208,209,192,210,57,33,212,213,216,217,219,104,195,224,225,226,80,60,229,250,8,7,50,232,61,103,31,183,215,48,102,106,108,109,13,54,17,27,220,190,69,76,201,230,81,59,235,233,234,202,37,227,231,79,58,74,221,105,222,16,91,194,173,214,6,24,178,78,170,223]),function(ee,e,i,C,S,L,I,R,y,k,O,w,m,b,f,r,o,l,v,E,P,p,n,d,t,u,s,h,a,c,g,A,F,j,te,x,N,$,T,M,V,q,le,_,pe,ue,de,re,G,H,oe,ve,Ae,Be,xe,Te,Se,ke,se,ce,J,D,B,W,K,Z,he,ye,ae,be,Ee,We,He,tt,Xe,et,it,dt,Fe,st,Y,Q,ge,Me,$e,je,Ye,nt,wt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ct(lt){const at=lt.get(ke.IExtHostInitDataService),Bt=lt.get(Ee.IExtHostFileSystemInfo),Ot=lt.get(Z.IExtHostConsumerFileSystem),Ft=lt.get(u.IExtHostExtensionService),ft=lt.get(de.IExtHostWorkspace),Dt=lt.get(et.IExtHostTelemetry),$t=lt.get(v.IExtHostConfiguration),Nt=lt.get(Te.IURITransformerService),Ge=lt.get(Se.IExtHostRpcService),Mt=lt.get(N.IExtHostStorage),Lt=lt.get(K.IExtensionStoragePaths),Ut=lt.get(xe.ILoggerService),gt=lt.get(xe.ILogService),kt=lt.get(J.IExtHostTunnelService),De=lt.get(D.IExtHostApiDeprecationService),Pe=lt.get(ue.IExtHostWindow),me=lt.get(tt.IExtHostSecretState),X=lt.get(Xe.IExtHostEditorTabs);Ge.set(m.ExtHostContext.ExtHostFileSystemInfo,Bt),Ge.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ut),Ge.set(m.ExtHostContext.ExtHostWorkspace,ft),Ge.set(m.ExtHostContext.ExtHostConfiguration,$t),Ge.set(m.ExtHostContext.ExtHostExtensionService,Ft),Ge.set(m.ExtHostContext.ExtHostStorage,Mt),Ge.set(m.ExtHostContext.ExtHostTunnelService,kt),Ge.set(m.ExtHostContext.ExtHostWindow,Pe),Ge.set(m.ExtHostContext.ExtHostSecretState,me),Ge.set(m.ExtHostContext.ExtHostTelemetry,Dt),Ge.set(m.ExtHostContext.ExtHostEditorTabs,X);const Re=Ge.set(m.ExtHostContext.ExtHostDecorations,lt.get(oe.IExtHostDecorations)),Le=Ge.set(m.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(t.IExtHostDocumentsAndEditors)),Qe=Ge.set(m.ExtHostContext.ExtHostCommands,lt.get(o.IExtHostCommands)),ze=Ge.set(m.ExtHostContext.ExtHostTerminalService,lt.get($.IExtHostTerminalService)),Ze=Ge.set(m.ExtHostContext.ExtHostDebugService,lt.get(Ae.IExtHostDebugService)),bt=Ge.set(m.ExtHostContext.ExtHostSearch,lt.get(Be.IExtHostSearch)),vt=Ge.set(m.ExtHostContext.ExtHostTask,lt.get(ve.IExtHostTask)),At=Ge.set(m.ExtHostContext.ExtHostOutputService,lt.get(A.IExtHostOutputService)),pt=Ge.set(m.ExtHostContext.ExtHostLocalization,lt.get(nt.IExtHostLocalizationService)),It=Ge.set(m.ExtHostContext.ExtHostUrls,new _.ExtHostUrls(Ge)),ht=Ge.set(m.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Ge,Le)),Kt=Ge.set(m.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ge,Le,gt)),Vt=Ge.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(gt,ht,Ge.getProxy(m.MainContext.MainThreadBulkEdits))),Et=Ge.set(m.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Ge,Qe,Le,ht)),Qt=Ge.set(m.ExtHostContext.ExtHostNotebookDocuments,new ge.ExtHostNotebookDocuments(Et)),ri=Ge.set(m.ExtHostContext.ExtHostNotebookEditors,new Q.ExtHostNotebookEditors(gt,Et)),ei=Ge.set(m.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,at,Et,Qe,gt)),bi=Ge.set(m.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ge,Et)),Tt=Ge.set(m.ExtHostContext.ExtHostEditors,new T.ExtHostEditors(Ge,Le)),si=Ge.set(m.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(Ge.getProxy(m.MainContext.MainThreadTreeViews),Qe,gt)),jt=Ge.set(m.ExtHostContext.ExtHostEditorInsets,new re.ExtHostEditorInsets(Ge.getProxy(m.MainContext.MainThreadEditorInsets),Tt,at.remote)),ti=Ge.set(m.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ge,gt,Bt,Le)),oi=Ge.set(m.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(Ge,ht,Qe.converter,Nt)),ct=Ge.set(m.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(Ge,Nt,ht,Qe,ti,gt,De,Dt)),Oi=Ge.set(m.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Ge,ct)),Yt=Ge.set(m.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(Ge,gt,Le)),Wt=Ge.set(m.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(Ge,ft,Qe)),ai=Ge.set(m.ExtHostContext.ExtHostSCM,new te.ExtHostSCM(Ge,Qe,gt)),Ei=Ge.set(m.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ge,Qe,ht)),ci=Ge.set(m.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(Ge.getProxy(m.MainContext.MainThreadProgress))),wi=Ge.set(m.ExtHostContext.ExtHosLabelService,new G.ExtHostLabelService(Ge)),ui=Ge.set(m.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Ge)),ii=Ge.set(m.ExtHostContext.ExtHostAuthentication,new B.ExtHostAuthentication(Ge)),Si=Ge.set(m.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(Ge,Qe)),ni=Ge.set(m.ExtHostContext.ExtHostWebviews,new pe.ExtHostWebviews(Ge,at.remote,ft,gt,De)),yi=Ge.set(m.ExtHostContext.ExtHostWebviewPanels,new ae.ExtHostWebviewPanels(Ge,ni,ft)),Di=Ge.set(m.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Ge,ht,Lt,ni,yi)),Ii=Ge.set(m.ExtHostContext.ExtHostWebviewViews,new he.ExtHostWebviewViews(Ge,ni)),_t=Ge.set(m.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Ge,Qe,Le)),Ci=Ge.set(m.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ge)),$i=Ge.set(m.ExtHostContext.ExtHostProfileContentHandlers,new St.ExtHostProfileContentHandlers(Ge));Ge.set(m.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ge,Et,Le,Qe,gt));const ki=Object.values(m.ExtHostContext);Ge.assertRegistered(ki);const Ti=new be.ExtHostBulkEdits(Ge,Le),zi=new r.ExtHostClipboard(Ge),Pi=new g.ExtHostMessageService(Ge,gt),Fi=new P.ExtHostDialogs(Ge),Ni=new x.ExtHostStatusBar(Ge,Qe.converter);return f.ExtHostApiCommands.register(Qe),function(Ue,Gt,li){const mt=function(){let ne=!Ue.isUnderDevelopment;function fe(){ne||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ne(rt){if(Array.isArray(rt))rt.forEach(Ne);else if(typeof rt=="string")fe();else{const yt=rt;typeof yt.scheme>"u"&&fe(),typeof yt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return rt}}(),Wi={getSession(ne,fe,Ne){return ii.getSession(Ue,ne,fe,Ne)},async hasSession(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"authSession"),!!await ii.getSession(Ue,ne,fe,{silent:!0})},get onDidChangeSessions(){return ii.onDidChangeSessions},registerAuthenticationProvider(ne,fe,Ne,rt){return ii.registerAuthenticationProvider(ne,fe,Ne,rt)}},Hi={registerCommand(ne,fe,Ne){return Qe.registerCommand(!0,ne,fe,Ne,void 0,Ue)},registerTextEditorCommand(ne,fe,Ne){return Qe.registerCommand(!0,ne,(...rt)=>{const yt=Tt.getActiveTextEditor();if(!yt){gt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return yt.edit(Pt=>{fe.apply(Ne,[yt,Pt,...rt])}).then(Pt=>{Pt||gt.warn("Edits from command "+ne+" were not applied.")},Pt=>{gt.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,fe,Ne)=>((0,je.checkProposedApiEnabled)(Ue,"diffCommand"),Qe.registerCommand(!0,ne,async(...rt)=>{const yt=Le.activeEditor(!0);if(!yt){gt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await Tt.getDiffInformation(yt.id);fe.apply(Ne,[Pt,...rt])},void 0,void 0,Ue)),executeCommand(ne,...fe){return Qe.executeCommand(ne,...fe)},getCommands(ne=!1){return Qe.getCommands(ne)}},Mi={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return zi.value},get shell(){return ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(Ue,"envShellEvent"),ze.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(at.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,je.checkProposedApiEnabled)(Ue,"telemetryLogger"),Dt.instantiateLogger(Ue,ne)},openExternal(ne,fe){return Pe.openUri(ne,{allowTunneling:!!at.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===at.environment.appUriScheme)return It.createAppUri(ne);try{return await Pe.asExternalUri(ne,{allowTunneling:!!at.remote.authority})}catch(fe){if((0,Y.matchesScheme)(ne,st.Schemas.http)||(0,Y.matchesScheme)(ne,st.Schemas.https))return ne;throw fe}},get remoteName(){return(0,H.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Ue,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return gt.onDidChangeLogLevel}};at.environment.extensionTestsLocationURI||Object.freeze(Mi);const di={createTestController(ne,fe,Ne){return _t.createTestController(Ue,ne,fe,Ne)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.createTestObserver()},runTests(ne){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.runTests(ne)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.results}},hi=at.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,Vi={getExtension(ne,fe){(0,je.isProposedApiEnabled)(Ue,"extensionsAny")||(fe=!1);const Ne=Gt.mine.getExtensionDescription(ne);if(Ne)return new u.Extension(Ft,Ue.identifier,Ne,hi,!1);if(fe){const rt=Gt.all.getExtensionDescription(ne);if(rt)return new u.Extension(Ft,Ue.identifier,rt,hi,!0)}},get all(){const ne=[];for(const fe of Gt.mine.getAllExtensionDescriptions())ne.push(new u.Extension(Ft,Ue.identifier,fe,hi,!1));return ne},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new je.ExtensionIdentifierSet(Gt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),fe=[];for(const Ne of Gt.all.getAllExtensionDescriptions()){const rt=!ne.has(Ne.identifier);fe.push(new u.Extension(Ft,Ue.identifier,Ne,hi,rt))}return fe},get onDidChange(){return(0,je.isProposedApiEnabled)(Ue,"extensionsAny")?S.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},ji={createDiagnosticCollection(ne){return ti.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return ti.onDidChangeDiagnostics},getDiagnostics:ne=>ti.getDiagnostics(ne),getLanguages(){return oi.getLanguages()},setTextDocumentLanguage(ne,fe){return oi.changeLanguage(ne.uri,fe)},match(ne,fe){const Ne=ht.getDocumentData(fe.uri)?.notebook;return(0,O.score)(V.LanguageSelector.from(ne),fe.uri,fe.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(ne,fe,Ne){return ct.registerCodeActionProvider(Ue,mt(ne),fe,Ne)},registerDocumentPasteEditProvider(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,mt(ne),fe,Ne)},registerCodeLensProvider(ne,fe){return ct.registerCodeLensProvider(Ue,mt(ne),fe)},registerDefinitionProvider(ne,fe){return ct.registerDefinitionProvider(Ue,mt(ne),fe)},registerDeclarationProvider(ne,fe){return ct.registerDeclarationProvider(Ue,mt(ne),fe)},registerImplementationProvider(ne,fe){return ct.registerImplementationProvider(Ue,mt(ne),fe)},registerTypeDefinitionProvider(ne,fe){return ct.registerTypeDefinitionProvider(Ue,mt(ne),fe)},registerHoverProvider(ne,fe){return ct.registerHoverProvider(Ue,mt(ne),fe,Ue.identifier)},registerEvaluatableExpressionProvider(ne,fe){return ct.registerEvaluatableExpressionProvider(Ue,mt(ne),fe,Ue.identifier)},registerInlineValuesProvider(ne,fe){return ct.registerInlineValuesProvider(Ue,mt(ne),fe,Ue.identifier)},registerDocumentHighlightProvider(ne,fe){return ct.registerDocumentHighlightProvider(Ue,mt(ne),fe)},registerLinkedEditingRangeProvider(ne,fe){return ct.registerLinkedEditingRangeProvider(Ue,mt(ne),fe)},registerReferenceProvider(ne,fe){return ct.registerReferenceProvider(Ue,mt(ne),fe)},registerRenameProvider(ne,fe){return ct.registerRenameProvider(Ue,mt(ne),fe)},registerDocumentSymbolProvider(ne,fe,Ne){return ct.registerDocumentSymbolProvider(Ue,mt(ne),fe,Ne)},registerWorkspaceSymbolProvider(ne){return ct.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,fe){return ct.registerDocumentFormattingEditProvider(Ue,mt(ne),fe)},registerDocumentRangeFormattingEditProvider(ne,fe){return ct.registerDocumentRangeFormattingEditProvider(Ue,mt(ne),fe)},registerOnTypeFormattingEditProvider(ne,fe,Ne,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,mt(ne),fe,[Ne].concat(rt))},registerDocumentSemanticTokensProvider(ne,fe,Ne){return ct.registerDocumentSemanticTokensProvider(Ue,mt(ne),fe,Ne)},registerDocumentRangeSemanticTokensProvider(ne,fe,Ne){return ct.registerDocumentRangeSemanticTokensProvider(Ue,mt(ne),fe,Ne)},registerSignatureHelpProvider(ne,fe,Ne,...rt){return typeof Ne=="object"?ct.registerSignatureHelpProvider(Ue,mt(ne),fe,Ne):ct.registerSignatureHelpProvider(Ue,mt(ne),fe,typeof Ne>"u"?[]:[Ne,...rt])},registerCompletionItemProvider(ne,fe,...Ne){return ct.registerCompletionItemProvider(Ue,mt(ne),fe,Ne)},registerInlineCompletionItemProvider(ne,fe){return fe.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,mt(ne),fe)},registerDocumentLinkProvider(ne,fe){return ct.registerDocumentLinkProvider(Ue,mt(ne),fe)},registerColorProvider(ne,fe){return ct.registerColorProvider(Ue,mt(ne),fe)},registerFoldingRangeProvider(ne,fe){return ct.registerFoldingRangeProvider(Ue,mt(ne),fe)},registerSelectionRangeProvider(ne,fe){return ct.registerSelectionRangeProvider(Ue,ne,fe)},registerCallHierarchyProvider(ne,fe){return ct.registerCallHierarchyProvider(Ue,ne,fe)},registerTypeHierarchyProvider(ne,fe){return ct.registerTypeHierarchyProvider(Ue,ne,fe)},setLanguageConfiguration:(ne,fe)=>ct.setLanguageConfiguration(Ue,ne,fe),getTokenInformationAtPosition(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"tokenInformation"),oi.tokenAtPosition(ne,fe)},registerInlayHintsProvider(ne,fe){return ct.registerInlayHintsProvider(Ue,ne,fe)},createLanguageStatusItem(ne,fe){return oi.createLanguageStatusItem(Ue,ne,fe)},registerDocumentDropEditProvider(ne,fe){return ct.registerDocumentOnDropEditProvider(Ue,ne,fe)}},qi={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return ze.activeTerminal},get terminals(){return ze.terminals},async showTextDocument(ne,fe,Ne){const rt=await(I.URI.isUri(ne)?Promise.resolve(fi.openTextDocument(ne)):Promise.resolve(ne));return Tt.showTextDocument(rt,fe,Ne)},createTextEditorDecorationType(ne){return Tt.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,fe,Ne){return Tt.onDidChangeActiveTextEditor(ne,fe,Ne)},onDidChangeVisibleTextEditors(ne,fe,Ne){return Tt.onDidChangeVisibleTextEditors(ne,fe,Ne)},onDidChangeTextEditorSelection(ne,fe,Ne){return Tt.onDidChangeTextEditorSelection(ne,fe,Ne)},onDidChangeTextEditorOptions(ne,fe,Ne){return Tt.onDidChangeTextEditorOptions(ne,fe,Ne)},onDidChangeTextEditorVisibleRanges(ne,fe,Ne){return Tt.onDidChangeTextEditorVisibleRanges(ne,fe,Ne)},onDidChangeTextEditorViewColumn(ne,fe,Ne){return Tt.onDidChangeTextEditorViewColumn(ne,fe,Ne)},onDidCloseTerminal(ne,fe,Ne){return ze.onDidCloseTerminal(ne,fe,Ne)},onDidOpenTerminal(ne,fe,Ne){return ze.onDidOpenTerminal(ne,fe,Ne)},onDidChangeActiveTerminal(ne,fe,Ne){return ze.onDidChangeActiveTerminal(ne,fe,Ne)},onDidChangeTerminalDimensions(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"terminalDimensions"),ze.onDidChangeTerminalDimensions(ne,fe,Ne)},onDidChangeTerminalState(ne,fe,Ne){return ze.onDidChangeTerminalState(ne,fe,Ne)},onDidWriteTerminalData(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),ze.onDidWriteTerminalData(ne,fe,Ne)},get state(){return Pe.state},onDidChangeWindowState(ne,fe,Ne){return Pe.onDidChangeWindowState(ne,fe,Ne)},showInformationMessage(ne,...fe){return Pi.showMessage(Ue,L.default.Info,ne,fe[0],fe.slice(1))},showWarningMessage(ne,...fe){return Pi.showMessage(Ue,L.default.Warning,ne,fe[0],fe.slice(1))},showErrorMessage(ne,...fe){return Pi.showMessage(Ue,L.default.Error,ne,fe[0],fe.slice(1))},showQuickPick(ne,fe,Ne){return Wt.showQuickPick(ne,fe,Ne)},showWorkspaceFolderPick(ne){return Wt.showWorkspaceFolderPick(ne)},showInputBox(ne,fe){return Wt.showInput(ne,fe)},showOpenDialog(ne){return Fi.showOpenDialog(ne)},showSaveDialog(ne){return Fi.showSaveDialog(ne)},createStatusBarItem(ne,fe,Ne){let rt,yt,Pt;return typeof ne=="string"?(rt=ne,yt=fe,Pt=Ne):(yt=ne,Pt=fe),Ni.createStatusBarEntry(Ue,rt,yt,Pt)},setStatusBarMessage(ne,fe){return Ni.setStatusBarMessage(ne,fe)},withScmProgress(ne){return De.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ci.withProgress(Ue,{location:q.ProgressLocation.SourceControl},(fe,Ne)=>ne({report(rt){}}))},withProgress(ne,fe){return ci.withProgress(Ue,ne,fe)},createOutputChannel(ne,fe){return At.createOutputChannel(ne,fe,Ue)},createWebviewPanel(ne,fe,Ne,rt){return yi.createWebviewPanel(Ue,ne,fe,Ne,rt)},createWebviewTextEditorInset(ne,fe,Ne,rt){return(0,je.checkProposedApiEnabled)(Ue,"editorInsets"),jt.createWebviewEditorInset(ne,fe,Ne,rt,Ue)},createTerminal(ne,fe,Ne){return typeof ne=="object"?"pty"in ne?ze.createExtensionTerminal(ne):ze.createTerminalFromOptions(ne):ze.createTerminal(ne,fe,Ne)},registerTerminalLinkProvider(ne){return ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,fe){return ze.registerProfileProvider(Ue,ne,fe)},registerTerminalQuickFixProvider(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),ze.registerTerminalQuickFixProvider(ne,Ue.identifier.value,fe)},registerTreeDataProvider(ne,fe){return si.registerTreeDataProvider(ne,fe,Ue)},createTreeView(ne,fe){return si.createTreeView(ne,fe,Ue)},registerWebviewPanelSerializer:(ne,fe)=>yi.registerWebviewPanelSerializer(Ue,ne,fe),registerCustomEditorProvider:(ne,fe,Ne={})=>Di.registerCustomEditorProvider(Ue,ne,fe,Ne),registerFileDecorationProvider(ne){return Re.registerFileDecorationProvider(ne,Ue)},registerUriHandler(ne){return It.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return Wt.createQuickPick(Ue)},createInputBox(){return Wt.createInputBox(Ue)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(ne,fe,Ne){return ui.onDidChangeActiveColorTheme(ne,fe,Ne)},registerWebviewViewProvider(ne,fe,Ne){return Ii.registerWebviewViewProvider(Ue,ne,fe,Ne?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,fe,Ne){return Et.onDidChangeActiveNotebookEditor(ne,fe,Ne)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,fe,Ne){return ri.onDidChangeNotebookEditorSelection(ne,fe,Ne)},onDidChangeNotebookEditorVisibleRanges(ne,fe,Ne){return ri.onDidChangeNotebookEditorVisibleRanges(ne,fe,Ne)},showNotebookDocument(ne,fe){return Et.showNotebookDocument(ne,fe)},registerExternalUriOpener(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ci.registerExternalUriOpener(Ue.identifier,ne,fe,Ne)},registerProfileContentHandler(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"profileContentHandlers"),$i.registrProfileContentHandler(Ue,ne,fe)},get tabGroups(){return X.tabGroups}},fi={get rootPath(){return De.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw C.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw C.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw C.readonly()},updateWorkspaceFolders:(ne,fe,...Ne)=>ft.updateWorkspaceFolders(Ue,ne,fe||0,...Ne),onDidChangeWorkspaceFolders:function(ne,fe,Ne){return ft.onDidChangeWorkspace(ne,fe,Ne)},asRelativePath:(ne,fe)=>ft.getRelativePath(ne,fe),findFiles:(ne,fe,Ne,rt)=>ft.findFiles(ne,fe,Ne,Ue.identifier,rt),findTextInFiles:(ne,fe,Ne,rt)=>{(0,je.checkProposedApiEnabled)(Ue,"findTextInFiles");let yt,Pt;return typeof fe=="object"?(yt=fe,Pt=Ne):(yt={},Pt=fe,rt=Ne),ft.findTextInFiles(ne,yt||{},Pt,Ue.identifier,rt)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne,fe){return Ti.applyWorkspaceEdit(ne,Ue,fe)},createFileSystemWatcher:(ne,fe,Ne,rt)=>Yt.createFileSystemWatcher(ft,Ue,ne,fe,Ne,rt),get textDocuments(){return ht.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw C.readonly()},openTextDocument(ne){let fe;const Ne=ne;if(typeof ne=="string")fe=Promise.resolve(I.URI.file(ne));else if(I.URI.isUri(ne))fe=Promise.resolve(ne);else if(!Ne||typeof Ne=="object")fe=ht.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(rt=>ht.ensureDocumentData(rt).then(yt=>yt.document))},onDidOpenTextDocument:(ne,fe,Ne)=>ht.onDidAddDocument(ne,fe,Ne),onDidCloseTextDocument:(ne,fe,Ne)=>ht.onDidRemoveDocument(ne,fe,Ne),onDidChangeTextDocument:(ne,fe,Ne)=>ht.onDidChangeDocument(ne,fe,Ne),onDidSaveTextDocument:(ne,fe,Ne)=>ht.onDidSaveDocument(ne,fe,Ne),onWillSaveTextDocument:(ne,fe,Ne)=>Vt.getOnWillSaveTextDocumentEvent(Ue)(ne,fe,Ne),get notebookDocuments(){return Et.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,fe){let Ne;if(I.URI.isUri(ne))Ne=ne,await Et.openNotebookDocument(ne);else if(typeof ne=="string")Ne=I.URI.revive(await Et.createNotebookDocument({viewType:ne,content:fe}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ne,fe,Ne){return Qt.onDidSaveNotebookDocument(ne,fe,Ne)},onDidChangeNotebookDocument(ne,fe,Ne){return Qt.onDidChangeNotebookDocument(ne,fe,Ne)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ne,fe,Ne,rt){return Et.registerNotebookSerializer(Ue,ne,fe,Ne,(0,je.isProposedApiEnabled)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ne,fe,Ne)=>li.onDidChangeConfiguration(ne,fe,Ne),getConfiguration(ne,fe){return fe=arguments.length===1?void 0:fe,li.getConfiguration(ne,fe,Ue)},registerTextDocumentContentProvider(ne,fe){return Kt.registerTextDocumentContentProvider(ne,fe)},registerTaskProvider:(ne,fe)=>(De.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Ue,ne,fe)),registerFileSystemProvider(ne,fe,Ne){return(0,$e.combinedDisposable)(Oi.registerFileSystemProvider(Ue,ne,fe,Ne),Ot.addFileSystemProvider(ne,fe))},get fs(){return Ot.value},registerFileSearchProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"fileSearchProvider"),bt.registerFileSearchProvider(ne,fe)),registerTextSearchProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"textSearchProvider"),bt.registerTextSearchProvider(ne,fe)),registerRemoteAuthorityResolver:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),Ft.registerRemoteAuthorityResolver(ne,fe)),registerResourceLabelFormatter:ne=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),wi.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,fe,Ne)=>Yt.onDidCreateFile(ne,fe,Ne),onDidDeleteFiles:(ne,fe,Ne)=>Yt.onDidDeleteFile(ne,fe,Ne),onDidRenameFiles:(ne,fe,Ne)=>Yt.onDidRenameFile(ne,fe,Ne),onWillCreateFiles:(ne,fe,Ne)=>Yt.getOnWillCreateFileEvent(Ue)(ne,fe,Ne),onWillDeleteFiles:(ne,fe,Ne)=>Yt.getOnWillDeleteFileEvent(Ue)(ne,fe,Ne),onWillRenameFiles:(ne,fe,Ne)=>Yt.getOnWillRenameFileEvent(Ue)(ne,fe,Ne),openTunnel:ne=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),kt.openTunnel(Ue,ne).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,je.checkProposedApiEnabled)(Ue,"tunnels"),kt.getTunnels()},onDidChangeTunnels:(ne,fe,Ne)=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),kt.onDidChangeTunnels(ne,fe,Ne)),registerPortAttributesProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"portsAttributes"),kt.registerPortsAttributesProvider(ne,fe)),registerTimelineProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"timeline"),Si.registerTimelineProvider(ne,fe,Ue.identifier,Qe.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,je.checkProposedApiEnabled)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,fe,Ne)=>ft.onDidGrantWorkspaceTrust(ne,fe,Ne),registerEditSessionIdentityProvider:(ne,fe)=>((0,je.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,fe))},Ki={get inputBox(){return De.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ai.getLastInputBox(Ue)},createSourceControl(ne,fe,Ne){return ai.createSourceControl(Ue,ne,fe,Ne)}},xt={createCommentController(ne,fe){return Ei.createCommentController(Ue,ne,fe)}},mi={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(ne,fe,Ne){return Ze.onDidStartDebugSession(ne,fe,Ne)},onDidTerminateDebugSession(ne,fe,Ne){return Ze.onDidTerminateDebugSession(ne,fe,Ne)},onDidChangeActiveDebugSession(ne,fe,Ne){return Ze.onDidChangeActiveDebugSession(ne,fe,Ne)},onDidReceiveDebugSessionCustomEvent(ne,fe,Ne){return Ze.onDidReceiveDebugSessionCustomEvent(ne,fe,Ne)},onDidChangeBreakpoints(ne,fe,Ne){return Ze.onDidChangeBreakpoints(ne,fe,Ne)},registerDebugConfigurationProvider(ne,fe,Ne){return Ze.registerDebugConfigurationProvider(ne,fe,Ne||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,fe){return Ze.registerDebugAdapterDescriptorFactory(Ue,ne,fe)},registerDebugAdapterTrackerFactory(ne,fe){return Ze.registerDebugAdapterTrackerFactory(ne,fe)},startDebugging(ne,fe,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?Ze.startDebugging(ne,fe,{parentSession:Ne}):Ze.startDebugging(ne,fe,Ne||{})},stopDebugging(ne){return Ze.stopDebugging(ne)},addBreakpoints(ne){return Ze.addBreakpoints(ne)},removeBreakpoints(ne){return Ze.removeBreakpoints(ne)},asDebugSourceUri(ne,fe){return Ze.asDebugSourceUri(ne,fe)}},Gi={registerTaskProvider:(ne,fe)=>vt.registerTaskProvider(Ue,ne,fe),fetchTasks:ne=>vt.fetchTasks(ne),executeTask:ne=>vt.executeTask(Ue,ne),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(ne,fe,Ne)=>vt.onDidStartTask(ne,fe,Ne),onDidEndTask:(ne,fe,Ne)=>vt.onDidEndTask(ne,fe,Ne),onDidStartTaskProcess:(ne,fe,Ne)=>vt.onDidStartTaskProcess(ne,fe,Ne),onDidEndTaskProcess:(ne,fe,Ne)=>vt.onDidEndTaskProcess(ne,fe,Ne)},zt={createNotebookController(ne,fe,Ne,rt,yt){return ei.createNotebookController(Ue,ne,fe,Ne,rt,(0,je.isProposedApiEnabled)(Ue,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,fe)=>Et.registerNotebookCellStatusBarItemProvider(Ue,ne,fe),createRendererMessaging(ne){return bi.createRendererMessaging(Ue,ne)},createNotebookControllerDetectionTask(ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),ei.createNotebookControllerDetectionTask(Ue,ne)},registerKernelSourceActionProvider(ne,fe){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),ei.registerKernelSourceActionProvider(Ue,ne,fe)},onDidChangeNotebookCellExecutionState(ne,fe,Ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),ei.onDidChangeNotebookCellExecutionState(ne,fe,Ne)}},gi={t(...ne){if(typeof ne[0]=="string"){const fe=ne.shift(),Ne=!ne||typeof ne[0]!="object"?ne:ne[0];return pt.getMessage(Ue.identifier.value,{message:fe,args:Ne})}return pt.getMessage(Ue.identifier.value,ne[0])},get bundle(){return pt.getBundle(Ue.identifier.value)},get uri(){return pt.getBundleUri(Ue.identifier.value)}};return{version:at.version,authentication:Wi,commands:Hi,comments:xt,debug:mi,env:Mi,extensions:Vi,l10n:gi,languages:ji,notebooks:zt,scm:Ki,tasks:Gi,tests:di,window:qi,workspace:fi,Breakpoint:q.Breakpoint,TerminalOutputAnchor:q.TerminalOutputAnchor,CallHierarchyIncomingCall:q.CallHierarchyIncomingCall,CallHierarchyItem:q.CallHierarchyItem,CallHierarchyOutgoingCall:q.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:q.CodeAction,CodeActionKind:q.CodeActionKind,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.CodeLens,Color:q.Color,ColorInformation:q.ColorInformation,ColorPresentation:q.ColorPresentation,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CompletionItem:q.CompletionItem,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.CompletionList,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.CustomExecution,DebugAdapterExecutable:q.DebugAdapterExecutable,DebugAdapterInlineImplementation:q.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:q.DebugAdapterNamedPipeServer,DebugAdapterServer:q.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.Diagnostic,DiagnosticRelatedInformation:q.DiagnosticRelatedInformation,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.Disposable,DocumentHighlight:q.DocumentHighlight,DocumentHighlightKind:q.DocumentHighlightKind,DocumentLink:q.DocumentLink,DocumentSymbol:q.DocumentSymbol,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.EvaluatableExpression,InlineValueText:q.InlineValueText,InlineValueVariableLookup:q.InlineValueVariableLookup,InlineValueEvaluatableExpression:q.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.FileDecoration,FileDecoration2:q.FileDecoration,FileSystemError:q.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:q.FoldingRange,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.FunctionBreakpoint,InlineCompletionItem:q.InlineSuggestion,InlineCompletionList:q.InlineSuggestionList,Hover:q.Hover,IndentAction:k.IndentAction,Location:q.Location,MarkdownString:q.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:q.ParameterInformation,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.Position,ProcessExecution:q.ProcessExecution,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.QuickInputButtons,Range:q.Range,RelativePattern:q.RelativePattern,Selection:q.Selection,SelectionRange:q.SelectionRange,SemanticTokens:q.SemanticTokens,SemanticTokensBuilder:q.SemanticTokensBuilder,SemanticTokensEdit:q.SemanticTokensEdit,SemanticTokensEdits:q.SemanticTokensEdits,SemanticTokensLegend:q.SemanticTokensLegend,ShellExecution:q.ShellExecution,ShellQuoting:q.ShellQuoting,SignatureHelp:q.SignatureHelp,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.SignatureInformation,SnippetString:q.SnippetString,SourceBreakpoint:q.SourceBreakpoint,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.SymbolInformation,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.Task,TaskGroup:q.TaskGroup,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.TerminalLink,TerminalQuickFixCommand:q.TerminalQuickFixCommand,TerminalQuickFixOpener:q.TerminalQuickFixOpener,TerminalLocation:q.TerminalLocation,TerminalProfile:q.TerminalProfile,TerminalExitReason:q.TerminalExitReason,TerminalQuickFixType:q.TerminalQuickFixType,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.TextEdit,SnippetTextEdit:q.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.ThemeColor,ThemeIcon:q.ThemeIcon,TreeItem:q.TreeItem,TreeItem2:q.TreeItem,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.TypeHierarchyItem,UIKind:b.UIKind,Uri:I.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.WorkspaceEdit,DocumentDropEdit:q.DocumentDropEdit,DocumentPasteEdit:q.DocumentPasteEdit,InlayHint:q.InlayHint,InlayHintLabelPart:q.InlayHintLabelPart,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.RemoteAuthorityResolverError,ResolvedAuthority:q.ResolvedAuthority,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.TimelineItem,NotebookRange:q.NotebookRange,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.NotebookCellData,NotebookData:q.NotebookData,NotebookRendererScript:q.NotebookRendererScript,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.NotebookCellOutput,NotebookCellOutputItem:q.NotebookCellOutputItem,NotebookCellStatusBarItem:q.NotebookCellStatusBarItem,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.NotebookEdit,NotebookKernelSourceAction:q.NotebookKernelSourceAction,PortAttributes:q.PortAttributes,LinkedEditingRanges:q.LinkedEditingRanges,TestResultState:q.TestResultState,TestRunRequest:q.TestRunRequest,TestRunRequest2:q.TestRunRequest2,TestMessage:q.TestMessage,TestTag:q.TestTag,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:q.DataTransfer,DataTransferItem:q.DataTransferItem,CoveredCount:q.CoveredCount,FileCoverage:q.FileCoverage,StatementCoverage:q.StatementCoverage,BranchCoverage:q.BranchCoverage,FunctionCoverage:q.FunctionCoverage,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.TextTabInput,TabInputTextDiff:q.TextDiffTabInput,TabInputTextMerge:q.TextMergeTabInput,TabInputCustom:q.CustomEditorTabInput,TabInputNotebook:q.NotebookEditorTabInput,TabInputNotebookDiff:q.NotebookDiffEditorTabInput,TabInputWebview:q.WebviewEditorTabInput,TabInputTerminal:q.TerminalEditorTabInput,TabInputInteractiveWindow:q.InteractiveWindowInput,TelemetryTrustedValue:le.TelemetryTrustedValue,LogLevel:xe.LogLevel,EditSessionIdentityMatch:wt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Ct}),define(Ie[252],Ce([1,0,251,33,2,245,7,12,236]),function(ee,e,i,C,S,L,I,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends L.RequireInterceptor{j(){}getModule(b,f){for(const r of this.b){const o=r(b);if(o){b=o;break}}if(this.a.has(b))return this.a.get(b).load(b,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(y.ExtHostConsoleForwarder);const b=this.h.invokeFunction(i.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,b,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(b){return b.browser}async pb(b,f,r){f=f.with({path:w(f.path,".js")});const o=b?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const l=S.URI.revive(await this.v.$asBrowserUri(f)),v=await fetch(l.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),v.status!==200)throw new Error(v.statusText);const E=await v.text(),P=`${f.toString(!0)}#vscode-extension`,p=`${E}
//# sourceURL=${P}`;let n;try{n=new Function("module","exports","require",p)}catch(s){throw console.error(o?`Loading code for extension ${o} failed: ${s.message}`:`Loading code failed: ${s.message}`),console.error(`${f.toString(!0)}${typeof s.line=="number"?` line ${s.line}`:""}${typeof s.column=="number"?` column ${s.column}`:""}`),console.error(s),s}b&&await this.s.initializeLocalizedMessages(b);const d={},t={exports:d},u=s=>{const h=this.r.getModule(s,f);if(h===void 0)throw new Error(`Cannot load module '${s}'`);return h};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),n(t,d,u),t.exports!==d?t.exports:d}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(b){}async tb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+b;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=O;function w(m,b){return m.endsWith(b)?m:m+b}}),define(Ie[253],Ce([1,0,66,33,81,252]),function(ee,e,i,C,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(C.IExtHostExtensionService,L.ExtHostExtensionService,0),(0,i.registerSingleton)(S.IExtensionStoragePaths,S.ExtensionStoragePaths,0)}),define(Ie[261],Ce([1,0,25,4,73,246,238,19,82,16,2,248,253]),function(ee,e,i,C,S,L,I,R,y,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(n){return/^(file|vscode-remote):/i.test(n)}const f=fetch.bind(self);function r(n){self.fetch=async function(d,t){return d instanceof Request||b(String(d))&&(d=(await n(O.URI.parse(String(d)))).toString(!0)),f(d,t)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,t,u,s,h){(async()=>(b(t.toString())&&(t=(await n(O.URI.parse(t.toString()))).toString(!0)),super.open(d,t,u??!0,s,h)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(d,t){if(/^file:/i.test(d.toString()))d=k.FileAccess.uriToBrowserUri(O.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const s=`(${function(g){function A(te){return typeof te=="string"||te instanceof URL?String(te).replace(/^file:\/\//i,"vscode-file://vscode-app"):te}const F=fetch.bind(self);self.fetch=function(te,x){return te instanceof Request?F(te,x):F(A(te),x)},self.XMLHttpRequest=class extends XMLHttpRequest{open(te,x,N,$,T){return super.open(te,A(x),N??!0,$,T)}};const j=importScripts.bind(self);self.importScripts=(...te)=>{j(...te.map(A))},j(g)}.toString()}('${d}'))`;t=t||{},t.name=t.name||R.basename(d.toString());const h=new Blob([s],{type:"application/javascript"}),a=URL.createObjectURL(h);return new n(a,t)}}else self.Worker=class extends I.NestedWorker{constructor(n,d){super(m,n,{name:R.basename(n.toString()),...d})}};const o=new class{constructor(){this.pid=void 0}exit(n){w()}async exists(n){return!0}async realpath(n){return n}};class l{constructor(){const d=new MessageChannel,t=new C.Emitter;let u=!1;m(d.port2,[d.port2]),d.port1.onmessage=s=>{const{data:h}=s;if(!(h instanceof ArrayBuffer)){console.warn("UNKNOWN data received",h);return}const a=i.VSBuffer.wrap(new Uint8Array(h,0,h.byteLength));if((0,S.isMessageOfType)(a,2)){u=!0,E("received terminate message from renderer");return}t.fire(a)},this.protocol={onMessage:t.event,send:s=>{if(!u){const h=s.buffer.buffer.slice(s.buffer.byteOffset,s.buffer.byteOffset+s.buffer.byteLength);d.port1.postMessage(h,[h])}}}}}function v(n){return new Promise(d=>{const t=n.onMessage(u=>{t.dispose();const s=JSON.parse(u.toString());n.send((0,S.createMessageOfType)(0)),d({protocol:n,initData:s})});n.send((0,S.createMessageOfType)(1))})}let E=n=>w();function P(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function p(){y.mark("code/extHost/willConnectToRenderer");const n=new l;return{onmessage(d){!P(d)||v(n.protocol).then(t=>{y.mark("code/extHost/didWaitForInitData");const u=new L.ExtensionHostMain(t.protocol,t.initData,o,null,d.data);r(s=>u.asBrowserUri(s)),E=s=>u.terminate(s)})}}}e.create=p})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e7b5449579249db344d473370d56a5df9446c826/core/vs/workbench/api/worker/extensionHostWorker.js.map
